/**************************************************************************
**
** Version: @(#)regtc27x.xml	1.15 12/03/05
** Generated by @(#)XmlSfrfilePrinter.java	1.38 12/03/05
** 
** This file contains all SFR and BIT names and on-chip register definitions
** It is based on the following document(s):
** - mira/TC27xA_TS_V3.0.xml (V3.0)
** 
** Copyright 2002-2012 Altium BV
**
**************************************************************************/
#ifndef _REGTC27X_H
#define _REGTC27X_H

/* Core Base */
#define core_base	0xf881	/* The base address off the memory for the CSFR's */
#define core_base_0	0xf881	/* The base address off the memory for the CSFR's CPU0 */
#define core_base_1	0xf883	/* The base address off the memory for the CSFR's CPU1 */
#define core_base_2	0xf885	/* The base address off the memory for the CSFR's CPU2 */

/* Core Special Function Registers (CSFR). Macros, such as TASK_ASI, that expand to a 16-bit number do not directly represent a memory address.
   They are intended to be used with the intrinsic functions __mfcr(...) and __mtcr(...). */
#define TASK_ASI	0x8004	/* CPUn Task Address Space Identifier Register */
#define PMA0	0x8100	/* Data Access CacheabilityRegister */
#define PMA1	0x8104	/* Code Access CacheabilityRegister */
#define PMA2	0x8108	/* Peripheral Space Identifier register */
#define SMACON	0x900c	/* SIST Mode Access Control Register */
#define DIEAR	0x9020	/* Data Integrity Error Address Register */
#define DIETR	0x9024	/* Data Integrity Error Trap Register */
#define PCON1	0x9204	/* Program Control 1 */
#define PCON2	0x9208	/* Program Control 2 */
#define PCON0	0x920c	/* Program Control 0 */
#define PSTR	0x9200	/* Program Synchronous Trap Register */
#define DCON0	0x9040	/* Data Memory Control Register */
#define DCON2	0x9000	/* Data Control Register 2 */
#define DSTR	0x9010	/* Data Synchronous Trap Register */
#define DATR	0x9018	/* Data Asynchronous Trap Register */
#define DEADD	0x901c	/* Data Error Address Register */
#define PIEAR	0x9210	/* Program Integrity Error Address Register */
#define PIETR	0x9214	/* Program Integrity Error Trap Register */
#define COMPAT	0x9400	/* Compatibility Control Register */
#define FPU_TRAP_CON	0xa000	/* CPUn Trap Control Register */
#define FPU_TRAP_PC	0xa004	/* CPUn Trapping Instruction Program Counter Register */
#define FPU_TRAP_OPC	0xa008	/* CPUn Trapping Instruction Opcode Register */
#define FPU_TRAP_SRC1	0xa010	/* CPUn Trapping Instruction Operand Register */
#define FPU_TRAP_SRC2	0xa014	/* CPUn Trapping Instruction Operand Register */
#define FPU_TRAP_SRC3	0xa018	/* Trapping Instruction Operand Register */
#define DPR0_L	0xc000	/* CPUn Data Protection Range 0, Lower Bound Register */
#define DPR1_L	0xc008	/* CPUn Data Protection Range 1, Lower Bound Register */
#define DPR2_L	0xc010	/* CPUn Data Protection Range 2, Lower Bound Register */
#define DPR3_L	0xc018	/* CPUn Data Protection Range 3, Lower Bound Register */
#define DPR4_L	0xc020	/* CPUn Data Protection Range 4, Lower Bound Register */
#define DPR5_L	0xc028	/* CPUn Data Protection Range 5, Lower Bound Register */
#define DPR6_L	0xc030	/* CPUn Data Protection Range 6, Lower Bound Register */
#define DPR7_L	0xc038	/* CPUn Data Protection Range 7, Lower Bound Register */
#define DPR8_L	0xc040	/* CPUn Data Protection Range 8, Lower Bound Register */
#define DPR9_L	0xc048	/* CPUn Data Protection Range 9, Lower Bound Register */
#define DPR10_L	0xc050	/* CPUn Data Protection Range 10, Lower Bound Register */
#define DPR11_L	0xc058	/* CPUn Data Protection Range 11, Lower Bound Register */
#define DPR12_L	0xc060	/* CPUn Data Protection Range 12, Lower Bound Register */
#define DPR13_L	0xc068	/* CPUn Data Protection Range 13, Lower Bound Register */
#define DPR14_L	0xc070	/* CPUn Data Protection Range 14, Lower Bound Register */
#define DPR15_L	0xc078	/* CPUn Data Protection Range 15, Lower Bound Register */
#define DPR0_U	0xc004	/* CPUn Data Protection Range 0, Upper Bound Register */
#define DPR1_U	0xc00c	/* CPUn Data Protection Range 1, Upper Bound Register */
#define DPR2_U	0xc014	/* CPUn Data Protection Range 2, Upper Bound Register */
#define DPR3_U	0xc01c	/* CPUn Data Protection Range 3, Upper Bound Register */
#define DPR4_U	0xc024	/* CPUn Data Protection Range 4, Upper Bound Register */
#define DPR5_U	0xc02c	/* CPUn Data Protection Range 5, Upper Bound Register */
#define DPR6_U	0xc034	/* CPUn Data Protection Range 6, Upper Bound Register */
#define DPR7_U	0xc03c	/* CPUn Data Protection Range 7, Upper Bound Register */
#define DPR8_U	0xc044	/* CPUn Data Protection Range 8, Upper Bound Register */
#define DPR9_U	0xc04c	/* CPUn Data Protection Range 9, Upper Bound Register */
#define DPR10_U	0xc054	/* CPUn Data Protection Range 10, Upper Bound Register */
#define DPR11_U	0xc05c	/* CPUn Data Protection Range 11, Upper Bound Register */
#define DPR12_U	0xc064	/* CPUn Data Protection Range 12, Upper Bound Register */
#define DPR13_U	0xc06c	/* CPUn Data Protection Range 13, Upper Bound Register */
#define DPR14_U	0xc074	/* CPUn Data Protection Range 14, Upper Bound Register */
#define DPR15_U	0xc07c	/* CPUn Data Protection Range 15, Upper Bound Register */
#define CPR0_L	0xd000	/* CPUn Code Protection Range 0 Lower Bound Register */
#define CPR1_L	0xd008	/* CPUn Code Protection Range 1 Lower Bound Register */
#define CPR2_L	0xd010	/* CPUn Code Protection Range 2 Lower Bound Register */
#define CPR3_L	0xd018	/* CPUn Code Protection Range 3 Lower Bound Register */
#define CPR4_L	0xd020	/* CPUn Code Protection Range 4 Lower Bound Register */
#define CPR5_L	0xd028	/* CPUn Code Protection Range 5 Lower Bound Register */
#define CPR6_L	0xd030	/* CPUn Code Protection Range 6 Lower Bound Register */
#define CPR7_L	0xd038	/* CPUn Code Protection Range 7 Lower Bound Register */
#define CPR0_U	0xd004	/* CPUn Code Protection Range 0 Upper Bound Register */
#define CPR1_U	0xd00c	/* CPUn Code Protection Range 1 Upper Bound Register */
#define CPR2_U	0xd014	/* CPUn Code Protection Range 2 Upper Bound Register */
#define CPR3_U	0xd01c	/* CPUn Code Protection Range 3 Upper Bound Register */
#define CPR4_U	0xd024	/* CPUn Code Protection Range 4 Upper Bound Register */
#define CPR5_U	0xd02c	/* CPUn Code Protection Range 5 Upper Bound Register */
#define CPR6_U	0xd034	/* CPUn Code Protection Range 6 Upper Bound Register */
#define CPR7_U	0xd03c	/* CPUn Code Protection Range 7 Upper Bound Register */
#define DPRE_0	0xe010	/* CPUn Data Protection Read Enable Register Set 0 */
#define DPRE_1	0xe014	/* CPUn Data Protection Read Enable Register Set 1 */
#define DPRE_2	0xe018	/* CPUn Data Protection Read Enable Register Set 2 */
#define DPRE_3	0xe01c	/* CPUn Data Protection Read Enable Register Set 3 */
#define DPWE_0	0xe020	/* CPUn Data Protection Write Enable Register Set 0 */
#define DPWE_1	0xe024	/* CPUn Data Protection Write Enable Register Set 1 */
#define DPWE_2	0xe028	/* CPUn Data Protection Write Enable Register Set 2 */
#define DPWE_3	0xe02c	/* CPUn Data Protection Write Enable Register Set 3 */
#define CPXE_0	0xe000	/* CPUn Code Protection Execute Enable Register Set 0 */
#define CPXE_1	0xe004	/* CPUn Code Protection Execute Enable Register Set 1 */
#define CPXE_2	0xe008	/* CPUn Code Protection Execute Enable Register Set 2 */
#define CPXE_3	0xe00c	/* CPUn Code Protection Execute Enable Register Set 3 */
#define TPS_TIMER0	0xe404	/* CPUn Temporal Protection System Timer Register 0 */
#define TPS_TIMER1	0xe408	/* CPUn Temporal Protection System Timer Register 0 */
#define TPS_TIMER2	0xe40c	/* CPUn Temporal Protection System Timer Register 0 */
#define TPS_CON	0xe400	/* CPUn Temporal Protection System Control Register */
#define DBGSR	0xfd00	/* Debug Status Register */
#define EXEVT	0xfd08	/* External Event Register */
#define CREVT	0xfd0c	/* Core Register Access Event */
#define SWEVT	0xfd10	/* Software Debug Event */
#define TR0EVT	0xf000	/* Trigger Event 0 */
#define TR1EVT	0xf008	/* Trigger Event 1 */
#define TR2EVT	0xf010	/* Trigger Event 2 */
#define TR3EVT	0xf018	/* Trigger Event 3 */
#define TR4EVT	0xf020	/* Trigger Event 4 */
#define TR5EVT	0xf028	/* Trigger Event 5 */
#define TR6EVT	0xf030	/* Trigger Event 6 */
#define TR7EVT	0xf038	/* Trigger Event 7 */
#define TR0ADR	0xf004	/* Trigger Address 0 */
#define TR1ADR	0xf00c	/* Trigger Address 1 */
#define TR2ADR	0xf014	/* Trigger Address 2 */
#define TR3ADR	0xf01c	/* Trigger Address 3 */
#define TR4ADR	0xf024	/* Trigger Address 4 */
#define TR5ADR	0xf02c	/* Trigger Address 5 */
#define TR6ADR	0xf034	/* Trigger Address 6 */
#define TR7ADR	0xf03c	/* Trigger Address 7 */
#define TRIG_ACC	0xfd30	/* CPUn Trigger Address x */
#define DMS	0xfd40	/* Debug Monitor Start Address */
#define DCX	0xfd44	/* Debug Context Save Area Pointer */
#define DBGTCR	0xfd48	/* Debug Trap Control Register */
#define CCTRL	0xfc00	/* Counter Control */
#define CCNT	0xfc04	/* CPU Clock Cycle Count */
#define ICNT	0xfc08	/* Instruction Count */
#define M1CNT	0xfc0c	/* Multi-Count Register 1 */
#define M2CNT	0xfc10	/* Multi-Count Register 2 */
#define M3CNT	0xfc14	/* Multi-Count Register 3 */
#define PCXI	0xfe00	/* Previous Context Information Register */
#define PSW	0xfe04	/* Program Status Word */
#define PC	0xfe08	/* Program Counter */
#define SYSCON	0xfe14	/* System Configuration Register */
#define CORE_ID	0xfe1c	/* CPUn Core Identification Register */
#define CPU_ID	0xfe18	/* CPUn Identification Register TC1.6P */
#define CUS_ID	0xfe50	/* CPUn Customer ID register */
#define BIV	0xfe20	/* Base Interrupt Vector Table Pointer */
#define BTV	0xfe24	/* Base Trap Vector Table Pointer */
#define ISP	0xfe28	/* Interrupt Stack Pointer */
#define ICR	0xfe2c	/* Interrupt Control Register */
#define FCX	0xfe38	/* Free CSA List Head Pointer */
#define LCX	0xfe3c	/* Free CSA List Limit Pointer */
#define SEGEN	0x1030	/* SRI Error Generation Register */

/* MCHK */
typedef volatile union
{
	struct
	{ 
		unsigned int MCHKCRC        : 32;	/* Memory Checker CRC */
	} B;
	int I;
	unsigned int U;

} MCHK_CRC0_type;
#define MCHK_CRC0	(*( MCHK_CRC0_type *) 0xf0004024u)	/* Memory Checker CRC Register */
#define MCHK_CRC1	(*( MCHK_CRC0_type *) 0xf0004028u)	/* Memory Checker CRC Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} MCHK_ID_type;
#define MCHK_ID	(*( MCHK_ID_type *) 0xf0004008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MCHKIN         : 32;	/* Memory Checker Input */
	} B;
	int I;
	unsigned int U;

} MCHK_IR0_type;
#define MCHK_IR0	(*( MCHK_IR0_type *) 0xf0004010u)	/* Memory Checker Input Register */
#define MCHK_IR1	(*( MCHK_IR0_type *) 0xf0004018u)	/* Memory Checker Input Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MCHKR          : 32;	/* Memory Checker Result */
	} B;
	int I;
	unsigned int U;

} MCHK_RR0_type;
#define MCHK_RR0	(*( MCHK_RR0_type *) 0xf0004014u)	/* Memory Checker Result Register */
#define MCHK_RR1	(*( MCHK_RR0_type *) 0xf000401cu)	/* Memory Checker Result Register */

typedef volatile union
{
	struct
	{ 
		unsigned int WO             : 32;	/* Write-Only */
	} B;
	int I;
	unsigned int U;

} MCHK_WR_type;
#define MCHK_WR	(*( MCHK_WR_type *) 0xf0004020u)	/* Memory Checker Write Register */


/* MTU */
typedef volatile union
{
	struct
	{ 
		unsigned int ACCSTYPE       : 8;	/* Access type */
		/* const */ unsigned int Res            : 4;	/* Reserved */
		unsigned int NUMACCS        : 4;	/* Number of accesses per address */
	} B;
	short S;
	unsigned short US;

} MC0_CONFIG0_type;
#define MC0_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061000u)	/* Configuration Register 0 */
#define MC10_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061a00u)	/* Configuration Register 0 */
#define MC11_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061b00u)	/* Configuration Register 0 */
#define MC12_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061c00u)	/* Configuration Register 0 */
#define MC13_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061d00u)	/* Configuration Register 0 */
#define MC14_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061e00u)	/* Configuration Register 0 */
#define MC15_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061f00u)	/* Configuration Register 0 */
#define MC16_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062000u)	/* Configuration Register 0 */
#define MC17_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062100u)	/* Configuration Register 0 */
#define MC18_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062200u)	/* Configuration Register 0 */
#define MC19_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062300u)	/* Configuration Register 0 */
#define MC1_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061100u)	/* Configuration Register 0 */
#define MC20_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062400u)	/* Configuration Register 0 */
#define MC21_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062500u)	/* Configuration Register 0 */
#define MC22_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062600u)	/* Configuration Register 0 */
#define MC23_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062700u)	/* Configuration Register 0 */
#define MC24_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062800u)	/* Configuration Register 0 */
#define MC25_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062900u)	/* Configuration Register 0 */
#define MC26_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062a00u)	/* Configuration Register 0 */
#define MC27_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062b00u)	/* Configuration Register 0 */
#define MC28_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062c00u)	/* Configuration Register 0 */
#define MC29_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062d00u)	/* Configuration Register 0 */
#define MC2_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061200u)	/* Configuration Register 0 */
#define MC30_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062e00u)	/* Configuration Register 0 */
#define MC31_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0062f00u)	/* Configuration Register 0 */
#define MC32_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063000u)	/* Configuration Register 0 */
#define MC33_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063100u)	/* Configuration Register 0 */
#define MC34_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063200u)	/* Configuration Register 0 */
#define MC35_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063300u)	/* Configuration Register 0 */
#define MC36_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063400u)	/* Configuration Register 0 */
#define MC37_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063500u)	/* Configuration Register 0 */
#define MC38_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063600u)	/* Configuration Register 0 */
#define MC39_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063700u)	/* Configuration Register 0 */
#define MC3_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061300u)	/* Configuration Register 0 */
#define MC40_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063800u)	/* Configuration Register 0 */
#define MC41_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063900u)	/* Configuration Register 0 */
#define MC42_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063a00u)	/* Configuration Register 0 */
#define MC43_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063b00u)	/* Configuration Register 0 */
#define MC44_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063c00u)	/* Configuration Register 0 */
#define MC45_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063d00u)	/* Configuration Register 0 */
#define MC46_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063e00u)	/* Configuration Register 0 */
#define MC47_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0063f00u)	/* Configuration Register 0 */
#define MC48_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064000u)	/* Configuration Register 0 */
#define MC49_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064100u)	/* Configuration Register 0 */
#define MC4_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061400u)	/* Configuration Register 0 */
#define MC50_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064200u)	/* Configuration Register 0 */
#define MC51_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064300u)	/* Configuration Register 0 */
#define MC52_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064400u)	/* Configuration Register 0 */
#define MC53_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064500u)	/* Configuration Register 0 */
#define MC54_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064600u)	/* Configuration Register 0 */
#define MC55_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064700u)	/* Configuration Register 0 */
#define MC56_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064800u)	/* Configuration Register 0 */
#define MC57_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064900u)	/* Configuration Register 0 */
#define MC58_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064a00u)	/* Configuration Register 0 */
#define MC59_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064b00u)	/* Configuration Register 0 */
#define MC5_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061500u)	/* Configuration Register 0 */
#define MC60_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064c00u)	/* Configuration Register 0 */
#define MC61_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064d00u)	/* Configuration Register 0 */
#define MC62_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064e00u)	/* Configuration Register 0 */
#define MC63_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0064f00u)	/* Configuration Register 0 */
#define MC64_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065000u)	/* Configuration Register 0 */
#define MC65_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065100u)	/* Configuration Register 0 */
#define MC66_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065200u)	/* Configuration Register 0 */
#define MC67_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065300u)	/* Configuration Register 0 */
#define MC68_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065400u)	/* Configuration Register 0 */
#define MC69_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065500u)	/* Configuration Register 0 */
#define MC6_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061600u)	/* Configuration Register 0 */
#define MC70_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065600u)	/* Configuration Register 0 */
#define MC71_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065700u)	/* Configuration Register 0 */
#define MC72_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065800u)	/* Configuration Register 0 */
#define MC73_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065900u)	/* Configuration Register 0 */
#define MC74_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065a00u)	/* Configuration Register 0 */
#define MC75_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065b00u)	/* Configuration Register 0 */
#define MC76_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065c00u)	/* Configuration Register 0 */
#define MC77_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065d00u)	/* Configuration Register 0 */
#define MC78_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065e00u)	/* Configuration Register 0 */
#define MC79_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0065f00u)	/* Configuration Register 0 */
#define MC7_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061700u)	/* Configuration Register 0 */
#define MC80_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0066000u)	/* Configuration Register 0 */
#define MC81_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0066100u)	/* Configuration Register 0 */
#define MC82_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0066200u)	/* Configuration Register 0 */
#define MC83_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0066300u)	/* Configuration Register 0 */
#define MC84_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0066400u)	/* Configuration Register 0 */
#define MC85_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0066500u)	/* Configuration Register 0 */
#define MC86_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0066600u)	/* Configuration Register 0 */
#define MC87_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0066700u)	/* Configuration Register 0 */
#define MC8_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061800u)	/* Configuration Register 0 */
#define MC9_CONFIG0	(*( MC0_CONFIG0_type *) 0xf0061900u)	/* Configuration Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int ACCSPAT        : 8;	/* Access pattern */
		/* const */ unsigned int Res            : 3;	/* Reserved */
		unsigned int DIR            : 1;	/* Direction */
		unsigned int AG_MOD         : 4;	/* Address Generator Mode */
	} B;
	short S;
	unsigned short US;

} MC0_CONFIG1_type;
#define MC0_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061002u)	/* Configuration Register 1 */
#define MC10_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061a02u)	/* Configuration Register 1 */
#define MC11_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061b02u)	/* Configuration Register 1 */
#define MC12_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061c02u)	/* Configuration Register 1 */
#define MC13_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061d02u)	/* Configuration Register 1 */
#define MC14_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061e02u)	/* Configuration Register 1 */
#define MC15_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061f02u)	/* Configuration Register 1 */
#define MC16_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062002u)	/* Configuration Register 1 */
#define MC17_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062102u)	/* Configuration Register 1 */
#define MC18_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062202u)	/* Configuration Register 1 */
#define MC19_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062302u)	/* Configuration Register 1 */
#define MC1_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061102u)	/* Configuration Register 1 */
#define MC20_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062402u)	/* Configuration Register 1 */
#define MC21_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062502u)	/* Configuration Register 1 */
#define MC22_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062602u)	/* Configuration Register 1 */
#define MC23_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062702u)	/* Configuration Register 1 */
#define MC24_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062802u)	/* Configuration Register 1 */
#define MC25_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062902u)	/* Configuration Register 1 */
#define MC26_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062a02u)	/* Configuration Register 1 */
#define MC27_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062b02u)	/* Configuration Register 1 */
#define MC28_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062c02u)	/* Configuration Register 1 */
#define MC29_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062d02u)	/* Configuration Register 1 */
#define MC2_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061202u)	/* Configuration Register 1 */
#define MC30_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062e02u)	/* Configuration Register 1 */
#define MC31_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0062f02u)	/* Configuration Register 1 */
#define MC32_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063002u)	/* Configuration Register 1 */
#define MC33_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063102u)	/* Configuration Register 1 */
#define MC34_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063202u)	/* Configuration Register 1 */
#define MC35_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063302u)	/* Configuration Register 1 */
#define MC36_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063402u)	/* Configuration Register 1 */
#define MC37_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063502u)	/* Configuration Register 1 */
#define MC38_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063602u)	/* Configuration Register 1 */
#define MC39_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063702u)	/* Configuration Register 1 */
#define MC3_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061302u)	/* Configuration Register 1 */
#define MC40_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063802u)	/* Configuration Register 1 */
#define MC41_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063902u)	/* Configuration Register 1 */
#define MC42_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063a02u)	/* Configuration Register 1 */
#define MC43_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063b02u)	/* Configuration Register 1 */
#define MC44_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063c02u)	/* Configuration Register 1 */
#define MC45_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063d02u)	/* Configuration Register 1 */
#define MC46_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063e02u)	/* Configuration Register 1 */
#define MC47_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0063f02u)	/* Configuration Register 1 */
#define MC48_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064002u)	/* Configuration Register 1 */
#define MC49_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064102u)	/* Configuration Register 1 */
#define MC4_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061402u)	/* Configuration Register 1 */
#define MC50_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064202u)	/* Configuration Register 1 */
#define MC51_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064302u)	/* Configuration Register 1 */
#define MC52_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064402u)	/* Configuration Register 1 */
#define MC53_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064502u)	/* Configuration Register 1 */
#define MC54_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064602u)	/* Configuration Register 1 */
#define MC55_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064702u)	/* Configuration Register 1 */
#define MC56_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064802u)	/* Configuration Register 1 */
#define MC57_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064902u)	/* Configuration Register 1 */
#define MC58_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064a02u)	/* Configuration Register 1 */
#define MC59_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064b02u)	/* Configuration Register 1 */
#define MC5_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061502u)	/* Configuration Register 1 */
#define MC60_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064c02u)	/* Configuration Register 1 */
#define MC61_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064d02u)	/* Configuration Register 1 */
#define MC62_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064e02u)	/* Configuration Register 1 */
#define MC63_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0064f02u)	/* Configuration Register 1 */
#define MC64_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065002u)	/* Configuration Register 1 */
#define MC65_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065102u)	/* Configuration Register 1 */
#define MC66_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065202u)	/* Configuration Register 1 */
#define MC67_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065302u)	/* Configuration Register 1 */
#define MC68_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065402u)	/* Configuration Register 1 */
#define MC69_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065502u)	/* Configuration Register 1 */
#define MC6_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061602u)	/* Configuration Register 1 */
#define MC70_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065602u)	/* Configuration Register 1 */
#define MC71_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065702u)	/* Configuration Register 1 */
#define MC72_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065802u)	/* Configuration Register 1 */
#define MC73_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065902u)	/* Configuration Register 1 */
#define MC74_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065a02u)	/* Configuration Register 1 */
#define MC75_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065b02u)	/* Configuration Register 1 */
#define MC76_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065c02u)	/* Configuration Register 1 */
#define MC77_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065d02u)	/* Configuration Register 1 */
#define MC78_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065e02u)	/* Configuration Register 1 */
#define MC79_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0065f02u)	/* Configuration Register 1 */
#define MC7_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061702u)	/* Configuration Register 1 */
#define MC80_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0066002u)	/* Configuration Register 1 */
#define MC81_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0066102u)	/* Configuration Register 1 */
#define MC82_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0066202u)	/* Configuration Register 1 */
#define MC83_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0066302u)	/* Configuration Register 1 */
#define MC84_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0066402u)	/* Configuration Register 1 */
#define MC85_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0066502u)	/* Configuration Register 1 */
#define MC86_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0066602u)	/* Configuration Register 1 */
#define MC87_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0066702u)	/* Configuration Register 1 */
#define MC8_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061802u)	/* Configuration Register 1 */
#define MC9_CONFIG1	(*( MC0_CONFIG1_type *) 0xf0061902u)	/* Configuration Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int SERR           : 1;	/* Error Detected */
		unsigned int CERR           : 1;	/* Correctable Error Detected */
		unsigned int UERR           : 1;	/* Uncorrectable Error Detected */
		unsigned int AERR           : 1;	/* Address Error Detected */
		/* const */ unsigned int TRC            : 1;	/* Tracking Clear */
		/* const */ unsigned int VAL            : 4;	/* Valid Bits */
		/* const */ unsigned int Res            : 6;	/* Reserved */
		/* const */ unsigned int EOV            : 1;	/* Error Overflow */
	} B;
	short S;
	unsigned short US;

} MC0_ECCD_type;
#define MC0_ECCD	(*( MC0_ECCD_type *) 0xf0061010u)	/* Memory ECC Detection Register */
#define MC10_ECCD	(*( MC0_ECCD_type *) 0xf0061a10u)	/* Memory ECC Detection Register */
#define MC11_ECCD	(*( MC0_ECCD_type *) 0xf0061b10u)	/* Memory ECC Detection Register */
#define MC12_ECCD	(*( MC0_ECCD_type *) 0xf0061c10u)	/* Memory ECC Detection Register */
#define MC13_ECCD	(*( MC0_ECCD_type *) 0xf0061d10u)	/* Memory ECC Detection Register */
#define MC14_ECCD	(*( MC0_ECCD_type *) 0xf0061e10u)	/* Memory ECC Detection Register */
#define MC15_ECCD	(*( MC0_ECCD_type *) 0xf0061f10u)	/* Memory ECC Detection Register */
#define MC16_ECCD	(*( MC0_ECCD_type *) 0xf0062010u)	/* Memory ECC Detection Register */
#define MC17_ECCD	(*( MC0_ECCD_type *) 0xf0062110u)	/* Memory ECC Detection Register */
#define MC18_ECCD	(*( MC0_ECCD_type *) 0xf0062210u)	/* Memory ECC Detection Register */
#define MC19_ECCD	(*( MC0_ECCD_type *) 0xf0062310u)	/* Memory ECC Detection Register */
#define MC1_ECCD	(*( MC0_ECCD_type *) 0xf0061110u)	/* Memory ECC Detection Register */
#define MC20_ECCD	(*( MC0_ECCD_type *) 0xf0062410u)	/* Memory ECC Detection Register */
#define MC21_ECCD	(*( MC0_ECCD_type *) 0xf0062510u)	/* Memory ECC Detection Register */
#define MC22_ECCD	(*( MC0_ECCD_type *) 0xf0062610u)	/* Memory ECC Detection Register */
#define MC23_ECCD	(*( MC0_ECCD_type *) 0xf0062710u)	/* Memory ECC Detection Register */
#define MC24_ECCD	(*( MC0_ECCD_type *) 0xf0062810u)	/* Memory ECC Detection Register */
#define MC25_ECCD	(*( MC0_ECCD_type *) 0xf0062910u)	/* Memory ECC Detection Register */
#define MC26_ECCD	(*( MC0_ECCD_type *) 0xf0062a10u)	/* Memory ECC Detection Register */
#define MC27_ECCD	(*( MC0_ECCD_type *) 0xf0062b10u)	/* Memory ECC Detection Register */
#define MC28_ECCD	(*( MC0_ECCD_type *) 0xf0062c10u)	/* Memory ECC Detection Register */
#define MC29_ECCD	(*( MC0_ECCD_type *) 0xf0062d10u)	/* Memory ECC Detection Register */
#define MC2_ECCD	(*( MC0_ECCD_type *) 0xf0061210u)	/* Memory ECC Detection Register */
#define MC30_ECCD	(*( MC0_ECCD_type *) 0xf0062e10u)	/* Memory ECC Detection Register */
#define MC31_ECCD	(*( MC0_ECCD_type *) 0xf0062f10u)	/* Memory ECC Detection Register */
#define MC32_ECCD	(*( MC0_ECCD_type *) 0xf0063010u)	/* Memory ECC Detection Register */
#define MC33_ECCD	(*( MC0_ECCD_type *) 0xf0063110u)	/* Memory ECC Detection Register */
#define MC34_ECCD	(*( MC0_ECCD_type *) 0xf0063210u)	/* Memory ECC Detection Register */
#define MC35_ECCD	(*( MC0_ECCD_type *) 0xf0063310u)	/* Memory ECC Detection Register */
#define MC36_ECCD	(*( MC0_ECCD_type *) 0xf0063410u)	/* Memory ECC Detection Register */
#define MC37_ECCD	(*( MC0_ECCD_type *) 0xf0063510u)	/* Memory ECC Detection Register */
#define MC38_ECCD	(*( MC0_ECCD_type *) 0xf0063610u)	/* Memory ECC Detection Register */
#define MC39_ECCD	(*( MC0_ECCD_type *) 0xf0063710u)	/* Memory ECC Detection Register */
#define MC3_ECCD	(*( MC0_ECCD_type *) 0xf0061310u)	/* Memory ECC Detection Register */
#define MC40_ECCD	(*( MC0_ECCD_type *) 0xf0063810u)	/* Memory ECC Detection Register */
#define MC41_ECCD	(*( MC0_ECCD_type *) 0xf0063910u)	/* Memory ECC Detection Register */
#define MC42_ECCD	(*( MC0_ECCD_type *) 0xf0063a10u)	/* Memory ECC Detection Register */
#define MC43_ECCD	(*( MC0_ECCD_type *) 0xf0063b10u)	/* Memory ECC Detection Register */
#define MC44_ECCD	(*( MC0_ECCD_type *) 0xf0063c10u)	/* Memory ECC Detection Register */
#define MC45_ECCD	(*( MC0_ECCD_type *) 0xf0063d10u)	/* Memory ECC Detection Register */
#define MC46_ECCD	(*( MC0_ECCD_type *) 0xf0063e10u)	/* Memory ECC Detection Register */
#define MC47_ECCD	(*( MC0_ECCD_type *) 0xf0063f10u)	/* Memory ECC Detection Register */
#define MC48_ECCD	(*( MC0_ECCD_type *) 0xf0064010u)	/* Memory ECC Detection Register */
#define MC49_ECCD	(*( MC0_ECCD_type *) 0xf0064110u)	/* Memory ECC Detection Register */
#define MC4_ECCD	(*( MC0_ECCD_type *) 0xf0061410u)	/* Memory ECC Detection Register */
#define MC50_ECCD	(*( MC0_ECCD_type *) 0xf0064210u)	/* Memory ECC Detection Register */
#define MC51_ECCD	(*( MC0_ECCD_type *) 0xf0064310u)	/* Memory ECC Detection Register */
#define MC52_ECCD	(*( MC0_ECCD_type *) 0xf0064410u)	/* Memory ECC Detection Register */
#define MC53_ECCD	(*( MC0_ECCD_type *) 0xf0064510u)	/* Memory ECC Detection Register */
#define MC54_ECCD	(*( MC0_ECCD_type *) 0xf0064610u)	/* Memory ECC Detection Register */
#define MC55_ECCD	(*( MC0_ECCD_type *) 0xf0064710u)	/* Memory ECC Detection Register */
#define MC56_ECCD	(*( MC0_ECCD_type *) 0xf0064810u)	/* Memory ECC Detection Register */
#define MC57_ECCD	(*( MC0_ECCD_type *) 0xf0064910u)	/* Memory ECC Detection Register */
#define MC58_ECCD	(*( MC0_ECCD_type *) 0xf0064a10u)	/* Memory ECC Detection Register */
#define MC59_ECCD	(*( MC0_ECCD_type *) 0xf0064b10u)	/* Memory ECC Detection Register */
#define MC5_ECCD	(*( MC0_ECCD_type *) 0xf0061510u)	/* Memory ECC Detection Register */
#define MC60_ECCD	(*( MC0_ECCD_type *) 0xf0064c10u)	/* Memory ECC Detection Register */
#define MC61_ECCD	(*( MC0_ECCD_type *) 0xf0064d10u)	/* Memory ECC Detection Register */
#define MC62_ECCD	(*( MC0_ECCD_type *) 0xf0064e10u)	/* Memory ECC Detection Register */
#define MC63_ECCD	(*( MC0_ECCD_type *) 0xf0064f10u)	/* Memory ECC Detection Register */
#define MC64_ECCD	(*( MC0_ECCD_type *) 0xf0065010u)	/* Memory ECC Detection Register */
#define MC65_ECCD	(*( MC0_ECCD_type *) 0xf0065110u)	/* Memory ECC Detection Register */
#define MC66_ECCD	(*( MC0_ECCD_type *) 0xf0065210u)	/* Memory ECC Detection Register */
#define MC67_ECCD	(*( MC0_ECCD_type *) 0xf0065310u)	/* Memory ECC Detection Register */
#define MC68_ECCD	(*( MC0_ECCD_type *) 0xf0065410u)	/* Memory ECC Detection Register */
#define MC69_ECCD	(*( MC0_ECCD_type *) 0xf0065510u)	/* Memory ECC Detection Register */
#define MC6_ECCD	(*( MC0_ECCD_type *) 0xf0061610u)	/* Memory ECC Detection Register */
#define MC70_ECCD	(*( MC0_ECCD_type *) 0xf0065610u)	/* Memory ECC Detection Register */
#define MC71_ECCD	(*( MC0_ECCD_type *) 0xf0065710u)	/* Memory ECC Detection Register */
#define MC72_ECCD	(*( MC0_ECCD_type *) 0xf0065810u)	/* Memory ECC Detection Register */
#define MC73_ECCD	(*( MC0_ECCD_type *) 0xf0065910u)	/* Memory ECC Detection Register */
#define MC74_ECCD	(*( MC0_ECCD_type *) 0xf0065a10u)	/* Memory ECC Detection Register */
#define MC75_ECCD	(*( MC0_ECCD_type *) 0xf0065b10u)	/* Memory ECC Detection Register */
#define MC76_ECCD	(*( MC0_ECCD_type *) 0xf0065c10u)	/* Memory ECC Detection Register */
#define MC77_ECCD	(*( MC0_ECCD_type *) 0xf0065d10u)	/* Memory ECC Detection Register */
#define MC78_ECCD	(*( MC0_ECCD_type *) 0xf0065e10u)	/* Memory ECC Detection Register */
#define MC79_ECCD	(*( MC0_ECCD_type *) 0xf0065f10u)	/* Memory ECC Detection Register */
#define MC7_ECCD	(*( MC0_ECCD_type *) 0xf0061710u)	/* Memory ECC Detection Register */
#define MC80_ECCD	(*( MC0_ECCD_type *) 0xf0066010u)	/* Memory ECC Detection Register */
#define MC81_ECCD	(*( MC0_ECCD_type *) 0xf0066110u)	/* Memory ECC Detection Register */
#define MC82_ECCD	(*( MC0_ECCD_type *) 0xf0066210u)	/* Memory ECC Detection Register */
#define MC83_ECCD	(*( MC0_ECCD_type *) 0xf0066310u)	/* Memory ECC Detection Register */
#define MC84_ECCD	(*( MC0_ECCD_type *) 0xf0066410u)	/* Memory ECC Detection Register */
#define MC85_ECCD	(*( MC0_ECCD_type *) 0xf0066510u)	/* Memory ECC Detection Register */
#define MC86_ECCD	(*( MC0_ECCD_type *) 0xf0066610u)	/* Memory ECC Detection Register */
#define MC87_ECCD	(*( MC0_ECCD_type *) 0xf0066710u)	/* Memory ECC Detection Register */
#define MC8_ECCD	(*( MC0_ECCD_type *) 0xf0061810u)	/* Memory ECC Detection Register */
#define MC9_ECCD	(*( MC0_ECCD_type *) 0xf0061910u)	/* Memory ECC Detection Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CENE           : 1;	/* Correctable Error Notification Enable */
		unsigned int UENE           : 1;	/* Uncorrectable Error Notification Enable */
		unsigned int AENE           : 1;	/* Address Error Notification Enable */
		unsigned int ECE            : 1;	/* Error Correction Enable */
		unsigned int TRE            : 1;	/* Tracking Enable */
		unsigned int BFLE           : 1;	/* Bit Flip Enable */
		unsigned int SFLE           : 2;	/* Signature Bit Flip Enables */
		unsigned int ECCMAP         : 2;	/* ECC Bit Mapping Mode */
		unsigned int TC_WAY_SEL     : 2;	/* TriCore Cache Way Select */
		/* const */ unsigned int Res            : 4;	/* Reserved */
	} B;
	short S;
	unsigned short US;

} MC0_ECCS_type;
#define MC0_ECCS	(*( MC0_ECCS_type *) 0xf006100eu)	/* ECC Safety Register */
#define MC10_ECCS	(*( MC0_ECCS_type *) 0xf0061a0eu)	/* ECC Safety Register */
#define MC11_ECCS	(*( MC0_ECCS_type *) 0xf0061b0eu)	/* ECC Safety Register */
#define MC12_ECCS	(*( MC0_ECCS_type *) 0xf0061c0eu)	/* ECC Safety Register */
#define MC13_ECCS	(*( MC0_ECCS_type *) 0xf0061d0eu)	/* ECC Safety Register */
#define MC14_ECCS	(*( MC0_ECCS_type *) 0xf0061e0eu)	/* ECC Safety Register */
#define MC15_ECCS	(*( MC0_ECCS_type *) 0xf0061f0eu)	/* ECC Safety Register */
#define MC16_ECCS	(*( MC0_ECCS_type *) 0xf006200eu)	/* ECC Safety Register */
#define MC17_ECCS	(*( MC0_ECCS_type *) 0xf006210eu)	/* ECC Safety Register */
#define MC18_ECCS	(*( MC0_ECCS_type *) 0xf006220eu)	/* ECC Safety Register */
#define MC19_ECCS	(*( MC0_ECCS_type *) 0xf006230eu)	/* ECC Safety Register */
#define MC1_ECCS	(*( MC0_ECCS_type *) 0xf006110eu)	/* ECC Safety Register */
#define MC20_ECCS	(*( MC0_ECCS_type *) 0xf006240eu)	/* ECC Safety Register */
#define MC21_ECCS	(*( MC0_ECCS_type *) 0xf006250eu)	/* ECC Safety Register */
#define MC22_ECCS	(*( MC0_ECCS_type *) 0xf006260eu)	/* ECC Safety Register */
#define MC23_ECCS	(*( MC0_ECCS_type *) 0xf006270eu)	/* ECC Safety Register */
#define MC24_ECCS	(*( MC0_ECCS_type *) 0xf006280eu)	/* ECC Safety Register */
#define MC25_ECCS	(*( MC0_ECCS_type *) 0xf006290eu)	/* ECC Safety Register */
#define MC26_ECCS	(*( MC0_ECCS_type *) 0xf0062a0eu)	/* ECC Safety Register */
#define MC27_ECCS	(*( MC0_ECCS_type *) 0xf0062b0eu)	/* ECC Safety Register */
#define MC28_ECCS	(*( MC0_ECCS_type *) 0xf0062c0eu)	/* ECC Safety Register */
#define MC29_ECCS	(*( MC0_ECCS_type *) 0xf0062d0eu)	/* ECC Safety Register */
#define MC2_ECCS	(*( MC0_ECCS_type *) 0xf006120eu)	/* ECC Safety Register */
#define MC30_ECCS	(*( MC0_ECCS_type *) 0xf0062e0eu)	/* ECC Safety Register */
#define MC31_ECCS	(*( MC0_ECCS_type *) 0xf0062f0eu)	/* ECC Safety Register */
#define MC32_ECCS	(*( MC0_ECCS_type *) 0xf006300eu)	/* ECC Safety Register */
#define MC33_ECCS	(*( MC0_ECCS_type *) 0xf006310eu)	/* ECC Safety Register */
#define MC34_ECCS	(*( MC0_ECCS_type *) 0xf006320eu)	/* ECC Safety Register */
#define MC35_ECCS	(*( MC0_ECCS_type *) 0xf006330eu)	/* ECC Safety Register */
#define MC36_ECCS	(*( MC0_ECCS_type *) 0xf006340eu)	/* ECC Safety Register */
#define MC37_ECCS	(*( MC0_ECCS_type *) 0xf006350eu)	/* ECC Safety Register */
#define MC38_ECCS	(*( MC0_ECCS_type *) 0xf006360eu)	/* ECC Safety Register */
#define MC39_ECCS	(*( MC0_ECCS_type *) 0xf006370eu)	/* ECC Safety Register */
#define MC3_ECCS	(*( MC0_ECCS_type *) 0xf006130eu)	/* ECC Safety Register */
#define MC40_ECCS	(*( MC0_ECCS_type *) 0xf006380eu)	/* ECC Safety Register */
#define MC41_ECCS	(*( MC0_ECCS_type *) 0xf006390eu)	/* ECC Safety Register */
#define MC42_ECCS	(*( MC0_ECCS_type *) 0xf0063a0eu)	/* ECC Safety Register */
#define MC43_ECCS	(*( MC0_ECCS_type *) 0xf0063b0eu)	/* ECC Safety Register */
#define MC44_ECCS	(*( MC0_ECCS_type *) 0xf0063c0eu)	/* ECC Safety Register */
#define MC45_ECCS	(*( MC0_ECCS_type *) 0xf0063d0eu)	/* ECC Safety Register */
#define MC46_ECCS	(*( MC0_ECCS_type *) 0xf0063e0eu)	/* ECC Safety Register */
#define MC47_ECCS	(*( MC0_ECCS_type *) 0xf0063f0eu)	/* ECC Safety Register */
#define MC48_ECCS	(*( MC0_ECCS_type *) 0xf006400eu)	/* ECC Safety Register */
#define MC49_ECCS	(*( MC0_ECCS_type *) 0xf006410eu)	/* ECC Safety Register */
#define MC4_ECCS	(*( MC0_ECCS_type *) 0xf006140eu)	/* ECC Safety Register */
#define MC50_ECCS	(*( MC0_ECCS_type *) 0xf006420eu)	/* ECC Safety Register */
#define MC51_ECCS	(*( MC0_ECCS_type *) 0xf006430eu)	/* ECC Safety Register */
#define MC52_ECCS	(*( MC0_ECCS_type *) 0xf006440eu)	/* ECC Safety Register */
#define MC53_ECCS	(*( MC0_ECCS_type *) 0xf006450eu)	/* ECC Safety Register */
#define MC54_ECCS	(*( MC0_ECCS_type *) 0xf006460eu)	/* ECC Safety Register */
#define MC55_ECCS	(*( MC0_ECCS_type *) 0xf006470eu)	/* ECC Safety Register */
#define MC56_ECCS	(*( MC0_ECCS_type *) 0xf006480eu)	/* ECC Safety Register */
#define MC57_ECCS	(*( MC0_ECCS_type *) 0xf006490eu)	/* ECC Safety Register */
#define MC58_ECCS	(*( MC0_ECCS_type *) 0xf0064a0eu)	/* ECC Safety Register */
#define MC59_ECCS	(*( MC0_ECCS_type *) 0xf0064b0eu)	/* ECC Safety Register */
#define MC5_ECCS	(*( MC0_ECCS_type *) 0xf006150eu)	/* ECC Safety Register */
#define MC60_ECCS	(*( MC0_ECCS_type *) 0xf0064c0eu)	/* ECC Safety Register */
#define MC61_ECCS	(*( MC0_ECCS_type *) 0xf0064d0eu)	/* ECC Safety Register */
#define MC62_ECCS	(*( MC0_ECCS_type *) 0xf0064e0eu)	/* ECC Safety Register */
#define MC63_ECCS	(*( MC0_ECCS_type *) 0xf0064f0eu)	/* ECC Safety Register */
#define MC64_ECCS	(*( MC0_ECCS_type *) 0xf006500eu)	/* ECC Safety Register */
#define MC65_ECCS	(*( MC0_ECCS_type *) 0xf006510eu)	/* ECC Safety Register */
#define MC66_ECCS	(*( MC0_ECCS_type *) 0xf006520eu)	/* ECC Safety Register */
#define MC67_ECCS	(*( MC0_ECCS_type *) 0xf006530eu)	/* ECC Safety Register */
#define MC68_ECCS	(*( MC0_ECCS_type *) 0xf006540eu)	/* ECC Safety Register */
#define MC69_ECCS	(*( MC0_ECCS_type *) 0xf006550eu)	/* ECC Safety Register */
#define MC6_ECCS	(*( MC0_ECCS_type *) 0xf006160eu)	/* ECC Safety Register */
#define MC70_ECCS	(*( MC0_ECCS_type *) 0xf006560eu)	/* ECC Safety Register */
#define MC71_ECCS	(*( MC0_ECCS_type *) 0xf006570eu)	/* ECC Safety Register */
#define MC72_ECCS	(*( MC0_ECCS_type *) 0xf006580eu)	/* ECC Safety Register */
#define MC73_ECCS	(*( MC0_ECCS_type *) 0xf006590eu)	/* ECC Safety Register */
#define MC74_ECCS	(*( MC0_ECCS_type *) 0xf0065a0eu)	/* ECC Safety Register */
#define MC75_ECCS	(*( MC0_ECCS_type *) 0xf0065b0eu)	/* ECC Safety Register */
#define MC76_ECCS	(*( MC0_ECCS_type *) 0xf0065c0eu)	/* ECC Safety Register */
#define MC77_ECCS	(*( MC0_ECCS_type *) 0xf0065d0eu)	/* ECC Safety Register */
#define MC78_ECCS	(*( MC0_ECCS_type *) 0xf0065e0eu)	/* ECC Safety Register */
#define MC79_ECCS	(*( MC0_ECCS_type *) 0xf0065f0eu)	/* ECC Safety Register */
#define MC7_ECCS	(*( MC0_ECCS_type *) 0xf006170eu)	/* ECC Safety Register */
#define MC80_ECCS	(*( MC0_ECCS_type *) 0xf006600eu)	/* ECC Safety Register */
#define MC81_ECCS	(*( MC0_ECCS_type *) 0xf006610eu)	/* ECC Safety Register */
#define MC82_ECCS	(*( MC0_ECCS_type *) 0xf006620eu)	/* ECC Safety Register */
#define MC83_ECCS	(*( MC0_ECCS_type *) 0xf006630eu)	/* ECC Safety Register */
#define MC84_ECCS	(*( MC0_ECCS_type *) 0xf006640eu)	/* ECC Safety Register */
#define MC85_ECCS	(*( MC0_ECCS_type *) 0xf006650eu)	/* ECC Safety Register */
#define MC86_ECCS	(*( MC0_ECCS_type *) 0xf006660eu)	/* ECC Safety Register */
#define MC87_ECCS	(*( MC0_ECCS_type *) 0xf006670eu)	/* ECC Safety Register */
#define MC8_ECCS	(*( MC0_ECCS_type *) 0xf006180eu)	/* ECC Safety Register */
#define MC9_ECCS	(*( MC0_ECCS_type *) 0xf006190eu)	/* ECC Safety Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ADDR           : 16;	/* Address of Error(i) */
	} B;
	short S;
	unsigned short US;

} MC0_ETRR0_type;
#define MC0_ETRR0	(*( MC0_ETRR0_type *) 0xf0061012u)	/* Error Tracking Register */
#define MC0_ETRR1	(*( MC0_ETRR0_type *) 0xf0061014u)	/* Error Tracking Register */
#define MC0_ETRR2	(*( MC0_ETRR0_type *) 0xf0061016u)	/* Error Tracking Register */
#define MC0_ETRR3	(*( MC0_ETRR0_type *) 0xf0061018u)	/* Error Tracking Register */
#define MC10_ETRR0	(*( MC0_ETRR0_type *) 0xf0061a12u)	/* Error Tracking Register */
#define MC10_ETRR1	(*( MC0_ETRR0_type *) 0xf0061a14u)	/* Error Tracking Register */
#define MC10_ETRR2	(*( MC0_ETRR0_type *) 0xf0061a16u)	/* Error Tracking Register */
#define MC10_ETRR3	(*( MC0_ETRR0_type *) 0xf0061a18u)	/* Error Tracking Register */
#define MC11_ETRR0	(*( MC0_ETRR0_type *) 0xf0061b12u)	/* Error Tracking Register */
#define MC11_ETRR1	(*( MC0_ETRR0_type *) 0xf0061b14u)	/* Error Tracking Register */
#define MC11_ETRR2	(*( MC0_ETRR0_type *) 0xf0061b16u)	/* Error Tracking Register */
#define MC11_ETRR3	(*( MC0_ETRR0_type *) 0xf0061b18u)	/* Error Tracking Register */
#define MC12_ETRR0	(*( MC0_ETRR0_type *) 0xf0061c12u)	/* Error Tracking Register */
#define MC12_ETRR1	(*( MC0_ETRR0_type *) 0xf0061c14u)	/* Error Tracking Register */
#define MC12_ETRR2	(*( MC0_ETRR0_type *) 0xf0061c16u)	/* Error Tracking Register */
#define MC12_ETRR3	(*( MC0_ETRR0_type *) 0xf0061c18u)	/* Error Tracking Register */
#define MC13_ETRR0	(*( MC0_ETRR0_type *) 0xf0061d12u)	/* Error Tracking Register */
#define MC13_ETRR1	(*( MC0_ETRR0_type *) 0xf0061d14u)	/* Error Tracking Register */
#define MC13_ETRR2	(*( MC0_ETRR0_type *) 0xf0061d16u)	/* Error Tracking Register */
#define MC13_ETRR3	(*( MC0_ETRR0_type *) 0xf0061d18u)	/* Error Tracking Register */
#define MC14_ETRR0	(*( MC0_ETRR0_type *) 0xf0061e12u)	/* Error Tracking Register */
#define MC14_ETRR1	(*( MC0_ETRR0_type *) 0xf0061e14u)	/* Error Tracking Register */
#define MC14_ETRR2	(*( MC0_ETRR0_type *) 0xf0061e16u)	/* Error Tracking Register */
#define MC14_ETRR3	(*( MC0_ETRR0_type *) 0xf0061e18u)	/* Error Tracking Register */
#define MC15_ETRR0	(*( MC0_ETRR0_type *) 0xf0061f12u)	/* Error Tracking Register */
#define MC15_ETRR1	(*( MC0_ETRR0_type *) 0xf0061f14u)	/* Error Tracking Register */
#define MC15_ETRR2	(*( MC0_ETRR0_type *) 0xf0061f16u)	/* Error Tracking Register */
#define MC15_ETRR3	(*( MC0_ETRR0_type *) 0xf0061f18u)	/* Error Tracking Register */
#define MC16_ETRR0	(*( MC0_ETRR0_type *) 0xf0062012u)	/* Error Tracking Register */
#define MC16_ETRR1	(*( MC0_ETRR0_type *) 0xf0062014u)	/* Error Tracking Register */
#define MC16_ETRR2	(*( MC0_ETRR0_type *) 0xf0062016u)	/* Error Tracking Register */
#define MC16_ETRR3	(*( MC0_ETRR0_type *) 0xf0062018u)	/* Error Tracking Register */
#define MC17_ETRR0	(*( MC0_ETRR0_type *) 0xf0062112u)	/* Error Tracking Register */
#define MC17_ETRR1	(*( MC0_ETRR0_type *) 0xf0062114u)	/* Error Tracking Register */
#define MC17_ETRR2	(*( MC0_ETRR0_type *) 0xf0062116u)	/* Error Tracking Register */
#define MC17_ETRR3	(*( MC0_ETRR0_type *) 0xf0062118u)	/* Error Tracking Register */
#define MC18_ETRR0	(*( MC0_ETRR0_type *) 0xf0062212u)	/* Error Tracking Register */
#define MC18_ETRR1	(*( MC0_ETRR0_type *) 0xf0062214u)	/* Error Tracking Register */
#define MC18_ETRR2	(*( MC0_ETRR0_type *) 0xf0062216u)	/* Error Tracking Register */
#define MC18_ETRR3	(*( MC0_ETRR0_type *) 0xf0062218u)	/* Error Tracking Register */
#define MC19_ETRR0	(*( MC0_ETRR0_type *) 0xf0062312u)	/* Error Tracking Register */
#define MC19_ETRR1	(*( MC0_ETRR0_type *) 0xf0062314u)	/* Error Tracking Register */
#define MC19_ETRR2	(*( MC0_ETRR0_type *) 0xf0062316u)	/* Error Tracking Register */
#define MC19_ETRR3	(*( MC0_ETRR0_type *) 0xf0062318u)	/* Error Tracking Register */
#define MC1_ETRR0	(*( MC0_ETRR0_type *) 0xf0061112u)	/* Error Tracking Register */
#define MC1_ETRR1	(*( MC0_ETRR0_type *) 0xf0061114u)	/* Error Tracking Register */
#define MC1_ETRR2	(*( MC0_ETRR0_type *) 0xf0061116u)	/* Error Tracking Register */
#define MC1_ETRR3	(*( MC0_ETRR0_type *) 0xf0061118u)	/* Error Tracking Register */
#define MC20_ETRR0	(*( MC0_ETRR0_type *) 0xf0062412u)	/* Error Tracking Register */
#define MC20_ETRR1	(*( MC0_ETRR0_type *) 0xf0062414u)	/* Error Tracking Register */
#define MC20_ETRR2	(*( MC0_ETRR0_type *) 0xf0062416u)	/* Error Tracking Register */
#define MC20_ETRR3	(*( MC0_ETRR0_type *) 0xf0062418u)	/* Error Tracking Register */
#define MC21_ETRR0	(*( MC0_ETRR0_type *) 0xf0062512u)	/* Error Tracking Register */
#define MC21_ETRR1	(*( MC0_ETRR0_type *) 0xf0062514u)	/* Error Tracking Register */
#define MC21_ETRR2	(*( MC0_ETRR0_type *) 0xf0062516u)	/* Error Tracking Register */
#define MC21_ETRR3	(*( MC0_ETRR0_type *) 0xf0062518u)	/* Error Tracking Register */
#define MC22_ETRR0	(*( MC0_ETRR0_type *) 0xf0062612u)	/* Error Tracking Register */
#define MC22_ETRR1	(*( MC0_ETRR0_type *) 0xf0062614u)	/* Error Tracking Register */
#define MC22_ETRR2	(*( MC0_ETRR0_type *) 0xf0062616u)	/* Error Tracking Register */
#define MC22_ETRR3	(*( MC0_ETRR0_type *) 0xf0062618u)	/* Error Tracking Register */
#define MC23_ETRR0	(*( MC0_ETRR0_type *) 0xf0062712u)	/* Error Tracking Register */
#define MC23_ETRR1	(*( MC0_ETRR0_type *) 0xf0062714u)	/* Error Tracking Register */
#define MC23_ETRR2	(*( MC0_ETRR0_type *) 0xf0062716u)	/* Error Tracking Register */
#define MC23_ETRR3	(*( MC0_ETRR0_type *) 0xf0062718u)	/* Error Tracking Register */
#define MC24_ETRR0	(*( MC0_ETRR0_type *) 0xf0062812u)	/* Error Tracking Register */
#define MC24_ETRR1	(*( MC0_ETRR0_type *) 0xf0062814u)	/* Error Tracking Register */
#define MC24_ETRR2	(*( MC0_ETRR0_type *) 0xf0062816u)	/* Error Tracking Register */
#define MC24_ETRR3	(*( MC0_ETRR0_type *) 0xf0062818u)	/* Error Tracking Register */
#define MC25_ETRR0	(*( MC0_ETRR0_type *) 0xf0062912u)	/* Error Tracking Register */
#define MC25_ETRR1	(*( MC0_ETRR0_type *) 0xf0062914u)	/* Error Tracking Register */
#define MC25_ETRR2	(*( MC0_ETRR0_type *) 0xf0062916u)	/* Error Tracking Register */
#define MC25_ETRR3	(*( MC0_ETRR0_type *) 0xf0062918u)	/* Error Tracking Register */
#define MC26_ETRR0	(*( MC0_ETRR0_type *) 0xf0062a12u)	/* Error Tracking Register */
#define MC26_ETRR1	(*( MC0_ETRR0_type *) 0xf0062a14u)	/* Error Tracking Register */
#define MC26_ETRR2	(*( MC0_ETRR0_type *) 0xf0062a16u)	/* Error Tracking Register */
#define MC26_ETRR3	(*( MC0_ETRR0_type *) 0xf0062a18u)	/* Error Tracking Register */
#define MC27_ETRR0	(*( MC0_ETRR0_type *) 0xf0062b12u)	/* Error Tracking Register */
#define MC27_ETRR1	(*( MC0_ETRR0_type *) 0xf0062b14u)	/* Error Tracking Register */
#define MC27_ETRR2	(*( MC0_ETRR0_type *) 0xf0062b16u)	/* Error Tracking Register */
#define MC27_ETRR3	(*( MC0_ETRR0_type *) 0xf0062b18u)	/* Error Tracking Register */
#define MC28_ETRR0	(*( MC0_ETRR0_type *) 0xf0062c12u)	/* Error Tracking Register */
#define MC28_ETRR1	(*( MC0_ETRR0_type *) 0xf0062c14u)	/* Error Tracking Register */
#define MC28_ETRR2	(*( MC0_ETRR0_type *) 0xf0062c16u)	/* Error Tracking Register */
#define MC28_ETRR3	(*( MC0_ETRR0_type *) 0xf0062c18u)	/* Error Tracking Register */
#define MC29_ETRR0	(*( MC0_ETRR0_type *) 0xf0062d12u)	/* Error Tracking Register */
#define MC29_ETRR1	(*( MC0_ETRR0_type *) 0xf0062d14u)	/* Error Tracking Register */
#define MC29_ETRR2	(*( MC0_ETRR0_type *) 0xf0062d16u)	/* Error Tracking Register */
#define MC29_ETRR3	(*( MC0_ETRR0_type *) 0xf0062d18u)	/* Error Tracking Register */
#define MC2_ETRR0	(*( MC0_ETRR0_type *) 0xf0061212u)	/* Error Tracking Register */
#define MC2_ETRR1	(*( MC0_ETRR0_type *) 0xf0061214u)	/* Error Tracking Register */
#define MC2_ETRR2	(*( MC0_ETRR0_type *) 0xf0061216u)	/* Error Tracking Register */
#define MC2_ETRR3	(*( MC0_ETRR0_type *) 0xf0061218u)	/* Error Tracking Register */
#define MC30_ETRR0	(*( MC0_ETRR0_type *) 0xf0062e12u)	/* Error Tracking Register */
#define MC30_ETRR1	(*( MC0_ETRR0_type *) 0xf0062e14u)	/* Error Tracking Register */
#define MC30_ETRR2	(*( MC0_ETRR0_type *) 0xf0062e16u)	/* Error Tracking Register */
#define MC30_ETRR3	(*( MC0_ETRR0_type *) 0xf0062e18u)	/* Error Tracking Register */
#define MC31_ETRR0	(*( MC0_ETRR0_type *) 0xf0062f12u)	/* Error Tracking Register */
#define MC31_ETRR1	(*( MC0_ETRR0_type *) 0xf0062f14u)	/* Error Tracking Register */
#define MC31_ETRR2	(*( MC0_ETRR0_type *) 0xf0062f16u)	/* Error Tracking Register */
#define MC31_ETRR3	(*( MC0_ETRR0_type *) 0xf0062f18u)	/* Error Tracking Register */
#define MC32_ETRR0	(*( MC0_ETRR0_type *) 0xf0063012u)	/* Error Tracking Register */
#define MC32_ETRR1	(*( MC0_ETRR0_type *) 0xf0063014u)	/* Error Tracking Register */
#define MC32_ETRR2	(*( MC0_ETRR0_type *) 0xf0063016u)	/* Error Tracking Register */
#define MC32_ETRR3	(*( MC0_ETRR0_type *) 0xf0063018u)	/* Error Tracking Register */
#define MC33_ETRR0	(*( MC0_ETRR0_type *) 0xf0063112u)	/* Error Tracking Register */
#define MC33_ETRR1	(*( MC0_ETRR0_type *) 0xf0063114u)	/* Error Tracking Register */
#define MC33_ETRR2	(*( MC0_ETRR0_type *) 0xf0063116u)	/* Error Tracking Register */
#define MC33_ETRR3	(*( MC0_ETRR0_type *) 0xf0063118u)	/* Error Tracking Register */
#define MC34_ETRR0	(*( MC0_ETRR0_type *) 0xf0063212u)	/* Error Tracking Register */
#define MC34_ETRR1	(*( MC0_ETRR0_type *) 0xf0063214u)	/* Error Tracking Register */
#define MC34_ETRR2	(*( MC0_ETRR0_type *) 0xf0063216u)	/* Error Tracking Register */
#define MC34_ETRR3	(*( MC0_ETRR0_type *) 0xf0063218u)	/* Error Tracking Register */
#define MC35_ETRR0	(*( MC0_ETRR0_type *) 0xf0063312u)	/* Error Tracking Register */
#define MC35_ETRR1	(*( MC0_ETRR0_type *) 0xf0063314u)	/* Error Tracking Register */
#define MC35_ETRR2	(*( MC0_ETRR0_type *) 0xf0063316u)	/* Error Tracking Register */
#define MC35_ETRR3	(*( MC0_ETRR0_type *) 0xf0063318u)	/* Error Tracking Register */
#define MC36_ETRR0	(*( MC0_ETRR0_type *) 0xf0063412u)	/* Error Tracking Register */
#define MC36_ETRR1	(*( MC0_ETRR0_type *) 0xf0063414u)	/* Error Tracking Register */
#define MC36_ETRR2	(*( MC0_ETRR0_type *) 0xf0063416u)	/* Error Tracking Register */
#define MC36_ETRR3	(*( MC0_ETRR0_type *) 0xf0063418u)	/* Error Tracking Register */
#define MC37_ETRR0	(*( MC0_ETRR0_type *) 0xf0063512u)	/* Error Tracking Register */
#define MC37_ETRR1	(*( MC0_ETRR0_type *) 0xf0063514u)	/* Error Tracking Register */
#define MC37_ETRR2	(*( MC0_ETRR0_type *) 0xf0063516u)	/* Error Tracking Register */
#define MC37_ETRR3	(*( MC0_ETRR0_type *) 0xf0063518u)	/* Error Tracking Register */
#define MC38_ETRR0	(*( MC0_ETRR0_type *) 0xf0063612u)	/* Error Tracking Register */
#define MC38_ETRR1	(*( MC0_ETRR0_type *) 0xf0063614u)	/* Error Tracking Register */
#define MC38_ETRR2	(*( MC0_ETRR0_type *) 0xf0063616u)	/* Error Tracking Register */
#define MC38_ETRR3	(*( MC0_ETRR0_type *) 0xf0063618u)	/* Error Tracking Register */
#define MC39_ETRR0	(*( MC0_ETRR0_type *) 0xf0063712u)	/* Error Tracking Register */
#define MC39_ETRR1	(*( MC0_ETRR0_type *) 0xf0063714u)	/* Error Tracking Register */
#define MC39_ETRR2	(*( MC0_ETRR0_type *) 0xf0063716u)	/* Error Tracking Register */
#define MC39_ETRR3	(*( MC0_ETRR0_type *) 0xf0063718u)	/* Error Tracking Register */
#define MC3_ETRR0	(*( MC0_ETRR0_type *) 0xf0061312u)	/* Error Tracking Register */
#define MC3_ETRR1	(*( MC0_ETRR0_type *) 0xf0061314u)	/* Error Tracking Register */
#define MC3_ETRR2	(*( MC0_ETRR0_type *) 0xf0061316u)	/* Error Tracking Register */
#define MC3_ETRR3	(*( MC0_ETRR0_type *) 0xf0061318u)	/* Error Tracking Register */
#define MC40_ETRR0	(*( MC0_ETRR0_type *) 0xf0063812u)	/* Error Tracking Register */
#define MC40_ETRR1	(*( MC0_ETRR0_type *) 0xf0063814u)	/* Error Tracking Register */
#define MC40_ETRR2	(*( MC0_ETRR0_type *) 0xf0063816u)	/* Error Tracking Register */
#define MC40_ETRR3	(*( MC0_ETRR0_type *) 0xf0063818u)	/* Error Tracking Register */
#define MC41_ETRR0	(*( MC0_ETRR0_type *) 0xf0063912u)	/* Error Tracking Register */
#define MC41_ETRR1	(*( MC0_ETRR0_type *) 0xf0063914u)	/* Error Tracking Register */
#define MC41_ETRR2	(*( MC0_ETRR0_type *) 0xf0063916u)	/* Error Tracking Register */
#define MC41_ETRR3	(*( MC0_ETRR0_type *) 0xf0063918u)	/* Error Tracking Register */
#define MC42_ETRR0	(*( MC0_ETRR0_type *) 0xf0063a12u)	/* Error Tracking Register */
#define MC42_ETRR1	(*( MC0_ETRR0_type *) 0xf0063a14u)	/* Error Tracking Register */
#define MC42_ETRR2	(*( MC0_ETRR0_type *) 0xf0063a16u)	/* Error Tracking Register */
#define MC42_ETRR3	(*( MC0_ETRR0_type *) 0xf0063a18u)	/* Error Tracking Register */
#define MC43_ETRR0	(*( MC0_ETRR0_type *) 0xf0063b12u)	/* Error Tracking Register */
#define MC43_ETRR1	(*( MC0_ETRR0_type *) 0xf0063b14u)	/* Error Tracking Register */
#define MC43_ETRR2	(*( MC0_ETRR0_type *) 0xf0063b16u)	/* Error Tracking Register */
#define MC43_ETRR3	(*( MC0_ETRR0_type *) 0xf0063b18u)	/* Error Tracking Register */
#define MC44_ETRR0	(*( MC0_ETRR0_type *) 0xf0063c12u)	/* Error Tracking Register */
#define MC44_ETRR1	(*( MC0_ETRR0_type *) 0xf0063c14u)	/* Error Tracking Register */
#define MC44_ETRR2	(*( MC0_ETRR0_type *) 0xf0063c16u)	/* Error Tracking Register */
#define MC44_ETRR3	(*( MC0_ETRR0_type *) 0xf0063c18u)	/* Error Tracking Register */
#define MC45_ETRR0	(*( MC0_ETRR0_type *) 0xf0063d12u)	/* Error Tracking Register */
#define MC45_ETRR1	(*( MC0_ETRR0_type *) 0xf0063d14u)	/* Error Tracking Register */
#define MC45_ETRR2	(*( MC0_ETRR0_type *) 0xf0063d16u)	/* Error Tracking Register */
#define MC45_ETRR3	(*( MC0_ETRR0_type *) 0xf0063d18u)	/* Error Tracking Register */
#define MC46_ETRR0	(*( MC0_ETRR0_type *) 0xf0063e12u)	/* Error Tracking Register */
#define MC46_ETRR1	(*( MC0_ETRR0_type *) 0xf0063e14u)	/* Error Tracking Register */
#define MC46_ETRR2	(*( MC0_ETRR0_type *) 0xf0063e16u)	/* Error Tracking Register */
#define MC46_ETRR3	(*( MC0_ETRR0_type *) 0xf0063e18u)	/* Error Tracking Register */
#define MC47_ETRR0	(*( MC0_ETRR0_type *) 0xf0063f12u)	/* Error Tracking Register */
#define MC47_ETRR1	(*( MC0_ETRR0_type *) 0xf0063f14u)	/* Error Tracking Register */
#define MC47_ETRR2	(*( MC0_ETRR0_type *) 0xf0063f16u)	/* Error Tracking Register */
#define MC47_ETRR3	(*( MC0_ETRR0_type *) 0xf0063f18u)	/* Error Tracking Register */
#define MC48_ETRR0	(*( MC0_ETRR0_type *) 0xf0064012u)	/* Error Tracking Register */
#define MC48_ETRR1	(*( MC0_ETRR0_type *) 0xf0064014u)	/* Error Tracking Register */
#define MC48_ETRR2	(*( MC0_ETRR0_type *) 0xf0064016u)	/* Error Tracking Register */
#define MC48_ETRR3	(*( MC0_ETRR0_type *) 0xf0064018u)	/* Error Tracking Register */
#define MC49_ETRR0	(*( MC0_ETRR0_type *) 0xf0064112u)	/* Error Tracking Register */
#define MC49_ETRR1	(*( MC0_ETRR0_type *) 0xf0064114u)	/* Error Tracking Register */
#define MC49_ETRR2	(*( MC0_ETRR0_type *) 0xf0064116u)	/* Error Tracking Register */
#define MC49_ETRR3	(*( MC0_ETRR0_type *) 0xf0064118u)	/* Error Tracking Register */
#define MC4_ETRR0	(*( MC0_ETRR0_type *) 0xf0061412u)	/* Error Tracking Register */
#define MC4_ETRR1	(*( MC0_ETRR0_type *) 0xf0061414u)	/* Error Tracking Register */
#define MC4_ETRR2	(*( MC0_ETRR0_type *) 0xf0061416u)	/* Error Tracking Register */
#define MC4_ETRR3	(*( MC0_ETRR0_type *) 0xf0061418u)	/* Error Tracking Register */
#define MC50_ETRR0	(*( MC0_ETRR0_type *) 0xf0064212u)	/* Error Tracking Register */
#define MC50_ETRR1	(*( MC0_ETRR0_type *) 0xf0064214u)	/* Error Tracking Register */
#define MC50_ETRR2	(*( MC0_ETRR0_type *) 0xf0064216u)	/* Error Tracking Register */
#define MC50_ETRR3	(*( MC0_ETRR0_type *) 0xf0064218u)	/* Error Tracking Register */
#define MC51_ETRR0	(*( MC0_ETRR0_type *) 0xf0064312u)	/* Error Tracking Register */
#define MC51_ETRR1	(*( MC0_ETRR0_type *) 0xf0064314u)	/* Error Tracking Register */
#define MC51_ETRR2	(*( MC0_ETRR0_type *) 0xf0064316u)	/* Error Tracking Register */
#define MC51_ETRR3	(*( MC0_ETRR0_type *) 0xf0064318u)	/* Error Tracking Register */
#define MC52_ETRR0	(*( MC0_ETRR0_type *) 0xf0064412u)	/* Error Tracking Register */
#define MC52_ETRR1	(*( MC0_ETRR0_type *) 0xf0064414u)	/* Error Tracking Register */
#define MC52_ETRR2	(*( MC0_ETRR0_type *) 0xf0064416u)	/* Error Tracking Register */
#define MC52_ETRR3	(*( MC0_ETRR0_type *) 0xf0064418u)	/* Error Tracking Register */
#define MC53_ETRR0	(*( MC0_ETRR0_type *) 0xf0064512u)	/* Error Tracking Register */
#define MC53_ETRR1	(*( MC0_ETRR0_type *) 0xf0064514u)	/* Error Tracking Register */
#define MC53_ETRR2	(*( MC0_ETRR0_type *) 0xf0064516u)	/* Error Tracking Register */
#define MC53_ETRR3	(*( MC0_ETRR0_type *) 0xf0064518u)	/* Error Tracking Register */
#define MC54_ETRR0	(*( MC0_ETRR0_type *) 0xf0064612u)	/* Error Tracking Register */
#define MC54_ETRR1	(*( MC0_ETRR0_type *) 0xf0064614u)	/* Error Tracking Register */
#define MC54_ETRR2	(*( MC0_ETRR0_type *) 0xf0064616u)	/* Error Tracking Register */
#define MC54_ETRR3	(*( MC0_ETRR0_type *) 0xf0064618u)	/* Error Tracking Register */
#define MC55_ETRR0	(*( MC0_ETRR0_type *) 0xf0064712u)	/* Error Tracking Register */
#define MC55_ETRR1	(*( MC0_ETRR0_type *) 0xf0064714u)	/* Error Tracking Register */
#define MC55_ETRR2	(*( MC0_ETRR0_type *) 0xf0064716u)	/* Error Tracking Register */
#define MC55_ETRR3	(*( MC0_ETRR0_type *) 0xf0064718u)	/* Error Tracking Register */
#define MC56_ETRR0	(*( MC0_ETRR0_type *) 0xf0064812u)	/* Error Tracking Register */
#define MC56_ETRR1	(*( MC0_ETRR0_type *) 0xf0064814u)	/* Error Tracking Register */
#define MC56_ETRR2	(*( MC0_ETRR0_type *) 0xf0064816u)	/* Error Tracking Register */
#define MC56_ETRR3	(*( MC0_ETRR0_type *) 0xf0064818u)	/* Error Tracking Register */
#define MC57_ETRR0	(*( MC0_ETRR0_type *) 0xf0064912u)	/* Error Tracking Register */
#define MC57_ETRR1	(*( MC0_ETRR0_type *) 0xf0064914u)	/* Error Tracking Register */
#define MC57_ETRR2	(*( MC0_ETRR0_type *) 0xf0064916u)	/* Error Tracking Register */
#define MC57_ETRR3	(*( MC0_ETRR0_type *) 0xf0064918u)	/* Error Tracking Register */
#define MC58_ETRR0	(*( MC0_ETRR0_type *) 0xf0064a12u)	/* Error Tracking Register */
#define MC58_ETRR1	(*( MC0_ETRR0_type *) 0xf0064a14u)	/* Error Tracking Register */
#define MC58_ETRR2	(*( MC0_ETRR0_type *) 0xf0064a16u)	/* Error Tracking Register */
#define MC58_ETRR3	(*( MC0_ETRR0_type *) 0xf0064a18u)	/* Error Tracking Register */
#define MC59_ETRR0	(*( MC0_ETRR0_type *) 0xf0064b12u)	/* Error Tracking Register */
#define MC59_ETRR1	(*( MC0_ETRR0_type *) 0xf0064b14u)	/* Error Tracking Register */
#define MC59_ETRR2	(*( MC0_ETRR0_type *) 0xf0064b16u)	/* Error Tracking Register */
#define MC59_ETRR3	(*( MC0_ETRR0_type *) 0xf0064b18u)	/* Error Tracking Register */
#define MC5_ETRR0	(*( MC0_ETRR0_type *) 0xf0061512u)	/* Error Tracking Register */
#define MC5_ETRR1	(*( MC0_ETRR0_type *) 0xf0061514u)	/* Error Tracking Register */
#define MC5_ETRR2	(*( MC0_ETRR0_type *) 0xf0061516u)	/* Error Tracking Register */
#define MC5_ETRR3	(*( MC0_ETRR0_type *) 0xf0061518u)	/* Error Tracking Register */
#define MC60_ETRR0	(*( MC0_ETRR0_type *) 0xf0064c12u)	/* Error Tracking Register */
#define MC60_ETRR1	(*( MC0_ETRR0_type *) 0xf0064c14u)	/* Error Tracking Register */
#define MC60_ETRR2	(*( MC0_ETRR0_type *) 0xf0064c16u)	/* Error Tracking Register */
#define MC60_ETRR3	(*( MC0_ETRR0_type *) 0xf0064c18u)	/* Error Tracking Register */
#define MC61_ETRR0	(*( MC0_ETRR0_type *) 0xf0064d12u)	/* Error Tracking Register */
#define MC61_ETRR1	(*( MC0_ETRR0_type *) 0xf0064d14u)	/* Error Tracking Register */
#define MC61_ETRR2	(*( MC0_ETRR0_type *) 0xf0064d16u)	/* Error Tracking Register */
#define MC61_ETRR3	(*( MC0_ETRR0_type *) 0xf0064d18u)	/* Error Tracking Register */
#define MC62_ETRR0	(*( MC0_ETRR0_type *) 0xf0064e12u)	/* Error Tracking Register */
#define MC62_ETRR1	(*( MC0_ETRR0_type *) 0xf0064e14u)	/* Error Tracking Register */
#define MC62_ETRR2	(*( MC0_ETRR0_type *) 0xf0064e16u)	/* Error Tracking Register */
#define MC62_ETRR3	(*( MC0_ETRR0_type *) 0xf0064e18u)	/* Error Tracking Register */
#define MC63_ETRR0	(*( MC0_ETRR0_type *) 0xf0064f12u)	/* Error Tracking Register */
#define MC63_ETRR1	(*( MC0_ETRR0_type *) 0xf0064f14u)	/* Error Tracking Register */
#define MC63_ETRR2	(*( MC0_ETRR0_type *) 0xf0064f16u)	/* Error Tracking Register */
#define MC63_ETRR3	(*( MC0_ETRR0_type *) 0xf0064f18u)	/* Error Tracking Register */
#define MC64_ETRR0	(*( MC0_ETRR0_type *) 0xf0065012u)	/* Error Tracking Register */
#define MC64_ETRR1	(*( MC0_ETRR0_type *) 0xf0065014u)	/* Error Tracking Register */
#define MC64_ETRR2	(*( MC0_ETRR0_type *) 0xf0065016u)	/* Error Tracking Register */
#define MC64_ETRR3	(*( MC0_ETRR0_type *) 0xf0065018u)	/* Error Tracking Register */
#define MC65_ETRR0	(*( MC0_ETRR0_type *) 0xf0065112u)	/* Error Tracking Register */
#define MC65_ETRR1	(*( MC0_ETRR0_type *) 0xf0065114u)	/* Error Tracking Register */
#define MC65_ETRR2	(*( MC0_ETRR0_type *) 0xf0065116u)	/* Error Tracking Register */
#define MC65_ETRR3	(*( MC0_ETRR0_type *) 0xf0065118u)	/* Error Tracking Register */
#define MC66_ETRR0	(*( MC0_ETRR0_type *) 0xf0065212u)	/* Error Tracking Register */
#define MC66_ETRR1	(*( MC0_ETRR0_type *) 0xf0065214u)	/* Error Tracking Register */
#define MC66_ETRR2	(*( MC0_ETRR0_type *) 0xf0065216u)	/* Error Tracking Register */
#define MC66_ETRR3	(*( MC0_ETRR0_type *) 0xf0065218u)	/* Error Tracking Register */
#define MC67_ETRR0	(*( MC0_ETRR0_type *) 0xf0065312u)	/* Error Tracking Register */
#define MC67_ETRR1	(*( MC0_ETRR0_type *) 0xf0065314u)	/* Error Tracking Register */
#define MC67_ETRR2	(*( MC0_ETRR0_type *) 0xf0065316u)	/* Error Tracking Register */
#define MC67_ETRR3	(*( MC0_ETRR0_type *) 0xf0065318u)	/* Error Tracking Register */
#define MC68_ETRR0	(*( MC0_ETRR0_type *) 0xf0065412u)	/* Error Tracking Register */
#define MC68_ETRR1	(*( MC0_ETRR0_type *) 0xf0065414u)	/* Error Tracking Register */
#define MC68_ETRR2	(*( MC0_ETRR0_type *) 0xf0065416u)	/* Error Tracking Register */
#define MC68_ETRR3	(*( MC0_ETRR0_type *) 0xf0065418u)	/* Error Tracking Register */
#define MC69_ETRR0	(*( MC0_ETRR0_type *) 0xf0065512u)	/* Error Tracking Register */
#define MC69_ETRR1	(*( MC0_ETRR0_type *) 0xf0065514u)	/* Error Tracking Register */
#define MC69_ETRR2	(*( MC0_ETRR0_type *) 0xf0065516u)	/* Error Tracking Register */
#define MC69_ETRR3	(*( MC0_ETRR0_type *) 0xf0065518u)	/* Error Tracking Register */
#define MC6_ETRR0	(*( MC0_ETRR0_type *) 0xf0061612u)	/* Error Tracking Register */
#define MC6_ETRR1	(*( MC0_ETRR0_type *) 0xf0061614u)	/* Error Tracking Register */
#define MC6_ETRR2	(*( MC0_ETRR0_type *) 0xf0061616u)	/* Error Tracking Register */
#define MC6_ETRR3	(*( MC0_ETRR0_type *) 0xf0061618u)	/* Error Tracking Register */
#define MC70_ETRR0	(*( MC0_ETRR0_type *) 0xf0065612u)	/* Error Tracking Register */
#define MC70_ETRR1	(*( MC0_ETRR0_type *) 0xf0065614u)	/* Error Tracking Register */
#define MC70_ETRR2	(*( MC0_ETRR0_type *) 0xf0065616u)	/* Error Tracking Register */
#define MC70_ETRR3	(*( MC0_ETRR0_type *) 0xf0065618u)	/* Error Tracking Register */
#define MC71_ETRR0	(*( MC0_ETRR0_type *) 0xf0065712u)	/* Error Tracking Register */
#define MC71_ETRR1	(*( MC0_ETRR0_type *) 0xf0065714u)	/* Error Tracking Register */
#define MC71_ETRR2	(*( MC0_ETRR0_type *) 0xf0065716u)	/* Error Tracking Register */
#define MC71_ETRR3	(*( MC0_ETRR0_type *) 0xf0065718u)	/* Error Tracking Register */
#define MC72_ETRR0	(*( MC0_ETRR0_type *) 0xf0065812u)	/* Error Tracking Register */
#define MC72_ETRR1	(*( MC0_ETRR0_type *) 0xf0065814u)	/* Error Tracking Register */
#define MC72_ETRR2	(*( MC0_ETRR0_type *) 0xf0065816u)	/* Error Tracking Register */
#define MC72_ETRR3	(*( MC0_ETRR0_type *) 0xf0065818u)	/* Error Tracking Register */
#define MC73_ETRR0	(*( MC0_ETRR0_type *) 0xf0065912u)	/* Error Tracking Register */
#define MC73_ETRR1	(*( MC0_ETRR0_type *) 0xf0065914u)	/* Error Tracking Register */
#define MC73_ETRR2	(*( MC0_ETRR0_type *) 0xf0065916u)	/* Error Tracking Register */
#define MC73_ETRR3	(*( MC0_ETRR0_type *) 0xf0065918u)	/* Error Tracking Register */
#define MC74_ETRR0	(*( MC0_ETRR0_type *) 0xf0065a12u)	/* Error Tracking Register */
#define MC74_ETRR1	(*( MC0_ETRR0_type *) 0xf0065a14u)	/* Error Tracking Register */
#define MC74_ETRR2	(*( MC0_ETRR0_type *) 0xf0065a16u)	/* Error Tracking Register */
#define MC74_ETRR3	(*( MC0_ETRR0_type *) 0xf0065a18u)	/* Error Tracking Register */
#define MC75_ETRR0	(*( MC0_ETRR0_type *) 0xf0065b12u)	/* Error Tracking Register */
#define MC75_ETRR1	(*( MC0_ETRR0_type *) 0xf0065b14u)	/* Error Tracking Register */
#define MC75_ETRR2	(*( MC0_ETRR0_type *) 0xf0065b16u)	/* Error Tracking Register */
#define MC75_ETRR3	(*( MC0_ETRR0_type *) 0xf0065b18u)	/* Error Tracking Register */
#define MC76_ETRR0	(*( MC0_ETRR0_type *) 0xf0065c12u)	/* Error Tracking Register */
#define MC76_ETRR1	(*( MC0_ETRR0_type *) 0xf0065c14u)	/* Error Tracking Register */
#define MC76_ETRR2	(*( MC0_ETRR0_type *) 0xf0065c16u)	/* Error Tracking Register */
#define MC76_ETRR3	(*( MC0_ETRR0_type *) 0xf0065c18u)	/* Error Tracking Register */
#define MC77_ETRR0	(*( MC0_ETRR0_type *) 0xf0065d12u)	/* Error Tracking Register */
#define MC77_ETRR1	(*( MC0_ETRR0_type *) 0xf0065d14u)	/* Error Tracking Register */
#define MC77_ETRR2	(*( MC0_ETRR0_type *) 0xf0065d16u)	/* Error Tracking Register */
#define MC77_ETRR3	(*( MC0_ETRR0_type *) 0xf0065d18u)	/* Error Tracking Register */
#define MC78_ETRR0	(*( MC0_ETRR0_type *) 0xf0065e12u)	/* Error Tracking Register */
#define MC78_ETRR1	(*( MC0_ETRR0_type *) 0xf0065e14u)	/* Error Tracking Register */
#define MC78_ETRR2	(*( MC0_ETRR0_type *) 0xf0065e16u)	/* Error Tracking Register */
#define MC78_ETRR3	(*( MC0_ETRR0_type *) 0xf0065e18u)	/* Error Tracking Register */
#define MC79_ETRR0	(*( MC0_ETRR0_type *) 0xf0065f12u)	/* Error Tracking Register */
#define MC79_ETRR1	(*( MC0_ETRR0_type *) 0xf0065f14u)	/* Error Tracking Register */
#define MC79_ETRR2	(*( MC0_ETRR0_type *) 0xf0065f16u)	/* Error Tracking Register */
#define MC79_ETRR3	(*( MC0_ETRR0_type *) 0xf0065f18u)	/* Error Tracking Register */
#define MC7_ETRR0	(*( MC0_ETRR0_type *) 0xf0061712u)	/* Error Tracking Register */
#define MC7_ETRR1	(*( MC0_ETRR0_type *) 0xf0061714u)	/* Error Tracking Register */
#define MC7_ETRR2	(*( MC0_ETRR0_type *) 0xf0061716u)	/* Error Tracking Register */
#define MC7_ETRR3	(*( MC0_ETRR0_type *) 0xf0061718u)	/* Error Tracking Register */
#define MC80_ETRR0	(*( MC0_ETRR0_type *) 0xf0066012u)	/* Error Tracking Register */
#define MC80_ETRR1	(*( MC0_ETRR0_type *) 0xf0066014u)	/* Error Tracking Register */
#define MC80_ETRR2	(*( MC0_ETRR0_type *) 0xf0066016u)	/* Error Tracking Register */
#define MC80_ETRR3	(*( MC0_ETRR0_type *) 0xf0066018u)	/* Error Tracking Register */
#define MC81_ETRR0	(*( MC0_ETRR0_type *) 0xf0066112u)	/* Error Tracking Register */
#define MC81_ETRR1	(*( MC0_ETRR0_type *) 0xf0066114u)	/* Error Tracking Register */
#define MC81_ETRR2	(*( MC0_ETRR0_type *) 0xf0066116u)	/* Error Tracking Register */
#define MC81_ETRR3	(*( MC0_ETRR0_type *) 0xf0066118u)	/* Error Tracking Register */
#define MC82_ETRR0	(*( MC0_ETRR0_type *) 0xf0066212u)	/* Error Tracking Register */
#define MC82_ETRR1	(*( MC0_ETRR0_type *) 0xf0066214u)	/* Error Tracking Register */
#define MC82_ETRR2	(*( MC0_ETRR0_type *) 0xf0066216u)	/* Error Tracking Register */
#define MC82_ETRR3	(*( MC0_ETRR0_type *) 0xf0066218u)	/* Error Tracking Register */
#define MC83_ETRR0	(*( MC0_ETRR0_type *) 0xf0066312u)	/* Error Tracking Register */
#define MC83_ETRR1	(*( MC0_ETRR0_type *) 0xf0066314u)	/* Error Tracking Register */
#define MC83_ETRR2	(*( MC0_ETRR0_type *) 0xf0066316u)	/* Error Tracking Register */
#define MC83_ETRR3	(*( MC0_ETRR0_type *) 0xf0066318u)	/* Error Tracking Register */
#define MC84_ETRR0	(*( MC0_ETRR0_type *) 0xf0066412u)	/* Error Tracking Register */
#define MC84_ETRR1	(*( MC0_ETRR0_type *) 0xf0066414u)	/* Error Tracking Register */
#define MC84_ETRR2	(*( MC0_ETRR0_type *) 0xf0066416u)	/* Error Tracking Register */
#define MC84_ETRR3	(*( MC0_ETRR0_type *) 0xf0066418u)	/* Error Tracking Register */
#define MC85_ETRR0	(*( MC0_ETRR0_type *) 0xf0066512u)	/* Error Tracking Register */
#define MC85_ETRR1	(*( MC0_ETRR0_type *) 0xf0066514u)	/* Error Tracking Register */
#define MC85_ETRR2	(*( MC0_ETRR0_type *) 0xf0066516u)	/* Error Tracking Register */
#define MC85_ETRR3	(*( MC0_ETRR0_type *) 0xf0066518u)	/* Error Tracking Register */
#define MC86_ETRR0	(*( MC0_ETRR0_type *) 0xf0066612u)	/* Error Tracking Register */
#define MC86_ETRR1	(*( MC0_ETRR0_type *) 0xf0066614u)	/* Error Tracking Register */
#define MC86_ETRR2	(*( MC0_ETRR0_type *) 0xf0066616u)	/* Error Tracking Register */
#define MC86_ETRR3	(*( MC0_ETRR0_type *) 0xf0066618u)	/* Error Tracking Register */
#define MC87_ETRR0	(*( MC0_ETRR0_type *) 0xf0066712u)	/* Error Tracking Register */
#define MC87_ETRR1	(*( MC0_ETRR0_type *) 0xf0066714u)	/* Error Tracking Register */
#define MC87_ETRR2	(*( MC0_ETRR0_type *) 0xf0066716u)	/* Error Tracking Register */
#define MC87_ETRR3	(*( MC0_ETRR0_type *) 0xf0066718u)	/* Error Tracking Register */
#define MC8_ETRR0	(*( MC0_ETRR0_type *) 0xf0061812u)	/* Error Tracking Register */
#define MC8_ETRR1	(*( MC0_ETRR0_type *) 0xf0061814u)	/* Error Tracking Register */
#define MC8_ETRR2	(*( MC0_ETRR0_type *) 0xf0061816u)	/* Error Tracking Register */
#define MC8_ETRR3	(*( MC0_ETRR0_type *) 0xf0061818u)	/* Error Tracking Register */
#define MC9_ETRR0	(*( MC0_ETRR0_type *) 0xf0061912u)	/* Error Tracking Register */
#define MC9_ETRR1	(*( MC0_ETRR0_type *) 0xf0061914u)	/* Error Tracking Register */
#define MC9_ETRR2	(*( MC0_ETRR0_type *) 0xf0061916u)	/* Error Tracking Register */
#define MC9_ETRR3	(*( MC0_ETRR0_type *) 0xf0061918u)	/* Error Tracking Register */

typedef volatile union
{
	struct
	{ 
		unsigned int START          : 1;	/* START */
		unsigned int MAREN          : 1;	/* Marching Algorithm Enable */
		unsigned int MARS           : 1;	/* Marching Algorithm Select */
		unsigned int CHEN           : 1;	/* Checkerboard Enable */
		unsigned int DINIT          : 1;	/* Data Initialization Enable */
		unsigned int RCADR          : 1;	/* Fast Row / Fast Column Addressing Scheme Select */
		unsigned int ROWTOG         : 1;	/* Row toggling */
		unsigned int BITTOG         : 1;	/* Bit toggling */
		unsigned int GP_BASE        : 1;	/* Galpat Base */
		unsigned int FAILDMP        : 1;	/* Fail bitmap dump */
		unsigned int RSF            : 1;	/* RESET_STICKY_FLAGS */
		unsigned int RESUME         : 1;	/* Resume failed test */
		unsigned int INITRED        : 1;	/* Initialize Redundancy Settings */
		unsigned int LDRED          : 1;	/* Load RedundancyShould not be used together with USERED =?1?. */
		unsigned int USERED         : 1;	/* Use RedundancyShould not be used together with LEDRED =?1?. */
		unsigned int RAR_ECC        : 1;	/* RAR_ECC saver */
	} B;
	short S;
	unsigned short US;

} MC0_MCONTROL_type;
#define MC0_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061004u)	/* MBIST Control Register */
#define MC10_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061a04u)	/* MBIST Control Register */
#define MC11_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061b04u)	/* MBIST Control Register */
#define MC12_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061c04u)	/* MBIST Control Register */
#define MC13_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061d04u)	/* MBIST Control Register */
#define MC14_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061e04u)	/* MBIST Control Register */
#define MC15_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061f04u)	/* MBIST Control Register */
#define MC16_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062004u)	/* MBIST Control Register */
#define MC17_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062104u)	/* MBIST Control Register */
#define MC18_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062204u)	/* MBIST Control Register */
#define MC19_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062304u)	/* MBIST Control Register */
#define MC1_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061104u)	/* MBIST Control Register */
#define MC20_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062404u)	/* MBIST Control Register */
#define MC21_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062504u)	/* MBIST Control Register */
#define MC22_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062604u)	/* MBIST Control Register */
#define MC23_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062704u)	/* MBIST Control Register */
#define MC24_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062804u)	/* MBIST Control Register */
#define MC25_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062904u)	/* MBIST Control Register */
#define MC26_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062a04u)	/* MBIST Control Register */
#define MC27_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062b04u)	/* MBIST Control Register */
#define MC28_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062c04u)	/* MBIST Control Register */
#define MC29_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062d04u)	/* MBIST Control Register */
#define MC2_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061204u)	/* MBIST Control Register */
#define MC30_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062e04u)	/* MBIST Control Register */
#define MC31_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0062f04u)	/* MBIST Control Register */
#define MC32_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063004u)	/* MBIST Control Register */
#define MC33_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063104u)	/* MBIST Control Register */
#define MC34_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063204u)	/* MBIST Control Register */
#define MC35_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063304u)	/* MBIST Control Register */
#define MC36_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063404u)	/* MBIST Control Register */
#define MC37_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063504u)	/* MBIST Control Register */
#define MC38_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063604u)	/* MBIST Control Register */
#define MC39_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063704u)	/* MBIST Control Register */
#define MC3_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061304u)	/* MBIST Control Register */
#define MC40_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063804u)	/* MBIST Control Register */
#define MC41_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063904u)	/* MBIST Control Register */
#define MC42_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063a04u)	/* MBIST Control Register */
#define MC43_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063b04u)	/* MBIST Control Register */
#define MC44_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063c04u)	/* MBIST Control Register */
#define MC45_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063d04u)	/* MBIST Control Register */
#define MC46_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063e04u)	/* MBIST Control Register */
#define MC47_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0063f04u)	/* MBIST Control Register */
#define MC48_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064004u)	/* MBIST Control Register */
#define MC49_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064104u)	/* MBIST Control Register */
#define MC4_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061404u)	/* MBIST Control Register */
#define MC50_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064204u)	/* MBIST Control Register */
#define MC51_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064304u)	/* MBIST Control Register */
#define MC52_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064404u)	/* MBIST Control Register */
#define MC53_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064504u)	/* MBIST Control Register */
#define MC54_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064604u)	/* MBIST Control Register */
#define MC55_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064704u)	/* MBIST Control Register */
#define MC56_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064804u)	/* MBIST Control Register */
#define MC57_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064904u)	/* MBIST Control Register */
#define MC58_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064a04u)	/* MBIST Control Register */
#define MC59_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064b04u)	/* MBIST Control Register */
#define MC5_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061504u)	/* MBIST Control Register */
#define MC60_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064c04u)	/* MBIST Control Register */
#define MC61_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064d04u)	/* MBIST Control Register */
#define MC62_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064e04u)	/* MBIST Control Register */
#define MC63_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0064f04u)	/* MBIST Control Register */
#define MC64_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065004u)	/* MBIST Control Register */
#define MC65_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065104u)	/* MBIST Control Register */
#define MC66_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065204u)	/* MBIST Control Register */
#define MC67_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065304u)	/* MBIST Control Register */
#define MC68_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065404u)	/* MBIST Control Register */
#define MC69_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065504u)	/* MBIST Control Register */
#define MC6_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061604u)	/* MBIST Control Register */
#define MC70_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065604u)	/* MBIST Control Register */
#define MC71_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065704u)	/* MBIST Control Register */
#define MC72_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065804u)	/* MBIST Control Register */
#define MC73_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065904u)	/* MBIST Control Register */
#define MC74_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065a04u)	/* MBIST Control Register */
#define MC75_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065b04u)	/* MBIST Control Register */
#define MC76_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065c04u)	/* MBIST Control Register */
#define MC77_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065d04u)	/* MBIST Control Register */
#define MC78_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065e04u)	/* MBIST Control Register */
#define MC79_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0065f04u)	/* MBIST Control Register */
#define MC7_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061704u)	/* MBIST Control Register */
#define MC80_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0066004u)	/* MBIST Control Register */
#define MC81_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0066104u)	/* MBIST Control Register */
#define MC82_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0066204u)	/* MBIST Control Register */
#define MC83_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0066304u)	/* MBIST Control Register */
#define MC84_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0066404u)	/* MBIST Control Register */
#define MC85_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0066504u)	/* MBIST Control Register */
#define MC86_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0066604u)	/* MBIST Control Register */
#define MC87_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0066704u)	/* MBIST Control Register */
#define MC8_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061804u)	/* MBIST Control Register */
#define MC9_MCONTROL	(*( MC0_MCONTROL_type *) 0xf0061904u)	/* MBIST Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DONE           : 1;	/* DONE */
		/* const */ unsigned int FAIL           : 1;	/* FAIL */
		/* const */ unsigned int FAIL_COUNT     : 6;	/* FAIL_COUNT */
		/* const */ unsigned int RUPD           : 1;	/* RAR_UPDATED */
		/* const */ unsigned int MTOF           : 1;	/* MORE_THAN_ONE_FAIL */
		unsigned int FDA            : 1;	/* Fail Dump Available */
		/* const */ unsigned int Res            : 5;	/* Reserved */
	} B;
	short S;
	unsigned short US;

} MC0_MSTATUS_type;
#define MC0_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061006u)	/* Status Register */
#define MC10_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061a06u)	/* Status Register */
#define MC11_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061b06u)	/* Status Register */
#define MC12_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061c06u)	/* Status Register */
#define MC13_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061d06u)	/* Status Register */
#define MC14_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061e06u)	/* Status Register */
#define MC15_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061f06u)	/* Status Register */
#define MC16_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062006u)	/* Status Register */
#define MC17_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062106u)	/* Status Register */
#define MC18_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062206u)	/* Status Register */
#define MC19_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062306u)	/* Status Register */
#define MC1_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061106u)	/* Status Register */
#define MC20_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062406u)	/* Status Register */
#define MC21_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062506u)	/* Status Register */
#define MC22_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062606u)	/* Status Register */
#define MC23_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062706u)	/* Status Register */
#define MC24_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062806u)	/* Status Register */
#define MC25_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062906u)	/* Status Register */
#define MC26_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062a06u)	/* Status Register */
#define MC27_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062b06u)	/* Status Register */
#define MC28_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062c06u)	/* Status Register */
#define MC29_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062d06u)	/* Status Register */
#define MC2_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061206u)	/* Status Register */
#define MC30_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062e06u)	/* Status Register */
#define MC31_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0062f06u)	/* Status Register */
#define MC32_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063006u)	/* Status Register */
#define MC33_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063106u)	/* Status Register */
#define MC34_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063206u)	/* Status Register */
#define MC35_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063306u)	/* Status Register */
#define MC36_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063406u)	/* Status Register */
#define MC37_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063506u)	/* Status Register */
#define MC38_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063606u)	/* Status Register */
#define MC39_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063706u)	/* Status Register */
#define MC3_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061306u)	/* Status Register */
#define MC40_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063806u)	/* Status Register */
#define MC41_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063906u)	/* Status Register */
#define MC42_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063a06u)	/* Status Register */
#define MC43_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063b06u)	/* Status Register */
#define MC44_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063c06u)	/* Status Register */
#define MC45_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063d06u)	/* Status Register */
#define MC46_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063e06u)	/* Status Register */
#define MC47_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0063f06u)	/* Status Register */
#define MC48_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064006u)	/* Status Register */
#define MC49_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064106u)	/* Status Register */
#define MC4_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061406u)	/* Status Register */
#define MC50_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064206u)	/* Status Register */
#define MC51_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064306u)	/* Status Register */
#define MC52_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064406u)	/* Status Register */
#define MC53_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064506u)	/* Status Register */
#define MC54_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064606u)	/* Status Register */
#define MC55_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064706u)	/* Status Register */
#define MC56_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064806u)	/* Status Register */
#define MC57_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064906u)	/* Status Register */
#define MC58_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064a06u)	/* Status Register */
#define MC59_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064b06u)	/* Status Register */
#define MC5_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061506u)	/* Status Register */
#define MC60_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064c06u)	/* Status Register */
#define MC61_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064d06u)	/* Status Register */
#define MC62_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064e06u)	/* Status Register */
#define MC63_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0064f06u)	/* Status Register */
#define MC64_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065006u)	/* Status Register */
#define MC65_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065106u)	/* Status Register */
#define MC66_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065206u)	/* Status Register */
#define MC67_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065306u)	/* Status Register */
#define MC68_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065406u)	/* Status Register */
#define MC69_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065506u)	/* Status Register */
#define MC6_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061606u)	/* Status Register */
#define MC70_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065606u)	/* Status Register */
#define MC71_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065706u)	/* Status Register */
#define MC72_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065806u)	/* Status Register */
#define MC73_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065906u)	/* Status Register */
#define MC74_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065a06u)	/* Status Register */
#define MC75_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065b06u)	/* Status Register */
#define MC76_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065c06u)	/* Status Register */
#define MC77_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065d06u)	/* Status Register */
#define MC78_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065e06u)	/* Status Register */
#define MC79_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0065f06u)	/* Status Register */
#define MC7_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061706u)	/* Status Register */
#define MC80_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0066006u)	/* Status Register */
#define MC81_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0066106u)	/* Status Register */
#define MC82_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0066206u)	/* Status Register */
#define MC83_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0066306u)	/* Status Register */
#define MC84_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0066406u)	/* Status Register */
#define MC85_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0066506u)	/* Status Register */
#define MC86_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0066606u)	/* Status Register */
#define MC87_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0066706u)	/* Status Register */
#define MC8_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061806u)	/* Status Register */
#define MC9_MSTATUS	(*( MC0_MSTATUS_type *) 0xf0061906u)	/* Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 15;	/* Address */
		unsigned int RAEN           : 1;	/* Range Enable */
	} B;
	short S;
	unsigned short US;

} MC0_RANGE_type;
#define MC0_RANGE	(*( MC0_RANGE_type *) 0xf0061008u)	/* Range Register, single address mode */
#define MC10_RANGE	(*( MC0_RANGE_type *) 0xf0061a08u)	/* Range Register, single address mode */
#define MC11_RANGE	(*( MC0_RANGE_type *) 0xf0061b08u)	/* Range Register, single address mode */
#define MC12_RANGE	(*( MC0_RANGE_type *) 0xf0061c08u)	/* Range Register, single address mode */
#define MC13_RANGE	(*( MC0_RANGE_type *) 0xf0061d08u)	/* Range Register, single address mode */
#define MC14_RANGE	(*( MC0_RANGE_type *) 0xf0061e08u)	/* Range Register, single address mode */
#define MC15_RANGE	(*( MC0_RANGE_type *) 0xf0061f08u)	/* Range Register, single address mode */
#define MC16_RANGE	(*( MC0_RANGE_type *) 0xf0062008u)	/* Range Register, single address mode */
#define MC17_RANGE	(*( MC0_RANGE_type *) 0xf0062108u)	/* Range Register, single address mode */
#define MC18_RANGE	(*( MC0_RANGE_type *) 0xf0062208u)	/* Range Register, single address mode */
#define MC19_RANGE	(*( MC0_RANGE_type *) 0xf0062308u)	/* Range Register, single address mode */
#define MC1_RANGE	(*( MC0_RANGE_type *) 0xf0061108u)	/* Range Register, single address mode */
#define MC20_RANGE	(*( MC0_RANGE_type *) 0xf0062408u)	/* Range Register, single address mode */
#define MC21_RANGE	(*( MC0_RANGE_type *) 0xf0062508u)	/* Range Register, single address mode */
#define MC22_RANGE	(*( MC0_RANGE_type *) 0xf0062608u)	/* Range Register, single address mode */
#define MC23_RANGE	(*( MC0_RANGE_type *) 0xf0062708u)	/* Range Register, single address mode */
#define MC24_RANGE	(*( MC0_RANGE_type *) 0xf0062808u)	/* Range Register, single address mode */
#define MC25_RANGE	(*( MC0_RANGE_type *) 0xf0062908u)	/* Range Register, single address mode */
#define MC26_RANGE	(*( MC0_RANGE_type *) 0xf0062a08u)	/* Range Register, single address mode */
#define MC27_RANGE	(*( MC0_RANGE_type *) 0xf0062b08u)	/* Range Register, single address mode */
#define MC28_RANGE	(*( MC0_RANGE_type *) 0xf0062c08u)	/* Range Register, single address mode */
#define MC29_RANGE	(*( MC0_RANGE_type *) 0xf0062d08u)	/* Range Register, single address mode */
#define MC2_RANGE	(*( MC0_RANGE_type *) 0xf0061208u)	/* Range Register, single address mode */
#define MC30_RANGE	(*( MC0_RANGE_type *) 0xf0062e08u)	/* Range Register, single address mode */
#define MC31_RANGE	(*( MC0_RANGE_type *) 0xf0062f08u)	/* Range Register, single address mode */
#define MC32_RANGE	(*( MC0_RANGE_type *) 0xf0063008u)	/* Range Register, single address mode */
#define MC33_RANGE	(*( MC0_RANGE_type *) 0xf0063108u)	/* Range Register, single address mode */
#define MC34_RANGE	(*( MC0_RANGE_type *) 0xf0063208u)	/* Range Register, single address mode */
#define MC35_RANGE	(*( MC0_RANGE_type *) 0xf0063308u)	/* Range Register, single address mode */
#define MC36_RANGE	(*( MC0_RANGE_type *) 0xf0063408u)	/* Range Register, single address mode */
#define MC37_RANGE	(*( MC0_RANGE_type *) 0xf0063508u)	/* Range Register, single address mode */
#define MC38_RANGE	(*( MC0_RANGE_type *) 0xf0063608u)	/* Range Register, single address mode */
#define MC39_RANGE	(*( MC0_RANGE_type *) 0xf0063708u)	/* Range Register, single address mode */
#define MC3_RANGE	(*( MC0_RANGE_type *) 0xf0061308u)	/* Range Register, single address mode */
#define MC40_RANGE	(*( MC0_RANGE_type *) 0xf0063808u)	/* Range Register, single address mode */
#define MC41_RANGE	(*( MC0_RANGE_type *) 0xf0063908u)	/* Range Register, single address mode */
#define MC42_RANGE	(*( MC0_RANGE_type *) 0xf0063a08u)	/* Range Register, single address mode */
#define MC43_RANGE	(*( MC0_RANGE_type *) 0xf0063b08u)	/* Range Register, single address mode */
#define MC44_RANGE	(*( MC0_RANGE_type *) 0xf0063c08u)	/* Range Register, single address mode */
#define MC45_RANGE	(*( MC0_RANGE_type *) 0xf0063d08u)	/* Range Register, single address mode */
#define MC46_RANGE	(*( MC0_RANGE_type *) 0xf0063e08u)	/* Range Register, single address mode */
#define MC47_RANGE	(*( MC0_RANGE_type *) 0xf0063f08u)	/* Range Register, single address mode */
#define MC48_RANGE	(*( MC0_RANGE_type *) 0xf0064008u)	/* Range Register, single address mode */
#define MC49_RANGE	(*( MC0_RANGE_type *) 0xf0064108u)	/* Range Register, single address mode */
#define MC4_RANGE	(*( MC0_RANGE_type *) 0xf0061408u)	/* Range Register, single address mode */
#define MC50_RANGE	(*( MC0_RANGE_type *) 0xf0064208u)	/* Range Register, single address mode */
#define MC51_RANGE	(*( MC0_RANGE_type *) 0xf0064308u)	/* Range Register, single address mode */
#define MC52_RANGE	(*( MC0_RANGE_type *) 0xf0064408u)	/* Range Register, single address mode */
#define MC53_RANGE	(*( MC0_RANGE_type *) 0xf0064508u)	/* Range Register, single address mode */
#define MC54_RANGE	(*( MC0_RANGE_type *) 0xf0064608u)	/* Range Register, single address mode */
#define MC55_RANGE	(*( MC0_RANGE_type *) 0xf0064708u)	/* Range Register, single address mode */
#define MC56_RANGE	(*( MC0_RANGE_type *) 0xf0064808u)	/* Range Register, single address mode */
#define MC57_RANGE	(*( MC0_RANGE_type *) 0xf0064908u)	/* Range Register, single address mode */
#define MC58_RANGE	(*( MC0_RANGE_type *) 0xf0064a08u)	/* Range Register, single address mode */
#define MC59_RANGE	(*( MC0_RANGE_type *) 0xf0064b08u)	/* Range Register, single address mode */
#define MC5_RANGE	(*( MC0_RANGE_type *) 0xf0061508u)	/* Range Register, single address mode */
#define MC60_RANGE	(*( MC0_RANGE_type *) 0xf0064c08u)	/* Range Register, single address mode */
#define MC61_RANGE	(*( MC0_RANGE_type *) 0xf0064d08u)	/* Range Register, single address mode */
#define MC62_RANGE	(*( MC0_RANGE_type *) 0xf0064e08u)	/* Range Register, single address mode */
#define MC63_RANGE	(*( MC0_RANGE_type *) 0xf0064f08u)	/* Range Register, single address mode */
#define MC64_RANGE	(*( MC0_RANGE_type *) 0xf0065008u)	/* Range Register, single address mode */
#define MC65_RANGE	(*( MC0_RANGE_type *) 0xf0065108u)	/* Range Register, single address mode */
#define MC66_RANGE	(*( MC0_RANGE_type *) 0xf0065208u)	/* Range Register, single address mode */
#define MC67_RANGE	(*( MC0_RANGE_type *) 0xf0065308u)	/* Range Register, single address mode */
#define MC68_RANGE	(*( MC0_RANGE_type *) 0xf0065408u)	/* Range Register, single address mode */
#define MC69_RANGE	(*( MC0_RANGE_type *) 0xf0065508u)	/* Range Register, single address mode */
#define MC6_RANGE	(*( MC0_RANGE_type *) 0xf0061608u)	/* Range Register, single address mode */
#define MC70_RANGE	(*( MC0_RANGE_type *) 0xf0065608u)	/* Range Register, single address mode */
#define MC71_RANGE	(*( MC0_RANGE_type *) 0xf0065708u)	/* Range Register, single address mode */
#define MC72_RANGE	(*( MC0_RANGE_type *) 0xf0065808u)	/* Range Register, single address mode */
#define MC73_RANGE	(*( MC0_RANGE_type *) 0xf0065908u)	/* Range Register, single address mode */
#define MC74_RANGE	(*( MC0_RANGE_type *) 0xf0065a08u)	/* Range Register, single address mode */
#define MC75_RANGE	(*( MC0_RANGE_type *) 0xf0065b08u)	/* Range Register, single address mode */
#define MC76_RANGE	(*( MC0_RANGE_type *) 0xf0065c08u)	/* Range Register, single address mode */
#define MC77_RANGE	(*( MC0_RANGE_type *) 0xf0065d08u)	/* Range Register, single address mode */
#define MC78_RANGE	(*( MC0_RANGE_type *) 0xf0065e08u)	/* Range Register, single address mode */
#define MC79_RANGE	(*( MC0_RANGE_type *) 0xf0065f08u)	/* Range Register, single address mode */
#define MC7_RANGE	(*( MC0_RANGE_type *) 0xf0061708u)	/* Range Register, single address mode */
#define MC80_RANGE	(*( MC0_RANGE_type *) 0xf0066008u)	/* Range Register, single address mode */
#define MC81_RANGE	(*( MC0_RANGE_type *) 0xf0066108u)	/* Range Register, single address mode */
#define MC82_RANGE	(*( MC0_RANGE_type *) 0xf0066208u)	/* Range Register, single address mode */
#define MC83_RANGE	(*( MC0_RANGE_type *) 0xf0066308u)	/* Range Register, single address mode */
#define MC84_RANGE	(*( MC0_RANGE_type *) 0xf0066408u)	/* Range Register, single address mode */
#define MC85_RANGE	(*( MC0_RANGE_type *) 0xf0066508u)	/* Range Register, single address mode */
#define MC86_RANGE	(*( MC0_RANGE_type *) 0xf0066608u)	/* Range Register, single address mode */
#define MC87_RANGE	(*( MC0_RANGE_type *) 0xf0066708u)	/* Range Register, single address mode */
#define MC8_RANGE	(*( MC0_RANGE_type *) 0xf0061808u)	/* Range Register, single address mode */
#define MC9_RANGE	(*( MC0_RANGE_type *) 0xf0061908u)	/* Range Register, single address mode */

typedef volatile union
{
	struct
	{ 
		unsigned int WDATA          : 16;	/* Word Data */
	} B;
	short S;
	unsigned short US;

} MC0_RDBFL0_type;
#define MC0_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00610a0u)	/* Read Data and Bit Flip Register 0 */
#define MC0_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00610a2u)	/* Read Data and Bit Flip Register 1 */
#define MC0_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00610b4u)	/* Read Data and Bit Flip Register 10 */
#define MC0_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00610b6u)	/* Read Data and Bit Flip Register 11 */
#define MC0_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00610b8u)	/* Read Data and Bit Flip Register 12 */
#define MC0_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00610bau)	/* Read Data and Bit Flip Register 13 */
#define MC0_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00610bcu)	/* Read Data and Bit Flip Register 14 */
#define MC0_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00610beu)	/* Read Data and Bit Flip Register 15 */
#define MC0_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00610c0u)	/* Read Data and Bit Flip Register 16 */
#define MC0_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00610c2u)	/* Read Data and Bit Flip Register 17 */
#define MC0_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00610c4u)	/* Read Data and Bit Flip Register 18 */
#define MC0_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00610c6u)	/* Read Data and Bit Flip Register 19 */
#define MC0_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00610a4u)	/* Read Data and Bit Flip Register 2 */
#define MC0_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00610c8u)	/* Read Data and Bit Flip Register 20 */
#define MC0_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00610cau)	/* Read Data and Bit Flip Register 21 */
#define MC0_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00610ccu)	/* Read Data and Bit Flip Register 22 */
#define MC0_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00610ceu)	/* Read Data and Bit Flip Register 23 */
#define MC0_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00610d0u)	/* Read Data and Bit Flip Register 24 */
#define MC0_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00610d2u)	/* Read Data and Bit Flip Register 25 */
#define MC0_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00610d4u)	/* Read Data and Bit Flip Register 26 */
#define MC0_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00610d6u)	/* Read Data and Bit Flip Register 27 */
#define MC0_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00610d8u)	/* Read Data and Bit Flip Register 28 */
#define MC0_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00610dau)	/* Read Data and Bit Flip Register 29 */
#define MC0_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00610a6u)	/* Read Data and Bit Flip Register 3 */
#define MC0_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00610dcu)	/* Read Data and Bit Flip Register 30 */
#define MC0_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00610deu)	/* Read Data and Bit Flip Register 31 */
#define MC0_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00610e0u)	/* Read Data and Bit Flip Register 32 */
#define MC0_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00610e2u)	/* Read Data and Bit Flip Register 33 */
#define MC0_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00610e4u)	/* Read Data and Bit Flip Register 34 */
#define MC0_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00610e6u)	/* Read Data and Bit Flip Register 35 */
#define MC0_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00610e8u)	/* Read Data and Bit Flip Register 36 */
#define MC0_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00610eau)	/* Read Data and Bit Flip Register 37 */
#define MC0_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00610ecu)	/* Read Data and Bit Flip Register 38 */
#define MC0_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00610eeu)	/* Read Data and Bit Flip Register 39 */
#define MC0_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00610a8u)	/* Read Data and Bit Flip Register 4 */
#define MC0_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00610aau)	/* Read Data and Bit Flip Register 5 */
#define MC0_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00610acu)	/* Read Data and Bit Flip Register 6 */
#define MC0_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00610aeu)	/* Read Data and Bit Flip Register 7 */
#define MC0_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00610b0u)	/* Read Data and Bit Flip Register 8 */
#define MC0_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00610b2u)	/* Read Data and Bit Flip Register 9 */
#define MC10_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0061aa0u)	/* Read Data and Bit Flip Register 0 */
#define MC10_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0061aa2u)	/* Read Data and Bit Flip Register 1 */
#define MC10_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0061ab4u)	/* Read Data and Bit Flip Register 10 */
#define MC10_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0061ab6u)	/* Read Data and Bit Flip Register 11 */
#define MC10_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0061ab8u)	/* Read Data and Bit Flip Register 12 */
#define MC10_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0061abau)	/* Read Data and Bit Flip Register 13 */
#define MC10_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0061abcu)	/* Read Data and Bit Flip Register 14 */
#define MC10_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0061abeu)	/* Read Data and Bit Flip Register 15 */
#define MC10_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0061ac0u)	/* Read Data and Bit Flip Register 16 */
#define MC10_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0061ac2u)	/* Read Data and Bit Flip Register 17 */
#define MC10_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0061ac4u)	/* Read Data and Bit Flip Register 18 */
#define MC10_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0061ac6u)	/* Read Data and Bit Flip Register 19 */
#define MC10_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0061aa4u)	/* Read Data and Bit Flip Register 2 */
#define MC10_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0061ac8u)	/* Read Data and Bit Flip Register 20 */
#define MC10_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0061acau)	/* Read Data and Bit Flip Register 21 */
#define MC10_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0061accu)	/* Read Data and Bit Flip Register 22 */
#define MC10_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0061aceu)	/* Read Data and Bit Flip Register 23 */
#define MC10_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0061ad0u)	/* Read Data and Bit Flip Register 24 */
#define MC10_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0061ad2u)	/* Read Data and Bit Flip Register 25 */
#define MC10_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0061ad4u)	/* Read Data and Bit Flip Register 26 */
#define MC10_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0061ad6u)	/* Read Data and Bit Flip Register 27 */
#define MC10_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0061ad8u)	/* Read Data and Bit Flip Register 28 */
#define MC10_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0061adau)	/* Read Data and Bit Flip Register 29 */
#define MC10_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0061aa6u)	/* Read Data and Bit Flip Register 3 */
#define MC10_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0061adcu)	/* Read Data and Bit Flip Register 30 */
#define MC10_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0061adeu)	/* Read Data and Bit Flip Register 31 */
#define MC10_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0061ae0u)	/* Read Data and Bit Flip Register 32 */
#define MC10_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0061ae2u)	/* Read Data and Bit Flip Register 33 */
#define MC10_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0061ae4u)	/* Read Data and Bit Flip Register 34 */
#define MC10_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0061ae6u)	/* Read Data and Bit Flip Register 35 */
#define MC10_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0061ae8u)	/* Read Data and Bit Flip Register 36 */
#define MC10_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0061aeau)	/* Read Data and Bit Flip Register 37 */
#define MC10_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0061aecu)	/* Read Data and Bit Flip Register 38 */
#define MC10_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0061aeeu)	/* Read Data and Bit Flip Register 39 */
#define MC10_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0061aa8u)	/* Read Data and Bit Flip Register 4 */
#define MC10_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0061aaau)	/* Read Data and Bit Flip Register 5 */
#define MC10_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0061aacu)	/* Read Data and Bit Flip Register 6 */
#define MC10_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0061aaeu)	/* Read Data and Bit Flip Register 7 */
#define MC10_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0061ab0u)	/* Read Data and Bit Flip Register 8 */
#define MC10_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0061ab2u)	/* Read Data and Bit Flip Register 9 */
#define MC11_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0061ba0u)	/* Read Data and Bit Flip Register 0 */
#define MC11_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0061ba2u)	/* Read Data and Bit Flip Register 1 */
#define MC11_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0061bb4u)	/* Read Data and Bit Flip Register 10 */
#define MC11_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0061bb6u)	/* Read Data and Bit Flip Register 11 */
#define MC11_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0061bb8u)	/* Read Data and Bit Flip Register 12 */
#define MC11_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0061bbau)	/* Read Data and Bit Flip Register 13 */
#define MC11_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0061bbcu)	/* Read Data and Bit Flip Register 14 */
#define MC11_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0061bbeu)	/* Read Data and Bit Flip Register 15 */
#define MC11_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0061bc0u)	/* Read Data and Bit Flip Register 16 */
#define MC11_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0061bc2u)	/* Read Data and Bit Flip Register 17 */
#define MC11_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0061bc4u)	/* Read Data and Bit Flip Register 18 */
#define MC11_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0061bc6u)	/* Read Data and Bit Flip Register 19 */
#define MC11_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0061ba4u)	/* Read Data and Bit Flip Register 2 */
#define MC11_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0061bc8u)	/* Read Data and Bit Flip Register 20 */
#define MC11_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0061bcau)	/* Read Data and Bit Flip Register 21 */
#define MC11_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0061bccu)	/* Read Data and Bit Flip Register 22 */
#define MC11_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0061bceu)	/* Read Data and Bit Flip Register 23 */
#define MC11_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0061bd0u)	/* Read Data and Bit Flip Register 24 */
#define MC11_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0061bd2u)	/* Read Data and Bit Flip Register 25 */
#define MC11_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0061bd4u)	/* Read Data and Bit Flip Register 26 */
#define MC11_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0061bd6u)	/* Read Data and Bit Flip Register 27 */
#define MC11_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0061bd8u)	/* Read Data and Bit Flip Register 28 */
#define MC11_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0061bdau)	/* Read Data and Bit Flip Register 29 */
#define MC11_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0061ba6u)	/* Read Data and Bit Flip Register 3 */
#define MC11_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0061bdcu)	/* Read Data and Bit Flip Register 30 */
#define MC11_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0061bdeu)	/* Read Data and Bit Flip Register 31 */
#define MC11_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0061be0u)	/* Read Data and Bit Flip Register 32 */
#define MC11_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0061be2u)	/* Read Data and Bit Flip Register 33 */
#define MC11_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0061be4u)	/* Read Data and Bit Flip Register 34 */
#define MC11_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0061be6u)	/* Read Data and Bit Flip Register 35 */
#define MC11_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0061be8u)	/* Read Data and Bit Flip Register 36 */
#define MC11_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0061beau)	/* Read Data and Bit Flip Register 37 */
#define MC11_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0061becu)	/* Read Data and Bit Flip Register 38 */
#define MC11_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0061beeu)	/* Read Data and Bit Flip Register 39 */
#define MC11_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0061ba8u)	/* Read Data and Bit Flip Register 4 */
#define MC11_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0061baau)	/* Read Data and Bit Flip Register 5 */
#define MC11_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0061bacu)	/* Read Data and Bit Flip Register 6 */
#define MC11_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0061baeu)	/* Read Data and Bit Flip Register 7 */
#define MC11_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0061bb0u)	/* Read Data and Bit Flip Register 8 */
#define MC11_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0061bb2u)	/* Read Data and Bit Flip Register 9 */
#define MC12_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0061ca0u)	/* Read Data and Bit Flip Register 0 */
#define MC12_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0061ca2u)	/* Read Data and Bit Flip Register 1 */
#define MC12_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0061cb4u)	/* Read Data and Bit Flip Register 10 */
#define MC12_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0061cb6u)	/* Read Data and Bit Flip Register 11 */
#define MC12_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0061cb8u)	/* Read Data and Bit Flip Register 12 */
#define MC12_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0061cbau)	/* Read Data and Bit Flip Register 13 */
#define MC12_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0061cbcu)	/* Read Data and Bit Flip Register 14 */
#define MC12_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0061cbeu)	/* Read Data and Bit Flip Register 15 */
#define MC12_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0061cc0u)	/* Read Data and Bit Flip Register 16 */
#define MC12_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0061cc2u)	/* Read Data and Bit Flip Register 17 */
#define MC12_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0061cc4u)	/* Read Data and Bit Flip Register 18 */
#define MC12_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0061cc6u)	/* Read Data and Bit Flip Register 19 */
#define MC12_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0061ca4u)	/* Read Data and Bit Flip Register 2 */
#define MC12_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0061cc8u)	/* Read Data and Bit Flip Register 20 */
#define MC12_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0061ccau)	/* Read Data and Bit Flip Register 21 */
#define MC12_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0061cccu)	/* Read Data and Bit Flip Register 22 */
#define MC12_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0061cceu)	/* Read Data and Bit Flip Register 23 */
#define MC12_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0061cd0u)	/* Read Data and Bit Flip Register 24 */
#define MC12_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0061cd2u)	/* Read Data and Bit Flip Register 25 */
#define MC12_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0061cd4u)	/* Read Data and Bit Flip Register 26 */
#define MC12_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0061cd6u)	/* Read Data and Bit Flip Register 27 */
#define MC12_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0061cd8u)	/* Read Data and Bit Flip Register 28 */
#define MC12_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0061cdau)	/* Read Data and Bit Flip Register 29 */
#define MC12_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0061ca6u)	/* Read Data and Bit Flip Register 3 */
#define MC12_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0061cdcu)	/* Read Data and Bit Flip Register 30 */
#define MC12_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0061cdeu)	/* Read Data and Bit Flip Register 31 */
#define MC12_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0061ce0u)	/* Read Data and Bit Flip Register 32 */
#define MC12_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0061ce2u)	/* Read Data and Bit Flip Register 33 */
#define MC12_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0061ce4u)	/* Read Data and Bit Flip Register 34 */
#define MC12_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0061ce6u)	/* Read Data and Bit Flip Register 35 */
#define MC12_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0061ce8u)	/* Read Data and Bit Flip Register 36 */
#define MC12_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0061ceau)	/* Read Data and Bit Flip Register 37 */
#define MC12_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0061cecu)	/* Read Data and Bit Flip Register 38 */
#define MC12_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0061ceeu)	/* Read Data and Bit Flip Register 39 */
#define MC12_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0061ca8u)	/* Read Data and Bit Flip Register 4 */
#define MC12_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0061caau)	/* Read Data and Bit Flip Register 5 */
#define MC12_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0061cacu)	/* Read Data and Bit Flip Register 6 */
#define MC12_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0061caeu)	/* Read Data and Bit Flip Register 7 */
#define MC12_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0061cb0u)	/* Read Data and Bit Flip Register 8 */
#define MC12_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0061cb2u)	/* Read Data and Bit Flip Register 9 */
#define MC13_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0061da0u)	/* Read Data and Bit Flip Register 0 */
#define MC13_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0061da2u)	/* Read Data and Bit Flip Register 1 */
#define MC13_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0061db4u)	/* Read Data and Bit Flip Register 10 */
#define MC13_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0061db6u)	/* Read Data and Bit Flip Register 11 */
#define MC13_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0061db8u)	/* Read Data and Bit Flip Register 12 */
#define MC13_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0061dbau)	/* Read Data and Bit Flip Register 13 */
#define MC13_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0061dbcu)	/* Read Data and Bit Flip Register 14 */
#define MC13_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0061dbeu)	/* Read Data and Bit Flip Register 15 */
#define MC13_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0061dc0u)	/* Read Data and Bit Flip Register 16 */
#define MC13_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0061dc2u)	/* Read Data and Bit Flip Register 17 */
#define MC13_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0061dc4u)	/* Read Data and Bit Flip Register 18 */
#define MC13_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0061dc6u)	/* Read Data and Bit Flip Register 19 */
#define MC13_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0061da4u)	/* Read Data and Bit Flip Register 2 */
#define MC13_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0061dc8u)	/* Read Data and Bit Flip Register 20 */
#define MC13_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0061dcau)	/* Read Data and Bit Flip Register 21 */
#define MC13_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0061dccu)	/* Read Data and Bit Flip Register 22 */
#define MC13_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0061dceu)	/* Read Data and Bit Flip Register 23 */
#define MC13_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0061dd0u)	/* Read Data and Bit Flip Register 24 */
#define MC13_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0061dd2u)	/* Read Data and Bit Flip Register 25 */
#define MC13_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0061dd4u)	/* Read Data and Bit Flip Register 26 */
#define MC13_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0061dd6u)	/* Read Data and Bit Flip Register 27 */
#define MC13_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0061dd8u)	/* Read Data and Bit Flip Register 28 */
#define MC13_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0061ddau)	/* Read Data and Bit Flip Register 29 */
#define MC13_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0061da6u)	/* Read Data and Bit Flip Register 3 */
#define MC13_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0061ddcu)	/* Read Data and Bit Flip Register 30 */
#define MC13_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0061ddeu)	/* Read Data and Bit Flip Register 31 */
#define MC13_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0061de0u)	/* Read Data and Bit Flip Register 32 */
#define MC13_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0061de2u)	/* Read Data and Bit Flip Register 33 */
#define MC13_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0061de4u)	/* Read Data and Bit Flip Register 34 */
#define MC13_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0061de6u)	/* Read Data and Bit Flip Register 35 */
#define MC13_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0061de8u)	/* Read Data and Bit Flip Register 36 */
#define MC13_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0061deau)	/* Read Data and Bit Flip Register 37 */
#define MC13_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0061decu)	/* Read Data and Bit Flip Register 38 */
#define MC13_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0061deeu)	/* Read Data and Bit Flip Register 39 */
#define MC13_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0061da8u)	/* Read Data and Bit Flip Register 4 */
#define MC13_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0061daau)	/* Read Data and Bit Flip Register 5 */
#define MC13_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0061dacu)	/* Read Data and Bit Flip Register 6 */
#define MC13_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0061daeu)	/* Read Data and Bit Flip Register 7 */
#define MC13_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0061db0u)	/* Read Data and Bit Flip Register 8 */
#define MC13_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0061db2u)	/* Read Data and Bit Flip Register 9 */
#define MC14_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0061ea0u)	/* Read Data and Bit Flip Register 0 */
#define MC14_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0061ea2u)	/* Read Data and Bit Flip Register 1 */
#define MC14_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0061eb4u)	/* Read Data and Bit Flip Register 10 */
#define MC14_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0061eb6u)	/* Read Data and Bit Flip Register 11 */
#define MC14_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0061eb8u)	/* Read Data and Bit Flip Register 12 */
#define MC14_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0061ebau)	/* Read Data and Bit Flip Register 13 */
#define MC14_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0061ebcu)	/* Read Data and Bit Flip Register 14 */
#define MC14_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0061ebeu)	/* Read Data and Bit Flip Register 15 */
#define MC14_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0061ec0u)	/* Read Data and Bit Flip Register 16 */
#define MC14_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0061ec2u)	/* Read Data and Bit Flip Register 17 */
#define MC14_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0061ec4u)	/* Read Data and Bit Flip Register 18 */
#define MC14_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0061ec6u)	/* Read Data and Bit Flip Register 19 */
#define MC14_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0061ea4u)	/* Read Data and Bit Flip Register 2 */
#define MC14_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0061ec8u)	/* Read Data and Bit Flip Register 20 */
#define MC14_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0061ecau)	/* Read Data and Bit Flip Register 21 */
#define MC14_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0061eccu)	/* Read Data and Bit Flip Register 22 */
#define MC14_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0061eceu)	/* Read Data and Bit Flip Register 23 */
#define MC14_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0061ed0u)	/* Read Data and Bit Flip Register 24 */
#define MC14_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0061ed2u)	/* Read Data and Bit Flip Register 25 */
#define MC14_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0061ed4u)	/* Read Data and Bit Flip Register 26 */
#define MC14_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0061ed6u)	/* Read Data and Bit Flip Register 27 */
#define MC14_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0061ed8u)	/* Read Data and Bit Flip Register 28 */
#define MC14_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0061edau)	/* Read Data and Bit Flip Register 29 */
#define MC14_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0061ea6u)	/* Read Data and Bit Flip Register 3 */
#define MC14_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0061edcu)	/* Read Data and Bit Flip Register 30 */
#define MC14_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0061edeu)	/* Read Data and Bit Flip Register 31 */
#define MC14_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0061ee0u)	/* Read Data and Bit Flip Register 32 */
#define MC14_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0061ee2u)	/* Read Data and Bit Flip Register 33 */
#define MC14_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0061ee4u)	/* Read Data and Bit Flip Register 34 */
#define MC14_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0061ee6u)	/* Read Data and Bit Flip Register 35 */
#define MC14_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0061ee8u)	/* Read Data and Bit Flip Register 36 */
#define MC14_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0061eeau)	/* Read Data and Bit Flip Register 37 */
#define MC14_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0061eecu)	/* Read Data and Bit Flip Register 38 */
#define MC14_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0061eeeu)	/* Read Data and Bit Flip Register 39 */
#define MC14_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0061ea8u)	/* Read Data and Bit Flip Register 4 */
#define MC14_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0061eaau)	/* Read Data and Bit Flip Register 5 */
#define MC14_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0061eacu)	/* Read Data and Bit Flip Register 6 */
#define MC14_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0061eaeu)	/* Read Data and Bit Flip Register 7 */
#define MC14_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0061eb0u)	/* Read Data and Bit Flip Register 8 */
#define MC14_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0061eb2u)	/* Read Data and Bit Flip Register 9 */
#define MC15_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0061fa0u)	/* Read Data and Bit Flip Register 0 */
#define MC15_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0061fa2u)	/* Read Data and Bit Flip Register 1 */
#define MC15_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0061fb4u)	/* Read Data and Bit Flip Register 10 */
#define MC15_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0061fb6u)	/* Read Data and Bit Flip Register 11 */
#define MC15_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0061fb8u)	/* Read Data and Bit Flip Register 12 */
#define MC15_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0061fbau)	/* Read Data and Bit Flip Register 13 */
#define MC15_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0061fbcu)	/* Read Data and Bit Flip Register 14 */
#define MC15_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0061fbeu)	/* Read Data and Bit Flip Register 15 */
#define MC15_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0061fc0u)	/* Read Data and Bit Flip Register 16 */
#define MC15_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0061fc2u)	/* Read Data and Bit Flip Register 17 */
#define MC15_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0061fc4u)	/* Read Data and Bit Flip Register 18 */
#define MC15_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0061fc6u)	/* Read Data and Bit Flip Register 19 */
#define MC15_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0061fa4u)	/* Read Data and Bit Flip Register 2 */
#define MC15_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0061fc8u)	/* Read Data and Bit Flip Register 20 */
#define MC15_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0061fcau)	/* Read Data and Bit Flip Register 21 */
#define MC15_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0061fccu)	/* Read Data and Bit Flip Register 22 */
#define MC15_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0061fceu)	/* Read Data and Bit Flip Register 23 */
#define MC15_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0061fd0u)	/* Read Data and Bit Flip Register 24 */
#define MC15_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0061fd2u)	/* Read Data and Bit Flip Register 25 */
#define MC15_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0061fd4u)	/* Read Data and Bit Flip Register 26 */
#define MC15_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0061fd6u)	/* Read Data and Bit Flip Register 27 */
#define MC15_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0061fd8u)	/* Read Data and Bit Flip Register 28 */
#define MC15_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0061fdau)	/* Read Data and Bit Flip Register 29 */
#define MC15_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0061fa6u)	/* Read Data and Bit Flip Register 3 */
#define MC15_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0061fdcu)	/* Read Data and Bit Flip Register 30 */
#define MC15_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0061fdeu)	/* Read Data and Bit Flip Register 31 */
#define MC15_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0061fe0u)	/* Read Data and Bit Flip Register 32 */
#define MC15_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0061fe2u)	/* Read Data and Bit Flip Register 33 */
#define MC15_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0061fe4u)	/* Read Data and Bit Flip Register 34 */
#define MC15_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0061fe6u)	/* Read Data and Bit Flip Register 35 */
#define MC15_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0061fe8u)	/* Read Data and Bit Flip Register 36 */
#define MC15_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0061feau)	/* Read Data and Bit Flip Register 37 */
#define MC15_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0061fecu)	/* Read Data and Bit Flip Register 38 */
#define MC15_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0061feeu)	/* Read Data and Bit Flip Register 39 */
#define MC15_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0061fa8u)	/* Read Data and Bit Flip Register 4 */
#define MC15_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0061faau)	/* Read Data and Bit Flip Register 5 */
#define MC15_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0061facu)	/* Read Data and Bit Flip Register 6 */
#define MC15_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0061faeu)	/* Read Data and Bit Flip Register 7 */
#define MC15_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0061fb0u)	/* Read Data and Bit Flip Register 8 */
#define MC15_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0061fb2u)	/* Read Data and Bit Flip Register 9 */
#define MC16_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00620a0u)	/* Read Data and Bit Flip Register 0 */
#define MC16_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00620a2u)	/* Read Data and Bit Flip Register 1 */
#define MC16_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00620b4u)	/* Read Data and Bit Flip Register 10 */
#define MC16_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00620b6u)	/* Read Data and Bit Flip Register 11 */
#define MC16_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00620b8u)	/* Read Data and Bit Flip Register 12 */
#define MC16_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00620bau)	/* Read Data and Bit Flip Register 13 */
#define MC16_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00620bcu)	/* Read Data and Bit Flip Register 14 */
#define MC16_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00620beu)	/* Read Data and Bit Flip Register 15 */
#define MC16_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00620c0u)	/* Read Data and Bit Flip Register 16 */
#define MC16_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00620c2u)	/* Read Data and Bit Flip Register 17 */
#define MC16_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00620c4u)	/* Read Data and Bit Flip Register 18 */
#define MC16_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00620c6u)	/* Read Data and Bit Flip Register 19 */
#define MC16_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00620a4u)	/* Read Data and Bit Flip Register 2 */
#define MC16_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00620c8u)	/* Read Data and Bit Flip Register 20 */
#define MC16_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00620cau)	/* Read Data and Bit Flip Register 21 */
#define MC16_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00620ccu)	/* Read Data and Bit Flip Register 22 */
#define MC16_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00620ceu)	/* Read Data and Bit Flip Register 23 */
#define MC16_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00620d0u)	/* Read Data and Bit Flip Register 24 */
#define MC16_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00620d2u)	/* Read Data and Bit Flip Register 25 */
#define MC16_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00620d4u)	/* Read Data and Bit Flip Register 26 */
#define MC16_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00620d6u)	/* Read Data and Bit Flip Register 27 */
#define MC16_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00620d8u)	/* Read Data and Bit Flip Register 28 */
#define MC16_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00620dau)	/* Read Data and Bit Flip Register 29 */
#define MC16_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00620a6u)	/* Read Data and Bit Flip Register 3 */
#define MC16_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00620dcu)	/* Read Data and Bit Flip Register 30 */
#define MC16_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00620deu)	/* Read Data and Bit Flip Register 31 */
#define MC16_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00620e0u)	/* Read Data and Bit Flip Register 32 */
#define MC16_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00620e2u)	/* Read Data and Bit Flip Register 33 */
#define MC16_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00620e4u)	/* Read Data and Bit Flip Register 34 */
#define MC16_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00620e6u)	/* Read Data and Bit Flip Register 35 */
#define MC16_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00620e8u)	/* Read Data and Bit Flip Register 36 */
#define MC16_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00620eau)	/* Read Data and Bit Flip Register 37 */
#define MC16_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00620ecu)	/* Read Data and Bit Flip Register 38 */
#define MC16_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00620eeu)	/* Read Data and Bit Flip Register 39 */
#define MC16_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00620a8u)	/* Read Data and Bit Flip Register 4 */
#define MC16_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00620aau)	/* Read Data and Bit Flip Register 5 */
#define MC16_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00620acu)	/* Read Data and Bit Flip Register 6 */
#define MC16_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00620aeu)	/* Read Data and Bit Flip Register 7 */
#define MC16_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00620b0u)	/* Read Data and Bit Flip Register 8 */
#define MC16_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00620b2u)	/* Read Data and Bit Flip Register 9 */
#define MC17_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00621a0u)	/* Read Data and Bit Flip Register 0 */
#define MC17_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00621a2u)	/* Read Data and Bit Flip Register 1 */
#define MC17_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00621b4u)	/* Read Data and Bit Flip Register 10 */
#define MC17_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00621b6u)	/* Read Data and Bit Flip Register 11 */
#define MC17_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00621b8u)	/* Read Data and Bit Flip Register 12 */
#define MC17_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00621bau)	/* Read Data and Bit Flip Register 13 */
#define MC17_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00621bcu)	/* Read Data and Bit Flip Register 14 */
#define MC17_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00621beu)	/* Read Data and Bit Flip Register 15 */
#define MC17_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00621c0u)	/* Read Data and Bit Flip Register 16 */
#define MC17_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00621c2u)	/* Read Data and Bit Flip Register 17 */
#define MC17_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00621c4u)	/* Read Data and Bit Flip Register 18 */
#define MC17_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00621c6u)	/* Read Data and Bit Flip Register 19 */
#define MC17_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00621a4u)	/* Read Data and Bit Flip Register 2 */
#define MC17_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00621c8u)	/* Read Data and Bit Flip Register 20 */
#define MC17_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00621cau)	/* Read Data and Bit Flip Register 21 */
#define MC17_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00621ccu)	/* Read Data and Bit Flip Register 22 */
#define MC17_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00621ceu)	/* Read Data and Bit Flip Register 23 */
#define MC17_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00621d0u)	/* Read Data and Bit Flip Register 24 */
#define MC17_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00621d2u)	/* Read Data and Bit Flip Register 25 */
#define MC17_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00621d4u)	/* Read Data and Bit Flip Register 26 */
#define MC17_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00621d6u)	/* Read Data and Bit Flip Register 27 */
#define MC17_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00621d8u)	/* Read Data and Bit Flip Register 28 */
#define MC17_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00621dau)	/* Read Data and Bit Flip Register 29 */
#define MC17_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00621a6u)	/* Read Data and Bit Flip Register 3 */
#define MC17_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00621dcu)	/* Read Data and Bit Flip Register 30 */
#define MC17_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00621deu)	/* Read Data and Bit Flip Register 31 */
#define MC17_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00621e0u)	/* Read Data and Bit Flip Register 32 */
#define MC17_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00621e2u)	/* Read Data and Bit Flip Register 33 */
#define MC17_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00621e4u)	/* Read Data and Bit Flip Register 34 */
#define MC17_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00621e6u)	/* Read Data and Bit Flip Register 35 */
#define MC17_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00621e8u)	/* Read Data and Bit Flip Register 36 */
#define MC17_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00621eau)	/* Read Data and Bit Flip Register 37 */
#define MC17_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00621ecu)	/* Read Data and Bit Flip Register 38 */
#define MC17_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00621eeu)	/* Read Data and Bit Flip Register 39 */
#define MC17_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00621a8u)	/* Read Data and Bit Flip Register 4 */
#define MC17_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00621aau)	/* Read Data and Bit Flip Register 5 */
#define MC17_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00621acu)	/* Read Data and Bit Flip Register 6 */
#define MC17_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00621aeu)	/* Read Data and Bit Flip Register 7 */
#define MC17_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00621b0u)	/* Read Data and Bit Flip Register 8 */
#define MC17_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00621b2u)	/* Read Data and Bit Flip Register 9 */
#define MC18_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00622a0u)	/* Read Data and Bit Flip Register 0 */
#define MC18_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00622a2u)	/* Read Data and Bit Flip Register 1 */
#define MC18_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00622b4u)	/* Read Data and Bit Flip Register 10 */
#define MC18_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00622b6u)	/* Read Data and Bit Flip Register 11 */
#define MC18_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00622b8u)	/* Read Data and Bit Flip Register 12 */
#define MC18_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00622bau)	/* Read Data and Bit Flip Register 13 */
#define MC18_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00622bcu)	/* Read Data and Bit Flip Register 14 */
#define MC18_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00622beu)	/* Read Data and Bit Flip Register 15 */
#define MC18_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00622c0u)	/* Read Data and Bit Flip Register 16 */
#define MC18_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00622c2u)	/* Read Data and Bit Flip Register 17 */
#define MC18_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00622c4u)	/* Read Data and Bit Flip Register 18 */
#define MC18_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00622c6u)	/* Read Data and Bit Flip Register 19 */
#define MC18_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00622a4u)	/* Read Data and Bit Flip Register 2 */
#define MC18_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00622c8u)	/* Read Data and Bit Flip Register 20 */
#define MC18_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00622cau)	/* Read Data and Bit Flip Register 21 */
#define MC18_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00622ccu)	/* Read Data and Bit Flip Register 22 */
#define MC18_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00622ceu)	/* Read Data and Bit Flip Register 23 */
#define MC18_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00622d0u)	/* Read Data and Bit Flip Register 24 */
#define MC18_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00622d2u)	/* Read Data and Bit Flip Register 25 */
#define MC18_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00622d4u)	/* Read Data and Bit Flip Register 26 */
#define MC18_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00622d6u)	/* Read Data and Bit Flip Register 27 */
#define MC18_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00622d8u)	/* Read Data and Bit Flip Register 28 */
#define MC18_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00622dau)	/* Read Data and Bit Flip Register 29 */
#define MC18_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00622a6u)	/* Read Data and Bit Flip Register 3 */
#define MC18_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00622dcu)	/* Read Data and Bit Flip Register 30 */
#define MC18_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00622deu)	/* Read Data and Bit Flip Register 31 */
#define MC18_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00622e0u)	/* Read Data and Bit Flip Register 32 */
#define MC18_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00622e2u)	/* Read Data and Bit Flip Register 33 */
#define MC18_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00622e4u)	/* Read Data and Bit Flip Register 34 */
#define MC18_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00622e6u)	/* Read Data and Bit Flip Register 35 */
#define MC18_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00622e8u)	/* Read Data and Bit Flip Register 36 */
#define MC18_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00622eau)	/* Read Data and Bit Flip Register 37 */
#define MC18_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00622ecu)	/* Read Data and Bit Flip Register 38 */
#define MC18_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00622eeu)	/* Read Data and Bit Flip Register 39 */
#define MC18_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00622a8u)	/* Read Data and Bit Flip Register 4 */
#define MC18_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00622aau)	/* Read Data and Bit Flip Register 5 */
#define MC18_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00622acu)	/* Read Data and Bit Flip Register 6 */
#define MC18_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00622aeu)	/* Read Data and Bit Flip Register 7 */
#define MC18_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00622b0u)	/* Read Data and Bit Flip Register 8 */
#define MC18_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00622b2u)	/* Read Data and Bit Flip Register 9 */
#define MC19_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00623a0u)	/* Read Data and Bit Flip Register 0 */
#define MC19_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00623a2u)	/* Read Data and Bit Flip Register 1 */
#define MC19_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00623b4u)	/* Read Data and Bit Flip Register 10 */
#define MC19_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00623b6u)	/* Read Data and Bit Flip Register 11 */
#define MC19_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00623b8u)	/* Read Data and Bit Flip Register 12 */
#define MC19_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00623bau)	/* Read Data and Bit Flip Register 13 */
#define MC19_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00623bcu)	/* Read Data and Bit Flip Register 14 */
#define MC19_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00623beu)	/* Read Data and Bit Flip Register 15 */
#define MC19_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00623c0u)	/* Read Data and Bit Flip Register 16 */
#define MC19_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00623c2u)	/* Read Data and Bit Flip Register 17 */
#define MC19_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00623c4u)	/* Read Data and Bit Flip Register 18 */
#define MC19_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00623c6u)	/* Read Data and Bit Flip Register 19 */
#define MC19_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00623a4u)	/* Read Data and Bit Flip Register 2 */
#define MC19_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00623c8u)	/* Read Data and Bit Flip Register 20 */
#define MC19_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00623cau)	/* Read Data and Bit Flip Register 21 */
#define MC19_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00623ccu)	/* Read Data and Bit Flip Register 22 */
#define MC19_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00623ceu)	/* Read Data and Bit Flip Register 23 */
#define MC19_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00623d0u)	/* Read Data and Bit Flip Register 24 */
#define MC19_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00623d2u)	/* Read Data and Bit Flip Register 25 */
#define MC19_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00623d4u)	/* Read Data and Bit Flip Register 26 */
#define MC19_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00623d6u)	/* Read Data and Bit Flip Register 27 */
#define MC19_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00623d8u)	/* Read Data and Bit Flip Register 28 */
#define MC19_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00623dau)	/* Read Data and Bit Flip Register 29 */
#define MC19_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00623a6u)	/* Read Data and Bit Flip Register 3 */
#define MC19_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00623dcu)	/* Read Data and Bit Flip Register 30 */
#define MC19_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00623deu)	/* Read Data and Bit Flip Register 31 */
#define MC19_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00623e0u)	/* Read Data and Bit Flip Register 32 */
#define MC19_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00623e2u)	/* Read Data and Bit Flip Register 33 */
#define MC19_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00623e4u)	/* Read Data and Bit Flip Register 34 */
#define MC19_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00623e6u)	/* Read Data and Bit Flip Register 35 */
#define MC19_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00623e8u)	/* Read Data and Bit Flip Register 36 */
#define MC19_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00623eau)	/* Read Data and Bit Flip Register 37 */
#define MC19_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00623ecu)	/* Read Data and Bit Flip Register 38 */
#define MC19_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00623eeu)	/* Read Data and Bit Flip Register 39 */
#define MC19_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00623a8u)	/* Read Data and Bit Flip Register 4 */
#define MC19_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00623aau)	/* Read Data and Bit Flip Register 5 */
#define MC19_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00623acu)	/* Read Data and Bit Flip Register 6 */
#define MC19_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00623aeu)	/* Read Data and Bit Flip Register 7 */
#define MC19_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00623b0u)	/* Read Data and Bit Flip Register 8 */
#define MC19_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00623b2u)	/* Read Data and Bit Flip Register 9 */
#define MC1_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00611a0u)	/* Read Data and Bit Flip Register 0 */
#define MC1_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00611a2u)	/* Read Data and Bit Flip Register 1 */
#define MC1_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00611b4u)	/* Read Data and Bit Flip Register 10 */
#define MC1_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00611b6u)	/* Read Data and Bit Flip Register 11 */
#define MC1_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00611b8u)	/* Read Data and Bit Flip Register 12 */
#define MC1_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00611bau)	/* Read Data and Bit Flip Register 13 */
#define MC1_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00611bcu)	/* Read Data and Bit Flip Register 14 */
#define MC1_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00611beu)	/* Read Data and Bit Flip Register 15 */
#define MC1_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00611c0u)	/* Read Data and Bit Flip Register 16 */
#define MC1_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00611c2u)	/* Read Data and Bit Flip Register 17 */
#define MC1_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00611c4u)	/* Read Data and Bit Flip Register 18 */
#define MC1_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00611c6u)	/* Read Data and Bit Flip Register 19 */
#define MC1_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00611a4u)	/* Read Data and Bit Flip Register 2 */
#define MC1_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00611c8u)	/* Read Data and Bit Flip Register 20 */
#define MC1_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00611cau)	/* Read Data and Bit Flip Register 21 */
#define MC1_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00611ccu)	/* Read Data and Bit Flip Register 22 */
#define MC1_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00611ceu)	/* Read Data and Bit Flip Register 23 */
#define MC1_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00611d0u)	/* Read Data and Bit Flip Register 24 */
#define MC1_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00611d2u)	/* Read Data and Bit Flip Register 25 */
#define MC1_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00611d4u)	/* Read Data and Bit Flip Register 26 */
#define MC1_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00611d6u)	/* Read Data and Bit Flip Register 27 */
#define MC1_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00611d8u)	/* Read Data and Bit Flip Register 28 */
#define MC1_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00611dau)	/* Read Data and Bit Flip Register 29 */
#define MC1_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00611a6u)	/* Read Data and Bit Flip Register 3 */
#define MC1_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00611dcu)	/* Read Data and Bit Flip Register 30 */
#define MC1_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00611deu)	/* Read Data and Bit Flip Register 31 */
#define MC1_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00611e0u)	/* Read Data and Bit Flip Register 32 */
#define MC1_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00611e2u)	/* Read Data and Bit Flip Register 33 */
#define MC1_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00611e4u)	/* Read Data and Bit Flip Register 34 */
#define MC1_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00611e6u)	/* Read Data and Bit Flip Register 35 */
#define MC1_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00611e8u)	/* Read Data and Bit Flip Register 36 */
#define MC1_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00611eau)	/* Read Data and Bit Flip Register 37 */
#define MC1_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00611ecu)	/* Read Data and Bit Flip Register 38 */
#define MC1_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00611eeu)	/* Read Data and Bit Flip Register 39 */
#define MC1_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00611a8u)	/* Read Data and Bit Flip Register 4 */
#define MC1_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00611aau)	/* Read Data and Bit Flip Register 5 */
#define MC1_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00611acu)	/* Read Data and Bit Flip Register 6 */
#define MC1_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00611aeu)	/* Read Data and Bit Flip Register 7 */
#define MC1_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00611b0u)	/* Read Data and Bit Flip Register 8 */
#define MC1_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00611b2u)	/* Read Data and Bit Flip Register 9 */
#define MC20_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00624a0u)	/* Read Data and Bit Flip Register 0 */
#define MC20_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00624a2u)	/* Read Data and Bit Flip Register 1 */
#define MC20_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00624b4u)	/* Read Data and Bit Flip Register 10 */
#define MC20_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00624b6u)	/* Read Data and Bit Flip Register 11 */
#define MC20_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00624b8u)	/* Read Data and Bit Flip Register 12 */
#define MC20_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00624bau)	/* Read Data and Bit Flip Register 13 */
#define MC20_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00624bcu)	/* Read Data and Bit Flip Register 14 */
#define MC20_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00624beu)	/* Read Data and Bit Flip Register 15 */
#define MC20_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00624c0u)	/* Read Data and Bit Flip Register 16 */
#define MC20_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00624c2u)	/* Read Data and Bit Flip Register 17 */
#define MC20_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00624c4u)	/* Read Data and Bit Flip Register 18 */
#define MC20_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00624c6u)	/* Read Data and Bit Flip Register 19 */
#define MC20_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00624a4u)	/* Read Data and Bit Flip Register 2 */
#define MC20_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00624c8u)	/* Read Data and Bit Flip Register 20 */
#define MC20_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00624cau)	/* Read Data and Bit Flip Register 21 */
#define MC20_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00624ccu)	/* Read Data and Bit Flip Register 22 */
#define MC20_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00624ceu)	/* Read Data and Bit Flip Register 23 */
#define MC20_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00624d0u)	/* Read Data and Bit Flip Register 24 */
#define MC20_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00624d2u)	/* Read Data and Bit Flip Register 25 */
#define MC20_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00624d4u)	/* Read Data and Bit Flip Register 26 */
#define MC20_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00624d6u)	/* Read Data and Bit Flip Register 27 */
#define MC20_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00624d8u)	/* Read Data and Bit Flip Register 28 */
#define MC20_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00624dau)	/* Read Data and Bit Flip Register 29 */
#define MC20_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00624a6u)	/* Read Data and Bit Flip Register 3 */
#define MC20_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00624dcu)	/* Read Data and Bit Flip Register 30 */
#define MC20_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00624deu)	/* Read Data and Bit Flip Register 31 */
#define MC20_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00624e0u)	/* Read Data and Bit Flip Register 32 */
#define MC20_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00624e2u)	/* Read Data and Bit Flip Register 33 */
#define MC20_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00624e4u)	/* Read Data and Bit Flip Register 34 */
#define MC20_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00624e6u)	/* Read Data and Bit Flip Register 35 */
#define MC20_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00624e8u)	/* Read Data and Bit Flip Register 36 */
#define MC20_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00624eau)	/* Read Data and Bit Flip Register 37 */
#define MC20_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00624ecu)	/* Read Data and Bit Flip Register 38 */
#define MC20_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00624eeu)	/* Read Data and Bit Flip Register 39 */
#define MC20_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00624a8u)	/* Read Data and Bit Flip Register 4 */
#define MC20_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00624aau)	/* Read Data and Bit Flip Register 5 */
#define MC20_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00624acu)	/* Read Data and Bit Flip Register 6 */
#define MC20_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00624aeu)	/* Read Data and Bit Flip Register 7 */
#define MC20_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00624b0u)	/* Read Data and Bit Flip Register 8 */
#define MC20_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00624b2u)	/* Read Data and Bit Flip Register 9 */
#define MC21_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00625a0u)	/* Read Data and Bit Flip Register 0 */
#define MC21_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00625a2u)	/* Read Data and Bit Flip Register 1 */
#define MC21_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00625b4u)	/* Read Data and Bit Flip Register 10 */
#define MC21_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00625b6u)	/* Read Data and Bit Flip Register 11 */
#define MC21_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00625b8u)	/* Read Data and Bit Flip Register 12 */
#define MC21_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00625bau)	/* Read Data and Bit Flip Register 13 */
#define MC21_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00625bcu)	/* Read Data and Bit Flip Register 14 */
#define MC21_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00625beu)	/* Read Data and Bit Flip Register 15 */
#define MC21_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00625c0u)	/* Read Data and Bit Flip Register 16 */
#define MC21_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00625c2u)	/* Read Data and Bit Flip Register 17 */
#define MC21_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00625c4u)	/* Read Data and Bit Flip Register 18 */
#define MC21_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00625c6u)	/* Read Data and Bit Flip Register 19 */
#define MC21_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00625a4u)	/* Read Data and Bit Flip Register 2 */
#define MC21_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00625c8u)	/* Read Data and Bit Flip Register 20 */
#define MC21_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00625cau)	/* Read Data and Bit Flip Register 21 */
#define MC21_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00625ccu)	/* Read Data and Bit Flip Register 22 */
#define MC21_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00625ceu)	/* Read Data and Bit Flip Register 23 */
#define MC21_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00625d0u)	/* Read Data and Bit Flip Register 24 */
#define MC21_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00625d2u)	/* Read Data and Bit Flip Register 25 */
#define MC21_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00625d4u)	/* Read Data and Bit Flip Register 26 */
#define MC21_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00625d6u)	/* Read Data and Bit Flip Register 27 */
#define MC21_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00625d8u)	/* Read Data and Bit Flip Register 28 */
#define MC21_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00625dau)	/* Read Data and Bit Flip Register 29 */
#define MC21_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00625a6u)	/* Read Data and Bit Flip Register 3 */
#define MC21_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00625dcu)	/* Read Data and Bit Flip Register 30 */
#define MC21_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00625deu)	/* Read Data and Bit Flip Register 31 */
#define MC21_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00625e0u)	/* Read Data and Bit Flip Register 32 */
#define MC21_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00625e2u)	/* Read Data and Bit Flip Register 33 */
#define MC21_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00625e4u)	/* Read Data and Bit Flip Register 34 */
#define MC21_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00625e6u)	/* Read Data and Bit Flip Register 35 */
#define MC21_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00625e8u)	/* Read Data and Bit Flip Register 36 */
#define MC21_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00625eau)	/* Read Data and Bit Flip Register 37 */
#define MC21_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00625ecu)	/* Read Data and Bit Flip Register 38 */
#define MC21_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00625eeu)	/* Read Data and Bit Flip Register 39 */
#define MC21_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00625a8u)	/* Read Data and Bit Flip Register 4 */
#define MC21_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00625aau)	/* Read Data and Bit Flip Register 5 */
#define MC21_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00625acu)	/* Read Data and Bit Flip Register 6 */
#define MC21_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00625aeu)	/* Read Data and Bit Flip Register 7 */
#define MC21_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00625b0u)	/* Read Data and Bit Flip Register 8 */
#define MC21_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00625b2u)	/* Read Data and Bit Flip Register 9 */
#define MC22_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00626a0u)	/* Read Data and Bit Flip Register 0 */
#define MC22_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00626a2u)	/* Read Data and Bit Flip Register 1 */
#define MC22_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00626b4u)	/* Read Data and Bit Flip Register 10 */
#define MC22_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00626b6u)	/* Read Data and Bit Flip Register 11 */
#define MC22_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00626b8u)	/* Read Data and Bit Flip Register 12 */
#define MC22_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00626bau)	/* Read Data and Bit Flip Register 13 */
#define MC22_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00626bcu)	/* Read Data and Bit Flip Register 14 */
#define MC22_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00626beu)	/* Read Data and Bit Flip Register 15 */
#define MC22_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00626c0u)	/* Read Data and Bit Flip Register 16 */
#define MC22_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00626c2u)	/* Read Data and Bit Flip Register 17 */
#define MC22_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00626c4u)	/* Read Data and Bit Flip Register 18 */
#define MC22_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00626c6u)	/* Read Data and Bit Flip Register 19 */
#define MC22_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00626a4u)	/* Read Data and Bit Flip Register 2 */
#define MC22_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00626c8u)	/* Read Data and Bit Flip Register 20 */
#define MC22_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00626cau)	/* Read Data and Bit Flip Register 21 */
#define MC22_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00626ccu)	/* Read Data and Bit Flip Register 22 */
#define MC22_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00626ceu)	/* Read Data and Bit Flip Register 23 */
#define MC22_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00626d0u)	/* Read Data and Bit Flip Register 24 */
#define MC22_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00626d2u)	/* Read Data and Bit Flip Register 25 */
#define MC22_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00626d4u)	/* Read Data and Bit Flip Register 26 */
#define MC22_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00626d6u)	/* Read Data and Bit Flip Register 27 */
#define MC22_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00626d8u)	/* Read Data and Bit Flip Register 28 */
#define MC22_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00626dau)	/* Read Data and Bit Flip Register 29 */
#define MC22_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00626a6u)	/* Read Data and Bit Flip Register 3 */
#define MC22_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00626dcu)	/* Read Data and Bit Flip Register 30 */
#define MC22_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00626deu)	/* Read Data and Bit Flip Register 31 */
#define MC22_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00626e0u)	/* Read Data and Bit Flip Register 32 */
#define MC22_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00626e2u)	/* Read Data and Bit Flip Register 33 */
#define MC22_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00626e4u)	/* Read Data and Bit Flip Register 34 */
#define MC22_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00626e6u)	/* Read Data and Bit Flip Register 35 */
#define MC22_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00626e8u)	/* Read Data and Bit Flip Register 36 */
#define MC22_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00626eau)	/* Read Data and Bit Flip Register 37 */
#define MC22_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00626ecu)	/* Read Data and Bit Flip Register 38 */
#define MC22_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00626eeu)	/* Read Data and Bit Flip Register 39 */
#define MC22_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00626a8u)	/* Read Data and Bit Flip Register 4 */
#define MC22_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00626aau)	/* Read Data and Bit Flip Register 5 */
#define MC22_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00626acu)	/* Read Data and Bit Flip Register 6 */
#define MC22_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00626aeu)	/* Read Data and Bit Flip Register 7 */
#define MC22_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00626b0u)	/* Read Data and Bit Flip Register 8 */
#define MC22_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00626b2u)	/* Read Data and Bit Flip Register 9 */
#define MC23_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00627a0u)	/* Read Data and Bit Flip Register 0 */
#define MC23_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00627a2u)	/* Read Data and Bit Flip Register 1 */
#define MC23_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00627b4u)	/* Read Data and Bit Flip Register 10 */
#define MC23_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00627b6u)	/* Read Data and Bit Flip Register 11 */
#define MC23_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00627b8u)	/* Read Data and Bit Flip Register 12 */
#define MC23_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00627bau)	/* Read Data and Bit Flip Register 13 */
#define MC23_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00627bcu)	/* Read Data and Bit Flip Register 14 */
#define MC23_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00627beu)	/* Read Data and Bit Flip Register 15 */
#define MC23_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00627c0u)	/* Read Data and Bit Flip Register 16 */
#define MC23_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00627c2u)	/* Read Data and Bit Flip Register 17 */
#define MC23_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00627c4u)	/* Read Data and Bit Flip Register 18 */
#define MC23_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00627c6u)	/* Read Data and Bit Flip Register 19 */
#define MC23_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00627a4u)	/* Read Data and Bit Flip Register 2 */
#define MC23_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00627c8u)	/* Read Data and Bit Flip Register 20 */
#define MC23_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00627cau)	/* Read Data and Bit Flip Register 21 */
#define MC23_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00627ccu)	/* Read Data and Bit Flip Register 22 */
#define MC23_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00627ceu)	/* Read Data and Bit Flip Register 23 */
#define MC23_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00627d0u)	/* Read Data and Bit Flip Register 24 */
#define MC23_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00627d2u)	/* Read Data and Bit Flip Register 25 */
#define MC23_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00627d4u)	/* Read Data and Bit Flip Register 26 */
#define MC23_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00627d6u)	/* Read Data and Bit Flip Register 27 */
#define MC23_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00627d8u)	/* Read Data and Bit Flip Register 28 */
#define MC23_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00627dau)	/* Read Data and Bit Flip Register 29 */
#define MC23_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00627a6u)	/* Read Data and Bit Flip Register 3 */
#define MC23_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00627dcu)	/* Read Data and Bit Flip Register 30 */
#define MC23_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00627deu)	/* Read Data and Bit Flip Register 31 */
#define MC23_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00627e0u)	/* Read Data and Bit Flip Register 32 */
#define MC23_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00627e2u)	/* Read Data and Bit Flip Register 33 */
#define MC23_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00627e4u)	/* Read Data and Bit Flip Register 34 */
#define MC23_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00627e6u)	/* Read Data and Bit Flip Register 35 */
#define MC23_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00627e8u)	/* Read Data and Bit Flip Register 36 */
#define MC23_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00627eau)	/* Read Data and Bit Flip Register 37 */
#define MC23_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00627ecu)	/* Read Data and Bit Flip Register 38 */
#define MC23_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00627eeu)	/* Read Data and Bit Flip Register 39 */
#define MC23_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00627a8u)	/* Read Data and Bit Flip Register 4 */
#define MC23_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00627aau)	/* Read Data and Bit Flip Register 5 */
#define MC23_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00627acu)	/* Read Data and Bit Flip Register 6 */
#define MC23_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00627aeu)	/* Read Data and Bit Flip Register 7 */
#define MC23_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00627b0u)	/* Read Data and Bit Flip Register 8 */
#define MC23_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00627b2u)	/* Read Data and Bit Flip Register 9 */
#define MC24_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00628a0u)	/* Read Data and Bit Flip Register 0 */
#define MC24_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00628a2u)	/* Read Data and Bit Flip Register 1 */
#define MC24_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00628b4u)	/* Read Data and Bit Flip Register 10 */
#define MC24_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00628b6u)	/* Read Data and Bit Flip Register 11 */
#define MC24_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00628b8u)	/* Read Data and Bit Flip Register 12 */
#define MC24_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00628bau)	/* Read Data and Bit Flip Register 13 */
#define MC24_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00628bcu)	/* Read Data and Bit Flip Register 14 */
#define MC24_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00628beu)	/* Read Data and Bit Flip Register 15 */
#define MC24_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00628c0u)	/* Read Data and Bit Flip Register 16 */
#define MC24_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00628c2u)	/* Read Data and Bit Flip Register 17 */
#define MC24_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00628c4u)	/* Read Data and Bit Flip Register 18 */
#define MC24_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00628c6u)	/* Read Data and Bit Flip Register 19 */
#define MC24_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00628a4u)	/* Read Data and Bit Flip Register 2 */
#define MC24_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00628c8u)	/* Read Data and Bit Flip Register 20 */
#define MC24_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00628cau)	/* Read Data and Bit Flip Register 21 */
#define MC24_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00628ccu)	/* Read Data and Bit Flip Register 22 */
#define MC24_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00628ceu)	/* Read Data and Bit Flip Register 23 */
#define MC24_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00628d0u)	/* Read Data and Bit Flip Register 24 */
#define MC24_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00628d2u)	/* Read Data and Bit Flip Register 25 */
#define MC24_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00628d4u)	/* Read Data and Bit Flip Register 26 */
#define MC24_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00628d6u)	/* Read Data and Bit Flip Register 27 */
#define MC24_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00628d8u)	/* Read Data and Bit Flip Register 28 */
#define MC24_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00628dau)	/* Read Data and Bit Flip Register 29 */
#define MC24_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00628a6u)	/* Read Data and Bit Flip Register 3 */
#define MC24_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00628dcu)	/* Read Data and Bit Flip Register 30 */
#define MC24_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00628deu)	/* Read Data and Bit Flip Register 31 */
#define MC24_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00628e0u)	/* Read Data and Bit Flip Register 32 */
#define MC24_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00628e2u)	/* Read Data and Bit Flip Register 33 */
#define MC24_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00628e4u)	/* Read Data and Bit Flip Register 34 */
#define MC24_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00628e6u)	/* Read Data and Bit Flip Register 35 */
#define MC24_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00628e8u)	/* Read Data and Bit Flip Register 36 */
#define MC24_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00628eau)	/* Read Data and Bit Flip Register 37 */
#define MC24_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00628ecu)	/* Read Data and Bit Flip Register 38 */
#define MC24_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00628eeu)	/* Read Data and Bit Flip Register 39 */
#define MC24_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00628a8u)	/* Read Data and Bit Flip Register 4 */
#define MC24_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00628aau)	/* Read Data and Bit Flip Register 5 */
#define MC24_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00628acu)	/* Read Data and Bit Flip Register 6 */
#define MC24_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00628aeu)	/* Read Data and Bit Flip Register 7 */
#define MC24_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00628b0u)	/* Read Data and Bit Flip Register 8 */
#define MC24_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00628b2u)	/* Read Data and Bit Flip Register 9 */
#define MC25_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00629a0u)	/* Read Data and Bit Flip Register 0 */
#define MC25_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00629a2u)	/* Read Data and Bit Flip Register 1 */
#define MC25_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00629b4u)	/* Read Data and Bit Flip Register 10 */
#define MC25_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00629b6u)	/* Read Data and Bit Flip Register 11 */
#define MC25_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00629b8u)	/* Read Data and Bit Flip Register 12 */
#define MC25_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00629bau)	/* Read Data and Bit Flip Register 13 */
#define MC25_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00629bcu)	/* Read Data and Bit Flip Register 14 */
#define MC25_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00629beu)	/* Read Data and Bit Flip Register 15 */
#define MC25_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00629c0u)	/* Read Data and Bit Flip Register 16 */
#define MC25_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00629c2u)	/* Read Data and Bit Flip Register 17 */
#define MC25_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00629c4u)	/* Read Data and Bit Flip Register 18 */
#define MC25_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00629c6u)	/* Read Data and Bit Flip Register 19 */
#define MC25_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00629a4u)	/* Read Data and Bit Flip Register 2 */
#define MC25_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00629c8u)	/* Read Data and Bit Flip Register 20 */
#define MC25_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00629cau)	/* Read Data and Bit Flip Register 21 */
#define MC25_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00629ccu)	/* Read Data and Bit Flip Register 22 */
#define MC25_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00629ceu)	/* Read Data and Bit Flip Register 23 */
#define MC25_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00629d0u)	/* Read Data and Bit Flip Register 24 */
#define MC25_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00629d2u)	/* Read Data and Bit Flip Register 25 */
#define MC25_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00629d4u)	/* Read Data and Bit Flip Register 26 */
#define MC25_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00629d6u)	/* Read Data and Bit Flip Register 27 */
#define MC25_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00629d8u)	/* Read Data and Bit Flip Register 28 */
#define MC25_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00629dau)	/* Read Data and Bit Flip Register 29 */
#define MC25_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00629a6u)	/* Read Data and Bit Flip Register 3 */
#define MC25_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00629dcu)	/* Read Data and Bit Flip Register 30 */
#define MC25_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00629deu)	/* Read Data and Bit Flip Register 31 */
#define MC25_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00629e0u)	/* Read Data and Bit Flip Register 32 */
#define MC25_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00629e2u)	/* Read Data and Bit Flip Register 33 */
#define MC25_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00629e4u)	/* Read Data and Bit Flip Register 34 */
#define MC25_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00629e6u)	/* Read Data and Bit Flip Register 35 */
#define MC25_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00629e8u)	/* Read Data and Bit Flip Register 36 */
#define MC25_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00629eau)	/* Read Data and Bit Flip Register 37 */
#define MC25_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00629ecu)	/* Read Data and Bit Flip Register 38 */
#define MC25_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00629eeu)	/* Read Data and Bit Flip Register 39 */
#define MC25_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00629a8u)	/* Read Data and Bit Flip Register 4 */
#define MC25_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00629aau)	/* Read Data and Bit Flip Register 5 */
#define MC25_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00629acu)	/* Read Data and Bit Flip Register 6 */
#define MC25_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00629aeu)	/* Read Data and Bit Flip Register 7 */
#define MC25_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00629b0u)	/* Read Data and Bit Flip Register 8 */
#define MC25_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00629b2u)	/* Read Data and Bit Flip Register 9 */
#define MC26_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0062aa0u)	/* Read Data and Bit Flip Register 0 */
#define MC26_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0062aa2u)	/* Read Data and Bit Flip Register 1 */
#define MC26_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0062ab4u)	/* Read Data and Bit Flip Register 10 */
#define MC26_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0062ab6u)	/* Read Data and Bit Flip Register 11 */
#define MC26_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0062ab8u)	/* Read Data and Bit Flip Register 12 */
#define MC26_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0062abau)	/* Read Data and Bit Flip Register 13 */
#define MC26_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0062abcu)	/* Read Data and Bit Flip Register 14 */
#define MC26_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0062abeu)	/* Read Data and Bit Flip Register 15 */
#define MC26_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0062ac0u)	/* Read Data and Bit Flip Register 16 */
#define MC26_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0062ac2u)	/* Read Data and Bit Flip Register 17 */
#define MC26_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0062ac4u)	/* Read Data and Bit Flip Register 18 */
#define MC26_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0062ac6u)	/* Read Data and Bit Flip Register 19 */
#define MC26_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0062aa4u)	/* Read Data and Bit Flip Register 2 */
#define MC26_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0062ac8u)	/* Read Data and Bit Flip Register 20 */
#define MC26_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0062acau)	/* Read Data and Bit Flip Register 21 */
#define MC26_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0062accu)	/* Read Data and Bit Flip Register 22 */
#define MC26_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0062aceu)	/* Read Data and Bit Flip Register 23 */
#define MC26_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0062ad0u)	/* Read Data and Bit Flip Register 24 */
#define MC26_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0062ad2u)	/* Read Data and Bit Flip Register 25 */
#define MC26_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0062ad4u)	/* Read Data and Bit Flip Register 26 */
#define MC26_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0062ad6u)	/* Read Data and Bit Flip Register 27 */
#define MC26_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0062ad8u)	/* Read Data and Bit Flip Register 28 */
#define MC26_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0062adau)	/* Read Data and Bit Flip Register 29 */
#define MC26_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0062aa6u)	/* Read Data and Bit Flip Register 3 */
#define MC26_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0062adcu)	/* Read Data and Bit Flip Register 30 */
#define MC26_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0062adeu)	/* Read Data and Bit Flip Register 31 */
#define MC26_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0062ae0u)	/* Read Data and Bit Flip Register 32 */
#define MC26_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0062ae2u)	/* Read Data and Bit Flip Register 33 */
#define MC26_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0062ae4u)	/* Read Data and Bit Flip Register 34 */
#define MC26_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0062ae6u)	/* Read Data and Bit Flip Register 35 */
#define MC26_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0062ae8u)	/* Read Data and Bit Flip Register 36 */
#define MC26_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0062aeau)	/* Read Data and Bit Flip Register 37 */
#define MC26_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0062aecu)	/* Read Data and Bit Flip Register 38 */
#define MC26_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0062aeeu)	/* Read Data and Bit Flip Register 39 */
#define MC26_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0062aa8u)	/* Read Data and Bit Flip Register 4 */
#define MC26_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0062aaau)	/* Read Data and Bit Flip Register 5 */
#define MC26_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0062aacu)	/* Read Data and Bit Flip Register 6 */
#define MC26_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0062aaeu)	/* Read Data and Bit Flip Register 7 */
#define MC26_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0062ab0u)	/* Read Data and Bit Flip Register 8 */
#define MC26_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0062ab2u)	/* Read Data and Bit Flip Register 9 */
#define MC27_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0062ba0u)	/* Read Data and Bit Flip Register 0 */
#define MC27_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0062ba2u)	/* Read Data and Bit Flip Register 1 */
#define MC27_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0062bb4u)	/* Read Data and Bit Flip Register 10 */
#define MC27_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0062bb6u)	/* Read Data and Bit Flip Register 11 */
#define MC27_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0062bb8u)	/* Read Data and Bit Flip Register 12 */
#define MC27_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0062bbau)	/* Read Data and Bit Flip Register 13 */
#define MC27_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0062bbcu)	/* Read Data and Bit Flip Register 14 */
#define MC27_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0062bbeu)	/* Read Data and Bit Flip Register 15 */
#define MC27_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0062bc0u)	/* Read Data and Bit Flip Register 16 */
#define MC27_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0062bc2u)	/* Read Data and Bit Flip Register 17 */
#define MC27_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0062bc4u)	/* Read Data and Bit Flip Register 18 */
#define MC27_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0062bc6u)	/* Read Data and Bit Flip Register 19 */
#define MC27_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0062ba4u)	/* Read Data and Bit Flip Register 2 */
#define MC27_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0062bc8u)	/* Read Data and Bit Flip Register 20 */
#define MC27_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0062bcau)	/* Read Data and Bit Flip Register 21 */
#define MC27_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0062bccu)	/* Read Data and Bit Flip Register 22 */
#define MC27_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0062bceu)	/* Read Data and Bit Flip Register 23 */
#define MC27_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0062bd0u)	/* Read Data and Bit Flip Register 24 */
#define MC27_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0062bd2u)	/* Read Data and Bit Flip Register 25 */
#define MC27_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0062bd4u)	/* Read Data and Bit Flip Register 26 */
#define MC27_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0062bd6u)	/* Read Data and Bit Flip Register 27 */
#define MC27_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0062bd8u)	/* Read Data and Bit Flip Register 28 */
#define MC27_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0062bdau)	/* Read Data and Bit Flip Register 29 */
#define MC27_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0062ba6u)	/* Read Data and Bit Flip Register 3 */
#define MC27_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0062bdcu)	/* Read Data and Bit Flip Register 30 */
#define MC27_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0062bdeu)	/* Read Data and Bit Flip Register 31 */
#define MC27_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0062be0u)	/* Read Data and Bit Flip Register 32 */
#define MC27_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0062be2u)	/* Read Data and Bit Flip Register 33 */
#define MC27_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0062be4u)	/* Read Data and Bit Flip Register 34 */
#define MC27_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0062be6u)	/* Read Data and Bit Flip Register 35 */
#define MC27_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0062be8u)	/* Read Data and Bit Flip Register 36 */
#define MC27_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0062beau)	/* Read Data and Bit Flip Register 37 */
#define MC27_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0062becu)	/* Read Data and Bit Flip Register 38 */
#define MC27_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0062beeu)	/* Read Data and Bit Flip Register 39 */
#define MC27_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0062ba8u)	/* Read Data and Bit Flip Register 4 */
#define MC27_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0062baau)	/* Read Data and Bit Flip Register 5 */
#define MC27_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0062bacu)	/* Read Data and Bit Flip Register 6 */
#define MC27_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0062baeu)	/* Read Data and Bit Flip Register 7 */
#define MC27_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0062bb0u)	/* Read Data and Bit Flip Register 8 */
#define MC27_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0062bb2u)	/* Read Data and Bit Flip Register 9 */
#define MC28_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0062ca0u)	/* Read Data and Bit Flip Register 0 */
#define MC28_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0062ca2u)	/* Read Data and Bit Flip Register 1 */
#define MC28_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0062cb4u)	/* Read Data and Bit Flip Register 10 */
#define MC28_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0062cb6u)	/* Read Data and Bit Flip Register 11 */
#define MC28_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0062cb8u)	/* Read Data and Bit Flip Register 12 */
#define MC28_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0062cbau)	/* Read Data and Bit Flip Register 13 */
#define MC28_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0062cbcu)	/* Read Data and Bit Flip Register 14 */
#define MC28_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0062cbeu)	/* Read Data and Bit Flip Register 15 */
#define MC28_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0062cc0u)	/* Read Data and Bit Flip Register 16 */
#define MC28_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0062cc2u)	/* Read Data and Bit Flip Register 17 */
#define MC28_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0062cc4u)	/* Read Data and Bit Flip Register 18 */
#define MC28_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0062cc6u)	/* Read Data and Bit Flip Register 19 */
#define MC28_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0062ca4u)	/* Read Data and Bit Flip Register 2 */
#define MC28_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0062cc8u)	/* Read Data and Bit Flip Register 20 */
#define MC28_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0062ccau)	/* Read Data and Bit Flip Register 21 */
#define MC28_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0062cccu)	/* Read Data and Bit Flip Register 22 */
#define MC28_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0062cceu)	/* Read Data and Bit Flip Register 23 */
#define MC28_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0062cd0u)	/* Read Data and Bit Flip Register 24 */
#define MC28_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0062cd2u)	/* Read Data and Bit Flip Register 25 */
#define MC28_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0062cd4u)	/* Read Data and Bit Flip Register 26 */
#define MC28_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0062cd6u)	/* Read Data and Bit Flip Register 27 */
#define MC28_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0062cd8u)	/* Read Data and Bit Flip Register 28 */
#define MC28_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0062cdau)	/* Read Data and Bit Flip Register 29 */
#define MC28_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0062ca6u)	/* Read Data and Bit Flip Register 3 */
#define MC28_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0062cdcu)	/* Read Data and Bit Flip Register 30 */
#define MC28_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0062cdeu)	/* Read Data and Bit Flip Register 31 */
#define MC28_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0062ce0u)	/* Read Data and Bit Flip Register 32 */
#define MC28_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0062ce2u)	/* Read Data and Bit Flip Register 33 */
#define MC28_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0062ce4u)	/* Read Data and Bit Flip Register 34 */
#define MC28_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0062ce6u)	/* Read Data and Bit Flip Register 35 */
#define MC28_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0062ce8u)	/* Read Data and Bit Flip Register 36 */
#define MC28_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0062ceau)	/* Read Data and Bit Flip Register 37 */
#define MC28_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0062cecu)	/* Read Data and Bit Flip Register 38 */
#define MC28_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0062ceeu)	/* Read Data and Bit Flip Register 39 */
#define MC28_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0062ca8u)	/* Read Data and Bit Flip Register 4 */
#define MC28_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0062caau)	/* Read Data and Bit Flip Register 5 */
#define MC28_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0062cacu)	/* Read Data and Bit Flip Register 6 */
#define MC28_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0062caeu)	/* Read Data and Bit Flip Register 7 */
#define MC28_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0062cb0u)	/* Read Data and Bit Flip Register 8 */
#define MC28_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0062cb2u)	/* Read Data and Bit Flip Register 9 */
#define MC29_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0062da0u)	/* Read Data and Bit Flip Register 0 */
#define MC29_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0062da2u)	/* Read Data and Bit Flip Register 1 */
#define MC29_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0062db4u)	/* Read Data and Bit Flip Register 10 */
#define MC29_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0062db6u)	/* Read Data and Bit Flip Register 11 */
#define MC29_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0062db8u)	/* Read Data and Bit Flip Register 12 */
#define MC29_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0062dbau)	/* Read Data and Bit Flip Register 13 */
#define MC29_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0062dbcu)	/* Read Data and Bit Flip Register 14 */
#define MC29_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0062dbeu)	/* Read Data and Bit Flip Register 15 */
#define MC29_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0062dc0u)	/* Read Data and Bit Flip Register 16 */
#define MC29_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0062dc2u)	/* Read Data and Bit Flip Register 17 */
#define MC29_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0062dc4u)	/* Read Data and Bit Flip Register 18 */
#define MC29_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0062dc6u)	/* Read Data and Bit Flip Register 19 */
#define MC29_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0062da4u)	/* Read Data and Bit Flip Register 2 */
#define MC29_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0062dc8u)	/* Read Data and Bit Flip Register 20 */
#define MC29_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0062dcau)	/* Read Data and Bit Flip Register 21 */
#define MC29_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0062dccu)	/* Read Data and Bit Flip Register 22 */
#define MC29_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0062dceu)	/* Read Data and Bit Flip Register 23 */
#define MC29_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0062dd0u)	/* Read Data and Bit Flip Register 24 */
#define MC29_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0062dd2u)	/* Read Data and Bit Flip Register 25 */
#define MC29_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0062dd4u)	/* Read Data and Bit Flip Register 26 */
#define MC29_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0062dd6u)	/* Read Data and Bit Flip Register 27 */
#define MC29_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0062dd8u)	/* Read Data and Bit Flip Register 28 */
#define MC29_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0062ddau)	/* Read Data and Bit Flip Register 29 */
#define MC29_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0062da6u)	/* Read Data and Bit Flip Register 3 */
#define MC29_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0062ddcu)	/* Read Data and Bit Flip Register 30 */
#define MC29_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0062ddeu)	/* Read Data and Bit Flip Register 31 */
#define MC29_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0062de0u)	/* Read Data and Bit Flip Register 32 */
#define MC29_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0062de2u)	/* Read Data and Bit Flip Register 33 */
#define MC29_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0062de4u)	/* Read Data and Bit Flip Register 34 */
#define MC29_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0062de6u)	/* Read Data and Bit Flip Register 35 */
#define MC29_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0062de8u)	/* Read Data and Bit Flip Register 36 */
#define MC29_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0062deau)	/* Read Data and Bit Flip Register 37 */
#define MC29_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0062decu)	/* Read Data and Bit Flip Register 38 */
#define MC29_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0062deeu)	/* Read Data and Bit Flip Register 39 */
#define MC29_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0062da8u)	/* Read Data and Bit Flip Register 4 */
#define MC29_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0062daau)	/* Read Data and Bit Flip Register 5 */
#define MC29_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0062dacu)	/* Read Data and Bit Flip Register 6 */
#define MC29_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0062daeu)	/* Read Data and Bit Flip Register 7 */
#define MC29_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0062db0u)	/* Read Data and Bit Flip Register 8 */
#define MC29_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0062db2u)	/* Read Data and Bit Flip Register 9 */
#define MC2_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00612a0u)	/* Read Data and Bit Flip Register 0 */
#define MC2_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00612a2u)	/* Read Data and Bit Flip Register 1 */
#define MC2_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00612b4u)	/* Read Data and Bit Flip Register 10 */
#define MC2_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00612b6u)	/* Read Data and Bit Flip Register 11 */
#define MC2_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00612b8u)	/* Read Data and Bit Flip Register 12 */
#define MC2_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00612bau)	/* Read Data and Bit Flip Register 13 */
#define MC2_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00612bcu)	/* Read Data and Bit Flip Register 14 */
#define MC2_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00612beu)	/* Read Data and Bit Flip Register 15 */
#define MC2_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00612c0u)	/* Read Data and Bit Flip Register 16 */
#define MC2_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00612c2u)	/* Read Data and Bit Flip Register 17 */
#define MC2_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00612c4u)	/* Read Data and Bit Flip Register 18 */
#define MC2_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00612c6u)	/* Read Data and Bit Flip Register 19 */
#define MC2_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00612a4u)	/* Read Data and Bit Flip Register 2 */
#define MC2_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00612c8u)	/* Read Data and Bit Flip Register 20 */
#define MC2_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00612cau)	/* Read Data and Bit Flip Register 21 */
#define MC2_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00612ccu)	/* Read Data and Bit Flip Register 22 */
#define MC2_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00612ceu)	/* Read Data and Bit Flip Register 23 */
#define MC2_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00612d0u)	/* Read Data and Bit Flip Register 24 */
#define MC2_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00612d2u)	/* Read Data and Bit Flip Register 25 */
#define MC2_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00612d4u)	/* Read Data and Bit Flip Register 26 */
#define MC2_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00612d6u)	/* Read Data and Bit Flip Register 27 */
#define MC2_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00612d8u)	/* Read Data and Bit Flip Register 28 */
#define MC2_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00612dau)	/* Read Data and Bit Flip Register 29 */
#define MC2_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00612a6u)	/* Read Data and Bit Flip Register 3 */
#define MC2_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00612dcu)	/* Read Data and Bit Flip Register 30 */
#define MC2_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00612deu)	/* Read Data and Bit Flip Register 31 */
#define MC2_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00612e0u)	/* Read Data and Bit Flip Register 32 */
#define MC2_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00612e2u)	/* Read Data and Bit Flip Register 33 */
#define MC2_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00612e4u)	/* Read Data and Bit Flip Register 34 */
#define MC2_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00612e6u)	/* Read Data and Bit Flip Register 35 */
#define MC2_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00612e8u)	/* Read Data and Bit Flip Register 36 */
#define MC2_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00612eau)	/* Read Data and Bit Flip Register 37 */
#define MC2_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00612ecu)	/* Read Data and Bit Flip Register 38 */
#define MC2_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00612eeu)	/* Read Data and Bit Flip Register 39 */
#define MC2_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00612a8u)	/* Read Data and Bit Flip Register 4 */
#define MC2_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00612aau)	/* Read Data and Bit Flip Register 5 */
#define MC2_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00612acu)	/* Read Data and Bit Flip Register 6 */
#define MC2_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00612aeu)	/* Read Data and Bit Flip Register 7 */
#define MC2_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00612b0u)	/* Read Data and Bit Flip Register 8 */
#define MC2_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00612b2u)	/* Read Data and Bit Flip Register 9 */
#define MC30_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0062ea0u)	/* Read Data and Bit Flip Register 0 */
#define MC30_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0062ea2u)	/* Read Data and Bit Flip Register 1 */
#define MC30_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0062eb4u)	/* Read Data and Bit Flip Register 10 */
#define MC30_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0062eb6u)	/* Read Data and Bit Flip Register 11 */
#define MC30_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0062eb8u)	/* Read Data and Bit Flip Register 12 */
#define MC30_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0062ebau)	/* Read Data and Bit Flip Register 13 */
#define MC30_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0062ebcu)	/* Read Data and Bit Flip Register 14 */
#define MC30_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0062ebeu)	/* Read Data and Bit Flip Register 15 */
#define MC30_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0062ec0u)	/* Read Data and Bit Flip Register 16 */
#define MC30_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0062ec2u)	/* Read Data and Bit Flip Register 17 */
#define MC30_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0062ec4u)	/* Read Data and Bit Flip Register 18 */
#define MC30_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0062ec6u)	/* Read Data and Bit Flip Register 19 */
#define MC30_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0062ea4u)	/* Read Data and Bit Flip Register 2 */
#define MC30_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0062ec8u)	/* Read Data and Bit Flip Register 20 */
#define MC30_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0062ecau)	/* Read Data and Bit Flip Register 21 */
#define MC30_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0062eccu)	/* Read Data and Bit Flip Register 22 */
#define MC30_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0062eceu)	/* Read Data and Bit Flip Register 23 */
#define MC30_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0062ed0u)	/* Read Data and Bit Flip Register 24 */
#define MC30_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0062ed2u)	/* Read Data and Bit Flip Register 25 */
#define MC30_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0062ed4u)	/* Read Data and Bit Flip Register 26 */
#define MC30_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0062ed6u)	/* Read Data and Bit Flip Register 27 */
#define MC30_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0062ed8u)	/* Read Data and Bit Flip Register 28 */
#define MC30_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0062edau)	/* Read Data and Bit Flip Register 29 */
#define MC30_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0062ea6u)	/* Read Data and Bit Flip Register 3 */
#define MC30_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0062edcu)	/* Read Data and Bit Flip Register 30 */
#define MC30_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0062edeu)	/* Read Data and Bit Flip Register 31 */
#define MC30_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0062ee0u)	/* Read Data and Bit Flip Register 32 */
#define MC30_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0062ee2u)	/* Read Data and Bit Flip Register 33 */
#define MC30_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0062ee4u)	/* Read Data and Bit Flip Register 34 */
#define MC30_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0062ee6u)	/* Read Data and Bit Flip Register 35 */
#define MC30_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0062ee8u)	/* Read Data and Bit Flip Register 36 */
#define MC30_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0062eeau)	/* Read Data and Bit Flip Register 37 */
#define MC30_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0062eecu)	/* Read Data and Bit Flip Register 38 */
#define MC30_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0062eeeu)	/* Read Data and Bit Flip Register 39 */
#define MC30_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0062ea8u)	/* Read Data and Bit Flip Register 4 */
#define MC30_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0062eaau)	/* Read Data and Bit Flip Register 5 */
#define MC30_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0062eacu)	/* Read Data and Bit Flip Register 6 */
#define MC30_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0062eaeu)	/* Read Data and Bit Flip Register 7 */
#define MC30_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0062eb0u)	/* Read Data and Bit Flip Register 8 */
#define MC30_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0062eb2u)	/* Read Data and Bit Flip Register 9 */
#define MC31_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0062fa0u)	/* Read Data and Bit Flip Register 0 */
#define MC31_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0062fa2u)	/* Read Data and Bit Flip Register 1 */
#define MC31_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0062fb4u)	/* Read Data and Bit Flip Register 10 */
#define MC31_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0062fb6u)	/* Read Data and Bit Flip Register 11 */
#define MC31_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0062fb8u)	/* Read Data and Bit Flip Register 12 */
#define MC31_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0062fbau)	/* Read Data and Bit Flip Register 13 */
#define MC31_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0062fbcu)	/* Read Data and Bit Flip Register 14 */
#define MC31_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0062fbeu)	/* Read Data and Bit Flip Register 15 */
#define MC31_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0062fc0u)	/* Read Data and Bit Flip Register 16 */
#define MC31_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0062fc2u)	/* Read Data and Bit Flip Register 17 */
#define MC31_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0062fc4u)	/* Read Data and Bit Flip Register 18 */
#define MC31_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0062fc6u)	/* Read Data and Bit Flip Register 19 */
#define MC31_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0062fa4u)	/* Read Data and Bit Flip Register 2 */
#define MC31_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0062fc8u)	/* Read Data and Bit Flip Register 20 */
#define MC31_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0062fcau)	/* Read Data and Bit Flip Register 21 */
#define MC31_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0062fccu)	/* Read Data and Bit Flip Register 22 */
#define MC31_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0062fceu)	/* Read Data and Bit Flip Register 23 */
#define MC31_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0062fd0u)	/* Read Data and Bit Flip Register 24 */
#define MC31_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0062fd2u)	/* Read Data and Bit Flip Register 25 */
#define MC31_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0062fd4u)	/* Read Data and Bit Flip Register 26 */
#define MC31_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0062fd6u)	/* Read Data and Bit Flip Register 27 */
#define MC31_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0062fd8u)	/* Read Data and Bit Flip Register 28 */
#define MC31_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0062fdau)	/* Read Data and Bit Flip Register 29 */
#define MC31_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0062fa6u)	/* Read Data and Bit Flip Register 3 */
#define MC31_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0062fdcu)	/* Read Data and Bit Flip Register 30 */
#define MC31_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0062fdeu)	/* Read Data and Bit Flip Register 31 */
#define MC31_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0062fe0u)	/* Read Data and Bit Flip Register 32 */
#define MC31_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0062fe2u)	/* Read Data and Bit Flip Register 33 */
#define MC31_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0062fe4u)	/* Read Data and Bit Flip Register 34 */
#define MC31_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0062fe6u)	/* Read Data and Bit Flip Register 35 */
#define MC31_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0062fe8u)	/* Read Data and Bit Flip Register 36 */
#define MC31_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0062feau)	/* Read Data and Bit Flip Register 37 */
#define MC31_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0062fecu)	/* Read Data and Bit Flip Register 38 */
#define MC31_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0062feeu)	/* Read Data and Bit Flip Register 39 */
#define MC31_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0062fa8u)	/* Read Data and Bit Flip Register 4 */
#define MC31_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0062faau)	/* Read Data and Bit Flip Register 5 */
#define MC31_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0062facu)	/* Read Data and Bit Flip Register 6 */
#define MC31_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0062faeu)	/* Read Data and Bit Flip Register 7 */
#define MC31_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0062fb0u)	/* Read Data and Bit Flip Register 8 */
#define MC31_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0062fb2u)	/* Read Data and Bit Flip Register 9 */
#define MC32_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00630a0u)	/* Read Data and Bit Flip Register 0 */
#define MC32_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00630a2u)	/* Read Data and Bit Flip Register 1 */
#define MC32_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00630b4u)	/* Read Data and Bit Flip Register 10 */
#define MC32_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00630b6u)	/* Read Data and Bit Flip Register 11 */
#define MC32_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00630b8u)	/* Read Data and Bit Flip Register 12 */
#define MC32_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00630bau)	/* Read Data and Bit Flip Register 13 */
#define MC32_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00630bcu)	/* Read Data and Bit Flip Register 14 */
#define MC32_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00630beu)	/* Read Data and Bit Flip Register 15 */
#define MC32_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00630c0u)	/* Read Data and Bit Flip Register 16 */
#define MC32_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00630c2u)	/* Read Data and Bit Flip Register 17 */
#define MC32_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00630c4u)	/* Read Data and Bit Flip Register 18 */
#define MC32_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00630c6u)	/* Read Data and Bit Flip Register 19 */
#define MC32_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00630a4u)	/* Read Data and Bit Flip Register 2 */
#define MC32_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00630c8u)	/* Read Data and Bit Flip Register 20 */
#define MC32_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00630cau)	/* Read Data and Bit Flip Register 21 */
#define MC32_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00630ccu)	/* Read Data and Bit Flip Register 22 */
#define MC32_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00630ceu)	/* Read Data and Bit Flip Register 23 */
#define MC32_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00630d0u)	/* Read Data and Bit Flip Register 24 */
#define MC32_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00630d2u)	/* Read Data and Bit Flip Register 25 */
#define MC32_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00630d4u)	/* Read Data and Bit Flip Register 26 */
#define MC32_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00630d6u)	/* Read Data and Bit Flip Register 27 */
#define MC32_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00630d8u)	/* Read Data and Bit Flip Register 28 */
#define MC32_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00630dau)	/* Read Data and Bit Flip Register 29 */
#define MC32_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00630a6u)	/* Read Data and Bit Flip Register 3 */
#define MC32_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00630dcu)	/* Read Data and Bit Flip Register 30 */
#define MC32_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00630deu)	/* Read Data and Bit Flip Register 31 */
#define MC32_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00630e0u)	/* Read Data and Bit Flip Register 32 */
#define MC32_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00630e2u)	/* Read Data and Bit Flip Register 33 */
#define MC32_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00630e4u)	/* Read Data and Bit Flip Register 34 */
#define MC32_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00630e6u)	/* Read Data and Bit Flip Register 35 */
#define MC32_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00630e8u)	/* Read Data and Bit Flip Register 36 */
#define MC32_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00630eau)	/* Read Data and Bit Flip Register 37 */
#define MC32_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00630ecu)	/* Read Data and Bit Flip Register 38 */
#define MC32_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00630eeu)	/* Read Data and Bit Flip Register 39 */
#define MC32_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00630a8u)	/* Read Data and Bit Flip Register 4 */
#define MC32_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00630aau)	/* Read Data and Bit Flip Register 5 */
#define MC32_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00630acu)	/* Read Data and Bit Flip Register 6 */
#define MC32_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00630aeu)	/* Read Data and Bit Flip Register 7 */
#define MC32_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00630b0u)	/* Read Data and Bit Flip Register 8 */
#define MC32_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00630b2u)	/* Read Data and Bit Flip Register 9 */
#define MC33_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00631a0u)	/* Read Data and Bit Flip Register 0 */
#define MC33_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00631a2u)	/* Read Data and Bit Flip Register 1 */
#define MC33_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00631b4u)	/* Read Data and Bit Flip Register 10 */
#define MC33_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00631b6u)	/* Read Data and Bit Flip Register 11 */
#define MC33_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00631b8u)	/* Read Data and Bit Flip Register 12 */
#define MC33_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00631bau)	/* Read Data and Bit Flip Register 13 */
#define MC33_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00631bcu)	/* Read Data and Bit Flip Register 14 */
#define MC33_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00631beu)	/* Read Data and Bit Flip Register 15 */
#define MC33_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00631c0u)	/* Read Data and Bit Flip Register 16 */
#define MC33_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00631c2u)	/* Read Data and Bit Flip Register 17 */
#define MC33_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00631c4u)	/* Read Data and Bit Flip Register 18 */
#define MC33_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00631c6u)	/* Read Data and Bit Flip Register 19 */
#define MC33_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00631a4u)	/* Read Data and Bit Flip Register 2 */
#define MC33_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00631c8u)	/* Read Data and Bit Flip Register 20 */
#define MC33_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00631cau)	/* Read Data and Bit Flip Register 21 */
#define MC33_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00631ccu)	/* Read Data and Bit Flip Register 22 */
#define MC33_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00631ceu)	/* Read Data and Bit Flip Register 23 */
#define MC33_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00631d0u)	/* Read Data and Bit Flip Register 24 */
#define MC33_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00631d2u)	/* Read Data and Bit Flip Register 25 */
#define MC33_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00631d4u)	/* Read Data and Bit Flip Register 26 */
#define MC33_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00631d6u)	/* Read Data and Bit Flip Register 27 */
#define MC33_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00631d8u)	/* Read Data and Bit Flip Register 28 */
#define MC33_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00631dau)	/* Read Data and Bit Flip Register 29 */
#define MC33_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00631a6u)	/* Read Data and Bit Flip Register 3 */
#define MC33_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00631dcu)	/* Read Data and Bit Flip Register 30 */
#define MC33_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00631deu)	/* Read Data and Bit Flip Register 31 */
#define MC33_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00631e0u)	/* Read Data and Bit Flip Register 32 */
#define MC33_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00631e2u)	/* Read Data and Bit Flip Register 33 */
#define MC33_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00631e4u)	/* Read Data and Bit Flip Register 34 */
#define MC33_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00631e6u)	/* Read Data and Bit Flip Register 35 */
#define MC33_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00631e8u)	/* Read Data and Bit Flip Register 36 */
#define MC33_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00631eau)	/* Read Data and Bit Flip Register 37 */
#define MC33_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00631ecu)	/* Read Data and Bit Flip Register 38 */
#define MC33_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00631eeu)	/* Read Data and Bit Flip Register 39 */
#define MC33_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00631a8u)	/* Read Data and Bit Flip Register 4 */
#define MC33_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00631aau)	/* Read Data and Bit Flip Register 5 */
#define MC33_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00631acu)	/* Read Data and Bit Flip Register 6 */
#define MC33_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00631aeu)	/* Read Data and Bit Flip Register 7 */
#define MC33_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00631b0u)	/* Read Data and Bit Flip Register 8 */
#define MC33_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00631b2u)	/* Read Data and Bit Flip Register 9 */
#define MC34_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00632a0u)	/* Read Data and Bit Flip Register 0 */
#define MC34_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00632a2u)	/* Read Data and Bit Flip Register 1 */
#define MC34_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00632b4u)	/* Read Data and Bit Flip Register 10 */
#define MC34_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00632b6u)	/* Read Data and Bit Flip Register 11 */
#define MC34_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00632b8u)	/* Read Data and Bit Flip Register 12 */
#define MC34_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00632bau)	/* Read Data and Bit Flip Register 13 */
#define MC34_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00632bcu)	/* Read Data and Bit Flip Register 14 */
#define MC34_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00632beu)	/* Read Data and Bit Flip Register 15 */
#define MC34_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00632c0u)	/* Read Data and Bit Flip Register 16 */
#define MC34_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00632c2u)	/* Read Data and Bit Flip Register 17 */
#define MC34_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00632c4u)	/* Read Data and Bit Flip Register 18 */
#define MC34_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00632c6u)	/* Read Data and Bit Flip Register 19 */
#define MC34_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00632a4u)	/* Read Data and Bit Flip Register 2 */
#define MC34_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00632c8u)	/* Read Data and Bit Flip Register 20 */
#define MC34_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00632cau)	/* Read Data and Bit Flip Register 21 */
#define MC34_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00632ccu)	/* Read Data and Bit Flip Register 22 */
#define MC34_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00632ceu)	/* Read Data and Bit Flip Register 23 */
#define MC34_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00632d0u)	/* Read Data and Bit Flip Register 24 */
#define MC34_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00632d2u)	/* Read Data and Bit Flip Register 25 */
#define MC34_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00632d4u)	/* Read Data and Bit Flip Register 26 */
#define MC34_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00632d6u)	/* Read Data and Bit Flip Register 27 */
#define MC34_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00632d8u)	/* Read Data and Bit Flip Register 28 */
#define MC34_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00632dau)	/* Read Data and Bit Flip Register 29 */
#define MC34_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00632a6u)	/* Read Data and Bit Flip Register 3 */
#define MC34_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00632dcu)	/* Read Data and Bit Flip Register 30 */
#define MC34_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00632deu)	/* Read Data and Bit Flip Register 31 */
#define MC34_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00632e0u)	/* Read Data and Bit Flip Register 32 */
#define MC34_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00632e2u)	/* Read Data and Bit Flip Register 33 */
#define MC34_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00632e4u)	/* Read Data and Bit Flip Register 34 */
#define MC34_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00632e6u)	/* Read Data and Bit Flip Register 35 */
#define MC34_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00632e8u)	/* Read Data and Bit Flip Register 36 */
#define MC34_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00632eau)	/* Read Data and Bit Flip Register 37 */
#define MC34_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00632ecu)	/* Read Data and Bit Flip Register 38 */
#define MC34_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00632eeu)	/* Read Data and Bit Flip Register 39 */
#define MC34_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00632a8u)	/* Read Data and Bit Flip Register 4 */
#define MC34_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00632aau)	/* Read Data and Bit Flip Register 5 */
#define MC34_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00632acu)	/* Read Data and Bit Flip Register 6 */
#define MC34_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00632aeu)	/* Read Data and Bit Flip Register 7 */
#define MC34_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00632b0u)	/* Read Data and Bit Flip Register 8 */
#define MC34_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00632b2u)	/* Read Data and Bit Flip Register 9 */
#define MC35_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00633a0u)	/* Read Data and Bit Flip Register 0 */
#define MC35_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00633a2u)	/* Read Data and Bit Flip Register 1 */
#define MC35_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00633b4u)	/* Read Data and Bit Flip Register 10 */
#define MC35_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00633b6u)	/* Read Data and Bit Flip Register 11 */
#define MC35_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00633b8u)	/* Read Data and Bit Flip Register 12 */
#define MC35_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00633bau)	/* Read Data and Bit Flip Register 13 */
#define MC35_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00633bcu)	/* Read Data and Bit Flip Register 14 */
#define MC35_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00633beu)	/* Read Data and Bit Flip Register 15 */
#define MC35_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00633c0u)	/* Read Data and Bit Flip Register 16 */
#define MC35_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00633c2u)	/* Read Data and Bit Flip Register 17 */
#define MC35_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00633c4u)	/* Read Data and Bit Flip Register 18 */
#define MC35_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00633c6u)	/* Read Data and Bit Flip Register 19 */
#define MC35_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00633a4u)	/* Read Data and Bit Flip Register 2 */
#define MC35_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00633c8u)	/* Read Data and Bit Flip Register 20 */
#define MC35_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00633cau)	/* Read Data and Bit Flip Register 21 */
#define MC35_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00633ccu)	/* Read Data and Bit Flip Register 22 */
#define MC35_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00633ceu)	/* Read Data and Bit Flip Register 23 */
#define MC35_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00633d0u)	/* Read Data and Bit Flip Register 24 */
#define MC35_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00633d2u)	/* Read Data and Bit Flip Register 25 */
#define MC35_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00633d4u)	/* Read Data and Bit Flip Register 26 */
#define MC35_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00633d6u)	/* Read Data and Bit Flip Register 27 */
#define MC35_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00633d8u)	/* Read Data and Bit Flip Register 28 */
#define MC35_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00633dau)	/* Read Data and Bit Flip Register 29 */
#define MC35_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00633a6u)	/* Read Data and Bit Flip Register 3 */
#define MC35_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00633dcu)	/* Read Data and Bit Flip Register 30 */
#define MC35_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00633deu)	/* Read Data and Bit Flip Register 31 */
#define MC35_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00633e0u)	/* Read Data and Bit Flip Register 32 */
#define MC35_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00633e2u)	/* Read Data and Bit Flip Register 33 */
#define MC35_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00633e4u)	/* Read Data and Bit Flip Register 34 */
#define MC35_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00633e6u)	/* Read Data and Bit Flip Register 35 */
#define MC35_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00633e8u)	/* Read Data and Bit Flip Register 36 */
#define MC35_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00633eau)	/* Read Data and Bit Flip Register 37 */
#define MC35_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00633ecu)	/* Read Data and Bit Flip Register 38 */
#define MC35_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00633eeu)	/* Read Data and Bit Flip Register 39 */
#define MC35_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00633a8u)	/* Read Data and Bit Flip Register 4 */
#define MC35_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00633aau)	/* Read Data and Bit Flip Register 5 */
#define MC35_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00633acu)	/* Read Data and Bit Flip Register 6 */
#define MC35_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00633aeu)	/* Read Data and Bit Flip Register 7 */
#define MC35_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00633b0u)	/* Read Data and Bit Flip Register 8 */
#define MC35_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00633b2u)	/* Read Data and Bit Flip Register 9 */
#define MC36_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00634a0u)	/* Read Data and Bit Flip Register 0 */
#define MC36_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00634a2u)	/* Read Data and Bit Flip Register 1 */
#define MC36_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00634b4u)	/* Read Data and Bit Flip Register 10 */
#define MC36_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00634b6u)	/* Read Data and Bit Flip Register 11 */
#define MC36_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00634b8u)	/* Read Data and Bit Flip Register 12 */
#define MC36_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00634bau)	/* Read Data and Bit Flip Register 13 */
#define MC36_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00634bcu)	/* Read Data and Bit Flip Register 14 */
#define MC36_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00634beu)	/* Read Data and Bit Flip Register 15 */
#define MC36_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00634c0u)	/* Read Data and Bit Flip Register 16 */
#define MC36_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00634c2u)	/* Read Data and Bit Flip Register 17 */
#define MC36_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00634c4u)	/* Read Data and Bit Flip Register 18 */
#define MC36_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00634c6u)	/* Read Data and Bit Flip Register 19 */
#define MC36_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00634a4u)	/* Read Data and Bit Flip Register 2 */
#define MC36_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00634c8u)	/* Read Data and Bit Flip Register 20 */
#define MC36_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00634cau)	/* Read Data and Bit Flip Register 21 */
#define MC36_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00634ccu)	/* Read Data and Bit Flip Register 22 */
#define MC36_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00634ceu)	/* Read Data and Bit Flip Register 23 */
#define MC36_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00634d0u)	/* Read Data and Bit Flip Register 24 */
#define MC36_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00634d2u)	/* Read Data and Bit Flip Register 25 */
#define MC36_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00634d4u)	/* Read Data and Bit Flip Register 26 */
#define MC36_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00634d6u)	/* Read Data and Bit Flip Register 27 */
#define MC36_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00634d8u)	/* Read Data and Bit Flip Register 28 */
#define MC36_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00634dau)	/* Read Data and Bit Flip Register 29 */
#define MC36_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00634a6u)	/* Read Data and Bit Flip Register 3 */
#define MC36_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00634dcu)	/* Read Data and Bit Flip Register 30 */
#define MC36_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00634deu)	/* Read Data and Bit Flip Register 31 */
#define MC36_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00634e0u)	/* Read Data and Bit Flip Register 32 */
#define MC36_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00634e2u)	/* Read Data and Bit Flip Register 33 */
#define MC36_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00634e4u)	/* Read Data and Bit Flip Register 34 */
#define MC36_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00634e6u)	/* Read Data and Bit Flip Register 35 */
#define MC36_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00634e8u)	/* Read Data and Bit Flip Register 36 */
#define MC36_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00634eau)	/* Read Data and Bit Flip Register 37 */
#define MC36_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00634ecu)	/* Read Data and Bit Flip Register 38 */
#define MC36_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00634eeu)	/* Read Data and Bit Flip Register 39 */
#define MC36_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00634a8u)	/* Read Data and Bit Flip Register 4 */
#define MC36_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00634aau)	/* Read Data and Bit Flip Register 5 */
#define MC36_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00634acu)	/* Read Data and Bit Flip Register 6 */
#define MC36_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00634aeu)	/* Read Data and Bit Flip Register 7 */
#define MC36_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00634b0u)	/* Read Data and Bit Flip Register 8 */
#define MC36_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00634b2u)	/* Read Data and Bit Flip Register 9 */
#define MC37_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00635a0u)	/* Read Data and Bit Flip Register 0 */
#define MC37_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00635a2u)	/* Read Data and Bit Flip Register 1 */
#define MC37_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00635b4u)	/* Read Data and Bit Flip Register 10 */
#define MC37_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00635b6u)	/* Read Data and Bit Flip Register 11 */
#define MC37_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00635b8u)	/* Read Data and Bit Flip Register 12 */
#define MC37_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00635bau)	/* Read Data and Bit Flip Register 13 */
#define MC37_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00635bcu)	/* Read Data and Bit Flip Register 14 */
#define MC37_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00635beu)	/* Read Data and Bit Flip Register 15 */
#define MC37_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00635c0u)	/* Read Data and Bit Flip Register 16 */
#define MC37_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00635c2u)	/* Read Data and Bit Flip Register 17 */
#define MC37_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00635c4u)	/* Read Data and Bit Flip Register 18 */
#define MC37_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00635c6u)	/* Read Data and Bit Flip Register 19 */
#define MC37_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00635a4u)	/* Read Data and Bit Flip Register 2 */
#define MC37_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00635c8u)	/* Read Data and Bit Flip Register 20 */
#define MC37_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00635cau)	/* Read Data and Bit Flip Register 21 */
#define MC37_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00635ccu)	/* Read Data and Bit Flip Register 22 */
#define MC37_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00635ceu)	/* Read Data and Bit Flip Register 23 */
#define MC37_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00635d0u)	/* Read Data and Bit Flip Register 24 */
#define MC37_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00635d2u)	/* Read Data and Bit Flip Register 25 */
#define MC37_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00635d4u)	/* Read Data and Bit Flip Register 26 */
#define MC37_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00635d6u)	/* Read Data and Bit Flip Register 27 */
#define MC37_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00635d8u)	/* Read Data and Bit Flip Register 28 */
#define MC37_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00635dau)	/* Read Data and Bit Flip Register 29 */
#define MC37_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00635a6u)	/* Read Data and Bit Flip Register 3 */
#define MC37_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00635dcu)	/* Read Data and Bit Flip Register 30 */
#define MC37_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00635deu)	/* Read Data and Bit Flip Register 31 */
#define MC37_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00635e0u)	/* Read Data and Bit Flip Register 32 */
#define MC37_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00635e2u)	/* Read Data and Bit Flip Register 33 */
#define MC37_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00635e4u)	/* Read Data and Bit Flip Register 34 */
#define MC37_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00635e6u)	/* Read Data and Bit Flip Register 35 */
#define MC37_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00635e8u)	/* Read Data and Bit Flip Register 36 */
#define MC37_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00635eau)	/* Read Data and Bit Flip Register 37 */
#define MC37_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00635ecu)	/* Read Data and Bit Flip Register 38 */
#define MC37_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00635eeu)	/* Read Data and Bit Flip Register 39 */
#define MC37_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00635a8u)	/* Read Data and Bit Flip Register 4 */
#define MC37_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00635aau)	/* Read Data and Bit Flip Register 5 */
#define MC37_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00635acu)	/* Read Data and Bit Flip Register 6 */
#define MC37_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00635aeu)	/* Read Data and Bit Flip Register 7 */
#define MC37_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00635b0u)	/* Read Data and Bit Flip Register 8 */
#define MC37_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00635b2u)	/* Read Data and Bit Flip Register 9 */
#define MC38_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00636a0u)	/* Read Data and Bit Flip Register 0 */
#define MC38_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00636a2u)	/* Read Data and Bit Flip Register 1 */
#define MC38_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00636b4u)	/* Read Data and Bit Flip Register 10 */
#define MC38_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00636b6u)	/* Read Data and Bit Flip Register 11 */
#define MC38_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00636b8u)	/* Read Data and Bit Flip Register 12 */
#define MC38_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00636bau)	/* Read Data and Bit Flip Register 13 */
#define MC38_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00636bcu)	/* Read Data and Bit Flip Register 14 */
#define MC38_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00636beu)	/* Read Data and Bit Flip Register 15 */
#define MC38_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00636c0u)	/* Read Data and Bit Flip Register 16 */
#define MC38_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00636c2u)	/* Read Data and Bit Flip Register 17 */
#define MC38_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00636c4u)	/* Read Data and Bit Flip Register 18 */
#define MC38_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00636c6u)	/* Read Data and Bit Flip Register 19 */
#define MC38_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00636a4u)	/* Read Data and Bit Flip Register 2 */
#define MC38_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00636c8u)	/* Read Data and Bit Flip Register 20 */
#define MC38_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00636cau)	/* Read Data and Bit Flip Register 21 */
#define MC38_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00636ccu)	/* Read Data and Bit Flip Register 22 */
#define MC38_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00636ceu)	/* Read Data and Bit Flip Register 23 */
#define MC38_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00636d0u)	/* Read Data and Bit Flip Register 24 */
#define MC38_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00636d2u)	/* Read Data and Bit Flip Register 25 */
#define MC38_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00636d4u)	/* Read Data and Bit Flip Register 26 */
#define MC38_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00636d6u)	/* Read Data and Bit Flip Register 27 */
#define MC38_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00636d8u)	/* Read Data and Bit Flip Register 28 */
#define MC38_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00636dau)	/* Read Data and Bit Flip Register 29 */
#define MC38_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00636a6u)	/* Read Data and Bit Flip Register 3 */
#define MC38_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00636dcu)	/* Read Data and Bit Flip Register 30 */
#define MC38_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00636deu)	/* Read Data and Bit Flip Register 31 */
#define MC38_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00636e0u)	/* Read Data and Bit Flip Register 32 */
#define MC38_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00636e2u)	/* Read Data and Bit Flip Register 33 */
#define MC38_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00636e4u)	/* Read Data and Bit Flip Register 34 */
#define MC38_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00636e6u)	/* Read Data and Bit Flip Register 35 */
#define MC38_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00636e8u)	/* Read Data and Bit Flip Register 36 */
#define MC38_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00636eau)	/* Read Data and Bit Flip Register 37 */
#define MC38_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00636ecu)	/* Read Data and Bit Flip Register 38 */
#define MC38_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00636eeu)	/* Read Data and Bit Flip Register 39 */
#define MC38_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00636a8u)	/* Read Data and Bit Flip Register 4 */
#define MC38_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00636aau)	/* Read Data and Bit Flip Register 5 */
#define MC38_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00636acu)	/* Read Data and Bit Flip Register 6 */
#define MC38_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00636aeu)	/* Read Data and Bit Flip Register 7 */
#define MC38_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00636b0u)	/* Read Data and Bit Flip Register 8 */
#define MC38_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00636b2u)	/* Read Data and Bit Flip Register 9 */
#define MC39_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00637a0u)	/* Read Data and Bit Flip Register 0 */
#define MC39_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00637a2u)	/* Read Data and Bit Flip Register 1 */
#define MC39_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00637b4u)	/* Read Data and Bit Flip Register 10 */
#define MC39_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00637b6u)	/* Read Data and Bit Flip Register 11 */
#define MC39_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00637b8u)	/* Read Data and Bit Flip Register 12 */
#define MC39_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00637bau)	/* Read Data and Bit Flip Register 13 */
#define MC39_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00637bcu)	/* Read Data and Bit Flip Register 14 */
#define MC39_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00637beu)	/* Read Data and Bit Flip Register 15 */
#define MC39_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00637c0u)	/* Read Data and Bit Flip Register 16 */
#define MC39_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00637c2u)	/* Read Data and Bit Flip Register 17 */
#define MC39_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00637c4u)	/* Read Data and Bit Flip Register 18 */
#define MC39_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00637c6u)	/* Read Data and Bit Flip Register 19 */
#define MC39_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00637a4u)	/* Read Data and Bit Flip Register 2 */
#define MC39_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00637c8u)	/* Read Data and Bit Flip Register 20 */
#define MC39_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00637cau)	/* Read Data and Bit Flip Register 21 */
#define MC39_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00637ccu)	/* Read Data and Bit Flip Register 22 */
#define MC39_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00637ceu)	/* Read Data and Bit Flip Register 23 */
#define MC39_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00637d0u)	/* Read Data and Bit Flip Register 24 */
#define MC39_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00637d2u)	/* Read Data and Bit Flip Register 25 */
#define MC39_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00637d4u)	/* Read Data and Bit Flip Register 26 */
#define MC39_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00637d6u)	/* Read Data and Bit Flip Register 27 */
#define MC39_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00637d8u)	/* Read Data and Bit Flip Register 28 */
#define MC39_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00637dau)	/* Read Data and Bit Flip Register 29 */
#define MC39_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00637a6u)	/* Read Data and Bit Flip Register 3 */
#define MC39_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00637dcu)	/* Read Data and Bit Flip Register 30 */
#define MC39_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00637deu)	/* Read Data and Bit Flip Register 31 */
#define MC39_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00637e0u)	/* Read Data and Bit Flip Register 32 */
#define MC39_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00637e2u)	/* Read Data and Bit Flip Register 33 */
#define MC39_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00637e4u)	/* Read Data and Bit Flip Register 34 */
#define MC39_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00637e6u)	/* Read Data and Bit Flip Register 35 */
#define MC39_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00637e8u)	/* Read Data and Bit Flip Register 36 */
#define MC39_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00637eau)	/* Read Data and Bit Flip Register 37 */
#define MC39_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00637ecu)	/* Read Data and Bit Flip Register 38 */
#define MC39_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00637eeu)	/* Read Data and Bit Flip Register 39 */
#define MC39_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00637a8u)	/* Read Data and Bit Flip Register 4 */
#define MC39_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00637aau)	/* Read Data and Bit Flip Register 5 */
#define MC39_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00637acu)	/* Read Data and Bit Flip Register 6 */
#define MC39_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00637aeu)	/* Read Data and Bit Flip Register 7 */
#define MC39_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00637b0u)	/* Read Data and Bit Flip Register 8 */
#define MC39_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00637b2u)	/* Read Data and Bit Flip Register 9 */
#define MC3_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00613a0u)	/* Read Data and Bit Flip Register 0 */
#define MC3_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00613a2u)	/* Read Data and Bit Flip Register 1 */
#define MC3_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00613b4u)	/* Read Data and Bit Flip Register 10 */
#define MC3_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00613b6u)	/* Read Data and Bit Flip Register 11 */
#define MC3_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00613b8u)	/* Read Data and Bit Flip Register 12 */
#define MC3_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00613bau)	/* Read Data and Bit Flip Register 13 */
#define MC3_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00613bcu)	/* Read Data and Bit Flip Register 14 */
#define MC3_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00613beu)	/* Read Data and Bit Flip Register 15 */
#define MC3_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00613c0u)	/* Read Data and Bit Flip Register 16 */
#define MC3_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00613c2u)	/* Read Data and Bit Flip Register 17 */
#define MC3_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00613c4u)	/* Read Data and Bit Flip Register 18 */
#define MC3_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00613c6u)	/* Read Data and Bit Flip Register 19 */
#define MC3_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00613a4u)	/* Read Data and Bit Flip Register 2 */
#define MC3_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00613c8u)	/* Read Data and Bit Flip Register 20 */
#define MC3_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00613cau)	/* Read Data and Bit Flip Register 21 */
#define MC3_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00613ccu)	/* Read Data and Bit Flip Register 22 */
#define MC3_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00613ceu)	/* Read Data and Bit Flip Register 23 */
#define MC3_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00613d0u)	/* Read Data and Bit Flip Register 24 */
#define MC3_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00613d2u)	/* Read Data and Bit Flip Register 25 */
#define MC3_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00613d4u)	/* Read Data and Bit Flip Register 26 */
#define MC3_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00613d6u)	/* Read Data and Bit Flip Register 27 */
#define MC3_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00613d8u)	/* Read Data and Bit Flip Register 28 */
#define MC3_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00613dau)	/* Read Data and Bit Flip Register 29 */
#define MC3_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00613a6u)	/* Read Data and Bit Flip Register 3 */
#define MC3_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00613dcu)	/* Read Data and Bit Flip Register 30 */
#define MC3_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00613deu)	/* Read Data and Bit Flip Register 31 */
#define MC3_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00613e0u)	/* Read Data and Bit Flip Register 32 */
#define MC3_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00613e2u)	/* Read Data and Bit Flip Register 33 */
#define MC3_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00613e4u)	/* Read Data and Bit Flip Register 34 */
#define MC3_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00613e6u)	/* Read Data and Bit Flip Register 35 */
#define MC3_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00613e8u)	/* Read Data and Bit Flip Register 36 */
#define MC3_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00613eau)	/* Read Data and Bit Flip Register 37 */
#define MC3_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00613ecu)	/* Read Data and Bit Flip Register 38 */
#define MC3_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00613eeu)	/* Read Data and Bit Flip Register 39 */
#define MC3_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00613a8u)	/* Read Data and Bit Flip Register 4 */
#define MC3_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00613aau)	/* Read Data and Bit Flip Register 5 */
#define MC3_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00613acu)	/* Read Data and Bit Flip Register 6 */
#define MC3_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00613aeu)	/* Read Data and Bit Flip Register 7 */
#define MC3_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00613b0u)	/* Read Data and Bit Flip Register 8 */
#define MC3_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00613b2u)	/* Read Data and Bit Flip Register 9 */
#define MC40_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00638a0u)	/* Read Data and Bit Flip Register 0 */
#define MC40_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00638a2u)	/* Read Data and Bit Flip Register 1 */
#define MC40_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00638b4u)	/* Read Data and Bit Flip Register 10 */
#define MC40_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00638b6u)	/* Read Data and Bit Flip Register 11 */
#define MC40_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00638b8u)	/* Read Data and Bit Flip Register 12 */
#define MC40_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00638bau)	/* Read Data and Bit Flip Register 13 */
#define MC40_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00638bcu)	/* Read Data and Bit Flip Register 14 */
#define MC40_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00638beu)	/* Read Data and Bit Flip Register 15 */
#define MC40_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00638c0u)	/* Read Data and Bit Flip Register 16 */
#define MC40_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00638c2u)	/* Read Data and Bit Flip Register 17 */
#define MC40_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00638c4u)	/* Read Data and Bit Flip Register 18 */
#define MC40_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00638c6u)	/* Read Data and Bit Flip Register 19 */
#define MC40_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00638a4u)	/* Read Data and Bit Flip Register 2 */
#define MC40_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00638c8u)	/* Read Data and Bit Flip Register 20 */
#define MC40_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00638cau)	/* Read Data and Bit Flip Register 21 */
#define MC40_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00638ccu)	/* Read Data and Bit Flip Register 22 */
#define MC40_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00638ceu)	/* Read Data and Bit Flip Register 23 */
#define MC40_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00638d0u)	/* Read Data and Bit Flip Register 24 */
#define MC40_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00638d2u)	/* Read Data and Bit Flip Register 25 */
#define MC40_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00638d4u)	/* Read Data and Bit Flip Register 26 */
#define MC40_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00638d6u)	/* Read Data and Bit Flip Register 27 */
#define MC40_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00638d8u)	/* Read Data and Bit Flip Register 28 */
#define MC40_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00638dau)	/* Read Data and Bit Flip Register 29 */
#define MC40_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00638a6u)	/* Read Data and Bit Flip Register 3 */
#define MC40_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00638dcu)	/* Read Data and Bit Flip Register 30 */
#define MC40_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00638deu)	/* Read Data and Bit Flip Register 31 */
#define MC40_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00638e0u)	/* Read Data and Bit Flip Register 32 */
#define MC40_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00638e2u)	/* Read Data and Bit Flip Register 33 */
#define MC40_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00638e4u)	/* Read Data and Bit Flip Register 34 */
#define MC40_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00638e6u)	/* Read Data and Bit Flip Register 35 */
#define MC40_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00638e8u)	/* Read Data and Bit Flip Register 36 */
#define MC40_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00638eau)	/* Read Data and Bit Flip Register 37 */
#define MC40_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00638ecu)	/* Read Data and Bit Flip Register 38 */
#define MC40_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00638eeu)	/* Read Data and Bit Flip Register 39 */
#define MC40_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00638a8u)	/* Read Data and Bit Flip Register 4 */
#define MC40_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00638aau)	/* Read Data and Bit Flip Register 5 */
#define MC40_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00638acu)	/* Read Data and Bit Flip Register 6 */
#define MC40_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00638aeu)	/* Read Data and Bit Flip Register 7 */
#define MC40_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00638b0u)	/* Read Data and Bit Flip Register 8 */
#define MC40_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00638b2u)	/* Read Data and Bit Flip Register 9 */
#define MC41_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00639a0u)	/* Read Data and Bit Flip Register 0 */
#define MC41_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00639a2u)	/* Read Data and Bit Flip Register 1 */
#define MC41_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00639b4u)	/* Read Data and Bit Flip Register 10 */
#define MC41_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00639b6u)	/* Read Data and Bit Flip Register 11 */
#define MC41_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00639b8u)	/* Read Data and Bit Flip Register 12 */
#define MC41_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00639bau)	/* Read Data and Bit Flip Register 13 */
#define MC41_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00639bcu)	/* Read Data and Bit Flip Register 14 */
#define MC41_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00639beu)	/* Read Data and Bit Flip Register 15 */
#define MC41_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00639c0u)	/* Read Data and Bit Flip Register 16 */
#define MC41_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00639c2u)	/* Read Data and Bit Flip Register 17 */
#define MC41_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00639c4u)	/* Read Data and Bit Flip Register 18 */
#define MC41_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00639c6u)	/* Read Data and Bit Flip Register 19 */
#define MC41_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00639a4u)	/* Read Data and Bit Flip Register 2 */
#define MC41_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00639c8u)	/* Read Data and Bit Flip Register 20 */
#define MC41_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00639cau)	/* Read Data and Bit Flip Register 21 */
#define MC41_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00639ccu)	/* Read Data and Bit Flip Register 22 */
#define MC41_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00639ceu)	/* Read Data and Bit Flip Register 23 */
#define MC41_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00639d0u)	/* Read Data and Bit Flip Register 24 */
#define MC41_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00639d2u)	/* Read Data and Bit Flip Register 25 */
#define MC41_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00639d4u)	/* Read Data and Bit Flip Register 26 */
#define MC41_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00639d6u)	/* Read Data and Bit Flip Register 27 */
#define MC41_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00639d8u)	/* Read Data and Bit Flip Register 28 */
#define MC41_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00639dau)	/* Read Data and Bit Flip Register 29 */
#define MC41_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00639a6u)	/* Read Data and Bit Flip Register 3 */
#define MC41_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00639dcu)	/* Read Data and Bit Flip Register 30 */
#define MC41_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00639deu)	/* Read Data and Bit Flip Register 31 */
#define MC41_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00639e0u)	/* Read Data and Bit Flip Register 32 */
#define MC41_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00639e2u)	/* Read Data and Bit Flip Register 33 */
#define MC41_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00639e4u)	/* Read Data and Bit Flip Register 34 */
#define MC41_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00639e6u)	/* Read Data and Bit Flip Register 35 */
#define MC41_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00639e8u)	/* Read Data and Bit Flip Register 36 */
#define MC41_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00639eau)	/* Read Data and Bit Flip Register 37 */
#define MC41_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00639ecu)	/* Read Data and Bit Flip Register 38 */
#define MC41_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00639eeu)	/* Read Data and Bit Flip Register 39 */
#define MC41_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00639a8u)	/* Read Data and Bit Flip Register 4 */
#define MC41_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00639aau)	/* Read Data and Bit Flip Register 5 */
#define MC41_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00639acu)	/* Read Data and Bit Flip Register 6 */
#define MC41_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00639aeu)	/* Read Data and Bit Flip Register 7 */
#define MC41_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00639b0u)	/* Read Data and Bit Flip Register 8 */
#define MC41_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00639b2u)	/* Read Data and Bit Flip Register 9 */
#define MC42_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0063aa0u)	/* Read Data and Bit Flip Register 0 */
#define MC42_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0063aa2u)	/* Read Data and Bit Flip Register 1 */
#define MC42_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0063ab4u)	/* Read Data and Bit Flip Register 10 */
#define MC42_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0063ab6u)	/* Read Data and Bit Flip Register 11 */
#define MC42_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0063ab8u)	/* Read Data and Bit Flip Register 12 */
#define MC42_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0063abau)	/* Read Data and Bit Flip Register 13 */
#define MC42_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0063abcu)	/* Read Data and Bit Flip Register 14 */
#define MC42_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0063abeu)	/* Read Data and Bit Flip Register 15 */
#define MC42_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0063ac0u)	/* Read Data and Bit Flip Register 16 */
#define MC42_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0063ac2u)	/* Read Data and Bit Flip Register 17 */
#define MC42_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0063ac4u)	/* Read Data and Bit Flip Register 18 */
#define MC42_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0063ac6u)	/* Read Data and Bit Flip Register 19 */
#define MC42_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0063aa4u)	/* Read Data and Bit Flip Register 2 */
#define MC42_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0063ac8u)	/* Read Data and Bit Flip Register 20 */
#define MC42_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0063acau)	/* Read Data and Bit Flip Register 21 */
#define MC42_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0063accu)	/* Read Data and Bit Flip Register 22 */
#define MC42_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0063aceu)	/* Read Data and Bit Flip Register 23 */
#define MC42_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0063ad0u)	/* Read Data and Bit Flip Register 24 */
#define MC42_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0063ad2u)	/* Read Data and Bit Flip Register 25 */
#define MC42_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0063ad4u)	/* Read Data and Bit Flip Register 26 */
#define MC42_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0063ad6u)	/* Read Data and Bit Flip Register 27 */
#define MC42_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0063ad8u)	/* Read Data and Bit Flip Register 28 */
#define MC42_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0063adau)	/* Read Data and Bit Flip Register 29 */
#define MC42_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0063aa6u)	/* Read Data and Bit Flip Register 3 */
#define MC42_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0063adcu)	/* Read Data and Bit Flip Register 30 */
#define MC42_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0063adeu)	/* Read Data and Bit Flip Register 31 */
#define MC42_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0063ae0u)	/* Read Data and Bit Flip Register 32 */
#define MC42_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0063ae2u)	/* Read Data and Bit Flip Register 33 */
#define MC42_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0063ae4u)	/* Read Data and Bit Flip Register 34 */
#define MC42_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0063ae6u)	/* Read Data and Bit Flip Register 35 */
#define MC42_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0063ae8u)	/* Read Data and Bit Flip Register 36 */
#define MC42_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0063aeau)	/* Read Data and Bit Flip Register 37 */
#define MC42_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0063aecu)	/* Read Data and Bit Flip Register 38 */
#define MC42_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0063aeeu)	/* Read Data and Bit Flip Register 39 */
#define MC42_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0063aa8u)	/* Read Data and Bit Flip Register 4 */
#define MC42_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0063aaau)	/* Read Data and Bit Flip Register 5 */
#define MC42_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0063aacu)	/* Read Data and Bit Flip Register 6 */
#define MC42_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0063aaeu)	/* Read Data and Bit Flip Register 7 */
#define MC42_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0063ab0u)	/* Read Data and Bit Flip Register 8 */
#define MC42_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0063ab2u)	/* Read Data and Bit Flip Register 9 */
#define MC43_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0063ba0u)	/* Read Data and Bit Flip Register 0 */
#define MC43_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0063ba2u)	/* Read Data and Bit Flip Register 1 */
#define MC43_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0063bb4u)	/* Read Data and Bit Flip Register 10 */
#define MC43_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0063bb6u)	/* Read Data and Bit Flip Register 11 */
#define MC43_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0063bb8u)	/* Read Data and Bit Flip Register 12 */
#define MC43_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0063bbau)	/* Read Data and Bit Flip Register 13 */
#define MC43_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0063bbcu)	/* Read Data and Bit Flip Register 14 */
#define MC43_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0063bbeu)	/* Read Data and Bit Flip Register 15 */
#define MC43_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0063bc0u)	/* Read Data and Bit Flip Register 16 */
#define MC43_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0063bc2u)	/* Read Data and Bit Flip Register 17 */
#define MC43_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0063bc4u)	/* Read Data and Bit Flip Register 18 */
#define MC43_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0063bc6u)	/* Read Data and Bit Flip Register 19 */
#define MC43_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0063ba4u)	/* Read Data and Bit Flip Register 2 */
#define MC43_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0063bc8u)	/* Read Data and Bit Flip Register 20 */
#define MC43_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0063bcau)	/* Read Data and Bit Flip Register 21 */
#define MC43_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0063bccu)	/* Read Data and Bit Flip Register 22 */
#define MC43_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0063bceu)	/* Read Data and Bit Flip Register 23 */
#define MC43_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0063bd0u)	/* Read Data and Bit Flip Register 24 */
#define MC43_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0063bd2u)	/* Read Data and Bit Flip Register 25 */
#define MC43_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0063bd4u)	/* Read Data and Bit Flip Register 26 */
#define MC43_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0063bd6u)	/* Read Data and Bit Flip Register 27 */
#define MC43_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0063bd8u)	/* Read Data and Bit Flip Register 28 */
#define MC43_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0063bdau)	/* Read Data and Bit Flip Register 29 */
#define MC43_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0063ba6u)	/* Read Data and Bit Flip Register 3 */
#define MC43_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0063bdcu)	/* Read Data and Bit Flip Register 30 */
#define MC43_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0063bdeu)	/* Read Data and Bit Flip Register 31 */
#define MC43_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0063be0u)	/* Read Data and Bit Flip Register 32 */
#define MC43_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0063be2u)	/* Read Data and Bit Flip Register 33 */
#define MC43_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0063be4u)	/* Read Data and Bit Flip Register 34 */
#define MC43_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0063be6u)	/* Read Data and Bit Flip Register 35 */
#define MC43_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0063be8u)	/* Read Data and Bit Flip Register 36 */
#define MC43_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0063beau)	/* Read Data and Bit Flip Register 37 */
#define MC43_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0063becu)	/* Read Data and Bit Flip Register 38 */
#define MC43_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0063beeu)	/* Read Data and Bit Flip Register 39 */
#define MC43_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0063ba8u)	/* Read Data and Bit Flip Register 4 */
#define MC43_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0063baau)	/* Read Data and Bit Flip Register 5 */
#define MC43_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0063bacu)	/* Read Data and Bit Flip Register 6 */
#define MC43_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0063baeu)	/* Read Data and Bit Flip Register 7 */
#define MC43_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0063bb0u)	/* Read Data and Bit Flip Register 8 */
#define MC43_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0063bb2u)	/* Read Data and Bit Flip Register 9 */
#define MC44_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0063ca0u)	/* Read Data and Bit Flip Register 0 */
#define MC44_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0063ca2u)	/* Read Data and Bit Flip Register 1 */
#define MC44_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0063cb4u)	/* Read Data and Bit Flip Register 10 */
#define MC44_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0063cb6u)	/* Read Data and Bit Flip Register 11 */
#define MC44_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0063cb8u)	/* Read Data and Bit Flip Register 12 */
#define MC44_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0063cbau)	/* Read Data and Bit Flip Register 13 */
#define MC44_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0063cbcu)	/* Read Data and Bit Flip Register 14 */
#define MC44_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0063cbeu)	/* Read Data and Bit Flip Register 15 */
#define MC44_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0063cc0u)	/* Read Data and Bit Flip Register 16 */
#define MC44_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0063cc2u)	/* Read Data and Bit Flip Register 17 */
#define MC44_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0063cc4u)	/* Read Data and Bit Flip Register 18 */
#define MC44_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0063cc6u)	/* Read Data and Bit Flip Register 19 */
#define MC44_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0063ca4u)	/* Read Data and Bit Flip Register 2 */
#define MC44_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0063cc8u)	/* Read Data and Bit Flip Register 20 */
#define MC44_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0063ccau)	/* Read Data and Bit Flip Register 21 */
#define MC44_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0063cccu)	/* Read Data and Bit Flip Register 22 */
#define MC44_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0063cceu)	/* Read Data and Bit Flip Register 23 */
#define MC44_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0063cd0u)	/* Read Data and Bit Flip Register 24 */
#define MC44_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0063cd2u)	/* Read Data and Bit Flip Register 25 */
#define MC44_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0063cd4u)	/* Read Data and Bit Flip Register 26 */
#define MC44_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0063cd6u)	/* Read Data and Bit Flip Register 27 */
#define MC44_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0063cd8u)	/* Read Data and Bit Flip Register 28 */
#define MC44_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0063cdau)	/* Read Data and Bit Flip Register 29 */
#define MC44_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0063ca6u)	/* Read Data and Bit Flip Register 3 */
#define MC44_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0063cdcu)	/* Read Data and Bit Flip Register 30 */
#define MC44_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0063cdeu)	/* Read Data and Bit Flip Register 31 */
#define MC44_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0063ce0u)	/* Read Data and Bit Flip Register 32 */
#define MC44_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0063ce2u)	/* Read Data and Bit Flip Register 33 */
#define MC44_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0063ce4u)	/* Read Data and Bit Flip Register 34 */
#define MC44_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0063ce6u)	/* Read Data and Bit Flip Register 35 */
#define MC44_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0063ce8u)	/* Read Data and Bit Flip Register 36 */
#define MC44_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0063ceau)	/* Read Data and Bit Flip Register 37 */
#define MC44_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0063cecu)	/* Read Data and Bit Flip Register 38 */
#define MC44_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0063ceeu)	/* Read Data and Bit Flip Register 39 */
#define MC44_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0063ca8u)	/* Read Data and Bit Flip Register 4 */
#define MC44_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0063caau)	/* Read Data and Bit Flip Register 5 */
#define MC44_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0063cacu)	/* Read Data and Bit Flip Register 6 */
#define MC44_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0063caeu)	/* Read Data and Bit Flip Register 7 */
#define MC44_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0063cb0u)	/* Read Data and Bit Flip Register 8 */
#define MC44_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0063cb2u)	/* Read Data and Bit Flip Register 9 */
#define MC45_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0063da0u)	/* Read Data and Bit Flip Register 0 */
#define MC45_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0063da2u)	/* Read Data and Bit Flip Register 1 */
#define MC45_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0063db4u)	/* Read Data and Bit Flip Register 10 */
#define MC45_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0063db6u)	/* Read Data and Bit Flip Register 11 */
#define MC45_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0063db8u)	/* Read Data and Bit Flip Register 12 */
#define MC45_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0063dbau)	/* Read Data and Bit Flip Register 13 */
#define MC45_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0063dbcu)	/* Read Data and Bit Flip Register 14 */
#define MC45_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0063dbeu)	/* Read Data and Bit Flip Register 15 */
#define MC45_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0063dc0u)	/* Read Data and Bit Flip Register 16 */
#define MC45_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0063dc2u)	/* Read Data and Bit Flip Register 17 */
#define MC45_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0063dc4u)	/* Read Data and Bit Flip Register 18 */
#define MC45_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0063dc6u)	/* Read Data and Bit Flip Register 19 */
#define MC45_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0063da4u)	/* Read Data and Bit Flip Register 2 */
#define MC45_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0063dc8u)	/* Read Data and Bit Flip Register 20 */
#define MC45_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0063dcau)	/* Read Data and Bit Flip Register 21 */
#define MC45_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0063dccu)	/* Read Data and Bit Flip Register 22 */
#define MC45_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0063dceu)	/* Read Data and Bit Flip Register 23 */
#define MC45_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0063dd0u)	/* Read Data and Bit Flip Register 24 */
#define MC45_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0063dd2u)	/* Read Data and Bit Flip Register 25 */
#define MC45_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0063dd4u)	/* Read Data and Bit Flip Register 26 */
#define MC45_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0063dd6u)	/* Read Data and Bit Flip Register 27 */
#define MC45_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0063dd8u)	/* Read Data and Bit Flip Register 28 */
#define MC45_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0063ddau)	/* Read Data and Bit Flip Register 29 */
#define MC45_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0063da6u)	/* Read Data and Bit Flip Register 3 */
#define MC45_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0063ddcu)	/* Read Data and Bit Flip Register 30 */
#define MC45_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0063ddeu)	/* Read Data and Bit Flip Register 31 */
#define MC45_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0063de0u)	/* Read Data and Bit Flip Register 32 */
#define MC45_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0063de2u)	/* Read Data and Bit Flip Register 33 */
#define MC45_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0063de4u)	/* Read Data and Bit Flip Register 34 */
#define MC45_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0063de6u)	/* Read Data and Bit Flip Register 35 */
#define MC45_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0063de8u)	/* Read Data and Bit Flip Register 36 */
#define MC45_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0063deau)	/* Read Data and Bit Flip Register 37 */
#define MC45_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0063decu)	/* Read Data and Bit Flip Register 38 */
#define MC45_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0063deeu)	/* Read Data and Bit Flip Register 39 */
#define MC45_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0063da8u)	/* Read Data and Bit Flip Register 4 */
#define MC45_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0063daau)	/* Read Data and Bit Flip Register 5 */
#define MC45_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0063dacu)	/* Read Data and Bit Flip Register 6 */
#define MC45_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0063daeu)	/* Read Data and Bit Flip Register 7 */
#define MC45_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0063db0u)	/* Read Data and Bit Flip Register 8 */
#define MC45_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0063db2u)	/* Read Data and Bit Flip Register 9 */
#define MC46_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0063ea0u)	/* Read Data and Bit Flip Register 0 */
#define MC46_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0063ea2u)	/* Read Data and Bit Flip Register 1 */
#define MC46_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0063eb4u)	/* Read Data and Bit Flip Register 10 */
#define MC46_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0063eb6u)	/* Read Data and Bit Flip Register 11 */
#define MC46_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0063eb8u)	/* Read Data and Bit Flip Register 12 */
#define MC46_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0063ebau)	/* Read Data and Bit Flip Register 13 */
#define MC46_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0063ebcu)	/* Read Data and Bit Flip Register 14 */
#define MC46_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0063ebeu)	/* Read Data and Bit Flip Register 15 */
#define MC46_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0063ec0u)	/* Read Data and Bit Flip Register 16 */
#define MC46_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0063ec2u)	/* Read Data and Bit Flip Register 17 */
#define MC46_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0063ec4u)	/* Read Data and Bit Flip Register 18 */
#define MC46_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0063ec6u)	/* Read Data and Bit Flip Register 19 */
#define MC46_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0063ea4u)	/* Read Data and Bit Flip Register 2 */
#define MC46_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0063ec8u)	/* Read Data and Bit Flip Register 20 */
#define MC46_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0063ecau)	/* Read Data and Bit Flip Register 21 */
#define MC46_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0063eccu)	/* Read Data and Bit Flip Register 22 */
#define MC46_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0063eceu)	/* Read Data and Bit Flip Register 23 */
#define MC46_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0063ed0u)	/* Read Data and Bit Flip Register 24 */
#define MC46_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0063ed2u)	/* Read Data and Bit Flip Register 25 */
#define MC46_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0063ed4u)	/* Read Data and Bit Flip Register 26 */
#define MC46_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0063ed6u)	/* Read Data and Bit Flip Register 27 */
#define MC46_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0063ed8u)	/* Read Data and Bit Flip Register 28 */
#define MC46_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0063edau)	/* Read Data and Bit Flip Register 29 */
#define MC46_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0063ea6u)	/* Read Data and Bit Flip Register 3 */
#define MC46_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0063edcu)	/* Read Data and Bit Flip Register 30 */
#define MC46_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0063edeu)	/* Read Data and Bit Flip Register 31 */
#define MC46_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0063ee0u)	/* Read Data and Bit Flip Register 32 */
#define MC46_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0063ee2u)	/* Read Data and Bit Flip Register 33 */
#define MC46_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0063ee4u)	/* Read Data and Bit Flip Register 34 */
#define MC46_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0063ee6u)	/* Read Data and Bit Flip Register 35 */
#define MC46_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0063ee8u)	/* Read Data and Bit Flip Register 36 */
#define MC46_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0063eeau)	/* Read Data and Bit Flip Register 37 */
#define MC46_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0063eecu)	/* Read Data and Bit Flip Register 38 */
#define MC46_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0063eeeu)	/* Read Data and Bit Flip Register 39 */
#define MC46_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0063ea8u)	/* Read Data and Bit Flip Register 4 */
#define MC46_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0063eaau)	/* Read Data and Bit Flip Register 5 */
#define MC46_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0063eacu)	/* Read Data and Bit Flip Register 6 */
#define MC46_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0063eaeu)	/* Read Data and Bit Flip Register 7 */
#define MC46_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0063eb0u)	/* Read Data and Bit Flip Register 8 */
#define MC46_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0063eb2u)	/* Read Data and Bit Flip Register 9 */
#define MC47_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0063fa0u)	/* Read Data and Bit Flip Register 0 */
#define MC47_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0063fa2u)	/* Read Data and Bit Flip Register 1 */
#define MC47_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0063fb4u)	/* Read Data and Bit Flip Register 10 */
#define MC47_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0063fb6u)	/* Read Data and Bit Flip Register 11 */
#define MC47_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0063fb8u)	/* Read Data and Bit Flip Register 12 */
#define MC47_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0063fbau)	/* Read Data and Bit Flip Register 13 */
#define MC47_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0063fbcu)	/* Read Data and Bit Flip Register 14 */
#define MC47_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0063fbeu)	/* Read Data and Bit Flip Register 15 */
#define MC47_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0063fc0u)	/* Read Data and Bit Flip Register 16 */
#define MC47_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0063fc2u)	/* Read Data and Bit Flip Register 17 */
#define MC47_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0063fc4u)	/* Read Data and Bit Flip Register 18 */
#define MC47_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0063fc6u)	/* Read Data and Bit Flip Register 19 */
#define MC47_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0063fa4u)	/* Read Data and Bit Flip Register 2 */
#define MC47_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0063fc8u)	/* Read Data and Bit Flip Register 20 */
#define MC47_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0063fcau)	/* Read Data and Bit Flip Register 21 */
#define MC47_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0063fccu)	/* Read Data and Bit Flip Register 22 */
#define MC47_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0063fceu)	/* Read Data and Bit Flip Register 23 */
#define MC47_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0063fd0u)	/* Read Data and Bit Flip Register 24 */
#define MC47_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0063fd2u)	/* Read Data and Bit Flip Register 25 */
#define MC47_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0063fd4u)	/* Read Data and Bit Flip Register 26 */
#define MC47_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0063fd6u)	/* Read Data and Bit Flip Register 27 */
#define MC47_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0063fd8u)	/* Read Data and Bit Flip Register 28 */
#define MC47_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0063fdau)	/* Read Data and Bit Flip Register 29 */
#define MC47_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0063fa6u)	/* Read Data and Bit Flip Register 3 */
#define MC47_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0063fdcu)	/* Read Data and Bit Flip Register 30 */
#define MC47_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0063fdeu)	/* Read Data and Bit Flip Register 31 */
#define MC47_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0063fe0u)	/* Read Data and Bit Flip Register 32 */
#define MC47_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0063fe2u)	/* Read Data and Bit Flip Register 33 */
#define MC47_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0063fe4u)	/* Read Data and Bit Flip Register 34 */
#define MC47_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0063fe6u)	/* Read Data and Bit Flip Register 35 */
#define MC47_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0063fe8u)	/* Read Data and Bit Flip Register 36 */
#define MC47_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0063feau)	/* Read Data and Bit Flip Register 37 */
#define MC47_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0063fecu)	/* Read Data and Bit Flip Register 38 */
#define MC47_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0063feeu)	/* Read Data and Bit Flip Register 39 */
#define MC47_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0063fa8u)	/* Read Data and Bit Flip Register 4 */
#define MC47_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0063faau)	/* Read Data and Bit Flip Register 5 */
#define MC47_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0063facu)	/* Read Data and Bit Flip Register 6 */
#define MC47_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0063faeu)	/* Read Data and Bit Flip Register 7 */
#define MC47_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0063fb0u)	/* Read Data and Bit Flip Register 8 */
#define MC47_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0063fb2u)	/* Read Data and Bit Flip Register 9 */
#define MC48_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00640a0u)	/* Read Data and Bit Flip Register 0 */
#define MC48_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00640a2u)	/* Read Data and Bit Flip Register 1 */
#define MC48_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00640b4u)	/* Read Data and Bit Flip Register 10 */
#define MC48_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00640b6u)	/* Read Data and Bit Flip Register 11 */
#define MC48_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00640b8u)	/* Read Data and Bit Flip Register 12 */
#define MC48_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00640bau)	/* Read Data and Bit Flip Register 13 */
#define MC48_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00640bcu)	/* Read Data and Bit Flip Register 14 */
#define MC48_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00640beu)	/* Read Data and Bit Flip Register 15 */
#define MC48_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00640c0u)	/* Read Data and Bit Flip Register 16 */
#define MC48_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00640c2u)	/* Read Data and Bit Flip Register 17 */
#define MC48_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00640c4u)	/* Read Data and Bit Flip Register 18 */
#define MC48_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00640c6u)	/* Read Data and Bit Flip Register 19 */
#define MC48_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00640a4u)	/* Read Data and Bit Flip Register 2 */
#define MC48_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00640c8u)	/* Read Data and Bit Flip Register 20 */
#define MC48_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00640cau)	/* Read Data and Bit Flip Register 21 */
#define MC48_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00640ccu)	/* Read Data and Bit Flip Register 22 */
#define MC48_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00640ceu)	/* Read Data and Bit Flip Register 23 */
#define MC48_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00640d0u)	/* Read Data and Bit Flip Register 24 */
#define MC48_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00640d2u)	/* Read Data and Bit Flip Register 25 */
#define MC48_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00640d4u)	/* Read Data and Bit Flip Register 26 */
#define MC48_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00640d6u)	/* Read Data and Bit Flip Register 27 */
#define MC48_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00640d8u)	/* Read Data and Bit Flip Register 28 */
#define MC48_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00640dau)	/* Read Data and Bit Flip Register 29 */
#define MC48_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00640a6u)	/* Read Data and Bit Flip Register 3 */
#define MC48_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00640dcu)	/* Read Data and Bit Flip Register 30 */
#define MC48_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00640deu)	/* Read Data and Bit Flip Register 31 */
#define MC48_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00640e0u)	/* Read Data and Bit Flip Register 32 */
#define MC48_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00640e2u)	/* Read Data and Bit Flip Register 33 */
#define MC48_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00640e4u)	/* Read Data and Bit Flip Register 34 */
#define MC48_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00640e6u)	/* Read Data and Bit Flip Register 35 */
#define MC48_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00640e8u)	/* Read Data and Bit Flip Register 36 */
#define MC48_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00640eau)	/* Read Data and Bit Flip Register 37 */
#define MC48_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00640ecu)	/* Read Data and Bit Flip Register 38 */
#define MC48_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00640eeu)	/* Read Data and Bit Flip Register 39 */
#define MC48_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00640a8u)	/* Read Data and Bit Flip Register 4 */
#define MC48_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00640aau)	/* Read Data and Bit Flip Register 5 */
#define MC48_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00640acu)	/* Read Data and Bit Flip Register 6 */
#define MC48_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00640aeu)	/* Read Data and Bit Flip Register 7 */
#define MC48_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00640b0u)	/* Read Data and Bit Flip Register 8 */
#define MC48_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00640b2u)	/* Read Data and Bit Flip Register 9 */
#define MC49_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00641a0u)	/* Read Data and Bit Flip Register 0 */
#define MC49_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00641a2u)	/* Read Data and Bit Flip Register 1 */
#define MC49_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00641b4u)	/* Read Data and Bit Flip Register 10 */
#define MC49_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00641b6u)	/* Read Data and Bit Flip Register 11 */
#define MC49_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00641b8u)	/* Read Data and Bit Flip Register 12 */
#define MC49_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00641bau)	/* Read Data and Bit Flip Register 13 */
#define MC49_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00641bcu)	/* Read Data and Bit Flip Register 14 */
#define MC49_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00641beu)	/* Read Data and Bit Flip Register 15 */
#define MC49_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00641c0u)	/* Read Data and Bit Flip Register 16 */
#define MC49_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00641c2u)	/* Read Data and Bit Flip Register 17 */
#define MC49_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00641c4u)	/* Read Data and Bit Flip Register 18 */
#define MC49_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00641c6u)	/* Read Data and Bit Flip Register 19 */
#define MC49_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00641a4u)	/* Read Data and Bit Flip Register 2 */
#define MC49_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00641c8u)	/* Read Data and Bit Flip Register 20 */
#define MC49_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00641cau)	/* Read Data and Bit Flip Register 21 */
#define MC49_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00641ccu)	/* Read Data and Bit Flip Register 22 */
#define MC49_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00641ceu)	/* Read Data and Bit Flip Register 23 */
#define MC49_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00641d0u)	/* Read Data and Bit Flip Register 24 */
#define MC49_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00641d2u)	/* Read Data and Bit Flip Register 25 */
#define MC49_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00641d4u)	/* Read Data and Bit Flip Register 26 */
#define MC49_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00641d6u)	/* Read Data and Bit Flip Register 27 */
#define MC49_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00641d8u)	/* Read Data and Bit Flip Register 28 */
#define MC49_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00641dau)	/* Read Data and Bit Flip Register 29 */
#define MC49_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00641a6u)	/* Read Data and Bit Flip Register 3 */
#define MC49_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00641dcu)	/* Read Data and Bit Flip Register 30 */
#define MC49_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00641deu)	/* Read Data and Bit Flip Register 31 */
#define MC49_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00641e0u)	/* Read Data and Bit Flip Register 32 */
#define MC49_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00641e2u)	/* Read Data and Bit Flip Register 33 */
#define MC49_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00641e4u)	/* Read Data and Bit Flip Register 34 */
#define MC49_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00641e6u)	/* Read Data and Bit Flip Register 35 */
#define MC49_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00641e8u)	/* Read Data and Bit Flip Register 36 */
#define MC49_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00641eau)	/* Read Data and Bit Flip Register 37 */
#define MC49_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00641ecu)	/* Read Data and Bit Flip Register 38 */
#define MC49_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00641eeu)	/* Read Data and Bit Flip Register 39 */
#define MC49_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00641a8u)	/* Read Data and Bit Flip Register 4 */
#define MC49_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00641aau)	/* Read Data and Bit Flip Register 5 */
#define MC49_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00641acu)	/* Read Data and Bit Flip Register 6 */
#define MC49_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00641aeu)	/* Read Data and Bit Flip Register 7 */
#define MC49_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00641b0u)	/* Read Data and Bit Flip Register 8 */
#define MC49_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00641b2u)	/* Read Data and Bit Flip Register 9 */
#define MC4_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00614a0u)	/* Read Data and Bit Flip Register 0 */
#define MC4_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00614a2u)	/* Read Data and Bit Flip Register 1 */
#define MC4_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00614b4u)	/* Read Data and Bit Flip Register 10 */
#define MC4_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00614b6u)	/* Read Data and Bit Flip Register 11 */
#define MC4_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00614b8u)	/* Read Data and Bit Flip Register 12 */
#define MC4_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00614bau)	/* Read Data and Bit Flip Register 13 */
#define MC4_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00614bcu)	/* Read Data and Bit Flip Register 14 */
#define MC4_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00614beu)	/* Read Data and Bit Flip Register 15 */
#define MC4_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00614c0u)	/* Read Data and Bit Flip Register 16 */
#define MC4_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00614c2u)	/* Read Data and Bit Flip Register 17 */
#define MC4_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00614c4u)	/* Read Data and Bit Flip Register 18 */
#define MC4_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00614c6u)	/* Read Data and Bit Flip Register 19 */
#define MC4_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00614a4u)	/* Read Data and Bit Flip Register 2 */
#define MC4_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00614c8u)	/* Read Data and Bit Flip Register 20 */
#define MC4_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00614cau)	/* Read Data and Bit Flip Register 21 */
#define MC4_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00614ccu)	/* Read Data and Bit Flip Register 22 */
#define MC4_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00614ceu)	/* Read Data and Bit Flip Register 23 */
#define MC4_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00614d0u)	/* Read Data and Bit Flip Register 24 */
#define MC4_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00614d2u)	/* Read Data and Bit Flip Register 25 */
#define MC4_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00614d4u)	/* Read Data and Bit Flip Register 26 */
#define MC4_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00614d6u)	/* Read Data and Bit Flip Register 27 */
#define MC4_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00614d8u)	/* Read Data and Bit Flip Register 28 */
#define MC4_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00614dau)	/* Read Data and Bit Flip Register 29 */
#define MC4_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00614a6u)	/* Read Data and Bit Flip Register 3 */
#define MC4_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00614dcu)	/* Read Data and Bit Flip Register 30 */
#define MC4_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00614deu)	/* Read Data and Bit Flip Register 31 */
#define MC4_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00614e0u)	/* Read Data and Bit Flip Register 32 */
#define MC4_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00614e2u)	/* Read Data and Bit Flip Register 33 */
#define MC4_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00614e4u)	/* Read Data and Bit Flip Register 34 */
#define MC4_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00614e6u)	/* Read Data and Bit Flip Register 35 */
#define MC4_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00614e8u)	/* Read Data and Bit Flip Register 36 */
#define MC4_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00614eau)	/* Read Data and Bit Flip Register 37 */
#define MC4_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00614ecu)	/* Read Data and Bit Flip Register 38 */
#define MC4_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00614eeu)	/* Read Data and Bit Flip Register 39 */
#define MC4_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00614a8u)	/* Read Data and Bit Flip Register 4 */
#define MC4_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00614aau)	/* Read Data and Bit Flip Register 5 */
#define MC4_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00614acu)	/* Read Data and Bit Flip Register 6 */
#define MC4_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00614aeu)	/* Read Data and Bit Flip Register 7 */
#define MC4_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00614b0u)	/* Read Data and Bit Flip Register 8 */
#define MC4_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00614b2u)	/* Read Data and Bit Flip Register 9 */
#define MC50_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00642a0u)	/* Read Data and Bit Flip Register 0 */
#define MC50_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00642a2u)	/* Read Data and Bit Flip Register 1 */
#define MC50_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00642b4u)	/* Read Data and Bit Flip Register 10 */
#define MC50_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00642b6u)	/* Read Data and Bit Flip Register 11 */
#define MC50_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00642b8u)	/* Read Data and Bit Flip Register 12 */
#define MC50_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00642bau)	/* Read Data and Bit Flip Register 13 */
#define MC50_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00642bcu)	/* Read Data and Bit Flip Register 14 */
#define MC50_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00642beu)	/* Read Data and Bit Flip Register 15 */
#define MC50_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00642c0u)	/* Read Data and Bit Flip Register 16 */
#define MC50_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00642c2u)	/* Read Data and Bit Flip Register 17 */
#define MC50_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00642c4u)	/* Read Data and Bit Flip Register 18 */
#define MC50_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00642c6u)	/* Read Data and Bit Flip Register 19 */
#define MC50_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00642a4u)	/* Read Data and Bit Flip Register 2 */
#define MC50_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00642c8u)	/* Read Data and Bit Flip Register 20 */
#define MC50_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00642cau)	/* Read Data and Bit Flip Register 21 */
#define MC50_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00642ccu)	/* Read Data and Bit Flip Register 22 */
#define MC50_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00642ceu)	/* Read Data and Bit Flip Register 23 */
#define MC50_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00642d0u)	/* Read Data and Bit Flip Register 24 */
#define MC50_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00642d2u)	/* Read Data and Bit Flip Register 25 */
#define MC50_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00642d4u)	/* Read Data and Bit Flip Register 26 */
#define MC50_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00642d6u)	/* Read Data and Bit Flip Register 27 */
#define MC50_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00642d8u)	/* Read Data and Bit Flip Register 28 */
#define MC50_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00642dau)	/* Read Data and Bit Flip Register 29 */
#define MC50_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00642a6u)	/* Read Data and Bit Flip Register 3 */
#define MC50_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00642dcu)	/* Read Data and Bit Flip Register 30 */
#define MC50_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00642deu)	/* Read Data and Bit Flip Register 31 */
#define MC50_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00642e0u)	/* Read Data and Bit Flip Register 32 */
#define MC50_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00642e2u)	/* Read Data and Bit Flip Register 33 */
#define MC50_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00642e4u)	/* Read Data and Bit Flip Register 34 */
#define MC50_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00642e6u)	/* Read Data and Bit Flip Register 35 */
#define MC50_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00642e8u)	/* Read Data and Bit Flip Register 36 */
#define MC50_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00642eau)	/* Read Data and Bit Flip Register 37 */
#define MC50_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00642ecu)	/* Read Data and Bit Flip Register 38 */
#define MC50_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00642eeu)	/* Read Data and Bit Flip Register 39 */
#define MC50_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00642a8u)	/* Read Data and Bit Flip Register 4 */
#define MC50_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00642aau)	/* Read Data and Bit Flip Register 5 */
#define MC50_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00642acu)	/* Read Data and Bit Flip Register 6 */
#define MC50_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00642aeu)	/* Read Data and Bit Flip Register 7 */
#define MC50_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00642b0u)	/* Read Data and Bit Flip Register 8 */
#define MC50_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00642b2u)	/* Read Data and Bit Flip Register 9 */
#define MC51_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00643a0u)	/* Read Data and Bit Flip Register 0 */
#define MC51_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00643a2u)	/* Read Data and Bit Flip Register 1 */
#define MC51_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00643b4u)	/* Read Data and Bit Flip Register 10 */
#define MC51_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00643b6u)	/* Read Data and Bit Flip Register 11 */
#define MC51_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00643b8u)	/* Read Data and Bit Flip Register 12 */
#define MC51_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00643bau)	/* Read Data and Bit Flip Register 13 */
#define MC51_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00643bcu)	/* Read Data and Bit Flip Register 14 */
#define MC51_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00643beu)	/* Read Data and Bit Flip Register 15 */
#define MC51_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00643c0u)	/* Read Data and Bit Flip Register 16 */
#define MC51_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00643c2u)	/* Read Data and Bit Flip Register 17 */
#define MC51_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00643c4u)	/* Read Data and Bit Flip Register 18 */
#define MC51_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00643c6u)	/* Read Data and Bit Flip Register 19 */
#define MC51_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00643a4u)	/* Read Data and Bit Flip Register 2 */
#define MC51_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00643c8u)	/* Read Data and Bit Flip Register 20 */
#define MC51_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00643cau)	/* Read Data and Bit Flip Register 21 */
#define MC51_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00643ccu)	/* Read Data and Bit Flip Register 22 */
#define MC51_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00643ceu)	/* Read Data and Bit Flip Register 23 */
#define MC51_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00643d0u)	/* Read Data and Bit Flip Register 24 */
#define MC51_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00643d2u)	/* Read Data and Bit Flip Register 25 */
#define MC51_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00643d4u)	/* Read Data and Bit Flip Register 26 */
#define MC51_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00643d6u)	/* Read Data and Bit Flip Register 27 */
#define MC51_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00643d8u)	/* Read Data and Bit Flip Register 28 */
#define MC51_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00643dau)	/* Read Data and Bit Flip Register 29 */
#define MC51_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00643a6u)	/* Read Data and Bit Flip Register 3 */
#define MC51_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00643dcu)	/* Read Data and Bit Flip Register 30 */
#define MC51_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00643deu)	/* Read Data and Bit Flip Register 31 */
#define MC51_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00643e0u)	/* Read Data and Bit Flip Register 32 */
#define MC51_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00643e2u)	/* Read Data and Bit Flip Register 33 */
#define MC51_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00643e4u)	/* Read Data and Bit Flip Register 34 */
#define MC51_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00643e6u)	/* Read Data and Bit Flip Register 35 */
#define MC51_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00643e8u)	/* Read Data and Bit Flip Register 36 */
#define MC51_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00643eau)	/* Read Data and Bit Flip Register 37 */
#define MC51_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00643ecu)	/* Read Data and Bit Flip Register 38 */
#define MC51_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00643eeu)	/* Read Data and Bit Flip Register 39 */
#define MC51_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00643a8u)	/* Read Data and Bit Flip Register 4 */
#define MC51_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00643aau)	/* Read Data and Bit Flip Register 5 */
#define MC51_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00643acu)	/* Read Data and Bit Flip Register 6 */
#define MC51_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00643aeu)	/* Read Data and Bit Flip Register 7 */
#define MC51_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00643b0u)	/* Read Data and Bit Flip Register 8 */
#define MC51_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00643b2u)	/* Read Data and Bit Flip Register 9 */
#define MC52_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00644a0u)	/* Read Data and Bit Flip Register 0 */
#define MC52_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00644a2u)	/* Read Data and Bit Flip Register 1 */
#define MC52_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00644b4u)	/* Read Data and Bit Flip Register 10 */
#define MC52_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00644b6u)	/* Read Data and Bit Flip Register 11 */
#define MC52_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00644b8u)	/* Read Data and Bit Flip Register 12 */
#define MC52_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00644bau)	/* Read Data and Bit Flip Register 13 */
#define MC52_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00644bcu)	/* Read Data and Bit Flip Register 14 */
#define MC52_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00644beu)	/* Read Data and Bit Flip Register 15 */
#define MC52_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00644c0u)	/* Read Data and Bit Flip Register 16 */
#define MC52_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00644c2u)	/* Read Data and Bit Flip Register 17 */
#define MC52_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00644c4u)	/* Read Data and Bit Flip Register 18 */
#define MC52_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00644c6u)	/* Read Data and Bit Flip Register 19 */
#define MC52_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00644a4u)	/* Read Data and Bit Flip Register 2 */
#define MC52_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00644c8u)	/* Read Data and Bit Flip Register 20 */
#define MC52_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00644cau)	/* Read Data and Bit Flip Register 21 */
#define MC52_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00644ccu)	/* Read Data and Bit Flip Register 22 */
#define MC52_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00644ceu)	/* Read Data and Bit Flip Register 23 */
#define MC52_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00644d0u)	/* Read Data and Bit Flip Register 24 */
#define MC52_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00644d2u)	/* Read Data and Bit Flip Register 25 */
#define MC52_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00644d4u)	/* Read Data and Bit Flip Register 26 */
#define MC52_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00644d6u)	/* Read Data and Bit Flip Register 27 */
#define MC52_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00644d8u)	/* Read Data and Bit Flip Register 28 */
#define MC52_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00644dau)	/* Read Data and Bit Flip Register 29 */
#define MC52_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00644a6u)	/* Read Data and Bit Flip Register 3 */
#define MC52_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00644dcu)	/* Read Data and Bit Flip Register 30 */
#define MC52_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00644deu)	/* Read Data and Bit Flip Register 31 */
#define MC52_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00644e0u)	/* Read Data and Bit Flip Register 32 */
#define MC52_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00644e2u)	/* Read Data and Bit Flip Register 33 */
#define MC52_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00644e4u)	/* Read Data and Bit Flip Register 34 */
#define MC52_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00644e6u)	/* Read Data and Bit Flip Register 35 */
#define MC52_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00644e8u)	/* Read Data and Bit Flip Register 36 */
#define MC52_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00644eau)	/* Read Data and Bit Flip Register 37 */
#define MC52_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00644ecu)	/* Read Data and Bit Flip Register 38 */
#define MC52_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00644eeu)	/* Read Data and Bit Flip Register 39 */
#define MC52_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00644a8u)	/* Read Data and Bit Flip Register 4 */
#define MC52_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00644aau)	/* Read Data and Bit Flip Register 5 */
#define MC52_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00644acu)	/* Read Data and Bit Flip Register 6 */
#define MC52_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00644aeu)	/* Read Data and Bit Flip Register 7 */
#define MC52_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00644b0u)	/* Read Data and Bit Flip Register 8 */
#define MC52_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00644b2u)	/* Read Data and Bit Flip Register 9 */
#define MC53_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00645a0u)	/* Read Data and Bit Flip Register 0 */
#define MC53_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00645a2u)	/* Read Data and Bit Flip Register 1 */
#define MC53_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00645b4u)	/* Read Data and Bit Flip Register 10 */
#define MC53_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00645b6u)	/* Read Data and Bit Flip Register 11 */
#define MC53_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00645b8u)	/* Read Data and Bit Flip Register 12 */
#define MC53_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00645bau)	/* Read Data and Bit Flip Register 13 */
#define MC53_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00645bcu)	/* Read Data and Bit Flip Register 14 */
#define MC53_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00645beu)	/* Read Data and Bit Flip Register 15 */
#define MC53_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00645c0u)	/* Read Data and Bit Flip Register 16 */
#define MC53_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00645c2u)	/* Read Data and Bit Flip Register 17 */
#define MC53_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00645c4u)	/* Read Data and Bit Flip Register 18 */
#define MC53_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00645c6u)	/* Read Data and Bit Flip Register 19 */
#define MC53_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00645a4u)	/* Read Data and Bit Flip Register 2 */
#define MC53_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00645c8u)	/* Read Data and Bit Flip Register 20 */
#define MC53_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00645cau)	/* Read Data and Bit Flip Register 21 */
#define MC53_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00645ccu)	/* Read Data and Bit Flip Register 22 */
#define MC53_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00645ceu)	/* Read Data and Bit Flip Register 23 */
#define MC53_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00645d0u)	/* Read Data and Bit Flip Register 24 */
#define MC53_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00645d2u)	/* Read Data and Bit Flip Register 25 */
#define MC53_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00645d4u)	/* Read Data and Bit Flip Register 26 */
#define MC53_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00645d6u)	/* Read Data and Bit Flip Register 27 */
#define MC53_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00645d8u)	/* Read Data and Bit Flip Register 28 */
#define MC53_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00645dau)	/* Read Data and Bit Flip Register 29 */
#define MC53_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00645a6u)	/* Read Data and Bit Flip Register 3 */
#define MC53_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00645dcu)	/* Read Data and Bit Flip Register 30 */
#define MC53_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00645deu)	/* Read Data and Bit Flip Register 31 */
#define MC53_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00645e0u)	/* Read Data and Bit Flip Register 32 */
#define MC53_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00645e2u)	/* Read Data and Bit Flip Register 33 */
#define MC53_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00645e4u)	/* Read Data and Bit Flip Register 34 */
#define MC53_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00645e6u)	/* Read Data and Bit Flip Register 35 */
#define MC53_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00645e8u)	/* Read Data and Bit Flip Register 36 */
#define MC53_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00645eau)	/* Read Data and Bit Flip Register 37 */
#define MC53_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00645ecu)	/* Read Data and Bit Flip Register 38 */
#define MC53_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00645eeu)	/* Read Data and Bit Flip Register 39 */
#define MC53_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00645a8u)	/* Read Data and Bit Flip Register 4 */
#define MC53_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00645aau)	/* Read Data and Bit Flip Register 5 */
#define MC53_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00645acu)	/* Read Data and Bit Flip Register 6 */
#define MC53_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00645aeu)	/* Read Data and Bit Flip Register 7 */
#define MC53_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00645b0u)	/* Read Data and Bit Flip Register 8 */
#define MC53_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00645b2u)	/* Read Data and Bit Flip Register 9 */
#define MC54_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00646a0u)	/* Read Data and Bit Flip Register 0 */
#define MC54_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00646a2u)	/* Read Data and Bit Flip Register 1 */
#define MC54_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00646b4u)	/* Read Data and Bit Flip Register 10 */
#define MC54_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00646b6u)	/* Read Data and Bit Flip Register 11 */
#define MC54_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00646b8u)	/* Read Data and Bit Flip Register 12 */
#define MC54_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00646bau)	/* Read Data and Bit Flip Register 13 */
#define MC54_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00646bcu)	/* Read Data and Bit Flip Register 14 */
#define MC54_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00646beu)	/* Read Data and Bit Flip Register 15 */
#define MC54_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00646c0u)	/* Read Data and Bit Flip Register 16 */
#define MC54_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00646c2u)	/* Read Data and Bit Flip Register 17 */
#define MC54_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00646c4u)	/* Read Data and Bit Flip Register 18 */
#define MC54_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00646c6u)	/* Read Data and Bit Flip Register 19 */
#define MC54_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00646a4u)	/* Read Data and Bit Flip Register 2 */
#define MC54_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00646c8u)	/* Read Data and Bit Flip Register 20 */
#define MC54_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00646cau)	/* Read Data and Bit Flip Register 21 */
#define MC54_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00646ccu)	/* Read Data and Bit Flip Register 22 */
#define MC54_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00646ceu)	/* Read Data and Bit Flip Register 23 */
#define MC54_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00646d0u)	/* Read Data and Bit Flip Register 24 */
#define MC54_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00646d2u)	/* Read Data and Bit Flip Register 25 */
#define MC54_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00646d4u)	/* Read Data and Bit Flip Register 26 */
#define MC54_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00646d6u)	/* Read Data and Bit Flip Register 27 */
#define MC54_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00646d8u)	/* Read Data and Bit Flip Register 28 */
#define MC54_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00646dau)	/* Read Data and Bit Flip Register 29 */
#define MC54_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00646a6u)	/* Read Data and Bit Flip Register 3 */
#define MC54_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00646dcu)	/* Read Data and Bit Flip Register 30 */
#define MC54_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00646deu)	/* Read Data and Bit Flip Register 31 */
#define MC54_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00646e0u)	/* Read Data and Bit Flip Register 32 */
#define MC54_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00646e2u)	/* Read Data and Bit Flip Register 33 */
#define MC54_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00646e4u)	/* Read Data and Bit Flip Register 34 */
#define MC54_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00646e6u)	/* Read Data and Bit Flip Register 35 */
#define MC54_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00646e8u)	/* Read Data and Bit Flip Register 36 */
#define MC54_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00646eau)	/* Read Data and Bit Flip Register 37 */
#define MC54_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00646ecu)	/* Read Data and Bit Flip Register 38 */
#define MC54_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00646eeu)	/* Read Data and Bit Flip Register 39 */
#define MC54_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00646a8u)	/* Read Data and Bit Flip Register 4 */
#define MC54_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00646aau)	/* Read Data and Bit Flip Register 5 */
#define MC54_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00646acu)	/* Read Data and Bit Flip Register 6 */
#define MC54_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00646aeu)	/* Read Data and Bit Flip Register 7 */
#define MC54_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00646b0u)	/* Read Data and Bit Flip Register 8 */
#define MC54_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00646b2u)	/* Read Data and Bit Flip Register 9 */
#define MC55_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00647a0u)	/* Read Data and Bit Flip Register 0 */
#define MC55_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00647a2u)	/* Read Data and Bit Flip Register 1 */
#define MC55_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00647b4u)	/* Read Data and Bit Flip Register 10 */
#define MC55_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00647b6u)	/* Read Data and Bit Flip Register 11 */
#define MC55_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00647b8u)	/* Read Data and Bit Flip Register 12 */
#define MC55_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00647bau)	/* Read Data and Bit Flip Register 13 */
#define MC55_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00647bcu)	/* Read Data and Bit Flip Register 14 */
#define MC55_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00647beu)	/* Read Data and Bit Flip Register 15 */
#define MC55_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00647c0u)	/* Read Data and Bit Flip Register 16 */
#define MC55_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00647c2u)	/* Read Data and Bit Flip Register 17 */
#define MC55_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00647c4u)	/* Read Data and Bit Flip Register 18 */
#define MC55_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00647c6u)	/* Read Data and Bit Flip Register 19 */
#define MC55_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00647a4u)	/* Read Data and Bit Flip Register 2 */
#define MC55_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00647c8u)	/* Read Data and Bit Flip Register 20 */
#define MC55_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00647cau)	/* Read Data and Bit Flip Register 21 */
#define MC55_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00647ccu)	/* Read Data and Bit Flip Register 22 */
#define MC55_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00647ceu)	/* Read Data and Bit Flip Register 23 */
#define MC55_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00647d0u)	/* Read Data and Bit Flip Register 24 */
#define MC55_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00647d2u)	/* Read Data and Bit Flip Register 25 */
#define MC55_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00647d4u)	/* Read Data and Bit Flip Register 26 */
#define MC55_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00647d6u)	/* Read Data and Bit Flip Register 27 */
#define MC55_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00647d8u)	/* Read Data and Bit Flip Register 28 */
#define MC55_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00647dau)	/* Read Data and Bit Flip Register 29 */
#define MC55_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00647a6u)	/* Read Data and Bit Flip Register 3 */
#define MC55_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00647dcu)	/* Read Data and Bit Flip Register 30 */
#define MC55_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00647deu)	/* Read Data and Bit Flip Register 31 */
#define MC55_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00647e0u)	/* Read Data and Bit Flip Register 32 */
#define MC55_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00647e2u)	/* Read Data and Bit Flip Register 33 */
#define MC55_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00647e4u)	/* Read Data and Bit Flip Register 34 */
#define MC55_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00647e6u)	/* Read Data and Bit Flip Register 35 */
#define MC55_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00647e8u)	/* Read Data and Bit Flip Register 36 */
#define MC55_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00647eau)	/* Read Data and Bit Flip Register 37 */
#define MC55_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00647ecu)	/* Read Data and Bit Flip Register 38 */
#define MC55_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00647eeu)	/* Read Data and Bit Flip Register 39 */
#define MC55_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00647a8u)	/* Read Data and Bit Flip Register 4 */
#define MC55_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00647aau)	/* Read Data and Bit Flip Register 5 */
#define MC55_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00647acu)	/* Read Data and Bit Flip Register 6 */
#define MC55_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00647aeu)	/* Read Data and Bit Flip Register 7 */
#define MC55_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00647b0u)	/* Read Data and Bit Flip Register 8 */
#define MC55_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00647b2u)	/* Read Data and Bit Flip Register 9 */
#define MC56_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00648a0u)	/* Read Data and Bit Flip Register 0 */
#define MC56_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00648a2u)	/* Read Data and Bit Flip Register 1 */
#define MC56_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00648b4u)	/* Read Data and Bit Flip Register 10 */
#define MC56_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00648b6u)	/* Read Data and Bit Flip Register 11 */
#define MC56_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00648b8u)	/* Read Data and Bit Flip Register 12 */
#define MC56_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00648bau)	/* Read Data and Bit Flip Register 13 */
#define MC56_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00648bcu)	/* Read Data and Bit Flip Register 14 */
#define MC56_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00648beu)	/* Read Data and Bit Flip Register 15 */
#define MC56_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00648c0u)	/* Read Data and Bit Flip Register 16 */
#define MC56_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00648c2u)	/* Read Data and Bit Flip Register 17 */
#define MC56_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00648c4u)	/* Read Data and Bit Flip Register 18 */
#define MC56_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00648c6u)	/* Read Data and Bit Flip Register 19 */
#define MC56_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00648a4u)	/* Read Data and Bit Flip Register 2 */
#define MC56_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00648c8u)	/* Read Data and Bit Flip Register 20 */
#define MC56_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00648cau)	/* Read Data and Bit Flip Register 21 */
#define MC56_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00648ccu)	/* Read Data and Bit Flip Register 22 */
#define MC56_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00648ceu)	/* Read Data and Bit Flip Register 23 */
#define MC56_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00648d0u)	/* Read Data and Bit Flip Register 24 */
#define MC56_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00648d2u)	/* Read Data and Bit Flip Register 25 */
#define MC56_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00648d4u)	/* Read Data and Bit Flip Register 26 */
#define MC56_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00648d6u)	/* Read Data and Bit Flip Register 27 */
#define MC56_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00648d8u)	/* Read Data and Bit Flip Register 28 */
#define MC56_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00648dau)	/* Read Data and Bit Flip Register 29 */
#define MC56_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00648a6u)	/* Read Data and Bit Flip Register 3 */
#define MC56_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00648dcu)	/* Read Data and Bit Flip Register 30 */
#define MC56_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00648deu)	/* Read Data and Bit Flip Register 31 */
#define MC56_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00648e0u)	/* Read Data and Bit Flip Register 32 */
#define MC56_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00648e2u)	/* Read Data and Bit Flip Register 33 */
#define MC56_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00648e4u)	/* Read Data and Bit Flip Register 34 */
#define MC56_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00648e6u)	/* Read Data and Bit Flip Register 35 */
#define MC56_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00648e8u)	/* Read Data and Bit Flip Register 36 */
#define MC56_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00648eau)	/* Read Data and Bit Flip Register 37 */
#define MC56_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00648ecu)	/* Read Data and Bit Flip Register 38 */
#define MC56_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00648eeu)	/* Read Data and Bit Flip Register 39 */
#define MC56_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00648a8u)	/* Read Data and Bit Flip Register 4 */
#define MC56_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00648aau)	/* Read Data and Bit Flip Register 5 */
#define MC56_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00648acu)	/* Read Data and Bit Flip Register 6 */
#define MC56_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00648aeu)	/* Read Data and Bit Flip Register 7 */
#define MC56_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00648b0u)	/* Read Data and Bit Flip Register 8 */
#define MC56_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00648b2u)	/* Read Data and Bit Flip Register 9 */
#define MC57_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00649a0u)	/* Read Data and Bit Flip Register 0 */
#define MC57_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00649a2u)	/* Read Data and Bit Flip Register 1 */
#define MC57_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00649b4u)	/* Read Data and Bit Flip Register 10 */
#define MC57_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00649b6u)	/* Read Data and Bit Flip Register 11 */
#define MC57_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00649b8u)	/* Read Data and Bit Flip Register 12 */
#define MC57_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00649bau)	/* Read Data and Bit Flip Register 13 */
#define MC57_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00649bcu)	/* Read Data and Bit Flip Register 14 */
#define MC57_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00649beu)	/* Read Data and Bit Flip Register 15 */
#define MC57_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00649c0u)	/* Read Data and Bit Flip Register 16 */
#define MC57_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00649c2u)	/* Read Data and Bit Flip Register 17 */
#define MC57_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00649c4u)	/* Read Data and Bit Flip Register 18 */
#define MC57_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00649c6u)	/* Read Data and Bit Flip Register 19 */
#define MC57_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00649a4u)	/* Read Data and Bit Flip Register 2 */
#define MC57_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00649c8u)	/* Read Data and Bit Flip Register 20 */
#define MC57_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00649cau)	/* Read Data and Bit Flip Register 21 */
#define MC57_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00649ccu)	/* Read Data and Bit Flip Register 22 */
#define MC57_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00649ceu)	/* Read Data and Bit Flip Register 23 */
#define MC57_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00649d0u)	/* Read Data and Bit Flip Register 24 */
#define MC57_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00649d2u)	/* Read Data and Bit Flip Register 25 */
#define MC57_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00649d4u)	/* Read Data and Bit Flip Register 26 */
#define MC57_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00649d6u)	/* Read Data and Bit Flip Register 27 */
#define MC57_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00649d8u)	/* Read Data and Bit Flip Register 28 */
#define MC57_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00649dau)	/* Read Data and Bit Flip Register 29 */
#define MC57_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00649a6u)	/* Read Data and Bit Flip Register 3 */
#define MC57_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00649dcu)	/* Read Data and Bit Flip Register 30 */
#define MC57_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00649deu)	/* Read Data and Bit Flip Register 31 */
#define MC57_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00649e0u)	/* Read Data and Bit Flip Register 32 */
#define MC57_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00649e2u)	/* Read Data and Bit Flip Register 33 */
#define MC57_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00649e4u)	/* Read Data and Bit Flip Register 34 */
#define MC57_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00649e6u)	/* Read Data and Bit Flip Register 35 */
#define MC57_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00649e8u)	/* Read Data and Bit Flip Register 36 */
#define MC57_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00649eau)	/* Read Data and Bit Flip Register 37 */
#define MC57_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00649ecu)	/* Read Data and Bit Flip Register 38 */
#define MC57_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00649eeu)	/* Read Data and Bit Flip Register 39 */
#define MC57_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00649a8u)	/* Read Data and Bit Flip Register 4 */
#define MC57_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00649aau)	/* Read Data and Bit Flip Register 5 */
#define MC57_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00649acu)	/* Read Data and Bit Flip Register 6 */
#define MC57_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00649aeu)	/* Read Data and Bit Flip Register 7 */
#define MC57_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00649b0u)	/* Read Data and Bit Flip Register 8 */
#define MC57_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00649b2u)	/* Read Data and Bit Flip Register 9 */
#define MC58_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0064aa0u)	/* Read Data and Bit Flip Register 0 */
#define MC58_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0064aa2u)	/* Read Data and Bit Flip Register 1 */
#define MC58_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0064ab4u)	/* Read Data and Bit Flip Register 10 */
#define MC58_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0064ab6u)	/* Read Data and Bit Flip Register 11 */
#define MC58_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0064ab8u)	/* Read Data and Bit Flip Register 12 */
#define MC58_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0064abau)	/* Read Data and Bit Flip Register 13 */
#define MC58_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0064abcu)	/* Read Data and Bit Flip Register 14 */
#define MC58_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0064abeu)	/* Read Data and Bit Flip Register 15 */
#define MC58_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0064ac0u)	/* Read Data and Bit Flip Register 16 */
#define MC58_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0064ac2u)	/* Read Data and Bit Flip Register 17 */
#define MC58_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0064ac4u)	/* Read Data and Bit Flip Register 18 */
#define MC58_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0064ac6u)	/* Read Data and Bit Flip Register 19 */
#define MC58_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0064aa4u)	/* Read Data and Bit Flip Register 2 */
#define MC58_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0064ac8u)	/* Read Data and Bit Flip Register 20 */
#define MC58_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0064acau)	/* Read Data and Bit Flip Register 21 */
#define MC58_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0064accu)	/* Read Data and Bit Flip Register 22 */
#define MC58_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0064aceu)	/* Read Data and Bit Flip Register 23 */
#define MC58_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0064ad0u)	/* Read Data and Bit Flip Register 24 */
#define MC58_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0064ad2u)	/* Read Data and Bit Flip Register 25 */
#define MC58_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0064ad4u)	/* Read Data and Bit Flip Register 26 */
#define MC58_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0064ad6u)	/* Read Data and Bit Flip Register 27 */
#define MC58_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0064ad8u)	/* Read Data and Bit Flip Register 28 */
#define MC58_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0064adau)	/* Read Data and Bit Flip Register 29 */
#define MC58_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0064aa6u)	/* Read Data and Bit Flip Register 3 */
#define MC58_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0064adcu)	/* Read Data and Bit Flip Register 30 */
#define MC58_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0064adeu)	/* Read Data and Bit Flip Register 31 */
#define MC58_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0064ae0u)	/* Read Data and Bit Flip Register 32 */
#define MC58_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0064ae2u)	/* Read Data and Bit Flip Register 33 */
#define MC58_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0064ae4u)	/* Read Data and Bit Flip Register 34 */
#define MC58_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0064ae6u)	/* Read Data and Bit Flip Register 35 */
#define MC58_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0064ae8u)	/* Read Data and Bit Flip Register 36 */
#define MC58_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0064aeau)	/* Read Data and Bit Flip Register 37 */
#define MC58_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0064aecu)	/* Read Data and Bit Flip Register 38 */
#define MC58_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0064aeeu)	/* Read Data and Bit Flip Register 39 */
#define MC58_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0064aa8u)	/* Read Data and Bit Flip Register 4 */
#define MC58_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0064aaau)	/* Read Data and Bit Flip Register 5 */
#define MC58_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0064aacu)	/* Read Data and Bit Flip Register 6 */
#define MC58_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0064aaeu)	/* Read Data and Bit Flip Register 7 */
#define MC58_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0064ab0u)	/* Read Data and Bit Flip Register 8 */
#define MC58_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0064ab2u)	/* Read Data and Bit Flip Register 9 */
#define MC59_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0064ba0u)	/* Read Data and Bit Flip Register 0 */
#define MC59_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0064ba2u)	/* Read Data and Bit Flip Register 1 */
#define MC59_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0064bb4u)	/* Read Data and Bit Flip Register 10 */
#define MC59_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0064bb6u)	/* Read Data and Bit Flip Register 11 */
#define MC59_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0064bb8u)	/* Read Data and Bit Flip Register 12 */
#define MC59_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0064bbau)	/* Read Data and Bit Flip Register 13 */
#define MC59_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0064bbcu)	/* Read Data and Bit Flip Register 14 */
#define MC59_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0064bbeu)	/* Read Data and Bit Flip Register 15 */
#define MC59_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0064bc0u)	/* Read Data and Bit Flip Register 16 */
#define MC59_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0064bc2u)	/* Read Data and Bit Flip Register 17 */
#define MC59_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0064bc4u)	/* Read Data and Bit Flip Register 18 */
#define MC59_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0064bc6u)	/* Read Data and Bit Flip Register 19 */
#define MC59_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0064ba4u)	/* Read Data and Bit Flip Register 2 */
#define MC59_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0064bc8u)	/* Read Data and Bit Flip Register 20 */
#define MC59_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0064bcau)	/* Read Data and Bit Flip Register 21 */
#define MC59_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0064bccu)	/* Read Data and Bit Flip Register 22 */
#define MC59_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0064bceu)	/* Read Data and Bit Flip Register 23 */
#define MC59_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0064bd0u)	/* Read Data and Bit Flip Register 24 */
#define MC59_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0064bd2u)	/* Read Data and Bit Flip Register 25 */
#define MC59_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0064bd4u)	/* Read Data and Bit Flip Register 26 */
#define MC59_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0064bd6u)	/* Read Data and Bit Flip Register 27 */
#define MC59_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0064bd8u)	/* Read Data and Bit Flip Register 28 */
#define MC59_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0064bdau)	/* Read Data and Bit Flip Register 29 */
#define MC59_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0064ba6u)	/* Read Data and Bit Flip Register 3 */
#define MC59_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0064bdcu)	/* Read Data and Bit Flip Register 30 */
#define MC59_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0064bdeu)	/* Read Data and Bit Flip Register 31 */
#define MC59_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0064be0u)	/* Read Data and Bit Flip Register 32 */
#define MC59_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0064be2u)	/* Read Data and Bit Flip Register 33 */
#define MC59_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0064be4u)	/* Read Data and Bit Flip Register 34 */
#define MC59_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0064be6u)	/* Read Data and Bit Flip Register 35 */
#define MC59_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0064be8u)	/* Read Data and Bit Flip Register 36 */
#define MC59_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0064beau)	/* Read Data and Bit Flip Register 37 */
#define MC59_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0064becu)	/* Read Data and Bit Flip Register 38 */
#define MC59_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0064beeu)	/* Read Data and Bit Flip Register 39 */
#define MC59_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0064ba8u)	/* Read Data and Bit Flip Register 4 */
#define MC59_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0064baau)	/* Read Data and Bit Flip Register 5 */
#define MC59_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0064bacu)	/* Read Data and Bit Flip Register 6 */
#define MC59_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0064baeu)	/* Read Data and Bit Flip Register 7 */
#define MC59_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0064bb0u)	/* Read Data and Bit Flip Register 8 */
#define MC59_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0064bb2u)	/* Read Data and Bit Flip Register 9 */
#define MC5_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00615a0u)	/* Read Data and Bit Flip Register 0 */
#define MC5_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00615a2u)	/* Read Data and Bit Flip Register 1 */
#define MC5_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00615b4u)	/* Read Data and Bit Flip Register 10 */
#define MC5_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00615b6u)	/* Read Data and Bit Flip Register 11 */
#define MC5_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00615b8u)	/* Read Data and Bit Flip Register 12 */
#define MC5_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00615bau)	/* Read Data and Bit Flip Register 13 */
#define MC5_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00615bcu)	/* Read Data and Bit Flip Register 14 */
#define MC5_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00615beu)	/* Read Data and Bit Flip Register 15 */
#define MC5_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00615c0u)	/* Read Data and Bit Flip Register 16 */
#define MC5_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00615c2u)	/* Read Data and Bit Flip Register 17 */
#define MC5_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00615c4u)	/* Read Data and Bit Flip Register 18 */
#define MC5_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00615c6u)	/* Read Data and Bit Flip Register 19 */
#define MC5_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00615a4u)	/* Read Data and Bit Flip Register 2 */
#define MC5_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00615c8u)	/* Read Data and Bit Flip Register 20 */
#define MC5_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00615cau)	/* Read Data and Bit Flip Register 21 */
#define MC5_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00615ccu)	/* Read Data and Bit Flip Register 22 */
#define MC5_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00615ceu)	/* Read Data and Bit Flip Register 23 */
#define MC5_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00615d0u)	/* Read Data and Bit Flip Register 24 */
#define MC5_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00615d2u)	/* Read Data and Bit Flip Register 25 */
#define MC5_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00615d4u)	/* Read Data and Bit Flip Register 26 */
#define MC5_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00615d6u)	/* Read Data and Bit Flip Register 27 */
#define MC5_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00615d8u)	/* Read Data and Bit Flip Register 28 */
#define MC5_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00615dau)	/* Read Data and Bit Flip Register 29 */
#define MC5_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00615a6u)	/* Read Data and Bit Flip Register 3 */
#define MC5_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00615dcu)	/* Read Data and Bit Flip Register 30 */
#define MC5_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00615deu)	/* Read Data and Bit Flip Register 31 */
#define MC5_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00615e0u)	/* Read Data and Bit Flip Register 32 */
#define MC5_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00615e2u)	/* Read Data and Bit Flip Register 33 */
#define MC5_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00615e4u)	/* Read Data and Bit Flip Register 34 */
#define MC5_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00615e6u)	/* Read Data and Bit Flip Register 35 */
#define MC5_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00615e8u)	/* Read Data and Bit Flip Register 36 */
#define MC5_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00615eau)	/* Read Data and Bit Flip Register 37 */
#define MC5_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00615ecu)	/* Read Data and Bit Flip Register 38 */
#define MC5_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00615eeu)	/* Read Data and Bit Flip Register 39 */
#define MC5_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00615a8u)	/* Read Data and Bit Flip Register 4 */
#define MC5_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00615aau)	/* Read Data and Bit Flip Register 5 */
#define MC5_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00615acu)	/* Read Data and Bit Flip Register 6 */
#define MC5_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00615aeu)	/* Read Data and Bit Flip Register 7 */
#define MC5_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00615b0u)	/* Read Data and Bit Flip Register 8 */
#define MC5_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00615b2u)	/* Read Data and Bit Flip Register 9 */
#define MC60_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0064ca0u)	/* Read Data and Bit Flip Register 0 */
#define MC60_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0064ca2u)	/* Read Data and Bit Flip Register 1 */
#define MC60_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0064cb4u)	/* Read Data and Bit Flip Register 10 */
#define MC60_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0064cb6u)	/* Read Data and Bit Flip Register 11 */
#define MC60_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0064cb8u)	/* Read Data and Bit Flip Register 12 */
#define MC60_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0064cbau)	/* Read Data and Bit Flip Register 13 */
#define MC60_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0064cbcu)	/* Read Data and Bit Flip Register 14 */
#define MC60_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0064cbeu)	/* Read Data and Bit Flip Register 15 */
#define MC60_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0064cc0u)	/* Read Data and Bit Flip Register 16 */
#define MC60_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0064cc2u)	/* Read Data and Bit Flip Register 17 */
#define MC60_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0064cc4u)	/* Read Data and Bit Flip Register 18 */
#define MC60_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0064cc6u)	/* Read Data and Bit Flip Register 19 */
#define MC60_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0064ca4u)	/* Read Data and Bit Flip Register 2 */
#define MC60_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0064cc8u)	/* Read Data and Bit Flip Register 20 */
#define MC60_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0064ccau)	/* Read Data and Bit Flip Register 21 */
#define MC60_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0064cccu)	/* Read Data and Bit Flip Register 22 */
#define MC60_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0064cceu)	/* Read Data and Bit Flip Register 23 */
#define MC60_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0064cd0u)	/* Read Data and Bit Flip Register 24 */
#define MC60_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0064cd2u)	/* Read Data and Bit Flip Register 25 */
#define MC60_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0064cd4u)	/* Read Data and Bit Flip Register 26 */
#define MC60_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0064cd6u)	/* Read Data and Bit Flip Register 27 */
#define MC60_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0064cd8u)	/* Read Data and Bit Flip Register 28 */
#define MC60_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0064cdau)	/* Read Data and Bit Flip Register 29 */
#define MC60_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0064ca6u)	/* Read Data and Bit Flip Register 3 */
#define MC60_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0064cdcu)	/* Read Data and Bit Flip Register 30 */
#define MC60_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0064cdeu)	/* Read Data and Bit Flip Register 31 */
#define MC60_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0064ce0u)	/* Read Data and Bit Flip Register 32 */
#define MC60_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0064ce2u)	/* Read Data and Bit Flip Register 33 */
#define MC60_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0064ce4u)	/* Read Data and Bit Flip Register 34 */
#define MC60_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0064ce6u)	/* Read Data and Bit Flip Register 35 */
#define MC60_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0064ce8u)	/* Read Data and Bit Flip Register 36 */
#define MC60_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0064ceau)	/* Read Data and Bit Flip Register 37 */
#define MC60_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0064cecu)	/* Read Data and Bit Flip Register 38 */
#define MC60_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0064ceeu)	/* Read Data and Bit Flip Register 39 */
#define MC60_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0064ca8u)	/* Read Data and Bit Flip Register 4 */
#define MC60_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0064caau)	/* Read Data and Bit Flip Register 5 */
#define MC60_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0064cacu)	/* Read Data and Bit Flip Register 6 */
#define MC60_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0064caeu)	/* Read Data and Bit Flip Register 7 */
#define MC60_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0064cb0u)	/* Read Data and Bit Flip Register 8 */
#define MC60_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0064cb2u)	/* Read Data and Bit Flip Register 9 */
#define MC61_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0064da0u)	/* Read Data and Bit Flip Register 0 */
#define MC61_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0064da2u)	/* Read Data and Bit Flip Register 1 */
#define MC61_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0064db4u)	/* Read Data and Bit Flip Register 10 */
#define MC61_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0064db6u)	/* Read Data and Bit Flip Register 11 */
#define MC61_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0064db8u)	/* Read Data and Bit Flip Register 12 */
#define MC61_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0064dbau)	/* Read Data and Bit Flip Register 13 */
#define MC61_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0064dbcu)	/* Read Data and Bit Flip Register 14 */
#define MC61_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0064dbeu)	/* Read Data and Bit Flip Register 15 */
#define MC61_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0064dc0u)	/* Read Data and Bit Flip Register 16 */
#define MC61_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0064dc2u)	/* Read Data and Bit Flip Register 17 */
#define MC61_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0064dc4u)	/* Read Data and Bit Flip Register 18 */
#define MC61_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0064dc6u)	/* Read Data and Bit Flip Register 19 */
#define MC61_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0064da4u)	/* Read Data and Bit Flip Register 2 */
#define MC61_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0064dc8u)	/* Read Data and Bit Flip Register 20 */
#define MC61_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0064dcau)	/* Read Data and Bit Flip Register 21 */
#define MC61_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0064dccu)	/* Read Data and Bit Flip Register 22 */
#define MC61_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0064dceu)	/* Read Data and Bit Flip Register 23 */
#define MC61_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0064dd0u)	/* Read Data and Bit Flip Register 24 */
#define MC61_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0064dd2u)	/* Read Data and Bit Flip Register 25 */
#define MC61_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0064dd4u)	/* Read Data and Bit Flip Register 26 */
#define MC61_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0064dd6u)	/* Read Data and Bit Flip Register 27 */
#define MC61_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0064dd8u)	/* Read Data and Bit Flip Register 28 */
#define MC61_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0064ddau)	/* Read Data and Bit Flip Register 29 */
#define MC61_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0064da6u)	/* Read Data and Bit Flip Register 3 */
#define MC61_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0064ddcu)	/* Read Data and Bit Flip Register 30 */
#define MC61_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0064ddeu)	/* Read Data and Bit Flip Register 31 */
#define MC61_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0064de0u)	/* Read Data and Bit Flip Register 32 */
#define MC61_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0064de2u)	/* Read Data and Bit Flip Register 33 */
#define MC61_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0064de4u)	/* Read Data and Bit Flip Register 34 */
#define MC61_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0064de6u)	/* Read Data and Bit Flip Register 35 */
#define MC61_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0064de8u)	/* Read Data and Bit Flip Register 36 */
#define MC61_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0064deau)	/* Read Data and Bit Flip Register 37 */
#define MC61_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0064decu)	/* Read Data and Bit Flip Register 38 */
#define MC61_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0064deeu)	/* Read Data and Bit Flip Register 39 */
#define MC61_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0064da8u)	/* Read Data and Bit Flip Register 4 */
#define MC61_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0064daau)	/* Read Data and Bit Flip Register 5 */
#define MC61_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0064dacu)	/* Read Data and Bit Flip Register 6 */
#define MC61_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0064daeu)	/* Read Data and Bit Flip Register 7 */
#define MC61_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0064db0u)	/* Read Data and Bit Flip Register 8 */
#define MC61_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0064db2u)	/* Read Data and Bit Flip Register 9 */
#define MC62_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0064ea0u)	/* Read Data and Bit Flip Register 0 */
#define MC62_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0064ea2u)	/* Read Data and Bit Flip Register 1 */
#define MC62_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0064eb4u)	/* Read Data and Bit Flip Register 10 */
#define MC62_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0064eb6u)	/* Read Data and Bit Flip Register 11 */
#define MC62_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0064eb8u)	/* Read Data and Bit Flip Register 12 */
#define MC62_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0064ebau)	/* Read Data and Bit Flip Register 13 */
#define MC62_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0064ebcu)	/* Read Data and Bit Flip Register 14 */
#define MC62_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0064ebeu)	/* Read Data and Bit Flip Register 15 */
#define MC62_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0064ec0u)	/* Read Data and Bit Flip Register 16 */
#define MC62_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0064ec2u)	/* Read Data and Bit Flip Register 17 */
#define MC62_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0064ec4u)	/* Read Data and Bit Flip Register 18 */
#define MC62_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0064ec6u)	/* Read Data and Bit Flip Register 19 */
#define MC62_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0064ea4u)	/* Read Data and Bit Flip Register 2 */
#define MC62_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0064ec8u)	/* Read Data and Bit Flip Register 20 */
#define MC62_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0064ecau)	/* Read Data and Bit Flip Register 21 */
#define MC62_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0064eccu)	/* Read Data and Bit Flip Register 22 */
#define MC62_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0064eceu)	/* Read Data and Bit Flip Register 23 */
#define MC62_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0064ed0u)	/* Read Data and Bit Flip Register 24 */
#define MC62_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0064ed2u)	/* Read Data and Bit Flip Register 25 */
#define MC62_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0064ed4u)	/* Read Data and Bit Flip Register 26 */
#define MC62_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0064ed6u)	/* Read Data and Bit Flip Register 27 */
#define MC62_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0064ed8u)	/* Read Data and Bit Flip Register 28 */
#define MC62_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0064edau)	/* Read Data and Bit Flip Register 29 */
#define MC62_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0064ea6u)	/* Read Data and Bit Flip Register 3 */
#define MC62_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0064edcu)	/* Read Data and Bit Flip Register 30 */
#define MC62_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0064edeu)	/* Read Data and Bit Flip Register 31 */
#define MC62_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0064ee0u)	/* Read Data and Bit Flip Register 32 */
#define MC62_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0064ee2u)	/* Read Data and Bit Flip Register 33 */
#define MC62_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0064ee4u)	/* Read Data and Bit Flip Register 34 */
#define MC62_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0064ee6u)	/* Read Data and Bit Flip Register 35 */
#define MC62_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0064ee8u)	/* Read Data and Bit Flip Register 36 */
#define MC62_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0064eeau)	/* Read Data and Bit Flip Register 37 */
#define MC62_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0064eecu)	/* Read Data and Bit Flip Register 38 */
#define MC62_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0064eeeu)	/* Read Data and Bit Flip Register 39 */
#define MC62_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0064ea8u)	/* Read Data and Bit Flip Register 4 */
#define MC62_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0064eaau)	/* Read Data and Bit Flip Register 5 */
#define MC62_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0064eacu)	/* Read Data and Bit Flip Register 6 */
#define MC62_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0064eaeu)	/* Read Data and Bit Flip Register 7 */
#define MC62_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0064eb0u)	/* Read Data and Bit Flip Register 8 */
#define MC62_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0064eb2u)	/* Read Data and Bit Flip Register 9 */
#define MC63_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0064fa0u)	/* Read Data and Bit Flip Register 0 */
#define MC63_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0064fa2u)	/* Read Data and Bit Flip Register 1 */
#define MC63_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0064fb4u)	/* Read Data and Bit Flip Register 10 */
#define MC63_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0064fb6u)	/* Read Data and Bit Flip Register 11 */
#define MC63_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0064fb8u)	/* Read Data and Bit Flip Register 12 */
#define MC63_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0064fbau)	/* Read Data and Bit Flip Register 13 */
#define MC63_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0064fbcu)	/* Read Data and Bit Flip Register 14 */
#define MC63_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0064fbeu)	/* Read Data and Bit Flip Register 15 */
#define MC63_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0064fc0u)	/* Read Data and Bit Flip Register 16 */
#define MC63_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0064fc2u)	/* Read Data and Bit Flip Register 17 */
#define MC63_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0064fc4u)	/* Read Data and Bit Flip Register 18 */
#define MC63_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0064fc6u)	/* Read Data and Bit Flip Register 19 */
#define MC63_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0064fa4u)	/* Read Data and Bit Flip Register 2 */
#define MC63_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0064fc8u)	/* Read Data and Bit Flip Register 20 */
#define MC63_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0064fcau)	/* Read Data and Bit Flip Register 21 */
#define MC63_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0064fccu)	/* Read Data and Bit Flip Register 22 */
#define MC63_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0064fceu)	/* Read Data and Bit Flip Register 23 */
#define MC63_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0064fd0u)	/* Read Data and Bit Flip Register 24 */
#define MC63_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0064fd2u)	/* Read Data and Bit Flip Register 25 */
#define MC63_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0064fd4u)	/* Read Data and Bit Flip Register 26 */
#define MC63_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0064fd6u)	/* Read Data and Bit Flip Register 27 */
#define MC63_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0064fd8u)	/* Read Data and Bit Flip Register 28 */
#define MC63_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0064fdau)	/* Read Data and Bit Flip Register 29 */
#define MC63_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0064fa6u)	/* Read Data and Bit Flip Register 3 */
#define MC63_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0064fdcu)	/* Read Data and Bit Flip Register 30 */
#define MC63_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0064fdeu)	/* Read Data and Bit Flip Register 31 */
#define MC63_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0064fe0u)	/* Read Data and Bit Flip Register 32 */
#define MC63_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0064fe2u)	/* Read Data and Bit Flip Register 33 */
#define MC63_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0064fe4u)	/* Read Data and Bit Flip Register 34 */
#define MC63_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0064fe6u)	/* Read Data and Bit Flip Register 35 */
#define MC63_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0064fe8u)	/* Read Data and Bit Flip Register 36 */
#define MC63_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0064feau)	/* Read Data and Bit Flip Register 37 */
#define MC63_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0064fecu)	/* Read Data and Bit Flip Register 38 */
#define MC63_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0064feeu)	/* Read Data and Bit Flip Register 39 */
#define MC63_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0064fa8u)	/* Read Data and Bit Flip Register 4 */
#define MC63_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0064faau)	/* Read Data and Bit Flip Register 5 */
#define MC63_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0064facu)	/* Read Data and Bit Flip Register 6 */
#define MC63_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0064faeu)	/* Read Data and Bit Flip Register 7 */
#define MC63_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0064fb0u)	/* Read Data and Bit Flip Register 8 */
#define MC63_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0064fb2u)	/* Read Data and Bit Flip Register 9 */
#define MC64_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00650a0u)	/* Read Data and Bit Flip Register 0 */
#define MC64_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00650a2u)	/* Read Data and Bit Flip Register 1 */
#define MC64_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00650b4u)	/* Read Data and Bit Flip Register 10 */
#define MC64_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00650b6u)	/* Read Data and Bit Flip Register 11 */
#define MC64_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00650b8u)	/* Read Data and Bit Flip Register 12 */
#define MC64_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00650bau)	/* Read Data and Bit Flip Register 13 */
#define MC64_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00650bcu)	/* Read Data and Bit Flip Register 14 */
#define MC64_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00650beu)	/* Read Data and Bit Flip Register 15 */
#define MC64_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00650c0u)	/* Read Data and Bit Flip Register 16 */
#define MC64_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00650c2u)	/* Read Data and Bit Flip Register 17 */
#define MC64_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00650c4u)	/* Read Data and Bit Flip Register 18 */
#define MC64_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00650c6u)	/* Read Data and Bit Flip Register 19 */
#define MC64_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00650a4u)	/* Read Data and Bit Flip Register 2 */
#define MC64_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00650c8u)	/* Read Data and Bit Flip Register 20 */
#define MC64_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00650cau)	/* Read Data and Bit Flip Register 21 */
#define MC64_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00650ccu)	/* Read Data and Bit Flip Register 22 */
#define MC64_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00650ceu)	/* Read Data and Bit Flip Register 23 */
#define MC64_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00650d0u)	/* Read Data and Bit Flip Register 24 */
#define MC64_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00650d2u)	/* Read Data and Bit Flip Register 25 */
#define MC64_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00650d4u)	/* Read Data and Bit Flip Register 26 */
#define MC64_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00650d6u)	/* Read Data and Bit Flip Register 27 */
#define MC64_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00650d8u)	/* Read Data and Bit Flip Register 28 */
#define MC64_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00650dau)	/* Read Data and Bit Flip Register 29 */
#define MC64_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00650a6u)	/* Read Data and Bit Flip Register 3 */
#define MC64_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00650dcu)	/* Read Data and Bit Flip Register 30 */
#define MC64_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00650deu)	/* Read Data and Bit Flip Register 31 */
#define MC64_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00650e0u)	/* Read Data and Bit Flip Register 32 */
#define MC64_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00650e2u)	/* Read Data and Bit Flip Register 33 */
#define MC64_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00650e4u)	/* Read Data and Bit Flip Register 34 */
#define MC64_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00650e6u)	/* Read Data and Bit Flip Register 35 */
#define MC64_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00650e8u)	/* Read Data and Bit Flip Register 36 */
#define MC64_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00650eau)	/* Read Data and Bit Flip Register 37 */
#define MC64_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00650ecu)	/* Read Data and Bit Flip Register 38 */
#define MC64_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00650eeu)	/* Read Data and Bit Flip Register 39 */
#define MC64_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00650a8u)	/* Read Data and Bit Flip Register 4 */
#define MC64_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00650aau)	/* Read Data and Bit Flip Register 5 */
#define MC64_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00650acu)	/* Read Data and Bit Flip Register 6 */
#define MC64_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00650aeu)	/* Read Data and Bit Flip Register 7 */
#define MC64_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00650b0u)	/* Read Data and Bit Flip Register 8 */
#define MC64_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00650b2u)	/* Read Data and Bit Flip Register 9 */
#define MC65_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00651a0u)	/* Read Data and Bit Flip Register 0 */
#define MC65_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00651a2u)	/* Read Data and Bit Flip Register 1 */
#define MC65_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00651b4u)	/* Read Data and Bit Flip Register 10 */
#define MC65_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00651b6u)	/* Read Data and Bit Flip Register 11 */
#define MC65_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00651b8u)	/* Read Data and Bit Flip Register 12 */
#define MC65_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00651bau)	/* Read Data and Bit Flip Register 13 */
#define MC65_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00651bcu)	/* Read Data and Bit Flip Register 14 */
#define MC65_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00651beu)	/* Read Data and Bit Flip Register 15 */
#define MC65_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00651c0u)	/* Read Data and Bit Flip Register 16 */
#define MC65_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00651c2u)	/* Read Data and Bit Flip Register 17 */
#define MC65_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00651c4u)	/* Read Data and Bit Flip Register 18 */
#define MC65_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00651c6u)	/* Read Data and Bit Flip Register 19 */
#define MC65_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00651a4u)	/* Read Data and Bit Flip Register 2 */
#define MC65_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00651c8u)	/* Read Data and Bit Flip Register 20 */
#define MC65_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00651cau)	/* Read Data and Bit Flip Register 21 */
#define MC65_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00651ccu)	/* Read Data and Bit Flip Register 22 */
#define MC65_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00651ceu)	/* Read Data and Bit Flip Register 23 */
#define MC65_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00651d0u)	/* Read Data and Bit Flip Register 24 */
#define MC65_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00651d2u)	/* Read Data and Bit Flip Register 25 */
#define MC65_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00651d4u)	/* Read Data and Bit Flip Register 26 */
#define MC65_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00651d6u)	/* Read Data and Bit Flip Register 27 */
#define MC65_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00651d8u)	/* Read Data and Bit Flip Register 28 */
#define MC65_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00651dau)	/* Read Data and Bit Flip Register 29 */
#define MC65_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00651a6u)	/* Read Data and Bit Flip Register 3 */
#define MC65_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00651dcu)	/* Read Data and Bit Flip Register 30 */
#define MC65_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00651deu)	/* Read Data and Bit Flip Register 31 */
#define MC65_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00651e0u)	/* Read Data and Bit Flip Register 32 */
#define MC65_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00651e2u)	/* Read Data and Bit Flip Register 33 */
#define MC65_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00651e4u)	/* Read Data and Bit Flip Register 34 */
#define MC65_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00651e6u)	/* Read Data and Bit Flip Register 35 */
#define MC65_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00651e8u)	/* Read Data and Bit Flip Register 36 */
#define MC65_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00651eau)	/* Read Data and Bit Flip Register 37 */
#define MC65_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00651ecu)	/* Read Data and Bit Flip Register 38 */
#define MC65_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00651eeu)	/* Read Data and Bit Flip Register 39 */
#define MC65_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00651a8u)	/* Read Data and Bit Flip Register 4 */
#define MC65_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00651aau)	/* Read Data and Bit Flip Register 5 */
#define MC65_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00651acu)	/* Read Data and Bit Flip Register 6 */
#define MC65_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00651aeu)	/* Read Data and Bit Flip Register 7 */
#define MC65_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00651b0u)	/* Read Data and Bit Flip Register 8 */
#define MC65_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00651b2u)	/* Read Data and Bit Flip Register 9 */
#define MC66_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00652a0u)	/* Read Data and Bit Flip Register 0 */
#define MC66_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00652a2u)	/* Read Data and Bit Flip Register 1 */
#define MC66_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00652b4u)	/* Read Data and Bit Flip Register 10 */
#define MC66_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00652b6u)	/* Read Data and Bit Flip Register 11 */
#define MC66_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00652b8u)	/* Read Data and Bit Flip Register 12 */
#define MC66_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00652bau)	/* Read Data and Bit Flip Register 13 */
#define MC66_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00652bcu)	/* Read Data and Bit Flip Register 14 */
#define MC66_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00652beu)	/* Read Data and Bit Flip Register 15 */
#define MC66_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00652c0u)	/* Read Data and Bit Flip Register 16 */
#define MC66_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00652c2u)	/* Read Data and Bit Flip Register 17 */
#define MC66_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00652c4u)	/* Read Data and Bit Flip Register 18 */
#define MC66_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00652c6u)	/* Read Data and Bit Flip Register 19 */
#define MC66_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00652a4u)	/* Read Data and Bit Flip Register 2 */
#define MC66_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00652c8u)	/* Read Data and Bit Flip Register 20 */
#define MC66_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00652cau)	/* Read Data and Bit Flip Register 21 */
#define MC66_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00652ccu)	/* Read Data and Bit Flip Register 22 */
#define MC66_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00652ceu)	/* Read Data and Bit Flip Register 23 */
#define MC66_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00652d0u)	/* Read Data and Bit Flip Register 24 */
#define MC66_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00652d2u)	/* Read Data and Bit Flip Register 25 */
#define MC66_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00652d4u)	/* Read Data and Bit Flip Register 26 */
#define MC66_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00652d6u)	/* Read Data and Bit Flip Register 27 */
#define MC66_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00652d8u)	/* Read Data and Bit Flip Register 28 */
#define MC66_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00652dau)	/* Read Data and Bit Flip Register 29 */
#define MC66_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00652a6u)	/* Read Data and Bit Flip Register 3 */
#define MC66_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00652dcu)	/* Read Data and Bit Flip Register 30 */
#define MC66_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00652deu)	/* Read Data and Bit Flip Register 31 */
#define MC66_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00652e0u)	/* Read Data and Bit Flip Register 32 */
#define MC66_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00652e2u)	/* Read Data and Bit Flip Register 33 */
#define MC66_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00652e4u)	/* Read Data and Bit Flip Register 34 */
#define MC66_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00652e6u)	/* Read Data and Bit Flip Register 35 */
#define MC66_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00652e8u)	/* Read Data and Bit Flip Register 36 */
#define MC66_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00652eau)	/* Read Data and Bit Flip Register 37 */
#define MC66_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00652ecu)	/* Read Data and Bit Flip Register 38 */
#define MC66_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00652eeu)	/* Read Data and Bit Flip Register 39 */
#define MC66_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00652a8u)	/* Read Data and Bit Flip Register 4 */
#define MC66_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00652aau)	/* Read Data and Bit Flip Register 5 */
#define MC66_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00652acu)	/* Read Data and Bit Flip Register 6 */
#define MC66_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00652aeu)	/* Read Data and Bit Flip Register 7 */
#define MC66_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00652b0u)	/* Read Data and Bit Flip Register 8 */
#define MC66_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00652b2u)	/* Read Data and Bit Flip Register 9 */
#define MC67_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00653a0u)	/* Read Data and Bit Flip Register 0 */
#define MC67_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00653a2u)	/* Read Data and Bit Flip Register 1 */
#define MC67_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00653b4u)	/* Read Data and Bit Flip Register 10 */
#define MC67_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00653b6u)	/* Read Data and Bit Flip Register 11 */
#define MC67_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00653b8u)	/* Read Data and Bit Flip Register 12 */
#define MC67_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00653bau)	/* Read Data and Bit Flip Register 13 */
#define MC67_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00653bcu)	/* Read Data and Bit Flip Register 14 */
#define MC67_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00653beu)	/* Read Data and Bit Flip Register 15 */
#define MC67_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00653c0u)	/* Read Data and Bit Flip Register 16 */
#define MC67_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00653c2u)	/* Read Data and Bit Flip Register 17 */
#define MC67_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00653c4u)	/* Read Data and Bit Flip Register 18 */
#define MC67_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00653c6u)	/* Read Data and Bit Flip Register 19 */
#define MC67_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00653a4u)	/* Read Data and Bit Flip Register 2 */
#define MC67_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00653c8u)	/* Read Data and Bit Flip Register 20 */
#define MC67_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00653cau)	/* Read Data and Bit Flip Register 21 */
#define MC67_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00653ccu)	/* Read Data and Bit Flip Register 22 */
#define MC67_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00653ceu)	/* Read Data and Bit Flip Register 23 */
#define MC67_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00653d0u)	/* Read Data and Bit Flip Register 24 */
#define MC67_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00653d2u)	/* Read Data and Bit Flip Register 25 */
#define MC67_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00653d4u)	/* Read Data and Bit Flip Register 26 */
#define MC67_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00653d6u)	/* Read Data and Bit Flip Register 27 */
#define MC67_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00653d8u)	/* Read Data and Bit Flip Register 28 */
#define MC67_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00653dau)	/* Read Data and Bit Flip Register 29 */
#define MC67_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00653a6u)	/* Read Data and Bit Flip Register 3 */
#define MC67_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00653dcu)	/* Read Data and Bit Flip Register 30 */
#define MC67_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00653deu)	/* Read Data and Bit Flip Register 31 */
#define MC67_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00653e0u)	/* Read Data and Bit Flip Register 32 */
#define MC67_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00653e2u)	/* Read Data and Bit Flip Register 33 */
#define MC67_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00653e4u)	/* Read Data and Bit Flip Register 34 */
#define MC67_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00653e6u)	/* Read Data and Bit Flip Register 35 */
#define MC67_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00653e8u)	/* Read Data and Bit Flip Register 36 */
#define MC67_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00653eau)	/* Read Data and Bit Flip Register 37 */
#define MC67_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00653ecu)	/* Read Data and Bit Flip Register 38 */
#define MC67_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00653eeu)	/* Read Data and Bit Flip Register 39 */
#define MC67_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00653a8u)	/* Read Data and Bit Flip Register 4 */
#define MC67_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00653aau)	/* Read Data and Bit Flip Register 5 */
#define MC67_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00653acu)	/* Read Data and Bit Flip Register 6 */
#define MC67_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00653aeu)	/* Read Data and Bit Flip Register 7 */
#define MC67_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00653b0u)	/* Read Data and Bit Flip Register 8 */
#define MC67_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00653b2u)	/* Read Data and Bit Flip Register 9 */
#define MC68_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00654a0u)	/* Read Data and Bit Flip Register 0 */
#define MC68_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00654a2u)	/* Read Data and Bit Flip Register 1 */
#define MC68_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00654b4u)	/* Read Data and Bit Flip Register 10 */
#define MC68_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00654b6u)	/* Read Data and Bit Flip Register 11 */
#define MC68_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00654b8u)	/* Read Data and Bit Flip Register 12 */
#define MC68_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00654bau)	/* Read Data and Bit Flip Register 13 */
#define MC68_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00654bcu)	/* Read Data and Bit Flip Register 14 */
#define MC68_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00654beu)	/* Read Data and Bit Flip Register 15 */
#define MC68_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00654c0u)	/* Read Data and Bit Flip Register 16 */
#define MC68_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00654c2u)	/* Read Data and Bit Flip Register 17 */
#define MC68_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00654c4u)	/* Read Data and Bit Flip Register 18 */
#define MC68_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00654c6u)	/* Read Data and Bit Flip Register 19 */
#define MC68_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00654a4u)	/* Read Data and Bit Flip Register 2 */
#define MC68_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00654c8u)	/* Read Data and Bit Flip Register 20 */
#define MC68_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00654cau)	/* Read Data and Bit Flip Register 21 */
#define MC68_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00654ccu)	/* Read Data and Bit Flip Register 22 */
#define MC68_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00654ceu)	/* Read Data and Bit Flip Register 23 */
#define MC68_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00654d0u)	/* Read Data and Bit Flip Register 24 */
#define MC68_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00654d2u)	/* Read Data and Bit Flip Register 25 */
#define MC68_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00654d4u)	/* Read Data and Bit Flip Register 26 */
#define MC68_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00654d6u)	/* Read Data and Bit Flip Register 27 */
#define MC68_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00654d8u)	/* Read Data and Bit Flip Register 28 */
#define MC68_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00654dau)	/* Read Data and Bit Flip Register 29 */
#define MC68_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00654a6u)	/* Read Data and Bit Flip Register 3 */
#define MC68_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00654dcu)	/* Read Data and Bit Flip Register 30 */
#define MC68_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00654deu)	/* Read Data and Bit Flip Register 31 */
#define MC68_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00654e0u)	/* Read Data and Bit Flip Register 32 */
#define MC68_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00654e2u)	/* Read Data and Bit Flip Register 33 */
#define MC68_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00654e4u)	/* Read Data and Bit Flip Register 34 */
#define MC68_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00654e6u)	/* Read Data and Bit Flip Register 35 */
#define MC68_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00654e8u)	/* Read Data and Bit Flip Register 36 */
#define MC68_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00654eau)	/* Read Data and Bit Flip Register 37 */
#define MC68_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00654ecu)	/* Read Data and Bit Flip Register 38 */
#define MC68_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00654eeu)	/* Read Data and Bit Flip Register 39 */
#define MC68_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00654a8u)	/* Read Data and Bit Flip Register 4 */
#define MC68_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00654aau)	/* Read Data and Bit Flip Register 5 */
#define MC68_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00654acu)	/* Read Data and Bit Flip Register 6 */
#define MC68_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00654aeu)	/* Read Data and Bit Flip Register 7 */
#define MC68_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00654b0u)	/* Read Data and Bit Flip Register 8 */
#define MC68_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00654b2u)	/* Read Data and Bit Flip Register 9 */
#define MC69_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00655a0u)	/* Read Data and Bit Flip Register 0 */
#define MC69_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00655a2u)	/* Read Data and Bit Flip Register 1 */
#define MC69_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00655b4u)	/* Read Data and Bit Flip Register 10 */
#define MC69_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00655b6u)	/* Read Data and Bit Flip Register 11 */
#define MC69_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00655b8u)	/* Read Data and Bit Flip Register 12 */
#define MC69_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00655bau)	/* Read Data and Bit Flip Register 13 */
#define MC69_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00655bcu)	/* Read Data and Bit Flip Register 14 */
#define MC69_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00655beu)	/* Read Data and Bit Flip Register 15 */
#define MC69_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00655c0u)	/* Read Data and Bit Flip Register 16 */
#define MC69_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00655c2u)	/* Read Data and Bit Flip Register 17 */
#define MC69_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00655c4u)	/* Read Data and Bit Flip Register 18 */
#define MC69_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00655c6u)	/* Read Data and Bit Flip Register 19 */
#define MC69_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00655a4u)	/* Read Data and Bit Flip Register 2 */
#define MC69_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00655c8u)	/* Read Data and Bit Flip Register 20 */
#define MC69_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00655cau)	/* Read Data and Bit Flip Register 21 */
#define MC69_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00655ccu)	/* Read Data and Bit Flip Register 22 */
#define MC69_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00655ceu)	/* Read Data and Bit Flip Register 23 */
#define MC69_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00655d0u)	/* Read Data and Bit Flip Register 24 */
#define MC69_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00655d2u)	/* Read Data and Bit Flip Register 25 */
#define MC69_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00655d4u)	/* Read Data and Bit Flip Register 26 */
#define MC69_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00655d6u)	/* Read Data and Bit Flip Register 27 */
#define MC69_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00655d8u)	/* Read Data and Bit Flip Register 28 */
#define MC69_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00655dau)	/* Read Data and Bit Flip Register 29 */
#define MC69_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00655a6u)	/* Read Data and Bit Flip Register 3 */
#define MC69_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00655dcu)	/* Read Data and Bit Flip Register 30 */
#define MC69_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00655deu)	/* Read Data and Bit Flip Register 31 */
#define MC69_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00655e0u)	/* Read Data and Bit Flip Register 32 */
#define MC69_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00655e2u)	/* Read Data and Bit Flip Register 33 */
#define MC69_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00655e4u)	/* Read Data and Bit Flip Register 34 */
#define MC69_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00655e6u)	/* Read Data and Bit Flip Register 35 */
#define MC69_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00655e8u)	/* Read Data and Bit Flip Register 36 */
#define MC69_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00655eau)	/* Read Data and Bit Flip Register 37 */
#define MC69_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00655ecu)	/* Read Data and Bit Flip Register 38 */
#define MC69_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00655eeu)	/* Read Data and Bit Flip Register 39 */
#define MC69_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00655a8u)	/* Read Data and Bit Flip Register 4 */
#define MC69_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00655aau)	/* Read Data and Bit Flip Register 5 */
#define MC69_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00655acu)	/* Read Data and Bit Flip Register 6 */
#define MC69_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00655aeu)	/* Read Data and Bit Flip Register 7 */
#define MC69_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00655b0u)	/* Read Data and Bit Flip Register 8 */
#define MC69_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00655b2u)	/* Read Data and Bit Flip Register 9 */
#define MC6_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00616a0u)	/* Read Data and Bit Flip Register 0 */
#define MC6_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00616a2u)	/* Read Data and Bit Flip Register 1 */
#define MC6_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00616b4u)	/* Read Data and Bit Flip Register 10 */
#define MC6_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00616b6u)	/* Read Data and Bit Flip Register 11 */
#define MC6_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00616b8u)	/* Read Data and Bit Flip Register 12 */
#define MC6_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00616bau)	/* Read Data and Bit Flip Register 13 */
#define MC6_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00616bcu)	/* Read Data and Bit Flip Register 14 */
#define MC6_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00616beu)	/* Read Data and Bit Flip Register 15 */
#define MC6_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00616c0u)	/* Read Data and Bit Flip Register 16 */
#define MC6_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00616c2u)	/* Read Data and Bit Flip Register 17 */
#define MC6_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00616c4u)	/* Read Data and Bit Flip Register 18 */
#define MC6_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00616c6u)	/* Read Data and Bit Flip Register 19 */
#define MC6_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00616a4u)	/* Read Data and Bit Flip Register 2 */
#define MC6_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00616c8u)	/* Read Data and Bit Flip Register 20 */
#define MC6_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00616cau)	/* Read Data and Bit Flip Register 21 */
#define MC6_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00616ccu)	/* Read Data and Bit Flip Register 22 */
#define MC6_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00616ceu)	/* Read Data and Bit Flip Register 23 */
#define MC6_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00616d0u)	/* Read Data and Bit Flip Register 24 */
#define MC6_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00616d2u)	/* Read Data and Bit Flip Register 25 */
#define MC6_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00616d4u)	/* Read Data and Bit Flip Register 26 */
#define MC6_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00616d6u)	/* Read Data and Bit Flip Register 27 */
#define MC6_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00616d8u)	/* Read Data and Bit Flip Register 28 */
#define MC6_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00616dau)	/* Read Data and Bit Flip Register 29 */
#define MC6_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00616a6u)	/* Read Data and Bit Flip Register 3 */
#define MC6_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00616dcu)	/* Read Data and Bit Flip Register 30 */
#define MC6_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00616deu)	/* Read Data and Bit Flip Register 31 */
#define MC6_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00616e0u)	/* Read Data and Bit Flip Register 32 */
#define MC6_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00616e2u)	/* Read Data and Bit Flip Register 33 */
#define MC6_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00616e4u)	/* Read Data and Bit Flip Register 34 */
#define MC6_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00616e6u)	/* Read Data and Bit Flip Register 35 */
#define MC6_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00616e8u)	/* Read Data and Bit Flip Register 36 */
#define MC6_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00616eau)	/* Read Data and Bit Flip Register 37 */
#define MC6_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00616ecu)	/* Read Data and Bit Flip Register 38 */
#define MC6_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00616eeu)	/* Read Data and Bit Flip Register 39 */
#define MC6_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00616a8u)	/* Read Data and Bit Flip Register 4 */
#define MC6_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00616aau)	/* Read Data and Bit Flip Register 5 */
#define MC6_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00616acu)	/* Read Data and Bit Flip Register 6 */
#define MC6_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00616aeu)	/* Read Data and Bit Flip Register 7 */
#define MC6_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00616b0u)	/* Read Data and Bit Flip Register 8 */
#define MC6_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00616b2u)	/* Read Data and Bit Flip Register 9 */
#define MC70_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00656a0u)	/* Read Data and Bit Flip Register 0 */
#define MC70_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00656a2u)	/* Read Data and Bit Flip Register 1 */
#define MC70_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00656b4u)	/* Read Data and Bit Flip Register 10 */
#define MC70_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00656b6u)	/* Read Data and Bit Flip Register 11 */
#define MC70_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00656b8u)	/* Read Data and Bit Flip Register 12 */
#define MC70_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00656bau)	/* Read Data and Bit Flip Register 13 */
#define MC70_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00656bcu)	/* Read Data and Bit Flip Register 14 */
#define MC70_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00656beu)	/* Read Data and Bit Flip Register 15 */
#define MC70_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00656c0u)	/* Read Data and Bit Flip Register 16 */
#define MC70_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00656c2u)	/* Read Data and Bit Flip Register 17 */
#define MC70_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00656c4u)	/* Read Data and Bit Flip Register 18 */
#define MC70_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00656c6u)	/* Read Data and Bit Flip Register 19 */
#define MC70_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00656a4u)	/* Read Data and Bit Flip Register 2 */
#define MC70_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00656c8u)	/* Read Data and Bit Flip Register 20 */
#define MC70_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00656cau)	/* Read Data and Bit Flip Register 21 */
#define MC70_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00656ccu)	/* Read Data and Bit Flip Register 22 */
#define MC70_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00656ceu)	/* Read Data and Bit Flip Register 23 */
#define MC70_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00656d0u)	/* Read Data and Bit Flip Register 24 */
#define MC70_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00656d2u)	/* Read Data and Bit Flip Register 25 */
#define MC70_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00656d4u)	/* Read Data and Bit Flip Register 26 */
#define MC70_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00656d6u)	/* Read Data and Bit Flip Register 27 */
#define MC70_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00656d8u)	/* Read Data and Bit Flip Register 28 */
#define MC70_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00656dau)	/* Read Data and Bit Flip Register 29 */
#define MC70_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00656a6u)	/* Read Data and Bit Flip Register 3 */
#define MC70_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00656dcu)	/* Read Data and Bit Flip Register 30 */
#define MC70_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00656deu)	/* Read Data and Bit Flip Register 31 */
#define MC70_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00656e0u)	/* Read Data and Bit Flip Register 32 */
#define MC70_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00656e2u)	/* Read Data and Bit Flip Register 33 */
#define MC70_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00656e4u)	/* Read Data and Bit Flip Register 34 */
#define MC70_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00656e6u)	/* Read Data and Bit Flip Register 35 */
#define MC70_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00656e8u)	/* Read Data and Bit Flip Register 36 */
#define MC70_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00656eau)	/* Read Data and Bit Flip Register 37 */
#define MC70_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00656ecu)	/* Read Data and Bit Flip Register 38 */
#define MC70_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00656eeu)	/* Read Data and Bit Flip Register 39 */
#define MC70_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00656a8u)	/* Read Data and Bit Flip Register 4 */
#define MC70_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00656aau)	/* Read Data and Bit Flip Register 5 */
#define MC70_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00656acu)	/* Read Data and Bit Flip Register 6 */
#define MC70_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00656aeu)	/* Read Data and Bit Flip Register 7 */
#define MC70_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00656b0u)	/* Read Data and Bit Flip Register 8 */
#define MC70_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00656b2u)	/* Read Data and Bit Flip Register 9 */
#define MC71_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00657a0u)	/* Read Data and Bit Flip Register 0 */
#define MC71_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00657a2u)	/* Read Data and Bit Flip Register 1 */
#define MC71_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00657b4u)	/* Read Data and Bit Flip Register 10 */
#define MC71_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00657b6u)	/* Read Data and Bit Flip Register 11 */
#define MC71_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00657b8u)	/* Read Data and Bit Flip Register 12 */
#define MC71_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00657bau)	/* Read Data and Bit Flip Register 13 */
#define MC71_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00657bcu)	/* Read Data and Bit Flip Register 14 */
#define MC71_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00657beu)	/* Read Data and Bit Flip Register 15 */
#define MC71_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00657c0u)	/* Read Data and Bit Flip Register 16 */
#define MC71_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00657c2u)	/* Read Data and Bit Flip Register 17 */
#define MC71_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00657c4u)	/* Read Data and Bit Flip Register 18 */
#define MC71_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00657c6u)	/* Read Data and Bit Flip Register 19 */
#define MC71_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00657a4u)	/* Read Data and Bit Flip Register 2 */
#define MC71_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00657c8u)	/* Read Data and Bit Flip Register 20 */
#define MC71_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00657cau)	/* Read Data and Bit Flip Register 21 */
#define MC71_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00657ccu)	/* Read Data and Bit Flip Register 22 */
#define MC71_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00657ceu)	/* Read Data and Bit Flip Register 23 */
#define MC71_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00657d0u)	/* Read Data and Bit Flip Register 24 */
#define MC71_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00657d2u)	/* Read Data and Bit Flip Register 25 */
#define MC71_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00657d4u)	/* Read Data and Bit Flip Register 26 */
#define MC71_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00657d6u)	/* Read Data and Bit Flip Register 27 */
#define MC71_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00657d8u)	/* Read Data and Bit Flip Register 28 */
#define MC71_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00657dau)	/* Read Data and Bit Flip Register 29 */
#define MC71_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00657a6u)	/* Read Data and Bit Flip Register 3 */
#define MC71_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00657dcu)	/* Read Data and Bit Flip Register 30 */
#define MC71_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00657deu)	/* Read Data and Bit Flip Register 31 */
#define MC71_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00657e0u)	/* Read Data and Bit Flip Register 32 */
#define MC71_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00657e2u)	/* Read Data and Bit Flip Register 33 */
#define MC71_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00657e4u)	/* Read Data and Bit Flip Register 34 */
#define MC71_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00657e6u)	/* Read Data and Bit Flip Register 35 */
#define MC71_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00657e8u)	/* Read Data and Bit Flip Register 36 */
#define MC71_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00657eau)	/* Read Data and Bit Flip Register 37 */
#define MC71_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00657ecu)	/* Read Data and Bit Flip Register 38 */
#define MC71_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00657eeu)	/* Read Data and Bit Flip Register 39 */
#define MC71_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00657a8u)	/* Read Data and Bit Flip Register 4 */
#define MC71_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00657aau)	/* Read Data and Bit Flip Register 5 */
#define MC71_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00657acu)	/* Read Data and Bit Flip Register 6 */
#define MC71_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00657aeu)	/* Read Data and Bit Flip Register 7 */
#define MC71_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00657b0u)	/* Read Data and Bit Flip Register 8 */
#define MC71_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00657b2u)	/* Read Data and Bit Flip Register 9 */
#define MC72_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00658a0u)	/* Read Data and Bit Flip Register 0 */
#define MC72_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00658a2u)	/* Read Data and Bit Flip Register 1 */
#define MC72_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00658b4u)	/* Read Data and Bit Flip Register 10 */
#define MC72_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00658b6u)	/* Read Data and Bit Flip Register 11 */
#define MC72_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00658b8u)	/* Read Data and Bit Flip Register 12 */
#define MC72_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00658bau)	/* Read Data and Bit Flip Register 13 */
#define MC72_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00658bcu)	/* Read Data and Bit Flip Register 14 */
#define MC72_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00658beu)	/* Read Data and Bit Flip Register 15 */
#define MC72_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00658c0u)	/* Read Data and Bit Flip Register 16 */
#define MC72_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00658c2u)	/* Read Data and Bit Flip Register 17 */
#define MC72_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00658c4u)	/* Read Data and Bit Flip Register 18 */
#define MC72_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00658c6u)	/* Read Data and Bit Flip Register 19 */
#define MC72_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00658a4u)	/* Read Data and Bit Flip Register 2 */
#define MC72_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00658c8u)	/* Read Data and Bit Flip Register 20 */
#define MC72_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00658cau)	/* Read Data and Bit Flip Register 21 */
#define MC72_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00658ccu)	/* Read Data and Bit Flip Register 22 */
#define MC72_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00658ceu)	/* Read Data and Bit Flip Register 23 */
#define MC72_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00658d0u)	/* Read Data and Bit Flip Register 24 */
#define MC72_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00658d2u)	/* Read Data and Bit Flip Register 25 */
#define MC72_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00658d4u)	/* Read Data and Bit Flip Register 26 */
#define MC72_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00658d6u)	/* Read Data and Bit Flip Register 27 */
#define MC72_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00658d8u)	/* Read Data and Bit Flip Register 28 */
#define MC72_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00658dau)	/* Read Data and Bit Flip Register 29 */
#define MC72_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00658a6u)	/* Read Data and Bit Flip Register 3 */
#define MC72_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00658dcu)	/* Read Data and Bit Flip Register 30 */
#define MC72_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00658deu)	/* Read Data and Bit Flip Register 31 */
#define MC72_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00658e0u)	/* Read Data and Bit Flip Register 32 */
#define MC72_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00658e2u)	/* Read Data and Bit Flip Register 33 */
#define MC72_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00658e4u)	/* Read Data and Bit Flip Register 34 */
#define MC72_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00658e6u)	/* Read Data and Bit Flip Register 35 */
#define MC72_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00658e8u)	/* Read Data and Bit Flip Register 36 */
#define MC72_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00658eau)	/* Read Data and Bit Flip Register 37 */
#define MC72_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00658ecu)	/* Read Data and Bit Flip Register 38 */
#define MC72_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00658eeu)	/* Read Data and Bit Flip Register 39 */
#define MC72_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00658a8u)	/* Read Data and Bit Flip Register 4 */
#define MC72_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00658aau)	/* Read Data and Bit Flip Register 5 */
#define MC72_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00658acu)	/* Read Data and Bit Flip Register 6 */
#define MC72_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00658aeu)	/* Read Data and Bit Flip Register 7 */
#define MC72_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00658b0u)	/* Read Data and Bit Flip Register 8 */
#define MC72_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00658b2u)	/* Read Data and Bit Flip Register 9 */
#define MC73_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00659a0u)	/* Read Data and Bit Flip Register 0 */
#define MC73_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00659a2u)	/* Read Data and Bit Flip Register 1 */
#define MC73_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00659b4u)	/* Read Data and Bit Flip Register 10 */
#define MC73_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00659b6u)	/* Read Data and Bit Flip Register 11 */
#define MC73_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00659b8u)	/* Read Data and Bit Flip Register 12 */
#define MC73_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00659bau)	/* Read Data and Bit Flip Register 13 */
#define MC73_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00659bcu)	/* Read Data and Bit Flip Register 14 */
#define MC73_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00659beu)	/* Read Data and Bit Flip Register 15 */
#define MC73_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00659c0u)	/* Read Data and Bit Flip Register 16 */
#define MC73_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00659c2u)	/* Read Data and Bit Flip Register 17 */
#define MC73_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00659c4u)	/* Read Data and Bit Flip Register 18 */
#define MC73_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00659c6u)	/* Read Data and Bit Flip Register 19 */
#define MC73_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00659a4u)	/* Read Data and Bit Flip Register 2 */
#define MC73_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00659c8u)	/* Read Data and Bit Flip Register 20 */
#define MC73_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00659cau)	/* Read Data and Bit Flip Register 21 */
#define MC73_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00659ccu)	/* Read Data and Bit Flip Register 22 */
#define MC73_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00659ceu)	/* Read Data and Bit Flip Register 23 */
#define MC73_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00659d0u)	/* Read Data and Bit Flip Register 24 */
#define MC73_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00659d2u)	/* Read Data and Bit Flip Register 25 */
#define MC73_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00659d4u)	/* Read Data and Bit Flip Register 26 */
#define MC73_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00659d6u)	/* Read Data and Bit Flip Register 27 */
#define MC73_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00659d8u)	/* Read Data and Bit Flip Register 28 */
#define MC73_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00659dau)	/* Read Data and Bit Flip Register 29 */
#define MC73_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00659a6u)	/* Read Data and Bit Flip Register 3 */
#define MC73_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00659dcu)	/* Read Data and Bit Flip Register 30 */
#define MC73_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00659deu)	/* Read Data and Bit Flip Register 31 */
#define MC73_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00659e0u)	/* Read Data and Bit Flip Register 32 */
#define MC73_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00659e2u)	/* Read Data and Bit Flip Register 33 */
#define MC73_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00659e4u)	/* Read Data and Bit Flip Register 34 */
#define MC73_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00659e6u)	/* Read Data and Bit Flip Register 35 */
#define MC73_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00659e8u)	/* Read Data and Bit Flip Register 36 */
#define MC73_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00659eau)	/* Read Data and Bit Flip Register 37 */
#define MC73_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00659ecu)	/* Read Data and Bit Flip Register 38 */
#define MC73_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00659eeu)	/* Read Data and Bit Flip Register 39 */
#define MC73_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00659a8u)	/* Read Data and Bit Flip Register 4 */
#define MC73_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00659aau)	/* Read Data and Bit Flip Register 5 */
#define MC73_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00659acu)	/* Read Data and Bit Flip Register 6 */
#define MC73_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00659aeu)	/* Read Data and Bit Flip Register 7 */
#define MC73_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00659b0u)	/* Read Data and Bit Flip Register 8 */
#define MC73_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00659b2u)	/* Read Data and Bit Flip Register 9 */
#define MC74_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0065aa0u)	/* Read Data and Bit Flip Register 0 */
#define MC74_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0065aa2u)	/* Read Data and Bit Flip Register 1 */
#define MC74_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0065ab4u)	/* Read Data and Bit Flip Register 10 */
#define MC74_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0065ab6u)	/* Read Data and Bit Flip Register 11 */
#define MC74_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0065ab8u)	/* Read Data and Bit Flip Register 12 */
#define MC74_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0065abau)	/* Read Data and Bit Flip Register 13 */
#define MC74_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0065abcu)	/* Read Data and Bit Flip Register 14 */
#define MC74_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0065abeu)	/* Read Data and Bit Flip Register 15 */
#define MC74_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0065ac0u)	/* Read Data and Bit Flip Register 16 */
#define MC74_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0065ac2u)	/* Read Data and Bit Flip Register 17 */
#define MC74_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0065ac4u)	/* Read Data and Bit Flip Register 18 */
#define MC74_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0065ac6u)	/* Read Data and Bit Flip Register 19 */
#define MC74_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0065aa4u)	/* Read Data and Bit Flip Register 2 */
#define MC74_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0065ac8u)	/* Read Data and Bit Flip Register 20 */
#define MC74_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0065acau)	/* Read Data and Bit Flip Register 21 */
#define MC74_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0065accu)	/* Read Data and Bit Flip Register 22 */
#define MC74_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0065aceu)	/* Read Data and Bit Flip Register 23 */
#define MC74_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0065ad0u)	/* Read Data and Bit Flip Register 24 */
#define MC74_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0065ad2u)	/* Read Data and Bit Flip Register 25 */
#define MC74_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0065ad4u)	/* Read Data and Bit Flip Register 26 */
#define MC74_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0065ad6u)	/* Read Data and Bit Flip Register 27 */
#define MC74_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0065ad8u)	/* Read Data and Bit Flip Register 28 */
#define MC74_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0065adau)	/* Read Data and Bit Flip Register 29 */
#define MC74_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0065aa6u)	/* Read Data and Bit Flip Register 3 */
#define MC74_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0065adcu)	/* Read Data and Bit Flip Register 30 */
#define MC74_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0065adeu)	/* Read Data and Bit Flip Register 31 */
#define MC74_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0065ae0u)	/* Read Data and Bit Flip Register 32 */
#define MC74_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0065ae2u)	/* Read Data and Bit Flip Register 33 */
#define MC74_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0065ae4u)	/* Read Data and Bit Flip Register 34 */
#define MC74_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0065ae6u)	/* Read Data and Bit Flip Register 35 */
#define MC74_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0065ae8u)	/* Read Data and Bit Flip Register 36 */
#define MC74_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0065aeau)	/* Read Data and Bit Flip Register 37 */
#define MC74_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0065aecu)	/* Read Data and Bit Flip Register 38 */
#define MC74_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0065aeeu)	/* Read Data and Bit Flip Register 39 */
#define MC74_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0065aa8u)	/* Read Data and Bit Flip Register 4 */
#define MC74_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0065aaau)	/* Read Data and Bit Flip Register 5 */
#define MC74_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0065aacu)	/* Read Data and Bit Flip Register 6 */
#define MC74_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0065aaeu)	/* Read Data and Bit Flip Register 7 */
#define MC74_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0065ab0u)	/* Read Data and Bit Flip Register 8 */
#define MC74_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0065ab2u)	/* Read Data and Bit Flip Register 9 */
#define MC75_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0065ba0u)	/* Read Data and Bit Flip Register 0 */
#define MC75_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0065ba2u)	/* Read Data and Bit Flip Register 1 */
#define MC75_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0065bb4u)	/* Read Data and Bit Flip Register 10 */
#define MC75_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0065bb6u)	/* Read Data and Bit Flip Register 11 */
#define MC75_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0065bb8u)	/* Read Data and Bit Flip Register 12 */
#define MC75_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0065bbau)	/* Read Data and Bit Flip Register 13 */
#define MC75_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0065bbcu)	/* Read Data and Bit Flip Register 14 */
#define MC75_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0065bbeu)	/* Read Data and Bit Flip Register 15 */
#define MC75_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0065bc0u)	/* Read Data and Bit Flip Register 16 */
#define MC75_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0065bc2u)	/* Read Data and Bit Flip Register 17 */
#define MC75_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0065bc4u)	/* Read Data and Bit Flip Register 18 */
#define MC75_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0065bc6u)	/* Read Data and Bit Flip Register 19 */
#define MC75_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0065ba4u)	/* Read Data and Bit Flip Register 2 */
#define MC75_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0065bc8u)	/* Read Data and Bit Flip Register 20 */
#define MC75_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0065bcau)	/* Read Data and Bit Flip Register 21 */
#define MC75_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0065bccu)	/* Read Data and Bit Flip Register 22 */
#define MC75_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0065bceu)	/* Read Data and Bit Flip Register 23 */
#define MC75_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0065bd0u)	/* Read Data and Bit Flip Register 24 */
#define MC75_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0065bd2u)	/* Read Data and Bit Flip Register 25 */
#define MC75_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0065bd4u)	/* Read Data and Bit Flip Register 26 */
#define MC75_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0065bd6u)	/* Read Data and Bit Flip Register 27 */
#define MC75_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0065bd8u)	/* Read Data and Bit Flip Register 28 */
#define MC75_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0065bdau)	/* Read Data and Bit Flip Register 29 */
#define MC75_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0065ba6u)	/* Read Data and Bit Flip Register 3 */
#define MC75_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0065bdcu)	/* Read Data and Bit Flip Register 30 */
#define MC75_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0065bdeu)	/* Read Data and Bit Flip Register 31 */
#define MC75_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0065be0u)	/* Read Data and Bit Flip Register 32 */
#define MC75_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0065be2u)	/* Read Data and Bit Flip Register 33 */
#define MC75_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0065be4u)	/* Read Data and Bit Flip Register 34 */
#define MC75_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0065be6u)	/* Read Data and Bit Flip Register 35 */
#define MC75_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0065be8u)	/* Read Data and Bit Flip Register 36 */
#define MC75_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0065beau)	/* Read Data and Bit Flip Register 37 */
#define MC75_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0065becu)	/* Read Data and Bit Flip Register 38 */
#define MC75_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0065beeu)	/* Read Data and Bit Flip Register 39 */
#define MC75_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0065ba8u)	/* Read Data and Bit Flip Register 4 */
#define MC75_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0065baau)	/* Read Data and Bit Flip Register 5 */
#define MC75_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0065bacu)	/* Read Data and Bit Flip Register 6 */
#define MC75_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0065baeu)	/* Read Data and Bit Flip Register 7 */
#define MC75_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0065bb0u)	/* Read Data and Bit Flip Register 8 */
#define MC75_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0065bb2u)	/* Read Data and Bit Flip Register 9 */
#define MC76_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0065ca0u)	/* Read Data and Bit Flip Register 0 */
#define MC76_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0065ca2u)	/* Read Data and Bit Flip Register 1 */
#define MC76_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0065cb4u)	/* Read Data and Bit Flip Register 10 */
#define MC76_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0065cb6u)	/* Read Data and Bit Flip Register 11 */
#define MC76_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0065cb8u)	/* Read Data and Bit Flip Register 12 */
#define MC76_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0065cbau)	/* Read Data and Bit Flip Register 13 */
#define MC76_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0065cbcu)	/* Read Data and Bit Flip Register 14 */
#define MC76_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0065cbeu)	/* Read Data and Bit Flip Register 15 */
#define MC76_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0065cc0u)	/* Read Data and Bit Flip Register 16 */
#define MC76_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0065cc2u)	/* Read Data and Bit Flip Register 17 */
#define MC76_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0065cc4u)	/* Read Data and Bit Flip Register 18 */
#define MC76_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0065cc6u)	/* Read Data and Bit Flip Register 19 */
#define MC76_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0065ca4u)	/* Read Data and Bit Flip Register 2 */
#define MC76_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0065cc8u)	/* Read Data and Bit Flip Register 20 */
#define MC76_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0065ccau)	/* Read Data and Bit Flip Register 21 */
#define MC76_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0065cccu)	/* Read Data and Bit Flip Register 22 */
#define MC76_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0065cceu)	/* Read Data and Bit Flip Register 23 */
#define MC76_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0065cd0u)	/* Read Data and Bit Flip Register 24 */
#define MC76_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0065cd2u)	/* Read Data and Bit Flip Register 25 */
#define MC76_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0065cd4u)	/* Read Data and Bit Flip Register 26 */
#define MC76_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0065cd6u)	/* Read Data and Bit Flip Register 27 */
#define MC76_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0065cd8u)	/* Read Data and Bit Flip Register 28 */
#define MC76_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0065cdau)	/* Read Data and Bit Flip Register 29 */
#define MC76_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0065ca6u)	/* Read Data and Bit Flip Register 3 */
#define MC76_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0065cdcu)	/* Read Data and Bit Flip Register 30 */
#define MC76_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0065cdeu)	/* Read Data and Bit Flip Register 31 */
#define MC76_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0065ce0u)	/* Read Data and Bit Flip Register 32 */
#define MC76_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0065ce2u)	/* Read Data and Bit Flip Register 33 */
#define MC76_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0065ce4u)	/* Read Data and Bit Flip Register 34 */
#define MC76_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0065ce6u)	/* Read Data and Bit Flip Register 35 */
#define MC76_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0065ce8u)	/* Read Data and Bit Flip Register 36 */
#define MC76_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0065ceau)	/* Read Data and Bit Flip Register 37 */
#define MC76_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0065cecu)	/* Read Data and Bit Flip Register 38 */
#define MC76_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0065ceeu)	/* Read Data and Bit Flip Register 39 */
#define MC76_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0065ca8u)	/* Read Data and Bit Flip Register 4 */
#define MC76_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0065caau)	/* Read Data and Bit Flip Register 5 */
#define MC76_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0065cacu)	/* Read Data and Bit Flip Register 6 */
#define MC76_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0065caeu)	/* Read Data and Bit Flip Register 7 */
#define MC76_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0065cb0u)	/* Read Data and Bit Flip Register 8 */
#define MC76_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0065cb2u)	/* Read Data and Bit Flip Register 9 */
#define MC77_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0065da0u)	/* Read Data and Bit Flip Register 0 */
#define MC77_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0065da2u)	/* Read Data and Bit Flip Register 1 */
#define MC77_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0065db4u)	/* Read Data and Bit Flip Register 10 */
#define MC77_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0065db6u)	/* Read Data and Bit Flip Register 11 */
#define MC77_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0065db8u)	/* Read Data and Bit Flip Register 12 */
#define MC77_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0065dbau)	/* Read Data and Bit Flip Register 13 */
#define MC77_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0065dbcu)	/* Read Data and Bit Flip Register 14 */
#define MC77_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0065dbeu)	/* Read Data and Bit Flip Register 15 */
#define MC77_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0065dc0u)	/* Read Data and Bit Flip Register 16 */
#define MC77_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0065dc2u)	/* Read Data and Bit Flip Register 17 */
#define MC77_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0065dc4u)	/* Read Data and Bit Flip Register 18 */
#define MC77_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0065dc6u)	/* Read Data and Bit Flip Register 19 */
#define MC77_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0065da4u)	/* Read Data and Bit Flip Register 2 */
#define MC77_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0065dc8u)	/* Read Data and Bit Flip Register 20 */
#define MC77_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0065dcau)	/* Read Data and Bit Flip Register 21 */
#define MC77_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0065dccu)	/* Read Data and Bit Flip Register 22 */
#define MC77_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0065dceu)	/* Read Data and Bit Flip Register 23 */
#define MC77_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0065dd0u)	/* Read Data and Bit Flip Register 24 */
#define MC77_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0065dd2u)	/* Read Data and Bit Flip Register 25 */
#define MC77_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0065dd4u)	/* Read Data and Bit Flip Register 26 */
#define MC77_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0065dd6u)	/* Read Data and Bit Flip Register 27 */
#define MC77_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0065dd8u)	/* Read Data and Bit Flip Register 28 */
#define MC77_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0065ddau)	/* Read Data and Bit Flip Register 29 */
#define MC77_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0065da6u)	/* Read Data and Bit Flip Register 3 */
#define MC77_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0065ddcu)	/* Read Data and Bit Flip Register 30 */
#define MC77_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0065ddeu)	/* Read Data and Bit Flip Register 31 */
#define MC77_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0065de0u)	/* Read Data and Bit Flip Register 32 */
#define MC77_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0065de2u)	/* Read Data and Bit Flip Register 33 */
#define MC77_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0065de4u)	/* Read Data and Bit Flip Register 34 */
#define MC77_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0065de6u)	/* Read Data and Bit Flip Register 35 */
#define MC77_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0065de8u)	/* Read Data and Bit Flip Register 36 */
#define MC77_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0065deau)	/* Read Data and Bit Flip Register 37 */
#define MC77_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0065decu)	/* Read Data and Bit Flip Register 38 */
#define MC77_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0065deeu)	/* Read Data and Bit Flip Register 39 */
#define MC77_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0065da8u)	/* Read Data and Bit Flip Register 4 */
#define MC77_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0065daau)	/* Read Data and Bit Flip Register 5 */
#define MC77_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0065dacu)	/* Read Data and Bit Flip Register 6 */
#define MC77_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0065daeu)	/* Read Data and Bit Flip Register 7 */
#define MC77_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0065db0u)	/* Read Data and Bit Flip Register 8 */
#define MC77_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0065db2u)	/* Read Data and Bit Flip Register 9 */
#define MC78_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0065ea0u)	/* Read Data and Bit Flip Register 0 */
#define MC78_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0065ea2u)	/* Read Data and Bit Flip Register 1 */
#define MC78_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0065eb4u)	/* Read Data and Bit Flip Register 10 */
#define MC78_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0065eb6u)	/* Read Data and Bit Flip Register 11 */
#define MC78_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0065eb8u)	/* Read Data and Bit Flip Register 12 */
#define MC78_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0065ebau)	/* Read Data and Bit Flip Register 13 */
#define MC78_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0065ebcu)	/* Read Data and Bit Flip Register 14 */
#define MC78_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0065ebeu)	/* Read Data and Bit Flip Register 15 */
#define MC78_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0065ec0u)	/* Read Data and Bit Flip Register 16 */
#define MC78_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0065ec2u)	/* Read Data and Bit Flip Register 17 */
#define MC78_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0065ec4u)	/* Read Data and Bit Flip Register 18 */
#define MC78_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0065ec6u)	/* Read Data and Bit Flip Register 19 */
#define MC78_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0065ea4u)	/* Read Data and Bit Flip Register 2 */
#define MC78_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0065ec8u)	/* Read Data and Bit Flip Register 20 */
#define MC78_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0065ecau)	/* Read Data and Bit Flip Register 21 */
#define MC78_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0065eccu)	/* Read Data and Bit Flip Register 22 */
#define MC78_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0065eceu)	/* Read Data and Bit Flip Register 23 */
#define MC78_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0065ed0u)	/* Read Data and Bit Flip Register 24 */
#define MC78_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0065ed2u)	/* Read Data and Bit Flip Register 25 */
#define MC78_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0065ed4u)	/* Read Data and Bit Flip Register 26 */
#define MC78_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0065ed6u)	/* Read Data and Bit Flip Register 27 */
#define MC78_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0065ed8u)	/* Read Data and Bit Flip Register 28 */
#define MC78_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0065edau)	/* Read Data and Bit Flip Register 29 */
#define MC78_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0065ea6u)	/* Read Data and Bit Flip Register 3 */
#define MC78_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0065edcu)	/* Read Data and Bit Flip Register 30 */
#define MC78_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0065edeu)	/* Read Data and Bit Flip Register 31 */
#define MC78_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0065ee0u)	/* Read Data and Bit Flip Register 32 */
#define MC78_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0065ee2u)	/* Read Data and Bit Flip Register 33 */
#define MC78_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0065ee4u)	/* Read Data and Bit Flip Register 34 */
#define MC78_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0065ee6u)	/* Read Data and Bit Flip Register 35 */
#define MC78_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0065ee8u)	/* Read Data and Bit Flip Register 36 */
#define MC78_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0065eeau)	/* Read Data and Bit Flip Register 37 */
#define MC78_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0065eecu)	/* Read Data and Bit Flip Register 38 */
#define MC78_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0065eeeu)	/* Read Data and Bit Flip Register 39 */
#define MC78_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0065ea8u)	/* Read Data and Bit Flip Register 4 */
#define MC78_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0065eaau)	/* Read Data and Bit Flip Register 5 */
#define MC78_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0065eacu)	/* Read Data and Bit Flip Register 6 */
#define MC78_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0065eaeu)	/* Read Data and Bit Flip Register 7 */
#define MC78_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0065eb0u)	/* Read Data and Bit Flip Register 8 */
#define MC78_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0065eb2u)	/* Read Data and Bit Flip Register 9 */
#define MC79_RDBFL0	(*( MC0_RDBFL0_type *) 0xf0065fa0u)	/* Read Data and Bit Flip Register 0 */
#define MC79_RDBFL1	(*( MC0_RDBFL0_type *) 0xf0065fa2u)	/* Read Data and Bit Flip Register 1 */
#define MC79_RDBFL10	(*( MC0_RDBFL0_type *) 0xf0065fb4u)	/* Read Data and Bit Flip Register 10 */
#define MC79_RDBFL11	(*( MC0_RDBFL0_type *) 0xf0065fb6u)	/* Read Data and Bit Flip Register 11 */
#define MC79_RDBFL12	(*( MC0_RDBFL0_type *) 0xf0065fb8u)	/* Read Data and Bit Flip Register 12 */
#define MC79_RDBFL13	(*( MC0_RDBFL0_type *) 0xf0065fbau)	/* Read Data and Bit Flip Register 13 */
#define MC79_RDBFL14	(*( MC0_RDBFL0_type *) 0xf0065fbcu)	/* Read Data and Bit Flip Register 14 */
#define MC79_RDBFL15	(*( MC0_RDBFL0_type *) 0xf0065fbeu)	/* Read Data and Bit Flip Register 15 */
#define MC79_RDBFL16	(*( MC0_RDBFL0_type *) 0xf0065fc0u)	/* Read Data and Bit Flip Register 16 */
#define MC79_RDBFL17	(*( MC0_RDBFL0_type *) 0xf0065fc2u)	/* Read Data and Bit Flip Register 17 */
#define MC79_RDBFL18	(*( MC0_RDBFL0_type *) 0xf0065fc4u)	/* Read Data and Bit Flip Register 18 */
#define MC79_RDBFL19	(*( MC0_RDBFL0_type *) 0xf0065fc6u)	/* Read Data and Bit Flip Register 19 */
#define MC79_RDBFL2	(*( MC0_RDBFL0_type *) 0xf0065fa4u)	/* Read Data and Bit Flip Register 2 */
#define MC79_RDBFL20	(*( MC0_RDBFL0_type *) 0xf0065fc8u)	/* Read Data and Bit Flip Register 20 */
#define MC79_RDBFL21	(*( MC0_RDBFL0_type *) 0xf0065fcau)	/* Read Data and Bit Flip Register 21 */
#define MC79_RDBFL22	(*( MC0_RDBFL0_type *) 0xf0065fccu)	/* Read Data and Bit Flip Register 22 */
#define MC79_RDBFL23	(*( MC0_RDBFL0_type *) 0xf0065fceu)	/* Read Data and Bit Flip Register 23 */
#define MC79_RDBFL24	(*( MC0_RDBFL0_type *) 0xf0065fd0u)	/* Read Data and Bit Flip Register 24 */
#define MC79_RDBFL25	(*( MC0_RDBFL0_type *) 0xf0065fd2u)	/* Read Data and Bit Flip Register 25 */
#define MC79_RDBFL26	(*( MC0_RDBFL0_type *) 0xf0065fd4u)	/* Read Data and Bit Flip Register 26 */
#define MC79_RDBFL27	(*( MC0_RDBFL0_type *) 0xf0065fd6u)	/* Read Data and Bit Flip Register 27 */
#define MC79_RDBFL28	(*( MC0_RDBFL0_type *) 0xf0065fd8u)	/* Read Data and Bit Flip Register 28 */
#define MC79_RDBFL29	(*( MC0_RDBFL0_type *) 0xf0065fdau)	/* Read Data and Bit Flip Register 29 */
#define MC79_RDBFL3	(*( MC0_RDBFL0_type *) 0xf0065fa6u)	/* Read Data and Bit Flip Register 3 */
#define MC79_RDBFL30	(*( MC0_RDBFL0_type *) 0xf0065fdcu)	/* Read Data and Bit Flip Register 30 */
#define MC79_RDBFL31	(*( MC0_RDBFL0_type *) 0xf0065fdeu)	/* Read Data and Bit Flip Register 31 */
#define MC79_RDBFL32	(*( MC0_RDBFL0_type *) 0xf0065fe0u)	/* Read Data and Bit Flip Register 32 */
#define MC79_RDBFL33	(*( MC0_RDBFL0_type *) 0xf0065fe2u)	/* Read Data and Bit Flip Register 33 */
#define MC79_RDBFL34	(*( MC0_RDBFL0_type *) 0xf0065fe4u)	/* Read Data and Bit Flip Register 34 */
#define MC79_RDBFL35	(*( MC0_RDBFL0_type *) 0xf0065fe6u)	/* Read Data and Bit Flip Register 35 */
#define MC79_RDBFL36	(*( MC0_RDBFL0_type *) 0xf0065fe8u)	/* Read Data and Bit Flip Register 36 */
#define MC79_RDBFL37	(*( MC0_RDBFL0_type *) 0xf0065feau)	/* Read Data and Bit Flip Register 37 */
#define MC79_RDBFL38	(*( MC0_RDBFL0_type *) 0xf0065fecu)	/* Read Data and Bit Flip Register 38 */
#define MC79_RDBFL39	(*( MC0_RDBFL0_type *) 0xf0065feeu)	/* Read Data and Bit Flip Register 39 */
#define MC79_RDBFL4	(*( MC0_RDBFL0_type *) 0xf0065fa8u)	/* Read Data and Bit Flip Register 4 */
#define MC79_RDBFL5	(*( MC0_RDBFL0_type *) 0xf0065faau)	/* Read Data and Bit Flip Register 5 */
#define MC79_RDBFL6	(*( MC0_RDBFL0_type *) 0xf0065facu)	/* Read Data and Bit Flip Register 6 */
#define MC79_RDBFL7	(*( MC0_RDBFL0_type *) 0xf0065faeu)	/* Read Data and Bit Flip Register 7 */
#define MC79_RDBFL8	(*( MC0_RDBFL0_type *) 0xf0065fb0u)	/* Read Data and Bit Flip Register 8 */
#define MC79_RDBFL9	(*( MC0_RDBFL0_type *) 0xf0065fb2u)	/* Read Data and Bit Flip Register 9 */
#define MC7_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00617a0u)	/* Read Data and Bit Flip Register 0 */
#define MC7_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00617a2u)	/* Read Data and Bit Flip Register 1 */
#define MC7_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00617b4u)	/* Read Data and Bit Flip Register 10 */
#define MC7_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00617b6u)	/* Read Data and Bit Flip Register 11 */
#define MC7_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00617b8u)	/* Read Data and Bit Flip Register 12 */
#define MC7_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00617bau)	/* Read Data and Bit Flip Register 13 */
#define MC7_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00617bcu)	/* Read Data and Bit Flip Register 14 */
#define MC7_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00617beu)	/* Read Data and Bit Flip Register 15 */
#define MC7_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00617c0u)	/* Read Data and Bit Flip Register 16 */
#define MC7_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00617c2u)	/* Read Data and Bit Flip Register 17 */
#define MC7_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00617c4u)	/* Read Data and Bit Flip Register 18 */
#define MC7_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00617c6u)	/* Read Data and Bit Flip Register 19 */
#define MC7_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00617a4u)	/* Read Data and Bit Flip Register 2 */
#define MC7_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00617c8u)	/* Read Data and Bit Flip Register 20 */
#define MC7_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00617cau)	/* Read Data and Bit Flip Register 21 */
#define MC7_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00617ccu)	/* Read Data and Bit Flip Register 22 */
#define MC7_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00617ceu)	/* Read Data and Bit Flip Register 23 */
#define MC7_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00617d0u)	/* Read Data and Bit Flip Register 24 */
#define MC7_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00617d2u)	/* Read Data and Bit Flip Register 25 */
#define MC7_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00617d4u)	/* Read Data and Bit Flip Register 26 */
#define MC7_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00617d6u)	/* Read Data and Bit Flip Register 27 */
#define MC7_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00617d8u)	/* Read Data and Bit Flip Register 28 */
#define MC7_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00617dau)	/* Read Data and Bit Flip Register 29 */
#define MC7_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00617a6u)	/* Read Data and Bit Flip Register 3 */
#define MC7_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00617dcu)	/* Read Data and Bit Flip Register 30 */
#define MC7_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00617deu)	/* Read Data and Bit Flip Register 31 */
#define MC7_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00617e0u)	/* Read Data and Bit Flip Register 32 */
#define MC7_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00617e2u)	/* Read Data and Bit Flip Register 33 */
#define MC7_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00617e4u)	/* Read Data and Bit Flip Register 34 */
#define MC7_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00617e6u)	/* Read Data and Bit Flip Register 35 */
#define MC7_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00617e8u)	/* Read Data and Bit Flip Register 36 */
#define MC7_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00617eau)	/* Read Data and Bit Flip Register 37 */
#define MC7_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00617ecu)	/* Read Data and Bit Flip Register 38 */
#define MC7_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00617eeu)	/* Read Data and Bit Flip Register 39 */
#define MC7_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00617a8u)	/* Read Data and Bit Flip Register 4 */
#define MC7_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00617aau)	/* Read Data and Bit Flip Register 5 */
#define MC7_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00617acu)	/* Read Data and Bit Flip Register 6 */
#define MC7_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00617aeu)	/* Read Data and Bit Flip Register 7 */
#define MC7_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00617b0u)	/* Read Data and Bit Flip Register 8 */
#define MC7_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00617b2u)	/* Read Data and Bit Flip Register 9 */
#define MC80_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00660a0u)	/* Read Data and Bit Flip Register 0 */
#define MC80_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00660a2u)	/* Read Data and Bit Flip Register 1 */
#define MC80_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00660b4u)	/* Read Data and Bit Flip Register 10 */
#define MC80_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00660b6u)	/* Read Data and Bit Flip Register 11 */
#define MC80_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00660b8u)	/* Read Data and Bit Flip Register 12 */
#define MC80_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00660bau)	/* Read Data and Bit Flip Register 13 */
#define MC80_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00660bcu)	/* Read Data and Bit Flip Register 14 */
#define MC80_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00660beu)	/* Read Data and Bit Flip Register 15 */
#define MC80_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00660c0u)	/* Read Data and Bit Flip Register 16 */
#define MC80_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00660c2u)	/* Read Data and Bit Flip Register 17 */
#define MC80_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00660c4u)	/* Read Data and Bit Flip Register 18 */
#define MC80_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00660c6u)	/* Read Data and Bit Flip Register 19 */
#define MC80_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00660a4u)	/* Read Data and Bit Flip Register 2 */
#define MC80_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00660c8u)	/* Read Data and Bit Flip Register 20 */
#define MC80_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00660cau)	/* Read Data and Bit Flip Register 21 */
#define MC80_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00660ccu)	/* Read Data and Bit Flip Register 22 */
#define MC80_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00660ceu)	/* Read Data and Bit Flip Register 23 */
#define MC80_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00660d0u)	/* Read Data and Bit Flip Register 24 */
#define MC80_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00660d2u)	/* Read Data and Bit Flip Register 25 */
#define MC80_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00660d4u)	/* Read Data and Bit Flip Register 26 */
#define MC80_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00660d6u)	/* Read Data and Bit Flip Register 27 */
#define MC80_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00660d8u)	/* Read Data and Bit Flip Register 28 */
#define MC80_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00660dau)	/* Read Data and Bit Flip Register 29 */
#define MC80_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00660a6u)	/* Read Data and Bit Flip Register 3 */
#define MC80_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00660dcu)	/* Read Data and Bit Flip Register 30 */
#define MC80_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00660deu)	/* Read Data and Bit Flip Register 31 */
#define MC80_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00660e0u)	/* Read Data and Bit Flip Register 32 */
#define MC80_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00660e2u)	/* Read Data and Bit Flip Register 33 */
#define MC80_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00660e4u)	/* Read Data and Bit Flip Register 34 */
#define MC80_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00660e6u)	/* Read Data and Bit Flip Register 35 */
#define MC80_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00660e8u)	/* Read Data and Bit Flip Register 36 */
#define MC80_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00660eau)	/* Read Data and Bit Flip Register 37 */
#define MC80_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00660ecu)	/* Read Data and Bit Flip Register 38 */
#define MC80_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00660eeu)	/* Read Data and Bit Flip Register 39 */
#define MC80_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00660a8u)	/* Read Data and Bit Flip Register 4 */
#define MC80_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00660aau)	/* Read Data and Bit Flip Register 5 */
#define MC80_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00660acu)	/* Read Data and Bit Flip Register 6 */
#define MC80_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00660aeu)	/* Read Data and Bit Flip Register 7 */
#define MC80_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00660b0u)	/* Read Data and Bit Flip Register 8 */
#define MC80_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00660b2u)	/* Read Data and Bit Flip Register 9 */
#define MC81_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00661a0u)	/* Read Data and Bit Flip Register 0 */
#define MC81_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00661a2u)	/* Read Data and Bit Flip Register 1 */
#define MC81_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00661b4u)	/* Read Data and Bit Flip Register 10 */
#define MC81_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00661b6u)	/* Read Data and Bit Flip Register 11 */
#define MC81_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00661b8u)	/* Read Data and Bit Flip Register 12 */
#define MC81_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00661bau)	/* Read Data and Bit Flip Register 13 */
#define MC81_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00661bcu)	/* Read Data and Bit Flip Register 14 */
#define MC81_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00661beu)	/* Read Data and Bit Flip Register 15 */
#define MC81_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00661c0u)	/* Read Data and Bit Flip Register 16 */
#define MC81_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00661c2u)	/* Read Data and Bit Flip Register 17 */
#define MC81_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00661c4u)	/* Read Data and Bit Flip Register 18 */
#define MC81_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00661c6u)	/* Read Data and Bit Flip Register 19 */
#define MC81_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00661a4u)	/* Read Data and Bit Flip Register 2 */
#define MC81_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00661c8u)	/* Read Data and Bit Flip Register 20 */
#define MC81_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00661cau)	/* Read Data and Bit Flip Register 21 */
#define MC81_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00661ccu)	/* Read Data and Bit Flip Register 22 */
#define MC81_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00661ceu)	/* Read Data and Bit Flip Register 23 */
#define MC81_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00661d0u)	/* Read Data and Bit Flip Register 24 */
#define MC81_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00661d2u)	/* Read Data and Bit Flip Register 25 */
#define MC81_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00661d4u)	/* Read Data and Bit Flip Register 26 */
#define MC81_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00661d6u)	/* Read Data and Bit Flip Register 27 */
#define MC81_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00661d8u)	/* Read Data and Bit Flip Register 28 */
#define MC81_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00661dau)	/* Read Data and Bit Flip Register 29 */
#define MC81_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00661a6u)	/* Read Data and Bit Flip Register 3 */
#define MC81_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00661dcu)	/* Read Data and Bit Flip Register 30 */
#define MC81_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00661deu)	/* Read Data and Bit Flip Register 31 */
#define MC81_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00661e0u)	/* Read Data and Bit Flip Register 32 */
#define MC81_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00661e2u)	/* Read Data and Bit Flip Register 33 */
#define MC81_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00661e4u)	/* Read Data and Bit Flip Register 34 */
#define MC81_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00661e6u)	/* Read Data and Bit Flip Register 35 */
#define MC81_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00661e8u)	/* Read Data and Bit Flip Register 36 */
#define MC81_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00661eau)	/* Read Data and Bit Flip Register 37 */
#define MC81_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00661ecu)	/* Read Data and Bit Flip Register 38 */
#define MC81_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00661eeu)	/* Read Data and Bit Flip Register 39 */
#define MC81_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00661a8u)	/* Read Data and Bit Flip Register 4 */
#define MC81_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00661aau)	/* Read Data and Bit Flip Register 5 */
#define MC81_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00661acu)	/* Read Data and Bit Flip Register 6 */
#define MC81_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00661aeu)	/* Read Data and Bit Flip Register 7 */
#define MC81_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00661b0u)	/* Read Data and Bit Flip Register 8 */
#define MC81_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00661b2u)	/* Read Data and Bit Flip Register 9 */
#define MC82_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00662a0u)	/* Read Data and Bit Flip Register 0 */
#define MC82_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00662a2u)	/* Read Data and Bit Flip Register 1 */
#define MC82_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00662b4u)	/* Read Data and Bit Flip Register 10 */
#define MC82_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00662b6u)	/* Read Data and Bit Flip Register 11 */
#define MC82_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00662b8u)	/* Read Data and Bit Flip Register 12 */
#define MC82_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00662bau)	/* Read Data and Bit Flip Register 13 */
#define MC82_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00662bcu)	/* Read Data and Bit Flip Register 14 */
#define MC82_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00662beu)	/* Read Data and Bit Flip Register 15 */
#define MC82_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00662c0u)	/* Read Data and Bit Flip Register 16 */
#define MC82_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00662c2u)	/* Read Data and Bit Flip Register 17 */
#define MC82_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00662c4u)	/* Read Data and Bit Flip Register 18 */
#define MC82_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00662c6u)	/* Read Data and Bit Flip Register 19 */
#define MC82_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00662a4u)	/* Read Data and Bit Flip Register 2 */
#define MC82_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00662c8u)	/* Read Data and Bit Flip Register 20 */
#define MC82_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00662cau)	/* Read Data and Bit Flip Register 21 */
#define MC82_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00662ccu)	/* Read Data and Bit Flip Register 22 */
#define MC82_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00662ceu)	/* Read Data and Bit Flip Register 23 */
#define MC82_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00662d0u)	/* Read Data and Bit Flip Register 24 */
#define MC82_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00662d2u)	/* Read Data and Bit Flip Register 25 */
#define MC82_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00662d4u)	/* Read Data and Bit Flip Register 26 */
#define MC82_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00662d6u)	/* Read Data and Bit Flip Register 27 */
#define MC82_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00662d8u)	/* Read Data and Bit Flip Register 28 */
#define MC82_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00662dau)	/* Read Data and Bit Flip Register 29 */
#define MC82_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00662a6u)	/* Read Data and Bit Flip Register 3 */
#define MC82_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00662dcu)	/* Read Data and Bit Flip Register 30 */
#define MC82_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00662deu)	/* Read Data and Bit Flip Register 31 */
#define MC82_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00662e0u)	/* Read Data and Bit Flip Register 32 */
#define MC82_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00662e2u)	/* Read Data and Bit Flip Register 33 */
#define MC82_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00662e4u)	/* Read Data and Bit Flip Register 34 */
#define MC82_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00662e6u)	/* Read Data and Bit Flip Register 35 */
#define MC82_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00662e8u)	/* Read Data and Bit Flip Register 36 */
#define MC82_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00662eau)	/* Read Data and Bit Flip Register 37 */
#define MC82_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00662ecu)	/* Read Data and Bit Flip Register 38 */
#define MC82_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00662eeu)	/* Read Data and Bit Flip Register 39 */
#define MC82_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00662a8u)	/* Read Data and Bit Flip Register 4 */
#define MC82_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00662aau)	/* Read Data and Bit Flip Register 5 */
#define MC82_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00662acu)	/* Read Data and Bit Flip Register 6 */
#define MC82_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00662aeu)	/* Read Data and Bit Flip Register 7 */
#define MC82_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00662b0u)	/* Read Data and Bit Flip Register 8 */
#define MC82_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00662b2u)	/* Read Data and Bit Flip Register 9 */
#define MC83_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00663a0u)	/* Read Data and Bit Flip Register 0 */
#define MC83_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00663a2u)	/* Read Data and Bit Flip Register 1 */
#define MC83_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00663b4u)	/* Read Data and Bit Flip Register 10 */
#define MC83_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00663b6u)	/* Read Data and Bit Flip Register 11 */
#define MC83_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00663b8u)	/* Read Data and Bit Flip Register 12 */
#define MC83_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00663bau)	/* Read Data and Bit Flip Register 13 */
#define MC83_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00663bcu)	/* Read Data and Bit Flip Register 14 */
#define MC83_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00663beu)	/* Read Data and Bit Flip Register 15 */
#define MC83_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00663c0u)	/* Read Data and Bit Flip Register 16 */
#define MC83_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00663c2u)	/* Read Data and Bit Flip Register 17 */
#define MC83_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00663c4u)	/* Read Data and Bit Flip Register 18 */
#define MC83_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00663c6u)	/* Read Data and Bit Flip Register 19 */
#define MC83_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00663a4u)	/* Read Data and Bit Flip Register 2 */
#define MC83_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00663c8u)	/* Read Data and Bit Flip Register 20 */
#define MC83_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00663cau)	/* Read Data and Bit Flip Register 21 */
#define MC83_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00663ccu)	/* Read Data and Bit Flip Register 22 */
#define MC83_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00663ceu)	/* Read Data and Bit Flip Register 23 */
#define MC83_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00663d0u)	/* Read Data and Bit Flip Register 24 */
#define MC83_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00663d2u)	/* Read Data and Bit Flip Register 25 */
#define MC83_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00663d4u)	/* Read Data and Bit Flip Register 26 */
#define MC83_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00663d6u)	/* Read Data and Bit Flip Register 27 */
#define MC83_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00663d8u)	/* Read Data and Bit Flip Register 28 */
#define MC83_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00663dau)	/* Read Data and Bit Flip Register 29 */
#define MC83_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00663a6u)	/* Read Data and Bit Flip Register 3 */
#define MC83_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00663dcu)	/* Read Data and Bit Flip Register 30 */
#define MC83_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00663deu)	/* Read Data and Bit Flip Register 31 */
#define MC83_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00663e0u)	/* Read Data and Bit Flip Register 32 */
#define MC83_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00663e2u)	/* Read Data and Bit Flip Register 33 */
#define MC83_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00663e4u)	/* Read Data and Bit Flip Register 34 */
#define MC83_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00663e6u)	/* Read Data and Bit Flip Register 35 */
#define MC83_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00663e8u)	/* Read Data and Bit Flip Register 36 */
#define MC83_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00663eau)	/* Read Data and Bit Flip Register 37 */
#define MC83_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00663ecu)	/* Read Data and Bit Flip Register 38 */
#define MC83_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00663eeu)	/* Read Data and Bit Flip Register 39 */
#define MC83_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00663a8u)	/* Read Data and Bit Flip Register 4 */
#define MC83_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00663aau)	/* Read Data and Bit Flip Register 5 */
#define MC83_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00663acu)	/* Read Data and Bit Flip Register 6 */
#define MC83_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00663aeu)	/* Read Data and Bit Flip Register 7 */
#define MC83_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00663b0u)	/* Read Data and Bit Flip Register 8 */
#define MC83_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00663b2u)	/* Read Data and Bit Flip Register 9 */
#define MC84_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00664a0u)	/* Read Data and Bit Flip Register 0 */
#define MC84_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00664a2u)	/* Read Data and Bit Flip Register 1 */
#define MC84_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00664b4u)	/* Read Data and Bit Flip Register 10 */
#define MC84_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00664b6u)	/* Read Data and Bit Flip Register 11 */
#define MC84_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00664b8u)	/* Read Data and Bit Flip Register 12 */
#define MC84_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00664bau)	/* Read Data and Bit Flip Register 13 */
#define MC84_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00664bcu)	/* Read Data and Bit Flip Register 14 */
#define MC84_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00664beu)	/* Read Data and Bit Flip Register 15 */
#define MC84_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00664c0u)	/* Read Data and Bit Flip Register 16 */
#define MC84_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00664c2u)	/* Read Data and Bit Flip Register 17 */
#define MC84_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00664c4u)	/* Read Data and Bit Flip Register 18 */
#define MC84_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00664c6u)	/* Read Data and Bit Flip Register 19 */
#define MC84_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00664a4u)	/* Read Data and Bit Flip Register 2 */
#define MC84_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00664c8u)	/* Read Data and Bit Flip Register 20 */
#define MC84_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00664cau)	/* Read Data and Bit Flip Register 21 */
#define MC84_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00664ccu)	/* Read Data and Bit Flip Register 22 */
#define MC84_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00664ceu)	/* Read Data and Bit Flip Register 23 */
#define MC84_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00664d0u)	/* Read Data and Bit Flip Register 24 */
#define MC84_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00664d2u)	/* Read Data and Bit Flip Register 25 */
#define MC84_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00664d4u)	/* Read Data and Bit Flip Register 26 */
#define MC84_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00664d6u)	/* Read Data and Bit Flip Register 27 */
#define MC84_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00664d8u)	/* Read Data and Bit Flip Register 28 */
#define MC84_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00664dau)	/* Read Data and Bit Flip Register 29 */
#define MC84_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00664a6u)	/* Read Data and Bit Flip Register 3 */
#define MC84_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00664dcu)	/* Read Data and Bit Flip Register 30 */
#define MC84_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00664deu)	/* Read Data and Bit Flip Register 31 */
#define MC84_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00664e0u)	/* Read Data and Bit Flip Register 32 */
#define MC84_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00664e2u)	/* Read Data and Bit Flip Register 33 */
#define MC84_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00664e4u)	/* Read Data and Bit Flip Register 34 */
#define MC84_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00664e6u)	/* Read Data and Bit Flip Register 35 */
#define MC84_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00664e8u)	/* Read Data and Bit Flip Register 36 */
#define MC84_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00664eau)	/* Read Data and Bit Flip Register 37 */
#define MC84_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00664ecu)	/* Read Data and Bit Flip Register 38 */
#define MC84_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00664eeu)	/* Read Data and Bit Flip Register 39 */
#define MC84_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00664a8u)	/* Read Data and Bit Flip Register 4 */
#define MC84_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00664aau)	/* Read Data and Bit Flip Register 5 */
#define MC84_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00664acu)	/* Read Data and Bit Flip Register 6 */
#define MC84_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00664aeu)	/* Read Data and Bit Flip Register 7 */
#define MC84_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00664b0u)	/* Read Data and Bit Flip Register 8 */
#define MC84_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00664b2u)	/* Read Data and Bit Flip Register 9 */
#define MC85_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00665a0u)	/* Read Data and Bit Flip Register 0 */
#define MC85_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00665a2u)	/* Read Data and Bit Flip Register 1 */
#define MC85_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00665b4u)	/* Read Data and Bit Flip Register 10 */
#define MC85_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00665b6u)	/* Read Data and Bit Flip Register 11 */
#define MC85_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00665b8u)	/* Read Data and Bit Flip Register 12 */
#define MC85_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00665bau)	/* Read Data and Bit Flip Register 13 */
#define MC85_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00665bcu)	/* Read Data and Bit Flip Register 14 */
#define MC85_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00665beu)	/* Read Data and Bit Flip Register 15 */
#define MC85_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00665c0u)	/* Read Data and Bit Flip Register 16 */
#define MC85_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00665c2u)	/* Read Data and Bit Flip Register 17 */
#define MC85_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00665c4u)	/* Read Data and Bit Flip Register 18 */
#define MC85_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00665c6u)	/* Read Data and Bit Flip Register 19 */
#define MC85_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00665a4u)	/* Read Data and Bit Flip Register 2 */
#define MC85_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00665c8u)	/* Read Data and Bit Flip Register 20 */
#define MC85_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00665cau)	/* Read Data and Bit Flip Register 21 */
#define MC85_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00665ccu)	/* Read Data and Bit Flip Register 22 */
#define MC85_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00665ceu)	/* Read Data and Bit Flip Register 23 */
#define MC85_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00665d0u)	/* Read Data and Bit Flip Register 24 */
#define MC85_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00665d2u)	/* Read Data and Bit Flip Register 25 */
#define MC85_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00665d4u)	/* Read Data and Bit Flip Register 26 */
#define MC85_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00665d6u)	/* Read Data and Bit Flip Register 27 */
#define MC85_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00665d8u)	/* Read Data and Bit Flip Register 28 */
#define MC85_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00665dau)	/* Read Data and Bit Flip Register 29 */
#define MC85_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00665a6u)	/* Read Data and Bit Flip Register 3 */
#define MC85_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00665dcu)	/* Read Data and Bit Flip Register 30 */
#define MC85_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00665deu)	/* Read Data and Bit Flip Register 31 */
#define MC85_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00665e0u)	/* Read Data and Bit Flip Register 32 */
#define MC85_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00665e2u)	/* Read Data and Bit Flip Register 33 */
#define MC85_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00665e4u)	/* Read Data and Bit Flip Register 34 */
#define MC85_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00665e6u)	/* Read Data and Bit Flip Register 35 */
#define MC85_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00665e8u)	/* Read Data and Bit Flip Register 36 */
#define MC85_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00665eau)	/* Read Data and Bit Flip Register 37 */
#define MC85_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00665ecu)	/* Read Data and Bit Flip Register 38 */
#define MC85_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00665eeu)	/* Read Data and Bit Flip Register 39 */
#define MC85_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00665a8u)	/* Read Data and Bit Flip Register 4 */
#define MC85_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00665aau)	/* Read Data and Bit Flip Register 5 */
#define MC85_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00665acu)	/* Read Data and Bit Flip Register 6 */
#define MC85_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00665aeu)	/* Read Data and Bit Flip Register 7 */
#define MC85_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00665b0u)	/* Read Data and Bit Flip Register 8 */
#define MC85_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00665b2u)	/* Read Data and Bit Flip Register 9 */
#define MC86_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00666a0u)	/* Read Data and Bit Flip Register 0 */
#define MC86_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00666a2u)	/* Read Data and Bit Flip Register 1 */
#define MC86_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00666b4u)	/* Read Data and Bit Flip Register 10 */
#define MC86_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00666b6u)	/* Read Data and Bit Flip Register 11 */
#define MC86_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00666b8u)	/* Read Data and Bit Flip Register 12 */
#define MC86_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00666bau)	/* Read Data and Bit Flip Register 13 */
#define MC86_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00666bcu)	/* Read Data and Bit Flip Register 14 */
#define MC86_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00666beu)	/* Read Data and Bit Flip Register 15 */
#define MC86_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00666c0u)	/* Read Data and Bit Flip Register 16 */
#define MC86_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00666c2u)	/* Read Data and Bit Flip Register 17 */
#define MC86_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00666c4u)	/* Read Data and Bit Flip Register 18 */
#define MC86_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00666c6u)	/* Read Data and Bit Flip Register 19 */
#define MC86_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00666a4u)	/* Read Data and Bit Flip Register 2 */
#define MC86_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00666c8u)	/* Read Data and Bit Flip Register 20 */
#define MC86_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00666cau)	/* Read Data and Bit Flip Register 21 */
#define MC86_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00666ccu)	/* Read Data and Bit Flip Register 22 */
#define MC86_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00666ceu)	/* Read Data and Bit Flip Register 23 */
#define MC86_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00666d0u)	/* Read Data and Bit Flip Register 24 */
#define MC86_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00666d2u)	/* Read Data and Bit Flip Register 25 */
#define MC86_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00666d4u)	/* Read Data and Bit Flip Register 26 */
#define MC86_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00666d6u)	/* Read Data and Bit Flip Register 27 */
#define MC86_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00666d8u)	/* Read Data and Bit Flip Register 28 */
#define MC86_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00666dau)	/* Read Data and Bit Flip Register 29 */
#define MC86_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00666a6u)	/* Read Data and Bit Flip Register 3 */
#define MC86_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00666dcu)	/* Read Data and Bit Flip Register 30 */
#define MC86_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00666deu)	/* Read Data and Bit Flip Register 31 */
#define MC86_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00666e0u)	/* Read Data and Bit Flip Register 32 */
#define MC86_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00666e2u)	/* Read Data and Bit Flip Register 33 */
#define MC86_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00666e4u)	/* Read Data and Bit Flip Register 34 */
#define MC86_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00666e6u)	/* Read Data and Bit Flip Register 35 */
#define MC86_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00666e8u)	/* Read Data and Bit Flip Register 36 */
#define MC86_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00666eau)	/* Read Data and Bit Flip Register 37 */
#define MC86_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00666ecu)	/* Read Data and Bit Flip Register 38 */
#define MC86_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00666eeu)	/* Read Data and Bit Flip Register 39 */
#define MC86_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00666a8u)	/* Read Data and Bit Flip Register 4 */
#define MC86_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00666aau)	/* Read Data and Bit Flip Register 5 */
#define MC86_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00666acu)	/* Read Data and Bit Flip Register 6 */
#define MC86_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00666aeu)	/* Read Data and Bit Flip Register 7 */
#define MC86_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00666b0u)	/* Read Data and Bit Flip Register 8 */
#define MC86_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00666b2u)	/* Read Data and Bit Flip Register 9 */
#define MC87_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00667a0u)	/* Read Data and Bit Flip Register 0 */
#define MC87_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00667a2u)	/* Read Data and Bit Flip Register 1 */
#define MC87_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00667b4u)	/* Read Data and Bit Flip Register 10 */
#define MC87_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00667b6u)	/* Read Data and Bit Flip Register 11 */
#define MC87_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00667b8u)	/* Read Data and Bit Flip Register 12 */
#define MC87_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00667bau)	/* Read Data and Bit Flip Register 13 */
#define MC87_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00667bcu)	/* Read Data and Bit Flip Register 14 */
#define MC87_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00667beu)	/* Read Data and Bit Flip Register 15 */
#define MC87_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00667c0u)	/* Read Data and Bit Flip Register 16 */
#define MC87_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00667c2u)	/* Read Data and Bit Flip Register 17 */
#define MC87_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00667c4u)	/* Read Data and Bit Flip Register 18 */
#define MC87_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00667c6u)	/* Read Data and Bit Flip Register 19 */
#define MC87_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00667a4u)	/* Read Data and Bit Flip Register 2 */
#define MC87_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00667c8u)	/* Read Data and Bit Flip Register 20 */
#define MC87_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00667cau)	/* Read Data and Bit Flip Register 21 */
#define MC87_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00667ccu)	/* Read Data and Bit Flip Register 22 */
#define MC87_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00667ceu)	/* Read Data and Bit Flip Register 23 */
#define MC87_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00667d0u)	/* Read Data and Bit Flip Register 24 */
#define MC87_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00667d2u)	/* Read Data and Bit Flip Register 25 */
#define MC87_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00667d4u)	/* Read Data and Bit Flip Register 26 */
#define MC87_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00667d6u)	/* Read Data and Bit Flip Register 27 */
#define MC87_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00667d8u)	/* Read Data and Bit Flip Register 28 */
#define MC87_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00667dau)	/* Read Data and Bit Flip Register 29 */
#define MC87_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00667a6u)	/* Read Data and Bit Flip Register 3 */
#define MC87_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00667dcu)	/* Read Data and Bit Flip Register 30 */
#define MC87_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00667deu)	/* Read Data and Bit Flip Register 31 */
#define MC87_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00667e0u)	/* Read Data and Bit Flip Register 32 */
#define MC87_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00667e2u)	/* Read Data and Bit Flip Register 33 */
#define MC87_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00667e4u)	/* Read Data and Bit Flip Register 34 */
#define MC87_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00667e6u)	/* Read Data and Bit Flip Register 35 */
#define MC87_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00667e8u)	/* Read Data and Bit Flip Register 36 */
#define MC87_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00667eau)	/* Read Data and Bit Flip Register 37 */
#define MC87_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00667ecu)	/* Read Data and Bit Flip Register 38 */
#define MC87_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00667eeu)	/* Read Data and Bit Flip Register 39 */
#define MC87_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00667a8u)	/* Read Data and Bit Flip Register 4 */
#define MC87_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00667aau)	/* Read Data and Bit Flip Register 5 */
#define MC87_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00667acu)	/* Read Data and Bit Flip Register 6 */
#define MC87_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00667aeu)	/* Read Data and Bit Flip Register 7 */
#define MC87_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00667b0u)	/* Read Data and Bit Flip Register 8 */
#define MC87_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00667b2u)	/* Read Data and Bit Flip Register 9 */
#define MC8_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00618a0u)	/* Read Data and Bit Flip Register 0 */
#define MC8_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00618a2u)	/* Read Data and Bit Flip Register 1 */
#define MC8_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00618b4u)	/* Read Data and Bit Flip Register 10 */
#define MC8_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00618b6u)	/* Read Data and Bit Flip Register 11 */
#define MC8_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00618b8u)	/* Read Data and Bit Flip Register 12 */
#define MC8_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00618bau)	/* Read Data and Bit Flip Register 13 */
#define MC8_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00618bcu)	/* Read Data and Bit Flip Register 14 */
#define MC8_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00618beu)	/* Read Data and Bit Flip Register 15 */
#define MC8_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00618c0u)	/* Read Data and Bit Flip Register 16 */
#define MC8_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00618c2u)	/* Read Data and Bit Flip Register 17 */
#define MC8_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00618c4u)	/* Read Data and Bit Flip Register 18 */
#define MC8_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00618c6u)	/* Read Data and Bit Flip Register 19 */
#define MC8_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00618a4u)	/* Read Data and Bit Flip Register 2 */
#define MC8_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00618c8u)	/* Read Data and Bit Flip Register 20 */
#define MC8_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00618cau)	/* Read Data and Bit Flip Register 21 */
#define MC8_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00618ccu)	/* Read Data and Bit Flip Register 22 */
#define MC8_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00618ceu)	/* Read Data and Bit Flip Register 23 */
#define MC8_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00618d0u)	/* Read Data and Bit Flip Register 24 */
#define MC8_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00618d2u)	/* Read Data and Bit Flip Register 25 */
#define MC8_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00618d4u)	/* Read Data and Bit Flip Register 26 */
#define MC8_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00618d6u)	/* Read Data and Bit Flip Register 27 */
#define MC8_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00618d8u)	/* Read Data and Bit Flip Register 28 */
#define MC8_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00618dau)	/* Read Data and Bit Flip Register 29 */
#define MC8_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00618a6u)	/* Read Data and Bit Flip Register 3 */
#define MC8_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00618dcu)	/* Read Data and Bit Flip Register 30 */
#define MC8_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00618deu)	/* Read Data and Bit Flip Register 31 */
#define MC8_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00618e0u)	/* Read Data and Bit Flip Register 32 */
#define MC8_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00618e2u)	/* Read Data and Bit Flip Register 33 */
#define MC8_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00618e4u)	/* Read Data and Bit Flip Register 34 */
#define MC8_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00618e6u)	/* Read Data and Bit Flip Register 35 */
#define MC8_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00618e8u)	/* Read Data and Bit Flip Register 36 */
#define MC8_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00618eau)	/* Read Data and Bit Flip Register 37 */
#define MC8_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00618ecu)	/* Read Data and Bit Flip Register 38 */
#define MC8_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00618eeu)	/* Read Data and Bit Flip Register 39 */
#define MC8_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00618a8u)	/* Read Data and Bit Flip Register 4 */
#define MC8_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00618aau)	/* Read Data and Bit Flip Register 5 */
#define MC8_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00618acu)	/* Read Data and Bit Flip Register 6 */
#define MC8_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00618aeu)	/* Read Data and Bit Flip Register 7 */
#define MC8_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00618b0u)	/* Read Data and Bit Flip Register 8 */
#define MC8_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00618b2u)	/* Read Data and Bit Flip Register 9 */
#define MC9_RDBFL0	(*( MC0_RDBFL0_type *) 0xf00619a0u)	/* Read Data and Bit Flip Register 0 */
#define MC9_RDBFL1	(*( MC0_RDBFL0_type *) 0xf00619a2u)	/* Read Data and Bit Flip Register 1 */
#define MC9_RDBFL10	(*( MC0_RDBFL0_type *) 0xf00619b4u)	/* Read Data and Bit Flip Register 10 */
#define MC9_RDBFL11	(*( MC0_RDBFL0_type *) 0xf00619b6u)	/* Read Data and Bit Flip Register 11 */
#define MC9_RDBFL12	(*( MC0_RDBFL0_type *) 0xf00619b8u)	/* Read Data and Bit Flip Register 12 */
#define MC9_RDBFL13	(*( MC0_RDBFL0_type *) 0xf00619bau)	/* Read Data and Bit Flip Register 13 */
#define MC9_RDBFL14	(*( MC0_RDBFL0_type *) 0xf00619bcu)	/* Read Data and Bit Flip Register 14 */
#define MC9_RDBFL15	(*( MC0_RDBFL0_type *) 0xf00619beu)	/* Read Data and Bit Flip Register 15 */
#define MC9_RDBFL16	(*( MC0_RDBFL0_type *) 0xf00619c0u)	/* Read Data and Bit Flip Register 16 */
#define MC9_RDBFL17	(*( MC0_RDBFL0_type *) 0xf00619c2u)	/* Read Data and Bit Flip Register 17 */
#define MC9_RDBFL18	(*( MC0_RDBFL0_type *) 0xf00619c4u)	/* Read Data and Bit Flip Register 18 */
#define MC9_RDBFL19	(*( MC0_RDBFL0_type *) 0xf00619c6u)	/* Read Data and Bit Flip Register 19 */
#define MC9_RDBFL2	(*( MC0_RDBFL0_type *) 0xf00619a4u)	/* Read Data and Bit Flip Register 2 */
#define MC9_RDBFL20	(*( MC0_RDBFL0_type *) 0xf00619c8u)	/* Read Data and Bit Flip Register 20 */
#define MC9_RDBFL21	(*( MC0_RDBFL0_type *) 0xf00619cau)	/* Read Data and Bit Flip Register 21 */
#define MC9_RDBFL22	(*( MC0_RDBFL0_type *) 0xf00619ccu)	/* Read Data and Bit Flip Register 22 */
#define MC9_RDBFL23	(*( MC0_RDBFL0_type *) 0xf00619ceu)	/* Read Data and Bit Flip Register 23 */
#define MC9_RDBFL24	(*( MC0_RDBFL0_type *) 0xf00619d0u)	/* Read Data and Bit Flip Register 24 */
#define MC9_RDBFL25	(*( MC0_RDBFL0_type *) 0xf00619d2u)	/* Read Data and Bit Flip Register 25 */
#define MC9_RDBFL26	(*( MC0_RDBFL0_type *) 0xf00619d4u)	/* Read Data and Bit Flip Register 26 */
#define MC9_RDBFL27	(*( MC0_RDBFL0_type *) 0xf00619d6u)	/* Read Data and Bit Flip Register 27 */
#define MC9_RDBFL28	(*( MC0_RDBFL0_type *) 0xf00619d8u)	/* Read Data and Bit Flip Register 28 */
#define MC9_RDBFL29	(*( MC0_RDBFL0_type *) 0xf00619dau)	/* Read Data and Bit Flip Register 29 */
#define MC9_RDBFL3	(*( MC0_RDBFL0_type *) 0xf00619a6u)	/* Read Data and Bit Flip Register 3 */
#define MC9_RDBFL30	(*( MC0_RDBFL0_type *) 0xf00619dcu)	/* Read Data and Bit Flip Register 30 */
#define MC9_RDBFL31	(*( MC0_RDBFL0_type *) 0xf00619deu)	/* Read Data and Bit Flip Register 31 */
#define MC9_RDBFL32	(*( MC0_RDBFL0_type *) 0xf00619e0u)	/* Read Data and Bit Flip Register 32 */
#define MC9_RDBFL33	(*( MC0_RDBFL0_type *) 0xf00619e2u)	/* Read Data and Bit Flip Register 33 */
#define MC9_RDBFL34	(*( MC0_RDBFL0_type *) 0xf00619e4u)	/* Read Data and Bit Flip Register 34 */
#define MC9_RDBFL35	(*( MC0_RDBFL0_type *) 0xf00619e6u)	/* Read Data and Bit Flip Register 35 */
#define MC9_RDBFL36	(*( MC0_RDBFL0_type *) 0xf00619e8u)	/* Read Data and Bit Flip Register 36 */
#define MC9_RDBFL37	(*( MC0_RDBFL0_type *) 0xf00619eau)	/* Read Data and Bit Flip Register 37 */
#define MC9_RDBFL38	(*( MC0_RDBFL0_type *) 0xf00619ecu)	/* Read Data and Bit Flip Register 38 */
#define MC9_RDBFL39	(*( MC0_RDBFL0_type *) 0xf00619eeu)	/* Read Data and Bit Flip Register 39 */
#define MC9_RDBFL4	(*( MC0_RDBFL0_type *) 0xf00619a8u)	/* Read Data and Bit Flip Register 4 */
#define MC9_RDBFL5	(*( MC0_RDBFL0_type *) 0xf00619aau)	/* Read Data and Bit Flip Register 5 */
#define MC9_RDBFL6	(*( MC0_RDBFL0_type *) 0xf00619acu)	/* Read Data and Bit Flip Register 6 */
#define MC9_RDBFL7	(*( MC0_RDBFL0_type *) 0xf00619aeu)	/* Read Data and Bit Flip Register 7 */
#define MC9_RDBFL8	(*( MC0_RDBFL0_type *) 0xf00619b0u)	/* Read Data and Bit Flip Register 8 */
#define MC9_RDBFL9	(*( MC0_RDBFL0_type *) 0xf00619b2u)	/* Read Data and Bit Flip Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int REV_ID         : 16;	/* Revision Identifier */
	} B;
	short S;
	unsigned short US;

} MC0_REVID_type;
#define MC0_REVID	(*( MC0_REVID_type *) 0xf006100cu)	/* Revision ID Register */
#define MC10_REVID	(*( MC0_REVID_type *) 0xf0061a0cu)	/* Revision ID Register */
#define MC11_REVID	(*( MC0_REVID_type *) 0xf0061b0cu)	/* Revision ID Register */
#define MC12_REVID	(*( MC0_REVID_type *) 0xf0061c0cu)	/* Revision ID Register */
#define MC13_REVID	(*( MC0_REVID_type *) 0xf0061d0cu)	/* Revision ID Register */
#define MC14_REVID	(*( MC0_REVID_type *) 0xf0061e0cu)	/* Revision ID Register */
#define MC15_REVID	(*( MC0_REVID_type *) 0xf0061f0cu)	/* Revision ID Register */
#define MC16_REVID	(*( MC0_REVID_type *) 0xf006200cu)	/* Revision ID Register */
#define MC17_REVID	(*( MC0_REVID_type *) 0xf006210cu)	/* Revision ID Register */
#define MC18_REVID	(*( MC0_REVID_type *) 0xf006220cu)	/* Revision ID Register */
#define MC19_REVID	(*( MC0_REVID_type *) 0xf006230cu)	/* Revision ID Register */
#define MC1_REVID	(*( MC0_REVID_type *) 0xf006110cu)	/* Revision ID Register */
#define MC20_REVID	(*( MC0_REVID_type *) 0xf006240cu)	/* Revision ID Register */
#define MC21_REVID	(*( MC0_REVID_type *) 0xf006250cu)	/* Revision ID Register */
#define MC22_REVID	(*( MC0_REVID_type *) 0xf006260cu)	/* Revision ID Register */
#define MC23_REVID	(*( MC0_REVID_type *) 0xf006270cu)	/* Revision ID Register */
#define MC24_REVID	(*( MC0_REVID_type *) 0xf006280cu)	/* Revision ID Register */
#define MC25_REVID	(*( MC0_REVID_type *) 0xf006290cu)	/* Revision ID Register */
#define MC26_REVID	(*( MC0_REVID_type *) 0xf0062a0cu)	/* Revision ID Register */
#define MC27_REVID	(*( MC0_REVID_type *) 0xf0062b0cu)	/* Revision ID Register */
#define MC28_REVID	(*( MC0_REVID_type *) 0xf0062c0cu)	/* Revision ID Register */
#define MC29_REVID	(*( MC0_REVID_type *) 0xf0062d0cu)	/* Revision ID Register */
#define MC2_REVID	(*( MC0_REVID_type *) 0xf006120cu)	/* Revision ID Register */
#define MC30_REVID	(*( MC0_REVID_type *) 0xf0062e0cu)	/* Revision ID Register */
#define MC31_REVID	(*( MC0_REVID_type *) 0xf0062f0cu)	/* Revision ID Register */
#define MC32_REVID	(*( MC0_REVID_type *) 0xf006300cu)	/* Revision ID Register */
#define MC33_REVID	(*( MC0_REVID_type *) 0xf006310cu)	/* Revision ID Register */
#define MC34_REVID	(*( MC0_REVID_type *) 0xf006320cu)	/* Revision ID Register */
#define MC35_REVID	(*( MC0_REVID_type *) 0xf006330cu)	/* Revision ID Register */
#define MC36_REVID	(*( MC0_REVID_type *) 0xf006340cu)	/* Revision ID Register */
#define MC37_REVID	(*( MC0_REVID_type *) 0xf006350cu)	/* Revision ID Register */
#define MC38_REVID	(*( MC0_REVID_type *) 0xf006360cu)	/* Revision ID Register */
#define MC39_REVID	(*( MC0_REVID_type *) 0xf006370cu)	/* Revision ID Register */
#define MC3_REVID	(*( MC0_REVID_type *) 0xf006130cu)	/* Revision ID Register */
#define MC40_REVID	(*( MC0_REVID_type *) 0xf006380cu)	/* Revision ID Register */
#define MC41_REVID	(*( MC0_REVID_type *) 0xf006390cu)	/* Revision ID Register */
#define MC42_REVID	(*( MC0_REVID_type *) 0xf0063a0cu)	/* Revision ID Register */
#define MC43_REVID	(*( MC0_REVID_type *) 0xf0063b0cu)	/* Revision ID Register */
#define MC44_REVID	(*( MC0_REVID_type *) 0xf0063c0cu)	/* Revision ID Register */
#define MC45_REVID	(*( MC0_REVID_type *) 0xf0063d0cu)	/* Revision ID Register */
#define MC46_REVID	(*( MC0_REVID_type *) 0xf0063e0cu)	/* Revision ID Register */
#define MC47_REVID	(*( MC0_REVID_type *) 0xf0063f0cu)	/* Revision ID Register */
#define MC48_REVID	(*( MC0_REVID_type *) 0xf006400cu)	/* Revision ID Register */
#define MC49_REVID	(*( MC0_REVID_type *) 0xf006410cu)	/* Revision ID Register */
#define MC4_REVID	(*( MC0_REVID_type *) 0xf006140cu)	/* Revision ID Register */
#define MC50_REVID	(*( MC0_REVID_type *) 0xf006420cu)	/* Revision ID Register */
#define MC51_REVID	(*( MC0_REVID_type *) 0xf006430cu)	/* Revision ID Register */
#define MC52_REVID	(*( MC0_REVID_type *) 0xf006440cu)	/* Revision ID Register */
#define MC53_REVID	(*( MC0_REVID_type *) 0xf006450cu)	/* Revision ID Register */
#define MC54_REVID	(*( MC0_REVID_type *) 0xf006460cu)	/* Revision ID Register */
#define MC55_REVID	(*( MC0_REVID_type *) 0xf006470cu)	/* Revision ID Register */
#define MC56_REVID	(*( MC0_REVID_type *) 0xf006480cu)	/* Revision ID Register */
#define MC57_REVID	(*( MC0_REVID_type *) 0xf006490cu)	/* Revision ID Register */
#define MC58_REVID	(*( MC0_REVID_type *) 0xf0064a0cu)	/* Revision ID Register */
#define MC59_REVID	(*( MC0_REVID_type *) 0xf0064b0cu)	/* Revision ID Register */
#define MC5_REVID	(*( MC0_REVID_type *) 0xf006150cu)	/* Revision ID Register */
#define MC60_REVID	(*( MC0_REVID_type *) 0xf0064c0cu)	/* Revision ID Register */
#define MC61_REVID	(*( MC0_REVID_type *) 0xf0064d0cu)	/* Revision ID Register */
#define MC62_REVID	(*( MC0_REVID_type *) 0xf0064e0cu)	/* Revision ID Register */
#define MC63_REVID	(*( MC0_REVID_type *) 0xf0064f0cu)	/* Revision ID Register */
#define MC64_REVID	(*( MC0_REVID_type *) 0xf006500cu)	/* Revision ID Register */
#define MC65_REVID	(*( MC0_REVID_type *) 0xf006510cu)	/* Revision ID Register */
#define MC66_REVID	(*( MC0_REVID_type *) 0xf006520cu)	/* Revision ID Register */
#define MC67_REVID	(*( MC0_REVID_type *) 0xf006530cu)	/* Revision ID Register */
#define MC68_REVID	(*( MC0_REVID_type *) 0xf006540cu)	/* Revision ID Register */
#define MC69_REVID	(*( MC0_REVID_type *) 0xf006550cu)	/* Revision ID Register */
#define MC6_REVID	(*( MC0_REVID_type *) 0xf006160cu)	/* Revision ID Register */
#define MC70_REVID	(*( MC0_REVID_type *) 0xf006560cu)	/* Revision ID Register */
#define MC71_REVID	(*( MC0_REVID_type *) 0xf006570cu)	/* Revision ID Register */
#define MC72_REVID	(*( MC0_REVID_type *) 0xf006580cu)	/* Revision ID Register */
#define MC73_REVID	(*( MC0_REVID_type *) 0xf006590cu)	/* Revision ID Register */
#define MC74_REVID	(*( MC0_REVID_type *) 0xf0065a0cu)	/* Revision ID Register */
#define MC75_REVID	(*( MC0_REVID_type *) 0xf0065b0cu)	/* Revision ID Register */
#define MC76_REVID	(*( MC0_REVID_type *) 0xf0065c0cu)	/* Revision ID Register */
#define MC77_REVID	(*( MC0_REVID_type *) 0xf0065d0cu)	/* Revision ID Register */
#define MC78_REVID	(*( MC0_REVID_type *) 0xf0065e0cu)	/* Revision ID Register */
#define MC79_REVID	(*( MC0_REVID_type *) 0xf0065f0cu)	/* Revision ID Register */
#define MC7_REVID	(*( MC0_REVID_type *) 0xf006170cu)	/* Revision ID Register */
#define MC80_REVID	(*( MC0_REVID_type *) 0xf006600cu)	/* Revision ID Register */
#define MC81_REVID	(*( MC0_REVID_type *) 0xf006610cu)	/* Revision ID Register */
#define MC82_REVID	(*( MC0_REVID_type *) 0xf006620cu)	/* Revision ID Register */
#define MC83_REVID	(*( MC0_REVID_type *) 0xf006630cu)	/* Revision ID Register */
#define MC84_REVID	(*( MC0_REVID_type *) 0xf006640cu)	/* Revision ID Register */
#define MC85_REVID	(*( MC0_REVID_type *) 0xf006650cu)	/* Revision ID Register */
#define MC86_REVID	(*( MC0_REVID_type *) 0xf006660cu)	/* Revision ID Register */
#define MC87_REVID	(*( MC0_REVID_type *) 0xf006670cu)	/* Revision ID Register */
#define MC8_REVID	(*( MC0_REVID_type *) 0xf006180cu)	/* Revision ID Register */
#define MC9_REVID	(*( MC0_REVID_type *) 0xf006190cu)	/* Revision ID Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} MTU_ACCEN0_type;
#define MTU_ACCEN0	(*( MTU_ACCEN0_type *) 0xf00600fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Res            : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} MTU_ACCEN1_type;
#define MTU_ACCEN1	(*( MTU_ACCEN1_type *) 0xf00600f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} MTU_ID_type;
#define MTU_ID	(*( MTU_ID_type *) 0xf0060008u)	/* Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MEM0AIU        : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM1AIU        : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM2AIU        : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM3AIU        : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM4AIU        : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM5AIU        : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM6AIU        : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM7AIU        : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM8AIU        : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM9AIU        : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM10AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM11AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM12AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM13AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM14AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM15AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM16AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM17AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM18AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM19AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM20AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM21AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM22AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM23AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM24AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM25AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM26AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM27AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM28AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM29AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM30AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM31AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
	} B;
	int I;
	unsigned int U;

} MTU_MEMSTAT0_type;
#define MTU_MEMSTAT0	(*( MTU_MEMSTAT0_type *) 0xf0060038u)	/* Memory Autoinitialize Status Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int MEM32AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM33AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM34AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM35AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM36AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM37AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM38AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM39AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM40AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM41AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM42AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM43AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM44AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM45AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM46AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM47AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM48AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM49AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM50AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM51AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM52AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM53AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM54AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM55AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM56AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM57AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM58AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM59AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM60AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM61AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM62AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM63AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
	} B;
	int I;
	unsigned int U;

} MTU_MEMSTAT1_type;
#define MTU_MEMSTAT1	(*( MTU_MEMSTAT1_type *) 0xf006003cu)	/* Memory Autoinitialize Status Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int MEM64AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM65AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM66AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM67AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM68AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM69AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM70AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM71AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM72AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM73AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM74AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM75AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM76AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM77AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM78AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM79AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM80AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM81AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM82AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM83AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM84AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM85AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM86AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int MEM87AIU       : 1;	/* Memory x MBIST AutoInitialize Underway */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} MTU_MEMSTAT2_type;
#define MTU_MEMSTAT2	(*( MTU_MEMSTAT2_type *) 0xf0060040u)	/* Memory Autoinitialize Status Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int CPU2DSEN       : 1;	/* CPU2 DSPR MBIST Controller Memory Enable */
		unsigned int CPU2DCEN       : 1;	/* CPU2 DCACHE MBIST Controller Memory Enable */
		unsigned int CPU2DTEN       : 1;	/* CPU2 DTAG MBIST Controller Memory Enable */
		unsigned int CPU2PSEN       : 1;	/* CPU2 PSPR MBIST Controller Memory Enable */
		unsigned int CPU2PCEN       : 1;	/* CPU2 PCACHE MBIST Controller Memory Enable */
		unsigned int CPU2PTEN       : 1;	/* CPU2 PTAG MBIST Controller Memory Enable */
		unsigned int CPU1DSEN       : 1;	/* CPU1 DSPR MBIST Controller Memory Enable */
		unsigned int CPU1DCEN       : 1;	/* CPU1 DCACHE MBIST Controller Memory Enable */
		unsigned int CPU1DTEN       : 1;	/* CPU1 DTAG MBIST Controller Memory Enable */
		unsigned int CPU1PSEN       : 1;	/* CPU1 PSPR MBIST Controller Memory Enable */
		unsigned int CPU1PCEN       : 1;	/* CPU1 PCACHE MBIST Controller Memory Enable */
		unsigned int CPU1PTEN       : 1;	/* CPU1 PTAG MBIST Controller Memory Enable */
		unsigned int Res            : 1;	/* Reserved */
		unsigned int Res_14         : 1;	/* Reserved */
		unsigned int CPU0DSEN       : 1;	/* CPU0 DSPR MBIST Controller Memory Enable */
		unsigned int CPU0PCEN       : 1;	/* CPU0 PCACHE MBIST Controller Memory Enable */
		unsigned int CPU0PSEN       : 1;	/* CPU0 PSPR MBIST Controller Memory Enable */
		unsigned int CPU0PTEN       : 1;	/* CPU0 PTAG MBIST Controller Memory Enable */
		unsigned int Res_19         : 4;	/* Reserved */
		unsigned int ETHEN          : 1;	/* ETHERMAC MBIST Controller Memory Enable */
		unsigned int HSMCEN         : 1;	/* HSM CACHE MBIST Controller Memory Enable */
		unsigned int HSMTEN         : 1;	/* HSM TAG MBIST Controller Memory Enable */
		unsigned int HSMREN         : 1;	/* HSM RAM MBIST Controller Memory Enable */
		unsigned int FSI0EN         : 1;	/* FSI0 MBIST Controller Memory Enable */
		unsigned int Res_25         : 1;	/* Reserved */
		unsigned int GTMFEN         : 1;	/* GTM FIFO0 MBIST Controller Memory Enable */
		unsigned int GTMM0EN        : 1;	/* GTM MCS0 MBIST Controller Memory Enable */
		unsigned int GTMM1EN        : 1;	/* GTM RAM1 MBIST Controller Memory Enable */
		unsigned int GTM1AEN        : 1;	/* GTM RAM1A MBIST Controller Memory Enable */
	} B;
	int I;
	unsigned int U;

} MTU_MEMTEST0_type;
#define MTU_MEMTEST0	(*( MTU_MEMTEST0_type *) 0xf0060010u)	/* Memory MBIST Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int GTM1BEN        : 1;	/* GTM RAM1B Controller Memory Enable */
		unsigned int GTM2EN         : 1;	/* GTM RAM2 Controller Memory Enable */
		unsigned int PSI5EN         : 1;	/* PSI5 Controller Memory Enable */
		unsigned int BMUEN          : 1;	/* BMU Controller Memory Enable */
		unsigned int MCAN0EN        : 1;	/* GTM RAM1B Controller Memory Enable */
		unsigned int Res            : 1;	/* Reserved */
		unsigned int ERAY0OEN       : 1;	/* ERAY0 OBF Controller Memory Enable */
		unsigned int ERAY0TEN       : 1;	/* ERAY0 TBF Controller Memory Enable */
		unsigned int ERAY0MEN       : 1;	/* ERAY0 MBF Controller Memory Enable */
		unsigned int Res_10         : 3;	/* Reserved */
		unsigned int Res_11         : 1;	/* Reserved */
		unsigned int MCDSEN         : 1;	/* MCDS Controller Memory Enable (ED only) */
		unsigned int EMEML0EN       : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML1EN       : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML2EN       : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML3EN       : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML4EN       : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML5EN       : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML6EN       : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML7EN       : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML8EN       : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML9EN       : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML10EN      : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML11EN      : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML12EN      : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML13EN      : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML14EN      : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int EMEML15EN      : 1;	/* EMEM Lower x MBIST Controller Memory Test Enable (ED only) */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} MTU_MEMTEST1_type;
#define MTU_MEMTEST1	(*( MTU_MEMTEST1_type *) 0xf0060014u)	/* Memory MBIST Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int Res            : 14;	/* Reserved */
		unsigned int CIF0EN         : 1;	/* CIF JPEG1_4 Memory Enable (ED only) */
		unsigned int DAMEN          : 1;	/* DAM Memory Enable */
		unsigned int CIF1EN         : 1;	/* CIF JPEG3 Memory Enable (ED only) */
		unsigned int CIF2EN         : 1;	/* CIF Memory2 Enable (ED only) */
		unsigned int Res_6          : 1;	/* Reserved */
		unsigned int Res_7          : 5;	/* Reserved */
		/* const */ unsigned int Res_8          : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} MTU_MEMTEST2_type;
#define MTU_MEMTEST2	(*( MTU_MEMTEST2_type *) 0xf0060018u)	/* Memory MBIST Enable Register 2 */


/* BUS */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} SBCU_ACCEN0_type;
#define SBCU_ACCEN0	(*( SBCU_ACCEN0_type *) 0xf00300fcu)	/* Access Enable Register 0 */
#define XBAR_ACCEN0	(*( SBCU_ACCEN0_type *) 0xf87004fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} SBCU_ACCEN1_type;
#define SBCU_ACCEN1	(*( SBCU_ACCEN1_type *) 0xf00300f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int TOUT           : 16;	/* SBCU Bus Time-Out Value */
		unsigned int DBG            : 1;	/* SBCU Debug Trace Enable */
		unsigned int                : 7;
		unsigned int SPC            : 8;	/* Starvation Period Control */
	} B;
	int I;
	unsigned int U;

} SBCU_CON_type;
#define SBCU_CON	(*( SBCU_CON_type *) 0xf0030010u)	/* SBCU Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADR1           : 32;	/* Debug Trigger Address 1 */
	} B;
	int I;
	unsigned int U;

} SBCU_DBADR1_type;
#define SBCU_DBADR1	(*( SBCU_DBADR1_type *) 0xf0030038u)	/* SBCU Debug Address 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADR2           : 32;	/* Debug Trigger Address 2 */
	} B;
	int I;
	unsigned int U;

} SBCU_DBADR2_type;
#define SBCU_DBADR2	(*( SBCU_DBADR2_type *) 0xf003003cu)	/* SBCU Debug Address 2 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int FPIADR         : 32;	/* FPIBus Address Status */
	} B;
	int I;
	unsigned int U;

} SBCU_DBADRT_type;
#define SBCU_DBADRT	(*( SBCU_DBADRT_type *) 0xf0030048u)	/* SBCU Debug Trapped Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int OPC            : 4;	/* Opcode for Signal Status Debug Trigger */
		unsigned int SVM            : 1;	/* SVM Signal for Status Debug Trigger */
		unsigned int                : 3;
		unsigned int WR             : 1;	/* Write Signal for Status Debug Trigger */
		unsigned int                : 3;
		unsigned int RD             : 1;	/* Write Signal for Status Debug Trigger */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} SBCU_DBBOS_type;
#define SBCU_DBBOS	(*( SBCU_DBBOS_type *) 0xf0030040u)	/* SBCU Debug Bus Operation Signals Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int FPIOPC         : 4;	/* FPIBus Opcode Status */
		/* const */ unsigned int FPISVM         : 1;	/* FPIBus Supervisor Mode Status */
		/* const */ unsigned int FPIACK         : 2;	/* FPIBus Acknowledge Status */
		/* const */ unsigned int FPIRDY         : 1;	/* FPIBus Ready Status */
		/* const */ unsigned int FPIWR          : 1;	/* FPIBus Write Indication Status */
		/* const */ unsigned int FPIRST         : 2;	/* FPIBus Reset Status */
		/* const */ unsigned int FPIOPS         : 1;	/* FPIBus OCDS Suspend Status */
		/* const */ unsigned int FPIRD          : 1;	/* FPIBus Read Indication Status */
		/* const */ unsigned int FPIABORT       : 1;	/* FPIBus Abort Status */
		/* const */ unsigned int FPITOUT        : 1;	/* FPIBus Time-out Status */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int FPITAG         : 6;	/* FPIBus Master TAG Status */
		/* const */ unsigned int                : 10;
	} B;
	int I;
	unsigned int U;

} SBCU_DBBOST_type;
#define SBCU_DBBOST	(*( SBCU_DBBOST_type *) 0xf003004cu)	/* SBCU Debug Trapped Bus Operation Signals Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int EO             : 1;	/* Status of SBCU Debug Support Enable */
		/* const */ unsigned int OA             : 1;	/* Status of SBCU Breakpoint Logic */
		unsigned int                : 2;
		unsigned int RA             : 1;	/* Rearm SBCU Breakpoint Logic */
		unsigned int                : 7;
		unsigned int CONCOM0        : 1;	/* Grant and Address Trigger Relation */
		unsigned int CONCOM1        : 1;	/* Address 1 and Address 2 Trigger Relation */
		unsigned int CONCOM2        : 1;	/* Address and Signal Trigger Relation */
		unsigned int                : 1;
		unsigned int ONG            : 1;	/* Grant Trigger Enable */
		unsigned int                : 3;
		unsigned int ONA1           : 2;	/* Address 1 Trigger Control */
		unsigned int                : 2;
		unsigned int ONA2           : 2;	/* Address 2 Trigger Control */
		unsigned int                : 2;
		unsigned int ONBOS0         : 1;	/* Opcode Signal Status Trigger Condition */
		unsigned int ONBOS1         : 1;	/* Supervisor Mode Signal Trigger Condition */
		unsigned int ONBOS2         : 1;	/* Write Signal Trigger Condition */
		unsigned int ONBOS3         : 1;	/* Read Signal Trigger Condition */
	} B;
	int I;
	unsigned int U;

} SBCU_DBCNTL_type;
#define SBCU_DBCNTL	(*( SBCU_DBCNTL_type *) 0xf0030030u)	/* SBCU Debug Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int FPIDATA        : 32;	/* FPIBus Data Status */
	} B;
	int I;
	unsigned int U;

} SBCU_DBDAT_type;
#define SBCU_DBDAT	(*( SBCU_DBDAT_type *) 0xf0030050u)	/* SBCU Debug Data Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SDMAH          : 1;	/* High-Priority SDMA FPIBus Master StatusIncluding SDMA transactions from SDMA channels with high priority and from Cerberus with high priority */
		unsigned int ONE            : 1;	/* Reserved */
		unsigned int ETH            : 1;	/* Ethernet FPIBus Master Status */
		unsigned int ONE_4          : 1;	/* Reserved */
		unsigned int DMA            : 1;	/* DMA FPIBus Master Status */
		unsigned int SDMAM          : 1;	/* Medium-Priority SDMA FPIBus Master StatusIncluding DMA transactions from DMA channels with medium priority */
		unsigned int ONE_7          : 2;	/* Reserved */
		unsigned int CPU0           : 1;	/* CPU0 FPIBus Master Status */
		unsigned int CPU1           : 1;	/* CPU1 FPIBus Master Status */
		unsigned int SFI            : 1;	/* SFI Bridge FPIBus Master Status */
		unsigned int ONE_11         : 1;	/* Reserved */
		unsigned int HSMRMI         : 1;	/* HSM Register FPIBus Master Interface Status */
		unsigned int HSMCMI         : 1;	/* HSM Cache FPIBus Master Interface Status */
		unsigned int ONE_14         : 1;	/* Reserved */
		unsigned int SDMAL          : 1;	/* Low-Priority SDMA FPIBus Master StatusIncluding DMA transactions from DMA channels with low priority, MLI and from Cerberus with low priority */
		unsigned int SDMACHNR       : 8;	/* SDMA-FPI Channel Grant Status */
		unsigned int DMACHNR        : 8;	/* DMA-FPI Channel Grant Status */
	} B;
	int I;
	unsigned int U;

} SBCU_DBGNTT_type;
#define SBCU_DBGNTT	(*( SBCU_DBGNTT_type *) 0xf0030044u)	/* SBCU Debug Trapped Master Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SDMAH          : 1;	/* Cerberus Grant Trigger Enable, High PriorityIncluding SDMA transactions from SDMA channels with high priority and from Cerberus with high priority */
		unsigned int ONE            : 1;	/* Reserved */
		unsigned int ETH            : 1;	/* Ethernet Trigger Enable, High PriorityIncluding SDMA transactions from SDMA channels with high priority and from Cerberus with high priority */
		unsigned int ONE_4          : 1;	/* Reserved */
		unsigned int DMA            : 1;	/* DMA Grant Trigger Enable */
		unsigned int SDMAM          : 1;	/* SDMA Grant Trigger Enable, Medium PriorityIncluding SDMA transactions from SDMA channels with medium priority */
		unsigned int ONE_7          : 2;	/* Reserved */
		unsigned int CPU0           : 1;	/* CPU0 Grant Trigger Enable */
		unsigned int CPU1           : 1;	/* CPU1 Grant Trigger Enable */
		unsigned int SFI            : 1;	/* SFI Bridge Grant Trigger Enable */
		unsigned int ONE_11         : 1;	/* Reserved */
		unsigned int HSMRMI         : 1;	/* HSM Register Master Interface Grant Trigger Enable */
		unsigned int HSMCMI         : 1;	/* HSM Cache Master Interface Grant Trigger Enable */
		unsigned int ONE_14         : 1;	/* Reserved */
		unsigned int SDMAL          : 1;	/* DMA Grant Trigger Enable, Low PriorityIncluding SDMA transactions from SDMA channels with low priority, MLI and from Cerberus with low priority */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SBCU_DBGRNT_type;
#define SBCU_DBGRNT	(*( SBCU_DBGRNT_type *) 0xf0030034u)	/* SBCU Debug Grant Mask Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FPIADR         : 32;	/* Captured FPIBus Address */
	} B;
	int I;
	unsigned int U;

} SBCU_EADD_type;
#define SBCU_EADD	(*( SBCU_EADD_type *) 0xf0030024u)	/* SBCU Error Address Capture Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ERRCNT         : 14;	/* FPIBus Error Counter */
		unsigned int TOUT           : 1;	/* State of FPIBus Time-Out Signal */
		unsigned int RDY            : 1;	/* State of FPIBus Ready Signal */
		unsigned int ABT            : 1;	/* State of FPI Bus Abort Signal */
		unsigned int ACK            : 2;	/* State of FPIBus Acknowledge Signals */
		unsigned int SVM            : 1;	/* State of FPIBus Supervisor Mode Signal */
		unsigned int WRN            : 1;	/* State of FPIBus Write Signal */
		unsigned int RDN            : 1;	/* State of FPIBus Read Signal */
		unsigned int TAG            : 6;	/* FPIBus Master Tag Number Signals */
		unsigned int OPC            : 4;	/* FPIBus Operation Code Signals */
	} B;
	int I;
	unsigned int U;

} SBCU_ECON_type;
#define SBCU_ECON	(*( SBCU_ECON_type *) 0xf0030020u)	/* SBCU Error Control Capture Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FPIDAT         : 32;	/* Captured FPIBus Data */
	} B;
	int I;
	unsigned int U;

} SBCU_EDAT_type;
#define SBCU_EDAT	(*( SBCU_EDAT_type *) 0xf0030028u)	/* SBCU Error Data Capture Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODNUMBER      : 8;	/* Module Number Value */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SBCU_ID_type;
#define SBCU_ID	(*( SBCU_ID_type *) 0xf0030008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CPU0           : 4;	/* Master 8 Priority */
		unsigned int CPU1           : 4;	/* Master 9 Priority */
		unsigned int SFI            : 4;	/* Master 10 Priority */
		/* const */ unsigned int ONES           : 4;	/* Reserved */
		unsigned int HSMRMI         : 4;	/* Master 12 Priority */
		unsigned int HSMCMI         : 4;	/* Master 13 Priority */
		/* const */ unsigned int ONES_7         : 4;	/* Reserved */
		unsigned int SDMAL          : 4;	/* Master 15 Priority */
	} B;
	int I;
	unsigned int U;

} SBCU_PRIOH_type;
#define SBCU_PRIOH	(*( SBCU_PRIOH_type *) 0xf0030014u)	/* Arbiter Priority Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SDMAH          : 4;	/* Master 0 Priority */
		/* const */ unsigned int ONES           : 4;	/* Reserved */
		unsigned int ETH            : 4;	/* Master 2 Priority */
		/* const */ unsigned int ONES_4         : 4;	/* Reserved */
		unsigned int DMA            : 4;	/* Master 4 Priority */
		unsigned int SDMAM          : 4;	/* Master 5 Priority */
		/* const */ unsigned int ONES_7         : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} SBCU_PRIOL_type;
#define SBCU_PRIOL	(*( SBCU_PRIOL_type *) 0xf0030018u)	/* Arbiter Priority Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} XBAR_ACCEN1_type;
#define XBAR_ACCEN1	(*( XBAR_ACCEN1_type *) 0xf87004f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int PRERREN        : 1;	/* SRI Protocol Error Enable */
		unsigned int SCERREN        : 1;	/* SRI Starvation Error Enable */
		unsigned int SETPRINT       : 1;	/* Set SRI Protocol Interrupt */
		unsigned int SETSCINT       : 1;	/* Set SRI Starvation Interrupt */
		unsigned int INTACK         : 1;	/* Interrupt Acknowledge */
		unsigned int                : 15;
		unsigned int SPC            : 12;	/* Starvation Protection Counter Reload Value */
	} B;
	int I;
	unsigned int U;

} XBAR_ARBCON0_type;
#define XBAR_ARBCON0	(*( XBAR_ARBCON0_type *) 0xf8700044u)	/* Arbiter Control Register 0 */
#define XBAR_ARBCON1	(*( XBAR_ARBCON0_type *) 0xf8700084u)	/* Arbiter Control Register 1 */
#define XBAR_ARBCON2	(*( XBAR_ARBCON0_type *) 0xf87000c4u)	/* Arbiter Control Register 2 */
#define XBAR_ARBCON3	(*( XBAR_ARBCON0_type *) 0xf8700104u)	/* Arbiter Control Register 3 */
#define XBAR_ARBCON4	(*( XBAR_ARBCON0_type *) 0xf8700144u)	/* Arbiter Control Register 4 */
#define XBAR_ARBCON5	(*( XBAR_ARBCON0_type *) 0xf8700184u)	/* Arbiter Control Register 5 */
#define XBAR_ARBCON6	(*( XBAR_ARBCON0_type *) 0xf87001c4u)	/* Arbiter Control Register 6 */
#define XBAR_ARBCON7	(*( XBAR_ARBCON0_type *) 0xf8700204u)	/* Arbiter Control Register 7 */
#define XBAR_ARBCON8	(*( XBAR_ARBCON0_type *) 0xf8700244u)	/* Arbiter Control Register 8 */
#define XBAR_ARBCON9	(*( XBAR_ARBCON0_type *) 0xf8700284u)	/* Arbiter Control Register 9 */
#define XBAR_ARBCOND	(*( XBAR_ARBCON0_type *) 0xf8700004u)	/* Arbiter Control Register D */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 19;	/* Debug Address Boundary */
		unsigned int                : 7;
		/* const */ unsigned int ONE            : 3;	/* Reserved */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} XBAR_DBADD0_type;
#define XBAR_DBADD0	(*( XBAR_DBADD0_type *) 0xf870005cu)	/* Debug Address Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 27;
		unsigned int ADDRESS_27     : 2;	/* Debug Address Boundary */
		/* const */ unsigned int ONE            : 2;	/* Reserved */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} XBAR_DBADD1_type;
#define XBAR_DBADD1	(*( XBAR_DBADD1_type *) 0xf870009cu)	/* Debug Address Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 18;	/* Debug Address Boundary */
		unsigned int                : 9;
		/* const */ unsigned int ONE            : 2;	/* Reserved */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} XBAR_DBADD2_type;
#define XBAR_DBADD2	(*( XBAR_DBADD2_type *) 0xf87000dcu)	/* Debug Address Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 19;	/* Debug Address Boundary */
		unsigned int                : 7;
		/* const */ unsigned int ONE            : 1;	/* Reserved */
		unsigned int                : 1;
		/* const */ unsigned int ONE_3          : 1;	/* Reserved */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} XBAR_DBADD3_type;
#define XBAR_DBADD3	(*( XBAR_DBADD3_type *) 0xf870011cu)	/* Debug Address Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 18;	/* Debug Address Boundary */
		unsigned int                : 8;
		/* const */ unsigned int ONE            : 1;	/* Reserved */
		unsigned int                : 1;
		/* const */ unsigned int ONE_3          : 1;	/* Reserved */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} XBAR_DBADD4_type;
#define XBAR_DBADD4	(*( XBAR_DBADD4_type *) 0xf870015cu)	/* Debug Address Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 25;	/* Debug Address Boundary */
		unsigned int                : 1;
		/* const */ unsigned int ONE            : 4;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} XBAR_DBADD5_type;
#define XBAR_DBADD5	(*( XBAR_DBADD5_type *) 0xf870019cu)	/* Debug Address Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 29;	/* Debug Address Boundary */
		/* const */ unsigned int ONE            : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} XBAR_DBADD6_type;
#define XBAR_DBADD6	(*( XBAR_DBADD6_type *) 0xf87001dcu)	/* Debug Address Register 6 */
#define XBAR_DBMADD6	(*( XBAR_DBADD6_type *) 0xf87001e0u)	/* Debug Mask Address Register 6 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 25;	/* Debug Address Boundary */
		/* const */ unsigned int ONE            : 1;	/* Reserved */
		unsigned int ADDRESS_28     : 3;	/* Debug Address Boundary */
		/* const */ unsigned int ONE_4          : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} XBAR_DBADD7_type;
#define XBAR_DBADD7	(*( XBAR_DBADD7_type *) 0xf870021cu)	/* Debug Address Register 7 */
#define XBAR_DBMADD7	(*( XBAR_DBADD7_type *) 0xf8700220u)	/* Debug Mask Address Register 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 19;	/* Debug Address Boundary */
		/* const */ unsigned int ONE            : 1;	/* Reserved */
		unsigned int                : 7;
		unsigned int ADDRESS_29     : 1;	/* Debug Address Boundary */
		unsigned int                : 1;
		/* const */ unsigned int ONE_4          : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} XBAR_DBADD8_type;
#define XBAR_DBADD8	(*( XBAR_DBADD8_type *) 0xf870025cu)	/* Debug Address Register 8 */
#define XBAR_DBADD9	(*( XBAR_DBADD8_type *) 0xf870029cu)	/* Debug Address Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 30;	/* Debug Address Boundary */
	} B;
	int I;
	unsigned int U;

} XBAR_DBADDD_type;
#define XBAR_DBADDD	(*( XBAR_DBADDD_type *) 0xf870001cu)	/* Debug Address Register D */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DBEN           : 1;	/* Status of OCDS Enable Signal */
		/* const */ unsigned int DBSAT          : 1;	/* Debug OCDS Trigger Status */
		unsigned int REARM          : 1;	/* Rearm Debug OCDS Trigger */
		unsigned int SETDBEVT       : 1;	/* Set Debug Event */
		unsigned int                : 12;
		unsigned int RDEN           : 1;	/* Read Trigger Enable */
		unsigned int WREN           : 1;	/* Write Trigger Enable */
		unsigned int SVMEN          : 1;	/* SVM Trigger Enable */
		unsigned int ADDEN          : 1;	/* Address Trigger Enable */
		unsigned int ERREN          : 1;	/* Error Trigger Enable */
		unsigned int                : 2;
		unsigned int MASEN          : 1;	/* Master Trigger Enable */
		unsigned int MASTER         : 6;	/* Master TAG ID Trigger Selector */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} XBAR_DBCON0_type;
#define XBAR_DBCON0	(*( XBAR_DBCON0_type *) 0xf8700058u)	/* Debug Control Register 0 */
#define XBAR_DBCON1	(*( XBAR_DBCON0_type *) 0xf8700098u)	/* Debug Control Register 1 */
#define XBAR_DBCON2	(*( XBAR_DBCON0_type *) 0xf87000d8u)	/* Debug Control Register 2 */
#define XBAR_DBCON3	(*( XBAR_DBCON0_type *) 0xf8700118u)	/* Debug Control Register 3 */
#define XBAR_DBCON4	(*( XBAR_DBCON0_type *) 0xf8700158u)	/* Debug Control Register 4 */
#define XBAR_DBCON5	(*( XBAR_DBCON0_type *) 0xf8700198u)	/* Debug Control Register 5 */
#define XBAR_DBCON6	(*( XBAR_DBCON0_type *) 0xf87001d8u)	/* Debug Control Register 6 */
#define XBAR_DBCON7	(*( XBAR_DBCON0_type *) 0xf8700218u)	/* Debug Control Register 7 */
#define XBAR_DBCON8	(*( XBAR_DBCON0_type *) 0xf8700258u)	/* Debug Control Register 8 */
#define XBAR_DBCON9	(*( XBAR_DBCON0_type *) 0xf8700298u)	/* Debug Control Register 9 */
#define XBAR_DBCOND	(*( XBAR_DBCON0_type *) 0xf8700018u)	/* Debug Control Register D */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 19;	/* Debug Address Boundary */
		/* const */ unsigned int ONE            : 2;	/* Reserved */
		unsigned int                : 1;
		/* const */ unsigned int ONE_3          : 3;	/* Reserved */
		unsigned int                : 1;
		/* const */ unsigned int ONE_4          : 3;	/* Reserved */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} XBAR_DBMADD0_type;
#define XBAR_DBMADD0	(*( XBAR_DBMADD0_type *) 0xf8700060u)	/* Debug Mask Address Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 21;
		/* const */ unsigned int ONE            : 2;	/* Reserved */
		unsigned int                : 1;
		/* const */ unsigned int ONE_2          : 3;	/* Reserved */
		unsigned int ADDRESS_27     : 2;	/* Debug Address Boundary */
		/* const */ unsigned int ONE_4          : 2;	/* Reserved */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} XBAR_DBMADD1_type;
#define XBAR_DBMADD1	(*( XBAR_DBMADD1_type *) 0xf87000a0u)	/* Debug Mask Address Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 18;	/* Debug Address Boundary */
		/* const */ unsigned int ONE            : 12;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} XBAR_DBMADD2_type;
#define XBAR_DBMADD2	(*( XBAR_DBMADD2_type *) 0xf87000e0u)	/* Debug Mask Address Register 2 */
#define XBAR_DBMADD4	(*( XBAR_DBMADD2_type *) 0xf8700160u)	/* Debug Mask Address Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 19;	/* Debug Address Boundary */
		/* const */ unsigned int ONE            : 2;	/* Reserved */
		unsigned int                : 1;
		/* const */ unsigned int ONE_3          : 3;	/* Reserved */
		unsigned int                : 1;
		/* const */ unsigned int ONE_4          : 1;	/* Reserved */
		unsigned int                : 1;
		/* const */ unsigned int ONE_5          : 1;	/* Reserved */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} XBAR_DBMADD3_type;
#define XBAR_DBMADD3	(*( XBAR_DBMADD3_type *) 0xf8700120u)	/* Debug Mask Address Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 25;	/* Debug Address Boundary */
		/* const */ unsigned int ONE            : 5;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} XBAR_DBMADD5_type;
#define XBAR_DBMADD5	(*( XBAR_DBMADD5_type *) 0xf87001a0u)	/* Debug Mask Address Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDRESS_2      : 19;	/* Debug Address Boundary */
		/* const */ unsigned int ONE            : 8;	/* Reserved */
		unsigned int ADDRESS_29     : 1;	/* Debug Address Boundary */
		/* const */ unsigned int ONE_4          : 2;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} XBAR_DBMADD8_type;
#define XBAR_DBMADD8	(*( XBAR_DBMADD8_type *) 0xf8700260u)	/* Debug Mask Address Register 8 */
#define XBAR_DBMADD9	(*( XBAR_DBMADD8_type *) 0xf87002a0u)	/* Debug Mask Address Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRESS_0      : 32;	/* Debug Address Boundary */
	} B;
	int I;
	unsigned int U;

} XBAR_DBMADDD_type;
#define XBAR_DBMADDD	(*( XBAR_DBMADDD_type *) 0xf8700020u)	/* Debug Mask Address Register D */

typedef volatile union
{
	struct
	{ 
		unsigned int SCI0           : 1;	/* SCI Debug Trigger Event Status */
		unsigned int SCI1           : 1;	/* SCI Debug Trigger Event Status */
		unsigned int SCI2           : 1;	/* SCI Debug Trigger Event Status */
		unsigned int SCI3           : 1;	/* SCI Debug Trigger Event Status */
		unsigned int SCI4           : 1;	/* SCI Debug Trigger Event Status */
		unsigned int SCI5           : 1;	/* SCI Debug Trigger Event Status */
		unsigned int SCI6           : 1;	/* SCI Debug Trigger Event Status */
		unsigned int SCI7           : 1;	/* SCI Debug Trigger Event Status */
		unsigned int SCI8           : 1;	/* SCI Debug Trigger Event Status */
		unsigned int SCI9           : 1;	/* SCI Debug Trigger Event Status */
		unsigned int                : 5;
		unsigned int SCID           : 1;	/* Default Slave Debug Trigger Event Status */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} XBAR_DBSAT_type;
#define XBAR_DBSAT	(*( XBAR_DBSAT_type *) 0xf870040cu)	/* Debug Trigger Event Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RD             : 1;	/* Read Indication Status */
		/* const */ unsigned int WR             : 1;	/* Write Indication Status */
		/* const */ unsigned int SVM            : 1;	/* Supervisor Mode Indication Status */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int OPC            : 4;	/* Operation Code */
		/* const */ unsigned int TR_ID          : 8;	/* Transaction ID */
		/* const */ unsigned int ADDR_ECC       : 8;	/* SRI Address Phase Error Detection Information */
		/* const */ unsigned int MCI_SBS        : 8;	/* MCI Sideband Signals [7:0] */
	} B;
	int I;
	unsigned int U;

} XBAR_ERR0_type;
#define XBAR_ERR0	(*( XBAR_ERR0_type *) 0xf8700054u)	/* Error/Debug Capture Register 0 */
#define XBAR_ERR1	(*( XBAR_ERR0_type *) 0xf8700094u)	/* Error/Debug Capture Register 1 */
#define XBAR_ERR2	(*( XBAR_ERR0_type *) 0xf87000d4u)	/* Error/Debug Capture Register 2 */
#define XBAR_ERR3	(*( XBAR_ERR0_type *) 0xf8700114u)	/* Error/Debug Capture Register 3 */
#define XBAR_ERR4	(*( XBAR_ERR0_type *) 0xf8700154u)	/* Error/Debug Capture Register 4 */
#define XBAR_ERR5	(*( XBAR_ERR0_type *) 0xf8700194u)	/* Error/Debug Capture Register 5 */
#define XBAR_ERR6	(*( XBAR_ERR0_type *) 0xf87001d4u)	/* Error/Debug Capture Register 6 */
#define XBAR_ERR7	(*( XBAR_ERR0_type *) 0xf8700214u)	/* Error/Debug Capture Register 7 */
#define XBAR_ERR8	(*( XBAR_ERR0_type *) 0xf8700254u)	/* Error/Debug Capture Register 8 */
#define XBAR_ERR9	(*( XBAR_ERR0_type *) 0xf8700294u)	/* Error/Debug Capture Register 9 */
#define XBAR_ERRD	(*( XBAR_ERR0_type *) 0xf8700014u)	/* Error/Debug Capture Register D */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ADDR           : 32;	/* Transaction Address */
	} B;
	int I;
	unsigned int U;

} XBAR_ERRADDR0_type;
#define XBAR_ERRADDR0	(*( XBAR_ERRADDR0_type *) 0xf8700050u)	/* Error/Debug Address Capture Register 0 */
#define XBAR_ERRADDR1	(*( XBAR_ERRADDR0_type *) 0xf8700090u)	/* Error/Debug Address Capture Register 1 */
#define XBAR_ERRADDR3	(*( XBAR_ERRADDR0_type *) 0xf8700110u)	/* Error/Debug Address Capture Register 3 */
#define XBAR_ERRADDR4	(*( XBAR_ERRADDR0_type *) 0xf8700150u)	/* Error/Debug Address Capture Register 4 */
#define XBAR_ERRADDR5	(*( XBAR_ERRADDR0_type *) 0xf8700190u)	/* Error/Debug Address Capture Register 5 */
#define XBAR_ERRADDR6	(*( XBAR_ERRADDR0_type *) 0xf87001d0u)	/* Error/Debug Address Capture Register 6 */
#define XBAR_ERRADDR7	(*( XBAR_ERRADDR0_type *) 0xf8700210u)	/* Error/Debug Address Capture Register 7 */
#define XBAR_ERRADDR8	(*( XBAR_ERRADDR0_type *) 0xf8700250u)	/* Error/Debug Address Capture Register 8 */
#define XBAR_ERRADDR9	(*( XBAR_ERRADDR0_type *) 0xf8700290u)	/* Error/Debug Address Capture Register 9 */
#define XBAR_ERRADDRD	(*( XBAR_ERRADDR0_type *) 0xf8700010u)	/* Error/Debug Address Capture Register D */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int WFWD           : 1;	/* Wait for FPI Write Data */
		unsigned int FREQDISS       : 1;	/* Disable Fast Request Feature for SRI to FPI Transactions */
		unsigned int                : 1;
		unsigned int FREQDISF       : 1;	/* Disable Fast Request Feature for FPI to SRI Transactions */
		unsigned int                : 2;
		unsigned int NODELTR        : 1;	/* Control Signal for deferred transactions */
		unsigned int NORMW          : 1;	/* Control Signal for deferred transactions */
		unsigned int                : 1;
		unsigned int MAX_WS         : 4;	/* FPI-Bus Wait State Retry Ratio */
		unsigned int                : 4;
		unsigned int RETRY_CNT      : 4;	/* MIF_FPI Retry Idle Count */
		unsigned int NOPDIS         : 1;	/* NOP-Inclusion Disable */
		unsigned int                : 7;
	} B;
	int I;
	unsigned int U;

} XBAR_EXTCON5_type;
#define XBAR_EXTCON5	(*( XBAR_EXTCON5_type *) 0xf8700180u)	/* External Control Register 5 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} XBAR_ID_type;
#define XBAR_ID	(*( XBAR_ID_type *) 0xf8700408u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ENSCI0         : 1;	/* Enable ID Error from SCIn */
		unsigned int ENSCI1         : 1;	/* Enable ID Error from SCIn */
		unsigned int ENSCI2         : 1;	/* Enable ID Error from SCIn */
		unsigned int ENSCI3         : 1;	/* Enable ID Error from SCIn */
		unsigned int ENSCI4         : 1;	/* Enable ID Error from SCIn */
		unsigned int ENSCI5         : 1;	/* Enable ID Error from SCIn */
		unsigned int ENSCI6         : 1;	/* Enable ID Error from SCIn */
		unsigned int ENSCI7         : 1;	/* Enable ID Error from SCIn */
		unsigned int ENSCI8         : 1;	/* Enable ID Error from SCIn */
		unsigned int ENSCI9         : 1;	/* Enable ID Error from SCIn */
		unsigned int                : 5;
		unsigned int ENSCID         : 1;	/* Enable ID Error from Default Slave */
		unsigned int ENMCI0         : 1;	/* Enable ID Error from MCI0 */
		unsigned int                : 2;
		unsigned int ENMCI3         : 1;	/* Enable ID Error from MCIn */
		unsigned int ENMCI4         : 1;	/* Enable ID Error from MCIn */
		unsigned int ENMCI5         : 1;	/* Enable ID Error from MCIn */
		unsigned int ENMCI6         : 1;	/* Enable ID Error from MCIn */
		unsigned int ENMCI7         : 1;	/* Enable ID Error from MCIn */
		unsigned int ENMCI8         : 1;	/* Enable ID Error from MCIn */
		unsigned int ENMCI9         : 1;	/* Enable ID Error from MCIn */
		unsigned int ENMCI10        : 1;	/* Enable ID Error from MCIn */
		unsigned int ENMCI11        : 1;	/* Enable ID Error from MCIn */
		unsigned int ENMCI12        : 1;	/* Enable ID Error from MCIn */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} XBAR_IDINTEN_type;
#define XBAR_IDINTEN	(*( XBAR_IDINTEN_type *) 0xf8700418u)	/* Transaction ID Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IDSCI0         : 1;	/* Transaction ID Error from SCIn Status */
		unsigned int IDSCI1         : 1;	/* Transaction ID Error from SCIn Status */
		unsigned int IDSCI2         : 1;	/* Transaction ID Error from SCIn Status */
		unsigned int IDSCI3         : 1;	/* Transaction ID Error from SCIn Status */
		unsigned int IDSCI4         : 1;	/* Transaction ID Error from SCIn Status */
		unsigned int IDSCI5         : 1;	/* Transaction ID Error from SCIn Status */
		unsigned int IDSCI6         : 1;	/* Transaction ID Error from SCIn Status */
		unsigned int IDSCI7         : 1;	/* Transaction ID Error from SCIn Status */
		unsigned int IDSCI8         : 1;	/* Transaction ID Error from SCIn Status */
		unsigned int IDSCI9         : 1;	/* Transaction ID Error from SCIn Status */
		unsigned int                : 5;
		unsigned int IDSCID         : 1;	/* Transaction ID Error from Default Slave Status */
		unsigned int IDMCI0         : 1;	/* Transaction ID Error from MCI0 Status */
		unsigned int                : 2;
		unsigned int IDMCI3         : 1;	/* Transaction ID Error from MCIn Status */
		unsigned int IDMCI4         : 1;	/* Transaction ID Error from MCIn Status */
		unsigned int IDMCI5         : 1;	/* Transaction ID Error from MCIn Status */
		unsigned int IDMCI6         : 1;	/* Transaction ID Error from MCIn Status */
		unsigned int IDMCI7         : 1;	/* Transaction ID Error from MCIn Status */
		unsigned int IDMCI8         : 1;	/* Transaction ID Error from MCIn Status */
		unsigned int IDMCI9         : 1;	/* Transaction ID Error from MCIn Status */
		unsigned int IDMCI10        : 1;	/* Transaction ID Error from MCIn Status */
		unsigned int IDMCI11        : 1;	/* Transaction ID Error from MCIn Status */
		unsigned int IDMCI12        : 1;	/* Transaction ID Error from MCIn Status */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} XBAR_IDINTSAT_type;
#define XBAR_IDINTSAT	(*( XBAR_IDINTSAT_type *) 0xf8700414u)	/* Transaction ID Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SCSCI0         : 1;	/* Starvation Error from SCIn Status */
		unsigned int SCSCI1         : 1;	/* Starvation Error from SCIn Status */
		unsigned int SCSCI2         : 1;	/* Starvation Error from SCIn Status */
		unsigned int SCSCI3         : 1;	/* Starvation Error from SCIn Status */
		unsigned int SCSCI4         : 1;	/* Starvation Error from SCIn Status */
		unsigned int SCSCI5         : 1;	/* Starvation Error from SCIn Status */
		unsigned int SCSCI6         : 1;	/* Starvation Error from SCIn Status */
		unsigned int SCSCI7         : 1;	/* Starvation Error from SCIn Status */
		unsigned int SCSCI8         : 1;	/* Starvation Error from SCIn Status */
		unsigned int SCSCI9         : 1;	/* Starvation Error from SCIn Status */
		unsigned int                : 5;
		unsigned int SCSCID         : 1;	/* Starvation Error from Default Slave Status */
		unsigned int PRSCI0         : 1;	/* Protocol Error from SCIn Status */
		unsigned int PRSCI1         : 1;	/* Protocol Error from SCIn Status */
		unsigned int PRSCI2         : 1;	/* Protocol Error from SCIn Status */
		unsigned int PRSCI3         : 1;	/* Protocol Error from SCIn Status */
		unsigned int PRSCI4         : 1;	/* Protocol Error from SCIn Status */
		unsigned int PRSCI5         : 1;	/* Protocol Error from SCIn Status */
		unsigned int PRSCI6         : 1;	/* Protocol Error from SCIn Status */
		unsigned int PRSCI7         : 1;	/* Protocol Error from SCIn Status */
		unsigned int PRSCI8         : 1;	/* Protocol Error from SCIn Status */
		unsigned int PRSCI9         : 1;	/* Protocol Error from SCIn Status */
		unsigned int                : 5;
		unsigned int PRSCID         : 1;	/* Protocol Error from Default Slave Status */
	} B;
	int I;
	unsigned int U;

} XBAR_INTSAT_type;
#define XBAR_INTSAT	(*( XBAR_INTSAT_type *) 0xf8700410u)	/* Arbiter Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MASTER8        : 4;	/* Master 8 Priority */
		unsigned int MASTER9        : 4;	/* Master 9 Priority */
		unsigned int MASTER10       : 4;	/* Master 10 Priority */
		unsigned int MASTER11       : 4;	/* Master 11 Priority */
		unsigned int MASTER12       : 4;	/* Master 12 Priority */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} XBAR_PRIOH0_type;
#define XBAR_PRIOH0	(*( XBAR_PRIOH0_type *) 0xf8700048u)	/* Arbiter Priority Register 0 */
#define XBAR_PRIOH4	(*( XBAR_PRIOH0_type *) 0xf8700148u)	/* Arbiter Priority Register 4 */
#define XBAR_PRIOH6	(*( XBAR_PRIOH0_type *) 0xf87001c8u)	/* Arbiter Priority Register 6 */
#define XBAR_PRIOH7	(*( XBAR_PRIOH0_type *) 0xf8700208u)	/* Arbiter Priority Register 7 */
#define XBAR_PRIOH8	(*( XBAR_PRIOH0_type *) 0xf8700248u)	/* Arbiter Priority Register 8 */
#define XBAR_PRIOH9	(*( XBAR_PRIOH0_type *) 0xf8700288u)	/* Arbiter Priority Register 9 */
#define XBAR_PRIOHD	(*( XBAR_PRIOH0_type *) 0xf8700008u)	/* Arbiter Priority Register D */

typedef volatile union
{
	struct
	{ 
		unsigned int MASTER8        : 4;	/* Master 8 Priority */
		unsigned int                : 4;
		unsigned int MASTER10       : 4;	/* Master 10 Priority */
		unsigned int MASTER11       : 4;	/* Master 11 Priority */
		unsigned int MASTER12       : 4;	/* Master 12 Priority */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} XBAR_PRIOH1_type;
#define XBAR_PRIOH1	(*( XBAR_PRIOH1_type *) 0xf8700088u)	/* Arbiter Priority Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int MASTER8        : 4;	/* Master 8 Priority */
		unsigned int MASTER9        : 4;	/* Master 9 Priority */
		unsigned int MASTER10       : 4;	/* Master 10 Priority */
		unsigned int                : 4;
		unsigned int MASTER12       : 4;	/* Master 12 Priority */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} XBAR_PRIOH3_type;
#define XBAR_PRIOH3	(*( XBAR_PRIOH3_type *) 0xf8700108u)	/* Arbiter Priority Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int MASTER8        : 4;	/* Master 8 Priority */
		unsigned int MASTER9        : 4;	/* Master 9 Priority */
		unsigned int MASTER10       : 4;	/* Master 10 Priority */
		unsigned int MASTER11       : 4;	/* Master 11 Priority */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} XBAR_PRIOH5_type;
#define XBAR_PRIOH5	(*( XBAR_PRIOH5_type *) 0xf8700188u)	/* Arbiter Priority Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int MASTER0        : 4;	/* Master 0 Priority */
		unsigned int                : 8;
		unsigned int MASTER3        : 4;	/* Master 3 Priority */
		unsigned int MASTER4        : 4;	/* Master 4 Priority */
		unsigned int MASTER5        : 4;	/* Master 5 Priority */
		unsigned int MASTER6        : 4;	/* Master 6 Priority */
		unsigned int MASTER7        : 4;	/* Master 7 Priority */
	} B;
	int I;
	unsigned int U;

} XBAR_PRIOL0_type;
#define XBAR_PRIOL0	(*( XBAR_PRIOL0_type *) 0xf870004cu)	/* Arbiter Priority Register 0 */
#define XBAR_PRIOL1	(*( XBAR_PRIOL0_type *) 0xf870008cu)	/* Arbiter Priority Register 1 */
#define XBAR_PRIOL3	(*( XBAR_PRIOL0_type *) 0xf870010cu)	/* Arbiter Priority Register 3 */
#define XBAR_PRIOL4	(*( XBAR_PRIOL0_type *) 0xf870014cu)	/* Arbiter Priority Register 4 */
#define XBAR_PRIOL6	(*( XBAR_PRIOL0_type *) 0xf87001ccu)	/* Arbiter Priority Register 6 */
#define XBAR_PRIOLD	(*( XBAR_PRIOL0_type *) 0xf870000cu)	/* Arbiter Priority Register D */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 16;
		unsigned int MASTER4        : 4;	/* Master 4 Priority */
		unsigned int                : 4;
		unsigned int MASTER6        : 4;	/* Master 6 Priority */
		unsigned int MASTER7        : 4;	/* Master 7 Priority */
	} B;
	int I;
	unsigned int U;

} XBAR_PRIOL5_type;
#define XBAR_PRIOL5	(*( XBAR_PRIOL5_type *) 0xf870018cu)	/* Arbiter Priority Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int MASTER0        : 4;	/* Master 0 Priority */
		unsigned int                : 8;
		unsigned int MASTER3        : 4;	/* Master 3 Priority */
		unsigned int                : 4;
		unsigned int MASTER5        : 4;	/* Master 5 Priority */
		unsigned int MASTER6        : 4;	/* Master 6 Priority */
		unsigned int MASTER7        : 4;	/* Master 7 Priority */
	} B;
	int I;
	unsigned int U;

} XBAR_PRIOL7_type;
#define XBAR_PRIOL7	(*( XBAR_PRIOL7_type *) 0xf870020cu)	/* Arbiter Priority Register 7 */
#define XBAR_PRIOL8	(*( XBAR_PRIOL7_type *) 0xf870024cu)	/* Arbiter Priority Register 8 */
#define XBAR_PRIOL9	(*( XBAR_PRIOL7_type *) 0xf870028cu)	/* Arbiter Priority Register 9 */


/* SCU */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} SCU_ACCEN0_type;
#define SCU_ACCEN0	(*( SCU_ACCEN0_type *) 0xf00363fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} SCU_ACCEN1_type;
#define SCU_ACCEN1	(*( SCU_ACCEN1_type *) 0xf00363f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int STM0DIS        : 1;	/* STM0 Disable Reset */
		unsigned int STM1DIS        : 1;	/* STM1 Disable Reset */
		unsigned int STM2DIS        : 1;	/* STM2 Disable Reset */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} SCU_ARSTDIS_type;
#define SCU_ARSTDIS	(*( SCU_ARSTDIS_type *) 0xf003605cu)	/* Application Reset Disable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CPU0DIV        : 4;	/* CPU0 Divider Reload Value */
		unsigned int CPU0FDR        : 4;	/* CPU0 Fractional Divider Reload Value */
		unsigned int SRIDIV         : 4;	/* SRI Divider Reload Value */
		unsigned int SRIFDR         : 4;	/* SRI Fractional Divider Reload Value */
		unsigned int SPBDIV         : 4;	/* SPB Divider Reload Value */
		unsigned int FSI2DIV        : 4;	/* FSI2 Divider Reload Value */
		unsigned int FSIDIV         : 4;	/* FSI Divider Reload Value */
		/* const */ unsigned int CLKSEL         : 2;	/* Clock Selection */
		unsigned int UP             : 1;	/* Update Request */
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_CCUCON0_type;
#define SCU_CCUCON0	(*( SCU_CCUCON0_type *) 0xf0036030u)	/* CCU Clock Control Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int MAXDIV         : 4;	/* Max Divider Reload Value */
		unsigned int ERAYDIV        : 4;	/* ERAY Divider Reload Value */
		unsigned int STMDIV         : 4;	/* STM Divider Reload Value */
		unsigned int GTMDIV         : 4;	/* GTM Divider Reload Value */
		unsigned int ETHDIV         : 4;	/* Ethernet Divider Reload Value */
		unsigned int                : 8;
		unsigned int INSEL          : 2;	/* Input Selection */
		unsigned int UP             : 1;	/* Update Request */
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_CCUCON1_type;
#define SCU_CCUCON1	(*( SCU_CCUCON1_type *) 0xf0036034u)	/* CCU Clock Control Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int BBBDIV         : 4;	/* BBB Divider Reload Value */
		unsigned int REFCLKDIV      : 4;	/* Reference Clock for MCDS Divider Reload Value */
		unsigned int MCDSDIV        : 4;	/* MCDS Divider Reload Value */
		unsigned int                : 18;
		unsigned int UP             : 1;	/* Update Request */
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_CCUCON2_type;
#define SCU_CCUCON2	(*( SCU_CCUCON2_type *) 0xf0036040u)	/* CCU Clock Control Register 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CHREV          : 6;	/* Chip Revision Number */
		/* const */ unsigned int CHTEC          : 2;	/* Chip Family */
		unsigned int CHID           : 8;	/* Chip Identification Number */
		/* const */ unsigned int EEA            : 1;	/* Emulation Extension Available */
		unsigned int UCODE          : 7;	/* Code Version */
		unsigned int FSIZE          : 4;	/* Program Flash Size */
		unsigned int SP             : 2;	/* Speed */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} SCU_CHIPID_type;
#define SCU_CHIPID	(*( SCU_CHIPID_type *) 0xf0036140u)	/* Chip Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PWD            : 1;	/* Sensor Power Down */
		unsigned int START          : 1;	/* Sensor Measurement Start */
		unsigned int                : 2;
		unsigned int OFFSET         : 8;	/* Offset Calibration Value */
		unsigned int GAIN           : 6;	/* Gain Calibration Value */
		unsigned int REFTRIM        : 3;	/* Reference Trim Calibration Value */
		unsigned int BGTRIM         : 4;	/* Bandgap Trim Calibration Value */
		unsigned int                : 6;
		unsigned int LCK            : 1;	/* Lock */
	} B;
	int I;
	unsigned int U;

} SCU_DTSCON_type;
#define SCU_DTSCON	(*( SCU_DTSCON_type *) 0xf00360e4u)	/* Die Temperature Sensor Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LOWER          : 10;	/* Lower Limit */
		unsigned int                : 5;
		unsigned int LLU            : 1;	/* Lower Limit Underflow */
		unsigned int UPPER          : 10;	/* Upper Limit */
		unsigned int                : 4;
		unsigned int LCK            : 1;	/* Lock */
		/* const */ unsigned int UOF            : 1;	/* Upper Limit Underflow */
	} B;
	int I;
	unsigned int U;

} SCU_DTSLIM_type;
#define SCU_DTSLIM	(*( SCU_DTSLIM_type *) 0xf0036240u)	/* Die Temperature Sensor Limit Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RESULT         : 10;	/* Result of the DTS Measurement */
		/* const */ unsigned int                : 4;
		/* const */ unsigned int RDY            : 1;	/* Sensor Ready Status */
		/* const */ unsigned int BUSY           : 1;	/* Sensor Busy Status */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SCU_DTSSTAT_type;
#define SCU_DTSSTAT	(*( SCU_DTSSTAT_type *) 0xf00360e0u)	/* Die Temperature Sensor Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int EXIS0          : 3;	/* External Input Selection 0 */
		unsigned int                : 1;
		unsigned int FEN0           : 1;	/* Falling Edge Enable 0 */
		unsigned int REN0           : 1;	/* Rising Edge Enable 0 */
		unsigned int LDEN0          : 1;	/* Level Detection Enable 0 */
		unsigned int EIEN0          : 1;	/* External Input Enable 0 */
		unsigned int INP0           : 3;	/* Input Node Pointer */
		unsigned int                : 5;
		unsigned int EXIS1          : 3;	/* External Input Selection 1 */
		unsigned int                : 1;
		unsigned int FEN1           : 1;	/* Falling Edge Enable 1 */
		unsigned int REN1           : 1;	/* Rising Edge Enable 1 */
		unsigned int LDEN1          : 1;	/* Level Detection Enable 1 */
		unsigned int EIEN1          : 1;	/* External Input Enable 1 */
		unsigned int INP1           : 3;	/* Input Node Pointer */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} SCU_EICR0_type;
#define SCU_EICR0	(*( SCU_EICR0_type *) 0xf0036210u)	/* External Input Channel Register 0 */
#define SCU_EICR1	(*( SCU_EICR0_type *) 0xf0036214u)	/* External Input Channel Register 1 */
#define SCU_EICR2	(*( SCU_EICR0_type *) 0xf0036218u)	/* External Input Channel Register 2 */
#define SCU_EICR3	(*( SCU_EICR0_type *) 0xf003621cu)	/* External Input Channel Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int INTF0          : 1;	/* External Event Flag of Channel x */
		/* const */ unsigned int INTF1          : 1;	/* External Event Flag of Channel x */
		/* const */ unsigned int INTF2          : 1;	/* External Event Flag of Channel x */
		/* const */ unsigned int INTF3          : 1;	/* External Event Flag of Channel x */
		/* const */ unsigned int INTF4          : 1;	/* External Event Flag of Channel x */
		/* const */ unsigned int INTF5          : 1;	/* External Event Flag of Channel x */
		/* const */ unsigned int INTF6          : 1;	/* External Event Flag of Channel x */
		/* const */ unsigned int INTF7          : 1;	/* External Event Flag of Channel x */
		/* const */ unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} SCU_EIFR_type;
#define SCU_EIFR	(*( SCU_EIFR_type *) 0xf0036220u)	/* External Input Flag Register */

typedef volatile union
{
	struct
	{ 
		unsigned int POL            : 1;	/* Input Polarity */
		unsigned int MODE           : 1;	/* Mode Selection */
		unsigned int ENON           : 1;	/* Enable ON */
		unsigned int PSEL           : 1;	/* PORT Select */
		unsigned int                : 12;
		/* const */ unsigned int EMSF           : 1;	/* Emergency Stop Flag */
		/* const */ unsigned int SEMSF          : 1;	/* SMU Emergency Stop Flag */
		unsigned int                : 6;
		unsigned int EMSFM          : 2;	/* Emergency Stop Flag Modification */
		unsigned int SEMSFM         : 2;	/* SMU Emergency Stop Flag Modification */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} SCU_EMSR_type;
#define SCU_EMSR	(*( SCU_EMSR_type *) 0xf00360fcu)	/* Emergency Stop Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int DFEN           : 1;	/* Digital Filter Enable */
		unsigned int                : 2;
		unsigned int EDCON          : 2;	/* Edge Detection Control */
		unsigned int                : 22;
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_ESRCFG0_type;
#define SCU_ESRCFG0	(*( SCU_ESRCFG0_type *) 0xf0036070u)	/* ESR0 Input Configuration Register */
#define SCU_ESRCFG1	(*( SCU_ESRCFG0_type *) 0xf0036074u)	/* ESR1 Input Configuration Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ARI            : 1;	/* Application Reset Indicator */
		unsigned int ARC            : 1;	/* Application Reset Indicator Clear */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} SCU_ESROCFG_type;
#define SCU_ESROCFG	(*( SCU_ESROCFG_type *) 0xf0036078u)	/* ESR Output Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int KP             : 4;	/* KP Value */
		unsigned int KI             : 4;	/* KI Value */
		unsigned int KD             : 4;	/* KD Value */
		unsigned int CTRL           : 4;	/* Reserved */
		unsigned int KPE            : 4;	/* KP Value */
		unsigned int KIE            : 4;	/* KI Value */
		unsigned int KDE            : 4;	/* KD Value */
		unsigned int EVR13OFF       : 1;	/* EVR13 Regulator Enable */
		unsigned int BPEVR13OFF     : 1;	/* Bit Protection EVR13OFF */
		unsigned int                : 1;
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_EVR13CON_type;
#define SCU_EVR13CON	(*( SCU_EVR13CON_type *) 0xf00360b8u)	/* EVR13 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int KP             : 4;	/* KP Value */
		unsigned int KI             : 4;	/* KI Value */
		unsigned int KD             : 4;	/* KD Value */
		unsigned int CTRL           : 4;	/* Reserved */
		unsigned int KPE            : 4;	/* KP Value */
		unsigned int KIE            : 4;	/* KI Value */
		unsigned int KDE            : 4;	/* KD Value */
		unsigned int EVR33OFF       : 1;	/* EVR33 Regulator Enable */
		unsigned int BPEVR33OFF     : 1;	/* Bit Protection EVR33OFF */
		unsigned int                : 1;
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_EVR33CON_type;
#define SCU_EVR33CON	(*( SCU_EVR33CON_type *) 0xf00360bcu)	/* EVR33 Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ADC13V         : 8;	/* ADC 13V Conversion Result */
		/* const */ unsigned int ADC33V         : 8;	/* ADC 33V Conversion Result */
		/* const */ unsigned int ADCSWDV        : 8;	/* ADC External Supply Conversion Result */
		/* const */ unsigned int                : 7;
		/* const */ unsigned int VAL            : 1;	/* Valid Status */
	} B;
	int I;
	unsigned int U;

} SCU_EVRADCSTAT_type;
#define SCU_EVRADCSTAT	(*( SCU_EVRADCSTAT_type *) 0xf003619cu)	/* EVR ADC Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EVR13OVMOD     : 2;	/* 13V Regulator Over-voltage monitoring mode */
		unsigned int                : 2;
		unsigned int EVR13UVMOD     : 2;	/* 13V Regulator Under-voltage monitoring mode */
		unsigned int                : 2;
		unsigned int EVR33OVMOD     : 2;	/* 33V Regulator Over-voltage monitoring mode */
		unsigned int                : 2;
		unsigned int EVR33UVMOD     : 2;	/* 33V Regulator Under-voltage monitoring mode */
		unsigned int                : 2;
		unsigned int SWDOVMOD       : 2;	/* Supply monitor SWD Over-voltage monitoring mode */
		unsigned int                : 2;
		unsigned int SWDUVMOD       : 2;	/* Supply monitor SWD Under-voltage monitoring mode */
		unsigned int                : 8;
		unsigned int SLCK           : 1;	/* HSM Security Lock */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} SCU_EVRMONCTRL_type;
#define SCU_EVRMONCTRL	(*( SCU_EVRMONCTRL_type *) 0xf00361a8u)	/* EVR Monitor Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EVR13OVVAL     : 8;	/* 13V Regulator Over-voltage threshold */
		unsigned int EVR33OVVAL     : 8;	/* 33V Regulator Over-voltage threshold */
		unsigned int SWDOVVAL       : 8;	/* Supply monitor SWD Over-voltage threshold value */
		unsigned int                : 6;
		unsigned int SLCK           : 1;	/* HSM Security Lock */
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_EVROVMON_type;
#define SCU_EVROVMON	(*( SCU_EVROVMON_type *) 0xf00361a4u)	/* EVR Over-voltage Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST13TRIM      : 8;	/* 13V Regulator Reset Trim Value */
		unsigned int RST33TRIM      : 8;	/* 33V Regulator Reset Trim Value */
		unsigned int RSTSWDTRIM     : 8;	/* 50V/33V External Supply Reset Trim Value */
		unsigned int RST13OFF       : 1;	/* Hard Reset EVR13 Enable */
		unsigned int BPRST13OFF     : 1;	/* Bit Protection RST13OFF */
		unsigned int RST33OFF       : 1;	/* Hard Reset EVR33 Enable */
		unsigned int BPRST33OFF     : 1;	/* Bit Protection RST33OFF */
		unsigned int RSTSWDOFF      : 1;	/* Hard Reset EVR Supply Monitor Enable */
		unsigned int BPRSTSWDOFF    : 1;	/* Bit Protection RSTSWDOFF */
		unsigned int SLCK           : 1;	/* HSM Security Lock */
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_EVRRSTCON_type;
#define SCU_EVRRSTCON	(*( SCU_EVRRSTCON_type *) 0xf003606cu)	/* EVR Hard Reset Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SDFREQSPRD     : 16;	/* Frequency Spread Threshold freq_spread_thr_i */
		unsigned int SDFREQ         : 8;	/* Regulator Switching Frequency os_factor_i */
		unsigned int SDSTEP         : 4;	/* Droop Voltage Step sd_droop_step_i */
		unsigned int                : 2;
		unsigned int SDSAMPLE       : 1;	/* ADC Sampling Scheme sd_sample_time_i */
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_EVRSDCTRL1_type;
#define SCU_EVRSDCTRL1	(*( SCU_EVRSDCTRL1_type *) 0xf00361b0u)	/* EVR13 SD Control Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int EVR13          : 1;	/* EVR13 status */
		/* const */ unsigned int OV13           : 1;	/* EVR13 Regulator Over-voltage event flag */
		/* const */ unsigned int EVR33          : 1;	/* EVR33 status */
		/* const */ unsigned int OV33           : 1;	/* EVR33 Regulator Over-voltage event flag */
		/* const */ unsigned int OVSWD          : 1;	/* Supply Monitor SWD Over-voltage event flag */
		/* const */ unsigned int UV13           : 1;	/* EVR13 Regulator Under-voltage event flag */
		/* const */ unsigned int UV33           : 1;	/* EVR33 Regulator Under-voltage event flag */
		/* const */ unsigned int UVSWD          : 1;	/* Supply Monitor SWD Under-voltage event flag */
		/* const */ unsigned int EXTPASS13      : 1;	/* External Pass Device for EVR13 */
		/* const */ unsigned int EXTPASS33      : 1;	/* External Pass Device for EVR33 */
		/* const */ unsigned int BGPROK         : 1;	/* Primary Bandgap status */
		/* const */ unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} SCU_EVRSTAT_type;
#define SCU_EVRSTAT	(*( SCU_EVRSTAT_type *) 0xf00360b0u)	/* EVR Status Flag Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EVR13UVVAL     : 8;	/* 13V Regulator Under-voltage threshold */
		unsigned int EVR33UVVAL     : 8;	/* 33V Regulator Under-voltage threshold */
		unsigned int SWDUVVAL       : 8;	/* Supply monitor SWD Under-voltage threshold value */
		unsigned int                : 6;
		unsigned int SLCK           : 1;	/* HSM Security Lock */
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_EVRUVMON_type;
#define SCU_EVRUVMON	(*( SCU_EVRUVMON_type *) 0xf00361a0u)	/* EVR Under-voltage Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* External Clock Enable for EXTCLK0 */
		unsigned int                : 1;
		unsigned int SEL0           : 4;	/* External Clock Select for EXTCLK0 */
		unsigned int                : 10;
		unsigned int EN1            : 1;	/* External Clock Enable for EXTCLK1 */
		unsigned int NSEL           : 1;	/* Negation Selection */
		unsigned int SEL1           : 4;	/* External Clock Select for EXTCLK1 */
		unsigned int                : 2;
		unsigned int DIV1           : 8;	/* External Clock Divider for EXTCLK1 */
	} B;
	int I;
	unsigned int U;

} SCU_EXTCON_type;
#define SCU_EXTCON	(*( SCU_EXTCON_type *) 0xf003603cu)	/* External Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int STEP           : 10;	/* Step Value */
		unsigned int                : 4;
		unsigned int DM             : 2;	/* Divider Mode */
		/* const */ unsigned int RESULT         : 10;	/* Result Value */
		unsigned int                : 5;
		unsigned int DISCLK         : 1;	/* Disable Clock */
	} B;
	int I;
	unsigned int U;

} SCU_FDR_type;
#define SCU_FDR	(*( SCU_FDR_type *) 0xf0036038u)	/* Fractional Divider Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FS0            : 1;	/* Set Flag INTFx for Channel x */
		unsigned int FS1            : 1;	/* Set Flag INTFx for Channel x */
		unsigned int FS2            : 1;	/* Set Flag INTFx for Channel x */
		unsigned int FS3            : 1;	/* Set Flag INTFx for Channel x */
		unsigned int FS4            : 1;	/* Set Flag INTFx for Channel x */
		unsigned int FS5            : 1;	/* Set Flag INTFx for Channel x */
		unsigned int FS6            : 1;	/* Set Flag INTFx for Channel x */
		unsigned int FS7            : 1;	/* Set Flag INTFx for Channel x */
		unsigned int                : 8;
		unsigned int FC0            : 1;	/* Clear Flag INTFx for Channel x */
		unsigned int FC1            : 1;	/* Clear Flag INTFx for Channel x */
		unsigned int FC2            : 1;	/* Clear Flag INTFx for Channel x */
		unsigned int FC3            : 1;	/* Clear Flag INTFx for Channel x */
		unsigned int FC4            : 1;	/* Clear Flag INTFx for Channel x */
		unsigned int FC5            : 1;	/* Clear Flag INTFx for Channel x */
		unsigned int FC6            : 1;	/* Clear Flag INTFx for Channel x */
		unsigned int FC7            : 1;	/* Clear Flag INTFx for Channel x */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} SCU_FMR_type;
#define SCU_FMR	(*( SCU_FMR_type *) 0xf0036224u)	/* Flag Modification Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} SCU_ID_type;
#define SCU_ID	(*( SCU_ID_type *) 0xf0036008u)	/* Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IPEN00         : 1;	/* Flag Pattern Enable for Channel 0 */
		unsigned int IPEN01         : 1;	/* Flag Pattern Enable for Channel 0 */
		unsigned int IPEN02         : 1;	/* Flag Pattern Enable for Channel 0 */
		unsigned int IPEN03         : 1;	/* Flag Pattern Enable for Channel 0 */
		unsigned int IPEN04         : 1;	/* Flag Pattern Enable for Channel 0 */
		unsigned int IPEN05         : 1;	/* Flag Pattern Enable for Channel 0 */
		unsigned int IPEN06         : 1;	/* Flag Pattern Enable for Channel 0 */
		unsigned int IPEN07         : 1;	/* Flag Pattern Enable for Channel 0 */
		unsigned int                : 5;
		unsigned int GEEN0          : 1;	/* Generate Event Enable 0 */
		unsigned int IGP0           : 2;	/* Interrupt Gating Pattern 0 */
		unsigned int IPEN10         : 1;	/* Interrupt Pattern Enable for Channel 1 */
		unsigned int IPEN11         : 1;	/* Interrupt Pattern Enable for Channel 1 */
		unsigned int IPEN12         : 1;	/* Interrupt Pattern Enable for Channel 1 */
		unsigned int IPEN13         : 1;	/* Interrupt Pattern Enable for Channel 1 */
		unsigned int IPEN14         : 1;	/* Interrupt Pattern Enable for Channel 1 */
		unsigned int IPEN15         : 1;	/* Interrupt Pattern Enable for Channel 1 */
		unsigned int IPEN16         : 1;	/* Interrupt Pattern Enable for Channel 1 */
		unsigned int IPEN17         : 1;	/* Interrupt Pattern Enable for Channel 1 */
		unsigned int                : 5;
		unsigned int GEEN1          : 1;	/* Generate Event Enable 1 */
		unsigned int IGP1           : 2;	/* Interrupt Gating Pattern 1 */
	} B;
	int I;
	unsigned int U;

} SCU_IGCR0_type;
#define SCU_IGCR0	(*( SCU_IGCR0_type *) 0xf003622cu)	/* Flag Gating Register 0 */
#define SCU_IGCR1	(*( SCU_IGCR0_type *) 0xf0036230u)	/* Flag Gating Register 1 */
#define SCU_IGCR2	(*( SCU_IGCR0_type *) 0xf0036234u)	/* Flag Gating Register 2 */
#define SCU_IGCR3	(*( SCU_IGCR0_type *) 0xf0036238u)	/* Flag Gating Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int P0             : 1;	/* Input Bit x */
		/* const */ unsigned int P1             : 1;	/* Input Bit x */
		/* const */ unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} SCU_IN_type;
#define SCU_IN	(*( SCU_IN_type *) 0xf00360acu)	/* ESR Input Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int PC0            : 4;	/* Control for ESR Pin x */
		unsigned int                : 4;
		unsigned int PC1            : 4;	/* Control for ESR Pin x */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SCU_IOCR_type;
#define SCU_IOCR	(*( SCU_IOCR_type *) 0xf00360a0u)	/* Input/Output Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LBISTREQ       : 1;	/* LBIST Request */
		unsigned int LBISTREQP      : 1;	/* LBIST Request Protection Bit */
		unsigned int PATTERNS       : 14;	/* LBIST Pattern Number */
		unsigned int SEED           : 15;	/* LBIST Seed */
		unsigned int BODY           : 1;	/* BODY Application Mode */
	} B;
	int I;
	unsigned int U;

} SCU_LBISTCTRL0_type;
#define SCU_LBISTCTRL0	(*( SCU_LBISTCTRL0_type *) 0xf0036164u)	/* Logic BIST Control 0 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SIGNATURE      : 24;	/* LBIST Signature */
		unsigned int                : 3;
		/* const */ unsigned int LBISTDONE      : 1;	/* LBIST Execution Indicator */
		unsigned int LBISTFREQ      : 4;	/* LBIST Frequency Select */
	} B;
	int I;
	unsigned int U;

} SCU_LBISTCTRL1_type;
#define SCU_LBISTCTRL1	(*( SCU_LBISTCTRL1_type *) 0xf0036168u)	/* Logic BIST Control 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 16;
		/* const */ unsigned int LS             : 1;	/* Lockstep Mode Status */
		unsigned int                : 14;
		unsigned int LSEN           : 1;	/* Lockstep Enable */
	} B;
	int I;
	unsigned int U;

} SCU_LCLCON0_type;
#define SCU_LCLCON0	(*( SCU_LCLCON0_type *) 0xf0036134u)	/* LCL CPU0 Control Register */
#define SCU_LCLCON1	(*( SCU_LCLCON0_type *) 0xf0036138u)	/* LCL CPU1 Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DEPT           : 5;	/* Department Identification Number */
		/* const */ unsigned int MANUF          : 11;	/* Manufacturer Identification Number */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SCU_MANID_type;
#define SCU_MANID	(*( SCU_MANID_type *) 0xf0036144u)	/* Manufacturer Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PS0            : 1;	/* ESRx Pin Set Bit x */
		unsigned int PS1            : 1;	/* ESRx Pin Set Bit x */
		unsigned int                : 14;
		unsigned int PCL0           : 1;	/* ESRx Pin Clear Bit x */
		unsigned int PCL1           : 1;	/* ESRx Pin Clear Bit x */
		unsigned int                : 14;
	} B;
	int I;
	unsigned int U;

} SCU_OMR_type;
#define SCU_OMR	(*( SCU_OMR_type *) 0xf00360a8u)	/* ESR Output Modification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		/* const */ unsigned int PLLLV          : 1;	/* Oscillator for PLL Valid Low Status Bit */
		unsigned int OSCRES         : 1;	/* Oscillator Watchdog Reset */
		unsigned int GAINSEL        : 2;	/* Oscillator Gain Selection */
		unsigned int MODE           : 2;	/* Oscillator Mode */
		unsigned int SHBY           : 1;	/* Shaper Bypass */
		/* const */ unsigned int PLLHV          : 1;	/* Oscillator for PLL Valid High Status Bit */
		unsigned int                : 1;
		/* const */ unsigned int X1D            : 1;	/* XTAL1 Data Value */
		unsigned int X1DEN          : 1;	/* XTAL1 Data Enable */
		unsigned int                : 4;
		unsigned int OSCVAL         : 5;	/* OSC Frequency Value */
		unsigned int                : 2;
		unsigned int APREN          : 1;	/* Amplitude Regulation Enable */
		unsigned int CAP0EN         : 1;	/* Capacitance 0 Enable */
		unsigned int CAP1EN         : 1;	/* Capacitance 1 Enable */
		unsigned int CAP2EN         : 1;	/* Capacitance 2 Enable */
		unsigned int CAP3EN         : 1;	/* Capacitance 3 Enable */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} SCU_OSCCON_type;
#define SCU_OSCCON	(*( SCU_OSCCON_type *) 0xf0036010u)	/* OSC Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int P0             : 1;	/* Output Bit x */
		unsigned int P1             : 1;	/* Output Bit x */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} SCU_OUT_type;
#define SCU_OUT	(*( SCU_OUT_type *) 0xf00360a4u)	/* ESR Output Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CSEL0          : 1;	/* CPU Select x */
		unsigned int CSEL1          : 1;	/* CPU Select x */
		unsigned int CSEL2          : 1;	/* CPU Select x */
		unsigned int                : 5;
		unsigned int PEND0          : 1;	/* CPU Pending x */
		unsigned int PEND1          : 1;	/* CPU Pending x */
		unsigned int PEND2          : 1;	/* CPU Pending x */
		unsigned int                : 5;
		unsigned int OVSTRT         : 1;	/* Overlay Start */
		unsigned int OVSTP          : 1;	/* Overlay Stop */
		unsigned int DCINVAL        : 1;	/* Data Cache Invalidate */
		unsigned int                : 5;
		unsigned int OVCONF         : 1;	/* Overlay Configured */
		unsigned int POVCONF        : 1;	/* Write Protection for OVCONF */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} SCU_OVCCON_type;
#define SCU_OVCCON	(*( SCU_OVCCON_type *) 0xf00361e4u)	/* Overlay Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int OVEN0          : 1;	/* Overlay Enable x */
		unsigned int OVEN1          : 1;	/* Overlay Enable x */
		unsigned int OVEN2          : 1;	/* Overlay Enable x */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} SCU_OVCENABLE_type;
#define SCU_OVCENABLE	(*( SCU_OVCENABLE_type *) 0xf00361e0u)	/* Overlay Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PDIS0          : 1;	/* Pad Disable for ESR Pin x */
		unsigned int PDIS1          : 1;	/* Pad Disable for ESR Pin x */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} SCU_PDISC_type;
#define SCU_PDISC	(*( SCU_PDISC_type *) 0xf003618cu)	/* Pad Disable Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int PDR0           : 1;	/* Pattern Detection Result of Channel y */
		/* const */ unsigned int PDR1           : 1;	/* Pattern Detection Result of Channel y */
		/* const */ unsigned int PDR2           : 1;	/* Pattern Detection Result of Channel y */
		/* const */ unsigned int PDR3           : 1;	/* Pattern Detection Result of Channel y */
		/* const */ unsigned int PDR4           : 1;	/* Pattern Detection Result of Channel y */
		/* const */ unsigned int PDR5           : 1;	/* Pattern Detection Result of Channel y */
		/* const */ unsigned int PDR6           : 1;	/* Pattern Detection Result of Channel y */
		/* const */ unsigned int PDR7           : 1;	/* Pattern Detection Result of Channel y */
		/* const */ unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} SCU_PDRR_type;
#define SCU_PDRR	(*( SCU_PDRR_type *) 0xf0036228u)	/* Pattern Detection Result Register */

typedef volatile union
{
	struct
	{ 
		unsigned int VCOBYP         : 1;	/* VCO Bypass */
		unsigned int VCOPWD         : 1;	/* VCO Power Saving Mode */
		unsigned int MODEN          : 1;	/* Modulation Enable */
		unsigned int CEN            : 1;	/* Clipping Enable */
		unsigned int SETFINDIS      : 1;	/* Set Status Bit PLLSTATFINDIS */
		unsigned int CLRFINDIS      : 1;	/* Clear Status Bit PLLSTATFINDIS */
		unsigned int OSCDISCDIS     : 1;	/* Oscillator Disconnect Disable */
		unsigned int                : 2;
		unsigned int NDIV           : 7;	/* N-Divider Value */
		unsigned int PLLPWD         : 1;	/* PLL Power Saving Mode */
		unsigned int                : 1;
		unsigned int RESLD          : 1;	/* Restart VCO Lock Detection */
		unsigned int                : 5;
		unsigned int PDIV           : 4;	/* P-Divider Value */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} SCU_PLLCON0_type;
#define SCU_PLLCON0	(*( SCU_PLLCON0_type *) 0xf0036018u)	/* PLL Configuration 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int K2DIV          : 7;	/* K2-Divider Value */
		unsigned int                : 9;
		unsigned int K1DIV          : 7;	/* K1-Divider Value */
		unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} SCU_PLLCON1_type;
#define SCU_PLLCON1	(*( SCU_PLLCON1_type *) 0xf003601cu)	/* PLL Configuration 1 Register */
#define SCU_PLLERAYCON1	(*( SCU_PLLCON1_type *) 0xf003602cu)	/* PLL_ERAY Configuration 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MODAMP         : 16;	/* Modulation Amplitude */
		unsigned int MODFREQ        : 16;	/* Modulation Frequency */
	} B;
	int I;
	unsigned int U;

} SCU_PLLCON2_type;
#define SCU_PLLCON2	(*( SCU_PLLCON2_type *) 0xf0036020u)	/* PLL Configuration 2 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int VCOBYP         : 1;	/* VCO Bypass */
		unsigned int VCOPWD         : 1;	/* VCO Power Saving Mode */
		unsigned int                : 2;
		unsigned int SETFINDIS      : 1;	/* Set Status Bit PLLERAYSTATFINDIS */
		unsigned int CLRFINDIS      : 1;	/* Clear Status Bit PLLERAYSTATFINDIS */
		unsigned int OSCDISCDIS     : 1;	/* Oscillator Disconnect Disable */
		unsigned int                : 2;
		unsigned int NDIV           : 5;	/* N-Divider Value */
		unsigned int                : 2;
		unsigned int PLLPWD         : 1;	/* PLL Power Saving Mode */
		unsigned int                : 1;
		unsigned int RESLD          : 1;	/* Restart VCO Lock Detection */
		unsigned int                : 5;
		unsigned int PDIV           : 4;	/* P-Divider Value */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} SCU_PLLERAYCON0_type;
#define SCU_PLLERAYCON0	(*( SCU_PLLERAYCON0_type *) 0xf0036028u)	/* PLL_ERAY Configuration 0 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int VCOBYST        : 1;	/* VCO Bypass Status */
		/* const */ unsigned int PWDSTAT        : 1;	/* PLL_ERAY Power-saving Mode Status */
		/* const */ unsigned int VCOLOCK        : 1;	/* PLL VCO Lock Status */
		/* const */ unsigned int FINDIS         : 1;	/* Input Clock Disconnect Select Status */
		/* const */ unsigned int K1RDY          : 1;	/* K1 Divider Ready Status */
		/* const */ unsigned int K2RDY          : 1;	/* K2 Divider Ready Status */
		/* const */ unsigned int BY             : 1;	/* Bypass Mode Status */
		/* const */ unsigned int                : 25;
	} B;
	int I;
	unsigned int U;

} SCU_PLLERAYSTAT_type;
#define SCU_PLLERAYSTAT	(*( SCU_PLLERAYSTAT_type *) 0xf0036024u)	/* PLL_ERAY Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int VCOBYST        : 1;	/* VCO Bypass Status */
		/* const */ unsigned int PWDSTAT        : 1;	/* PLL Power-saving Mode Status */
		/* const */ unsigned int VCOLOCK        : 1;	/* PLL VCO Lock Status */
		/* const */ unsigned int FINDIS         : 1;	/* Input Clock Disconnect Select Status */
		/* const */ unsigned int K1RDY          : 1;	/* K1 Divider Ready Status */
		/* const */ unsigned int K2RDY          : 1;	/* K2 Divider Ready Status */
		/* const */ unsigned int BY             : 1;	/* Bypass Mode Status */
		/* const */ unsigned int MODRUN         : 1;	/* Modulation Run */
		/* const */ unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} SCU_PLLSTAT_type;
#define SCU_PLLSTAT	(*( SCU_PLLSTAT_type *) 0xf0036014u)	/* PLL Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int REQSLP         : 2;	/* Idle Mode and Sleep Mode Request */
		unsigned int SMUSLP         : 1;	/* SMU CPU Idle Request */
		unsigned int RSTSLP         : 1;	/* Reset Controller CPU Idle Request */
		unsigned int                : 4;
		/* const */ unsigned int PMST           : 3;	/* Power management Status */
		unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} SCU_PMCSR0_type;
#define SCU_PMCSR0	(*( SCU_PMCSR0_type *) 0xf00360d4u)	/* Power Management Control and Status Register */
#define SCU_PMCSR1	(*( SCU_PMCSR0_type *) 0xf00360d8u)	/* Power Management Control and Status Register */
#define SCU_PMCSR2	(*( SCU_PMCSR0_type *) 0xf00360dcu)	/* Power Management Control and Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ESR0WKEN       : 1;	/* ESR0 Wake-up enable from Standby */
		unsigned int ESR1WKEN       : 1;	/* ESR1 Wake-up enable from Standby */
		unsigned int PINAWKEN       : 1;	/* Pin A Wake-up enable from Standby */
		unsigned int PINBWKEN       : 1;	/* Pin B Wake-up enable from Standby */
		unsigned int ESR0DFEN       : 1;	/* Digital Filter Enable */
		unsigned int ESR0EDCON      : 2;	/* Edge Detection Control */
		unsigned int ESR1DFEN       : 1;	/* Digital Filter Enable */
		unsigned int ESR1EDCON      : 2;	/* Edge Detection Control */
		unsigned int PINADFEN       : 1;	/* Digital Filter Enable */
		unsigned int PINAEDCON      : 2;	/* Edge Detection Control */
		unsigned int PINBDFEN       : 1;	/* Digital Filter Enable */
		unsigned int PINBEDCON      : 2;	/* Edge Detection Control */
		unsigned int                : 1;
		unsigned int STBYRAMSEL     : 2;	/* Standby RAM supply in Standby Mode */
		unsigned int                : 2;
		unsigned int TRISTEN        : 1;	/* Bit protection for Tristate request bit TRISTREQ */
		unsigned int TRISTREQ       : 1;	/* Tristate enable */
		unsigned int PORSTDF        : 1;	/* PORST Digital Filter enable */
		unsigned int PORSTWKP       : 1;	/* Standby - Wakeup transition on PORST edges */
		unsigned int DCDCSYNC       : 1;	/* DC-DC Synchronisation Enable */
		unsigned int                : 5;
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_PMSWCR0_type;
#define SCU_PMSWCR0	(*( SCU_PMSWCR0_type *) 0xf00360c8u)	/* Standby and Wake-up Control Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 8;
		unsigned int CPU0IDLE       : 1;	/* CPU0 IDLE request */
		unsigned int CPU1IDLE       : 1;	/* CPU1 IDLE request */
		unsigned int CPU2IDLE       : 1;	/* CPU2 IDLE request */
		unsigned int                : 13;
		unsigned int CPUSEL         : 3;	/* CPU selection for Sleep and Standby mode */
		unsigned int                : 4;
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_PMSWCR1_type;
#define SCU_PMSWCR1	(*( SCU_PMSWCR1_type *) 0xf00360e8u)	/* Standby and Wake-up Control Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SCRINT         : 8;	/* Data exchange from Standby Controller to SCU */
		/* const */ unsigned int BUSY           : 1;	/* SCR Arbiter Busy status flag */
		/* const */ unsigned int SCRECC         : 1;	/* SCR RAM ECC error / reset flag */
		/* const */ unsigned int SCRWDT         : 1;	/* SCR Watchdog Timer error / reset flag */
		/* const */ unsigned int SCRRST         : 1;	/* SCR Software reset flag */
		unsigned int                : 4;
		unsigned int TCINT          : 8;	/* Data exchange from SCU to Standby Controller */
		unsigned int TCINTREQ       : 1;	/* SW Interrupt request from SCU to Standby Controller */
		/* const */ unsigned int SMURST         : 1;	/* SMU Reset indication flag */
		/* const */ unsigned int RST            : 1;	/* Application or System Reset indication flag */
		unsigned int                : 4;
		/* const */ unsigned int LCK            : 1;	/* Lock Status */
	} B;
	int I;
	unsigned int U;

} SCU_PMSWCR2_type;
#define SCU_PMSWCR2	(*( SCU_PMSWCR2_type *) 0xf00360ecu)	/* Standby and Wake-up Control Register 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ESR0WKP        : 1;	/* ESR0 Wake-up flag */
		/* const */ unsigned int ESR0OVRUN      : 1;	/* ESR0 Overrun status flag */
		/* const */ unsigned int ESR1WKP        : 1;	/* ESR1 Wake-up flag */
		/* const */ unsigned int ESR1OVRUN      : 1;	/* ESR1 Overrun status flag */
		/* const */ unsigned int PINAWKP        : 1;	/* Pin A Wake-up flag */
		/* const */ unsigned int PINAOVRUN      : 1;	/* Pin A Overrun status flag */
		/* const */ unsigned int PINBWKP        : 1;	/* Pin B Wake-up flag */
		/* const */ unsigned int PINBOVRUN      : 1;	/* Pin B Overrun status flag */
		/* const */ unsigned int PORSTWKP       : 1;	/* Standby-Wakeup transition on PORST edges */
		/* const */ unsigned int PORSTDF        : 1;	/* PORST Digital Filter status */
		/* const */ unsigned int HWCFGEVR       : 3;	/* EVR Hardware Configuration */
		/* const */ unsigned int STBYRAM        : 2;	/* Standby RAM Supply status */
		/* const */ unsigned int TRIST          : 1;	/* Pad Tristate / Pull-up status */
		/* const */ unsigned int                : 3;
		/* const */ unsigned int SPARE0         : 5;	/* Spare bits */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} SCU_PMSWSTAT_type;
#define SCU_PMSWSTAT	(*( SCU_PMSWSTAT_type *) 0xf00360ccu)	/* Standby and Wake-up Status Flag Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ESR0WKPCLR     : 1;	/* ESR0 Wake-up indication flag clear */
		unsigned int ESR0OVRUNCLR   : 1;	/* ESR0 Overrun status indication flag clear */
		unsigned int ESR1WKPCLR     : 1;	/* ESR1 Wake-up indication flag clear */
		unsigned int ESR1OVRUNCLR   : 1;	/* ESR1 Overrun status indication flag clear */
		unsigned int PINAWKPCLR     : 1;	/* PINA Wake-up indication flag clear */
		unsigned int PINAOVRUNCLR   : 1;	/* PINA Overrun status indication flag clear */
		unsigned int PINBWKPCLR     : 1;	/* PINB Wake-up indication flag clear */
		unsigned int PINBOVRUNCLR   : 1;	/* PINB Overrun status indication flag clear */
		unsigned int                : 11;
		unsigned int SPARECLR       : 5;	/* SPARE flag clear */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} SCU_PMSWSTATCLR_type;
#define SCU_PMSWSTATCLR	(*( SCU_PMSWSTATCLR_type *) 0xf00360d0u)	/* Standby and Wake-up Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ESR0           : 2;	/* ESR0 Reset Request Trigger Reset Configuration */
		unsigned int ESR1           : 2;	/* ESR1 Reset Request Trigger Reset Configuration */
		unsigned int                : 2;
		unsigned int SMU            : 2;	/* SMU Reset Request Trigger Reset Configuration */
		unsigned int SW             : 2;	/* SW Reset Request Trigger Reset Configuration */
		unsigned int STM0           : 2;	/* STM0 Reset Request Trigger Reset Configuration */
		unsigned int STM1           : 2;	/* STM1 Reset Request Trigger Reset Configuration */
		unsigned int STM2           : 2;	/* STM2 Reset Request Trigger Reset Configuration */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SCU_RSTCON_type;
#define SCU_RSTCON	(*( SCU_RSTCON_type *) 0xf0036058u)	/* Reset Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FRTO           : 1;	/* Force Reset Timeout */
		unsigned int CLRC           : 1;	/* Clear Cold Reset Status */
		unsigned int                : 8;
		/* const */ unsigned int FLSS           : 2;	/* Flash Safe State Reached */
		/* const */ unsigned int CSS            : 3;	/* CPU Safe State Reached */
		/* const */ unsigned int MCDSSS         : 1;	/* MCDS Safe State Reached */
		unsigned int USRINFO        : 16;	/* User Information */
	} B;
	int I;
	unsigned int U;

} SCU_RSTCON2_type;
#define SCU_RSTCON2	(*( SCU_RSTCON2_type *) 0xf0036064u)	/* Additional Reset Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ESR0           : 1;	/* Reset Request Trigger Reset Status for ESR0 */
		/* const */ unsigned int ESR1           : 1;	/* Reset Request Trigger Reset Status for ESR1 */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int SMU            : 1;	/* Reset Request Trigger Reset Status for SMU */
		/* const */ unsigned int SW             : 1;	/* Reset Request Trigger Reset Status for SW */
		/* const */ unsigned int STM0           : 1;	/* Reset Request Trigger Reset Status for STM0 */
		/* const */ unsigned int STM1           : 1;	/* Reset Request Trigger Reset Status for STM1 */
		/* const */ unsigned int STM2           : 1;	/* Reset Request Trigger Reset Status for STM2 */
		/* const */ unsigned int                : 8;
		/* const */ unsigned int PORST          : 1;	/* Reset Request Trigger Reset Status for PORST */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int CB0            : 1;	/* Reset Request Trigger Reset Status for Cerberus System Reset */
		/* const */ unsigned int CB1            : 1;	/* Reset Request Trigger Reset Status for Cerberus Debug Reset */
		/* const */ unsigned int CB3            : 1;	/* Reset Request Trigger Reset Status for Cerberus Application Reset */
		/* const */ unsigned int TP             : 1;	/* Reset Request Trigger Reset Status for Tuning Protection */
		/* const */ unsigned int TCU            : 1;	/* Reset Request Trigger Reset Status for TCU */
		/* const */ unsigned int EVR13          : 1;	/* Reset Request Trigger Reset Status for EVR13 */
		/* const */ unsigned int EVR33          : 1;	/* Reset Request Trigger Reset Status for EVR33 */
		/* const */ unsigned int SWD            : 1;	/* Reset Request Trigger Reset Status for Supply Watchdog SWD */
		/* const */ unsigned int HSMS           : 1;	/* Reset Request Trigger Reset Status for HSM System Reset HSM S */
		/* const */ unsigned int HSMA           : 1;	/* Reset Request Trigger Reset Status for HSM Application Reset HSM A */
		/* const */ unsigned int STBYR          : 1;	/* Reset Request Trigger Reset Status for Standby Regulator Watchdog STBYR */
		/* const */ unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} SCU_RSTSTAT_type;
#define SCU_RSTSTAT	(*( SCU_RSTSTAT_type *) 0xf0036050u)	/* Reset Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int HWCFG          : 8;	/* Hardware Configuration Setting */
		unsigned int                : 5;
		unsigned int SFCBAE         : 1;	/* Set Flash Config Sector Access Enable */
		unsigned int CFCBAE         : 1;	/* Clear Flash Config Sector Access Enable */
		unsigned int STP            : 1;	/* Start-up Protection Setting */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SCU_STCON_type;
#define SCU_STCON	(*( SCU_STCON_type *) 0xf00360c4u)	/* Start-up Configuration Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int HWCFG          : 8;	/* Hardware Configuration Setting */
		/* const */ unsigned int                : 7;
		/* const */ unsigned int MODE           : 1;	/* MODE */
		/* const */ unsigned int FCBAE          : 1;	/* Flash Config Sector Access Enable */
		/* const */ unsigned int LUDIS          : 1;	/* Latch Update Disable */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int TRSTL          : 1;	/* TRSTL Status */
		/* const */ unsigned int SPDEN          : 1;	/* Single Pin DAP Mode Enable */
		/* const */ unsigned int OTPOFF         : 1;	/* OTP Over-ruled */
		/* const */ unsigned int FSIOFF         : 1;	/* FSI Disabled */
		/* const */ unsigned int STPOVREQ       : 1;	/* Start-Up Protection Over-ruling Request */
		/* const */ unsigned int RAMINT         : 1;	/* RAM Content Security Integrity */
		/* const */ unsigned int                : 7;
	} B;
	int I;
	unsigned int U;

} SCU_STSTAT_type;
#define SCU_STSTAT	(*( SCU_STSTAT_type *) 0xf00360c0u)	/* Start-up Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SWBOOT         : 1;	/* Software Boot Configuration Selection */
		unsigned int SWRSTREQ       : 1;	/* Software Reset Request */
		unsigned int                : 6;
		unsigned int SWCFG          : 8;	/* Software Boot Configuration */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SCU_SWRSTCON_type;
#define SCU_SWRSTCON	(*( SCU_SWRSTCON_type *) 0xf0036060u)	/* Software Reset Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CCTRIG0        : 1;	/* Capture Compare Trigger x */
		unsigned int CCTRIG1        : 1;	/* Capture Compare Trigger x */
		unsigned int RAMINTM        : 2;	/* RAM Integrity Modify */
		unsigned int SETLUDIS       : 1;	/* Set Latch Update Disable */
		unsigned int                : 3;
		unsigned int DATM           : 1;	/* Disable Application Test Mode ATM */
		unsigned int                : 23;
	} B;
	int I;
	unsigned int U;

} SCU_SYSCON_type;
#define SCU_SYSCON	(*( SCU_SYSCON_type *) 0xf003607cu)	/* System Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ESR0T          : 1;	/* Clear Trap Request Flag ESR0T */
		unsigned int ESR1T          : 1;	/* Clear Trap Request Flag ESR1T */
		unsigned int                : 1;
		unsigned int SMUT           : 1;	/* Clear Trap Request Flag SMUT */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} SCU_TRAPCLR_type;
#define SCU_TRAPCLR	(*( SCU_TRAPCLR_type *) 0xf003612cu)	/* Trap Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ESR0T          : 1;	/* Disable Trap Request ESR0T */
		unsigned int ESR1T          : 1;	/* Disable Trap Request ESR1T */
		unsigned int                : 1;
		unsigned int SMUT           : 1;	/* Disable Trap Request SMUT */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} SCU_TRAPDIS_type;
#define SCU_TRAPDIS	(*( SCU_TRAPDIS_type *) 0xf0036130u)	/* Trap Disable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ESR0T          : 1;	/* Set Trap Request Flag ESR0T */
		unsigned int ESR1T          : 1;	/* Set Trap Request Flag ESR1T */
		unsigned int                : 1;
		unsigned int SMUT           : 1;	/* Set Trap Request Flag SMUT */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} SCU_TRAPSET_type;
#define SCU_TRAPSET	(*( SCU_TRAPSET_type *) 0xf0036128u)	/* Trap Set Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ESR0T          : 1;	/* ESR0 Trap Request Flag */
		/* const */ unsigned int ESR1T          : 1;	/* ESR1 Trap Request Flag */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int SMUT           : 1;	/* SMU Alarm Trap Request Flag */
		/* const */ unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} SCU_TRAPSTAT_type;
#define SCU_TRAPSTAT	(*( SCU_TRAPSTAT_type *) 0xf0036124u)	/* Trap Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ENDINIT        : 1;	/* End-of-Initialization Control Bit */
		unsigned int LCK            : 1;	/* Lock Bit to Control Access to WDTxCON0 */
		unsigned int PW             : 14;	/* User-Definable Password Field for Access to WDTxCON0 */
		unsigned int REL            : 16;	/* Reload Value for the WDT also Time Check Value */
	} B;
	int I;
	unsigned int U;

} SCU_WDTCPU0CON0_type;
#define SCU_WDTCPU0CON0	(*( SCU_WDTCPU0CON0_type *) 0xf0036100u)	/* CPU0 WDT Control Register 0 */
#define SCU_WDTCPU1CON0	(*( SCU_WDTCPU0CON0_type *) 0xf003610cu)	/* CPU1 WDT Control Register 0 */
#define SCU_WDTCPU2CON0	(*( SCU_WDTCPU0CON0_type *) 0xf0036118u)	/* CPU2 WDT Control Register 0 */
#define SCU_WDTSCON0	(*( SCU_WDTCPU0CON0_type *) 0xf00360f0u)	/* Safety WDT Control Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int IR0            : 1;	/* Input Frequency Request Control */
		unsigned int DR             : 1;	/* Disable Request Control Bit */
		unsigned int                : 1;
		unsigned int IR1            : 1;	/* Input Frequency Request Control */
		unsigned int UR             : 1;	/* Unlock Restriction Request Control Bit */
		unsigned int PAR            : 1;	/* Password Auto-sequence Request Bit */
		unsigned int TCR            : 1;	/* Counter Check Request Bit */
		/* const */ unsigned int TCTR           : 7;	/* Timer Check Tolerance Request */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SCU_WDTCPU0CON1_type;
#define SCU_WDTCPU0CON1	(*( SCU_WDTCPU0CON1_type *) 0xf0036104u)	/* CPU0 WDT Control Register 1 */
#define SCU_WDTCPU1CON1	(*( SCU_WDTCPU0CON1_type *) 0xf0036110u)	/* CPU1 WDT Control Register 1 */
#define SCU_WDTCPU2CON1	(*( SCU_WDTCPU0CON1_type *) 0xf003611cu)	/* CPU2 WDT Control Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int AE             : 1;	/* Watchdog Access Error Status Flag */
		/* const */ unsigned int OE             : 1;	/* Watchdog Overflow Error Status Flag */
		/* const */ unsigned int IS0            : 1;	/* Watchdog Input Clock Status */
		/* const */ unsigned int DS             : 1;	/* Watchdog Enable/Disable Status Flag */
		/* const */ unsigned int TO             : 1;	/* Watchdog Time-Out Mode Flag */
		/* const */ unsigned int IS1            : 1;	/* Watchdog Input Clock Status */
		/* const */ unsigned int US             : 1;	/* SMU Unlock Restriction Status Flag */
		/* const */ unsigned int PAS            : 1;	/* Password Auto-sequence Status Flag */
		/* const */ unsigned int TCS            : 1;	/* Timer Check Status Flag */
		/* const */ unsigned int TCT            : 7;	/* Timer Check Tolerance */
		/* const */ unsigned int TIM            : 16;	/* Timer Value */
	} B;
	int I;
	unsigned int U;

} SCU_WDTCPU0SR_type;
#define SCU_WDTCPU0SR	(*( SCU_WDTCPU0SR_type *) 0xf0036108u)	/* CPU0 WDT Status Register */
#define SCU_WDTCPU1SR	(*( SCU_WDTCPU0SR_type *) 0xf0036114u)	/* CPU1 WDT Status Register */
#define SCU_WDTCPU2SR	(*( SCU_WDTCPU0SR_type *) 0xf0036120u)	/* CPU2 WDT Status Register */
#define SCU_WDTSSR	(*( SCU_WDTCPU0SR_type *) 0xf00360f8u)	/* Safety WDT Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CLRIRF         : 1;	/* Clear Internal Reset Flag */
		unsigned int                : 1;
		unsigned int IR0            : 1;	/* Input Frequency Request Control */
		unsigned int DR             : 1;	/* Disable Request Control Bit */
		unsigned int                : 1;
		unsigned int IR1            : 1;	/* Input Frequency Request Control */
		unsigned int UR             : 1;	/* Unlock Restriction Request Control Bit */
		unsigned int PAR            : 1;	/* Password Auto-sequence Request Bit */
		unsigned int TCR            : 1;	/* Counter Check Request Bit */
		/* const */ unsigned int TCTR           : 7;	/* Timer Check Tolerance Request */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SCU_WDTSCON1_type;
#define SCU_WDTSCON1	(*( SCU_WDTSCON1_type *) 0xf00360f4u)	/* Safety WDT Control Register 1 */


/* MultiCAN */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} CAN_ACCEN0_type;
#define CAN_ACCEN0	(*( CAN_ACCEN0_type *) 0xf00180fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CAN_ACCEN1_type;
#define CAN_ACCEN1	(*( CAN_ACCEN1_type *) 0xf00180f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int AWDV           : 8;	/* Application Watchdog Value */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} CAN_AWDR_type;
#define CAN_AWDR	(*( CAN_AWDR_type *) 0xf00182a4u)	/* Application Watchdog Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CAN_CLC_type;
#define CAN_CLC	(*( CAN_CLC_type *) 0xf0018000u)	/* CAN Clock Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CYCTM          : 16;	/* Cycle Time */
		/* const */ unsigned int BCC            : 6;	/* Basic Cycle Count */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int CSM            : 6;	/* Column of System Matrix */
		/* const */ unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} CAN_CYCTMR_type;
#define CAN_CYCTMR	(*( CAN_CYCTMR_type *) 0xf0018294u)	/* Cycle Time Register */

typedef volatile union
{
	struct
	{ 
		unsigned int STEP           : 10;	/* Step Value */
		unsigned int                : 4;
		unsigned int DM             : 2;	/* Divider Mode */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CAN_FDR_type;
#define CAN_FDR	(*( CAN_FDR_type *) 0xf001800cu)	/* CAN Fractional Divider Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 9;
		/* const */ unsigned int GMFR           : 7;	/* Global Mark Fraction */
		/* const */ unsigned int GM             : 16;	/* Global Mark */
	} B;
	int I;
	unsigned int U;

} CAN_GMR_type;
#define CAN_GMR	(*( CAN_GMR_type *) 0xf001829cu)	/* Global Mark Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} CAN_ID_type;
#define CAN_ID	(*( CAN_ID_type *) 0xf0018008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} CAN_KRST0_type;
#define CAN_KRST0	(*( CAN_KRST0_type *) 0xf00180f4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CAN_KRST1_type;
#define CAN_KRST1	(*( CAN_KRST1_type *) 0xf00180f0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CAN_KRSTCLR_type;
#define CAN_KRSTCLR	(*( CAN_KRSTCLR_type *) 0xf00180ecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 9;
		/* const */ unsigned int LGMFR          : 7;	/* Last Global Mark Fraction */
		/* const */ unsigned int LGM            : 16;	/* Last Global Mark */
	} B;
	int I;
	unsigned int U;

} CAN_LGMR_type;
#define CAN_LGMR	(*( CAN_LGMR_type *) 0xf00182a0u)	/* Last Global Mark Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int BEGIN          : 8;	/* List Begin */
		/* const */ unsigned int END            : 8;	/* List End */
		/* const */ unsigned int SIZE           : 8;	/* List Size */
		/* const */ unsigned int EMPTY          : 1;	/* List Empty Indication */
		/* const */ unsigned int                : 7;
	} B;
	int I;
	unsigned int U;

} CAN_LIST0_type;
#define CAN_LIST0	(*( CAN_LIST0_type *) 0xf0018100u)	/* List Register 0 */
#define CAN_LIST1	(*( CAN_LIST0_type *) 0xf0018104u)	/* List Register 1 */
#define CAN_LIST10	(*( CAN_LIST0_type *) 0xf0018128u)	/* List Register 10 */
#define CAN_LIST11	(*( CAN_LIST0_type *) 0xf001812cu)	/* List Register 11 */
#define CAN_LIST12	(*( CAN_LIST0_type *) 0xf0018130u)	/* List Register 12 */
#define CAN_LIST13	(*( CAN_LIST0_type *) 0xf0018134u)	/* List Register 13 */
#define CAN_LIST14	(*( CAN_LIST0_type *) 0xf0018138u)	/* List Register 14 */
#define CAN_LIST15	(*( CAN_LIST0_type *) 0xf001813cu)	/* List Register 15 */
#define CAN_LIST2	(*( CAN_LIST0_type *) 0xf0018108u)	/* List Register 2 */
#define CAN_LIST3	(*( CAN_LIST0_type *) 0xf001810cu)	/* List Register 3 */
#define CAN_LIST4	(*( CAN_LIST0_type *) 0xf0018110u)	/* List Register 4 */
#define CAN_LIST5	(*( CAN_LIST0_type *) 0xf0018114u)	/* List Register 5 */
#define CAN_LIST6	(*( CAN_LIST0_type *) 0xf0018118u)	/* List Register 6 */
#define CAN_LIST7	(*( CAN_LIST0_type *) 0xf001811cu)	/* List Register 7 */
#define CAN_LIST8	(*( CAN_LIST0_type *) 0xf0018120u)	/* List Register 8 */
#define CAN_LIST9	(*( CAN_LIST0_type *) 0xf0018124u)	/* List Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int NEWDISC        : 1;	/* New Discontinuity Bit */
		/* const */ unsigned int DISC           : 1;	/* Discontinuity Bit */
		unsigned int                : 7;
		unsigned int LOFFR          : 7;	/* Local Offset Fraction */
		unsigned int LOF            : 16;	/* Local Offset */
	} B;
	int I;
	unsigned int U;

} CAN_LOR_type;
#define CAN_LOR	(*( CAN_LOR_type *) 0xf0018298u)	/* Local Offset Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 9;
		/* const */ unsigned int LREFMFR        : 7;	/* Last Reference Mark Fraction */
		/* const */ unsigned int LREFM          : 16;	/* Last Reference Mark */
	} B;
	int I;
	unsigned int U;

} CAN_LREFMR_type;
#define CAN_LREFMR	(*( CAN_LREFMR_type *) 0xf001828cu)	/* Last Reference Mark Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 6;
		/* const */ unsigned int LTFRC          : 10;	/* Local Time Fraction Value Capture */
		/* const */ unsigned int LTC            : 16;	/* Local Time Value Capture */
	} B;
	int I;
	unsigned int U;

} CAN_LTCR_type;
#define CAN_LTCR	(*( CAN_LTCR_type *) 0xf00182a8u)	/* Local Time Capture Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 6;
		/* const */ unsigned int LTFR           : 10;	/* Local Time Fraction */
		/* const */ unsigned int LT             : 16;	/* Local Time */
	} B;
	int I;
	unsigned int U;

} CAN_LTR_type;
#define CAN_LTR	(*( CAN_LTR_type *) 0xf0018280u)	/* Local Time Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CLKSEL         : 4;	/* Baud Rate Logic Clock Select */
		unsigned int                : 8;
		unsigned int MPSEL          : 4;	/* Message Pending Selector */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CAN_MCR_type;
#define CAN_MCR	(*( CAN_MCR_type *) 0xf00181c8u)	/* Module Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IT             : 16;	/* Interrupt Trigger */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CAN_MITR_type;
#define CAN_MITR	(*( CAN_MITR_type *) 0xf00181ccu)	/* Module Interrupt Trigger Register */

typedef volatile union
{
	struct
	{ 
		unsigned int AM             : 29;	/* Acceptance Mask for Message Identifier */
		unsigned int MIDE           : 1;	/* Acceptance Mask Bit for Message IDE Bit */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} CAN_MOAMR0_type;
#define CAN_MOAMR0	(*( CAN_MOAMR0_type *) 0xf001900cu)	/* Message Object 0 Acceptance Mask Register */
#define CAN_MOAMR1	(*( CAN_MOAMR0_type *) 0xf001902cu)	/* Message Object 1 Acceptance Mask Register */
#define CAN_MOAMR10	(*( CAN_MOAMR0_type *) 0xf001914cu)	/* Message Object 10 Acceptance Mask Register */
#define CAN_MOAMR100	(*( CAN_MOAMR0_type *) 0xf0019c8cu)	/* Message Object 100 Acceptance Mask Register */
#define CAN_MOAMR101	(*( CAN_MOAMR0_type *) 0xf0019cacu)	/* Message Object 101 Acceptance Mask Register */
#define CAN_MOAMR102	(*( CAN_MOAMR0_type *) 0xf0019cccu)	/* Message Object 102 Acceptance Mask Register */
#define CAN_MOAMR103	(*( CAN_MOAMR0_type *) 0xf0019cecu)	/* Message Object 103 Acceptance Mask Register */
#define CAN_MOAMR104	(*( CAN_MOAMR0_type *) 0xf0019d0cu)	/* Message Object 104 Acceptance Mask Register */
#define CAN_MOAMR105	(*( CAN_MOAMR0_type *) 0xf0019d2cu)	/* Message Object 105 Acceptance Mask Register */
#define CAN_MOAMR106	(*( CAN_MOAMR0_type *) 0xf0019d4cu)	/* Message Object 106 Acceptance Mask Register */
#define CAN_MOAMR107	(*( CAN_MOAMR0_type *) 0xf0019d6cu)	/* Message Object 107 Acceptance Mask Register */
#define CAN_MOAMR108	(*( CAN_MOAMR0_type *) 0xf0019d8cu)	/* Message Object 108 Acceptance Mask Register */
#define CAN_MOAMR109	(*( CAN_MOAMR0_type *) 0xf0019dacu)	/* Message Object 109 Acceptance Mask Register */
#define CAN_MOAMR11	(*( CAN_MOAMR0_type *) 0xf001916cu)	/* Message Object 11 Acceptance Mask Register */
#define CAN_MOAMR110	(*( CAN_MOAMR0_type *) 0xf0019dccu)	/* Message Object 110 Acceptance Mask Register */
#define CAN_MOAMR111	(*( CAN_MOAMR0_type *) 0xf0019decu)	/* Message Object 111 Acceptance Mask Register */
#define CAN_MOAMR112	(*( CAN_MOAMR0_type *) 0xf0019e0cu)	/* Message Object 112 Acceptance Mask Register */
#define CAN_MOAMR113	(*( CAN_MOAMR0_type *) 0xf0019e2cu)	/* Message Object 113 Acceptance Mask Register */
#define CAN_MOAMR114	(*( CAN_MOAMR0_type *) 0xf0019e4cu)	/* Message Object 114 Acceptance Mask Register */
#define CAN_MOAMR115	(*( CAN_MOAMR0_type *) 0xf0019e6cu)	/* Message Object 115 Acceptance Mask Register */
#define CAN_MOAMR116	(*( CAN_MOAMR0_type *) 0xf0019e8cu)	/* Message Object 116 Acceptance Mask Register */
#define CAN_MOAMR117	(*( CAN_MOAMR0_type *) 0xf0019eacu)	/* Message Object 117 Acceptance Mask Register */
#define CAN_MOAMR118	(*( CAN_MOAMR0_type *) 0xf0019eccu)	/* Message Object 118 Acceptance Mask Register */
#define CAN_MOAMR119	(*( CAN_MOAMR0_type *) 0xf0019eecu)	/* Message Object 119 Acceptance Mask Register */
#define CAN_MOAMR12	(*( CAN_MOAMR0_type *) 0xf001918cu)	/* Message Object 12 Acceptance Mask Register */
#define CAN_MOAMR120	(*( CAN_MOAMR0_type *) 0xf0019f0cu)	/* Message Object 120 Acceptance Mask Register */
#define CAN_MOAMR121	(*( CAN_MOAMR0_type *) 0xf0019f2cu)	/* Message Object 121 Acceptance Mask Register */
#define CAN_MOAMR122	(*( CAN_MOAMR0_type *) 0xf0019f4cu)	/* Message Object 122 Acceptance Mask Register */
#define CAN_MOAMR123	(*( CAN_MOAMR0_type *) 0xf0019f6cu)	/* Message Object 123 Acceptance Mask Register */
#define CAN_MOAMR124	(*( CAN_MOAMR0_type *) 0xf0019f8cu)	/* Message Object 124 Acceptance Mask Register */
#define CAN_MOAMR125	(*( CAN_MOAMR0_type *) 0xf0019facu)	/* Message Object 125 Acceptance Mask Register */
#define CAN_MOAMR126	(*( CAN_MOAMR0_type *) 0xf0019fccu)	/* Message Object 126 Acceptance Mask Register */
#define CAN_MOAMR127	(*( CAN_MOAMR0_type *) 0xf0019fecu)	/* Message Object 127 Acceptance Mask Register */
#define CAN_MOAMR128	(*( CAN_MOAMR0_type *) 0xf001a00cu)	/* Message Object 128 Acceptance Mask Register */
#define CAN_MOAMR129	(*( CAN_MOAMR0_type *) 0xf001a02cu)	/* Message Object 129 Acceptance Mask Register */
#define CAN_MOAMR13	(*( CAN_MOAMR0_type *) 0xf00191acu)	/* Message Object 13 Acceptance Mask Register */
#define CAN_MOAMR130	(*( CAN_MOAMR0_type *) 0xf001a04cu)	/* Message Object 130 Acceptance Mask Register */
#define CAN_MOAMR131	(*( CAN_MOAMR0_type *) 0xf001a06cu)	/* Message Object 131 Acceptance Mask Register */
#define CAN_MOAMR132	(*( CAN_MOAMR0_type *) 0xf001a08cu)	/* Message Object 132 Acceptance Mask Register */
#define CAN_MOAMR133	(*( CAN_MOAMR0_type *) 0xf001a0acu)	/* Message Object 133 Acceptance Mask Register */
#define CAN_MOAMR134	(*( CAN_MOAMR0_type *) 0xf001a0ccu)	/* Message Object 134 Acceptance Mask Register */
#define CAN_MOAMR135	(*( CAN_MOAMR0_type *) 0xf001a0ecu)	/* Message Object 135 Acceptance Mask Register */
#define CAN_MOAMR136	(*( CAN_MOAMR0_type *) 0xf001a10cu)	/* Message Object 136 Acceptance Mask Register */
#define CAN_MOAMR137	(*( CAN_MOAMR0_type *) 0xf001a12cu)	/* Message Object 137 Acceptance Mask Register */
#define CAN_MOAMR138	(*( CAN_MOAMR0_type *) 0xf001a14cu)	/* Message Object 138 Acceptance Mask Register */
#define CAN_MOAMR139	(*( CAN_MOAMR0_type *) 0xf001a16cu)	/* Message Object 139 Acceptance Mask Register */
#define CAN_MOAMR14	(*( CAN_MOAMR0_type *) 0xf00191ccu)	/* Message Object 14 Acceptance Mask Register */
#define CAN_MOAMR140	(*( CAN_MOAMR0_type *) 0xf001a18cu)	/* Message Object 140 Acceptance Mask Register */
#define CAN_MOAMR141	(*( CAN_MOAMR0_type *) 0xf001a1acu)	/* Message Object 141 Acceptance Mask Register */
#define CAN_MOAMR142	(*( CAN_MOAMR0_type *) 0xf001a1ccu)	/* Message Object 142 Acceptance Mask Register */
#define CAN_MOAMR143	(*( CAN_MOAMR0_type *) 0xf001a1ecu)	/* Message Object 143 Acceptance Mask Register */
#define CAN_MOAMR144	(*( CAN_MOAMR0_type *) 0xf001a20cu)	/* Message Object 144 Acceptance Mask Register */
#define CAN_MOAMR145	(*( CAN_MOAMR0_type *) 0xf001a22cu)	/* Message Object 145 Acceptance Mask Register */
#define CAN_MOAMR146	(*( CAN_MOAMR0_type *) 0xf001a24cu)	/* Message Object 146 Acceptance Mask Register */
#define CAN_MOAMR147	(*( CAN_MOAMR0_type *) 0xf001a26cu)	/* Message Object 147 Acceptance Mask Register */
#define CAN_MOAMR148	(*( CAN_MOAMR0_type *) 0xf001a28cu)	/* Message Object 148 Acceptance Mask Register */
#define CAN_MOAMR149	(*( CAN_MOAMR0_type *) 0xf001a2acu)	/* Message Object 149 Acceptance Mask Register */
#define CAN_MOAMR15	(*( CAN_MOAMR0_type *) 0xf00191ecu)	/* Message Object 15 Acceptance Mask Register */
#define CAN_MOAMR150	(*( CAN_MOAMR0_type *) 0xf001a2ccu)	/* Message Object 150 Acceptance Mask Register */
#define CAN_MOAMR151	(*( CAN_MOAMR0_type *) 0xf001a2ecu)	/* Message Object 151 Acceptance Mask Register */
#define CAN_MOAMR152	(*( CAN_MOAMR0_type *) 0xf001a30cu)	/* Message Object 152 Acceptance Mask Register */
#define CAN_MOAMR153	(*( CAN_MOAMR0_type *) 0xf001a32cu)	/* Message Object 153 Acceptance Mask Register */
#define CAN_MOAMR154	(*( CAN_MOAMR0_type *) 0xf001a34cu)	/* Message Object 154 Acceptance Mask Register */
#define CAN_MOAMR155	(*( CAN_MOAMR0_type *) 0xf001a36cu)	/* Message Object 155 Acceptance Mask Register */
#define CAN_MOAMR156	(*( CAN_MOAMR0_type *) 0xf001a38cu)	/* Message Object 156 Acceptance Mask Register */
#define CAN_MOAMR157	(*( CAN_MOAMR0_type *) 0xf001a3acu)	/* Message Object 157 Acceptance Mask Register */
#define CAN_MOAMR158	(*( CAN_MOAMR0_type *) 0xf001a3ccu)	/* Message Object 158 Acceptance Mask Register */
#define CAN_MOAMR159	(*( CAN_MOAMR0_type *) 0xf001a3ecu)	/* Message Object 159 Acceptance Mask Register */
#define CAN_MOAMR16	(*( CAN_MOAMR0_type *) 0xf001920cu)	/* Message Object 16 Acceptance Mask Register */
#define CAN_MOAMR160	(*( CAN_MOAMR0_type *) 0xf001a40cu)	/* Message Object 160 Acceptance Mask Register */
#define CAN_MOAMR161	(*( CAN_MOAMR0_type *) 0xf001a42cu)	/* Message Object 161 Acceptance Mask Register */
#define CAN_MOAMR162	(*( CAN_MOAMR0_type *) 0xf001a44cu)	/* Message Object 162 Acceptance Mask Register */
#define CAN_MOAMR163	(*( CAN_MOAMR0_type *) 0xf001a46cu)	/* Message Object 163 Acceptance Mask Register */
#define CAN_MOAMR164	(*( CAN_MOAMR0_type *) 0xf001a48cu)	/* Message Object 164 Acceptance Mask Register */
#define CAN_MOAMR165	(*( CAN_MOAMR0_type *) 0xf001a4acu)	/* Message Object 165 Acceptance Mask Register */
#define CAN_MOAMR166	(*( CAN_MOAMR0_type *) 0xf001a4ccu)	/* Message Object 166 Acceptance Mask Register */
#define CAN_MOAMR167	(*( CAN_MOAMR0_type *) 0xf001a4ecu)	/* Message Object 167 Acceptance Mask Register */
#define CAN_MOAMR168	(*( CAN_MOAMR0_type *) 0xf001a50cu)	/* Message Object 168 Acceptance Mask Register */
#define CAN_MOAMR169	(*( CAN_MOAMR0_type *) 0xf001a52cu)	/* Message Object 169 Acceptance Mask Register */
#define CAN_MOAMR17	(*( CAN_MOAMR0_type *) 0xf001922cu)	/* Message Object 17 Acceptance Mask Register */
#define CAN_MOAMR170	(*( CAN_MOAMR0_type *) 0xf001a54cu)	/* Message Object 170 Acceptance Mask Register */
#define CAN_MOAMR171	(*( CAN_MOAMR0_type *) 0xf001a56cu)	/* Message Object 171 Acceptance Mask Register */
#define CAN_MOAMR172	(*( CAN_MOAMR0_type *) 0xf001a58cu)	/* Message Object 172 Acceptance Mask Register */
#define CAN_MOAMR173	(*( CAN_MOAMR0_type *) 0xf001a5acu)	/* Message Object 173 Acceptance Mask Register */
#define CAN_MOAMR174	(*( CAN_MOAMR0_type *) 0xf001a5ccu)	/* Message Object 174 Acceptance Mask Register */
#define CAN_MOAMR175	(*( CAN_MOAMR0_type *) 0xf001a5ecu)	/* Message Object 175 Acceptance Mask Register */
#define CAN_MOAMR176	(*( CAN_MOAMR0_type *) 0xf001a60cu)	/* Message Object 176 Acceptance Mask Register */
#define CAN_MOAMR177	(*( CAN_MOAMR0_type *) 0xf001a62cu)	/* Message Object 177 Acceptance Mask Register */
#define CAN_MOAMR178	(*( CAN_MOAMR0_type *) 0xf001a64cu)	/* Message Object 178 Acceptance Mask Register */
#define CAN_MOAMR179	(*( CAN_MOAMR0_type *) 0xf001a66cu)	/* Message Object 179 Acceptance Mask Register */
#define CAN_MOAMR18	(*( CAN_MOAMR0_type *) 0xf001924cu)	/* Message Object 18 Acceptance Mask Register */
#define CAN_MOAMR180	(*( CAN_MOAMR0_type *) 0xf001a68cu)	/* Message Object 180 Acceptance Mask Register */
#define CAN_MOAMR181	(*( CAN_MOAMR0_type *) 0xf001a6acu)	/* Message Object 181 Acceptance Mask Register */
#define CAN_MOAMR182	(*( CAN_MOAMR0_type *) 0xf001a6ccu)	/* Message Object 182 Acceptance Mask Register */
#define CAN_MOAMR183	(*( CAN_MOAMR0_type *) 0xf001a6ecu)	/* Message Object 183 Acceptance Mask Register */
#define CAN_MOAMR184	(*( CAN_MOAMR0_type *) 0xf001a70cu)	/* Message Object 184 Acceptance Mask Register */
#define CAN_MOAMR185	(*( CAN_MOAMR0_type *) 0xf001a72cu)	/* Message Object 185 Acceptance Mask Register */
#define CAN_MOAMR186	(*( CAN_MOAMR0_type *) 0xf001a74cu)	/* Message Object 186 Acceptance Mask Register */
#define CAN_MOAMR187	(*( CAN_MOAMR0_type *) 0xf001a76cu)	/* Message Object 187 Acceptance Mask Register */
#define CAN_MOAMR188	(*( CAN_MOAMR0_type *) 0xf001a78cu)	/* Message Object 188 Acceptance Mask Register */
#define CAN_MOAMR189	(*( CAN_MOAMR0_type *) 0xf001a7acu)	/* Message Object 189 Acceptance Mask Register */
#define CAN_MOAMR19	(*( CAN_MOAMR0_type *) 0xf001926cu)	/* Message Object 19 Acceptance Mask Register */
#define CAN_MOAMR190	(*( CAN_MOAMR0_type *) 0xf001a7ccu)	/* Message Object 190 Acceptance Mask Register */
#define CAN_MOAMR191	(*( CAN_MOAMR0_type *) 0xf001a7ecu)	/* Message Object 191 Acceptance Mask Register */
#define CAN_MOAMR192	(*( CAN_MOAMR0_type *) 0xf001a80cu)	/* Message Object 192 Acceptance Mask Register */
#define CAN_MOAMR193	(*( CAN_MOAMR0_type *) 0xf001a82cu)	/* Message Object 193 Acceptance Mask Register */
#define CAN_MOAMR194	(*( CAN_MOAMR0_type *) 0xf001a84cu)	/* Message Object 194 Acceptance Mask Register */
#define CAN_MOAMR195	(*( CAN_MOAMR0_type *) 0xf001a86cu)	/* Message Object 195 Acceptance Mask Register */
#define CAN_MOAMR196	(*( CAN_MOAMR0_type *) 0xf001a88cu)	/* Message Object 196 Acceptance Mask Register */
#define CAN_MOAMR197	(*( CAN_MOAMR0_type *) 0xf001a8acu)	/* Message Object 197 Acceptance Mask Register */
#define CAN_MOAMR198	(*( CAN_MOAMR0_type *) 0xf001a8ccu)	/* Message Object 198 Acceptance Mask Register */
#define CAN_MOAMR199	(*( CAN_MOAMR0_type *) 0xf001a8ecu)	/* Message Object 199 Acceptance Mask Register */
#define CAN_MOAMR2	(*( CAN_MOAMR0_type *) 0xf001904cu)	/* Message Object 2 Acceptance Mask Register */
#define CAN_MOAMR20	(*( CAN_MOAMR0_type *) 0xf001928cu)	/* Message Object 20 Acceptance Mask Register */
#define CAN_MOAMR200	(*( CAN_MOAMR0_type *) 0xf001a90cu)	/* Message Object 200 Acceptance Mask Register */
#define CAN_MOAMR201	(*( CAN_MOAMR0_type *) 0xf001a92cu)	/* Message Object 201 Acceptance Mask Register */
#define CAN_MOAMR202	(*( CAN_MOAMR0_type *) 0xf001a94cu)	/* Message Object 202 Acceptance Mask Register */
#define CAN_MOAMR203	(*( CAN_MOAMR0_type *) 0xf001a96cu)	/* Message Object 203 Acceptance Mask Register */
#define CAN_MOAMR204	(*( CAN_MOAMR0_type *) 0xf001a98cu)	/* Message Object 204 Acceptance Mask Register */
#define CAN_MOAMR205	(*( CAN_MOAMR0_type *) 0xf001a9acu)	/* Message Object 205 Acceptance Mask Register */
#define CAN_MOAMR206	(*( CAN_MOAMR0_type *) 0xf001a9ccu)	/* Message Object 206 Acceptance Mask Register */
#define CAN_MOAMR207	(*( CAN_MOAMR0_type *) 0xf001a9ecu)	/* Message Object 207 Acceptance Mask Register */
#define CAN_MOAMR208	(*( CAN_MOAMR0_type *) 0xf001aa0cu)	/* Message Object 208 Acceptance Mask Register */
#define CAN_MOAMR209	(*( CAN_MOAMR0_type *) 0xf001aa2cu)	/* Message Object 209 Acceptance Mask Register */
#define CAN_MOAMR21	(*( CAN_MOAMR0_type *) 0xf00192acu)	/* Message Object 21 Acceptance Mask Register */
#define CAN_MOAMR210	(*( CAN_MOAMR0_type *) 0xf001aa4cu)	/* Message Object 210 Acceptance Mask Register */
#define CAN_MOAMR211	(*( CAN_MOAMR0_type *) 0xf001aa6cu)	/* Message Object 211 Acceptance Mask Register */
#define CAN_MOAMR212	(*( CAN_MOAMR0_type *) 0xf001aa8cu)	/* Message Object 212 Acceptance Mask Register */
#define CAN_MOAMR213	(*( CAN_MOAMR0_type *) 0xf001aaacu)	/* Message Object 213 Acceptance Mask Register */
#define CAN_MOAMR214	(*( CAN_MOAMR0_type *) 0xf001aaccu)	/* Message Object 214 Acceptance Mask Register */
#define CAN_MOAMR215	(*( CAN_MOAMR0_type *) 0xf001aaecu)	/* Message Object 215 Acceptance Mask Register */
#define CAN_MOAMR216	(*( CAN_MOAMR0_type *) 0xf001ab0cu)	/* Message Object 216 Acceptance Mask Register */
#define CAN_MOAMR217	(*( CAN_MOAMR0_type *) 0xf001ab2cu)	/* Message Object 217 Acceptance Mask Register */
#define CAN_MOAMR218	(*( CAN_MOAMR0_type *) 0xf001ab4cu)	/* Message Object 218 Acceptance Mask Register */
#define CAN_MOAMR219	(*( CAN_MOAMR0_type *) 0xf001ab6cu)	/* Message Object 219 Acceptance Mask Register */
#define CAN_MOAMR22	(*( CAN_MOAMR0_type *) 0xf00192ccu)	/* Message Object 22 Acceptance Mask Register */
#define CAN_MOAMR220	(*( CAN_MOAMR0_type *) 0xf001ab8cu)	/* Message Object 220 Acceptance Mask Register */
#define CAN_MOAMR221	(*( CAN_MOAMR0_type *) 0xf001abacu)	/* Message Object 221 Acceptance Mask Register */
#define CAN_MOAMR222	(*( CAN_MOAMR0_type *) 0xf001abccu)	/* Message Object 222 Acceptance Mask Register */
#define CAN_MOAMR223	(*( CAN_MOAMR0_type *) 0xf001abecu)	/* Message Object 223 Acceptance Mask Register */
#define CAN_MOAMR224	(*( CAN_MOAMR0_type *) 0xf001ac0cu)	/* Message Object 224 Acceptance Mask Register */
#define CAN_MOAMR225	(*( CAN_MOAMR0_type *) 0xf001ac2cu)	/* Message Object 225 Acceptance Mask Register */
#define CAN_MOAMR226	(*( CAN_MOAMR0_type *) 0xf001ac4cu)	/* Message Object 226 Acceptance Mask Register */
#define CAN_MOAMR227	(*( CAN_MOAMR0_type *) 0xf001ac6cu)	/* Message Object 227 Acceptance Mask Register */
#define CAN_MOAMR228	(*( CAN_MOAMR0_type *) 0xf001ac8cu)	/* Message Object 228 Acceptance Mask Register */
#define CAN_MOAMR229	(*( CAN_MOAMR0_type *) 0xf001acacu)	/* Message Object 229 Acceptance Mask Register */
#define CAN_MOAMR23	(*( CAN_MOAMR0_type *) 0xf00192ecu)	/* Message Object 23 Acceptance Mask Register */
#define CAN_MOAMR230	(*( CAN_MOAMR0_type *) 0xf001acccu)	/* Message Object 230 Acceptance Mask Register */
#define CAN_MOAMR231	(*( CAN_MOAMR0_type *) 0xf001acecu)	/* Message Object 231 Acceptance Mask Register */
#define CAN_MOAMR232	(*( CAN_MOAMR0_type *) 0xf001ad0cu)	/* Message Object 232 Acceptance Mask Register */
#define CAN_MOAMR233	(*( CAN_MOAMR0_type *) 0xf001ad2cu)	/* Message Object 233 Acceptance Mask Register */
#define CAN_MOAMR234	(*( CAN_MOAMR0_type *) 0xf001ad4cu)	/* Message Object 234 Acceptance Mask Register */
#define CAN_MOAMR235	(*( CAN_MOAMR0_type *) 0xf001ad6cu)	/* Message Object 235 Acceptance Mask Register */
#define CAN_MOAMR236	(*( CAN_MOAMR0_type *) 0xf001ad8cu)	/* Message Object 236 Acceptance Mask Register */
#define CAN_MOAMR237	(*( CAN_MOAMR0_type *) 0xf001adacu)	/* Message Object 237 Acceptance Mask Register */
#define CAN_MOAMR238	(*( CAN_MOAMR0_type *) 0xf001adccu)	/* Message Object 238 Acceptance Mask Register */
#define CAN_MOAMR239	(*( CAN_MOAMR0_type *) 0xf001adecu)	/* Message Object 239 Acceptance Mask Register */
#define CAN_MOAMR24	(*( CAN_MOAMR0_type *) 0xf001930cu)	/* Message Object 24 Acceptance Mask Register */
#define CAN_MOAMR240	(*( CAN_MOAMR0_type *) 0xf001ae0cu)	/* Message Object 240 Acceptance Mask Register */
#define CAN_MOAMR241	(*( CAN_MOAMR0_type *) 0xf001ae2cu)	/* Message Object 241 Acceptance Mask Register */
#define CAN_MOAMR242	(*( CAN_MOAMR0_type *) 0xf001ae4cu)	/* Message Object 242 Acceptance Mask Register */
#define CAN_MOAMR243	(*( CAN_MOAMR0_type *) 0xf001ae6cu)	/* Message Object 243 Acceptance Mask Register */
#define CAN_MOAMR244	(*( CAN_MOAMR0_type *) 0xf001ae8cu)	/* Message Object 244 Acceptance Mask Register */
#define CAN_MOAMR245	(*( CAN_MOAMR0_type *) 0xf001aeacu)	/* Message Object 245 Acceptance Mask Register */
#define CAN_MOAMR246	(*( CAN_MOAMR0_type *) 0xf001aeccu)	/* Message Object 246 Acceptance Mask Register */
#define CAN_MOAMR247	(*( CAN_MOAMR0_type *) 0xf001aeecu)	/* Message Object 247 Acceptance Mask Register */
#define CAN_MOAMR248	(*( CAN_MOAMR0_type *) 0xf001af0cu)	/* Message Object 248 Acceptance Mask Register */
#define CAN_MOAMR249	(*( CAN_MOAMR0_type *) 0xf001af2cu)	/* Message Object 249 Acceptance Mask Register */
#define CAN_MOAMR25	(*( CAN_MOAMR0_type *) 0xf001932cu)	/* Message Object 25 Acceptance Mask Register */
#define CAN_MOAMR250	(*( CAN_MOAMR0_type *) 0xf001af4cu)	/* Message Object 250 Acceptance Mask Register */
#define CAN_MOAMR251	(*( CAN_MOAMR0_type *) 0xf001af6cu)	/* Message Object 251 Acceptance Mask Register */
#define CAN_MOAMR252	(*( CAN_MOAMR0_type *) 0xf001af8cu)	/* Message Object 252 Acceptance Mask Register */
#define CAN_MOAMR253	(*( CAN_MOAMR0_type *) 0xf001afacu)	/* Message Object 253 Acceptance Mask Register */
#define CAN_MOAMR254	(*( CAN_MOAMR0_type *) 0xf001afccu)	/* Message Object 254 Acceptance Mask Register */
#define CAN_MOAMR255	(*( CAN_MOAMR0_type *) 0xf001afecu)	/* Message Object 255 Acceptance Mask Register */
#define CAN_MOAMR26	(*( CAN_MOAMR0_type *) 0xf001934cu)	/* Message Object 26 Acceptance Mask Register */
#define CAN_MOAMR27	(*( CAN_MOAMR0_type *) 0xf001936cu)	/* Message Object 27 Acceptance Mask Register */
#define CAN_MOAMR28	(*( CAN_MOAMR0_type *) 0xf001938cu)	/* Message Object 28 Acceptance Mask Register */
#define CAN_MOAMR29	(*( CAN_MOAMR0_type *) 0xf00193acu)	/* Message Object 29 Acceptance Mask Register */
#define CAN_MOAMR3	(*( CAN_MOAMR0_type *) 0xf001906cu)	/* Message Object 3 Acceptance Mask Register */
#define CAN_MOAMR30	(*( CAN_MOAMR0_type *) 0xf00193ccu)	/* Message Object 30 Acceptance Mask Register */
#define CAN_MOAMR31	(*( CAN_MOAMR0_type *) 0xf00193ecu)	/* Message Object 31 Acceptance Mask Register */
#define CAN_MOAMR32	(*( CAN_MOAMR0_type *) 0xf001940cu)	/* Message Object 32 Acceptance Mask Register */
#define CAN_MOAMR33	(*( CAN_MOAMR0_type *) 0xf001942cu)	/* Message Object 33 Acceptance Mask Register */
#define CAN_MOAMR34	(*( CAN_MOAMR0_type *) 0xf001944cu)	/* Message Object 34 Acceptance Mask Register */
#define CAN_MOAMR35	(*( CAN_MOAMR0_type *) 0xf001946cu)	/* Message Object 35 Acceptance Mask Register */
#define CAN_MOAMR36	(*( CAN_MOAMR0_type *) 0xf001948cu)	/* Message Object 36 Acceptance Mask Register */
#define CAN_MOAMR37	(*( CAN_MOAMR0_type *) 0xf00194acu)	/* Message Object 37 Acceptance Mask Register */
#define CAN_MOAMR38	(*( CAN_MOAMR0_type *) 0xf00194ccu)	/* Message Object 38 Acceptance Mask Register */
#define CAN_MOAMR39	(*( CAN_MOAMR0_type *) 0xf00194ecu)	/* Message Object 39 Acceptance Mask Register */
#define CAN_MOAMR4	(*( CAN_MOAMR0_type *) 0xf001908cu)	/* Message Object 4 Acceptance Mask Register */
#define CAN_MOAMR40	(*( CAN_MOAMR0_type *) 0xf001950cu)	/* Message Object 40 Acceptance Mask Register */
#define CAN_MOAMR41	(*( CAN_MOAMR0_type *) 0xf001952cu)	/* Message Object 41 Acceptance Mask Register */
#define CAN_MOAMR42	(*( CAN_MOAMR0_type *) 0xf001954cu)	/* Message Object 42 Acceptance Mask Register */
#define CAN_MOAMR43	(*( CAN_MOAMR0_type *) 0xf001956cu)	/* Message Object 43 Acceptance Mask Register */
#define CAN_MOAMR44	(*( CAN_MOAMR0_type *) 0xf001958cu)	/* Message Object 44 Acceptance Mask Register */
#define CAN_MOAMR45	(*( CAN_MOAMR0_type *) 0xf00195acu)	/* Message Object 45 Acceptance Mask Register */
#define CAN_MOAMR46	(*( CAN_MOAMR0_type *) 0xf00195ccu)	/* Message Object 46 Acceptance Mask Register */
#define CAN_MOAMR47	(*( CAN_MOAMR0_type *) 0xf00195ecu)	/* Message Object 47 Acceptance Mask Register */
#define CAN_MOAMR48	(*( CAN_MOAMR0_type *) 0xf001960cu)	/* Message Object 48 Acceptance Mask Register */
#define CAN_MOAMR49	(*( CAN_MOAMR0_type *) 0xf001962cu)	/* Message Object 49 Acceptance Mask Register */
#define CAN_MOAMR5	(*( CAN_MOAMR0_type *) 0xf00190acu)	/* Message Object 5 Acceptance Mask Register */
#define CAN_MOAMR50	(*( CAN_MOAMR0_type *) 0xf001964cu)	/* Message Object 50 Acceptance Mask Register */
#define CAN_MOAMR51	(*( CAN_MOAMR0_type *) 0xf001966cu)	/* Message Object 51 Acceptance Mask Register */
#define CAN_MOAMR52	(*( CAN_MOAMR0_type *) 0xf001968cu)	/* Message Object 52 Acceptance Mask Register */
#define CAN_MOAMR53	(*( CAN_MOAMR0_type *) 0xf00196acu)	/* Message Object 53 Acceptance Mask Register */
#define CAN_MOAMR54	(*( CAN_MOAMR0_type *) 0xf00196ccu)	/* Message Object 54 Acceptance Mask Register */
#define CAN_MOAMR55	(*( CAN_MOAMR0_type *) 0xf00196ecu)	/* Message Object 55 Acceptance Mask Register */
#define CAN_MOAMR56	(*( CAN_MOAMR0_type *) 0xf001970cu)	/* Message Object 56 Acceptance Mask Register */
#define CAN_MOAMR57	(*( CAN_MOAMR0_type *) 0xf001972cu)	/* Message Object 57 Acceptance Mask Register */
#define CAN_MOAMR58	(*( CAN_MOAMR0_type *) 0xf001974cu)	/* Message Object 58 Acceptance Mask Register */
#define CAN_MOAMR59	(*( CAN_MOAMR0_type *) 0xf001976cu)	/* Message Object 59 Acceptance Mask Register */
#define CAN_MOAMR6	(*( CAN_MOAMR0_type *) 0xf00190ccu)	/* Message Object 6 Acceptance Mask Register */
#define CAN_MOAMR60	(*( CAN_MOAMR0_type *) 0xf001978cu)	/* Message Object 60 Acceptance Mask Register */
#define CAN_MOAMR61	(*( CAN_MOAMR0_type *) 0xf00197acu)	/* Message Object 61 Acceptance Mask Register */
#define CAN_MOAMR62	(*( CAN_MOAMR0_type *) 0xf00197ccu)	/* Message Object 62 Acceptance Mask Register */
#define CAN_MOAMR63	(*( CAN_MOAMR0_type *) 0xf00197ecu)	/* Message Object 63 Acceptance Mask Register */
#define CAN_MOAMR64	(*( CAN_MOAMR0_type *) 0xf001980cu)	/* Message Object 64 Acceptance Mask Register */
#define CAN_MOAMR65	(*( CAN_MOAMR0_type *) 0xf001982cu)	/* Message Object 65 Acceptance Mask Register */
#define CAN_MOAMR66	(*( CAN_MOAMR0_type *) 0xf001984cu)	/* Message Object 66 Acceptance Mask Register */
#define CAN_MOAMR67	(*( CAN_MOAMR0_type *) 0xf001986cu)	/* Message Object 67 Acceptance Mask Register */
#define CAN_MOAMR68	(*( CAN_MOAMR0_type *) 0xf001988cu)	/* Message Object 68 Acceptance Mask Register */
#define CAN_MOAMR69	(*( CAN_MOAMR0_type *) 0xf00198acu)	/* Message Object 69 Acceptance Mask Register */
#define CAN_MOAMR7	(*( CAN_MOAMR0_type *) 0xf00190ecu)	/* Message Object 7 Acceptance Mask Register */
#define CAN_MOAMR70	(*( CAN_MOAMR0_type *) 0xf00198ccu)	/* Message Object 70 Acceptance Mask Register */
#define CAN_MOAMR71	(*( CAN_MOAMR0_type *) 0xf00198ecu)	/* Message Object 71 Acceptance Mask Register */
#define CAN_MOAMR72	(*( CAN_MOAMR0_type *) 0xf001990cu)	/* Message Object 72 Acceptance Mask Register */
#define CAN_MOAMR73	(*( CAN_MOAMR0_type *) 0xf001992cu)	/* Message Object 73 Acceptance Mask Register */
#define CAN_MOAMR74	(*( CAN_MOAMR0_type *) 0xf001994cu)	/* Message Object 74 Acceptance Mask Register */
#define CAN_MOAMR75	(*( CAN_MOAMR0_type *) 0xf001996cu)	/* Message Object 75 Acceptance Mask Register */
#define CAN_MOAMR76	(*( CAN_MOAMR0_type *) 0xf001998cu)	/* Message Object 76 Acceptance Mask Register */
#define CAN_MOAMR77	(*( CAN_MOAMR0_type *) 0xf00199acu)	/* Message Object 77 Acceptance Mask Register */
#define CAN_MOAMR78	(*( CAN_MOAMR0_type *) 0xf00199ccu)	/* Message Object 78 Acceptance Mask Register */
#define CAN_MOAMR79	(*( CAN_MOAMR0_type *) 0xf00199ecu)	/* Message Object 79 Acceptance Mask Register */
#define CAN_MOAMR8	(*( CAN_MOAMR0_type *) 0xf001910cu)	/* Message Object 8 Acceptance Mask Register */
#define CAN_MOAMR80	(*( CAN_MOAMR0_type *) 0xf0019a0cu)	/* Message Object 80 Acceptance Mask Register */
#define CAN_MOAMR81	(*( CAN_MOAMR0_type *) 0xf0019a2cu)	/* Message Object 81 Acceptance Mask Register */
#define CAN_MOAMR82	(*( CAN_MOAMR0_type *) 0xf0019a4cu)	/* Message Object 82 Acceptance Mask Register */
#define CAN_MOAMR83	(*( CAN_MOAMR0_type *) 0xf0019a6cu)	/* Message Object 83 Acceptance Mask Register */
#define CAN_MOAMR84	(*( CAN_MOAMR0_type *) 0xf0019a8cu)	/* Message Object 84 Acceptance Mask Register */
#define CAN_MOAMR85	(*( CAN_MOAMR0_type *) 0xf0019aacu)	/* Message Object 85 Acceptance Mask Register */
#define CAN_MOAMR86	(*( CAN_MOAMR0_type *) 0xf0019accu)	/* Message Object 86 Acceptance Mask Register */
#define CAN_MOAMR87	(*( CAN_MOAMR0_type *) 0xf0019aecu)	/* Message Object 87 Acceptance Mask Register */
#define CAN_MOAMR88	(*( CAN_MOAMR0_type *) 0xf0019b0cu)	/* Message Object 88 Acceptance Mask Register */
#define CAN_MOAMR89	(*( CAN_MOAMR0_type *) 0xf0019b2cu)	/* Message Object 89 Acceptance Mask Register */
#define CAN_MOAMR9	(*( CAN_MOAMR0_type *) 0xf001912cu)	/* Message Object 9 Acceptance Mask Register */
#define CAN_MOAMR90	(*( CAN_MOAMR0_type *) 0xf0019b4cu)	/* Message Object 90 Acceptance Mask Register */
#define CAN_MOAMR91	(*( CAN_MOAMR0_type *) 0xf0019b6cu)	/* Message Object 91 Acceptance Mask Register */
#define CAN_MOAMR92	(*( CAN_MOAMR0_type *) 0xf0019b8cu)	/* Message Object 92 Acceptance Mask Register */
#define CAN_MOAMR93	(*( CAN_MOAMR0_type *) 0xf0019bacu)	/* Message Object 93 Acceptance Mask Register */
#define CAN_MOAMR94	(*( CAN_MOAMR0_type *) 0xf0019bccu)	/* Message Object 94 Acceptance Mask Register */
#define CAN_MOAMR95	(*( CAN_MOAMR0_type *) 0xf0019becu)	/* Message Object 95 Acceptance Mask Register */
#define CAN_MOAMR96	(*( CAN_MOAMR0_type *) 0xf0019c0cu)	/* Message Object 96 Acceptance Mask Register */
#define CAN_MOAMR97	(*( CAN_MOAMR0_type *) 0xf0019c2cu)	/* Message Object 97 Acceptance Mask Register */
#define CAN_MOAMR98	(*( CAN_MOAMR0_type *) 0xf0019c4cu)	/* Message Object 98 Acceptance Mask Register */
#define CAN_MOAMR99	(*( CAN_MOAMR0_type *) 0xf0019c6cu)	/* Message Object 99 Acceptance Mask Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ID             : 29;	/* CAN Identifier of Message Object n */
		unsigned int IDE            : 1;	/* Identifier Extension Bit of Message Object n */
		unsigned int PRI            : 2;	/* Priority Class */
	} B;
	int I;
	unsigned int U;

} CAN_MOAR0_type;
#define CAN_MOAR0	(*( CAN_MOAR0_type *) 0xf0019018u)	/* Message Object 0 Arbitration Register */
#define CAN_MOAR1	(*( CAN_MOAR0_type *) 0xf0019038u)	/* Message Object 1 Arbitration Register */
#define CAN_MOAR10	(*( CAN_MOAR0_type *) 0xf0019158u)	/* Message Object 10 Arbitration Register */
#define CAN_MOAR100	(*( CAN_MOAR0_type *) 0xf0019c98u)	/* Message Object 100 Arbitration Register */
#define CAN_MOAR101	(*( CAN_MOAR0_type *) 0xf0019cb8u)	/* Message Object 101 Arbitration Register */
#define CAN_MOAR102	(*( CAN_MOAR0_type *) 0xf0019cd8u)	/* Message Object 102 Arbitration Register */
#define CAN_MOAR103	(*( CAN_MOAR0_type *) 0xf0019cf8u)	/* Message Object 103 Arbitration Register */
#define CAN_MOAR104	(*( CAN_MOAR0_type *) 0xf0019d18u)	/* Message Object 104 Arbitration Register */
#define CAN_MOAR105	(*( CAN_MOAR0_type *) 0xf0019d38u)	/* Message Object 105 Arbitration Register */
#define CAN_MOAR106	(*( CAN_MOAR0_type *) 0xf0019d58u)	/* Message Object 106 Arbitration Register */
#define CAN_MOAR107	(*( CAN_MOAR0_type *) 0xf0019d78u)	/* Message Object 107 Arbitration Register */
#define CAN_MOAR108	(*( CAN_MOAR0_type *) 0xf0019d98u)	/* Message Object 108 Arbitration Register */
#define CAN_MOAR109	(*( CAN_MOAR0_type *) 0xf0019db8u)	/* Message Object 109 Arbitration Register */
#define CAN_MOAR11	(*( CAN_MOAR0_type *) 0xf0019178u)	/* Message Object 11 Arbitration Register */
#define CAN_MOAR110	(*( CAN_MOAR0_type *) 0xf0019dd8u)	/* Message Object 110 Arbitration Register */
#define CAN_MOAR111	(*( CAN_MOAR0_type *) 0xf0019df8u)	/* Message Object 111 Arbitration Register */
#define CAN_MOAR112	(*( CAN_MOAR0_type *) 0xf0019e18u)	/* Message Object 112 Arbitration Register */
#define CAN_MOAR113	(*( CAN_MOAR0_type *) 0xf0019e38u)	/* Message Object 113 Arbitration Register */
#define CAN_MOAR114	(*( CAN_MOAR0_type *) 0xf0019e58u)	/* Message Object 114 Arbitration Register */
#define CAN_MOAR115	(*( CAN_MOAR0_type *) 0xf0019e78u)	/* Message Object 115 Arbitration Register */
#define CAN_MOAR116	(*( CAN_MOAR0_type *) 0xf0019e98u)	/* Message Object 116 Arbitration Register */
#define CAN_MOAR117	(*( CAN_MOAR0_type *) 0xf0019eb8u)	/* Message Object 117 Arbitration Register */
#define CAN_MOAR118	(*( CAN_MOAR0_type *) 0xf0019ed8u)	/* Message Object 118 Arbitration Register */
#define CAN_MOAR119	(*( CAN_MOAR0_type *) 0xf0019ef8u)	/* Message Object 119 Arbitration Register */
#define CAN_MOAR12	(*( CAN_MOAR0_type *) 0xf0019198u)	/* Message Object 12 Arbitration Register */
#define CAN_MOAR120	(*( CAN_MOAR0_type *) 0xf0019f18u)	/* Message Object 120 Arbitration Register */
#define CAN_MOAR121	(*( CAN_MOAR0_type *) 0xf0019f38u)	/* Message Object 121 Arbitration Register */
#define CAN_MOAR122	(*( CAN_MOAR0_type *) 0xf0019f58u)	/* Message Object 122 Arbitration Register */
#define CAN_MOAR123	(*( CAN_MOAR0_type *) 0xf0019f78u)	/* Message Object 123 Arbitration Register */
#define CAN_MOAR124	(*( CAN_MOAR0_type *) 0xf0019f98u)	/* Message Object 124 Arbitration Register */
#define CAN_MOAR125	(*( CAN_MOAR0_type *) 0xf0019fb8u)	/* Message Object 125 Arbitration Register */
#define CAN_MOAR126	(*( CAN_MOAR0_type *) 0xf0019fd8u)	/* Message Object 126 Arbitration Register */
#define CAN_MOAR127	(*( CAN_MOAR0_type *) 0xf0019ff8u)	/* Message Object 127 Arbitration Register */
#define CAN_MOAR128	(*( CAN_MOAR0_type *) 0xf001a018u)	/* Message Object 128 Arbitration Register */
#define CAN_MOAR129	(*( CAN_MOAR0_type *) 0xf001a038u)	/* Message Object 129 Arbitration Register */
#define CAN_MOAR13	(*( CAN_MOAR0_type *) 0xf00191b8u)	/* Message Object 13 Arbitration Register */
#define CAN_MOAR130	(*( CAN_MOAR0_type *) 0xf001a058u)	/* Message Object 130 Arbitration Register */
#define CAN_MOAR131	(*( CAN_MOAR0_type *) 0xf001a078u)	/* Message Object 131 Arbitration Register */
#define CAN_MOAR132	(*( CAN_MOAR0_type *) 0xf001a098u)	/* Message Object 132 Arbitration Register */
#define CAN_MOAR133	(*( CAN_MOAR0_type *) 0xf001a0b8u)	/* Message Object 133 Arbitration Register */
#define CAN_MOAR134	(*( CAN_MOAR0_type *) 0xf001a0d8u)	/* Message Object 134 Arbitration Register */
#define CAN_MOAR135	(*( CAN_MOAR0_type *) 0xf001a0f8u)	/* Message Object 135 Arbitration Register */
#define CAN_MOAR136	(*( CAN_MOAR0_type *) 0xf001a118u)	/* Message Object 136 Arbitration Register */
#define CAN_MOAR137	(*( CAN_MOAR0_type *) 0xf001a138u)	/* Message Object 137 Arbitration Register */
#define CAN_MOAR138	(*( CAN_MOAR0_type *) 0xf001a158u)	/* Message Object 138 Arbitration Register */
#define CAN_MOAR139	(*( CAN_MOAR0_type *) 0xf001a178u)	/* Message Object 139 Arbitration Register */
#define CAN_MOAR14	(*( CAN_MOAR0_type *) 0xf00191d8u)	/* Message Object 14 Arbitration Register */
#define CAN_MOAR140	(*( CAN_MOAR0_type *) 0xf001a198u)	/* Message Object 140 Arbitration Register */
#define CAN_MOAR141	(*( CAN_MOAR0_type *) 0xf001a1b8u)	/* Message Object 141 Arbitration Register */
#define CAN_MOAR142	(*( CAN_MOAR0_type *) 0xf001a1d8u)	/* Message Object 142 Arbitration Register */
#define CAN_MOAR143	(*( CAN_MOAR0_type *) 0xf001a1f8u)	/* Message Object 143 Arbitration Register */
#define CAN_MOAR144	(*( CAN_MOAR0_type *) 0xf001a218u)	/* Message Object 144 Arbitration Register */
#define CAN_MOAR145	(*( CAN_MOAR0_type *) 0xf001a238u)	/* Message Object 145 Arbitration Register */
#define CAN_MOAR146	(*( CAN_MOAR0_type *) 0xf001a258u)	/* Message Object 146 Arbitration Register */
#define CAN_MOAR147	(*( CAN_MOAR0_type *) 0xf001a278u)	/* Message Object 147 Arbitration Register */
#define CAN_MOAR148	(*( CAN_MOAR0_type *) 0xf001a298u)	/* Message Object 148 Arbitration Register */
#define CAN_MOAR149	(*( CAN_MOAR0_type *) 0xf001a2b8u)	/* Message Object 149 Arbitration Register */
#define CAN_MOAR15	(*( CAN_MOAR0_type *) 0xf00191f8u)	/* Message Object 15 Arbitration Register */
#define CAN_MOAR150	(*( CAN_MOAR0_type *) 0xf001a2d8u)	/* Message Object 150 Arbitration Register */
#define CAN_MOAR151	(*( CAN_MOAR0_type *) 0xf001a2f8u)	/* Message Object 151 Arbitration Register */
#define CAN_MOAR152	(*( CAN_MOAR0_type *) 0xf001a318u)	/* Message Object 152 Arbitration Register */
#define CAN_MOAR153	(*( CAN_MOAR0_type *) 0xf001a338u)	/* Message Object 153 Arbitration Register */
#define CAN_MOAR154	(*( CAN_MOAR0_type *) 0xf001a358u)	/* Message Object 154 Arbitration Register */
#define CAN_MOAR155	(*( CAN_MOAR0_type *) 0xf001a378u)	/* Message Object 155 Arbitration Register */
#define CAN_MOAR156	(*( CAN_MOAR0_type *) 0xf001a398u)	/* Message Object 156 Arbitration Register */
#define CAN_MOAR157	(*( CAN_MOAR0_type *) 0xf001a3b8u)	/* Message Object 157 Arbitration Register */
#define CAN_MOAR158	(*( CAN_MOAR0_type *) 0xf001a3d8u)	/* Message Object 158 Arbitration Register */
#define CAN_MOAR159	(*( CAN_MOAR0_type *) 0xf001a3f8u)	/* Message Object 159 Arbitration Register */
#define CAN_MOAR16	(*( CAN_MOAR0_type *) 0xf0019218u)	/* Message Object 16 Arbitration Register */
#define CAN_MOAR160	(*( CAN_MOAR0_type *) 0xf001a418u)	/* Message Object 160 Arbitration Register */
#define CAN_MOAR161	(*( CAN_MOAR0_type *) 0xf001a438u)	/* Message Object 161 Arbitration Register */
#define CAN_MOAR162	(*( CAN_MOAR0_type *) 0xf001a458u)	/* Message Object 162 Arbitration Register */
#define CAN_MOAR163	(*( CAN_MOAR0_type *) 0xf001a478u)	/* Message Object 163 Arbitration Register */
#define CAN_MOAR164	(*( CAN_MOAR0_type *) 0xf001a498u)	/* Message Object 164 Arbitration Register */
#define CAN_MOAR165	(*( CAN_MOAR0_type *) 0xf001a4b8u)	/* Message Object 165 Arbitration Register */
#define CAN_MOAR166	(*( CAN_MOAR0_type *) 0xf001a4d8u)	/* Message Object 166 Arbitration Register */
#define CAN_MOAR167	(*( CAN_MOAR0_type *) 0xf001a4f8u)	/* Message Object 167 Arbitration Register */
#define CAN_MOAR168	(*( CAN_MOAR0_type *) 0xf001a518u)	/* Message Object 168 Arbitration Register */
#define CAN_MOAR169	(*( CAN_MOAR0_type *) 0xf001a538u)	/* Message Object 169 Arbitration Register */
#define CAN_MOAR17	(*( CAN_MOAR0_type *) 0xf0019238u)	/* Message Object 17 Arbitration Register */
#define CAN_MOAR170	(*( CAN_MOAR0_type *) 0xf001a558u)	/* Message Object 170 Arbitration Register */
#define CAN_MOAR171	(*( CAN_MOAR0_type *) 0xf001a578u)	/* Message Object 171 Arbitration Register */
#define CAN_MOAR172	(*( CAN_MOAR0_type *) 0xf001a598u)	/* Message Object 172 Arbitration Register */
#define CAN_MOAR173	(*( CAN_MOAR0_type *) 0xf001a5b8u)	/* Message Object 173 Arbitration Register */
#define CAN_MOAR174	(*( CAN_MOAR0_type *) 0xf001a5d8u)	/* Message Object 174 Arbitration Register */
#define CAN_MOAR175	(*( CAN_MOAR0_type *) 0xf001a5f8u)	/* Message Object 175 Arbitration Register */
#define CAN_MOAR176	(*( CAN_MOAR0_type *) 0xf001a618u)	/* Message Object 176 Arbitration Register */
#define CAN_MOAR177	(*( CAN_MOAR0_type *) 0xf001a638u)	/* Message Object 177 Arbitration Register */
#define CAN_MOAR178	(*( CAN_MOAR0_type *) 0xf001a658u)	/* Message Object 178 Arbitration Register */
#define CAN_MOAR179	(*( CAN_MOAR0_type *) 0xf001a678u)	/* Message Object 179 Arbitration Register */
#define CAN_MOAR18	(*( CAN_MOAR0_type *) 0xf0019258u)	/* Message Object 18 Arbitration Register */
#define CAN_MOAR180	(*( CAN_MOAR0_type *) 0xf001a698u)	/* Message Object 180 Arbitration Register */
#define CAN_MOAR181	(*( CAN_MOAR0_type *) 0xf001a6b8u)	/* Message Object 181 Arbitration Register */
#define CAN_MOAR182	(*( CAN_MOAR0_type *) 0xf001a6d8u)	/* Message Object 182 Arbitration Register */
#define CAN_MOAR183	(*( CAN_MOAR0_type *) 0xf001a6f8u)	/* Message Object 183 Arbitration Register */
#define CAN_MOAR184	(*( CAN_MOAR0_type *) 0xf001a718u)	/* Message Object 184 Arbitration Register */
#define CAN_MOAR185	(*( CAN_MOAR0_type *) 0xf001a738u)	/* Message Object 185 Arbitration Register */
#define CAN_MOAR186	(*( CAN_MOAR0_type *) 0xf001a758u)	/* Message Object 186 Arbitration Register */
#define CAN_MOAR187	(*( CAN_MOAR0_type *) 0xf001a778u)	/* Message Object 187 Arbitration Register */
#define CAN_MOAR188	(*( CAN_MOAR0_type *) 0xf001a798u)	/* Message Object 188 Arbitration Register */
#define CAN_MOAR189	(*( CAN_MOAR0_type *) 0xf001a7b8u)	/* Message Object 189 Arbitration Register */
#define CAN_MOAR19	(*( CAN_MOAR0_type *) 0xf0019278u)	/* Message Object 19 Arbitration Register */
#define CAN_MOAR190	(*( CAN_MOAR0_type *) 0xf001a7d8u)	/* Message Object 190 Arbitration Register */
#define CAN_MOAR191	(*( CAN_MOAR0_type *) 0xf001a7f8u)	/* Message Object 191 Arbitration Register */
#define CAN_MOAR192	(*( CAN_MOAR0_type *) 0xf001a818u)	/* Message Object 192 Arbitration Register */
#define CAN_MOAR193	(*( CAN_MOAR0_type *) 0xf001a838u)	/* Message Object 193 Arbitration Register */
#define CAN_MOAR194	(*( CAN_MOAR0_type *) 0xf001a858u)	/* Message Object 194 Arbitration Register */
#define CAN_MOAR195	(*( CAN_MOAR0_type *) 0xf001a878u)	/* Message Object 195 Arbitration Register */
#define CAN_MOAR196	(*( CAN_MOAR0_type *) 0xf001a898u)	/* Message Object 196 Arbitration Register */
#define CAN_MOAR197	(*( CAN_MOAR0_type *) 0xf001a8b8u)	/* Message Object 197 Arbitration Register */
#define CAN_MOAR198	(*( CAN_MOAR0_type *) 0xf001a8d8u)	/* Message Object 198 Arbitration Register */
#define CAN_MOAR199	(*( CAN_MOAR0_type *) 0xf001a8f8u)	/* Message Object 199 Arbitration Register */
#define CAN_MOAR2	(*( CAN_MOAR0_type *) 0xf0019058u)	/* Message Object 2 Arbitration Register */
#define CAN_MOAR20	(*( CAN_MOAR0_type *) 0xf0019298u)	/* Message Object 20 Arbitration Register */
#define CAN_MOAR200	(*( CAN_MOAR0_type *) 0xf001a918u)	/* Message Object 200 Arbitration Register */
#define CAN_MOAR201	(*( CAN_MOAR0_type *) 0xf001a938u)	/* Message Object 201 Arbitration Register */
#define CAN_MOAR202	(*( CAN_MOAR0_type *) 0xf001a958u)	/* Message Object 202 Arbitration Register */
#define CAN_MOAR203	(*( CAN_MOAR0_type *) 0xf001a978u)	/* Message Object 203 Arbitration Register */
#define CAN_MOAR204	(*( CAN_MOAR0_type *) 0xf001a998u)	/* Message Object 204 Arbitration Register */
#define CAN_MOAR205	(*( CAN_MOAR0_type *) 0xf001a9b8u)	/* Message Object 205 Arbitration Register */
#define CAN_MOAR206	(*( CAN_MOAR0_type *) 0xf001a9d8u)	/* Message Object 206 Arbitration Register */
#define CAN_MOAR207	(*( CAN_MOAR0_type *) 0xf001a9f8u)	/* Message Object 207 Arbitration Register */
#define CAN_MOAR208	(*( CAN_MOAR0_type *) 0xf001aa18u)	/* Message Object 208 Arbitration Register */
#define CAN_MOAR209	(*( CAN_MOAR0_type *) 0xf001aa38u)	/* Message Object 209 Arbitration Register */
#define CAN_MOAR21	(*( CAN_MOAR0_type *) 0xf00192b8u)	/* Message Object 21 Arbitration Register */
#define CAN_MOAR210	(*( CAN_MOAR0_type *) 0xf001aa58u)	/* Message Object 210 Arbitration Register */
#define CAN_MOAR211	(*( CAN_MOAR0_type *) 0xf001aa78u)	/* Message Object 211 Arbitration Register */
#define CAN_MOAR212	(*( CAN_MOAR0_type *) 0xf001aa98u)	/* Message Object 212 Arbitration Register */
#define CAN_MOAR213	(*( CAN_MOAR0_type *) 0xf001aab8u)	/* Message Object 213 Arbitration Register */
#define CAN_MOAR214	(*( CAN_MOAR0_type *) 0xf001aad8u)	/* Message Object 214 Arbitration Register */
#define CAN_MOAR215	(*( CAN_MOAR0_type *) 0xf001aaf8u)	/* Message Object 215 Arbitration Register */
#define CAN_MOAR216	(*( CAN_MOAR0_type *) 0xf001ab18u)	/* Message Object 216 Arbitration Register */
#define CAN_MOAR217	(*( CAN_MOAR0_type *) 0xf001ab38u)	/* Message Object 217 Arbitration Register */
#define CAN_MOAR218	(*( CAN_MOAR0_type *) 0xf001ab58u)	/* Message Object 218 Arbitration Register */
#define CAN_MOAR219	(*( CAN_MOAR0_type *) 0xf001ab78u)	/* Message Object 219 Arbitration Register */
#define CAN_MOAR22	(*( CAN_MOAR0_type *) 0xf00192d8u)	/* Message Object 22 Arbitration Register */
#define CAN_MOAR220	(*( CAN_MOAR0_type *) 0xf001ab98u)	/* Message Object 220 Arbitration Register */
#define CAN_MOAR221	(*( CAN_MOAR0_type *) 0xf001abb8u)	/* Message Object 221 Arbitration Register */
#define CAN_MOAR222	(*( CAN_MOAR0_type *) 0xf001abd8u)	/* Message Object 222 Arbitration Register */
#define CAN_MOAR223	(*( CAN_MOAR0_type *) 0xf001abf8u)	/* Message Object 223 Arbitration Register */
#define CAN_MOAR224	(*( CAN_MOAR0_type *) 0xf001ac18u)	/* Message Object 224 Arbitration Register */
#define CAN_MOAR225	(*( CAN_MOAR0_type *) 0xf001ac38u)	/* Message Object 225 Arbitration Register */
#define CAN_MOAR226	(*( CAN_MOAR0_type *) 0xf001ac58u)	/* Message Object 226 Arbitration Register */
#define CAN_MOAR227	(*( CAN_MOAR0_type *) 0xf001ac78u)	/* Message Object 227 Arbitration Register */
#define CAN_MOAR228	(*( CAN_MOAR0_type *) 0xf001ac98u)	/* Message Object 228 Arbitration Register */
#define CAN_MOAR229	(*( CAN_MOAR0_type *) 0xf001acb8u)	/* Message Object 229 Arbitration Register */
#define CAN_MOAR23	(*( CAN_MOAR0_type *) 0xf00192f8u)	/* Message Object 23 Arbitration Register */
#define CAN_MOAR230	(*( CAN_MOAR0_type *) 0xf001acd8u)	/* Message Object 230 Arbitration Register */
#define CAN_MOAR231	(*( CAN_MOAR0_type *) 0xf001acf8u)	/* Message Object 231 Arbitration Register */
#define CAN_MOAR232	(*( CAN_MOAR0_type *) 0xf001ad18u)	/* Message Object 232 Arbitration Register */
#define CAN_MOAR233	(*( CAN_MOAR0_type *) 0xf001ad38u)	/* Message Object 233 Arbitration Register */
#define CAN_MOAR234	(*( CAN_MOAR0_type *) 0xf001ad58u)	/* Message Object 234 Arbitration Register */
#define CAN_MOAR235	(*( CAN_MOAR0_type *) 0xf001ad78u)	/* Message Object 235 Arbitration Register */
#define CAN_MOAR236	(*( CAN_MOAR0_type *) 0xf001ad98u)	/* Message Object 236 Arbitration Register */
#define CAN_MOAR237	(*( CAN_MOAR0_type *) 0xf001adb8u)	/* Message Object 237 Arbitration Register */
#define CAN_MOAR238	(*( CAN_MOAR0_type *) 0xf001add8u)	/* Message Object 238 Arbitration Register */
#define CAN_MOAR239	(*( CAN_MOAR0_type *) 0xf001adf8u)	/* Message Object 239 Arbitration Register */
#define CAN_MOAR24	(*( CAN_MOAR0_type *) 0xf0019318u)	/* Message Object 24 Arbitration Register */
#define CAN_MOAR240	(*( CAN_MOAR0_type *) 0xf001ae18u)	/* Message Object 240 Arbitration Register */
#define CAN_MOAR241	(*( CAN_MOAR0_type *) 0xf001ae38u)	/* Message Object 241 Arbitration Register */
#define CAN_MOAR242	(*( CAN_MOAR0_type *) 0xf001ae58u)	/* Message Object 242 Arbitration Register */
#define CAN_MOAR243	(*( CAN_MOAR0_type *) 0xf001ae78u)	/* Message Object 243 Arbitration Register */
#define CAN_MOAR244	(*( CAN_MOAR0_type *) 0xf001ae98u)	/* Message Object 244 Arbitration Register */
#define CAN_MOAR245	(*( CAN_MOAR0_type *) 0xf001aeb8u)	/* Message Object 245 Arbitration Register */
#define CAN_MOAR246	(*( CAN_MOAR0_type *) 0xf001aed8u)	/* Message Object 246 Arbitration Register */
#define CAN_MOAR247	(*( CAN_MOAR0_type *) 0xf001aef8u)	/* Message Object 247 Arbitration Register */
#define CAN_MOAR248	(*( CAN_MOAR0_type *) 0xf001af18u)	/* Message Object 248 Arbitration Register */
#define CAN_MOAR249	(*( CAN_MOAR0_type *) 0xf001af38u)	/* Message Object 249 Arbitration Register */
#define CAN_MOAR25	(*( CAN_MOAR0_type *) 0xf0019338u)	/* Message Object 25 Arbitration Register */
#define CAN_MOAR250	(*( CAN_MOAR0_type *) 0xf001af58u)	/* Message Object 250 Arbitration Register */
#define CAN_MOAR251	(*( CAN_MOAR0_type *) 0xf001af78u)	/* Message Object 251 Arbitration Register */
#define CAN_MOAR252	(*( CAN_MOAR0_type *) 0xf001af98u)	/* Message Object 252 Arbitration Register */
#define CAN_MOAR253	(*( CAN_MOAR0_type *) 0xf001afb8u)	/* Message Object 253 Arbitration Register */
#define CAN_MOAR254	(*( CAN_MOAR0_type *) 0xf001afd8u)	/* Message Object 254 Arbitration Register */
#define CAN_MOAR255	(*( CAN_MOAR0_type *) 0xf001aff8u)	/* Message Object 255 Arbitration Register */
#define CAN_MOAR26	(*( CAN_MOAR0_type *) 0xf0019358u)	/* Message Object 26 Arbitration Register */
#define CAN_MOAR27	(*( CAN_MOAR0_type *) 0xf0019378u)	/* Message Object 27 Arbitration Register */
#define CAN_MOAR28	(*( CAN_MOAR0_type *) 0xf0019398u)	/* Message Object 28 Arbitration Register */
#define CAN_MOAR29	(*( CAN_MOAR0_type *) 0xf00193b8u)	/* Message Object 29 Arbitration Register */
#define CAN_MOAR3	(*( CAN_MOAR0_type *) 0xf0019078u)	/* Message Object 3 Arbitration Register */
#define CAN_MOAR30	(*( CAN_MOAR0_type *) 0xf00193d8u)	/* Message Object 30 Arbitration Register */
#define CAN_MOAR31	(*( CAN_MOAR0_type *) 0xf00193f8u)	/* Message Object 31 Arbitration Register */
#define CAN_MOAR32	(*( CAN_MOAR0_type *) 0xf0019418u)	/* Message Object 32 Arbitration Register */
#define CAN_MOAR33	(*( CAN_MOAR0_type *) 0xf0019438u)	/* Message Object 33 Arbitration Register */
#define CAN_MOAR34	(*( CAN_MOAR0_type *) 0xf0019458u)	/* Message Object 34 Arbitration Register */
#define CAN_MOAR35	(*( CAN_MOAR0_type *) 0xf0019478u)	/* Message Object 35 Arbitration Register */
#define CAN_MOAR36	(*( CAN_MOAR0_type *) 0xf0019498u)	/* Message Object 36 Arbitration Register */
#define CAN_MOAR37	(*( CAN_MOAR0_type *) 0xf00194b8u)	/* Message Object 37 Arbitration Register */
#define CAN_MOAR38	(*( CAN_MOAR0_type *) 0xf00194d8u)	/* Message Object 38 Arbitration Register */
#define CAN_MOAR39	(*( CAN_MOAR0_type *) 0xf00194f8u)	/* Message Object 39 Arbitration Register */
#define CAN_MOAR4	(*( CAN_MOAR0_type *) 0xf0019098u)	/* Message Object 4 Arbitration Register */
#define CAN_MOAR40	(*( CAN_MOAR0_type *) 0xf0019518u)	/* Message Object 40 Arbitration Register */
#define CAN_MOAR41	(*( CAN_MOAR0_type *) 0xf0019538u)	/* Message Object 41 Arbitration Register */
#define CAN_MOAR42	(*( CAN_MOAR0_type *) 0xf0019558u)	/* Message Object 42 Arbitration Register */
#define CAN_MOAR43	(*( CAN_MOAR0_type *) 0xf0019578u)	/* Message Object 43 Arbitration Register */
#define CAN_MOAR44	(*( CAN_MOAR0_type *) 0xf0019598u)	/* Message Object 44 Arbitration Register */
#define CAN_MOAR45	(*( CAN_MOAR0_type *) 0xf00195b8u)	/* Message Object 45 Arbitration Register */
#define CAN_MOAR46	(*( CAN_MOAR0_type *) 0xf00195d8u)	/* Message Object 46 Arbitration Register */
#define CAN_MOAR47	(*( CAN_MOAR0_type *) 0xf00195f8u)	/* Message Object 47 Arbitration Register */
#define CAN_MOAR48	(*( CAN_MOAR0_type *) 0xf0019618u)	/* Message Object 48 Arbitration Register */
#define CAN_MOAR49	(*( CAN_MOAR0_type *) 0xf0019638u)	/* Message Object 49 Arbitration Register */
#define CAN_MOAR5	(*( CAN_MOAR0_type *) 0xf00190b8u)	/* Message Object 5 Arbitration Register */
#define CAN_MOAR50	(*( CAN_MOAR0_type *) 0xf0019658u)	/* Message Object 50 Arbitration Register */
#define CAN_MOAR51	(*( CAN_MOAR0_type *) 0xf0019678u)	/* Message Object 51 Arbitration Register */
#define CAN_MOAR52	(*( CAN_MOAR0_type *) 0xf0019698u)	/* Message Object 52 Arbitration Register */
#define CAN_MOAR53	(*( CAN_MOAR0_type *) 0xf00196b8u)	/* Message Object 53 Arbitration Register */
#define CAN_MOAR54	(*( CAN_MOAR0_type *) 0xf00196d8u)	/* Message Object 54 Arbitration Register */
#define CAN_MOAR55	(*( CAN_MOAR0_type *) 0xf00196f8u)	/* Message Object 55 Arbitration Register */
#define CAN_MOAR56	(*( CAN_MOAR0_type *) 0xf0019718u)	/* Message Object 56 Arbitration Register */
#define CAN_MOAR57	(*( CAN_MOAR0_type *) 0xf0019738u)	/* Message Object 57 Arbitration Register */
#define CAN_MOAR58	(*( CAN_MOAR0_type *) 0xf0019758u)	/* Message Object 58 Arbitration Register */
#define CAN_MOAR59	(*( CAN_MOAR0_type *) 0xf0019778u)	/* Message Object 59 Arbitration Register */
#define CAN_MOAR6	(*( CAN_MOAR0_type *) 0xf00190d8u)	/* Message Object 6 Arbitration Register */
#define CAN_MOAR60	(*( CAN_MOAR0_type *) 0xf0019798u)	/* Message Object 60 Arbitration Register */
#define CAN_MOAR61	(*( CAN_MOAR0_type *) 0xf00197b8u)	/* Message Object 61 Arbitration Register */
#define CAN_MOAR62	(*( CAN_MOAR0_type *) 0xf00197d8u)	/* Message Object 62 Arbitration Register */
#define CAN_MOAR63	(*( CAN_MOAR0_type *) 0xf00197f8u)	/* Message Object 63 Arbitration Register */
#define CAN_MOAR64	(*( CAN_MOAR0_type *) 0xf0019818u)	/* Message Object 64 Arbitration Register */
#define CAN_MOAR65	(*( CAN_MOAR0_type *) 0xf0019838u)	/* Message Object 65 Arbitration Register */
#define CAN_MOAR66	(*( CAN_MOAR0_type *) 0xf0019858u)	/* Message Object 66 Arbitration Register */
#define CAN_MOAR67	(*( CAN_MOAR0_type *) 0xf0019878u)	/* Message Object 67 Arbitration Register */
#define CAN_MOAR68	(*( CAN_MOAR0_type *) 0xf0019898u)	/* Message Object 68 Arbitration Register */
#define CAN_MOAR69	(*( CAN_MOAR0_type *) 0xf00198b8u)	/* Message Object 69 Arbitration Register */
#define CAN_MOAR7	(*( CAN_MOAR0_type *) 0xf00190f8u)	/* Message Object 7 Arbitration Register */
#define CAN_MOAR70	(*( CAN_MOAR0_type *) 0xf00198d8u)	/* Message Object 70 Arbitration Register */
#define CAN_MOAR71	(*( CAN_MOAR0_type *) 0xf00198f8u)	/* Message Object 71 Arbitration Register */
#define CAN_MOAR72	(*( CAN_MOAR0_type *) 0xf0019918u)	/* Message Object 72 Arbitration Register */
#define CAN_MOAR73	(*( CAN_MOAR0_type *) 0xf0019938u)	/* Message Object 73 Arbitration Register */
#define CAN_MOAR74	(*( CAN_MOAR0_type *) 0xf0019958u)	/* Message Object 74 Arbitration Register */
#define CAN_MOAR75	(*( CAN_MOAR0_type *) 0xf0019978u)	/* Message Object 75 Arbitration Register */
#define CAN_MOAR76	(*( CAN_MOAR0_type *) 0xf0019998u)	/* Message Object 76 Arbitration Register */
#define CAN_MOAR77	(*( CAN_MOAR0_type *) 0xf00199b8u)	/* Message Object 77 Arbitration Register */
#define CAN_MOAR78	(*( CAN_MOAR0_type *) 0xf00199d8u)	/* Message Object 78 Arbitration Register */
#define CAN_MOAR79	(*( CAN_MOAR0_type *) 0xf00199f8u)	/* Message Object 79 Arbitration Register */
#define CAN_MOAR8	(*( CAN_MOAR0_type *) 0xf0019118u)	/* Message Object 8 Arbitration Register */
#define CAN_MOAR80	(*( CAN_MOAR0_type *) 0xf0019a18u)	/* Message Object 80 Arbitration Register */
#define CAN_MOAR81	(*( CAN_MOAR0_type *) 0xf0019a38u)	/* Message Object 81 Arbitration Register */
#define CAN_MOAR82	(*( CAN_MOAR0_type *) 0xf0019a58u)	/* Message Object 82 Arbitration Register */
#define CAN_MOAR83	(*( CAN_MOAR0_type *) 0xf0019a78u)	/* Message Object 83 Arbitration Register */
#define CAN_MOAR84	(*( CAN_MOAR0_type *) 0xf0019a98u)	/* Message Object 84 Arbitration Register */
#define CAN_MOAR85	(*( CAN_MOAR0_type *) 0xf0019ab8u)	/* Message Object 85 Arbitration Register */
#define CAN_MOAR86	(*( CAN_MOAR0_type *) 0xf0019ad8u)	/* Message Object 86 Arbitration Register */
#define CAN_MOAR87	(*( CAN_MOAR0_type *) 0xf0019af8u)	/* Message Object 87 Arbitration Register */
#define CAN_MOAR88	(*( CAN_MOAR0_type *) 0xf0019b18u)	/* Message Object 88 Arbitration Register */
#define CAN_MOAR89	(*( CAN_MOAR0_type *) 0xf0019b38u)	/* Message Object 89 Arbitration Register */
#define CAN_MOAR9	(*( CAN_MOAR0_type *) 0xf0019138u)	/* Message Object 9 Arbitration Register */
#define CAN_MOAR90	(*( CAN_MOAR0_type *) 0xf0019b58u)	/* Message Object 90 Arbitration Register */
#define CAN_MOAR91	(*( CAN_MOAR0_type *) 0xf0019b78u)	/* Message Object 91 Arbitration Register */
#define CAN_MOAR92	(*( CAN_MOAR0_type *) 0xf0019b98u)	/* Message Object 92 Arbitration Register */
#define CAN_MOAR93	(*( CAN_MOAR0_type *) 0xf0019bb8u)	/* Message Object 93 Arbitration Register */
#define CAN_MOAR94	(*( CAN_MOAR0_type *) 0xf0019bd8u)	/* Message Object 94 Arbitration Register */
#define CAN_MOAR95	(*( CAN_MOAR0_type *) 0xf0019bf8u)	/* Message Object 95 Arbitration Register */
#define CAN_MOAR96	(*( CAN_MOAR0_type *) 0xf0019c18u)	/* Message Object 96 Arbitration Register */
#define CAN_MOAR97	(*( CAN_MOAR0_type *) 0xf0019c38u)	/* Message Object 97 Arbitration Register */
#define CAN_MOAR98	(*( CAN_MOAR0_type *) 0xf0019c58u)	/* Message Object 98 Arbitration Register */
#define CAN_MOAR99	(*( CAN_MOAR0_type *) 0xf0019c78u)	/* Message Object 99 Arbitration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RESRXPND       : 1;	/* Reset/Set Receive Pending */
		unsigned int RESTXPND       : 1;	/* Reset/Set Transmit Pending */
		unsigned int RESRXUPD       : 1;	/* Reset/Set Receive Updating */
		unsigned int RESNEWDAT      : 1;	/* Reset/Set New Data */
		unsigned int RESMSGLST      : 1;	/* Reset/Set Message Lost */
		unsigned int RESMSGVAL      : 1;	/* Reset/Set Message Valid */
		unsigned int RESRTSEL       : 1;	/* Reset/Set Receive/Transmit Selected */
		unsigned int RESRXEN        : 1;	/* Reset/Set Receive Enable */
		unsigned int RESTXRQ        : 1;	/* Reset/Set Transmit Request */
		unsigned int RESTXEN0       : 1;	/* Reset/Set Transmit Enable 0 */
		unsigned int RESTXEN1       : 1;	/* Reset/Set Transmit Enable 1 */
		unsigned int RESDIR         : 1;	/* Reset/Set Message Direction */
		unsigned int                : 4;
		unsigned int SETRXPND       : 1;	/* Reset/Set Receive Pending */
		unsigned int SETTXPND       : 1;	/* Reset/Set Transmit Pending */
		unsigned int SETRXUPD       : 1;	/* Reset/Set Receive Updating */
		unsigned int SETNEWDAT      : 1;	/* Reset/Set New Data */
		unsigned int SETMSGLST      : 1;	/* Reset/Set Message Lost */
		unsigned int SETMSGVAL      : 1;	/* Reset/Set Message Valid */
		unsigned int SETRTSEL       : 1;	/* Reset/Set Receive/Transmit Selected */
		unsigned int SETRXEN        : 1;	/* Reset/Set Receive Enable */
		unsigned int SETTXRQ        : 1;	/* Reset/Set Transmit Request */
		unsigned int SETTXEN0       : 1;	/* Reset/Set Transmit Enable 0 */
		unsigned int SETTXEN1       : 1;	/* Reset/Set Transmit Enable 1 */
		unsigned int SETDIR         : 1;	/* Reset/Set Message Direction */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} CAN_MOCTR0_type;
#define CAN_MOCTR0	(*( CAN_MOCTR0_type *) 0xf001901cu)	/* Message Object 0 Control Register */
#define CAN_MOCTR1	(*( CAN_MOCTR0_type *) 0xf001903cu)	/* Message Object 1 Control Register */
#define CAN_MOCTR10	(*( CAN_MOCTR0_type *) 0xf001915cu)	/* Message Object 10 Control Register */
#define CAN_MOCTR100	(*( CAN_MOCTR0_type *) 0xf0019c9cu)	/* Message Object 100 Control Register */
#define CAN_MOCTR101	(*( CAN_MOCTR0_type *) 0xf0019cbcu)	/* Message Object 101 Control Register */
#define CAN_MOCTR102	(*( CAN_MOCTR0_type *) 0xf0019cdcu)	/* Message Object 102 Control Register */
#define CAN_MOCTR103	(*( CAN_MOCTR0_type *) 0xf0019cfcu)	/* Message Object 103 Control Register */
#define CAN_MOCTR104	(*( CAN_MOCTR0_type *) 0xf0019d1cu)	/* Message Object 104 Control Register */
#define CAN_MOCTR105	(*( CAN_MOCTR0_type *) 0xf0019d3cu)	/* Message Object 105 Control Register */
#define CAN_MOCTR106	(*( CAN_MOCTR0_type *) 0xf0019d5cu)	/* Message Object 106 Control Register */
#define CAN_MOCTR107	(*( CAN_MOCTR0_type *) 0xf0019d7cu)	/* Message Object 107 Control Register */
#define CAN_MOCTR108	(*( CAN_MOCTR0_type *) 0xf0019d9cu)	/* Message Object 108 Control Register */
#define CAN_MOCTR109	(*( CAN_MOCTR0_type *) 0xf0019dbcu)	/* Message Object 109 Control Register */
#define CAN_MOCTR11	(*( CAN_MOCTR0_type *) 0xf001917cu)	/* Message Object 11 Control Register */
#define CAN_MOCTR110	(*( CAN_MOCTR0_type *) 0xf0019ddcu)	/* Message Object 110 Control Register */
#define CAN_MOCTR111	(*( CAN_MOCTR0_type *) 0xf0019dfcu)	/* Message Object 111 Control Register */
#define CAN_MOCTR112	(*( CAN_MOCTR0_type *) 0xf0019e1cu)	/* Message Object 112 Control Register */
#define CAN_MOCTR113	(*( CAN_MOCTR0_type *) 0xf0019e3cu)	/* Message Object 113 Control Register */
#define CAN_MOCTR114	(*( CAN_MOCTR0_type *) 0xf0019e5cu)	/* Message Object 114 Control Register */
#define CAN_MOCTR115	(*( CAN_MOCTR0_type *) 0xf0019e7cu)	/* Message Object 115 Control Register */
#define CAN_MOCTR116	(*( CAN_MOCTR0_type *) 0xf0019e9cu)	/* Message Object 116 Control Register */
#define CAN_MOCTR117	(*( CAN_MOCTR0_type *) 0xf0019ebcu)	/* Message Object 117 Control Register */
#define CAN_MOCTR118	(*( CAN_MOCTR0_type *) 0xf0019edcu)	/* Message Object 118 Control Register */
#define CAN_MOCTR119	(*( CAN_MOCTR0_type *) 0xf0019efcu)	/* Message Object 119 Control Register */
#define CAN_MOCTR12	(*( CAN_MOCTR0_type *) 0xf001919cu)	/* Message Object 12 Control Register */
#define CAN_MOCTR120	(*( CAN_MOCTR0_type *) 0xf0019f1cu)	/* Message Object 120 Control Register */
#define CAN_MOCTR121	(*( CAN_MOCTR0_type *) 0xf0019f3cu)	/* Message Object 121 Control Register */
#define CAN_MOCTR122	(*( CAN_MOCTR0_type *) 0xf0019f5cu)	/* Message Object 122 Control Register */
#define CAN_MOCTR123	(*( CAN_MOCTR0_type *) 0xf0019f7cu)	/* Message Object 123 Control Register */
#define CAN_MOCTR124	(*( CAN_MOCTR0_type *) 0xf0019f9cu)	/* Message Object 124 Control Register */
#define CAN_MOCTR125	(*( CAN_MOCTR0_type *) 0xf0019fbcu)	/* Message Object 125 Control Register */
#define CAN_MOCTR126	(*( CAN_MOCTR0_type *) 0xf0019fdcu)	/* Message Object 126 Control Register */
#define CAN_MOCTR127	(*( CAN_MOCTR0_type *) 0xf0019ffcu)	/* Message Object 127 Control Register */
#define CAN_MOCTR128	(*( CAN_MOCTR0_type *) 0xf001a01cu)	/* Message Object 128 Control Register */
#define CAN_MOCTR129	(*( CAN_MOCTR0_type *) 0xf001a03cu)	/* Message Object 129 Control Register */
#define CAN_MOCTR13	(*( CAN_MOCTR0_type *) 0xf00191bcu)	/* Message Object 13 Control Register */
#define CAN_MOCTR130	(*( CAN_MOCTR0_type *) 0xf001a05cu)	/* Message Object 130 Control Register */
#define CAN_MOCTR131	(*( CAN_MOCTR0_type *) 0xf001a07cu)	/* Message Object 131 Control Register */
#define CAN_MOCTR132	(*( CAN_MOCTR0_type *) 0xf001a09cu)	/* Message Object 132 Control Register */
#define CAN_MOCTR133	(*( CAN_MOCTR0_type *) 0xf001a0bcu)	/* Message Object 133 Control Register */
#define CAN_MOCTR134	(*( CAN_MOCTR0_type *) 0xf001a0dcu)	/* Message Object 134 Control Register */
#define CAN_MOCTR135	(*( CAN_MOCTR0_type *) 0xf001a0fcu)	/* Message Object 135 Control Register */
#define CAN_MOCTR136	(*( CAN_MOCTR0_type *) 0xf001a11cu)	/* Message Object 136 Control Register */
#define CAN_MOCTR137	(*( CAN_MOCTR0_type *) 0xf001a13cu)	/* Message Object 137 Control Register */
#define CAN_MOCTR138	(*( CAN_MOCTR0_type *) 0xf001a15cu)	/* Message Object 138 Control Register */
#define CAN_MOCTR139	(*( CAN_MOCTR0_type *) 0xf001a17cu)	/* Message Object 139 Control Register */
#define CAN_MOCTR14	(*( CAN_MOCTR0_type *) 0xf00191dcu)	/* Message Object 14 Control Register */
#define CAN_MOCTR140	(*( CAN_MOCTR0_type *) 0xf001a19cu)	/* Message Object 140 Control Register */
#define CAN_MOCTR141	(*( CAN_MOCTR0_type *) 0xf001a1bcu)	/* Message Object 141 Control Register */
#define CAN_MOCTR142	(*( CAN_MOCTR0_type *) 0xf001a1dcu)	/* Message Object 142 Control Register */
#define CAN_MOCTR143	(*( CAN_MOCTR0_type *) 0xf001a1fcu)	/* Message Object 143 Control Register */
#define CAN_MOCTR144	(*( CAN_MOCTR0_type *) 0xf001a21cu)	/* Message Object 144 Control Register */
#define CAN_MOCTR145	(*( CAN_MOCTR0_type *) 0xf001a23cu)	/* Message Object 145 Control Register */
#define CAN_MOCTR146	(*( CAN_MOCTR0_type *) 0xf001a25cu)	/* Message Object 146 Control Register */
#define CAN_MOCTR147	(*( CAN_MOCTR0_type *) 0xf001a27cu)	/* Message Object 147 Control Register */
#define CAN_MOCTR148	(*( CAN_MOCTR0_type *) 0xf001a29cu)	/* Message Object 148 Control Register */
#define CAN_MOCTR149	(*( CAN_MOCTR0_type *) 0xf001a2bcu)	/* Message Object 149 Control Register */
#define CAN_MOCTR15	(*( CAN_MOCTR0_type *) 0xf00191fcu)	/* Message Object 15 Control Register */
#define CAN_MOCTR150	(*( CAN_MOCTR0_type *) 0xf001a2dcu)	/* Message Object 150 Control Register */
#define CAN_MOCTR151	(*( CAN_MOCTR0_type *) 0xf001a2fcu)	/* Message Object 151 Control Register */
#define CAN_MOCTR152	(*( CAN_MOCTR0_type *) 0xf001a31cu)	/* Message Object 152 Control Register */
#define CAN_MOCTR153	(*( CAN_MOCTR0_type *) 0xf001a33cu)	/* Message Object 153 Control Register */
#define CAN_MOCTR154	(*( CAN_MOCTR0_type *) 0xf001a35cu)	/* Message Object 154 Control Register */
#define CAN_MOCTR155	(*( CAN_MOCTR0_type *) 0xf001a37cu)	/* Message Object 155 Control Register */
#define CAN_MOCTR156	(*( CAN_MOCTR0_type *) 0xf001a39cu)	/* Message Object 156 Control Register */
#define CAN_MOCTR157	(*( CAN_MOCTR0_type *) 0xf001a3bcu)	/* Message Object 157 Control Register */
#define CAN_MOCTR158	(*( CAN_MOCTR0_type *) 0xf001a3dcu)	/* Message Object 158 Control Register */
#define CAN_MOCTR159	(*( CAN_MOCTR0_type *) 0xf001a3fcu)	/* Message Object 159 Control Register */
#define CAN_MOCTR16	(*( CAN_MOCTR0_type *) 0xf001921cu)	/* Message Object 16 Control Register */
#define CAN_MOCTR160	(*( CAN_MOCTR0_type *) 0xf001a41cu)	/* Message Object 160 Control Register */
#define CAN_MOCTR161	(*( CAN_MOCTR0_type *) 0xf001a43cu)	/* Message Object 161 Control Register */
#define CAN_MOCTR162	(*( CAN_MOCTR0_type *) 0xf001a45cu)	/* Message Object 162 Control Register */
#define CAN_MOCTR163	(*( CAN_MOCTR0_type *) 0xf001a47cu)	/* Message Object 163 Control Register */
#define CAN_MOCTR164	(*( CAN_MOCTR0_type *) 0xf001a49cu)	/* Message Object 164 Control Register */
#define CAN_MOCTR165	(*( CAN_MOCTR0_type *) 0xf001a4bcu)	/* Message Object 165 Control Register */
#define CAN_MOCTR166	(*( CAN_MOCTR0_type *) 0xf001a4dcu)	/* Message Object 166 Control Register */
#define CAN_MOCTR167	(*( CAN_MOCTR0_type *) 0xf001a4fcu)	/* Message Object 167 Control Register */
#define CAN_MOCTR168	(*( CAN_MOCTR0_type *) 0xf001a51cu)	/* Message Object 168 Control Register */
#define CAN_MOCTR169	(*( CAN_MOCTR0_type *) 0xf001a53cu)	/* Message Object 169 Control Register */
#define CAN_MOCTR17	(*( CAN_MOCTR0_type *) 0xf001923cu)	/* Message Object 17 Control Register */
#define CAN_MOCTR170	(*( CAN_MOCTR0_type *) 0xf001a55cu)	/* Message Object 170 Control Register */
#define CAN_MOCTR171	(*( CAN_MOCTR0_type *) 0xf001a57cu)	/* Message Object 171 Control Register */
#define CAN_MOCTR172	(*( CAN_MOCTR0_type *) 0xf001a59cu)	/* Message Object 172 Control Register */
#define CAN_MOCTR173	(*( CAN_MOCTR0_type *) 0xf001a5bcu)	/* Message Object 173 Control Register */
#define CAN_MOCTR174	(*( CAN_MOCTR0_type *) 0xf001a5dcu)	/* Message Object 174 Control Register */
#define CAN_MOCTR175	(*( CAN_MOCTR0_type *) 0xf001a5fcu)	/* Message Object 175 Control Register */
#define CAN_MOCTR176	(*( CAN_MOCTR0_type *) 0xf001a61cu)	/* Message Object 176 Control Register */
#define CAN_MOCTR177	(*( CAN_MOCTR0_type *) 0xf001a63cu)	/* Message Object 177 Control Register */
#define CAN_MOCTR178	(*( CAN_MOCTR0_type *) 0xf001a65cu)	/* Message Object 178 Control Register */
#define CAN_MOCTR179	(*( CAN_MOCTR0_type *) 0xf001a67cu)	/* Message Object 179 Control Register */
#define CAN_MOCTR18	(*( CAN_MOCTR0_type *) 0xf001925cu)	/* Message Object 18 Control Register */
#define CAN_MOCTR180	(*( CAN_MOCTR0_type *) 0xf001a69cu)	/* Message Object 180 Control Register */
#define CAN_MOCTR181	(*( CAN_MOCTR0_type *) 0xf001a6bcu)	/* Message Object 181 Control Register */
#define CAN_MOCTR182	(*( CAN_MOCTR0_type *) 0xf001a6dcu)	/* Message Object 182 Control Register */
#define CAN_MOCTR183	(*( CAN_MOCTR0_type *) 0xf001a6fcu)	/* Message Object 183 Control Register */
#define CAN_MOCTR184	(*( CAN_MOCTR0_type *) 0xf001a71cu)	/* Message Object 184 Control Register */
#define CAN_MOCTR185	(*( CAN_MOCTR0_type *) 0xf001a73cu)	/* Message Object 185 Control Register */
#define CAN_MOCTR186	(*( CAN_MOCTR0_type *) 0xf001a75cu)	/* Message Object 186 Control Register */
#define CAN_MOCTR187	(*( CAN_MOCTR0_type *) 0xf001a77cu)	/* Message Object 187 Control Register */
#define CAN_MOCTR188	(*( CAN_MOCTR0_type *) 0xf001a79cu)	/* Message Object 188 Control Register */
#define CAN_MOCTR189	(*( CAN_MOCTR0_type *) 0xf001a7bcu)	/* Message Object 189 Control Register */
#define CAN_MOCTR19	(*( CAN_MOCTR0_type *) 0xf001927cu)	/* Message Object 19 Control Register */
#define CAN_MOCTR190	(*( CAN_MOCTR0_type *) 0xf001a7dcu)	/* Message Object 190 Control Register */
#define CAN_MOCTR191	(*( CAN_MOCTR0_type *) 0xf001a7fcu)	/* Message Object 191 Control Register */
#define CAN_MOCTR192	(*( CAN_MOCTR0_type *) 0xf001a81cu)	/* Message Object 192 Control Register */
#define CAN_MOCTR193	(*( CAN_MOCTR0_type *) 0xf001a83cu)	/* Message Object 193 Control Register */
#define CAN_MOCTR194	(*( CAN_MOCTR0_type *) 0xf001a85cu)	/* Message Object 194 Control Register */
#define CAN_MOCTR195	(*( CAN_MOCTR0_type *) 0xf001a87cu)	/* Message Object 195 Control Register */
#define CAN_MOCTR196	(*( CAN_MOCTR0_type *) 0xf001a89cu)	/* Message Object 196 Control Register */
#define CAN_MOCTR197	(*( CAN_MOCTR0_type *) 0xf001a8bcu)	/* Message Object 197 Control Register */
#define CAN_MOCTR198	(*( CAN_MOCTR0_type *) 0xf001a8dcu)	/* Message Object 198 Control Register */
#define CAN_MOCTR199	(*( CAN_MOCTR0_type *) 0xf001a8fcu)	/* Message Object 199 Control Register */
#define CAN_MOCTR2	(*( CAN_MOCTR0_type *) 0xf001905cu)	/* Message Object 2 Control Register */
#define CAN_MOCTR20	(*( CAN_MOCTR0_type *) 0xf001929cu)	/* Message Object 20 Control Register */
#define CAN_MOCTR200	(*( CAN_MOCTR0_type *) 0xf001a91cu)	/* Message Object 200 Control Register */
#define CAN_MOCTR201	(*( CAN_MOCTR0_type *) 0xf001a93cu)	/* Message Object 201 Control Register */
#define CAN_MOCTR202	(*( CAN_MOCTR0_type *) 0xf001a95cu)	/* Message Object 202 Control Register */
#define CAN_MOCTR203	(*( CAN_MOCTR0_type *) 0xf001a97cu)	/* Message Object 203 Control Register */
#define CAN_MOCTR204	(*( CAN_MOCTR0_type *) 0xf001a99cu)	/* Message Object 204 Control Register */
#define CAN_MOCTR205	(*( CAN_MOCTR0_type *) 0xf001a9bcu)	/* Message Object 205 Control Register */
#define CAN_MOCTR206	(*( CAN_MOCTR0_type *) 0xf001a9dcu)	/* Message Object 206 Control Register */
#define CAN_MOCTR207	(*( CAN_MOCTR0_type *) 0xf001a9fcu)	/* Message Object 207 Control Register */
#define CAN_MOCTR208	(*( CAN_MOCTR0_type *) 0xf001aa1cu)	/* Message Object 208 Control Register */
#define CAN_MOCTR209	(*( CAN_MOCTR0_type *) 0xf001aa3cu)	/* Message Object 209 Control Register */
#define CAN_MOCTR21	(*( CAN_MOCTR0_type *) 0xf00192bcu)	/* Message Object 21 Control Register */
#define CAN_MOCTR210	(*( CAN_MOCTR0_type *) 0xf001aa5cu)	/* Message Object 210 Control Register */
#define CAN_MOCTR211	(*( CAN_MOCTR0_type *) 0xf001aa7cu)	/* Message Object 211 Control Register */
#define CAN_MOCTR212	(*( CAN_MOCTR0_type *) 0xf001aa9cu)	/* Message Object 212 Control Register */
#define CAN_MOCTR213	(*( CAN_MOCTR0_type *) 0xf001aabcu)	/* Message Object 213 Control Register */
#define CAN_MOCTR214	(*( CAN_MOCTR0_type *) 0xf001aadcu)	/* Message Object 214 Control Register */
#define CAN_MOCTR215	(*( CAN_MOCTR0_type *) 0xf001aafcu)	/* Message Object 215 Control Register */
#define CAN_MOCTR216	(*( CAN_MOCTR0_type *) 0xf001ab1cu)	/* Message Object 216 Control Register */
#define CAN_MOCTR217	(*( CAN_MOCTR0_type *) 0xf001ab3cu)	/* Message Object 217 Control Register */
#define CAN_MOCTR218	(*( CAN_MOCTR0_type *) 0xf001ab5cu)	/* Message Object 218 Control Register */
#define CAN_MOCTR219	(*( CAN_MOCTR0_type *) 0xf001ab7cu)	/* Message Object 219 Control Register */
#define CAN_MOCTR22	(*( CAN_MOCTR0_type *) 0xf00192dcu)	/* Message Object 22 Control Register */
#define CAN_MOCTR220	(*( CAN_MOCTR0_type *) 0xf001ab9cu)	/* Message Object 220 Control Register */
#define CAN_MOCTR221	(*( CAN_MOCTR0_type *) 0xf001abbcu)	/* Message Object 221 Control Register */
#define CAN_MOCTR222	(*( CAN_MOCTR0_type *) 0xf001abdcu)	/* Message Object 222 Control Register */
#define CAN_MOCTR223	(*( CAN_MOCTR0_type *) 0xf001abfcu)	/* Message Object 223 Control Register */
#define CAN_MOCTR224	(*( CAN_MOCTR0_type *) 0xf001ac1cu)	/* Message Object 224 Control Register */
#define CAN_MOCTR225	(*( CAN_MOCTR0_type *) 0xf001ac3cu)	/* Message Object 225 Control Register */
#define CAN_MOCTR226	(*( CAN_MOCTR0_type *) 0xf001ac5cu)	/* Message Object 226 Control Register */
#define CAN_MOCTR227	(*( CAN_MOCTR0_type *) 0xf001ac7cu)	/* Message Object 227 Control Register */
#define CAN_MOCTR228	(*( CAN_MOCTR0_type *) 0xf001ac9cu)	/* Message Object 228 Control Register */
#define CAN_MOCTR229	(*( CAN_MOCTR0_type *) 0xf001acbcu)	/* Message Object 229 Control Register */
#define CAN_MOCTR23	(*( CAN_MOCTR0_type *) 0xf00192fcu)	/* Message Object 23 Control Register */
#define CAN_MOCTR230	(*( CAN_MOCTR0_type *) 0xf001acdcu)	/* Message Object 230 Control Register */
#define CAN_MOCTR231	(*( CAN_MOCTR0_type *) 0xf001acfcu)	/* Message Object 231 Control Register */
#define CAN_MOCTR232	(*( CAN_MOCTR0_type *) 0xf001ad1cu)	/* Message Object 232 Control Register */
#define CAN_MOCTR233	(*( CAN_MOCTR0_type *) 0xf001ad3cu)	/* Message Object 233 Control Register */
#define CAN_MOCTR234	(*( CAN_MOCTR0_type *) 0xf001ad5cu)	/* Message Object 234 Control Register */
#define CAN_MOCTR235	(*( CAN_MOCTR0_type *) 0xf001ad7cu)	/* Message Object 235 Control Register */
#define CAN_MOCTR236	(*( CAN_MOCTR0_type *) 0xf001ad9cu)	/* Message Object 236 Control Register */
#define CAN_MOCTR237	(*( CAN_MOCTR0_type *) 0xf001adbcu)	/* Message Object 237 Control Register */
#define CAN_MOCTR238	(*( CAN_MOCTR0_type *) 0xf001addcu)	/* Message Object 238 Control Register */
#define CAN_MOCTR239	(*( CAN_MOCTR0_type *) 0xf001adfcu)	/* Message Object 239 Control Register */
#define CAN_MOCTR24	(*( CAN_MOCTR0_type *) 0xf001931cu)	/* Message Object 24 Control Register */
#define CAN_MOCTR240	(*( CAN_MOCTR0_type *) 0xf001ae1cu)	/* Message Object 240 Control Register */
#define CAN_MOCTR241	(*( CAN_MOCTR0_type *) 0xf001ae3cu)	/* Message Object 241 Control Register */
#define CAN_MOCTR242	(*( CAN_MOCTR0_type *) 0xf001ae5cu)	/* Message Object 242 Control Register */
#define CAN_MOCTR243	(*( CAN_MOCTR0_type *) 0xf001ae7cu)	/* Message Object 243 Control Register */
#define CAN_MOCTR244	(*( CAN_MOCTR0_type *) 0xf001ae9cu)	/* Message Object 244 Control Register */
#define CAN_MOCTR245	(*( CAN_MOCTR0_type *) 0xf001aebcu)	/* Message Object 245 Control Register */
#define CAN_MOCTR246	(*( CAN_MOCTR0_type *) 0xf001aedcu)	/* Message Object 246 Control Register */
#define CAN_MOCTR247	(*( CAN_MOCTR0_type *) 0xf001aefcu)	/* Message Object 247 Control Register */
#define CAN_MOCTR248	(*( CAN_MOCTR0_type *) 0xf001af1cu)	/* Message Object 248 Control Register */
#define CAN_MOCTR249	(*( CAN_MOCTR0_type *) 0xf001af3cu)	/* Message Object 249 Control Register */
#define CAN_MOCTR25	(*( CAN_MOCTR0_type *) 0xf001933cu)	/* Message Object 25 Control Register */
#define CAN_MOCTR250	(*( CAN_MOCTR0_type *) 0xf001af5cu)	/* Message Object 250 Control Register */
#define CAN_MOCTR251	(*( CAN_MOCTR0_type *) 0xf001af7cu)	/* Message Object 251 Control Register */
#define CAN_MOCTR252	(*( CAN_MOCTR0_type *) 0xf001af9cu)	/* Message Object 252 Control Register */
#define CAN_MOCTR253	(*( CAN_MOCTR0_type *) 0xf001afbcu)	/* Message Object 253 Control Register */
#define CAN_MOCTR254	(*( CAN_MOCTR0_type *) 0xf001afdcu)	/* Message Object 254 Control Register */
#define CAN_MOCTR255	(*( CAN_MOCTR0_type *) 0xf001affcu)	/* Message Object 255 Control Register */
#define CAN_MOCTR26	(*( CAN_MOCTR0_type *) 0xf001935cu)	/* Message Object 26 Control Register */
#define CAN_MOCTR27	(*( CAN_MOCTR0_type *) 0xf001937cu)	/* Message Object 27 Control Register */
#define CAN_MOCTR28	(*( CAN_MOCTR0_type *) 0xf001939cu)	/* Message Object 28 Control Register */
#define CAN_MOCTR29	(*( CAN_MOCTR0_type *) 0xf00193bcu)	/* Message Object 29 Control Register */
#define CAN_MOCTR3	(*( CAN_MOCTR0_type *) 0xf001907cu)	/* Message Object 3 Control Register */
#define CAN_MOCTR30	(*( CAN_MOCTR0_type *) 0xf00193dcu)	/* Message Object 30 Control Register */
#define CAN_MOCTR31	(*( CAN_MOCTR0_type *) 0xf00193fcu)	/* Message Object 31 Control Register */
#define CAN_MOCTR32	(*( CAN_MOCTR0_type *) 0xf001941cu)	/* Message Object 32 Control Register */
#define CAN_MOCTR33	(*( CAN_MOCTR0_type *) 0xf001943cu)	/* Message Object 33 Control Register */
#define CAN_MOCTR34	(*( CAN_MOCTR0_type *) 0xf001945cu)	/* Message Object 34 Control Register */
#define CAN_MOCTR35	(*( CAN_MOCTR0_type *) 0xf001947cu)	/* Message Object 35 Control Register */
#define CAN_MOCTR36	(*( CAN_MOCTR0_type *) 0xf001949cu)	/* Message Object 36 Control Register */
#define CAN_MOCTR37	(*( CAN_MOCTR0_type *) 0xf00194bcu)	/* Message Object 37 Control Register */
#define CAN_MOCTR38	(*( CAN_MOCTR0_type *) 0xf00194dcu)	/* Message Object 38 Control Register */
#define CAN_MOCTR39	(*( CAN_MOCTR0_type *) 0xf00194fcu)	/* Message Object 39 Control Register */
#define CAN_MOCTR4	(*( CAN_MOCTR0_type *) 0xf001909cu)	/* Message Object 4 Control Register */
#define CAN_MOCTR40	(*( CAN_MOCTR0_type *) 0xf001951cu)	/* Message Object 40 Control Register */
#define CAN_MOCTR41	(*( CAN_MOCTR0_type *) 0xf001953cu)	/* Message Object 41 Control Register */
#define CAN_MOCTR42	(*( CAN_MOCTR0_type *) 0xf001955cu)	/* Message Object 42 Control Register */
#define CAN_MOCTR43	(*( CAN_MOCTR0_type *) 0xf001957cu)	/* Message Object 43 Control Register */
#define CAN_MOCTR44	(*( CAN_MOCTR0_type *) 0xf001959cu)	/* Message Object 44 Control Register */
#define CAN_MOCTR45	(*( CAN_MOCTR0_type *) 0xf00195bcu)	/* Message Object 45 Control Register */
#define CAN_MOCTR46	(*( CAN_MOCTR0_type *) 0xf00195dcu)	/* Message Object 46 Control Register */
#define CAN_MOCTR47	(*( CAN_MOCTR0_type *) 0xf00195fcu)	/* Message Object 47 Control Register */
#define CAN_MOCTR48	(*( CAN_MOCTR0_type *) 0xf001961cu)	/* Message Object 48 Control Register */
#define CAN_MOCTR49	(*( CAN_MOCTR0_type *) 0xf001963cu)	/* Message Object 49 Control Register */
#define CAN_MOCTR5	(*( CAN_MOCTR0_type *) 0xf00190bcu)	/* Message Object 5 Control Register */
#define CAN_MOCTR50	(*( CAN_MOCTR0_type *) 0xf001965cu)	/* Message Object 50 Control Register */
#define CAN_MOCTR51	(*( CAN_MOCTR0_type *) 0xf001967cu)	/* Message Object 51 Control Register */
#define CAN_MOCTR52	(*( CAN_MOCTR0_type *) 0xf001969cu)	/* Message Object 52 Control Register */
#define CAN_MOCTR53	(*( CAN_MOCTR0_type *) 0xf00196bcu)	/* Message Object 53 Control Register */
#define CAN_MOCTR54	(*( CAN_MOCTR0_type *) 0xf00196dcu)	/* Message Object 54 Control Register */
#define CAN_MOCTR55	(*( CAN_MOCTR0_type *) 0xf00196fcu)	/* Message Object 55 Control Register */
#define CAN_MOCTR56	(*( CAN_MOCTR0_type *) 0xf001971cu)	/* Message Object 56 Control Register */
#define CAN_MOCTR57	(*( CAN_MOCTR0_type *) 0xf001973cu)	/* Message Object 57 Control Register */
#define CAN_MOCTR58	(*( CAN_MOCTR0_type *) 0xf001975cu)	/* Message Object 58 Control Register */
#define CAN_MOCTR59	(*( CAN_MOCTR0_type *) 0xf001977cu)	/* Message Object 59 Control Register */
#define CAN_MOCTR6	(*( CAN_MOCTR0_type *) 0xf00190dcu)	/* Message Object 6 Control Register */
#define CAN_MOCTR60	(*( CAN_MOCTR0_type *) 0xf001979cu)	/* Message Object 60 Control Register */
#define CAN_MOCTR61	(*( CAN_MOCTR0_type *) 0xf00197bcu)	/* Message Object 61 Control Register */
#define CAN_MOCTR62	(*( CAN_MOCTR0_type *) 0xf00197dcu)	/* Message Object 62 Control Register */
#define CAN_MOCTR63	(*( CAN_MOCTR0_type *) 0xf00197fcu)	/* Message Object 63 Control Register */
#define CAN_MOCTR64	(*( CAN_MOCTR0_type *) 0xf001981cu)	/* Message Object 64 Control Register */
#define CAN_MOCTR65	(*( CAN_MOCTR0_type *) 0xf001983cu)	/* Message Object 65 Control Register */
#define CAN_MOCTR66	(*( CAN_MOCTR0_type *) 0xf001985cu)	/* Message Object 66 Control Register */
#define CAN_MOCTR67	(*( CAN_MOCTR0_type *) 0xf001987cu)	/* Message Object 67 Control Register */
#define CAN_MOCTR68	(*( CAN_MOCTR0_type *) 0xf001989cu)	/* Message Object 68 Control Register */
#define CAN_MOCTR69	(*( CAN_MOCTR0_type *) 0xf00198bcu)	/* Message Object 69 Control Register */
#define CAN_MOCTR7	(*( CAN_MOCTR0_type *) 0xf00190fcu)	/* Message Object 7 Control Register */
#define CAN_MOCTR70	(*( CAN_MOCTR0_type *) 0xf00198dcu)	/* Message Object 70 Control Register */
#define CAN_MOCTR71	(*( CAN_MOCTR0_type *) 0xf00198fcu)	/* Message Object 71 Control Register */
#define CAN_MOCTR72	(*( CAN_MOCTR0_type *) 0xf001991cu)	/* Message Object 72 Control Register */
#define CAN_MOCTR73	(*( CAN_MOCTR0_type *) 0xf001993cu)	/* Message Object 73 Control Register */
#define CAN_MOCTR74	(*( CAN_MOCTR0_type *) 0xf001995cu)	/* Message Object 74 Control Register */
#define CAN_MOCTR75	(*( CAN_MOCTR0_type *) 0xf001997cu)	/* Message Object 75 Control Register */
#define CAN_MOCTR76	(*( CAN_MOCTR0_type *) 0xf001999cu)	/* Message Object 76 Control Register */
#define CAN_MOCTR77	(*( CAN_MOCTR0_type *) 0xf00199bcu)	/* Message Object 77 Control Register */
#define CAN_MOCTR78	(*( CAN_MOCTR0_type *) 0xf00199dcu)	/* Message Object 78 Control Register */
#define CAN_MOCTR79	(*( CAN_MOCTR0_type *) 0xf00199fcu)	/* Message Object 79 Control Register */
#define CAN_MOCTR8	(*( CAN_MOCTR0_type *) 0xf001911cu)	/* Message Object 8 Control Register */
#define CAN_MOCTR80	(*( CAN_MOCTR0_type *) 0xf0019a1cu)	/* Message Object 80 Control Register */
#define CAN_MOCTR81	(*( CAN_MOCTR0_type *) 0xf0019a3cu)	/* Message Object 81 Control Register */
#define CAN_MOCTR82	(*( CAN_MOCTR0_type *) 0xf0019a5cu)	/* Message Object 82 Control Register */
#define CAN_MOCTR83	(*( CAN_MOCTR0_type *) 0xf0019a7cu)	/* Message Object 83 Control Register */
#define CAN_MOCTR84	(*( CAN_MOCTR0_type *) 0xf0019a9cu)	/* Message Object 84 Control Register */
#define CAN_MOCTR85	(*( CAN_MOCTR0_type *) 0xf0019abcu)	/* Message Object 85 Control Register */
#define CAN_MOCTR86	(*( CAN_MOCTR0_type *) 0xf0019adcu)	/* Message Object 86 Control Register */
#define CAN_MOCTR87	(*( CAN_MOCTR0_type *) 0xf0019afcu)	/* Message Object 87 Control Register */
#define CAN_MOCTR88	(*( CAN_MOCTR0_type *) 0xf0019b1cu)	/* Message Object 88 Control Register */
#define CAN_MOCTR89	(*( CAN_MOCTR0_type *) 0xf0019b3cu)	/* Message Object 89 Control Register */
#define CAN_MOCTR9	(*( CAN_MOCTR0_type *) 0xf001913cu)	/* Message Object 9 Control Register */
#define CAN_MOCTR90	(*( CAN_MOCTR0_type *) 0xf0019b5cu)	/* Message Object 90 Control Register */
#define CAN_MOCTR91	(*( CAN_MOCTR0_type *) 0xf0019b7cu)	/* Message Object 91 Control Register */
#define CAN_MOCTR92	(*( CAN_MOCTR0_type *) 0xf0019b9cu)	/* Message Object 92 Control Register */
#define CAN_MOCTR93	(*( CAN_MOCTR0_type *) 0xf0019bbcu)	/* Message Object 93 Control Register */
#define CAN_MOCTR94	(*( CAN_MOCTR0_type *) 0xf0019bdcu)	/* Message Object 94 Control Register */
#define CAN_MOCTR95	(*( CAN_MOCTR0_type *) 0xf0019bfcu)	/* Message Object 95 Control Register */
#define CAN_MOCTR96	(*( CAN_MOCTR0_type *) 0xf0019c1cu)	/* Message Object 96 Control Register */
#define CAN_MOCTR97	(*( CAN_MOCTR0_type *) 0xf0019c3cu)	/* Message Object 97 Control Register */
#define CAN_MOCTR98	(*( CAN_MOCTR0_type *) 0xf0019c5cu)	/* Message Object 98 Control Register */
#define CAN_MOCTR99	(*( CAN_MOCTR0_type *) 0xf0019c7cu)	/* Message Object 99 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DB4            : 8;	/* Data Byte 4 of Message Object n */
		unsigned int DB5            : 8;	/* Data Byte 5 of Message Object n */
		unsigned int DB6            : 8;	/* Data Byte 6 of Message Object n */
		unsigned int DB7            : 8;	/* Data Byte 7 of Message Object n */
	} B;
	int I;
	unsigned int U;

} CAN_MODATAH0_type;
#define CAN_MODATAH0	(*( CAN_MODATAH0_type *) 0xf0019014u)	/* Message Object 0 Data Register High */
#define CAN_MODATAH1	(*( CAN_MODATAH0_type *) 0xf0019034u)	/* Message Object 1 Data Register High */
#define CAN_MODATAH10	(*( CAN_MODATAH0_type *) 0xf0019154u)	/* Message Object 10 Data Register High */
#define CAN_MODATAH100	(*( CAN_MODATAH0_type *) 0xf0019c94u)	/* Message Object 100 Data Register High */
#define CAN_MODATAH101	(*( CAN_MODATAH0_type *) 0xf0019cb4u)	/* Message Object 101 Data Register High */
#define CAN_MODATAH102	(*( CAN_MODATAH0_type *) 0xf0019cd4u)	/* Message Object 102 Data Register High */
#define CAN_MODATAH103	(*( CAN_MODATAH0_type *) 0xf0019cf4u)	/* Message Object 103 Data Register High */
#define CAN_MODATAH104	(*( CAN_MODATAH0_type *) 0xf0019d14u)	/* Message Object 104 Data Register High */
#define CAN_MODATAH105	(*( CAN_MODATAH0_type *) 0xf0019d34u)	/* Message Object 105 Data Register High */
#define CAN_MODATAH106	(*( CAN_MODATAH0_type *) 0xf0019d54u)	/* Message Object 106 Data Register High */
#define CAN_MODATAH107	(*( CAN_MODATAH0_type *) 0xf0019d74u)	/* Message Object 107 Data Register High */
#define CAN_MODATAH108	(*( CAN_MODATAH0_type *) 0xf0019d94u)	/* Message Object 108 Data Register High */
#define CAN_MODATAH109	(*( CAN_MODATAH0_type *) 0xf0019db4u)	/* Message Object 109 Data Register High */
#define CAN_MODATAH11	(*( CAN_MODATAH0_type *) 0xf0019174u)	/* Message Object 11 Data Register High */
#define CAN_MODATAH110	(*( CAN_MODATAH0_type *) 0xf0019dd4u)	/* Message Object 110 Data Register High */
#define CAN_MODATAH111	(*( CAN_MODATAH0_type *) 0xf0019df4u)	/* Message Object 111 Data Register High */
#define CAN_MODATAH112	(*( CAN_MODATAH0_type *) 0xf0019e14u)	/* Message Object 112 Data Register High */
#define CAN_MODATAH113	(*( CAN_MODATAH0_type *) 0xf0019e34u)	/* Message Object 113 Data Register High */
#define CAN_MODATAH114	(*( CAN_MODATAH0_type *) 0xf0019e54u)	/* Message Object 114 Data Register High */
#define CAN_MODATAH115	(*( CAN_MODATAH0_type *) 0xf0019e74u)	/* Message Object 115 Data Register High */
#define CAN_MODATAH116	(*( CAN_MODATAH0_type *) 0xf0019e94u)	/* Message Object 116 Data Register High */
#define CAN_MODATAH117	(*( CAN_MODATAH0_type *) 0xf0019eb4u)	/* Message Object 117 Data Register High */
#define CAN_MODATAH118	(*( CAN_MODATAH0_type *) 0xf0019ed4u)	/* Message Object 118 Data Register High */
#define CAN_MODATAH119	(*( CAN_MODATAH0_type *) 0xf0019ef4u)	/* Message Object 119 Data Register High */
#define CAN_MODATAH12	(*( CAN_MODATAH0_type *) 0xf0019194u)	/* Message Object 12 Data Register High */
#define CAN_MODATAH120	(*( CAN_MODATAH0_type *) 0xf0019f14u)	/* Message Object 120 Data Register High */
#define CAN_MODATAH121	(*( CAN_MODATAH0_type *) 0xf0019f34u)	/* Message Object 121 Data Register High */
#define CAN_MODATAH122	(*( CAN_MODATAH0_type *) 0xf0019f54u)	/* Message Object 122 Data Register High */
#define CAN_MODATAH123	(*( CAN_MODATAH0_type *) 0xf0019f74u)	/* Message Object 123 Data Register High */
#define CAN_MODATAH124	(*( CAN_MODATAH0_type *) 0xf0019f94u)	/* Message Object 124 Data Register High */
#define CAN_MODATAH125	(*( CAN_MODATAH0_type *) 0xf0019fb4u)	/* Message Object 125 Data Register High */
#define CAN_MODATAH126	(*( CAN_MODATAH0_type *) 0xf0019fd4u)	/* Message Object 126 Data Register High */
#define CAN_MODATAH127	(*( CAN_MODATAH0_type *) 0xf0019ff4u)	/* Message Object 127 Data Register High */
#define CAN_MODATAH128	(*( CAN_MODATAH0_type *) 0xf001a014u)	/* Message Object 128 Data Register High */
#define CAN_MODATAH129	(*( CAN_MODATAH0_type *) 0xf001a034u)	/* Message Object 129 Data Register High */
#define CAN_MODATAH13	(*( CAN_MODATAH0_type *) 0xf00191b4u)	/* Message Object 13 Data Register High */
#define CAN_MODATAH130	(*( CAN_MODATAH0_type *) 0xf001a054u)	/* Message Object 130 Data Register High */
#define CAN_MODATAH131	(*( CAN_MODATAH0_type *) 0xf001a074u)	/* Message Object 131 Data Register High */
#define CAN_MODATAH132	(*( CAN_MODATAH0_type *) 0xf001a094u)	/* Message Object 132 Data Register High */
#define CAN_MODATAH133	(*( CAN_MODATAH0_type *) 0xf001a0b4u)	/* Message Object 133 Data Register High */
#define CAN_MODATAH134	(*( CAN_MODATAH0_type *) 0xf001a0d4u)	/* Message Object 134 Data Register High */
#define CAN_MODATAH135	(*( CAN_MODATAH0_type *) 0xf001a0f4u)	/* Message Object 135 Data Register High */
#define CAN_MODATAH136	(*( CAN_MODATAH0_type *) 0xf001a114u)	/* Message Object 136 Data Register High */
#define CAN_MODATAH137	(*( CAN_MODATAH0_type *) 0xf001a134u)	/* Message Object 137 Data Register High */
#define CAN_MODATAH138	(*( CAN_MODATAH0_type *) 0xf001a154u)	/* Message Object 138 Data Register High */
#define CAN_MODATAH139	(*( CAN_MODATAH0_type *) 0xf001a174u)	/* Message Object 139 Data Register High */
#define CAN_MODATAH14	(*( CAN_MODATAH0_type *) 0xf00191d4u)	/* Message Object 14 Data Register High */
#define CAN_MODATAH140	(*( CAN_MODATAH0_type *) 0xf001a194u)	/* Message Object 140 Data Register High */
#define CAN_MODATAH141	(*( CAN_MODATAH0_type *) 0xf001a1b4u)	/* Message Object 141 Data Register High */
#define CAN_MODATAH142	(*( CAN_MODATAH0_type *) 0xf001a1d4u)	/* Message Object 142 Data Register High */
#define CAN_MODATAH143	(*( CAN_MODATAH0_type *) 0xf001a1f4u)	/* Message Object 143 Data Register High */
#define CAN_MODATAH144	(*( CAN_MODATAH0_type *) 0xf001a214u)	/* Message Object 144 Data Register High */
#define CAN_MODATAH145	(*( CAN_MODATAH0_type *) 0xf001a234u)	/* Message Object 145 Data Register High */
#define CAN_MODATAH146	(*( CAN_MODATAH0_type *) 0xf001a254u)	/* Message Object 146 Data Register High */
#define CAN_MODATAH147	(*( CAN_MODATAH0_type *) 0xf001a274u)	/* Message Object 147 Data Register High */
#define CAN_MODATAH148	(*( CAN_MODATAH0_type *) 0xf001a294u)	/* Message Object 148 Data Register High */
#define CAN_MODATAH149	(*( CAN_MODATAH0_type *) 0xf001a2b4u)	/* Message Object 149 Data Register High */
#define CAN_MODATAH15	(*( CAN_MODATAH0_type *) 0xf00191f4u)	/* Message Object 15 Data Register High */
#define CAN_MODATAH150	(*( CAN_MODATAH0_type *) 0xf001a2d4u)	/* Message Object 150 Data Register High */
#define CAN_MODATAH151	(*( CAN_MODATAH0_type *) 0xf001a2f4u)	/* Message Object 151 Data Register High */
#define CAN_MODATAH152	(*( CAN_MODATAH0_type *) 0xf001a314u)	/* Message Object 152 Data Register High */
#define CAN_MODATAH153	(*( CAN_MODATAH0_type *) 0xf001a334u)	/* Message Object 153 Data Register High */
#define CAN_MODATAH154	(*( CAN_MODATAH0_type *) 0xf001a354u)	/* Message Object 154 Data Register High */
#define CAN_MODATAH155	(*( CAN_MODATAH0_type *) 0xf001a374u)	/* Message Object 155 Data Register High */
#define CAN_MODATAH156	(*( CAN_MODATAH0_type *) 0xf001a394u)	/* Message Object 156 Data Register High */
#define CAN_MODATAH157	(*( CAN_MODATAH0_type *) 0xf001a3b4u)	/* Message Object 157 Data Register High */
#define CAN_MODATAH158	(*( CAN_MODATAH0_type *) 0xf001a3d4u)	/* Message Object 158 Data Register High */
#define CAN_MODATAH159	(*( CAN_MODATAH0_type *) 0xf001a3f4u)	/* Message Object 159 Data Register High */
#define CAN_MODATAH16	(*( CAN_MODATAH0_type *) 0xf0019214u)	/* Message Object 16 Data Register High */
#define CAN_MODATAH160	(*( CAN_MODATAH0_type *) 0xf001a414u)	/* Message Object 160 Data Register High */
#define CAN_MODATAH161	(*( CAN_MODATAH0_type *) 0xf001a434u)	/* Message Object 161 Data Register High */
#define CAN_MODATAH162	(*( CAN_MODATAH0_type *) 0xf001a454u)	/* Message Object 162 Data Register High */
#define CAN_MODATAH163	(*( CAN_MODATAH0_type *) 0xf001a474u)	/* Message Object 163 Data Register High */
#define CAN_MODATAH164	(*( CAN_MODATAH0_type *) 0xf001a494u)	/* Message Object 164 Data Register High */
#define CAN_MODATAH165	(*( CAN_MODATAH0_type *) 0xf001a4b4u)	/* Message Object 165 Data Register High */
#define CAN_MODATAH166	(*( CAN_MODATAH0_type *) 0xf001a4d4u)	/* Message Object 166 Data Register High */
#define CAN_MODATAH167	(*( CAN_MODATAH0_type *) 0xf001a4f4u)	/* Message Object 167 Data Register High */
#define CAN_MODATAH168	(*( CAN_MODATAH0_type *) 0xf001a514u)	/* Message Object 168 Data Register High */
#define CAN_MODATAH169	(*( CAN_MODATAH0_type *) 0xf001a534u)	/* Message Object 169 Data Register High */
#define CAN_MODATAH17	(*( CAN_MODATAH0_type *) 0xf0019234u)	/* Message Object 17 Data Register High */
#define CAN_MODATAH170	(*( CAN_MODATAH0_type *) 0xf001a554u)	/* Message Object 170 Data Register High */
#define CAN_MODATAH171	(*( CAN_MODATAH0_type *) 0xf001a574u)	/* Message Object 171 Data Register High */
#define CAN_MODATAH172	(*( CAN_MODATAH0_type *) 0xf001a594u)	/* Message Object 172 Data Register High */
#define CAN_MODATAH173	(*( CAN_MODATAH0_type *) 0xf001a5b4u)	/* Message Object 173 Data Register High */
#define CAN_MODATAH174	(*( CAN_MODATAH0_type *) 0xf001a5d4u)	/* Message Object 174 Data Register High */
#define CAN_MODATAH175	(*( CAN_MODATAH0_type *) 0xf001a5f4u)	/* Message Object 175 Data Register High */
#define CAN_MODATAH176	(*( CAN_MODATAH0_type *) 0xf001a614u)	/* Message Object 176 Data Register High */
#define CAN_MODATAH177	(*( CAN_MODATAH0_type *) 0xf001a634u)	/* Message Object 177 Data Register High */
#define CAN_MODATAH178	(*( CAN_MODATAH0_type *) 0xf001a654u)	/* Message Object 178 Data Register High */
#define CAN_MODATAH179	(*( CAN_MODATAH0_type *) 0xf001a674u)	/* Message Object 179 Data Register High */
#define CAN_MODATAH18	(*( CAN_MODATAH0_type *) 0xf0019254u)	/* Message Object 18 Data Register High */
#define CAN_MODATAH180	(*( CAN_MODATAH0_type *) 0xf001a694u)	/* Message Object 180 Data Register High */
#define CAN_MODATAH181	(*( CAN_MODATAH0_type *) 0xf001a6b4u)	/* Message Object 181 Data Register High */
#define CAN_MODATAH182	(*( CAN_MODATAH0_type *) 0xf001a6d4u)	/* Message Object 182 Data Register High */
#define CAN_MODATAH183	(*( CAN_MODATAH0_type *) 0xf001a6f4u)	/* Message Object 183 Data Register High */
#define CAN_MODATAH184	(*( CAN_MODATAH0_type *) 0xf001a714u)	/* Message Object 184 Data Register High */
#define CAN_MODATAH185	(*( CAN_MODATAH0_type *) 0xf001a734u)	/* Message Object 185 Data Register High */
#define CAN_MODATAH186	(*( CAN_MODATAH0_type *) 0xf001a754u)	/* Message Object 186 Data Register High */
#define CAN_MODATAH187	(*( CAN_MODATAH0_type *) 0xf001a774u)	/* Message Object 187 Data Register High */
#define CAN_MODATAH188	(*( CAN_MODATAH0_type *) 0xf001a794u)	/* Message Object 188 Data Register High */
#define CAN_MODATAH189	(*( CAN_MODATAH0_type *) 0xf001a7b4u)	/* Message Object 189 Data Register High */
#define CAN_MODATAH19	(*( CAN_MODATAH0_type *) 0xf0019274u)	/* Message Object 19 Data Register High */
#define CAN_MODATAH190	(*( CAN_MODATAH0_type *) 0xf001a7d4u)	/* Message Object 190 Data Register High */
#define CAN_MODATAH191	(*( CAN_MODATAH0_type *) 0xf001a7f4u)	/* Message Object 191 Data Register High */
#define CAN_MODATAH192	(*( CAN_MODATAH0_type *) 0xf001a814u)	/* Message Object 192 Data Register High */
#define CAN_MODATAH193	(*( CAN_MODATAH0_type *) 0xf001a834u)	/* Message Object 193 Data Register High */
#define CAN_MODATAH194	(*( CAN_MODATAH0_type *) 0xf001a854u)	/* Message Object 194 Data Register High */
#define CAN_MODATAH195	(*( CAN_MODATAH0_type *) 0xf001a874u)	/* Message Object 195 Data Register High */
#define CAN_MODATAH196	(*( CAN_MODATAH0_type *) 0xf001a894u)	/* Message Object 196 Data Register High */
#define CAN_MODATAH197	(*( CAN_MODATAH0_type *) 0xf001a8b4u)	/* Message Object 197 Data Register High */
#define CAN_MODATAH198	(*( CAN_MODATAH0_type *) 0xf001a8d4u)	/* Message Object 198 Data Register High */
#define CAN_MODATAH199	(*( CAN_MODATAH0_type *) 0xf001a8f4u)	/* Message Object 199 Data Register High */
#define CAN_MODATAH2	(*( CAN_MODATAH0_type *) 0xf0019054u)	/* Message Object 2 Data Register High */
#define CAN_MODATAH20	(*( CAN_MODATAH0_type *) 0xf0019294u)	/* Message Object 20 Data Register High */
#define CAN_MODATAH200	(*( CAN_MODATAH0_type *) 0xf001a914u)	/* Message Object 200 Data Register High */
#define CAN_MODATAH201	(*( CAN_MODATAH0_type *) 0xf001a934u)	/* Message Object 201 Data Register High */
#define CAN_MODATAH202	(*( CAN_MODATAH0_type *) 0xf001a954u)	/* Message Object 202 Data Register High */
#define CAN_MODATAH203	(*( CAN_MODATAH0_type *) 0xf001a974u)	/* Message Object 203 Data Register High */
#define CAN_MODATAH204	(*( CAN_MODATAH0_type *) 0xf001a994u)	/* Message Object 204 Data Register High */
#define CAN_MODATAH205	(*( CAN_MODATAH0_type *) 0xf001a9b4u)	/* Message Object 205 Data Register High */
#define CAN_MODATAH206	(*( CAN_MODATAH0_type *) 0xf001a9d4u)	/* Message Object 206 Data Register High */
#define CAN_MODATAH207	(*( CAN_MODATAH0_type *) 0xf001a9f4u)	/* Message Object 207 Data Register High */
#define CAN_MODATAH208	(*( CAN_MODATAH0_type *) 0xf001aa14u)	/* Message Object 208 Data Register High */
#define CAN_MODATAH209	(*( CAN_MODATAH0_type *) 0xf001aa34u)	/* Message Object 209 Data Register High */
#define CAN_MODATAH21	(*( CAN_MODATAH0_type *) 0xf00192b4u)	/* Message Object 21 Data Register High */
#define CAN_MODATAH210	(*( CAN_MODATAH0_type *) 0xf001aa54u)	/* Message Object 210 Data Register High */
#define CAN_MODATAH211	(*( CAN_MODATAH0_type *) 0xf001aa74u)	/* Message Object 211 Data Register High */
#define CAN_MODATAH212	(*( CAN_MODATAH0_type *) 0xf001aa94u)	/* Message Object 212 Data Register High */
#define CAN_MODATAH213	(*( CAN_MODATAH0_type *) 0xf001aab4u)	/* Message Object 213 Data Register High */
#define CAN_MODATAH214	(*( CAN_MODATAH0_type *) 0xf001aad4u)	/* Message Object 214 Data Register High */
#define CAN_MODATAH215	(*( CAN_MODATAH0_type *) 0xf001aaf4u)	/* Message Object 215 Data Register High */
#define CAN_MODATAH216	(*( CAN_MODATAH0_type *) 0xf001ab14u)	/* Message Object 216 Data Register High */
#define CAN_MODATAH217	(*( CAN_MODATAH0_type *) 0xf001ab34u)	/* Message Object 217 Data Register High */
#define CAN_MODATAH218	(*( CAN_MODATAH0_type *) 0xf001ab54u)	/* Message Object 218 Data Register High */
#define CAN_MODATAH219	(*( CAN_MODATAH0_type *) 0xf001ab74u)	/* Message Object 219 Data Register High */
#define CAN_MODATAH22	(*( CAN_MODATAH0_type *) 0xf00192d4u)	/* Message Object 22 Data Register High */
#define CAN_MODATAH220	(*( CAN_MODATAH0_type *) 0xf001ab94u)	/* Message Object 220 Data Register High */
#define CAN_MODATAH221	(*( CAN_MODATAH0_type *) 0xf001abb4u)	/* Message Object 221 Data Register High */
#define CAN_MODATAH222	(*( CAN_MODATAH0_type *) 0xf001abd4u)	/* Message Object 222 Data Register High */
#define CAN_MODATAH223	(*( CAN_MODATAH0_type *) 0xf001abf4u)	/* Message Object 223 Data Register High */
#define CAN_MODATAH224	(*( CAN_MODATAH0_type *) 0xf001ac14u)	/* Message Object 224 Data Register High */
#define CAN_MODATAH225	(*( CAN_MODATAH0_type *) 0xf001ac34u)	/* Message Object 225 Data Register High */
#define CAN_MODATAH226	(*( CAN_MODATAH0_type *) 0xf001ac54u)	/* Message Object 226 Data Register High */
#define CAN_MODATAH227	(*( CAN_MODATAH0_type *) 0xf001ac74u)	/* Message Object 227 Data Register High */
#define CAN_MODATAH228	(*( CAN_MODATAH0_type *) 0xf001ac94u)	/* Message Object 228 Data Register High */
#define CAN_MODATAH229	(*( CAN_MODATAH0_type *) 0xf001acb4u)	/* Message Object 229 Data Register High */
#define CAN_MODATAH23	(*( CAN_MODATAH0_type *) 0xf00192f4u)	/* Message Object 23 Data Register High */
#define CAN_MODATAH230	(*( CAN_MODATAH0_type *) 0xf001acd4u)	/* Message Object 230 Data Register High */
#define CAN_MODATAH231	(*( CAN_MODATAH0_type *) 0xf001acf4u)	/* Message Object 231 Data Register High */
#define CAN_MODATAH232	(*( CAN_MODATAH0_type *) 0xf001ad14u)	/* Message Object 232 Data Register High */
#define CAN_MODATAH233	(*( CAN_MODATAH0_type *) 0xf001ad34u)	/* Message Object 233 Data Register High */
#define CAN_MODATAH234	(*( CAN_MODATAH0_type *) 0xf001ad54u)	/* Message Object 234 Data Register High */
#define CAN_MODATAH235	(*( CAN_MODATAH0_type *) 0xf001ad74u)	/* Message Object 235 Data Register High */
#define CAN_MODATAH236	(*( CAN_MODATAH0_type *) 0xf001ad94u)	/* Message Object 236 Data Register High */
#define CAN_MODATAH237	(*( CAN_MODATAH0_type *) 0xf001adb4u)	/* Message Object 237 Data Register High */
#define CAN_MODATAH238	(*( CAN_MODATAH0_type *) 0xf001add4u)	/* Message Object 238 Data Register High */
#define CAN_MODATAH239	(*( CAN_MODATAH0_type *) 0xf001adf4u)	/* Message Object 239 Data Register High */
#define CAN_MODATAH24	(*( CAN_MODATAH0_type *) 0xf0019314u)	/* Message Object 24 Data Register High */
#define CAN_MODATAH240	(*( CAN_MODATAH0_type *) 0xf001ae14u)	/* Message Object 240 Data Register High */
#define CAN_MODATAH241	(*( CAN_MODATAH0_type *) 0xf001ae34u)	/* Message Object 241 Data Register High */
#define CAN_MODATAH242	(*( CAN_MODATAH0_type *) 0xf001ae54u)	/* Message Object 242 Data Register High */
#define CAN_MODATAH243	(*( CAN_MODATAH0_type *) 0xf001ae74u)	/* Message Object 243 Data Register High */
#define CAN_MODATAH244	(*( CAN_MODATAH0_type *) 0xf001ae94u)	/* Message Object 244 Data Register High */
#define CAN_MODATAH245	(*( CAN_MODATAH0_type *) 0xf001aeb4u)	/* Message Object 245 Data Register High */
#define CAN_MODATAH246	(*( CAN_MODATAH0_type *) 0xf001aed4u)	/* Message Object 246 Data Register High */
#define CAN_MODATAH247	(*( CAN_MODATAH0_type *) 0xf001aef4u)	/* Message Object 247 Data Register High */
#define CAN_MODATAH248	(*( CAN_MODATAH0_type *) 0xf001af14u)	/* Message Object 248 Data Register High */
#define CAN_MODATAH249	(*( CAN_MODATAH0_type *) 0xf001af34u)	/* Message Object 249 Data Register High */
#define CAN_MODATAH25	(*( CAN_MODATAH0_type *) 0xf0019334u)	/* Message Object 25 Data Register High */
#define CAN_MODATAH250	(*( CAN_MODATAH0_type *) 0xf001af54u)	/* Message Object 250 Data Register High */
#define CAN_MODATAH251	(*( CAN_MODATAH0_type *) 0xf001af74u)	/* Message Object 251 Data Register High */
#define CAN_MODATAH252	(*( CAN_MODATAH0_type *) 0xf001af94u)	/* Message Object 252 Data Register High */
#define CAN_MODATAH253	(*( CAN_MODATAH0_type *) 0xf001afb4u)	/* Message Object 253 Data Register High */
#define CAN_MODATAH254	(*( CAN_MODATAH0_type *) 0xf001afd4u)	/* Message Object 254 Data Register High */
#define CAN_MODATAH255	(*( CAN_MODATAH0_type *) 0xf001aff4u)	/* Message Object 255 Data Register High */
#define CAN_MODATAH26	(*( CAN_MODATAH0_type *) 0xf0019354u)	/* Message Object 26 Data Register High */
#define CAN_MODATAH27	(*( CAN_MODATAH0_type *) 0xf0019374u)	/* Message Object 27 Data Register High */
#define CAN_MODATAH28	(*( CAN_MODATAH0_type *) 0xf0019394u)	/* Message Object 28 Data Register High */
#define CAN_MODATAH29	(*( CAN_MODATAH0_type *) 0xf00193b4u)	/* Message Object 29 Data Register High */
#define CAN_MODATAH3	(*( CAN_MODATAH0_type *) 0xf0019074u)	/* Message Object 3 Data Register High */
#define CAN_MODATAH30	(*( CAN_MODATAH0_type *) 0xf00193d4u)	/* Message Object 30 Data Register High */
#define CAN_MODATAH31	(*( CAN_MODATAH0_type *) 0xf00193f4u)	/* Message Object 31 Data Register High */
#define CAN_MODATAH32	(*( CAN_MODATAH0_type *) 0xf0019414u)	/* Message Object 32 Data Register High */
#define CAN_MODATAH33	(*( CAN_MODATAH0_type *) 0xf0019434u)	/* Message Object 33 Data Register High */
#define CAN_MODATAH34	(*( CAN_MODATAH0_type *) 0xf0019454u)	/* Message Object 34 Data Register High */
#define CAN_MODATAH35	(*( CAN_MODATAH0_type *) 0xf0019474u)	/* Message Object 35 Data Register High */
#define CAN_MODATAH36	(*( CAN_MODATAH0_type *) 0xf0019494u)	/* Message Object 36 Data Register High */
#define CAN_MODATAH37	(*( CAN_MODATAH0_type *) 0xf00194b4u)	/* Message Object 37 Data Register High */
#define CAN_MODATAH38	(*( CAN_MODATAH0_type *) 0xf00194d4u)	/* Message Object 38 Data Register High */
#define CAN_MODATAH39	(*( CAN_MODATAH0_type *) 0xf00194f4u)	/* Message Object 39 Data Register High */
#define CAN_MODATAH4	(*( CAN_MODATAH0_type *) 0xf0019094u)	/* Message Object 4 Data Register High */
#define CAN_MODATAH40	(*( CAN_MODATAH0_type *) 0xf0019514u)	/* Message Object 40 Data Register High */
#define CAN_MODATAH41	(*( CAN_MODATAH0_type *) 0xf0019534u)	/* Message Object 41 Data Register High */
#define CAN_MODATAH42	(*( CAN_MODATAH0_type *) 0xf0019554u)	/* Message Object 42 Data Register High */
#define CAN_MODATAH43	(*( CAN_MODATAH0_type *) 0xf0019574u)	/* Message Object 43 Data Register High */
#define CAN_MODATAH44	(*( CAN_MODATAH0_type *) 0xf0019594u)	/* Message Object 44 Data Register High */
#define CAN_MODATAH45	(*( CAN_MODATAH0_type *) 0xf00195b4u)	/* Message Object 45 Data Register High */
#define CAN_MODATAH46	(*( CAN_MODATAH0_type *) 0xf00195d4u)	/* Message Object 46 Data Register High */
#define CAN_MODATAH47	(*( CAN_MODATAH0_type *) 0xf00195f4u)	/* Message Object 47 Data Register High */
#define CAN_MODATAH48	(*( CAN_MODATAH0_type *) 0xf0019614u)	/* Message Object 48 Data Register High */
#define CAN_MODATAH49	(*( CAN_MODATAH0_type *) 0xf0019634u)	/* Message Object 49 Data Register High */
#define CAN_MODATAH5	(*( CAN_MODATAH0_type *) 0xf00190b4u)	/* Message Object 5 Data Register High */
#define CAN_MODATAH50	(*( CAN_MODATAH0_type *) 0xf0019654u)	/* Message Object 50 Data Register High */
#define CAN_MODATAH51	(*( CAN_MODATAH0_type *) 0xf0019674u)	/* Message Object 51 Data Register High */
#define CAN_MODATAH52	(*( CAN_MODATAH0_type *) 0xf0019694u)	/* Message Object 52 Data Register High */
#define CAN_MODATAH53	(*( CAN_MODATAH0_type *) 0xf00196b4u)	/* Message Object 53 Data Register High */
#define CAN_MODATAH54	(*( CAN_MODATAH0_type *) 0xf00196d4u)	/* Message Object 54 Data Register High */
#define CAN_MODATAH55	(*( CAN_MODATAH0_type *) 0xf00196f4u)	/* Message Object 55 Data Register High */
#define CAN_MODATAH56	(*( CAN_MODATAH0_type *) 0xf0019714u)	/* Message Object 56 Data Register High */
#define CAN_MODATAH57	(*( CAN_MODATAH0_type *) 0xf0019734u)	/* Message Object 57 Data Register High */
#define CAN_MODATAH58	(*( CAN_MODATAH0_type *) 0xf0019754u)	/* Message Object 58 Data Register High */
#define CAN_MODATAH59	(*( CAN_MODATAH0_type *) 0xf0019774u)	/* Message Object 59 Data Register High */
#define CAN_MODATAH6	(*( CAN_MODATAH0_type *) 0xf00190d4u)	/* Message Object 6 Data Register High */
#define CAN_MODATAH60	(*( CAN_MODATAH0_type *) 0xf0019794u)	/* Message Object 60 Data Register High */
#define CAN_MODATAH61	(*( CAN_MODATAH0_type *) 0xf00197b4u)	/* Message Object 61 Data Register High */
#define CAN_MODATAH62	(*( CAN_MODATAH0_type *) 0xf00197d4u)	/* Message Object 62 Data Register High */
#define CAN_MODATAH63	(*( CAN_MODATAH0_type *) 0xf00197f4u)	/* Message Object 63 Data Register High */
#define CAN_MODATAH64	(*( CAN_MODATAH0_type *) 0xf0019814u)	/* Message Object 64 Data Register High */
#define CAN_MODATAH65	(*( CAN_MODATAH0_type *) 0xf0019834u)	/* Message Object 65 Data Register High */
#define CAN_MODATAH66	(*( CAN_MODATAH0_type *) 0xf0019854u)	/* Message Object 66 Data Register High */
#define CAN_MODATAH67	(*( CAN_MODATAH0_type *) 0xf0019874u)	/* Message Object 67 Data Register High */
#define CAN_MODATAH68	(*( CAN_MODATAH0_type *) 0xf0019894u)	/* Message Object 68 Data Register High */
#define CAN_MODATAH69	(*( CAN_MODATAH0_type *) 0xf00198b4u)	/* Message Object 69 Data Register High */
#define CAN_MODATAH7	(*( CAN_MODATAH0_type *) 0xf00190f4u)	/* Message Object 7 Data Register High */
#define CAN_MODATAH70	(*( CAN_MODATAH0_type *) 0xf00198d4u)	/* Message Object 70 Data Register High */
#define CAN_MODATAH71	(*( CAN_MODATAH0_type *) 0xf00198f4u)	/* Message Object 71 Data Register High */
#define CAN_MODATAH72	(*( CAN_MODATAH0_type *) 0xf0019914u)	/* Message Object 72 Data Register High */
#define CAN_MODATAH73	(*( CAN_MODATAH0_type *) 0xf0019934u)	/* Message Object 73 Data Register High */
#define CAN_MODATAH74	(*( CAN_MODATAH0_type *) 0xf0019954u)	/* Message Object 74 Data Register High */
#define CAN_MODATAH75	(*( CAN_MODATAH0_type *) 0xf0019974u)	/* Message Object 75 Data Register High */
#define CAN_MODATAH76	(*( CAN_MODATAH0_type *) 0xf0019994u)	/* Message Object 76 Data Register High */
#define CAN_MODATAH77	(*( CAN_MODATAH0_type *) 0xf00199b4u)	/* Message Object 77 Data Register High */
#define CAN_MODATAH78	(*( CAN_MODATAH0_type *) 0xf00199d4u)	/* Message Object 78 Data Register High */
#define CAN_MODATAH79	(*( CAN_MODATAH0_type *) 0xf00199f4u)	/* Message Object 79 Data Register High */
#define CAN_MODATAH8	(*( CAN_MODATAH0_type *) 0xf0019114u)	/* Message Object 8 Data Register High */
#define CAN_MODATAH80	(*( CAN_MODATAH0_type *) 0xf0019a14u)	/* Message Object 80 Data Register High */
#define CAN_MODATAH81	(*( CAN_MODATAH0_type *) 0xf0019a34u)	/* Message Object 81 Data Register High */
#define CAN_MODATAH82	(*( CAN_MODATAH0_type *) 0xf0019a54u)	/* Message Object 82 Data Register High */
#define CAN_MODATAH83	(*( CAN_MODATAH0_type *) 0xf0019a74u)	/* Message Object 83 Data Register High */
#define CAN_MODATAH84	(*( CAN_MODATAH0_type *) 0xf0019a94u)	/* Message Object 84 Data Register High */
#define CAN_MODATAH85	(*( CAN_MODATAH0_type *) 0xf0019ab4u)	/* Message Object 85 Data Register High */
#define CAN_MODATAH86	(*( CAN_MODATAH0_type *) 0xf0019ad4u)	/* Message Object 86 Data Register High */
#define CAN_MODATAH87	(*( CAN_MODATAH0_type *) 0xf0019af4u)	/* Message Object 87 Data Register High */
#define CAN_MODATAH88	(*( CAN_MODATAH0_type *) 0xf0019b14u)	/* Message Object 88 Data Register High */
#define CAN_MODATAH89	(*( CAN_MODATAH0_type *) 0xf0019b34u)	/* Message Object 89 Data Register High */
#define CAN_MODATAH9	(*( CAN_MODATAH0_type *) 0xf0019134u)	/* Message Object 9 Data Register High */
#define CAN_MODATAH90	(*( CAN_MODATAH0_type *) 0xf0019b54u)	/* Message Object 90 Data Register High */
#define CAN_MODATAH91	(*( CAN_MODATAH0_type *) 0xf0019b74u)	/* Message Object 91 Data Register High */
#define CAN_MODATAH92	(*( CAN_MODATAH0_type *) 0xf0019b94u)	/* Message Object 92 Data Register High */
#define CAN_MODATAH93	(*( CAN_MODATAH0_type *) 0xf0019bb4u)	/* Message Object 93 Data Register High */
#define CAN_MODATAH94	(*( CAN_MODATAH0_type *) 0xf0019bd4u)	/* Message Object 94 Data Register High */
#define CAN_MODATAH95	(*( CAN_MODATAH0_type *) 0xf0019bf4u)	/* Message Object 95 Data Register High */
#define CAN_MODATAH96	(*( CAN_MODATAH0_type *) 0xf0019c14u)	/* Message Object 96 Data Register High */
#define CAN_MODATAH97	(*( CAN_MODATAH0_type *) 0xf0019c34u)	/* Message Object 97 Data Register High */
#define CAN_MODATAH98	(*( CAN_MODATAH0_type *) 0xf0019c54u)	/* Message Object 98 Data Register High */
#define CAN_MODATAH99	(*( CAN_MODATAH0_type *) 0xf0019c74u)	/* Message Object 99 Data Register High */

typedef volatile union
{
	struct
	{ 
		unsigned int DB0            : 8;	/* Data Byte 0 of Message Object n */
		unsigned int DB1            : 8;	/* Data Byte 1 of Message Object n */
		unsigned int DB2            : 8;	/* Data Byte 2 of Message Object n */
		unsigned int DB3            : 8;	/* Data Byte 3 of Message Object n */
	} B;
	int I;
	unsigned int U;

} CAN_MODATAL0_type;
#define CAN_MODATAL0	(*( CAN_MODATAL0_type *) 0xf0019010u)	/* Message Object 0 Data Register Low */
#define CAN_MODATAL1	(*( CAN_MODATAL0_type *) 0xf0019030u)	/* Message Object 1 Data Register Low */
#define CAN_MODATAL10	(*( CAN_MODATAL0_type *) 0xf0019150u)	/* Message Object 10 Data Register Low */
#define CAN_MODATAL100	(*( CAN_MODATAL0_type *) 0xf0019c90u)	/* Message Object 100 Data Register Low */
#define CAN_MODATAL101	(*( CAN_MODATAL0_type *) 0xf0019cb0u)	/* Message Object 101 Data Register Low */
#define CAN_MODATAL102	(*( CAN_MODATAL0_type *) 0xf0019cd0u)	/* Message Object 102 Data Register Low */
#define CAN_MODATAL103	(*( CAN_MODATAL0_type *) 0xf0019cf0u)	/* Message Object 103 Data Register Low */
#define CAN_MODATAL104	(*( CAN_MODATAL0_type *) 0xf0019d10u)	/* Message Object 104 Data Register Low */
#define CAN_MODATAL105	(*( CAN_MODATAL0_type *) 0xf0019d30u)	/* Message Object 105 Data Register Low */
#define CAN_MODATAL106	(*( CAN_MODATAL0_type *) 0xf0019d50u)	/* Message Object 106 Data Register Low */
#define CAN_MODATAL107	(*( CAN_MODATAL0_type *) 0xf0019d70u)	/* Message Object 107 Data Register Low */
#define CAN_MODATAL108	(*( CAN_MODATAL0_type *) 0xf0019d90u)	/* Message Object 108 Data Register Low */
#define CAN_MODATAL109	(*( CAN_MODATAL0_type *) 0xf0019db0u)	/* Message Object 109 Data Register Low */
#define CAN_MODATAL11	(*( CAN_MODATAL0_type *) 0xf0019170u)	/* Message Object 11 Data Register Low */
#define CAN_MODATAL110	(*( CAN_MODATAL0_type *) 0xf0019dd0u)	/* Message Object 110 Data Register Low */
#define CAN_MODATAL111	(*( CAN_MODATAL0_type *) 0xf0019df0u)	/* Message Object 111 Data Register Low */
#define CAN_MODATAL112	(*( CAN_MODATAL0_type *) 0xf0019e10u)	/* Message Object 112 Data Register Low */
#define CAN_MODATAL113	(*( CAN_MODATAL0_type *) 0xf0019e30u)	/* Message Object 113 Data Register Low */
#define CAN_MODATAL114	(*( CAN_MODATAL0_type *) 0xf0019e50u)	/* Message Object 114 Data Register Low */
#define CAN_MODATAL115	(*( CAN_MODATAL0_type *) 0xf0019e70u)	/* Message Object 115 Data Register Low */
#define CAN_MODATAL116	(*( CAN_MODATAL0_type *) 0xf0019e90u)	/* Message Object 116 Data Register Low */
#define CAN_MODATAL117	(*( CAN_MODATAL0_type *) 0xf0019eb0u)	/* Message Object 117 Data Register Low */
#define CAN_MODATAL118	(*( CAN_MODATAL0_type *) 0xf0019ed0u)	/* Message Object 118 Data Register Low */
#define CAN_MODATAL119	(*( CAN_MODATAL0_type *) 0xf0019ef0u)	/* Message Object 119 Data Register Low */
#define CAN_MODATAL12	(*( CAN_MODATAL0_type *) 0xf0019190u)	/* Message Object 12 Data Register Low */
#define CAN_MODATAL120	(*( CAN_MODATAL0_type *) 0xf0019f10u)	/* Message Object 120 Data Register Low */
#define CAN_MODATAL121	(*( CAN_MODATAL0_type *) 0xf0019f30u)	/* Message Object 121 Data Register Low */
#define CAN_MODATAL122	(*( CAN_MODATAL0_type *) 0xf0019f50u)	/* Message Object 122 Data Register Low */
#define CAN_MODATAL123	(*( CAN_MODATAL0_type *) 0xf0019f70u)	/* Message Object 123 Data Register Low */
#define CAN_MODATAL124	(*( CAN_MODATAL0_type *) 0xf0019f90u)	/* Message Object 124 Data Register Low */
#define CAN_MODATAL125	(*( CAN_MODATAL0_type *) 0xf0019fb0u)	/* Message Object 125 Data Register Low */
#define CAN_MODATAL126	(*( CAN_MODATAL0_type *) 0xf0019fd0u)	/* Message Object 126 Data Register Low */
#define CAN_MODATAL127	(*( CAN_MODATAL0_type *) 0xf0019ff0u)	/* Message Object 127 Data Register Low */
#define CAN_MODATAL128	(*( CAN_MODATAL0_type *) 0xf001a010u)	/* Message Object 128 Data Register Low */
#define CAN_MODATAL129	(*( CAN_MODATAL0_type *) 0xf001a030u)	/* Message Object 129 Data Register Low */
#define CAN_MODATAL13	(*( CAN_MODATAL0_type *) 0xf00191b0u)	/* Message Object 13 Data Register Low */
#define CAN_MODATAL130	(*( CAN_MODATAL0_type *) 0xf001a050u)	/* Message Object 130 Data Register Low */
#define CAN_MODATAL131	(*( CAN_MODATAL0_type *) 0xf001a070u)	/* Message Object 131 Data Register Low */
#define CAN_MODATAL132	(*( CAN_MODATAL0_type *) 0xf001a090u)	/* Message Object 132 Data Register Low */
#define CAN_MODATAL133	(*( CAN_MODATAL0_type *) 0xf001a0b0u)	/* Message Object 133 Data Register Low */
#define CAN_MODATAL134	(*( CAN_MODATAL0_type *) 0xf001a0d0u)	/* Message Object 134 Data Register Low */
#define CAN_MODATAL135	(*( CAN_MODATAL0_type *) 0xf001a0f0u)	/* Message Object 135 Data Register Low */
#define CAN_MODATAL136	(*( CAN_MODATAL0_type *) 0xf001a110u)	/* Message Object 136 Data Register Low */
#define CAN_MODATAL137	(*( CAN_MODATAL0_type *) 0xf001a130u)	/* Message Object 137 Data Register Low */
#define CAN_MODATAL138	(*( CAN_MODATAL0_type *) 0xf001a150u)	/* Message Object 138 Data Register Low */
#define CAN_MODATAL139	(*( CAN_MODATAL0_type *) 0xf001a170u)	/* Message Object 139 Data Register Low */
#define CAN_MODATAL14	(*( CAN_MODATAL0_type *) 0xf00191d0u)	/* Message Object 14 Data Register Low */
#define CAN_MODATAL140	(*( CAN_MODATAL0_type *) 0xf001a190u)	/* Message Object 140 Data Register Low */
#define CAN_MODATAL141	(*( CAN_MODATAL0_type *) 0xf001a1b0u)	/* Message Object 141 Data Register Low */
#define CAN_MODATAL142	(*( CAN_MODATAL0_type *) 0xf001a1d0u)	/* Message Object 142 Data Register Low */
#define CAN_MODATAL143	(*( CAN_MODATAL0_type *) 0xf001a1f0u)	/* Message Object 143 Data Register Low */
#define CAN_MODATAL144	(*( CAN_MODATAL0_type *) 0xf001a210u)	/* Message Object 144 Data Register Low */
#define CAN_MODATAL145	(*( CAN_MODATAL0_type *) 0xf001a230u)	/* Message Object 145 Data Register Low */
#define CAN_MODATAL146	(*( CAN_MODATAL0_type *) 0xf001a250u)	/* Message Object 146 Data Register Low */
#define CAN_MODATAL147	(*( CAN_MODATAL0_type *) 0xf001a270u)	/* Message Object 147 Data Register Low */
#define CAN_MODATAL148	(*( CAN_MODATAL0_type *) 0xf001a290u)	/* Message Object 148 Data Register Low */
#define CAN_MODATAL149	(*( CAN_MODATAL0_type *) 0xf001a2b0u)	/* Message Object 149 Data Register Low */
#define CAN_MODATAL15	(*( CAN_MODATAL0_type *) 0xf00191f0u)	/* Message Object 15 Data Register Low */
#define CAN_MODATAL150	(*( CAN_MODATAL0_type *) 0xf001a2d0u)	/* Message Object 150 Data Register Low */
#define CAN_MODATAL151	(*( CAN_MODATAL0_type *) 0xf001a2f0u)	/* Message Object 151 Data Register Low */
#define CAN_MODATAL152	(*( CAN_MODATAL0_type *) 0xf001a310u)	/* Message Object 152 Data Register Low */
#define CAN_MODATAL153	(*( CAN_MODATAL0_type *) 0xf001a330u)	/* Message Object 153 Data Register Low */
#define CAN_MODATAL154	(*( CAN_MODATAL0_type *) 0xf001a350u)	/* Message Object 154 Data Register Low */
#define CAN_MODATAL155	(*( CAN_MODATAL0_type *) 0xf001a370u)	/* Message Object 155 Data Register Low */
#define CAN_MODATAL156	(*( CAN_MODATAL0_type *) 0xf001a390u)	/* Message Object 156 Data Register Low */
#define CAN_MODATAL157	(*( CAN_MODATAL0_type *) 0xf001a3b0u)	/* Message Object 157 Data Register Low */
#define CAN_MODATAL158	(*( CAN_MODATAL0_type *) 0xf001a3d0u)	/* Message Object 158 Data Register Low */
#define CAN_MODATAL159	(*( CAN_MODATAL0_type *) 0xf001a3f0u)	/* Message Object 159 Data Register Low */
#define CAN_MODATAL16	(*( CAN_MODATAL0_type *) 0xf0019210u)	/* Message Object 16 Data Register Low */
#define CAN_MODATAL160	(*( CAN_MODATAL0_type *) 0xf001a410u)	/* Message Object 160 Data Register Low */
#define CAN_MODATAL161	(*( CAN_MODATAL0_type *) 0xf001a430u)	/* Message Object 161 Data Register Low */
#define CAN_MODATAL162	(*( CAN_MODATAL0_type *) 0xf001a450u)	/* Message Object 162 Data Register Low */
#define CAN_MODATAL163	(*( CAN_MODATAL0_type *) 0xf001a470u)	/* Message Object 163 Data Register Low */
#define CAN_MODATAL164	(*( CAN_MODATAL0_type *) 0xf001a490u)	/* Message Object 164 Data Register Low */
#define CAN_MODATAL165	(*( CAN_MODATAL0_type *) 0xf001a4b0u)	/* Message Object 165 Data Register Low */
#define CAN_MODATAL166	(*( CAN_MODATAL0_type *) 0xf001a4d0u)	/* Message Object 166 Data Register Low */
#define CAN_MODATAL167	(*( CAN_MODATAL0_type *) 0xf001a4f0u)	/* Message Object 167 Data Register Low */
#define CAN_MODATAL168	(*( CAN_MODATAL0_type *) 0xf001a510u)	/* Message Object 168 Data Register Low */
#define CAN_MODATAL169	(*( CAN_MODATAL0_type *) 0xf001a530u)	/* Message Object 169 Data Register Low */
#define CAN_MODATAL17	(*( CAN_MODATAL0_type *) 0xf0019230u)	/* Message Object 17 Data Register Low */
#define CAN_MODATAL170	(*( CAN_MODATAL0_type *) 0xf001a550u)	/* Message Object 170 Data Register Low */
#define CAN_MODATAL171	(*( CAN_MODATAL0_type *) 0xf001a570u)	/* Message Object 171 Data Register Low */
#define CAN_MODATAL172	(*( CAN_MODATAL0_type *) 0xf001a590u)	/* Message Object 172 Data Register Low */
#define CAN_MODATAL173	(*( CAN_MODATAL0_type *) 0xf001a5b0u)	/* Message Object 173 Data Register Low */
#define CAN_MODATAL174	(*( CAN_MODATAL0_type *) 0xf001a5d0u)	/* Message Object 174 Data Register Low */
#define CAN_MODATAL175	(*( CAN_MODATAL0_type *) 0xf001a5f0u)	/* Message Object 175 Data Register Low */
#define CAN_MODATAL176	(*( CAN_MODATAL0_type *) 0xf001a610u)	/* Message Object 176 Data Register Low */
#define CAN_MODATAL177	(*( CAN_MODATAL0_type *) 0xf001a630u)	/* Message Object 177 Data Register Low */
#define CAN_MODATAL178	(*( CAN_MODATAL0_type *) 0xf001a650u)	/* Message Object 178 Data Register Low */
#define CAN_MODATAL179	(*( CAN_MODATAL0_type *) 0xf001a670u)	/* Message Object 179 Data Register Low */
#define CAN_MODATAL18	(*( CAN_MODATAL0_type *) 0xf0019250u)	/* Message Object 18 Data Register Low */
#define CAN_MODATAL180	(*( CAN_MODATAL0_type *) 0xf001a690u)	/* Message Object 180 Data Register Low */
#define CAN_MODATAL181	(*( CAN_MODATAL0_type *) 0xf001a6b0u)	/* Message Object 181 Data Register Low */
#define CAN_MODATAL182	(*( CAN_MODATAL0_type *) 0xf001a6d0u)	/* Message Object 182 Data Register Low */
#define CAN_MODATAL183	(*( CAN_MODATAL0_type *) 0xf001a6f0u)	/* Message Object 183 Data Register Low */
#define CAN_MODATAL184	(*( CAN_MODATAL0_type *) 0xf001a710u)	/* Message Object 184 Data Register Low */
#define CAN_MODATAL185	(*( CAN_MODATAL0_type *) 0xf001a730u)	/* Message Object 185 Data Register Low */
#define CAN_MODATAL186	(*( CAN_MODATAL0_type *) 0xf001a750u)	/* Message Object 186 Data Register Low */
#define CAN_MODATAL187	(*( CAN_MODATAL0_type *) 0xf001a770u)	/* Message Object 187 Data Register Low */
#define CAN_MODATAL188	(*( CAN_MODATAL0_type *) 0xf001a790u)	/* Message Object 188 Data Register Low */
#define CAN_MODATAL189	(*( CAN_MODATAL0_type *) 0xf001a7b0u)	/* Message Object 189 Data Register Low */
#define CAN_MODATAL19	(*( CAN_MODATAL0_type *) 0xf0019270u)	/* Message Object 19 Data Register Low */
#define CAN_MODATAL190	(*( CAN_MODATAL0_type *) 0xf001a7d0u)	/* Message Object 190 Data Register Low */
#define CAN_MODATAL191	(*( CAN_MODATAL0_type *) 0xf001a7f0u)	/* Message Object 191 Data Register Low */
#define CAN_MODATAL192	(*( CAN_MODATAL0_type *) 0xf001a810u)	/* Message Object 192 Data Register Low */
#define CAN_MODATAL193	(*( CAN_MODATAL0_type *) 0xf001a830u)	/* Message Object 193 Data Register Low */
#define CAN_MODATAL194	(*( CAN_MODATAL0_type *) 0xf001a850u)	/* Message Object 194 Data Register Low */
#define CAN_MODATAL195	(*( CAN_MODATAL0_type *) 0xf001a870u)	/* Message Object 195 Data Register Low */
#define CAN_MODATAL196	(*( CAN_MODATAL0_type *) 0xf001a890u)	/* Message Object 196 Data Register Low */
#define CAN_MODATAL197	(*( CAN_MODATAL0_type *) 0xf001a8b0u)	/* Message Object 197 Data Register Low */
#define CAN_MODATAL198	(*( CAN_MODATAL0_type *) 0xf001a8d0u)	/* Message Object 198 Data Register Low */
#define CAN_MODATAL199	(*( CAN_MODATAL0_type *) 0xf001a8f0u)	/* Message Object 199 Data Register Low */
#define CAN_MODATAL2	(*( CAN_MODATAL0_type *) 0xf0019050u)	/* Message Object 2 Data Register Low */
#define CAN_MODATAL20	(*( CAN_MODATAL0_type *) 0xf0019290u)	/* Message Object 20 Data Register Low */
#define CAN_MODATAL200	(*( CAN_MODATAL0_type *) 0xf001a910u)	/* Message Object 200 Data Register Low */
#define CAN_MODATAL201	(*( CAN_MODATAL0_type *) 0xf001a930u)	/* Message Object 201 Data Register Low */
#define CAN_MODATAL202	(*( CAN_MODATAL0_type *) 0xf001a950u)	/* Message Object 202 Data Register Low */
#define CAN_MODATAL203	(*( CAN_MODATAL0_type *) 0xf001a970u)	/* Message Object 203 Data Register Low */
#define CAN_MODATAL204	(*( CAN_MODATAL0_type *) 0xf001a990u)	/* Message Object 204 Data Register Low */
#define CAN_MODATAL205	(*( CAN_MODATAL0_type *) 0xf001a9b0u)	/* Message Object 205 Data Register Low */
#define CAN_MODATAL206	(*( CAN_MODATAL0_type *) 0xf001a9d0u)	/* Message Object 206 Data Register Low */
#define CAN_MODATAL207	(*( CAN_MODATAL0_type *) 0xf001a9f0u)	/* Message Object 207 Data Register Low */
#define CAN_MODATAL208	(*( CAN_MODATAL0_type *) 0xf001aa10u)	/* Message Object 208 Data Register Low */
#define CAN_MODATAL209	(*( CAN_MODATAL0_type *) 0xf001aa30u)	/* Message Object 209 Data Register Low */
#define CAN_MODATAL21	(*( CAN_MODATAL0_type *) 0xf00192b0u)	/* Message Object 21 Data Register Low */
#define CAN_MODATAL210	(*( CAN_MODATAL0_type *) 0xf001aa50u)	/* Message Object 210 Data Register Low */
#define CAN_MODATAL211	(*( CAN_MODATAL0_type *) 0xf001aa70u)	/* Message Object 211 Data Register Low */
#define CAN_MODATAL212	(*( CAN_MODATAL0_type *) 0xf001aa90u)	/* Message Object 212 Data Register Low */
#define CAN_MODATAL213	(*( CAN_MODATAL0_type *) 0xf001aab0u)	/* Message Object 213 Data Register Low */
#define CAN_MODATAL214	(*( CAN_MODATAL0_type *) 0xf001aad0u)	/* Message Object 214 Data Register Low */
#define CAN_MODATAL215	(*( CAN_MODATAL0_type *) 0xf001aaf0u)	/* Message Object 215 Data Register Low */
#define CAN_MODATAL216	(*( CAN_MODATAL0_type *) 0xf001ab10u)	/* Message Object 216 Data Register Low */
#define CAN_MODATAL217	(*( CAN_MODATAL0_type *) 0xf001ab30u)	/* Message Object 217 Data Register Low */
#define CAN_MODATAL218	(*( CAN_MODATAL0_type *) 0xf001ab50u)	/* Message Object 218 Data Register Low */
#define CAN_MODATAL219	(*( CAN_MODATAL0_type *) 0xf001ab70u)	/* Message Object 219 Data Register Low */
#define CAN_MODATAL22	(*( CAN_MODATAL0_type *) 0xf00192d0u)	/* Message Object 22 Data Register Low */
#define CAN_MODATAL220	(*( CAN_MODATAL0_type *) 0xf001ab90u)	/* Message Object 220 Data Register Low */
#define CAN_MODATAL221	(*( CAN_MODATAL0_type *) 0xf001abb0u)	/* Message Object 221 Data Register Low */
#define CAN_MODATAL222	(*( CAN_MODATAL0_type *) 0xf001abd0u)	/* Message Object 222 Data Register Low */
#define CAN_MODATAL223	(*( CAN_MODATAL0_type *) 0xf001abf0u)	/* Message Object 223 Data Register Low */
#define CAN_MODATAL224	(*( CAN_MODATAL0_type *) 0xf001ac10u)	/* Message Object 224 Data Register Low */
#define CAN_MODATAL225	(*( CAN_MODATAL0_type *) 0xf001ac30u)	/* Message Object 225 Data Register Low */
#define CAN_MODATAL226	(*( CAN_MODATAL0_type *) 0xf001ac50u)	/* Message Object 226 Data Register Low */
#define CAN_MODATAL227	(*( CAN_MODATAL0_type *) 0xf001ac70u)	/* Message Object 227 Data Register Low */
#define CAN_MODATAL228	(*( CAN_MODATAL0_type *) 0xf001ac90u)	/* Message Object 228 Data Register Low */
#define CAN_MODATAL229	(*( CAN_MODATAL0_type *) 0xf001acb0u)	/* Message Object 229 Data Register Low */
#define CAN_MODATAL23	(*( CAN_MODATAL0_type *) 0xf00192f0u)	/* Message Object 23 Data Register Low */
#define CAN_MODATAL230	(*( CAN_MODATAL0_type *) 0xf001acd0u)	/* Message Object 230 Data Register Low */
#define CAN_MODATAL231	(*( CAN_MODATAL0_type *) 0xf001acf0u)	/* Message Object 231 Data Register Low */
#define CAN_MODATAL232	(*( CAN_MODATAL0_type *) 0xf001ad10u)	/* Message Object 232 Data Register Low */
#define CAN_MODATAL233	(*( CAN_MODATAL0_type *) 0xf001ad30u)	/* Message Object 233 Data Register Low */
#define CAN_MODATAL234	(*( CAN_MODATAL0_type *) 0xf001ad50u)	/* Message Object 234 Data Register Low */
#define CAN_MODATAL235	(*( CAN_MODATAL0_type *) 0xf001ad70u)	/* Message Object 235 Data Register Low */
#define CAN_MODATAL236	(*( CAN_MODATAL0_type *) 0xf001ad90u)	/* Message Object 236 Data Register Low */
#define CAN_MODATAL237	(*( CAN_MODATAL0_type *) 0xf001adb0u)	/* Message Object 237 Data Register Low */
#define CAN_MODATAL238	(*( CAN_MODATAL0_type *) 0xf001add0u)	/* Message Object 238 Data Register Low */
#define CAN_MODATAL239	(*( CAN_MODATAL0_type *) 0xf001adf0u)	/* Message Object 239 Data Register Low */
#define CAN_MODATAL24	(*( CAN_MODATAL0_type *) 0xf0019310u)	/* Message Object 24 Data Register Low */
#define CAN_MODATAL240	(*( CAN_MODATAL0_type *) 0xf001ae10u)	/* Message Object 240 Data Register Low */
#define CAN_MODATAL241	(*( CAN_MODATAL0_type *) 0xf001ae30u)	/* Message Object 241 Data Register Low */
#define CAN_MODATAL242	(*( CAN_MODATAL0_type *) 0xf001ae50u)	/* Message Object 242 Data Register Low */
#define CAN_MODATAL243	(*( CAN_MODATAL0_type *) 0xf001ae70u)	/* Message Object 243 Data Register Low */
#define CAN_MODATAL244	(*( CAN_MODATAL0_type *) 0xf001ae90u)	/* Message Object 244 Data Register Low */
#define CAN_MODATAL245	(*( CAN_MODATAL0_type *) 0xf001aeb0u)	/* Message Object 245 Data Register Low */
#define CAN_MODATAL246	(*( CAN_MODATAL0_type *) 0xf001aed0u)	/* Message Object 246 Data Register Low */
#define CAN_MODATAL247	(*( CAN_MODATAL0_type *) 0xf001aef0u)	/* Message Object 247 Data Register Low */
#define CAN_MODATAL248	(*( CAN_MODATAL0_type *) 0xf001af10u)	/* Message Object 248 Data Register Low */
#define CAN_MODATAL249	(*( CAN_MODATAL0_type *) 0xf001af30u)	/* Message Object 249 Data Register Low */
#define CAN_MODATAL25	(*( CAN_MODATAL0_type *) 0xf0019330u)	/* Message Object 25 Data Register Low */
#define CAN_MODATAL250	(*( CAN_MODATAL0_type *) 0xf001af50u)	/* Message Object 250 Data Register Low */
#define CAN_MODATAL251	(*( CAN_MODATAL0_type *) 0xf001af70u)	/* Message Object 251 Data Register Low */
#define CAN_MODATAL252	(*( CAN_MODATAL0_type *) 0xf001af90u)	/* Message Object 252 Data Register Low */
#define CAN_MODATAL253	(*( CAN_MODATAL0_type *) 0xf001afb0u)	/* Message Object 253 Data Register Low */
#define CAN_MODATAL254	(*( CAN_MODATAL0_type *) 0xf001afd0u)	/* Message Object 254 Data Register Low */
#define CAN_MODATAL255	(*( CAN_MODATAL0_type *) 0xf001aff0u)	/* Message Object 255 Data Register Low */
#define CAN_MODATAL26	(*( CAN_MODATAL0_type *) 0xf0019350u)	/* Message Object 26 Data Register Low */
#define CAN_MODATAL27	(*( CAN_MODATAL0_type *) 0xf0019370u)	/* Message Object 27 Data Register Low */
#define CAN_MODATAL28	(*( CAN_MODATAL0_type *) 0xf0019390u)	/* Message Object 28 Data Register Low */
#define CAN_MODATAL29	(*( CAN_MODATAL0_type *) 0xf00193b0u)	/* Message Object 29 Data Register Low */
#define CAN_MODATAL3	(*( CAN_MODATAL0_type *) 0xf0019070u)	/* Message Object 3 Data Register Low */
#define CAN_MODATAL30	(*( CAN_MODATAL0_type *) 0xf00193d0u)	/* Message Object 30 Data Register Low */
#define CAN_MODATAL31	(*( CAN_MODATAL0_type *) 0xf00193f0u)	/* Message Object 31 Data Register Low */
#define CAN_MODATAL32	(*( CAN_MODATAL0_type *) 0xf0019410u)	/* Message Object 32 Data Register Low */
#define CAN_MODATAL33	(*( CAN_MODATAL0_type *) 0xf0019430u)	/* Message Object 33 Data Register Low */
#define CAN_MODATAL34	(*( CAN_MODATAL0_type *) 0xf0019450u)	/* Message Object 34 Data Register Low */
#define CAN_MODATAL35	(*( CAN_MODATAL0_type *) 0xf0019470u)	/* Message Object 35 Data Register Low */
#define CAN_MODATAL36	(*( CAN_MODATAL0_type *) 0xf0019490u)	/* Message Object 36 Data Register Low */
#define CAN_MODATAL37	(*( CAN_MODATAL0_type *) 0xf00194b0u)	/* Message Object 37 Data Register Low */
#define CAN_MODATAL38	(*( CAN_MODATAL0_type *) 0xf00194d0u)	/* Message Object 38 Data Register Low */
#define CAN_MODATAL39	(*( CAN_MODATAL0_type *) 0xf00194f0u)	/* Message Object 39 Data Register Low */
#define CAN_MODATAL4	(*( CAN_MODATAL0_type *) 0xf0019090u)	/* Message Object 4 Data Register Low */
#define CAN_MODATAL40	(*( CAN_MODATAL0_type *) 0xf0019510u)	/* Message Object 40 Data Register Low */
#define CAN_MODATAL41	(*( CAN_MODATAL0_type *) 0xf0019530u)	/* Message Object 41 Data Register Low */
#define CAN_MODATAL42	(*( CAN_MODATAL0_type *) 0xf0019550u)	/* Message Object 42 Data Register Low */
#define CAN_MODATAL43	(*( CAN_MODATAL0_type *) 0xf0019570u)	/* Message Object 43 Data Register Low */
#define CAN_MODATAL44	(*( CAN_MODATAL0_type *) 0xf0019590u)	/* Message Object 44 Data Register Low */
#define CAN_MODATAL45	(*( CAN_MODATAL0_type *) 0xf00195b0u)	/* Message Object 45 Data Register Low */
#define CAN_MODATAL46	(*( CAN_MODATAL0_type *) 0xf00195d0u)	/* Message Object 46 Data Register Low */
#define CAN_MODATAL47	(*( CAN_MODATAL0_type *) 0xf00195f0u)	/* Message Object 47 Data Register Low */
#define CAN_MODATAL48	(*( CAN_MODATAL0_type *) 0xf0019610u)	/* Message Object 48 Data Register Low */
#define CAN_MODATAL49	(*( CAN_MODATAL0_type *) 0xf0019630u)	/* Message Object 49 Data Register Low */
#define CAN_MODATAL5	(*( CAN_MODATAL0_type *) 0xf00190b0u)	/* Message Object 5 Data Register Low */
#define CAN_MODATAL50	(*( CAN_MODATAL0_type *) 0xf0019650u)	/* Message Object 50 Data Register Low */
#define CAN_MODATAL51	(*( CAN_MODATAL0_type *) 0xf0019670u)	/* Message Object 51 Data Register Low */
#define CAN_MODATAL52	(*( CAN_MODATAL0_type *) 0xf0019690u)	/* Message Object 52 Data Register Low */
#define CAN_MODATAL53	(*( CAN_MODATAL0_type *) 0xf00196b0u)	/* Message Object 53 Data Register Low */
#define CAN_MODATAL54	(*( CAN_MODATAL0_type *) 0xf00196d0u)	/* Message Object 54 Data Register Low */
#define CAN_MODATAL55	(*( CAN_MODATAL0_type *) 0xf00196f0u)	/* Message Object 55 Data Register Low */
#define CAN_MODATAL56	(*( CAN_MODATAL0_type *) 0xf0019710u)	/* Message Object 56 Data Register Low */
#define CAN_MODATAL57	(*( CAN_MODATAL0_type *) 0xf0019730u)	/* Message Object 57 Data Register Low */
#define CAN_MODATAL58	(*( CAN_MODATAL0_type *) 0xf0019750u)	/* Message Object 58 Data Register Low */
#define CAN_MODATAL59	(*( CAN_MODATAL0_type *) 0xf0019770u)	/* Message Object 59 Data Register Low */
#define CAN_MODATAL6	(*( CAN_MODATAL0_type *) 0xf00190d0u)	/* Message Object 6 Data Register Low */
#define CAN_MODATAL60	(*( CAN_MODATAL0_type *) 0xf0019790u)	/* Message Object 60 Data Register Low */
#define CAN_MODATAL61	(*( CAN_MODATAL0_type *) 0xf00197b0u)	/* Message Object 61 Data Register Low */
#define CAN_MODATAL62	(*( CAN_MODATAL0_type *) 0xf00197d0u)	/* Message Object 62 Data Register Low */
#define CAN_MODATAL63	(*( CAN_MODATAL0_type *) 0xf00197f0u)	/* Message Object 63 Data Register Low */
#define CAN_MODATAL64	(*( CAN_MODATAL0_type *) 0xf0019810u)	/* Message Object 64 Data Register Low */
#define CAN_MODATAL65	(*( CAN_MODATAL0_type *) 0xf0019830u)	/* Message Object 65 Data Register Low */
#define CAN_MODATAL66	(*( CAN_MODATAL0_type *) 0xf0019850u)	/* Message Object 66 Data Register Low */
#define CAN_MODATAL67	(*( CAN_MODATAL0_type *) 0xf0019870u)	/* Message Object 67 Data Register Low */
#define CAN_MODATAL68	(*( CAN_MODATAL0_type *) 0xf0019890u)	/* Message Object 68 Data Register Low */
#define CAN_MODATAL69	(*( CAN_MODATAL0_type *) 0xf00198b0u)	/* Message Object 69 Data Register Low */
#define CAN_MODATAL7	(*( CAN_MODATAL0_type *) 0xf00190f0u)	/* Message Object 7 Data Register Low */
#define CAN_MODATAL70	(*( CAN_MODATAL0_type *) 0xf00198d0u)	/* Message Object 70 Data Register Low */
#define CAN_MODATAL71	(*( CAN_MODATAL0_type *) 0xf00198f0u)	/* Message Object 71 Data Register Low */
#define CAN_MODATAL72	(*( CAN_MODATAL0_type *) 0xf0019910u)	/* Message Object 72 Data Register Low */
#define CAN_MODATAL73	(*( CAN_MODATAL0_type *) 0xf0019930u)	/* Message Object 73 Data Register Low */
#define CAN_MODATAL74	(*( CAN_MODATAL0_type *) 0xf0019950u)	/* Message Object 74 Data Register Low */
#define CAN_MODATAL75	(*( CAN_MODATAL0_type *) 0xf0019970u)	/* Message Object 75 Data Register Low */
#define CAN_MODATAL76	(*( CAN_MODATAL0_type *) 0xf0019990u)	/* Message Object 76 Data Register Low */
#define CAN_MODATAL77	(*( CAN_MODATAL0_type *) 0xf00199b0u)	/* Message Object 77 Data Register Low */
#define CAN_MODATAL78	(*( CAN_MODATAL0_type *) 0xf00199d0u)	/* Message Object 78 Data Register Low */
#define CAN_MODATAL79	(*( CAN_MODATAL0_type *) 0xf00199f0u)	/* Message Object 79 Data Register Low */
#define CAN_MODATAL8	(*( CAN_MODATAL0_type *) 0xf0019110u)	/* Message Object 8 Data Register Low */
#define CAN_MODATAL80	(*( CAN_MODATAL0_type *) 0xf0019a10u)	/* Message Object 80 Data Register Low */
#define CAN_MODATAL81	(*( CAN_MODATAL0_type *) 0xf0019a30u)	/* Message Object 81 Data Register Low */
#define CAN_MODATAL82	(*( CAN_MODATAL0_type *) 0xf0019a50u)	/* Message Object 82 Data Register Low */
#define CAN_MODATAL83	(*( CAN_MODATAL0_type *) 0xf0019a70u)	/* Message Object 83 Data Register Low */
#define CAN_MODATAL84	(*( CAN_MODATAL0_type *) 0xf0019a90u)	/* Message Object 84 Data Register Low */
#define CAN_MODATAL85	(*( CAN_MODATAL0_type *) 0xf0019ab0u)	/* Message Object 85 Data Register Low */
#define CAN_MODATAL86	(*( CAN_MODATAL0_type *) 0xf0019ad0u)	/* Message Object 86 Data Register Low */
#define CAN_MODATAL87	(*( CAN_MODATAL0_type *) 0xf0019af0u)	/* Message Object 87 Data Register Low */
#define CAN_MODATAL88	(*( CAN_MODATAL0_type *) 0xf0019b10u)	/* Message Object 88 Data Register Low */
#define CAN_MODATAL89	(*( CAN_MODATAL0_type *) 0xf0019b30u)	/* Message Object 89 Data Register Low */
#define CAN_MODATAL9	(*( CAN_MODATAL0_type *) 0xf0019130u)	/* Message Object 9 Data Register Low */
#define CAN_MODATAL90	(*( CAN_MODATAL0_type *) 0xf0019b50u)	/* Message Object 90 Data Register Low */
#define CAN_MODATAL91	(*( CAN_MODATAL0_type *) 0xf0019b70u)	/* Message Object 91 Data Register Low */
#define CAN_MODATAL92	(*( CAN_MODATAL0_type *) 0xf0019b90u)	/* Message Object 92 Data Register Low */
#define CAN_MODATAL93	(*( CAN_MODATAL0_type *) 0xf0019bb0u)	/* Message Object 93 Data Register Low */
#define CAN_MODATAL94	(*( CAN_MODATAL0_type *) 0xf0019bd0u)	/* Message Object 94 Data Register Low */
#define CAN_MODATAL95	(*( CAN_MODATAL0_type *) 0xf0019bf0u)	/* Message Object 95 Data Register Low */
#define CAN_MODATAL96	(*( CAN_MODATAL0_type *) 0xf0019c10u)	/* Message Object 96 Data Register Low */
#define CAN_MODATAL97	(*( CAN_MODATAL0_type *) 0xf0019c30u)	/* Message Object 97 Data Register Low */
#define CAN_MODATAL98	(*( CAN_MODATAL0_type *) 0xf0019c50u)	/* Message Object 98 Data Register Low */
#define CAN_MODATAL99	(*( CAN_MODATAL0_type *) 0xf0019c70u)	/* Message Object 99 Data Register Low */

typedef volatile union
{
	struct
	{ 
		unsigned int MMC            : 4;	/* Message Mode Control */
		unsigned int RXTOE          : 1;	/* Receive Time-Out Enable */
		unsigned int                : 3;
		unsigned int GDFS           : 1;	/* Gateway Data Frame Send */
		unsigned int IDC            : 1;	/* Identifier Copy */
		unsigned int DLCC           : 1;	/* Data Length Code Copy */
		unsigned int DATC           : 1;	/* Data Copy */
		unsigned int                : 4;
		unsigned int RXIE           : 1;	/* Receive Interrupt Enable */
		unsigned int TXIE           : 1;	/* Transmit Interrupt Enable */
		unsigned int OVIE           : 1;	/* Overflow Interrupt Enable */
		unsigned int                : 1;
		unsigned int FRREN          : 1;	/* Foreign Remote Request Enable */
		unsigned int RMM            : 1;	/* Transmit Object Remote Monitoring */
		unsigned int SDT            : 1;	/* Single Data Transfer */
		unsigned int STT            : 1;	/* Single Transmit Trial */
		unsigned int DLC            : 4;	/* Data Length Code */
		unsigned int MSC            : 4;	/* Message Status Count (TTCAN only) */
	} B;
	int I;
	unsigned int U;

} CAN_MOFCR0_type;
#define CAN_MOFCR0	(*( CAN_MOFCR0_type *) 0xf0019000u)	/* Message Object 0 Function Control Register */
#define CAN_MOFCR1	(*( CAN_MOFCR0_type *) 0xf0019020u)	/* Message Object 1 Function Control Register */
#define CAN_MOFCR10	(*( CAN_MOFCR0_type *) 0xf0019140u)	/* Message Object 10 Function Control Register */
#define CAN_MOFCR100	(*( CAN_MOFCR0_type *) 0xf0019c80u)	/* Message Object 100 Function Control Register */
#define CAN_MOFCR101	(*( CAN_MOFCR0_type *) 0xf0019ca0u)	/* Message Object 101 Function Control Register */
#define CAN_MOFCR102	(*( CAN_MOFCR0_type *) 0xf0019cc0u)	/* Message Object 102 Function Control Register */
#define CAN_MOFCR103	(*( CAN_MOFCR0_type *) 0xf0019ce0u)	/* Message Object 103 Function Control Register */
#define CAN_MOFCR104	(*( CAN_MOFCR0_type *) 0xf0019d00u)	/* Message Object 104 Function Control Register */
#define CAN_MOFCR105	(*( CAN_MOFCR0_type *) 0xf0019d20u)	/* Message Object 105 Function Control Register */
#define CAN_MOFCR106	(*( CAN_MOFCR0_type *) 0xf0019d40u)	/* Message Object 106 Function Control Register */
#define CAN_MOFCR107	(*( CAN_MOFCR0_type *) 0xf0019d60u)	/* Message Object 107 Function Control Register */
#define CAN_MOFCR108	(*( CAN_MOFCR0_type *) 0xf0019d80u)	/* Message Object 108 Function Control Register */
#define CAN_MOFCR109	(*( CAN_MOFCR0_type *) 0xf0019da0u)	/* Message Object 109 Function Control Register */
#define CAN_MOFCR11	(*( CAN_MOFCR0_type *) 0xf0019160u)	/* Message Object 11 Function Control Register */
#define CAN_MOFCR110	(*( CAN_MOFCR0_type *) 0xf0019dc0u)	/* Message Object 110 Function Control Register */
#define CAN_MOFCR111	(*( CAN_MOFCR0_type *) 0xf0019de0u)	/* Message Object 111 Function Control Register */
#define CAN_MOFCR112	(*( CAN_MOFCR0_type *) 0xf0019e00u)	/* Message Object 112 Function Control Register */
#define CAN_MOFCR113	(*( CAN_MOFCR0_type *) 0xf0019e20u)	/* Message Object 113 Function Control Register */
#define CAN_MOFCR114	(*( CAN_MOFCR0_type *) 0xf0019e40u)	/* Message Object 114 Function Control Register */
#define CAN_MOFCR115	(*( CAN_MOFCR0_type *) 0xf0019e60u)	/* Message Object 115 Function Control Register */
#define CAN_MOFCR116	(*( CAN_MOFCR0_type *) 0xf0019e80u)	/* Message Object 116 Function Control Register */
#define CAN_MOFCR117	(*( CAN_MOFCR0_type *) 0xf0019ea0u)	/* Message Object 117 Function Control Register */
#define CAN_MOFCR118	(*( CAN_MOFCR0_type *) 0xf0019ec0u)	/* Message Object 118 Function Control Register */
#define CAN_MOFCR119	(*( CAN_MOFCR0_type *) 0xf0019ee0u)	/* Message Object 119 Function Control Register */
#define CAN_MOFCR12	(*( CAN_MOFCR0_type *) 0xf0019180u)	/* Message Object 12 Function Control Register */
#define CAN_MOFCR120	(*( CAN_MOFCR0_type *) 0xf0019f00u)	/* Message Object 120 Function Control Register */
#define CAN_MOFCR121	(*( CAN_MOFCR0_type *) 0xf0019f20u)	/* Message Object 121 Function Control Register */
#define CAN_MOFCR122	(*( CAN_MOFCR0_type *) 0xf0019f40u)	/* Message Object 122 Function Control Register */
#define CAN_MOFCR123	(*( CAN_MOFCR0_type *) 0xf0019f60u)	/* Message Object 123 Function Control Register */
#define CAN_MOFCR124	(*( CAN_MOFCR0_type *) 0xf0019f80u)	/* Message Object 124 Function Control Register */
#define CAN_MOFCR125	(*( CAN_MOFCR0_type *) 0xf0019fa0u)	/* Message Object 125 Function Control Register */
#define CAN_MOFCR126	(*( CAN_MOFCR0_type *) 0xf0019fc0u)	/* Message Object 126 Function Control Register */
#define CAN_MOFCR127	(*( CAN_MOFCR0_type *) 0xf0019fe0u)	/* Message Object 127 Function Control Register */
#define CAN_MOFCR128	(*( CAN_MOFCR0_type *) 0xf001a000u)	/* Message Object 128 Function Control Register */
#define CAN_MOFCR129	(*( CAN_MOFCR0_type *) 0xf001a020u)	/* Message Object 129 Function Control Register */
#define CAN_MOFCR13	(*( CAN_MOFCR0_type *) 0xf00191a0u)	/* Message Object 13 Function Control Register */
#define CAN_MOFCR130	(*( CAN_MOFCR0_type *) 0xf001a040u)	/* Message Object 130 Function Control Register */
#define CAN_MOFCR131	(*( CAN_MOFCR0_type *) 0xf001a060u)	/* Message Object 131 Function Control Register */
#define CAN_MOFCR132	(*( CAN_MOFCR0_type *) 0xf001a080u)	/* Message Object 132 Function Control Register */
#define CAN_MOFCR133	(*( CAN_MOFCR0_type *) 0xf001a0a0u)	/* Message Object 133 Function Control Register */
#define CAN_MOFCR134	(*( CAN_MOFCR0_type *) 0xf001a0c0u)	/* Message Object 134 Function Control Register */
#define CAN_MOFCR135	(*( CAN_MOFCR0_type *) 0xf001a0e0u)	/* Message Object 135 Function Control Register */
#define CAN_MOFCR136	(*( CAN_MOFCR0_type *) 0xf001a100u)	/* Message Object 136 Function Control Register */
#define CAN_MOFCR137	(*( CAN_MOFCR0_type *) 0xf001a120u)	/* Message Object 137 Function Control Register */
#define CAN_MOFCR138	(*( CAN_MOFCR0_type *) 0xf001a140u)	/* Message Object 138 Function Control Register */
#define CAN_MOFCR139	(*( CAN_MOFCR0_type *) 0xf001a160u)	/* Message Object 139 Function Control Register */
#define CAN_MOFCR14	(*( CAN_MOFCR0_type *) 0xf00191c0u)	/* Message Object 14 Function Control Register */
#define CAN_MOFCR140	(*( CAN_MOFCR0_type *) 0xf001a180u)	/* Message Object 140 Function Control Register */
#define CAN_MOFCR141	(*( CAN_MOFCR0_type *) 0xf001a1a0u)	/* Message Object 141 Function Control Register */
#define CAN_MOFCR142	(*( CAN_MOFCR0_type *) 0xf001a1c0u)	/* Message Object 142 Function Control Register */
#define CAN_MOFCR143	(*( CAN_MOFCR0_type *) 0xf001a1e0u)	/* Message Object 143 Function Control Register */
#define CAN_MOFCR144	(*( CAN_MOFCR0_type *) 0xf001a200u)	/* Message Object 144 Function Control Register */
#define CAN_MOFCR145	(*( CAN_MOFCR0_type *) 0xf001a220u)	/* Message Object 145 Function Control Register */
#define CAN_MOFCR146	(*( CAN_MOFCR0_type *) 0xf001a240u)	/* Message Object 146 Function Control Register */
#define CAN_MOFCR147	(*( CAN_MOFCR0_type *) 0xf001a260u)	/* Message Object 147 Function Control Register */
#define CAN_MOFCR148	(*( CAN_MOFCR0_type *) 0xf001a280u)	/* Message Object 148 Function Control Register */
#define CAN_MOFCR149	(*( CAN_MOFCR0_type *) 0xf001a2a0u)	/* Message Object 149 Function Control Register */
#define CAN_MOFCR15	(*( CAN_MOFCR0_type *) 0xf00191e0u)	/* Message Object 15 Function Control Register */
#define CAN_MOFCR150	(*( CAN_MOFCR0_type *) 0xf001a2c0u)	/* Message Object 150 Function Control Register */
#define CAN_MOFCR151	(*( CAN_MOFCR0_type *) 0xf001a2e0u)	/* Message Object 151 Function Control Register */
#define CAN_MOFCR152	(*( CAN_MOFCR0_type *) 0xf001a300u)	/* Message Object 152 Function Control Register */
#define CAN_MOFCR153	(*( CAN_MOFCR0_type *) 0xf001a320u)	/* Message Object 153 Function Control Register */
#define CAN_MOFCR154	(*( CAN_MOFCR0_type *) 0xf001a340u)	/* Message Object 154 Function Control Register */
#define CAN_MOFCR155	(*( CAN_MOFCR0_type *) 0xf001a360u)	/* Message Object 155 Function Control Register */
#define CAN_MOFCR156	(*( CAN_MOFCR0_type *) 0xf001a380u)	/* Message Object 156 Function Control Register */
#define CAN_MOFCR157	(*( CAN_MOFCR0_type *) 0xf001a3a0u)	/* Message Object 157 Function Control Register */
#define CAN_MOFCR158	(*( CAN_MOFCR0_type *) 0xf001a3c0u)	/* Message Object 158 Function Control Register */
#define CAN_MOFCR159	(*( CAN_MOFCR0_type *) 0xf001a3e0u)	/* Message Object 159 Function Control Register */
#define CAN_MOFCR16	(*( CAN_MOFCR0_type *) 0xf0019200u)	/* Message Object 16 Function Control Register */
#define CAN_MOFCR160	(*( CAN_MOFCR0_type *) 0xf001a400u)	/* Message Object 160 Function Control Register */
#define CAN_MOFCR161	(*( CAN_MOFCR0_type *) 0xf001a420u)	/* Message Object 161 Function Control Register */
#define CAN_MOFCR162	(*( CAN_MOFCR0_type *) 0xf001a440u)	/* Message Object 162 Function Control Register */
#define CAN_MOFCR163	(*( CAN_MOFCR0_type *) 0xf001a460u)	/* Message Object 163 Function Control Register */
#define CAN_MOFCR164	(*( CAN_MOFCR0_type *) 0xf001a480u)	/* Message Object 164 Function Control Register */
#define CAN_MOFCR165	(*( CAN_MOFCR0_type *) 0xf001a4a0u)	/* Message Object 165 Function Control Register */
#define CAN_MOFCR166	(*( CAN_MOFCR0_type *) 0xf001a4c0u)	/* Message Object 166 Function Control Register */
#define CAN_MOFCR167	(*( CAN_MOFCR0_type *) 0xf001a4e0u)	/* Message Object 167 Function Control Register */
#define CAN_MOFCR168	(*( CAN_MOFCR0_type *) 0xf001a500u)	/* Message Object 168 Function Control Register */
#define CAN_MOFCR169	(*( CAN_MOFCR0_type *) 0xf001a520u)	/* Message Object 169 Function Control Register */
#define CAN_MOFCR17	(*( CAN_MOFCR0_type *) 0xf0019220u)	/* Message Object 17 Function Control Register */
#define CAN_MOFCR170	(*( CAN_MOFCR0_type *) 0xf001a540u)	/* Message Object 170 Function Control Register */
#define CAN_MOFCR171	(*( CAN_MOFCR0_type *) 0xf001a560u)	/* Message Object 171 Function Control Register */
#define CAN_MOFCR172	(*( CAN_MOFCR0_type *) 0xf001a580u)	/* Message Object 172 Function Control Register */
#define CAN_MOFCR173	(*( CAN_MOFCR0_type *) 0xf001a5a0u)	/* Message Object 173 Function Control Register */
#define CAN_MOFCR174	(*( CAN_MOFCR0_type *) 0xf001a5c0u)	/* Message Object 174 Function Control Register */
#define CAN_MOFCR175	(*( CAN_MOFCR0_type *) 0xf001a5e0u)	/* Message Object 175 Function Control Register */
#define CAN_MOFCR176	(*( CAN_MOFCR0_type *) 0xf001a600u)	/* Message Object 176 Function Control Register */
#define CAN_MOFCR177	(*( CAN_MOFCR0_type *) 0xf001a620u)	/* Message Object 177 Function Control Register */
#define CAN_MOFCR178	(*( CAN_MOFCR0_type *) 0xf001a640u)	/* Message Object 178 Function Control Register */
#define CAN_MOFCR179	(*( CAN_MOFCR0_type *) 0xf001a660u)	/* Message Object 179 Function Control Register */
#define CAN_MOFCR18	(*( CAN_MOFCR0_type *) 0xf0019240u)	/* Message Object 18 Function Control Register */
#define CAN_MOFCR180	(*( CAN_MOFCR0_type *) 0xf001a680u)	/* Message Object 180 Function Control Register */
#define CAN_MOFCR181	(*( CAN_MOFCR0_type *) 0xf001a6a0u)	/* Message Object 181 Function Control Register */
#define CAN_MOFCR182	(*( CAN_MOFCR0_type *) 0xf001a6c0u)	/* Message Object 182 Function Control Register */
#define CAN_MOFCR183	(*( CAN_MOFCR0_type *) 0xf001a6e0u)	/* Message Object 183 Function Control Register */
#define CAN_MOFCR184	(*( CAN_MOFCR0_type *) 0xf001a700u)	/* Message Object 184 Function Control Register */
#define CAN_MOFCR185	(*( CAN_MOFCR0_type *) 0xf001a720u)	/* Message Object 185 Function Control Register */
#define CAN_MOFCR186	(*( CAN_MOFCR0_type *) 0xf001a740u)	/* Message Object 186 Function Control Register */
#define CAN_MOFCR187	(*( CAN_MOFCR0_type *) 0xf001a760u)	/* Message Object 187 Function Control Register */
#define CAN_MOFCR188	(*( CAN_MOFCR0_type *) 0xf001a780u)	/* Message Object 188 Function Control Register */
#define CAN_MOFCR189	(*( CAN_MOFCR0_type *) 0xf001a7a0u)	/* Message Object 189 Function Control Register */
#define CAN_MOFCR19	(*( CAN_MOFCR0_type *) 0xf0019260u)	/* Message Object 19 Function Control Register */
#define CAN_MOFCR190	(*( CAN_MOFCR0_type *) 0xf001a7c0u)	/* Message Object 190 Function Control Register */
#define CAN_MOFCR191	(*( CAN_MOFCR0_type *) 0xf001a7e0u)	/* Message Object 191 Function Control Register */
#define CAN_MOFCR192	(*( CAN_MOFCR0_type *) 0xf001a800u)	/* Message Object 192 Function Control Register */
#define CAN_MOFCR193	(*( CAN_MOFCR0_type *) 0xf001a820u)	/* Message Object 193 Function Control Register */
#define CAN_MOFCR194	(*( CAN_MOFCR0_type *) 0xf001a840u)	/* Message Object 194 Function Control Register */
#define CAN_MOFCR195	(*( CAN_MOFCR0_type *) 0xf001a860u)	/* Message Object 195 Function Control Register */
#define CAN_MOFCR196	(*( CAN_MOFCR0_type *) 0xf001a880u)	/* Message Object 196 Function Control Register */
#define CAN_MOFCR197	(*( CAN_MOFCR0_type *) 0xf001a8a0u)	/* Message Object 197 Function Control Register */
#define CAN_MOFCR198	(*( CAN_MOFCR0_type *) 0xf001a8c0u)	/* Message Object 198 Function Control Register */
#define CAN_MOFCR199	(*( CAN_MOFCR0_type *) 0xf001a8e0u)	/* Message Object 199 Function Control Register */
#define CAN_MOFCR2	(*( CAN_MOFCR0_type *) 0xf0019040u)	/* Message Object 2 Function Control Register */
#define CAN_MOFCR20	(*( CAN_MOFCR0_type *) 0xf0019280u)	/* Message Object 20 Function Control Register */
#define CAN_MOFCR200	(*( CAN_MOFCR0_type *) 0xf001a900u)	/* Message Object 200 Function Control Register */
#define CAN_MOFCR201	(*( CAN_MOFCR0_type *) 0xf001a920u)	/* Message Object 201 Function Control Register */
#define CAN_MOFCR202	(*( CAN_MOFCR0_type *) 0xf001a940u)	/* Message Object 202 Function Control Register */
#define CAN_MOFCR203	(*( CAN_MOFCR0_type *) 0xf001a960u)	/* Message Object 203 Function Control Register */
#define CAN_MOFCR204	(*( CAN_MOFCR0_type *) 0xf001a980u)	/* Message Object 204 Function Control Register */
#define CAN_MOFCR205	(*( CAN_MOFCR0_type *) 0xf001a9a0u)	/* Message Object 205 Function Control Register */
#define CAN_MOFCR206	(*( CAN_MOFCR0_type *) 0xf001a9c0u)	/* Message Object 206 Function Control Register */
#define CAN_MOFCR207	(*( CAN_MOFCR0_type *) 0xf001a9e0u)	/* Message Object 207 Function Control Register */
#define CAN_MOFCR208	(*( CAN_MOFCR0_type *) 0xf001aa00u)	/* Message Object 208 Function Control Register */
#define CAN_MOFCR209	(*( CAN_MOFCR0_type *) 0xf001aa20u)	/* Message Object 209 Function Control Register */
#define CAN_MOFCR21	(*( CAN_MOFCR0_type *) 0xf00192a0u)	/* Message Object 21 Function Control Register */
#define CAN_MOFCR210	(*( CAN_MOFCR0_type *) 0xf001aa40u)	/* Message Object 210 Function Control Register */
#define CAN_MOFCR211	(*( CAN_MOFCR0_type *) 0xf001aa60u)	/* Message Object 211 Function Control Register */
#define CAN_MOFCR212	(*( CAN_MOFCR0_type *) 0xf001aa80u)	/* Message Object 212 Function Control Register */
#define CAN_MOFCR213	(*( CAN_MOFCR0_type *) 0xf001aaa0u)	/* Message Object 213 Function Control Register */
#define CAN_MOFCR214	(*( CAN_MOFCR0_type *) 0xf001aac0u)	/* Message Object 214 Function Control Register */
#define CAN_MOFCR215	(*( CAN_MOFCR0_type *) 0xf001aae0u)	/* Message Object 215 Function Control Register */
#define CAN_MOFCR216	(*( CAN_MOFCR0_type *) 0xf001ab00u)	/* Message Object 216 Function Control Register */
#define CAN_MOFCR217	(*( CAN_MOFCR0_type *) 0xf001ab20u)	/* Message Object 217 Function Control Register */
#define CAN_MOFCR218	(*( CAN_MOFCR0_type *) 0xf001ab40u)	/* Message Object 218 Function Control Register */
#define CAN_MOFCR219	(*( CAN_MOFCR0_type *) 0xf001ab60u)	/* Message Object 219 Function Control Register */
#define CAN_MOFCR22	(*( CAN_MOFCR0_type *) 0xf00192c0u)	/* Message Object 22 Function Control Register */
#define CAN_MOFCR220	(*( CAN_MOFCR0_type *) 0xf001ab80u)	/* Message Object 220 Function Control Register */
#define CAN_MOFCR221	(*( CAN_MOFCR0_type *) 0xf001aba0u)	/* Message Object 221 Function Control Register */
#define CAN_MOFCR222	(*( CAN_MOFCR0_type *) 0xf001abc0u)	/* Message Object 222 Function Control Register */
#define CAN_MOFCR223	(*( CAN_MOFCR0_type *) 0xf001abe0u)	/* Message Object 223 Function Control Register */
#define CAN_MOFCR224	(*( CAN_MOFCR0_type *) 0xf001ac00u)	/* Message Object 224 Function Control Register */
#define CAN_MOFCR225	(*( CAN_MOFCR0_type *) 0xf001ac20u)	/* Message Object 225 Function Control Register */
#define CAN_MOFCR226	(*( CAN_MOFCR0_type *) 0xf001ac40u)	/* Message Object 226 Function Control Register */
#define CAN_MOFCR227	(*( CAN_MOFCR0_type *) 0xf001ac60u)	/* Message Object 227 Function Control Register */
#define CAN_MOFCR228	(*( CAN_MOFCR0_type *) 0xf001ac80u)	/* Message Object 228 Function Control Register */
#define CAN_MOFCR229	(*( CAN_MOFCR0_type *) 0xf001aca0u)	/* Message Object 229 Function Control Register */
#define CAN_MOFCR23	(*( CAN_MOFCR0_type *) 0xf00192e0u)	/* Message Object 23 Function Control Register */
#define CAN_MOFCR230	(*( CAN_MOFCR0_type *) 0xf001acc0u)	/* Message Object 230 Function Control Register */
#define CAN_MOFCR231	(*( CAN_MOFCR0_type *) 0xf001ace0u)	/* Message Object 231 Function Control Register */
#define CAN_MOFCR232	(*( CAN_MOFCR0_type *) 0xf001ad00u)	/* Message Object 232 Function Control Register */
#define CAN_MOFCR233	(*( CAN_MOFCR0_type *) 0xf001ad20u)	/* Message Object 233 Function Control Register */
#define CAN_MOFCR234	(*( CAN_MOFCR0_type *) 0xf001ad40u)	/* Message Object 234 Function Control Register */
#define CAN_MOFCR235	(*( CAN_MOFCR0_type *) 0xf001ad60u)	/* Message Object 235 Function Control Register */
#define CAN_MOFCR236	(*( CAN_MOFCR0_type *) 0xf001ad80u)	/* Message Object 236 Function Control Register */
#define CAN_MOFCR237	(*( CAN_MOFCR0_type *) 0xf001ada0u)	/* Message Object 237 Function Control Register */
#define CAN_MOFCR238	(*( CAN_MOFCR0_type *) 0xf001adc0u)	/* Message Object 238 Function Control Register */
#define CAN_MOFCR239	(*( CAN_MOFCR0_type *) 0xf001ade0u)	/* Message Object 239 Function Control Register */
#define CAN_MOFCR24	(*( CAN_MOFCR0_type *) 0xf0019300u)	/* Message Object 24 Function Control Register */
#define CAN_MOFCR240	(*( CAN_MOFCR0_type *) 0xf001ae00u)	/* Message Object 240 Function Control Register */
#define CAN_MOFCR241	(*( CAN_MOFCR0_type *) 0xf001ae20u)	/* Message Object 241 Function Control Register */
#define CAN_MOFCR242	(*( CAN_MOFCR0_type *) 0xf001ae40u)	/* Message Object 242 Function Control Register */
#define CAN_MOFCR243	(*( CAN_MOFCR0_type *) 0xf001ae60u)	/* Message Object 243 Function Control Register */
#define CAN_MOFCR244	(*( CAN_MOFCR0_type *) 0xf001ae80u)	/* Message Object 244 Function Control Register */
#define CAN_MOFCR245	(*( CAN_MOFCR0_type *) 0xf001aea0u)	/* Message Object 245 Function Control Register */
#define CAN_MOFCR246	(*( CAN_MOFCR0_type *) 0xf001aec0u)	/* Message Object 246 Function Control Register */
#define CAN_MOFCR247	(*( CAN_MOFCR0_type *) 0xf001aee0u)	/* Message Object 247 Function Control Register */
#define CAN_MOFCR248	(*( CAN_MOFCR0_type *) 0xf001af00u)	/* Message Object 248 Function Control Register */
#define CAN_MOFCR249	(*( CAN_MOFCR0_type *) 0xf001af20u)	/* Message Object 249 Function Control Register */
#define CAN_MOFCR25	(*( CAN_MOFCR0_type *) 0xf0019320u)	/* Message Object 25 Function Control Register */
#define CAN_MOFCR250	(*( CAN_MOFCR0_type *) 0xf001af40u)	/* Message Object 250 Function Control Register */
#define CAN_MOFCR251	(*( CAN_MOFCR0_type *) 0xf001af60u)	/* Message Object 251 Function Control Register */
#define CAN_MOFCR252	(*( CAN_MOFCR0_type *) 0xf001af80u)	/* Message Object 252 Function Control Register */
#define CAN_MOFCR253	(*( CAN_MOFCR0_type *) 0xf001afa0u)	/* Message Object 253 Function Control Register */
#define CAN_MOFCR254	(*( CAN_MOFCR0_type *) 0xf001afc0u)	/* Message Object 254 Function Control Register */
#define CAN_MOFCR255	(*( CAN_MOFCR0_type *) 0xf001afe0u)	/* Message Object 255 Function Control Register */
#define CAN_MOFCR26	(*( CAN_MOFCR0_type *) 0xf0019340u)	/* Message Object 26 Function Control Register */
#define CAN_MOFCR27	(*( CAN_MOFCR0_type *) 0xf0019360u)	/* Message Object 27 Function Control Register */
#define CAN_MOFCR28	(*( CAN_MOFCR0_type *) 0xf0019380u)	/* Message Object 28 Function Control Register */
#define CAN_MOFCR29	(*( CAN_MOFCR0_type *) 0xf00193a0u)	/* Message Object 29 Function Control Register */
#define CAN_MOFCR3	(*( CAN_MOFCR0_type *) 0xf0019060u)	/* Message Object 3 Function Control Register */
#define CAN_MOFCR30	(*( CAN_MOFCR0_type *) 0xf00193c0u)	/* Message Object 30 Function Control Register */
#define CAN_MOFCR31	(*( CAN_MOFCR0_type *) 0xf00193e0u)	/* Message Object 31 Function Control Register */
#define CAN_MOFCR32	(*( CAN_MOFCR0_type *) 0xf0019400u)	/* Message Object 32 Function Control Register */
#define CAN_MOFCR33	(*( CAN_MOFCR0_type *) 0xf0019420u)	/* Message Object 33 Function Control Register */
#define CAN_MOFCR34	(*( CAN_MOFCR0_type *) 0xf0019440u)	/* Message Object 34 Function Control Register */
#define CAN_MOFCR35	(*( CAN_MOFCR0_type *) 0xf0019460u)	/* Message Object 35 Function Control Register */
#define CAN_MOFCR36	(*( CAN_MOFCR0_type *) 0xf0019480u)	/* Message Object 36 Function Control Register */
#define CAN_MOFCR37	(*( CAN_MOFCR0_type *) 0xf00194a0u)	/* Message Object 37 Function Control Register */
#define CAN_MOFCR38	(*( CAN_MOFCR0_type *) 0xf00194c0u)	/* Message Object 38 Function Control Register */
#define CAN_MOFCR39	(*( CAN_MOFCR0_type *) 0xf00194e0u)	/* Message Object 39 Function Control Register */
#define CAN_MOFCR4	(*( CAN_MOFCR0_type *) 0xf0019080u)	/* Message Object 4 Function Control Register */
#define CAN_MOFCR40	(*( CAN_MOFCR0_type *) 0xf0019500u)	/* Message Object 40 Function Control Register */
#define CAN_MOFCR41	(*( CAN_MOFCR0_type *) 0xf0019520u)	/* Message Object 41 Function Control Register */
#define CAN_MOFCR42	(*( CAN_MOFCR0_type *) 0xf0019540u)	/* Message Object 42 Function Control Register */
#define CAN_MOFCR43	(*( CAN_MOFCR0_type *) 0xf0019560u)	/* Message Object 43 Function Control Register */
#define CAN_MOFCR44	(*( CAN_MOFCR0_type *) 0xf0019580u)	/* Message Object 44 Function Control Register */
#define CAN_MOFCR45	(*( CAN_MOFCR0_type *) 0xf00195a0u)	/* Message Object 45 Function Control Register */
#define CAN_MOFCR46	(*( CAN_MOFCR0_type *) 0xf00195c0u)	/* Message Object 46 Function Control Register */
#define CAN_MOFCR47	(*( CAN_MOFCR0_type *) 0xf00195e0u)	/* Message Object 47 Function Control Register */
#define CAN_MOFCR48	(*( CAN_MOFCR0_type *) 0xf0019600u)	/* Message Object 48 Function Control Register */
#define CAN_MOFCR49	(*( CAN_MOFCR0_type *) 0xf0019620u)	/* Message Object 49 Function Control Register */
#define CAN_MOFCR5	(*( CAN_MOFCR0_type *) 0xf00190a0u)	/* Message Object 5 Function Control Register */
#define CAN_MOFCR50	(*( CAN_MOFCR0_type *) 0xf0019640u)	/* Message Object 50 Function Control Register */
#define CAN_MOFCR51	(*( CAN_MOFCR0_type *) 0xf0019660u)	/* Message Object 51 Function Control Register */
#define CAN_MOFCR52	(*( CAN_MOFCR0_type *) 0xf0019680u)	/* Message Object 52 Function Control Register */
#define CAN_MOFCR53	(*( CAN_MOFCR0_type *) 0xf00196a0u)	/* Message Object 53 Function Control Register */
#define CAN_MOFCR54	(*( CAN_MOFCR0_type *) 0xf00196c0u)	/* Message Object 54 Function Control Register */
#define CAN_MOFCR55	(*( CAN_MOFCR0_type *) 0xf00196e0u)	/* Message Object 55 Function Control Register */
#define CAN_MOFCR56	(*( CAN_MOFCR0_type *) 0xf0019700u)	/* Message Object 56 Function Control Register */
#define CAN_MOFCR57	(*( CAN_MOFCR0_type *) 0xf0019720u)	/* Message Object 57 Function Control Register */
#define CAN_MOFCR58	(*( CAN_MOFCR0_type *) 0xf0019740u)	/* Message Object 58 Function Control Register */
#define CAN_MOFCR59	(*( CAN_MOFCR0_type *) 0xf0019760u)	/* Message Object 59 Function Control Register */
#define CAN_MOFCR6	(*( CAN_MOFCR0_type *) 0xf00190c0u)	/* Message Object 6 Function Control Register */
#define CAN_MOFCR60	(*( CAN_MOFCR0_type *) 0xf0019780u)	/* Message Object 60 Function Control Register */
#define CAN_MOFCR61	(*( CAN_MOFCR0_type *) 0xf00197a0u)	/* Message Object 61 Function Control Register */
#define CAN_MOFCR62	(*( CAN_MOFCR0_type *) 0xf00197c0u)	/* Message Object 62 Function Control Register */
#define CAN_MOFCR63	(*( CAN_MOFCR0_type *) 0xf00197e0u)	/* Message Object 63 Function Control Register */
#define CAN_MOFCR64	(*( CAN_MOFCR0_type *) 0xf0019800u)	/* Message Object 64 Function Control Register */
#define CAN_MOFCR65	(*( CAN_MOFCR0_type *) 0xf0019820u)	/* Message Object 65 Function Control Register */
#define CAN_MOFCR66	(*( CAN_MOFCR0_type *) 0xf0019840u)	/* Message Object 66 Function Control Register */
#define CAN_MOFCR67	(*( CAN_MOFCR0_type *) 0xf0019860u)	/* Message Object 67 Function Control Register */
#define CAN_MOFCR68	(*( CAN_MOFCR0_type *) 0xf0019880u)	/* Message Object 68 Function Control Register */
#define CAN_MOFCR69	(*( CAN_MOFCR0_type *) 0xf00198a0u)	/* Message Object 69 Function Control Register */
#define CAN_MOFCR7	(*( CAN_MOFCR0_type *) 0xf00190e0u)	/* Message Object 7 Function Control Register */
#define CAN_MOFCR70	(*( CAN_MOFCR0_type *) 0xf00198c0u)	/* Message Object 70 Function Control Register */
#define CAN_MOFCR71	(*( CAN_MOFCR0_type *) 0xf00198e0u)	/* Message Object 71 Function Control Register */
#define CAN_MOFCR72	(*( CAN_MOFCR0_type *) 0xf0019900u)	/* Message Object 72 Function Control Register */
#define CAN_MOFCR73	(*( CAN_MOFCR0_type *) 0xf0019920u)	/* Message Object 73 Function Control Register */
#define CAN_MOFCR74	(*( CAN_MOFCR0_type *) 0xf0019940u)	/* Message Object 74 Function Control Register */
#define CAN_MOFCR75	(*( CAN_MOFCR0_type *) 0xf0019960u)	/* Message Object 75 Function Control Register */
#define CAN_MOFCR76	(*( CAN_MOFCR0_type *) 0xf0019980u)	/* Message Object 76 Function Control Register */
#define CAN_MOFCR77	(*( CAN_MOFCR0_type *) 0xf00199a0u)	/* Message Object 77 Function Control Register */
#define CAN_MOFCR78	(*( CAN_MOFCR0_type *) 0xf00199c0u)	/* Message Object 78 Function Control Register */
#define CAN_MOFCR79	(*( CAN_MOFCR0_type *) 0xf00199e0u)	/* Message Object 79 Function Control Register */
#define CAN_MOFCR8	(*( CAN_MOFCR0_type *) 0xf0019100u)	/* Message Object 8 Function Control Register */
#define CAN_MOFCR80	(*( CAN_MOFCR0_type *) 0xf0019a00u)	/* Message Object 80 Function Control Register */
#define CAN_MOFCR81	(*( CAN_MOFCR0_type *) 0xf0019a20u)	/* Message Object 81 Function Control Register */
#define CAN_MOFCR82	(*( CAN_MOFCR0_type *) 0xf0019a40u)	/* Message Object 82 Function Control Register */
#define CAN_MOFCR83	(*( CAN_MOFCR0_type *) 0xf0019a60u)	/* Message Object 83 Function Control Register */
#define CAN_MOFCR84	(*( CAN_MOFCR0_type *) 0xf0019a80u)	/* Message Object 84 Function Control Register */
#define CAN_MOFCR85	(*( CAN_MOFCR0_type *) 0xf0019aa0u)	/* Message Object 85 Function Control Register */
#define CAN_MOFCR86	(*( CAN_MOFCR0_type *) 0xf0019ac0u)	/* Message Object 86 Function Control Register */
#define CAN_MOFCR87	(*( CAN_MOFCR0_type *) 0xf0019ae0u)	/* Message Object 87 Function Control Register */
#define CAN_MOFCR88	(*( CAN_MOFCR0_type *) 0xf0019b00u)	/* Message Object 88 Function Control Register */
#define CAN_MOFCR89	(*( CAN_MOFCR0_type *) 0xf0019b20u)	/* Message Object 89 Function Control Register */
#define CAN_MOFCR9	(*( CAN_MOFCR0_type *) 0xf0019120u)	/* Message Object 9 Function Control Register */
#define CAN_MOFCR90	(*( CAN_MOFCR0_type *) 0xf0019b40u)	/* Message Object 90 Function Control Register */
#define CAN_MOFCR91	(*( CAN_MOFCR0_type *) 0xf0019b60u)	/* Message Object 91 Function Control Register */
#define CAN_MOFCR92	(*( CAN_MOFCR0_type *) 0xf0019b80u)	/* Message Object 92 Function Control Register */
#define CAN_MOFCR93	(*( CAN_MOFCR0_type *) 0xf0019ba0u)	/* Message Object 93 Function Control Register */
#define CAN_MOFCR94	(*( CAN_MOFCR0_type *) 0xf0019bc0u)	/* Message Object 94 Function Control Register */
#define CAN_MOFCR95	(*( CAN_MOFCR0_type *) 0xf0019be0u)	/* Message Object 95 Function Control Register */
#define CAN_MOFCR96	(*( CAN_MOFCR0_type *) 0xf0019c00u)	/* Message Object 96 Function Control Register */
#define CAN_MOFCR97	(*( CAN_MOFCR0_type *) 0xf0019c20u)	/* Message Object 97 Function Control Register */
#define CAN_MOFCR98	(*( CAN_MOFCR0_type *) 0xf0019c40u)	/* Message Object 98 Function Control Register */
#define CAN_MOFCR99	(*( CAN_MOFCR0_type *) 0xf0019c60u)	/* Message Object 99 Function Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int BOT            : 8;	/* Bottom Pointer */
		unsigned int TOP            : 8;	/* Top Pointer */
		unsigned int CUR            : 8;	/* Current Object Pointer */
		unsigned int SEL            : 8;	/* Object Select Pointer */
	} B;
	int I;
	unsigned int U;

} CAN_MOFGPR0_type;
#define CAN_MOFGPR0	(*( CAN_MOFGPR0_type *) 0xf0019004u)	/* Message Object 0 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR1	(*( CAN_MOFGPR0_type *) 0xf0019024u)	/* Message Object 1 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR10	(*( CAN_MOFGPR0_type *) 0xf0019144u)	/* Message Object 10 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR100	(*( CAN_MOFGPR0_type *) 0xf0019c84u)	/* Message Object 100 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR101	(*( CAN_MOFGPR0_type *) 0xf0019ca4u)	/* Message Object 101 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR102	(*( CAN_MOFGPR0_type *) 0xf0019cc4u)	/* Message Object 102 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR103	(*( CAN_MOFGPR0_type *) 0xf0019ce4u)	/* Message Object 103 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR104	(*( CAN_MOFGPR0_type *) 0xf0019d04u)	/* Message Object 104 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR105	(*( CAN_MOFGPR0_type *) 0xf0019d24u)	/* Message Object 105 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR106	(*( CAN_MOFGPR0_type *) 0xf0019d44u)	/* Message Object 106 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR107	(*( CAN_MOFGPR0_type *) 0xf0019d64u)	/* Message Object 107 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR108	(*( CAN_MOFGPR0_type *) 0xf0019d84u)	/* Message Object 108 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR109	(*( CAN_MOFGPR0_type *) 0xf0019da4u)	/* Message Object 109 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR11	(*( CAN_MOFGPR0_type *) 0xf0019164u)	/* Message Object 11 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR110	(*( CAN_MOFGPR0_type *) 0xf0019dc4u)	/* Message Object 110 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR111	(*( CAN_MOFGPR0_type *) 0xf0019de4u)	/* Message Object 111 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR112	(*( CAN_MOFGPR0_type *) 0xf0019e04u)	/* Message Object 112 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR113	(*( CAN_MOFGPR0_type *) 0xf0019e24u)	/* Message Object 113 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR114	(*( CAN_MOFGPR0_type *) 0xf0019e44u)	/* Message Object 114 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR115	(*( CAN_MOFGPR0_type *) 0xf0019e64u)	/* Message Object 115 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR116	(*( CAN_MOFGPR0_type *) 0xf0019e84u)	/* Message Object 116 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR117	(*( CAN_MOFGPR0_type *) 0xf0019ea4u)	/* Message Object 117 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR118	(*( CAN_MOFGPR0_type *) 0xf0019ec4u)	/* Message Object 118 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR119	(*( CAN_MOFGPR0_type *) 0xf0019ee4u)	/* Message Object 119 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR12	(*( CAN_MOFGPR0_type *) 0xf0019184u)	/* Message Object 12 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR120	(*( CAN_MOFGPR0_type *) 0xf0019f04u)	/* Message Object 120 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR121	(*( CAN_MOFGPR0_type *) 0xf0019f24u)	/* Message Object 121 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR122	(*( CAN_MOFGPR0_type *) 0xf0019f44u)	/* Message Object 122 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR123	(*( CAN_MOFGPR0_type *) 0xf0019f64u)	/* Message Object 123 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR124	(*( CAN_MOFGPR0_type *) 0xf0019f84u)	/* Message Object 124 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR125	(*( CAN_MOFGPR0_type *) 0xf0019fa4u)	/* Message Object 125 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR126	(*( CAN_MOFGPR0_type *) 0xf0019fc4u)	/* Message Object 126 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR127	(*( CAN_MOFGPR0_type *) 0xf0019fe4u)	/* Message Object 127 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR128	(*( CAN_MOFGPR0_type *) 0xf001a004u)	/* Message Object 128 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR129	(*( CAN_MOFGPR0_type *) 0xf001a024u)	/* Message Object 129 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR13	(*( CAN_MOFGPR0_type *) 0xf00191a4u)	/* Message Object 13 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR130	(*( CAN_MOFGPR0_type *) 0xf001a044u)	/* Message Object 130 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR131	(*( CAN_MOFGPR0_type *) 0xf001a064u)	/* Message Object 131 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR132	(*( CAN_MOFGPR0_type *) 0xf001a084u)	/* Message Object 132 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR133	(*( CAN_MOFGPR0_type *) 0xf001a0a4u)	/* Message Object 133 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR134	(*( CAN_MOFGPR0_type *) 0xf001a0c4u)	/* Message Object 134 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR135	(*( CAN_MOFGPR0_type *) 0xf001a0e4u)	/* Message Object 135 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR136	(*( CAN_MOFGPR0_type *) 0xf001a104u)	/* Message Object 136 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR137	(*( CAN_MOFGPR0_type *) 0xf001a124u)	/* Message Object 137 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR138	(*( CAN_MOFGPR0_type *) 0xf001a144u)	/* Message Object 138 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR139	(*( CAN_MOFGPR0_type *) 0xf001a164u)	/* Message Object 139 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR14	(*( CAN_MOFGPR0_type *) 0xf00191c4u)	/* Message Object 14 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR140	(*( CAN_MOFGPR0_type *) 0xf001a184u)	/* Message Object 140 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR141	(*( CAN_MOFGPR0_type *) 0xf001a1a4u)	/* Message Object 141 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR142	(*( CAN_MOFGPR0_type *) 0xf001a1c4u)	/* Message Object 142 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR143	(*( CAN_MOFGPR0_type *) 0xf001a1e4u)	/* Message Object 143 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR144	(*( CAN_MOFGPR0_type *) 0xf001a204u)	/* Message Object 144 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR145	(*( CAN_MOFGPR0_type *) 0xf001a224u)	/* Message Object 145 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR146	(*( CAN_MOFGPR0_type *) 0xf001a244u)	/* Message Object 146 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR147	(*( CAN_MOFGPR0_type *) 0xf001a264u)	/* Message Object 147 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR148	(*( CAN_MOFGPR0_type *) 0xf001a284u)	/* Message Object 148 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR149	(*( CAN_MOFGPR0_type *) 0xf001a2a4u)	/* Message Object 149 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR15	(*( CAN_MOFGPR0_type *) 0xf00191e4u)	/* Message Object 15 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR150	(*( CAN_MOFGPR0_type *) 0xf001a2c4u)	/* Message Object 150 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR151	(*( CAN_MOFGPR0_type *) 0xf001a2e4u)	/* Message Object 151 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR152	(*( CAN_MOFGPR0_type *) 0xf001a304u)	/* Message Object 152 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR153	(*( CAN_MOFGPR0_type *) 0xf001a324u)	/* Message Object 153 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR154	(*( CAN_MOFGPR0_type *) 0xf001a344u)	/* Message Object 154 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR155	(*( CAN_MOFGPR0_type *) 0xf001a364u)	/* Message Object 155 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR156	(*( CAN_MOFGPR0_type *) 0xf001a384u)	/* Message Object 156 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR157	(*( CAN_MOFGPR0_type *) 0xf001a3a4u)	/* Message Object 157 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR158	(*( CAN_MOFGPR0_type *) 0xf001a3c4u)	/* Message Object 158 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR159	(*( CAN_MOFGPR0_type *) 0xf001a3e4u)	/* Message Object 159 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR16	(*( CAN_MOFGPR0_type *) 0xf0019204u)	/* Message Object 16 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR160	(*( CAN_MOFGPR0_type *) 0xf001a404u)	/* Message Object 160 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR161	(*( CAN_MOFGPR0_type *) 0xf001a424u)	/* Message Object 161 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR162	(*( CAN_MOFGPR0_type *) 0xf001a444u)	/* Message Object 162 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR163	(*( CAN_MOFGPR0_type *) 0xf001a464u)	/* Message Object 163 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR164	(*( CAN_MOFGPR0_type *) 0xf001a484u)	/* Message Object 164 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR165	(*( CAN_MOFGPR0_type *) 0xf001a4a4u)	/* Message Object 165 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR166	(*( CAN_MOFGPR0_type *) 0xf001a4c4u)	/* Message Object 166 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR167	(*( CAN_MOFGPR0_type *) 0xf001a4e4u)	/* Message Object 167 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR168	(*( CAN_MOFGPR0_type *) 0xf001a504u)	/* Message Object 168 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR169	(*( CAN_MOFGPR0_type *) 0xf001a524u)	/* Message Object 169 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR17	(*( CAN_MOFGPR0_type *) 0xf0019224u)	/* Message Object 17 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR170	(*( CAN_MOFGPR0_type *) 0xf001a544u)	/* Message Object 170 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR171	(*( CAN_MOFGPR0_type *) 0xf001a564u)	/* Message Object 171 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR172	(*( CAN_MOFGPR0_type *) 0xf001a584u)	/* Message Object 172 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR173	(*( CAN_MOFGPR0_type *) 0xf001a5a4u)	/* Message Object 173 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR174	(*( CAN_MOFGPR0_type *) 0xf001a5c4u)	/* Message Object 174 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR175	(*( CAN_MOFGPR0_type *) 0xf001a5e4u)	/* Message Object 175 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR176	(*( CAN_MOFGPR0_type *) 0xf001a604u)	/* Message Object 176 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR177	(*( CAN_MOFGPR0_type *) 0xf001a624u)	/* Message Object 177 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR178	(*( CAN_MOFGPR0_type *) 0xf001a644u)	/* Message Object 178 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR179	(*( CAN_MOFGPR0_type *) 0xf001a664u)	/* Message Object 179 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR18	(*( CAN_MOFGPR0_type *) 0xf0019244u)	/* Message Object 18 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR180	(*( CAN_MOFGPR0_type *) 0xf001a684u)	/* Message Object 180 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR181	(*( CAN_MOFGPR0_type *) 0xf001a6a4u)	/* Message Object 181 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR182	(*( CAN_MOFGPR0_type *) 0xf001a6c4u)	/* Message Object 182 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR183	(*( CAN_MOFGPR0_type *) 0xf001a6e4u)	/* Message Object 183 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR184	(*( CAN_MOFGPR0_type *) 0xf001a704u)	/* Message Object 184 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR185	(*( CAN_MOFGPR0_type *) 0xf001a724u)	/* Message Object 185 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR186	(*( CAN_MOFGPR0_type *) 0xf001a744u)	/* Message Object 186 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR187	(*( CAN_MOFGPR0_type *) 0xf001a764u)	/* Message Object 187 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR188	(*( CAN_MOFGPR0_type *) 0xf001a784u)	/* Message Object 188 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR189	(*( CAN_MOFGPR0_type *) 0xf001a7a4u)	/* Message Object 189 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR19	(*( CAN_MOFGPR0_type *) 0xf0019264u)	/* Message Object 19 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR190	(*( CAN_MOFGPR0_type *) 0xf001a7c4u)	/* Message Object 190 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR191	(*( CAN_MOFGPR0_type *) 0xf001a7e4u)	/* Message Object 191 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR192	(*( CAN_MOFGPR0_type *) 0xf001a804u)	/* Message Object 192 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR193	(*( CAN_MOFGPR0_type *) 0xf001a824u)	/* Message Object 193 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR194	(*( CAN_MOFGPR0_type *) 0xf001a844u)	/* Message Object 194 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR195	(*( CAN_MOFGPR0_type *) 0xf001a864u)	/* Message Object 195 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR196	(*( CAN_MOFGPR0_type *) 0xf001a884u)	/* Message Object 196 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR197	(*( CAN_MOFGPR0_type *) 0xf001a8a4u)	/* Message Object 197 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR198	(*( CAN_MOFGPR0_type *) 0xf001a8c4u)	/* Message Object 198 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR199	(*( CAN_MOFGPR0_type *) 0xf001a8e4u)	/* Message Object 199 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR2	(*( CAN_MOFGPR0_type *) 0xf0019044u)	/* Message Object 2 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR20	(*( CAN_MOFGPR0_type *) 0xf0019284u)	/* Message Object 20 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR200	(*( CAN_MOFGPR0_type *) 0xf001a904u)	/* Message Object 200 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR201	(*( CAN_MOFGPR0_type *) 0xf001a924u)	/* Message Object 201 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR202	(*( CAN_MOFGPR0_type *) 0xf001a944u)	/* Message Object 202 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR203	(*( CAN_MOFGPR0_type *) 0xf001a964u)	/* Message Object 203 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR204	(*( CAN_MOFGPR0_type *) 0xf001a984u)	/* Message Object 204 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR205	(*( CAN_MOFGPR0_type *) 0xf001a9a4u)	/* Message Object 205 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR206	(*( CAN_MOFGPR0_type *) 0xf001a9c4u)	/* Message Object 206 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR207	(*( CAN_MOFGPR0_type *) 0xf001a9e4u)	/* Message Object 207 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR208	(*( CAN_MOFGPR0_type *) 0xf001aa04u)	/* Message Object 208 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR209	(*( CAN_MOFGPR0_type *) 0xf001aa24u)	/* Message Object 209 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR21	(*( CAN_MOFGPR0_type *) 0xf00192a4u)	/* Message Object 21 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR210	(*( CAN_MOFGPR0_type *) 0xf001aa44u)	/* Message Object 210 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR211	(*( CAN_MOFGPR0_type *) 0xf001aa64u)	/* Message Object 211 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR212	(*( CAN_MOFGPR0_type *) 0xf001aa84u)	/* Message Object 212 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR213	(*( CAN_MOFGPR0_type *) 0xf001aaa4u)	/* Message Object 213 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR214	(*( CAN_MOFGPR0_type *) 0xf001aac4u)	/* Message Object 214 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR215	(*( CAN_MOFGPR0_type *) 0xf001aae4u)	/* Message Object 215 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR216	(*( CAN_MOFGPR0_type *) 0xf001ab04u)	/* Message Object 216 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR217	(*( CAN_MOFGPR0_type *) 0xf001ab24u)	/* Message Object 217 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR218	(*( CAN_MOFGPR0_type *) 0xf001ab44u)	/* Message Object 218 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR219	(*( CAN_MOFGPR0_type *) 0xf001ab64u)	/* Message Object 219 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR22	(*( CAN_MOFGPR0_type *) 0xf00192c4u)	/* Message Object 22 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR220	(*( CAN_MOFGPR0_type *) 0xf001ab84u)	/* Message Object 220 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR221	(*( CAN_MOFGPR0_type *) 0xf001aba4u)	/* Message Object 221 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR222	(*( CAN_MOFGPR0_type *) 0xf001abc4u)	/* Message Object 222 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR223	(*( CAN_MOFGPR0_type *) 0xf001abe4u)	/* Message Object 223 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR224	(*( CAN_MOFGPR0_type *) 0xf001ac04u)	/* Message Object 224 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR225	(*( CAN_MOFGPR0_type *) 0xf001ac24u)	/* Message Object 225 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR226	(*( CAN_MOFGPR0_type *) 0xf001ac44u)	/* Message Object 226 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR227	(*( CAN_MOFGPR0_type *) 0xf001ac64u)	/* Message Object 227 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR228	(*( CAN_MOFGPR0_type *) 0xf001ac84u)	/* Message Object 228 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR229	(*( CAN_MOFGPR0_type *) 0xf001aca4u)	/* Message Object 229 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR23	(*( CAN_MOFGPR0_type *) 0xf00192e4u)	/* Message Object 23 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR230	(*( CAN_MOFGPR0_type *) 0xf001acc4u)	/* Message Object 230 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR231	(*( CAN_MOFGPR0_type *) 0xf001ace4u)	/* Message Object 231 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR232	(*( CAN_MOFGPR0_type *) 0xf001ad04u)	/* Message Object 232 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR233	(*( CAN_MOFGPR0_type *) 0xf001ad24u)	/* Message Object 233 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR234	(*( CAN_MOFGPR0_type *) 0xf001ad44u)	/* Message Object 234 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR235	(*( CAN_MOFGPR0_type *) 0xf001ad64u)	/* Message Object 235 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR236	(*( CAN_MOFGPR0_type *) 0xf001ad84u)	/* Message Object 236 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR237	(*( CAN_MOFGPR0_type *) 0xf001ada4u)	/* Message Object 237 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR238	(*( CAN_MOFGPR0_type *) 0xf001adc4u)	/* Message Object 238 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR239	(*( CAN_MOFGPR0_type *) 0xf001ade4u)	/* Message Object 239 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR24	(*( CAN_MOFGPR0_type *) 0xf0019304u)	/* Message Object 24 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR240	(*( CAN_MOFGPR0_type *) 0xf001ae04u)	/* Message Object 240 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR241	(*( CAN_MOFGPR0_type *) 0xf001ae24u)	/* Message Object 241 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR242	(*( CAN_MOFGPR0_type *) 0xf001ae44u)	/* Message Object 242 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR243	(*( CAN_MOFGPR0_type *) 0xf001ae64u)	/* Message Object 243 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR244	(*( CAN_MOFGPR0_type *) 0xf001ae84u)	/* Message Object 244 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR245	(*( CAN_MOFGPR0_type *) 0xf001aea4u)	/* Message Object 245 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR246	(*( CAN_MOFGPR0_type *) 0xf001aec4u)	/* Message Object 246 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR247	(*( CAN_MOFGPR0_type *) 0xf001aee4u)	/* Message Object 247 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR248	(*( CAN_MOFGPR0_type *) 0xf001af04u)	/* Message Object 248 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR249	(*( CAN_MOFGPR0_type *) 0xf001af24u)	/* Message Object 249 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR25	(*( CAN_MOFGPR0_type *) 0xf0019324u)	/* Message Object 25 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR250	(*( CAN_MOFGPR0_type *) 0xf001af44u)	/* Message Object 250 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR251	(*( CAN_MOFGPR0_type *) 0xf001af64u)	/* Message Object 251 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR252	(*( CAN_MOFGPR0_type *) 0xf001af84u)	/* Message Object 252 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR253	(*( CAN_MOFGPR0_type *) 0xf001afa4u)	/* Message Object 253 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR254	(*( CAN_MOFGPR0_type *) 0xf001afc4u)	/* Message Object 254 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR255	(*( CAN_MOFGPR0_type *) 0xf001afe4u)	/* Message Object 255 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR26	(*( CAN_MOFGPR0_type *) 0xf0019344u)	/* Message Object 26 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR27	(*( CAN_MOFGPR0_type *) 0xf0019364u)	/* Message Object 27 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR28	(*( CAN_MOFGPR0_type *) 0xf0019384u)	/* Message Object 28 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR29	(*( CAN_MOFGPR0_type *) 0xf00193a4u)	/* Message Object 29 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR3	(*( CAN_MOFGPR0_type *) 0xf0019064u)	/* Message Object 3 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR30	(*( CAN_MOFGPR0_type *) 0xf00193c4u)	/* Message Object 30 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR31	(*( CAN_MOFGPR0_type *) 0xf00193e4u)	/* Message Object 31 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR32	(*( CAN_MOFGPR0_type *) 0xf0019404u)	/* Message Object 32 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR33	(*( CAN_MOFGPR0_type *) 0xf0019424u)	/* Message Object 33 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR34	(*( CAN_MOFGPR0_type *) 0xf0019444u)	/* Message Object 34 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR35	(*( CAN_MOFGPR0_type *) 0xf0019464u)	/* Message Object 35 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR36	(*( CAN_MOFGPR0_type *) 0xf0019484u)	/* Message Object 36 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR37	(*( CAN_MOFGPR0_type *) 0xf00194a4u)	/* Message Object 37 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR38	(*( CAN_MOFGPR0_type *) 0xf00194c4u)	/* Message Object 38 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR39	(*( CAN_MOFGPR0_type *) 0xf00194e4u)	/* Message Object 39 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR4	(*( CAN_MOFGPR0_type *) 0xf0019084u)	/* Message Object 4 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR40	(*( CAN_MOFGPR0_type *) 0xf0019504u)	/* Message Object 40 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR41	(*( CAN_MOFGPR0_type *) 0xf0019524u)	/* Message Object 41 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR42	(*( CAN_MOFGPR0_type *) 0xf0019544u)	/* Message Object 42 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR43	(*( CAN_MOFGPR0_type *) 0xf0019564u)	/* Message Object 43 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR44	(*( CAN_MOFGPR0_type *) 0xf0019584u)	/* Message Object 44 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR45	(*( CAN_MOFGPR0_type *) 0xf00195a4u)	/* Message Object 45 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR46	(*( CAN_MOFGPR0_type *) 0xf00195c4u)	/* Message Object 46 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR47	(*( CAN_MOFGPR0_type *) 0xf00195e4u)	/* Message Object 47 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR48	(*( CAN_MOFGPR0_type *) 0xf0019604u)	/* Message Object 48 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR49	(*( CAN_MOFGPR0_type *) 0xf0019624u)	/* Message Object 49 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR5	(*( CAN_MOFGPR0_type *) 0xf00190a4u)	/* Message Object 5 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR50	(*( CAN_MOFGPR0_type *) 0xf0019644u)	/* Message Object 50 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR51	(*( CAN_MOFGPR0_type *) 0xf0019664u)	/* Message Object 51 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR52	(*( CAN_MOFGPR0_type *) 0xf0019684u)	/* Message Object 52 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR53	(*( CAN_MOFGPR0_type *) 0xf00196a4u)	/* Message Object 53 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR54	(*( CAN_MOFGPR0_type *) 0xf00196c4u)	/* Message Object 54 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR55	(*( CAN_MOFGPR0_type *) 0xf00196e4u)	/* Message Object 55 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR56	(*( CAN_MOFGPR0_type *) 0xf0019704u)	/* Message Object 56 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR57	(*( CAN_MOFGPR0_type *) 0xf0019724u)	/* Message Object 57 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR58	(*( CAN_MOFGPR0_type *) 0xf0019744u)	/* Message Object 58 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR59	(*( CAN_MOFGPR0_type *) 0xf0019764u)	/* Message Object 59 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR6	(*( CAN_MOFGPR0_type *) 0xf00190c4u)	/* Message Object 6 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR60	(*( CAN_MOFGPR0_type *) 0xf0019784u)	/* Message Object 60 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR61	(*( CAN_MOFGPR0_type *) 0xf00197a4u)	/* Message Object 61 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR62	(*( CAN_MOFGPR0_type *) 0xf00197c4u)	/* Message Object 62 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR63	(*( CAN_MOFGPR0_type *) 0xf00197e4u)	/* Message Object 63 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR64	(*( CAN_MOFGPR0_type *) 0xf0019804u)	/* Message Object 64 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR65	(*( CAN_MOFGPR0_type *) 0xf0019824u)	/* Message Object 65 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR66	(*( CAN_MOFGPR0_type *) 0xf0019844u)	/* Message Object 66 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR67	(*( CAN_MOFGPR0_type *) 0xf0019864u)	/* Message Object 67 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR68	(*( CAN_MOFGPR0_type *) 0xf0019884u)	/* Message Object 68 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR69	(*( CAN_MOFGPR0_type *) 0xf00198a4u)	/* Message Object 69 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR7	(*( CAN_MOFGPR0_type *) 0xf00190e4u)	/* Message Object 7 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR70	(*( CAN_MOFGPR0_type *) 0xf00198c4u)	/* Message Object 70 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR71	(*( CAN_MOFGPR0_type *) 0xf00198e4u)	/* Message Object 71 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR72	(*( CAN_MOFGPR0_type *) 0xf0019904u)	/* Message Object 72 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR73	(*( CAN_MOFGPR0_type *) 0xf0019924u)	/* Message Object 73 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR74	(*( CAN_MOFGPR0_type *) 0xf0019944u)	/* Message Object 74 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR75	(*( CAN_MOFGPR0_type *) 0xf0019964u)	/* Message Object 75 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR76	(*( CAN_MOFGPR0_type *) 0xf0019984u)	/* Message Object 76 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR77	(*( CAN_MOFGPR0_type *) 0xf00199a4u)	/* Message Object 77 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR78	(*( CAN_MOFGPR0_type *) 0xf00199c4u)	/* Message Object 78 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR79	(*( CAN_MOFGPR0_type *) 0xf00199e4u)	/* Message Object 79 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR8	(*( CAN_MOFGPR0_type *) 0xf0019104u)	/* Message Object 8 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR80	(*( CAN_MOFGPR0_type *) 0xf0019a04u)	/* Message Object 80 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR81	(*( CAN_MOFGPR0_type *) 0xf0019a24u)	/* Message Object 81 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR82	(*( CAN_MOFGPR0_type *) 0xf0019a44u)	/* Message Object 82 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR83	(*( CAN_MOFGPR0_type *) 0xf0019a64u)	/* Message Object 83 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR84	(*( CAN_MOFGPR0_type *) 0xf0019a84u)	/* Message Object 84 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR85	(*( CAN_MOFGPR0_type *) 0xf0019aa4u)	/* Message Object 85 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR86	(*( CAN_MOFGPR0_type *) 0xf0019ac4u)	/* Message Object 86 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR87	(*( CAN_MOFGPR0_type *) 0xf0019ae4u)	/* Message Object 87 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR88	(*( CAN_MOFGPR0_type *) 0xf0019b04u)	/* Message Object 88 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR89	(*( CAN_MOFGPR0_type *) 0xf0019b24u)	/* Message Object 89 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR9	(*( CAN_MOFGPR0_type *) 0xf0019124u)	/* Message Object 9 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR90	(*( CAN_MOFGPR0_type *) 0xf0019b44u)	/* Message Object 90 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR91	(*( CAN_MOFGPR0_type *) 0xf0019b64u)	/* Message Object 91 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR92	(*( CAN_MOFGPR0_type *) 0xf0019b84u)	/* Message Object 92 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR93	(*( CAN_MOFGPR0_type *) 0xf0019ba4u)	/* Message Object 93 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR94	(*( CAN_MOFGPR0_type *) 0xf0019bc4u)	/* Message Object 94 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR95	(*( CAN_MOFGPR0_type *) 0xf0019be4u)	/* Message Object 95 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR96	(*( CAN_MOFGPR0_type *) 0xf0019c04u)	/* Message Object 96 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR97	(*( CAN_MOFGPR0_type *) 0xf0019c24u)	/* Message Object 97 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR98	(*( CAN_MOFGPR0_type *) 0xf0019c44u)	/* Message Object 98 FIFO/Gateway Pointer Register */
#define CAN_MOFGPR99	(*( CAN_MOFGPR0_type *) 0xf0019c64u)	/* Message Object 99 FIFO/Gateway Pointer Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RXINP          : 4;	/* Receive Interrupt Node Pointer */
		unsigned int TXINP          : 4;	/* Transmit Interrupt Node Pointer */
		unsigned int MPN            : 8;	/* Message Pending Number */
		unsigned int CFCVAL         : 16;	/* CAN Frame Counter Value */
	} B;
	int I;
	unsigned int U;

} CAN_MOIPR0_type;
#define CAN_MOIPR0	(*( CAN_MOIPR0_type *) 0xf0019008u)	/* Message Object 0 Interrupt Pointer Register */
#define CAN_MOIPR1	(*( CAN_MOIPR0_type *) 0xf0019028u)	/* Message Object 1 Interrupt Pointer Register */
#define CAN_MOIPR10	(*( CAN_MOIPR0_type *) 0xf0019148u)	/* Message Object 10 Interrupt Pointer Register */
#define CAN_MOIPR100	(*( CAN_MOIPR0_type *) 0xf0019c88u)	/* Message Object 100 Interrupt Pointer Register */
#define CAN_MOIPR101	(*( CAN_MOIPR0_type *) 0xf0019ca8u)	/* Message Object 101 Interrupt Pointer Register */
#define CAN_MOIPR102	(*( CAN_MOIPR0_type *) 0xf0019cc8u)	/* Message Object 102 Interrupt Pointer Register */
#define CAN_MOIPR103	(*( CAN_MOIPR0_type *) 0xf0019ce8u)	/* Message Object 103 Interrupt Pointer Register */
#define CAN_MOIPR104	(*( CAN_MOIPR0_type *) 0xf0019d08u)	/* Message Object 104 Interrupt Pointer Register */
#define CAN_MOIPR105	(*( CAN_MOIPR0_type *) 0xf0019d28u)	/* Message Object 105 Interrupt Pointer Register */
#define CAN_MOIPR106	(*( CAN_MOIPR0_type *) 0xf0019d48u)	/* Message Object 106 Interrupt Pointer Register */
#define CAN_MOIPR107	(*( CAN_MOIPR0_type *) 0xf0019d68u)	/* Message Object 107 Interrupt Pointer Register */
#define CAN_MOIPR108	(*( CAN_MOIPR0_type *) 0xf0019d88u)	/* Message Object 108 Interrupt Pointer Register */
#define CAN_MOIPR109	(*( CAN_MOIPR0_type *) 0xf0019da8u)	/* Message Object 109 Interrupt Pointer Register */
#define CAN_MOIPR11	(*( CAN_MOIPR0_type *) 0xf0019168u)	/* Message Object 11 Interrupt Pointer Register */
#define CAN_MOIPR110	(*( CAN_MOIPR0_type *) 0xf0019dc8u)	/* Message Object 110 Interrupt Pointer Register */
#define CAN_MOIPR111	(*( CAN_MOIPR0_type *) 0xf0019de8u)	/* Message Object 111 Interrupt Pointer Register */
#define CAN_MOIPR112	(*( CAN_MOIPR0_type *) 0xf0019e08u)	/* Message Object 112 Interrupt Pointer Register */
#define CAN_MOIPR113	(*( CAN_MOIPR0_type *) 0xf0019e28u)	/* Message Object 113 Interrupt Pointer Register */
#define CAN_MOIPR114	(*( CAN_MOIPR0_type *) 0xf0019e48u)	/* Message Object 114 Interrupt Pointer Register */
#define CAN_MOIPR115	(*( CAN_MOIPR0_type *) 0xf0019e68u)	/* Message Object 115 Interrupt Pointer Register */
#define CAN_MOIPR116	(*( CAN_MOIPR0_type *) 0xf0019e88u)	/* Message Object 116 Interrupt Pointer Register */
#define CAN_MOIPR117	(*( CAN_MOIPR0_type *) 0xf0019ea8u)	/* Message Object 117 Interrupt Pointer Register */
#define CAN_MOIPR118	(*( CAN_MOIPR0_type *) 0xf0019ec8u)	/* Message Object 118 Interrupt Pointer Register */
#define CAN_MOIPR119	(*( CAN_MOIPR0_type *) 0xf0019ee8u)	/* Message Object 119 Interrupt Pointer Register */
#define CAN_MOIPR12	(*( CAN_MOIPR0_type *) 0xf0019188u)	/* Message Object 12 Interrupt Pointer Register */
#define CAN_MOIPR120	(*( CAN_MOIPR0_type *) 0xf0019f08u)	/* Message Object 120 Interrupt Pointer Register */
#define CAN_MOIPR121	(*( CAN_MOIPR0_type *) 0xf0019f28u)	/* Message Object 121 Interrupt Pointer Register */
#define CAN_MOIPR122	(*( CAN_MOIPR0_type *) 0xf0019f48u)	/* Message Object 122 Interrupt Pointer Register */
#define CAN_MOIPR123	(*( CAN_MOIPR0_type *) 0xf0019f68u)	/* Message Object 123 Interrupt Pointer Register */
#define CAN_MOIPR124	(*( CAN_MOIPR0_type *) 0xf0019f88u)	/* Message Object 124 Interrupt Pointer Register */
#define CAN_MOIPR125	(*( CAN_MOIPR0_type *) 0xf0019fa8u)	/* Message Object 125 Interrupt Pointer Register */
#define CAN_MOIPR126	(*( CAN_MOIPR0_type *) 0xf0019fc8u)	/* Message Object 126 Interrupt Pointer Register */
#define CAN_MOIPR127	(*( CAN_MOIPR0_type *) 0xf0019fe8u)	/* Message Object 127 Interrupt Pointer Register */
#define CAN_MOIPR128	(*( CAN_MOIPR0_type *) 0xf001a008u)	/* Message Object 128 Interrupt Pointer Register */
#define CAN_MOIPR129	(*( CAN_MOIPR0_type *) 0xf001a028u)	/* Message Object 129 Interrupt Pointer Register */
#define CAN_MOIPR13	(*( CAN_MOIPR0_type *) 0xf00191a8u)	/* Message Object 13 Interrupt Pointer Register */
#define CAN_MOIPR130	(*( CAN_MOIPR0_type *) 0xf001a048u)	/* Message Object 130 Interrupt Pointer Register */
#define CAN_MOIPR131	(*( CAN_MOIPR0_type *) 0xf001a068u)	/* Message Object 131 Interrupt Pointer Register */
#define CAN_MOIPR132	(*( CAN_MOIPR0_type *) 0xf001a088u)	/* Message Object 132 Interrupt Pointer Register */
#define CAN_MOIPR133	(*( CAN_MOIPR0_type *) 0xf001a0a8u)	/* Message Object 133 Interrupt Pointer Register */
#define CAN_MOIPR134	(*( CAN_MOIPR0_type *) 0xf001a0c8u)	/* Message Object 134 Interrupt Pointer Register */
#define CAN_MOIPR135	(*( CAN_MOIPR0_type *) 0xf001a0e8u)	/* Message Object 135 Interrupt Pointer Register */
#define CAN_MOIPR136	(*( CAN_MOIPR0_type *) 0xf001a108u)	/* Message Object 136 Interrupt Pointer Register */
#define CAN_MOIPR137	(*( CAN_MOIPR0_type *) 0xf001a128u)	/* Message Object 137 Interrupt Pointer Register */
#define CAN_MOIPR138	(*( CAN_MOIPR0_type *) 0xf001a148u)	/* Message Object 138 Interrupt Pointer Register */
#define CAN_MOIPR139	(*( CAN_MOIPR0_type *) 0xf001a168u)	/* Message Object 139 Interrupt Pointer Register */
#define CAN_MOIPR14	(*( CAN_MOIPR0_type *) 0xf00191c8u)	/* Message Object 14 Interrupt Pointer Register */
#define CAN_MOIPR140	(*( CAN_MOIPR0_type *) 0xf001a188u)	/* Message Object 140 Interrupt Pointer Register */
#define CAN_MOIPR141	(*( CAN_MOIPR0_type *) 0xf001a1a8u)	/* Message Object 141 Interrupt Pointer Register */
#define CAN_MOIPR142	(*( CAN_MOIPR0_type *) 0xf001a1c8u)	/* Message Object 142 Interrupt Pointer Register */
#define CAN_MOIPR143	(*( CAN_MOIPR0_type *) 0xf001a1e8u)	/* Message Object 143 Interrupt Pointer Register */
#define CAN_MOIPR144	(*( CAN_MOIPR0_type *) 0xf001a208u)	/* Message Object 144 Interrupt Pointer Register */
#define CAN_MOIPR145	(*( CAN_MOIPR0_type *) 0xf001a228u)	/* Message Object 145 Interrupt Pointer Register */
#define CAN_MOIPR146	(*( CAN_MOIPR0_type *) 0xf001a248u)	/* Message Object 146 Interrupt Pointer Register */
#define CAN_MOIPR147	(*( CAN_MOIPR0_type *) 0xf001a268u)	/* Message Object 147 Interrupt Pointer Register */
#define CAN_MOIPR148	(*( CAN_MOIPR0_type *) 0xf001a288u)	/* Message Object 148 Interrupt Pointer Register */
#define CAN_MOIPR149	(*( CAN_MOIPR0_type *) 0xf001a2a8u)	/* Message Object 149 Interrupt Pointer Register */
#define CAN_MOIPR15	(*( CAN_MOIPR0_type *) 0xf00191e8u)	/* Message Object 15 Interrupt Pointer Register */
#define CAN_MOIPR150	(*( CAN_MOIPR0_type *) 0xf001a2c8u)	/* Message Object 150 Interrupt Pointer Register */
#define CAN_MOIPR151	(*( CAN_MOIPR0_type *) 0xf001a2e8u)	/* Message Object 151 Interrupt Pointer Register */
#define CAN_MOIPR152	(*( CAN_MOIPR0_type *) 0xf001a308u)	/* Message Object 152 Interrupt Pointer Register */
#define CAN_MOIPR153	(*( CAN_MOIPR0_type *) 0xf001a328u)	/* Message Object 153 Interrupt Pointer Register */
#define CAN_MOIPR154	(*( CAN_MOIPR0_type *) 0xf001a348u)	/* Message Object 154 Interrupt Pointer Register */
#define CAN_MOIPR155	(*( CAN_MOIPR0_type *) 0xf001a368u)	/* Message Object 155 Interrupt Pointer Register */
#define CAN_MOIPR156	(*( CAN_MOIPR0_type *) 0xf001a388u)	/* Message Object 156 Interrupt Pointer Register */
#define CAN_MOIPR157	(*( CAN_MOIPR0_type *) 0xf001a3a8u)	/* Message Object 157 Interrupt Pointer Register */
#define CAN_MOIPR158	(*( CAN_MOIPR0_type *) 0xf001a3c8u)	/* Message Object 158 Interrupt Pointer Register */
#define CAN_MOIPR159	(*( CAN_MOIPR0_type *) 0xf001a3e8u)	/* Message Object 159 Interrupt Pointer Register */
#define CAN_MOIPR16	(*( CAN_MOIPR0_type *) 0xf0019208u)	/* Message Object 16 Interrupt Pointer Register */
#define CAN_MOIPR160	(*( CAN_MOIPR0_type *) 0xf001a408u)	/* Message Object 160 Interrupt Pointer Register */
#define CAN_MOIPR161	(*( CAN_MOIPR0_type *) 0xf001a428u)	/* Message Object 161 Interrupt Pointer Register */
#define CAN_MOIPR162	(*( CAN_MOIPR0_type *) 0xf001a448u)	/* Message Object 162 Interrupt Pointer Register */
#define CAN_MOIPR163	(*( CAN_MOIPR0_type *) 0xf001a468u)	/* Message Object 163 Interrupt Pointer Register */
#define CAN_MOIPR164	(*( CAN_MOIPR0_type *) 0xf001a488u)	/* Message Object 164 Interrupt Pointer Register */
#define CAN_MOIPR165	(*( CAN_MOIPR0_type *) 0xf001a4a8u)	/* Message Object 165 Interrupt Pointer Register */
#define CAN_MOIPR166	(*( CAN_MOIPR0_type *) 0xf001a4c8u)	/* Message Object 166 Interrupt Pointer Register */
#define CAN_MOIPR167	(*( CAN_MOIPR0_type *) 0xf001a4e8u)	/* Message Object 167 Interrupt Pointer Register */
#define CAN_MOIPR168	(*( CAN_MOIPR0_type *) 0xf001a508u)	/* Message Object 168 Interrupt Pointer Register */
#define CAN_MOIPR169	(*( CAN_MOIPR0_type *) 0xf001a528u)	/* Message Object 169 Interrupt Pointer Register */
#define CAN_MOIPR17	(*( CAN_MOIPR0_type *) 0xf0019228u)	/* Message Object 17 Interrupt Pointer Register */
#define CAN_MOIPR170	(*( CAN_MOIPR0_type *) 0xf001a548u)	/* Message Object 170 Interrupt Pointer Register */
#define CAN_MOIPR171	(*( CAN_MOIPR0_type *) 0xf001a568u)	/* Message Object 171 Interrupt Pointer Register */
#define CAN_MOIPR172	(*( CAN_MOIPR0_type *) 0xf001a588u)	/* Message Object 172 Interrupt Pointer Register */
#define CAN_MOIPR173	(*( CAN_MOIPR0_type *) 0xf001a5a8u)	/* Message Object 173 Interrupt Pointer Register */
#define CAN_MOIPR174	(*( CAN_MOIPR0_type *) 0xf001a5c8u)	/* Message Object 174 Interrupt Pointer Register */
#define CAN_MOIPR175	(*( CAN_MOIPR0_type *) 0xf001a5e8u)	/* Message Object 175 Interrupt Pointer Register */
#define CAN_MOIPR176	(*( CAN_MOIPR0_type *) 0xf001a608u)	/* Message Object 176 Interrupt Pointer Register */
#define CAN_MOIPR177	(*( CAN_MOIPR0_type *) 0xf001a628u)	/* Message Object 177 Interrupt Pointer Register */
#define CAN_MOIPR178	(*( CAN_MOIPR0_type *) 0xf001a648u)	/* Message Object 178 Interrupt Pointer Register */
#define CAN_MOIPR179	(*( CAN_MOIPR0_type *) 0xf001a668u)	/* Message Object 179 Interrupt Pointer Register */
#define CAN_MOIPR18	(*( CAN_MOIPR0_type *) 0xf0019248u)	/* Message Object 18 Interrupt Pointer Register */
#define CAN_MOIPR180	(*( CAN_MOIPR0_type *) 0xf001a688u)	/* Message Object 180 Interrupt Pointer Register */
#define CAN_MOIPR181	(*( CAN_MOIPR0_type *) 0xf001a6a8u)	/* Message Object 181 Interrupt Pointer Register */
#define CAN_MOIPR182	(*( CAN_MOIPR0_type *) 0xf001a6c8u)	/* Message Object 182 Interrupt Pointer Register */
#define CAN_MOIPR183	(*( CAN_MOIPR0_type *) 0xf001a6e8u)	/* Message Object 183 Interrupt Pointer Register */
#define CAN_MOIPR184	(*( CAN_MOIPR0_type *) 0xf001a708u)	/* Message Object 184 Interrupt Pointer Register */
#define CAN_MOIPR185	(*( CAN_MOIPR0_type *) 0xf001a728u)	/* Message Object 185 Interrupt Pointer Register */
#define CAN_MOIPR186	(*( CAN_MOIPR0_type *) 0xf001a748u)	/* Message Object 186 Interrupt Pointer Register */
#define CAN_MOIPR187	(*( CAN_MOIPR0_type *) 0xf001a768u)	/* Message Object 187 Interrupt Pointer Register */
#define CAN_MOIPR188	(*( CAN_MOIPR0_type *) 0xf001a788u)	/* Message Object 188 Interrupt Pointer Register */
#define CAN_MOIPR189	(*( CAN_MOIPR0_type *) 0xf001a7a8u)	/* Message Object 189 Interrupt Pointer Register */
#define CAN_MOIPR19	(*( CAN_MOIPR0_type *) 0xf0019268u)	/* Message Object 19 Interrupt Pointer Register */
#define CAN_MOIPR190	(*( CAN_MOIPR0_type *) 0xf001a7c8u)	/* Message Object 190 Interrupt Pointer Register */
#define CAN_MOIPR191	(*( CAN_MOIPR0_type *) 0xf001a7e8u)	/* Message Object 191 Interrupt Pointer Register */
#define CAN_MOIPR192	(*( CAN_MOIPR0_type *) 0xf001a808u)	/* Message Object 192 Interrupt Pointer Register */
#define CAN_MOIPR193	(*( CAN_MOIPR0_type *) 0xf001a828u)	/* Message Object 193 Interrupt Pointer Register */
#define CAN_MOIPR194	(*( CAN_MOIPR0_type *) 0xf001a848u)	/* Message Object 194 Interrupt Pointer Register */
#define CAN_MOIPR195	(*( CAN_MOIPR0_type *) 0xf001a868u)	/* Message Object 195 Interrupt Pointer Register */
#define CAN_MOIPR196	(*( CAN_MOIPR0_type *) 0xf001a888u)	/* Message Object 196 Interrupt Pointer Register */
#define CAN_MOIPR197	(*( CAN_MOIPR0_type *) 0xf001a8a8u)	/* Message Object 197 Interrupt Pointer Register */
#define CAN_MOIPR198	(*( CAN_MOIPR0_type *) 0xf001a8c8u)	/* Message Object 198 Interrupt Pointer Register */
#define CAN_MOIPR199	(*( CAN_MOIPR0_type *) 0xf001a8e8u)	/* Message Object 199 Interrupt Pointer Register */
#define CAN_MOIPR2	(*( CAN_MOIPR0_type *) 0xf0019048u)	/* Message Object 2 Interrupt Pointer Register */
#define CAN_MOIPR20	(*( CAN_MOIPR0_type *) 0xf0019288u)	/* Message Object 20 Interrupt Pointer Register */
#define CAN_MOIPR200	(*( CAN_MOIPR0_type *) 0xf001a908u)	/* Message Object 200 Interrupt Pointer Register */
#define CAN_MOIPR201	(*( CAN_MOIPR0_type *) 0xf001a928u)	/* Message Object 201 Interrupt Pointer Register */
#define CAN_MOIPR202	(*( CAN_MOIPR0_type *) 0xf001a948u)	/* Message Object 202 Interrupt Pointer Register */
#define CAN_MOIPR203	(*( CAN_MOIPR0_type *) 0xf001a968u)	/* Message Object 203 Interrupt Pointer Register */
#define CAN_MOIPR204	(*( CAN_MOIPR0_type *) 0xf001a988u)	/* Message Object 204 Interrupt Pointer Register */
#define CAN_MOIPR205	(*( CAN_MOIPR0_type *) 0xf001a9a8u)	/* Message Object 205 Interrupt Pointer Register */
#define CAN_MOIPR206	(*( CAN_MOIPR0_type *) 0xf001a9c8u)	/* Message Object 206 Interrupt Pointer Register */
#define CAN_MOIPR207	(*( CAN_MOIPR0_type *) 0xf001a9e8u)	/* Message Object 207 Interrupt Pointer Register */
#define CAN_MOIPR208	(*( CAN_MOIPR0_type *) 0xf001aa08u)	/* Message Object 208 Interrupt Pointer Register */
#define CAN_MOIPR209	(*( CAN_MOIPR0_type *) 0xf001aa28u)	/* Message Object 209 Interrupt Pointer Register */
#define CAN_MOIPR21	(*( CAN_MOIPR0_type *) 0xf00192a8u)	/* Message Object 21 Interrupt Pointer Register */
#define CAN_MOIPR210	(*( CAN_MOIPR0_type *) 0xf001aa48u)	/* Message Object 210 Interrupt Pointer Register */
#define CAN_MOIPR211	(*( CAN_MOIPR0_type *) 0xf001aa68u)	/* Message Object 211 Interrupt Pointer Register */
#define CAN_MOIPR212	(*( CAN_MOIPR0_type *) 0xf001aa88u)	/* Message Object 212 Interrupt Pointer Register */
#define CAN_MOIPR213	(*( CAN_MOIPR0_type *) 0xf001aaa8u)	/* Message Object 213 Interrupt Pointer Register */
#define CAN_MOIPR214	(*( CAN_MOIPR0_type *) 0xf001aac8u)	/* Message Object 214 Interrupt Pointer Register */
#define CAN_MOIPR215	(*( CAN_MOIPR0_type *) 0xf001aae8u)	/* Message Object 215 Interrupt Pointer Register */
#define CAN_MOIPR216	(*( CAN_MOIPR0_type *) 0xf001ab08u)	/* Message Object 216 Interrupt Pointer Register */
#define CAN_MOIPR217	(*( CAN_MOIPR0_type *) 0xf001ab28u)	/* Message Object 217 Interrupt Pointer Register */
#define CAN_MOIPR218	(*( CAN_MOIPR0_type *) 0xf001ab48u)	/* Message Object 218 Interrupt Pointer Register */
#define CAN_MOIPR219	(*( CAN_MOIPR0_type *) 0xf001ab68u)	/* Message Object 219 Interrupt Pointer Register */
#define CAN_MOIPR22	(*( CAN_MOIPR0_type *) 0xf00192c8u)	/* Message Object 22 Interrupt Pointer Register */
#define CAN_MOIPR220	(*( CAN_MOIPR0_type *) 0xf001ab88u)	/* Message Object 220 Interrupt Pointer Register */
#define CAN_MOIPR221	(*( CAN_MOIPR0_type *) 0xf001aba8u)	/* Message Object 221 Interrupt Pointer Register */
#define CAN_MOIPR222	(*( CAN_MOIPR0_type *) 0xf001abc8u)	/* Message Object 222 Interrupt Pointer Register */
#define CAN_MOIPR223	(*( CAN_MOIPR0_type *) 0xf001abe8u)	/* Message Object 223 Interrupt Pointer Register */
#define CAN_MOIPR224	(*( CAN_MOIPR0_type *) 0xf001ac08u)	/* Message Object 224 Interrupt Pointer Register */
#define CAN_MOIPR225	(*( CAN_MOIPR0_type *) 0xf001ac28u)	/* Message Object 225 Interrupt Pointer Register */
#define CAN_MOIPR226	(*( CAN_MOIPR0_type *) 0xf001ac48u)	/* Message Object 226 Interrupt Pointer Register */
#define CAN_MOIPR227	(*( CAN_MOIPR0_type *) 0xf001ac68u)	/* Message Object 227 Interrupt Pointer Register */
#define CAN_MOIPR228	(*( CAN_MOIPR0_type *) 0xf001ac88u)	/* Message Object 228 Interrupt Pointer Register */
#define CAN_MOIPR229	(*( CAN_MOIPR0_type *) 0xf001aca8u)	/* Message Object 229 Interrupt Pointer Register */
#define CAN_MOIPR23	(*( CAN_MOIPR0_type *) 0xf00192e8u)	/* Message Object 23 Interrupt Pointer Register */
#define CAN_MOIPR230	(*( CAN_MOIPR0_type *) 0xf001acc8u)	/* Message Object 230 Interrupt Pointer Register */
#define CAN_MOIPR231	(*( CAN_MOIPR0_type *) 0xf001ace8u)	/* Message Object 231 Interrupt Pointer Register */
#define CAN_MOIPR232	(*( CAN_MOIPR0_type *) 0xf001ad08u)	/* Message Object 232 Interrupt Pointer Register */
#define CAN_MOIPR233	(*( CAN_MOIPR0_type *) 0xf001ad28u)	/* Message Object 233 Interrupt Pointer Register */
#define CAN_MOIPR234	(*( CAN_MOIPR0_type *) 0xf001ad48u)	/* Message Object 234 Interrupt Pointer Register */
#define CAN_MOIPR235	(*( CAN_MOIPR0_type *) 0xf001ad68u)	/* Message Object 235 Interrupt Pointer Register */
#define CAN_MOIPR236	(*( CAN_MOIPR0_type *) 0xf001ad88u)	/* Message Object 236 Interrupt Pointer Register */
#define CAN_MOIPR237	(*( CAN_MOIPR0_type *) 0xf001ada8u)	/* Message Object 237 Interrupt Pointer Register */
#define CAN_MOIPR238	(*( CAN_MOIPR0_type *) 0xf001adc8u)	/* Message Object 238 Interrupt Pointer Register */
#define CAN_MOIPR239	(*( CAN_MOIPR0_type *) 0xf001ade8u)	/* Message Object 239 Interrupt Pointer Register */
#define CAN_MOIPR24	(*( CAN_MOIPR0_type *) 0xf0019308u)	/* Message Object 24 Interrupt Pointer Register */
#define CAN_MOIPR240	(*( CAN_MOIPR0_type *) 0xf001ae08u)	/* Message Object 240 Interrupt Pointer Register */
#define CAN_MOIPR241	(*( CAN_MOIPR0_type *) 0xf001ae28u)	/* Message Object 241 Interrupt Pointer Register */
#define CAN_MOIPR242	(*( CAN_MOIPR0_type *) 0xf001ae48u)	/* Message Object 242 Interrupt Pointer Register */
#define CAN_MOIPR243	(*( CAN_MOIPR0_type *) 0xf001ae68u)	/* Message Object 243 Interrupt Pointer Register */
#define CAN_MOIPR244	(*( CAN_MOIPR0_type *) 0xf001ae88u)	/* Message Object 244 Interrupt Pointer Register */
#define CAN_MOIPR245	(*( CAN_MOIPR0_type *) 0xf001aea8u)	/* Message Object 245 Interrupt Pointer Register */
#define CAN_MOIPR246	(*( CAN_MOIPR0_type *) 0xf001aec8u)	/* Message Object 246 Interrupt Pointer Register */
#define CAN_MOIPR247	(*( CAN_MOIPR0_type *) 0xf001aee8u)	/* Message Object 247 Interrupt Pointer Register */
#define CAN_MOIPR248	(*( CAN_MOIPR0_type *) 0xf001af08u)	/* Message Object 248 Interrupt Pointer Register */
#define CAN_MOIPR249	(*( CAN_MOIPR0_type *) 0xf001af28u)	/* Message Object 249 Interrupt Pointer Register */
#define CAN_MOIPR25	(*( CAN_MOIPR0_type *) 0xf0019328u)	/* Message Object 25 Interrupt Pointer Register */
#define CAN_MOIPR250	(*( CAN_MOIPR0_type *) 0xf001af48u)	/* Message Object 250 Interrupt Pointer Register */
#define CAN_MOIPR251	(*( CAN_MOIPR0_type *) 0xf001af68u)	/* Message Object 251 Interrupt Pointer Register */
#define CAN_MOIPR252	(*( CAN_MOIPR0_type *) 0xf001af88u)	/* Message Object 252 Interrupt Pointer Register */
#define CAN_MOIPR253	(*( CAN_MOIPR0_type *) 0xf001afa8u)	/* Message Object 253 Interrupt Pointer Register */
#define CAN_MOIPR254	(*( CAN_MOIPR0_type *) 0xf001afc8u)	/* Message Object 254 Interrupt Pointer Register */
#define CAN_MOIPR255	(*( CAN_MOIPR0_type *) 0xf001afe8u)	/* Message Object 255 Interrupt Pointer Register */
#define CAN_MOIPR26	(*( CAN_MOIPR0_type *) 0xf0019348u)	/* Message Object 26 Interrupt Pointer Register */
#define CAN_MOIPR27	(*( CAN_MOIPR0_type *) 0xf0019368u)	/* Message Object 27 Interrupt Pointer Register */
#define CAN_MOIPR28	(*( CAN_MOIPR0_type *) 0xf0019388u)	/* Message Object 28 Interrupt Pointer Register */
#define CAN_MOIPR29	(*( CAN_MOIPR0_type *) 0xf00193a8u)	/* Message Object 29 Interrupt Pointer Register */
#define CAN_MOIPR3	(*( CAN_MOIPR0_type *) 0xf0019068u)	/* Message Object 3 Interrupt Pointer Register */
#define CAN_MOIPR30	(*( CAN_MOIPR0_type *) 0xf00193c8u)	/* Message Object 30 Interrupt Pointer Register */
#define CAN_MOIPR31	(*( CAN_MOIPR0_type *) 0xf00193e8u)	/* Message Object 31 Interrupt Pointer Register */
#define CAN_MOIPR32	(*( CAN_MOIPR0_type *) 0xf0019408u)	/* Message Object 32 Interrupt Pointer Register */
#define CAN_MOIPR33	(*( CAN_MOIPR0_type *) 0xf0019428u)	/* Message Object 33 Interrupt Pointer Register */
#define CAN_MOIPR34	(*( CAN_MOIPR0_type *) 0xf0019448u)	/* Message Object 34 Interrupt Pointer Register */
#define CAN_MOIPR35	(*( CAN_MOIPR0_type *) 0xf0019468u)	/* Message Object 35 Interrupt Pointer Register */
#define CAN_MOIPR36	(*( CAN_MOIPR0_type *) 0xf0019488u)	/* Message Object 36 Interrupt Pointer Register */
#define CAN_MOIPR37	(*( CAN_MOIPR0_type *) 0xf00194a8u)	/* Message Object 37 Interrupt Pointer Register */
#define CAN_MOIPR38	(*( CAN_MOIPR0_type *) 0xf00194c8u)	/* Message Object 38 Interrupt Pointer Register */
#define CAN_MOIPR39	(*( CAN_MOIPR0_type *) 0xf00194e8u)	/* Message Object 39 Interrupt Pointer Register */
#define CAN_MOIPR4	(*( CAN_MOIPR0_type *) 0xf0019088u)	/* Message Object 4 Interrupt Pointer Register */
#define CAN_MOIPR40	(*( CAN_MOIPR0_type *) 0xf0019508u)	/* Message Object 40 Interrupt Pointer Register */
#define CAN_MOIPR41	(*( CAN_MOIPR0_type *) 0xf0019528u)	/* Message Object 41 Interrupt Pointer Register */
#define CAN_MOIPR42	(*( CAN_MOIPR0_type *) 0xf0019548u)	/* Message Object 42 Interrupt Pointer Register */
#define CAN_MOIPR43	(*( CAN_MOIPR0_type *) 0xf0019568u)	/* Message Object 43 Interrupt Pointer Register */
#define CAN_MOIPR44	(*( CAN_MOIPR0_type *) 0xf0019588u)	/* Message Object 44 Interrupt Pointer Register */
#define CAN_MOIPR45	(*( CAN_MOIPR0_type *) 0xf00195a8u)	/* Message Object 45 Interrupt Pointer Register */
#define CAN_MOIPR46	(*( CAN_MOIPR0_type *) 0xf00195c8u)	/* Message Object 46 Interrupt Pointer Register */
#define CAN_MOIPR47	(*( CAN_MOIPR0_type *) 0xf00195e8u)	/* Message Object 47 Interrupt Pointer Register */
#define CAN_MOIPR48	(*( CAN_MOIPR0_type *) 0xf0019608u)	/* Message Object 48 Interrupt Pointer Register */
#define CAN_MOIPR49	(*( CAN_MOIPR0_type *) 0xf0019628u)	/* Message Object 49 Interrupt Pointer Register */
#define CAN_MOIPR5	(*( CAN_MOIPR0_type *) 0xf00190a8u)	/* Message Object 5 Interrupt Pointer Register */
#define CAN_MOIPR50	(*( CAN_MOIPR0_type *) 0xf0019648u)	/* Message Object 50 Interrupt Pointer Register */
#define CAN_MOIPR51	(*( CAN_MOIPR0_type *) 0xf0019668u)	/* Message Object 51 Interrupt Pointer Register */
#define CAN_MOIPR52	(*( CAN_MOIPR0_type *) 0xf0019688u)	/* Message Object 52 Interrupt Pointer Register */
#define CAN_MOIPR53	(*( CAN_MOIPR0_type *) 0xf00196a8u)	/* Message Object 53 Interrupt Pointer Register */
#define CAN_MOIPR54	(*( CAN_MOIPR0_type *) 0xf00196c8u)	/* Message Object 54 Interrupt Pointer Register */
#define CAN_MOIPR55	(*( CAN_MOIPR0_type *) 0xf00196e8u)	/* Message Object 55 Interrupt Pointer Register */
#define CAN_MOIPR56	(*( CAN_MOIPR0_type *) 0xf0019708u)	/* Message Object 56 Interrupt Pointer Register */
#define CAN_MOIPR57	(*( CAN_MOIPR0_type *) 0xf0019728u)	/* Message Object 57 Interrupt Pointer Register */
#define CAN_MOIPR58	(*( CAN_MOIPR0_type *) 0xf0019748u)	/* Message Object 58 Interrupt Pointer Register */
#define CAN_MOIPR59	(*( CAN_MOIPR0_type *) 0xf0019768u)	/* Message Object 59 Interrupt Pointer Register */
#define CAN_MOIPR6	(*( CAN_MOIPR0_type *) 0xf00190c8u)	/* Message Object 6 Interrupt Pointer Register */
#define CAN_MOIPR60	(*( CAN_MOIPR0_type *) 0xf0019788u)	/* Message Object 60 Interrupt Pointer Register */
#define CAN_MOIPR61	(*( CAN_MOIPR0_type *) 0xf00197a8u)	/* Message Object 61 Interrupt Pointer Register */
#define CAN_MOIPR62	(*( CAN_MOIPR0_type *) 0xf00197c8u)	/* Message Object 62 Interrupt Pointer Register */
#define CAN_MOIPR63	(*( CAN_MOIPR0_type *) 0xf00197e8u)	/* Message Object 63 Interrupt Pointer Register */
#define CAN_MOIPR64	(*( CAN_MOIPR0_type *) 0xf0019808u)	/* Message Object 64 Interrupt Pointer Register */
#define CAN_MOIPR65	(*( CAN_MOIPR0_type *) 0xf0019828u)	/* Message Object 65 Interrupt Pointer Register */
#define CAN_MOIPR66	(*( CAN_MOIPR0_type *) 0xf0019848u)	/* Message Object 66 Interrupt Pointer Register */
#define CAN_MOIPR67	(*( CAN_MOIPR0_type *) 0xf0019868u)	/* Message Object 67 Interrupt Pointer Register */
#define CAN_MOIPR68	(*( CAN_MOIPR0_type *) 0xf0019888u)	/* Message Object 68 Interrupt Pointer Register */
#define CAN_MOIPR69	(*( CAN_MOIPR0_type *) 0xf00198a8u)	/* Message Object 69 Interrupt Pointer Register */
#define CAN_MOIPR7	(*( CAN_MOIPR0_type *) 0xf00190e8u)	/* Message Object 7 Interrupt Pointer Register */
#define CAN_MOIPR70	(*( CAN_MOIPR0_type *) 0xf00198c8u)	/* Message Object 70 Interrupt Pointer Register */
#define CAN_MOIPR71	(*( CAN_MOIPR0_type *) 0xf00198e8u)	/* Message Object 71 Interrupt Pointer Register */
#define CAN_MOIPR72	(*( CAN_MOIPR0_type *) 0xf0019908u)	/* Message Object 72 Interrupt Pointer Register */
#define CAN_MOIPR73	(*( CAN_MOIPR0_type *) 0xf0019928u)	/* Message Object 73 Interrupt Pointer Register */
#define CAN_MOIPR74	(*( CAN_MOIPR0_type *) 0xf0019948u)	/* Message Object 74 Interrupt Pointer Register */
#define CAN_MOIPR75	(*( CAN_MOIPR0_type *) 0xf0019968u)	/* Message Object 75 Interrupt Pointer Register */
#define CAN_MOIPR76	(*( CAN_MOIPR0_type *) 0xf0019988u)	/* Message Object 76 Interrupt Pointer Register */
#define CAN_MOIPR77	(*( CAN_MOIPR0_type *) 0xf00199a8u)	/* Message Object 77 Interrupt Pointer Register */
#define CAN_MOIPR78	(*( CAN_MOIPR0_type *) 0xf00199c8u)	/* Message Object 78 Interrupt Pointer Register */
#define CAN_MOIPR79	(*( CAN_MOIPR0_type *) 0xf00199e8u)	/* Message Object 79 Interrupt Pointer Register */
#define CAN_MOIPR8	(*( CAN_MOIPR0_type *) 0xf0019108u)	/* Message Object 8 Interrupt Pointer Register */
#define CAN_MOIPR80	(*( CAN_MOIPR0_type *) 0xf0019a08u)	/* Message Object 80 Interrupt Pointer Register */
#define CAN_MOIPR81	(*( CAN_MOIPR0_type *) 0xf0019a28u)	/* Message Object 81 Interrupt Pointer Register */
#define CAN_MOIPR82	(*( CAN_MOIPR0_type *) 0xf0019a48u)	/* Message Object 82 Interrupt Pointer Register */
#define CAN_MOIPR83	(*( CAN_MOIPR0_type *) 0xf0019a68u)	/* Message Object 83 Interrupt Pointer Register */
#define CAN_MOIPR84	(*( CAN_MOIPR0_type *) 0xf0019a88u)	/* Message Object 84 Interrupt Pointer Register */
#define CAN_MOIPR85	(*( CAN_MOIPR0_type *) 0xf0019aa8u)	/* Message Object 85 Interrupt Pointer Register */
#define CAN_MOIPR86	(*( CAN_MOIPR0_type *) 0xf0019ac8u)	/* Message Object 86 Interrupt Pointer Register */
#define CAN_MOIPR87	(*( CAN_MOIPR0_type *) 0xf0019ae8u)	/* Message Object 87 Interrupt Pointer Register */
#define CAN_MOIPR88	(*( CAN_MOIPR0_type *) 0xf0019b08u)	/* Message Object 88 Interrupt Pointer Register */
#define CAN_MOIPR89	(*( CAN_MOIPR0_type *) 0xf0019b28u)	/* Message Object 89 Interrupt Pointer Register */
#define CAN_MOIPR9	(*( CAN_MOIPR0_type *) 0xf0019128u)	/* Message Object 9 Interrupt Pointer Register */
#define CAN_MOIPR90	(*( CAN_MOIPR0_type *) 0xf0019b48u)	/* Message Object 90 Interrupt Pointer Register */
#define CAN_MOIPR91	(*( CAN_MOIPR0_type *) 0xf0019b68u)	/* Message Object 91 Interrupt Pointer Register */
#define CAN_MOIPR92	(*( CAN_MOIPR0_type *) 0xf0019b88u)	/* Message Object 92 Interrupt Pointer Register */
#define CAN_MOIPR93	(*( CAN_MOIPR0_type *) 0xf0019ba8u)	/* Message Object 93 Interrupt Pointer Register */
#define CAN_MOIPR94	(*( CAN_MOIPR0_type *) 0xf0019bc8u)	/* Message Object 94 Interrupt Pointer Register */
#define CAN_MOIPR95	(*( CAN_MOIPR0_type *) 0xf0019be8u)	/* Message Object 95 Interrupt Pointer Register */
#define CAN_MOIPR96	(*( CAN_MOIPR0_type *) 0xf0019c08u)	/* Message Object 96 Interrupt Pointer Register */
#define CAN_MOIPR97	(*( CAN_MOIPR0_type *) 0xf0019c28u)	/* Message Object 97 Interrupt Pointer Register */
#define CAN_MOIPR98	(*( CAN_MOIPR0_type *) 0xf0019c48u)	/* Message Object 98 Interrupt Pointer Register */
#define CAN_MOIPR99	(*( CAN_MOIPR0_type *) 0xf0019c68u)	/* Message Object 99 Interrupt Pointer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXPND          : 1;	/* Receive Pending */
		/* const */ unsigned int TXPND          : 1;	/* Transmit Pending */
		/* const */ unsigned int RXUPD          : 1;	/* Receive Updating */
		/* const */ unsigned int NEWDAT         : 1;	/* New Data */
		/* const */ unsigned int MSGLST         : 1;	/* Message Lost */
		/* const */ unsigned int MSGVAL         : 1;	/* Message Valid */
		/* const */ unsigned int RTSEL          : 1;	/* Receive/Transmit Selected */
		/* const */ unsigned int RXEN           : 1;	/* Receive Enable */
		/* const */ unsigned int TXRQ           : 1;	/* Transmit Request */
		/* const */ unsigned int TXEN0          : 1;	/* Transmit Enable 0 */
		/* const */ unsigned int TXEN1          : 1;	/* Transmit Enable 1 */
		/* const */ unsigned int DIR            : 1;	/* Message Direction */
		/* const */ unsigned int LIST           : 4;	/* List Allocation */
		/* const */ unsigned int PPREV          : 8;	/* Pointer to Previous Message Object */
		/* const */ unsigned int PNEXT          : 8;	/* Pointer to Next Message Object */
	} B;
	int I;
	unsigned int U;

} CAN_MOSTAT0_type;
#define CAN_MOSTAT0	(*( CAN_MOSTAT0_type *) 0xf001901cu)	/* Message Object 0 Status Register */
#define CAN_MOSTAT1	(*( CAN_MOSTAT0_type *) 0xf001903cu)	/* Message Object 1 Status Register */
#define CAN_MOSTAT10	(*( CAN_MOSTAT0_type *) 0xf001915cu)	/* Message Object 10 Status Register */
#define CAN_MOSTAT100	(*( CAN_MOSTAT0_type *) 0xf0019c9cu)	/* Message Object 100 Status Register */
#define CAN_MOSTAT101	(*( CAN_MOSTAT0_type *) 0xf0019cbcu)	/* Message Object 101 Status Register */
#define CAN_MOSTAT102	(*( CAN_MOSTAT0_type *) 0xf0019cdcu)	/* Message Object 102 Status Register */
#define CAN_MOSTAT103	(*( CAN_MOSTAT0_type *) 0xf0019cfcu)	/* Message Object 103 Status Register */
#define CAN_MOSTAT104	(*( CAN_MOSTAT0_type *) 0xf0019d1cu)	/* Message Object 104 Status Register */
#define CAN_MOSTAT105	(*( CAN_MOSTAT0_type *) 0xf0019d3cu)	/* Message Object 105 Status Register */
#define CAN_MOSTAT106	(*( CAN_MOSTAT0_type *) 0xf0019d5cu)	/* Message Object 106 Status Register */
#define CAN_MOSTAT107	(*( CAN_MOSTAT0_type *) 0xf0019d7cu)	/* Message Object 107 Status Register */
#define CAN_MOSTAT108	(*( CAN_MOSTAT0_type *) 0xf0019d9cu)	/* Message Object 108 Status Register */
#define CAN_MOSTAT109	(*( CAN_MOSTAT0_type *) 0xf0019dbcu)	/* Message Object 109 Status Register */
#define CAN_MOSTAT11	(*( CAN_MOSTAT0_type *) 0xf001917cu)	/* Message Object 11 Status Register */
#define CAN_MOSTAT110	(*( CAN_MOSTAT0_type *) 0xf0019ddcu)	/* Message Object 110 Status Register */
#define CAN_MOSTAT111	(*( CAN_MOSTAT0_type *) 0xf0019dfcu)	/* Message Object 111 Status Register */
#define CAN_MOSTAT112	(*( CAN_MOSTAT0_type *) 0xf0019e1cu)	/* Message Object 112 Status Register */
#define CAN_MOSTAT113	(*( CAN_MOSTAT0_type *) 0xf0019e3cu)	/* Message Object 113 Status Register */
#define CAN_MOSTAT114	(*( CAN_MOSTAT0_type *) 0xf0019e5cu)	/* Message Object 114 Status Register */
#define CAN_MOSTAT115	(*( CAN_MOSTAT0_type *) 0xf0019e7cu)	/* Message Object 115 Status Register */
#define CAN_MOSTAT116	(*( CAN_MOSTAT0_type *) 0xf0019e9cu)	/* Message Object 116 Status Register */
#define CAN_MOSTAT117	(*( CAN_MOSTAT0_type *) 0xf0019ebcu)	/* Message Object 117 Status Register */
#define CAN_MOSTAT118	(*( CAN_MOSTAT0_type *) 0xf0019edcu)	/* Message Object 118 Status Register */
#define CAN_MOSTAT119	(*( CAN_MOSTAT0_type *) 0xf0019efcu)	/* Message Object 119 Status Register */
#define CAN_MOSTAT12	(*( CAN_MOSTAT0_type *) 0xf001919cu)	/* Message Object 12 Status Register */
#define CAN_MOSTAT120	(*( CAN_MOSTAT0_type *) 0xf0019f1cu)	/* Message Object 120 Status Register */
#define CAN_MOSTAT121	(*( CAN_MOSTAT0_type *) 0xf0019f3cu)	/* Message Object 121 Status Register */
#define CAN_MOSTAT122	(*( CAN_MOSTAT0_type *) 0xf0019f5cu)	/* Message Object 122 Status Register */
#define CAN_MOSTAT123	(*( CAN_MOSTAT0_type *) 0xf0019f7cu)	/* Message Object 123 Status Register */
#define CAN_MOSTAT124	(*( CAN_MOSTAT0_type *) 0xf0019f9cu)	/* Message Object 124 Status Register */
#define CAN_MOSTAT125	(*( CAN_MOSTAT0_type *) 0xf0019fbcu)	/* Message Object 125 Status Register */
#define CAN_MOSTAT126	(*( CAN_MOSTAT0_type *) 0xf0019fdcu)	/* Message Object 126 Status Register */
#define CAN_MOSTAT127	(*( CAN_MOSTAT0_type *) 0xf0019ffcu)	/* Message Object 127 Status Register */
#define CAN_MOSTAT128	(*( CAN_MOSTAT0_type *) 0xf001a01cu)	/* Message Object 128 Status Register */
#define CAN_MOSTAT129	(*( CAN_MOSTAT0_type *) 0xf001a03cu)	/* Message Object 129 Status Register */
#define CAN_MOSTAT13	(*( CAN_MOSTAT0_type *) 0xf00191bcu)	/* Message Object 13 Status Register */
#define CAN_MOSTAT130	(*( CAN_MOSTAT0_type *) 0xf001a05cu)	/* Message Object 130 Status Register */
#define CAN_MOSTAT131	(*( CAN_MOSTAT0_type *) 0xf001a07cu)	/* Message Object 131 Status Register */
#define CAN_MOSTAT132	(*( CAN_MOSTAT0_type *) 0xf001a09cu)	/* Message Object 132 Status Register */
#define CAN_MOSTAT133	(*( CAN_MOSTAT0_type *) 0xf001a0bcu)	/* Message Object 133 Status Register */
#define CAN_MOSTAT134	(*( CAN_MOSTAT0_type *) 0xf001a0dcu)	/* Message Object 134 Status Register */
#define CAN_MOSTAT135	(*( CAN_MOSTAT0_type *) 0xf001a0fcu)	/* Message Object 135 Status Register */
#define CAN_MOSTAT136	(*( CAN_MOSTAT0_type *) 0xf001a11cu)	/* Message Object 136 Status Register */
#define CAN_MOSTAT137	(*( CAN_MOSTAT0_type *) 0xf001a13cu)	/* Message Object 137 Status Register */
#define CAN_MOSTAT138	(*( CAN_MOSTAT0_type *) 0xf001a15cu)	/* Message Object 138 Status Register */
#define CAN_MOSTAT139	(*( CAN_MOSTAT0_type *) 0xf001a17cu)	/* Message Object 139 Status Register */
#define CAN_MOSTAT14	(*( CAN_MOSTAT0_type *) 0xf00191dcu)	/* Message Object 14 Status Register */
#define CAN_MOSTAT140	(*( CAN_MOSTAT0_type *) 0xf001a19cu)	/* Message Object 140 Status Register */
#define CAN_MOSTAT141	(*( CAN_MOSTAT0_type *) 0xf001a1bcu)	/* Message Object 141 Status Register */
#define CAN_MOSTAT142	(*( CAN_MOSTAT0_type *) 0xf001a1dcu)	/* Message Object 142 Status Register */
#define CAN_MOSTAT143	(*( CAN_MOSTAT0_type *) 0xf001a1fcu)	/* Message Object 143 Status Register */
#define CAN_MOSTAT144	(*( CAN_MOSTAT0_type *) 0xf001a21cu)	/* Message Object 144 Status Register */
#define CAN_MOSTAT145	(*( CAN_MOSTAT0_type *) 0xf001a23cu)	/* Message Object 145 Status Register */
#define CAN_MOSTAT146	(*( CAN_MOSTAT0_type *) 0xf001a25cu)	/* Message Object 146 Status Register */
#define CAN_MOSTAT147	(*( CAN_MOSTAT0_type *) 0xf001a27cu)	/* Message Object 147 Status Register */
#define CAN_MOSTAT148	(*( CAN_MOSTAT0_type *) 0xf001a29cu)	/* Message Object 148 Status Register */
#define CAN_MOSTAT149	(*( CAN_MOSTAT0_type *) 0xf001a2bcu)	/* Message Object 149 Status Register */
#define CAN_MOSTAT15	(*( CAN_MOSTAT0_type *) 0xf00191fcu)	/* Message Object 15 Status Register */
#define CAN_MOSTAT150	(*( CAN_MOSTAT0_type *) 0xf001a2dcu)	/* Message Object 150 Status Register */
#define CAN_MOSTAT151	(*( CAN_MOSTAT0_type *) 0xf001a2fcu)	/* Message Object 151 Status Register */
#define CAN_MOSTAT152	(*( CAN_MOSTAT0_type *) 0xf001a31cu)	/* Message Object 152 Status Register */
#define CAN_MOSTAT153	(*( CAN_MOSTAT0_type *) 0xf001a33cu)	/* Message Object 153 Status Register */
#define CAN_MOSTAT154	(*( CAN_MOSTAT0_type *) 0xf001a35cu)	/* Message Object 154 Status Register */
#define CAN_MOSTAT155	(*( CAN_MOSTAT0_type *) 0xf001a37cu)	/* Message Object 155 Status Register */
#define CAN_MOSTAT156	(*( CAN_MOSTAT0_type *) 0xf001a39cu)	/* Message Object 156 Status Register */
#define CAN_MOSTAT157	(*( CAN_MOSTAT0_type *) 0xf001a3bcu)	/* Message Object 157 Status Register */
#define CAN_MOSTAT158	(*( CAN_MOSTAT0_type *) 0xf001a3dcu)	/* Message Object 158 Status Register */
#define CAN_MOSTAT159	(*( CAN_MOSTAT0_type *) 0xf001a3fcu)	/* Message Object 159 Status Register */
#define CAN_MOSTAT16	(*( CAN_MOSTAT0_type *) 0xf001921cu)	/* Message Object 16 Status Register */
#define CAN_MOSTAT160	(*( CAN_MOSTAT0_type *) 0xf001a41cu)	/* Message Object 160 Status Register */
#define CAN_MOSTAT161	(*( CAN_MOSTAT0_type *) 0xf001a43cu)	/* Message Object 161 Status Register */
#define CAN_MOSTAT162	(*( CAN_MOSTAT0_type *) 0xf001a45cu)	/* Message Object 162 Status Register */
#define CAN_MOSTAT163	(*( CAN_MOSTAT0_type *) 0xf001a47cu)	/* Message Object 163 Status Register */
#define CAN_MOSTAT164	(*( CAN_MOSTAT0_type *) 0xf001a49cu)	/* Message Object 164 Status Register */
#define CAN_MOSTAT165	(*( CAN_MOSTAT0_type *) 0xf001a4bcu)	/* Message Object 165 Status Register */
#define CAN_MOSTAT166	(*( CAN_MOSTAT0_type *) 0xf001a4dcu)	/* Message Object 166 Status Register */
#define CAN_MOSTAT167	(*( CAN_MOSTAT0_type *) 0xf001a4fcu)	/* Message Object 167 Status Register */
#define CAN_MOSTAT168	(*( CAN_MOSTAT0_type *) 0xf001a51cu)	/* Message Object 168 Status Register */
#define CAN_MOSTAT169	(*( CAN_MOSTAT0_type *) 0xf001a53cu)	/* Message Object 169 Status Register */
#define CAN_MOSTAT17	(*( CAN_MOSTAT0_type *) 0xf001923cu)	/* Message Object 17 Status Register */
#define CAN_MOSTAT170	(*( CAN_MOSTAT0_type *) 0xf001a55cu)	/* Message Object 170 Status Register */
#define CAN_MOSTAT171	(*( CAN_MOSTAT0_type *) 0xf001a57cu)	/* Message Object 171 Status Register */
#define CAN_MOSTAT172	(*( CAN_MOSTAT0_type *) 0xf001a59cu)	/* Message Object 172 Status Register */
#define CAN_MOSTAT173	(*( CAN_MOSTAT0_type *) 0xf001a5bcu)	/* Message Object 173 Status Register */
#define CAN_MOSTAT174	(*( CAN_MOSTAT0_type *) 0xf001a5dcu)	/* Message Object 174 Status Register */
#define CAN_MOSTAT175	(*( CAN_MOSTAT0_type *) 0xf001a5fcu)	/* Message Object 175 Status Register */
#define CAN_MOSTAT176	(*( CAN_MOSTAT0_type *) 0xf001a61cu)	/* Message Object 176 Status Register */
#define CAN_MOSTAT177	(*( CAN_MOSTAT0_type *) 0xf001a63cu)	/* Message Object 177 Status Register */
#define CAN_MOSTAT178	(*( CAN_MOSTAT0_type *) 0xf001a65cu)	/* Message Object 178 Status Register */
#define CAN_MOSTAT179	(*( CAN_MOSTAT0_type *) 0xf001a67cu)	/* Message Object 179 Status Register */
#define CAN_MOSTAT18	(*( CAN_MOSTAT0_type *) 0xf001925cu)	/* Message Object 18 Status Register */
#define CAN_MOSTAT180	(*( CAN_MOSTAT0_type *) 0xf001a69cu)	/* Message Object 180 Status Register */
#define CAN_MOSTAT181	(*( CAN_MOSTAT0_type *) 0xf001a6bcu)	/* Message Object 181 Status Register */
#define CAN_MOSTAT182	(*( CAN_MOSTAT0_type *) 0xf001a6dcu)	/* Message Object 182 Status Register */
#define CAN_MOSTAT183	(*( CAN_MOSTAT0_type *) 0xf001a6fcu)	/* Message Object 183 Status Register */
#define CAN_MOSTAT184	(*( CAN_MOSTAT0_type *) 0xf001a71cu)	/* Message Object 184 Status Register */
#define CAN_MOSTAT185	(*( CAN_MOSTAT0_type *) 0xf001a73cu)	/* Message Object 185 Status Register */
#define CAN_MOSTAT186	(*( CAN_MOSTAT0_type *) 0xf001a75cu)	/* Message Object 186 Status Register */
#define CAN_MOSTAT187	(*( CAN_MOSTAT0_type *) 0xf001a77cu)	/* Message Object 187 Status Register */
#define CAN_MOSTAT188	(*( CAN_MOSTAT0_type *) 0xf001a79cu)	/* Message Object 188 Status Register */
#define CAN_MOSTAT189	(*( CAN_MOSTAT0_type *) 0xf001a7bcu)	/* Message Object 189 Status Register */
#define CAN_MOSTAT19	(*( CAN_MOSTAT0_type *) 0xf001927cu)	/* Message Object 19 Status Register */
#define CAN_MOSTAT190	(*( CAN_MOSTAT0_type *) 0xf001a7dcu)	/* Message Object 190 Status Register */
#define CAN_MOSTAT191	(*( CAN_MOSTAT0_type *) 0xf001a7fcu)	/* Message Object 191 Status Register */
#define CAN_MOSTAT192	(*( CAN_MOSTAT0_type *) 0xf001a81cu)	/* Message Object 192 Status Register */
#define CAN_MOSTAT193	(*( CAN_MOSTAT0_type *) 0xf001a83cu)	/* Message Object 193 Status Register */
#define CAN_MOSTAT194	(*( CAN_MOSTAT0_type *) 0xf001a85cu)	/* Message Object 194 Status Register */
#define CAN_MOSTAT195	(*( CAN_MOSTAT0_type *) 0xf001a87cu)	/* Message Object 195 Status Register */
#define CAN_MOSTAT196	(*( CAN_MOSTAT0_type *) 0xf001a89cu)	/* Message Object 196 Status Register */
#define CAN_MOSTAT197	(*( CAN_MOSTAT0_type *) 0xf001a8bcu)	/* Message Object 197 Status Register */
#define CAN_MOSTAT198	(*( CAN_MOSTAT0_type *) 0xf001a8dcu)	/* Message Object 198 Status Register */
#define CAN_MOSTAT199	(*( CAN_MOSTAT0_type *) 0xf001a8fcu)	/* Message Object 199 Status Register */
#define CAN_MOSTAT2	(*( CAN_MOSTAT0_type *) 0xf001905cu)	/* Message Object 2 Status Register */
#define CAN_MOSTAT20	(*( CAN_MOSTAT0_type *) 0xf001929cu)	/* Message Object 20 Status Register */
#define CAN_MOSTAT200	(*( CAN_MOSTAT0_type *) 0xf001a91cu)	/* Message Object 200 Status Register */
#define CAN_MOSTAT201	(*( CAN_MOSTAT0_type *) 0xf001a93cu)	/* Message Object 201 Status Register */
#define CAN_MOSTAT202	(*( CAN_MOSTAT0_type *) 0xf001a95cu)	/* Message Object 202 Status Register */
#define CAN_MOSTAT203	(*( CAN_MOSTAT0_type *) 0xf001a97cu)	/* Message Object 203 Status Register */
#define CAN_MOSTAT204	(*( CAN_MOSTAT0_type *) 0xf001a99cu)	/* Message Object 204 Status Register */
#define CAN_MOSTAT205	(*( CAN_MOSTAT0_type *) 0xf001a9bcu)	/* Message Object 205 Status Register */
#define CAN_MOSTAT206	(*( CAN_MOSTAT0_type *) 0xf001a9dcu)	/* Message Object 206 Status Register */
#define CAN_MOSTAT207	(*( CAN_MOSTAT0_type *) 0xf001a9fcu)	/* Message Object 207 Status Register */
#define CAN_MOSTAT208	(*( CAN_MOSTAT0_type *) 0xf001aa1cu)	/* Message Object 208 Status Register */
#define CAN_MOSTAT209	(*( CAN_MOSTAT0_type *) 0xf001aa3cu)	/* Message Object 209 Status Register */
#define CAN_MOSTAT21	(*( CAN_MOSTAT0_type *) 0xf00192bcu)	/* Message Object 21 Status Register */
#define CAN_MOSTAT210	(*( CAN_MOSTAT0_type *) 0xf001aa5cu)	/* Message Object 210 Status Register */
#define CAN_MOSTAT211	(*( CAN_MOSTAT0_type *) 0xf001aa7cu)	/* Message Object 211 Status Register */
#define CAN_MOSTAT212	(*( CAN_MOSTAT0_type *) 0xf001aa9cu)	/* Message Object 212 Status Register */
#define CAN_MOSTAT213	(*( CAN_MOSTAT0_type *) 0xf001aabcu)	/* Message Object 213 Status Register */
#define CAN_MOSTAT214	(*( CAN_MOSTAT0_type *) 0xf001aadcu)	/* Message Object 214 Status Register */
#define CAN_MOSTAT215	(*( CAN_MOSTAT0_type *) 0xf001aafcu)	/* Message Object 215 Status Register */
#define CAN_MOSTAT216	(*( CAN_MOSTAT0_type *) 0xf001ab1cu)	/* Message Object 216 Status Register */
#define CAN_MOSTAT217	(*( CAN_MOSTAT0_type *) 0xf001ab3cu)	/* Message Object 217 Status Register */
#define CAN_MOSTAT218	(*( CAN_MOSTAT0_type *) 0xf001ab5cu)	/* Message Object 218 Status Register */
#define CAN_MOSTAT219	(*( CAN_MOSTAT0_type *) 0xf001ab7cu)	/* Message Object 219 Status Register */
#define CAN_MOSTAT22	(*( CAN_MOSTAT0_type *) 0xf00192dcu)	/* Message Object 22 Status Register */
#define CAN_MOSTAT220	(*( CAN_MOSTAT0_type *) 0xf001ab9cu)	/* Message Object 220 Status Register */
#define CAN_MOSTAT221	(*( CAN_MOSTAT0_type *) 0xf001abbcu)	/* Message Object 221 Status Register */
#define CAN_MOSTAT222	(*( CAN_MOSTAT0_type *) 0xf001abdcu)	/* Message Object 222 Status Register */
#define CAN_MOSTAT223	(*( CAN_MOSTAT0_type *) 0xf001abfcu)	/* Message Object 223 Status Register */
#define CAN_MOSTAT224	(*( CAN_MOSTAT0_type *) 0xf001ac1cu)	/* Message Object 224 Status Register */
#define CAN_MOSTAT225	(*( CAN_MOSTAT0_type *) 0xf001ac3cu)	/* Message Object 225 Status Register */
#define CAN_MOSTAT226	(*( CAN_MOSTAT0_type *) 0xf001ac5cu)	/* Message Object 226 Status Register */
#define CAN_MOSTAT227	(*( CAN_MOSTAT0_type *) 0xf001ac7cu)	/* Message Object 227 Status Register */
#define CAN_MOSTAT228	(*( CAN_MOSTAT0_type *) 0xf001ac9cu)	/* Message Object 228 Status Register */
#define CAN_MOSTAT229	(*( CAN_MOSTAT0_type *) 0xf001acbcu)	/* Message Object 229 Status Register */
#define CAN_MOSTAT23	(*( CAN_MOSTAT0_type *) 0xf00192fcu)	/* Message Object 23 Status Register */
#define CAN_MOSTAT230	(*( CAN_MOSTAT0_type *) 0xf001acdcu)	/* Message Object 230 Status Register */
#define CAN_MOSTAT231	(*( CAN_MOSTAT0_type *) 0xf001acfcu)	/* Message Object 231 Status Register */
#define CAN_MOSTAT232	(*( CAN_MOSTAT0_type *) 0xf001ad1cu)	/* Message Object 232 Status Register */
#define CAN_MOSTAT233	(*( CAN_MOSTAT0_type *) 0xf001ad3cu)	/* Message Object 233 Status Register */
#define CAN_MOSTAT234	(*( CAN_MOSTAT0_type *) 0xf001ad5cu)	/* Message Object 234 Status Register */
#define CAN_MOSTAT235	(*( CAN_MOSTAT0_type *) 0xf001ad7cu)	/* Message Object 235 Status Register */
#define CAN_MOSTAT236	(*( CAN_MOSTAT0_type *) 0xf001ad9cu)	/* Message Object 236 Status Register */
#define CAN_MOSTAT237	(*( CAN_MOSTAT0_type *) 0xf001adbcu)	/* Message Object 237 Status Register */
#define CAN_MOSTAT238	(*( CAN_MOSTAT0_type *) 0xf001addcu)	/* Message Object 238 Status Register */
#define CAN_MOSTAT239	(*( CAN_MOSTAT0_type *) 0xf001adfcu)	/* Message Object 239 Status Register */
#define CAN_MOSTAT24	(*( CAN_MOSTAT0_type *) 0xf001931cu)	/* Message Object 24 Status Register */
#define CAN_MOSTAT240	(*( CAN_MOSTAT0_type *) 0xf001ae1cu)	/* Message Object 240 Status Register */
#define CAN_MOSTAT241	(*( CAN_MOSTAT0_type *) 0xf001ae3cu)	/* Message Object 241 Status Register */
#define CAN_MOSTAT242	(*( CAN_MOSTAT0_type *) 0xf001ae5cu)	/* Message Object 242 Status Register */
#define CAN_MOSTAT243	(*( CAN_MOSTAT0_type *) 0xf001ae7cu)	/* Message Object 243 Status Register */
#define CAN_MOSTAT244	(*( CAN_MOSTAT0_type *) 0xf001ae9cu)	/* Message Object 244 Status Register */
#define CAN_MOSTAT245	(*( CAN_MOSTAT0_type *) 0xf001aebcu)	/* Message Object 245 Status Register */
#define CAN_MOSTAT246	(*( CAN_MOSTAT0_type *) 0xf001aedcu)	/* Message Object 246 Status Register */
#define CAN_MOSTAT247	(*( CAN_MOSTAT0_type *) 0xf001aefcu)	/* Message Object 247 Status Register */
#define CAN_MOSTAT248	(*( CAN_MOSTAT0_type *) 0xf001af1cu)	/* Message Object 248 Status Register */
#define CAN_MOSTAT249	(*( CAN_MOSTAT0_type *) 0xf001af3cu)	/* Message Object 249 Status Register */
#define CAN_MOSTAT25	(*( CAN_MOSTAT0_type *) 0xf001933cu)	/* Message Object 25 Status Register */
#define CAN_MOSTAT250	(*( CAN_MOSTAT0_type *) 0xf001af5cu)	/* Message Object 250 Status Register */
#define CAN_MOSTAT251	(*( CAN_MOSTAT0_type *) 0xf001af7cu)	/* Message Object 251 Status Register */
#define CAN_MOSTAT252	(*( CAN_MOSTAT0_type *) 0xf001af9cu)	/* Message Object 252 Status Register */
#define CAN_MOSTAT253	(*( CAN_MOSTAT0_type *) 0xf001afbcu)	/* Message Object 253 Status Register */
#define CAN_MOSTAT254	(*( CAN_MOSTAT0_type *) 0xf001afdcu)	/* Message Object 254 Status Register */
#define CAN_MOSTAT255	(*( CAN_MOSTAT0_type *) 0xf001affcu)	/* Message Object 255 Status Register */
#define CAN_MOSTAT26	(*( CAN_MOSTAT0_type *) 0xf001935cu)	/* Message Object 26 Status Register */
#define CAN_MOSTAT27	(*( CAN_MOSTAT0_type *) 0xf001937cu)	/* Message Object 27 Status Register */
#define CAN_MOSTAT28	(*( CAN_MOSTAT0_type *) 0xf001939cu)	/* Message Object 28 Status Register */
#define CAN_MOSTAT29	(*( CAN_MOSTAT0_type *) 0xf00193bcu)	/* Message Object 29 Status Register */
#define CAN_MOSTAT3	(*( CAN_MOSTAT0_type *) 0xf001907cu)	/* Message Object 3 Status Register */
#define CAN_MOSTAT30	(*( CAN_MOSTAT0_type *) 0xf00193dcu)	/* Message Object 30 Status Register */
#define CAN_MOSTAT31	(*( CAN_MOSTAT0_type *) 0xf00193fcu)	/* Message Object 31 Status Register */
#define CAN_MOSTAT32	(*( CAN_MOSTAT0_type *) 0xf001941cu)	/* Message Object 32 Status Register */
#define CAN_MOSTAT33	(*( CAN_MOSTAT0_type *) 0xf001943cu)	/* Message Object 33 Status Register */
#define CAN_MOSTAT34	(*( CAN_MOSTAT0_type *) 0xf001945cu)	/* Message Object 34 Status Register */
#define CAN_MOSTAT35	(*( CAN_MOSTAT0_type *) 0xf001947cu)	/* Message Object 35 Status Register */
#define CAN_MOSTAT36	(*( CAN_MOSTAT0_type *) 0xf001949cu)	/* Message Object 36 Status Register */
#define CAN_MOSTAT37	(*( CAN_MOSTAT0_type *) 0xf00194bcu)	/* Message Object 37 Status Register */
#define CAN_MOSTAT38	(*( CAN_MOSTAT0_type *) 0xf00194dcu)	/* Message Object 38 Status Register */
#define CAN_MOSTAT39	(*( CAN_MOSTAT0_type *) 0xf00194fcu)	/* Message Object 39 Status Register */
#define CAN_MOSTAT4	(*( CAN_MOSTAT0_type *) 0xf001909cu)	/* Message Object 4 Status Register */
#define CAN_MOSTAT40	(*( CAN_MOSTAT0_type *) 0xf001951cu)	/* Message Object 40 Status Register */
#define CAN_MOSTAT41	(*( CAN_MOSTAT0_type *) 0xf001953cu)	/* Message Object 41 Status Register */
#define CAN_MOSTAT42	(*( CAN_MOSTAT0_type *) 0xf001955cu)	/* Message Object 42 Status Register */
#define CAN_MOSTAT43	(*( CAN_MOSTAT0_type *) 0xf001957cu)	/* Message Object 43 Status Register */
#define CAN_MOSTAT44	(*( CAN_MOSTAT0_type *) 0xf001959cu)	/* Message Object 44 Status Register */
#define CAN_MOSTAT45	(*( CAN_MOSTAT0_type *) 0xf00195bcu)	/* Message Object 45 Status Register */
#define CAN_MOSTAT46	(*( CAN_MOSTAT0_type *) 0xf00195dcu)	/* Message Object 46 Status Register */
#define CAN_MOSTAT47	(*( CAN_MOSTAT0_type *) 0xf00195fcu)	/* Message Object 47 Status Register */
#define CAN_MOSTAT48	(*( CAN_MOSTAT0_type *) 0xf001961cu)	/* Message Object 48 Status Register */
#define CAN_MOSTAT49	(*( CAN_MOSTAT0_type *) 0xf001963cu)	/* Message Object 49 Status Register */
#define CAN_MOSTAT5	(*( CAN_MOSTAT0_type *) 0xf00190bcu)	/* Message Object 5 Status Register */
#define CAN_MOSTAT50	(*( CAN_MOSTAT0_type *) 0xf001965cu)	/* Message Object 50 Status Register */
#define CAN_MOSTAT51	(*( CAN_MOSTAT0_type *) 0xf001967cu)	/* Message Object 51 Status Register */
#define CAN_MOSTAT52	(*( CAN_MOSTAT0_type *) 0xf001969cu)	/* Message Object 52 Status Register */
#define CAN_MOSTAT53	(*( CAN_MOSTAT0_type *) 0xf00196bcu)	/* Message Object 53 Status Register */
#define CAN_MOSTAT54	(*( CAN_MOSTAT0_type *) 0xf00196dcu)	/* Message Object 54 Status Register */
#define CAN_MOSTAT55	(*( CAN_MOSTAT0_type *) 0xf00196fcu)	/* Message Object 55 Status Register */
#define CAN_MOSTAT56	(*( CAN_MOSTAT0_type *) 0xf001971cu)	/* Message Object 56 Status Register */
#define CAN_MOSTAT57	(*( CAN_MOSTAT0_type *) 0xf001973cu)	/* Message Object 57 Status Register */
#define CAN_MOSTAT58	(*( CAN_MOSTAT0_type *) 0xf001975cu)	/* Message Object 58 Status Register */
#define CAN_MOSTAT59	(*( CAN_MOSTAT0_type *) 0xf001977cu)	/* Message Object 59 Status Register */
#define CAN_MOSTAT6	(*( CAN_MOSTAT0_type *) 0xf00190dcu)	/* Message Object 6 Status Register */
#define CAN_MOSTAT60	(*( CAN_MOSTAT0_type *) 0xf001979cu)	/* Message Object 60 Status Register */
#define CAN_MOSTAT61	(*( CAN_MOSTAT0_type *) 0xf00197bcu)	/* Message Object 61 Status Register */
#define CAN_MOSTAT62	(*( CAN_MOSTAT0_type *) 0xf00197dcu)	/* Message Object 62 Status Register */
#define CAN_MOSTAT63	(*( CAN_MOSTAT0_type *) 0xf00197fcu)	/* Message Object 63 Status Register */
#define CAN_MOSTAT64	(*( CAN_MOSTAT0_type *) 0xf001981cu)	/* Message Object 64 Status Register */
#define CAN_MOSTAT65	(*( CAN_MOSTAT0_type *) 0xf001983cu)	/* Message Object 65 Status Register */
#define CAN_MOSTAT66	(*( CAN_MOSTAT0_type *) 0xf001985cu)	/* Message Object 66 Status Register */
#define CAN_MOSTAT67	(*( CAN_MOSTAT0_type *) 0xf001987cu)	/* Message Object 67 Status Register */
#define CAN_MOSTAT68	(*( CAN_MOSTAT0_type *) 0xf001989cu)	/* Message Object 68 Status Register */
#define CAN_MOSTAT69	(*( CAN_MOSTAT0_type *) 0xf00198bcu)	/* Message Object 69 Status Register */
#define CAN_MOSTAT7	(*( CAN_MOSTAT0_type *) 0xf00190fcu)	/* Message Object 7 Status Register */
#define CAN_MOSTAT70	(*( CAN_MOSTAT0_type *) 0xf00198dcu)	/* Message Object 70 Status Register */
#define CAN_MOSTAT71	(*( CAN_MOSTAT0_type *) 0xf00198fcu)	/* Message Object 71 Status Register */
#define CAN_MOSTAT72	(*( CAN_MOSTAT0_type *) 0xf001991cu)	/* Message Object 72 Status Register */
#define CAN_MOSTAT73	(*( CAN_MOSTAT0_type *) 0xf001993cu)	/* Message Object 73 Status Register */
#define CAN_MOSTAT74	(*( CAN_MOSTAT0_type *) 0xf001995cu)	/* Message Object 74 Status Register */
#define CAN_MOSTAT75	(*( CAN_MOSTAT0_type *) 0xf001997cu)	/* Message Object 75 Status Register */
#define CAN_MOSTAT76	(*( CAN_MOSTAT0_type *) 0xf001999cu)	/* Message Object 76 Status Register */
#define CAN_MOSTAT77	(*( CAN_MOSTAT0_type *) 0xf00199bcu)	/* Message Object 77 Status Register */
#define CAN_MOSTAT78	(*( CAN_MOSTAT0_type *) 0xf00199dcu)	/* Message Object 78 Status Register */
#define CAN_MOSTAT79	(*( CAN_MOSTAT0_type *) 0xf00199fcu)	/* Message Object 79 Status Register */
#define CAN_MOSTAT8	(*( CAN_MOSTAT0_type *) 0xf001911cu)	/* Message Object 8 Status Register */
#define CAN_MOSTAT80	(*( CAN_MOSTAT0_type *) 0xf0019a1cu)	/* Message Object 80 Status Register */
#define CAN_MOSTAT81	(*( CAN_MOSTAT0_type *) 0xf0019a3cu)	/* Message Object 81 Status Register */
#define CAN_MOSTAT82	(*( CAN_MOSTAT0_type *) 0xf0019a5cu)	/* Message Object 82 Status Register */
#define CAN_MOSTAT83	(*( CAN_MOSTAT0_type *) 0xf0019a7cu)	/* Message Object 83 Status Register */
#define CAN_MOSTAT84	(*( CAN_MOSTAT0_type *) 0xf0019a9cu)	/* Message Object 84 Status Register */
#define CAN_MOSTAT85	(*( CAN_MOSTAT0_type *) 0xf0019abcu)	/* Message Object 85 Status Register */
#define CAN_MOSTAT86	(*( CAN_MOSTAT0_type *) 0xf0019adcu)	/* Message Object 86 Status Register */
#define CAN_MOSTAT87	(*( CAN_MOSTAT0_type *) 0xf0019afcu)	/* Message Object 87 Status Register */
#define CAN_MOSTAT88	(*( CAN_MOSTAT0_type *) 0xf0019b1cu)	/* Message Object 88 Status Register */
#define CAN_MOSTAT89	(*( CAN_MOSTAT0_type *) 0xf0019b3cu)	/* Message Object 89 Status Register */
#define CAN_MOSTAT9	(*( CAN_MOSTAT0_type *) 0xf001913cu)	/* Message Object 9 Status Register */
#define CAN_MOSTAT90	(*( CAN_MOSTAT0_type *) 0xf0019b5cu)	/* Message Object 90 Status Register */
#define CAN_MOSTAT91	(*( CAN_MOSTAT0_type *) 0xf0019b7cu)	/* Message Object 91 Status Register */
#define CAN_MOSTAT92	(*( CAN_MOSTAT0_type *) 0xf0019b9cu)	/* Message Object 92 Status Register */
#define CAN_MOSTAT93	(*( CAN_MOSTAT0_type *) 0xf0019bbcu)	/* Message Object 93 Status Register */
#define CAN_MOSTAT94	(*( CAN_MOSTAT0_type *) 0xf0019bdcu)	/* Message Object 94 Status Register */
#define CAN_MOSTAT95	(*( CAN_MOSTAT0_type *) 0xf0019bfcu)	/* Message Object 95 Status Register */
#define CAN_MOSTAT96	(*( CAN_MOSTAT0_type *) 0xf0019c1cu)	/* Message Object 96 Status Register */
#define CAN_MOSTAT97	(*( CAN_MOSTAT0_type *) 0xf0019c3cu)	/* Message Object 97 Status Register */
#define CAN_MOSTAT98	(*( CAN_MOSTAT0_type *) 0xf0019c5cu)	/* Message Object 98 Status Register */
#define CAN_MOSTAT99	(*( CAN_MOSTAT0_type *) 0xf0019c7cu)	/* Message Object 99 Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int INDEX          : 6;	/* Message Pending Index */
		/* const */ unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} CAN_MSID0_type;
#define CAN_MSID0	(*( CAN_MSID0_type *) 0xf0018180u)	/* Message Index Register 0 */
#define CAN_MSID1	(*( CAN_MSID0_type *) 0xf0018184u)	/* Message Index Register 1 */
#define CAN_MSID2	(*( CAN_MSID0_type *) 0xf0018188u)	/* Message Index Register 2 */
#define CAN_MSID3	(*( CAN_MSID0_type *) 0xf001818cu)	/* Message Index Register 3 */
#define CAN_MSID4	(*( CAN_MSID0_type *) 0xf0018190u)	/* Message Index Register 4 */
#define CAN_MSID5	(*( CAN_MSID0_type *) 0xf0018194u)	/* Message Index Register 5 */
#define CAN_MSID6	(*( CAN_MSID0_type *) 0xf0018198u)	/* Message Index Register 6 */
#define CAN_MSID7	(*( CAN_MSID0_type *) 0xf001819cu)	/* Message Index Register 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int IM             : 32;	/* Message Index Mask */
	} B;
	int I;
	unsigned int U;

} CAN_MSIMASK_type;
#define CAN_MSIMASK	(*( CAN_MSIMASK_type *) 0xf00181c0u)	/* Message Index Mask Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PND            : 32;	/* Message Pending */
	} B;
	int I;
	unsigned int U;

} CAN_MSPND0_type;
#define CAN_MSPND0	(*( CAN_MSPND0_type *) 0xf0018140u)	/* Message Pending Register 0 */
#define CAN_MSPND1	(*( CAN_MSPND0_type *) 0xf0018144u)	/* Message Pending Register 1 */
#define CAN_MSPND2	(*( CAN_MSPND0_type *) 0xf0018148u)	/* Message Pending Register 2 */
#define CAN_MSPND3	(*( CAN_MSPND0_type *) 0xf001814cu)	/* Message Pending Register 3 */
#define CAN_MSPND4	(*( CAN_MSPND0_type *) 0xf0018150u)	/* Message Pending Register 4 */
#define CAN_MSPND5	(*( CAN_MSPND0_type *) 0xf0018154u)	/* Message Pending Register 5 */
#define CAN_MSPND6	(*( CAN_MSPND0_type *) 0xf0018158u)	/* Message Pending Register 6 */
#define CAN_MSPND7	(*( CAN_MSPND0_type *) 0xf001815cu)	/* Message Pending Register 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int BRP            : 6;	/* Baud Rate Prescaler */
		unsigned int SJW            : 2;	/* (Re) Synchronization Jump Width */
		unsigned int TSEG1          : 4;	/* Time Segment Before Sample Point */
		unsigned int TSEG2          : 3;	/* Time Segment After Sample Point */
		unsigned int DIV8           : 1;	/* Divide Prescaler Clock by 8 */
		unsigned int FTX            : 1;	/* Fast Transmit (TTCAN only) */
		unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} CAN_NBTR0_type;
#define CAN_NBTR0	(*( CAN_NBTR0_type *) 0xf0018210u)	/* Node 0 Bit Timing Register */
#define CAN_NBTR1	(*( CAN_NBTR0_type *) 0xf0018310u)	/* Node 1 Bit Timing Register */
#define CAN_NBTR2	(*( CAN_NBTR0_type *) 0xf0018410u)	/* Node 2 Bit Timing Register */
#define CAN_NBTR3	(*( CAN_NBTR0_type *) 0xf0018510u)	/* Node 3 Bit Timing Register */
#define CAN_NBTR4	(*( CAN_NBTR0_type *) 0xf0018610u)	/* Node 4 Bit Timing Register */
#define CAN_NBTR5	(*( CAN_NBTR0_type *) 0xf0018710u)	/* Node 5 Bit Timing Register */
#define CAN_NBTR6	(*( CAN_NBTR0_type *) 0xf0018810u)	/* Node 6 Bit Timing Register */
#define CAN_NBTR7	(*( CAN_NBTR0_type *) 0xf0018910u)	/* Node 7 Bit Timing Register */

typedef volatile union
{
	struct
	{ 
		unsigned int INIT           : 1;	/* Node Initialization */
		unsigned int TRIE           : 1;	/* Transfer Interrupt Enable */
		unsigned int LECIE          : 1;	/* LEC Indicated Error Interrupt Enable */
		unsigned int ALIE           : 1;	/* Alert Interrupt Enable */
		unsigned int CANDIS         : 1;	/* CAN Disable */
		unsigned int TXDIS          : 1;	/* Transmit Disable */
		unsigned int CCE            : 1;	/* Configuration Change Enable */
		unsigned int CALM           : 1;	/* CAN Analyzer Mode */
		unsigned int SUSEN          : 1;	/* Suspend Enable */
		unsigned int                : 23;
	} B;
	int I;
	unsigned int U;

} CAN_NCR0_type;
#define CAN_NCR0	(*( CAN_NCR0_type *) 0xf0018200u)	/* Node 0 Control Register */
#define CAN_NCR1	(*( CAN_NCR0_type *) 0xf0018300u)	/* Node 1 Control Register */
#define CAN_NCR2	(*( CAN_NCR0_type *) 0xf0018400u)	/* Node 2 Control Register */
#define CAN_NCR3	(*( CAN_NCR0_type *) 0xf0018500u)	/* Node 3 Control Register */
#define CAN_NCR4	(*( CAN_NCR0_type *) 0xf0018600u)	/* Node 4 Control Register */
#define CAN_NCR5	(*( CAN_NCR0_type *) 0xf0018700u)	/* Node 5 Control Register */
#define CAN_NCR6	(*( CAN_NCR0_type *) 0xf0018800u)	/* Node 6 Control Register */
#define CAN_NCR7	(*( CAN_NCR0_type *) 0xf0018900u)	/* Node 7 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int REC            : 8;	/* Receive Error Counter */
		unsigned int TEC            : 8;	/* Transmit Error Counter */
		unsigned int EWRNLVL        : 8;	/* Error Warning Level */
		/* const */ unsigned int LETD           : 1;	/* Last Error Transfer Direction */
		/* const */ unsigned int LEINC          : 1;	/* Last Error Increment */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} CAN_NECNT0_type;
#define CAN_NECNT0	(*( CAN_NECNT0_type *) 0xf0018214u)	/* Node 0 Error Counter Register */
#define CAN_NECNT1	(*( CAN_NECNT0_type *) 0xf0018314u)	/* Node 1 Error Counter Register */
#define CAN_NECNT2	(*( CAN_NECNT0_type *) 0xf0018414u)	/* Node 2 Error Counter Register */
#define CAN_NECNT3	(*( CAN_NECNT0_type *) 0xf0018514u)	/* Node 3 Error Counter Register */
#define CAN_NECNT4	(*( CAN_NECNT0_type *) 0xf0018614u)	/* Node 4 Error Counter Register */
#define CAN_NECNT5	(*( CAN_NECNT0_type *) 0xf0018714u)	/* Node 5 Error Counter Register */
#define CAN_NECNT6	(*( CAN_NECNT0_type *) 0xf0018814u)	/* Node 6 Error Counter Register */
#define CAN_NECNT7	(*( CAN_NECNT0_type *) 0xf0018914u)	/* Node 7 Error Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CFC            : 16;	/* CAN Frame Counter */
		unsigned int CFSEL          : 3;	/* CAN Frame Count Selection */
		unsigned int CFMOD          : 2;	/* CAN Frame Counter Mode */
		unsigned int                : 1;
		unsigned int CFCIE          : 1;	/* CAN Frame Count Interrupt Enable */
		unsigned int CFCOV          : 1;	/* CAN Frame Counter Overflow Flag */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CAN_NFCR0_type;
#define CAN_NFCR0	(*( CAN_NFCR0_type *) 0xf0018218u)	/* Node 0 Frame Counter Register */
#define CAN_NFCR1	(*( CAN_NFCR0_type *) 0xf0018318u)	/* Node 1 Frame Counter Register */
#define CAN_NFCR2	(*( CAN_NFCR0_type *) 0xf0018418u)	/* Node 2 Frame Counter Register */
#define CAN_NFCR3	(*( CAN_NFCR0_type *) 0xf0018518u)	/* Node 3 Frame Counter Register */
#define CAN_NFCR4	(*( CAN_NFCR0_type *) 0xf0018618u)	/* Node 4 Frame Counter Register */
#define CAN_NFCR5	(*( CAN_NFCR0_type *) 0xf0018718u)	/* Node 5 Frame Counter Register */
#define CAN_NFCR6	(*( CAN_NFCR0_type *) 0xf0018818u)	/* Node 6 Frame Counter Register */
#define CAN_NFCR7	(*( CAN_NFCR0_type *) 0xf0018918u)	/* Node 7 Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ALINP          : 4;	/* Alert Interrupt Node Pointer */
		unsigned int LECINP         : 4;	/* Last Error Code Interrupt Node Pointer */
		unsigned int TRINP          : 4;	/* Transfer OK Interrupt Node Pointer */
		unsigned int CFCINP         : 4;	/* Frame Counter Interrupt Node Pointer */
		unsigned int TEINP          : 4;	/* Timer Event Interrupt Node Pointer */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CAN_NIPR0_type;
#define CAN_NIPR0	(*( CAN_NIPR0_type *) 0xf0018208u)	/* Node 0 Interrupt Pointer Register */
#define CAN_NIPR1	(*( CAN_NIPR0_type *) 0xf0018308u)	/* Node 1 Interrupt Pointer Register */
#define CAN_NIPR2	(*( CAN_NIPR0_type *) 0xf0018408u)	/* Node 2 Interrupt Pointer Register */
#define CAN_NIPR3	(*( CAN_NIPR0_type *) 0xf0018508u)	/* Node 3 Interrupt Pointer Register */
#define CAN_NIPR4	(*( CAN_NIPR0_type *) 0xf0018608u)	/* Node 4 Interrupt Pointer Register */
#define CAN_NIPR5	(*( CAN_NIPR0_type *) 0xf0018708u)	/* Node 5 Interrupt Pointer Register */
#define CAN_NIPR6	(*( CAN_NIPR0_type *) 0xf0018808u)	/* Node 6 Interrupt Pointer Register */
#define CAN_NIPR7	(*( CAN_NIPR0_type *) 0xf0018908u)	/* Node 7 Interrupt Pointer Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RXSEL          : 3;	/* Receive Select */
		unsigned int                : 5;
		unsigned int LBM            : 1;	/* Loop-Back Mode */
		unsigned int                : 23;
	} B;
	int I;
	unsigned int U;

} CAN_NPCR0_type;
#define CAN_NPCR0	(*( CAN_NPCR0_type *) 0xf001820cu)	/* Node 0 Port Control Register */
#define CAN_NPCR1	(*( CAN_NPCR0_type *) 0xf001830cu)	/* Node 1 Port Control Register */
#define CAN_NPCR2	(*( CAN_NPCR0_type *) 0xf001840cu)	/* Node 2 Port Control Register */
#define CAN_NPCR3	(*( CAN_NPCR0_type *) 0xf001850cu)	/* Node 3 Port Control Register */
#define CAN_NPCR4	(*( CAN_NPCR0_type *) 0xf001860cu)	/* Node 4 Port Control Register */
#define CAN_NPCR5	(*( CAN_NPCR0_type *) 0xf001870cu)	/* Node 5 Port Control Register */
#define CAN_NPCR6	(*( CAN_NPCR0_type *) 0xf001880cu)	/* Node 6 Port Control Register */
#define CAN_NPCR7	(*( CAN_NPCR0_type *) 0xf001890cu)	/* Node 7 Port Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LEC            : 3;	/* Last Error Code */
		unsigned int TXOK           : 1;	/* Message Transmitted Successfully */
		unsigned int RXOK           : 1;	/* Message Received Successfully */
		unsigned int ALERT          : 1;	/* Alert Warning */
		/* const */ unsigned int EWRN           : 1;	/* Error Warning Status */
		/* const */ unsigned int BOFF           : 1;	/* Bus-off Status */
		unsigned int LLE            : 1;	/* List Length Error */
		unsigned int LOE            : 1;	/* List Object Error */
		/* const */ unsigned int SUSACK         : 1;	/* Suspend Acknowledge */
		unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} CAN_NSR0_type;
#define CAN_NSR0	(*( CAN_NSR0_type *) 0xf0018204u)	/* Node 0 Status Register */
#define CAN_NSR1	(*( CAN_NSR0_type *) 0xf0018304u)	/* Node 1 Status Register */
#define CAN_NSR2	(*( CAN_NSR0_type *) 0xf0018404u)	/* Node 2 Status Register */
#define CAN_NSR3	(*( CAN_NSR0_type *) 0xf0018504u)	/* Node 3 Status Register */
#define CAN_NSR4	(*( CAN_NSR0_type *) 0xf0018604u)	/* Node 4 Status Register */
#define CAN_NSR5	(*( CAN_NSR0_type *) 0xf0018704u)	/* Node 5 Status Register */
#define CAN_NSR6	(*( CAN_NSR0_type *) 0xf0018804u)	/* Node 6 Status Register */
#define CAN_NSR7	(*( CAN_NSR0_type *) 0xf0018904u)	/* Node 7 Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RELOAD         : 16;	/* Reload Value */
		unsigned int TXMO           : 8;	/* Transmit Message Object */
		unsigned int STRT           : 1;	/* Timer Start */
		unsigned int                : 7;
	} B;
	int I;
	unsigned int U;

} CAN_NTATTR0_type;
#define CAN_NTATTR0	(*( CAN_NTATTR0_type *) 0xf0018224u)	/* Node 0 Timer A Transmit Trigger Register */
#define CAN_NTATTR1	(*( CAN_NTATTR0_type *) 0xf0018324u)	/* Node 1 Timer A Transmit Trigger Register */
#define CAN_NTATTR2	(*( CAN_NTATTR0_type *) 0xf0018424u)	/* Node 2 Timer A Transmit Trigger Register */
#define CAN_NTATTR3	(*( CAN_NTATTR0_type *) 0xf0018524u)	/* Node 3 Timer A Transmit Trigger Register */
#define CAN_NTATTR4	(*( CAN_NTATTR0_type *) 0xf0018624u)	/* Node 4 Timer A Transmit Trigger Register */
#define CAN_NTATTR5	(*( CAN_NTATTR0_type *) 0xf0018724u)	/* Node 5 Timer A Transmit Trigger Register */
#define CAN_NTATTR6	(*( CAN_NTATTR0_type *) 0xf0018824u)	/* Node 6 Timer A Transmit Trigger Register */
#define CAN_NTATTR7	(*( CAN_NTATTR0_type *) 0xf0018924u)	/* Node 7 Timer A Transmit Trigger Register */
#define CAN_NTBTTR0	(*( CAN_NTATTR0_type *) 0xf0018228u)	/* Node 0 Timer B Transmit Trigger Register */
#define CAN_NTBTTR1	(*( CAN_NTATTR0_type *) 0xf0018328u)	/* Node 1 Timer B Transmit Trigger Register */
#define CAN_NTBTTR2	(*( CAN_NTATTR0_type *) 0xf0018428u)	/* Node 2 Timer B Transmit Trigger Register */
#define CAN_NTBTTR3	(*( CAN_NTATTR0_type *) 0xf0018528u)	/* Node 3 Timer B Transmit Trigger Register */
#define CAN_NTBTTR4	(*( CAN_NTATTR0_type *) 0xf0018628u)	/* Node 4 Timer B Transmit Trigger Register */
#define CAN_NTBTTR5	(*( CAN_NTATTR0_type *) 0xf0018728u)	/* Node 5 Timer B Transmit Trigger Register */
#define CAN_NTBTTR6	(*( CAN_NTATTR0_type *) 0xf0018828u)	/* Node 6 Timer B Transmit Trigger Register */
#define CAN_NTBTTR7	(*( CAN_NTATTR0_type *) 0xf0018928u)	/* Node 7 Timer B Transmit Trigger Register */
#define CAN_NTCTTR0	(*( CAN_NTATTR0_type *) 0xf001822cu)	/* Node 0 Timer C Transmit Trigger Register */
#define CAN_NTCTTR1	(*( CAN_NTATTR0_type *) 0xf001832cu)	/* Node 1 Timer C Transmit Trigger Register */
#define CAN_NTCTTR2	(*( CAN_NTATTR0_type *) 0xf001842cu)	/* Node 2 Timer C Transmit Trigger Register */
#define CAN_NTCTTR3	(*( CAN_NTATTR0_type *) 0xf001852cu)	/* Node 3 Timer C Transmit Trigger Register */
#define CAN_NTCTTR4	(*( CAN_NTATTR0_type *) 0xf001862cu)	/* Node 4 Timer C Transmit Trigger Register */
#define CAN_NTCTTR5	(*( CAN_NTATTR0_type *) 0xf001872cu)	/* Node 5 Timer C Transmit Trigger Register */
#define CAN_NTCTTR6	(*( CAN_NTATTR0_type *) 0xf001882cu)	/* Node 6 Timer C Transmit Trigger Register */
#define CAN_NTCTTR7	(*( CAN_NTATTR0_type *) 0xf001892cu)	/* Node 7 Timer C Transmit Trigger Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 8;
		unsigned int TPSC           : 4;	/* Timer Prescaler */
		unsigned int                : 6;
		unsigned int TRIGSRC        : 3;	/* Trigger Source */
		unsigned int                : 11;
	} B;
	int I;
	unsigned int U;

} CAN_NTCCR0_type;
#define CAN_NTCCR0	(*( CAN_NTCCR0_type *) 0xf001821cu)	/* Node 0 Timer Clock Control Register */
#define CAN_NTCCR1	(*( CAN_NTCCR0_type *) 0xf001831cu)	/* Node 1 Timer Clock Control Register */
#define CAN_NTCCR2	(*( CAN_NTCCR0_type *) 0xf001841cu)	/* Node 2 Timer Clock Control Register */
#define CAN_NTCCR3	(*( CAN_NTCCR0_type *) 0xf001851cu)	/* Node 3 Timer Clock Control Register */
#define CAN_NTCCR4	(*( CAN_NTCCR0_type *) 0xf001861cu)	/* Node 4 Timer Clock Control Register */
#define CAN_NTCCR5	(*( CAN_NTCCR0_type *) 0xf001871cu)	/* Node 5 Timer Clock Control Register */
#define CAN_NTCCR6	(*( CAN_NTCCR0_type *) 0xf001881cu)	/* Node 6 Timer Clock Control Register */
#define CAN_NTCCR7	(*( CAN_NTCCR0_type *) 0xf001891cu)	/* Node 7 Timer Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RELOAD         : 16;	/* Reload Value */
		unsigned int                : 6;
		unsigned int TEIE           : 1;	/* Timer Event Interrupt Enable */
		unsigned int TE             : 1;	/* Timer Event */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CAN_NTRTR0_type;
#define CAN_NTRTR0	(*( CAN_NTRTR0_type *) 0xf0018220u)	/* Node 0 Timer Receive Timeout Register */
#define CAN_NTRTR1	(*( CAN_NTRTR0_type *) 0xf0018320u)	/* Node 1 Timer Receive Timeout Register */
#define CAN_NTRTR2	(*( CAN_NTRTR0_type *) 0xf0018420u)	/* Node 2 Timer Receive Timeout Register */
#define CAN_NTRTR3	(*( CAN_NTRTR0_type *) 0xf0018520u)	/* Node 3 Timer Receive Timeout Register */
#define CAN_NTRTR4	(*( CAN_NTRTR0_type *) 0xf0018620u)	/* Node 4 Timer Receive Timeout Register */
#define CAN_NTRTR5	(*( CAN_NTRTR0_type *) 0xf0018720u)	/* Node 5 Timer Receive Timeout Register */
#define CAN_NTRTR6	(*( CAN_NTRTR0_type *) 0xf0018820u)	/* Node 6 Timer Receive Timeout Register */
#define CAN_NTRTR7	(*( CAN_NTRTR0_type *) 0xf0018920u)	/* Node 7 Timer Receive Timeout Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 2;	/* Trigger Set for OTGB0/1 */
		unsigned int TGB            : 1;	/* OTGB0/1 Bus Select */
		unsigned int TG_P           : 1;	/* TGS, TGB Write Protection */
		unsigned int                : 20;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} CAN_OCS_type;
#define CAN_OCS	(*( CAN_OCS_type *) 0xf00180e8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		unsigned int PANCMD         : 8;	/* Panel Command */
		/* const */ unsigned int BUSY           : 1;	/* Panel Busy Flag */
		/* const */ unsigned int RBUSY          : 1;	/* Result Busy Flag */
		unsigned int                : 6;
		unsigned int PANAR1         : 8;	/* Panel Argument 1 */
		unsigned int PANAR2         : 8;	/* Panel Argument 2 */
	} B;
	int I;
	unsigned int U;

} CAN_PANCTR_type;
#define CAN_PANCTR	(*( CAN_PANCTR_type *) 0xf00181c4u)	/* Panel Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 9;
		/* const */ unsigned int REFMFR         : 7;	/* Reference Mark Fraction */
		/* const */ unsigned int REFM           : 16;	/* Reference Mark */
	} B;
	int I;
	unsigned int U;

} CAN_REFMR_type;
#define CAN_REFMR	(*( CAN_REFMR_type *) 0xf0018288u)	/* Reference Mark Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int INP            : 4;	/* Interrupt Node Pointer */
		/* const */ unsigned int IENTRAF0       : 1;	/* Interrupt Enable if TRAF=0 */
		/* const */ unsigned int IENTRAF1       : 1;	/* Interrupt Enable if TRAF=1 */
		/* const */ unsigned int IENRECF0       : 1;	/* Interrupt Enable if RECF=0 */
		/* const */ unsigned int IENRECF1       : 1;	/* Interrupt Enable if RECF=1 */
		/* const */ unsigned int CHEN           : 1;	/* Check Enable */
		/* const */ unsigned int TREN           : 1;	/* Transmit Enable */
		/* const */ unsigned int ALTMSG         : 2;	/* Alternative Message */
		/* const */ unsigned int ARBM           : 2;	/* Arbitration Mode */
		/* const */ unsigned int GM             : 1;	/* Gap Mode */
		/* const */ unsigned int ICF            : 1;	/* Instruction Collection Finished */
		/* const */ unsigned int RCEV           : 1;	/* Receive Control Entry Valid */
		/* const */ unsigned int TCEV           : 1;	/* Transmit Control Entry Valid */
		/* const */ unsigned int ICEV           : 1;	/* Interrupt Control Entry Valid */
		/* const */ unsigned int ARBV           : 1;	/* Arbitration Entry Valid */
		/* const */ unsigned int TMEV           : 1;	/* Time Mark Entry Valid */
		/* const */ unsigned int RMEV           : 1;	/* Reference Mark Entry Valid */
		/* const */ unsigned int BCEV           : 1;	/* Basic Cycle End Entry Valid */
		/* const */ unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} CAN_SISR_type;
#define CAN_SISR	(*( CAN_SISR_type *) 0xf00182f8u)	/* Scheduler Instruction Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int STPTR          : 7;	/* Start Pointer */
		/* const */ unsigned int                : 25;
	} B;
	int I;
	unsigned int U;

} CAN_STPTR0_type;
#define CAN_STPTR0	(*( CAN_STPTR0_type *) 0xf001bffcu)	/* Scheduler Start Pointer Node 0 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TMETMV         : 16;	/* Time Mark Value from TME */
		/* const */ unsigned int RCEMSGNR       : 8;	/* Receive Control Entry Message Number */
		/* const */ unsigned int TCEMSGNR       : 8;	/* Transmit Control Entry Message Number */
	} B;
	int I;
	unsigned int U;

} CAN_STSRH_type;
#define CAN_STSRH	(*( CAN_STSRH_type *) 0xf00182f4u)	/* Scheduler Timing Status Register High */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RMETMV         : 16;	/* Time Mark Value from RME */
		/* const */ unsigned int BCETMV         : 16;	/* Time Mark Value from BCE */
	} B;
	int I;
	unsigned int U;

} CAN_STSRL_type;
#define CAN_STSRL	(*( CAN_STSRL_type *) 0xf00182f0u)	/* Scheduler Timing Status Register Low */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 9;
		/* const */ unsigned int SYNMFR         : 7;	/* Synchronization Mark Fraction */
		/* const */ unsigned int SYNM           : 16;	/* Synchronization Mark */
	} B;
	int I;
	unsigned int U;

} CAN_SYNMR_type;
#define CAN_SYNMR	(*( CAN_SYNMR_type *) 0xf0018284u)	/* Synchronization Mark Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IRO            : 7;	/* Initial Reference Offset */
		unsigned int                : 1;
		unsigned int EXPTT          : 8;	/* Expected Transmit Triggers */
		/* const */ unsigned int RTO            : 8;	/* Reference Trigger Offset */
		/* const */ unsigned int TTCNT          : 8;	/* Transmit Trigger Counter */
	} B;
	int I;
	unsigned int U;

} CAN_TTCFGR_type;
#define CAN_TTCFGR	(*( CAN_TTCFGR_type *) 0xf00182c4u)	/* Time Trigger Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TTM            : 2;	/* Time Trigger Mode */
		unsigned int ETESEL         : 2;	/* External Trigger Event Selection */
		unsigned int ETSSEL         : 3;	/* External Trigger Source Selection */
		unsigned int ETM            : 1;	/* External Trigger Mode */
		unsigned int TTLVL          : 1;	/* Time Trigger Level */
		unsigned int LTCTSS         : 3;	/* Local Time Capture Trigger Source Select */
		unsigned int TMPRIO         : 3;	/* Time Master Priority */
		unsigned int ETSSEX         : 1;	/* External Trigger Source Select Extension */
		unsigned int CYCLE          : 6;	/* Basic Cycle Number */
		unsigned int                : 2;
		unsigned int TENW           : 4;	/* Transmit Enable Window */
		unsigned int RMDLC          : 4;	/* Reference Message DLC */
	} B;
	int I;
	unsigned int U;

} CAN_TTCR_type;
#define CAN_TTCR	(*( CAN_TTCR_type *) 0xf00182c0u)	/* Time Trigger Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CFGMEL         : 2;	/* Configuration Mode Enter/Leave */
		unsigned int NIGSR          : 2;	/* Next Is Gap Flag Set/Reset */
		unsigned int STE            : 1;	/* Software Trigger Event */
		unsigned int ETREVR         : 1;	/* Reset External Trigger Event */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} CAN_TTFMR_type;
#define CAN_TTFMR	(*( CAN_TTFMR_type *) 0xf00182ccu)	/* Time Trigger Flag Modification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NBCIE          : 2;	/* New Basic Cycle Interrupt Enable */
		unsigned int TENWERIE       : 1;	/* Transmit Enable Window Error Interrupt Enable */
		unsigned int TTERIE         : 1;	/* Transmit Trigger Error Interrupt Enable */
		unsigned int                : 2;
		unsigned int WTEIE          : 1;	/* Watch Trigger Event Interrupt Enable */
		unsigned int AWDIE          : 1;	/* Application Watchdog Interrupt Enable */
		unsigned int ERRSCIE        : 1;	/* Error State Change Interrupt Enable */
		unsigned int MSRCIE         : 1;	/* Master Slave Relation Change Interrupt Enable */
		unsigned int SYNCSCIE       : 1;	/* Synchronization State Change Interrupt Enable */
		unsigned int SEIE           : 1;	/* Scheduler Error Interrupt Enable */
		unsigned int NOTIFIE        : 1;	/* Notification Interrupt Enable */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} CAN_TTIER_type;
#define CAN_TTIER	(*( CAN_TTIER_type *) 0xf00182d4u)	/* Time Trigger Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ERRINP         : 4;	/* Error Interrupt Node Pointer */
		unsigned int NBCINP         : 4;	/* New Basic Cycle Interrupt Node Pointer */
		unsigned int NOTIFINP       : 4;	/* Notification Interrupt Node Pointer */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CAN_TTINPR_type;
#define CAN_TTINPR	(*( CAN_TTINPR_type *) 0xf00182d8u)	/* Time Trigger Interrupt Node Pointer Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NMC            : 1;	/* New Matrix Cycle */
		unsigned int NBC            : 1;	/* New Basic Cycle */
		unsigned int TENWER         : 1;	/* Transmit Enable Window Error */
		unsigned int TTUF           : 1;	/* Transmit Trigger Underflow */
		unsigned int TTOF           : 1;	/* Transmit Trigger Overflow */
		unsigned int WTE            : 1;	/* Watch Trigger EventThe WTE can be generated only after the first message has been transferred on the bus. */
		unsigned int IWTE           : 1;	/* Init Watch Trigger EventThe IWTE can be generated only until the first message has been transferred on the bus. */
		unsigned int AWDERR         : 1;	/* Application Watchdog Error */
		unsigned int ERRSC          : 1;	/* Error State Change */
		unsigned int MSRC           : 1;	/* Master-Slave Relation Change */
		unsigned int SYNCSC         : 1;	/* Synchronization State Change */
		unsigned int EOS            : 1;	/* End Of Scheduler Entry Flag */
		unsigned int WFE            : 1;	/* Wait For Event Flag */
		unsigned int DISC           : 1;	/* Discontinuity Flag */
		unsigned int SERR1          : 1;	/* Scheduler Error 1 Flag */
		unsigned int SERR2          : 1;	/* Scheduler Error 2 Flag */
		unsigned int CFGERR         : 1;	/* Configuration Error */
		unsigned int TURERR         : 1;	/* TUR Adjust Error */
		unsigned int                : 14;
	} B;
	int I;
	unsigned int U;

} CAN_TTIRR_type;
#define CAN_TTIRR	(*( CAN_TTIRR_type *) 0xf00182d0u)	/* Time Trigger Interrupt Request Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ERRS           : 2;	/* Error State */
		/* const */ unsigned int MSR            : 2;	/* Master-Slave Relation */
		/* const */ unsigned int SYNCS          : 2;	/* Synchronization State */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int EFI            : 1;	/* Error Frame Indication */
		/* const */ unsigned int EFF            : 1;	/* Error Frame Flag */
		/* const */ unsigned int REFTRG         : 1;	/* Reference Trigger Flag */
		/* const */ unsigned int ARB            : 1;	/* Arbitration Window Flag */
		/* const */ unsigned int CFGM           : 1;	/* Configuration Mode Flag */
		/* const */ unsigned int TMPC           : 1;	/* Time Master Priority Conflict */
		/* const */ unsigned int TRAF           : 1;	/* Transmission Finished Flag */
		/* const */ unsigned int RECF           : 1;	/* Reception Finished Flag */
		/* const */ unsigned int MSCMIN         : 3;	/* Minimum of MSC Bit Fields */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int MSCMAX         : 3;	/* Maximum of MSC Bit Fields */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int NIG            : 1;	/* Next Is Gap */
		/* const */ unsigned int ETR            : 1;	/* External Trigger Request */
		/* const */ unsigned int ETREV          : 1;	/* External Trigger Event */
		/* const */ unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} CAN_TTSR_type;
#define CAN_TTSR	(*( CAN_TTSR_type *) 0xf00182c8u)	/* Time Trigger Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADJEN          : 1;	/* Adjust Enable */
		unsigned int                : 5;
		unsigned int TURADJ         : 10;	/* Time Unit Ratio Adjust */
		/* const */ unsigned int VAL            : 1;	/* Valid */
		unsigned int LTCS           : 1;	/* Local Time Clock Source */
		unsigned int LTDIV          : 3;	/* Local Time Divider */
		unsigned int                : 1;
		/* const */ unsigned int TUR            : 10;	/* TUR */
	} B;
	int I;
	unsigned int U;

} CAN_TURR_type;
#define CAN_TURR	(*( CAN_TURR_type *) 0xf0018290u)	/* Time Unit Ratio Register */


/* DMA */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} DMA_ACCEN00_type;
#define DMA_ACCEN00	(*( DMA_ACCEN00_type *) 0xf00148fcu)	/* DMA Sub-block 0 Access Enable Register 0 */
#define DMA_ACCEN10	(*( DMA_ACCEN00_type *) 0xf00158fcu)	/* DMA Sub-block 1 Access Enable Register 0 */
#define SDMA_ACCEN00	(*( DMA_ACCEN00_type *) 0xf00108fcu)	/* SDMA Sub-block 0 Access Enable Register 0 */
#define SDMA_ACCEN10	(*( DMA_ACCEN00_type *) 0xf00118fcu)	/* SDMA Sub-block 1 Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} DMA_ACCEN01_type;
#define DMA_ACCEN01	(*( DMA_ACCEN01_type *) 0xf00148f8u)	/* DMA Sub-block 0 Access Enable Register 1 */
#define DMA_ACCEN11	(*( DMA_ACCEN01_type *) 0xf00158f8u)	/* DMA Sub-block 1 Access Enable Register 1 */
#define SDMA_ACCEN01	(*( DMA_ACCEN01_type *) 0xf00108f8u)	/* SDMA Sub-block 0 Access Enable Register 1 */
#define SDMA_ACCEN11	(*( DMA_ACCEN01_type *) 0xf00118f8u)	/* SDMA Sub-block 1 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int SMF            : 3;	/* Source Address Modification Factor */
		unsigned int INCS           : 1;	/* Increment of Source Address */
		unsigned int DMF            : 3;	/* Destination Address Modification Factor */
		unsigned int INCD           : 1;	/* Increment of Destination Address */
		unsigned int CBLS           : 4;	/* Circular Buffer Length Source */
		unsigned int CBLD           : 4;	/* Circular Buffer Length Destination */
		unsigned int SHCT           : 2;	/* Shadow Control */
		unsigned int SHWEN          : 1;	/* Shadow Address Register Write Enable */
		/* const */ unsigned int RES            : 13;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} DMA_ADRCR000_type;
#define DMA_ADRCR000	(*( DMA_ADRCR000_type *) 0xf001408cu)	/* DMA Channel 000 Address Control Register */
#define DMA_ADRCR001	(*( DMA_ADRCR000_type *) 0xf00140acu)	/* DMA Channel 001 Address Control Register */
#define DMA_ADRCR002	(*( DMA_ADRCR000_type *) 0xf00140ccu)	/* DMA Channel 002 Address Control Register */
#define DMA_ADRCR003	(*( DMA_ADRCR000_type *) 0xf00140ecu)	/* DMA Channel 003 Address Control Register */
#define DMA_ADRCR004	(*( DMA_ADRCR000_type *) 0xf001410cu)	/* DMA Channel 004 Address Control Register */
#define DMA_ADRCR005	(*( DMA_ADRCR000_type *) 0xf001412cu)	/* DMA Channel 005 Address Control Register */
#define DMA_ADRCR006	(*( DMA_ADRCR000_type *) 0xf001414cu)	/* DMA Channel 006 Address Control Register */
#define DMA_ADRCR007	(*( DMA_ADRCR000_type *) 0xf001416cu)	/* DMA Channel 007 Address Control Register */
#define DMA_ADRCR008	(*( DMA_ADRCR000_type *) 0xf001418cu)	/* DMA Channel 008 Address Control Register */
#define DMA_ADRCR009	(*( DMA_ADRCR000_type *) 0xf00141acu)	/* DMA Channel 009 Address Control Register */
#define DMA_ADRCR010	(*( DMA_ADRCR000_type *) 0xf00141ccu)	/* DMA Channel 010 Address Control Register */
#define DMA_ADRCR011	(*( DMA_ADRCR000_type *) 0xf00141ecu)	/* DMA Channel 011 Address Control Register */
#define DMA_ADRCR012	(*( DMA_ADRCR000_type *) 0xf001420cu)	/* DMA Channel 012 Address Control Register */
#define DMA_ADRCR013	(*( DMA_ADRCR000_type *) 0xf001422cu)	/* DMA Channel 013 Address Control Register */
#define DMA_ADRCR014	(*( DMA_ADRCR000_type *) 0xf001424cu)	/* DMA Channel 014 Address Control Register */
#define DMA_ADRCR015	(*( DMA_ADRCR000_type *) 0xf001426cu)	/* DMA Channel 015 Address Control Register */
#define DMA_ADRCR016	(*( DMA_ADRCR000_type *) 0xf001428cu)	/* DMA Channel 016 Address Control Register */
#define DMA_ADRCR017	(*( DMA_ADRCR000_type *) 0xf00142acu)	/* DMA Channel 017 Address Control Register */
#define DMA_ADRCR018	(*( DMA_ADRCR000_type *) 0xf00142ccu)	/* DMA Channel 018 Address Control Register */
#define DMA_ADRCR019	(*( DMA_ADRCR000_type *) 0xf00142ecu)	/* DMA Channel 019 Address Control Register */
#define DMA_ADRCR020	(*( DMA_ADRCR000_type *) 0xf001430cu)	/* DMA Channel 020 Address Control Register */
#define DMA_ADRCR021	(*( DMA_ADRCR000_type *) 0xf001432cu)	/* DMA Channel 021 Address Control Register */
#define DMA_ADRCR022	(*( DMA_ADRCR000_type *) 0xf001434cu)	/* DMA Channel 022 Address Control Register */
#define DMA_ADRCR023	(*( DMA_ADRCR000_type *) 0xf001436cu)	/* DMA Channel 023 Address Control Register */
#define DMA_ADRCR100	(*( DMA_ADRCR000_type *) 0xf001508cu)	/* DMA Channel 100 Address Control Register */
#define DMA_ADRCR101	(*( DMA_ADRCR000_type *) 0xf00150acu)	/* DMA Channel 101 Address Control Register */
#define DMA_ADRCR102	(*( DMA_ADRCR000_type *) 0xf00150ccu)	/* DMA Channel 102 Address Control Register */
#define DMA_ADRCR103	(*( DMA_ADRCR000_type *) 0xf00150ecu)	/* DMA Channel 103 Address Control Register */
#define DMA_ADRCR104	(*( DMA_ADRCR000_type *) 0xf001510cu)	/* DMA Channel 104 Address Control Register */
#define DMA_ADRCR105	(*( DMA_ADRCR000_type *) 0xf001512cu)	/* DMA Channel 105 Address Control Register */
#define DMA_ADRCR106	(*( DMA_ADRCR000_type *) 0xf001514cu)	/* DMA Channel 106 Address Control Register */
#define DMA_ADRCR107	(*( DMA_ADRCR000_type *) 0xf001516cu)	/* DMA Channel 107 Address Control Register */
#define DMA_ADRCR108	(*( DMA_ADRCR000_type *) 0xf001518cu)	/* DMA Channel 108 Address Control Register */
#define DMA_ADRCR109	(*( DMA_ADRCR000_type *) 0xf00151acu)	/* DMA Channel 109 Address Control Register */
#define DMA_ADRCR110	(*( DMA_ADRCR000_type *) 0xf00151ccu)	/* DMA Channel 110 Address Control Register */
#define DMA_ADRCR111	(*( DMA_ADRCR000_type *) 0xf00151ecu)	/* DMA Channel 111 Address Control Register */
#define DMA_ADRCR112	(*( DMA_ADRCR000_type *) 0xf001520cu)	/* DMA Channel 112 Address Control Register */
#define DMA_ADRCR113	(*( DMA_ADRCR000_type *) 0xf001522cu)	/* DMA Channel 113 Address Control Register */
#define DMA_ADRCR114	(*( DMA_ADRCR000_type *) 0xf001524cu)	/* DMA Channel 114 Address Control Register */
#define DMA_ADRCR115	(*( DMA_ADRCR000_type *) 0xf001526cu)	/* DMA Channel 115 Address Control Register */
#define DMA_ADRCR116	(*( DMA_ADRCR000_type *) 0xf001528cu)	/* DMA Channel 116 Address Control Register */
#define DMA_ADRCR117	(*( DMA_ADRCR000_type *) 0xf00152acu)	/* DMA Channel 117 Address Control Register */
#define DMA_ADRCR118	(*( DMA_ADRCR000_type *) 0xf00152ccu)	/* DMA Channel 118 Address Control Register */
#define DMA_ADRCR119	(*( DMA_ADRCR000_type *) 0xf00152ecu)	/* DMA Channel 119 Address Control Register */
#define DMA_ADRCR120	(*( DMA_ADRCR000_type *) 0xf001530cu)	/* DMA Channel 120 Address Control Register */
#define DMA_ADRCR121	(*( DMA_ADRCR000_type *) 0xf001532cu)	/* DMA Channel 121 Address Control Register */
#define DMA_ADRCR122	(*( DMA_ADRCR000_type *) 0xf001534cu)	/* DMA Channel 122 Address Control Register */
#define DMA_ADRCR123	(*( DMA_ADRCR000_type *) 0xf001536cu)	/* DMA Channel 123 Address Control Register */
#define SDMA_ADRCR000	(*( DMA_ADRCR000_type *) 0xf001008cu)	/* SDMA Channel 000 Address Control Register */
#define SDMA_ADRCR001	(*( DMA_ADRCR000_type *) 0xf00100acu)	/* SDMA Channel 001 Address Control Register */
#define SDMA_ADRCR002	(*( DMA_ADRCR000_type *) 0xf00100ccu)	/* SDMA Channel 002 Address Control Register */
#define SDMA_ADRCR003	(*( DMA_ADRCR000_type *) 0xf00100ecu)	/* SDMA Channel 003 Address Control Register */
#define SDMA_ADRCR004	(*( DMA_ADRCR000_type *) 0xf001010cu)	/* SDMA Channel 004 Address Control Register */
#define SDMA_ADRCR005	(*( DMA_ADRCR000_type *) 0xf001012cu)	/* SDMA Channel 005 Address Control Register */
#define SDMA_ADRCR006	(*( DMA_ADRCR000_type *) 0xf001014cu)	/* SDMA Channel 006 Address Control Register */
#define SDMA_ADRCR007	(*( DMA_ADRCR000_type *) 0xf001016cu)	/* SDMA Channel 007 Address Control Register */
#define SDMA_ADRCR100	(*( DMA_ADRCR000_type *) 0xf001108cu)	/* SDMA Channel 100 Address Control Register */
#define SDMA_ADRCR101	(*( DMA_ADRCR000_type *) 0xf00110acu)	/* SDMA Channel 101 Address Control Register */
#define SDMA_ADRCR102	(*( DMA_ADRCR000_type *) 0xf00110ccu)	/* SDMA Channel 102 Address Control Register */
#define SDMA_ADRCR103	(*( DMA_ADRCR000_type *) 0xf00110ecu)	/* SDMA Channel 103 Address Control Register */
#define SDMA_ADRCR104	(*( DMA_ADRCR000_type *) 0xf001110cu)	/* SDMA Channel 104 Address Control Register */
#define SDMA_ADRCR105	(*( DMA_ADRCR000_type *) 0xf001112cu)	/* SDMA Channel 105 Address Control Register */
#define SDMA_ADRCR106	(*( DMA_ADRCR000_type *) 0xf001114cu)	/* SDMA Channel 106 Address Control Register */
#define SDMA_ADRCR107	(*( DMA_ADRCR000_type *) 0xf001116cu)	/* SDMA Channel 107 Address Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TREL           : 14;	/* Transfer Reload Value */
		/* const */ unsigned int RES            : 2;	/* Reserved */
		unsigned int BLKM           : 3;	/* Block Mode */
		unsigned int RROAT          : 1;	/* Reset Request Only After Transaction */
		unsigned int CHMODE         : 1;	/* Channel Operation Mode */
		unsigned int CHDW           : 2;	/* Channel Data Width */
		unsigned int                : 1;
		unsigned int PATSEL         : 2;	/* Pattern Select */
		unsigned int ECH            : 1;	/* Enable Hardware Transfer Request */
		unsigned int DCH            : 1;	/* Disable Hardware Transfer Request */
		unsigned int PRSEL          : 1;	/* Peripheral Request Select */
		unsigned int SCH            : 1;	/* Set Transaction Request for DMA Channel z */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} DMA_CHCR000_type;
#define DMA_CHCR000	(*( DMA_CHCR000_type *) 0xf0014084u)	/* DMA Channel 000 Control Register */
#define DMA_CHCR001	(*( DMA_CHCR000_type *) 0xf00140a4u)	/* DMA Channel 001 Control Register */
#define DMA_CHCR002	(*( DMA_CHCR000_type *) 0xf00140c4u)	/* DMA Channel 002 Control Register */
#define DMA_CHCR003	(*( DMA_CHCR000_type *) 0xf00140e4u)	/* DMA Channel 003 Control Register */
#define DMA_CHCR004	(*( DMA_CHCR000_type *) 0xf0014104u)	/* DMA Channel 004 Control Register */
#define DMA_CHCR005	(*( DMA_CHCR000_type *) 0xf0014124u)	/* DMA Channel 005 Control Register */
#define DMA_CHCR006	(*( DMA_CHCR000_type *) 0xf0014144u)	/* DMA Channel 006 Control Register */
#define DMA_CHCR007	(*( DMA_CHCR000_type *) 0xf0014164u)	/* DMA Channel 007 Control Register */
#define DMA_CHCR008	(*( DMA_CHCR000_type *) 0xf0014184u)	/* DMA Channel 008 Control Register */
#define DMA_CHCR009	(*( DMA_CHCR000_type *) 0xf00141a4u)	/* DMA Channel 009 Control Register */
#define DMA_CHCR010	(*( DMA_CHCR000_type *) 0xf00141c4u)	/* DMA Channel 010 Control Register */
#define DMA_CHCR011	(*( DMA_CHCR000_type *) 0xf00141e4u)	/* DMA Channel 011 Control Register */
#define DMA_CHCR012	(*( DMA_CHCR000_type *) 0xf0014204u)	/* DMA Channel 012 Control Register */
#define DMA_CHCR013	(*( DMA_CHCR000_type *) 0xf0014224u)	/* DMA Channel 013 Control Register */
#define DMA_CHCR014	(*( DMA_CHCR000_type *) 0xf0014244u)	/* DMA Channel 014 Control Register */
#define DMA_CHCR015	(*( DMA_CHCR000_type *) 0xf0014264u)	/* DMA Channel 015 Control Register */
#define DMA_CHCR016	(*( DMA_CHCR000_type *) 0xf0014284u)	/* DMA Channel 016 Control Register */
#define DMA_CHCR017	(*( DMA_CHCR000_type *) 0xf00142a4u)	/* DMA Channel 017 Control Register */
#define DMA_CHCR018	(*( DMA_CHCR000_type *) 0xf00142c4u)	/* DMA Channel 018 Control Register */
#define DMA_CHCR019	(*( DMA_CHCR000_type *) 0xf00142e4u)	/* DMA Channel 019 Control Register */
#define DMA_CHCR020	(*( DMA_CHCR000_type *) 0xf0014304u)	/* DMA Channel 020 Control Register */
#define DMA_CHCR021	(*( DMA_CHCR000_type *) 0xf0014324u)	/* DMA Channel 021 Control Register */
#define DMA_CHCR022	(*( DMA_CHCR000_type *) 0xf0014344u)	/* DMA Channel 022 Control Register */
#define DMA_CHCR023	(*( DMA_CHCR000_type *) 0xf0014364u)	/* DMA Channel 023 Control Register */
#define DMA_CHCR100	(*( DMA_CHCR000_type *) 0xf0015084u)	/* DMA Channel 100 Control Register */
#define DMA_CHCR101	(*( DMA_CHCR000_type *) 0xf00150a4u)	/* DMA Channel 101 Control Register */
#define DMA_CHCR102	(*( DMA_CHCR000_type *) 0xf00150c4u)	/* DMA Channel 102 Control Register */
#define DMA_CHCR103	(*( DMA_CHCR000_type *) 0xf00150e4u)	/* DMA Channel 103 Control Register */
#define DMA_CHCR104	(*( DMA_CHCR000_type *) 0xf0015104u)	/* DMA Channel 104 Control Register */
#define DMA_CHCR105	(*( DMA_CHCR000_type *) 0xf0015124u)	/* DMA Channel 105 Control Register */
#define DMA_CHCR106	(*( DMA_CHCR000_type *) 0xf0015144u)	/* DMA Channel 106 Control Register */
#define DMA_CHCR107	(*( DMA_CHCR000_type *) 0xf0015164u)	/* DMA Channel 107 Control Register */
#define DMA_CHCR108	(*( DMA_CHCR000_type *) 0xf0015184u)	/* DMA Channel 108 Control Register */
#define DMA_CHCR109	(*( DMA_CHCR000_type *) 0xf00151a4u)	/* DMA Channel 109 Control Register */
#define DMA_CHCR110	(*( DMA_CHCR000_type *) 0xf00151c4u)	/* DMA Channel 110 Control Register */
#define DMA_CHCR111	(*( DMA_CHCR000_type *) 0xf00151e4u)	/* DMA Channel 111 Control Register */
#define DMA_CHCR112	(*( DMA_CHCR000_type *) 0xf0015204u)	/* DMA Channel 112 Control Register */
#define DMA_CHCR113	(*( DMA_CHCR000_type *) 0xf0015224u)	/* DMA Channel 113 Control Register */
#define DMA_CHCR114	(*( DMA_CHCR000_type *) 0xf0015244u)	/* DMA Channel 114 Control Register */
#define DMA_CHCR115	(*( DMA_CHCR000_type *) 0xf0015264u)	/* DMA Channel 115 Control Register */
#define DMA_CHCR116	(*( DMA_CHCR000_type *) 0xf0015284u)	/* DMA Channel 116 Control Register */
#define DMA_CHCR117	(*( DMA_CHCR000_type *) 0xf00152a4u)	/* DMA Channel 117 Control Register */
#define DMA_CHCR118	(*( DMA_CHCR000_type *) 0xf00152c4u)	/* DMA Channel 118 Control Register */
#define DMA_CHCR119	(*( DMA_CHCR000_type *) 0xf00152e4u)	/* DMA Channel 119 Control Register */
#define DMA_CHCR120	(*( DMA_CHCR000_type *) 0xf0015304u)	/* DMA Channel 120 Control Register */
#define DMA_CHCR121	(*( DMA_CHCR000_type *) 0xf0015324u)	/* DMA Channel 121 Control Register */
#define DMA_CHCR122	(*( DMA_CHCR000_type *) 0xf0015344u)	/* DMA Channel 122 Control Register */
#define DMA_CHCR123	(*( DMA_CHCR000_type *) 0xf0015364u)	/* DMA Channel 123 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int WRPSE          : 1;	/* Wrap Source Enable */
		unsigned int WRPDE          : 1;	/* Wrap Destination Enable */
		unsigned int INTCT          : 2;	/* Interrupt Control */
		unsigned int ETRL           : 1;	/* Enable Transaction Request Lost Interrupt */
		/* const */ unsigned int RES            : 7;	/* Reserved */
		unsigned int IRDV           : 4;	/* Interrupt Raise Detect Value */
		unsigned int CWRP           : 1;	/* Clear Wrap Buffer Interrupt xz */
		unsigned int                : 1;
		unsigned int CICH           : 1;	/* Clear Interrupt for DMA Channel xz */
		unsigned int                : 1;
		unsigned int CTL            : 1;	/* Clear Transaction Request Lost for DMA Channel xz */
		unsigned int                : 11;
	} B;
	int I;
	unsigned int U;

} DMA_CHICR000_type;
#define DMA_CHICR000	(*( DMA_CHICR000_type *) 0xf0014088u)	/* DMA Channel 000 Interrupt Control Register */
#define DMA_CHICR001	(*( DMA_CHICR000_type *) 0xf00140a8u)	/* DMA Channel 001 Interrupt Control Register */
#define DMA_CHICR002	(*( DMA_CHICR000_type *) 0xf00140c8u)	/* DMA Channel 002 Interrupt Control Register */
#define DMA_CHICR003	(*( DMA_CHICR000_type *) 0xf00140e8u)	/* DMA Channel 003 Interrupt Control Register */
#define DMA_CHICR004	(*( DMA_CHICR000_type *) 0xf0014108u)	/* DMA Channel 004 Interrupt Control Register */
#define DMA_CHICR005	(*( DMA_CHICR000_type *) 0xf0014128u)	/* DMA Channel 005 Interrupt Control Register */
#define DMA_CHICR006	(*( DMA_CHICR000_type *) 0xf0014148u)	/* DMA Channel 006 Interrupt Control Register */
#define DMA_CHICR007	(*( DMA_CHICR000_type *) 0xf0014168u)	/* DMA Channel 007 Interrupt Control Register */
#define DMA_CHICR008	(*( DMA_CHICR000_type *) 0xf0014188u)	/* DMA Channel 008 Interrupt Control Register */
#define DMA_CHICR009	(*( DMA_CHICR000_type *) 0xf00141a8u)	/* DMA Channel 009 Interrupt Control Register */
#define DMA_CHICR010	(*( DMA_CHICR000_type *) 0xf00141c8u)	/* DMA Channel 010 Interrupt Control Register */
#define DMA_CHICR011	(*( DMA_CHICR000_type *) 0xf00141e8u)	/* DMA Channel 011 Interrupt Control Register */
#define DMA_CHICR012	(*( DMA_CHICR000_type *) 0xf0014208u)	/* DMA Channel 012 Interrupt Control Register */
#define DMA_CHICR013	(*( DMA_CHICR000_type *) 0xf0014228u)	/* DMA Channel 013 Interrupt Control Register */
#define DMA_CHICR014	(*( DMA_CHICR000_type *) 0xf0014248u)	/* DMA Channel 014 Interrupt Control Register */
#define DMA_CHICR015	(*( DMA_CHICR000_type *) 0xf0014268u)	/* DMA Channel 015 Interrupt Control Register */
#define DMA_CHICR016	(*( DMA_CHICR000_type *) 0xf0014288u)	/* DMA Channel 016 Interrupt Control Register */
#define DMA_CHICR017	(*( DMA_CHICR000_type *) 0xf00142a8u)	/* DMA Channel 017 Interrupt Control Register */
#define DMA_CHICR018	(*( DMA_CHICR000_type *) 0xf00142c8u)	/* DMA Channel 018 Interrupt Control Register */
#define DMA_CHICR019	(*( DMA_CHICR000_type *) 0xf00142e8u)	/* DMA Channel 019 Interrupt Control Register */
#define DMA_CHICR020	(*( DMA_CHICR000_type *) 0xf0014308u)	/* DMA Channel 020 Interrupt Control Register */
#define DMA_CHICR021	(*( DMA_CHICR000_type *) 0xf0014328u)	/* DMA Channel 021 Interrupt Control Register */
#define DMA_CHICR022	(*( DMA_CHICR000_type *) 0xf0014348u)	/* DMA Channel 022 Interrupt Control Register */
#define DMA_CHICR023	(*( DMA_CHICR000_type *) 0xf0014368u)	/* DMA Channel 023 Interrupt Control Register */
#define DMA_CHICR100	(*( DMA_CHICR000_type *) 0xf0015088u)	/* DMA Channel 100 Interrupt Control Register */
#define DMA_CHICR101	(*( DMA_CHICR000_type *) 0xf00150a8u)	/* DMA Channel 101 Interrupt Control Register */
#define DMA_CHICR102	(*( DMA_CHICR000_type *) 0xf00150c8u)	/* DMA Channel 102 Interrupt Control Register */
#define DMA_CHICR103	(*( DMA_CHICR000_type *) 0xf00150e8u)	/* DMA Channel 103 Interrupt Control Register */
#define DMA_CHICR104	(*( DMA_CHICR000_type *) 0xf0015108u)	/* DMA Channel 104 Interrupt Control Register */
#define DMA_CHICR105	(*( DMA_CHICR000_type *) 0xf0015128u)	/* DMA Channel 105 Interrupt Control Register */
#define DMA_CHICR106	(*( DMA_CHICR000_type *) 0xf0015148u)	/* DMA Channel 106 Interrupt Control Register */
#define DMA_CHICR107	(*( DMA_CHICR000_type *) 0xf0015168u)	/* DMA Channel 107 Interrupt Control Register */
#define DMA_CHICR108	(*( DMA_CHICR000_type *) 0xf0015188u)	/* DMA Channel 108 Interrupt Control Register */
#define DMA_CHICR109	(*( DMA_CHICR000_type *) 0xf00151a8u)	/* DMA Channel 109 Interrupt Control Register */
#define DMA_CHICR110	(*( DMA_CHICR000_type *) 0xf00151c8u)	/* DMA Channel 110 Interrupt Control Register */
#define DMA_CHICR111	(*( DMA_CHICR000_type *) 0xf00151e8u)	/* DMA Channel 111 Interrupt Control Register */
#define DMA_CHICR112	(*( DMA_CHICR000_type *) 0xf0015208u)	/* DMA Channel 112 Interrupt Control Register */
#define DMA_CHICR113	(*( DMA_CHICR000_type *) 0xf0015228u)	/* DMA Channel 113 Interrupt Control Register */
#define DMA_CHICR114	(*( DMA_CHICR000_type *) 0xf0015248u)	/* DMA Channel 114 Interrupt Control Register */
#define DMA_CHICR115	(*( DMA_CHICR000_type *) 0xf0015268u)	/* DMA Channel 115 Interrupt Control Register */
#define DMA_CHICR116	(*( DMA_CHICR000_type *) 0xf0015288u)	/* DMA Channel 116 Interrupt Control Register */
#define DMA_CHICR117	(*( DMA_CHICR000_type *) 0xf00152a8u)	/* DMA Channel 117 Interrupt Control Register */
#define DMA_CHICR118	(*( DMA_CHICR000_type *) 0xf00152c8u)	/* DMA Channel 118 Interrupt Control Register */
#define DMA_CHICR119	(*( DMA_CHICR000_type *) 0xf00152e8u)	/* DMA Channel 119 Interrupt Control Register */
#define DMA_CHICR120	(*( DMA_CHICR000_type *) 0xf0015308u)	/* DMA Channel 120 Interrupt Control Register */
#define DMA_CHICR121	(*( DMA_CHICR000_type *) 0xf0015328u)	/* DMA Channel 121 Interrupt Control Register */
#define DMA_CHICR122	(*( DMA_CHICR000_type *) 0xf0015348u)	/* DMA Channel 122 Interrupt Control Register */
#define DMA_CHICR123	(*( DMA_CHICR000_type *) 0xf0015368u)	/* DMA Channel 123 Interrupt Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SIT0           : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT1           : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT2           : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT3           : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT4           : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT5           : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT6           : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT7           : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT8           : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT9           : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT10          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT11          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT12          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT13          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT14          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT15          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT16          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT17          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT18          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT19          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT20          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT21          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT22          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		unsigned int SIT23          : 1;	/* Set Interrupt Trigger for DMA Channel z */
		/* const */ unsigned int RES            : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} DMA_CHINTR00_type;
#define DMA_CHINTR00	(*( DMA_CHINTR00_type *) 0xf0014070u)	/* DMA Channel Interrupt Set Register 00 */
#define DMA_CHINTR10	(*( DMA_CHINTR00_type *) 0xf0015070u)	/* DMA Channel Interrupt Set Register 10 */

typedef volatile union
{
	struct
	{ 
		unsigned int CH0            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH1            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH2            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH3            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH4            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH5            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH6            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH7            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH8            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH9            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH10           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH11           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH12           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH13           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH14           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH15           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH16           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH17           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH18           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH19           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH20           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH21           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH22           : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH23           : 1;	/* DMA Sub-block x Channel z Reset */
		/* const */ unsigned int RES            : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} DMA_CHRSTR00_type;
#define DMA_CHRSTR00	(*( DMA_CHRSTR00_type *) 0xf0014040u)	/* DMA Channel Reset Request Register 00 */
#define DMA_CHRSTR10	(*( DMA_CHRSTR00_type *) 0xf0015040u)	/* DMA Channel Reset Request Register 10 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TCOUNT         : 14;	/* Transfer Count Status */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int LXO            : 1;	/* Old Value of Pattern Detection */
		/* const */ unsigned int WRPS           : 1;	/* Wrap Source Buffer */
		/* const */ unsigned int WRPD           : 1;	/* Wrap Destination Buffer */
		/* const */ unsigned int ICH            : 1;	/* Interrupt from Channel */
		/* const */ unsigned int IPM            : 1;	/* Pattern Detection from Channel */
		/* const */ unsigned int TRL            : 1;	/* Transaction/Transfer Request Lost of DMA Channel */
		/* const */ unsigned int RES            : 3;	/* Reserved */
		/* const */ unsigned int CH             : 1;	/* Transaction Request State */
		/* const */ unsigned int HTRE           : 1;	/* Hardware Transaction Request Enable State */
		/* const */ unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} DMA_CHSR000_type;
#define DMA_CHSR000	(*( DMA_CHSR000_type *) 0xf0014080u)	/* DMA Channel 000 Status Register */
#define DMA_CHSR001	(*( DMA_CHSR000_type *) 0xf00140a0u)	/* DMA Channel 001 Status Register */
#define DMA_CHSR002	(*( DMA_CHSR000_type *) 0xf00140c0u)	/* DMA Channel 002 Status Register */
#define DMA_CHSR003	(*( DMA_CHSR000_type *) 0xf00140e0u)	/* DMA Channel 003 Status Register */
#define DMA_CHSR004	(*( DMA_CHSR000_type *) 0xf0014100u)	/* DMA Channel 004 Status Register */
#define DMA_CHSR005	(*( DMA_CHSR000_type *) 0xf0014120u)	/* DMA Channel 005 Status Register */
#define DMA_CHSR006	(*( DMA_CHSR000_type *) 0xf0014140u)	/* DMA Channel 006 Status Register */
#define DMA_CHSR007	(*( DMA_CHSR000_type *) 0xf0014160u)	/* DMA Channel 007 Status Register */
#define DMA_CHSR008	(*( DMA_CHSR000_type *) 0xf0014180u)	/* DMA Channel 008 Status Register */
#define DMA_CHSR009	(*( DMA_CHSR000_type *) 0xf00141a0u)	/* DMA Channel 009 Status Register */
#define DMA_CHSR010	(*( DMA_CHSR000_type *) 0xf00141c0u)	/* DMA Channel 010 Status Register */
#define DMA_CHSR011	(*( DMA_CHSR000_type *) 0xf00141e0u)	/* DMA Channel 011 Status Register */
#define DMA_CHSR012	(*( DMA_CHSR000_type *) 0xf0014200u)	/* DMA Channel 012 Status Register */
#define DMA_CHSR013	(*( DMA_CHSR000_type *) 0xf0014220u)	/* DMA Channel 013 Status Register */
#define DMA_CHSR014	(*( DMA_CHSR000_type *) 0xf0014240u)	/* DMA Channel 014 Status Register */
#define DMA_CHSR015	(*( DMA_CHSR000_type *) 0xf0014260u)	/* DMA Channel 015 Status Register */
#define DMA_CHSR016	(*( DMA_CHSR000_type *) 0xf0014280u)	/* DMA Channel 016 Status Register */
#define DMA_CHSR017	(*( DMA_CHSR000_type *) 0xf00142a0u)	/* DMA Channel 017 Status Register */
#define DMA_CHSR018	(*( DMA_CHSR000_type *) 0xf00142c0u)	/* DMA Channel 018 Status Register */
#define DMA_CHSR019	(*( DMA_CHSR000_type *) 0xf00142e0u)	/* DMA Channel 019 Status Register */
#define DMA_CHSR020	(*( DMA_CHSR000_type *) 0xf0014300u)	/* DMA Channel 020 Status Register */
#define DMA_CHSR021	(*( DMA_CHSR000_type *) 0xf0014320u)	/* DMA Channel 021 Status Register */
#define DMA_CHSR022	(*( DMA_CHSR000_type *) 0xf0014340u)	/* DMA Channel 022 Status Register */
#define DMA_CHSR023	(*( DMA_CHSR000_type *) 0xf0014360u)	/* DMA Channel 023 Status Register */
#define DMA_CHSR100	(*( DMA_CHSR000_type *) 0xf0015080u)	/* DMA Channel 100 Status Register */
#define DMA_CHSR101	(*( DMA_CHSR000_type *) 0xf00150a0u)	/* DMA Channel 101 Status Register */
#define DMA_CHSR102	(*( DMA_CHSR000_type *) 0xf00150c0u)	/* DMA Channel 102 Status Register */
#define DMA_CHSR103	(*( DMA_CHSR000_type *) 0xf00150e0u)	/* DMA Channel 103 Status Register */
#define DMA_CHSR104	(*( DMA_CHSR000_type *) 0xf0015100u)	/* DMA Channel 104 Status Register */
#define DMA_CHSR105	(*( DMA_CHSR000_type *) 0xf0015120u)	/* DMA Channel 105 Status Register */
#define DMA_CHSR106	(*( DMA_CHSR000_type *) 0xf0015140u)	/* DMA Channel 106 Status Register */
#define DMA_CHSR107	(*( DMA_CHSR000_type *) 0xf0015160u)	/* DMA Channel 107 Status Register */
#define DMA_CHSR108	(*( DMA_CHSR000_type *) 0xf0015180u)	/* DMA Channel 108 Status Register */
#define DMA_CHSR109	(*( DMA_CHSR000_type *) 0xf00151a0u)	/* DMA Channel 109 Status Register */
#define DMA_CHSR110	(*( DMA_CHSR000_type *) 0xf00151c0u)	/* DMA Channel 110 Status Register */
#define DMA_CHSR111	(*( DMA_CHSR000_type *) 0xf00151e0u)	/* DMA Channel 111 Status Register */
#define DMA_CHSR112	(*( DMA_CHSR000_type *) 0xf0015200u)	/* DMA Channel 112 Status Register */
#define DMA_CHSR113	(*( DMA_CHSR000_type *) 0xf0015220u)	/* DMA Channel 113 Status Register */
#define DMA_CHSR114	(*( DMA_CHSR000_type *) 0xf0015240u)	/* DMA Channel 114 Status Register */
#define DMA_CHSR115	(*( DMA_CHSR000_type *) 0xf0015260u)	/* DMA Channel 115 Status Register */
#define DMA_CHSR116	(*( DMA_CHSR000_type *) 0xf0015280u)	/* DMA Channel 116 Status Register */
#define DMA_CHSR117	(*( DMA_CHSR000_type *) 0xf00152a0u)	/* DMA Channel 117 Status Register */
#define DMA_CHSR118	(*( DMA_CHSR000_type *) 0xf00152c0u)	/* DMA Channel 118 Status Register */
#define DMA_CHSR119	(*( DMA_CHSR000_type *) 0xf00152e0u)	/* DMA Channel 119 Status Register */
#define DMA_CHSR120	(*( DMA_CHSR000_type *) 0xf0015300u)	/* DMA Channel 120 Status Register */
#define DMA_CHSR121	(*( DMA_CHSR000_type *) 0xf0015320u)	/* DMA Channel 121 Status Register */
#define DMA_CHSR122	(*( DMA_CHSR000_type *) 0xf0015340u)	/* DMA Channel 122 Status Register */
#define DMA_CHSR123	(*( DMA_CHSR000_type *) 0xf0015360u)	/* DMA Channel 123 Status Register */
#define SDMA_CHSR000	(*( DMA_CHSR000_type *) 0xf0010080u)	/* SDMA Channel 000 Status Register */
#define SDMA_CHSR001	(*( DMA_CHSR000_type *) 0xf00100a0u)	/* SDMA Channel 001 Status Register */
#define SDMA_CHSR002	(*( DMA_CHSR000_type *) 0xf00100c0u)	/* SDMA Channel 002 Status Register */
#define SDMA_CHSR003	(*( DMA_CHSR000_type *) 0xf00100e0u)	/* SDMA Channel 003 Status Register */
#define SDMA_CHSR004	(*( DMA_CHSR000_type *) 0xf0010100u)	/* SDMA Channel 004 Status Register */
#define SDMA_CHSR005	(*( DMA_CHSR000_type *) 0xf0010120u)	/* SDMA Channel 005 Status Register */
#define SDMA_CHSR006	(*( DMA_CHSR000_type *) 0xf0010140u)	/* SDMA Channel 006 Status Register */
#define SDMA_CHSR007	(*( DMA_CHSR000_type *) 0xf0010160u)	/* SDMA Channel 007 Status Register */
#define SDMA_CHSR100	(*( DMA_CHSR000_type *) 0xf0011080u)	/* SDMA Channel 100 Status Register */
#define SDMA_CHSR101	(*( DMA_CHSR000_type *) 0xf00110a0u)	/* SDMA Channel 101 Status Register */
#define SDMA_CHSR102	(*( DMA_CHSR000_type *) 0xf00110c0u)	/* SDMA Channel 102 Status Register */
#define SDMA_CHSR103	(*( DMA_CHSR000_type *) 0xf00110e0u)	/* SDMA Channel 103 Status Register */
#define SDMA_CHSR104	(*( DMA_CHSR000_type *) 0xf0011100u)	/* SDMA Channel 104 Status Register */
#define SDMA_CHSR105	(*( DMA_CHSR000_type *) 0xf0011120u)	/* SDMA Channel 105 Status Register */
#define SDMA_CHSR106	(*( DMA_CHSR000_type *) 0xf0011140u)	/* SDMA Channel 106 Status Register */
#define SDMA_CHSR107	(*( DMA_CHSR000_type *) 0xf0011160u)	/* SDMA Channel 107 Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		/* const */ unsigned int RES            : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} DMA_CLC0_type;
#define DMA_CLC0	(*( DMA_CLC0_type *) 0xf0014000u)	/* DMA Sub-block 0 Clock Control Register */
#define DMA_CLC1	(*( DMA_CLC0_type *) 0xf0015000u)	/* DMA Sub-block 1 Clock Control Register */
#define SDMA_CLC0	(*( DMA_CLC0_type *) 0xf0010000u)	/* SDMA Sub-block 0 Clock Control Register */
#define SDMA_CLC1	(*( DMA_CLC0_type *) 0xf0011000u)	/* SDMA Sub-block 1 Clock Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 16;	/* Reserved */
		unsigned int CMExSER        : 1;	/* Clear Move Engine x Source Error */
		unsigned int CMExDER        : 1;	/* Clear Move Engine x Destination Error */
		unsigned int                : 2;
		unsigned int CFPIER         : 1;	/* Clear FPI Error */
		unsigned int CSRIER         : 1;	/* Clear SRI Error */
		unsigned int CPERER         : 1;	/* Clear Peripheral Error */
		unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} DMA_CLRE0_type;
#define DMA_CLRE0	(*( DMA_CLRE0_type *) 0xf0014028u)	/* DMA Clear Error Register 0 */
#define DMA_CLRE1	(*( DMA_CLRE0_type *) 0xf0015028u)	/* DMA Clear Error Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int DADR           : 32;	/* Destination Address */
	} B;
	int I;
	unsigned int U;

} DMA_DADR000_type;
#define DMA_DADR000	(*( DMA_DADR000_type *) 0xf0014094u)	/* DMA Channel 000 Destination Address Register */
#define DMA_DADR001	(*( DMA_DADR000_type *) 0xf00140b4u)	/* DMA Channel 001 Destination Address Register */
#define DMA_DADR002	(*( DMA_DADR000_type *) 0xf00140d4u)	/* DMA Channel 002 Destination Address Register */
#define DMA_DADR003	(*( DMA_DADR000_type *) 0xf00140f4u)	/* DMA Channel 003 Destination Address Register */
#define DMA_DADR004	(*( DMA_DADR000_type *) 0xf0014114u)	/* DMA Channel 004 Destination Address Register */
#define DMA_DADR005	(*( DMA_DADR000_type *) 0xf0014134u)	/* DMA Channel 005 Destination Address Register */
#define DMA_DADR006	(*( DMA_DADR000_type *) 0xf0014154u)	/* DMA Channel 006 Destination Address Register */
#define DMA_DADR007	(*( DMA_DADR000_type *) 0xf0014174u)	/* DMA Channel 007 Destination Address Register */
#define DMA_DADR008	(*( DMA_DADR000_type *) 0xf0014194u)	/* DMA Channel 008 Destination Address Register */
#define DMA_DADR009	(*( DMA_DADR000_type *) 0xf00141b4u)	/* DMA Channel 009 Destination Address Register */
#define DMA_DADR010	(*( DMA_DADR000_type *) 0xf00141d4u)	/* DMA Channel 010 Destination Address Register */
#define DMA_DADR011	(*( DMA_DADR000_type *) 0xf00141f4u)	/* DMA Channel 011 Destination Address Register */
#define DMA_DADR012	(*( DMA_DADR000_type *) 0xf0014214u)	/* DMA Channel 012 Destination Address Register */
#define DMA_DADR013	(*( DMA_DADR000_type *) 0xf0014234u)	/* DMA Channel 013 Destination Address Register */
#define DMA_DADR014	(*( DMA_DADR000_type *) 0xf0014254u)	/* DMA Channel 014 Destination Address Register */
#define DMA_DADR015	(*( DMA_DADR000_type *) 0xf0014274u)	/* DMA Channel 015 Destination Address Register */
#define DMA_DADR016	(*( DMA_DADR000_type *) 0xf0014294u)	/* DMA Channel 016 Destination Address Register */
#define DMA_DADR017	(*( DMA_DADR000_type *) 0xf00142b4u)	/* DMA Channel 017 Destination Address Register */
#define DMA_DADR018	(*( DMA_DADR000_type *) 0xf00142d4u)	/* DMA Channel 018 Destination Address Register */
#define DMA_DADR019	(*( DMA_DADR000_type *) 0xf00142f4u)	/* DMA Channel 019 Destination Address Register */
#define DMA_DADR020	(*( DMA_DADR000_type *) 0xf0014314u)	/* DMA Channel 020 Destination Address Register */
#define DMA_DADR021	(*( DMA_DADR000_type *) 0xf0014334u)	/* DMA Channel 021 Destination Address Register */
#define DMA_DADR022	(*( DMA_DADR000_type *) 0xf0014354u)	/* DMA Channel 022 Destination Address Register */
#define DMA_DADR023	(*( DMA_DADR000_type *) 0xf0014374u)	/* DMA Channel 023 Destination Address Register */
#define DMA_DADR100	(*( DMA_DADR000_type *) 0xf0015094u)	/* DMA Channel 100 Destination Address Register */
#define DMA_DADR101	(*( DMA_DADR000_type *) 0xf00150b4u)	/* DMA Channel 101 Destination Address Register */
#define DMA_DADR102	(*( DMA_DADR000_type *) 0xf00150d4u)	/* DMA Channel 102 Destination Address Register */
#define DMA_DADR103	(*( DMA_DADR000_type *) 0xf00150f4u)	/* DMA Channel 103 Destination Address Register */
#define DMA_DADR104	(*( DMA_DADR000_type *) 0xf0015114u)	/* DMA Channel 104 Destination Address Register */
#define DMA_DADR105	(*( DMA_DADR000_type *) 0xf0015134u)	/* DMA Channel 105 Destination Address Register */
#define DMA_DADR106	(*( DMA_DADR000_type *) 0xf0015154u)	/* DMA Channel 106 Destination Address Register */
#define DMA_DADR107	(*( DMA_DADR000_type *) 0xf0015174u)	/* DMA Channel 107 Destination Address Register */
#define DMA_DADR108	(*( DMA_DADR000_type *) 0xf0015194u)	/* DMA Channel 108 Destination Address Register */
#define DMA_DADR109	(*( DMA_DADR000_type *) 0xf00151b4u)	/* DMA Channel 109 Destination Address Register */
#define DMA_DADR110	(*( DMA_DADR000_type *) 0xf00151d4u)	/* DMA Channel 110 Destination Address Register */
#define DMA_DADR111	(*( DMA_DADR000_type *) 0xf00151f4u)	/* DMA Channel 111 Destination Address Register */
#define DMA_DADR112	(*( DMA_DADR000_type *) 0xf0015214u)	/* DMA Channel 112 Destination Address Register */
#define DMA_DADR113	(*( DMA_DADR000_type *) 0xf0015234u)	/* DMA Channel 113 Destination Address Register */
#define DMA_DADR114	(*( DMA_DADR000_type *) 0xf0015254u)	/* DMA Channel 114 Destination Address Register */
#define DMA_DADR115	(*( DMA_DADR000_type *) 0xf0015274u)	/* DMA Channel 115 Destination Address Register */
#define DMA_DADR116	(*( DMA_DADR000_type *) 0xf0015294u)	/* DMA Channel 116 Destination Address Register */
#define DMA_DADR117	(*( DMA_DADR000_type *) 0xf00152b4u)	/* DMA Channel 117 Destination Address Register */
#define DMA_DADR118	(*( DMA_DADR000_type *) 0xf00152d4u)	/* DMA Channel 118 Destination Address Register */
#define DMA_DADR119	(*( DMA_DADR000_type *) 0xf00152f4u)	/* DMA Channel 119 Destination Address Register */
#define DMA_DADR120	(*( DMA_DADR000_type *) 0xf0015314u)	/* DMA Channel 120 Destination Address Register */
#define DMA_DADR121	(*( DMA_DADR000_type *) 0xf0015334u)	/* DMA Channel 121 Destination Address Register */
#define DMA_DADR122	(*( DMA_DADR000_type *) 0xf0015354u)	/* DMA Channel 122 Destination Address Register */
#define DMA_DADR123	(*( DMA_DADR000_type *) 0xf0015374u)	/* DMA Channel 123 Destination Address Register */
#define SDMA_DADR000	(*( DMA_DADR000_type *) 0xf0010094u)	/* SDMA Channel 000 Destination Address Register */
#define SDMA_DADR001	(*( DMA_DADR000_type *) 0xf00100b4u)	/* SDMA Channel 001 Destination Address Register */
#define SDMA_DADR002	(*( DMA_DADR000_type *) 0xf00100d4u)	/* SDMA Channel 002 Destination Address Register */
#define SDMA_DADR003	(*( DMA_DADR000_type *) 0xf00100f4u)	/* SDMA Channel 003 Destination Address Register */
#define SDMA_DADR004	(*( DMA_DADR000_type *) 0xf0010114u)	/* SDMA Channel 004 Destination Address Register */
#define SDMA_DADR005	(*( DMA_DADR000_type *) 0xf0010134u)	/* SDMA Channel 005 Destination Address Register */
#define SDMA_DADR006	(*( DMA_DADR000_type *) 0xf0010154u)	/* SDMA Channel 006 Destination Address Register */
#define SDMA_DADR007	(*( DMA_DADR000_type *) 0xf0010174u)	/* SDMA Channel 007 Destination Address Register */
#define SDMA_DADR100	(*( DMA_DADR000_type *) 0xf0011094u)	/* SDMA Channel 100 Destination Address Register */
#define SDMA_DADR101	(*( DMA_DADR000_type *) 0xf00110b4u)	/* SDMA Channel 101 Destination Address Register */
#define SDMA_DADR102	(*( DMA_DADR000_type *) 0xf00110d4u)	/* SDMA Channel 102 Destination Address Register */
#define SDMA_DADR103	(*( DMA_DADR000_type *) 0xf00110f4u)	/* SDMA Channel 103 Destination Address Register */
#define SDMA_DADR104	(*( DMA_DADR000_type *) 0xf0011114u)	/* SDMA Channel 104 Destination Address Register */
#define SDMA_DADR105	(*( DMA_DADR000_type *) 0xf0011134u)	/* SDMA Channel 105 Destination Address Register */
#define SDMA_DADR106	(*( DMA_DADR000_type *) 0xf0011154u)	/* SDMA Channel 106 Destination Address Register */
#define SDMA_DADR107	(*( DMA_DADR000_type *) 0xf0011174u)	/* SDMA Channel 107 Destination Address Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 16;	/* Reserved */
		unsigned int ESER           : 1;	/* Enable Move Engine x Source Error */
		unsigned int EDER           : 1;	/* Enable Move Engine x Destination Error */
		unsigned int                : 14;
	} B;
	int I;
	unsigned int U;

} DMA_EER0_type;
#define DMA_EER0	(*( DMA_EER0_type *) 0xf0014020u)	/* DMA Enable Error Register 0 */
#define DMA_EER1	(*( DMA_EER0_type *) 0xf0015020u)	/* DMA Enable Error Register 1 */
#define SDMA_EER0	(*( DMA_EER0_type *) 0xf0010020u)	/* SDMA Enable Error Register 0 */
#define SDMA_EER1	(*( DMA_EER0_type *) 0xf0011020u)	/* SDMA Enable Error Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int LEC            : 6;	/* Move Engine x Last Error Channel */
		/* const */ unsigned int RES            : 10;	/* Reserved */
		/* const */ unsigned int SER            : 1;	/* Move Engine x Source Error */
		/* const */ unsigned int DER            : 1;	/* Move Engine x Destination Error */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int FPIER          : 1;	/* Move Engine x FPI Bus Error */
		/* const */ unsigned int SRIER          : 1;	/* Move Engine x SRI Bus Error */
		/* const */ unsigned int PERER          : 1;	/* Move Engine x Peripheral Error */
		/* const */ unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} DMA_ERRSR0_type;
#define DMA_ERRSR0	(*( DMA_ERRSR0_type *) 0xf0014024u)	/* DMA Error Status Register 0 */
#define DMA_ERRSR1	(*( DMA_ERRSR0_type *) 0xf0015024u)	/* DMA Error Status Register 1 */
#define SDMA_ERRSR0	(*( DMA_ERRSR0_type *) 0xf0010024u)	/* SDMA Error Status Register 0 */
#define SDMA_ERRSR1	(*( DMA_ERRSR0_type *) 0xf0011024u)	/* SDMA Error Status Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} DMA_ID_type;
#define DMA_ID	(*( DMA_ID_type *) 0xf0014008u)	/* Module Identification Register */
#define SDMA_ID	(*( DMA_ID_type *) 0xf0010008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SIT            : 1;	/* Set Interrupt Trigger for DMA Move Engine x */
		/* const */ unsigned int RES            : 31;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} DMA_ME0INTR_type;
#define DMA_ME0INTR	(*( DMA_ME0INTR_type *) 0xf0014038u)	/* DMA Move Engine 0 Interrupt Set Register */
#define DMA_ME1INTR	(*( DMA_ME0INTR_type *) 0xf0015038u)	/* DMA Move Engine 1 Interrupt Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PAT00          : 8;	/* Pattern for Move Engine x */
		unsigned int PAT01          : 8;	/* Pattern for Move Engine x */
		unsigned int PAT02          : 8;	/* Pattern for Move Engine x */
		unsigned int PAT03          : 8;	/* Pattern for Move Engine x */
	} B;
	int I;
	unsigned int U;

} DMA_ME0PR_type;
#define DMA_ME0PR	(*( DMA_ME0PR_type *) 0xf001403cu)	/* DMA Move Engine 0 Pattern Read Register */
#define DMA_ME1PR	(*( DMA_ME0PR_type *) 0xf001503cu)	/* DMA Move Engine 1 Pattern Read Register */
#define SDMA_ME0PR	(*( DMA_ME0PR_type *) 0xf001003cu)	/* SDMA Move Engine 0 Pattern Read Register */
#define SDMA_ME1PR	(*( DMA_ME0PR_type *) 0xf001103cu)	/* SDMA Move Engine 1 Pattern Read Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RD00           : 8;	/* Read Value for Move Engine x */
		/* const */ unsigned int RD01           : 8;	/* Read Value for Move Engine x */
		/* const */ unsigned int RD02           : 8;	/* Read Value for Move Engine x */
		/* const */ unsigned int RD03           : 8;	/* Read Value for Move Engine x */
	} B;
	int I;
	unsigned int U;

} DMA_ME0R_type;
#define DMA_ME0R	(*( DMA_ME0R_type *) 0xf0014034u)	/* DMA Move Engine 0 Read Register */
#define DMA_ME1R	(*( DMA_ME0R_type *) 0xf0015034u)	/* DMA Move Engine 1 Read Register */
#define SDMA_ME0R	(*( DMA_ME0R_type *) 0xf0010034u)	/* SDMA Move Engine 0 Read Register */
#define SDMA_ME1R	(*( DMA_ME0R_type *) 0xf0011034u)	/* SDMA Move Engine 1 Read Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RS             : 1;	/* Move Engine x Read Status */
		/* const */ unsigned int RES            : 3;	/* Reserved */
		/* const */ unsigned int WS             : 1;	/* Move Engine x Write Status */
		/* const */ unsigned int                : 11;
		/* const */ unsigned int CH             : 6;	/* Reading Channel in Move Engine x */
		/* const */ unsigned int                : 10;
	} B;
	int I;
	unsigned int U;

} DMA_ME0SR_type;
#define DMA_ME0SR	(*( DMA_ME0SR_type *) 0xf0014030u)	/* DMA Move Engine 0 Status Register */
#define DMA_ME1SR	(*( DMA_ME0SR_type *) 0xf0015030u)	/* DMA Move Engine 1 Status Register */
#define SDMA_ME0SR	(*( DMA_ME0SR_type *) 0xf0010030u)	/* SDMA Move Engine 0 Status Register */
#define SDMA_ME1SR	(*( DMA_ME0SR_type *) 0xf0011030u)	/* SDMA Move Engine 1 Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 4;	/* Trigger Set () for OTGB0/1 */
		/* const */ unsigned int RES            : 3;	/* Reserved */
		unsigned int BS             : 1;	/* OTGB0/1 Bus Select */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} DMA_OTSS_type;
#define DMA_OTSS	(*( DMA_OTSS_type *) 0xf001400cu)	/* DMA OCDS Trigger Set Select */

typedef volatile union
{
	struct
	{ 
		unsigned int SADR           : 32;	/* Source Start Address */
	} B;
	int I;
	unsigned int U;

} DMA_SADR000_type;
#define DMA_SADR000	(*( DMA_SADR000_type *) 0xf0014090u)	/* DMA Channel 000 Source Address Register */
#define DMA_SADR001	(*( DMA_SADR000_type *) 0xf00140b0u)	/* DMA Channel 001 Source Address Register */
#define DMA_SADR002	(*( DMA_SADR000_type *) 0xf00140d0u)	/* DMA Channel 002 Source Address Register */
#define DMA_SADR003	(*( DMA_SADR000_type *) 0xf00140f0u)	/* DMA Channel 003 Source Address Register */
#define DMA_SADR004	(*( DMA_SADR000_type *) 0xf0014110u)	/* DMA Channel 004 Source Address Register */
#define DMA_SADR005	(*( DMA_SADR000_type *) 0xf0014130u)	/* DMA Channel 005 Source Address Register */
#define DMA_SADR006	(*( DMA_SADR000_type *) 0xf0014150u)	/* DMA Channel 006 Source Address Register */
#define DMA_SADR007	(*( DMA_SADR000_type *) 0xf0014170u)	/* DMA Channel 007 Source Address Register */
#define DMA_SADR008	(*( DMA_SADR000_type *) 0xf0014190u)	/* DMA Channel 008 Source Address Register */
#define DMA_SADR009	(*( DMA_SADR000_type *) 0xf00141b0u)	/* DMA Channel 009 Source Address Register */
#define DMA_SADR010	(*( DMA_SADR000_type *) 0xf00141d0u)	/* DMA Channel 010 Source Address Register */
#define DMA_SADR011	(*( DMA_SADR000_type *) 0xf00141f0u)	/* DMA Channel 011 Source Address Register */
#define DMA_SADR012	(*( DMA_SADR000_type *) 0xf0014210u)	/* DMA Channel 012 Source Address Register */
#define DMA_SADR013	(*( DMA_SADR000_type *) 0xf0014230u)	/* DMA Channel 013 Source Address Register */
#define DMA_SADR014	(*( DMA_SADR000_type *) 0xf0014250u)	/* DMA Channel 014 Source Address Register */
#define DMA_SADR015	(*( DMA_SADR000_type *) 0xf0014270u)	/* DMA Channel 015 Source Address Register */
#define DMA_SADR016	(*( DMA_SADR000_type *) 0xf0014290u)	/* DMA Channel 016 Source Address Register */
#define DMA_SADR017	(*( DMA_SADR000_type *) 0xf00142b0u)	/* DMA Channel 017 Source Address Register */
#define DMA_SADR018	(*( DMA_SADR000_type *) 0xf00142d0u)	/* DMA Channel 018 Source Address Register */
#define DMA_SADR019	(*( DMA_SADR000_type *) 0xf00142f0u)	/* DMA Channel 019 Source Address Register */
#define DMA_SADR020	(*( DMA_SADR000_type *) 0xf0014310u)	/* DMA Channel 020 Source Address Register */
#define DMA_SADR021	(*( DMA_SADR000_type *) 0xf0014330u)	/* DMA Channel 021 Source Address Register */
#define DMA_SADR022	(*( DMA_SADR000_type *) 0xf0014350u)	/* DMA Channel 022 Source Address Register */
#define DMA_SADR023	(*( DMA_SADR000_type *) 0xf0014370u)	/* DMA Channel 023 Source Address Register */
#define DMA_SADR100	(*( DMA_SADR000_type *) 0xf0015090u)	/* DMA Channel 100 Source Address Register */
#define DMA_SADR101	(*( DMA_SADR000_type *) 0xf00150b0u)	/* DMA Channel 101 Source Address Register */
#define DMA_SADR102	(*( DMA_SADR000_type *) 0xf00150d0u)	/* DMA Channel 102 Source Address Register */
#define DMA_SADR103	(*( DMA_SADR000_type *) 0xf00150f0u)	/* DMA Channel 103 Source Address Register */
#define DMA_SADR104	(*( DMA_SADR000_type *) 0xf0015110u)	/* DMA Channel 104 Source Address Register */
#define DMA_SADR105	(*( DMA_SADR000_type *) 0xf0015130u)	/* DMA Channel 105 Source Address Register */
#define DMA_SADR106	(*( DMA_SADR000_type *) 0xf0015150u)	/* DMA Channel 106 Source Address Register */
#define DMA_SADR107	(*( DMA_SADR000_type *) 0xf0015170u)	/* DMA Channel 107 Source Address Register */
#define DMA_SADR108	(*( DMA_SADR000_type *) 0xf0015190u)	/* DMA Channel 108 Source Address Register */
#define DMA_SADR109	(*( DMA_SADR000_type *) 0xf00151b0u)	/* DMA Channel 109 Source Address Register */
#define DMA_SADR110	(*( DMA_SADR000_type *) 0xf00151d0u)	/* DMA Channel 110 Source Address Register */
#define DMA_SADR111	(*( DMA_SADR000_type *) 0xf00151f0u)	/* DMA Channel 111 Source Address Register */
#define DMA_SADR112	(*( DMA_SADR000_type *) 0xf0015210u)	/* DMA Channel 112 Source Address Register */
#define DMA_SADR113	(*( DMA_SADR000_type *) 0xf0015230u)	/* DMA Channel 113 Source Address Register */
#define DMA_SADR114	(*( DMA_SADR000_type *) 0xf0015250u)	/* DMA Channel 114 Source Address Register */
#define DMA_SADR115	(*( DMA_SADR000_type *) 0xf0015270u)	/* DMA Channel 115 Source Address Register */
#define DMA_SADR116	(*( DMA_SADR000_type *) 0xf0015290u)	/* DMA Channel 116 Source Address Register */
#define DMA_SADR117	(*( DMA_SADR000_type *) 0xf00152b0u)	/* DMA Channel 117 Source Address Register */
#define DMA_SADR118	(*( DMA_SADR000_type *) 0xf00152d0u)	/* DMA Channel 118 Source Address Register */
#define DMA_SADR119	(*( DMA_SADR000_type *) 0xf00152f0u)	/* DMA Channel 119 Source Address Register */
#define DMA_SADR120	(*( DMA_SADR000_type *) 0xf0015310u)	/* DMA Channel 120 Source Address Register */
#define DMA_SADR121	(*( DMA_SADR000_type *) 0xf0015330u)	/* DMA Channel 121 Source Address Register */
#define DMA_SADR122	(*( DMA_SADR000_type *) 0xf0015350u)	/* DMA Channel 122 Source Address Register */
#define DMA_SADR123	(*( DMA_SADR000_type *) 0xf0015370u)	/* DMA Channel 123 Source Address Register */
#define SDMA_SADR000	(*( DMA_SADR000_type *) 0xf0010090u)	/* SDMA Channel 000 Source Address Register */
#define SDMA_SADR001	(*( DMA_SADR000_type *) 0xf00100b0u)	/* SDMA Channel 001 Source Address Register */
#define SDMA_SADR002	(*( DMA_SADR000_type *) 0xf00100d0u)	/* SDMA Channel 002 Source Address Register */
#define SDMA_SADR003	(*( DMA_SADR000_type *) 0xf00100f0u)	/* SDMA Channel 003 Source Address Register */
#define SDMA_SADR004	(*( DMA_SADR000_type *) 0xf0010110u)	/* SDMA Channel 004 Source Address Register */
#define SDMA_SADR005	(*( DMA_SADR000_type *) 0xf0010130u)	/* SDMA Channel 005 Source Address Register */
#define SDMA_SADR006	(*( DMA_SADR000_type *) 0xf0010150u)	/* SDMA Channel 006 Source Address Register */
#define SDMA_SADR007	(*( DMA_SADR000_type *) 0xf0010170u)	/* SDMA Channel 007 Source Address Register */
#define SDMA_SADR100	(*( DMA_SADR000_type *) 0xf0011090u)	/* SDMA Channel 100 Source Address Register */
#define SDMA_SADR101	(*( DMA_SADR000_type *) 0xf00110b0u)	/* SDMA Channel 101 Source Address Register */
#define SDMA_SADR102	(*( DMA_SADR000_type *) 0xf00110d0u)	/* SDMA Channel 102 Source Address Register */
#define SDMA_SADR103	(*( DMA_SADR000_type *) 0xf00110f0u)	/* SDMA Channel 103 Source Address Register */
#define SDMA_SADR104	(*( DMA_SADR000_type *) 0xf0011110u)	/* SDMA Channel 104 Source Address Register */
#define SDMA_SADR105	(*( DMA_SADR000_type *) 0xf0011130u)	/* SDMA Channel 105 Source Address Register */
#define SDMA_SADR106	(*( DMA_SADR000_type *) 0xf0011150u)	/* SDMA Channel 106 Source Address Register */
#define SDMA_SADR107	(*( DMA_SADR000_type *) 0xf0011170u)	/* SDMA Channel 107 Source Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SHADR          : 32;	/* Shadowed Address */
	} B;
	int I;
	unsigned int U;

} DMA_SHADR000_type;
#define DMA_SHADR000	(*( DMA_SHADR000_type *) 0xf0014098u)	/* DMA Channel 000 Shadow Address Register */
#define DMA_SHADR001	(*( DMA_SHADR000_type *) 0xf00140b8u)	/* DMA Channel 001 Shadow Address Register */
#define DMA_SHADR002	(*( DMA_SHADR000_type *) 0xf00140d8u)	/* DMA Channel 002 Shadow Address Register */
#define DMA_SHADR003	(*( DMA_SHADR000_type *) 0xf00140f8u)	/* DMA Channel 003 Shadow Address Register */
#define DMA_SHADR004	(*( DMA_SHADR000_type *) 0xf0014118u)	/* DMA Channel 004 Shadow Address Register */
#define DMA_SHADR005	(*( DMA_SHADR000_type *) 0xf0014138u)	/* DMA Channel 005 Shadow Address Register */
#define DMA_SHADR006	(*( DMA_SHADR000_type *) 0xf0014158u)	/* DMA Channel 006 Shadow Address Register */
#define DMA_SHADR007	(*( DMA_SHADR000_type *) 0xf0014178u)	/* DMA Channel 007 Shadow Address Register */
#define DMA_SHADR008	(*( DMA_SHADR000_type *) 0xf0014198u)	/* DMA Channel 008 Shadow Address Register */
#define DMA_SHADR009	(*( DMA_SHADR000_type *) 0xf00141b8u)	/* DMA Channel 009 Shadow Address Register */
#define DMA_SHADR010	(*( DMA_SHADR000_type *) 0xf00141d8u)	/* DMA Channel 010 Shadow Address Register */
#define DMA_SHADR011	(*( DMA_SHADR000_type *) 0xf00141f8u)	/* DMA Channel 011 Shadow Address Register */
#define DMA_SHADR012	(*( DMA_SHADR000_type *) 0xf0014218u)	/* DMA Channel 012 Shadow Address Register */
#define DMA_SHADR013	(*( DMA_SHADR000_type *) 0xf0014238u)	/* DMA Channel 013 Shadow Address Register */
#define DMA_SHADR014	(*( DMA_SHADR000_type *) 0xf0014258u)	/* DMA Channel 014 Shadow Address Register */
#define DMA_SHADR015	(*( DMA_SHADR000_type *) 0xf0014278u)	/* DMA Channel 015 Shadow Address Register */
#define DMA_SHADR016	(*( DMA_SHADR000_type *) 0xf0014298u)	/* DMA Channel 016 Shadow Address Register */
#define DMA_SHADR017	(*( DMA_SHADR000_type *) 0xf00142b8u)	/* DMA Channel 017 Shadow Address Register */
#define DMA_SHADR018	(*( DMA_SHADR000_type *) 0xf00142d8u)	/* DMA Channel 018 Shadow Address Register */
#define DMA_SHADR019	(*( DMA_SHADR000_type *) 0xf00142f8u)	/* DMA Channel 019 Shadow Address Register */
#define DMA_SHADR020	(*( DMA_SHADR000_type *) 0xf0014318u)	/* DMA Channel 020 Shadow Address Register */
#define DMA_SHADR021	(*( DMA_SHADR000_type *) 0xf0014338u)	/* DMA Channel 021 Shadow Address Register */
#define DMA_SHADR022	(*( DMA_SHADR000_type *) 0xf0014358u)	/* DMA Channel 022 Shadow Address Register */
#define DMA_SHADR023	(*( DMA_SHADR000_type *) 0xf0014378u)	/* DMA Channel 023 Shadow Address Register */
#define DMA_SHADR100	(*( DMA_SHADR000_type *) 0xf0015098u)	/* DMA Channel 100 Shadow Address Register */
#define DMA_SHADR101	(*( DMA_SHADR000_type *) 0xf00150b8u)	/* DMA Channel 101 Shadow Address Register */
#define DMA_SHADR102	(*( DMA_SHADR000_type *) 0xf00150d8u)	/* DMA Channel 102 Shadow Address Register */
#define DMA_SHADR103	(*( DMA_SHADR000_type *) 0xf00150f8u)	/* DMA Channel 103 Shadow Address Register */
#define DMA_SHADR104	(*( DMA_SHADR000_type *) 0xf0015118u)	/* DMA Channel 104 Shadow Address Register */
#define DMA_SHADR105	(*( DMA_SHADR000_type *) 0xf0015138u)	/* DMA Channel 105 Shadow Address Register */
#define DMA_SHADR106	(*( DMA_SHADR000_type *) 0xf0015158u)	/* DMA Channel 106 Shadow Address Register */
#define DMA_SHADR107	(*( DMA_SHADR000_type *) 0xf0015178u)	/* DMA Channel 107 Shadow Address Register */
#define DMA_SHADR108	(*( DMA_SHADR000_type *) 0xf0015198u)	/* DMA Channel 108 Shadow Address Register */
#define DMA_SHADR109	(*( DMA_SHADR000_type *) 0xf00151b8u)	/* DMA Channel 109 Shadow Address Register */
#define DMA_SHADR110	(*( DMA_SHADR000_type *) 0xf00151d8u)	/* DMA Channel 110 Shadow Address Register */
#define DMA_SHADR111	(*( DMA_SHADR000_type *) 0xf00151f8u)	/* DMA Channel 111 Shadow Address Register */
#define DMA_SHADR112	(*( DMA_SHADR000_type *) 0xf0015218u)	/* DMA Channel 112 Shadow Address Register */
#define DMA_SHADR113	(*( DMA_SHADR000_type *) 0xf0015238u)	/* DMA Channel 113 Shadow Address Register */
#define DMA_SHADR114	(*( DMA_SHADR000_type *) 0xf0015258u)	/* DMA Channel 114 Shadow Address Register */
#define DMA_SHADR115	(*( DMA_SHADR000_type *) 0xf0015278u)	/* DMA Channel 115 Shadow Address Register */
#define DMA_SHADR116	(*( DMA_SHADR000_type *) 0xf0015298u)	/* DMA Channel 116 Shadow Address Register */
#define DMA_SHADR117	(*( DMA_SHADR000_type *) 0xf00152b8u)	/* DMA Channel 117 Shadow Address Register */
#define DMA_SHADR118	(*( DMA_SHADR000_type *) 0xf00152d8u)	/* DMA Channel 118 Shadow Address Register */
#define DMA_SHADR119	(*( DMA_SHADR000_type *) 0xf00152f8u)	/* DMA Channel 119 Shadow Address Register */
#define DMA_SHADR120	(*( DMA_SHADR000_type *) 0xf0015318u)	/* DMA Channel 120 Shadow Address Register */
#define DMA_SHADR121	(*( DMA_SHADR000_type *) 0xf0015338u)	/* DMA Channel 121 Shadow Address Register */
#define DMA_SHADR122	(*( DMA_SHADR000_type *) 0xf0015358u)	/* DMA Channel 122 Shadow Address Register */
#define DMA_SHADR123	(*( DMA_SHADR000_type *) 0xf0015378u)	/* DMA Channel 123 Shadow Address Register */
#define SDMA_SHADR000	(*( DMA_SHADR000_type *) 0xf0010098u)	/* SDMA Channel 000 Shadow Address Register */
#define SDMA_SHADR001	(*( DMA_SHADR000_type *) 0xf00100b8u)	/* SDMA Channel 001 Shadow Address Register */
#define SDMA_SHADR002	(*( DMA_SHADR000_type *) 0xf00100d8u)	/* SDMA Channel 002 Shadow Address Register */
#define SDMA_SHADR003	(*( DMA_SHADR000_type *) 0xf00100f8u)	/* SDMA Channel 003 Shadow Address Register */
#define SDMA_SHADR004	(*( DMA_SHADR000_type *) 0xf0010118u)	/* SDMA Channel 004 Shadow Address Register */
#define SDMA_SHADR005	(*( DMA_SHADR000_type *) 0xf0010138u)	/* SDMA Channel 005 Shadow Address Register */
#define SDMA_SHADR006	(*( DMA_SHADR000_type *) 0xf0010158u)	/* SDMA Channel 006 Shadow Address Register */
#define SDMA_SHADR007	(*( DMA_SHADR000_type *) 0xf0010178u)	/* SDMA Channel 007 Shadow Address Register */
#define SDMA_SHADR100	(*( DMA_SHADR000_type *) 0xf0011098u)	/* SDMA Channel 100 Shadow Address Register */
#define SDMA_SHADR101	(*( DMA_SHADR000_type *) 0xf00110b8u)	/* SDMA Channel 101 Shadow Address Register */
#define SDMA_SHADR102	(*( DMA_SHADR000_type *) 0xf00110d8u)	/* SDMA Channel 102 Shadow Address Register */
#define SDMA_SHADR103	(*( DMA_SHADR000_type *) 0xf00110f8u)	/* SDMA Channel 103 Shadow Address Register */
#define SDMA_SHADR104	(*( DMA_SHADR000_type *) 0xf0011118u)	/* SDMA Channel 104 Shadow Address Register */
#define SDMA_SHADR105	(*( DMA_SHADR000_type *) 0xf0011138u)	/* SDMA Channel 105 Shadow Address Register */
#define SDMA_SHADR106	(*( DMA_SHADR000_type *) 0xf0011158u)	/* SDMA Channel 106 Shadow Address Register */
#define SDMA_SHADR107	(*( DMA_SHADR000_type *) 0xf0011178u)	/* SDMA Channel 107 Shadow Address Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SUSAC0         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC1         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC2         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC3         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC4         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC5         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC6         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC7         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC8         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC9         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC10        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC11        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC12        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC13        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC14        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC15        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC16        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC17        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC18        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC19        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC20        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC21        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC22        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC23        : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int RES            : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} DMA_SUSACR00_type;
#define DMA_SUSACR00	(*( DMA_SUSACR00_type *) 0xf0014068u)	/* DMA Suspend Acknowledge Register 00 */
#define DMA_SUSACR10	(*( DMA_SUSACR00_type *) 0xf0015068u)	/* DMA Suspend Acknowledge Register 10 */

typedef volatile union
{
	struct
	{ 
		unsigned int SUSEN0         : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN1         : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN2         : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN3         : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN4         : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN5         : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN6         : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN7         : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN8         : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN9         : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN10        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN11        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN12        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN13        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN14        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN15        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN16        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN17        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN18        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN19        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN20        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN21        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN22        : 1;	/* Channel Suspend Enable for DMA Channel z */
		unsigned int SUSEN23        : 1;	/* Channel Suspend Enable for DMA Channel z */
		/* const */ unsigned int RES            : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} DMA_SUSENR00_type;
#define DMA_SUSENR00	(*( DMA_SUSENR00_type *) 0xf0014060u)	/* DMA Suspend Enable Register 00 */
#define DMA_SUSENR10	(*( DMA_SUSENR00_type *) 0xf0015060u)	/* DMA Suspend Enable Register 10 */

typedef volatile union
{
	struct
	{ 
		unsigned int TREL           : 14;	/* Transfer Reload Value */
		/* const */ unsigned int RES            : 2;	/* Reserved */
		unsigned int BLKM           : 3;	/* Block Mode */
		unsigned int RROAT          : 1;	/* Reset Request Only After Transaction */
		unsigned int CHMODE         : 1;	/* Channel Operation Mode */
		unsigned int CHDW           : 2;	/* Channel Data Width */
		unsigned int                : 1;
		unsigned int PATSEL         : 2;	/* Pattern Select */
		unsigned int ECH            : 1;	/* Enable Hardware Transfer Request */
		unsigned int DCH            : 1;	/* Disable Hardware Transfer Request */
		unsigned int PRSEL          : 1;	/* Peripheral Request Select */
		unsigned int SCH            : 1;	/* Set Transaction Request for DMA Channel z */
		unsigned int DMAPRIO        : 2;	/* DMA Priority */
	} B;
	int I;
	unsigned int U;

} SDMA_CHCR000_type;
#define SDMA_CHCR000	(*( SDMA_CHCR000_type *) 0xf0010084u)	/* SDMA Channel 000 Control Register */
#define SDMA_CHCR001	(*( SDMA_CHCR000_type *) 0xf00100a4u)	/* SDMA Channel 001 Control Register */
#define SDMA_CHCR002	(*( SDMA_CHCR000_type *) 0xf00100c4u)	/* SDMA Channel 002 Control Register */
#define SDMA_CHCR003	(*( SDMA_CHCR000_type *) 0xf00100e4u)	/* SDMA Channel 003 Control Register */
#define SDMA_CHCR004	(*( SDMA_CHCR000_type *) 0xf0010104u)	/* SDMA Channel 004 Control Register */
#define SDMA_CHCR005	(*( SDMA_CHCR000_type *) 0xf0010124u)	/* SDMA Channel 005 Control Register */
#define SDMA_CHCR006	(*( SDMA_CHCR000_type *) 0xf0010144u)	/* SDMA Channel 006 Control Register */
#define SDMA_CHCR007	(*( SDMA_CHCR000_type *) 0xf0010164u)	/* SDMA Channel 007 Control Register */
#define SDMA_CHCR100	(*( SDMA_CHCR000_type *) 0xf0011084u)	/* SDMA Channel 100 Control Register */
#define SDMA_CHCR101	(*( SDMA_CHCR000_type *) 0xf00110a4u)	/* SDMA Channel 101 Control Register */
#define SDMA_CHCR102	(*( SDMA_CHCR000_type *) 0xf00110c4u)	/* SDMA Channel 102 Control Register */
#define SDMA_CHCR103	(*( SDMA_CHCR000_type *) 0xf00110e4u)	/* SDMA Channel 103 Control Register */
#define SDMA_CHCR104	(*( SDMA_CHCR000_type *) 0xf0011104u)	/* SDMA Channel 104 Control Register */
#define SDMA_CHCR105	(*( SDMA_CHCR000_type *) 0xf0011124u)	/* SDMA Channel 105 Control Register */
#define SDMA_CHCR106	(*( SDMA_CHCR000_type *) 0xf0011144u)	/* SDMA Channel 106 Control Register */
#define SDMA_CHCR107	(*( SDMA_CHCR000_type *) 0xf0011164u)	/* SDMA Channel 107 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int WRPSE          : 1;	/* Wrap Source Enable */
		unsigned int WRPDE          : 1;	/* Wrap Destination Enable */
		unsigned int INTCT          : 2;	/* Interrupt Control */
		unsigned int ETRL           : 1;	/* Enable Transaction Request Lost Interrupt */
		/* const */ unsigned int RES            : 7;	/* Reserved */
		unsigned int IRDV           : 4;	/* Interrupt Raise Detect Value */
		unsigned int CWRP           : 1;	/* Clear Wrap Buffer Interrupt xz */
		unsigned int                : 1;
		unsigned int CICH           : 1;	/* Clear Interrupt for DMA Channel xz */
		unsigned int                : 1;
		unsigned int CTL            : 1;	/* Clear Transaction Request Lost for DMA Channel xz */
		unsigned int                : 11;
	} B;
	int I;
	unsigned int U;

} SDMA_CHICR000_type;
#define SDMA_CHICR000	(*( SDMA_CHICR000_type *) 0xf0010088u)	/* SDMA Channel 000 Interrupt Control Register */
#define SDMA_CHICR001	(*( SDMA_CHICR000_type *) 0xf00100a8u)	/* SDMA Channel 001 Interrupt Control Register */
#define SDMA_CHICR002	(*( SDMA_CHICR000_type *) 0xf00100c8u)	/* SDMA Channel 002 Interrupt Control Register */
#define SDMA_CHICR003	(*( SDMA_CHICR000_type *) 0xf00100e8u)	/* SDMA Channel 003 Interrupt Control Register */
#define SDMA_CHICR004	(*( SDMA_CHICR000_type *) 0xf0010108u)	/* SDMA Channel 004 Interrupt Control Register */
#define SDMA_CHICR005	(*( SDMA_CHICR000_type *) 0xf0010128u)	/* SDMA Channel 005 Interrupt Control Register */
#define SDMA_CHICR006	(*( SDMA_CHICR000_type *) 0xf0010148u)	/* SDMA Channel 006 Interrupt Control Register */
#define SDMA_CHICR007	(*( SDMA_CHICR000_type *) 0xf0010168u)	/* SDMA Channel 007 Interrupt Control Register */
#define SDMA_CHICR100	(*( SDMA_CHICR000_type *) 0xf0011088u)	/* SDMA Channel 100 Interrupt Control Register */
#define SDMA_CHICR101	(*( SDMA_CHICR000_type *) 0xf00110a8u)	/* SDMA Channel 101 Interrupt Control Register */
#define SDMA_CHICR102	(*( SDMA_CHICR000_type *) 0xf00110c8u)	/* SDMA Channel 102 Interrupt Control Register */
#define SDMA_CHICR103	(*( SDMA_CHICR000_type *) 0xf00110e8u)	/* SDMA Channel 103 Interrupt Control Register */
#define SDMA_CHICR104	(*( SDMA_CHICR000_type *) 0xf0011108u)	/* SDMA Channel 104 Interrupt Control Register */
#define SDMA_CHICR105	(*( SDMA_CHICR000_type *) 0xf0011128u)	/* SDMA Channel 105 Interrupt Control Register */
#define SDMA_CHICR106	(*( SDMA_CHICR000_type *) 0xf0011148u)	/* SDMA Channel 106 Interrupt Control Register */
#define SDMA_CHICR107	(*( SDMA_CHICR000_type *) 0xf0011168u)	/* SDMA Channel 107 Interrupt Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SIT0           : 1;	/* Set Interrupt Trigger for SDMA Channel z */
		unsigned int SIT1           : 1;	/* Set Interrupt Trigger for SDMA Channel z */
		unsigned int SIT2           : 1;	/* Set Interrupt Trigger for SDMA Channel z */
		unsigned int SIT3           : 1;	/* Set Interrupt Trigger for SDMA Channel z */
		unsigned int SIT4           : 1;	/* Set Interrupt Trigger for SDMA Channel z */
		unsigned int SIT5           : 1;	/* Set Interrupt Trigger for SDMA Channel z */
		unsigned int SIT6           : 1;	/* Set Interrupt Trigger for SDMA Channel z */
		unsigned int SIT7           : 1;	/* Set Interrupt Trigger for SDMA Channel z */
		/* const */ unsigned int RES            : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} SDMA_CHINTR00_type;
#define SDMA_CHINTR00	(*( SDMA_CHINTR00_type *) 0xf0010070u)	/* SDMA Channel Interrupt Set Register 00 */
#define SDMA_CHINTR10	(*( SDMA_CHINTR00_type *) 0xf0011070u)	/* SDMA Channel Interrupt Set Register 10 */

typedef volatile union
{
	struct
	{ 
		unsigned int CH0            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH1            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH2            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH3            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH4            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH5            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH6            : 1;	/* DMA Sub-block x Channel z Reset */
		unsigned int CH7            : 1;	/* DMA Sub-block x Channel z Reset */
		/* const */ unsigned int RES            : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} SDMA_CHRSTR00_type;
#define SDMA_CHRSTR00	(*( SDMA_CHRSTR00_type *) 0xf0010040u)	/* SDMA Channel Reset Request Register 00 */
#define SDMA_CHRSTR10	(*( SDMA_CHRSTR00_type *) 0xf0011040u)	/* SDMA Channel Reset Request Register 10 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 16;	/* Reserved */
		unsigned int CMExSER        : 1;	/* Clear Move Engine x Source Error */
		unsigned int CMExDER        : 1;	/* Clear Move Engine x Destination Error */
		unsigned int                : 2;
		unsigned int CFPIER         : 1;	/* Clear FPI Error */
		unsigned int CSRIER         : 1;	/* Clear SRI Error */
		unsigned int CPERER         : 1;	/* Clear Peripheral Error */
		unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} SDMA_CLRE0_type;
#define SDMA_CLRE0	(*( SDMA_CLRE0_type *) 0xf0010028u)	/* SDMA Clear Error Register 0 */
#define SDMA_CLRE1	(*( SDMA_CLRE0_type *) 0xf0011028u)	/* SDMA Clear Error Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int SIT            : 1;	/* Set Interrupt Trigger for SDMA Move Engine x */
		/* const */ unsigned int RES            : 31;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} SDMA_ME0INTR_type;
#define SDMA_ME0INTR	(*( SDMA_ME0INTR_type *) 0xf0010038u)	/* SDMA Move Engine 0 Interrupt Set Register */
#define SDMA_ME1INTR	(*( SDMA_ME0INTR_type *) 0xf0011038u)	/* SDMA Move Engine 1 Interrupt Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 4;	/* Trigger Set () for OTGB0/1 */
		/* const */ unsigned int RES            : 3;	/* Reserved */
		unsigned int BS             : 1;	/* OTGB0/1 Bus Select */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} SDMA_OTSS_type;
#define SDMA_OTSS	(*( SDMA_OTSS_type *) 0xf001000cu)	/* SDMA OCDS Trigger Set Select */

typedef volatile union
{
	struct
	{ 
		unsigned int RDCRC          : 32;	/* Read Data CRC */
	} B;
	int I;
	unsigned int U;

} SDMA_RDCRC000_type;
#define SDMA_RDCRC000	(*( SDMA_RDCRC000_type *) 0xf0012018u)	/* SDMA Channel 000 Read Data CRC Register */
#define SDMA_RDCRC001	(*( SDMA_RDCRC000_type *) 0xf0012038u)	/* SDMA Channel 001 Read Data CRC Register */
#define SDMA_RDCRC002	(*( SDMA_RDCRC000_type *) 0xf0012058u)	/* SDMA Channel 002 Read Data CRC Register */
#define SDMA_RDCRC003	(*( SDMA_RDCRC000_type *) 0xf0012078u)	/* SDMA Channel 003 Read Data CRC Register */
#define SDMA_RDCRC004	(*( SDMA_RDCRC000_type *) 0xf0012098u)	/* SDMA Channel 004 Read Data CRC Register */
#define SDMA_RDCRC005	(*( SDMA_RDCRC000_type *) 0xf00120b8u)	/* SDMA Channel 005 Read Data CRC Register */
#define SDMA_RDCRC006	(*( SDMA_RDCRC000_type *) 0xf00120d8u)	/* SDMA Channel 006 Read Data CRC Register */
#define SDMA_RDCRC007	(*( SDMA_RDCRC000_type *) 0xf00120f8u)	/* SDMA Channel 007 Read Data CRC Register */
#define SDMA_RDCRC100	(*( SDMA_RDCRC000_type *) 0xf0012818u)	/* SDMA Channel 100 Read Data CRC Register */
#define SDMA_RDCRC101	(*( SDMA_RDCRC000_type *) 0xf0012838u)	/* SDMA Channel 101 Read Data CRC Register */
#define SDMA_RDCRC102	(*( SDMA_RDCRC000_type *) 0xf0012858u)	/* SDMA Channel 102 Read Data CRC Register */
#define SDMA_RDCRC103	(*( SDMA_RDCRC000_type *) 0xf0012878u)	/* SDMA Channel 103 Read Data CRC Register */
#define SDMA_RDCRC104	(*( SDMA_RDCRC000_type *) 0xf0012898u)	/* SDMA Channel 104 Read Data CRC Register */
#define SDMA_RDCRC105	(*( SDMA_RDCRC000_type *) 0xf00128b8u)	/* SDMA Channel 105 Read Data CRC Register */
#define SDMA_RDCRC106	(*( SDMA_RDCRC000_type *) 0xf00128d8u)	/* SDMA Channel 106 Read Data CRC Register */
#define SDMA_RDCRC107	(*( SDMA_RDCRC000_type *) 0xf00128f8u)	/* SDMA Channel 107 Read Data CRC Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SDCRC          : 32;	/* Source and Destination Address CRC */
	} B;
	int I;
	unsigned int U;

} SDMA_SDCRC000_type;
#define SDMA_SDCRC000	(*( SDMA_SDCRC000_type *) 0xf001201cu)	/* SDMA Channel 000 Source and Destination Address CRC Register */
#define SDMA_SDCRC001	(*( SDMA_SDCRC000_type *) 0xf001203cu)	/* SDMA Channel 001 Source and Destination Address CRC Register */
#define SDMA_SDCRC002	(*( SDMA_SDCRC000_type *) 0xf001205cu)	/* SDMA Channel 002 Source and Destination Address CRC Register */
#define SDMA_SDCRC003	(*( SDMA_SDCRC000_type *) 0xf001207cu)	/* SDMA Channel 003 Source and Destination Address CRC Register */
#define SDMA_SDCRC004	(*( SDMA_SDCRC000_type *) 0xf001209cu)	/* SDMA Channel 004 Source and Destination Address CRC Register */
#define SDMA_SDCRC005	(*( SDMA_SDCRC000_type *) 0xf00120bcu)	/* SDMA Channel 005 Source and Destination Address CRC Register */
#define SDMA_SDCRC006	(*( SDMA_SDCRC000_type *) 0xf00120dcu)	/* SDMA Channel 006 Source and Destination Address CRC Register */
#define SDMA_SDCRC007	(*( SDMA_SDCRC000_type *) 0xf00120fcu)	/* SDMA Channel 007 Source and Destination Address CRC Register */
#define SDMA_SDCRC100	(*( SDMA_SDCRC000_type *) 0xf001281cu)	/* SDMA Channel 100 Source and Destination Address CRC Register */
#define SDMA_SDCRC101	(*( SDMA_SDCRC000_type *) 0xf001283cu)	/* SDMA Channel 101 Source and Destination Address CRC Register */
#define SDMA_SDCRC102	(*( SDMA_SDCRC000_type *) 0xf001285cu)	/* SDMA Channel 102 Source and Destination Address CRC Register */
#define SDMA_SDCRC103	(*( SDMA_SDCRC000_type *) 0xf001287cu)	/* SDMA Channel 103 Source and Destination Address CRC Register */
#define SDMA_SDCRC104	(*( SDMA_SDCRC000_type *) 0xf001289cu)	/* SDMA Channel 104 Source and Destination Address CRC Register */
#define SDMA_SDCRC105	(*( SDMA_SDCRC000_type *) 0xf00128bcu)	/* SDMA Channel 105 Source and Destination Address CRC Register */
#define SDMA_SDCRC106	(*( SDMA_SDCRC000_type *) 0xf00128dcu)	/* SDMA Channel 106 Source and Destination Address CRC Register */
#define SDMA_SDCRC107	(*( SDMA_SDCRC000_type *) 0xf00128fcu)	/* SDMA Channel 107 Source and Destination Address CRC Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SUSAC0         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC1         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC2         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC3         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC4         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC5         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC6         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int SUSAC7         : 1;	/* Channel Suspend Active for SDMA Channel z */
		/* const */ unsigned int RES            : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} SDMA_SUSACR00_type;
#define SDMA_SUSACR00	(*( SDMA_SUSACR00_type *) 0xf0010068u)	/* SDMA Suspend Acknowledge Register 00 */
#define SDMA_SUSACR10	(*( SDMA_SUSACR00_type *) 0xf0011068u)	/* SDMA Suspend Acknowledge Register 10 */

typedef volatile union
{
	struct
	{ 
		unsigned int SUSEN0         : 1;	/* Channel Suspend Enable for SDMA Channel z */
		unsigned int SUSEN1         : 1;	/* Channel Suspend Enable for SDMA Channel z */
		unsigned int SUSEN2         : 1;	/* Channel Suspend Enable for SDMA Channel z */
		unsigned int SUSEN3         : 1;	/* Channel Suspend Enable for SDMA Channel z */
		unsigned int SUSEN4         : 1;	/* Channel Suspend Enable for SDMA Channel z */
		unsigned int SUSEN5         : 1;	/* Channel Suspend Enable for SDMA Channel z */
		unsigned int SUSEN6         : 1;	/* Channel Suspend Enable for SDMA Channel z */
		unsigned int SUSEN7         : 1;	/* Channel Suspend Enable for SDMA Channel z */
		/* const */ unsigned int RES            : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} SDMA_SUSENR00_type;
#define SDMA_SUSENR00	(*( SDMA_SUSENR00_type *) 0xf0010060u)	/* SDMA Suspend Enable Register 00 */
#define SDMA_SUSENR10	(*( SDMA_SUSENR00_type *) 0xf0011060u)	/* SDMA Suspend Enable Register 10 */


/* INT */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} INT_ACCEN00_type;
#define INT_ACCEN00	(*( INT_ACCEN00_type *) 0xf00370f4u)	/* Access Enable Register 0 */
#define INT_ACCEN10	(*( INT_ACCEN00_type *) 0xf00370fcu)	/* Kernel 1 Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} INT_ACCEN01_type;
#define INT_ACCEN01	(*( INT_ACCEN01_type *) 0xf00370f0u)	/* Kernel 0 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} INT_ACCEN11_type;
#define INT_ACCEN11	(*( INT_ACCEN11_type *) 0xf00370f8u)	/* Kernel 1 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int PN             : 8;	/* Service Request Priority Number */
		unsigned int                : 2;
		unsigned int ECC            : 6;	/* Service Request ECC */
		unsigned int ID             : 10;	/* Service Request Node ID */
		unsigned int                : 4;
		unsigned int EOV            : 1;	/* Error Overflow Bit */
		unsigned int STAT           : 1;	/* Error Status Bit */
	} B;
	int I;
	unsigned int U;

} INT_ECR0_type;
#define INT_ECR0	(*( INT_ECR0_type *) 0xf0037108u)	/* Error Capture Register 0 */
#define INT_ECR1	(*( INT_ECR0_type *) 0xf0037118u)	/* Error Capture Register 1 */
#define INT_ECR2	(*( INT_ECR0_type *) 0xf0037128u)	/* Error Capture Register 2 */
#define INT_ECR3	(*( INT_ECR0_type *) 0xf0037138u)	/* Error Capture Register 3 */
#define INT_ECR4	(*( INT_ECR0_type *) 0xf0037148u)	/* Error Capture Register 4 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} INT_ID_type;
#define INT_ID	(*( INT_ID_type *) 0xf0037008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int PN             : 8;	/* Last Acknowledged Service Request Priority Number */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int ECC            : 6;	/* Last Acknowledged Interrupt ECC */
		/* const */ unsigned int ID             : 10;	/* Last Acknowledged Interrupt SRN ID */
		/* const */ unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} INT_LASR0_type;
#define INT_LASR0	(*( INT_LASR0_type *) 0xf0037104u)	/* Last Acknowledged Service Request Register 0 */
#define INT_LASR1	(*( INT_LASR0_type *) 0xf0037114u)	/* Last Acknowledged Service Request Register 1 */
#define INT_LASR2	(*( INT_LASR0_type *) 0xf0037124u)	/* Last Acknowledged Service Request Register 2 */
#define INT_LASR3	(*( INT_LASR0_type *) 0xf0037134u)	/* Last Acknowledged Service Request Register 3 */
#define INT_LASR4	(*( INT_LASR0_type *) 0xf0037144u)	/* Last Acknowledged Service Request Register 4 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int PN             : 8;	/* Latest Winner Priority Number */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int ECC            : 6;	/* Latest Winner ECC */
		/* const */ unsigned int ID             : 10;	/* Latest Winner ID */
		/* const */ unsigned int                : 5;
		/* const */ unsigned int STAT           : 1;	/* LWI Register Status */
	} B;
	int I;
	unsigned int U;

} INT_LWSR0_type;
#define INT_LWSR0	(*( INT_LWSR0_type *) 0xf0037100u)	/* Latest Winning Service Request Register 0 */
#define INT_LWSR1	(*( INT_LWSR0_type *) 0xf0037110u)	/* Latest Winning Service Request Register 1 */
#define INT_LWSR2	(*( INT_LWSR0_type *) 0xf0037120u)	/* Latest Winning Service Request Register 2 */
#define INT_LWSR3	(*( INT_LWSR0_type *) 0xf0037130u)	/* Latest Winning Service Request Register 3 */
#define INT_LWSR4	(*( INT_LWSR0_type *) 0xf0037140u)	/* Latest Winning Service Request Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int TOS0           : 4;	/* Type of Service for Observation on OTGB0 */
		unsigned int                : 3;
		unsigned int OE0            : 1;	/* Output Enable for OTGB0 */
		unsigned int TOS1           : 4;	/* Type of Service for Observation on OTGB1 */
		unsigned int                : 3;
		unsigned int OE1            : 1;	/* Output Enable for OTGB1 */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} INT_OIT_type;
#define INT_OIT	(*( INT_OIT_type *) 0xf00370a0u)	/* OTGM IRQ Trace */

typedef volatile union
{
	struct
	{ 
		unsigned int MIRQ           : 10;	/* SRN Index for Missed Interrupt Trigger */
		unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} INT_OIXMS_type;
#define INT_OIXMS	(*( INT_OIXMS_type *) 0xf003708cu)	/* OTGM IRQ MUX Missed IRQ Select */

typedef volatile union
{
	struct
	{ 
		unsigned int IRQ0           : 10;	/* SRN Index for Interrupt Trigger 0 */
		unsigned int                : 6;
		unsigned int IRQ1           : 10;	/* SRN Index for Interrupt Trigger 1 */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} INT_OIXS0_type;
#define INT_OIXS0	(*( INT_OIXS0_type *) 0xf0037090u)	/* OTGM IRQ MUX Select 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int IRQ2           : 10;	/* SRN Index for Interrupt Trigger 2 */
		unsigned int                : 6;
		unsigned int IRQ3           : 10;	/* SRN Index for Interrupt Trigger 3 */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} INT_OIXS1_type;
#define INT_OIXS1	(*( INT_OIXS1_type *) 0xf0037094u)	/* OTGM IRQ MUX Select 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 2;	/* Trigger Set Select for OTGB0/1 Overlay */
		unsigned int                : 6;
		unsigned int OBS            : 2;	/* Overlay Byte Select */
		unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} INT_OIXTS_type;
#define INT_OIXTS	(*( INT_OIXTS_type *) 0xf0037088u)	/* OTGM IRQ MUX Trigger Set Select */

typedef volatile union
{
	struct
	{ 
		unsigned int OTGB0          : 16;	/* Bitwise Negedge Sensitivity for OTGB0 */
		unsigned int OTGB1          : 16;	/* Bitwise Negedge Sensitivity for OTGB1 */
	} B;
	int I;
	unsigned int U;

} INT_OMISN_type;
#define INT_OMISN	(*( INT_OMISN_type *) 0xf00370a8u)	/* OTGM MCDS I/F Sensitivity Negedge */

typedef volatile union
{
	struct
	{ 
		unsigned int OTGB0          : 16;	/* Bitwise Posedge Sensitivity for OTGB0 */
		unsigned int OTGB1          : 16;	/* Bitwise Posedge Sensitivity for OTGB1 */
	} B;
	int I;
	unsigned int U;

} INT_OMISP_type;
#define INT_OMISP	(*( INT_OMISP_type *) 0xf00370a4u)	/* OTGM MCDS I/F Sensitivity Posedge */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int OTGB0          : 16;	/* Status of OTGB0 */
		/* const */ unsigned int OTGB1          : 16;	/* Status of OTGB1 */
	} B;
	int I;
	unsigned int U;

} INT_OOBS_type;
#define INT_OOBS	(*( INT_OOBS_type *) 0xf0037080u)	/* OTGM OTGB0/1 Status */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 2;	/* Trigger Set for OTGB0/1 */
		unsigned int TGB            : 1;	/* OTGB0/1 Bus Select */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} INT_OSSIC_type;
#define INT_OSSIC	(*( INT_OSSIC_type *) 0xf0037084u)	/* OTGM SSI Control */

typedef volatile union
{
	struct
	{ 
		unsigned int TRIG0          : 1;	/* General Purpose Service Request Trigger 0 */
		unsigned int TRIG1          : 1;	/* General Purpose Service Request Trigger 1 */
		unsigned int TRIG2          : 1;	/* General Purpose Service Request Trigger 2 */
		unsigned int TRIG3          : 1;	/* General Purpose Service Request Trigger 3 */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} INT_SRB0_type;
#define INT_SRB0	(*( INT_SRB0_type *) 0xf0037010u)	/* Service Request Broadcast Register 0 */
#define INT_SRB1	(*( INT_SRB0_type *) 0xf0037014u)	/* Service Request Broadcast Register 1 */
#define INT_SRB2	(*( INT_SRB0_type *) 0xf0037018u)	/* Service Request Broadcast Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int SRPN           : 8;	/* Service Request Priority Number */
		unsigned int                : 2;
		unsigned int SRE            : 1;	/* Service Request Enable */
		unsigned int TOS            : 3;	/* Type of Service Control */
		unsigned int                : 2;
		unsigned int ECC            : 6;	/* ECC */
		unsigned int                : 2;
		/* const */ unsigned int SRR            : 1;	/* Service Request Flag */
		unsigned int CLRR           : 1;	/* Request Clear Bit */
		unsigned int SETR           : 1;	/* Request Set Bit */
		/* const */ unsigned int IOV            : 1;	/* Interrupt Trigger Overflow Bit */
		unsigned int IOVCLR         : 1;	/* Interrupt Trigger Overflow Clear Bit */
		/* const */ unsigned int SWS            : 1;	/* SW Sticky Bit */
		unsigned int SWSCLR         : 1;	/* SW Sticky Clear Bit */
		/* const */ unsigned int BUSY           : 1;	/* Busy Bit */
	} B;
	int I;
	unsigned int U;

} SRC_AGBT_type;
#define SRC_AGBT	(*( SRC_AGBT_type *) 0xf0038024u)	/* AGBT Service Request */
#define SRC_ASCLIN0ERR	(*( SRC_AGBT_type *) 0xf0038088u)	/* ASCLIN 0 Error Service Request */
#define SRC_ASCLIN0RX	(*( SRC_AGBT_type *) 0xf0038084u)	/* ASCLIN 0 Receive Service Request */
#define SRC_ASCLIN0TX	(*( SRC_AGBT_type *) 0xf0038080u)	/* ASCLIN 0 Transmit Service Request */
#define SRC_ASCLIN1ERR	(*( SRC_AGBT_type *) 0xf0038094u)	/* ASCLIN 1 Error Service Request */
#define SRC_ASCLIN1RX	(*( SRC_AGBT_type *) 0xf0038090u)	/* ASCLIN 1 Receive Service Request */
#define SRC_ASCLIN1TX	(*( SRC_AGBT_type *) 0xf003808cu)	/* ASCLIN 1 Transmit Service Request */
#define SRC_ASCLIN2ERR	(*( SRC_AGBT_type *) 0xf00380a0u)	/* ASCLIN 2 Error Service Request */
#define SRC_ASCLIN2RX	(*( SRC_AGBT_type *) 0xf003809cu)	/* ASCLIN 2 Receive Service Request */
#define SRC_ASCLIN2TX	(*( SRC_AGBT_type *) 0xf0038098u)	/* ASCLIN 2 Transmit Service Request */
#define SRC_ASCLIN3ERR	(*( SRC_AGBT_type *) 0xf00380acu)	/* ASCLIN 3 Error Service Request */
#define SRC_ASCLIN3RX	(*( SRC_AGBT_type *) 0xf00380a8u)	/* ASCLIN 3 Receive Service Request */
#define SRC_ASCLIN3TX	(*( SRC_AGBT_type *) 0xf00380a4u)	/* ASCLIN 3 Transmit Service Request */
#define SRC_BCUSPBSBSRC	(*( SRC_AGBT_type *) 0xf0038040u)	/* Bus Control Unit SPB Service Request */
#define SRC_BMU	(*( SRC_AGBT_type *) 0xf0038c80u)	/* Bus Monitor Unit Service Request */
#define SRC_CANINT0	(*( SRC_AGBT_type *) 0xf0038900u)	/* MULTICAN+ Service Request 0 */
#define SRC_CANINT1	(*( SRC_AGBT_type *) 0xf0038904u)	/* MULTICAN+ Service Request 1 */
#define SRC_CANINT10	(*( SRC_AGBT_type *) 0xf0038928u)	/* MULTICAN+ Service Request 10 */
#define SRC_CANINT11	(*( SRC_AGBT_type *) 0xf003892cu)	/* MULTICAN+ Service Request 11 */
#define SRC_CANINT12	(*( SRC_AGBT_type *) 0xf0038930u)	/* MULTICAN+ Service Request 12 */
#define SRC_CANINT13	(*( SRC_AGBT_type *) 0xf0038934u)	/* MULTICAN+ Service Request 13 */
#define SRC_CANINT14	(*( SRC_AGBT_type *) 0xf0038938u)	/* MULTICAN+ Service Request 14 */
#define SRC_CANINT15	(*( SRC_AGBT_type *) 0xf003893cu)	/* MULTICAN+ Service Request 15 */
#define SRC_CANINT2	(*( SRC_AGBT_type *) 0xf0038908u)	/* MULTICAN+ Service Request 2 */
#define SRC_CANINT3	(*( SRC_AGBT_type *) 0xf003890cu)	/* MULTICAN+ Service Request 3 */
#define SRC_CANINT4	(*( SRC_AGBT_type *) 0xf0038910u)	/* MULTICAN+ Service Request 4 */
#define SRC_CANINT5	(*( SRC_AGBT_type *) 0xf0038914u)	/* MULTICAN+ Service Request 5 */
#define SRC_CANINT6	(*( SRC_AGBT_type *) 0xf0038918u)	/* MULTICAN+ Service Request 6 */
#define SRC_CANINT7	(*( SRC_AGBT_type *) 0xf003891cu)	/* MULTICAN+ Service Request 7 */
#define SRC_CANINT8	(*( SRC_AGBT_type *) 0xf0038920u)	/* MULTICAN+ Service Request 8 */
#define SRC_CANINT9	(*( SRC_AGBT_type *) 0xf0038924u)	/* MULTICAN+ Service Request 9 */
#define SRC_CCU60SR0	(*( SRC_AGBT_type *) 0xf0038420u)	/* CCU6 0 Service Request 0 */
#define SRC_CCU60SR1	(*( SRC_AGBT_type *) 0xf0038424u)	/* CCU6 0 Service Request 1 */
#define SRC_CCU60SR2	(*( SRC_AGBT_type *) 0xf0038428u)	/* CCU6 0 Service Request 2 */
#define SRC_CCU60SR3	(*( SRC_AGBT_type *) 0xf003842cu)	/* CCU6 0 Service Request 3 */
#define SRC_CCU61SR0	(*( SRC_AGBT_type *) 0xf0038430u)	/* CCU6 1 Service Request 0 */
#define SRC_CCU61SR1	(*( SRC_AGBT_type *) 0xf0038434u)	/* CCU6 1 Service Request 1 */
#define SRC_CCU61SR2	(*( SRC_AGBT_type *) 0xf0038438u)	/* CCU6 1 Service Request 2 */
#define SRC_CCU61SR3	(*( SRC_AGBT_type *) 0xf003843cu)	/* CCU6 1 Service Request 3 */
#define SRC_CCU62SR0	(*( SRC_AGBT_type *) 0xf0038440u)	/* CCU6 2 Service Request 0 */
#define SRC_CCU62SR1	(*( SRC_AGBT_type *) 0xf0038444u)	/* CCU6 2 Service Request 1 */
#define SRC_CCU62SR2	(*( SRC_AGBT_type *) 0xf0038448u)	/* CCU6 2 Service Request 2 */
#define SRC_CCU62SR3	(*( SRC_AGBT_type *) 0xf003844cu)	/* CCU6 2 Service Request 3 */
#define SRC_CCU63SR0	(*( SRC_AGBT_type *) 0xf0038450u)	/* CCU6 3 Service Request 0 */
#define SRC_CCU63SR1	(*( SRC_AGBT_type *) 0xf0038454u)	/* CCU6 3 Service Request 1 */
#define SRC_CCU63SR2	(*( SRC_AGBT_type *) 0xf0038458u)	/* CCU6 3 Service Request 2 */
#define SRC_CCU63SR3	(*( SRC_AGBT_type *) 0xf003845cu)	/* CCU6 3 Service Request 3 */
#define SRC_CERBERUS0	(*( SRC_AGBT_type *) 0xf0038050u)	/* Cerberus Service Request 0 */
#define SRC_CERBERUS1	(*( SRC_AGBT_type *) 0xf0038054u)	/* Cerberus Service Request 1 */
#define SRC_CIFISP	(*( SRC_AGBT_type *) 0xf0038da8u)	/* CIF ISP Service Request */
#define SRC_CIFMI	(*( SRC_AGBT_type *) 0xf0038da0u)	/* CIF MI Service Request */
#define SRC_CIFMIEP	(*( SRC_AGBT_type *) 0xf0038da4u)	/* CIF MI EP Service Request */
#define SRC_CIFMJPEG	(*( SRC_AGBT_type *) 0xf0038dacu)	/* CIF MJPEG Service Request */
#define SRC_CPU0SBSRC	(*( SRC_AGBT_type *) 0xf0038000u)	/* CPU 0 Software Breakpoint Service Request */
#define SRC_CPU1SBSRC	(*( SRC_AGBT_type *) 0xf0038004u)	/* CPU 1 Software Breakpoint Service Request */
#define SRC_CPU2SBSRC	(*( SRC_AGBT_type *) 0xf0038008u)	/* CPU 2 Software Breakpoint Service Request */
#define SRC_DAM0	(*( SRC_AGBT_type *) 0xf0038d70u)	/* DAM Service Request 0 */
#define SRC_DAM1	(*( SRC_AGBT_type *) 0xf0038d74u)	/* DAM Service Request 1 */
#define SRC_DAM2	(*( SRC_AGBT_type *) 0xf0038d78u)	/* DAM Service Request 2 */
#define SRC_DAM3	(*( SRC_AGBT_type *) 0xf0038d7cu)	/* DAM Service Request 3 */
#define SRC_DAM4	(*( SRC_AGBT_type *) 0xf0038d80u)	/* DAM Service Request 4 */
#define SRC_DAM5	(*( SRC_AGBT_type *) 0xf0038d84u)	/* DAM Service Request 5 */
#define SRC_DMAME0	(*( SRC_AGBT_type *) 0xf00384d8u)	/* DMA Move Engine 0 Service Request */
#define SRC_DMAME0CH0	(*( SRC_AGBT_type *) 0xf00386f0u)	/* DMA Move Engine 0 Channel 0 Service Request */
#define SRC_DMAME0CH1	(*( SRC_AGBT_type *) 0xf00386f4u)	/* DMA Move Engine 0 Channel 1 Service Request */
#define SRC_DMAME0CH10	(*( SRC_AGBT_type *) 0xf0038718u)	/* DMA Move Engine 0 Channel 10 Service Request */
#define SRC_DMAME0CH11	(*( SRC_AGBT_type *) 0xf003871cu)	/* DMA Move Engine 0 Channel 11 Service Request */
#define SRC_DMAME0CH12	(*( SRC_AGBT_type *) 0xf0038720u)	/* DMA Move Engine 0 Channel 12 Service Request */
#define SRC_DMAME0CH13	(*( SRC_AGBT_type *) 0xf0038724u)	/* DMA Move Engine 0 Channel 13 Service Request */
#define SRC_DMAME0CH14	(*( SRC_AGBT_type *) 0xf0038728u)	/* DMA Move Engine 0 Channel 14 Service Request */
#define SRC_DMAME0CH15	(*( SRC_AGBT_type *) 0xf003872cu)	/* DMA Move Engine 0 Channel 15 Service Request */
#define SRC_DMAME0CH16	(*( SRC_AGBT_type *) 0xf0038730u)	/* DMA Move Engine 0 Channel 16 Service Request */
#define SRC_DMAME0CH17	(*( SRC_AGBT_type *) 0xf0038734u)	/* DMA Move Engine 0 Channel 17 Service Request */
#define SRC_DMAME0CH18	(*( SRC_AGBT_type *) 0xf0038738u)	/* DMA Move Engine 0 Channel 18 Service Request */
#define SRC_DMAME0CH19	(*( SRC_AGBT_type *) 0xf003873cu)	/* DMA Move Engine 0 Channel 19 Service Request */
#define SRC_DMAME0CH2	(*( SRC_AGBT_type *) 0xf00386f8u)	/* DMA Move Engine 0 Channel 2 Service Request */
#define SRC_DMAME0CH20	(*( SRC_AGBT_type *) 0xf0038740u)	/* DMA Move Engine 0 Channel 20 Service Request */
#define SRC_DMAME0CH21	(*( SRC_AGBT_type *) 0xf0038744u)	/* DMA Move Engine 0 Channel 21 Service Request */
#define SRC_DMAME0CH22	(*( SRC_AGBT_type *) 0xf0038748u)	/* DMA Move Engine 0 Channel 22 Service Request */
#define SRC_DMAME0CH23	(*( SRC_AGBT_type *) 0xf003874cu)	/* DMA Move Engine 0 Channel 23 Service Request */
#define SRC_DMAME0CH3	(*( SRC_AGBT_type *) 0xf00386fcu)	/* DMA Move Engine 0 Channel 3 Service Request */
#define SRC_DMAME0CH4	(*( SRC_AGBT_type *) 0xf0038700u)	/* DMA Move Engine 0 Channel 4 Service Request */
#define SRC_DMAME0CH5	(*( SRC_AGBT_type *) 0xf0038704u)	/* DMA Move Engine 0 Channel 5 Service Request */
#define SRC_DMAME0CH6	(*( SRC_AGBT_type *) 0xf0038708u)	/* DMA Move Engine 0 Channel 6 Service Request */
#define SRC_DMAME0CH7	(*( SRC_AGBT_type *) 0xf003870cu)	/* DMA Move Engine 0 Channel 7 Service Request */
#define SRC_DMAME0CH8	(*( SRC_AGBT_type *) 0xf0038710u)	/* DMA Move Engine 0 Channel 8 Service Request */
#define SRC_DMAME0CH9	(*( SRC_AGBT_type *) 0xf0038714u)	/* DMA Move Engine 0 Channel 9 Service Request */
#define SRC_DMAME1	(*( SRC_AGBT_type *) 0xf00384dcu)	/* DMA Move Engine 1 Service Request */
#define SRC_DMAME1CH0	(*( SRC_AGBT_type *) 0xf00387f0u)	/* DMA Move Engine 1 Channel 0 Service Request */
#define SRC_DMAME1CH1	(*( SRC_AGBT_type *) 0xf00387f4u)	/* DMA Move Engine 1 Channel 1 Service Request */
#define SRC_DMAME1CH10	(*( SRC_AGBT_type *) 0xf0038818u)	/* DMA Move Engine 1 Channel 10 Service Request */
#define SRC_DMAME1CH11	(*( SRC_AGBT_type *) 0xf003881cu)	/* DMA Move Engine 1 Channel 11 Service Request */
#define SRC_DMAME1CH12	(*( SRC_AGBT_type *) 0xf0038820u)	/* DMA Move Engine 1 Channel 12 Service Request */
#define SRC_DMAME1CH13	(*( SRC_AGBT_type *) 0xf0038824u)	/* DMA Move Engine 1 Channel 13 Service Request */
#define SRC_DMAME1CH14	(*( SRC_AGBT_type *) 0xf0038828u)	/* DMA Move Engine 1 Channel 14 Service Request */
#define SRC_DMAME1CH15	(*( SRC_AGBT_type *) 0xf003882cu)	/* DMA Move Engine 1 Channel 15 Service Request */
#define SRC_DMAME1CH16	(*( SRC_AGBT_type *) 0xf0038830u)	/* DMA Move Engine 1 Channel 16 Service Request */
#define SRC_DMAME1CH17	(*( SRC_AGBT_type *) 0xf0038834u)	/* DMA Move Engine 1 Channel 17 Service Request */
#define SRC_DMAME1CH18	(*( SRC_AGBT_type *) 0xf0038838u)	/* DMA Move Engine 1 Channel 18 Service Request */
#define SRC_DMAME1CH19	(*( SRC_AGBT_type *) 0xf003883cu)	/* DMA Move Engine 1 Channel 19 Service Request */
#define SRC_DMAME1CH2	(*( SRC_AGBT_type *) 0xf00387f8u)	/* DMA Move Engine 1 Channel 2 Service Request */
#define SRC_DMAME1CH20	(*( SRC_AGBT_type *) 0xf0038840u)	/* DMA Move Engine 1 Channel 20 Service Request */
#define SRC_DMAME1CH21	(*( SRC_AGBT_type *) 0xf0038844u)	/* DMA Move Engine 1 Channel 21 Service Request */
#define SRC_DMAME1CH22	(*( SRC_AGBT_type *) 0xf0038848u)	/* DMA Move Engine 1 Channel 22 Service Request */
#define SRC_DMAME1CH23	(*( SRC_AGBT_type *) 0xf003884cu)	/* DMA Move Engine 1 Channel 23 Service Request */
#define SRC_DMAME1CH3	(*( SRC_AGBT_type *) 0xf00387fcu)	/* DMA Move Engine 1 Channel 3 Service Request */
#define SRC_DMAME1CH4	(*( SRC_AGBT_type *) 0xf0038800u)	/* DMA Move Engine 1 Channel 4 Service Request */
#define SRC_DMAME1CH5	(*( SRC_AGBT_type *) 0xf0038804u)	/* DMA Move Engine 1 Channel 5 Service Request */
#define SRC_DMAME1CH6	(*( SRC_AGBT_type *) 0xf0038808u)	/* DMA Move Engine 1 Channel 6 Service Request */
#define SRC_DMAME1CH7	(*( SRC_AGBT_type *) 0xf003880cu)	/* DMA Move Engine 1 Channel 7 Service Request */
#define SRC_DMAME1CH8	(*( SRC_AGBT_type *) 0xf0038810u)	/* DMA Move Engine 1 Channel 8 Service Request */
#define SRC_DMAME1CH9	(*( SRC_AGBT_type *) 0xf0038814u)	/* DMA Move Engine 1 Channel 9 Service Request */
#define SRC_DSADCSRA0	(*( SRC_AGBT_type *) 0xf0038b94u)	/* DSADC SRA0 Service Request */
#define SRC_DSADCSRA1	(*( SRC_AGBT_type *) 0xf0038b9cu)	/* DSADC SRA1 Service Request */
#define SRC_DSADCSRA2	(*( SRC_AGBT_type *) 0xf0038ba4u)	/* DSADC SRA2 Service Request */
#define SRC_DSADCSRA3	(*( SRC_AGBT_type *) 0xf0038bacu)	/* DSADC SRA3 Service Request */
#define SRC_DSADCSRA4	(*( SRC_AGBT_type *) 0xf0038bb4u)	/* DSADC SRA4 Service Request */
#define SRC_DSADCSRA5	(*( SRC_AGBT_type *) 0xf0038bbcu)	/* DSADC SRA5 Service Request */
#define SRC_DSADCSRM0	(*( SRC_AGBT_type *) 0xf0038b90u)	/* DSADC SRM0 Service Request */
#define SRC_DSADCSRM1	(*( SRC_AGBT_type *) 0xf0038b98u)	/* DSADC SRM1 Service Request */
#define SRC_DSADCSRM2	(*( SRC_AGBT_type *) 0xf0038ba0u)	/* DSADC SRM2 Service Request */
#define SRC_DSADCSRM3	(*( SRC_AGBT_type *) 0xf0038ba8u)	/* DSADC SRM3 Service Request */
#define SRC_DSADCSRM4	(*( SRC_AGBT_type *) 0xf0038bb0u)	/* DSADC SRM4 Service Request */
#define SRC_DSADCSRM5	(*( SRC_AGBT_type *) 0xf0038bb8u)	/* DSADC SRM5 Service Request */
#define SRC_EMEM	(*( SRC_AGBT_type *) 0xf0038020u)	/* Emulation Memory Service Request */
#define SRC_ERAYIBUSY	(*( SRC_AGBT_type *) 0xf0038c04u)	/* E-RAY Input Buffer Busy Service Request */
#define SRC_ERAYINT0	(*( SRC_AGBT_type *) 0xf0038be0u)	/* E-RAY Service Request 0 */
#define SRC_ERAYINT1	(*( SRC_AGBT_type *) 0xf0038be4u)	/* E-RAY Service Request 1 */
#define SRC_ERAYMBSC0	(*( SRC_AGBT_type *) 0xf0038bf8u)	/* E-RAY Message Buffer Status Changed 0 Service Request */
#define SRC_ERAYMBSC1	(*( SRC_AGBT_type *) 0xf0038bfcu)	/* E-RAY Message Buffer Status Changed 1 Service Request */
#define SRC_ERAYNDAT0	(*( SRC_AGBT_type *) 0xf0038bf0u)	/* E-RAY New Data 0 Service Request */
#define SRC_ERAYNDAT1	(*( SRC_AGBT_type *) 0xf0038bf4u)	/* E-RAY New Data 1 Service Request */
#define SRC_ERAYOBUSY	(*( SRC_AGBT_type *) 0xf0038c00u)	/* E-RAY Output Buffer Busy Service Request */
#define SRC_ERAYTINT0	(*( SRC_AGBT_type *) 0xf0038be8u)	/* E-RAY Timer Interrupt 0 Service Request */
#define SRC_ERAYTINT1	(*( SRC_AGBT_type *) 0xf0038becu)	/* E-RAY Timer Interrupt 1 Service Request */
#define SRC_ETH	(*( SRC_AGBT_type *) 0xf00388f0u)	/* Ethernet Service Request */
#define SRC_FCE	(*( SRC_AGBT_type *) 0xf00384b0u)	/* FCE Error Service Request */
#define SRC_GPSR00	(*( SRC_AGBT_type *) 0xf0039000u)	/* General Purpose Service Request 00 */
#define SRC_GPSR01	(*( SRC_AGBT_type *) 0xf0039004u)	/* General Purpose Service Request 01 */
#define SRC_GPSR02	(*( SRC_AGBT_type *) 0xf0039008u)	/* General Purpose Service Request 02 */
#define SRC_GPSR03	(*( SRC_AGBT_type *) 0xf003900cu)	/* General Purpose Service Request 03 */
#define SRC_GPSR10	(*( SRC_AGBT_type *) 0xf0039020u)	/* General Purpose Service Request 10 */
#define SRC_GPSR11	(*( SRC_AGBT_type *) 0xf0039024u)	/* General Purpose Service Request 11 */
#define SRC_GPSR12	(*( SRC_AGBT_type *) 0xf0039028u)	/* General Purpose Service Request 12 */
#define SRC_GPSR13	(*( SRC_AGBT_type *) 0xf003902cu)	/* General Purpose Service Request 13 */
#define SRC_GPSR20	(*( SRC_AGBT_type *) 0xf0039040u)	/* General Purpose Service Request 20 */
#define SRC_GPSR21	(*( SRC_AGBT_type *) 0xf0039044u)	/* General Purpose Service Request 21 */
#define SRC_GPSR22	(*( SRC_AGBT_type *) 0xf0039048u)	/* General Purpose Service Request 22 */
#define SRC_GPSR23	(*( SRC_AGBT_type *) 0xf003904cu)	/* General Purpose Service Request 23 */
#define SRC_GPT120CIRQ	(*( SRC_AGBT_type *) 0xf0038460u)	/* GPT120 CAPREL Service Request */
#define SRC_GPT120T2	(*( SRC_AGBT_type *) 0xf0038464u)	/* GPT120 T2 Overflow/Underflow Service Request */
#define SRC_GPT120T3	(*( SRC_AGBT_type *) 0xf0038468u)	/* GPT120 T3 Overflow/Underflow Service Request */
#define SRC_GPT120T4	(*( SRC_AGBT_type *) 0xf003846cu)	/* GPT120 T4 Overflow/Underflow Service Request */
#define SRC_GPT120T5	(*( SRC_AGBT_type *) 0xf0038470u)	/* GPT120 T5 Overflow/Underflow Service Request */
#define SRC_GPT120T6	(*( SRC_AGBT_type *) 0xf0038474u)	/* GPT120 T6 Overflow/Underflow Service Request */
#define SRC_GPT121CIRQ	(*( SRC_AGBT_type *) 0xf0038478u)	/* GPT121 CAPREL Service Request */
#define SRC_GPT121T2	(*( SRC_AGBT_type *) 0xf003847cu)	/* GPT121 T2 Overflow/Underflow Service Request */
#define SRC_GPT121T3	(*( SRC_AGBT_type *) 0xf0038480u)	/* GPT121 T3 Overflow/Underflow Service Request */
#define SRC_GPT121T4	(*( SRC_AGBT_type *) 0xf0038484u)	/* GPT121 T4 Overflow/Underflow Service Request */
#define SRC_GPT121T5	(*( SRC_AGBT_type *) 0xf0038488u)	/* GPT121 T5 Overflow/Underflow Service Request */
#define SRC_GPT121T6	(*( SRC_AGBT_type *) 0xf003848cu)	/* GPT121 T6 Overflow/Underflow Service Request */
#define SRC_GTMAEIIRQ	(*( SRC_AGBT_type *) 0xf0039600u)	/* GTM AEI Shared Service Request */
#define SRC_GTMARUIRQ0	(*( SRC_AGBT_type *) 0xf0039604u)	/* GTM ARU Shared Service Request 0 */
#define SRC_GTMARUIRQ1	(*( SRC_AGBT_type *) 0xf0039608u)	/* GTM ARU Shared Service Request 1 */
#define SRC_GTMARUIRQ2	(*( SRC_AGBT_type *) 0xf003960cu)	/* GTM ARU Shared Service Request 2 */
#define SRC_GTMATOM00	(*( SRC_AGBT_type *) 0xf0039d80u)	/* GTM ATOM0 Shared Service Request 0 */
#define SRC_GTMATOM01	(*( SRC_AGBT_type *) 0xf0039d84u)	/* GTM ATOM0 Shared Service Request 1 */
#define SRC_GTMATOM02	(*( SRC_AGBT_type *) 0xf0039d88u)	/* GTM ATOM0 Shared Service Request 2 */
#define SRC_GTMATOM03	(*( SRC_AGBT_type *) 0xf0039d8cu)	/* GTM ATOM0 Shared Service Request 3 */
#define SRC_GTMATOM10	(*( SRC_AGBT_type *) 0xf0039d90u)	/* GTM ATOM1 Shared Service Request 0 */
#define SRC_GTMATOM11	(*( SRC_AGBT_type *) 0xf0039d94u)	/* GTM ATOM1 Shared Service Request 1 */
#define SRC_GTMATOM12	(*( SRC_AGBT_type *) 0xf0039d98u)	/* GTM ATOM1 Shared Service Request 2 */
#define SRC_GTMATOM13	(*( SRC_AGBT_type *) 0xf0039d9cu)	/* GTM ATOM1 Shared Service Request 3 */
#define SRC_GTMATOM20	(*( SRC_AGBT_type *) 0xf0039da0u)	/* GTM ATOM2 Shared Service Request 0 */
#define SRC_GTMATOM21	(*( SRC_AGBT_type *) 0xf0039da4u)	/* GTM ATOM2 Shared Service Request 1 */
#define SRC_GTMATOM22	(*( SRC_AGBT_type *) 0xf0039da8u)	/* GTM ATOM2 Shared Service Request 2 */
#define SRC_GTMATOM23	(*( SRC_AGBT_type *) 0xf0039dacu)	/* GTM ATOM2 Shared Service Request 3 */
#define SRC_GTMATOM30	(*( SRC_AGBT_type *) 0xf0039db0u)	/* GTM ATOM3 Shared Service Request 0 */
#define SRC_GTMATOM31	(*( SRC_AGBT_type *) 0xf0039db4u)	/* GTM ATOM3 Shared Service Request 1 */
#define SRC_GTMATOM32	(*( SRC_AGBT_type *) 0xf0039db8u)	/* GTM ATOM3 Shared Service Request 2 */
#define SRC_GTMATOM33	(*( SRC_AGBT_type *) 0xf0039dbcu)	/* GTM ATOM3 Shared Service Request 3 */
#define SRC_GTMATOM40	(*( SRC_AGBT_type *) 0xf0039dc0u)	/* GTM ATOM4 Shared Service Request 0 */
#define SRC_GTMATOM41	(*( SRC_AGBT_type *) 0xf0039dc4u)	/* GTM ATOM4 Shared Service Request 1 */
#define SRC_GTMATOM42	(*( SRC_AGBT_type *) 0xf0039dc8u)	/* GTM ATOM4 Shared Service Request 2 */
#define SRC_GTMATOM43	(*( SRC_AGBT_type *) 0xf0039dccu)	/* GTM ATOM4 Shared Service Request 3 */
#define SRC_GTMBRCIRQ	(*( SRC_AGBT_type *) 0xf0039614u)	/* GTM BRC Shared Service Request */
#define SRC_GTMCMPIRQ	(*( SRC_AGBT_type *) 0xf0039618u)	/* GTM CMP Shared Service Request */
#define SRC_GTMDPLL0	(*( SRC_AGBT_type *) 0xf00396a4u)	/* GTM DPLL Service Request 0 */
#define SRC_GTMDPLL1	(*( SRC_AGBT_type *) 0xf00396a8u)	/* GTM DPLL Service Request 1 */
#define SRC_GTMDPLL10	(*( SRC_AGBT_type *) 0xf00396ccu)	/* GTM DPLL Service Request 10 */
#define SRC_GTMDPLL11	(*( SRC_AGBT_type *) 0xf00396d0u)	/* GTM DPLL Service Request 11 */
#define SRC_GTMDPLL12	(*( SRC_AGBT_type *) 0xf00396d4u)	/* GTM DPLL Service Request 12 */
#define SRC_GTMDPLL13	(*( SRC_AGBT_type *) 0xf00396d8u)	/* GTM DPLL Service Request 13 */
#define SRC_GTMDPLL14	(*( SRC_AGBT_type *) 0xf00396dcu)	/* GTM DPLL Service Request 14 */
#define SRC_GTMDPLL15	(*( SRC_AGBT_type *) 0xf00396e0u)	/* GTM DPLL Service Request 15 */
#define SRC_GTMDPLL16	(*( SRC_AGBT_type *) 0xf00396e4u)	/* GTM DPLL Service Request 16 */
#define SRC_GTMDPLL17	(*( SRC_AGBT_type *) 0xf00396e8u)	/* GTM DPLL Service Request 17 */
#define SRC_GTMDPLL18	(*( SRC_AGBT_type *) 0xf00396ecu)	/* GTM DPLL Service Request 18 */
#define SRC_GTMDPLL19	(*( SRC_AGBT_type *) 0xf00396f0u)	/* GTM DPLL Service Request 19 */
#define SRC_GTMDPLL2	(*( SRC_AGBT_type *) 0xf00396acu)	/* GTM DPLL Service Request 2 */
#define SRC_GTMDPLL20	(*( SRC_AGBT_type *) 0xf00396f4u)	/* GTM DPLL Service Request 20 */
#define SRC_GTMDPLL21	(*( SRC_AGBT_type *) 0xf00396f8u)	/* GTM DPLL Service Request 21 */
#define SRC_GTMDPLL22	(*( SRC_AGBT_type *) 0xf00396fcu)	/* GTM DPLL Service Request 22 */
#define SRC_GTMDPLL23	(*( SRC_AGBT_type *) 0xf0039700u)	/* GTM DPLL Service Request 23 */
#define SRC_GTMDPLL24	(*( SRC_AGBT_type *) 0xf0039704u)	/* GTM DPLL Service Request 24 */
#define SRC_GTMDPLL25	(*( SRC_AGBT_type *) 0xf0039708u)	/* GTM DPLL Service Request 25 */
#define SRC_GTMDPLL26	(*( SRC_AGBT_type *) 0xf003970cu)	/* GTM DPLL Service Request 26 */
#define SRC_GTMDPLL3	(*( SRC_AGBT_type *) 0xf00396b0u)	/* GTM DPLL Service Request 3 */
#define SRC_GTMDPLL4	(*( SRC_AGBT_type *) 0xf00396b4u)	/* GTM DPLL Service Request 4 */
#define SRC_GTMDPLL5	(*( SRC_AGBT_type *) 0xf00396b8u)	/* GTM DPLL Service Request 5 */
#define SRC_GTMDPLL6	(*( SRC_AGBT_type *) 0xf00396bcu)	/* GTM DPLL Service Request 6 */
#define SRC_GTMDPLL7	(*( SRC_AGBT_type *) 0xf00396c0u)	/* GTM DPLL Service Request 7 */
#define SRC_GTMDPLL8	(*( SRC_AGBT_type *) 0xf00396c4u)	/* GTM DPLL Service Request 8 */
#define SRC_GTMDPLL9	(*( SRC_AGBT_type *) 0xf00396c8u)	/* GTM DPLL Service Request 9 */
#define SRC_GTMMCS00	(*( SRC_AGBT_type *) 0xf0039980u)	/* GTM MCS0 Shared Service Request 0 */
#define SRC_GTMMCS01	(*( SRC_AGBT_type *) 0xf0039984u)	/* GTM MCS0 Shared Service Request 1 */
#define SRC_GTMMCS02	(*( SRC_AGBT_type *) 0xf0039988u)	/* GTM MCS0 Shared Service Request 2 */
#define SRC_GTMMCS03	(*( SRC_AGBT_type *) 0xf003998cu)	/* GTM MCS0 Shared Service Request 3 */
#define SRC_GTMMCS04	(*( SRC_AGBT_type *) 0xf0039990u)	/* GTM MCS0 Shared Service Request 4 */
#define SRC_GTMMCS05	(*( SRC_AGBT_type *) 0xf0039994u)	/* GTM MCS0 Shared Service Request 5 */
#define SRC_GTMMCS06	(*( SRC_AGBT_type *) 0xf0039998u)	/* GTM MCS0 Shared Service Request 6 */
#define SRC_GTMMCS07	(*( SRC_AGBT_type *) 0xf003999cu)	/* GTM MCS0 Shared Service Request 7 */
#define SRC_GTMMCS10	(*( SRC_AGBT_type *) 0xf00399a0u)	/* GTM MCS1 Shared Service Request 0 */
#define SRC_GTMMCS11	(*( SRC_AGBT_type *) 0xf00399a4u)	/* GTM MCS1 Shared Service Request 1 */
#define SRC_GTMMCS12	(*( SRC_AGBT_type *) 0xf00399a8u)	/* GTM MCS1 Shared Service Request 2 */
#define SRC_GTMMCS13	(*( SRC_AGBT_type *) 0xf00399acu)	/* GTM MCS1 Shared Service Request 3 */
#define SRC_GTMMCS14	(*( SRC_AGBT_type *) 0xf00399b0u)	/* GTM MCS1 Shared Service Request 4 */
#define SRC_GTMMCS15	(*( SRC_AGBT_type *) 0xf00399b4u)	/* GTM MCS1 Shared Service Request 5 */
#define SRC_GTMMCS16	(*( SRC_AGBT_type *) 0xf00399b8u)	/* GTM MCS1 Shared Service Request 6 */
#define SRC_GTMMCS17	(*( SRC_AGBT_type *) 0xf00399bcu)	/* GTM MCS1 Shared Service Request 7 */
#define SRC_GTMMCS20	(*( SRC_AGBT_type *) 0xf00399c0u)	/* GTM MCS2 Shared Service Request 0 */
#define SRC_GTMMCS21	(*( SRC_AGBT_type *) 0xf00399c4u)	/* GTM MCS2 Shared Service Request 1 */
#define SRC_GTMMCS22	(*( SRC_AGBT_type *) 0xf00399c8u)	/* GTM MCS2 Shared Service Request 2 */
#define SRC_GTMMCS23	(*( SRC_AGBT_type *) 0xf00399ccu)	/* GTM MCS2 Shared Service Request 3 */
#define SRC_GTMMCS24	(*( SRC_AGBT_type *) 0xf00399d0u)	/* GTM MCS2 Shared Service Request 4 */
#define SRC_GTMMCS25	(*( SRC_AGBT_type *) 0xf00399d4u)	/* GTM MCS2 Shared Service Request 5 */
#define SRC_GTMMCS26	(*( SRC_AGBT_type *) 0xf00399d8u)	/* GTM MCS2 Shared Service Request 6 */
#define SRC_GTMMCS27	(*( SRC_AGBT_type *) 0xf00399dcu)	/* GTM MCS2 Shared Service Request 7 */
#define SRC_GTMMCS30	(*( SRC_AGBT_type *) 0xf00399e0u)	/* GTM MCS3 Shared Service Request 0 */
#define SRC_GTMMCS31	(*( SRC_AGBT_type *) 0xf00399e4u)	/* GTM MCS3 Shared Service Request 1 */
#define SRC_GTMMCS32	(*( SRC_AGBT_type *) 0xf00399e8u)	/* GTM MCS3 Shared Service Request 2 */
#define SRC_GTMMCS33	(*( SRC_AGBT_type *) 0xf00399ecu)	/* GTM MCS3 Shared Service Request 3 */
#define SRC_GTMMCS34	(*( SRC_AGBT_type *) 0xf00399f0u)	/* GTM MCS3 Shared Service Request 4 */
#define SRC_GTMMCS35	(*( SRC_AGBT_type *) 0xf00399f4u)	/* GTM MCS3 Shared Service Request 5 */
#define SRC_GTMMCS36	(*( SRC_AGBT_type *) 0xf00399f8u)	/* GTM MCS3 Shared Service Request 6 */
#define SRC_GTMMCS37	(*( SRC_AGBT_type *) 0xf00399fcu)	/* GTM MCS3 Shared Service Request 7 */
#define SRC_GTMMCSW00	(*( SRC_AGBT_type *) 0xf0039f00u)	/* GTM Multi Channel Sequencer 0 Service Request 0 */
#define SRC_GTMMCSW01	(*( SRC_AGBT_type *) 0xf0039f04u)	/* GTM Multi Channel Sequencer 0 Service Request 1 */
#define SRC_GTMMCSW10	(*( SRC_AGBT_type *) 0xf0039f08u)	/* GTM Multi Channel Sequencer 1 Service Request 0 */
#define SRC_GTMMCSW11	(*( SRC_AGBT_type *) 0xf0039f0cu)	/* GTM Multi Channel Sequencer 1 Service Request 1 */
#define SRC_GTMMCSW20	(*( SRC_AGBT_type *) 0xf0039f10u)	/* GTM Multi Channel Sequencer 2 Service Request 0 */
#define SRC_GTMMCSW21	(*( SRC_AGBT_type *) 0xf0039f14u)	/* GTM Multi Channel Sequencer 2 Service Request 1 */
#define SRC_GTMMCSW30	(*( SRC_AGBT_type *) 0xf0039f18u)	/* GTM Multi Channel Sequencer 2 Service Request 0 */
#define SRC_GTMMCSW31	(*( SRC_AGBT_type *) 0xf0039f1cu)	/* GTM Multi Channel Sequencer 2 Service Request 1 */
#define SRC_GTMPSM00	(*( SRC_AGBT_type *) 0xf0039624u)	/* GTM PSM0 Shared Service Request 0 */
#define SRC_GTMPSM01	(*( SRC_AGBT_type *) 0xf0039628u)	/* GTM PSM0 Shared Service Request 1 */
#define SRC_GTMPSM02	(*( SRC_AGBT_type *) 0xf003962cu)	/* GTM PSM0 Shared Service Request 2 */
#define SRC_GTMPSM03	(*( SRC_AGBT_type *) 0xf0039630u)	/* GTM PSM0 Shared Service Request 3 */
#define SRC_GTMPSM04	(*( SRC_AGBT_type *) 0xf0039634u)	/* GTM PSM0 Shared Service Request 4 */
#define SRC_GTMPSM05	(*( SRC_AGBT_type *) 0xf0039638u)	/* GTM PSM0 Shared Service Request 5 */
#define SRC_GTMPSM06	(*( SRC_AGBT_type *) 0xf003963cu)	/* GTM PSM0 Shared Service Request 6 */
#define SRC_GTMPSM07	(*( SRC_AGBT_type *) 0xf0039640u)	/* GTM PSM0 Shared Service Request 7 */
#define SRC_GTMSPE0IRQ	(*( SRC_AGBT_type *) 0xf003961cu)	/* GTM SPE0 Shared Service Request */
#define SRC_GTMSPE1IRQ	(*( SRC_AGBT_type *) 0xf0039620u)	/* GTM SPE1 Shared Service Request */
#define SRC_GTMTIM00	(*( SRC_AGBT_type *) 0xf0039780u)	/* GTM TIM0 Shared Service Request 0 */
#define SRC_GTMTIM01	(*( SRC_AGBT_type *) 0xf0039784u)	/* GTM TIM0 Shared Service Request 1 */
#define SRC_GTMTIM02	(*( SRC_AGBT_type *) 0xf0039788u)	/* GTM TIM0 Shared Service Request 2 */
#define SRC_GTMTIM03	(*( SRC_AGBT_type *) 0xf003978cu)	/* GTM TIM0 Shared Service Request 3 */
#define SRC_GTMTIM04	(*( SRC_AGBT_type *) 0xf0039790u)	/* GTM TIM0 Shared Service Request 4 */
#define SRC_GTMTIM05	(*( SRC_AGBT_type *) 0xf0039794u)	/* GTM TIM0 Shared Service Request 5 */
#define SRC_GTMTIM06	(*( SRC_AGBT_type *) 0xf0039798u)	/* GTM TIM0 Shared Service Request 6 */
#define SRC_GTMTIM07	(*( SRC_AGBT_type *) 0xf003979cu)	/* GTM TIM0 Shared Service Request 7 */
#define SRC_GTMTIM10	(*( SRC_AGBT_type *) 0xf00397a0u)	/* GTM TIM1 Shared Service Request 0 */
#define SRC_GTMTIM11	(*( SRC_AGBT_type *) 0xf00397a4u)	/* GTM TIM1 Shared Service Request 1 */
#define SRC_GTMTIM12	(*( SRC_AGBT_type *) 0xf00397a8u)	/* GTM TIM1 Shared Service Request 2 */
#define SRC_GTMTIM13	(*( SRC_AGBT_type *) 0xf00397acu)	/* GTM TIM1 Shared Service Request 3 */
#define SRC_GTMTIM14	(*( SRC_AGBT_type *) 0xf00397b0u)	/* GTM TIM1 Shared Service Request 4 */
#define SRC_GTMTIM15	(*( SRC_AGBT_type *) 0xf00397b4u)	/* GTM TIM1 Shared Service Request 5 */
#define SRC_GTMTIM16	(*( SRC_AGBT_type *) 0xf00397b8u)	/* GTM TIM1 Shared Service Request 6 */
#define SRC_GTMTIM17	(*( SRC_AGBT_type *) 0xf00397bcu)	/* GTM TIM1 Shared Service Request 7 */
#define SRC_GTMTIM20	(*( SRC_AGBT_type *) 0xf00397c0u)	/* GTM TIM2 Shared Service Request 0 */
#define SRC_GTMTIM21	(*( SRC_AGBT_type *) 0xf00397c4u)	/* GTM TIM2 Shared Service Request 1 */
#define SRC_GTMTIM22	(*( SRC_AGBT_type *) 0xf00397c8u)	/* GTM TIM2 Shared Service Request 2 */
#define SRC_GTMTIM23	(*( SRC_AGBT_type *) 0xf00397ccu)	/* GTM TIM2 Shared Service Request 3 */
#define SRC_GTMTIM24	(*( SRC_AGBT_type *) 0xf00397d0u)	/* GTM TIM2 Shared Service Request 4 */
#define SRC_GTMTIM25	(*( SRC_AGBT_type *) 0xf00397d4u)	/* GTM TIM2 Shared Service Request 5 */
#define SRC_GTMTIM26	(*( SRC_AGBT_type *) 0xf00397d8u)	/* GTM TIM2 Shared Service Request 6 */
#define SRC_GTMTIM27	(*( SRC_AGBT_type *) 0xf00397dcu)	/* GTM TIM2 Shared Service Request 7 */
#define SRC_GTMTIM30	(*( SRC_AGBT_type *) 0xf00397e0u)	/* GTM TIM3 Shared Service Request 0 */
#define SRC_GTMTIM31	(*( SRC_AGBT_type *) 0xf00397e4u)	/* GTM TIM3 Shared Service Request 1 */
#define SRC_GTMTIM32	(*( SRC_AGBT_type *) 0xf00397e8u)	/* GTM TIM3 Shared Service Request 2 */
#define SRC_GTMTIM33	(*( SRC_AGBT_type *) 0xf00397ecu)	/* GTM TIM3 Shared Service Request 3 */
#define SRC_GTMTIM34	(*( SRC_AGBT_type *) 0xf00397f0u)	/* GTM TIM3 Shared Service Request 4 */
#define SRC_GTMTIM35	(*( SRC_AGBT_type *) 0xf00397f4u)	/* GTM TIM3 Shared Service Request 5 */
#define SRC_GTMTIM36	(*( SRC_AGBT_type *) 0xf00397f8u)	/* GTM TIM3 Shared Service Request 6 */
#define SRC_GTMTIM37	(*( SRC_AGBT_type *) 0xf00397fcu)	/* GTM TIM3 Shared Service Request 7 */
#define SRC_GTMTOM00	(*( SRC_AGBT_type *) 0xf0039b80u)	/* GTM TOM0 Shared Service Request 0 */
#define SRC_GTMTOM01	(*( SRC_AGBT_type *) 0xf0039b84u)	/* GTM TOM0 Shared Service Request 1 */
#define SRC_GTMTOM02	(*( SRC_AGBT_type *) 0xf0039b88u)	/* GTM TOM0 Shared Service Request 2 */
#define SRC_GTMTOM03	(*( SRC_AGBT_type *) 0xf0039b8cu)	/* GTM TOM0 Shared Service Request 3 */
#define SRC_GTMTOM04	(*( SRC_AGBT_type *) 0xf0039b90u)	/* GTM TOM0 Shared Service Request 4 */
#define SRC_GTMTOM05	(*( SRC_AGBT_type *) 0xf0039b94u)	/* GTM TOM0 Shared Service Request 5 */
#define SRC_GTMTOM06	(*( SRC_AGBT_type *) 0xf0039b98u)	/* GTM TOM0 Shared Service Request 6 */
#define SRC_GTMTOM07	(*( SRC_AGBT_type *) 0xf0039b9cu)	/* GTM TOM0 Shared Service Request 7 */
#define SRC_GTMTOM10	(*( SRC_AGBT_type *) 0xf0039ba0u)	/* GTM TOM1 Shared Service Request 0 */
#define SRC_GTMTOM11	(*( SRC_AGBT_type *) 0xf0039ba4u)	/* GTM TOM1 Shared Service Request 1 */
#define SRC_GTMTOM12	(*( SRC_AGBT_type *) 0xf0039ba8u)	/* GTM TOM1 Shared Service Request 2 */
#define SRC_GTMTOM13	(*( SRC_AGBT_type *) 0xf0039bacu)	/* GTM TOM1 Shared Service Request 3 */
#define SRC_GTMTOM14	(*( SRC_AGBT_type *) 0xf0039bb0u)	/* GTM TOM1 Shared Service Request 4 */
#define SRC_GTMTOM15	(*( SRC_AGBT_type *) 0xf0039bb4u)	/* GTM TOM1 Shared Service Request 5 */
#define SRC_GTMTOM16	(*( SRC_AGBT_type *) 0xf0039bb8u)	/* GTM TOM1 Shared Service Request 6 */
#define SRC_GTMTOM17	(*( SRC_AGBT_type *) 0xf0039bbcu)	/* GTM TOM1 Shared Service Request 7 */
#define SRC_GTMTOM20	(*( SRC_AGBT_type *) 0xf0039bc0u)	/* GTM TOM2 Shared Service Request 0 */
#define SRC_GTMTOM21	(*( SRC_AGBT_type *) 0xf0039bc4u)	/* GTM TOM2 Shared Service Request 1 */
#define SRC_GTMTOM22	(*( SRC_AGBT_type *) 0xf0039bc8u)	/* GTM TOM2 Shared Service Request 2 */
#define SRC_GTMTOM23	(*( SRC_AGBT_type *) 0xf0039bccu)	/* GTM TOM2 Shared Service Request 3 */
#define SRC_GTMTOM24	(*( SRC_AGBT_type *) 0xf0039bd0u)	/* GTM TOM2 Shared Service Request 4 */
#define SRC_GTMTOM25	(*( SRC_AGBT_type *) 0xf0039bd4u)	/* GTM TOM2 Shared Service Request 5 */
#define SRC_GTMTOM26	(*( SRC_AGBT_type *) 0xf0039bd8u)	/* GTM TOM2 Shared Service Request 6 */
#define SRC_GTMTOM27	(*( SRC_AGBT_type *) 0xf0039bdcu)	/* GTM TOM2 Shared Service Request 7 */
#define SRC_HSCT	(*( SRC_AGBT_type *) 0xf0038290u)	/* HSCT Service Request */
#define SRC_HSM0	(*( SRC_AGBT_type *) 0xf0038cc0u)	/* HSM Service Request 0 */
#define SRC_HSM1	(*( SRC_AGBT_type *) 0xf0038cc4u)	/* HSM Service Request 1 */
#define SRC_HSSLCOK0	(*( SRC_AGBT_type *) 0xf00382a0u)	/* Channel 0 OK Service Request m */
#define SRC_HSSLCOK1	(*( SRC_AGBT_type *) 0xf00382b0u)	/* Channel 1 OK Service Request m */
#define SRC_HSSLCOK2	(*( SRC_AGBT_type *) 0xf00382c0u)	/* Channel 2 OK Service Request m */
#define SRC_HSSLCOK3	(*( SRC_AGBT_type *) 0xf00382d0u)	/* Channel 3 OK Service Request m */
#define SRC_HSSLERR0	(*( SRC_AGBT_type *) 0xf00382a8u)	/* Channel 0 Error ServiceRequest m */
#define SRC_HSSLERR1	(*( SRC_AGBT_type *) 0xf00382b8u)	/* Channel 1 Error ServiceRequest m */
#define SRC_HSSLERR2	(*( SRC_AGBT_type *) 0xf00382c8u)	/* Channel 2 Error ServiceRequest m */
#define SRC_HSSLERR3	(*( SRC_AGBT_type *) 0xf00382d8u)	/* Channel 3 Error ServiceRequest m */
#define SRC_HSSLEXI	(*( SRC_AGBT_type *) 0xf00382e0u)	/* Exception Service Request */
#define SRC_HSSLRDI0	(*( SRC_AGBT_type *) 0xf00382a4u)	/* Channel 0 Read Data Service Request m */
#define SRC_HSSLRDI1	(*( SRC_AGBT_type *) 0xf00382b4u)	/* Channel 1 Read Data Service Request m */
#define SRC_HSSLRDI2	(*( SRC_AGBT_type *) 0xf00382c4u)	/* Channel 2 Read Data Service Request m */
#define SRC_HSSLRDI3	(*( SRC_AGBT_type *) 0xf00382d4u)	/* Channel 3 Read Data Service Request m */
#define SRC_HSSLTRG0	(*( SRC_AGBT_type *) 0xf00382acu)	/* Channel 0 Trigger Service Request m */
#define SRC_HSSLTRG1	(*( SRC_AGBT_type *) 0xf00382bcu)	/* Channel 1 Trigger Service Request m */
#define SRC_HSSLTRG2	(*( SRC_AGBT_type *) 0xf00382ccu)	/* Channel 2 Trigger Service Request m */
#define SRC_HSSLTRG3	(*( SRC_AGBT_type *) 0xf00382dcu)	/* Channel 3 Trigger Service Request m */
#define SRC_I2C0BREQ	(*( SRC_AGBT_type *) 0xf0038300u)	/* I2C 0 Burst Data Transfer Request */
#define SRC_I2C0ERR	(*( SRC_AGBT_type *) 0xf0038310u)	/* I2C 0 Error Service Request */
#define SRC_I2C0LBREQ	(*( SRC_AGBT_type *) 0xf0038304u)	/* I2C 0 Last Burst Data Transfer Service Request */
#define SRC_I2C0LSREQ	(*( SRC_AGBT_type *) 0xf003830cu)	/* I2C 0 Last Single Data Transfer Service Request */
#define SRC_I2C0P	(*( SRC_AGBT_type *) 0xf0038314u)	/* I2C 0 Kernel Service Request */
#define SRC_I2C0SREQ	(*( SRC_AGBT_type *) 0xf0038308u)	/* I2C 0 Single Data Transfer Service Request */
#define SRC_LMU	(*( SRC_AGBT_type *) 0xf0038de0u)	/* LMU Service Request */
#define SRC_MSC0SR0	(*( SRC_AGBT_type *) 0xf00383e0u)	/* MSC 0 Service Request 0 */
#define SRC_MSC0SR1	(*( SRC_AGBT_type *) 0xf00383e4u)	/* MSC 0 Service Request 1 */
#define SRC_MSC0SR2	(*( SRC_AGBT_type *) 0xf00383e8u)	/* MSC 0 Service Request 2 */
#define SRC_MSC0SR3	(*( SRC_AGBT_type *) 0xf00383ecu)	/* MSC 0 Service Request 3 */
#define SRC_MSC1SR0	(*( SRC_AGBT_type *) 0xf00383f0u)	/* MSC 1 Service Request 0 */
#define SRC_MSC1SR1	(*( SRC_AGBT_type *) 0xf00383f4u)	/* MSC 1 Service Request 1 */
#define SRC_MSC1SR2	(*( SRC_AGBT_type *) 0xf00383f8u)	/* MSC 1 Service Request 2 */
#define SRC_MSC1SR3	(*( SRC_AGBT_type *) 0xf00383fcu)	/* MSC 1 Service Request 3 */
#define SRC_PMU00	(*( SRC_AGBT_type *) 0xf0038c30u)	/* PMU 0 Service Request 0 */
#define SRC_PMU01	(*( SRC_AGBT_type *) 0xf0038c34u)	/* PMU 0 Service Request 1 */
#define SRC_PSI50	(*( SRC_AGBT_type *) 0xf0038d30u)	/* PSI5 Service Request 0 */
#define SRC_PSI51	(*( SRC_AGBT_type *) 0xf0038d34u)	/* PSI5 Service Request 1 */
#define SRC_PSI52	(*( SRC_AGBT_type *) 0xf0038d38u)	/* PSI5 Service Request 2 */
#define SRC_PSI53	(*( SRC_AGBT_type *) 0xf0038d3cu)	/* PSI5 Service Request 3 */
#define SRC_PSI54	(*( SRC_AGBT_type *) 0xf0038d40u)	/* PSI5 Service Request 4 */
#define SRC_PSI55	(*( SRC_AGBT_type *) 0xf0038d44u)	/* PSI5 Service Request 5 */
#define SRC_PSI56	(*( SRC_AGBT_type *) 0xf0038d48u)	/* PSI5 Service Request 6 */
#define SRC_PSI57	(*( SRC_AGBT_type *) 0xf0038d4cu)	/* PSI5 Service Request 7 */
#define SRC_QSPI0ERR	(*( SRC_AGBT_type *) 0xf0038198u)	/* QSPI 0 Error Service Request */
#define SRC_QSPI0HC	(*( SRC_AGBT_type *) 0xf00381a0u)	/* QSPI 0 Half Cycle Service Request */
#define SRC_QSPI0PT	(*( SRC_AGBT_type *) 0xf003819cu)	/* QSPI 0 Phase Transition Service Request */
#define SRC_QSPI0RX	(*( SRC_AGBT_type *) 0xf0038194u)	/* QSPI 0 Receive Service Request */
#define SRC_QSPI0TX	(*( SRC_AGBT_type *) 0xf0038190u)	/* QSPI 0 Transmit Service Request */
#define SRC_QSPI0U	(*( SRC_AGBT_type *) 0xf00381a4u)	/* QSPI 0 User Defined Service Request */
#define SRC_QSPI1ERR	(*( SRC_AGBT_type *) 0xf00381b0u)	/* QSPI 1 Error Service Request */
#define SRC_QSPI1HC	(*( SRC_AGBT_type *) 0xf00381b8u)	/* QSPI 1 Half Cycle Service Request */
#define SRC_QSPI1PT	(*( SRC_AGBT_type *) 0xf00381b4u)	/* QSPI 1 Phase Transition Service Request */
#define SRC_QSPI1RX	(*( SRC_AGBT_type *) 0xf00381acu)	/* QSPI 1 Receive Service Request */
#define SRC_QSPI1TX	(*( SRC_AGBT_type *) 0xf00381a8u)	/* QSPI 1 Transmit Service Request */
#define SRC_QSPI1U	(*( SRC_AGBT_type *) 0xf00381bcu)	/* QSPI 1 User Defined Service Request */
#define SRC_QSPI2ERR	(*( SRC_AGBT_type *) 0xf00381c8u)	/* QSPI 2 Error Service Request */
#define SRC_QSPI2HC	(*( SRC_AGBT_type *) 0xf00381d0u)	/* QSPI 2 Half Cycle Service Request */
#define SRC_QSPI2PT	(*( SRC_AGBT_type *) 0xf00381ccu)	/* QSPI 2 Phase Transition Service Request */
#define SRC_QSPI2RX	(*( SRC_AGBT_type *) 0xf00381c4u)	/* QSPI 2 Receive Service Request */
#define SRC_QSPI2TX	(*( SRC_AGBT_type *) 0xf00381c0u)	/* QSPI 2 Transmit Service Request */
#define SRC_QSPI2U	(*( SRC_AGBT_type *) 0xf00381d4u)	/* QSPI 2 User Defined Service Request */
#define SRC_QSPI3ERR	(*( SRC_AGBT_type *) 0xf00381e0u)	/* QSPI 3 Error Service Request */
#define SRC_QSPI3HC	(*( SRC_AGBT_type *) 0xf00381e8u)	/* QSPI 3 Half Cycle Service Request */
#define SRC_QSPI3PT	(*( SRC_AGBT_type *) 0xf00381e4u)	/* QSPI 3 Phase Transition Service Request */
#define SRC_QSPI3RX	(*( SRC_AGBT_type *) 0xf00381dcu)	/* QSPI 3 Receive Service Request */
#define SRC_QSPI3TX	(*( SRC_AGBT_type *) 0xf00381d8u)	/* QSPI 3 Transmit Service Request */
#define SRC_QSPI3U	(*( SRC_AGBT_type *) 0xf00381ecu)	/* QSPI 3 User Defined Service Request */
#define SRC_QSPI4ERR	(*( SRC_AGBT_type *) 0xf00381f8u)	/* QSPI 4 Error Service Request */
#define SRC_QSPI4HC	(*( SRC_AGBT_type *) 0xf0038200u)	/* QSPI 4 Half Cycle Service Request */
#define SRC_QSPI4PT	(*( SRC_AGBT_type *) 0xf00381fcu)	/* QSPI 4 Phase Transition Service Request */
#define SRC_QSPI4RX	(*( SRC_AGBT_type *) 0xf00381f4u)	/* QSPI 4 Receive Service Request */
#define SRC_QSPI4TX	(*( SRC_AGBT_type *) 0xf00381f0u)	/* QSPI 4 Transmit Service Request */
#define SRC_QSPI4U	(*( SRC_AGBT_type *) 0xf0038204u)	/* QSPI 4 User Defined Service Request */
#define SRC_SCUDTS	(*( SRC_AGBT_type *) 0xf0038cd0u)	/* SCU DTS Busy Service Request */
#define SRC_SCUERU0	(*( SRC_AGBT_type *) 0xf0038cd4u)	/* SCU ERU Service Request 0 */
#define SRC_SCUERU1	(*( SRC_AGBT_type *) 0xf0038cd8u)	/* SCU ERU Service Request 1 */
#define SRC_SCUERU2	(*( SRC_AGBT_type *) 0xf0038cdcu)	/* SCU ERU Service Request 2 */
#define SRC_SCUERU3	(*( SRC_AGBT_type *) 0xf0038ce0u)	/* SCU ERU Service Request 3 */
#define SRC_SDMAME0	(*( SRC_AGBT_type *) 0xf00384d0u)	/* SDMA Move Engine 0 Service Request */
#define SRC_SDMAME0CH0	(*( SRC_AGBT_type *) 0xf00384f0u)	/* SDMA Move Engine 0 Channel 0 Service Request */
#define SRC_SDMAME0CH1	(*( SRC_AGBT_type *) 0xf00384f4u)	/* SDMA Move Engine 0 Channel 1 Service Request */
#define SRC_SDMAME0CH2	(*( SRC_AGBT_type *) 0xf00384f8u)	/* SDMA Move Engine 0 Channel 2 Service Request */
#define SRC_SDMAME0CH3	(*( SRC_AGBT_type *) 0xf00384fcu)	/* SDMA Move Engine 0 Channel 3 Service Request */
#define SRC_SDMAME0CH4	(*( SRC_AGBT_type *) 0xf0038500u)	/* SDMA Move Engine 0 Channel 4 Service Request */
#define SRC_SDMAME0CH5	(*( SRC_AGBT_type *) 0xf0038504u)	/* SDMA Move Engine 0 Channel 5 Service Request */
#define SRC_SDMAME0CH6	(*( SRC_AGBT_type *) 0xf0038508u)	/* SDMA Move Engine 0 Channel 6 Service Request */
#define SRC_SDMAME0CH7	(*( SRC_AGBT_type *) 0xf003850cu)	/* SDMA Move Engine 0 Channel 7 Service Request */
#define SRC_SDMAME1	(*( SRC_AGBT_type *) 0xf00384d4u)	/* SDMA Move Engine 1 Service Request */
#define SRC_SDMAME1CH0	(*( SRC_AGBT_type *) 0xf00385f0u)	/* SDMA Move Engine 1 Channel 0 Service Request */
#define SRC_SDMAME1CH1	(*( SRC_AGBT_type *) 0xf00385f4u)	/* SDMA Move Engine 1 Channel 1 Service Request */
#define SRC_SDMAME1CH2	(*( SRC_AGBT_type *) 0xf00385f8u)	/* SDMA Move Engine 1 Channel 2 Service Request */
#define SRC_SDMAME1CH3	(*( SRC_AGBT_type *) 0xf00385fcu)	/* SDMA Move Engine 1 Channel 3 Service Request */
#define SRC_SDMAME1CH4	(*( SRC_AGBT_type *) 0xf0038600u)	/* SDMA Move Engine 1 Channel 4 Service Request */
#define SRC_SDMAME1CH5	(*( SRC_AGBT_type *) 0xf0038604u)	/* SDMA Move Engine 1 Channel 5 Service Request */
#define SRC_SDMAME1CH6	(*( SRC_AGBT_type *) 0xf0038608u)	/* SDMA Move Engine 1 Channel 6 Service Request */
#define SRC_SDMAME1CH7	(*( SRC_AGBT_type *) 0xf003860cu)	/* SDMA Move Engine 1 Channel 7 Service Request */
#define SRC_SENT0	(*( SRC_AGBT_type *) 0xf0038350u)	/* SENT TRIG0 Service Request */
#define SRC_SENT1	(*( SRC_AGBT_type *) 0xf0038354u)	/* SENT TRIG1 Service Request */
#define SRC_SENT2	(*( SRC_AGBT_type *) 0xf0038358u)	/* SENT TRIG2 Service Request */
#define SRC_SENT3	(*( SRC_AGBT_type *) 0xf003835cu)	/* SENT TRIG3 Service Request */
#define SRC_SENT4	(*( SRC_AGBT_type *) 0xf0038360u)	/* SENT TRIG4 Service Request */
#define SRC_SENT5	(*( SRC_AGBT_type *) 0xf0038364u)	/* SENT TRIG5 Service Request */
#define SRC_SENT6	(*( SRC_AGBT_type *) 0xf0038368u)	/* SENT TRIG6 Service Request */
#define SRC_SENT7	(*( SRC_AGBT_type *) 0xf003836cu)	/* SENT TRIG7 Service Request */
#define SRC_SENT8	(*( SRC_AGBT_type *) 0xf0038370u)	/* SENT TRIG8 Service Request */
#define SRC_SENT9	(*( SRC_AGBT_type *) 0xf0038374u)	/* SENT TRIG9 Service Request */
#define SRC_SMU0	(*( SRC_AGBT_type *) 0xf0038d10u)	/* SMU Service Request 0 */
#define SRC_SMU1	(*( SRC_AGBT_type *) 0xf0038d14u)	/* SMU Service Request 1 */
#define SRC_SMU2	(*( SRC_AGBT_type *) 0xf0038d18u)	/* SMU Service Request 2 */
#define SRC_STM0SR0	(*( SRC_AGBT_type *) 0xf0038490u)	/* System Timer 0 Service Request 0 */
#define SRC_STM0SR1	(*( SRC_AGBT_type *) 0xf0038494u)	/* System Timer 0 Service Request 1 */
#define SRC_STM1SR0	(*( SRC_AGBT_type *) 0xf0038498u)	/* System Timer 1 Service Request 0 */
#define SRC_STM1SR1	(*( SRC_AGBT_type *) 0xf003849cu)	/* System Timer 1 Service Request 1 */
#define SRC_STM2SR0	(*( SRC_AGBT_type *) 0xf00384a0u)	/* System Timer 2 Service Request 0 */
#define SRC_STM2SR1	(*( SRC_AGBT_type *) 0xf00384a4u)	/* System Timer 2 Service Request 1 */
#define SRC_VADCCG0SR0	(*( SRC_AGBT_type *) 0xf0038aa0u)	/* VADC Common Group 0 Service Request 0 */
#define SRC_VADCCG0SR1	(*( SRC_AGBT_type *) 0xf0038aa4u)	/* VADC Common Group 0 Service Request 1 */
#define SRC_VADCCG0SR2	(*( SRC_AGBT_type *) 0xf0038aa8u)	/* VADC Common Group 0 Service Request 2 */
#define SRC_VADCCG0SR3	(*( SRC_AGBT_type *) 0xf0038aacu)	/* VADC Common Group 0 Service Request 3 */
#define SRC_VADCCG1SR0	(*( SRC_AGBT_type *) 0xf0038ab0u)	/* VADC Common Group 1 Service Request 0 */
#define SRC_VADCCG1SR1	(*( SRC_AGBT_type *) 0xf0038ab4u)	/* VADC Common Group 1 Service Request 1 */
#define SRC_VADCCG1SR2	(*( SRC_AGBT_type *) 0xf0038ab8u)	/* VADC Common Group 1 Service Request 2 */
#define SRC_VADCCG1SR3	(*( SRC_AGBT_type *) 0xf0038abcu)	/* VADC Common Group 1 Service Request 3 */
#define SRC_VADCG0SR0	(*( SRC_AGBT_type *) 0xf0038980u)	/* VADC Group 0 Service Request 0 */
#define SRC_VADCG0SR1	(*( SRC_AGBT_type *) 0xf0038984u)	/* VADC Group 0 Service Request 1 */
#define SRC_VADCG0SR2	(*( SRC_AGBT_type *) 0xf0038988u)	/* VADC Group 0 Service Request 2 */
#define SRC_VADCG0SR3	(*( SRC_AGBT_type *) 0xf003898cu)	/* VADC Group 0 Service Request 3 */
#define SRC_VADCG1SR0	(*( SRC_AGBT_type *) 0xf0038990u)	/* VADC Group 1 Service Request 0 */
#define SRC_VADCG1SR1	(*( SRC_AGBT_type *) 0xf0038994u)	/* VADC Group 1 Service Request 1 */
#define SRC_VADCG1SR2	(*( SRC_AGBT_type *) 0xf0038998u)	/* VADC Group 1 Service Request 2 */
#define SRC_VADCG1SR3	(*( SRC_AGBT_type *) 0xf003899cu)	/* VADC Group 1 Service Request 3 */
#define SRC_VADCG2SR0	(*( SRC_AGBT_type *) 0xf00389a0u)	/* VADC Group 2 Service Request 0 */
#define SRC_VADCG2SR1	(*( SRC_AGBT_type *) 0xf00389a4u)	/* VADC Group 2 Service Request 1 */
#define SRC_VADCG2SR2	(*( SRC_AGBT_type *) 0xf00389a8u)	/* VADC Group 2 Service Request 2 */
#define SRC_VADCG2SR3	(*( SRC_AGBT_type *) 0xf00389acu)	/* VADC Group 2 Service Request 3 */
#define SRC_VADCG3SR0	(*( SRC_AGBT_type *) 0xf00389b0u)	/* VADC Group 3 Service Request 0 */
#define SRC_VADCG3SR1	(*( SRC_AGBT_type *) 0xf00389b4u)	/* VADC Group 3 Service Request 1 */
#define SRC_VADCG3SR2	(*( SRC_AGBT_type *) 0xf00389b8u)	/* VADC Group 3 Service Request 2 */
#define SRC_VADCG3SR3	(*( SRC_AGBT_type *) 0xf00389bcu)	/* VADC Group 3 Service Request 3 */
#define SRC_VADCG4SR0	(*( SRC_AGBT_type *) 0xf00389c0u)	/* VADC Group 4 Service Request 0 */
#define SRC_VADCG4SR1	(*( SRC_AGBT_type *) 0xf00389c4u)	/* VADC Group 4 Service Request 1 */
#define SRC_VADCG4SR2	(*( SRC_AGBT_type *) 0xf00389c8u)	/* VADC Group 4 Service Request 2 */
#define SRC_VADCG4SR3	(*( SRC_AGBT_type *) 0xf00389ccu)	/* VADC Group 4 Service Request 3 */
#define SRC_VADCG5SR0	(*( SRC_AGBT_type *) 0xf00389d0u)	/* VADC Group 5 Service Request 0 */
#define SRC_VADCG5SR1	(*( SRC_AGBT_type *) 0xf00389d4u)	/* VADC Group 5 Service Request 1 */
#define SRC_VADCG5SR2	(*( SRC_AGBT_type *) 0xf00389d8u)	/* VADC Group 5 Service Request 2 */
#define SRC_VADCG5SR3	(*( SRC_AGBT_type *) 0xf00389dcu)	/* VADC Group 5 Service Request 3 */
#define SRC_VADCG6SR0	(*( SRC_AGBT_type *) 0xf00389e0u)	/* VADC Group 6 Service Request 0 */
#define SRC_VADCG6SR1	(*( SRC_AGBT_type *) 0xf00389e4u)	/* VADC Group 6 Service Request 1 */
#define SRC_VADCG6SR2	(*( SRC_AGBT_type *) 0xf00389e8u)	/* VADC Group 6 Service Request 2 */
#define SRC_VADCG6SR3	(*( SRC_AGBT_type *) 0xf00389ecu)	/* VADC Group 6 Service Request 3 */
#define SRC_VADCG7SR0	(*( SRC_AGBT_type *) 0xf00389f0u)	/* VADC Group 7 Service Request 0 */
#define SRC_VADCG7SR1	(*( SRC_AGBT_type *) 0xf00389f4u)	/* VADC Group 7 Service Request 1 */
#define SRC_VADCG7SR2	(*( SRC_AGBT_type *) 0xf00389f8u)	/* VADC Group 7 Service Request 2 */
#define SRC_VADCG7SR3	(*( SRC_AGBT_type *) 0xf00389fcu)	/* VADC Group 7 Service Request 3 */
#define SRC_XBARSRC	(*( SRC_AGBT_type *) 0xf0038048u)	/* XBAR_SRI Service Request */


/* GPT12 */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} GPT120_ACCEN0_type;
#define GPT120_ACCEN0	(*( GPT120_ACCEN0_type *) 0xf0002efcu)	/* Access Enable Register 0 */
#define GPT121_ACCEN0	(*( GPT120_ACCEN0_type *) 0xf0002ffcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GPT120_ACCEN1_type;
#define GPT120_ACCEN1	(*( GPT120_ACCEN1_type *) 0xf0002ef8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CAPREL         : 16;	/* Current reload value or Captured value */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_CAPREL_type;
#define GPT120_CAPREL	(*( GPT120_CAPREL_type *) 0xf0002e30u)	/* Capture and Reload Register */
#define GPT121_CAPREL	(*( GPT120_CAPREL_type *) 0xf0002f30u)	/* Capture and Reload Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} GPT120_CLC_type;
#define GPT120_CLC	(*( GPT120_CLC_type *) 0xf0002e00u)	/* Clock Control Register */
#define GPT121_CLC	(*( GPT120_CLC_type *) 0xf0002f00u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} GPT120_ID_type;
#define GPT120_ID	(*( GPT120_ID_type *) 0xf0002e08u)	/* Identification Register */
#define GPT121_ID	(*( GPT120_ID_type *) 0xf0002f08u)	/* Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} GPT120_KRST0_type;
#define GPT120_KRST0	(*( GPT120_KRST0_type *) 0xf0002ef4u)	/* Kernel Reset Register 0 */
#define GPT121_KRST0	(*( GPT120_KRST0_type *) 0xf0002ff4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} GPT120_KRST1_type;
#define GPT120_KRST1	(*( GPT120_KRST1_type *) 0xf0002ef0u)	/* Kernel Reset Register 1 */
#define GPT121_KRST1	(*( GPT120_KRST1_type *) 0xf0002ff0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} GPT120_KRSTCLR_type;
#define GPT120_KRSTCLR	(*( GPT120_KRSTCLR_type *) 0xf0002eecu)	/* Kernel Reset Status Clear Register */
#define GPT121_KRSTCLR	(*( GPT120_KRSTCLR_type *) 0xf0002fecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 2;	/* Trigger Set for OTGB0/1 */
		unsigned int TGB            : 1;	/* OTGB0/1 Bus Select */
		unsigned int TG_P           : 1;	/* TGS, TGB Write Protection */
		unsigned int                : 20;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} GPT120_OCS_type;
#define GPT120_OCS	(*( GPT120_OCS_type *) 0xf0002ee8u)	/* OCDS Control and Status Register */
#define GPT121_OCS	(*( GPT120_OCS_type *) 0xf0002fe8u)	/* OCDS Control and Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IST2IN         : 1;	/* Input Select for T2IN */
		unsigned int IST2EUD        : 1;	/* Input Select for T2EUD */
		unsigned int IST3IN         : 2;	/* Input Select for T3IN */
		unsigned int IST3EUD        : 2;	/* Input Select for T3EUD */
		unsigned int IST4IN         : 2;	/* Input Select for T4IN */
		unsigned int IST4EUD        : 2;	/* Input Select for T4EUD */
		unsigned int IST5IN         : 1;	/* Input Select for T5IN */
		unsigned int IST5EUD        : 1;	/* Input Select for T5EUD */
		unsigned int IST6IN         : 1;	/* Input Select for T6IN */
		unsigned int IST6EUD        : 1;	/* Input Select for T6EUD */
		unsigned int ISCAPIN        : 2;	/* Input Select for CAPIN */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_PISEL_type;
#define GPT120_PISEL	(*( GPT120_PISEL_type *) 0xf0002e04u)	/* Port Input Select Register */
#define GPT121_PISEL	(*( GPT120_PISEL_type *) 0xf0002f04u)	/* Port Input Select Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T2             : 16;	/* Timer T2 */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_T2_type;
#define GPT120_T2	(*( GPT120_T2_type *) 0xf0002e34u)	/* Timer T2 Register */
#define GPT121_T2	(*( GPT120_T2_type *) 0xf0002f34u)	/* Timer T2 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T2I            : 3;	/* Timer T2 Input Parameter Selection */
		unsigned int T2M            : 3;	/* Timer T2 Mode Control (Basic Operating Mode) */
		unsigned int T2R            : 1;	/* Timer T2 Run Bit */
		unsigned int T2UD           : 1;	/* Timer T2 Up/Down ControlSee for encoding of bits T2UD and T2UDE. */
		unsigned int T2UDE          : 1;	/* Timer T2 External Up/Down Enable */
		unsigned int T2RC           : 1;	/* Timer T2 Remote Control */
		unsigned int                : 2;
		unsigned int T2IRDIS        : 1;	/* Timer T2 Interrupt Disable */
		unsigned int T2EDGE         : 1;	/* Timer T2 Edge Detection */
		unsigned int T2CHDIR        : 1;	/* Timer T2 Count Direction Change */
		/* const */ unsigned int T2RDIR         : 1;	/* Timer T2 Rotation Direction */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_T2CON_type;
#define GPT120_T2CON	(*( GPT120_T2CON_type *) 0xf0002e10u)	/* Timer T2 Control Register */
#define GPT121_T2CON	(*( GPT120_T2CON_type *) 0xf0002f10u)	/* Timer T2 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T3             : 16;	/* Timer T3 */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_T3_type;
#define GPT120_T3	(*( GPT120_T3_type *) 0xf0002e38u)	/* Timer T3 Register */
#define GPT121_T3	(*( GPT120_T3_type *) 0xf0002f38u)	/* Timer T3 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T3I            : 3;	/* Timer T3 Input Parameter Selection */
		unsigned int T3M            : 3;	/* Timer T3 Mode Control */
		unsigned int T3R            : 1;	/* Timer T3 Run Bit */
		unsigned int T3UD           : 1;	/* Timer T3 Up/Down Control */
		unsigned int T3UDE          : 1;	/* Timer T3 External Up/Down EnableSee for encoding of bits T3UD and T3UDE. */
		unsigned int T3OE           : 1;	/* Overflow/Underflow Output Enable */
		unsigned int T3OTL          : 1;	/* Timer T3 Overflow Toggle Latch */
		unsigned int BPS1           : 2;	/* GPT1 Block Prescaler Control */
		unsigned int T3EDGE         : 1;	/* Timer T3 Edge Detection Flag */
		unsigned int T3CHDIR        : 1;	/* Timer T3 Count Direction Change Flag */
		/* const */ unsigned int T3RDIR         : 1;	/* Timer T3 Rotation Direction Flag */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_T3CON_type;
#define GPT120_T3CON	(*( GPT120_T3CON_type *) 0xf0002e14u)	/* Timer T3 Control Register */
#define GPT121_T3CON	(*( GPT120_T3CON_type *) 0xf0002f14u)	/* Timer T3 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T4             : 16;	/* Timer T4 */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_T4_type;
#define GPT120_T4	(*( GPT120_T4_type *) 0xf0002e3cu)	/* Timer T4 Register */
#define GPT121_T4	(*( GPT120_T4_type *) 0xf0002f3cu)	/* Timer T4 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T4I            : 3;	/* Timer T4 Input Parameter Selection */
		unsigned int T4M            : 3;	/* Timer T4 Mode Control (Basic Operating Mode) */
		unsigned int T4R            : 1;	/* Timer T4 Run Bit */
		unsigned int T4UD           : 1;	/* Timer T4 Up/Down ControlSee for encoding of bits T4UD and T4UDE. */
		unsigned int T4UDE          : 1;	/* Timer T4 External Up/Down Enable */
		unsigned int T4RC           : 1;	/* Timer T4 Remote Control */
		unsigned int CLRT2EN        : 1;	/* Clear Timer T2 Enable */
		unsigned int CLRT3EN        : 1;	/* Clear Timer T3 Enable */
		unsigned int T4IRDIS        : 1;	/* Timer T4 Interrupt Disable */
		unsigned int T4EDGE         : 1;	/* Timer T4 Edge Detection */
		unsigned int T4CHDIR        : 1;	/* Timer T4 Count Direction Change */
		/* const */ unsigned int T4RDIR         : 1;	/* Timer T4 Rotation Direction */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_T4CON_type;
#define GPT120_T4CON	(*( GPT120_T4CON_type *) 0xf0002e18u)	/* Timer T4 Control Register */
#define GPT121_T4CON	(*( GPT120_T4CON_type *) 0xf0002f18u)	/* Timer T4 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T5             : 16;	/* Timer T5 */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_T5_type;
#define GPT120_T5	(*( GPT120_T5_type *) 0xf0002e40u)	/* Timer T5 Register */
#define GPT121_T5	(*( GPT120_T5_type *) 0xf0002f40u)	/* Timer T5 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T5I            : 3;	/* Timer T5 Input Parameter Selection */
		unsigned int T5M            : 3;	/* Timer T5 Mode Control (Basic Operating Mode) */
		unsigned int T5R            : 1;	/* Timer T5 Run Bit */
		unsigned int T5UD           : 1;	/* Timer T5 Up/Down Control */
		unsigned int T5UDE          : 1;	/* Timer T5 External Up/Down EnableSee for encoding of bits T5UD and T5UDE. */
		unsigned int T5RC           : 1;	/* Timer T5 Remote Control */
		unsigned int CT3            : 1;	/* Timer T3 Capture Trigger Enable */
		unsigned int T5CC           : 1;	/* Timer T5 Capture Correction */
		unsigned int CI             : 2;	/* Register CAPREL Capture Trigger SelectionTo define the respective trigger source signal, also bit CT3 must be regarded (see ). */
		unsigned int T5CLR          : 1;	/* Timer T5 Clear Enable Bit */
		unsigned int T5SC           : 1;	/* Timer T5 Capture Mode Enable */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_T5CON_type;
#define GPT120_T5CON	(*( GPT120_T5CON_type *) 0xf0002e1cu)	/* Timer T5 Control Register */
#define GPT121_T5CON	(*( GPT120_T5CON_type *) 0xf0002f1cu)	/* Timer T5 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T6             : 16;	/* Timer T6 */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_T6_type;
#define GPT120_T6	(*( GPT120_T6_type *) 0xf0002e44u)	/* Timer T6 Register */
#define GPT121_T6	(*( GPT120_T6_type *) 0xf0002f44u)	/* Timer T6 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T6I            : 3;	/* Timer T6 Input Parameter Selection */
		unsigned int T6M            : 3;	/* Timer T6 Mode Control (Basic Operating Mode) */
		unsigned int T6R            : 1;	/* Timer T6 Run Bit */
		unsigned int T6UD           : 1;	/* Timer T6 Up/Down ControlSee for coding of bits T6UD and T6UDE */
		unsigned int T6UDE          : 1;	/* Timer T6 External Up/Down Enable */
		unsigned int T6OE           : 1;	/* Overflow/Underflow Output Enable */
		unsigned int T6OTL          : 1;	/* Timer T6 Overflow Toggle Latch */
		unsigned int BPS2           : 2;	/* GPT2 Block Prescaler Control */
		unsigned int                : 1;
		unsigned int T6CLR          : 1;	/* Timer T6 Clear Enable Bit */
		unsigned int T6SR           : 1;	/* Timer T6 Reload Mode Enable */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} GPT120_T6CON_type;
#define GPT120_T6CON	(*( GPT120_T6CON_type *) 0xf0002e20u)	/* Timer T6 Control Register */
#define GPT121_T6CON	(*( GPT120_T6CON_type *) 0xf0002f20u)	/* Timer T6 Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GPT121_ACCEN1_type;
#define GPT121_ACCEN1	(*( GPT121_ACCEN1_type *) 0xf0002ff8u)	/* Access Enable Register 1 */


/* CIF */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access E0able for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access E1able for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access E2able for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access E3able for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access E4able for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access E5able for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access E6able for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access E7able for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access E8able for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access E9able for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access E10able for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access E11able for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access E12able for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access E13able for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access E14able for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access E15able for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access E16able for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access E17able for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access E18able for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access E19able for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access E20able for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access E21able for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access E22able for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access E23able for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access E24able for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access E25able for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access E26able for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access E27able for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access E28able for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access E29able for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access E30able for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access E31able for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} CIF_BBB_ACCEN0_type;
#define CIF_BBB_ACCEN0	(*( CIF_BBB_ACCEN0_type *) 0xf00e1f0cu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CIF_BBB_ACCEN1_type;
#define CIF_BBB_ACCEN1	(*( CIF_BBB_ACCEN1_type *) 0xf00e1f10u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} CIF_BBB_CLC_type;
#define CIF_BBB_CLC	(*( CIF_BBB_CLC_type *) 0xf00e1f00u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CIF_BBB_GPCTL_type;
#define CIF_BBB_GPCTL	(*( CIF_BBB_GPCTL_type *) 0xf00e1f08u)	/* General Purpose Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} CIF_BBB_KRST0_type;
#define CIF_BBB_KRST0	(*( CIF_BBB_KRST0_type *) 0xf00e1f14u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_BBB_KRST1_type;
#define CIF_BBB_KRST1	(*( CIF_BBB_KRST1_type *) 0xf00e1f18u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_BBB_KRSTCLR_type;
#define CIF_BBB_KRSTCLR	(*( CIF_BBB_KRSTCLR_type *) 0xf00e1f1cu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} CIF_BBB_MODID_type;
#define CIF_BBB_MODID	(*( CIF_BBB_MODID_type *) 0xf00e1f04u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		/* const */ unsigned int cif_ccldiss    : 1;	/* Status of cif_ccl[2] bit */
		unsigned int cif_cclfdis    : 1;	/* Clock Control Logic disable */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} CIF_CCL_type;
#define CIF_CCL	(*( CIF_CCL_type *) 0xf00e2000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int cif_mp_mux     : 2;	/* Data path selector for main path */
		unsigned int cif_chan_mode  : 2;	/* Y/C splitter channel mode */
		unsigned int                : 4;
		unsigned int if_select      : 2;	/* Selects input interface */
		unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} CIF_DPCL_type;
#define CIF_DPCL	(*( CIF_DPCL_type *) 0xf00e2018u)	/* CIF Data Path Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int dp_en          : 1;	/* Debug Path Enable */
		unsigned int dp_sel         : 3;	/* Select Source Path which will be transfered over the Debug Interface */
		unsigned int                : 4;
		unsigned int rst_fnc        : 1;	/* Reset Frame Number Counter */
		unsigned int rst_lnc        : 1;	/* Reset Line Number Counter */
		unsigned int rst_tsc        : 1;	/* Reset Timestamp Counter */
		unsigned int rst_pd         : 1;	/* Reset Predivider Counter */
		unsigned int                : 1;
		unsigned int fnc_en         : 1;	/* Enable/disable Frame Number Counter */
		unsigned int lnc_en         : 1;	/* Enable/disable Line Number Counter */
		unsigned int tsc_en         : 1;	/* Enable/disable Timestamp Counter */
		unsigned int uds1           : 1;	/* Enable/disable sending of User Defined Symbol 1 */
		unsigned int uds2           : 1;	/* Enable/disable sending of User Defined Symbol 2 */
		unsigned int uds3           : 1;	/* Enable/disable sending of User Defined Symbol 3 */
		unsigned int uds4           : 1;	/* Enable/disable sending of User Defined Symbol 4 */
		unsigned int uds5           : 1;	/* Enable/disable sending of User Defined Symbol 5 */
		unsigned int uds6           : 1;	/* Enable/disable sending of User Defined Symbol 6 */
		unsigned int uds7           : 1;	/* Enable/disable sending of User Defined Symbol 7 */
		unsigned int uds8           : 1;	/* Enable/disable sending of User Defined Symbol 8 */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_DP_CTRL_type;
#define CIF_DP_CTRL	(*( CIF_DP_CTRL_type *) 0xf00e4700u)	/* Debug Path Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fnc_val        : 15;	/* Returns the current value of the Frame Number Counter */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int lnc_val        : 15;	/* Returns the current value of the Line Number Counter */
		/* const */ unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} CIF_DP_FLC_STAT_type;
#define CIF_DP_FLC_STAT	(*( CIF_DP_FLC_STAT_type *) 0xf00e4708u)	/* Debug Path Frame/Line Counter Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int pdiv_val       : 32;	/* If the Debug Path and the Timestamp Counter are enabled, the timestamp counter will be increased with every pdiv_val+1 CIF module clock cycle. */
	} B;
	int I;
	unsigned int U;

} CIF_DP_PDIV_CTRL_type;
#define CIF_DP_PDIV_CTRL	(*( CIF_DP_PDIV_CTRL_type *) 0xf00e4704u)	/* Debug Path Predivider Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int pdiv_val       : 32;	/* Returns the current value of the Predivider Counter. */
	} B;
	int I;
	unsigned int U;

} CIF_DP_PDIV_STAT_type;
#define CIF_DP_PDIV_STAT	(*( CIF_DP_PDIV_STAT_type *) 0xf00e470cu)	/* Debug Path Predivider Counter Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int tsc_val        : 30;	/* Returns the current value of the Timestamp Counter. */
		/* const */ unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} CIF_DP_TSC_STAT_type;
#define CIF_DP_TSC_STAT	(*( CIF_DP_TSC_STAT_type *) 0xf00e4710u)	/* Debug Path Timestamp Counter Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int UDS            : 15;	/* User Defined Symbol which may be inserted into debug stream */
		unsigned int                : 17;
	} B;
	int I;
	unsigned int U;

} CIF_DP_UDS_1_type;
#define CIF_DP_UDS_1	(*( CIF_DP_UDS_1_type *) 0xf00e4714u)	/* Debug Path User Defined Symbol 1 Register */
#define CIF_DP_UDS_2	(*( CIF_DP_UDS_1_type *) 0xf00e4718u)	/* Debug Path User Defined Symbol 2 Register */
#define CIF_DP_UDS_3	(*( CIF_DP_UDS_1_type *) 0xf00e471cu)	/* Debug Path User Defined Symbol 3 Register */
#define CIF_DP_UDS_4	(*( CIF_DP_UDS_1_type *) 0xf00e4720u)	/* Debug Path User Defined Symbol 4 Register */
#define CIF_DP_UDS_5	(*( CIF_DP_UDS_1_type *) 0xf00e4724u)	/* Debug Path User Defined Symbol 5 Register */
#define CIF_DP_UDS_6	(*( CIF_DP_UDS_1_type *) 0xf00e4728u)	/* Debug Path User Defined Symbol 6 Register */
#define CIF_DP_UDS_7	(*( CIF_DP_UDS_1_type *) 0xf00e472cu)	/* Debug Path User Defined Symbol 7 Register */
#define CIF_DP_UDS_8	(*( CIF_DP_UDS_1_type *) 0xf00e4730u)	/* Debug Path User Defined Symbol 8 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ic_en          : 1;	/* Image Cropping Enable */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_CTRL_type;
#define CIF_EP_1_IC_CTRL	(*( CIF_EP_1_IC_CTRL_type *) 0xf00e4900u)	/* Extra Path 1 Image Cropping Control Register */
#define CIF_EP_2_IC_CTRL	(*( CIF_EP_1_IC_CTRL_type *) 0xf00e4a00u)	/* Extra Path 2 Image Cropping Control Register */
#define CIF_EP_3_IC_CTRL	(*( CIF_EP_1_IC_CTRL_type *) 0xf00e4b00u)	/* Extra Path 3 Image Cropping Control Register */
#define CIF_EP_4_IC_CTRL	(*( CIF_EP_1_IC_CTRL_type *) 0xf00e4c00u)	/* Extra Path 4 Image Cropping Control Register */
#define CIF_EP_5_IC_CTRL	(*( CIF_EP_1_IC_CTRL_type *) 0xf00e4d00u)	/* Extra Path 5 Image Cropping Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int dx             : 12;	/* Camera Displacement */
		unsigned int                : 4;
		unsigned int dy             : 12;	/* Camera Displacement */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_DISPLACE_type;
#define CIF_EP_1_IC_DISPLACE	(*( CIF_EP_1_IC_DISPLACE_type *) 0xf00e4920u)	/* Extra Path 1 Image Cropping Camera Displacement Register */
#define CIF_EP_2_IC_DISPLACE	(*( CIF_EP_1_IC_DISPLACE_type *) 0xf00e4a20u)	/* Extra Path 2 Image Cropping Camera Displacement Register */
#define CIF_EP_3_IC_DISPLACE	(*( CIF_EP_1_IC_DISPLACE_type *) 0xf00e4b20u)	/* Extra Path 3 Image Cropping Camera Displacement Register */
#define CIF_EP_4_IC_DISPLACE	(*( CIF_EP_1_IC_DISPLACE_type *) 0xf00e4c20u)	/* Extra Path 4 Image Cropping Camera Displacement Register */
#define CIF_EP_5_IC_DISPLACE	(*( CIF_EP_1_IC_DISPLACE_type *) 0xf00e4d20u)	/* Extra Path 5 Image Cropping Camera Displacement Register */
#define CIF_ISPIS_DISPLACE	(*( CIF_EP_1_IC_DISPLACE_type *) 0xf00e4320u)	/* ISP Image Stabilization Camera Displacement Register */

typedef volatile union
{
	struct
	{ 
		unsigned int h_offs         : 12;	/* Horizontal Picture Offset */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_H_OFFS_type;
#define CIF_EP_1_IC_H_OFFS	(*( CIF_EP_1_IC_H_OFFS_type *) 0xf00e4908u)	/* Extra Path 1 Image Cropping Horizontal Offset of Output Window Register */
#define CIF_EP_2_IC_H_OFFS	(*( CIF_EP_1_IC_H_OFFS_type *) 0xf00e4a08u)	/* Extra Path 2 Image Cropping Horizontal Offset of Output Window Register */
#define CIF_EP_3_IC_H_OFFS	(*( CIF_EP_1_IC_H_OFFS_type *) 0xf00e4b08u)	/* Extra Path 3 Image Cropping Horizontal Offset of Output Window Register */
#define CIF_EP_4_IC_H_OFFS	(*( CIF_EP_1_IC_H_OFFS_type *) 0xf00e4c08u)	/* Extra Path 4 Image Cropping Horizontal Offset of Output Window Register */
#define CIF_EP_5_IC_H_OFFS	(*( CIF_EP_1_IC_H_OFFS_type *) 0xf00e4d08u)	/* Extra Path 5 Image Cropping Horizontal Offset of Output Window Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int h_offs_shd     : 13;	/* Horizontal Picture Offset */
		/* const */ unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_H_OFFS_SHD_type;
#define CIF_EP_1_IC_H_OFFS_SHD	(*( CIF_EP_1_IC_H_OFFS_SHD_type *) 0xf00e4924u)	/* Extra Path 1 Image Current Horizontal Offset Of Output Window Shadow Register */
#define CIF_EP_2_IC_H_OFFS_SHD	(*( CIF_EP_1_IC_H_OFFS_SHD_type *) 0xf00e4a24u)	/* Extra Path 2 Image Current Horizontal Offset Of Output Window Shadow Register */
#define CIF_EP_3_IC_H_OFFS_SHD	(*( CIF_EP_1_IC_H_OFFS_SHD_type *) 0xf00e4b24u)	/* Extra Path 3 Image Current Horizontal Offset Of Output Window Shadow Register */
#define CIF_EP_4_IC_H_OFFS_SHD	(*( CIF_EP_1_IC_H_OFFS_SHD_type *) 0xf00e4c24u)	/* Extra Path 4 Image Current Horizontal Offset Of Output Window Shadow Register */
#define CIF_EP_5_IC_H_OFFS_SHD	(*( CIF_EP_1_IC_H_OFFS_SHD_type *) 0xf00e4d24u)	/* Extra Path 5 Image Current Horizontal Offset Of Output Window Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int h_size         : 12;	/* Horizontal Picture Size */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_H_SIZE_type;
#define CIF_EP_1_IC_H_SIZE	(*( CIF_EP_1_IC_H_SIZE_type *) 0xf00e4910u)	/* Extra Path 1 Image Cropping Output Horizontal Picture Size Register */
#define CIF_EP_2_IC_H_SIZE	(*( CIF_EP_1_IC_H_SIZE_type *) 0xf00e4a10u)	/* Extra Path 2 Image Cropping Output Horizontal Picture Size Register */
#define CIF_EP_3_IC_H_SIZE	(*( CIF_EP_1_IC_H_SIZE_type *) 0xf00e4b10u)	/* Extra Path 3 Image Cropping Output Horizontal Picture Size Register */
#define CIF_EP_4_IC_H_SIZE	(*( CIF_EP_1_IC_H_SIZE_type *) 0xf00e4c10u)	/* Extra Path 4 Image Cropping Output Horizontal Picture Size Register */
#define CIF_EP_5_IC_H_SIZE	(*( CIF_EP_1_IC_H_SIZE_type *) 0xf00e4d10u)	/* Extra Path 5 Image Cropping Output Horizontal Picture Size Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int h_size_shd     : 13;	/* Horizontal Picture Size */
		/* const */ unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_H_SIZE_SHD_type;
#define CIF_EP_1_IC_H_SIZE_SHD	(*( CIF_EP_1_IC_H_SIZE_SHD_type *) 0xf00e492cu)	/* Extra Path 1 Image Current Output Horizontal Picture Size Shadow Register */
#define CIF_EP_2_IC_H_SIZE_SHD	(*( CIF_EP_1_IC_H_SIZE_SHD_type *) 0xf00e4a2cu)	/* Extra Path 2 Image Current Output Horizontal Picture Size Shadow Register */
#define CIF_EP_3_IC_H_SIZE_SHD	(*( CIF_EP_1_IC_H_SIZE_SHD_type *) 0xf00e4b2cu)	/* Extra Path 3 Image Current Output Horizontal Picture Size Shadow Register */
#define CIF_EP_4_IC_H_SIZE_SHD	(*( CIF_EP_1_IC_H_SIZE_SHD_type *) 0xf00e4c2cu)	/* Extra Path 4 Image Current Output Horizontal Picture Size Shadow Register */
#define CIF_EP_5_IC_H_SIZE_SHD	(*( CIF_EP_1_IC_H_SIZE_SHD_type *) 0xf00e4d2cu)	/* Extra Path 5 Image Current Output Horizontal Picture Size Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int max_dx         : 12;	/* Maximum Horizontal Displacement */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_MAX_DX_type;
#define CIF_EP_1_IC_MAX_DX	(*( CIF_EP_1_IC_MAX_DX_type *) 0xf00e4918u)	/* Extra Path 1 Image Cropping Maximum Horizontal Displacement Register */
#define CIF_EP_2_IC_MAX_DX	(*( CIF_EP_1_IC_MAX_DX_type *) 0xf00e4a18u)	/* Extra Path 2 Image Cropping Maximum Horizontal Displacement Register */
#define CIF_EP_3_IC_MAX_DX	(*( CIF_EP_1_IC_MAX_DX_type *) 0xf00e4b18u)	/* Extra Path 3 Image Cropping Maximum Horizontal Displacement Register */
#define CIF_EP_4_IC_MAX_DX	(*( CIF_EP_1_IC_MAX_DX_type *) 0xf00e4c18u)	/* Extra Path 4 Image Cropping Maximum Horizontal Displacement Register */
#define CIF_EP_5_IC_MAX_DX	(*( CIF_EP_1_IC_MAX_DX_type *) 0xf00e4d18u)	/* Extra Path 5 Image Cropping Maximum Horizontal Displacement Register */

typedef volatile union
{
	struct
	{ 
		unsigned int max_dy         : 12;	/* Maximum Vertical Displacement */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_MAX_DY_type;
#define CIF_EP_1_IC_MAX_DY	(*( CIF_EP_1_IC_MAX_DY_type *) 0xf00e491cu)	/* Extra Path 1 Image Cropping Maximum Vertical Displacement Register */
#define CIF_EP_2_IC_MAX_DY	(*( CIF_EP_1_IC_MAX_DY_type *) 0xf00e4a1cu)	/* Extra Path 2 Image Cropping Maximum Vertical Displacement Register */
#define CIF_EP_3_IC_MAX_DY	(*( CIF_EP_1_IC_MAX_DY_type *) 0xf00e4b1cu)	/* Extra Path 3 Image Cropping Maximum Vertical Displacement Register */
#define CIF_EP_4_IC_MAX_DY	(*( CIF_EP_1_IC_MAX_DY_type *) 0xf00e4c1cu)	/* Extra Path 4 Image Cropping Maximum Vertical Displacement Register */
#define CIF_EP_5_IC_MAX_DY	(*( CIF_EP_1_IC_MAX_DY_type *) 0xf00e4d1cu)	/* Extra Path 5 Image Cropping Maximum Vertical Displacement Register */

typedef volatile union
{
	struct
	{ 
		unsigned int recenter       : 3;	/* Recenter */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_RECENTER_type;
#define CIF_EP_1_IC_RECENTER	(*( CIF_EP_1_IC_RECENTER_type *) 0xf00e4904u)	/* Extra Path 1 Image Cropping Recenter Register */
#define CIF_EP_2_IC_RECENTER	(*( CIF_EP_1_IC_RECENTER_type *) 0xf00e4a04u)	/* Extra Path 2 Image Cropping Recenter Register */
#define CIF_EP_3_IC_RECENTER	(*( CIF_EP_1_IC_RECENTER_type *) 0xf00e4b04u)	/* Extra Path 3 Image Cropping Recenter Register */
#define CIF_EP_4_IC_RECENTER	(*( CIF_EP_1_IC_RECENTER_type *) 0xf00e4c04u)	/* Extra Path 4 Image Cropping Recenter Register */
#define CIF_EP_5_IC_RECENTER	(*( CIF_EP_1_IC_RECENTER_type *) 0xf00e4d04u)	/* Extra Path 5 Image Cropping Recenter Register */
#define CIF_ISPIS_RECENTER	(*( CIF_EP_1_IC_RECENTER_type *) 0xf00e4304u)	/* ISP Image Stabilization Recenter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int v_offs         : 12;	/* Vertical Picture Offset */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_V_OFFS_type;
#define CIF_EP_1_IC_V_OFFS	(*( CIF_EP_1_IC_V_OFFS_type *) 0xf00e490cu)	/* Extra Path 1 Image Cropping Vertical Offset Of Output Window Register */
#define CIF_EP_2_IC_V_OFFS	(*( CIF_EP_1_IC_V_OFFS_type *) 0xf00e4a0cu)	/* Extra Path 2 Image Cropping Vertical Offset Of Output Window Register */
#define CIF_EP_3_IC_V_OFFS	(*( CIF_EP_1_IC_V_OFFS_type *) 0xf00e4b0cu)	/* Extra Path 3 Image Cropping Vertical Offset Of Output Window Register */
#define CIF_EP_4_IC_V_OFFS	(*( CIF_EP_1_IC_V_OFFS_type *) 0xf00e4c0cu)	/* Extra Path 4 Image Cropping Vertical Offset Of Output Window Register */
#define CIF_EP_5_IC_V_OFFS	(*( CIF_EP_1_IC_V_OFFS_type *) 0xf00e4d0cu)	/* Extra Path 5 Image Cropping Vertical Offset Of Output Window Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int v_offs_shd     : 12;	/* Vertical Picture Offset */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_V_OFFS_SHD_type;
#define CIF_EP_1_IC_V_OFFS_SHD	(*( CIF_EP_1_IC_V_OFFS_SHD_type *) 0xf00e4928u)	/* Extra Path 1 Image Current Vertical Offset Of Output Window Shadow Register */
#define CIF_EP_2_IC_V_OFFS_SHD	(*( CIF_EP_1_IC_V_OFFS_SHD_type *) 0xf00e4a28u)	/* Extra Path 2 Image Current Vertical Offset Of Output Window Shadow Register */
#define CIF_EP_3_IC_V_OFFS_SHD	(*( CIF_EP_1_IC_V_OFFS_SHD_type *) 0xf00e4b28u)	/* Extra Path 3 Image Current Vertical Offset Of Output Window Shadow Register */
#define CIF_EP_4_IC_V_OFFS_SHD	(*( CIF_EP_1_IC_V_OFFS_SHD_type *) 0xf00e4c28u)	/* Extra Path 4 Image Current Vertical Offset Of Output Window Shadow Register */
#define CIF_EP_5_IC_V_OFFS_SHD	(*( CIF_EP_1_IC_V_OFFS_SHD_type *) 0xf00e4d28u)	/* Extra Path 5 Image Current Vertical Offset Of Output Window Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int v_size         : 12;	/* Vertical Picture Size */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_V_SIZE_type;
#define CIF_EP_1_IC_V_SIZE	(*( CIF_EP_1_IC_V_SIZE_type *) 0xf00e4914u)	/* Extra Path 1 Image Cropping Output Vertical Picture Size Register */
#define CIF_EP_2_IC_V_SIZE	(*( CIF_EP_1_IC_V_SIZE_type *) 0xf00e4a14u)	/* Extra Path 2 Image Cropping Output Vertical Picture Size Register */
#define CIF_EP_3_IC_V_SIZE	(*( CIF_EP_1_IC_V_SIZE_type *) 0xf00e4b14u)	/* Extra Path 3 Image Cropping Output Vertical Picture Size Register */
#define CIF_EP_4_IC_V_SIZE	(*( CIF_EP_1_IC_V_SIZE_type *) 0xf00e4c14u)	/* Extra Path 4 Image Cropping Output Vertical Picture Size Register */
#define CIF_EP_5_IC_V_SIZE	(*( CIF_EP_1_IC_V_SIZE_type *) 0xf00e4d14u)	/* Extra Path 5 Image Cropping Output Vertical Picture Size Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int v_size_shd     : 12;	/* Vertical Picture Size */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_EP_1_IC_V_SIZE_SHD_type;
#define CIF_EP_1_IC_V_SIZE_SHD	(*( CIF_EP_1_IC_V_SIZE_SHD_type *) 0xf00e4930u)	/* Extra Path 1 Image Current Output Vertical Picture Size Shadow Register */
#define CIF_EP_2_IC_V_SIZE_SHD	(*( CIF_EP_1_IC_V_SIZE_SHD_type *) 0xf00e4a30u)	/* Extra Path 2 Image Current Output Vertical Picture Size Shadow Register */
#define CIF_EP_3_IC_V_SIZE_SHD	(*( CIF_EP_1_IC_V_SIZE_SHD_type *) 0xf00e4b30u)	/* Extra Path 3 Image Current Output Vertical Picture Size Shadow Register */
#define CIF_EP_4_IC_V_SIZE_SHD	(*( CIF_EP_1_IC_V_SIZE_SHD_type *) 0xf00e4c30u)	/* Extra Path 4 Image Current Output Vertical Picture Size Shadow Register */
#define CIF_EP_5_IC_V_SIZE_SHD	(*( CIF_EP_1_IC_V_SIZE_SHD_type *) 0xf00e4d30u)	/* Extra Path 5 Image Current Output Vertical Picture Size Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int cif_isp_clk_enable: 1;	/* ISP processing clock enable */
		unsigned int                : 4;
		unsigned int cif_jpeg_clk_enable: 1;	/* JPEG encoder clock enable */
		unsigned int cif_mi_clk_enable: 1;	/* Memory interface clock enable */
		unsigned int                : 9;
		unsigned int cif_watchdog_clk_enable: 1;	/* Security Watchdog clock enable */
		unsigned int cif_lin_dscaler_clk_enable: 1;	/* Linear Downscaler clock enable */
		unsigned int cif_extra_paths_clk_enable: 1;	/* Extra Paths clock enable */
		unsigned int cif_debug_path_clk_en: 1;	/* Debug Path clock enable */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_ICCL_type;
#define CIF_ICCL	(*( CIF_ICCL_type *) 0xf00e2010u)	/* CIF Internal Clock Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int modrev         : 8;	/* Module Revision Number */
		/* const */ unsigned int modtype        : 8;	/* Module Type */
		/* const */ unsigned int modnum         : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} CIF_ID_type;
#define CIF_ID	(*( CIF_ID_type *) 0xf00e2008u)	/* CIF Revision Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int cif_isp_soft_rst: 1;	/* Isp software reset */
		unsigned int                : 1;
		unsigned int cif_ycs_soft_rst: 1;	/* Y/C splitter software reset */
		unsigned int                : 2;
		unsigned int cif_jpeg_soft_rst: 1;	/* JPEG encoder software reset */
		unsigned int cif_mi_soft_rst: 1;	/* Memory interface software reset */
		unsigned int cif_global_rst : 1;	/* Soft reset of entire CIF */
		unsigned int                : 8;
		unsigned int cif_watchdog_rst: 1;	/* Securtiy Watchdog software reset */
		unsigned int cif_lin_dscaler_rst: 1;	/* Linear Downscaler software reset */
		unsigned int cif_extra_paths_rst: 1;	/* Extra Paths software reset */
		unsigned int cif_debug_path_rst: 1;	/* Debug Path software reset */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_IRCL_type;
#define CIF_IRCL	(*( CIF_IRCL_type *) 0xf00e2014u)	/* CIF Internal Reset Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int is_en          : 1;	/* Image Stabilization Enable */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_CTRL_type;
#define CIF_ISPIS_CTRL	(*( CIF_ISPIS_CTRL_type *) 0xf00e4300u)	/* ISP Image Stabilization Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int is_h_offs      : 12;	/* Horizontal Picture Offset */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_H_OFFS_type;
#define CIF_ISPIS_H_OFFS	(*( CIF_ISPIS_H_OFFS_type *) 0xf00e4308u)	/* ISP Image Stabilization Horizontal Offset Of Output Window Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int is_h_offs_shd  : 13;	/* Horizontal Picture Offset */
		/* const */ unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_H_OFFS_SHD_type;
#define CIF_ISPIS_H_OFFS_SHD	(*( CIF_ISPIS_H_OFFS_SHD_type *) 0xf00e4324u)	/* SP Image Current Horizontal Offset Of Output Window Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int is_h_size      : 12;	/* Horizontal Picture Size */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_H_SIZE_type;
#define CIF_ISPIS_H_SIZE	(*( CIF_ISPIS_H_SIZE_type *) 0xf00e4310u)	/* ISP Image Stabilization Output Horizontal Picture Size Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int isp_h_size_shd : 13;	/* Horizontal Picture Size */
		/* const */ unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_H_SIZE_SHD_type;
#define CIF_ISPIS_H_SIZE_SHD	(*( CIF_ISPIS_H_SIZE_SHD_type *) 0xf00e432cu)	/* ISP Image Current Output Horizontal Picture Size Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int Is_max_dx      : 12;	/* Maximum Horizontal Displacement */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_MAX_DX_type;
#define CIF_ISPIS_MAX_DX	(*( CIF_ISPIS_MAX_DX_type *) 0xf00e4318u)	/* ISP Image Stabilization Maximum Horizontal Displacement Register */

typedef volatile union
{
	struct
	{ 
		unsigned int is_max_dy      : 12;	/* Maximum Vertical Displacement */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_MAX_DY_type;
#define CIF_ISPIS_MAX_DY	(*( CIF_ISPIS_MAX_DY_type *) 0xf00e431cu)	/* ISP Image Stabilization Maximum Vertical Displacement Register */

typedef volatile union
{
	struct
	{ 
		unsigned int is_v_offs      : 12;	/* Vertical Picture Offset */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_V_OFFS_type;
#define CIF_ISPIS_V_OFFS	(*( CIF_ISPIS_V_OFFS_type *) 0xf00e430cu)	/* ISP Image Stabilization Vertical Offset Of Output Window Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int is_v_offs_shd  : 12;	/* Vertical Picture Offset */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_V_OFFS_SHD_type;
#define CIF_ISPIS_V_OFFS_SHD	(*( CIF_ISPIS_V_OFFS_SHD_type *) 0xf00e4328u)	/* ISP Image Current Vertical Offset Of Output Window Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int is_v_size      : 12;	/* Vertical Picture Size */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_V_SIZE_type;
#define CIF_ISPIS_V_SIZE	(*( CIF_ISPIS_V_SIZE_type *) 0xf00e4314u)	/* ISP Image Stabilization Output Vertical Picture Size Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int isp_v_size_shd : 12;	/* Vertical Picture Size */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISPIS_V_SIZE_SHD_type;
#define CIF_ISPIS_V_SIZE_SHD	(*( CIF_ISPIS_V_SIZE_SHD_type *) 0xf00e4330u)	/* ISP Image Current Output Vertical Picture Size Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int acq_h_offs     : 13;	/* Horizontal sample offset */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_ACQ_H_OFFS_type;
#define CIF_ISP_ACQ_H_OFFS	(*( CIF_ISP_ACQ_H_OFFS_type *) 0xf00e2408u)	/* ISP Acquisition Horizontal Offset Register */

typedef volatile union
{
	struct
	{ 
		unsigned int acq_h_size     : 13;	/* Horizontal sample size */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_ACQ_H_SIZE_type;
#define CIF_ISP_ACQ_H_SIZE	(*( CIF_ISP_ACQ_H_SIZE_type *) 0xf00e2410u)	/* ISP Acquisition Horizontal Size Register */

typedef volatile union
{
	struct
	{ 
		unsigned int acq_nr_frames  : 10;	/* Number of Input Frames */
		unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_ACQ_NR_FRAMES_type;
#define CIF_ISP_ACQ_NR_FRAMES	(*( CIF_ISP_ACQ_NR_FRAMES_type *) 0xf00e2418u)	/* ISP Acquisition Number of Frames Register */

typedef volatile union
{
	struct
	{ 
		unsigned int sample_edge    : 1;	/* Sample Edge */
		unsigned int hsync_pol      : 1;	/* Horizontal sync polarity */
		unsigned int vsync_pol      : 1;	/* Vertical sync polarity */
		unsigned int                : 4;
		unsigned int ccir_seq       : 2;	/* CCIR Sequence */
		unsigned int field_selection: 2;	/* Field Selection */
		unsigned int field_invert   : 1;	/* Field Invert */
		unsigned int input_selection: 4;	/* Input Selection */
		unsigned int                : 4;
		unsigned int input_selection_no_app: 1;	/* Input Selection No Append */
		unsigned int                : 11;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_ACQ_PROP_type;
#define CIF_ISP_ACQ_PROP	(*( CIF_ISP_ACQ_PROP_type *) 0xf00e2404u)	/* ISP Acquisition Properties Register */

typedef volatile union
{
	struct
	{ 
		unsigned int acq_v_offs     : 12;	/* Vertical sample offset */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_ACQ_V_OFFS_type;
#define CIF_ISP_ACQ_V_OFFS	(*( CIF_ISP_ACQ_V_OFFS_type *) 0xf00e240cu)	/* ISP Acquistion Vertical Offset Register */

typedef volatile union
{
	struct
	{ 
		unsigned int acq_v_size     : 12;	/* Vertical sample size */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_ACQ_V_SIZE_type;
#define CIF_ISP_ACQ_V_SIZE	(*( CIF_ISP_ACQ_V_SIZE_type *) 0xf00e2414u)	/* ISP Acquisition Vertical Size Register */

typedef volatile union
{
	struct
	{ 
		unsigned int isp_enable     : 1;	/* ISP output enable */
		unsigned int isp_mode       : 3;	/* ISP Mode */
		unsigned int isp_inform_enable: 1;	/* ISP Input Formater Enable */
		unsigned int                : 4;
		unsigned int isp_cfg_upd    : 1;	/* ISP Config Update */
		unsigned int isp_gen_cfg_upd: 1;	/* ISP Generate Config Update */
		unsigned int                : 2;
		unsigned int isp_csm_y_range: 1;	/* Color Space Matrix luminance clipping range for ISP output */
		unsigned int isp_csm_c_range: 1;	/* Color Space Matrix chrominance clipping range for ISP output */
		unsigned int                : 17;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_CTRL_type;
#define CIF_ISP_CTRL	(*( CIF_ISP_CTRL_type *) 0xf00e2400u)	/* ISP Global Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int inform_size_err: 1;	/* Size error is generated in inform submodule */
		/* const */ unsigned int is_size_err    : 1;	/* Size error is generated in image stabilization submodule */
		/* const */ unsigned int outform_size_err: 1;	/* Size error is generated in outmux submodule */
		/* const */ unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_ERR_type;
#define CIF_ISP_ERR	(*( CIF_ISP_ERR_type *) 0xf00e263cu)	/* ISP Error Register */

typedef volatile union
{
	struct
	{ 
		unsigned int inform_size_err_clr: 1;	/* Size error is cleared */
		unsigned int is_size_err_clr: 1;	/* Size error is cleared */
		unsigned int outform_size_err_clr: 1;	/* Size error is cleared */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_ERR_CLR_type;
#define CIF_ISP_ERR_CLR	(*( CIF_ISP_ERR_CLR_type *) 0xf00e2640u)	/* ISP Error Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int isp_enable_shd : 1;	/* ISP enable shadow register */
		/* const */ unsigned int isp_inform_enable_shd: 1;	/* Input formatter enable shadow register */
		/* const */ unsigned int inform_field   : 1;	/* Current field information */
		/* const */ unsigned int                : 11;
		/* const */ unsigned int s_data         : 16;	/* State of ISP input port s_data */
		/* const */ unsigned int s_vsync        : 1;	/* State of ISP input port s_vsync */
		/* const */ unsigned int s_hsync        : 1;	/* State of ISP input port s_hsync */
	} B;
	int I;
	unsigned int U;

} CIF_ISP_FLAGS_SHD_type;
#define CIF_ISP_FLAGS_SHD	(*( CIF_ISP_FLAGS_SHD_type *) 0xf00e25a8u)	/* ISP Shadow Flags Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int frame_counter  : 10;	/* Current Frame Count of Processing */
		/* const */ unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_FRAME_COUNT_type;
#define CIF_ISP_FRAME_COUNT	(*( CIF_ISP_FRAME_COUNT_type *) 0xf00e2644u)	/* ISP Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int icr_isp_off    : 1;	/* Isp was Turned Off (vsynced) */
		unsigned int icr_frame      : 1;	/* Frame was Completely Put Out */
		unsigned int icr_data_loss  : 1;	/* Loss of Data */
		unsigned int icr_pic_size_err: 1;	/* Pic Size Violation Occurred */
		unsigned int                : 1;
		unsigned int icr_frame_in   : 1;	/* Sampled Input Frame is Complete */
		unsigned int icr_v_start    : 1;	/* Start Edge of v_sync */
		unsigned int icr_h_start    : 1;	/* Start Edge of h_sync */
		unsigned int                : 11;
		unsigned int icr_wd_trig    : 1;	/* A watchdog timeout was triggered at the ISP input */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_ICR_type;
#define CIF_ISP_ICR	(*( CIF_ISP_ICR_type *) 0xf00e25c8u)	/* ISP Interrupt Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int imsc_isp_off   : 1;	/* Isp was Turned Off (vsynced) */
		unsigned int imsc_frame     : 1;	/* Frame was Completely Put Out */
		unsigned int imsc_data_loss : 1;	/* Loss of Data */
		unsigned int imsc_pic_size_err: 1;	/* Pic Size Violation Occurred */
		unsigned int                : 1;
		unsigned int imsc_frame_in  : 1;	/* Sampled Input Frame is Complete */
		unsigned int imsc_v_start   : 1;	/* Start Edge of v_sync */
		unsigned int imsc_h_start   : 1;	/* Start Edge of h_sync */
		unsigned int                : 11;
		unsigned int imsc_wd_trig   : 1;	/* A watchdog timeout was triggered at the ISP input */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_IMSC_type;
#define CIF_ISP_IMSC	(*( CIF_ISP_IMSC_type *) 0xf00e25bcu)	/* ISP Interrupt Mask Register */

typedef volatile union
{
	struct
	{ 
		unsigned int isr_isp_off    : 1;	/* Isp was Turned Off (vsynced) */
		unsigned int isr_frame      : 1;	/* Frame was Completely Put Out */
		unsigned int isr_data_loss  : 1;	/* Loss of Data */
		unsigned int isr_pic_size_err: 1;	/* Pic Size Violation Occurred */
		unsigned int                : 1;
		unsigned int isr_frame_in   : 1;	/* Sampled Input Frame is Complete */
		unsigned int isr_v_start    : 1;	/* Start Edge of v_sync */
		unsigned int isr_h_start    : 1;	/* Start Edge of h_sync */
		unsigned int                : 11;
		unsigned int isr_wd_trig    : 1;	/* A watchdog timeout was triggered at the ISP input */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_ISR_type;
#define CIF_ISP_ISR	(*( CIF_ISP_ISR_type *) 0xf00e25ccu)	/* ISP Interrupt Set Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int mis_isp_off    : 1;	/* Isp was Turned Off (vsynced) */
		/* const */ unsigned int mis_frame      : 1;	/* Frame was Completely Put Out */
		/* const */ unsigned int mis_data_loss  : 1;	/* Loss of Data */
		/* const */ unsigned int mis_pic_size_err: 1;	/* Pic Size Violation Occurred */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int mis_frame_in   : 1;	/* Sampled Input Frame is Complete */
		/* const */ unsigned int mis_v_start    : 1;	/* Start Edge of v_sync */
		/* const */ unsigned int mis_h_start    : 1;	/* Start Edge of h_sync */
		/* const */ unsigned int                : 11;
		/* const */ unsigned int mis_wd_trig    : 1;	/* A watchdog timeout was triggered at the ISP input */
		/* const */ unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_MIS_type;
#define CIF_ISP_MIS	(*( CIF_ISP_MIS_type *) 0xf00e25c4u)	/* ISP Masked Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int isp_out_h_offs : 12;	/* Horizontal Picture Offset */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_OUT_H_OFFS_type;
#define CIF_ISP_OUT_H_OFFS	(*( CIF_ISP_OUT_H_OFFS_type *) 0xf00e2594u)	/* ISP Output Window Horizontal Offset Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int isp_out_h_offs_shd: 12;	/* Current horizontal picture offset */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_OUT_H_OFFS_SHD_type;
#define CIF_ISP_OUT_H_OFFS_SHD	(*( CIF_ISP_OUT_H_OFFS_SHD_type *) 0xf00e25acu)	/* ISP Output Window Horizontal Offset Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int isp_out_h_size : 12;	/* Horizontal picture size */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_OUT_H_SIZE_type;
#define CIF_ISP_OUT_H_SIZE	(*( CIF_ISP_OUT_H_SIZE_type *) 0xf00e259cu)	/* ISP Output Horizontal Picture Size Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int isp_out_h_size_shd: 13;	/* Current horizontal picture size */
		/* const */ unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_OUT_H_SIZE_SHD_type;
#define CIF_ISP_OUT_H_SIZE_SHD	(*( CIF_ISP_OUT_H_SIZE_SHD_type *) 0xf00e25b4u)	/* ISP Output Horizontal Picture Size Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int isp_out_v_offs : 12;	/* Vertical Picture Offset */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_OUT_V_OFFS_type;
#define CIF_ISP_OUT_V_OFFS	(*( CIF_ISP_OUT_V_OFFS_type *) 0xf00e2598u)	/* ISP Output Window Vertical Offset Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int isp_out_v_offs_shd: 12;	/* Current vertical picture offset */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_OUT_V_OFFS_SHD_type;
#define CIF_ISP_OUT_V_OFFS_SHD	(*( CIF_ISP_OUT_V_OFFS_SHD_type *) 0xf00e25b0u)	/* ISP Output Window Vertical Offset Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int isp_out_v_size : 12;	/* Vertical picture size */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_OUT_V_SIZE_type;
#define CIF_ISP_OUT_V_SIZE	(*( CIF_ISP_OUT_V_SIZE_type *) 0xf00e25a0u)	/* ISP Output Vertical Picture Size Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int isp_out_v_size_shd: 12;	/* Current vertical pic size */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_OUT_V_SIZE_SHD_type;
#define CIF_ISP_OUT_V_SIZE_SHD	(*( CIF_ISP_OUT_V_SIZE_SHD_type *) 0xf00e25b8u)	/* ISP Output Vertical Picture Size Shadow Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ris_isp_off    : 1;	/* Isp was Turned Off (vsynced) */
		/* const */ unsigned int ris_frame      : 1;	/* Frame was Completely Put Out */
		/* const */ unsigned int ris_data_loss  : 1;	/* Loss of Data */
		/* const */ unsigned int ris_pic_size_err: 1;	/* Pic Size Violation Occurred */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int ris_frame_in   : 1;	/* Sampled Input Frame is Complete */
		/* const */ unsigned int ris_v_start    : 1;	/* Start Edge of v_sync */
		/* const */ unsigned int ris_h_start    : 1;	/* Start Edge of h_sync */
		/* const */ unsigned int                : 11;
		/* const */ unsigned int ris_wd_trig    : 1;	/* A watchdog timeout was triggered at the ISP input */
		/* const */ unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_ISP_RIS_type;
#define CIF_ISP_RIS	(*( CIF_ISP_RIS_type *) 0xf00e25c0u)	/* ISP Raw Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ac_table_select: 3;	/* AC Table Selector */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_AC_TABLE_SELECT_type;
#define CIF_JPE_AC_TABLE_SELECT	(*( CIF_JPE_AC_TABLE_SELECT_type *) 0xf00e3838u)	/* JPE Huffman Table Selector For AC Values Register */

typedef volatile union
{
	struct
	{ 
		unsigned int cbcr_scale_en  : 1;	/* Cb/Cr scale flag */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_CBCR_SCALE_EN_type;
#define CIF_JPE_CBCR_SCALE_EN	(*( CIF_JPE_CBCR_SCALE_EN_type *) 0xf00e3810u)	/* JPE Cb/Cr Value Scaling Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int dc_table_select: 3;	/* DC Table Selector */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_DC_TABLE_SELECT_type;
#define CIF_JPE_DC_TABLE_SELECT	(*( CIF_JPE_DC_TABLE_SELECT_type *) 0xf00e3834u)	/* JPE Huffman Table Selector For DC Values Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 2;
		/* const */ unsigned int deb_qiq_table_acc: 1;	/* QIQ Table Access */
		/* const */ unsigned int deb_vlc_encode_busy: 1;	/* VLC Encode Busy */
		/* const */ unsigned int deb_r2b_memory_full: 1;	/* R2B Memory Full */
		/* const */ unsigned int deb_vlc_table_busy: 1;	/* Debug VLC Table Busy */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int deb_bad_table_access: 1;	/* Debug Bad Table Access */
		/* const */ unsigned int                : 23;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_DEBUG_type;
#define CIF_JPE_DEBUG	(*( CIF_JPE_DEBUG_type *) 0xf00e3864u)	/* JPE Debug Information Register */

typedef volatile union
{
	struct
	{ 
		unsigned int encode         : 1;	/* Encode */
		unsigned int                : 3;
		unsigned int cont_mode      : 2;	/* Encoder continuous mode */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_ENCODE_type;
#define CIF_JPE_ENCODE	(*( CIF_JPE_ENCODE_type *) 0xf00e3804u)	/* JPE Start Command To Start JFIF Stream Encoding Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int codec_busy     : 1;	/* Codec Busy */
		/* const */ unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_ENCODER_BUSY_type;
#define CIF_JPE_ENCODER_BUSY	(*( CIF_JPE_ENCODER_BUSY_type *) 0xf00e3858u)	/* JPE Encoder Status Flag Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int encode_mode    : 1;	/* Encode Mode */
		/* const */ unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_ENCODE_MODE_type;
#define CIF_JPE_ENCODE_MODE	(*( CIF_JPE_ENCODE_MODE_type *) 0xf00e3860u)	/* JPE Encode Mode Register */

typedef volatile union
{
	struct
	{ 
		unsigned int enc_hsize      : 12;	/* Horizontal Size */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_ENC_HSIZE_type;
#define CIF_JPE_ENC_HSIZE	(*( CIF_JPE_ENC_HSIZE_type *) 0xf00e3818u)	/* JPEG Codec Horizontal Image Size For Encoding Register */

typedef volatile union
{
	struct
	{ 
		unsigned int enc_vsize      : 12;	/* Vertical Size */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_ENC_VSIZE_type;
#define CIF_JPE_ENC_VSIZE	(*( CIF_JPE_ENC_VSIZE_type *) 0xf00e381cu)	/* JPEG Codec Vertical Image Size For Encoding Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int vlc_symbol_err : 1;	/* VLC Symbol Error */
		unsigned int                : 2;
		unsigned int dct_err        : 1;	/* DC Table Error */
		unsigned int                : 1;
		unsigned int r2b_img_size_err: 1;	/* R2B Image Size Error */
		unsigned int vlc_table_err  : 1;	/* VLC Table Error */
		unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_ERROR_ICR_type;
#define CIF_JPE_ERROR_ICR	(*( CIF_JPE_ERROR_ICR_type *) 0xf00e3874u)	/* JPE Error Interrupt Clear Register */
#define CIF_JPE_ERROR_ISR	(*( CIF_JPE_ERROR_ICR_type *) 0xf00e3878u)	/* JPE Error Interrupt Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int vlc_symbol_err : 1;	/* VLC Symbol Error */
		unsigned int                : 2;
		unsigned int dct_err        : 1;	/* DC Table Error */
		unsigned int                : 1;
		unsigned int r2b_img_size_err: 1;	/* R2B Image Size Error */
		unsigned int vlc_table_err  : 1;	/* VLC Table Error */
		unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_ERROR_IMR_type;
#define CIF_JPE_ERROR_IMR	(*( CIF_JPE_ERROR_IMR_type *) 0xf00e3868u)	/* JPE Error Interrupt Mask Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 4;
		/* const */ unsigned int vlc_symbol_err : 1;	/* VLC Symbol Error */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int dct_err        : 1;	/* DC Table Error */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int r2b_img_size_err: 1;	/* R2B Image Size Error */
		/* const */ unsigned int vlc_table_err  : 1;	/* VLC Table Error */
		/* const */ unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_ERROR_MIS_type;
#define CIF_JPE_ERROR_MIS	(*( CIF_JPE_ERROR_MIS_type *) 0xf00e3870u)	/* JPE Error Masked Interrupt Status Register */
#define CIF_JPE_ERROR_RIS	(*( CIF_JPE_ERROR_MIS_type *) 0xf00e386cu)	/* JPE Error Raw Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int gen_header     : 1;	/* Generate Header */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_GEN_HEADER_type;
#define CIF_JPE_GEN_HEADER	(*( CIF_JPE_GEN_HEADER_type *) 0xf00e3800u)	/* JPE Command To Start Stream Header Generation Register */

typedef volatile union
{
	struct
	{ 
		unsigned int header_mode    : 2;	/* Header Mode */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_HEADER_MODE_type;
#define CIF_JPE_HEADER_MODE	(*( CIF_JPE_HEADER_MODE_type *) 0xf00e385cu)	/* JPE Header Mode Definition Register */

typedef volatile union
{
	struct
	{ 
		unsigned int JP_INIT        : 1;	/* JPEG Init */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_INIT_type;
#define CIF_JPE_INIT	(*( CIF_JPE_INIT_type *) 0xf00e3808u)	/* JPE Automatic Configuration Update Register */

typedef volatile union
{
	struct
	{ 
		unsigned int enc_pic_format : 3;	/* Picture Encoding Format */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_PIC_FORMAT_type;
#define CIF_JPE_PIC_FORMAT	(*( CIF_JPE_PIC_FORMAT_type *) 0xf00e3820u)	/* JPEG Picture Encoding Format Register */

typedef volatile union
{
	struct
	{ 
		unsigned int restart_interval: 16;	/* Restart Interval */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_RESTART_INTERVAL_type;
#define CIF_JPE_RESTART_INTERVAL	(*( CIF_JPE_RESTART_INTERVAL_type *) 0xf00e3824u)	/* JPE Restart Marker Insertion Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int encode_done    : 1;	/* Encoding Complete */
		unsigned int gen_header_done: 1;	/* Header Generation Complete */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_STATUS_ICR_type;
#define CIF_JPE_STATUS_ICR	(*( CIF_JPE_STATUS_ICR_type *) 0xf00e3888u)	/* JPEG Status Interrupt Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int encode_done    : 1;	/* Encoding Complete */
		unsigned int gen_header_done: 1;	/* Header Generation Complete */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_STATUS_IMR_type;
#define CIF_JPE_STATUS_IMR	(*( CIF_JPE_STATUS_IMR_type *) 0xf00e387cu)	/* JPEG Status Interrupt Mask Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int encode_done    : 1;	/* Encoding Complete */
		unsigned int gen_header_done: 1;	/* Header Generation Complete */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_STATUS_ISR_type;
#define CIF_JPE_STATUS_ISR	(*( CIF_JPE_STATUS_ISR_type *) 0xf00e388cu)	/* JPEG Status Interrupt Set Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 4;
		/* const */ unsigned int encode_done    : 1;	/* Encoding Complete */
		/* const */ unsigned int gen_header_done: 1;	/* Header Generation Complete */
		/* const */ unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_STATUS_MIS_type;
#define CIF_JPE_STATUS_MIS	(*( CIF_JPE_STATUS_MIS_type *) 0xf00e3884u)	/* JPEG Status Masked Interrupt Status Register */
#define CIF_JPE_STATUS_RIS	(*( CIF_JPE_STATUS_MIS_type *) 0xf00e3880u)	/* JPEG Status Raw Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int table_wdata_l  : 8;	/* Table data LSB */
		unsigned int table_wdata_h  : 8;	/* Table data MSB */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_TABLE_DATA_type;
#define CIF_JPE_TABLE_DATA	(*( CIF_JPE_TABLE_DATA_type *) 0xf00e383cu)	/* JPE Table Programming Register */

typedef volatile union
{
	struct
	{ 
		unsigned int table_flush    : 1;	/* Header generation debug control flag */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_TABLE_FLUSH_type;
#define CIF_JPE_TABLE_FLUSH	(*( CIF_JPE_TABLE_FLUSH_type *) 0xf00e3814u)	/* JPE Header Generation Debug Register */

typedef volatile union
{
	struct
	{ 
		unsigned int table_id       : 4;	/* JPE Table ID */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_TABLE_ID_type;
#define CIF_JPE_TABLE_ID	(*( CIF_JPE_TABLE_ID_type *) 0xf00e3840u)	/* JPE Table Programming Select Register */

typedef volatile union
{
	struct
	{ 
		unsigned int tac0_len       : 8;	/* AC Table 0 Length */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_TAC0_LEN_type;
#define CIF_JPE_TAC0_LEN	(*( CIF_JPE_TAC0_LEN_type *) 0xf00e3844u)	/* JPE Huffman AC Table 0 Length Register */

typedef volatile union
{
	struct
	{ 
		unsigned int tac1_len       : 8;	/* AC Table 1 Length */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_TAC1_LEN_type;
#define CIF_JPE_TAC1_LEN	(*( CIF_JPE_TAC1_LEN_type *) 0xf00e384cu)	/* JPE Huffman AC Table 1 Length Register */

typedef volatile union
{
	struct
	{ 
		unsigned int tdc0_len       : 8;	/* DC Table 0 Length */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_TDC0_LEN_type;
#define CIF_JPE_TDC0_LEN	(*( CIF_JPE_TDC0_LEN_type *) 0xf00e3848u)	/* JPE Huffman DC Table 0 Length Register */

typedef volatile union
{
	struct
	{ 
		unsigned int tdc1_len       : 8;	/* DC Table 1 Length */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_TDC1_LEN_type;
#define CIF_JPE_TDC1_LEN	(*( CIF_JPE_TDC1_LEN_type *) 0xf00e3850u)	/* JPE Huffman DC Table 1 Length Register */

typedef volatile union
{
	struct
	{ 
		unsigned int tq1_select     : 2;	/* Q-Table Selector U */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_TQ_U_SELECT_type;
#define CIF_JPE_TQ_U_SELECT	(*( CIF_JPE_TQ_U_SELECT_type *) 0xf00e382cu)	/* Q- table Selector 1, Quant. Table For U Component */

typedef volatile union
{
	struct
	{ 
		unsigned int tq2_select     : 2;	/* Q-Table Selector V */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_TQ_V_SELECT_type;
#define CIF_JPE_TQ_V_SELECT	(*( CIF_JPE_TQ_V_SELECT_type *) 0xf00e3830u)	/* Q- table Selector 2 Quant Table For V Component */

typedef volatile union
{
	struct
	{ 
		unsigned int tq0_select     : 2;	/* Q-Table Selector Y */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_TQ_Y_SELECT_type;
#define CIF_JPE_TQ_Y_SELECT	(*( CIF_JPE_TQ_Y_SELECT_type *) 0xf00e3828u)	/* Q- table Selector 0 Quant Table For Y Component */

typedef volatile union
{
	struct
	{ 
		unsigned int y_scale_en     : 1;	/* Y scale flag */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CIF_JPE_Y_SCALE_EN_type;
#define CIF_JPE_Y_SCALE_EN	(*( CIF_JPE_Y_SCALE_EN_type *) 0xf00e380cu)	/* JPE Y Value Scaling Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int lds_v_en       : 1;	/* Vertical scaling enable */
		unsigned int lds_h_en       : 1;	/* Horizontal scaling enable */
		unsigned int                : 2;
		unsigned int lds_v_mode     : 2;	/* Vertical scaling mode */
		unsigned int                : 2;
		unsigned int lds_h_mode     : 2;	/* Horizontal scaling mode */
		unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} CIF_LDS_CTRL_type;
#define CIF_LDS_CTRL	(*( CIF_LDS_CTRL_type *) 0xf00e4500u)	/* Linear Downscaler Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int lds_v_fac      : 8;	/* Vertical scaling factor */
		unsigned int                : 8;
		unsigned int lds_h_fac      : 8;	/* Horizontal scaling factor */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_LDS_FAC_type;
#define CIF_LDS_FAC	(*( CIF_LDS_FAC_type *) 0xf00e4504u)	/* Linear Downscaler Factor Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int ep_base_ad_init: 30;	/* Extra Path Base Address Init */
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_BASE_AD_INIT_type;
#define CIF_MIEP_1_BASE_AD_INIT	(*( CIF_MIEP_1_BASE_AD_INIT_type *) 0xf00e5508u)	/* Memory Interface Base Address For Extra Path 1 Data Buffer Register */
#define CIF_MIEP_2_BASE_AD_INIT	(*( CIF_MIEP_1_BASE_AD_INIT_type *) 0xf00e5608u)	/* Memory Interface Base Address For Extra Path 2 Data Buffer Register */
#define CIF_MIEP_3_BASE_AD_INIT	(*( CIF_MIEP_1_BASE_AD_INIT_type *) 0xf00e5708u)	/* Memory Interface Base Address For Extra Path 3 Data Buffer Register */
#define CIF_MIEP_4_BASE_AD_INIT	(*( CIF_MIEP_1_BASE_AD_INIT_type *) 0xf00e5808u)	/* Memory Interface Base Address For Extra Path 4 Data Buffer Register */
#define CIF_MIEP_5_BASE_AD_INIT	(*( CIF_MIEP_1_BASE_AD_INIT_type *) 0xf00e5908u)	/* Memory Interface Base Address For Extra Path 5 Data Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int ep_base_ad     : 30;	/* Extra Path Base Address */
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_BASE_AD_SHD_type;
#define CIF_MIEP_1_BASE_AD_SHD	(*( CIF_MIEP_1_BASE_AD_SHD_type *) 0xf00e5520u)	/* Memory Interface Base Address Shadow Register for Extra Path 1 Buffer Register */
#define CIF_MIEP_2_BASE_AD_SHD	(*( CIF_MIEP_1_BASE_AD_SHD_type *) 0xf00e5620u)	/* Memory Interface Base Address Shadow Register for Extra Path 2 Buffer Register */
#define CIF_MIEP_3_BASE_AD_SHD	(*( CIF_MIEP_1_BASE_AD_SHD_type *) 0xf00e5720u)	/* Memory Interface Base Address Shadow Register for Extra Path 3 Buffer Register */
#define CIF_MIEP_4_BASE_AD_SHD	(*( CIF_MIEP_1_BASE_AD_SHD_type *) 0xf00e5820u)	/* Memory Interface Base Address Shadow Register for Extra Path 4 Buffer Register */
#define CIF_MIEP_5_BASE_AD_SHD	(*( CIF_MIEP_1_BASE_AD_SHD_type *) 0xf00e5920u)	/* Memory Interface Base Address Shadow Register for Extra Path 5 Buffer Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ep_enable      : 1;	/* Enables enable ep picture data path */
		unsigned int                : 6;
		unsigned int byte_swap      : 1;	/* Byte Swap Enable */
		unsigned int                : 12;
		unsigned int init_base_en   : 1;	/* Init Base Address Enable */
		unsigned int init_offset_en : 1;	/* Init Offset Counter Enable */
		unsigned int ep_write_format: 2;	/* Extra Path Write Format */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_CTRL_type;
#define CIF_MIEP_1_CTRL	(*( CIF_MIEP_1_CTRL_type *) 0xf00e5500u)	/* Memory Interface Extra Path 1 Control Register */
#define CIF_MIEP_2_CTRL	(*( CIF_MIEP_1_CTRL_type *) 0xf00e5600u)	/* Memory Interface Extra Path 2 Control Register */
#define CIF_MIEP_3_CTRL	(*( CIF_MIEP_1_CTRL_type *) 0xf00e5700u)	/* Memory Interface Extra Path 3 Control Register */
#define CIF_MIEP_4_CTRL	(*( CIF_MIEP_1_CTRL_type *) 0xf00e5800u)	/* Memory Interface Extra Path 4 Control Register */
#define CIF_MIEP_5_CTRL	(*( CIF_MIEP_1_CTRL_type *) 0xf00e5900u)	/* Memory Interface Extra Path 5 Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ep_enable_in   : 1;	/* Extra Path In Enable */
		/* const */ unsigned int                : 15;
		/* const */ unsigned int ep_enable_out  : 1;	/* Extra Path Out Enable */
		/* const */ unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_CTRL_SHD_type;
#define CIF_MIEP_1_CTRL_SHD	(*( CIF_MIEP_1_CTRL_SHD_type *) 0xf00e551cu)	/* Memory Interface Extra Path 1 Control Internal Shadow Register */
#define CIF_MIEP_2_CTRL_SHD	(*( CIF_MIEP_1_CTRL_SHD_type *) 0xf00e561cu)	/* Memory Interface Extra Path 2 Control Internal Shadow Register */
#define CIF_MIEP_3_CTRL_SHD	(*( CIF_MIEP_1_CTRL_SHD_type *) 0xf00e571cu)	/* Memory Interface Extra Path 3 Control Internal Shadow Register */
#define CIF_MIEP_4_CTRL_SHD	(*( CIF_MIEP_1_CTRL_SHD_type *) 0xf00e581cu)	/* Memory Interface Extra Path 4 Control Internal Shadow Register */
#define CIF_MIEP_5_CTRL_SHD	(*( CIF_MIEP_1_CTRL_SHD_type *) 0xf00e591cu)	/* Memory Interface Extra Path 5 Control Internal Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int mi_ep_skip     : 1;	/* Skip Picture */
		unsigned int                : 1;
		unsigned int mi_ep_cfg_upd  : 1;	/* Forced Configuration Update */
		unsigned int                : 27;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_INIT_type;
#define CIF_MIEP_1_INIT	(*( CIF_MIEP_1_INIT_type *) 0xf00e5504u)	/* Memory Interface Extra Path 1 Control Register For Address Init And Skip Function Register */
#define CIF_MIEP_2_INIT	(*( CIF_MIEP_1_INIT_type *) 0xf00e5604u)	/* Memory Interface Extra Path 2 Control Register For Address Init And Skip Function Register */
#define CIF_MIEP_3_INIT	(*( CIF_MIEP_1_INIT_type *) 0xf00e5704u)	/* Memory Interface Extra Path 3 Control Register For Address Init And Skip Function Register */
#define CIF_MIEP_4_INIT	(*( CIF_MIEP_1_INIT_type *) 0xf00e5804u)	/* Memory Interface Extra Path 4 Control Register For Address Init And Skip Function Register */
#define CIF_MIEP_5_INIT	(*( CIF_MIEP_1_INIT_type *) 0xf00e5904u)	/* Memory Interface Extra Path 5 Control Register For Address Init And Skip Function Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int ep_irq_offs_init: 22;	/* Extra Path Y IRQ Offset Init */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_IRQ_OFFS_INIT_type;
#define CIF_MIEP_1_IRQ_OFFS_INIT	(*( CIF_MIEP_1_IRQ_OFFS_INIT_type *) 0xf00e5518u)	/* Memory Interface Fill Level Interrupt Offset Value For Extra Path 1 Register */
#define CIF_MIEP_2_IRQ_OFFS_INIT	(*( CIF_MIEP_1_IRQ_OFFS_INIT_type *) 0xf00e5618u)	/* Memory Interface Fill Level Interrupt Offset Value For Extra Path 2 Register */
#define CIF_MIEP_3_IRQ_OFFS_INIT	(*( CIF_MIEP_1_IRQ_OFFS_INIT_type *) 0xf00e5718u)	/* Memory Interface Fill Level Interrupt Offset Value For Extra Path 3 Register */
#define CIF_MIEP_4_IRQ_OFFS_INIT	(*( CIF_MIEP_1_IRQ_OFFS_INIT_type *) 0xf00e5818u)	/* Memory Interface Fill Level Interrupt Offset Value For Extra Path 4 Register */
#define CIF_MIEP_5_IRQ_OFFS_INIT	(*( CIF_MIEP_1_IRQ_OFFS_INIT_type *) 0xf00e5918u)	/* Memory Interface Fill Level Interrupt Offset Value For Extra Path 5 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int ep_irq_offs    : 22;	/* Extra Path IRQ Offset */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_IRQ_OFFS_SHD_type;
#define CIF_MIEP_1_IRQ_OFFS_SHD	(*( CIF_MIEP_1_IRQ_OFFS_SHD_type *) 0xf00e552cu)	/* Memory Interface Shadow Register of Fill Level Interrupt Offset Value For Extra Path 1 Register */
#define CIF_MIEP_2_IRQ_OFFS_SHD	(*( CIF_MIEP_1_IRQ_OFFS_SHD_type *) 0xf00e562cu)	/* Memory Interface Shadow Register of Fill Level Interrupt Offset Value For Extra Path 2 Register */
#define CIF_MIEP_3_IRQ_OFFS_SHD	(*( CIF_MIEP_1_IRQ_OFFS_SHD_type *) 0xf00e572cu)	/* Memory Interface Shadow Register of Fill Level Interrupt Offset Value For Extra Path 3 Register */
#define CIF_MIEP_4_IRQ_OFFS_SHD	(*( CIF_MIEP_1_IRQ_OFFS_SHD_type *) 0xf00e582cu)	/* Memory Interface Shadow Register of Fill Level Interrupt Offset Value For Extra Path 4 Register */
#define CIF_MIEP_5_IRQ_OFFS_SHD	(*( CIF_MIEP_1_IRQ_OFFS_SHD_type *) 0xf00e592cu)	/* Memory Interface Shadow Register of Fill Level Interrupt Offset Value For Extra Path 5 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int ep_offs_cnt_init: 22;	/* Extra Path Offset Counter Init */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_OFFS_CNT_INIT_type;
#define CIF_MIEP_1_OFFS_CNT_INIT	(*( CIF_MIEP_1_OFFS_CNT_INIT_type *) 0xf00e5510u)	/* Memory Interface Offset Counter Init Value For Extra Path 1 Buffer Register */
#define CIF_MIEP_2_OFFS_CNT_INIT	(*( CIF_MIEP_1_OFFS_CNT_INIT_type *) 0xf00e5610u)	/* Memory Interface Offset Counter Init Value For Extra Path 2 Buffer Register */
#define CIF_MIEP_3_OFFS_CNT_INIT	(*( CIF_MIEP_1_OFFS_CNT_INIT_type *) 0xf00e5710u)	/* Memory Interface Offset Counter Init Value For Extra Path 3 Buffer Register */
#define CIF_MIEP_4_OFFS_CNT_INIT	(*( CIF_MIEP_1_OFFS_CNT_INIT_type *) 0xf00e5810u)	/* Memory Interface Offset Counter Init Value For Extra Path 4 Buffer Register */
#define CIF_MIEP_5_OFFS_CNT_INIT	(*( CIF_MIEP_1_OFFS_CNT_INIT_type *) 0xf00e5910u)	/* Memory Interface Offset Counter Init Value For Extra Path 5 Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int ep_offs_cnt    : 22;	/* Extra Path Y Offset Counter */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_OFFS_CNT_SHD_type;
#define CIF_MIEP_1_OFFS_CNT_SHD	(*( CIF_MIEP_1_OFFS_CNT_SHD_type *) 0xf00e5528u)	/* Memory Interface Current Offset Counter of Extra Path 1 Buffer Register */
#define CIF_MIEP_2_OFFS_CNT_SHD	(*( CIF_MIEP_1_OFFS_CNT_SHD_type *) 0xf00e5628u)	/* Memory Interface Current Offset Counter of Extra Path 2 Buffer Register */
#define CIF_MIEP_3_OFFS_CNT_SHD	(*( CIF_MIEP_1_OFFS_CNT_SHD_type *) 0xf00e5728u)	/* Memory Interface Current Offset Counter of Extra Path 3 Buffer Register */
#define CIF_MIEP_4_OFFS_CNT_SHD	(*( CIF_MIEP_1_OFFS_CNT_SHD_type *) 0xf00e5828u)	/* Memory Interface Current Offset Counter of Extra Path 4 Buffer Register */
#define CIF_MIEP_5_OFFS_CNT_SHD	(*( CIF_MIEP_1_OFFS_CNT_SHD_type *) 0xf00e5928u)	/* Memory Interface Current Offset Counter of Extra Path 5 Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int ep_offs_cnt_start: 22;	/* Extra Path Offset Counter Start */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_OFFS_CNT_START_type;
#define CIF_MIEP_1_OFFS_CNT_START	(*( CIF_MIEP_1_OFFS_CNT_START_type *) 0xf00e5514u)	/* Memory Interface Offset Counter Start Value For Extra Path 1 Register */
#define CIF_MIEP_2_OFFS_CNT_START	(*( CIF_MIEP_1_OFFS_CNT_START_type *) 0xf00e5614u)	/* Memory Interface Offset Counter Start Value For Extra Path 2 Register */
#define CIF_MIEP_3_OFFS_CNT_START	(*( CIF_MIEP_1_OFFS_CNT_START_type *) 0xf00e5714u)	/* Memory Interface Offset Counter Start Value For Extra Path 3 Register */
#define CIF_MIEP_4_OFFS_CNT_START	(*( CIF_MIEP_1_OFFS_CNT_START_type *) 0xf00e5814u)	/* Memory Interface Offset Counter Start Value For Extra Path 4 Register */
#define CIF_MIEP_5_OFFS_CNT_START	(*( CIF_MIEP_1_OFFS_CNT_START_type *) 0xf00e5914u)	/* Memory Interface Offset Counter Start Value For Extra Path 5 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int ep_size_init   : 22;	/* Extra Path Size Init */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_SIZE_INIT_type;
#define CIF_MIEP_1_SIZE_INIT	(*( CIF_MIEP_1_SIZE_INIT_type *) 0xf00e550cu)	/* Memory Interface Size of Extra Path 1 Data Buffer Register */
#define CIF_MIEP_2_SIZE_INIT	(*( CIF_MIEP_1_SIZE_INIT_type *) 0xf00e560cu)	/* Memory Interface Size of Extra Path 2 Data Buffer Register */
#define CIF_MIEP_3_SIZE_INIT	(*( CIF_MIEP_1_SIZE_INIT_type *) 0xf00e570cu)	/* Memory Interface Size of Extra Path 3 Data Buffer Register */
#define CIF_MIEP_4_SIZE_INIT	(*( CIF_MIEP_1_SIZE_INIT_type *) 0xf00e580cu)	/* Memory Interface Size of Extra Path 4 Data Buffer Register */
#define CIF_MIEP_5_SIZE_INIT	(*( CIF_MIEP_1_SIZE_INIT_type *) 0xf00e590cu)	/* Memory Interface Size of Extra Path 5 Data Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int ep_size        : 22;	/* Extra Path Size */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_1_SIZE_SHD_type;
#define CIF_MIEP_1_SIZE_SHD	(*( CIF_MIEP_1_SIZE_SHD_type *) 0xf00e5524u)	/* Memory Interface Size Shadow Register of Extra Path 1 Buffer Register */
#define CIF_MIEP_2_SIZE_SHD	(*( CIF_MIEP_1_SIZE_SHD_type *) 0xf00e5624u)	/* Memory Interface Size Shadow Register of Extra Path 2 Buffer Register */
#define CIF_MIEP_3_SIZE_SHD	(*( CIF_MIEP_1_SIZE_SHD_type *) 0xf00e5724u)	/* Memory Interface Size Shadow Register of Extra Path 3 Buffer Register */
#define CIF_MIEP_4_SIZE_SHD	(*( CIF_MIEP_1_SIZE_SHD_type *) 0xf00e5824u)	/* Memory Interface Size Shadow Register of Extra Path 4 Buffer Register */
#define CIF_MIEP_5_SIZE_SHD	(*( CIF_MIEP_1_SIZE_SHD_type *) 0xf00e5924u)	/* Memory Interface Size Shadow Register of Extra Path 5 Buffer Register */

typedef volatile union
{
	struct
	{ 
		unsigned int frame_end_ep_1 : 1;	/* Extra Path 1 Frame End */
		unsigned int fill_ep_1      : 1;	/* Fill Extra Path 1 */
		unsigned int wrap_ep_1      : 1;	/* Wrap Extra Path 1 */
		unsigned int mblk_line_ep_1 : 1;	/* Macro Block Line Interrupt Extra Path 1 */
		unsigned int frame_end_ep_2 : 1;	/* Extra Path 2 Frame End */
		unsigned int fill_ep_2      : 1;	/* Fill Extra Path 2 */
		unsigned int wrap_ep_2      : 1;	/* Wrap Extra Path 2 */
		unsigned int                : 1;
		unsigned int frame_end_ep_3 : 1;	/* Extra Path 3 Frame End */
		unsigned int fill_ep_3      : 1;	/* Fill Extra Path 3 */
		unsigned int wrap_ep_3      : 1;	/* Wrap Extra Path 3 */
		unsigned int mblk_line_ep_3 : 1;	/* Macro Block Line Interrupt Extra Path 3 */
		unsigned int frame_end_ep_4 : 1;	/* Extra Path 4 Frame End */
		unsigned int fill_ep_4      : 1;	/* Fill Extra Path 4 */
		unsigned int wrap_ep_4      : 1;	/* Wrap Extra Path 4 */
		unsigned int mblk_line_ep_4 : 1;	/* Macro Block Line Interrupt Extra Path 4 */
		unsigned int frame_end_ep_5 : 1;	/* Extra Path 5 Frame End */
		unsigned int fill_ep_5      : 1;	/* Fill Extra Path 5 */
		unsigned int wrap_ep_5      : 1;	/* Wrap Extra Path 5 */
		unsigned int mblk_line_ep_5 : 1;	/* Macro Block Line Interrupt Extra Path 5 */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_ICR_type;
#define CIF_MIEP_ICR	(*( CIF_MIEP_ICR_type *) 0xf00e5414u)	/* MI Extra Path Interrupt Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int frame_end_ep_1 : 1;	/* Extra Path 1 Frame End */
		unsigned int fill_ep_1      : 1;	/* Fill Extra Path 1 */
		unsigned int wrap_ep_1      : 1;	/* Wrap Extra Path 1 */
		unsigned int mblk_line_ep_1 : 1;	/* Macro Block Line Interrupt Extra Path 1 */
		unsigned int frame_end_ep_2 : 1;	/* Extra Path 2 Frame End */
		unsigned int fill_ep_2      : 1;	/* Fill Extra Path 2 */
		unsigned int wrap_ep_2      : 1;	/* Wrap Extra Path 2 */
		unsigned int mblk_line_ep_2 : 1;	/* Macro Block Line Interrupt Extra Path 2 */
		unsigned int frame_end_ep_3 : 1;	/* Extra Path 3 Frame End */
		unsigned int fill_ep_3      : 1;	/* Fill Extra Path 3 */
		unsigned int wrap_ep_3      : 1;	/* Wrap Extra Path 3 */
		unsigned int mblk_line_ep_3 : 1;	/* Macro Block Line Interrupt Extra Path 3 */
		unsigned int frame_end_ep_4 : 1;	/* Extra Path 4 Frame End */
		unsigned int fill_ep_4      : 1;	/* Fill Extra Path 4 */
		unsigned int wrap_ep_4      : 1;	/* Wrap Extra Path 4 */
		unsigned int mblk_line_ep_4 : 1;	/* Macro Block Line Interrupt Extra Path 4 */
		unsigned int frame_end_ep_5 : 1;	/* Extra Path 5 Frame End */
		unsigned int fill_ep_5      : 1;	/* Fill Extra Path 5 */
		unsigned int wrap_ep_5      : 1;	/* Wrap Extra Path 5 */
		unsigned int mblk_line_ep_5 : 1;	/* Macro Block Line Interrupt Extra Path 5 */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_IMSC_type;
#define CIF_MIEP_IMSC	(*( CIF_MIEP_IMSC_type *) 0xf00e5408u)	/* MI Extra Path Interrupt Mask ?1?: interrupt active, ?0?: interrupt masked */

typedef volatile union
{
	struct
	{ 
		unsigned int frame_end_ep_1 : 1;	/* Extra Path 1 Frame End */
		unsigned int fill_ep_1      : 1;	/* Fill Extra Path 1 */
		unsigned int wrap_ep_1      : 1;	/* Wrap Extra Path 1 */
		unsigned int mblk_line_ep_1 : 1;	/* Macro Block Line Interrupt Extra Path 1 */
		unsigned int frame_end_ep_2 : 1;	/* Extra Path 2 Frame End */
		unsigned int fill_ep_2      : 1;	/* Fill Extra Path 2 */
		unsigned int wrap_ep_2      : 1;	/* Wrap Extra Path 2 */
		unsigned int mblk_line_ep_2 : 1;	/* Macro Block Line Interrupt Extra Path 2 */
		unsigned int frame_end_ep_3 : 1;	/* Extra Path 3 Frame End */
		unsigned int fill_ep_3      : 1;	/* Fill Extra Path 3 */
		unsigned int wrap_ep_3      : 1;	/* Wrap Extra Path 3 */
		unsigned int mblk_line_ep_3 : 1;	/* Macro Block Line Interrupt Extra Path 3 */
		unsigned int frame_end_ep_4 : 1;	/* Extra Path 4 Frame End */
		unsigned int fill_ep_4      : 1;	/* Fill Extra Path 4 */
		unsigned int wrap_ep_4      : 1;	/* Wrap Extra Path 4 */
		unsigned int mblk_line_ep_4 : 1;	/* Macro Block Line Interrupt Extra Path 4 */
		unsigned int frame_end_ep_5 : 1;	/* Extra Path 5 Frame End */
		unsigned int fill_ep_5      : 1;	/* Fill Extra Path 5 */
		unsigned int wrap_ep_5      : 1;	/* Wrap Extra Path 5 */
		unsigned int mblk_line_ep_5 : 1;	/* Macro Block Line Interrupt Extra Path 5 */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_ISR_type;
#define CIF_MIEP_ISR	(*( CIF_MIEP_ISR_type *) 0xf00e5418u)	/* MI Extra Path Interrupt Set Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int frame_end_ep_1 : 1;	/* Extra Path 1 Frame End */
		/* const */ unsigned int fill_ep_1      : 1;	/* Fill Extra Path 1 */
		/* const */ unsigned int wrap_ep_1      : 1;	/* Wrap Extra Path 1 */
		/* const */ unsigned int mblk_line_ep_1 : 1;	/* Macro Block Line Interrupt Extra Path 1 */
		/* const */ unsigned int frame_end_ep_2 : 1;	/* Extra Path 2 Frame End */
		/* const */ unsigned int fill_ep_2      : 1;	/* Fill Extra Path 2 */
		/* const */ unsigned int wrap_ep_2      : 1;	/* Wrap Extra Path 2 */
		/* const */ unsigned int mblk_line_ep_2 : 1;	/* Macro Block Line Interrupt Extra Path 2 */
		/* const */ unsigned int frame_end_ep_3 : 1;	/* Extra Path 3 Frame End */
		/* const */ unsigned int fill_ep_3      : 1;	/* Fill Extra Path 3 */
		/* const */ unsigned int wrap_ep_3      : 1;	/* Wrap Extra Path 3 */
		/* const */ unsigned int mblk_line_ep_3 : 1;	/* Macro Block Line Interrupt Extra Path 3 */
		/* const */ unsigned int frame_end_ep_4 : 1;	/* Extra Path 4 Frame End */
		/* const */ unsigned int fill_ep_4      : 1;	/* Fill Extra Path 4 */
		/* const */ unsigned int wrap_ep_4      : 1;	/* Wrap Extra Path 4 */
		/* const */ unsigned int mblk_line_ep_4 : 1;	/* Macro Block Line Interrupt Extra Path 4 */
		/* const */ unsigned int frame_end_ep_5 : 1;	/* Extra Path 5 Frame End */
		/* const */ unsigned int fill_ep_5      : 1;	/* Fill Extra Path 5 */
		/* const */ unsigned int wrap_ep_5      : 1;	/* Wrap Extra Path 5 */
		/* const */ unsigned int mblk_line_ep_5 : 1;	/* Macro Block Line Interrupt Extra Path 5 */
		/* const */ unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_MIS_type;
#define CIF_MIEP_MIS	(*( CIF_MIEP_MIS_type *) 0xf00e5410u)	/* MI Extra Path Masked Interrupt Status Register */
#define CIF_MIEP_RIS	(*( CIF_MIEP_MIS_type *) 0xf00e540cu)	/* MI Extra Path Raw Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 1;
		/* const */ unsigned int ep_1_ic_size_err: 1;	/* Size error is generated in Extra Path 1 image cropping submodule */
		/* const */ unsigned int ep_2_ic_size_err: 1;	/* Size error is generated in Extra Path 2 image cropping submodule */
		/* const */ unsigned int ep_3_ic_size_err: 1;	/* Size error is generated in Extra Path 3 image cropping submodule */
		/* const */ unsigned int ep_4_ic_size_err: 1;	/* Size error is generated in Extra Path 4 image cropping submodule */
		/* const */ unsigned int ep_5_ic_size_err: 1;	/* Size error is generated in Extra Path 5 image cropping submodule */
		/* const */ unsigned int                : 11;
		/* const */ unsigned int ep_1_fifo_full : 1;	/* Extra Path 1 FIFO Full */
		/* const */ unsigned int ep_2_fifo_full : 1;	/* Extra Path 2 FIFO Full */
		/* const */ unsigned int ep_3_fifo_full : 1;	/* Extra Path 3 FIFO Full */
		/* const */ unsigned int ep_4_fifo_full : 1;	/* Extra Path 4 FIFO Full */
		/* const */ unsigned int ep_5_fifo_full : 1;	/* Extra Path 5 FIFO Full */
		/* const */ unsigned int                : 10;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_STA_ERR_type;
#define CIF_MIEP_STA_ERR	(*( CIF_MIEP_STA_ERR_type *) 0xf00e5400u)	/* Extra Path Error Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		unsigned int ep_1_ic_size_err_clr: 1;	/* Size error is cleared */
		unsigned int ep_2_ic_size_err_clr: 1;	/* Size error is cleared */
		unsigned int ep_3_ic_size_err_clr: 1;	/* Size error is cleared */
		unsigned int ep_4_ic_size_err_clr: 1;	/* Size error is cleared */
		unsigned int ep_5_ic_size_err_clr: 1;	/* Size error is cleared */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} CIF_MIEP_STA_ERR_CLR_type;
#define CIF_MIEP_STA_ERR_CLR	(*( CIF_MIEP_STA_ERR_CLR_type *) 0xf00e5404u)	/* Extra Path Error Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int byte_cnt       : 24;	/* Byte Count */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_BYTE_CNT_type;
#define CIF_MI_BYTE_CNT	(*( CIF_MI_BYTE_CNT_type *) 0xf00e3470u)	/* Memory Interface Counter Value of JPEG or RAW Data Bytes Register */

typedef volatile union
{
	struct
	{ 
		unsigned int mp_enable      : 1;	/* Enables main picture data path */
		unsigned int                : 1;
		unsigned int jpeg_enable    : 1;	/* Enables JPEG data */
		unsigned int raw_enable     : 1;	/* Enables RAW data */
		unsigned int                : 3;
		unsigned int byte_swap      : 1;	/* Byte Swap Enable */
		unsigned int                : 8;
		unsigned int burst_len_lum  : 1;	/* Luminance Burst Length */
		unsigned int                : 1;
		unsigned int burst_len_chrom: 1;	/* Chrominance Burst Length */
		unsigned int                : 1;
		unsigned int init_base_en   : 1;	/* Init Base Address Enable */
		unsigned int init_offset_en : 1;	/* Init Offset Counter Enable */
		unsigned int mp_write_format: 2;	/* Main Picture YCbCr Write Format */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_CTRL_type;
#define CIF_MI_CTRL	(*( CIF_MI_CTRL_type *) 0xf00e3400u)	/* Memory Interface Global Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int mp_enable_in   : 1;	/* Main Picture In Enable */
		/* const */ unsigned int                : 3;
		/* const */ unsigned int jpeg_enable_in : 1;	/* JPEG In Enable */
		/* const */ unsigned int raw_enable_in  : 1;	/* RAW In Enable */
		/* const */ unsigned int                : 10;
		/* const */ unsigned int mp_enable_out  : 1;	/* Main Picture Out Enable */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int jpeg_enable_out: 1;	/* JPEG Out Enable */
		/* const */ unsigned int raw_enable_out : 1;	/* RAW Out Enable */
		/* const */ unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CIF_MI_CTRL_SHD_type;
#define CIF_MI_CTRL_SHD	(*( CIF_MI_CTRL_SHD_type *) 0xf00e3474u)	/* Memory Interface Global Control Internal Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int mp_frame_end   : 1;	/* Main Picture Frame End */
		unsigned int                : 1;
		unsigned int mblk_line      : 1;	/* Macro Block Line Interrupt */
		unsigned int fill_mpy       : 1;	/* Fill Main Picture Y */
		unsigned int wrap_mp_y      : 1;	/* Wrap Main Picture Y */
		unsigned int wrap_mp_cb     : 1;	/* Wrap Main Picture Cb */
		unsigned int wrap_mp_cr     : 1;	/* Wrap Main Picture Cr */
		unsigned int                : 3;
		unsigned int Bus_error      : 1;	/* Bus Error */
		unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} CIF_MI_ICR_type;
#define CIF_MI_ICR	(*( CIF_MI_ICR_type *) 0xf00e3504u)	/* MI Interrupt Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int mp_frame_end   : 1;	/* Main Picture Frame End */
		unsigned int                : 1;
		unsigned int mblk_line      : 1;	/* Macro Block Line Interrupt */
		unsigned int fill_mp_y      : 1;	/* Fill Main Picture Y */
		unsigned int wrap_mp_y      : 1;	/* Wrap Main Picture Y */
		unsigned int wrap_mp_cb     : 1;	/* Wrap Main Picture Cb */
		unsigned int wrap_mp_cr     : 1;	/* Wrap Main Picture Cr */
		unsigned int                : 3;
		unsigned int Bus_error      : 1;	/* Bus Error */
		unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} CIF_MI_IMSC_type;
#define CIF_MI_IMSC	(*( CIF_MI_IMSC_type *) 0xf00e34f8u)	/* MI Interrupt Mask ?1? interrupt active ?0? interrupt masked */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int mi_skip        : 1;	/* Skip Picture */
		unsigned int                : 1;
		unsigned int mi_cfg_upd     : 1;	/* Forced Configuration Update */
		unsigned int                : 27;
	} B;
	int I;
	unsigned int U;

} CIF_MI_INIT_type;
#define CIF_MI_INIT	(*( CIF_MI_INIT_type *) 0xf00e3404u)	/* Memory Interface Control Register For Address Init And Skip Function Register */

typedef volatile union
{
	struct
	{ 
		unsigned int mp_frame_end   : 1;	/* Main Picture Frame End */
		unsigned int                : 1;
		unsigned int mblk_line      : 1;	/* Macro Block Line Interrupt */
		unsigned int fill_mp_y      : 1;	/* Fill Main Picture Y */
		unsigned int wrap_mp_y      : 1;	/* Wrap Main Picture Y */
		unsigned int wrap_mp_cb     : 1;	/* Wrap Main Picture Cb */
		unsigned int wrap_mp_cr     : 1;	/* Wrap Main Picture Cr */
		unsigned int                : 3;
		unsigned int Bus_error      : 1;	/* Bus Error */
		unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} CIF_MI_ISR_type;
#define CIF_MI_ISR	(*( CIF_MI_ISR_type *) 0xf00e3508u)	/* MI Interrupt Set Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int mp_frame_end   : 1;	/* Main Picture Frame End */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int mblk_line      : 1;	/* Macro Block Line Interrupt */
		/* const */ unsigned int fill_mp_y      : 1;	/* Fill Main Picture Y */
		/* const */ unsigned int wrap_mp_y      : 1;	/* Wrap Main Picture Y */
		/* const */ unsigned int wrap_mp_cb     : 1;	/* Wrap Main Picture Cb */
		/* const */ unsigned int wrap_mp_cr     : 1;	/* Wrap Main Picture Cr */
		/* const */ unsigned int                : 3;
		/* const */ unsigned int Bus_error      : 1;	/* Bus Error */
		/* const */ unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MIS_type;
#define CIF_MI_MIS	(*( CIF_MI_MIS_type *) 0xf00e3500u)	/* MI Masked Interrupt Status Registe */
#define CIF_MI_RIS	(*( CIF_MI_MIS_type *) 0xf00e34fcu)	/* MI Raw Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int mp_cb_basead_init: 30;	/* Main Picture Cb Base Address Init */
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CB_BASE_AD_INIT_type;
#define CIF_MI_MP_CB_BASE_AD_INIT	(*( CIF_MI_MP_CB_BASE_AD_INIT_type *) 0xf00e341cu)	/* Memory Interface Base Address For Main Picture Cb Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_cb_base_ad  : 30;	/* Main Picture Cb Base Address */
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CB_BASE_AD_SHD_type;
#define CIF_MI_MP_CB_BASE_AD_SHD	(*( CIF_MI_MP_CB_BASE_AD_SHD_type *) 0xf00e3488u)	/* Memory Interface Base Address Shadow Register For Main Picture Cb Component Ring Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int mp_cb_offs_cnt_init: 22;	/* Main Picture Cb Offset Counter Init */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CB_OFFS_CNT_INIT_type;
#define CIF_MI_MP_CB_OFFS_CNT_INIT	(*( CIF_MI_MP_CB_OFFS_CNT_INIT_type *) 0xf00e3424u)	/* Memory Interface Offset Counter Init Value For Main Picture Cb Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_cb_offs_cnt : 22;	/* Main Picture Cb Offset Counter */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CB_OFFS_CNT_SHD_type;
#define CIF_MI_MP_CB_OFFS_CNT_SHD	(*( CIF_MI_MP_CB_OFFS_CNT_SHD_type *) 0xf00e3490u)	/* Memory Interface Current Offset Counter Of Main Picture Cb Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_cb_offs_cnt_start: 22;	/* Main Picture Cb Offset Count Start */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CB_OFFS_CNT_START_type;
#define CIF_MI_MP_CB_OFFS_CNT_START	(*( CIF_MI_MP_CB_OFFS_CNT_START_type *) 0xf00e3428u)	/* Memory Interface Offset Counter Start Value For Main Picture Cb Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int mp_cb_size_init: 22;	/* Main Picture Cb Size Init */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CB_SIZE_INIT_type;
#define CIF_MI_MP_CB_SIZE_INIT	(*( CIF_MI_MP_CB_SIZE_INIT_type *) 0xf00e3420u)	/* Memory Interface Size Of Main Picture Cb Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_cb_size     : 22;	/* Main Picture Cb Size */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CB_SIZE_SHD_type;
#define CIF_MI_MP_CB_SIZE_SHD	(*( CIF_MI_MP_CB_SIZE_SHD_type *) 0xf00e348cu)	/* Memory Interface Size Shadow Register Of Main Picture Cb Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int mp_cr_base_ad_init: 30;	/* Main Picture Cr Base Address Init */
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CR_BASE_AD_INIT_type;
#define CIF_MI_MP_CR_BASE_AD_INIT	(*( CIF_MI_MP_CR_BASE_AD_INIT_type *) 0xf00e342cu)	/* Memory Interface Base Address For Main Picture Cr Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_cr_base_ad  : 30;	/* Main Picture Cr Base Address */
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CR_BASE_AD_SHD_type;
#define CIF_MI_MP_CR_BASE_AD_SHD	(*( CIF_MI_MP_CR_BASE_AD_SHD_type *) 0xf00e3494u)	/* Memory Interface Base Address Shadow Register For Main Picture Cr Component Ring Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int mp_cr_offs_cnt_init: 22;	/* Main Picture Cr Offset Counter Init */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CR_OFFS_CNT_INIT_type;
#define CIF_MI_MP_CR_OFFS_CNT_INIT	(*( CIF_MI_MP_CR_OFFS_CNT_INIT_type *) 0xf00e3434u)	/* Memory Interface Offset Counter Init value For Main Picture Cr Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_cr_offs_cnt : 22;	/* Main Picture Cr Offset Counter */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CR_OFFS_CNT_SHD_type;
#define CIF_MI_MP_CR_OFFS_CNT_SHD	(*( CIF_MI_MP_CR_OFFS_CNT_SHD_type *) 0xf00e349cu)	/* Memory Interface Current Offset Counter Of Main Picture Cr Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_cr_offs_cnt_start: 22;	/* Main Picture Cr Offset Counter Start */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CR_OFFS_CNT_START_type;
#define CIF_MI_MP_CR_OFFS_CNT_START	(*( CIF_MI_MP_CR_OFFS_CNT_START_type *) 0xf00e3438u)	/* Memory Interface Offset Counter Start Value For Main Picture Cr Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int mp_cr_size_init: 22;	/* Main Picture Cr Size Init */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CR_SIZE_INIT_type;
#define CIF_MI_MP_CR_SIZE_INIT	(*( CIF_MI_MP_CR_SIZE_INIT_type *) 0xf00e3430u)	/* Memory Interface Size Of Main Picture Cr Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_cr_size     : 22;	/* Main Picture Cr Size */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_CR_SIZE_SHD_type;
#define CIF_MI_MP_CR_SIZE_SHD	(*( CIF_MI_MP_CR_SIZE_SHD_type *) 0xf00e3498u)	/* Memory Interface Size Shadow Register Of Main Picture Cr Component Ring Buffer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int mp_y_base_ad_init: 30;	/* Main Picture Y Base Address Init */
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_Y_BASE_AD_INIT_type;
#define CIF_MI_MP_Y_BASE_AD_INIT	(*( CIF_MI_MP_Y_BASE_AD_INIT_type *) 0xf00e3408u)	/* Memory Interface Base Address For Main Picture Y Component, JPEG or RAW Data Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_y_base_ad   : 30;	/* Main Picture Y Base Address */
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_Y_BASE_AD_SHD_type;
#define CIF_MI_MP_Y_BASE_AD_SHD	(*( CIF_MI_MP_Y_BASE_AD_SHD_type *) 0xf00e3478u)	/* Memory Interface Base Address Shadow Register For Main Picture Y Component, JPEG Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int mp_y_irq_offs_init: 22;	/* Main Picture Y IRQ Offset Init */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_Y_IRQ_OFFS_INIT_type;
#define CIF_MI_MP_Y_IRQ_OFFS_INIT	(*( CIF_MI_MP_Y_IRQ_OFFS_INIT_type *) 0xf00e3418u)	/* Memory Interface Fill Level Interrupt Offset Value For Main Picture Y, JPEG or RAW Data Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_y_irq_offs  : 22;	/* Main Picture Y IRQ Offset */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_Y_IRQ_OFFS_SHD_type;
#define CIF_MI_MP_Y_IRQ_OFFS_SHD	(*( CIF_MI_MP_Y_IRQ_OFFS_SHD_type *) 0xf00e3484u)	/* Memory Interface Shadow Register of Fill Level Interrupt Offset Value For Main Picture Y Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int mp_y_offs_cnt_init: 22;	/* Main Picture Y Offset Counter Init */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_Y_OFFS_CNT_INIT_type;
#define CIF_MI_MP_Y_OFFS_CNT_INIT	(*( CIF_MI_MP_Y_OFFS_CNT_INIT_type *) 0xf00e3410u)	/* Memory Interface Offset Counter Init Value For Main Picture Y, JPEG or RAW Data Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_y_offs_cnt  : 22;	/* Main Picture Y Offset Counter */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_Y_OFFS_CNT_SHD_type;
#define CIF_MI_MP_Y_OFFS_CNT_SHD	(*( CIF_MI_MP_Y_OFFS_CNT_SHD_type *) 0xf00e3480u)	/* Memory Interface Current Offset Counter of Main Picture Y Component JPEG or RAW Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_y_offs_cnt_start: 22;	/* Main Picture Y Offset Counter Start */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_Y_OFFS_CNT_START_type;
#define CIF_MI_MP_Y_OFFS_CNT_START	(*( CIF_MI_MP_Y_OFFS_CNT_START_type *) 0xf00e3414u)	/* Memory Interface Offset Counter Start Value For Main Picture Y, JPEG or RAW Data Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		unsigned int mp_y_size_init : 22;	/* Main Picture Y Size Init */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_Y_SIZE_INIT_type;
#define CIF_MI_MP_Y_SIZE_INIT	(*( CIF_MI_MP_Y_SIZE_INIT_type *) 0xf00e340cu)	/* Memory Interface Size of main picture Y component, JPEG or RAW data Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int fixed_to_00    : 2;	/* Bits [1:0] are set to '00' (word aligned value). */
		/* const */ unsigned int mp_y_size      : 22;	/* Main Picture Y Size */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CIF_MI_MP_Y_SIZE_SHD_type;
#define CIF_MI_MP_Y_SIZE_SHD	(*( CIF_MI_MP_Y_SIZE_SHD_type *) 0xf00e347cu)	/* Memory Interface Size Shadow Register of Main Picture Y Component,JPEG or RAW Data Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int mp_y_fifo_full : 1;	/* Main Picture Y FIFO Full */
		/* const */ unsigned int mp_cb_fifo_full: 1;	/* Main Picture Cb FIFO Full */
		/* const */ unsigned int mp_cr_fifo_full: 1;	/* Main Picture Cr FIFO Full */
		/* const */ unsigned int                : 5;
		/* const */ unsigned int Bus_write_error: 1;	/* Bus Write Error */
		/* const */ unsigned int                : 23;
	} B;
	int I;
	unsigned int U;

} CIF_MI_STATUS_type;
#define CIF_MI_STATUS	(*( CIF_MI_STATUS_type *) 0xf00e350cu)	/* MI Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int mp_y_fifo_full : 1;	/* Main Picture Y FIFO Full */
		unsigned int mp_cb_fifo_full: 1;	/* Main Picture Cb FIFO Full */
		unsigned int mp_cr_fifo_full: 1;	/* Main Picture Cr FIFO Full */
		unsigned int                : 5;
		unsigned int Bus_write_error: 1;	/* Bus Write Error */
		unsigned int                : 15;
		unsigned int ep_1_fifo_full : 1;	/* Extra Path 1 FIFO Full */
		unsigned int ep_2_fifo_full : 1;	/* Extra Path 2 FIFO Full */
		unsigned int ep_3_fifo_full : 1;	/* Extra Path 3 FIFO Full */
		unsigned int ep_4_fifo_full : 1;	/* Extra Path 4 FIFO Full */
		unsigned int ep_5_fifo_full : 1;	/* Extra Path 5 FIFO Full */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} CIF_MI_STATUS_CLR_type;
#define CIF_MI_STATUS_CLR	(*( CIF_MI_STATUS_CLR_type *) 0xf00e3510u)	/* MI Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int wd_en          : 1;	/* Enable Security Watchdog */
		unsigned int rst_h_cnt      : 1;	/* Reset Horizontal Counter */
		unsigned int rst_v_cnt      : 1;	/* Reset Vertical Counter */
		unsigned int rst_pd_cnt     : 1;	/* Reset Predivider Counter */
		unsigned int                : 12;
		unsigned int wd_prediv      : 16;	/* Watchdog Counter Predivider */
	} B;
	int I;
	unsigned int U;

} CIF_WD_CTRL_type;
#define CIF_WD_CTRL	(*( CIF_WD_CTRL_type *) 0xf00e4400u)	/* Watchdog Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int wd_hse_to      : 16;	/* Watchdog Horizontal Start End Timeout */
		unsigned int wd_hes_to      : 16;	/* Watchdog Horizontal End Start Timeout */
	} B;
	int I;
	unsigned int U;

} CIF_WD_H_TIMEOUT_type;
#define CIF_WD_H_TIMEOUT	(*( CIF_WD_H_TIMEOUT_type *) 0xf00e4408u)	/* Watchdog Horizontal Timeout Register */

typedef volatile union
{
	struct
	{ 
		unsigned int icr_wd_hse_to  : 1;	/* Horizontal Start End Timeout */
		unsigned int icr_wd_hes_to  : 1;	/* Horizontal End Start Timeout */
		unsigned int icr_wd_vse_to  : 1;	/* Vertical Start End Timeout */
		unsigned int icr_wd_ves_to  : 1;	/* Vertical End Start Timeout */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CIF_WD_ICR_type;
#define CIF_WD_ICR	(*( CIF_WD_ICR_type *) 0xf00e4418u)	/* Watchdog Interrupt Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int imsc_wd_hse_to : 1;	/* Horizontal Start End Timeout */
		unsigned int imsc_wd_hes_to : 1;	/* Horizontal End Start Timeout */
		unsigned int imsc_wd_vse_to : 1;	/* Vertical Start End Timeout */
		unsigned int imsc_wd_ves_to : 1;	/* Vertical End Start Timeout */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CIF_WD_IMSC_type;
#define CIF_WD_IMSC	(*( CIF_WD_IMSC_type *) 0xf00e440cu)	/* Watchdog Interrupt Mask Register */

typedef volatile union
{
	struct
	{ 
		unsigned int isr_wd_hse_to  : 1;	/* Horizontal Start End Timeout */
		unsigned int isr_wd_hes_to  : 1;	/* Horizontal End Start Timeout */
		unsigned int isr_wd_vse_to  : 1;	/* Vertical Start End Timeout */
		unsigned int isr_wd_ves_to  : 1;	/* Vertical End Start Timeout */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CIF_WD_ISR_type;
#define CIF_WD_ISR	(*( CIF_WD_ISR_type *) 0xf00e441cu)	/* Watchdog Interrupt Set Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int mis_wd_hse_to  : 1;	/* Horizontal Start End Timeout */
		/* const */ unsigned int mis_wd_hes_to  : 1;	/* Horizontal End Start Timeout */
		/* const */ unsigned int mis_wd_vse_to  : 1;	/* Vertical Start End Timeout */
		/* const */ unsigned int mis_wd_ves_to  : 1;	/* Vertical End Start Timeout */
		/* const */ unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CIF_WD_MIS_type;
#define CIF_WD_MIS	(*( CIF_WD_MIS_type *) 0xf00e4414u)	/* Watchdog Masked Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ris_wd_hse_to  : 1;	/* Horizontal Start End Timeout */
		/* const */ unsigned int ris_wd_hes_to  : 1;	/* Horizontal End Start Timeout */
		/* const */ unsigned int ris_wd_vse_to  : 1;	/* Vertical Start End Timeout */
		/* const */ unsigned int ris_wd_ves_to  : 1;	/* Vertical End Start Timeout */
		/* const */ unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CIF_WD_RIS_type;
#define CIF_WD_RIS	(*( CIF_WD_RIS_type *) 0xf00e4410u)	/* Watchdog Raw Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int wd_vse_to      : 16;	/* Watchdog Vertical Start End Timeout */
		unsigned int wd_ves_to      : 16;	/* Watchdog Vertical End Start Timeout */
	} B;
	int I;
	unsigned int U;

} CIF_WD_V_TIMEOUT_type;
#define CIF_WD_V_TIMEOUT	(*( CIF_WD_V_TIMEOUT_type *) 0xf00e4404u)	/* Watchdog Vertical Timeout Register */


/* CCU6 */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} CCU60_ACCEN0_type;
#define CCU60_ACCEN0	(*( CCU60_ACCEN0_type *) 0xf0002afcu)	/* Access Enable Register 0 */
#define CCU61_ACCEN0	(*( CCU60_ACCEN0_type *) 0xf0002bfcu)	/* Access Enable Register 0 */
#define CCU62_ACCEN0	(*( CCU60_ACCEN0_type *) 0xf0002cfcu)	/* Access Enable Register 0 */
#define CCU63_ACCEN0	(*( CCU60_ACCEN0_type *) 0xf0002dfcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CCU60_ACCEN1_type;
#define CCU60_ACCEN1	(*( CCU60_ACCEN1_type *) 0xf0002af8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CCV            : 16;	/* Capture/Compare Value */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_CC60R_type;
#define CCU60_CC60R	(*( CCU60_CC60R_type *) 0xf0002a30u)	/* Capture/Compare Register for Channel CC60 */
#define CCU60_CC61R	(*( CCU60_CC60R_type *) 0xf0002a34u)	/* Capture/Compare Register for Channel CC61 */
#define CCU60_CC62R	(*( CCU60_CC60R_type *) 0xf0002a38u)	/* Capture/Compare Register for Channel CC62 */
#define CCU61_CC60R	(*( CCU60_CC60R_type *) 0xf0002b30u)	/* Capture/Compare Register for Channel CC60 */
#define CCU61_CC61R	(*( CCU60_CC60R_type *) 0xf0002b34u)	/* Capture/Compare Register for Channel CC61 */
#define CCU61_CC62R	(*( CCU60_CC60R_type *) 0xf0002b38u)	/* Capture/Compare Register for Channel CC62 */
#define CCU62_CC60R	(*( CCU60_CC60R_type *) 0xf0002c30u)	/* Capture/Compare Register for Channel CC60 */
#define CCU62_CC61R	(*( CCU60_CC60R_type *) 0xf0002c34u)	/* Capture/Compare Register for Channel CC61 */
#define CCU62_CC62R	(*( CCU60_CC60R_type *) 0xf0002c38u)	/* Capture/Compare Register for Channel CC62 */
#define CCU63_CC60R	(*( CCU60_CC60R_type *) 0xf0002d30u)	/* Capture/Compare Register for Channel CC60 */
#define CCU63_CC61R	(*( CCU60_CC60R_type *) 0xf0002d34u)	/* Capture/Compare Register for Channel CC61 */
#define CCU63_CC62R	(*( CCU60_CC60R_type *) 0xf0002d38u)	/* Capture/Compare Register for Channel CC62 */

typedef volatile union
{
	struct
	{ 
		unsigned int CCS            : 16;	/* Shadow Register for Channel x Capture/Compare Value */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_CC60SR_type;
#define CCU60_CC60SR	(*( CCU60_CC60SR_type *) 0xf0002a40u)	/* Capture/Compare Shadow Reg. for Channel CC60 */
#define CCU60_CC61SR	(*( CCU60_CC60SR_type *) 0xf0002a44u)	/* Capture/Compare Shadow Reg. for Channel CC61 */
#define CCU60_CC62SR	(*( CCU60_CC60SR_type *) 0xf0002a48u)	/* Capture/Compare Shadow Reg. for Channel CC62 */
#define CCU61_CC60SR	(*( CCU60_CC60SR_type *) 0xf0002b40u)	/* Capture/Compare Shadow Reg. for Channel CC60 */
#define CCU61_CC61SR	(*( CCU60_CC60SR_type *) 0xf0002b44u)	/* Capture/Compare Shadow Reg. for Channel CC61 */
#define CCU61_CC62SR	(*( CCU60_CC60SR_type *) 0xf0002b48u)	/* Capture/Compare Shadow Reg. for Channel CC62 */
#define CCU62_CC60SR	(*( CCU60_CC60SR_type *) 0xf0002c40u)	/* Capture/Compare Shadow Reg. for Channel CC60 */
#define CCU62_CC61SR	(*( CCU60_CC60SR_type *) 0xf0002c44u)	/* Capture/Compare Shadow Reg. for Channel CC61 */
#define CCU62_CC62SR	(*( CCU60_CC60SR_type *) 0xf0002c48u)	/* Capture/Compare Shadow Reg. for Channel CC62 */
#define CCU63_CC60SR	(*( CCU60_CC60SR_type *) 0xf0002d40u)	/* Capture/Compare Shadow Reg. for Channel CC60 */
#define CCU63_CC61SR	(*( CCU60_CC60SR_type *) 0xf0002d44u)	/* Capture/Compare Shadow Reg. for Channel CC61 */
#define CCU63_CC62SR	(*( CCU60_CC60SR_type *) 0xf0002d48u)	/* Capture/Compare Shadow Reg. for Channel CC62 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CCV            : 16;	/* Channel CC63 Compare Value */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_CC63R_type;
#define CCU60_CC63R	(*( CCU60_CC63R_type *) 0xf0002a58u)	/* Compare Register for T13 */
#define CCU61_CC63R	(*( CCU60_CC63R_type *) 0xf0002b58u)	/* Compare Register for T13 */
#define CCU62_CC63R	(*( CCU60_CC63R_type *) 0xf0002c58u)	/* Compare Register for T13 */
#define CCU63_CC63R	(*( CCU60_CC63R_type *) 0xf0002d58u)	/* Compare Register for T13 */

typedef volatile union
{
	struct
	{ 
		unsigned int CCS            : 16;	/* Shadow Register for Channel CC63 Compare Value */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_CC63SR_type;
#define CCU60_CC63SR	(*( CCU60_CC63SR_type *) 0xf0002a5cu)	/* Compare Shadow Register for T13 */
#define CCU61_CC63SR	(*( CCU60_CC63SR_type *) 0xf0002b5cu)	/* Compare Shadow Register for T13 */
#define CCU62_CC63SR	(*( CCU60_CC63SR_type *) 0xf0002c5cu)	/* Compare Shadow Register for T13 */
#define CCU63_CC63SR	(*( CCU60_CC63SR_type *) 0xf0002d5cu)	/* Compare Shadow Register for T13 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CCU60_CLC_type;
#define CCU60_CLC	(*( CCU60_CLC_type *) 0xf0002a00u)	/* Clock Control Register */
#define CCU61_CLC	(*( CCU60_CLC_type *) 0xf0002b00u)	/* Clock Control Register */
#define CCU62_CLC	(*( CCU60_CLC_type *) 0xf0002c00u)	/* Clock Control Register */
#define CCU63_CLC	(*( CCU60_CLC_type *) 0xf0002d00u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MCC60S         : 1;	/* Capture/Compare Status Modification Bits */
		unsigned int MCC61S         : 1;	/* Capture/Compare Status Modification Bits */
		unsigned int MCC62S         : 1;	/* Capture/Compare Status Modification Bits */
		unsigned int                : 3;
		unsigned int MCC63S         : 1;	/* Capture/Compare Status Modification Bits */
		unsigned int                : 1;
		unsigned int MCC60R         : 1;	/* Capture/Compare Status Modification Bits */
		unsigned int MCC61R         : 1;	/* Capture/Compare Status Modification Bits */
		unsigned int MCC62R         : 1;	/* Capture/Compare Status Modification Bits */
		unsigned int                : 3;
		unsigned int MCC63R         : 1;	/* Capture/Compare Status Modification Bits */
		unsigned int                : 17;
	} B;
	int I;
	unsigned int U;

} CCU60_CMPMODIF_type;
#define CCU60_CMPMODIF	(*( CCU60_CMPMODIF_type *) 0xf0002a64u)	/* Compare State Modification Register */
#define CCU61_CMPMODIF	(*( CCU60_CMPMODIF_type *) 0xf0002b64u)	/* Compare State Modification Register */
#define CCU62_CMPMODIF	(*( CCU60_CMPMODIF_type *) 0xf0002c64u)	/* Compare State Modification Register */
#define CCU63_CMPMODIF	(*( CCU60_CMPMODIF_type *) 0xf0002d64u)	/* Compare State Modification Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CC60ST         : 1;	/* Capture/Compare State Bits */
		/* const */ unsigned int CC61ST         : 1;	/* Capture/Compare State Bits */
		/* const */ unsigned int CC62ST         : 1;	/* Capture/Compare State Bits */
		/* const */ unsigned int CCPOS60        : 1;	/* Sampled Hall Pattern Bits */
		/* const */ unsigned int CCPOS61        : 1;	/* Sampled Hall Pattern Bits */
		/* const */ unsigned int CCPOS62        : 1;	/* Sampled Hall Pattern Bits */
		/* const */ unsigned int CC63ST         : 1;	/* Capture/Compare State Bits */
		unsigned int                : 1;
		unsigned int CC60PS         : 1;	/* Passive State Select for Compare Outputs */
		unsigned int COUT60PS       : 1;	/* Passive State Select for Compare Outputs */
		unsigned int CC61PS         : 1;	/* Passive State Select for Compare Outputs */
		unsigned int COUT61PS       : 1;	/* Passive State Select for Compare Outputs */
		unsigned int CC62PS         : 1;	/* Passive State Select for Compare Outputs */
		unsigned int COUT62PS       : 1;	/* Passive State Select for Compare Outputs */
		unsigned int COUT63PS       : 1;	/* Passive State Select for Compare Outputs */
		unsigned int T13IM          : 1;	/* T13 Inverted Modulation */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_CMPSTAT_type;
#define CCU60_CMPSTAT	(*( CCU60_CMPSTAT_type *) 0xf0002a60u)	/* Compare State Register */
#define CCU61_CMPSTAT	(*( CCU60_CMPSTAT_type *) 0xf0002b60u)	/* Compare State Register */
#define CCU62_CMPSTAT	(*( CCU60_CMPSTAT_type *) 0xf0002c60u)	/* Compare State Register */
#define CCU63_CMPSTAT	(*( CCU60_CMPSTAT_type *) 0xf0002d60u)	/* Compare State Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODNUMBER      : 8;	/* Module Number Value */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_ID_type;
#define CCU60_ID	(*( CCU60_ID_type *) 0xf0002a08u)	/* Module Identification Register */
#define CCU61_ID	(*( CCU60_ID_type *) 0xf0002b08u)	/* Module Identification Register */
#define CCU62_ID	(*( CCU60_ID_type *) 0xf0002c08u)	/* Module Identification Register */
#define CCU63_ID	(*( CCU60_ID_type *) 0xf0002d08u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ENCC60R        : 1;	/* Capture, Compare-Match Rising Edge Interrupt Enable for Channel CC6x */
		unsigned int ENCC60F        : 1;	/* Capture, Compare-Match Falling Edge Interrupt Enable for Channel CC6x */
		unsigned int ENCC61R        : 1;	/* Capture, Compare-Match Rising Edge Interrupt Enable for Channel CC6x */
		unsigned int ENCC61F        : 1;	/* Capture, Compare-Match Falling Edge Interrupt Enable for Channel CC6x */
		unsigned int ENCC62R        : 1;	/* Capture, Compare-Match Rising Edge Interrupt Enable for Channel CC6x */
		unsigned int ENCC62F        : 1;	/* Capture, Compare-Match Falling Edge Interrupt Enable for Channel CC6x */
		unsigned int ENT12OM        : 1;	/* Enable Interrupt for T12 One-Match */
		unsigned int ENT12PM        : 1;	/* Enable Interrupt for T12 Period-Match */
		unsigned int ENT13CM        : 1;	/* Enable Interrupt for T13 Compare-Match */
		unsigned int ENT13PM        : 1;	/* Enable Interrupt for T13 Period-Match */
		unsigned int ENTRPF         : 1;	/* Enable Interrupt for Trap Flag */
		unsigned int                : 1;
		unsigned int ENCHE          : 1;	/* Enable Interrupt for Correct Hall Event */
		unsigned int ENWHE          : 1;	/* Enable Interrupt for Wrong Hall Event */
		unsigned int ENIDLE         : 1;	/* Enable Idle */
		unsigned int ENSTR          : 1;	/* Enable Multi-Channel Mode Shadow Transfer Interrupt */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_IEN_type;
#define CCU60_IEN	(*( CCU60_IEN_type *) 0xf0002ab0u)	/* Interrupt Enable Register */
#define CCU61_IEN	(*( CCU60_IEN_type *) 0xf0002bb0u)	/* Interrupt Enable Register */
#define CCU62_IEN	(*( CCU60_IEN_type *) 0xf0002cb0u)	/* Interrupt Enable Register */
#define CCU63_IEN	(*( CCU60_IEN_type *) 0xf0002db0u)	/* Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LBE            : 1;	/* Lost Bit Event */
		unsigned int CCPOS0I        : 1;	/* Event indication for input signal CCPOSx */
		unsigned int CCPOS1I        : 1;	/* Event indication for input signal CCPOSx */
		unsigned int CCPOS2I        : 1;	/* Event indication for input signal CCPOSx */
		unsigned int CC60INI        : 1;	/* Event indication for input signal CC6xIN */
		unsigned int CC61INI        : 1;	/* Event indication for input signal CC6xIN */
		unsigned int CC62INI        : 1;	/* Event indication for input signal CC6xIN */
		unsigned int CTRAPI         : 1;	/* Event indication for input signal CTRAP */
		unsigned int T12HRI         : 1;	/* Event indication for input signal T12HR */
		unsigned int T13HRI         : 1;	/* Event indication for input signal T13HR */
		unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} CCU60_IMON_type;
#define CCU60_IMON	(*( CCU60_IMON_type *) 0xf0002a98u)	/* Input Monitoring Register */
#define CCU61_IMON	(*( CCU60_IMON_type *) 0xf0002b98u)	/* Input Monitoring Register */
#define CCU62_IMON	(*( CCU60_IMON_type *) 0xf0002c98u)	/* Input Monitoring Register */
#define CCU63_IMON	(*( CCU60_IMON_type *) 0xf0002d98u)	/* Input Monitoring Register */

typedef volatile union
{
	struct
	{ 
		unsigned int INPCC60        : 2;	/* Interrupt Node Pointer for Channel CC6x Interrupts */
		unsigned int INPCC61        : 2;	/* Interrupt Node Pointer for Channel CC6x Interrupts */
		unsigned int INPCC62        : 2;	/* Interrupt Node Pointer for Channel CC6x Interrupts */
		unsigned int INPCHE         : 2;	/* Interrupt Node Pointer for the CHE Interrupt */
		unsigned int INPERR         : 2;	/* Interrupt Node Pointer for Error Interrupts */
		unsigned int INPT12         : 2;	/* Interrupt Node Pointer for Timer12 Interrupts */
		unsigned int INPT13         : 2;	/* Interrupt Node Pointer for Timer13 Interrupt */
		unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} CCU60_INP_type;
#define CCU60_INP	(*( CCU60_INP_type *) 0xf0002aacu)	/* Interrupt Node Pointer Register */
#define CCU61_INP	(*( CCU60_INP_type *) 0xf0002bacu)	/* Interrupt Node Pointer Register */
#define CCU62_INP	(*( CCU60_INP_type *) 0xf0002cacu)	/* Interrupt Node Pointer Register */
#define CCU63_INP	(*( CCU60_INP_type *) 0xf0002dacu)	/* Interrupt Node Pointer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ICC60R         : 1;	/* Capture, Compare-Match Rising Edge Flag */
		/* const */ unsigned int ICC60F         : 1;	/* Capture, Compare-Match Falling Edge Flag */
		/* const */ unsigned int ICC61R         : 1;	/* Capture, Compare-Match Rising Edge Flag */
		/* const */ unsigned int ICC61F         : 1;	/* Capture, Compare-Match Falling Edge Flag */
		/* const */ unsigned int ICC62R         : 1;	/* Capture, Compare-Match Rising Edge Flag */
		/* const */ unsigned int ICC62F         : 1;	/* Capture, Compare-Match Falling Edge Flag */
		/* const */ unsigned int T12OM          : 1;	/* Timer T12 One-Match Flag */
		/* const */ unsigned int T12PM          : 1;	/* Timer T12 Period-Match Flag */
		/* const */ unsigned int T13CM          : 1;	/* Timer T13 Compare-Match Flag */
		/* const */ unsigned int T13PM          : 1;	/* Timer T13 Period-Match Flag */
		/* const */ unsigned int TRPF           : 1;	/* Trap Flag */
		/* const */ unsigned int TRPS           : 1;	/* Trap StateDuring the trap state, the selected outputs are set to the passive state. The logic level driven during the passive state is defined by the corresponding bit in register PSLR. Bits TRPS=1 and TRPF=0 can occur if the trap condition is no longer active but the selected synchronization has not yet taken place. */
		/* const */ unsigned int CHE            : 1;	/* Correct Hall Event */
		/* const */ unsigned int WHE            : 1;	/* Wrong Hall Event */
		/* const */ unsigned int IDLE           : 1;	/* IDLE State */
		/* const */ unsigned int STR            : 1;	/* Multi-Channel Mode Shadow Transfer Request */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_IS_type;
#define CCU60_IS	(*( CCU60_IS_type *) 0xf0002aa0u)	/* Interrupt Status Register */
#define CCU61_IS	(*( CCU60_IS_type *) 0xf0002ba0u)	/* Interrupt Status Register */
#define CCU62_IS	(*( CCU60_IS_type *) 0xf0002ca0u)	/* Interrupt Status Register */
#define CCU63_IS	(*( CCU60_IS_type *) 0xf0002da0u)	/* Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RCC60R         : 1;	/* Reset Capture, Compare-Match Rising Edge Flag */
		unsigned int RCC60F         : 1;	/* Reset Capture, Compare-Match Falling Edge Flag */
		unsigned int RCC61R         : 1;	/* Reset Capture, Compare-Match Rising Edge Flag */
		unsigned int RCC61F         : 1;	/* Reset Capture, Compare-Match Falling Edge Flag */
		unsigned int RCC62R         : 1;	/* Reset Capture, Compare-Match Rising Edge Flag */
		unsigned int RCC62F         : 1;	/* Reset Capture, Compare-Match Falling Edge Flag */
		unsigned int RT12OM         : 1;	/* Reset Timer T12 One-Match Flag */
		unsigned int RT12PM         : 1;	/* Reset Timer T12 Period-Match Flag */
		unsigned int RT13CM         : 1;	/* Reset Timer T13 Compare-Match Flag */
		unsigned int RT13PM         : 1;	/* Reset Timer T13 Period-Match Flag */
		unsigned int RTRPF          : 1;	/* Reset Trap Flag */
		unsigned int                : 1;
		unsigned int RCHE           : 1;	/* Reset Correct Hall Event Flag */
		unsigned int RWHE           : 1;	/* Reset Wrong Hall Event Flag */
		unsigned int RIDLE          : 1;	/* Reset IDLE Flag */
		unsigned int RSTR           : 1;	/* Reset STR Flag */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_ISR_type;
#define CCU60_ISR	(*( CCU60_ISR_type *) 0xf0002aa8u)	/* Interrupt Status Reset Register */
#define CCU61_ISR	(*( CCU60_ISR_type *) 0xf0002ba8u)	/* Interrupt Status Reset Register */
#define CCU62_ISR	(*( CCU60_ISR_type *) 0xf0002ca8u)	/* Interrupt Status Reset Register */
#define CCU63_ISR	(*( CCU60_ISR_type *) 0xf0002da8u)	/* Interrupt Status Reset Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SCC60R         : 1;	/* Set Capture, Compare-Match Rising Edge Flag */
		unsigned int SCC60F         : 1;	/* Set Capture, Compare-Match Falling Edge Flag */
		unsigned int SCC61R         : 1;	/* Set Capture, Compare-Match Rising Edge Flag */
		unsigned int SCC61F         : 1;	/* Set Capture, Compare-Match Falling Edge Flag */
		unsigned int SCC62R         : 1;	/* Set Capture, Compare-Match Rising Edge Flag */
		unsigned int SCC62F         : 1;	/* Set Capture, Compare-Match Falling Edge Flag */
		unsigned int ST12OM         : 1;	/* Set Timer T12 One-Match Flag */
		unsigned int ST12PM         : 1;	/* Set Timer T12 Period-Match Flag */
		unsigned int ST13CM         : 1;	/* Set Timer T13 Compare-Match Flag */
		unsigned int ST13PM         : 1;	/* Set Timer T13 Period-Match Flag */
		unsigned int STRPF          : 1;	/* Set Trap Flag */
		unsigned int SWHC           : 1;	/* Software Hall Compare */
		unsigned int SCHE           : 1;	/* Set Correct Hall Event Flag */
		unsigned int SWHE           : 1;	/* Set Wrong Hall Event Flag */
		unsigned int SIDLE          : 1;	/* Set IDLE Flag */
		unsigned int SSTR           : 1;	/* Set STR Flag */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_ISS_type;
#define CCU60_ISS	(*( CCU60_ISS_type *) 0xf0002aa4u)	/* Interrupt Status Set Register */
#define CCU61_ISS	(*( CCU60_ISS_type *) 0xf0002ba4u)	/* Interrupt Status Set Register */
#define CCU62_ISS	(*( CCU60_ISS_type *) 0xf0002ca4u)	/* Interrupt Status Set Register */
#define CCU63_ISS	(*( CCU60_ISS_type *) 0xf0002da4u)	/* Interrupt Status Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} CCU60_KRST0_type;
#define CCU60_KRST0	(*( CCU60_KRST0_type *) 0xf0002af4u)	/* Kernel Reset Register 0 */
#define CCU61_KRST0	(*( CCU60_KRST0_type *) 0xf0002bf4u)	/* Kernel Reset Register 0 */
#define CCU62_KRST0	(*( CCU60_KRST0_type *) 0xf0002cf4u)	/* Kernel Reset Register 0 */
#define CCU63_KRST0	(*( CCU60_KRST0_type *) 0xf0002df4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CCU60_KRST1_type;
#define CCU60_KRST1	(*( CCU60_KRST1_type *) 0xf0002af0u)	/* Kernel Reset Register 1 */
#define CCU61_KRST1	(*( CCU60_KRST1_type *) 0xf0002bf0u)	/* Kernel Reset Register 1 */
#define CCU62_KRST1	(*( CCU60_KRST1_type *) 0xf0002cf0u)	/* Kernel Reset Register 1 */
#define CCU63_KRST1	(*( CCU60_KRST1_type *) 0xf0002df0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} CCU60_KRSTCLR_type;
#define CCU60_KRSTCLR	(*( CCU60_KRSTCLR_type *) 0xf0002aecu)	/* Kernel Reset Status Clear Register */
#define CCU61_KRSTCLR	(*( CCU60_KRSTCLR_type *) 0xf0002becu)	/* Kernel Reset Status Clear Register */
#define CCU62_KRSTCLR	(*( CCU60_KRSTCLR_type *) 0xf0002cecu)	/* Kernel Reset Status Clear Register */
#define CCU63_KRSTCLR	(*( CCU60_KRSTCLR_type *) 0xf0002decu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SB0            : 1;	/* Sensitivity Block x */
		unsigned int SB1            : 1;	/* Sensitivity Block x */
		unsigned int SB2            : 1;	/* Sensitivity Block x */
		unsigned int SB3            : 1;	/* Sensitivity Block x */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CCU60_KSCSR_type;
#define CCU60_KSCSR	(*( CCU60_KSCSR_type *) 0xf0002a1cu)	/* Kernel State Control Sensitivity Register */
#define CCU61_KSCSR	(*( CCU60_KSCSR_type *) 0xf0002b1cu)	/* Kernel State Control Sensitivity Register */
#define CCU62_KSCSR	(*( CCU60_KSCSR_type *) 0xf0002c1cu)	/* Kernel State Control Sensitivity Register */
#define CCU63_KSCSR	(*( CCU60_KSCSR_type *) 0xf0002d1cu)	/* Kernel State Control Sensitivity Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		unsigned int CCPOS0EN       : 1;	/* Lost Indicator Enable for input signal CCPOSx */
		unsigned int CCPOS1EN       : 1;	/* Lost Indicator Enable for input signal CCPOSx */
		unsigned int CCPOS2EN       : 1;	/* Lost Indicator Enable for input signal CCPOSx */
		unsigned int CC60INEN       : 1;	/* Lost Indicator Enable for input signal CC6xIN */
		unsigned int CC61INEN       : 1;	/* Lost Indicator Enable for input signal CC6xIN */
		unsigned int CC62INEN       : 1;	/* Lost Indicator Enable for input signal CC6xIN */
		unsigned int CTRAPEN        : 1;	/* Lost Indicator Enable for input signal CTRAP */
		unsigned int T12HREN        : 1;	/* Lost Indicator Enable for input signal T12HR */
		unsigned int T13HREN        : 1;	/* Lost Indicator Enable for input signal T13HR */
		unsigned int                : 3;
		unsigned int LBEEN          : 1;	/* Interrupt Enable for Lost Bit Event */
		unsigned int INPLBE         : 2;	/* Interrupt Node Pointer for lost bit event */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_LI_type;
#define CCU60_LI	(*( CCU60_LI_type *) 0xf0002a9cu)	/* Lost Indicator Register */
#define CCU61_LI	(*( CCU60_LI_type *) 0xf0002b9cu)	/* Lost Indicator Register */
#define CCU62_LI	(*( CCU60_LI_type *) 0xf0002c9cu)	/* Lost Indicator Register */
#define CCU63_LI	(*( CCU60_LI_type *) 0xf0002d9cu)	/* Lost Indicator Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T12            : 1;	/* T12 Available */
		unsigned int T13            : 1;	/* T13 Available */
		unsigned int MCM            : 1;	/* Multi-Channel Mode Available */
		unsigned int                : 12;
		unsigned int WREN           : 1;	/* Write Enable */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_MCFG_type;
#define CCU60_MCFG	(*( CCU60_MCFG_type *) 0xf0002a04u)	/* Module Configuration Register */
#define CCU61_MCFG	(*( CCU60_MCFG_type *) 0xf0002b04u)	/* Module Configuration Register */
#define CCU62_MCFG	(*( CCU60_MCFG_type *) 0xf0002c04u)	/* Module Configuration Register */
#define CCU63_MCFG	(*( CCU60_MCFG_type *) 0xf0002d04u)	/* Module Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SWSEL          : 3;	/* Switching Selection */
		unsigned int                : 1;
		unsigned int SWSYN          : 2;	/* Switching Synchronization */
		unsigned int                : 2;
		unsigned int STE12U         : 1;	/* Shadow Transfer Enable for T12 Upcounting */
		unsigned int STE12D         : 1;	/* Shadow Transfer Enable for T12 Downcounting */
		unsigned int STE13U         : 1;	/* Shadow Transfer Enable for T13 Upcounting */
		unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} CCU60_MCMCTR_type;
#define CCU60_MCMCTR	(*( CCU60_MCMCTR_type *) 0xf0002a94u)	/* Multi-Channel Mode Control Register */
#define CCU61_MCMCTR	(*( CCU60_MCMCTR_type *) 0xf0002b94u)	/* Multi-Channel Mode Control Register */
#define CCU62_MCMCTR	(*( CCU60_MCMCTR_type *) 0xf0002c94u)	/* Multi-Channel Mode Control Register */
#define CCU63_MCMCTR	(*( CCU60_MCMCTR_type *) 0xf0002d94u)	/* Multi-Channel Mode Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MCMP           : 6;	/* Multi-Channel PWM Pattern */
		/* const */ unsigned int R              : 1;	/* Reminder Flag */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int EXPH           : 3;	/* Expected Hall Pattern */
		/* const */ unsigned int CURH           : 3;	/* Current Hall Pattern */
		/* const */ unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} CCU60_MCMOUT_type;
#define CCU60_MCMOUT	(*( CCU60_MCMOUT_type *) 0xf0002a90u)	/* Multi-Channel Mode Output Register */
#define CCU61_MCMOUT	(*( CCU60_MCMOUT_type *) 0xf0002b90u)	/* Multi-Channel Mode Output Register */
#define CCU62_MCMOUT	(*( CCU60_MCMOUT_type *) 0xf0002c90u)	/* Multi-Channel Mode Output Register */
#define CCU63_MCMOUT	(*( CCU60_MCMOUT_type *) 0xf0002d90u)	/* Multi-Channel Mode Output Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MCMPS          : 6;	/* Multi-Channel PWM Pattern Shadow */
		unsigned int                : 1;
		unsigned int STRMCM         : 1;	/* Shadow Transfer Request for MCMPS */
		unsigned int EXPHS          : 3;	/* Expected Hall Pattern Shadow */
		unsigned int CURHS          : 3;	/* Current Hall Pattern Shadow */
		unsigned int                : 1;
		unsigned int STRHP          : 1;	/* Shadow Transfer Request for the Hall Pattern */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_MCMOUTS_type;
#define CCU60_MCMOUTS	(*( CCU60_MCMOUTS_type *) 0xf0002a8cu)	/* Multi-Channel Mode Output Shadow Register */
#define CCU61_MCMOUTS	(*( CCU60_MCMOUTS_type *) 0xf0002b8cu)	/* Multi-Channel Mode Output Shadow Register */
#define CCU62_MCMOUTS	(*( CCU60_MCMOUTS_type *) 0xf0002c8cu)	/* Multi-Channel Mode Output Shadow Register */
#define CCU63_MCMOUTS	(*( CCU60_MCMOUTS_type *) 0xf0002d8cu)	/* Multi-Channel Mode Output Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T12MODEN       : 6;	/* T12 Modulation Enable */
		unsigned int                : 1;
		unsigned int MCMEN          : 1;	/* Multi-Channel Mode Enable */
		unsigned int T13MODEN       : 6;	/* T13 Modulation Enable */
		unsigned int                : 1;
		unsigned int ECT13O         : 1;	/* Enable Compare Timer T13 Output */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_MODCTR_type;
#define CCU60_MODCTR	(*( CCU60_MODCTR_type *) 0xf0002a80u)	/* Modulation Control Register */
#define CCU61_MODCTR	(*( CCU60_MODCTR_type *) 0xf0002b80u)	/* Modulation Control Register */
#define CCU62_MODCTR	(*( CCU60_MODCTR_type *) 0xf0002c80u)	/* Modulation Control Register */
#define CCU63_MODCTR	(*( CCU60_MODCTR_type *) 0xf0002d80u)	/* Modulation Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRIG0SEL       : 3;	/* Output Trigger Select for CCU6061 TRIG0 */
		unsigned int TRIG1SEL       : 3;	/* Output Trigger Select for CCU6061 TRIG1 */
		unsigned int TRIG2SEL       : 3;	/* Output Trigger Select for CCU6061 TRIG2 */
		unsigned int                : 23;
	} B;
	int I;
	unsigned int U;

} CCU60_MOSEL_type;
#define CCU60_MOSEL	(*( CCU60_MOSEL_type *) 0xf0002a0cu)	/* CCU60 Module Output Select Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 2;	/* Trigger Set for OTGB0/1 */
		unsigned int TGB            : 1;	/* OTGB0/1 Bus Select */
		unsigned int TG_P           : 1;	/* TGS, TGB Write Protection */
		unsigned int                : 20;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} CCU60_OCS_type;
#define CCU60_OCS	(*( CCU60_OCS_type *) 0xf0002ae8u)	/* OCDS Control and Status Register */
#define CCU61_OCS	(*( CCU60_OCS_type *) 0xf0002be8u)	/* OCDS Control and Status Register */
#define CCU62_OCS	(*( CCU60_OCS_type *) 0xf0002ce8u)	/* OCDS Control and Status Register */
#define CCU63_OCS	(*( CCU60_OCS_type *) 0xf0002de8u)	/* OCDS Control and Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ISCC60         : 2;	/* Input Select for CC60 */
		unsigned int ISCC61         : 2;	/* Input Select for CC61 */
		unsigned int ISCC62         : 2;	/* Input Select for CC62 */
		unsigned int ISTRP          : 2;	/* Input Select for CTRAP */
		unsigned int ISPOS0         : 2;	/* Input Select for CCPOS0 */
		unsigned int ISPOS1         : 2;	/* Input Select for CCPOS1 */
		unsigned int ISPOS2         : 2;	/* Input Select for CCPOS2 */
		unsigned int IST12HR        : 2;	/* Input Select for T12HR */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_PISEL0_type;
#define CCU60_PISEL0	(*( CCU60_PISEL0_type *) 0xf0002a10u)	/* Port Input Select Register 0 */
#define CCU61_PISEL0	(*( CCU60_PISEL0_type *) 0xf0002b10u)	/* Port Input Select Register 0 */
#define CCU62_PISEL0	(*( CCU60_PISEL0_type *) 0xf0002c10u)	/* Port Input Select Register 0 */
#define CCU63_PISEL0	(*( CCU60_PISEL0_type *) 0xf0002d10u)	/* Port Input Select Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int IST13HR        : 2;	/* Input Select for T13HR */
		unsigned int ISCNT12        : 2;	/* Input Select for T12 Counting Input */
		unsigned int ISCNT13        : 2;	/* Input Select for T13 Counting Input */
		unsigned int T12EXT         : 1;	/* Extension for T12HR Inputs */
		unsigned int T13EXT         : 1;	/* Extension for T13HR Inputs */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} CCU60_PISEL2_type;
#define CCU60_PISEL2	(*( CCU60_PISEL2_type *) 0xf0002a14u)	/* Port Input Select Register 2 */
#define CCU61_PISEL2	(*( CCU60_PISEL2_type *) 0xf0002b14u)	/* Port Input Select Register 2 */
#define CCU62_PISEL2	(*( CCU60_PISEL2_type *) 0xf0002c14u)	/* Port Input Select Register 2 */
#define CCU63_PISEL2	(*( CCU60_PISEL2_type *) 0xf0002d14u)	/* Port Input Select Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int PSL            : 6;	/* Compare Outputs Passive State Level */
		unsigned int                : 1;
		unsigned int PSL63          : 1;	/* Passive State Level of Output COUT63 */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} CCU60_PSLR_type;
#define CCU60_PSLR	(*( CCU60_PSLR_type *) 0xf0002a88u)	/* Passive State Level Register */
#define CCU61_PSLR	(*( CCU60_PSLR_type *) 0xf0002b88u)	/* Passive State Level Register */
#define CCU62_PSLR	(*( CCU60_PSLR_type *) 0xf0002c88u)	/* Passive State Level Register */
#define CCU63_PSLR	(*( CCU60_PSLR_type *) 0xf0002d88u)	/* Passive State Level Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T12CV          : 16;	/* Timer 12 Counter Value */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_T12_type;
#define CCU60_T12	(*( CCU60_T12_type *) 0xf0002a20u)	/* Timer T12 Counter Register */
#define CCU61_T12	(*( CCU60_T12_type *) 0xf0002b20u)	/* Timer T12 Counter Register */
#define CCU62_T12	(*( CCU60_T12_type *) 0xf0002c20u)	/* Timer T12 Counter Register */
#define CCU63_T12	(*( CCU60_T12_type *) 0xf0002d20u)	/* Timer T12 Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DTM            : 8;	/* Dead-Time */
		unsigned int DTE0           : 1;	/* Dead Time Enable Bits */
		unsigned int DTE1           : 1;	/* Dead Time Enable Bits */
		unsigned int DTE2           : 1;	/* Dead Time Enable Bits */
		unsigned int                : 1;
		/* const */ unsigned int DTR0           : 1;	/* Dead Time Run Indication Bits */
		/* const */ unsigned int DTR1           : 1;	/* Dead Time Run Indication Bits */
		/* const */ unsigned int DTR2           : 1;	/* Dead Time Run Indication Bits */
		unsigned int                : 17;
	} B;
	int I;
	unsigned int U;

} CCU60_T12DTC_type;
#define CCU60_T12DTC	(*( CCU60_T12DTC_type *) 0xf0002a28u)	/* Dead-Time Control Register for Timer12 */
#define CCU61_T12DTC	(*( CCU60_T12DTC_type *) 0xf0002b28u)	/* Dead-Time Control Register for Timer12 */
#define CCU62_T12DTC	(*( CCU60_T12DTC_type *) 0xf0002c28u)	/* Dead-Time Control Register for Timer12 */
#define CCU63_T12DTC	(*( CCU60_T12DTC_type *) 0xf0002d28u)	/* Dead-Time Control Register for Timer12 */

typedef volatile union
{
	struct
	{ 
		unsigned int MSEL60         : 4;	/* Capture/Compare Mode Selection */
		unsigned int MSEL61         : 4;	/* Capture/Compare Mode Selection */
		unsigned int MSEL62         : 4;	/* Capture/Compare Mode Selection */
		unsigned int HSYNC          : 3;	/* Hall Synchronization */
		unsigned int DBYP           : 1;	/* Delay Bypass */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_T12MSEL_type;
#define CCU60_T12MSEL	(*( CCU60_T12MSEL_type *) 0xf0002a68u)	/* T12 Mode Select Register */
#define CCU61_T12MSEL	(*( CCU60_T12MSEL_type *) 0xf0002b68u)	/* T12 Mode Select Register */
#define CCU62_T12MSEL	(*( CCU60_T12MSEL_type *) 0xf0002c68u)	/* T12 Mode Select Register */
#define CCU63_T12MSEL	(*( CCU60_T12MSEL_type *) 0xf0002d68u)	/* T12 Mode Select Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T12PV          : 16;	/* T12 Period Value */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_T12PR_type;
#define CCU60_T12PR	(*( CCU60_T12PR_type *) 0xf0002a24u)	/* Timer 12 Period Register */
#define CCU61_T12PR	(*( CCU60_T12PR_type *) 0xf0002b24u)	/* Timer 12 Period Register */
#define CCU62_T12PR	(*( CCU60_T12PR_type *) 0xf0002c24u)	/* Timer 12 Period Register */
#define CCU63_T12PR	(*( CCU60_T12PR_type *) 0xf0002d24u)	/* Timer 12 Period Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T13CV          : 16;	/* Timer 13 Counter Value */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_T13_type;
#define CCU60_T13	(*( CCU60_T13_type *) 0xf0002a50u)	/* Timer T13 Counter Register */
#define CCU61_T13	(*( CCU60_T13_type *) 0xf0002b50u)	/* Timer T13 Counter Register */
#define CCU62_T13	(*( CCU60_T13_type *) 0xf0002c50u)	/* Timer T13 Counter Register */
#define CCU63_T13	(*( CCU60_T13_type *) 0xf0002d50u)	/* Timer T13 Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T13PV          : 16;	/* T13 Period Value */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_T13PR_type;
#define CCU60_T13PR	(*( CCU60_T13PR_type *) 0xf0002a54u)	/* Timer 13 Period Register */
#define CCU61_T13PR	(*( CCU60_T13PR_type *) 0xf0002b54u)	/* Timer 13 Period Register */
#define CCU62_T13PR	(*( CCU60_T13PR_type *) 0xf0002c54u)	/* Timer 13 Period Register */
#define CCU63_T13PR	(*( CCU60_T13PR_type *) 0xf0002d54u)	/* Timer 13 Period Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T12CLK         : 3;	/* Timer T12 Input Clock Select */
		unsigned int T12PRE         : 1;	/* Timer T12 Prescaler Bit */
		/* const */ unsigned int T12R           : 1;	/* Timer T12 Run BitA concurrent set/clear action on T12R (from T12SSC, T12RR or T12RS) will have no effect. The bit T12R will remain unchanged. */
		/* const */ unsigned int STE12          : 1;	/* Timer T12 Shadow Transfer Enable */
		/* const */ unsigned int CDIR           : 1;	/* Count Direction of Timer T12 */
		unsigned int CTM            : 1;	/* T12 Operating Mode */
		unsigned int T13CLK         : 3;	/* Timer T13 Input Clock Select */
		unsigned int T13PRE         : 1;	/* Timer T13 Prescaler Bit */
		/* const */ unsigned int T13R           : 1;	/* Timer T13 Run BitA concurrent set/cleared action on T13R (from T13SSC, T13TEC, T13RR or T13RS) will have no effect. The bit T12R will remain unchanged. */
		/* const */ unsigned int STE13          : 1;	/* Timer T13 Shadow Transfer Enable */
		unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} CCU60_TCTR0_type;
#define CCU60_TCTR0	(*( CCU60_TCTR0_type *) 0xf0002a70u)	/* Timer Control Register 0 */
#define CCU61_TCTR0	(*( CCU60_TCTR0_type *) 0xf0002b70u)	/* Timer Control Register 0 */
#define CCU62_TCTR0	(*( CCU60_TCTR0_type *) 0xf0002c70u)	/* Timer Control Register 0 */
#define CCU63_TCTR0	(*( CCU60_TCTR0_type *) 0xf0002d70u)	/* Timer Control Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int T12SSC         : 1;	/* Timer T12 Single Shot Control */
		unsigned int T13SSC         : 1;	/* Timer T13 Single Shot Control */
		unsigned int T13TEC         : 3;	/* T13 Trigger Event Control */
		unsigned int T13TED         : 2;	/* Timer T13 Trigger Event DirectionExample: If the timer T13 is intended to start at any compare event on T12 (T13TEC=100) the trigger event direction can be programmed to - counting up 'gt''gt' a T12 channel 0, 1, 2 compare match triggers T13R only while T12 is counting up - counting down 'gt''gt' a T12 channel 0, 1, 2 compare match triggers T13R only while T12 is counting down - independent from bit CDIR 'gt''gt' each T12 channel 0, 1, 2 compare match triggers T13R The timer count direction is taken from the value of bit CDIR. As a result, if T12 is running in edge-aligned mode (counting up only), T13 can only be started automatically if bit field T13TED=01 or 11. */
		unsigned int                : 1;
		unsigned int T12RSEL        : 2;	/* Timer T12 External Run Selection */
		unsigned int T13RSEL        : 2;	/* Timer T13 External Run Selection */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CCU60_TCTR2_type;
#define CCU60_TCTR2	(*( CCU60_TCTR2_type *) 0xf0002a74u)	/* Timer Control Register 2 */
#define CCU61_TCTR2	(*( CCU60_TCTR2_type *) 0xf0002b74u)	/* Timer Control Register 2 */
#define CCU62_TCTR2	(*( CCU60_TCTR2_type *) 0xf0002c74u)	/* Timer Control Register 2 */
#define CCU63_TCTR2	(*( CCU60_TCTR2_type *) 0xf0002d74u)	/* Timer Control Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int T12RR          : 1;	/* Timer T12 Run Reset */
		unsigned int T12RS          : 1;	/* Timer T12 Run Set */
		unsigned int T12RES         : 1;	/* Timer T12 Reset */
		unsigned int DTRES          : 1;	/* Dead-Time Counter Reset */
		unsigned int                : 1;
		unsigned int T12CNT         : 1;	/* Timer T12 Count Event */
		unsigned int T12STR         : 1;	/* Timer T12 Shadow Transfer Request */
		unsigned int T12STD         : 1;	/* Timer T12 Shadow Transfer Disable */
		unsigned int T13RR          : 1;	/* Timer T13 Run Reset */
		unsigned int T13RS          : 1;	/* Timer T13 Run Set */
		unsigned int T13RES         : 1;	/* Timer T13 Reset */
		unsigned int                : 2;
		unsigned int T13CNT         : 1;	/* Timer T13 Count Event */
		unsigned int T13STR         : 1;	/* Timer T13 Shadow Transfer Request */
		unsigned int T13STD         : 1;	/* Timer T13 Shadow Transfer Disable */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_TCTR4_type;
#define CCU60_TCTR4	(*( CCU60_TCTR4_type *) 0xf0002a78u)	/* Timer Control Register 4 */
#define CCU61_TCTR4	(*( CCU60_TCTR4_type *) 0xf0002b78u)	/* Timer Control Register 4 */
#define CCU62_TCTR4	(*( CCU60_TCTR4_type *) 0xf0002c78u)	/* Timer Control Register 4 */
#define CCU63_TCTR4	(*( CCU60_TCTR4_type *) 0xf0002d78u)	/* Timer Control Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int TRPM0          : 1;	/* Trap Mode Control Bits 1, 0 */
		unsigned int TRPM1          : 1;	/* Trap Mode Control Bits 1, 0 */
		unsigned int TRPM2          : 1;	/* Trap Mode Control Bit 2 */
		unsigned int                : 5;
		unsigned int TRPEN          : 6;	/* Trap Enable Control */
		unsigned int TRPEN13        : 1;	/* Trap Enable Control for Timer T13 */
		unsigned int TRPPEN         : 1;	/* Trap Pin Enable */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CCU60_TRPCTR_type;
#define CCU60_TRPCTR	(*( CCU60_TRPCTR_type *) 0xf0002a84u)	/* Trap Control Register */
#define CCU61_TRPCTR	(*( CCU60_TRPCTR_type *) 0xf0002b84u)	/* Trap Control Register */
#define CCU62_TRPCTR	(*( CCU60_TRPCTR_type *) 0xf0002c84u)	/* Trap Control Register */
#define CCU63_TRPCTR	(*( CCU60_TRPCTR_type *) 0xf0002d84u)	/* Trap Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CCU61_ACCEN1_type;
#define CCU61_ACCEN1	(*( CCU61_ACCEN1_type *) 0xf0002bf8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CCU62_ACCEN1_type;
#define CCU62_ACCEN1	(*( CCU62_ACCEN1_type *) 0xf0002cf8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int TRIG0SEL       : 3;	/* Output Trigger Select for CCU6263 TRIG0 */
		unsigned int TRIG1SEL       : 3;	/* Output Trigger Select for CCU6263 TRIG1 */
		unsigned int TRIG2SEL       : 3;	/* Output Trigger Select for CCU6263 TRIG2 */
		unsigned int                : 23;
	} B;
	int I;
	unsigned int U;

} CCU62_MOSEL_type;
#define CCU62_MOSEL	(*( CCU62_MOSEL_type *) 0xf0002c0cu)	/* CCU62 Module Output Select Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CCU63_ACCEN1_type;
#define CCU63_ACCEN1	(*( CCU63_ACCEN1_type *) 0xf0002df8u)	/* Access Enable Register 1 */


/* EMEM */
typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Disable Status Bit */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} EMEM_CLC_type;
#define EMEM_CLC	(*( EMEM_CLC_type *) 0xf00e6000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} EMEM_ID_type;
#define EMEM_ID	(*( EMEM_ID_type *) 0xf00e6008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int STBLOCK        : 1;	/* Standby Lock Flag */
		unsigned int STBULK         : 3;	/* Unlock Standby Lock Flag */
		unsigned int STBSLK         : 4;	/* Set Standby Lock Flag */
		unsigned int                : 4;
		unsigned int ACGEN          : 1;	/* Automatic Clock Gating Enabling */
		unsigned int                : 3;
		/* const */ unsigned int ACGST0         : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST1         : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST2         : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST3         : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST4         : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST5         : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST6         : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST7         : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST8         : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST9         : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST10        : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST11        : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST12        : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST13        : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST14        : 1;	/* Automatic Clock Gating Status of Tile x */
		/* const */ unsigned int ACGST15        : 1;	/* Automatic Clock Gating Status of Tile x */
	} B;
	int I;
	unsigned int U;

} EMEM_SBRCTR_type;
#define EMEM_SBRCTR	(*( EMEM_SBRCTR_type *) 0xf00e6034u)	/* Standby RAM Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T0             : 1;	/* Calibration Tile x Control Bit */
		unsigned int T1             : 1;	/* Calibration Tile x Control Bit */
		unsigned int T2             : 1;	/* Calibration Tile x Control Bit */
		unsigned int T3             : 1;	/* Calibration Tile x Control Bit */
		unsigned int T4             : 1;	/* Calibration Tile x Control Bit */
		unsigned int T5             : 1;	/* Calibration Tile x Control Bit */
		unsigned int T6             : 1;	/* Calibration Tile x Control Bit */
		unsigned int T7             : 1;	/* Calibration Tile x Control Bit */
		unsigned int T8             : 1;	/* Calibration Tile x Control Bit */
		unsigned int T9             : 1;	/* Calibration Tile x Control Bit */
		unsigned int T10            : 1;	/* Calibration Tile x Control Bit */
		unsigned int T11            : 1;	/* Calibration Tile x Control Bit */
		unsigned int T12            : 1;	/* Calibration Tile x Control Bit */
		unsigned int T13            : 1;	/* Calibration Tile x Control Bit */
		unsigned int T14            : 1;	/* Calibration Tile x Control Bit */
		unsigned int T15            : 1;	/* Calibration Tile x Control Bit */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} EMEM_TILECC_type;
#define EMEM_TILECC	(*( EMEM_TILECC_type *) 0xf00e6024u)	/* Calibration Tile Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T0             : 2;	/* Tile x Allocation */
		unsigned int T1             : 2;	/* Tile x Allocation */
		unsigned int T2             : 2;	/* Tile x Allocation */
		unsigned int T3             : 2;	/* Tile x Allocation */
		unsigned int T4             : 2;	/* Tile x Allocation */
		unsigned int T5             : 2;	/* Tile x Allocation */
		unsigned int T6             : 2;	/* Tile x Allocation */
		unsigned int T7             : 2;	/* Tile x Allocation */
		unsigned int T8             : 2;	/* Tile x Allocation */
		unsigned int T9             : 2;	/* Tile x Allocation */
		unsigned int T10            : 2;	/* Tile x Allocation */
		unsigned int T11            : 2;	/* Tile x Allocation */
		unsigned int T12            : 2;	/* Tile x Allocation */
		unsigned int T13            : 2;	/* Tile x Allocation */
		unsigned int T14            : 2;	/* Tile x Allocation */
		unsigned int T15            : 2;	/* Tile x Allocation */
	} B;
	int I;
	unsigned int U;

} EMEM_TILECONFIG_type;
#define EMEM_TILECONFIG	(*( EMEM_TILECONFIG_type *) 0xf00e6020u)	/* Tile Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int T0             : 1;	/* Trace Tile x Control Bit */
		unsigned int T1             : 1;	/* Trace Tile x Control Bit */
		unsigned int T2             : 1;	/* Trace Tile x Control Bit */
		unsigned int T3             : 1;	/* Trace Tile x Control Bit */
		unsigned int T4             : 1;	/* Trace Tile x Control Bit */
		unsigned int T5             : 1;	/* Trace Tile x Control Bit */
		unsigned int T6             : 1;	/* Trace Tile x Control Bit */
		unsigned int T7             : 1;	/* Trace Tile x Control Bit */
		unsigned int T8             : 1;	/* Trace Tile x Control Bit */
		unsigned int T9             : 1;	/* Trace Tile x Control Bit */
		unsigned int T10            : 1;	/* Trace Tile x Control Bit */
		unsigned int T11            : 1;	/* Trace Tile x Control Bit */
		unsigned int T12            : 1;	/* Trace Tile x Control Bit */
		unsigned int T13            : 1;	/* Trace Tile x Control Bit */
		unsigned int T14            : 1;	/* Trace Tile x Control Bit */
		unsigned int T15            : 1;	/* Trace Tile x Control Bit */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} EMEM_TILECT_type;
#define EMEM_TILECT	(*( EMEM_TILECT_type *) 0xf00e6028u)	/* Trace Tile Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TILE0          : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE1          : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE2          : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE3          : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE4          : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE5          : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE6          : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE7          : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE8          : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE9          : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE10         : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE11         : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE12         : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE13         : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE14         : 2;	/* Usage of Tile x */
		/* const */ unsigned int TILE15         : 2;	/* Usage of Tile x */
	} B;
	int I;
	unsigned int U;

} EMEM_TILESTATE_type;
#define EMEM_TILESTATE	(*( EMEM_TILESTATE_type *) 0xf00e602cu)	/* Tile Status Register */


/* EBCU */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID x */
	} B;
	int I;
	unsigned int U;

} EBCU_ACCEN0_type;
#define EBCU_ACCEN0	(*( EBCU_ACCEN0_type *) 0xf00e01fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int EN32           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN33           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN34           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN35           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN36           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN37           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN38           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN39           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN40           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN41           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN42           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN43           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN44           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN45           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN46           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN47           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN48           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN49           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN50           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN51           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN52           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN53           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN54           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN55           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN56           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN57           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN58           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN59           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN60           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN61           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN62           : 1;	/* Access Enable for Master TAG ID x */
		/* const */ unsigned int EN63           : 1;	/* Access Enable for Master TAG ID x */
	} B;
	int I;
	unsigned int U;

} EBCU_ACCEN1_type;
#define EBCU_ACCEN1	(*( EBCU_ACCEN1_type *) 0xf00e01f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int TOUT           : 16;	/* Bus Time-Out Value */
		unsigned int DBG            : 1;	/* Debug Trace Enable */
		unsigned int                : 7;
		unsigned int SPC            : 8;	/* Starvation Period Control */
	} B;
	int I;
	unsigned int U;

} EBCU_CON_type;
#define EBCU_CON	(*( EBCU_CON_type *) 0xf00e0110u)	/* EBCU Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADR1           : 32;	/* Debug Trigger Address 1 */
	} B;
	int I;
	unsigned int U;

} EBCU_DBADR1_type;
#define EBCU_DBADR1	(*( EBCU_DBADR1_type *) 0xf00e0138u)	/* Debug Address 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADR2           : 32;	/* Debug Trigger Address 2 */
	} B;
	int I;
	unsigned int U;

} EBCU_DBADR2_type;
#define EBCU_DBADR2	(*( EBCU_DBADR2_type *) 0xf00e013cu)	/* Debug Address 2 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int FPIADR         : 32;	/* FPIBus Address Status */
	} B;
	int I;
	unsigned int U;

} EBCU_DBADRT_type;
#define EBCU_DBADRT	(*( EBCU_DBADRT_type *) 0xf00e0148u)	/* Debug Trapped Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int OPC            : 4;	/* Opcode for Signal Status Debug Trigger */
		unsigned int SVM            : 1;	/* SVM Signal for Status Debug Trigger */
		unsigned int                : 3;
		unsigned int WR             : 1;	/* Write Signal for Status Debug Trigger */
		unsigned int                : 3;
		unsigned int RD             : 1;	/* Write Signal for Status Debug Trigger */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} EBCU_DBBOS_type;
#define EBCU_DBBOS	(*( EBCU_DBBOS_type *) 0xf00e0140u)	/* Debug Bus Operation Signals Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int FPIOPC         : 4;	/* FPIBus Opcode Status */
		/* const */ unsigned int FPISVM         : 1;	/* FPIBus Supervisor Mode Status */
		/* const */ unsigned int FPIACK         : 2;	/* FPIBus Acknowledge Status */
		/* const */ unsigned int FPIRDY         : 1;	/* FPIBus Ready Status */
		/* const */ unsigned int FPIWR          : 1;	/* FPIBus Write Indication Status */
		/* const */ unsigned int FPIRST         : 2;	/* FPIBus Reset Status */
		/* const */ unsigned int FPIOPS         : 1;	/* FPIBus OCDS Suspend Status */
		/* const */ unsigned int FPIRD          : 1;	/* FPIBus Read Indication Status */
		/* const */ unsigned int FPIABORT       : 1;	/* FPIBus Abort Status */
		/* const */ unsigned int FPITOUT        : 1;	/* FPIBus Time-out Status */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int FPITAG         : 6;	/* FPIBus Master TAG Status */
		/* const */ unsigned int                : 10;
	} B;
	int I;
	unsigned int U;

} EBCU_DBBOST_type;
#define EBCU_DBBOST	(*( EBCU_DBBOST_type *) 0xf00e014cu)	/* Debug Trapped Bus Operation Signals Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int EO             : 1;	/* Status of Debug Support Enable */
		/* const */ unsigned int OA             : 1;	/* Status of Breakpoint Logic */
		unsigned int                : 2;
		unsigned int RA             : 1;	/* Rearm Breakpoint Logic */
		unsigned int                : 7;
		unsigned int CONCOM0        : 1;	/* Grant and Address Trigger Relation */
		unsigned int CONCOM1        : 1;	/* Address 1 and Address 2 Trigger Relation */
		unsigned int CONCOM2        : 1;	/* Address and Signal Trigger Relation */
		unsigned int                : 1;
		unsigned int ONG            : 1;	/* Grant Trigger Enable */
		unsigned int                : 3;
		unsigned int ONA1           : 2;	/* Address 1 Trigger Control */
		unsigned int                : 2;
		unsigned int ONA2           : 2;	/* Address 2 Trigger Control */
		unsigned int                : 2;
		unsigned int ONBOS0         : 1;	/* Opcode Signal Status Trigger Condition */
		unsigned int ONBOS1         : 1;	/* Supervisor Mode Signal Trigger Condition */
		unsigned int ONBOS2         : 1;	/* Write Signal Trigger Condition */
		unsigned int ONBOS3         : 1;	/* Read Signal Trigger Condition */
	} B;
	int I;
	unsigned int U;

} EBCU_DBCNTL_type;
#define EBCU_DBCNTL	(*( EBCU_DBCNTL_type *) 0xf00e0130u)	/* Debug Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int FPIDATA        : 32;	/* FPIBus Data Status */
	} B;
	int I;
	unsigned int U;

} EBCU_DBDAT_type;
#define EBCU_DBDAT	(*( EBCU_DBDAT_type *) 0xf00e0150u)	/* Debug Data Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FPIGNT0        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT1        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT2        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT3        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT4        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT5        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT6        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT7        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT8        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT9        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT10       : 1;	/* Master x Grant Status */
		unsigned int FPIGNT11       : 1;	/* Master x Grant Status */
		unsigned int FPIGNT12       : 1;	/* Master x Grant Status */
		unsigned int FPIGNT13       : 1;	/* Master x Grant Status */
		unsigned int FPIGNT14       : 1;	/* Master x Grant Status */
		unsigned int FPIGNT15       : 1;	/* Master x Grant Status */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} EBCU_DBGNTT_type;
#define EBCU_DBGNTT	(*( EBCU_DBGNTT_type *) 0xf00e0144u)	/* Debug Trapped Master Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FPIGNT0        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT1        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT2        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT3        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT4        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT5        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT6        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT7        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT8        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT9        : 1;	/* Master x Grant Status */
		unsigned int FPIGNT10       : 1;	/* Master x Grant Status */
		unsigned int FPIGNT11       : 1;	/* Master x Grant Status */
		unsigned int FPIGNT12       : 1;	/* Master x Grant Status */
		unsigned int FPIGNT13       : 1;	/* Master x Grant Status */
		unsigned int FPIGNT14       : 1;	/* Master x Grant Status */
		unsigned int FPIGNT15       : 1;	/* Master x Grant Status */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} EBCU_DBGRNT_type;
#define EBCU_DBGRNT	(*( EBCU_DBGRNT_type *) 0xf00e0134u)	/* Debug Grant Mask Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FPIADR         : 32;	/* Captured FPIBus Address */
	} B;
	int I;
	unsigned int U;

} EBCU_EADD_type;
#define EBCU_EADD	(*( EBCU_EADD_type *) 0xf00e0124u)	/* Error Address Capture Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ERRCNT         : 14;	/* FPIBus Error Counter */
		unsigned int TOUT           : 1;	/* State of FPIBus Time-Out Signal */
		unsigned int RDY            : 1;	/* State of FPIBus Ready Signal */
		unsigned int ABT            : 1;	/* State of FPI Bus Abort Signal */
		unsigned int ACK            : 2;	/* State of FPIBus Acknowledge Signals */
		unsigned int SVM            : 1;	/* State of FPIBus Supervisor Mode Signal */
		unsigned int WRN            : 1;	/* State of FPIBus Write Signal */
		unsigned int RDN            : 1;	/* State of FPIBus Read Signal */
		unsigned int TAG            : 6;	/* FPIBus Master Tag Number Signals */
		unsigned int OPC            : 4;	/* FPIBus Operation Code Signals */
	} B;
	int I;
	unsigned int U;

} EBCU_ECON_type;
#define EBCU_ECON	(*( EBCU_ECON_type *) 0xf00e0120u)	/* Error Control Capture Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FPIDAT         : 32;	/* Captured FPIBus Address */
	} B;
	int I;
	unsigned int U;

} EBCU_EDAT_type;
#define EBCU_EDAT	(*( EBCU_EDAT_type *) 0xf00e0128u)	/* Error Data Capture Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODNUMBER      : 8;	/* Module Number Value */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} EBCU_ID_type;
#define EBCU_ID	(*( EBCU_ID_type *) 0xf00e0108u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MASTER8        : 4;	/* Master x Priority */
		unsigned int MASTER9        : 4;	/* Master x Priority */
		unsigned int MASTER10       : 4;	/* Master x Priority */
		unsigned int MASTER11       : 4;	/* Master x Priority */
		unsigned int MASTER12       : 4;	/* Master x Priority */
		unsigned int MASTER13       : 4;	/* Master x Priority */
		unsigned int MASTER14       : 4;	/* Master x Priority */
		unsigned int MASTER15       : 4;	/* Master x Priority */
	} B;
	int I;
	unsigned int U;

} EBCU_PRIOH_type;
#define EBCU_PRIOH	(*( EBCU_PRIOH_type *) 0xf00e0114u)	/* Arbiter Priority Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MASTER0        : 4;	/* Master x Priority */
		unsigned int MASTER1        : 4;	/* Master x Priority */
		unsigned int MASTER2        : 4;	/* Master x Priority */
		unsigned int MASTER3        : 4;	/* Master x Priority */
		unsigned int MASTER4        : 4;	/* Master x Priority */
		unsigned int MASTER5        : 4;	/* Master x Priority */
		unsigned int MASTER6        : 4;	/* Master x Priority */
		unsigned int MASTER7        : 4;	/* Master x Priority */
	} B;
	int I;
	unsigned int U;

} EBCU_PRIOL_type;
#define EBCU_PRIOL	(*( EBCU_PRIOL_type *) 0xf00e0118u)	/* Arbiter Priority Register */


/* MCDS */
typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Disable Status Bit */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} MCDS_CLC_type;
#define MCDS_CLC	(*( MCDS_CLC_type *) 0xf00e8000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		/* const */ unsigned int KOK            : 1;	/* Key OK Flag */
		unsigned int CLRK           : 1;	/* Clear Key OK Flag */
		/* const */ unsigned int KAV            : 1;	/* Key Available Flag */
		unsigned int                : 5;
		/* const */ unsigned int EN             : 1;	/* MCDS Enable Flag */
		unsigned int CLRE           : 1;	/* Clear MCDS Enable Flag */
		unsigned int SETE           : 1;	/* Set MCDS Enable Flag */
		unsigned int BED            : 1;	/* Bus Error Disable Flag */
		unsigned int                : 2;
		unsigned int BED_P          : 1;	/* Bus Error Disable Protection */
		unsigned int                : 1;
		/* const */ unsigned int IRA            : 1;	/* Invalid Read Access Flag */
		unsigned int CLRI           : 1;	/* Clear Invalid Access Bits */
		/* const */ unsigned int IWA            : 1;	/* Invalid Write Access Flag */
		unsigned int                : 5;
		/* const */ unsigned int RES            : 1;	/* MCDS Reset Flag */
		unsigned int                : 1;
		unsigned int SETR           : 1;	/* MCDS Reset Request Bit */
	} B;
	int I;
	unsigned int U;

} MCDS_CT_type;
#define MCDS_CT	(*( MCDS_CT_type *) 0xf00e8010u)	/* MCDS Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 12;
		unsigned int BOTTOM         : 8;	/* Trace Buffer lower Bound */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} MCDS_FIFOBOT_type;
#define MCDS_FIFOBOT	(*( MCDS_FIFOBOT_type *) 0xf00e8204u)	/* Trace Buffer Bottom Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TRG            : 1;	/* Trigger Received Flag */
		/* const */ unsigned int FFE            : 1;	/* FIFO Feeder Empty */
		/* const */ unsigned int TME            : 1;	/* Trace Buffer Access Error */
		unsigned int                : 6;
		/* const */ unsigned int TRDIS          : 1;	/* Trigger Disable Flag */
		unsigned int TRON           : 1;	/* Clear Trigger Disable Flag */
		unsigned int TROFF          : 1;	/* Set Trigger Disable Flag */
		unsigned int                : 1;
		/* const */ unsigned int FLSH           : 1;	/* Flush Flag */
		unsigned int CLR            : 1;	/* Clear Flush Flag */
		unsigned int SET            : 1;	/* Set Flush Flag */
		unsigned int NTN            : 1;	/* Next Tile Now request */
		unsigned int                : 7;
		unsigned int CTTO           : 7;	/* Continuos Trace Time Out */
		unsigned int CTTO_P         : 1;	/* CTTO write protection */
	} B;
	int I;
	unsigned int U;

} MCDS_FIFOCTL_type;
#define MCDS_FIFOCTL	(*( MCDS_FIFOCTL_type *) 0xf00e8210u)	/* Trace Buffer Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 5;
		/* const */ unsigned int NOW            : 15;	/* Trace Buffer Current Write Pointer */
		/* const */ unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} MCDS_FIFONOW_type;
#define MCDS_FIFONOW	(*( MCDS_FIFONOW_type *) 0xf00e8200u)	/* Trace Buffer Write Pointer */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		unsigned int PRE            : 15;	/* Trace Buffer Pre-Trigger Area Size */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} MCDS_FIFOPRE_type;
#define MCDS_FIFOPRE	(*( MCDS_FIFOPRE_type *) 0xf00e8208u)	/* Trace Buffer PRE/POST Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		unsigned int TOP            : 15;	/* Trace Buffer upper Bound */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} MCDS_FIFOTOP_type;
#define MCDS_FIFOTOP	(*( MCDS_FIFOTOP_type *) 0xf00e820cu)	/* Trace Buffer Top Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		unsigned int WARN           : 15;	/* Trace Buffer Warn Level */
		unsigned int                : 10;
		unsigned int OCDEN          : 1;	/* Enable Trigger Output */
		unsigned int EN             : 1;	/* Enable Trigger Generation */
	} B;
	int I;
	unsigned int U;

} MCDS_FIFOWARN0_type;
#define MCDS_FIFOWARN0	(*( MCDS_FIFOWARN0_type *) 0xf00e8214u)	/* Trace Buffer Comparator Register */
#define MCDS_FIFOWARN1	(*( MCDS_FIFOWARN0_type *) 0xf00e8218u)	/* Trace Buffer Comparator Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} MCDS_ID_type;
#define MCDS_ID	(*( MCDS_ID_type *) 0xf00e8008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int AIS0           : 5;	/* Action Input Selector */
		unsigned int AIQ0           : 2;	/* Action Input Qualifier */
		unsigned int LV0            : 1;	/* Action Input Level Mode */
		unsigned int AIS1           : 5;	/* Action Input Selector */
		unsigned int AIQ1           : 2;	/* Action Input Qualifier */
		unsigned int LV1            : 1;	/* Action Input Level Mode */
		unsigned int AIS2           : 5;	/* Action Input Selector */
		unsigned int AIQ2           : 2;	/* Action Input Qualifier */
		unsigned int LV2            : 1;	/* Action Input Level Mode */
		unsigned int AIS3           : 5;	/* Action Input Selector */
		unsigned int AIQ3           : 2;	/* Action Input Qualifier */
		unsigned int LV3            : 1;	/* Action Input Level Mode */
	} B;
	int I;
	unsigned int U;

} MCDS_MCXACT0_type;
#define MCDS_MCXACT0	(*( MCDS_MCXACT0_type *) 0xf00e8880u)	/* Action Definition Register 0 */
#define MCDS_MCXACT1	(*( MCDS_MCXACT0_type *) 0xf00e8884u)	/* Action Definition Register 1 */
#define MCDS_MCXACT10	(*( MCDS_MCXACT0_type *) 0xf00e88a8u)	/* Action Definition Register 10 */
#define MCDS_MCXACT11	(*( MCDS_MCXACT0_type *) 0xf00e88acu)	/* Action Definition Register 11 */
#define MCDS_MCXACT12	(*( MCDS_MCXACT0_type *) 0xf00e88b0u)	/* Action Definition Register 12 */
#define MCDS_MCXACT13	(*( MCDS_MCXACT0_type *) 0xf00e88b4u)	/* Action Definition Register 13 */
#define MCDS_MCXACT14	(*( MCDS_MCXACT0_type *) 0xf00e88b8u)	/* Action Definition Register 14 */
#define MCDS_MCXACT15	(*( MCDS_MCXACT0_type *) 0xf00e88bcu)	/* Action Definition Register 15 */
#define MCDS_MCXACT16	(*( MCDS_MCXACT0_type *) 0xf00e88c0u)	/* Action Definition Register 16 */
#define MCDS_MCXACT17	(*( MCDS_MCXACT0_type *) 0xf00e88c4u)	/* Action Definition Register 17 */
#define MCDS_MCXACT18	(*( MCDS_MCXACT0_type *) 0xf00e88c8u)	/* Action Definition Register 18 */
#define MCDS_MCXACT19	(*( MCDS_MCXACT0_type *) 0xf00e88ccu)	/* Action Definition Register 19 */
#define MCDS_MCXACT2	(*( MCDS_MCXACT0_type *) 0xf00e8888u)	/* Action Definition Register 2 */
#define MCDS_MCXACT20	(*( MCDS_MCXACT0_type *) 0xf00e88d0u)	/* Action Definition Register 20 */
#define MCDS_MCXACT21	(*( MCDS_MCXACT0_type *) 0xf00e88d4u)	/* Action Definition Register 21 */
#define MCDS_MCXACT22	(*( MCDS_MCXACT0_type *) 0xf00e88d8u)	/* Action Definition Register 22 */
#define MCDS_MCXACT23	(*( MCDS_MCXACT0_type *) 0xf00e88dcu)	/* Action Definition Register 23 */
#define MCDS_MCXACT24	(*( MCDS_MCXACT0_type *) 0xf00e88e0u)	/* Action Definition Register 24 */
#define MCDS_MCXACT25	(*( MCDS_MCXACT0_type *) 0xf00e88e4u)	/* Action Definition Register 25 */
#define MCDS_MCXACT26	(*( MCDS_MCXACT0_type *) 0xf00e88e8u)	/* Action Definition Register 26 */
#define MCDS_MCXACT27	(*( MCDS_MCXACT0_type *) 0xf00e88ecu)	/* Action Definition Register 27 */
#define MCDS_MCXACT28	(*( MCDS_MCXACT0_type *) 0xf00e88f0u)	/* Action Definition Register 28 */
#define MCDS_MCXACT29	(*( MCDS_MCXACT0_type *) 0xf00e88f4u)	/* Action Definition Register 29 */
#define MCDS_MCXACT3	(*( MCDS_MCXACT0_type *) 0xf00e888cu)	/* Action Definition Register 3 */
#define MCDS_MCXACT30	(*( MCDS_MCXACT0_type *) 0xf00e88f8u)	/* Action Definition Register 30 */
#define MCDS_MCXACT31	(*( MCDS_MCXACT0_type *) 0xf00e88fcu)	/* Action Definition Register 31 */
#define MCDS_MCXACT32	(*( MCDS_MCXACT0_type *) 0xf00e8900u)	/* Action Definition Register 32 */
#define MCDS_MCXACT33	(*( MCDS_MCXACT0_type *) 0xf00e8904u)	/* Action Definition Register 33 */
#define MCDS_MCXACT34	(*( MCDS_MCXACT0_type *) 0xf00e8908u)	/* Action Definition Register 34 */
#define MCDS_MCXACT35	(*( MCDS_MCXACT0_type *) 0xf00e890cu)	/* Action Definition Register 35 */
#define MCDS_MCXACT36	(*( MCDS_MCXACT0_type *) 0xf00e8910u)	/* Action Definition Register 36 */
#define MCDS_MCXACT37	(*( MCDS_MCXACT0_type *) 0xf00e8914u)	/* Action Definition Register 37 */
#define MCDS_MCXACT38	(*( MCDS_MCXACT0_type *) 0xf00e8918u)	/* Action Definition Register 38 */
#define MCDS_MCXACT39	(*( MCDS_MCXACT0_type *) 0xf00e891cu)	/* Action Definition Register 39 */
#define MCDS_MCXACT4	(*( MCDS_MCXACT0_type *) 0xf00e8890u)	/* Action Definition Register 4 */
#define MCDS_MCXACT40	(*( MCDS_MCXACT0_type *) 0xf00e8920u)	/* Action Definition Register 40 */
#define MCDS_MCXACT41	(*( MCDS_MCXACT0_type *) 0xf00e8924u)	/* Action Definition Register 41 */
#define MCDS_MCXACT42	(*( MCDS_MCXACT0_type *) 0xf00e8928u)	/* Action Definition Register 42 */
#define MCDS_MCXACT43	(*( MCDS_MCXACT0_type *) 0xf00e892cu)	/* Action Definition Register 43 */
#define MCDS_MCXACT44	(*( MCDS_MCXACT0_type *) 0xf00e8930u)	/* Action Definition Register 44 */
#define MCDS_MCXACT45	(*( MCDS_MCXACT0_type *) 0xf00e8934u)	/* Action Definition Register 45 */
#define MCDS_MCXACT46	(*( MCDS_MCXACT0_type *) 0xf00e8938u)	/* Action Definition Register 46 */
#define MCDS_MCXACT47	(*( MCDS_MCXACT0_type *) 0xf00e893cu)	/* Action Definition Register 47 */
#define MCDS_MCXACT48	(*( MCDS_MCXACT0_type *) 0xf00e8940u)	/* Action Definition Register 48 */
#define MCDS_MCXACT49	(*( MCDS_MCXACT0_type *) 0xf00e8944u)	/* Action Definition Register 49 */
#define MCDS_MCXACT5	(*( MCDS_MCXACT0_type *) 0xf00e8894u)	/* Action Definition Register 5 */
#define MCDS_MCXACT50	(*( MCDS_MCXACT0_type *) 0xf00e8948u)	/* Action Definition Register 50 */
#define MCDS_MCXACT51	(*( MCDS_MCXACT0_type *) 0xf00e894cu)	/* Action Definition Register 51 */
#define MCDS_MCXACT52	(*( MCDS_MCXACT0_type *) 0xf00e8950u)	/* Action Definition Register 52 */
#define MCDS_MCXACT53	(*( MCDS_MCXACT0_type *) 0xf00e8954u)	/* Action Definition Register 53 */
#define MCDS_MCXACT54	(*( MCDS_MCXACT0_type *) 0xf00e8958u)	/* Action Definition Register 54 */
#define MCDS_MCXACT55	(*( MCDS_MCXACT0_type *) 0xf00e895cu)	/* Action Definition Register 55 */
#define MCDS_MCXACT56	(*( MCDS_MCXACT0_type *) 0xf00e8960u)	/* Action Definition Register 56 */
#define MCDS_MCXACT57	(*( MCDS_MCXACT0_type *) 0xf00e8964u)	/* Action Definition Register 57 */
#define MCDS_MCXACT58	(*( MCDS_MCXACT0_type *) 0xf00e8968u)	/* Action Definition Register 58 */
#define MCDS_MCXACT59	(*( MCDS_MCXACT0_type *) 0xf00e896cu)	/* Action Definition Register 59 */
#define MCDS_MCXACT6	(*( MCDS_MCXACT0_type *) 0xf00e8898u)	/* Action Definition Register 6 */
#define MCDS_MCXACT60	(*( MCDS_MCXACT0_type *) 0xf00e8970u)	/* Action Definition Register 60 */
#define MCDS_MCXACT61	(*( MCDS_MCXACT0_type *) 0xf00e8974u)	/* Action Definition Register 61 */
#define MCDS_MCXACT62	(*( MCDS_MCXACT0_type *) 0xf00e8978u)	/* Action Definition Register 62 */
#define MCDS_MCXACT63	(*( MCDS_MCXACT0_type *) 0xf00e897cu)	/* Action Definition Register 63 */
#define MCDS_MCXACT64	(*( MCDS_MCXACT0_type *) 0xf00e8980u)	/* Action Definition Register 64 */
#define MCDS_MCXACT65	(*( MCDS_MCXACT0_type *) 0xf00e8984u)	/* Action Definition Register 65 */
#define MCDS_MCXACT66	(*( MCDS_MCXACT0_type *) 0xf00e8988u)	/* Action Definition Register 66 */
#define MCDS_MCXACT67	(*( MCDS_MCXACT0_type *) 0xf00e898cu)	/* Action Definition Register 67 */
#define MCDS_MCXACT68	(*( MCDS_MCXACT0_type *) 0xf00e8990u)	/* Action Definition Register 68 */
#define MCDS_MCXACT69	(*( MCDS_MCXACT0_type *) 0xf00e8994u)	/* Action Definition Register 69 */
#define MCDS_MCXACT7	(*( MCDS_MCXACT0_type *) 0xf00e889cu)	/* Action Definition Register 7 */
#define MCDS_MCXACT70	(*( MCDS_MCXACT0_type *) 0xf00e8998u)	/* Action Definition Register 70 */
#define MCDS_MCXACT71	(*( MCDS_MCXACT0_type *) 0xf00e899cu)	/* Action Definition Register 71 */
#define MCDS_MCXACT8	(*( MCDS_MCXACT0_type *) 0xf00e88a0u)	/* Action Definition Register 8 */
#define MCDS_MCXACT9	(*( MCDS_MCXACT0_type *) 0xf00e88a4u)	/* Action Definition Register 9 */
#define MCDS_SPBACT0	(*( MCDS_MCXACT0_type *) 0xf00ee880u)	/* Action Definition Register 0 */
#define MCDS_SPBACT1	(*( MCDS_MCXACT0_type *) 0xf00ee884u)	/* Action Definition Register 1 */
#define MCDS_SPBACT10	(*( MCDS_MCXACT0_type *) 0xf00ee8a8u)	/* Action Definition Register 10 */
#define MCDS_SPBACT11	(*( MCDS_MCXACT0_type *) 0xf00ee8acu)	/* Action Definition Register 11 */
#define MCDS_SPBACT12	(*( MCDS_MCXACT0_type *) 0xf00ee8b0u)	/* Action Definition Register 12 */
#define MCDS_SPBACT13	(*( MCDS_MCXACT0_type *) 0xf00ee8b4u)	/* Action Definition Register 13 */
#define MCDS_SPBACT14	(*( MCDS_MCXACT0_type *) 0xf00ee8b8u)	/* Action Definition Register 14 */
#define MCDS_SPBACT2	(*( MCDS_MCXACT0_type *) 0xf00ee888u)	/* Action Definition Register 2 */
#define MCDS_SPBACT3	(*( MCDS_MCXACT0_type *) 0xf00ee88cu)	/* Action Definition Register 3 */
#define MCDS_SPBACT4	(*( MCDS_MCXACT0_type *) 0xf00ee890u)	/* Action Definition Register 4 */
#define MCDS_SPBACT5	(*( MCDS_MCXACT0_type *) 0xf00ee894u)	/* Action Definition Register 5 */
#define MCDS_SPBACT6	(*( MCDS_MCXACT0_type *) 0xf00ee898u)	/* Action Definition Register 6 */
#define MCDS_SPBACT7	(*( MCDS_MCXACT0_type *) 0xf00ee89cu)	/* Action Definition Register 7 */
#define MCDS_SPBACT8	(*( MCDS_MCXACT0_type *) 0xf00ee8a0u)	/* Action Definition Register 8 */
#define MCDS_SPBACT9	(*( MCDS_MCXACT0_type *) 0xf00ee8a4u)	/* Action Definition Register 9 */
#define MCDS_SRIACT0	(*( MCDS_MCXACT0_type *) 0xf00ef880u)	/* Action Definition Register 0 */
#define MCDS_SRIACT1	(*( MCDS_MCXACT0_type *) 0xf00ef884u)	/* Action Definition Register 1 */
#define MCDS_SRIACT10	(*( MCDS_MCXACT0_type *) 0xf00ef8a8u)	/* Action Definition Register 10 */
#define MCDS_SRIACT11	(*( MCDS_MCXACT0_type *) 0xf00ef8acu)	/* Action Definition Register 11 */
#define MCDS_SRIACT12	(*( MCDS_MCXACT0_type *) 0xf00ef8b0u)	/* Action Definition Register 12 */
#define MCDS_SRIACT13	(*( MCDS_MCXACT0_type *) 0xf00ef8b4u)	/* Action Definition Register 13 */
#define MCDS_SRIACT14	(*( MCDS_MCXACT0_type *) 0xf00ef8b8u)	/* Action Definition Register 14 */
#define MCDS_SRIACT15	(*( MCDS_MCXACT0_type *) 0xf00ef8bcu)	/* Action Definition Register 15 */
#define MCDS_SRIACT16	(*( MCDS_MCXACT0_type *) 0xf00ef8c0u)	/* Action Definition Register 16 */
#define MCDS_SRIACT17	(*( MCDS_MCXACT0_type *) 0xf00ef8c4u)	/* Action Definition Register 17 */
#define MCDS_SRIACT18	(*( MCDS_MCXACT0_type *) 0xf00ef8c8u)	/* Action Definition Register 18 */
#define MCDS_SRIACT19	(*( MCDS_MCXACT0_type *) 0xf00ef8ccu)	/* Action Definition Register 19 */
#define MCDS_SRIACT2	(*( MCDS_MCXACT0_type *) 0xf00ef888u)	/* Action Definition Register 2 */
#define MCDS_SRIACT20	(*( MCDS_MCXACT0_type *) 0xf00ef8d0u)	/* Action Definition Register 20 */
#define MCDS_SRIACT21	(*( MCDS_MCXACT0_type *) 0xf00ef8d4u)	/* Action Definition Register 21 */
#define MCDS_SRIACT22	(*( MCDS_MCXACT0_type *) 0xf00ef8d8u)	/* Action Definition Register 22 */
#define MCDS_SRIACT23	(*( MCDS_MCXACT0_type *) 0xf00ef8dcu)	/* Action Definition Register 23 */
#define MCDS_SRIACT24	(*( MCDS_MCXACT0_type *) 0xf00ef8e0u)	/* Action Definition Register 24 */
#define MCDS_SRIACT25	(*( MCDS_MCXACT0_type *) 0xf00ef8e4u)	/* Action Definition Register 25 */
#define MCDS_SRIACT26	(*( MCDS_MCXACT0_type *) 0xf00ef8e8u)	/* Action Definition Register 26 */
#define MCDS_SRIACT3	(*( MCDS_MCXACT0_type *) 0xf00ef88cu)	/* Action Definition Register 3 */
#define MCDS_SRIACT4	(*( MCDS_MCXACT0_type *) 0xf00ef890u)	/* Action Definition Register 4 */
#define MCDS_SRIACT5	(*( MCDS_MCXACT0_type *) 0xf00ef894u)	/* Action Definition Register 5 */
#define MCDS_SRIACT6	(*( MCDS_MCXACT0_type *) 0xf00ef898u)	/* Action Definition Register 6 */
#define MCDS_SRIACT7	(*( MCDS_MCXACT0_type *) 0xf00ef89cu)	/* Action Definition Register 7 */
#define MCDS_SRIACT8	(*( MCDS_MCXACT0_type *) 0xf00ef8a0u)	/* Action Definition Register 8 */
#define MCDS_SRIACT9	(*( MCDS_MCXACT0_type *) 0xf00ef8a4u)	/* Action Definition Register 9 */
#define MCDS_TCXACT0	(*( MCDS_MCXACT0_type *) 0xf00ea880u)	/* Action Definition Register 0 */
#define MCDS_TCXACT1	(*( MCDS_MCXACT0_type *) 0xf00ea884u)	/* Action Definition Register 1 */
#define MCDS_TCXACT10	(*( MCDS_MCXACT0_type *) 0xf00ea8a8u)	/* Action Definition Register 10 */
#define MCDS_TCXACT11	(*( MCDS_MCXACT0_type *) 0xf00ea8acu)	/* Action Definition Register 11 */
#define MCDS_TCXACT12	(*( MCDS_MCXACT0_type *) 0xf00ea8b0u)	/* Action Definition Register 12 */
#define MCDS_TCXACT13	(*( MCDS_MCXACT0_type *) 0xf00ea8b4u)	/* Action Definition Register 13 */
#define MCDS_TCXACT14	(*( MCDS_MCXACT0_type *) 0xf00ea8b8u)	/* Action Definition Register 14 */
#define MCDS_TCXACT15	(*( MCDS_MCXACT0_type *) 0xf00ea8bcu)	/* Action Definition Register 15 */
#define MCDS_TCXACT16	(*( MCDS_MCXACT0_type *) 0xf00ea8c0u)	/* Action Definition Register 16 */
#define MCDS_TCXACT17	(*( MCDS_MCXACT0_type *) 0xf00ea8c4u)	/* Action Definition Register 17 */
#define MCDS_TCXACT18	(*( MCDS_MCXACT0_type *) 0xf00ea8c8u)	/* Action Definition Register 18 */
#define MCDS_TCXACT19	(*( MCDS_MCXACT0_type *) 0xf00ea8ccu)	/* Action Definition Register 19 */
#define MCDS_TCXACT2	(*( MCDS_MCXACT0_type *) 0xf00ea888u)	/* Action Definition Register 2 */
#define MCDS_TCXACT20	(*( MCDS_MCXACT0_type *) 0xf00ea8d0u)	/* Action Definition Register 20 */
#define MCDS_TCXACT21	(*( MCDS_MCXACT0_type *) 0xf00ea8d4u)	/* Action Definition Register 21 */
#define MCDS_TCXACT22	(*( MCDS_MCXACT0_type *) 0xf00ea8d8u)	/* Action Definition Register 22 */
#define MCDS_TCXACT3	(*( MCDS_MCXACT0_type *) 0xf00ea88cu)	/* Action Definition Register 3 */
#define MCDS_TCXACT4	(*( MCDS_MCXACT0_type *) 0xf00ea890u)	/* Action Definition Register 4 */
#define MCDS_TCXACT5	(*( MCDS_MCXACT0_type *) 0xf00ea894u)	/* Action Definition Register 5 */
#define MCDS_TCXACT6	(*( MCDS_MCXACT0_type *) 0xf00ea898u)	/* Action Definition Register 6 */
#define MCDS_TCXACT7	(*( MCDS_MCXACT0_type *) 0xf00ea89cu)	/* Action Definition Register 7 */
#define MCDS_TCXACT8	(*( MCDS_MCXACT0_type *) 0xf00ea8a0u)	/* Action Definition Register 8 */
#define MCDS_TCXACT9	(*( MCDS_MCXACT0_type *) 0xf00ea8a4u)	/* Action Definition Register 9 */
#define MCDS_TCYACT0	(*( MCDS_MCXACT0_type *) 0xf00ec880u)	/* Action Definition Register 0 */
#define MCDS_TCYACT1	(*( MCDS_MCXACT0_type *) 0xf00ec884u)	/* Action Definition Register 1 */
#define MCDS_TCYACT10	(*( MCDS_MCXACT0_type *) 0xf00ec8a8u)	/* Action Definition Register 10 */
#define MCDS_TCYACT11	(*( MCDS_MCXACT0_type *) 0xf00ec8acu)	/* Action Definition Register 11 */
#define MCDS_TCYACT12	(*( MCDS_MCXACT0_type *) 0xf00ec8b0u)	/* Action Definition Register 12 */
#define MCDS_TCYACT13	(*( MCDS_MCXACT0_type *) 0xf00ec8b4u)	/* Action Definition Register 13 */
#define MCDS_TCYACT14	(*( MCDS_MCXACT0_type *) 0xf00ec8b8u)	/* Action Definition Register 14 */
#define MCDS_TCYACT15	(*( MCDS_MCXACT0_type *) 0xf00ec8bcu)	/* Action Definition Register 15 */
#define MCDS_TCYACT16	(*( MCDS_MCXACT0_type *) 0xf00ec8c0u)	/* Action Definition Register 16 */
#define MCDS_TCYACT17	(*( MCDS_MCXACT0_type *) 0xf00ec8c4u)	/* Action Definition Register 17 */
#define MCDS_TCYACT18	(*( MCDS_MCXACT0_type *) 0xf00ec8c8u)	/* Action Definition Register 18 */
#define MCDS_TCYACT19	(*( MCDS_MCXACT0_type *) 0xf00ec8ccu)	/* Action Definition Register 19 */
#define MCDS_TCYACT2	(*( MCDS_MCXACT0_type *) 0xf00ec888u)	/* Action Definition Register 2 */
#define MCDS_TCYACT20	(*( MCDS_MCXACT0_type *) 0xf00ec8d0u)	/* Action Definition Register 20 */
#define MCDS_TCYACT21	(*( MCDS_MCXACT0_type *) 0xf00ec8d4u)	/* Action Definition Register 21 */
#define MCDS_TCYACT22	(*( MCDS_MCXACT0_type *) 0xf00ec8d8u)	/* Action Definition Register 22 */
#define MCDS_TCYACT3	(*( MCDS_MCXACT0_type *) 0xf00ec88cu)	/* Action Definition Register 3 */
#define MCDS_TCYACT4	(*( MCDS_MCXACT0_type *) 0xf00ec890u)	/* Action Definition Register 4 */
#define MCDS_TCYACT5	(*( MCDS_MCXACT0_type *) 0xf00ec894u)	/* Action Definition Register 5 */
#define MCDS_TCYACT6	(*( MCDS_MCXACT0_type *) 0xf00ec898u)	/* Action Definition Register 6 */
#define MCDS_TCYACT7	(*( MCDS_MCXACT0_type *) 0xf00ec89cu)	/* Action Definition Register 7 */
#define MCDS_TCYACT8	(*( MCDS_MCXACT0_type *) 0xf00ec8a0u)	/* Action Definition Register 8 */
#define MCDS_TCYACT9	(*( MCDS_MCXACT0_type *) 0xf00ec8a4u)	/* Action Definition Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int INC0           : 7;	/* Count Input Selector */
		unsigned int ILV0           : 1;	/* Count Input Level Mode */
		unsigned int CLR0           : 6;	/* Clear Input Selector */
		unsigned int                : 1;
		unsigned int CLV0           : 1;	/* Clear Input Level Mode */
		unsigned int INC1           : 7;	/* Count Input Selector */
		unsigned int ILV1           : 1;	/* Count Input Level Mode */
		unsigned int CLR1           : 6;	/* Clear Input Selector */
		unsigned int                : 1;
		unsigned int CLV1           : 1;	/* Clear Input Level Mode */
	} B;
	int I;
	unsigned int U;

} MCDS_MCXCCL0_type;
#define MCDS_MCXCCL0	(*( MCDS_MCXCCL0_type *) 0xf00e8a00u)	/* Counter Control Register */
#define MCDS_MCXCCL1	(*( MCDS_MCXCCL0_type *) 0xf00e8a10u)	/* Counter Control Register */
#define MCDS_MCXCCL10	(*( MCDS_MCXCCL0_type *) 0xf00e8aa0u)	/* Counter Control Register */
#define MCDS_MCXCCL11	(*( MCDS_MCXCCL0_type *) 0xf00e8ab0u)	/* Counter Control Register */
#define MCDS_MCXCCL12	(*( MCDS_MCXCCL0_type *) 0xf00e8ac0u)	/* Counter Control Register */
#define MCDS_MCXCCL13	(*( MCDS_MCXCCL0_type *) 0xf00e8ad0u)	/* Counter Control Register */
#define MCDS_MCXCCL14	(*( MCDS_MCXCCL0_type *) 0xf00e8ae0u)	/* Counter Control Register */
#define MCDS_MCXCCL15	(*( MCDS_MCXCCL0_type *) 0xf00e8af0u)	/* Counter Control Register */
#define MCDS_MCXCCL16	(*( MCDS_MCXCCL0_type *) 0xf00e8b00u)	/* Counter Control Register */
#define MCDS_MCXCCL17	(*( MCDS_MCXCCL0_type *) 0xf00e8b10u)	/* Counter Control Register */
#define MCDS_MCXCCL18	(*( MCDS_MCXCCL0_type *) 0xf00e8b20u)	/* Counter Control Register */
#define MCDS_MCXCCL19	(*( MCDS_MCXCCL0_type *) 0xf00e8b30u)	/* Counter Control Register */
#define MCDS_MCXCCL2	(*( MCDS_MCXCCL0_type *) 0xf00e8a20u)	/* Counter Control Register */
#define MCDS_MCXCCL20	(*( MCDS_MCXCCL0_type *) 0xf00e8b40u)	/* Counter Control Register */
#define MCDS_MCXCCL21	(*( MCDS_MCXCCL0_type *) 0xf00e8b50u)	/* Counter Control Register */
#define MCDS_MCXCCL22	(*( MCDS_MCXCCL0_type *) 0xf00e8b60u)	/* Counter Control Register */
#define MCDS_MCXCCL23	(*( MCDS_MCXCCL0_type *) 0xf00e8b70u)	/* Counter Control Register */
#define MCDS_MCXCCL24	(*( MCDS_MCXCCL0_type *) 0xf00e8b80u)	/* Counter Control Register */
#define MCDS_MCXCCL25	(*( MCDS_MCXCCL0_type *) 0xf00e8b90u)	/* Counter Control Register */
#define MCDS_MCXCCL26	(*( MCDS_MCXCCL0_type *) 0xf00e8ba0u)	/* Counter Control Register */
#define MCDS_MCXCCL27	(*( MCDS_MCXCCL0_type *) 0xf00e8bb0u)	/* Counter Control Register */
#define MCDS_MCXCCL28	(*( MCDS_MCXCCL0_type *) 0xf00e8bc0u)	/* Counter Control Register */
#define MCDS_MCXCCL29	(*( MCDS_MCXCCL0_type *) 0xf00e8bd0u)	/* Counter Control Register */
#define MCDS_MCXCCL3	(*( MCDS_MCXCCL0_type *) 0xf00e8a30u)	/* Counter Control Register */
#define MCDS_MCXCCL30	(*( MCDS_MCXCCL0_type *) 0xf00e8be0u)	/* Counter Control Register */
#define MCDS_MCXCCL31	(*( MCDS_MCXCCL0_type *) 0xf00e8bf0u)	/* Counter Control Register */
#define MCDS_MCXCCL4	(*( MCDS_MCXCCL0_type *) 0xf00e8a40u)	/* Counter Control Register */
#define MCDS_MCXCCL5	(*( MCDS_MCXCCL0_type *) 0xf00e8a50u)	/* Counter Control Register */
#define MCDS_MCXCCL6	(*( MCDS_MCXCCL0_type *) 0xf00e8a60u)	/* Counter Control Register */
#define MCDS_MCXCCL7	(*( MCDS_MCXCCL0_type *) 0xf00e8a70u)	/* Counter Control Register */
#define MCDS_MCXCCL8	(*( MCDS_MCXCCL0_type *) 0xf00e8a80u)	/* Counter Control Register */
#define MCDS_MCXCCL9	(*( MCDS_MCXCCL0_type *) 0xf00e8a90u)	/* Counter Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int COUNT          : 16;	/* Current Counter */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} MCDS_MCXCNT0_type;
#define MCDS_MCXCNT0	(*( MCDS_MCXCNT0_type *) 0xf00e8a08u)	/* Current Count Register */
#define MCDS_MCXCNT1	(*( MCDS_MCXCNT0_type *) 0xf00e8a18u)	/* Current Count Register */
#define MCDS_MCXCNT10	(*( MCDS_MCXCNT0_type *) 0xf00e8aa8u)	/* Current Count Register */
#define MCDS_MCXCNT11	(*( MCDS_MCXCNT0_type *) 0xf00e8ab8u)	/* Current Count Register */
#define MCDS_MCXCNT12	(*( MCDS_MCXCNT0_type *) 0xf00e8ac8u)	/* Current Count Register */
#define MCDS_MCXCNT13	(*( MCDS_MCXCNT0_type *) 0xf00e8ad8u)	/* Current Count Register */
#define MCDS_MCXCNT14	(*( MCDS_MCXCNT0_type *) 0xf00e8ae8u)	/* Current Count Register */
#define MCDS_MCXCNT15	(*( MCDS_MCXCNT0_type *) 0xf00e8af8u)	/* Current Count Register */
#define MCDS_MCXCNT16	(*( MCDS_MCXCNT0_type *) 0xf00e8b08u)	/* Current Count Register */
#define MCDS_MCXCNT17	(*( MCDS_MCXCNT0_type *) 0xf00e8b18u)	/* Current Count Register */
#define MCDS_MCXCNT18	(*( MCDS_MCXCNT0_type *) 0xf00e8b28u)	/* Current Count Register */
#define MCDS_MCXCNT19	(*( MCDS_MCXCNT0_type *) 0xf00e8b38u)	/* Current Count Register */
#define MCDS_MCXCNT2	(*( MCDS_MCXCNT0_type *) 0xf00e8a28u)	/* Current Count Register */
#define MCDS_MCXCNT20	(*( MCDS_MCXCNT0_type *) 0xf00e8b48u)	/* Current Count Register */
#define MCDS_MCXCNT21	(*( MCDS_MCXCNT0_type *) 0xf00e8b58u)	/* Current Count Register */
#define MCDS_MCXCNT22	(*( MCDS_MCXCNT0_type *) 0xf00e8b68u)	/* Current Count Register */
#define MCDS_MCXCNT23	(*( MCDS_MCXCNT0_type *) 0xf00e8b78u)	/* Current Count Register */
#define MCDS_MCXCNT24	(*( MCDS_MCXCNT0_type *) 0xf00e8b88u)	/* Current Count Register */
#define MCDS_MCXCNT25	(*( MCDS_MCXCNT0_type *) 0xf00e8b98u)	/* Current Count Register */
#define MCDS_MCXCNT26	(*( MCDS_MCXCNT0_type *) 0xf00e8ba8u)	/* Current Count Register */
#define MCDS_MCXCNT27	(*( MCDS_MCXCNT0_type *) 0xf00e8bb8u)	/* Current Count Register */
#define MCDS_MCXCNT28	(*( MCDS_MCXCNT0_type *) 0xf00e8bc8u)	/* Current Count Register */
#define MCDS_MCXCNT29	(*( MCDS_MCXCNT0_type *) 0xf00e8bd8u)	/* Current Count Register */
#define MCDS_MCXCNT3	(*( MCDS_MCXCNT0_type *) 0xf00e8a38u)	/* Current Count Register */
#define MCDS_MCXCNT30	(*( MCDS_MCXCNT0_type *) 0xf00e8be8u)	/* Current Count Register */
#define MCDS_MCXCNT31	(*( MCDS_MCXCNT0_type *) 0xf00e8bf8u)	/* Current Count Register */
#define MCDS_MCXCNT4	(*( MCDS_MCXCNT0_type *) 0xf00e8a48u)	/* Current Count Register */
#define MCDS_MCXCNT5	(*( MCDS_MCXCNT0_type *) 0xf00e8a58u)	/* Current Count Register */
#define MCDS_MCXCNT6	(*( MCDS_MCXCNT0_type *) 0xf00e8a68u)	/* Current Count Register */
#define MCDS_MCXCNT7	(*( MCDS_MCXCNT0_type *) 0xf00e8a78u)	/* Current Count Register */
#define MCDS_MCXCNT8	(*( MCDS_MCXCNT0_type *) 0xf00e8a88u)	/* Current Count Register */
#define MCDS_MCXCNT9	(*( MCDS_MCXCNT0_type *) 0xf00e8a98u)	/* Current Count Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EIQ0           : 2;	/* Event Input Qualifier */
		unsigned int EIQ1           : 2;	/* Event Input Qualifier */
		unsigned int EIQ2           : 2;	/* Event Input Qualifier */
		unsigned int EIQ3           : 2;	/* Event Input Qualifier */
		unsigned int EIQ4           : 2;	/* Event Input Qualifier */
		unsigned int EIQ5           : 2;	/* Event Input Qualifier */
		unsigned int EIQ6           : 2;	/* Event Input Qualifier */
		unsigned int EIQ7           : 2;	/* Event Input Qualifier */
		unsigned int EIQ8           : 2;	/* Event Input Qualifier */
		unsigned int EIQ9           : 2;	/* Event Input Qualifier */
		unsigned int EIQ10          : 2;	/* Event Input Qualifier */
		unsigned int EIQ11          : 2;	/* Event Input Qualifier */
		unsigned int EIQ12          : 2;	/* Event Input Qualifier */
		unsigned int EIQ13          : 2;	/* Event Input Qualifier */
		unsigned int EIQ14          : 2;	/* Event Input Qualifier */
		unsigned int EIQ15          : 2;	/* Event Input Qualifier */
	} B;
	int I;
	unsigned int U;

} MCDS_MCXEVT0_type;
#define MCDS_MCXEVT0	(*( MCDS_MCXEVT0_type *) 0xf00e8800u)	/* Event Definition Register 0 */
#define MCDS_MCXEVT1	(*( MCDS_MCXEVT0_type *) 0xf00e8804u)	/* Event Definition Register 1 */
#define MCDS_MCXEVT10	(*( MCDS_MCXEVT0_type *) 0xf00e8828u)	/* Event Definition Register 10 */
#define MCDS_MCXEVT11	(*( MCDS_MCXEVT0_type *) 0xf00e882cu)	/* Event Definition Register 11 */
#define MCDS_MCXEVT12	(*( MCDS_MCXEVT0_type *) 0xf00e8830u)	/* Event Definition Register 12 */
#define MCDS_MCXEVT13	(*( MCDS_MCXEVT0_type *) 0xf00e8834u)	/* Event Definition Register 13 */
#define MCDS_MCXEVT14	(*( MCDS_MCXEVT0_type *) 0xf00e8838u)	/* Event Definition Register 14 */
#define MCDS_MCXEVT15	(*( MCDS_MCXEVT0_type *) 0xf00e883cu)	/* Event Definition Register 15 */
#define MCDS_MCXEVT16	(*( MCDS_MCXEVT0_type *) 0xf00e8840u)	/* Event Definition Register 16 */
#define MCDS_MCXEVT17	(*( MCDS_MCXEVT0_type *) 0xf00e8844u)	/* Event Definition Register 17 */
#define MCDS_MCXEVT18	(*( MCDS_MCXEVT0_type *) 0xf00e8848u)	/* Event Definition Register 18 */
#define MCDS_MCXEVT19	(*( MCDS_MCXEVT0_type *) 0xf00e884cu)	/* Event Definition Register 19 */
#define MCDS_MCXEVT2	(*( MCDS_MCXEVT0_type *) 0xf00e8808u)	/* Event Definition Register 2 */
#define MCDS_MCXEVT20	(*( MCDS_MCXEVT0_type *) 0xf00e8850u)	/* Event Definition Register 20 */
#define MCDS_MCXEVT21	(*( MCDS_MCXEVT0_type *) 0xf00e8854u)	/* Event Definition Register 21 */
#define MCDS_MCXEVT22	(*( MCDS_MCXEVT0_type *) 0xf00e8858u)	/* Event Definition Register 22 */
#define MCDS_MCXEVT23	(*( MCDS_MCXEVT0_type *) 0xf00e885cu)	/* Event Definition Register 23 */
#define MCDS_MCXEVT3	(*( MCDS_MCXEVT0_type *) 0xf00e880cu)	/* Event Definition Register 3 */
#define MCDS_MCXEVT4	(*( MCDS_MCXEVT0_type *) 0xf00e8810u)	/* Event Definition Register 4 */
#define MCDS_MCXEVT5	(*( MCDS_MCXEVT0_type *) 0xf00e8814u)	/* Event Definition Register 5 */
#define MCDS_MCXEVT6	(*( MCDS_MCXEVT0_type *) 0xf00e8818u)	/* Event Definition Register 6 */
#define MCDS_MCXEVT7	(*( MCDS_MCXEVT0_type *) 0xf00e881cu)	/* Event Definition Register 7 */
#define MCDS_MCXEVT8	(*( MCDS_MCXEVT0_type *) 0xf00e8820u)	/* Event Definition Register 8 */
#define MCDS_MCXEVT9	(*( MCDS_MCXEVT0_type *) 0xf00e8824u)	/* Event Definition Register 9 */
#define MCDS_SPBEVT0	(*( MCDS_MCXEVT0_type *) 0xf00ee800u)	/* Event Definition Register 0 */
#define MCDS_SPBEVT1	(*( MCDS_MCXEVT0_type *) 0xf00ee804u)	/* Event Definition Register 1 */
#define MCDS_SPBEVT10	(*( MCDS_MCXEVT0_type *) 0xf00ee828u)	/* Event Definition Register 10 */
#define MCDS_SPBEVT11	(*( MCDS_MCXEVT0_type *) 0xf00ee82cu)	/* Event Definition Register 11 */
#define MCDS_SPBEVT12	(*( MCDS_MCXEVT0_type *) 0xf00ee830u)	/* Event Definition Register 12 */
#define MCDS_SPBEVT13	(*( MCDS_MCXEVT0_type *) 0xf00ee834u)	/* Event Definition Register 13 */
#define MCDS_SPBEVT14	(*( MCDS_MCXEVT0_type *) 0xf00ee838u)	/* Event Definition Register 14 */
#define MCDS_SPBEVT15	(*( MCDS_MCXEVT0_type *) 0xf00ee83cu)	/* Event Definition Register 15 */
#define MCDS_SPBEVT2	(*( MCDS_MCXEVT0_type *) 0xf00ee808u)	/* Event Definition Register 2 */
#define MCDS_SPBEVT3	(*( MCDS_MCXEVT0_type *) 0xf00ee80cu)	/* Event Definition Register 3 */
#define MCDS_SPBEVT4	(*( MCDS_MCXEVT0_type *) 0xf00ee810u)	/* Event Definition Register 4 */
#define MCDS_SPBEVT5	(*( MCDS_MCXEVT0_type *) 0xf00ee814u)	/* Event Definition Register 5 */
#define MCDS_SPBEVT6	(*( MCDS_MCXEVT0_type *) 0xf00ee818u)	/* Event Definition Register 6 */
#define MCDS_SPBEVT7	(*( MCDS_MCXEVT0_type *) 0xf00ee81cu)	/* Event Definition Register 7 */
#define MCDS_SPBEVT8	(*( MCDS_MCXEVT0_type *) 0xf00ee820u)	/* Event Definition Register 8 */
#define MCDS_SPBEVT9	(*( MCDS_MCXEVT0_type *) 0xf00ee824u)	/* Event Definition Register 9 */
#define MCDS_SRIEVT0	(*( MCDS_MCXEVT0_type *) 0xf00ef800u)	/* Event Definition Register 0 */
#define MCDS_SRIEVT1	(*( MCDS_MCXEVT0_type *) 0xf00ef804u)	/* Event Definition Register 1 */
#define MCDS_SRIEVT10	(*( MCDS_MCXEVT0_type *) 0xf00ef828u)	/* Event Definition Register 10 */
#define MCDS_SRIEVT11	(*( MCDS_MCXEVT0_type *) 0xf00ef82cu)	/* Event Definition Register 11 */
#define MCDS_SRIEVT12	(*( MCDS_MCXEVT0_type *) 0xf00ef830u)	/* Event Definition Register 12 */
#define MCDS_SRIEVT13	(*( MCDS_MCXEVT0_type *) 0xf00ef834u)	/* Event Definition Register 13 */
#define MCDS_SRIEVT14	(*( MCDS_MCXEVT0_type *) 0xf00ef838u)	/* Event Definition Register 14 */
#define MCDS_SRIEVT15	(*( MCDS_MCXEVT0_type *) 0xf00ef83cu)	/* Event Definition Register 15 */
#define MCDS_SRIEVT2	(*( MCDS_MCXEVT0_type *) 0xf00ef808u)	/* Event Definition Register 2 */
#define MCDS_SRIEVT3	(*( MCDS_MCXEVT0_type *) 0xf00ef80cu)	/* Event Definition Register 3 */
#define MCDS_SRIEVT4	(*( MCDS_MCXEVT0_type *) 0xf00ef810u)	/* Event Definition Register 4 */
#define MCDS_SRIEVT5	(*( MCDS_MCXEVT0_type *) 0xf00ef814u)	/* Event Definition Register 5 */
#define MCDS_SRIEVT6	(*( MCDS_MCXEVT0_type *) 0xf00ef818u)	/* Event Definition Register 6 */
#define MCDS_SRIEVT7	(*( MCDS_MCXEVT0_type *) 0xf00ef81cu)	/* Event Definition Register 7 */
#define MCDS_SRIEVT8	(*( MCDS_MCXEVT0_type *) 0xf00ef820u)	/* Event Definition Register 8 */
#define MCDS_SRIEVT9	(*( MCDS_MCXEVT0_type *) 0xf00ef824u)	/* Event Definition Register 9 */
#define MCDS_TCXEVT0	(*( MCDS_MCXEVT0_type *) 0xf00ea800u)	/* Event Definition Register 0 */
#define MCDS_TCXEVT1	(*( MCDS_MCXEVT0_type *) 0xf00ea804u)	/* Event Definition Register 1 */
#define MCDS_TCXEVT10	(*( MCDS_MCXEVT0_type *) 0xf00ea828u)	/* Event Definition Register 10 */
#define MCDS_TCXEVT11	(*( MCDS_MCXEVT0_type *) 0xf00ea82cu)	/* Event Definition Register 11 */
#define MCDS_TCXEVT12	(*( MCDS_MCXEVT0_type *) 0xf00ea830u)	/* Event Definition Register 12 */
#define MCDS_TCXEVT13	(*( MCDS_MCXEVT0_type *) 0xf00ea834u)	/* Event Definition Register 13 */
#define MCDS_TCXEVT14	(*( MCDS_MCXEVT0_type *) 0xf00ea838u)	/* Event Definition Register 14 */
#define MCDS_TCXEVT15	(*( MCDS_MCXEVT0_type *) 0xf00ea83cu)	/* Event Definition Register 15 */
#define MCDS_TCXEVT2	(*( MCDS_MCXEVT0_type *) 0xf00ea808u)	/* Event Definition Register 2 */
#define MCDS_TCXEVT3	(*( MCDS_MCXEVT0_type *) 0xf00ea80cu)	/* Event Definition Register 3 */
#define MCDS_TCXEVT4	(*( MCDS_MCXEVT0_type *) 0xf00ea810u)	/* Event Definition Register 4 */
#define MCDS_TCXEVT5	(*( MCDS_MCXEVT0_type *) 0xf00ea814u)	/* Event Definition Register 5 */
#define MCDS_TCXEVT6	(*( MCDS_MCXEVT0_type *) 0xf00ea818u)	/* Event Definition Register 6 */
#define MCDS_TCXEVT7	(*( MCDS_MCXEVT0_type *) 0xf00ea81cu)	/* Event Definition Register 7 */
#define MCDS_TCXEVT8	(*( MCDS_MCXEVT0_type *) 0xf00ea820u)	/* Event Definition Register 8 */
#define MCDS_TCXEVT9	(*( MCDS_MCXEVT0_type *) 0xf00ea824u)	/* Event Definition Register 9 */
#define MCDS_TCYEVT0	(*( MCDS_MCXEVT0_type *) 0xf00ec800u)	/* Event Definition Register 0 */
#define MCDS_TCYEVT1	(*( MCDS_MCXEVT0_type *) 0xf00ec804u)	/* Event Definition Register 1 */
#define MCDS_TCYEVT10	(*( MCDS_MCXEVT0_type *) 0xf00ec828u)	/* Event Definition Register 10 */
#define MCDS_TCYEVT11	(*( MCDS_MCXEVT0_type *) 0xf00ec82cu)	/* Event Definition Register 11 */
#define MCDS_TCYEVT12	(*( MCDS_MCXEVT0_type *) 0xf00ec830u)	/* Event Definition Register 12 */
#define MCDS_TCYEVT13	(*( MCDS_MCXEVT0_type *) 0xf00ec834u)	/* Event Definition Register 13 */
#define MCDS_TCYEVT14	(*( MCDS_MCXEVT0_type *) 0xf00ec838u)	/* Event Definition Register 14 */
#define MCDS_TCYEVT15	(*( MCDS_MCXEVT0_type *) 0xf00ec83cu)	/* Event Definition Register 15 */
#define MCDS_TCYEVT2	(*( MCDS_MCXEVT0_type *) 0xf00ec808u)	/* Event Definition Register 2 */
#define MCDS_TCYEVT3	(*( MCDS_MCXEVT0_type *) 0xf00ec80cu)	/* Event Definition Register 3 */
#define MCDS_TCYEVT4	(*( MCDS_MCXEVT0_type *) 0xf00ec810u)	/* Event Definition Register 4 */
#define MCDS_TCYEVT5	(*( MCDS_MCXEVT0_type *) 0xf00ec814u)	/* Event Definition Register 5 */
#define MCDS_TCYEVT6	(*( MCDS_MCXEVT0_type *) 0xf00ec818u)	/* Event Definition Register 6 */
#define MCDS_TCYEVT7	(*( MCDS_MCXEVT0_type *) 0xf00ec81cu)	/* Event Definition Register 7 */
#define MCDS_TCYEVT8	(*( MCDS_MCXEVT0_type *) 0xf00ec820u)	/* Event Definition Register 8 */
#define MCDS_TCYEVT9	(*( MCDS_MCXEVT0_type *) 0xf00ec824u)	/* Event Definition Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int LIMIT          : 16;	/* Counter Limit */
		unsigned int                : 14;
		unsigned int MOD0           : 1;	/* Modulo Count Control */
		unsigned int MOD1           : 1;	/* Modulo Count Control */
	} B;
	int I;
	unsigned int U;

} MCDS_MCXLMT0_type;
#define MCDS_MCXLMT0	(*( MCDS_MCXLMT0_type *) 0xf00e8a04u)	/* Counter Limit Register */
#define MCDS_MCXLMT1	(*( MCDS_MCXLMT0_type *) 0xf00e8a14u)	/* Counter Limit Register */
#define MCDS_MCXLMT10	(*( MCDS_MCXLMT0_type *) 0xf00e8aa4u)	/* Counter Limit Register */
#define MCDS_MCXLMT11	(*( MCDS_MCXLMT0_type *) 0xf00e8ab4u)	/* Counter Limit Register */
#define MCDS_MCXLMT12	(*( MCDS_MCXLMT0_type *) 0xf00e8ac4u)	/* Counter Limit Register */
#define MCDS_MCXLMT13	(*( MCDS_MCXLMT0_type *) 0xf00e8ad4u)	/* Counter Limit Register */
#define MCDS_MCXLMT14	(*( MCDS_MCXLMT0_type *) 0xf00e8ae4u)	/* Counter Limit Register */
#define MCDS_MCXLMT15	(*( MCDS_MCXLMT0_type *) 0xf00e8af4u)	/* Counter Limit Register */
#define MCDS_MCXLMT16	(*( MCDS_MCXLMT0_type *) 0xf00e8b04u)	/* Counter Limit Register */
#define MCDS_MCXLMT17	(*( MCDS_MCXLMT0_type *) 0xf00e8b14u)	/* Counter Limit Register */
#define MCDS_MCXLMT18	(*( MCDS_MCXLMT0_type *) 0xf00e8b24u)	/* Counter Limit Register */
#define MCDS_MCXLMT19	(*( MCDS_MCXLMT0_type *) 0xf00e8b34u)	/* Counter Limit Register */
#define MCDS_MCXLMT2	(*( MCDS_MCXLMT0_type *) 0xf00e8a24u)	/* Counter Limit Register */
#define MCDS_MCXLMT20	(*( MCDS_MCXLMT0_type *) 0xf00e8b44u)	/* Counter Limit Register */
#define MCDS_MCXLMT21	(*( MCDS_MCXLMT0_type *) 0xf00e8b54u)	/* Counter Limit Register */
#define MCDS_MCXLMT22	(*( MCDS_MCXLMT0_type *) 0xf00e8b64u)	/* Counter Limit Register */
#define MCDS_MCXLMT23	(*( MCDS_MCXLMT0_type *) 0xf00e8b74u)	/* Counter Limit Register */
#define MCDS_MCXLMT24	(*( MCDS_MCXLMT0_type *) 0xf00e8b84u)	/* Counter Limit Register */
#define MCDS_MCXLMT25	(*( MCDS_MCXLMT0_type *) 0xf00e8b94u)	/* Counter Limit Register */
#define MCDS_MCXLMT26	(*( MCDS_MCXLMT0_type *) 0xf00e8ba4u)	/* Counter Limit Register */
#define MCDS_MCXLMT27	(*( MCDS_MCXLMT0_type *) 0xf00e8bb4u)	/* Counter Limit Register */
#define MCDS_MCXLMT28	(*( MCDS_MCXLMT0_type *) 0xf00e8bc4u)	/* Counter Limit Register */
#define MCDS_MCXLMT29	(*( MCDS_MCXLMT0_type *) 0xf00e8bd4u)	/* Counter Limit Register */
#define MCDS_MCXLMT3	(*( MCDS_MCXLMT0_type *) 0xf00e8a34u)	/* Counter Limit Register */
#define MCDS_MCXLMT30	(*( MCDS_MCXLMT0_type *) 0xf00e8be4u)	/* Counter Limit Register */
#define MCDS_MCXLMT31	(*( MCDS_MCXLMT0_type *) 0xf00e8bf4u)	/* Counter Limit Register */
#define MCDS_MCXLMT4	(*( MCDS_MCXLMT0_type *) 0xf00e8a44u)	/* Counter Limit Register */
#define MCDS_MCXLMT5	(*( MCDS_MCXLMT0_type *) 0xf00e8a54u)	/* Counter Limit Register */
#define MCDS_MCXLMT6	(*( MCDS_MCXLMT0_type *) 0xf00e8a64u)	/* Counter Limit Register */
#define MCDS_MCXLMT7	(*( MCDS_MCXLMT0_type *) 0xf00e8a74u)	/* Counter Limit Register */
#define MCDS_MCXLMT8	(*( MCDS_MCXLMT0_type *) 0xf00e8a84u)	/* Counter Limit Register */
#define MCDS_MCXLMT9	(*( MCDS_MCXLMT0_type *) 0xf00e8a94u)	/* Counter Limit Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TMUX0          : 4;	/* Trace Source Select 0 */
		unsigned int                : 3;
		unsigned int TM0_P          : 1;	/* Trace Source Select z Protection */
		unsigned int TMUX1          : 4;	/* Trace Source Select 1 */
		unsigned int                : 3;
		unsigned int TM1_P          : 1;	/* Trace Source Select z Protection */
		unsigned int TMUX2          : 3;	/* Trace Source Select 2 */
		unsigned int TM2_P          : 1;	/* Trace Source Select z Protection */
		unsigned int TMUX3          : 3;	/* Trace Source Select 3 */
		unsigned int TM3_P          : 1;	/* Trace Source Select z Protection */
		unsigned int RC             : 1;	/* Reference Clock Select */
		unsigned int                : 2;
		unsigned int RC_P           : 1;	/* Reference Clock Select Protection */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} MCDS_MUX_type;
#define MCDS_MUX	(*( MCDS_MUX_type *) 0xf00e8014u)	/* MCDS Signal Source Control */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State (inverted busy_o) */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} MCDS_OCS_type;
#define MCDS_OCS	(*( MCDS_OCS_type *) 0xf00e8004u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		unsigned int KEY            : 32;	/* Key High Word (bits [63:32]) */
	} B;
	int I;
	unsigned int U;

} MCDS_SESSIDH_type;
#define MCDS_SESSIDH	(*( MCDS_SESSIDH_type *) 0xf00e801cu)	/* Session ID High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int KEY            : 32;	/* Key Low Word (bits [31:0]) */
	} B;
	int I;
	unsigned int U;

} MCDS_SESSIDL_type;
#define MCDS_SESSIDL	(*( MCDS_SESSIDL_type *) 0xf00e8018u)	/* Session ID Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int BOUND          : 12;	/* Mode Comparator range lower bound */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} MCDS_SPBACBND0_type;
#define MCDS_SPBACBND0	(*( MCDS_SPBACBND0_type *) 0xf00ee500u)	/* Comparator Bound Register 0 */
#define MCDS_SPBACBND1	(*( MCDS_SPBACBND0_type *) 0xf00ee510u)	/* Comparator Bound Register 1 */
#define MCDS_SPBACBND2	(*( MCDS_SPBACBND0_type *) 0xf00ee520u)	/* Comparator Bound Register 2 */
#define MCDS_SPBACBND3	(*( MCDS_SPBACBND0_type *) 0xf00ee530u)	/* Comparator Bound Register 3 */
#define MCDS_SRI1ACBND0	(*( MCDS_SPBACBND0_type *) 0xf00ef500u)	/* Comparator Bound Register 0 */
#define MCDS_SRI1ACBND1	(*( MCDS_SPBACBND0_type *) 0xf00ef510u)	/* Comparator Bound Register 1 */
#define MCDS_SRI1ACBND2	(*( MCDS_SPBACBND0_type *) 0xf00ef520u)	/* Comparator Bound Register 2 */
#define MCDS_SRI1ACBND3	(*( MCDS_SPBACBND0_type *) 0xf00ef530u)	/* Comparator Bound Register 3 */
#define MCDS_SRI2ACBND0	(*( MCDS_SPBACBND0_type *) 0xf00ef700u)	/* Comparator Bound Register 0 */
#define MCDS_SRI2ACBND1	(*( MCDS_SPBACBND0_type *) 0xf00ef710u)	/* Comparator Bound Register 1 */
#define MCDS_SRI2ACBND2	(*( MCDS_SPBACBND0_type *) 0xf00ef720u)	/* Comparator Bound Register 2 */
#define MCDS_SRI2ACBND3	(*( MCDS_SPBACBND0_type *) 0xf00ef730u)	/* Comparator Bound Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int SVM            : 1;	/* Comparator bit mask for Supervisor Mode */
		unsigned int MASTER         : 4;	/* Comparator bit mask for Master ID */
		unsigned int SUBCHANNEL     : 5;	/* Comparator bit mask for Sub-channel ID */
		unsigned int WR             : 1;	/* Comparator bit mask for Direction Write */
		unsigned int RD             : 1;	/* Comparator bit mask for Direction Read */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} MCDS_SPBACMSK0_type;
#define MCDS_SPBACMSK0	(*( MCDS_SPBACMSK0_type *) 0xf00ee508u)	/* Comparator Mask Register 0 */
#define MCDS_SPBACMSK1	(*( MCDS_SPBACMSK0_type *) 0xf00ee518u)	/* Comparator Mask Register 1 */
#define MCDS_SPBACMSK2	(*( MCDS_SPBACMSK0_type *) 0xf00ee528u)	/* Comparator Mask Register 2 */
#define MCDS_SPBACMSK3	(*( MCDS_SPBACMSK0_type *) 0xf00ee538u)	/* Comparator Mask Register 3 */
#define MCDS_SRI1ACMSK0	(*( MCDS_SPBACMSK0_type *) 0xf00ef508u)	/* Comparator Mask Register 0 */
#define MCDS_SRI1ACMSK1	(*( MCDS_SPBACMSK0_type *) 0xf00ef518u)	/* Comparator Mask Register 1 */
#define MCDS_SRI1ACMSK2	(*( MCDS_SPBACMSK0_type *) 0xf00ef528u)	/* Comparator Mask Register 2 */
#define MCDS_SRI1ACMSK3	(*( MCDS_SPBACMSK0_type *) 0xf00ef538u)	/* Comparator Mask Register 3 */
#define MCDS_SRI2ACMSK0	(*( MCDS_SPBACMSK0_type *) 0xf00ef708u)	/* Comparator Mask Register 0 */
#define MCDS_SRI2ACMSK1	(*( MCDS_SPBACMSK0_type *) 0xf00ef718u)	/* Comparator Mask Register 1 */
#define MCDS_SRI2ACMSK2	(*( MCDS_SPBACMSK0_type *) 0xf00ef728u)	/* Comparator Mask Register 2 */
#define MCDS_SRI2ACMSK3	(*( MCDS_SPBACMSK0_type *) 0xf00ef738u)	/* Comparator Mask Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int RANGE          : 12;	/* Mode Comparator range size */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} MCDS_SPBACRNG0_type;
#define MCDS_SPBACRNG0	(*( MCDS_SPBACRNG0_type *) 0xf00ee504u)	/* Comparator Range Register 0 */
#define MCDS_SPBACRNG1	(*( MCDS_SPBACRNG0_type *) 0xf00ee514u)	/* Comparator Range Register 1 */
#define MCDS_SPBACRNG2	(*( MCDS_SPBACRNG0_type *) 0xf00ee524u)	/* Comparator Range Register 2 */
#define MCDS_SPBACRNG3	(*( MCDS_SPBACRNG0_type *) 0xf00ee534u)	/* Comparator Range Register 3 */
#define MCDS_SRI1ACRNG0	(*( MCDS_SPBACRNG0_type *) 0xf00ef504u)	/* Comparator Range Register 0 */
#define MCDS_SRI1ACRNG1	(*( MCDS_SPBACRNG0_type *) 0xf00ef514u)	/* Comparator Range Register 1 */
#define MCDS_SRI1ACRNG2	(*( MCDS_SPBACRNG0_type *) 0xf00ef524u)	/* Comparator Range Register 2 */
#define MCDS_SRI1ACRNG3	(*( MCDS_SPBACRNG0_type *) 0xf00ef534u)	/* Comparator Range Register 3 */
#define MCDS_SRI2ACRNG0	(*( MCDS_SPBACRNG0_type *) 0xf00ef704u)	/* Comparator Range Register 0 */
#define MCDS_SRI2ACRNG1	(*( MCDS_SPBACRNG0_type *) 0xf00ef714u)	/* Comparator Range Register 1 */
#define MCDS_SRI2ACRNG2	(*( MCDS_SPBACRNG0_type *) 0xf00ef724u)	/* Comparator Range Register 2 */
#define MCDS_SRI2ACRNG3	(*( MCDS_SPBACRNG0_type *) 0xf00ef734u)	/* Comparator Range Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int EI             : 1;	/* ENDINIT Protection Flag */
		/* const */ unsigned int SUS            : 1;	/* Suspended Flag */
		/* const */ unsigned int ERR            : 1;	/* Error Flag */
		/* const */ unsigned int RTY            : 1;	/* Retry Flag */
		/* const */ unsigned int SYSRES         : 1;	/* System Reset (Class 0) Flag */
		/* const */ unsigned int APPRES         : 1;	/* Application Reset (Class 3) Flag */
		/* const */ unsigned int CLKDIV         : 2;	/* Current Clock Divider */
		/* const */ unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} MCDS_SPBDCSTS_type;
#define MCDS_SPBDCSTS	(*( MCDS_SPBDCSTS_type *) 0xf00ee000u)	/* Debug Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int BOUND          : 32;	/* Address Comparator range lower bound */
	} B;
	int I;
	unsigned int U;

} MCDS_SPBEABND0_type;
#define MCDS_SPBEABND0	(*( MCDS_SPBEABND0_type *) 0xf00ee400u)	/* Comparator Bound Register 0 */
#define MCDS_SPBEABND1	(*( MCDS_SPBEABND0_type *) 0xf00ee410u)	/* Comparator Bound Register 1 */
#define MCDS_SPBEABND2	(*( MCDS_SPBEABND0_type *) 0xf00ee420u)	/* Comparator Bound Register 2 */
#define MCDS_SPBEABND3	(*( MCDS_SPBEABND0_type *) 0xf00ee430u)	/* Comparator Bound Register 3 */
#define MCDS_SRI1EABND0	(*( MCDS_SPBEABND0_type *) 0xf00ef400u)	/* Comparator Bound Register 0 */
#define MCDS_SRI1EABND1	(*( MCDS_SPBEABND0_type *) 0xf00ef410u)	/* Comparator Bound Register 1 */
#define MCDS_SRI1EABND2	(*( MCDS_SPBEABND0_type *) 0xf00ef420u)	/* Comparator Bound Register 2 */
#define MCDS_SRI1EABND3	(*( MCDS_SPBEABND0_type *) 0xf00ef430u)	/* Comparator Bound Register 3 */
#define MCDS_SRI2EABND0	(*( MCDS_SPBEABND0_type *) 0xf00ef600u)	/* Comparator Bound Register 0 */
#define MCDS_SRI2EABND1	(*( MCDS_SPBEABND0_type *) 0xf00ef610u)	/* Comparator Bound Register 1 */
#define MCDS_SRI2EABND2	(*( MCDS_SPBEABND0_type *) 0xf00ef620u)	/* Comparator Bound Register 2 */
#define MCDS_SRI2EABND3	(*( MCDS_SPBEABND0_type *) 0xf00ef630u)	/* Comparator Bound Register 3 */
#define MCDS_TCXEABND0	(*( MCDS_SPBEABND0_type *) 0xf00ea400u)	/* Comparator Bound Register 0 */
#define MCDS_TCXEABND1	(*( MCDS_SPBEABND0_type *) 0xf00ea410u)	/* Comparator Bound Register 1 */
#define MCDS_TCXEABND2	(*( MCDS_SPBEABND0_type *) 0xf00ea420u)	/* Comparator Bound Register 2 */
#define MCDS_TCXEABND3	(*( MCDS_SPBEABND0_type *) 0xf00ea430u)	/* Comparator Bound Register 3 */
#define MCDS_TCXEABND4	(*( MCDS_SPBEABND0_type *) 0xf00ea440u)	/* Comparator Bound Register 4 */
#define MCDS_TCXEABND5	(*( MCDS_SPBEABND0_type *) 0xf00ea450u)	/* Comparator Bound Register 5 */
#define MCDS_TCXEABND6	(*( MCDS_SPBEABND0_type *) 0xf00ea460u)	/* Comparator Bound Register 6 */
#define MCDS_TCXEABND7	(*( MCDS_SPBEABND0_type *) 0xf00ea470u)	/* Comparator Bound Register 7 */
#define MCDS_TCYEABND0	(*( MCDS_SPBEABND0_type *) 0xf00ec400u)	/* Comparator Bound Register 0 */
#define MCDS_TCYEABND1	(*( MCDS_SPBEABND0_type *) 0xf00ec410u)	/* Comparator Bound Register 1 */
#define MCDS_TCYEABND2	(*( MCDS_SPBEABND0_type *) 0xf00ec420u)	/* Comparator Bound Register 2 */
#define MCDS_TCYEABND3	(*( MCDS_SPBEABND0_type *) 0xf00ec430u)	/* Comparator Bound Register 3 */
#define MCDS_TCYEABND4	(*( MCDS_SPBEABND0_type *) 0xf00ec440u)	/* Comparator Bound Register 4 */
#define MCDS_TCYEABND5	(*( MCDS_SPBEABND0_type *) 0xf00ec450u)	/* Comparator Bound Register 5 */
#define MCDS_TCYEABND6	(*( MCDS_SPBEABND0_type *) 0xf00ec460u)	/* Comparator Bound Register 6 */
#define MCDS_TCYEABND7	(*( MCDS_SPBEABND0_type *) 0xf00ec470u)	/* Comparator Bound Register 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int RANGE          : 32;	/* Address Comparator range size */
	} B;
	int I;
	unsigned int U;

} MCDS_SPBEARNG0_type;
#define MCDS_SPBEARNG0	(*( MCDS_SPBEARNG0_type *) 0xf00ee404u)	/* Comparator Range Register 0 */
#define MCDS_SPBEARNG1	(*( MCDS_SPBEARNG0_type *) 0xf00ee414u)	/* Comparator Range Register 1 */
#define MCDS_SPBEARNG2	(*( MCDS_SPBEARNG0_type *) 0xf00ee424u)	/* Comparator Range Register 2 */
#define MCDS_SPBEARNG3	(*( MCDS_SPBEARNG0_type *) 0xf00ee434u)	/* Comparator Range Register 3 */
#define MCDS_SRI1EARNG0	(*( MCDS_SPBEARNG0_type *) 0xf00ef404u)	/* Comparator Range Register 0 */
#define MCDS_SRI1EARNG1	(*( MCDS_SPBEARNG0_type *) 0xf00ef414u)	/* Comparator Range Register 1 */
#define MCDS_SRI1EARNG2	(*( MCDS_SPBEARNG0_type *) 0xf00ef424u)	/* Comparator Range Register 2 */
#define MCDS_SRI1EARNG3	(*( MCDS_SPBEARNG0_type *) 0xf00ef434u)	/* Comparator Range Register 3 */
#define MCDS_SRI2EARNG0	(*( MCDS_SPBEARNG0_type *) 0xf00ef604u)	/* Comparator Range Register 0 */
#define MCDS_SRI2EARNG1	(*( MCDS_SPBEARNG0_type *) 0xf00ef614u)	/* Comparator Range Register 1 */
#define MCDS_SRI2EARNG2	(*( MCDS_SPBEARNG0_type *) 0xf00ef624u)	/* Comparator Range Register 2 */
#define MCDS_SRI2EARNG3	(*( MCDS_SPBEARNG0_type *) 0xf00ef634u)	/* Comparator Range Register 3 */
#define MCDS_TCXEARNG0	(*( MCDS_SPBEARNG0_type *) 0xf00ea404u)	/* Comparator Range Register 0 */
#define MCDS_TCXEARNG1	(*( MCDS_SPBEARNG0_type *) 0xf00ea414u)	/* Comparator Range Register 1 */
#define MCDS_TCXEARNG2	(*( MCDS_SPBEARNG0_type *) 0xf00ea424u)	/* Comparator Range Register 2 */
#define MCDS_TCXEARNG3	(*( MCDS_SPBEARNG0_type *) 0xf00ea434u)	/* Comparator Range Register 3 */
#define MCDS_TCXEARNG4	(*( MCDS_SPBEARNG0_type *) 0xf00ea444u)	/* Comparator Range Register 4 */
#define MCDS_TCXEARNG5	(*( MCDS_SPBEARNG0_type *) 0xf00ea454u)	/* Comparator Range Register 5 */
#define MCDS_TCXEARNG6	(*( MCDS_SPBEARNG0_type *) 0xf00ea464u)	/* Comparator Range Register 6 */
#define MCDS_TCXEARNG7	(*( MCDS_SPBEARNG0_type *) 0xf00ea474u)	/* Comparator Range Register 7 */
#define MCDS_TCYEARNG0	(*( MCDS_SPBEARNG0_type *) 0xf00ec404u)	/* Comparator Range Register 0 */
#define MCDS_TCYEARNG1	(*( MCDS_SPBEARNG0_type *) 0xf00ec414u)	/* Comparator Range Register 1 */
#define MCDS_TCYEARNG2	(*( MCDS_SPBEARNG0_type *) 0xf00ec424u)	/* Comparator Range Register 2 */
#define MCDS_TCYEARNG3	(*( MCDS_SPBEARNG0_type *) 0xf00ec434u)	/* Comparator Range Register 3 */
#define MCDS_TCYEARNG4	(*( MCDS_SPBEARNG0_type *) 0xf00ec444u)	/* Comparator Range Register 4 */
#define MCDS_TCYEARNG5	(*( MCDS_SPBEARNG0_type *) 0xf00ec454u)	/* Comparator Range Register 5 */
#define MCDS_TCYEARNG6	(*( MCDS_SPBEARNG0_type *) 0xf00ec464u)	/* Comparator Range Register 6 */
#define MCDS_TCYEARNG7	(*( MCDS_SPBEARNG0_type *) 0xf00ec474u)	/* Comparator Range Register 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int BOUND          : 32;	/* Data Comparator range lower bound */
	} B;
	int I;
	unsigned int U;

} MCDS_SPBWDBND0_type;
#define MCDS_SPBWDBND0	(*( MCDS_SPBWDBND0_type *) 0xf00ee480u)	/* Comparator Bound Register 0 */
#define MCDS_SPBWDBND1	(*( MCDS_SPBWDBND0_type *) 0xf00ee490u)	/* Comparator Bound Register 1 */
#define MCDS_SPBWDBND2	(*( MCDS_SPBWDBND0_type *) 0xf00ee4a0u)	/* Comparator Bound Register 2 */
#define MCDS_SPBWDBND3	(*( MCDS_SPBWDBND0_type *) 0xf00ee4b0u)	/* Comparator Bound Register 3 */
#define MCDS_SRI1WDBND0	(*( MCDS_SPBWDBND0_type *) 0xf00ef480u)	/* Comparator Bound Register 0 */
#define MCDS_SRI1WDBND1	(*( MCDS_SPBWDBND0_type *) 0xf00ef4a0u)	/* Comparator Bound Register 1 */
#define MCDS_SRI1WDBND2	(*( MCDS_SPBWDBND0_type *) 0xf00ef4c0u)	/* Comparator Bound Register 2 */
#define MCDS_SRI1WDBND3	(*( MCDS_SPBWDBND0_type *) 0xf00ef4e0u)	/* Comparator Bound Register 3 */
#define MCDS_SRI2WDBND0	(*( MCDS_SPBWDBND0_type *) 0xf00ef680u)	/* Comparator Bound Register 0 */
#define MCDS_SRI2WDBND1	(*( MCDS_SPBWDBND0_type *) 0xf00ef6a0u)	/* Comparator Bound Register 1 */
#define MCDS_SRI2WDBND2	(*( MCDS_SPBWDBND0_type *) 0xf00ef6c0u)	/* Comparator Bound Register 2 */
#define MCDS_SRI2WDBND3	(*( MCDS_SPBWDBND0_type *) 0xf00ef6e0u)	/* Comparator Bound Register 3 */
#define MCDS_TCXWDBND0	(*( MCDS_SPBWDBND0_type *) 0xf00ea480u)	/* Comparator Bound Register 0 */
#define MCDS_TCXWDBND1	(*( MCDS_SPBWDBND0_type *) 0xf00ea4a0u)	/* Comparator Bound Register 1 */
#define MCDS_TCXWDBND2	(*( MCDS_SPBWDBND0_type *) 0xf00ea4c0u)	/* Comparator Bound Register 2 */
#define MCDS_TCXWDBND3	(*( MCDS_SPBWDBND0_type *) 0xf00ea4e0u)	/* Comparator Bound Register 3 */
#define MCDS_TCYWDBND0	(*( MCDS_SPBWDBND0_type *) 0xf00ec480u)	/* Comparator Bound Register 0 */
#define MCDS_TCYWDBND1	(*( MCDS_SPBWDBND0_type *) 0xf00ec4a0u)	/* Comparator Bound Register 1 */
#define MCDS_TCYWDBND2	(*( MCDS_SPBWDBND0_type *) 0xf00ec4c0u)	/* Comparator Bound Register 2 */
#define MCDS_TCYWDBND3	(*( MCDS_SPBWDBND0_type *) 0xf00ec4e0u)	/* Comparator Bound Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int MASK           : 32;	/* Data Comparator bit mask */
	} B;
	int I;
	unsigned int U;

} MCDS_SPBWDMSK0_type;
#define MCDS_SPBWDMSK0	(*( MCDS_SPBWDMSK0_type *) 0xf00ee488u)	/* Comparator Mask Register 0 */
#define MCDS_SPBWDMSK1	(*( MCDS_SPBWDMSK0_type *) 0xf00ee498u)	/* Comparator Mask Register 1 */
#define MCDS_SPBWDMSK2	(*( MCDS_SPBWDMSK0_type *) 0xf00ee4a8u)	/* Comparator Mask Register 2 */
#define MCDS_SPBWDMSK3	(*( MCDS_SPBWDMSK0_type *) 0xf00ee4b8u)	/* Comparator Mask Register 3 */
#define MCDS_SRI1WDMSK0	(*( MCDS_SPBWDMSK0_type *) 0xf00ef490u)	/* Comparator Mask Register 0 */
#define MCDS_SRI1WDMSK1	(*( MCDS_SPBWDMSK0_type *) 0xf00ef4b0u)	/* Comparator Mask Register 1 */
#define MCDS_SRI1WDMSK2	(*( MCDS_SPBWDMSK0_type *) 0xf00ef4d0u)	/* Comparator Mask Register 2 */
#define MCDS_SRI1WDMSK3	(*( MCDS_SPBWDMSK0_type *) 0xf00ef4f0u)	/* Comparator Mask Register 3 */
#define MCDS_SRI2WDMSK0	(*( MCDS_SPBWDMSK0_type *) 0xf00ef690u)	/* Comparator Mask Register 0 */
#define MCDS_SRI2WDMSK1	(*( MCDS_SPBWDMSK0_type *) 0xf00ef6b0u)	/* Comparator Mask Register 1 */
#define MCDS_SRI2WDMSK2	(*( MCDS_SPBWDMSK0_type *) 0xf00ef6d0u)	/* Comparator Mask Register 2 */
#define MCDS_SRI2WDMSK3	(*( MCDS_SPBWDMSK0_type *) 0xf00ef6f0u)	/* Comparator Mask Register 3 */
#define MCDS_TCXWDMSK0	(*( MCDS_SPBWDMSK0_type *) 0xf00ea490u)	/* Comparator Mask Register 0 */
#define MCDS_TCXWDMSK1	(*( MCDS_SPBWDMSK0_type *) 0xf00ea4b0u)	/* Comparator Mask Register 1 */
#define MCDS_TCXWDMSK2	(*( MCDS_SPBWDMSK0_type *) 0xf00ea4d0u)	/* Comparator Mask Register 2 */
#define MCDS_TCXWDMSK3	(*( MCDS_SPBWDMSK0_type *) 0xf00ea4f0u)	/* Comparator Mask Register 3 */
#define MCDS_TCYWDMSK0	(*( MCDS_SPBWDMSK0_type *) 0xf00ec490u)	/* Comparator Mask Register 0 */
#define MCDS_TCYWDMSK1	(*( MCDS_SPBWDMSK0_type *) 0xf00ec4b0u)	/* Comparator Mask Register 1 */
#define MCDS_TCYWDMSK2	(*( MCDS_SPBWDMSK0_type *) 0xf00ec4d0u)	/* Comparator Mask Register 2 */
#define MCDS_TCYWDMSK3	(*( MCDS_SPBWDMSK0_type *) 0xf00ec4f0u)	/* Comparator Mask Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int RANGE          : 32;	/* Data Comparator range size */
	} B;
	int I;
	unsigned int U;

} MCDS_SPBWDRNG0_type;
#define MCDS_SPBWDRNG0	(*( MCDS_SPBWDRNG0_type *) 0xf00ee484u)	/* Comparator Range Register 0 */
#define MCDS_SPBWDRNG1	(*( MCDS_SPBWDRNG0_type *) 0xf00ee494u)	/* Comparator Range Register 1 */
#define MCDS_SPBWDRNG2	(*( MCDS_SPBWDRNG0_type *) 0xf00ee4a4u)	/* Comparator Range Register 2 */
#define MCDS_SPBWDRNG3	(*( MCDS_SPBWDRNG0_type *) 0xf00ee4b4u)	/* Comparator Range Register 3 */
#define MCDS_SRI1WDRNG0	(*( MCDS_SPBWDRNG0_type *) 0xf00ef488u)	/* Comparator Range Register 0 */
#define MCDS_SRI1WDRNG1	(*( MCDS_SPBWDRNG0_type *) 0xf00ef4a8u)	/* Comparator Range Register 1 */
#define MCDS_SRI1WDRNG2	(*( MCDS_SPBWDRNG0_type *) 0xf00ef4c8u)	/* Comparator Range Register 2 */
#define MCDS_SRI1WDRNG3	(*( MCDS_SPBWDRNG0_type *) 0xf00ef4e8u)	/* Comparator Range Register 3 */
#define MCDS_SRI2WDRNG0	(*( MCDS_SPBWDRNG0_type *) 0xf00ef688u)	/* Comparator Range Register 0 */
#define MCDS_SRI2WDRNG1	(*( MCDS_SPBWDRNG0_type *) 0xf00ef6a8u)	/* Comparator Range Register 1 */
#define MCDS_SRI2WDRNG2	(*( MCDS_SPBWDRNG0_type *) 0xf00ef6c8u)	/* Comparator Range Register 2 */
#define MCDS_SRI2WDRNG3	(*( MCDS_SPBWDRNG0_type *) 0xf00ef6e8u)	/* Comparator Range Register 3 */
#define MCDS_TCXWDRNG0	(*( MCDS_SPBWDRNG0_type *) 0xf00ea488u)	/* Comparator Range Register 0 */
#define MCDS_TCXWDRNG1	(*( MCDS_SPBWDRNG0_type *) 0xf00ea4a8u)	/* Comparator Range Register 1 */
#define MCDS_TCXWDRNG2	(*( MCDS_SPBWDRNG0_type *) 0xf00ea4c8u)	/* Comparator Range Register 2 */
#define MCDS_TCXWDRNG3	(*( MCDS_SPBWDRNG0_type *) 0xf00ea4e8u)	/* Comparator Range Register 3 */
#define MCDS_TCYWDRNG0	(*( MCDS_SPBWDRNG0_type *) 0xf00ec488u)	/* Comparator Range Register 0 */
#define MCDS_TCYWDRNG1	(*( MCDS_SPBWDRNG0_type *) 0xf00ec4a8u)	/* Comparator Range Register 1 */
#define MCDS_TCYWDRNG2	(*( MCDS_SPBWDRNG0_type *) 0xf00ec4c8u)	/* Comparator Range Register 2 */
#define MCDS_TCYWDRNG3	(*( MCDS_SPBWDRNG0_type *) 0xf00ec4e8u)	/* Comparator Range Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int SIGN           : 5;	/* Bit number (1?31) of sign bit */
		unsigned int                : 9;
		unsigned int EITHER         : 1;	/* RANGE matching either side of BOUND */
		unsigned int BELOW          : 1;	/* RANGE matching lower side of BOUND */
		unsigned int RELOAD         : 4;	/* Reload Event Selector */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} MCDS_SPBWDSGN0_type;
#define MCDS_SPBWDSGN0	(*( MCDS_SPBWDSGN0_type *) 0xf00ee48cu)	/* Comparator Sign Register 0 */
#define MCDS_SPBWDSGN1	(*( MCDS_SPBWDSGN0_type *) 0xf00ee49cu)	/* Comparator Sign Register 1 */
#define MCDS_SPBWDSGN2	(*( MCDS_SPBWDSGN0_type *) 0xf00ee4acu)	/* Comparator Sign Register 2 */
#define MCDS_SPBWDSGN3	(*( MCDS_SPBWDSGN0_type *) 0xf00ee4bcu)	/* Comparator Sign Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int BOUND          : 32;	/* Comparator range lower bound */
	} B;
	int I;
	unsigned int U;

} MCDS_SRI1BALBND0_type;
#define MCDS_SRI1BALBND0	(*( MCDS_SRI1BALBND0_type *) 0xf00ef210u)	/* Lookup Table Base Register */
#define MCDS_SRI1BALBND1	(*( MCDS_SRI1BALBND0_type *) 0xf00ef220u)	/* Lookup Table Base Register */
#define MCDS_SRI1BALBND2	(*( MCDS_SRI1BALBND0_type *) 0xf00ef230u)	/* Lookup Table Base Register */
#define MCDS_SRI1BALBND3	(*( MCDS_SRI1BALBND0_type *) 0xf00ef240u)	/* Lookup Table Base Register */
#define MCDS_SRI2BALBND0	(*( MCDS_SRI1BALBND0_type *) 0xf00ef310u)	/* Lookup Table Base Register */
#define MCDS_SRI2BALBND1	(*( MCDS_SRI1BALBND0_type *) 0xf00ef320u)	/* Lookup Table Base Register */
#define MCDS_SRI2BALBND2	(*( MCDS_SRI1BALBND0_type *) 0xf00ef330u)	/* Lookup Table Base Register */
#define MCDS_SRI2BALBND3	(*( MCDS_SRI1BALBND0_type *) 0xf00ef340u)	/* Lookup Table Base Register */
#define MCDS_TCXPALBND0	(*( MCDS_SRI1BALBND0_type *) 0xf00ea210u)	/* Lookup Table Base Register */
#define MCDS_TCXPALBND1	(*( MCDS_SRI1BALBND0_type *) 0xf00ea220u)	/* Lookup Table Base Register */
#define MCDS_TCXPALBND2	(*( MCDS_SRI1BALBND0_type *) 0xf00ea230u)	/* Lookup Table Base Register */
#define MCDS_TCXPALBND3	(*( MCDS_SRI1BALBND0_type *) 0xf00ea240u)	/* Lookup Table Base Register */
#define MCDS_TCYPALBND0	(*( MCDS_SRI1BALBND0_type *) 0xf00ec210u)	/* Lookup Table Base Register */
#define MCDS_TCYPALBND1	(*( MCDS_SRI1BALBND0_type *) 0xf00ec220u)	/* Lookup Table Base Register */
#define MCDS_TCYPALBND2	(*( MCDS_SRI1BALBND0_type *) 0xf00ec230u)	/* Lookup Table Base Register */
#define MCDS_TCYPALBND3	(*( MCDS_SRI1BALBND0_type *) 0xf00ec240u)	/* Lookup Table Base Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int ADDR           : 10;	/* Address pointer */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} MCDS_SRI1BALLUTA_type;
#define MCDS_SRI1BALLUTA	(*( MCDS_SRI1BALLUTA_type *) 0xf00ef204u)	/* Lookup Table Address Register */
#define MCDS_SRI2BALLUTA	(*( MCDS_SRI1BALLUTA_type *) 0xf00ef304u)	/* Lookup Table Address Register */
#define MCDS_TCXPALLUTA	(*( MCDS_SRI1BALLUTA_type *) 0xf00ea204u)	/* Lookup Table Address Register */
#define MCDS_TCYPALLUTA	(*( MCDS_SRI1BALLUTA_type *) 0xf00ec204u)	/* Lookup Table Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DATA           : 32;	/* Data transfer register */
	} B;
	int I;
	unsigned int U;

} MCDS_SRI1BALLUTD_type;
#define MCDS_SRI1BALLUTD	(*( MCDS_SRI1BALLUTD_type *) 0xf00ef200u)	/* Lookup Table Data Register */
#define MCDS_SRI2BALLUTD	(*( MCDS_SRI1BALLUTD_type *) 0xf00ef300u)	/* Lookup Table Data Register */
#define MCDS_TCXPALLUTD	(*( MCDS_SRI1BALLUTD_type *) 0xf00ea200u)	/* Lookup Table Data Register */
#define MCDS_TCYPALLUTD	(*( MCDS_SRI1BALLUTD_type *) 0xf00ec200u)	/* Lookup Table Data Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int OFFSET         : 10;	/* Lookup table location in RAM */
		unsigned int                : 16;
		unsigned int GRAIN          : 3;	/* Lookup table granularity */
		unsigned int EN             : 1;	/* Lookup table active */
	} B;
	int I;
	unsigned int U;

} MCDS_SRI1BALMAP0_type;
#define MCDS_SRI1BALMAP0	(*( MCDS_SRI1BALMAP0_type *) 0xf00ef218u)	/* Lookup Table Mapping Register */
#define MCDS_SRI1BALMAP1	(*( MCDS_SRI1BALMAP0_type *) 0xf00ef228u)	/* Lookup Table Mapping Register */
#define MCDS_SRI1BALMAP2	(*( MCDS_SRI1BALMAP0_type *) 0xf00ef238u)	/* Lookup Table Mapping Register */
#define MCDS_SRI1BALMAP3	(*( MCDS_SRI1BALMAP0_type *) 0xf00ef248u)	/* Lookup Table Mapping Register */
#define MCDS_SRI2BALMAP0	(*( MCDS_SRI1BALMAP0_type *) 0xf00ef318u)	/* Lookup Table Mapping Register */
#define MCDS_SRI2BALMAP1	(*( MCDS_SRI1BALMAP0_type *) 0xf00ef328u)	/* Lookup Table Mapping Register */
#define MCDS_SRI2BALMAP2	(*( MCDS_SRI1BALMAP0_type *) 0xf00ef338u)	/* Lookup Table Mapping Register */
#define MCDS_SRI2BALMAP3	(*( MCDS_SRI1BALMAP0_type *) 0xf00ef348u)	/* Lookup Table Mapping Register */
#define MCDS_TCXPALMAP0	(*( MCDS_SRI1BALMAP0_type *) 0xf00ea218u)	/* Lookup Table Mapping Register */
#define MCDS_TCXPALMAP1	(*( MCDS_SRI1BALMAP0_type *) 0xf00ea228u)	/* Lookup Table Mapping Register */
#define MCDS_TCXPALMAP2	(*( MCDS_SRI1BALMAP0_type *) 0xf00ea238u)	/* Lookup Table Mapping Register */
#define MCDS_TCXPALMAP3	(*( MCDS_SRI1BALMAP0_type *) 0xf00ea248u)	/* Lookup Table Mapping Register */
#define MCDS_TCYPALMAP0	(*( MCDS_SRI1BALMAP0_type *) 0xf00ec218u)	/* Lookup Table Mapping Register */
#define MCDS_TCYPALMAP1	(*( MCDS_SRI1BALMAP0_type *) 0xf00ec228u)	/* Lookup Table Mapping Register */
#define MCDS_TCYPALMAP2	(*( MCDS_SRI1BALMAP0_type *) 0xf00ec238u)	/* Lookup Table Mapping Register */
#define MCDS_TCYPALMAP3	(*( MCDS_SRI1BALMAP0_type *) 0xf00ec248u)	/* Lookup Table Mapping Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RANGE          : 32;	/* Lookup table range size */
	} B;
	int I;
	unsigned int U;

} MCDS_SRI1BALRNG0_type;
#define MCDS_SRI1BALRNG0	(*( MCDS_SRI1BALRNG0_type *) 0xf00ef214u)	/* Lookup Table Range Register */
#define MCDS_SRI1BALRNG1	(*( MCDS_SRI1BALRNG0_type *) 0xf00ef224u)	/* Lookup Table Range Register */
#define MCDS_SRI1BALRNG2	(*( MCDS_SRI1BALRNG0_type *) 0xf00ef234u)	/* Lookup Table Range Register */
#define MCDS_SRI1BALRNG3	(*( MCDS_SRI1BALRNG0_type *) 0xf00ef244u)	/* Lookup Table Range Register */
#define MCDS_SRI2BALRNG0	(*( MCDS_SRI1BALRNG0_type *) 0xf00ef314u)	/* Lookup Table Range Register */
#define MCDS_SRI2BALRNG1	(*( MCDS_SRI1BALRNG0_type *) 0xf00ef324u)	/* Lookup Table Range Register */
#define MCDS_SRI2BALRNG2	(*( MCDS_SRI1BALRNG0_type *) 0xf00ef334u)	/* Lookup Table Range Register */
#define MCDS_SRI2BALRNG3	(*( MCDS_SRI1BALRNG0_type *) 0xf00ef344u)	/* Lookup Table Range Register */
#define MCDS_TCXPALRNG0	(*( MCDS_SRI1BALRNG0_type *) 0xf00ea214u)	/* Lookup Table Range Register */
#define MCDS_TCXPALRNG1	(*( MCDS_SRI1BALRNG0_type *) 0xf00ea224u)	/* Lookup Table Range Register */
#define MCDS_TCXPALRNG2	(*( MCDS_SRI1BALRNG0_type *) 0xf00ea234u)	/* Lookup Table Range Register */
#define MCDS_TCXPALRNG3	(*( MCDS_SRI1BALRNG0_type *) 0xf00ea244u)	/* Lookup Table Range Register */
#define MCDS_TCYPALRNG0	(*( MCDS_SRI1BALRNG0_type *) 0xf00ec214u)	/* Lookup Table Range Register */
#define MCDS_TCYPALRNG1	(*( MCDS_SRI1BALRNG0_type *) 0xf00ec224u)	/* Lookup Table Range Register */
#define MCDS_TCYPALRNG2	(*( MCDS_SRI1BALRNG0_type *) 0xf00ec234u)	/* Lookup Table Range Register */
#define MCDS_TCYPALRNG3	(*( MCDS_SRI1BALRNG0_type *) 0xf00ec244u)	/* Lookup Table Range Register */

typedef volatile union
{
	struct
	{ 
		unsigned int BOUND          : 32;	/* Data Comparator range lower bound high word */
	} B;
	int I;
	unsigned int U;

} MCDS_SRI1WDHBND0_type;
#define MCDS_SRI1WDHBND0	(*( MCDS_SRI1WDHBND0_type *) 0xf00ef484u)	/* Comparator Bound Register 0 */
#define MCDS_SRI1WDHBND1	(*( MCDS_SRI1WDHBND0_type *) 0xf00ef4a4u)	/* Comparator Bound Register 1 */
#define MCDS_SRI1WDHBND2	(*( MCDS_SRI1WDHBND0_type *) 0xf00ef4c4u)	/* Comparator Bound Register 2 */
#define MCDS_SRI1WDHBND3	(*( MCDS_SRI1WDHBND0_type *) 0xf00ef4e4u)	/* Comparator Bound Register 3 */
#define MCDS_SRI2WDHBND0	(*( MCDS_SRI1WDHBND0_type *) 0xf00ef684u)	/* Comparator Bound Register 0 */
#define MCDS_SRI2WDHBND1	(*( MCDS_SRI1WDHBND0_type *) 0xf00ef6a4u)	/* Comparator Bound Register 1 */
#define MCDS_SRI2WDHBND2	(*( MCDS_SRI1WDHBND0_type *) 0xf00ef6c4u)	/* Comparator Bound Register 2 */
#define MCDS_SRI2WDHBND3	(*( MCDS_SRI1WDHBND0_type *) 0xf00ef6e4u)	/* Comparator Bound Register 3 */
#define MCDS_TCXWDHBND0	(*( MCDS_SRI1WDHBND0_type *) 0xf00ea484u)	/* Comparator Bound Register 0 */
#define MCDS_TCXWDHBND1	(*( MCDS_SRI1WDHBND0_type *) 0xf00ea4a4u)	/* Comparator Bound Register 1 */
#define MCDS_TCXWDHBND2	(*( MCDS_SRI1WDHBND0_type *) 0xf00ea4c4u)	/* Comparator Bound Register 2 */
#define MCDS_TCXWDHBND3	(*( MCDS_SRI1WDHBND0_type *) 0xf00ea4e4u)	/* Comparator Bound Register 3 */
#define MCDS_TCYWDHBND0	(*( MCDS_SRI1WDHBND0_type *) 0xf00ec484u)	/* Comparator Bound Register 0 */
#define MCDS_TCYWDHBND1	(*( MCDS_SRI1WDHBND0_type *) 0xf00ec4a4u)	/* Comparator Bound Register 1 */
#define MCDS_TCYWDHBND2	(*( MCDS_SRI1WDHBND0_type *) 0xf00ec4c4u)	/* Comparator Bound Register 2 */
#define MCDS_TCYWDHBND3	(*( MCDS_SRI1WDHBND0_type *) 0xf00ec4e4u)	/* Comparator Bound Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int MASK           : 32;	/* Data Comparator bit mask high word */
	} B;
	int I;
	unsigned int U;

} MCDS_SRI1WDHMSK0_type;
#define MCDS_SRI1WDHMSK0	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ef494u)	/* Comparator Mask Register 0 */
#define MCDS_SRI1WDHMSK1	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ef4b4u)	/* Comparator Mask Register 1 */
#define MCDS_SRI1WDHMSK2	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ef4d4u)	/* Comparator Mask Register 2 */
#define MCDS_SRI1WDHMSK3	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ef4f4u)	/* Comparator Mask Register 3 */
#define MCDS_SRI2WDHMSK0	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ef694u)	/* Comparator Mask Register 0 */
#define MCDS_SRI2WDHMSK1	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ef6b4u)	/* Comparator Mask Register 1 */
#define MCDS_SRI2WDHMSK2	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ef6d4u)	/* Comparator Mask Register 2 */
#define MCDS_SRI2WDHMSK3	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ef6f4u)	/* Comparator Mask Register 3 */
#define MCDS_TCXWDHMSK0	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ea494u)	/* Comparator Mask Register 0 */
#define MCDS_TCXWDHMSK1	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ea4b4u)	/* Comparator Mask Register 1 */
#define MCDS_TCXWDHMSK2	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ea4d4u)	/* Comparator Mask Register 2 */
#define MCDS_TCXWDHMSK3	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ea4f4u)	/* Comparator Mask Register 3 */
#define MCDS_TCYWDHMSK0	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ec494u)	/* Comparator Mask Register 0 */
#define MCDS_TCYWDHMSK1	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ec4b4u)	/* Comparator Mask Register 1 */
#define MCDS_TCYWDHMSK2	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ec4d4u)	/* Comparator Mask Register 2 */
#define MCDS_TCYWDHMSK3	(*( MCDS_SRI1WDHMSK0_type *) 0xf00ec4f4u)	/* Comparator Mask Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int RANGE          : 32;	/* Data Comparator range size high word */
	} B;
	int I;
	unsigned int U;

} MCDS_SRI1WDHRNG0_type;
#define MCDS_SRI1WDHRNG0	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ef48cu)	/* Comparator Range Register 0 */
#define MCDS_SRI1WDHRNG1	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ef4acu)	/* Comparator Range Register 1 */
#define MCDS_SRI1WDHRNG2	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ef4ccu)	/* Comparator Range Register 2 */
#define MCDS_SRI1WDHRNG3	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ef4ecu)	/* Comparator Range Register 3 */
#define MCDS_SRI2WDHRNG0	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ef68cu)	/* Comparator Range Register 0 */
#define MCDS_SRI2WDHRNG1	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ef6acu)	/* Comparator Range Register 1 */
#define MCDS_SRI2WDHRNG2	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ef6ccu)	/* Comparator Range Register 2 */
#define MCDS_SRI2WDHRNG3	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ef6ecu)	/* Comparator Range Register 3 */
#define MCDS_TCXWDHRNG0	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ea48cu)	/* Comparator Range Register 0 */
#define MCDS_TCXWDHRNG1	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ea4acu)	/* Comparator Range Register 1 */
#define MCDS_TCXWDHRNG2	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ea4ccu)	/* Comparator Range Register 2 */
#define MCDS_TCXWDHRNG3	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ea4ecu)	/* Comparator Range Register 3 */
#define MCDS_TCYWDHRNG0	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ec48cu)	/* Comparator Range Register 0 */
#define MCDS_TCYWDHRNG1	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ec4acu)	/* Comparator Range Register 1 */
#define MCDS_TCYWDHRNG2	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ec4ccu)	/* Comparator Range Register 2 */
#define MCDS_TCYWDHRNG3	(*( MCDS_SRI1WDHRNG0_type *) 0xf00ec4ecu)	/* Comparator Range Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int SIGN           : 6;	/* Bit number (1?63) of sign bit */
		unsigned int                : 8;
		unsigned int EITHER         : 1;	/* RANGE matching either side of BOUND */
		unsigned int BELOW          : 1;	/* RANGE matching lower side of BOUND */
		unsigned int RELOAD         : 4;	/* Reload Event Selector */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} MCDS_SRI1WDSGN0_type;
#define MCDS_SRI1WDSGN0	(*( MCDS_SRI1WDSGN0_type *) 0xf00ef49cu)	/* Comparator Sign Register 0 */
#define MCDS_SRI1WDSGN1	(*( MCDS_SRI1WDSGN0_type *) 0xf00ef4bcu)	/* Comparator Sign Register 1 */
#define MCDS_SRI1WDSGN2	(*( MCDS_SRI1WDSGN0_type *) 0xf00ef4dcu)	/* Comparator Sign Register 2 */
#define MCDS_SRI1WDSGN3	(*( MCDS_SRI1WDSGN0_type *) 0xf00ef4fcu)	/* Comparator Sign Register 3 */
#define MCDS_SRI2WDSGN0	(*( MCDS_SRI1WDSGN0_type *) 0xf00ef69cu)	/* Comparator Sign Register 0 */
#define MCDS_SRI2WDSGN1	(*( MCDS_SRI1WDSGN0_type *) 0xf00ef6bcu)	/* Comparator Sign Register 1 */
#define MCDS_SRI2WDSGN2	(*( MCDS_SRI1WDSGN0_type *) 0xf00ef6dcu)	/* Comparator Sign Register 2 */
#define MCDS_SRI2WDSGN3	(*( MCDS_SRI1WDSGN0_type *) 0xf00ef6fcu)	/* Comparator Sign Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int EI             : 1;	/* ENDINIT Protection Flag */
		/* const */ unsigned int SUS            : 1;	/* Suspended Flag */
		/* const */ unsigned int ERR            : 1;	/* Error Flag */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int SYSRES         : 1;	/* System Reset (Class 0) Flag */
		/* const */ unsigned int APPRES         : 1;	/* Application Reset (Class 3) Flag */
		/* const */ unsigned int CLKDIV         : 2;	/* Current Clock Divider */
		/* const */ unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} MCDS_SRIDCSTS_type;
#define MCDS_SRIDCSTS	(*( MCDS_SRIDCSTS_type *) 0xf00ef000u)	/* Debug Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CURRENT        : 2;	/* Current Process ID */
		/* const */ unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} MCDS_TCXCID_type;
#define MCDS_TCXCID	(*( MCDS_TCXCID_type *) 0xf00ea004u)	/* Current Process ID */
#define MCDS_TCYCID	(*( MCDS_TCXCID_type *) 0xf00ec004u)	/* Current Process ID */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 1;
		/* const */ unsigned int CURRENT        : 31;	/* Current Instruction Pointer */
	} B;
	int I;
	unsigned int U;

} MCDS_TCXCIP_type;
#define MCDS_TCXCIP	(*( MCDS_TCXCIP_type *) 0xf00ea008u)	/* Current Instruction Pointer */
#define MCDS_TCYCIP	(*( MCDS_TCXCIP_type *) 0xf00ec008u)	/* Current Instruction Pointer */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SUS            : 1;	/* Suspended Flag */
		/* const */ unsigned int IDLE           : 1;	/* Run Flag */
		/* const */ unsigned int HALT           : 1;	/* Halted Flag */
		/* const */ unsigned int ISR            : 1;	/* Interrupt Service Flag */
		/* const */ unsigned int HBRK           : 1;	/* Hardware Break Flag */
		/* const */ unsigned int SBRK           : 1;	/* Software Break Flag */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int IEN            : 1;	/* Interrupt Enable Flag */
		/* const */ unsigned int DBGEN          : 1;	/* Debug Enabled Flag */
		/* const */ unsigned int CLKDIV         : 2;	/* Current Clock Divider */
		/* const */ unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} MCDS_TCXDCSTS_type;
#define MCDS_TCXDCSTS	(*( MCDS_TCXDCSTS_type *) 0xf00ea000u)	/* Debug Status Register */
#define MCDS_TCYDCSTS	(*( MCDS_TCXDCSTS_type *) 0xf00ec000u)	/* Debug Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int BOUND          : 2;	/* Process ID Comparator range lower bound */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} MCDS_TCXIDBND0_type;
#define MCDS_TCXIDBND0	(*( MCDS_TCXIDBND0_type *) 0xf00eac00u)	/* Comparator Bound Register 0 */
#define MCDS_TCXIDBND1	(*( MCDS_TCXIDBND0_type *) 0xf00eac10u)	/* Comparator Bound Register 1 */
#define MCDS_TCYIDBND0	(*( MCDS_TCXIDBND0_type *) 0xf00ecc00u)	/* Comparator Bound Register 0 */
#define MCDS_TCYIDBND1	(*( MCDS_TCXIDBND0_type *) 0xf00ecc10u)	/* Comparator Bound Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int MASK           : 2;	/* Process ID Comparator bit mask */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} MCDS_TCXIDMSK0_type;
#define MCDS_TCXIDMSK0	(*( MCDS_TCXIDMSK0_type *) 0xf00eac08u)	/* Comparator Mask Register 0 */
#define MCDS_TCXIDMSK1	(*( MCDS_TCXIDMSK0_type *) 0xf00eac18u)	/* Comparator Mask Register 1 */
#define MCDS_TCYIDMSK0	(*( MCDS_TCXIDMSK0_type *) 0xf00ecc08u)	/* Comparator Mask Register 0 */
#define MCDS_TCYIDMSK1	(*( MCDS_TCXIDMSK0_type *) 0xf00ecc18u)	/* Comparator Mask Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int RANGE          : 2;	/* Process ID Comparator range size */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} MCDS_TCXIDRNG0_type;
#define MCDS_TCXIDRNG0	(*( MCDS_TCXIDRNG0_type *) 0xf00eac04u)	/* Comparator Range Register 0 */
#define MCDS_TCXIDRNG1	(*( MCDS_TCXIDRNG0_type *) 0xf00eac14u)	/* Comparator Range Register 1 */
#define MCDS_TCYIDRNG0	(*( MCDS_TCXIDRNG0_type *) 0xf00ecc04u)	/* Comparator Range Register 0 */
#define MCDS_TCYIDRNG1	(*( MCDS_TCXIDRNG0_type *) 0xf00ecc14u)	/* Comparator Range Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int SIGN           : 1;	/* Bit number (1) of sign bit */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} MCDS_TCXIDSGN0_type;
#define MCDS_TCXIDSGN0	(*( MCDS_TCXIDSGN0_type *) 0xf00eac0cu)	/* Comparator Sign Register 0 */
#define MCDS_TCXIDSGN1	(*( MCDS_TCXIDSGN0_type *) 0xf00eac1cu)	/* Comparator Sign Register 1 */
#define MCDS_TCYIDSGN0	(*( MCDS_TCXIDSGN0_type *) 0xf00ecc0cu)	/* Comparator Sign Register 0 */
#define MCDS_TCYIDSGN1	(*( MCDS_TCXIDSGN0_type *) 0xf00ecc1cu)	/* Comparator Sign Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		unsigned int BOUND          : 31;	/* IP Comparator range lower bound */
	} B;
	int I;
	unsigned int U;

} MCDS_TCXIPBND0_type;
#define MCDS_TCXIPBND0	(*( MCDS_TCXIPBND0_type *) 0xf00eb000u)	/* Comparator Bound Register 0 */
#define MCDS_TCXIPBND1	(*( MCDS_TCXIPBND0_type *) 0xf00eb010u)	/* Comparator Bound Register 1 */
#define MCDS_TCXIPBND2	(*( MCDS_TCXIPBND0_type *) 0xf00eb020u)	/* Comparator Bound Register 2 */
#define MCDS_TCXIPBND3	(*( MCDS_TCXIPBND0_type *) 0xf00eb030u)	/* Comparator Bound Register 3 */
#define MCDS_TCXIPBND4	(*( MCDS_TCXIPBND0_type *) 0xf00eb040u)	/* Comparator Bound Register 4 */
#define MCDS_TCXIPBND5	(*( MCDS_TCXIPBND0_type *) 0xf00eb050u)	/* Comparator Bound Register 5 */
#define MCDS_TCYIPBND0	(*( MCDS_TCXIPBND0_type *) 0xf00ed000u)	/* Comparator Bound Register 0 */
#define MCDS_TCYIPBND1	(*( MCDS_TCXIPBND0_type *) 0xf00ed010u)	/* Comparator Bound Register 1 */
#define MCDS_TCYIPBND2	(*( MCDS_TCXIPBND0_type *) 0xf00ed020u)	/* Comparator Bound Register 2 */
#define MCDS_TCYIPBND3	(*( MCDS_TCXIPBND0_type *) 0xf00ed030u)	/* Comparator Bound Register 3 */
#define MCDS_TCYIPBND4	(*( MCDS_TCXIPBND0_type *) 0xf00ed040u)	/* Comparator Bound Register 4 */
#define MCDS_TCYIPBND5	(*( MCDS_TCXIPBND0_type *) 0xf00ed050u)	/* Comparator Bound Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		unsigned int RANGE          : 31;	/* IP Comparator range size */
	} B;
	int I;
	unsigned int U;

} MCDS_TCXIPRNG0_type;
#define MCDS_TCXIPRNG0	(*( MCDS_TCXIPRNG0_type *) 0xf00eb004u)	/* Comparator Range Register 0 */
#define MCDS_TCXIPRNG1	(*( MCDS_TCXIPRNG0_type *) 0xf00eb014u)	/* Comparator Range Register 1 */
#define MCDS_TCXIPRNG2	(*( MCDS_TCXIPRNG0_type *) 0xf00eb024u)	/* Comparator Range Register 2 */
#define MCDS_TCXIPRNG3	(*( MCDS_TCXIPRNG0_type *) 0xf00eb034u)	/* Comparator Range Register 3 */
#define MCDS_TCXIPRNG4	(*( MCDS_TCXIPRNG0_type *) 0xf00eb044u)	/* Comparator Range Register 4 */
#define MCDS_TCXIPRNG5	(*( MCDS_TCXIPRNG0_type *) 0xf00eb054u)	/* Comparator Range Register 5 */
#define MCDS_TCYIPRNG0	(*( MCDS_TCXIPRNG0_type *) 0xf00ed004u)	/* Comparator Range Register 0 */
#define MCDS_TCYIPRNG1	(*( MCDS_TCXIPRNG0_type *) 0xf00ed014u)	/* Comparator Range Register 1 */
#define MCDS_TCYIPRNG2	(*( MCDS_TCXIPRNG0_type *) 0xf00ed024u)	/* Comparator Range Register 2 */
#define MCDS_TCYIPRNG3	(*( MCDS_TCXIPRNG0_type *) 0xf00ed034u)	/* Comparator Range Register 3 */
#define MCDS_TCYIPRNG4	(*( MCDS_TCXIPRNG0_type *) 0xf00ed044u)	/* Comparator Range Register 4 */
#define MCDS_TCYIPRNG5	(*( MCDS_TCXIPRNG0_type *) 0xf00ed054u)	/* Comparator Range Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int SIGN           : 6;	/* Bit number (1?63) of sign bit */
		unsigned int                : 8;
		unsigned int EITHER         : 1;	/* RANGE matching either side of BOUND */
		unsigned int BELOW          : 1;	/* RANGE matching lower side of BOUND */
		unsigned int RELOAD         : 4;	/* Reload Event Selector */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} MCDS_TCXWDSGN0_type;
#define MCDS_TCXWDSGN0	(*( MCDS_TCXWDSGN0_type *) 0xf00ea49cu)	/* Comparator Sign Register 0 */
#define MCDS_TCXWDSGN1	(*( MCDS_TCXWDSGN0_type *) 0xf00ea4bcu)	/* Comparator Sign Register 1 */
#define MCDS_TCXWDSGN2	(*( MCDS_TCXWDSGN0_type *) 0xf00ea4dcu)	/* Comparator Sign Register 2 */
#define MCDS_TCXWDSGN3	(*( MCDS_TCXWDSGN0_type *) 0xf00ea4fcu)	/* Comparator Sign Register 3 */
#define MCDS_TCYWDSGN0	(*( MCDS_TCXWDSGN0_type *) 0xf00ec49cu)	/* Comparator Sign Register 0 */
#define MCDS_TCYWDSGN1	(*( MCDS_TCXWDSGN0_type *) 0xf00ec4bcu)	/* Comparator Sign Register 1 */
#define MCDS_TCYWDSGN2	(*( MCDS_TCXWDSGN0_type *) 0xf00ec4dcu)	/* Comparator Sign Register 2 */
#define MCDS_TCYWDSGN3	(*( MCDS_TCXWDSGN0_type *) 0xf00ec4fcu)	/* Comparator Sign Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int COUNT          : 32;	/* Current Count Value */
	} B;
	int I;
	unsigned int U;

} MCDS_TSUEMUCNT_type;
#define MCDS_TSUEMUCNT	(*( MCDS_TSUEMUCNT_type *) 0xf00e8408u)	/* Clock Counter Register */
#define MCDS_TSUREFCNT	(*( MCDS_TSUEMUCNT_type *) 0xf00e8400u)	/* Clock Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RELOAD         : 32;	/* Prescaler Reload Value */
	} B;
	int I;
	unsigned int U;

} MCDS_TSUPRSCL_type;
#define MCDS_TSUPRSCL	(*( MCDS_TSUPRSCL_type *) 0xf00e8404u)	/* Clock Prescaler Register */


/* AGBT */
typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Disable Status Bit */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} AGBT_CLC_type;
#define AGBT_CLC	(*( AGBT_CLC_type *) 0xf00e1000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DFTREN         : 1;	/* DFT RECEIVER Enable */
		/* const */ unsigned int DFTANAAC       : 1;	/* DFT Monitor of analog test output status */
		/* const */ unsigned int DFTCIT         : 1;	/* DFT Monitor of JTAG test register status */
		unsigned int                : 1;
		unsigned int DFTPPS         : 6;	/* DFT RECEIVER Phase Select */
		unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} AGBT_DFT1_type;
#define AGBT_DFT1	(*( AGBT_DFT1_type *) 0xf00e104cu)	/* Intro Design For Test Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CURLVL         : 8;	/* Current FIFO Fill Level */
		unsigned int MAXLVL         : 8;	/* Maximum FIFO Fill Level */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} AGBT_FBFLV_type;
#define AGBT_FBFLV	(*( AGBT_FBFLV_type *) 0xf00e1020u)	/* FIFO Block Fill Level */

typedef volatile union
{
	struct
	{ 
		unsigned int WMLVL          : 8;	/* Watermark Level */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} AGBT_FCTRL_type;
#define AGBT_FCTRL	(*( AGBT_FCTRL_type *) 0xf00e1018u)	/* FIFO Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} AGBT_ID_type;
#define AGBT_ID	(*( AGBT_ID_type *) 0xf00e1008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int OFWE           : 1;	/* FIFO overflow enable */
		unsigned int WME            : 1;	/* Watermark interrupt enable */
		unsigned int HWE            : 1;	/* Hardware error indication interrupt enable */
		unsigned int FERE           : 1;	/* Truncated Frame error interrupt enable */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} AGBT_IRE_type;
#define AGBT_IRE	(*( AGBT_IRE_type *) 0xf00e1028u)	/* Intro Interrupt enable register */

typedef volatile union
{
	struct
	{ 
		unsigned int OFW            : 1;	/* FIFO overflow */
		unsigned int WM             : 1;	/* FIFO watermark interrupt */
		unsigned int HW             : 1;	/* Hardware error indication interrupt */
		unsigned int FER            : 1;	/* Truncated Frame */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} AGBT_IRS_type;
#define AGBT_IRS	(*( AGBT_IRS_type *) 0xf00e1024u)	/* Intro Interrupt status register */

typedef volatile union
{
	struct
	{ 
		unsigned int PCTR0          : 1;	/* Enable PLL to lock. */
		unsigned int PCTR1          : 1;	/* Enable PLL divider by 2 */
		unsigned int PCTR2          : 1;	/* Activate the clock for the tDC */
		unsigned int PCTR3          : 1;	/* Activate the clock for the TX */
		unsigned int PCTR4          : 1;	/* Activates the clock for the PI */
		unsigned int                : 19;
		unsigned int PCTR24         : 1;	/* Select signal for register readback */
		unsigned int PCTR25         : 1;	/* Write signal for internal PLL registers */
		unsigned int PCTRA          : 6;	/* Address of internal PLL register */
	} B;
	int I;
	unsigned int U;

} AGBT_PLC1_type;
#define AGBT_PLC1	(*( AGBT_PLC1_type *) 0xf00e1030u)	/* Intro PLL Control Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int PCTRL2         : 32;	/* PLL dynamic control bits [63:32] */
	} B;
	int I;
	unsigned int U;

} AGBT_PLC2_type;
#define AGBT_PLC2	(*( AGBT_PLC2_type *) 0xf00e1034u)	/* Intro PLL Control Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int PFCW           : 24;	/* PLL multiplication factor selection */
		unsigned int CBTRIMCUR      : 3;	/* Central Bias */
		unsigned int                : 4;
		unsigned int PRS            : 1;	/* PLL Ref. clock select */
	} B;
	int I;
	unsigned int U;

} AGBT_PLC3_type;
#define AGBT_PLC3	(*( AGBT_PLC3_type *) 0xf00e1038u)	/* Intro PLL Control Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int PCSP           : 1;	/* PCS layer bit polarity selection */
		unsigned int SEREN          : 1;	/* Enable SERIALIZER */
		unsigned int SERDEM         : 1;	/* Activate SERIALIZER De-Emphasis Mode */
		unsigned int DPNBS          : 2;	/* DATA PREDRIVER Current */
		unsigned int DPARE          : 3;	/* DATA PREDRIVER Capacity */
		unsigned int DPSRE          : 3;	/* DATA PREDRIVER High Level */
		unsigned int DPBYS          : 1;	/* DATA PROVIDER Full Swing */
		unsigned int CLKRXSCMR      : 3;	/* Clock Receiver reference voltage */
		unsigned int                : 1;
		unsigned int OCDCVS         : 4;	/* OFF-CHIP DRIVER (OCD) Current */
		unsigned int OCDRTS         : 5;	/* OFF-CHIP DRIVER (OCD) Termination */
		unsigned int PCSMSB         : 1;	/* MSB first (PCS) */
		unsigned int PCSBSW         : 1;	/* Byte Swap (PCS) */
		unsigned int CLKRXSRTER     : 4;	/* Clock Receiver Termination */
		unsigned int OCDDIFEN       : 1;	/* OCD DIFFERENTIAL OUTPUT ENABLE (OCD) */
	} B;
	int I;
	unsigned int U;

} AGBT_PLC4_type;
#define AGBT_PLC4	(*( AGBT_PLC4_type *) 0xf00e103cu)	/* Intro Physical Layer Control Register 4 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int PLLREGDO       : 32;	/* Readback data from internal PLL registers and BIST status register. Register selected by PLL Address field. */
	} B;
	int I;
	unsigned int U;

} AGBT_PLC5_type;
#define AGBT_PLC5	(*( AGBT_PLC5_type *) 0xf00e1050u)	/* Intro Production Test Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int PCSDS          : 2;	/* PCS Layer Data Source */
		unsigned int PCSDPAT        : 2;	/* PCS Layer Dynamic Pattern Select */
		unsigned int PCSSPAT        : 20;	/* PCS Layer Static Pattern */
		unsigned int PCS8BE         : 1;	/* PCS Layer - Enable the 8B10B Encoder */
		unsigned int PCSPER         : 1;	/* PCS Layer - Insert error in the PRBS generation */
		/* const */ unsigned int PCSPCO         : 1;	/* PCS Layer - PRBS checker output */
		unsigned int SEREIE         : 1;	/* SERIALIZER Output Override */
		unsigned int SERSGS         : 1;	/* SERIALIZER Data Polarity */
		unsigned int SERCES         : 1;	/* SERIALIZER Clock Polarity */
		unsigned int SERDEEMPH      : 1;	/* SERIALIZER De-Emphasis Mode */
		/* const */ unsigned int SERDIV20CO     : 1;	/* SERIALIZER Clock Divider */
	} B;
	int I;
	unsigned int U;

} AGBT_PTR1_type;
#define AGBT_PTR1	(*( AGBT_PTR1_type *) 0xf00e1040u)	/* Intro Production Test Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int PCSPCRX        : 1;	/* PCS Layer PRBS checker enable */
		unsigned int PCSPFSM        : 1;	/* PCS Layer PRBS checker mode */
		unsigned int PCSEM          : 1;	/* PCS Layer Error Insertion Mode */
		unsigned int PCSBERCON      : 1;	/* PCS Layer BER counter mode */
		unsigned int PCSERRB        : 5;	/* PCS Layer Error Insertion Size */
		unsigned int PCSBERCRST     : 1;	/* PCS Layer BER counter reset */
		/* const */ unsigned int PCSFERCO       : 5;	/* PCS Layer - FER counter output */
		unsigned int OCDPON         : 1;	/* OFF-CHIP DRIVER (OCD) Power On */
		/* const */ unsigned int PCSPRBSFSM     : 2;	/* PCS Layer PRBS checker state */
		unsigned int                : 12;
		unsigned int CLKPEN         : 1;	/* CLOCK PREDRIVER Enable */
		unsigned int CLKPSL         : 1;	/* CLOCK PREDRIVER Clock Select */
	} B;
	int I;
	unsigned int U;

} AGBT_PTR2_type;
#define AGBT_PTR2	(*( AGBT_PTR2_type *) 0xf00e1044u)	/* Intro Production Test Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int PCSBERCOUT     : 32;	/* PCS Layer - BER counter output. */
	} B;
	int I;
	unsigned int U;

} AGBT_PTR3_type;
#define AGBT_PTR3	(*( AGBT_PTR3_type *) 0xf00e1048u)	/* Intro Production Test Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int ACIC           : 24;	/* Automatic Channel Initialization Counter */
		unsigned int                : 7;
		unsigned int ACIEN          : 1;	/* Automatic Channel Initialization enable */
	} B;
	int I;
	unsigned int U;

} AGBT_TACU_type;
#define AGBT_TACU	(*( AGBT_TACU_type *) 0xf00e101cu)	/* Trace Auto Channel UP */

typedef volatile union
{
	struct
	{ 
		unsigned int TE             : 1;	/* Trace Enable */
		unsigned int PLLE           : 1;	/* PLL reset */
		unsigned int TXA            : 1;	/* Initialized */
		unsigned int PON            : 1;	/* Power On */
		unsigned int TPV            : 1;	/* Trace Port Verified */
		unsigned int BD             : 3;	/* Baud rate selection/availability */
		unsigned int                : 8;
		unsigned int AGBTON         : 1;	/* Intro on */
		unsigned int CIFON          : 1;	/* CIF on */
		unsigned int CRCON          : 1;	/* CRC append at the end of a data block on. */
		unsigned int ATPMON         : 1;	/* Aurora Test Pattern Mode */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} AGBT_TCR_type;
#define AGBT_TCR	(*( AGBT_TCR_type *) 0xf00e1010u)	/* Trace Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXLNUP         : 1;	/* TX lane up */
		/* const */ unsigned int FBE            : 1;	/* FIFO Buffer empty indication */
		/* const */ unsigned int PLK            : 1;	/* PLL lock status */
		/* const */ unsigned int ATBS           : 2;	/* AGBT Trace Buffer Size */
		/* const */ unsigned int ETS            : 2;	/* EMEM Tile Size */
		/* const */ unsigned int                : 24;
		/* const */ unsigned int CHUP           : 1;	/* Channel up */
	} B;
	int I;
	unsigned int U;

} AGBT_TSR_type;
#define AGBT_TSR	(*( AGBT_TSR_type *) 0xf00e1014u)	/* Trace Status Register */


/* CPU */
typedef volatile union
{
	struct
	{ 
		unsigned int VSS            : 1;	/* Vector Spacing Select */
		unsigned int bBIV           : 31;	/* Base Address of Interrupt Vector Table */
	} B;
	int I;
	unsigned int U;

} CPU0_BIV_type;
#define CPU0_BIV	(*( CPU0_BIV_type *) 0xf881fe20u)	/* Base Interrupt Vector Table Pointer */
#define CPU1_BIV	(*( CPU0_BIV_type *) 0xf883fe20u)	/* Base Interrupt Vector Table Pointer */
#define CPU2_BIV	(*( CPU0_BIV_type *) 0xf885fe20u)	/* Base Interrupt Vector Table Pointer */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 1;	/* Reserved */
		unsigned int bBTV           : 31;	/* Base Address of Trap Vector Table */
	} B;
	int I;
	unsigned int U;

} CPU0_BTV_type;
#define CPU0_BTV	(*( CPU0_BTV_type *) 0xf881fe24u)	/* Base Trap Vector Table Pointer */
#define CPU1_BTV	(*( CPU0_BTV_type *) 0xf883fe24u)	/* Base Trap Vector Table Pointer */
#define CPU2_BTV	(*( CPU0_BTV_type *) 0xf885fe24u)	/* Base Trap Vector Table Pointer */

typedef volatile union
{
	struct
	{ 
		unsigned int CountValue     : 31;	/* Count Value */
		unsigned int SOvf           : 1;	/* Sticky Overflow Bit */
	} B;
	int I;
	unsigned int U;

} CPU0_CCNT_type;
#define CPU0_CCNT	(*( CPU0_CCNT_type *) 0xf881fc04u)	/* CPU Clock Cycle Count */
#define CPU0_ICNT	(*( CPU0_CCNT_type *) 0xf881fc08u)	/* Instruction Count */
#define CPU0_M1CNT	(*( CPU0_CCNT_type *) 0xf881fc0cu)	/* Multi-Count Register 1 */
#define CPU0_M2CNT	(*( CPU0_CCNT_type *) 0xf881fc10u)	/* Multi-Count Register 2 */
#define CPU0_M3CNT	(*( CPU0_CCNT_type *) 0xf881fc14u)	/* Multi-Count Register 3 */
#define CPU1_CCNT	(*( CPU0_CCNT_type *) 0xf883fc04u)	/* CPU Clock Cycle Count */
#define CPU1_ICNT	(*( CPU0_CCNT_type *) 0xf883fc08u)	/* Instruction Count */
#define CPU1_M1CNT	(*( CPU0_CCNT_type *) 0xf883fc0cu)	/* Multi-Count Register 1 */
#define CPU1_M2CNT	(*( CPU0_CCNT_type *) 0xf883fc10u)	/* Multi-Count Register 2 */
#define CPU1_M3CNT	(*( CPU0_CCNT_type *) 0xf883fc14u)	/* Multi-Count Register 3 */
#define CPU2_CCNT	(*( CPU0_CCNT_type *) 0xf885fc04u)	/* CPU Clock Cycle Count */
#define CPU2_ICNT	(*( CPU0_CCNT_type *) 0xf885fc08u)	/* Instruction Count */
#define CPU2_M1CNT	(*( CPU0_CCNT_type *) 0xf885fc0cu)	/* Multi-Count Register 1 */
#define CPU2_M2CNT	(*( CPU0_CCNT_type *) 0xf885fc10u)	/* Multi-Count Register 2 */
#define CPU2_M3CNT	(*( CPU0_CCNT_type *) 0xf885fc14u)	/* Multi-Count Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int CM             : 1;	/* Counter Mode */
		unsigned int CE             : 1;	/* Count Enable */
		unsigned int M1             : 3;	/* M1CNT Configuration */
		unsigned int M2             : 3;	/* M2CNT Configuration */
		unsigned int M3             : 3;	/* M3CNT Configuration */
		/* const */ unsigned int RES            : 21;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_CCTRL_type;
#define CPU0_CCTRL	(*( CPU0_CCTRL_type *) 0xf881fc00u)	/* Counter Control */
#define CPU1_CCTRL	(*( CPU0_CCTRL_type *) 0xf883fc00u)	/* Counter Control */
#define CPU2_CCTRL	(*( CPU0_CCTRL_type *) 0xf885fc00u)	/* Counter Control */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 3;	/* Reserved */
		unsigned int RM             : 1;	/* Rounding Mode Compatibility */
		unsigned int SP             : 1;	/* SYSCON Safety Protection Mode Compatibility */
		/* const */ unsigned int RES_4          : 27;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_COMPAT_type;
#define CPU0_COMPAT	(*( CPU0_COMPAT_type *) 0xf8819400u)	/* Compatibility Control Register */
#define CPU1_COMPAT	(*( CPU0_COMPAT_type *) 0xf8839400u)	/* Compatibility Control Register */
#define CPU2_COMPAT	(*( CPU0_COMPAT_type *) 0xf8859400u)	/* Compatibility Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int bCORE_ID       : 3;	/* Core Identification Number */
		/* const */ unsigned int RES            : 29;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_CORE_ID_type;
#define CPU0_CORE_ID	(*( CPU0_CORE_ID_type *) 0xf881fe1cu)	/* CPU0 Core Identification Register */
#define CPU1_CORE_ID	(*( CPU0_CORE_ID_type *) 0xf883fe1cu)	/* CPU1 Core Identification Register */
#define CPU2_CORE_ID	(*( CPU0_CORE_ID_type *) 0xf885fe1cu)	/* CPU2 Core Identification Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 3;	/* Reserved */
		unsigned int LOWBND         : 29;	/* CPRy Lower Boundary Address */
	} B;
	int I;
	unsigned int U;

} CPU0_CPR0_L_type;
#define CPU0_CPR0_L	(*( CPU0_CPR0_L_type *) 0xf881d000u)	/* CPU0 Code Protection Range 0 Lower Bound Register */
#define CPU0_CPR1_L	(*( CPU0_CPR0_L_type *) 0xf881d008u)	/* CPU0 Code Protection Range 1 Lower Bound Register */
#define CPU0_CPR2_L	(*( CPU0_CPR0_L_type *) 0xf881d010u)	/* CPU0 Code Protection Range 2 Lower Bound Register */
#define CPU0_CPR3_L	(*( CPU0_CPR0_L_type *) 0xf881d018u)	/* CPU0 Code Protection Range 3 Lower Bound Register */
#define CPU0_CPR4_L	(*( CPU0_CPR0_L_type *) 0xf881d020u)	/* CPU0 Code Protection Range 4 Lower Bound Register */
#define CPU0_CPR5_L	(*( CPU0_CPR0_L_type *) 0xf881d028u)	/* CPU0 Code Protection Range 5 Lower Bound Register */
#define CPU0_CPR6_L	(*( CPU0_CPR0_L_type *) 0xf881d030u)	/* CPU0 Code Protection Range 6 Lower Bound Register */
#define CPU0_CPR7_L	(*( CPU0_CPR0_L_type *) 0xf881d038u)	/* CPU0 Code Protection Range 7 Lower Bound Register */
#define CPU1_CPR0_L	(*( CPU0_CPR0_L_type *) 0xf883d000u)	/* CPU1 Code Protection Range 0 Lower Bound Register */
#define CPU1_CPR1_L	(*( CPU0_CPR0_L_type *) 0xf883d008u)	/* CPU1 Code Protection Range 1 Lower Bound Register */
#define CPU1_CPR2_L	(*( CPU0_CPR0_L_type *) 0xf883d010u)	/* CPU1 Code Protection Range 2 Lower Bound Register */
#define CPU1_CPR3_L	(*( CPU0_CPR0_L_type *) 0xf883d018u)	/* CPU1 Code Protection Range 3 Lower Bound Register */
#define CPU1_CPR4_L	(*( CPU0_CPR0_L_type *) 0xf883d020u)	/* CPU1 Code Protection Range 4 Lower Bound Register */
#define CPU1_CPR5_L	(*( CPU0_CPR0_L_type *) 0xf883d028u)	/* CPU1 Code Protection Range 5 Lower Bound Register */
#define CPU1_CPR6_L	(*( CPU0_CPR0_L_type *) 0xf883d030u)	/* CPU1 Code Protection Range 6 Lower Bound Register */
#define CPU1_CPR7_L	(*( CPU0_CPR0_L_type *) 0xf883d038u)	/* CPU1 Code Protection Range 7 Lower Bound Register */
#define CPU2_CPR0_L	(*( CPU0_CPR0_L_type *) 0xf885d000u)	/* CPU2 Code Protection Range 0 Lower Bound Register */
#define CPU2_CPR1_L	(*( CPU0_CPR0_L_type *) 0xf885d008u)	/* CPU2 Code Protection Range 1 Lower Bound Register */
#define CPU2_CPR2_L	(*( CPU0_CPR0_L_type *) 0xf885d010u)	/* CPU2 Code Protection Range 2 Lower Bound Register */
#define CPU2_CPR3_L	(*( CPU0_CPR0_L_type *) 0xf885d018u)	/* CPU2 Code Protection Range 3 Lower Bound Register */
#define CPU2_CPR4_L	(*( CPU0_CPR0_L_type *) 0xf885d020u)	/* CPU2 Code Protection Range 4 Lower Bound Register */
#define CPU2_CPR5_L	(*( CPU0_CPR0_L_type *) 0xf885d028u)	/* CPU2 Code Protection Range 5 Lower Bound Register */
#define CPU2_CPR6_L	(*( CPU0_CPR0_L_type *) 0xf885d030u)	/* CPU2 Code Protection Range 6 Lower Bound Register */
#define CPU2_CPR7_L	(*( CPU0_CPR0_L_type *) 0xf885d038u)	/* CPU2 Code Protection Range 7 Lower Bound Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 3;	/* Reserved */
		unsigned int UPPBND         : 29;	/* CPR0_m Upper Boundary Address */
	} B;
	int I;
	unsigned int U;

} CPU0_CPR0_U_type;
#define CPU0_CPR0_U	(*( CPU0_CPR0_U_type *) 0xf881d004u)	/* CPU0 Code Protection Range 0 Upper Bound Register */
#define CPU0_CPR1_U	(*( CPU0_CPR0_U_type *) 0xf881d00cu)	/* CPU0 Code Protection Range 1 Upper Bound Register */
#define CPU0_CPR2_U	(*( CPU0_CPR0_U_type *) 0xf881d014u)	/* CPU0 Code Protection Range 2 Upper Bound Register */
#define CPU0_CPR3_U	(*( CPU0_CPR0_U_type *) 0xf881d01cu)	/* CPU0 Code Protection Range 3 Upper Bound Register */
#define CPU0_CPR4_U	(*( CPU0_CPR0_U_type *) 0xf881d024u)	/* CPU0 Code Protection Range 4 Upper Bound Register */
#define CPU0_CPR5_U	(*( CPU0_CPR0_U_type *) 0xf881d02cu)	/* CPU0 Code Protection Range 5 Upper Bound Register */
#define CPU0_CPR6_U	(*( CPU0_CPR0_U_type *) 0xf881d034u)	/* CPU0 Code Protection Range 6 Upper Bound Register */
#define CPU0_CPR7_U	(*( CPU0_CPR0_U_type *) 0xf881d03cu)	/* CPU0 Code Protection Range 7 Upper Bound Register */
#define CPU1_CPR0_U	(*( CPU0_CPR0_U_type *) 0xf883d004u)	/* CPU1 Code Protection Range 0 Upper Bound Register */
#define CPU1_CPR1_U	(*( CPU0_CPR0_U_type *) 0xf883d00cu)	/* CPU1 Code Protection Range 1 Upper Bound Register */
#define CPU1_CPR2_U	(*( CPU0_CPR0_U_type *) 0xf883d014u)	/* CPU1 Code Protection Range 2 Upper Bound Register */
#define CPU1_CPR3_U	(*( CPU0_CPR0_U_type *) 0xf883d01cu)	/* CPU1 Code Protection Range 3 Upper Bound Register */
#define CPU1_CPR4_U	(*( CPU0_CPR0_U_type *) 0xf883d024u)	/* CPU1 Code Protection Range 4 Upper Bound Register */
#define CPU1_CPR5_U	(*( CPU0_CPR0_U_type *) 0xf883d02cu)	/* CPU1 Code Protection Range 5 Upper Bound Register */
#define CPU1_CPR6_U	(*( CPU0_CPR0_U_type *) 0xf883d034u)	/* CPU1 Code Protection Range 6 Upper Bound Register */
#define CPU1_CPR7_U	(*( CPU0_CPR0_U_type *) 0xf883d03cu)	/* CPU1 Code Protection Range 7 Upper Bound Register */
#define CPU2_CPR0_U	(*( CPU0_CPR0_U_type *) 0xf885d004u)	/* CPU2 Code Protection Range 0 Upper Bound Register */
#define CPU2_CPR1_U	(*( CPU0_CPR0_U_type *) 0xf885d00cu)	/* CPU2 Code Protection Range 1 Upper Bound Register */
#define CPU2_CPR2_U	(*( CPU0_CPR0_U_type *) 0xf885d014u)	/* CPU2 Code Protection Range 2 Upper Bound Register */
#define CPU2_CPR3_U	(*( CPU0_CPR0_U_type *) 0xf885d01cu)	/* CPU2 Code Protection Range 3 Upper Bound Register */
#define CPU2_CPR4_U	(*( CPU0_CPR0_U_type *) 0xf885d024u)	/* CPU2 Code Protection Range 4 Upper Bound Register */
#define CPU2_CPR5_U	(*( CPU0_CPR0_U_type *) 0xf885d02cu)	/* CPU2 Code Protection Range 5 Upper Bound Register */
#define CPU2_CPR6_U	(*( CPU0_CPR0_U_type *) 0xf885d034u)	/* CPU2 Code Protection Range 6 Upper Bound Register */
#define CPU2_CPR7_U	(*( CPU0_CPR0_U_type *) 0xf885d03cu)	/* CPU2 Code Protection Range 7 Upper Bound Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Revision Number */
		/* const */ unsigned int MOD_32B        : 8;	/* 32-Bit Module Enable */
		/* const */ unsigned int MOD            : 16;	/* Module Identification Number */
	} B;
	int I;
	unsigned int U;

} CPU0_CPU_ID_type;
#define CPU0_CPU_ID	(*( CPU0_CPU_ID_type *) 0xf881fe18u)	/* CPU0 Identification Register TC1.6P */
#define CPU1_CPU_ID	(*( CPU0_CPU_ID_type *) 0xf883fe18u)	/* CPU1 Identification Register TC1.6P */
#define CPU2_CPU_ID	(*( CPU0_CPU_ID_type *) 0xf885fe18u)	/* CPU2 Identification Register TC1.6P */

typedef volatile union
{
	struct
	{ 
		unsigned int XE             : 8;	/* Execute Enable Range select */
		/* const */ unsigned int RES            : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_CPXE_0_type;
#define CPU0_CPXE_0	(*( CPU0_CPXE_0_type *) 0xf881e000u)	/* CPU0 Code Protection Execute Enable Register Set 0 */
#define CPU0_CPXE_1	(*( CPU0_CPXE_0_type *) 0xf881e004u)	/* CPU0 Code Protection Execute Enable Register Set 1 */
#define CPU0_CPXE_2	(*( CPU0_CPXE_0_type *) 0xf881e008u)	/* CPU0 Code Protection Execute Enable Register Set 2 */
#define CPU0_CPXE_3	(*( CPU0_CPXE_0_type *) 0xf881e00cu)	/* CPU0 Code Protection Execute Enable Register Set 3 */
#define CPU1_CPXE_0	(*( CPU0_CPXE_0_type *) 0xf883e000u)	/* CPU1 Code Protection Execute Enable Register Set 0 */
#define CPU1_CPXE_1	(*( CPU0_CPXE_0_type *) 0xf883e004u)	/* CPU1 Code Protection Execute Enable Register Set 1 */
#define CPU1_CPXE_2	(*( CPU0_CPXE_0_type *) 0xf883e008u)	/* CPU1 Code Protection Execute Enable Register Set 2 */
#define CPU1_CPXE_3	(*( CPU0_CPXE_0_type *) 0xf883e00cu)	/* CPU1 Code Protection Execute Enable Register Set 3 */
#define CPU2_CPXE_0	(*( CPU0_CPXE_0_type *) 0xf885e000u)	/* CPU2 Code Protection Execute Enable Register Set 0 */
#define CPU2_CPXE_1	(*( CPU0_CPXE_0_type *) 0xf885e004u)	/* CPU2 Code Protection Execute Enable Register Set 1 */
#define CPU2_CPXE_2	(*( CPU0_CPXE_0_type *) 0xf885e008u)	/* CPU2 Code Protection Execute Enable Register Set 2 */
#define CPU2_CPXE_3	(*( CPU0_CPXE_0_type *) 0xf885e00cu)	/* CPU2 Code Protection Execute Enable Register Set 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int EVTA           : 3;	/* Event Associated */
		unsigned int BBM            : 1;	/* Break Before Make (BBM) or Break After Make (BAM) Selection */
		unsigned int BOD            : 1;	/* Breakout Disable */
		unsigned int SUSP           : 1;	/* CDC Suspend-Out Signal State */
		unsigned int CNT            : 2;	/* Counter */
		/* const */ unsigned int RES            : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_CREVT_type;
#define CPU0_CREVT	(*( CPU0_CREVT_type *) 0xf881fd0cu)	/* Core Register Access Event */
#define CPU1_CREVT	(*( CPU0_CREVT_type *) 0xf883fd0cu)	/* Core Register Access Event */
#define CPU2_CREVT	(*( CPU0_CREVT_type *) 0xf885fd0cu)	/* Core Register Access Event */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CID            : 3;	/* Customer ID */
		/* const */ unsigned int RES            : 29;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_CUS_ID_type;
#define CPU0_CUS_ID	(*( CPU0_CUS_ID_type *) 0xf881fe50u)	/* CPU0 Customer ID register */
#define CPU1_CUS_ID	(*( CPU0_CUS_ID_type *) 0xf883fe50u)	/* CPU1 Customer ID register */
#define CPU2_CUS_ID	(*( CPU0_CUS_ID_type *) 0xf885fe50u)	/* CPU2 Customer ID register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 3;	/* Reserved */
		unsigned int SBE            : 1;	/* Store Bus Error */
		/* const */ unsigned int RES_3          : 5;	/* Reserved */
		unsigned int CWE            : 1;	/* Cache Writeback Error */
		unsigned int CFE            : 1;	/* Cache Flush Error */
		/* const */ unsigned int RES_6          : 3;	/* Reserved */
		unsigned int SOE            : 1;	/* Store Overlay Error */
		unsigned int SME            : 1;	/* Store MIST Error */
		/* const */ unsigned int RES_9          : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_DATR_type;
#define CPU0_DATR	(*( CPU0_DATR_type *) 0xf8819018u)	/* Data Asynchronous Trap Register */
#define CPU1_DATR	(*( CPU0_DATR_type *) 0xf8839018u)	/* Data Asynchronous Trap Register */
#define CPU2_DATR	(*( CPU0_DATR_type *) 0xf8859018u)	/* Data Asynchronous Trap Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DE             : 1;	/* Debug Enable */
		unsigned int HALT           : 2;	/* CPU Halt Request / Status Field */
		/* const */ unsigned int SIH            : 1;	/* Suspend-in Halt */
		unsigned int SUSP           : 1;	/* Current State of the Core Suspend-Out Signal */
		/* const */ unsigned int RES            : 1;	/* Reserved */
		/* const */ unsigned int PREVSUSP       : 1;	/* Previous State of Core Suspend-Out Signal */
		unsigned int PEVT           : 1;	/* Posted Event */
		/* const */ unsigned int EVTSRC         : 5;	/* Event Source */
		/* const */ unsigned int RES_9          : 19;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_DBGSR_type;
#define CPU0_DBGSR	(*( CPU0_DBGSR_type *) 0xf881fd00u)	/* Debug Status Register */
#define CPU1_DBGSR	(*( CPU0_DBGSR_type *) 0xf883fd00u)	/* Debug Status Register */
#define CPU2_DBGSR	(*( CPU0_DBGSR_type *) 0xf885fd00u)	/* Debug Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DTA            : 1;	/* Debug Trap Active Bit */
		/* const */ unsigned int RES            : 31;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_DBGTCR_type;
#define CPU0_DBGTCR	(*( CPU0_DBGTCR_type *) 0xf881fd48u)	/* Debug Trap Control Register */
#define CPU1_DBGTCR	(*( CPU0_DBGTCR_type *) 0xf883fd48u)	/* Debug Trap Control Register */
#define CPU2_DBGTCR	(*( CPU0_DBGTCR_type *) 0xf885fd48u)	/* Debug Trap Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 1;	/* Reserved */
		unsigned int DCBYP          : 1;	/* Data Cache Bypass */
		/* const */ unsigned int RES_3          : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_DCON0_type;
#define CPU0_DCON0	(*( CPU0_DCON0_type *) 0xf8819040u)	/* Data Memory Control Register */
#define CPU1_DCON0	(*( CPU0_DCON0_type *) 0xf8839040u)	/* Data Memory Control Register */
#define CPU2_DCON0	(*( CPU0_DCON0_type *) 0xf8859040u)	/* Data Memory Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DCACHE_SZE     : 16;	/* Data Cache Size */
		/* const */ unsigned int DSCRATCH_SZE   : 16;	/* Data Scratch Size */
	} B;
	int I;
	unsigned int U;

} CPU0_DCON2_type;
#define CPU0_DCON2	(*( CPU0_DCON2_type *) 0xf8819000u)	/* Data Control Register 2 */
#define CPU1_DCON2	(*( CPU0_DCON2_type *) 0xf8839000u)	/* Data Control Register 2 */
#define CPU2_DCON2	(*( CPU0_DCON2_type *) 0xf8859000u)	/* Data Control Register 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 6;	/* Reserved */
		unsigned int DCXValue       : 26;	/* Debug Context Save Area Pointer */
	} B;
	int I;
	unsigned int U;

} CPU0_DCX_type;
#define CPU0_DCX	(*( CPU0_DCX_type *) 0xf881fd44u)	/* Debug Context Save Area Pointer */
#define CPU1_DCX	(*( CPU0_DCX_type *) 0xf883fd44u)	/* Debug Context Save Area Pointer */
#define CPU2_DCX	(*( CPU0_DCX_type *) 0xf885fd44u)	/* Debug Context Save Area Pointer */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ERROR_ADDRESS  : 32;	/* Error Address */
	} B;
	int I;
	unsigned int U;

} CPU0_DEADD_type;
#define CPU0_DEADD	(*( CPU0_DEADD_type *) 0xf881901cu)	/* Data Error Address Register */
#define CPU1_DEADD	(*( CPU0_DEADD_type *) 0xf883901cu)	/* Data Error Address Register */
#define CPU2_DEADD	(*( CPU0_DEADD_type *) 0xf885901cu)	/* Data Error Address Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TA             : 32;	/* Transaction Address */
	} B;
	int I;
	unsigned int U;

} CPU0_DIEAR_type;
#define CPU0_DIEAR	(*( CPU0_DIEAR_type *) 0xf8819020u)	/* Data Integrity Error Address Register */
#define CPU0_PIEAR	(*( CPU0_DIEAR_type *) 0xf8819210u)	/* Program Integrity Error Address Register */
#define CPU1_DIEAR	(*( CPU0_DIEAR_type *) 0xf8839020u)	/* Data Integrity Error Address Register */
#define CPU1_PIEAR	(*( CPU0_DIEAR_type *) 0xf8839210u)	/* Program Integrity Error Address Register */
#define CPU2_DIEAR	(*( CPU0_DIEAR_type *) 0xf8859020u)	/* Data Integrity Error Address Register */
#define CPU2_PIEAR	(*( CPU0_DIEAR_type *) 0xf8859210u)	/* Program Integrity Error Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IED            : 1;	/* Integrity Error Detected */
		/* const */ unsigned int IE_T           : 1;	/* Integrity Error - Tag Memory */
		/* const */ unsigned int IE_C           : 1;	/* Integrity Error - Cache Memory */
		/* const */ unsigned int IE_S           : 1;	/* Integrity Error - Scratchpad Memory */
		/* const */ unsigned int IE_BI          : 1;	/* Integrity Error - Bus Integrity */
		/* const */ unsigned int E_INFO         : 6;	/* Error Information */
		/* const */ unsigned int IE_DUAL        : 1;	/* Dual Bit Error Detected */
		/* const */ unsigned int IE_SP          : 1;	/* Safety Protection Error Detected */
		/* const */ unsigned int IE_BS          : 1;	/* Bus Slave Access Indicator */
		/* const */ unsigned int RES            : 18;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_DIETR_type;
#define CPU0_DIETR	(*( CPU0_DIETR_type *) 0xf8819024u)	/* Data Integrity Error Trap Register */
#define CPU1_DIETR	(*( CPU0_DIETR_type *) 0xf8839024u)	/* Data Integrity Error Trap Register */
#define CPU2_DIETR	(*( CPU0_DIETR_type *) 0xf8859024u)	/* Data Integrity Error Trap Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 1;	/* Reserved */
		unsigned int DMSValue       : 31;	/* Debug Monitor Start Address */
	} B;
	int I;
	unsigned int U;

} CPU0_DMS_type;
#define CPU0_DMS	(*( CPU0_DMS_type *) 0xf881fd40u)	/* Debug Monitor Start Address */
#define CPU1_DMS	(*( CPU0_DMS_type *) 0xf883fd40u)	/* Debug Monitor Start Address */
#define CPU2_DMS	(*( CPU0_DMS_type *) 0xf885fd40u)	/* Debug Monitor Start Address */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 3;	/* Reserved */
		unsigned int LOWBND         : 29;	/* DPRy Lower Boundary Address */
	} B;
	int I;
	unsigned int U;

} CPU0_DPR0_L_type;
#define CPU0_DPR0_L	(*( CPU0_DPR0_L_type *) 0xf881c000u)	/* CPU0 Data Protection Range 0, Lower Bound Register */
#define CPU0_DPR10_L	(*( CPU0_DPR0_L_type *) 0xf881c050u)	/* CPU0 Data Protection Range 10, Lower Bound Register */
#define CPU0_DPR11_L	(*( CPU0_DPR0_L_type *) 0xf881c058u)	/* CPU0 Data Protection Range 11, Lower Bound Register */
#define CPU0_DPR12_L	(*( CPU0_DPR0_L_type *) 0xf881c060u)	/* CPU0 Data Protection Range 12, Lower Bound Register */
#define CPU0_DPR13_L	(*( CPU0_DPR0_L_type *) 0xf881c068u)	/* CPU0 Data Protection Range 13, Lower Bound Register */
#define CPU0_DPR14_L	(*( CPU0_DPR0_L_type *) 0xf881c070u)	/* CPU0 Data Protection Range 14, Lower Bound Register */
#define CPU0_DPR15_L	(*( CPU0_DPR0_L_type *) 0xf881c078u)	/* CPU0 Data Protection Range 15, Lower Bound Register */
#define CPU0_DPR1_L	(*( CPU0_DPR0_L_type *) 0xf881c008u)	/* CPU0 Data Protection Range 1, Lower Bound Register */
#define CPU0_DPR2_L	(*( CPU0_DPR0_L_type *) 0xf881c010u)	/* CPU0 Data Protection Range 2, Lower Bound Register */
#define CPU0_DPR3_L	(*( CPU0_DPR0_L_type *) 0xf881c018u)	/* CPU0 Data Protection Range 3, Lower Bound Register */
#define CPU0_DPR4_L	(*( CPU0_DPR0_L_type *) 0xf881c020u)	/* CPU0 Data Protection Range 4, Lower Bound Register */
#define CPU0_DPR5_L	(*( CPU0_DPR0_L_type *) 0xf881c028u)	/* CPU0 Data Protection Range 5, Lower Bound Register */
#define CPU0_DPR6_L	(*( CPU0_DPR0_L_type *) 0xf881c030u)	/* CPU0 Data Protection Range 6, Lower Bound Register */
#define CPU0_DPR7_L	(*( CPU0_DPR0_L_type *) 0xf881c038u)	/* CPU0 Data Protection Range 7, Lower Bound Register */
#define CPU0_DPR8_L	(*( CPU0_DPR0_L_type *) 0xf881c040u)	/* CPU0 Data Protection Range 8, Lower Bound Register */
#define CPU0_DPR9_L	(*( CPU0_DPR0_L_type *) 0xf881c048u)	/* CPU0 Data Protection Range 9, Lower Bound Register */
#define CPU1_DPR0_L	(*( CPU0_DPR0_L_type *) 0xf883c000u)	/* CPU1 Data Protection Range 0, Lower Bound Register */
#define CPU1_DPR10_L	(*( CPU0_DPR0_L_type *) 0xf883c050u)	/* CPU1 Data Protection Range 10, Lower Bound Register */
#define CPU1_DPR11_L	(*( CPU0_DPR0_L_type *) 0xf883c058u)	/* CPU1 Data Protection Range 11, Lower Bound Register */
#define CPU1_DPR12_L	(*( CPU0_DPR0_L_type *) 0xf883c060u)	/* CPU1 Data Protection Range 12, Lower Bound Register */
#define CPU1_DPR13_L	(*( CPU0_DPR0_L_type *) 0xf883c068u)	/* CPU1 Data Protection Range 13, Lower Bound Register */
#define CPU1_DPR14_L	(*( CPU0_DPR0_L_type *) 0xf883c070u)	/* CPU1 Data Protection Range 14, Lower Bound Register */
#define CPU1_DPR15_L	(*( CPU0_DPR0_L_type *) 0xf883c078u)	/* CPU1 Data Protection Range 15, Lower Bound Register */
#define CPU1_DPR1_L	(*( CPU0_DPR0_L_type *) 0xf883c008u)	/* CPU1 Data Protection Range 1, Lower Bound Register */
#define CPU1_DPR2_L	(*( CPU0_DPR0_L_type *) 0xf883c010u)	/* CPU1 Data Protection Range 2, Lower Bound Register */
#define CPU1_DPR3_L	(*( CPU0_DPR0_L_type *) 0xf883c018u)	/* CPU1 Data Protection Range 3, Lower Bound Register */
#define CPU1_DPR4_L	(*( CPU0_DPR0_L_type *) 0xf883c020u)	/* CPU1 Data Protection Range 4, Lower Bound Register */
#define CPU1_DPR5_L	(*( CPU0_DPR0_L_type *) 0xf883c028u)	/* CPU1 Data Protection Range 5, Lower Bound Register */
#define CPU1_DPR6_L	(*( CPU0_DPR0_L_type *) 0xf883c030u)	/* CPU1 Data Protection Range 6, Lower Bound Register */
#define CPU1_DPR7_L	(*( CPU0_DPR0_L_type *) 0xf883c038u)	/* CPU1 Data Protection Range 7, Lower Bound Register */
#define CPU1_DPR8_L	(*( CPU0_DPR0_L_type *) 0xf883c040u)	/* CPU1 Data Protection Range 8, Lower Bound Register */
#define CPU1_DPR9_L	(*( CPU0_DPR0_L_type *) 0xf883c048u)	/* CPU1 Data Protection Range 9, Lower Bound Register */
#define CPU2_DPR0_L	(*( CPU0_DPR0_L_type *) 0xf885c000u)	/* CPU2 Data Protection Range 0, Lower Bound Register */
#define CPU2_DPR10_L	(*( CPU0_DPR0_L_type *) 0xf885c050u)	/* CPU2 Data Protection Range 10, Lower Bound Register */
#define CPU2_DPR11_L	(*( CPU0_DPR0_L_type *) 0xf885c058u)	/* CPU2 Data Protection Range 11, Lower Bound Register */
#define CPU2_DPR12_L	(*( CPU0_DPR0_L_type *) 0xf885c060u)	/* CPU2 Data Protection Range 12, Lower Bound Register */
#define CPU2_DPR13_L	(*( CPU0_DPR0_L_type *) 0xf885c068u)	/* CPU2 Data Protection Range 13, Lower Bound Register */
#define CPU2_DPR14_L	(*( CPU0_DPR0_L_type *) 0xf885c070u)	/* CPU2 Data Protection Range 14, Lower Bound Register */
#define CPU2_DPR15_L	(*( CPU0_DPR0_L_type *) 0xf885c078u)	/* CPU2 Data Protection Range 15, Lower Bound Register */
#define CPU2_DPR1_L	(*( CPU0_DPR0_L_type *) 0xf885c008u)	/* CPU2 Data Protection Range 1, Lower Bound Register */
#define CPU2_DPR2_L	(*( CPU0_DPR0_L_type *) 0xf885c010u)	/* CPU2 Data Protection Range 2, Lower Bound Register */
#define CPU2_DPR3_L	(*( CPU0_DPR0_L_type *) 0xf885c018u)	/* CPU2 Data Protection Range 3, Lower Bound Register */
#define CPU2_DPR4_L	(*( CPU0_DPR0_L_type *) 0xf885c020u)	/* CPU2 Data Protection Range 4, Lower Bound Register */
#define CPU2_DPR5_L	(*( CPU0_DPR0_L_type *) 0xf885c028u)	/* CPU2 Data Protection Range 5, Lower Bound Register */
#define CPU2_DPR6_L	(*( CPU0_DPR0_L_type *) 0xf885c030u)	/* CPU2 Data Protection Range 6, Lower Bound Register */
#define CPU2_DPR7_L	(*( CPU0_DPR0_L_type *) 0xf885c038u)	/* CPU2 Data Protection Range 7, Lower Bound Register */
#define CPU2_DPR8_L	(*( CPU0_DPR0_L_type *) 0xf885c040u)	/* CPU2 Data Protection Range 8, Lower Bound Register */
#define CPU2_DPR9_L	(*( CPU0_DPR0_L_type *) 0xf885c048u)	/* CPU2 Data Protection Range 9, Lower Bound Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 3;	/* Reserved */
		unsigned int UPPBND         : 29;	/* DPRy Upper Boundary Address */
	} B;
	int I;
	unsigned int U;

} CPU0_DPR0_U_type;
#define CPU0_DPR0_U	(*( CPU0_DPR0_U_type *) 0xf881c004u)	/* CPU0 Data Protection Range 0, Upper Bound Register */
#define CPU0_DPR10_U	(*( CPU0_DPR0_U_type *) 0xf881c054u)	/* CPU0 Data Protection Range 10, Upper Bound Register */
#define CPU0_DPR11_U	(*( CPU0_DPR0_U_type *) 0xf881c05cu)	/* CPU0 Data Protection Range 11, Upper Bound Register */
#define CPU0_DPR12_U	(*( CPU0_DPR0_U_type *) 0xf881c064u)	/* CPU0 Data Protection Range 12, Upper Bound Register */
#define CPU0_DPR13_U	(*( CPU0_DPR0_U_type *) 0xf881c06cu)	/* CPU0 Data Protection Range 13, Upper Bound Register */
#define CPU0_DPR14_U	(*( CPU0_DPR0_U_type *) 0xf881c074u)	/* CPU0 Data Protection Range 14, Upper Bound Register */
#define CPU0_DPR15_U	(*( CPU0_DPR0_U_type *) 0xf881c07cu)	/* CPU0 Data Protection Range 15, Upper Bound Register */
#define CPU0_DPR1_U	(*( CPU0_DPR0_U_type *) 0xf881c00cu)	/* CPU0 Data Protection Range 1, Upper Bound Register */
#define CPU0_DPR2_U	(*( CPU0_DPR0_U_type *) 0xf881c014u)	/* CPU0 Data Protection Range 2, Upper Bound Register */
#define CPU0_DPR3_U	(*( CPU0_DPR0_U_type *) 0xf881c01cu)	/* CPU0 Data Protection Range 3, Upper Bound Register */
#define CPU0_DPR4_U	(*( CPU0_DPR0_U_type *) 0xf881c024u)	/* CPU0 Data Protection Range 4, Upper Bound Register */
#define CPU0_DPR5_U	(*( CPU0_DPR0_U_type *) 0xf881c02cu)	/* CPU0 Data Protection Range 5, Upper Bound Register */
#define CPU0_DPR6_U	(*( CPU0_DPR0_U_type *) 0xf881c034u)	/* CPU0 Data Protection Range 6, Upper Bound Register */
#define CPU0_DPR7_U	(*( CPU0_DPR0_U_type *) 0xf881c03cu)	/* CPU0 Data Protection Range 7, Upper Bound Register */
#define CPU0_DPR8_U	(*( CPU0_DPR0_U_type *) 0xf881c044u)	/* CPU0 Data Protection Range 8, Upper Bound Register */
#define CPU0_DPR9_U	(*( CPU0_DPR0_U_type *) 0xf881c04cu)	/* CPU0 Data Protection Range 9, Upper Bound Register */
#define CPU1_DPR0_U	(*( CPU0_DPR0_U_type *) 0xf883c004u)	/* CPU1 Data Protection Range 0, Upper Bound Register */
#define CPU1_DPR10_U	(*( CPU0_DPR0_U_type *) 0xf883c054u)	/* CPU1 Data Protection Range 10, Upper Bound Register */
#define CPU1_DPR11_U	(*( CPU0_DPR0_U_type *) 0xf883c05cu)	/* CPU1 Data Protection Range 11, Upper Bound Register */
#define CPU1_DPR12_U	(*( CPU0_DPR0_U_type *) 0xf883c064u)	/* CPU1 Data Protection Range 12, Upper Bound Register */
#define CPU1_DPR13_U	(*( CPU0_DPR0_U_type *) 0xf883c06cu)	/* CPU1 Data Protection Range 13, Upper Bound Register */
#define CPU1_DPR14_U	(*( CPU0_DPR0_U_type *) 0xf883c074u)	/* CPU1 Data Protection Range 14, Upper Bound Register */
#define CPU1_DPR15_U	(*( CPU0_DPR0_U_type *) 0xf883c07cu)	/* CPU1 Data Protection Range 15, Upper Bound Register */
#define CPU1_DPR1_U	(*( CPU0_DPR0_U_type *) 0xf883c00cu)	/* CPU1 Data Protection Range 1, Upper Bound Register */
#define CPU1_DPR2_U	(*( CPU0_DPR0_U_type *) 0xf883c014u)	/* CPU1 Data Protection Range 2, Upper Bound Register */
#define CPU1_DPR3_U	(*( CPU0_DPR0_U_type *) 0xf883c01cu)	/* CPU1 Data Protection Range 3, Upper Bound Register */
#define CPU1_DPR4_U	(*( CPU0_DPR0_U_type *) 0xf883c024u)	/* CPU1 Data Protection Range 4, Upper Bound Register */
#define CPU1_DPR5_U	(*( CPU0_DPR0_U_type *) 0xf883c02cu)	/* CPU1 Data Protection Range 5, Upper Bound Register */
#define CPU1_DPR6_U	(*( CPU0_DPR0_U_type *) 0xf883c034u)	/* CPU1 Data Protection Range 6, Upper Bound Register */
#define CPU1_DPR7_U	(*( CPU0_DPR0_U_type *) 0xf883c03cu)	/* CPU1 Data Protection Range 7, Upper Bound Register */
#define CPU1_DPR8_U	(*( CPU0_DPR0_U_type *) 0xf883c044u)	/* CPU1 Data Protection Range 8, Upper Bound Register */
#define CPU1_DPR9_U	(*( CPU0_DPR0_U_type *) 0xf883c04cu)	/* CPU1 Data Protection Range 9, Upper Bound Register */
#define CPU2_DPR0_U	(*( CPU0_DPR0_U_type *) 0xf885c004u)	/* CPU2 Data Protection Range 0, Upper Bound Register */
#define CPU2_DPR10_U	(*( CPU0_DPR0_U_type *) 0xf885c054u)	/* CPU2 Data Protection Range 10, Upper Bound Register */
#define CPU2_DPR11_U	(*( CPU0_DPR0_U_type *) 0xf885c05cu)	/* CPU2 Data Protection Range 11, Upper Bound Register */
#define CPU2_DPR12_U	(*( CPU0_DPR0_U_type *) 0xf885c064u)	/* CPU2 Data Protection Range 12, Upper Bound Register */
#define CPU2_DPR13_U	(*( CPU0_DPR0_U_type *) 0xf885c06cu)	/* CPU2 Data Protection Range 13, Upper Bound Register */
#define CPU2_DPR14_U	(*( CPU0_DPR0_U_type *) 0xf885c074u)	/* CPU2 Data Protection Range 14, Upper Bound Register */
#define CPU2_DPR15_U	(*( CPU0_DPR0_U_type *) 0xf885c07cu)	/* CPU2 Data Protection Range 15, Upper Bound Register */
#define CPU2_DPR1_U	(*( CPU0_DPR0_U_type *) 0xf885c00cu)	/* CPU2 Data Protection Range 1, Upper Bound Register */
#define CPU2_DPR2_U	(*( CPU0_DPR0_U_type *) 0xf885c014u)	/* CPU2 Data Protection Range 2, Upper Bound Register */
#define CPU2_DPR3_U	(*( CPU0_DPR0_U_type *) 0xf885c01cu)	/* CPU2 Data Protection Range 3, Upper Bound Register */
#define CPU2_DPR4_U	(*( CPU0_DPR0_U_type *) 0xf885c024u)	/* CPU2 Data Protection Range 4, Upper Bound Register */
#define CPU2_DPR5_U	(*( CPU0_DPR0_U_type *) 0xf885c02cu)	/* CPU2 Data Protection Range 5, Upper Bound Register */
#define CPU2_DPR6_U	(*( CPU0_DPR0_U_type *) 0xf885c034u)	/* CPU2 Data Protection Range 6, Upper Bound Register */
#define CPU2_DPR7_U	(*( CPU0_DPR0_U_type *) 0xf885c03cu)	/* CPU2 Data Protection Range 7, Upper Bound Register */
#define CPU2_DPR8_U	(*( CPU0_DPR0_U_type *) 0xf885c044u)	/* CPU2 Data Protection Range 8, Upper Bound Register */
#define CPU2_DPR9_U	(*( CPU0_DPR0_U_type *) 0xf885c04cu)	/* CPU2 Data Protection Range 9, Upper Bound Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RE             : 16;	/* Read Enable Range Select */
		/* const */ unsigned int RES            : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_DPRE_0_type;
#define CPU0_DPRE_0	(*( CPU0_DPRE_0_type *) 0xf881e010u)	/* CPU0 Data Protection Read Enable Register Set 0 */
#define CPU0_DPRE_1	(*( CPU0_DPRE_0_type *) 0xf881e014u)	/* CPU0 Data Protection Read Enable Register Set 1 */
#define CPU0_DPRE_2	(*( CPU0_DPRE_0_type *) 0xf881e018u)	/* CPU0 Data Protection Read Enable Register Set 2 */
#define CPU0_DPRE_3	(*( CPU0_DPRE_0_type *) 0xf881e01cu)	/* CPU0 Data Protection Read Enable Register Set 3 */
#define CPU1_DPRE_0	(*( CPU0_DPRE_0_type *) 0xf883e010u)	/* CPU1 Data Protection Read Enable Register Set 0 */
#define CPU1_DPRE_1	(*( CPU0_DPRE_0_type *) 0xf883e014u)	/* CPU1 Data Protection Read Enable Register Set 1 */
#define CPU1_DPRE_2	(*( CPU0_DPRE_0_type *) 0xf883e018u)	/* CPU1 Data Protection Read Enable Register Set 2 */
#define CPU1_DPRE_3	(*( CPU0_DPRE_0_type *) 0xf883e01cu)	/* CPU1 Data Protection Read Enable Register Set 3 */
#define CPU2_DPRE_0	(*( CPU0_DPRE_0_type *) 0xf885e010u)	/* CPU2 Data Protection Read Enable Register Set 0 */
#define CPU2_DPRE_1	(*( CPU0_DPRE_0_type *) 0xf885e014u)	/* CPU2 Data Protection Read Enable Register Set 1 */
#define CPU2_DPRE_2	(*( CPU0_DPRE_0_type *) 0xf885e018u)	/* CPU2 Data Protection Read Enable Register Set 2 */
#define CPU2_DPRE_3	(*( CPU0_DPRE_0_type *) 0xf885e01cu)	/* CPU2 Data Protection Read Enable Register Set 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int WE             : 16;	/* Write Enable Range Select */
		/* const */ unsigned int RES            : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_DPWE_0_type;
#define CPU0_DPWE_0	(*( CPU0_DPWE_0_type *) 0xf881e020u)	/* CPU0 Data Protection Write Enable Register Set 0 */
#define CPU0_DPWE_1	(*( CPU0_DPWE_0_type *) 0xf881e024u)	/* CPU0 Data Protection Write Enable Register Set 1 */
#define CPU0_DPWE_2	(*( CPU0_DPWE_0_type *) 0xf881e028u)	/* CPU0 Data Protection Write Enable Register Set 2 */
#define CPU0_DPWE_3	(*( CPU0_DPWE_0_type *) 0xf881e02cu)	/* CPU0 Data Protection Write Enable Register Set 3 */
#define CPU1_DPWE_0	(*( CPU0_DPWE_0_type *) 0xf883e020u)	/* CPU1 Data Protection Write Enable Register Set 0 */
#define CPU1_DPWE_1	(*( CPU0_DPWE_0_type *) 0xf883e024u)	/* CPU1 Data Protection Write Enable Register Set 1 */
#define CPU1_DPWE_2	(*( CPU0_DPWE_0_type *) 0xf883e028u)	/* CPU1 Data Protection Write Enable Register Set 2 */
#define CPU1_DPWE_3	(*( CPU0_DPWE_0_type *) 0xf883e02cu)	/* CPU1 Data Protection Write Enable Register Set 3 */
#define CPU2_DPWE_0	(*( CPU0_DPWE_0_type *) 0xf885e020u)	/* CPU2 Data Protection Write Enable Register Set 0 */
#define CPU2_DPWE_1	(*( CPU0_DPWE_0_type *) 0xf885e024u)	/* CPU2 Data Protection Write Enable Register Set 1 */
#define CPU2_DPWE_2	(*( CPU0_DPWE_0_type *) 0xf885e028u)	/* CPU2 Data Protection Write Enable Register Set 2 */
#define CPU2_DPWE_3	(*( CPU0_DPWE_0_type *) 0xf885e02cu)	/* CPU2 Data Protection Write Enable Register Set 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int SRE            : 1;	/* Scratch Range Error */
		unsigned int GAE            : 1;	/* Global Address Error */
		unsigned int LBE            : 1;	/* Load Bus Error */
		/* const */ unsigned int RES            : 3;	/* Reserved */
		unsigned int CRE            : 1;	/* Cache Refill Error */
		/* const */ unsigned int RES_6          : 7;	/* Reserved */
		unsigned int DTME           : 1;	/* DTAG MSIST Error */
		unsigned int LOE            : 1;	/* Load Overlay Error */
		unsigned int SDE            : 1;	/* Segment Difference Error */
		unsigned int SCE            : 1;	/* Segment Crossing Error */
		unsigned int CAC            : 1;	/* CSFR Access Error */
		unsigned int MPE            : 1;	/* Memory Protection Error */
		unsigned int CLE            : 1;	/* Context Location Error */
		/* const */ unsigned int RES_14         : 3;	/* Reserved */
		unsigned int ALN            : 1;	/* Alignment Error */
		/* const */ unsigned int RES_16         : 7;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_DSTR_type;
#define CPU0_DSTR	(*( CPU0_DSTR_type *) 0xf8819010u)	/* Data Synchronous Trap Register */
#define CPU1_DSTR	(*( CPU0_DSTR_type *) 0xf8839010u)	/* Data Synchronous Trap Register */
#define CPU2_DSTR	(*( CPU0_DSTR_type *) 0xf8859010u)	/* Data Synchronous Trap Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EVTA           : 3;	/* Event Associated */
		unsigned int BBM            : 1;	/* Break Before Make (BBM) or Break After Make (BAM) Selection */
		unsigned int BOD            : 1;	/* Breakout Disable */
		unsigned int SUSP           : 1;	/* CDC Suspend-Out Signal State */
		unsigned int CNT            : 2;	/* Counter */
		/* const */ unsigned int RES            : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_EXEVT_type;
#define CPU0_EXEVT	(*( CPU0_EXEVT_type *) 0xf881fd08u)	/* External Event Register */
#define CPU1_EXEVT	(*( CPU0_EXEVT_type *) 0xf883fd08u)	/* External Event Register */
#define CPU2_EXEVT	(*( CPU0_EXEVT_type *) 0xf885fd08u)	/* External Event Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FCXO           : 16;	/* FCX Offset Address Field */
		unsigned int FCXS           : 4;	/* FCX Segment Address Field */
		/* const */ unsigned int RES            : 12;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_FCX_type;
#define CPU0_FCX	(*( CPU0_FCX_type *) 0xf881fe38u)	/* Free CSA List Head Pointer */
#define CPU1_FCX	(*( CPU0_FCX_type *) 0xf883fe38u)	/* Free CSA List Head Pointer */
#define CPU2_FCX	(*( CPU0_FCX_type *) 0xf885fe38u)	/* Free CSA List Head Pointer */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TST            : 1;	/* Trap Status */
		unsigned int TCL            : 1;	/* Trap Clear */
		/* const */ unsigned int RES            : 6;	/* Reserved */
		/* const */ unsigned int RM             : 2;	/* Captured Rounding Mode */
		/* const */ unsigned int RES_5          : 8;	/* Reserved */
		unsigned int FXE            : 1;	/* FX Trap Enable */
		unsigned int FUE            : 1;	/* FU Trap Enable */
		unsigned int FZE            : 1;	/* FZ Trap Enable */
		unsigned int FVE            : 1;	/* FV Trap Enable */
		unsigned int FIE            : 1;	/* FI Trap Enable */
		/* const */ unsigned int RES_11         : 3;	/* Reserved */
		/* const */ unsigned int FX             : 1;	/* Captured FX */
		/* const */ unsigned int FU             : 1;	/* Captured FU */
		/* const */ unsigned int FZ             : 1;	/* Captured FZ */
		/* const */ unsigned int FV             : 1;	/* Captured FV */
		/* const */ unsigned int FI             : 1;	/* Captured FI */
		/* const */ unsigned int RES_17         : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_FPU_TRAP_CON_type;
#define CPU0_FPU_TRAP_CON	(*( CPU0_FPU_TRAP_CON_type *) 0xf881a000u)	/* CPU0 Trap Control Register */
#define CPU1_FPU_TRAP_CON	(*( CPU0_FPU_TRAP_CON_type *) 0xf883a000u)	/* CPU1 Trap Control Register */
#define CPU2_FPU_TRAP_CON	(*( CPU0_FPU_TRAP_CON_type *) 0xf885a000u)	/* CPU2 Trap Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int OPC            : 8;	/* Captured Opcode */
		/* const */ unsigned int FMT            : 1;	/* Captured Instruction Format */
		/* const */ unsigned int RES            : 7;	/* Reserved */
		/* const */ unsigned int DREG           : 4;	/* Captured Destination Register */
		/* const */ unsigned int RES_5          : 12;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_FPU_TRAP_OPC_type;
#define CPU0_FPU_TRAP_OPC	(*( CPU0_FPU_TRAP_OPC_type *) 0xf881a008u)	/* CPU0 Trapping Instruction Opcode Register */
#define CPU1_FPU_TRAP_OPC	(*( CPU0_FPU_TRAP_OPC_type *) 0xf883a008u)	/* CPU1 Trapping Instruction Opcode Register */
#define CPU2_FPU_TRAP_OPC	(*( CPU0_FPU_TRAP_OPC_type *) 0xf885a008u)	/* CPU2 Trapping Instruction Opcode Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int bPC            : 32;	/* Captured Program Counter */
	} B;
	int I;
	unsigned int U;

} CPU0_FPU_TRAP_PC_type;
#define CPU0_FPU_TRAP_PC	(*( CPU0_FPU_TRAP_PC_type *) 0xf881a004u)	/* CPU0 Trapping Instruction Program Counter Register */
#define CPU1_FPU_TRAP_PC	(*( CPU0_FPU_TRAP_PC_type *) 0xf883a004u)	/* CPU1 Trapping Instruction Program Counter Register */
#define CPU2_FPU_TRAP_PC	(*( CPU0_FPU_TRAP_PC_type *) 0xf885a004u)	/* CPU2 Trapping Instruction Program Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SRC1           : 32;	/* Captured SRC1 Operand */
	} B;
	int I;
	unsigned int U;

} CPU0_FPU_TRAP_SRC1_type;
#define CPU0_FPU_TRAP_SRC1	(*( CPU0_FPU_TRAP_SRC1_type *) 0xf881a010u)	/* CPU0 Trapping Instruction Operand Register */
#define CPU1_FPU_TRAP_SRC1	(*( CPU0_FPU_TRAP_SRC1_type *) 0xf883a010u)	/* CPU1 Trapping Instruction Operand Register */
#define CPU2_FPU_TRAP_SRC1	(*( CPU0_FPU_TRAP_SRC1_type *) 0xf885a010u)	/* CPU2 Trapping Instruction Operand Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SRC2           : 32;	/* Captured SRC2 Operand */
	} B;
	int I;
	unsigned int U;

} CPU0_FPU_TRAP_SRC2_type;
#define CPU0_FPU_TRAP_SRC2	(*( CPU0_FPU_TRAP_SRC2_type *) 0xf881a014u)	/* CPU0 Trapping Instruction Operand Register */
#define CPU1_FPU_TRAP_SRC2	(*( CPU0_FPU_TRAP_SRC2_type *) 0xf883a014u)	/* CPU1 Trapping Instruction Operand Register */
#define CPU2_FPU_TRAP_SRC2	(*( CPU0_FPU_TRAP_SRC2_type *) 0xf885a014u)	/* CPU2 Trapping Instruction Operand Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SRC3           : 32;	/* Captured SRC3 Operand */
	} B;
	int I;
	unsigned int U;

} CPU0_FPU_TRAP_SRC3_type;
#define CPU0_FPU_TRAP_SRC3	(*( CPU0_FPU_TRAP_SRC3_type *) 0xf881a018u)	/* Trapping Instruction Operand Register */
#define CPU1_FPU_TRAP_SRC3	(*( CPU0_FPU_TRAP_SRC3_type *) 0xf883a018u)	/* Trapping Instruction Operand Register */
#define CPU2_FPU_TRAP_SRC3	(*( CPU0_FPU_TRAP_SRC3_type *) 0xf885a018u)	/* Trapping Instruction Operand Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CCPN           : 10;	/* Current CPU Priority Number */
		/* const */ unsigned int RES            : 5;	/* Reserved */
		unsigned int IE             : 1;	/* Global Interrupt Enable Bit */
		/* const */ unsigned int PIPN           : 10;	/* Pending Interrupt Priority Number */
		/* const */ unsigned int RES_5          : 6;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_ICR_type;
#define CPU0_ICR	(*( CPU0_ICR_type *) 0xf881fe2cu)	/* Interrupt Control Register */
#define CPU1_ICR	(*( CPU0_ICR_type *) 0xf883fe2cu)	/* Interrupt Control Register */
#define CPU2_ICR	(*( CPU0_ICR_type *) 0xf885fe2cu)	/* Interrupt Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int bISP           : 32;	/* Interrupt Stack Pointer */
	} B;
	int I;
	unsigned int U;

} CPU0_ISP_type;
#define CPU0_ISP	(*( CPU0_ISP_type *) 0xf881fe28u)	/* Interrupt Stack Pointer */
#define CPU1_ISP	(*( CPU0_ISP_type *) 0xf883fe28u)	/* Interrupt Stack Pointer */
#define CPU2_ISP	(*( CPU0_ISP_type *) 0xf885fe28u)	/* Interrupt Stack Pointer */

typedef volatile union
{
	struct
	{ 
		unsigned int LCXO           : 16;	/* LCX Offset Field */
		unsigned int LCXS           : 4;	/* LCX Segment Address */
		/* const */ unsigned int RES            : 12;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_LCX_type;
#define CPU0_LCX	(*( CPU0_LCX_type *) 0xf881fe3cu)	/* Free CSA List Limit Pointer */
#define CPU1_LCX	(*( CPU0_LCX_type *) 0xf883fe3cu)	/* Free CSA List Limit Pointer */
#define CPU2_LCX	(*( CPU0_LCX_type *) 0xf885fe3cu)	/* Free CSA List Limit Pointer */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 1;	/* Reserved */
		/* const */ unsigned int bPC            : 31;	/* Program Counter */
	} B;
	int I;
	unsigned int U;

} CPU0_PC_type;
#define CPU0_PC	(*( CPU0_PC_type *) 0xf881fe08u)	/* Program Counter */
#define CPU1_PC	(*( CPU0_PC_type *) 0xf883fe08u)	/* Program Counter */
#define CPU2_PC	(*( CPU0_PC_type *) 0xf885fe08u)	/* Program Counter */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 1;	/* Reserved */
		unsigned int PCBYP          : 1;	/* Program Cache Bypass */
		/* const */ unsigned int RES_3          : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_PCON0_type;
#define CPU0_PCON0	(*( CPU0_PCON0_type *) 0xf881920cu)	/* Program Control 0 */
#define CPU1_PCON0	(*( CPU0_PCON0_type *) 0xf883920cu)	/* Program Control 0 */
#define CPU2_PCON0	(*( CPU0_PCON0_type *) 0xf885920cu)	/* Program Control 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int PCINV          : 1;	/* Program Cache Invalidate */
		unsigned int PBINV          : 1;	/* Program Buffer Invalidate */
		/* const */ unsigned int RES            : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_PCON1_type;
#define CPU0_PCON1	(*( CPU0_PCON1_type *) 0xf8819204u)	/* Program Control 1 */
#define CPU1_PCON1	(*( CPU0_PCON1_type *) 0xf8839204u)	/* Program Control 1 */
#define CPU2_PCON1	(*( CPU0_PCON1_type *) 0xf8859204u)	/* Program Control 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int PCACHE_SZE     : 16;	/* Program Cache Size (ICACHE) in KBytes */
		/* const */ unsigned int PSCRATCH_SZE   : 16;	/* Program Scratch Size in KBytes */
	} B;
	int I;
	unsigned int U;

} CPU0_PCON2_type;
#define CPU0_PCON2	(*( CPU0_PCON2_type *) 0xf8819208u)	/* Program Control 2 */
#define CPU1_PCON2	(*( CPU0_PCON2_type *) 0xf8839208u)	/* Program Control 2 */
#define CPU2_PCON2	(*( CPU0_PCON2_type *) 0xf8859208u)	/* Program Control 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int PCXO           : 16;	/* Previous Context Pointer Offset Field */
		unsigned int PCXS           : 4;	/* Previous Context Pointer Segment Address */
		unsigned int UL             : 1;	/* Upper or Lower Context Tag */
		unsigned int PIE            : 1;	/* Previous Interrupt Enable */
		unsigned int PCPN           : 10;	/* Previous CPU Priority Number */
	} B;
	int I;
	unsigned int U;

} CPU0_PCXI_type;
#define CPU0_PCXI	(*( CPU0_PCXI_type *) 0xf881fe00u)	/* Previous Context Information Register */
#define CPU1_PCXI	(*( CPU0_PCXI_type *) 0xf883fe00u)	/* Previous Context Information Register */
#define CPU2_PCXI	(*( CPU0_PCXI_type *) 0xf885fe00u)	/* Previous Context Information Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IED            : 1;	/* Integrity Error Detected */
		/* const */ unsigned int IE_T           : 1;	/* Integrity Error - Tag Memory */
		/* const */ unsigned int IE_C           : 1;	/* Integrity Error - Cache Memory */
		/* const */ unsigned int IE_S           : 1;	/* Integrity Error - Scratchpad Memory */
		/* const */ unsigned int IE_BI          : 1;	/* Integrity Error - Bus Interface */
		/* const */ unsigned int E_INFO         : 6;	/* Error Information */
		/* const */ unsigned int IE_DUAL        : 1;	/* Integrity Error - Dual Error Detected */
		/* const */ unsigned int IE_SP          : 1;	/* Safety Protection Error Detected */
		/* const */ unsigned int IE_BS          : 1;	/* Bus Slave Access Indicator */
		/* const */ unsigned int RES            : 18;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_PIETR_type;
#define CPU0_PIETR	(*( CPU0_PIETR_type *) 0xf8819214u)	/* Program Integrity Error Trap Register */
#define CPU1_PIETR	(*( CPU0_PIETR_type *) 0xf8839214u)	/* Program Integrity Error Trap Register */
#define CPU2_PIETR	(*( CPU0_PIETR_type *) 0xf8859214u)	/* Program Integrity Error Trap Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DAC_0          : 10;	/* Data Access Cacheability Segments 9H-0H */
		/* const */ unsigned int DAC_A          : 1;	/* Data Access Cacheability Segments AH */
		unsigned int DAC_B          : 2;	/* Data Access Cacheability Segments CH,BH */
		/* const */ unsigned int DAC_D          : 3;	/* Data Access Cacheability Segments FH,EH,DH */
		/* const */ unsigned int RES            : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_PMA0_type;
#define CPU0_PMA0	(*( CPU0_PMA0_type *) 0xf8818100u)	/* Data Access CacheabilityRegister */
#define CPU1_PMA0	(*( CPU0_PMA0_type *) 0xf8838100u)	/* Data Access CacheabilityRegister */
#define CPU2_PMA0	(*( CPU0_PMA0_type *) 0xf8858100u)	/* Data Access CacheabilityRegister */

typedef volatile union
{
	struct
	{ 
		unsigned int CAC_0          : 10;	/* Code Access Cacheability Segments 9H-0H */
		/* const */ unsigned int CAC_A          : 1;	/* Code Access Cacheability Segments AH */
		unsigned int CAC_B          : 1;	/* Code Access Cacheability Segments BH */
		/* const */ unsigned int CAC_C          : 1;	/* Code Access Cacheability Segments CH */
		unsigned int CAC_D          : 1;	/* Code Access Cacheability Segments DH */
		/* const */ unsigned int CAC_E          : 2;	/* Code Access Cacheability Segments FH,EH */
		/* const */ unsigned int RES            : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_PMA1_type;
#define CPU0_PMA1	(*( CPU0_PMA1_type *) 0xf8818104u)	/* Code Access CacheabilityRegister */
#define CPU1_PMA1	(*( CPU0_PMA1_type *) 0xf8838104u)	/* Code Access CacheabilityRegister */
#define CPU2_PMA1	(*( CPU0_PMA1_type *) 0xf8858104u)	/* Code Access CacheabilityRegister */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int PSI            : 16;	/* Peripheral Space Identifier Segments FH-0H */
		/* const */ unsigned int RES            : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_PMA2_type;
#define CPU0_PMA2	(*( CPU0_PMA2_type *) 0xf8818108u)	/* Peripheral Space Identifier register */
#define CPU1_PMA2	(*( CPU0_PMA2_type *) 0xf8838108u)	/* Peripheral Space Identifier register */
#define CPU2_PMA2	(*( CPU0_PMA2_type *) 0xf8858108u)	/* Peripheral Space Identifier register */

typedef volatile union
{
	struct
	{ 
		unsigned int FRE            : 1;	/* Fetch Range Error */
		unsigned int FGAE           : 1;	/* Fetch Global Address Error */
		unsigned int FBE            : 1;	/* Fetch Bus Error */
		/* const */ unsigned int RES            : 9;	/* Reserved */
		unsigned int FPE            : 1;	/* Fetch Peripheral Error */
		/* const */ unsigned int RES_6          : 1;	/* Reserved */
		unsigned int FME            : 1;	/* Fetch MSIST Error */
		/* const */ unsigned int RES_8          : 17;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_PSTR_type;
#define CPU0_PSTR	(*( CPU0_PSTR_type *) 0xf8819200u)	/* Program Synchronous Trap Register */
#define CPU1_PSTR	(*( CPU0_PSTR_type *) 0xf8839200u)	/* Program Synchronous Trap Register */
#define CPU2_PSTR	(*( CPU0_PSTR_type *) 0xf8859200u)	/* Program Synchronous Trap Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CDC            : 7;	/* Call Depth Counter */
		unsigned int CDE            : 1;	/* Call Depth Count Enable */
		unsigned int GW             : 1;	/* Global Address Register Write Permission */
		unsigned int IS             : 1;	/* Interrupt Stack Control */
		unsigned int IO             : 2;	/* Access Privilege Level Control (I/O Privilege) */
		unsigned int PRS            : 2;	/* Protection Register Set */
		unsigned int S              : 1;	/* Safe Task Identifier */
		/* const */ unsigned int RES            : 12;	/* Reserved */
		unsigned int SAV            : 1;	/* Sticky Advance Overflow Flag */
		unsigned int AV             : 1;	/* Advance Overflow Flag */
		unsigned int SV             : 1;	/* Sticky Overflow Flag */
		unsigned int V              : 1;	/* Overflow Flag */
		unsigned int C              : 1;	/* Carry Flag */
	} B;
	int I;
	unsigned int U;

} CPU0_PSW_type;
#define CPU0_PSW	(*( CPU0_PSW_type *) 0xf881fe04u)	/* Program Status Word */
#define CPU1_PSW	(*( CPU0_PSW_type *) 0xf883fe04u)	/* Program Status Word */
#define CPU2_PSW	(*( CPU0_PSW_type *) 0xf885fe04u)	/* Program Status Word */

typedef volatile union
{
	struct
	{ 
		unsigned int ADFLIP         : 8;	/* Address ECC Bit Flip */
		unsigned int ADTYPE         : 2;	/* Type of error */
		/* const */ unsigned int RES            : 21;	/* Reserved */
		unsigned int AE             : 1;	/* Activate Error Enable */
	} B;
	int I;
	unsigned int U;

} CPU0_SEGEN_type;
#define CPU0_SEGEN	(*( CPU0_SEGEN_type *) 0xf8811030u)	/* SRI Error Generation Register */

typedef volatile union
{
	struct
	{ 
		unsigned int bPC            : 1;	/* Instruction Cache Memory SIST Mode Access Control */
		/* const */ unsigned int RES            : 1;	/* Reserved */
		unsigned int PT             : 1;	/* Program Tag Memory SIST Mode Access Control */
		/* const */ unsigned int RES_4          : 5;	/* Reserved */
		unsigned int DC             : 1;	/* Data Cache Memory SIST Mode Access Control */
		/* const */ unsigned int RES_6          : 1;	/* Reserved */
		unsigned int DT             : 1;	/* Data Tag Memory SIST Mode Access Control */
		/* const */ unsigned int RES_8          : 5;	/* Reserved */
		/* const */ unsigned int RES_9          : 8;	/* Reserved */
		unsigned int IODT           : 1;	/* In-Order Data Transactions */
		/* const */ unsigned int RES_11         : 7;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_SMACON_type;
#define CPU0_SMACON	(*( CPU0_SMACON_type *) 0xf881900cu)	/* SIST Mode Access Control Register */
#define CPU1_SMACON	(*( CPU0_SMACON_type *) 0xf883900cu)	/* SIST Mode Access Control Register */
#define CPU2_SMACON	(*( CPU0_SMACON_type *) 0xf885900cu)	/* SIST Mode Access Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EVTA           : 3;	/* Event Associated */
		unsigned int BBM            : 1;	/* Break Before Make (BBM) or Break After Make (BAM) Selection */
		unsigned int BOD            : 1;	/* Breakout Disable */
		unsigned int SUSP           : 1;	/* CDC Suspend-Out Signal State */
		unsigned int CNT            : 2;	/* Counter */
		/* const */ unsigned int RES            : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_SWEVT_type;
#define CPU0_SWEVT	(*( CPU0_SWEVT_type *) 0xf881fd10u)	/* Software Debug Event */
#define CPU1_SWEVT	(*( CPU0_SWEVT_type *) 0xf883fd10u)	/* Software Debug Event */
#define CPU2_SWEVT	(*( CPU0_SWEVT_type *) 0xf885fd10u)	/* Software Debug Event */

typedef volatile union
{
	struct
	{ 
		unsigned int FCDSF          : 1;	/* Free Context List Depleted Sticky Flag */
		unsigned int PROTEN         : 1;	/* Memory Protection Enable */
		unsigned int TPROTEN        : 1;	/* Temporal Protection Enable */
		unsigned int IS             : 1;	/* Initial State */
		unsigned int IT             : 1;	/* Initial State */
		/* const */ unsigned int RES            : 27;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_SYSCON_type;
#define CPU0_SYSCON	(*( CPU0_SYSCON_type *) 0xf881fe14u)	/* System Configuration Register */
#define CPU1_SYSCON	(*( CPU0_SYSCON_type *) 0xf883fe14u)	/* System Configuration Register */
#define CPU2_SYSCON	(*( CPU0_SYSCON_type *) 0xf885fe14u)	/* System Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ASI            : 5;	/* Address Space Identifier */
		/* const */ unsigned int RES            : 27;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_TASK_ASI_type;
#define CPU0_TASK_ASI	(*( CPU0_TASK_ASI_type *) 0xf8818004u)	/* CPU0 Task Address Space Identifier Register */
#define CPU1_TASK_ASI	(*( CPU0_TASK_ASI_type *) 0xf8838004u)	/* CPU1 Task Address Space Identifier Register */
#define CPU2_TASK_ASI	(*( CPU0_TASK_ASI_type *) 0xf8858004u)	/* CPU2 Task Address Space Identifier Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TEXP0          : 1;	/* Timer0 Expired Flag */
		/* const */ unsigned int TEXP1          : 1;	/* Timer1 Expired Flag */
		/* const */ unsigned int TEXP2          : 1;	/* Timer1 Expired Flag */
		/* const */ unsigned int RES            : 13;	/* Reserved */
		/* const */ unsigned int TTRAP          : 1;	/* Temporal Protection Trap */
		/* const */ unsigned int RES_6          : 15;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_TPS_CON_type;
#define CPU0_TPS_CON	(*( CPU0_TPS_CON_type *) 0xf881e400u)	/* CPU0 Temporal Protection System Control Register */
#define CPU1_TPS_CON	(*( CPU0_TPS_CON_type *) 0xf883e400u)	/* CPU1 Temporal Protection System Control Register */
#define CPU2_TPS_CON	(*( CPU0_TPS_CON_type *) 0xf885e400u)	/* CPU2 Temporal Protection System Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int Timer          : 32;	/* Temporal Protection Timer */
	} B;
	int I;
	unsigned int U;

} CPU0_TPS_TIMER0_type;
#define CPU0_TPS_TIMER0	(*( CPU0_TPS_TIMER0_type *) 0xf881e404u)	/* CPU0 Temporal Protection System Timer Register 0 */
#define CPU0_TPS_TIMER1	(*( CPU0_TPS_TIMER0_type *) 0xf881e408u)	/* CPU0 Temporal Protection System Timer Register 0 */
#define CPU0_TPS_TIMER2	(*( CPU0_TPS_TIMER0_type *) 0xf881e40cu)	/* CPU0 Temporal Protection System Timer Register 0 */
#define CPU1_TPS_TIMER0	(*( CPU0_TPS_TIMER0_type *) 0xf883e404u)	/* CPU1 Temporal Protection System Timer Register 1 */
#define CPU1_TPS_TIMER1	(*( CPU0_TPS_TIMER0_type *) 0xf883e408u)	/* CPU1 Temporal Protection System Timer Register 1 */
#define CPU1_TPS_TIMER2	(*( CPU0_TPS_TIMER0_type *) 0xf883e40cu)	/* CPU1 Temporal Protection System Timer Register 1 */
#define CPU2_TPS_TIMER0	(*( CPU0_TPS_TIMER0_type *) 0xf885e404u)	/* CPU2 Temporal Protection System Timer Register 2 */
#define CPU2_TPS_TIMER1	(*( CPU0_TPS_TIMER0_type *) 0xf885e408u)	/* CPU2 Temporal Protection System Timer Register 2 */
#define CPU2_TPS_TIMER2	(*( CPU0_TPS_TIMER0_type *) 0xf885e40cu)	/* CPU2 Temporal Protection System Timer Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 32;	/* Comparison Address */
	} B;
	int I;
	unsigned int U;

} CPU0_TR0ADR_type;
#define CPU0_TR0ADR	(*( CPU0_TR0ADR_type *) 0xf881f004u)	/* Trigger Address 0 */
#define CPU0_TR1ADR	(*( CPU0_TR0ADR_type *) 0xf881f00cu)	/* Trigger Address 1 */
#define CPU0_TR2ADR	(*( CPU0_TR0ADR_type *) 0xf881f014u)	/* Trigger Address 2 */
#define CPU0_TR3ADR	(*( CPU0_TR0ADR_type *) 0xf881f01cu)	/* Trigger Address 3 */
#define CPU0_TR4ADR	(*( CPU0_TR0ADR_type *) 0xf881f024u)	/* Trigger Address 4 */
#define CPU0_TR5ADR	(*( CPU0_TR0ADR_type *) 0xf881f02cu)	/* Trigger Address 5 */
#define CPU0_TR6ADR	(*( CPU0_TR0ADR_type *) 0xf881f034u)	/* Trigger Address 6 */
#define CPU0_TR7ADR	(*( CPU0_TR0ADR_type *) 0xf881f03cu)	/* Trigger Address 7 */
#define CPU1_TR0ADR	(*( CPU0_TR0ADR_type *) 0xf883f004u)	/* Trigger Address 0 */
#define CPU1_TR1ADR	(*( CPU0_TR0ADR_type *) 0xf883f00cu)	/* Trigger Address 1 */
#define CPU1_TR2ADR	(*( CPU0_TR0ADR_type *) 0xf883f014u)	/* Trigger Address 2 */
#define CPU1_TR3ADR	(*( CPU0_TR0ADR_type *) 0xf883f01cu)	/* Trigger Address 3 */
#define CPU1_TR4ADR	(*( CPU0_TR0ADR_type *) 0xf883f024u)	/* Trigger Address 4 */
#define CPU1_TR5ADR	(*( CPU0_TR0ADR_type *) 0xf883f02cu)	/* Trigger Address 5 */
#define CPU1_TR6ADR	(*( CPU0_TR0ADR_type *) 0xf883f034u)	/* Trigger Address 6 */
#define CPU1_TR7ADR	(*( CPU0_TR0ADR_type *) 0xf883f03cu)	/* Trigger Address 7 */
#define CPU2_TR0ADR	(*( CPU0_TR0ADR_type *) 0xf885f004u)	/* Trigger Address 0 */
#define CPU2_TR1ADR	(*( CPU0_TR0ADR_type *) 0xf885f00cu)	/* Trigger Address 1 */
#define CPU2_TR2ADR	(*( CPU0_TR0ADR_type *) 0xf885f014u)	/* Trigger Address 2 */
#define CPU2_TR3ADR	(*( CPU0_TR0ADR_type *) 0xf885f01cu)	/* Trigger Address 3 */
#define CPU2_TR4ADR	(*( CPU0_TR0ADR_type *) 0xf885f024u)	/* Trigger Address 4 */
#define CPU2_TR5ADR	(*( CPU0_TR0ADR_type *) 0xf885f02cu)	/* Trigger Address 5 */
#define CPU2_TR6ADR	(*( CPU0_TR0ADR_type *) 0xf885f034u)	/* Trigger Address 6 */
#define CPU2_TR7ADR	(*( CPU0_TR0ADR_type *) 0xf885f03cu)	/* Trigger Address 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int EVTA           : 3;	/* Event Associated */
		unsigned int BBM            : 1;	/* Break Before Make (BBM) or Break After Make (BAM) Selection */
		unsigned int BOD            : 1;	/* Breakout Disable */
		unsigned int SUSP           : 1;	/* CDC Suspend-Out Signal State */
		unsigned int CNT            : 2;	/* Counter */
		/* const */ unsigned int RES            : 4;	/* Reserved */
		unsigned int TYP            : 1;	/* Input Selection */
		unsigned int RNG            : 1;	/* Compare Type */
		/* const */ unsigned int RES_9          : 1;	/* Reserved */
		unsigned int ASI_EN         : 1;	/* Enable ASI Comparison */
		unsigned int ASI            : 5;	/* Address Space Identifier */
		/* const */ unsigned int RES_12         : 6;	/* Reserved */
		unsigned int AST            : 1;	/* Address Store */
		unsigned int ALD            : 1;	/* Address Load */
		/* const */ unsigned int RES_15         : 3;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_TR0EVT_type;
#define CPU0_TR0EVT	(*( CPU0_TR0EVT_type *) 0xf881f000u)	/* Trigger Event 0 */
#define CPU0_TR1EVT	(*( CPU0_TR0EVT_type *) 0xf881f008u)	/* Trigger Event 1 */
#define CPU0_TR2EVT	(*( CPU0_TR0EVT_type *) 0xf881f010u)	/* Trigger Event 2 */
#define CPU0_TR3EVT	(*( CPU0_TR0EVT_type *) 0xf881f018u)	/* Trigger Event 3 */
#define CPU0_TR4EVT	(*( CPU0_TR0EVT_type *) 0xf881f020u)	/* Trigger Event 4 */
#define CPU0_TR5EVT	(*( CPU0_TR0EVT_type *) 0xf881f028u)	/* Trigger Event 5 */
#define CPU0_TR6EVT	(*( CPU0_TR0EVT_type *) 0xf881f030u)	/* Trigger Event 6 */
#define CPU0_TR7EVT	(*( CPU0_TR0EVT_type *) 0xf881f038u)	/* Trigger Event 7 */
#define CPU1_TR0EVT	(*( CPU0_TR0EVT_type *) 0xf883f000u)	/* Trigger Event 0 */
#define CPU1_TR1EVT	(*( CPU0_TR0EVT_type *) 0xf883f008u)	/* Trigger Event 1 */
#define CPU1_TR2EVT	(*( CPU0_TR0EVT_type *) 0xf883f010u)	/* Trigger Event 2 */
#define CPU1_TR3EVT	(*( CPU0_TR0EVT_type *) 0xf883f018u)	/* Trigger Event 3 */
#define CPU1_TR4EVT	(*( CPU0_TR0EVT_type *) 0xf883f020u)	/* Trigger Event 4 */
#define CPU1_TR5EVT	(*( CPU0_TR0EVT_type *) 0xf883f028u)	/* Trigger Event 5 */
#define CPU1_TR6EVT	(*( CPU0_TR0EVT_type *) 0xf883f030u)	/* Trigger Event 6 */
#define CPU1_TR7EVT	(*( CPU0_TR0EVT_type *) 0xf883f038u)	/* Trigger Event 7 */
#define CPU2_TR0EVT	(*( CPU0_TR0EVT_type *) 0xf885f000u)	/* Trigger Event 0 */
#define CPU2_TR1EVT	(*( CPU0_TR0EVT_type *) 0xf885f008u)	/* Trigger Event 1 */
#define CPU2_TR2EVT	(*( CPU0_TR0EVT_type *) 0xf885f010u)	/* Trigger Event 2 */
#define CPU2_TR3EVT	(*( CPU0_TR0EVT_type *) 0xf885f018u)	/* Trigger Event 3 */
#define CPU2_TR4EVT	(*( CPU0_TR0EVT_type *) 0xf885f020u)	/* Trigger Event 4 */
#define CPU2_TR5EVT	(*( CPU0_TR0EVT_type *) 0xf885f028u)	/* Trigger Event 5 */
#define CPU2_TR6EVT	(*( CPU0_TR0EVT_type *) 0xf885f030u)	/* Trigger Event 6 */
#define CPU2_TR7EVT	(*( CPU0_TR0EVT_type *) 0xf885f038u)	/* Trigger Event 7 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int T0             : 1;	/* Trigger-0 */
		/* const */ unsigned int T1             : 1;	/* Trigger-1 */
		/* const */ unsigned int T2             : 1;	/* Trigger-2 */
		/* const */ unsigned int T3             : 1;	/* Trigger-3 */
		/* const */ unsigned int T4             : 1;	/* Trigger-4 */
		/* const */ unsigned int T5             : 1;	/* Trigger-5 */
		/* const */ unsigned int T6             : 1;	/* Trigger-6 */
		/* const */ unsigned int T7             : 1;	/* Trigger-7 */
		/* const */ unsigned int RES            : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_TRIG_ACC_type;
#define CPU0_TRIG_ACC	(*( CPU0_TRIG_ACC_type *) 0xf881fd30u)	/* CPU0 Trigger Address x */
#define CPU1_TRIG_ACC	(*( CPU0_TRIG_ACC_type *) 0xf883fd30u)	/* CPU1 Trigger Address x */
#define CPU2_TRIG_ACC	(*( CPU0_TRIG_ACC_type *) 0xf885fd30u)	/* CPU2 Trigger Address x */


/* CPU_SPROT */
typedef volatile union
{
	struct
	{ 
		unsigned int EN             : 32;	/* Access Enable for Master TAG ID n (n= 0-31) */
	} B;
	int I;
	unsigned int U;

} CPU0_SPROT_ACCENA_type;
#define CPU0_SPROT_ACCENA	(*( CPU0_SPROT_ACCENA_type *) 0xf880e100u)	/* CPU0 Safety Protection Register Access Enable Register A */
#define CPU1_SPROT_ACCENA	(*( CPU0_SPROT_ACCENA_type *) 0xf882e100u)	/* CPU1 Safety Protection Register Access Enable Register A */
#define CPU2_SPROT_ACCENA	(*( CPU0_SPROT_ACCENA_type *) 0xf884e100u)	/* CPU2 Safety Protection Register Access Enable Register A */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} CPU0_SPROT_ACCENB_type;
#define CPU0_SPROT_ACCENB	(*( CPU0_SPROT_ACCENB_type *) 0xf880e104u)	/* CPU0 Safety Protection Region Access Enable Register B */
#define CPU0_SPROT_RGNACCENB0	(*( CPU0_SPROT_ACCENB_type *) 0xf880e00cu)	/* CPU0 Safety Protection Region Access Enable Register B */
#define CPU0_SPROT_RGNACCENB1	(*( CPU0_SPROT_ACCENB_type *) 0xf880e01cu)	/* CPU0 Safety Protection Region Access Enable Register B */
#define CPU0_SPROT_RGNACCENB2	(*( CPU0_SPROT_ACCENB_type *) 0xf880e02cu)	/* CPU0 Safety Protection Region Access Enable Register B */
#define CPU0_SPROT_RGNACCENB3	(*( CPU0_SPROT_ACCENB_type *) 0xf880e03cu)	/* CPU0 Safety Protection Region Access Enable Register B */
#define CPU0_SPROT_RGNACCENB4	(*( CPU0_SPROT_ACCENB_type *) 0xf880e04cu)	/* CPU0 Safety Protection Region Access Enable Register B */
#define CPU0_SPROT_RGNACCENB5	(*( CPU0_SPROT_ACCENB_type *) 0xf880e05cu)	/* CPU0 Safety Protection Region Access Enable Register B */
#define CPU0_SPROT_RGNACCENB6	(*( CPU0_SPROT_ACCENB_type *) 0xf880e06cu)	/* CPU0 Safety Protection Region Access Enable Register B */
#define CPU0_SPROT_RGNACCENB7	(*( CPU0_SPROT_ACCENB_type *) 0xf880e07cu)	/* CPU0 Safety Protection Region Access Enable Register B */
#define CPU1_SPROT_ACCENB	(*( CPU0_SPROT_ACCENB_type *) 0xf882e104u)	/* CPU1 Safety Protection Region Access Enable Register B */
#define CPU1_SPROT_RGNACCENB0	(*( CPU0_SPROT_ACCENB_type *) 0xf882e00cu)	/* CPU1 Safety Protection Region Access Enable Register B */
#define CPU1_SPROT_RGNACCENB1	(*( CPU0_SPROT_ACCENB_type *) 0xf882e01cu)	/* CPU1 Safety Protection Region Access Enable Register B */
#define CPU1_SPROT_RGNACCENB2	(*( CPU0_SPROT_ACCENB_type *) 0xf882e02cu)	/* CPU1 Safety Protection Region Access Enable Register B */
#define CPU1_SPROT_RGNACCENB3	(*( CPU0_SPROT_ACCENB_type *) 0xf882e03cu)	/* CPU1 Safety Protection Region Access Enable Register B */
#define CPU1_SPROT_RGNACCENB4	(*( CPU0_SPROT_ACCENB_type *) 0xf882e04cu)	/* CPU1 Safety Protection Region Access Enable Register B */
#define CPU1_SPROT_RGNACCENB5	(*( CPU0_SPROT_ACCENB_type *) 0xf882e05cu)	/* CPU1 Safety Protection Region Access Enable Register B */
#define CPU1_SPROT_RGNACCENB6	(*( CPU0_SPROT_ACCENB_type *) 0xf882e06cu)	/* CPU1 Safety Protection Region Access Enable Register B */
#define CPU1_SPROT_RGNACCENB7	(*( CPU0_SPROT_ACCENB_type *) 0xf882e07cu)	/* CPU1 Safety Protection Region Access Enable Register B */
#define CPU2_SPROT_ACCENB	(*( CPU0_SPROT_ACCENB_type *) 0xf884e104u)	/* CPU2 Safety Protection Region Access Enable Register B */
#define CPU2_SPROT_RGNACCENB0	(*( CPU0_SPROT_ACCENB_type *) 0xf884e00cu)	/* CPU2 Safety Protection Region Access Enable Register B */
#define CPU2_SPROT_RGNACCENB1	(*( CPU0_SPROT_ACCENB_type *) 0xf884e01cu)	/* CPU2 Safety Protection Region Access Enable Register B */
#define CPU2_SPROT_RGNACCENB2	(*( CPU0_SPROT_ACCENB_type *) 0xf884e02cu)	/* CPU2 Safety Protection Region Access Enable Register B */
#define CPU2_SPROT_RGNACCENB3	(*( CPU0_SPROT_ACCENB_type *) 0xf884e03cu)	/* CPU2 Safety Protection Region Access Enable Register B */
#define CPU2_SPROT_RGNACCENB4	(*( CPU0_SPROT_ACCENB_type *) 0xf884e04cu)	/* CPU2 Safety Protection Region Access Enable Register B */
#define CPU2_SPROT_RGNACCENB5	(*( CPU0_SPROT_ACCENB_type *) 0xf884e05cu)	/* CPU2 Safety Protection Region Access Enable Register B */
#define CPU2_SPROT_RGNACCENB6	(*( CPU0_SPROT_ACCENB_type *) 0xf884e06cu)	/* CPU2 Safety Protection Region Access Enable Register B */
#define CPU2_SPROT_RGNACCENB7	(*( CPU0_SPROT_ACCENB_type *) 0xf884e07cu)	/* CPU2 Safety Protection Region Access Enable Register B */

typedef volatile union
{
	struct
	{ 
		unsigned int EN             : 32;	/* Access Enable for Master TAG ID n (n = 0-31) */
	} B;
	int I;
	unsigned int U;

} CPU0_SPROT_RGNACCENA0_type;
#define CPU0_SPROT_RGNACCENA0	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf880e008u)	/* CPU0 Safety Protection Region Access Enable Register A */
#define CPU0_SPROT_RGNACCENA1	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf880e018u)	/* CPU0 Safety Protection Region Access Enable Register A */
#define CPU0_SPROT_RGNACCENA2	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf880e028u)	/* CPU0 Safety Protection Region Access Enable Register A */
#define CPU0_SPROT_RGNACCENA3	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf880e038u)	/* CPU0 Safety Protection Region Access Enable Register A */
#define CPU0_SPROT_RGNACCENA4	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf880e048u)	/* CPU0 Safety Protection Region Access Enable Register A */
#define CPU0_SPROT_RGNACCENA5	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf880e058u)	/* CPU0 Safety Protection Region Access Enable Register A */
#define CPU0_SPROT_RGNACCENA6	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf880e068u)	/* CPU0 Safety Protection Region Access Enable Register A */
#define CPU0_SPROT_RGNACCENA7	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf880e078u)	/* CPU0 Safety Protection Region Access Enable Register A */
#define CPU1_SPROT_RGNACCENA0	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf882e008u)	/* CPU1 Safety Protection Region Access Enable Register A */
#define CPU1_SPROT_RGNACCENA1	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf882e018u)	/* CPU1 Safety Protection Region Access Enable Register A */
#define CPU1_SPROT_RGNACCENA2	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf882e028u)	/* CPU1 Safety Protection Region Access Enable Register A */
#define CPU1_SPROT_RGNACCENA3	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf882e038u)	/* CPU1 Safety Protection Region Access Enable Register A */
#define CPU1_SPROT_RGNACCENA4	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf882e048u)	/* CPU1 Safety Protection Region Access Enable Register A */
#define CPU1_SPROT_RGNACCENA5	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf882e058u)	/* CPU1 Safety Protection Region Access Enable Register A */
#define CPU1_SPROT_RGNACCENA6	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf882e068u)	/* CPU1 Safety Protection Region Access Enable Register A */
#define CPU1_SPROT_RGNACCENA7	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf882e078u)	/* CPU1 Safety Protection Region Access Enable Register A */
#define CPU2_SPROT_RGNACCENA0	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf884e008u)	/* CPU2 Safety Protection Region Access Enable Register A */
#define CPU2_SPROT_RGNACCENA1	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf884e018u)	/* CPU2 Safety Protection Region Access Enable Register A */
#define CPU2_SPROT_RGNACCENA2	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf884e028u)	/* CPU2 Safety Protection Region Access Enable Register A */
#define CPU2_SPROT_RGNACCENA3	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf884e038u)	/* CPU2 Safety Protection Region Access Enable Register A */
#define CPU2_SPROT_RGNACCENA4	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf884e048u)	/* CPU2 Safety Protection Region Access Enable Register A */
#define CPU2_SPROT_RGNACCENA5	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf884e058u)	/* CPU2 Safety Protection Region Access Enable Register A */
#define CPU2_SPROT_RGNACCENA6	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf884e068u)	/* CPU2 Safety Protection Region Access Enable Register A */
#define CPU2_SPROT_RGNACCENA7	(*( CPU0_SPROT_RGNACCENA0_type *) 0xf884e078u)	/* CPU2 Safety Protection Region Access Enable Register A */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 5;	/* Reserved */
		unsigned int ADDR           : 27;	/* Region Lower Address */
	} B;
	int I;
	unsigned int U;

} CPU0_SPROT_RGNLA0_type;
#define CPU0_SPROT_RGNLA0	(*( CPU0_SPROT_RGNLA0_type *) 0xf880e000u)	/* CPU0 Safety Protection Region Lower Address Register */
#define CPU0_SPROT_RGNLA1	(*( CPU0_SPROT_RGNLA0_type *) 0xf880e010u)	/* CPU0 Safety Protection Region Lower Address Register */
#define CPU0_SPROT_RGNLA2	(*( CPU0_SPROT_RGNLA0_type *) 0xf880e020u)	/* CPU0 Safety Protection Region Lower Address Register */
#define CPU0_SPROT_RGNLA3	(*( CPU0_SPROT_RGNLA0_type *) 0xf880e030u)	/* CPU0 Safety Protection Region Lower Address Register */
#define CPU0_SPROT_RGNLA4	(*( CPU0_SPROT_RGNLA0_type *) 0xf880e040u)	/* CPU0 Safety Protection Region Lower Address Register */
#define CPU0_SPROT_RGNLA5	(*( CPU0_SPROT_RGNLA0_type *) 0xf880e050u)	/* CPU0 Safety Protection Region Lower Address Register */
#define CPU0_SPROT_RGNLA6	(*( CPU0_SPROT_RGNLA0_type *) 0xf880e060u)	/* CPU0 Safety Protection Region Lower Address Register */
#define CPU0_SPROT_RGNLA7	(*( CPU0_SPROT_RGNLA0_type *) 0xf880e070u)	/* CPU0 Safety Protection Region Lower Address Register */
#define CPU1_SPROT_RGNLA0	(*( CPU0_SPROT_RGNLA0_type *) 0xf882e000u)	/* CPU1 Safety Protection Region Lower Address Register */
#define CPU1_SPROT_RGNLA1	(*( CPU0_SPROT_RGNLA0_type *) 0xf882e010u)	/* CPU1 Safety Protection Region Lower Address Register */
#define CPU1_SPROT_RGNLA2	(*( CPU0_SPROT_RGNLA0_type *) 0xf882e020u)	/* CPU1 Safety Protection Region Lower Address Register */
#define CPU1_SPROT_RGNLA3	(*( CPU0_SPROT_RGNLA0_type *) 0xf882e030u)	/* CPU1 Safety Protection Region Lower Address Register */
#define CPU1_SPROT_RGNLA4	(*( CPU0_SPROT_RGNLA0_type *) 0xf882e040u)	/* CPU1 Safety Protection Region Lower Address Register */
#define CPU1_SPROT_RGNLA5	(*( CPU0_SPROT_RGNLA0_type *) 0xf882e050u)	/* CPU1 Safety Protection Region Lower Address Register */
#define CPU1_SPROT_RGNLA6	(*( CPU0_SPROT_RGNLA0_type *) 0xf882e060u)	/* CPU1 Safety Protection Region Lower Address Register */
#define CPU1_SPROT_RGNLA7	(*( CPU0_SPROT_RGNLA0_type *) 0xf882e070u)	/* CPU1 Safety Protection Region Lower Address Register */
#define CPU2_SPROT_RGNLA0	(*( CPU0_SPROT_RGNLA0_type *) 0xf884e000u)	/* CPU2 Safety Protection Region Lower Address Register */
#define CPU2_SPROT_RGNLA1	(*( CPU0_SPROT_RGNLA0_type *) 0xf884e010u)	/* CPU2 Safety Protection Region Lower Address Register */
#define CPU2_SPROT_RGNLA2	(*( CPU0_SPROT_RGNLA0_type *) 0xf884e020u)	/* CPU2 Safety Protection Region Lower Address Register */
#define CPU2_SPROT_RGNLA3	(*( CPU0_SPROT_RGNLA0_type *) 0xf884e030u)	/* CPU2 Safety Protection Region Lower Address Register */
#define CPU2_SPROT_RGNLA4	(*( CPU0_SPROT_RGNLA0_type *) 0xf884e040u)	/* CPU2 Safety Protection Region Lower Address Register */
#define CPU2_SPROT_RGNLA5	(*( CPU0_SPROT_RGNLA0_type *) 0xf884e050u)	/* CPU2 Safety Protection Region Lower Address Register */
#define CPU2_SPROT_RGNLA6	(*( CPU0_SPROT_RGNLA0_type *) 0xf884e060u)	/* CPU2 Safety Protection Region Lower Address Register */
#define CPU2_SPROT_RGNLA7	(*( CPU0_SPROT_RGNLA0_type *) 0xf884e070u)	/* CPU2 Safety Protection Region Lower Address Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 5;	/* Reserved */
		unsigned int ADDR           : 27;	/* Region Upper Address */
	} B;
	int I;
	unsigned int U;

} CPU0_SPROT_RGNUA0_type;
#define CPU0_SPROT_RGNUA0	(*( CPU0_SPROT_RGNUA0_type *) 0xf880e004u)	/* CPU0 Safety protection Region Upper Address Register */
#define CPU0_SPROT_RGNUA1	(*( CPU0_SPROT_RGNUA0_type *) 0xf880e014u)	/* CPU0 Safety protection Region Upper Address Register */
#define CPU0_SPROT_RGNUA2	(*( CPU0_SPROT_RGNUA0_type *) 0xf880e024u)	/* CPU0 Safety protection Region Upper Address Register */
#define CPU0_SPROT_RGNUA3	(*( CPU0_SPROT_RGNUA0_type *) 0xf880e034u)	/* CPU0 Safety protection Region Upper Address Register */
#define CPU0_SPROT_RGNUA4	(*( CPU0_SPROT_RGNUA0_type *) 0xf880e044u)	/* CPU0 Safety protection Region Upper Address Register */
#define CPU0_SPROT_RGNUA5	(*( CPU0_SPROT_RGNUA0_type *) 0xf880e054u)	/* CPU0 Safety protection Region Upper Address Register */
#define CPU0_SPROT_RGNUA6	(*( CPU0_SPROT_RGNUA0_type *) 0xf880e064u)	/* CPU0 Safety protection Region Upper Address Register */
#define CPU0_SPROT_RGNUA7	(*( CPU0_SPROT_RGNUA0_type *) 0xf880e074u)	/* CPU0 Safety protection Region Upper Address Register */
#define CPU1_SPROT_RGNUA0	(*( CPU0_SPROT_RGNUA0_type *) 0xf882e004u)	/* CPU1 Safety protection Region Upper Address Register */
#define CPU1_SPROT_RGNUA1	(*( CPU0_SPROT_RGNUA0_type *) 0xf882e014u)	/* CPU1 Safety protection Region Upper Address Register */
#define CPU1_SPROT_RGNUA2	(*( CPU0_SPROT_RGNUA0_type *) 0xf882e024u)	/* CPU1 Safety protection Region Upper Address Register */
#define CPU1_SPROT_RGNUA3	(*( CPU0_SPROT_RGNUA0_type *) 0xf882e034u)	/* CPU1 Safety protection Region Upper Address Register */
#define CPU1_SPROT_RGNUA4	(*( CPU0_SPROT_RGNUA0_type *) 0xf882e044u)	/* CPU1 Safety protection Region Upper Address Register */
#define CPU1_SPROT_RGNUA5	(*( CPU0_SPROT_RGNUA0_type *) 0xf882e054u)	/* CPU1 Safety protection Region Upper Address Register */
#define CPU1_SPROT_RGNUA6	(*( CPU0_SPROT_RGNUA0_type *) 0xf882e064u)	/* CPU1 Safety protection Region Upper Address Register */
#define CPU1_SPROT_RGNUA7	(*( CPU0_SPROT_RGNUA0_type *) 0xf882e074u)	/* CPU1 Safety protection Region Upper Address Register */
#define CPU2_SPROT_RGNUA0	(*( CPU0_SPROT_RGNUA0_type *) 0xf884e004u)	/* CPU2 Safety protection Region Upper Address Register */
#define CPU2_SPROT_RGNUA1	(*( CPU0_SPROT_RGNUA0_type *) 0xf884e014u)	/* CPU2 Safety protection Region Upper Address Register */
#define CPU2_SPROT_RGNUA2	(*( CPU0_SPROT_RGNUA0_type *) 0xf884e024u)	/* CPU2 Safety protection Region Upper Address Register */
#define CPU2_SPROT_RGNUA3	(*( CPU0_SPROT_RGNUA0_type *) 0xf884e034u)	/* CPU2 Safety protection Region Upper Address Register */
#define CPU2_SPROT_RGNUA4	(*( CPU0_SPROT_RGNUA0_type *) 0xf884e044u)	/* CPU2 Safety protection Region Upper Address Register */
#define CPU2_SPROT_RGNUA5	(*( CPU0_SPROT_RGNUA0_type *) 0xf884e054u)	/* CPU2 Safety protection Region Upper Address Register */
#define CPU2_SPROT_RGNUA6	(*( CPU0_SPROT_RGNUA0_type *) 0xf884e064u)	/* CPU2 Safety protection Region Upper Address Register */
#define CPU2_SPROT_RGNUA7	(*( CPU0_SPROT_RGNUA0_type *) 0xf884e074u)	/* CPU2 Safety protection Region Upper Address Register */


/* SMU */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} SMU_ACCEN0_type;
#define SMU_ACCEN0	(*( SMU_ACCEN0_type *) 0xf0036ffcu)	/* SMU Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} SMU_ACCEN1_type;
#define SMU_ACCEN1	(*( SMU_ACCEN1_type *) 0xf0036ff8u)	/* SMU Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DF0            : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF1            : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF2            : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF3            : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF4            : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF5            : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF6            : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF7            : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF8            : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF9            : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF10           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF11           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF12           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF13           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF14           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF15           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF16           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF17           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF18           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF19           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF20           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF21           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF22           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF23           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF24           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF25           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF26           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF27           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF28           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF29           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF30           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
		/* const */ unsigned int DF31           : 1;	/* Debug flag for alarm n belonging to alarm group x (x=0-6). */
	} B;
	int I;
	unsigned int U;

} SMU_AD0_type;
#define SMU_AD0	(*( SMU_AD0_type *) 0xf0036a00u)	/* Alarm Status Register */
#define SMU_AD1	(*( SMU_AD0_type *) 0xf0036a04u)	/* Alarm Status Register */
#define SMU_AD2	(*( SMU_AD0_type *) 0xf0036a08u)	/* Alarm Status Register */
#define SMU_AD3	(*( SMU_AD0_type *) 0xf0036a0cu)	/* Alarm Status Register */
#define SMU_AD4	(*( SMU_AD0_type *) 0xf0036a10u)	/* Alarm Status Register */
#define SMU_AD5	(*( SMU_AD0_type *) 0xf0036a14u)	/* Alarm Status Register */
#define SMU_AD6	(*( SMU_AD0_type *) 0xf0036a18u)	/* Alarm Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SF0            : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF1            : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF2            : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF3            : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF4            : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF5            : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF6            : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF7            : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF8            : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF9            : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF10           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF11           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF12           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF13           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF14           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF15           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF16           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF17           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF18           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF19           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF20           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF21           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF22           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF23           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF24           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF25           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF26           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF27           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF28           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF29           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF30           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
		unsigned int SF31           : 1;	/* Status flag for alarm n belonging to alarm group x (x=0-6). */
	} B;
	int I;
	unsigned int U;

} SMU_AG0_type;
#define SMU_AG0	(*( SMU_AG0_type *) 0xf00369c0u)	/* Alarm Status Register */
#define SMU_AG1	(*( SMU_AG0_type *) 0xf00369c4u)	/* Alarm Status Register */
#define SMU_AG2	(*( SMU_AG0_type *) 0xf00369c8u)	/* Alarm Status Register */
#define SMU_AG3	(*( SMU_AG0_type *) 0xf00369ccu)	/* Alarm Status Register */
#define SMU_AG4	(*( SMU_AG0_type *) 0xf00369d0u)	/* Alarm Status Register */
#define SMU_AG5	(*( SMU_AG0_type *) 0xf00369d4u)	/* Alarm Status Register */
#define SMU_AG6	(*( SMU_AG0_type *) 0xf00369d8u)	/* Alarm Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CF0            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF1            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF2            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF3            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF4            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF5            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF6            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF7            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF8            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF9            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF10           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF11           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF12           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF13           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF14           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF15           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF16           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF17           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF18           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF19           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF20           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF21           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF22           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF23           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF24           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF25           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF26           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF27           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF28           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF29           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF30           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
		unsigned int CF31           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 0. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 0. */
	} B;
	int I;
	unsigned int U;

} SMU_AG0CF0_type;
#define SMU_AG0CF0	(*( SMU_AG0CF0_type *) 0xf0036900u)	/* Alarm Configuration Register */
#define SMU_AG0CF1	(*( SMU_AG0CF0_type *) 0xf0036904u)	/* Alarm Configuration Register */
#define SMU_AG0CF2	(*( SMU_AG0CF0_type *) 0xf0036908u)	/* Alarm Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FE0            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE1            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE2            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE3            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE4            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE5            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE6            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE7            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE8            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE9            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE10           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE11           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE12           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE13           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE14           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE15           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE16           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE17           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE18           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE19           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE20           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE21           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE22           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE23           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE24           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE25           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE26           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE27           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE28           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE29           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE30           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
		unsigned int FE31           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 0. */
	} B;
	int I;
	unsigned int U;

} SMU_AG0FSP_type;
#define SMU_AG0FSP	(*( SMU_AG0FSP_type *) 0xf0036980u)	/* FSP Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CF0            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF1            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF2            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF3            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF4            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF5            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF6            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF7            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF8            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF9            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF10           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF11           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF12           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF13           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF14           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF15           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF16           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF17           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF18           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF19           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF20           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF21           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF22           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF23           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF24           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF25           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF26           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF27           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF28           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF29           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF30           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
		unsigned int CF31           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 1. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 1. */
	} B;
	int I;
	unsigned int U;

} SMU_AG1CF0_type;
#define SMU_AG1CF0	(*( SMU_AG1CF0_type *) 0xf003690cu)	/* Alarm Configuration Register */
#define SMU_AG1CF1	(*( SMU_AG1CF0_type *) 0xf0036910u)	/* Alarm Configuration Register */
#define SMU_AG1CF2	(*( SMU_AG1CF0_type *) 0xf0036914u)	/* Alarm Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FE0            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE1            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE2            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE3            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE4            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE5            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE6            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE7            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE8            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE9            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE10           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE11           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE12           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE13           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE14           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE15           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE16           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE17           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE18           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE19           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE20           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE21           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE22           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE23           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE24           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE25           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE26           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE27           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE28           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE29           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE30           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
		unsigned int FE31           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 1. */
	} B;
	int I;
	unsigned int U;

} SMU_AG1FSP_type;
#define SMU_AG1FSP	(*( SMU_AG1FSP_type *) 0xf0036984u)	/* FSP Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CF0            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF1            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF2            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF3            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF4            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF5            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF6            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF7            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF8            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF9            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF10           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF11           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF12           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF13           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF14           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF15           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF16           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF17           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF18           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF19           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF20           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF21           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF22           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF23           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF24           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF25           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF26           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF27           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF28           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF29           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF30           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
		unsigned int CF31           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 2. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 2. */
	} B;
	int I;
	unsigned int U;

} SMU_AG2CF0_type;
#define SMU_AG2CF0	(*( SMU_AG2CF0_type *) 0xf0036918u)	/* Alarm Configuration Register */
#define SMU_AG2CF1	(*( SMU_AG2CF0_type *) 0xf003691cu)	/* Alarm Configuration Register */
#define SMU_AG2CF2	(*( SMU_AG2CF0_type *) 0xf0036920u)	/* Alarm Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FE0            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE1            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE2            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE3            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE4            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE5            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE6            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE7            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE8            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE9            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE10           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE11           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE12           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE13           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE14           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE15           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE16           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE17           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE18           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE19           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE20           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE21           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE22           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE23           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE24           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE25           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE26           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE27           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE28           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE29           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE30           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
		unsigned int FE31           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 2. */
	} B;
	int I;
	unsigned int U;

} SMU_AG2FSP_type;
#define SMU_AG2FSP	(*( SMU_AG2FSP_type *) 0xf0036988u)	/* FSP Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CF0            : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF1            : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF2            : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF3            : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF4            : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF5            : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF6            : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF7            : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF8            : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF9            : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF10           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF11           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF12           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF13           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF14           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF15           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF16           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF17           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF18           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF19           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF20           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF21           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF22           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF23           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF24           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF25           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF26           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF27           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF28           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF29           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF30           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF31           : 1;	/* Configuration flag x (x=0-0) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
	} B;
	int I;
	unsigned int U;

} SMU_AG3CF0_type;
#define SMU_AG3CF0	(*( SMU_AG3CF0_type *) 0xf0036924u)	/* Alarm Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CF0            : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF1            : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF2            : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF3            : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF4            : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF5            : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF6            : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF7            : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF8            : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF9            : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF10           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF11           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF12           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF13           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF14           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF15           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF16           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF17           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF18           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF19           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF20           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF21           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF22           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF23           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF24           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF25           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF26           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF27           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF28           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF29           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF30           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF31           : 1;	/* Configuration flag x (x=1-1) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
	} B;
	int I;
	unsigned int U;

} SMU_AG3CF1_type;
#define SMU_AG3CF1	(*( SMU_AG3CF1_type *) 0xf0036928u)	/* Alarm Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CF0            : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF1            : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF2            : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF3            : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF4            : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF5            : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF6            : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF7            : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF8            : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF9            : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF10           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF11           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF12           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF13           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF14           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF15           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF16           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF17           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF18           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF19           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF20           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF21           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF22           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF23           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF24           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF25           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF26           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF27           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF28           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF29           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF30           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
		unsigned int CF31           : 1;	/* Configuration flag x (x=2) for alarm n belonging to alarm group 3. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 3. */
	} B;
	int I;
	unsigned int U;

} SMU_AG3CF2_type;
#define SMU_AG3CF2	(*( SMU_AG3CF2_type *) 0xf003692cu)	/* Alarm Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FE0            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE1            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE2            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE3            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE4            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE5            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE6            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE7            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE8            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE9            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE10           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE11           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE12           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE13           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE14           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE15           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE16           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE17           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE18           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE19           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE20           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE21           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE22           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE23           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE24           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE25           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE26           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE27           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE28           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE29           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE30           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
		unsigned int FE31           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 3. */
	} B;
	int I;
	unsigned int U;

} SMU_AG3FSP_type;
#define SMU_AG3FSP	(*( SMU_AG3FSP_type *) 0xf003698cu)	/* FSP Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CF0            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF1            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF2            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF3            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF4            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF5            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF6            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF7            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF8            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF9            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF10           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF11           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF12           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF13           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF14           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF15           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF16           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF17           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF18           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF19           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF20           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF21           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF22           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF23           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF24           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF25           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF26           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF27           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF28           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF29           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF30           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
		unsigned int CF31           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 4. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 4. */
	} B;
	int I;
	unsigned int U;

} SMU_AG4CF0_type;
#define SMU_AG4CF0	(*( SMU_AG4CF0_type *) 0xf0036930u)	/* Alarm Configuration Register */
#define SMU_AG4CF1	(*( SMU_AG4CF0_type *) 0xf0036934u)	/* Alarm Configuration Register */
#define SMU_AG4CF2	(*( SMU_AG4CF0_type *) 0xf0036938u)	/* Alarm Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FE0            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE1            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE2            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE3            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE4            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE5            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE6            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE7            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE8            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE9            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE10           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE11           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE12           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE13           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE14           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE15           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE16           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE17           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE18           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE19           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE20           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE21           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE22           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE23           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE24           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE25           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE26           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE27           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE28           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE29           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE30           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
		unsigned int FE31           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 4. */
	} B;
	int I;
	unsigned int U;

} SMU_AG4FSP_type;
#define SMU_AG4FSP	(*( SMU_AG4FSP_type *) 0xf0036990u)	/* FSP Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CF0            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF1            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF2            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF3            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF4            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF5            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF6            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF7            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF8            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF9            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF10           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF11           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF12           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF13           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF14           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF15           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF16           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF17           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF18           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF19           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF20           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF21           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF22           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF23           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF24           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF25           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF26           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF27           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF28           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF29           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF30           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
		unsigned int CF31           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 5. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 5. */
	} B;
	int I;
	unsigned int U;

} SMU_AG5CF0_type;
#define SMU_AG5CF0	(*( SMU_AG5CF0_type *) 0xf003693cu)	/* Alarm Configuration Register */
#define SMU_AG5CF1	(*( SMU_AG5CF0_type *) 0xf0036940u)	/* Alarm Configuration Register */
#define SMU_AG5CF2	(*( SMU_AG5CF0_type *) 0xf0036944u)	/* Alarm Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FE0            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE1            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE2            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE3            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE4            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE5            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE6            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE7            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE8            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE9            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE10           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE11           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE12           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE13           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE14           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE15           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE16           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE17           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE18           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE19           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE20           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE21           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE22           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE23           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE24           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE25           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE26           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE27           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE28           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE29           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE30           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
		unsigned int FE31           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 5. */
	} B;
	int I;
	unsigned int U;

} SMU_AG5FSP_type;
#define SMU_AG5FSP	(*( SMU_AG5FSP_type *) 0xf0036994u)	/* FSP Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CF0            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF1            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF2            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF3            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF4            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF5            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF6            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF7            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF8            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF9            : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF10           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF11           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF12           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF13           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF14           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF15           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF16           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF17           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF18           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF19           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF20           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF21           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF22           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF23           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF24           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF25           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF26           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF27           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF28           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF29           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF30           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
		unsigned int CF31           : 1;	/* Configuration flag x (x=0-2) for alarm n belonging to alarm group 6. The configuration flags 0, 1 and 2 must be used together to define the behavior of the SMU when a fault state is reported by the alarm n belonging to group 6. */
	} B;
	int I;
	unsigned int U;

} SMU_AG6CF0_type;
#define SMU_AG6CF0	(*( SMU_AG6CF0_type *) 0xf0036948u)	/* Alarm Configuration Register */
#define SMU_AG6CF1	(*( SMU_AG6CF0_type *) 0xf003694cu)	/* Alarm Configuration Register */
#define SMU_AG6CF2	(*( SMU_AG6CF0_type *) 0xf0036950u)	/* Alarm Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FE0            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE1            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE2            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE3            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE4            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE5            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE6            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE7            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE8            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE9            : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE10           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE11           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE12           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE13           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE14           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE15           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE16           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE17           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE18           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE19           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE20           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE21           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE22           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE23           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE24           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE25           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE26           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE27           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE28           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE29           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE30           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
		unsigned int FE31           : 1;	/* Fault signalling configuration flag for alarm n belonging to alarm group 6. */
	} B;
	int I;
	unsigned int U;

} SMU_AG6FSP_type;
#define SMU_AG6FSP	(*( SMU_AG6FSP_type *) 0xf0036998u)	/* FSP Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IGCS0          : 3;	/* Interrupt Generation Configuration Set 0 */
		unsigned int                : 1;
		unsigned int IGCS1          : 3;	/* Interrupt Generation Configuration Set 1 */
		unsigned int                : 1;
		unsigned int IGCS2          : 3;	/* Interrupt Generation Configuration Set 2 */
		unsigned int                : 5;
		unsigned int ICS            : 3;	/* Idle Configuration Set */
		unsigned int                : 5;
		unsigned int PES            : 5;	/* Port Emergency Stop */
		unsigned int EFRST          : 1;	/* Enable FAULT to RUN State Transition */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} SMU_AGC_type;
#define SMU_AGC	(*( SMU_AGC_type *) 0xf003682cu)	/* Alarm Global Configuration */

typedef volatile union
{
	struct
	{ 
		unsigned int CMD            : 4;	/* Implements the SMU Command Interface. */
		unsigned int ARG            : 4;	/* Implements the SMU Command Interface. */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} SMU_CMD_type;
#define SMU_CMD	(*( SMU_CMD_type *) 0xf0036820u)	/* Command Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SSM            : 2;	/* Running state of the SMU State Machine */
		/* const */ unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} SMU_DBG_type;
#define SMU_DBG	(*( SMU_DBG_type *) 0xf0036838u)	/* Debug Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PRE1           : 3;	/* Prescaler1 */
		unsigned int PRE2           : 2;	/* Prescaler2 */
		unsigned int MODE           : 2;	/* Fault Signaling Protocol configuration */
		unsigned int PES            : 1;	/* Port Emergency Stop (PES) */
		/* const */ unsigned int TFSP_LOW       : 14;	/* Specifies the FSP fault state duration */
		unsigned int TFSP_HIGH      : 10;	/* Specifies the FSP fault state duration */
	} B;
	int I;
	unsigned int U;

} SMU_FSP_type;
#define SMU_FSP	(*( SMU_FSP_type *) 0xf0036828u)	/* Fault Signaling Protocol */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} SMU_ID_type;
#define SMU_ID	(*( SMU_ID_type *) 0xf0036808u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CFGLCK         : 8;	/* Configuration Lock */
		unsigned int PERLCK         : 8;	/* Permanent Lock */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SMU_KEYS_type;
#define SMU_KEYS	(*( SMU_KEYS_type *) 0xf0036834u)	/* Key Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} SMU_KRST0_type;
#define SMU_KRST0	(*( SMU_KRST0_type *) 0xf0036ff4u)	/* SMU Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} SMU_KRST1_type;
#define SMU_KRST1	(*( SMU_KRST1_type *) 0xf0036ff0u)	/* SMU Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} SMU_KRSTCLR_type;
#define SMU_KRSTCLR	(*( SMU_KRSTCLR_type *) 0xf0036fecu)	/* SMU Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 2;	/* Trigger Set for OTGB0/1 */
		unsigned int TGB            : 1;	/* OTGB0/1 Bus Select */
		unsigned int TG_P           : 1;	/* TGS, TGB Write Protection */
		unsigned int                : 20;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} SMU_OCS_type;
#define SMU_OCS	(*( SMU_OCS_type *) 0xf0036fe8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		unsigned int HWDIR          : 1;	/* Port Direction. */
		unsigned int HWEN           : 1;	/* Port Enable. */
		unsigned int                : 5;
		unsigned int PCS            : 1;	/* PAD Configuration Select */
		unsigned int                : 8;
		/* const */ unsigned int PCFG           : 16;	/* PAD Configuration */
	} B;
	int I;
	unsigned int U;

} SMU_PCTL_type;
#define SMU_PCTL	(*( SMU_PCTL_type *) 0xf003683cu)	/* Port Control */

typedef volatile union
{
	struct
	{ 
		unsigned int TE             : 1;	/* Test Enable. */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} SMU_RMCTL_type;
#define SMU_RMCTL	(*( SMU_RMCTL_type *) 0xf0036b00u)	/* Register Monitor Control */

typedef volatile union
{
	struct
	{ 
		unsigned int EF0            : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF1            : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF2            : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF3            : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF4            : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF5            : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF6            : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF7            : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF8            : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF9            : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF10           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF11           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF12           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF13           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF14           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF15           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF16           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF17           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF18           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF19           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF20           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF21           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF22           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF23           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF24           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF25           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF26           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF27           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF28           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF29           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF30           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
		unsigned int EF31           : 1;	/* Status flag related to the different instances of the register monitor safety mechanism. */
	} B;
	int I;
	unsigned int U;

} SMU_RMEF_type;
#define SMU_RMEF	(*( SMU_RMEF_type *) 0xf0036b04u)	/* Register Monitor Error Flags */

typedef volatile union
{
	struct
	{ 
		unsigned int STS0           : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS1           : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS2           : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS3           : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS4           : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS5           : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS6           : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS7           : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS8           : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS9           : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS10          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS11          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS12          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS13          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS14          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS15          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS16          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS17          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS18          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS19          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS20          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS21          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS22          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS23          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS24          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS25          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS26          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS27          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS28          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS29          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS30          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
		unsigned int STS31          : 1;	/* Ready flag related to the different instances of the register monitor safety mechanism. */
	} B;
	int I;
	unsigned int U;

} SMU_RMSTS_type;
#define SMU_RMSTS	(*( SMU_RMSTS_type *) 0xf0036b08u)	/* Register Monitor Self Test Status */

typedef volatile union
{
	struct
	{ 
		unsigned int GID0           : 3;	/* Group Index 0. */
		unsigned int ALID0          : 5;	/* Alarm Identifier 0. */
		unsigned int GID1           : 3;	/* Group Index 1. */
		unsigned int ALID1          : 5;	/* Alarm Identifier 1. */
		unsigned int GID2           : 3;	/* Group Index 2. */
		unsigned int ALID2          : 5;	/* Alarm Identifier 2. */
		unsigned int GID3           : 3;	/* Group Index 3. */
		unsigned int ALID3          : 5;	/* Alarm Identifier 3. */
	} B;
	int I;
	unsigned int U;

} SMU_RTAC0_type;
#define SMU_RTAC0	(*( SMU_RTAC0_type *) 0xf0036860u)	/* Recovery Timer Alarm Configuration */
#define SMU_RTAC1	(*( SMU_RTAC0_type *) 0xf0036864u)	/* Recovery Timer Alarm Configuration */

typedef volatile union
{
	struct
	{ 
		unsigned int RT0E           : 1;	/* RT0 Enable Bit */
		unsigned int RT1E           : 1;	/* RT1 Enable Bit */
		unsigned int                : 6;
		unsigned int RTD            : 24;	/* Recovery Timer Duration */
	} B;
	int I;
	unsigned int U;

} SMU_RTC_type;
#define SMU_RTC	(*( SMU_RTC_type *) 0xf0036830u)	/* Fault Signaling Protocol */

typedef volatile union
{
	struct
	{ 
		unsigned int CMD            : 4;	/* Last command received */
		unsigned int ARG            : 4;	/* Last command argument received */
		unsigned int RES            : 1;	/* Result of last received command */
		unsigned int ASCE           : 1;	/* Alarm Status Clear Enable */
		/* const */ unsigned int FSP            : 2;	/* Fault Signaling Protocol status */
		unsigned int FSTS           : 1;	/* Fault State Timing Status */
		unsigned int                : 3;
		unsigned int RTS0           : 1;	/* Recovery Timer 0 Status */
		unsigned int RTME0          : 1;	/* Recovery Timer 0 Missed Event */
		unsigned int RTS1           : 1;	/* Recovery Timer 1 Status */
		unsigned int RTME1          : 1;	/* Recovery Timer 1 Missed Event */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} SMU_STS_type;
#define SMU_STS	(*( SMU_STS_type *) 0xf0036824u)	/* Status Register */


/* PMU */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} FLASH0_ACCEN0_type;
#define FLASH0_ACCEN0	(*( FLASH0_ACCEN0_type *) 0xf80023fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} FLASH0_ACCEN1_type;
#define FLASH0_ACCEN1	(*( FLASH0_ACCEN1_type *) 0xf80023f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL            : 6;	/* Select Bit-Errors */
		unsigned int                : 2;
		unsigned int CLR            : 1;	/* Clear */
		unsigned int DIS            : 1;	/* Disable */
		unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} FLASH0_CBABCFG0_type;
#define FLASH0_CBABCFG0	(*( FLASH0_CBABCFG0_type *) 0xf80020b4u)	/* CBAB Configuration Port 0 */
#define FLASH0_CBABCFG1	(*( FLASH0_CBABCFG0_type *) 0xf80020c0u)	/* CBAB Configuration Port 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int VLD0           : 1;	/* Filling Level */
		/* const */ unsigned int VLD1           : 1;	/* Filling Level */
		/* const */ unsigned int VLD2           : 1;	/* Filling Level */
		/* const */ unsigned int VLD3           : 1;	/* Filling Level */
		/* const */ unsigned int VLD4           : 1;	/* Filling Level */
		/* const */ unsigned int                : 27;
	} B;
	int I;
	unsigned int U;

} FLASH0_CBABSTAT0_type;
#define FLASH0_CBABSTAT0	(*( FLASH0_CBABSTAT0_type *) 0xf80020b8u)	/* CBAB Status Port 0 */
#define FLASH0_CBABSTAT1	(*( FLASH0_CBABSTAT0_type *) 0xf80020c4u)	/* CBAB Status Port 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		/* const */ unsigned int ADDR           : 19;	/* Address */
		/* const */ unsigned int ERR            : 6;	/* Error Type */
		/* const */ unsigned int VLD            : 1;	/* Valid */
		unsigned int CLR            : 1;	/* Clear */
	} B;
	int I;
	unsigned int U;

} FLASH0_CBABTOP0_type;
#define FLASH0_CBABTOP0	(*( FLASH0_CBABTOP0_type *) 0xf80020bcu)	/* CBAB FIFO TOP Entry Port 0 */
#define FLASH0_CBABTOP1	(*( FLASH0_CBABTOP0_type *) 0xf80020c8u)	/* CBAB FIFO TOP Entry Port 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RCODE          : 22;	/* Error Correction Read Code */
		/* const */ unsigned int RED            : 2;	/* Redundant Bits */
		unsigned int                : 6;
		unsigned int EDCERRINJ      : 1;	/* EDC Error Injection */
		unsigned int ECCORDIS       : 1;	/* ECC Correction Disable */
	} B;
	int I;
	unsigned int U;

} FLASH0_ECCRD_type;
#define FLASH0_ECCRD	(*( FLASH0_ECCRD_type *) 0xf80020a4u)	/* ECC Read Register DF */
#define FLASH0_ECCRP0	(*( FLASH0_ECCRD_type *) 0xf8002094u)	/* ECC Read Register PF0 */
#define FLASH0_ECCRP1	(*( FLASH0_ECCRD_type *) 0xf8002098u)	/* ECC Read Register PF1 */

typedef volatile union
{
	struct
	{ 
		unsigned int WCODE          : 22;	/* Error Correction Write Code */
		unsigned int                : 8;
		unsigned int DECENCDIS      : 1;	/* DFlash ECC Encoding Disable */
		unsigned int PECENCDIS      : 1;	/* PFlash ECC Encoding Disable */
	} B;
	int I;
	unsigned int U;

} FLASH0_ECCW_type;
#define FLASH0_ECCW	(*( FLASH0_ECCW_type *) 0xf8002090u)	/* ECC Write Register */

typedef volatile union
{
	struct
	{ 
		unsigned int WSPFLASH       : 4;	/* Wait States for read access to PFlash */
		unsigned int WSECPF         : 2;	/* Wait States for Error Correction of PFlash */
		unsigned int WSDFLASH       : 6;	/* Wait States for read access to DFlash */
		unsigned int WSECDF         : 3;	/* Wait State for Error Correction of DFlash */
		unsigned int IDLE           : 1;	/* Dynamic Flash Idle */
		unsigned int ESLDIS         : 1;	/* External Sleep Request Disable */
		unsigned int SLEEP          : 1;	/* Flash SLEEP / Flash Shut-Down */
		unsigned int NSAFECC        : 1;	/* Non-Safety PFlash ECC */
		unsigned int STALL          : 1;	/* Stall SRI */
		unsigned int FSISTART       : 2;	/* Start FSI */
		unsigned int REC            : 2;	/* Start FSI Recovery */
		unsigned int VOPERM         : 1;	/* Verify and Operation Error Interrupt Mask */
		unsigned int SQERM          : 1;	/* Command Sequence Error Interrupt Mask */
		unsigned int PROERM         : 1;	/* Protection Error Interrupt Mask */
		unsigned int                : 3;
		unsigned int PR5V           : 1;	/* Programming Supply 5V */
		unsigned int EOBM           : 1;	/* End of Busy Interrupt Mask */
	} B;
	int I;
	unsigned int U;

} FLASH0_FCON_type;
#define FLASH0_FCON	(*( FLASH0_FCON_type *) 0xf8002014u)	/* Flash Configuration Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int PROINP         : 1;	/* PFlash Protection */
		/* const */ unsigned int PRODISP        : 1;	/* PFlash Protection DisabledCleared with command 'Resume Protection'. */
		/* const */ unsigned int PROIND         : 1;	/* DFlash Protection */
		/* const */ unsigned int PRODISD        : 1;	/* DFlash Protection Disabled */
		/* const */ unsigned int PROINHSMCOTP   : 1;	/* HSM OTP Protection */
		/* const */ unsigned int PROINHSMCFG    : 1;	/* HSM Configuration Protection */
		/* const */ unsigned int PROINOTP       : 1;	/* OTP and Write-Once Protection */
		/* const */ unsigned int PROINIFX       : 1;	/* UCB_IFX Protection */
		/* const */ unsigned int PROINDBG       : 1;	/* Debug Interface Password Protection */
		/* const */ unsigned int PRODISDBG      : 1;	/* Debug Interface Password Protection Disabled */
		/* const */ unsigned int PROINHSM       : 1;	/* HSM Configuration */
		unsigned int                : 5;
		unsigned int DCFP           : 1;	/* Disable Code Fetch from PFlash Memory for CPU0 PMI */
		unsigned int DDFP           : 1;	/* Disable Read from PFlash for CPU0 DMI */
		unsigned int DDFPX          : 1;	/* Disable Read from PFlash for Other Masters */
		unsigned int                : 1;
		unsigned int DDFD           : 1;	/* Disable Data Fetch from DFlash Memory */
		unsigned int                : 1;
		unsigned int ENPE           : 2;	/* Enable Program/Erase */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} FLASH0_FPRO_type;
#define FLASH0_FPRO	(*( FLASH0_FPRO_type *) 0xf800201cu)	/* Flash Protection Control and Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int FABUSY         : 1;	/* Flash Array Busy Cleared with application reset */
		/* const */ unsigned int D0BUSY         : 1;	/* Data Flash Bank0 Busy */
		/* const */ unsigned int D1BUSY         : 1;	/* Data Flash Bank1 Busy */
		/* const */ unsigned int P0BUSY         : 1;	/* Program Flash PF0 Busy */
		/* const */ unsigned int P1BUSY         : 1;	/* Program Flash PF1 Busy */
		/* const */ unsigned int RES5           : 1;	/* Reserved for Program Flash PF2 Busy */
		/* const */ unsigned int RES6           : 1;	/* Reserved for Program Flash PF3 Busy */
		unsigned int PROG           : 1;	/* Programming State Cleared with command 'Clear Status'Cleared with power-on reset (PORST) */
		unsigned int ERASE          : 1;	/* Erase State */
		/* const */ unsigned int PFPAGE         : 1;	/* Program Flash in Page ModeCleared with command 'Reset to Read' */
		/* const */ unsigned int DFPAGE         : 1;	/* Data Flash in Page Mode */
		unsigned int OPER           : 1;	/* Flash Operation Error */
		unsigned int SQER           : 1;	/* Command Sequence Error */
		unsigned int PROER          : 1;	/* Protection Error */
		unsigned int PFSBER         : 1;	/* PFlash Single-Bit Error and Correction */
		unsigned int PFDBER         : 1;	/* PFlash Double-Bit Error */
		unsigned int PFMBER         : 1;	/* PFlash Uncorrectable Error */
		unsigned int RES17          : 1;	/* Reserved */
		unsigned int DFSBER         : 1;	/* DFlash Single-Bit Error */
		unsigned int DFDBER         : 1;	/* DFlash Double-Bit Error */
		unsigned int DFTBER         : 1;	/* DFlash Triple-Bit Error */
		unsigned int DFMBER         : 1;	/* DFlash Uncorrectable Error */
		unsigned int SRIADDERR      : 1;	/* SRI Bus Address ECC Error */
		unsigned int                : 1;
		unsigned int REC            : 1;	/* Recovery State */
		unsigned int PVER           : 1;	/* Program Verify Error */
		unsigned int EVER           : 1;	/* Erase Verify Error */
		/* const */ unsigned int SPND           : 1;	/* Operation Suspended */
		/* const */ unsigned int SLM            : 1;	/* Flash Sleep Mode */
		/* const */ unsigned int VIS            : 1;	/* Flash Virgin / Initial State */
		/* const */ unsigned int ORIER          : 1;	/* Original Error */
		/* const */ unsigned int CFU            : 1;	/* Configuration Sector Unlocked */
	} B;
	int I;
	unsigned int U;

} FLASH0_FSR_type;
#define FLASH0_FSR	(*( FLASH0_FSR_type *) 0xf8002010u)	/* Flash Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LCKHSMUCB      : 2;	/* Lock Access to UCB_HSMCFG */
		unsigned int                : 22;
		unsigned int VOPERM         : 1;	/* Verify and Operation Error Interrupt Mask */
		unsigned int SQERM          : 1;	/* Command Sequence Error Interrupt Mask */
		unsigned int                : 5;
		unsigned int EOBM           : 1;	/* End of Busy Interrupt Mask */
	} B;
	int I;
	unsigned int U;

} FLASH0_HSMFCON_type;
#define FLASH0_HSMFCON	(*( FLASH0_HSMFCON_type *) 0xf8002204u)	/* HSM Flash Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		/* const */ unsigned int D1BUSY         : 1;	/* Data Flash Bank1 BusyCleared with application reset */
		unsigned int                : 4;
		unsigned int PROG           : 1;	/* Programming State Cleared with command 'Clear Status'Cleared with power-on reset (PORST) */
		unsigned int ERASE          : 1;	/* Erase State */
		unsigned int                : 1;
		/* const */ unsigned int DFPAGE         : 1;	/* Data Flash in Page ModeCleared with command 'Reset to Read' */
		unsigned int OPER           : 1;	/* Flash Operation Error */
		unsigned int SQER           : 1;	/* Command Sequence Error */
		unsigned int                : 12;
		unsigned int PVER           : 1;	/* Program Verify Error */
		unsigned int EVER           : 1;	/* Erase Verify Error */
		/* const */ unsigned int SPND           : 1;	/* Operation Suspended */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} FLASH0_HSMFSR_type;
#define FLASH0_HSMFSR	(*( FLASH0_HSMFSR_type *) 0xf8002200u)	/* Flash Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		unsigned int SELD1          : 1;	/* HSM DFLASH Bank Selection */
		unsigned int                : 1;
		unsigned int SPND           : 1;	/* Suspend */
		unsigned int SPNDERR        : 1;	/* Suspend Error */
		unsigned int                : 27;
	} B;
	int I;
	unsigned int U;

} FLASH0_HSMMARD_type;
#define FLASH0_HSMMARD	(*( FLASH0_HSMMARD_type *) 0xf8002208u)	/* Margin Control Register HSM DFlash */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int ADD            : 29;	/* Address */
	} B;
	int I;
	unsigned int U;

} FLASH0_HSMRRAD_type;
#define FLASH0_HSMRRAD	(*( FLASH0_HSMRRAD_type *) 0xf8002218u)	/* HSM Requested Read Address Register */
#define FLASH0_RRAD	(*( FLASH0_HSMRRAD_type *) 0xf800214cu)	/* Requested Read Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int STRT           : 1;	/* Start Request */
		unsigned int STP            : 1;	/* Stop */
		/* const */ unsigned int BUSY           : 1;	/* Flash Read Busy */
		/* const */ unsigned int DONE           : 1;	/* Flash Read Done */
		/* const */ unsigned int ERR            : 1;	/* Error */
		unsigned int                : 3;
		unsigned int EOBM           : 1;	/* End of Busy Interrupt Mask */
		unsigned int                : 7;
		unsigned int CNT            : 16;	/* Count */
	} B;
	int I;
	unsigned int U;

} FLASH0_HSMRRCT_type;
#define FLASH0_HSMRRCT	(*( FLASH0_HSMRRCT_type *) 0xf800220cu)	/* Requested Read Control Register HSM */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DATA           : 32;	/* Read Data */
	} B;
	int I;
	unsigned int U;

} FLASH0_HSMRRD0_type;
#define FLASH0_HSMRRD0	(*( FLASH0_HSMRRD0_type *) 0xf8002210u)	/* HSM Requested Read Data Register 0 */
#define FLASH0_HSMRRD1	(*( FLASH0_HSMRRD0_type *) 0xf8002214u)	/* HSM Requested Read Data Register 1 */
#define FLASH0_RRD0	(*( FLASH0_HSMRRD0_type *) 0xf8002144u)	/* Requested Read Data Register 0 */
#define FLASH0_RRD1	(*( FLASH0_HSMRRD0_type *) 0xf8002148u)	/* Requested Read Data Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} FLASH0_ID_type;
#define FLASH0_ID	(*( FLASH0_ID_type *) 0xf8002008u)	/* Flash Module Identification Register */
#define PMU0_ID	(*( FLASH0_ID_type *) 0xf8000508u)	/* PMU0 Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int HMARGIN        : 1;	/* Hard Margin Selection */
		unsigned int SELD0          : 1;	/* DFLASH Bank Selection */
		unsigned int                : 1;
		unsigned int SPND           : 1;	/* Suspend */
		unsigned int SPNDERR        : 1;	/* Suspend Error */
		unsigned int                : 10;
		unsigned int TRAPDIS        : 1;	/* DFLASH Uncorrectable Bit Error Trap Disable */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} FLASH0_MARD_type;
#define FLASH0_MARD	(*( FLASH0_MARD_type *) 0xf80020acu)	/* Margin Control Register DFlash */

typedef volatile union
{
	struct
	{ 
		unsigned int SELP0          : 1;	/* PFLASH Bank Selection */
		unsigned int SELP1          : 1;	/* PFLASH Bank Selection */
		unsigned int RES2           : 1;	/* Reserved */
		unsigned int RES3           : 1;	/* Reserved */
		unsigned int                : 11;
		unsigned int TRAPDIS        : 1;	/* PFLASH Uncorrectable Bit Error Trap Disable */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} FLASH0_MARP_type;
#define FLASH0_MARP	(*( FLASH0_MARP_type *) 0xf80020a8u)	/* Margin Control Register PFlash */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int L              : 1;	/* DF_EEPROM Locked for Write Protection */
		/* const */ unsigned int NSAFECC        : 1;	/* Non-Safety PFlash ECC */
		/* const */ unsigned int RAMIN          : 2;	/* RAM Initialization by SSW Control */
		/* const */ unsigned int RAMINSEL       : 4;	/* RAM Initialization Selection */
		/* const */ unsigned int OSCCFG         : 1;	/* OSC Configuration by SSW */
		/* const */ unsigned int MODE           : 2;	/* OSC Mode */
		/* const */ unsigned int APREN          : 1;	/* OSC Amplitude Regulation Enable */
		/* const */ unsigned int CAP0EN         : 1;	/* OSC Capacitance x Enable (x=0-3) */
		/* const */ unsigned int CAP1EN         : 1;	/* OSC Capacitance x Enable (x=0-3) */
		/* const */ unsigned int CAP2EN         : 1;	/* OSC Capacitance x Enable (x=0-3) */
		/* const */ unsigned int CAP3EN         : 1;	/* OSC Capacitance x Enable (x=0-3) */
		/* const */ unsigned int RSTCNT         : 12;	/* ESR0 Delay */
		/* const */ unsigned int RES29          : 2;	/* Reserved */
		/* const */ unsigned int TRISTREQ       : 1;	/* Tristate Request */
		/* const */ unsigned int RPRO           : 1;	/* Read Protection Configuration */
	} B;
	int I;
	unsigned int U;

} FLASH0_PROCOND_type;
#define FLASH0_PROCOND	(*( FLASH0_PROCOND_type *) 0xf8002030u)	/* DFlash Protection Configuration */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int OCDSDIS        : 1;	/* OCDS Disabled */
		/* const */ unsigned int DBGIFLCK       : 1;	/* Debug Interface Locked */
		/* const */ unsigned int EDM            : 2;	/* Entered Debug Mode */
		/* const */ unsigned int RES            : 12;	/* Reserved */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} FLASH0_PROCONDBG_type;
#define FLASH0_PROCONDBG	(*( FLASH0_PROCONDBG_type *) 0xf8002058u)	/* Debug Interface Protection Configuration */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int HSMDBGDIS      : 1;	/* HSM Debug Disable */
		/* const */ unsigned int DBGIFLCK       : 1;	/* Debug Interface Locked */
		/* const */ unsigned int TSTIFLCK       : 1;	/* Test Interface Locked */
		/* const */ unsigned int HSMTSTDIS      : 1;	/* HSM Test Disable */
		/* const */ unsigned int RES15          : 12;	/* Reserved */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} FLASH0_PROCONHSM_type;
#define FLASH0_PROCONHSM	(*( FLASH0_PROCONHSM_type *) 0xf800205cu)	/* HSM Interface Configuration */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int HSMBOOTEN      : 1;	/* HSM Boot Enable */
		/* const */ unsigned int SSWWAIT        : 1;	/* SSW Wait */
		/* const */ unsigned int HSMDX          : 1;	/* HSM Data Sectors Exclusive */
		/* const */ unsigned int HSM6X          : 1;	/* HSM Code Sector 6 Exclusive */
		/* const */ unsigned int HSM16X         : 1;	/* HSM Code Sector 16 Exclusive */
		/* const */ unsigned int HSM17X         : 1;	/* HSM Code Sector 17 Exclusive */
		/* const */ unsigned int S6ROM          : 1;	/* HSM Code Sector 6 Locked Forever */
		/* const */ unsigned int HSMENPINS      : 2;	/* Enable HSM Forcing of Pins HSM1/2 */
		/* const */ unsigned int HSMENRES       : 2;	/* Enable HSM Triggering Resets */
		/* const */ unsigned int DESTDBG        : 2;	/* Destructive Debug Entry */
		/* const */ unsigned int RES            : 3;	/* Reserved */
		/* const */ unsigned int S16ROM         : 1;	/* HSM Code Sector 16 Locked Forever */
		/* const */ unsigned int S17ROM         : 1;	/* HSM Code Sector 17 Locked Forever */
		/* const */ unsigned int                : 14;
	} B;
	int I;
	unsigned int U;

} FLASH0_PROCONHSMCOTP_type;
#define FLASH0_PROCONHSMCOTP	(*( FLASH0_PROCONHSMCOTP_type *) 0xf8002034u)	/* HSM Code Flash OTP Protection Configuration */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int S0ROM          : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S1ROM          : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S2ROM          : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S3ROM          : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S4ROM          : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S5ROM          : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S6ROM          : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S7ROM          : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S8ROM          : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S9ROM          : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S10ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S11ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S12ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S13ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S14ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S15ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S16ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S17ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S18ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S19ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S20ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S21ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S22ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S23ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S24ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S25ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int S26ROM         : 1;	/* PFlash p Sector x Locked for Forever */
		/* const */ unsigned int RES            : 2;	/* Reserved */
		/* const */ unsigned int BML            : 2;	/* Boot Mode Lock */
		/* const */ unsigned int TP             : 1;	/* Tuning Protection */
	} B;
	int I;
	unsigned int U;

} FLASH0_PROCONOTP0_type;
#define FLASH0_PROCONOTP0	(*( FLASH0_PROCONOTP0_type *) 0xf8002038u)	/* OTP Protection Configuration PF0 */
#define FLASH0_PROCONOTP1	(*( FLASH0_PROCONOTP0_type *) 0xf800203cu)	/* OTP Protection Configuration PF1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int S0L            : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S1L            : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S2L            : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S3L            : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S4L            : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S5L            : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S6L            : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S7L            : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S8L            : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S9L            : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S10L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S11L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S12L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S13L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S14L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S15L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S16L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S17L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S18L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S19L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S20L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S21L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S22L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S23L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S24L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S25L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int S26L           : 1;	/* PFlash p Sector x Locked for Write Protection */
		/* const */ unsigned int RES            : 4;	/* Reserved */
		/* const */ unsigned int RPRO           : 1;	/* Read Protection Configuration */
	} B;
	int I;
	unsigned int U;

} FLASH0_PROCONP0_type;
#define FLASH0_PROCONP0	(*( FLASH0_PROCONP0_type *) 0xf8002020u)	/* PFlash Protection Configuration PF0 */
#define FLASH0_PROCONP1	(*( FLASH0_PROCONP0_type *) 0xf8002024u)	/* PFlash Protection Configuration PF1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int S0WOP          : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S1WOP          : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S2WOP          : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S3WOP          : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S4WOP          : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S5WOP          : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S6WOP          : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S7WOP          : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S8WOP          : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S9WOP          : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S10WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S11WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S12WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S13WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S14WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S15WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S16WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S17WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S18WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S19WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S20WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S21WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S22WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S23WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S24WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S25WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int S26WOP         : 1;	/* PFlash p Sector x Configured for Write-Once Protection */
		/* const */ unsigned int RES            : 4;	/* Reserved */
		/* const */ unsigned int DATM           : 1;	/* Disable ATM */
	} B;
	int I;
	unsigned int U;

} FLASH0_PROCONWOP0_type;
#define FLASH0_PROCONWOP0	(*( FLASH0_PROCONWOP0_type *) 0xf8002048u)	/* Write-Once Protection Configuration PF0 */
#define FLASH0_PROCONWOP1	(*( FLASH0_PROCONWOP0_type *) 0xf800204cu)	/* Write-Once Protection Configuration PF1 */

typedef volatile union
{
	struct
	{ 
		unsigned int TAG            : 6;	/* Master Tag */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} FLASH0_RDBCFG00_type;
#define FLASH0_RDBCFG00	(*( FLASH0_RDBCFG00_type *) 0xf8002060u)	/* Read Buffer Port 0 Cfg 0 */
#define FLASH0_RDBCFG01	(*( FLASH0_RDBCFG00_type *) 0xf8002064u)	/* Read Buffer Port 0 Cfg 1 */
#define FLASH0_RDBCFG02	(*( FLASH0_RDBCFG00_type *) 0xf8002068u)	/* Read Buffer Port 0 Cfg 2 */
#define FLASH0_RDBCFG10	(*( FLASH0_RDBCFG00_type *) 0xf800206cu)	/* Read Buffer Port 1 Cfg 0 */
#define FLASH0_RDBCFG11	(*( FLASH0_RDBCFG00_type *) 0xf8002070u)	/* Read Buffer Port 1 Cfg 1 */
#define FLASH0_RDBCFG12	(*( FLASH0_RDBCFG00_type *) 0xf8002074u)	/* Read Buffer Port 1 Cfg 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int STRT           : 1;	/* Start Request */
		unsigned int STP            : 1;	/* Stop */
		/* const */ unsigned int BUSY           : 1;	/* Flash Read Busy */
		/* const */ unsigned int DONE           : 1;	/* Flash Read Done */
		/* const */ unsigned int ERR            : 1;	/* Error */
		unsigned int                : 3;
		unsigned int EOBM           : 1;	/* End of Busy Interrupt Mask */
		unsigned int                : 7;
		unsigned int CNT            : 16;	/* Count */
	} B;
	int I;
	unsigned int U;

} FLASH0_RRCT_type;
#define FLASH0_RRCT	(*( FLASH0_RRCT_type *) 0xf8002140u)	/* Requested Read Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL            : 6;	/* Select Bit-Errors */
		unsigned int                : 2;
		unsigned int CLR            : 1;	/* Clear */
		unsigned int DIS            : 1;	/* Disable */
		unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} FLASH0_UBABCFG0_type;
#define FLASH0_UBABCFG0	(*( FLASH0_UBABCFG0_type *) 0xf80020e4u)	/* UBAB Configuration Port 0 */
#define FLASH0_UBABCFG1	(*( FLASH0_UBABCFG0_type *) 0xf80020f0u)	/* UBAB Configuration Port 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int VLD0           : 1;	/* Filling Level */
		/* const */ unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} FLASH0_UBABSTAT0_type;
#define FLASH0_UBABSTAT0	(*( FLASH0_UBABSTAT0_type *) 0xf80020e8u)	/* UBAB Status Port 0 */
#define FLASH0_UBABSTAT1	(*( FLASH0_UBABSTAT0_type *) 0xf80020f4u)	/* UBAB Status Port 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		/* const */ unsigned int ADDR           : 19;	/* Address */
		/* const */ unsigned int ERR            : 6;	/* Error Type */
		/* const */ unsigned int VLD            : 1;	/* Valid */
		unsigned int CLR            : 1;	/* Clear */
	} B;
	int I;
	unsigned int U;

} FLASH0_UBABTOP0_type;
#define FLASH0_UBABTOP0	(*( FLASH0_UBABTOP0_type *) 0xf80020ecu)	/* UBAB FIFO TOP Entry Port 0 */
#define FLASH0_UBABTOP1	(*( FLASH0_UBABTOP0_type *) 0xf80020f8u)	/* UBAB FIFO TOP Entry Port 1 */


/* LMU */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} LMU_ACCEN0_type;
#define LMU_ACCEN0	(*( LMU_ACCEN0_type *) 0xf8700810u)	/* LMU Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} LMU_ACCEN1_type;
#define LMU_ACCEN1	(*( LMU_ACCEN1_type *) 0xf8700814u)	/* LMU Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int TAG1           : 6;	/* Master Tag ID 1 */
		unsigned int                : 2;
		unsigned int TAG2           : 6;	/* Master Tag ID 2 */
		unsigned int                : 8;
		unsigned int EREN           : 1;	/* EMEM Read Buffer Enable */
		unsigned int EPEN           : 1;	/* EMEM Prefetch Enable */
		unsigned int                : 6;
		unsigned int EN1            : 1;	/* TAG1 Field Enable */
		unsigned int EN2            : 1;	/* TAG2 Field Enable */
	} B;
	int I;
	unsigned int U;

} LMU_BUFCON0_type;
#define LMU_BUFCON0	(*( LMU_BUFCON0_type *) 0xf8700830u)	/* LMU Buffer Control Register */
#define LMU_BUFCON1	(*( LMU_BUFCON0_type *) 0xf8700834u)	/* LMU Buffer Control Register */
#define LMU_BUFCON2	(*( LMU_BUFCON0_type *) 0xf8700838u)	/* LMU Buffer Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* LMU Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* LMU Disable Status Bit */
		/* const */ unsigned int RES            : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} LMU_CLC_type;
#define LMU_CLC	(*( LMU_CLC_type *) 0xf8700800u)	/* LMU Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int OLDAEN         : 1;	/* Online Data Acquisition Enabled */
		unsigned int POLDAEN        : 1;	/* Protection Bit for OLDAEN */
		unsigned int INTERR         : 1;	/* Internal ECC Error */
		unsigned int ERERR          : 1;	/* EMEM Read Error */
		unsigned int RMWERR         : 1;	/* Internal Read Modify Write Error */
		unsigned int EWERR          : 1;	/* EMEM Write Error */
		unsigned int DATAERR        : 1;	/* SRI Data Phase ECC Error */
		unsigned int ADDERR         : 1;	/* SRI Address Phase ECC Error */
		unsigned int PMIC           : 1;	/* Protection Bit for Memory Integrity Control Bit */
		unsigned int ERRDIS         : 1;	/* ECC Error Disable */
		unsigned int                : 2;
		unsigned int WSTATES        : 4;	/* EMEM Wait States */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} LMU_MEMCON_type;
#define LMU_MEMCON	(*( LMU_MEMCON_type *) 0xf8700820u)	/* LMU Memory Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ID_VALUE       : 32;	/* Module Identification Value */
	} B;
	int I;
	unsigned int U;

} LMU_MODID_type;
#define LMU_MODID	(*( LMU_MODID_type *) 0xf8700808u)	/* LMU Module ID Register */


/* OVC */
typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		unsigned int OMASK          : 12;	/* Overlay Address Mask */
		/* const */ unsigned int ONE            : 11;	/* Fixed '1' Values */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} OVC0_OMASK0_type;
#define OVC0_OMASK0	(*( OVC0_OMASK0_type *) 0xf880fb18u)	/* Overlay Mask Register 0 */
#define OVC0_OMASK1	(*( OVC0_OMASK0_type *) 0xf880fb24u)	/* Overlay Mask Register 1 */
#define OVC0_OMASK10	(*( OVC0_OMASK0_type *) 0xf880fb90u)	/* Overlay Mask Register 10 */
#define OVC0_OMASK11	(*( OVC0_OMASK0_type *) 0xf880fb9cu)	/* Overlay Mask Register 11 */
#define OVC0_OMASK12	(*( OVC0_OMASK0_type *) 0xf880fba8u)	/* Overlay Mask Register 12 */
#define OVC0_OMASK13	(*( OVC0_OMASK0_type *) 0xf880fbb4u)	/* Overlay Mask Register 13 */
#define OVC0_OMASK14	(*( OVC0_OMASK0_type *) 0xf880fbc0u)	/* Overlay Mask Register 14 */
#define OVC0_OMASK15	(*( OVC0_OMASK0_type *) 0xf880fbccu)	/* Overlay Mask Register 15 */
#define OVC0_OMASK16	(*( OVC0_OMASK0_type *) 0xf880fbd8u)	/* Overlay Mask Register 16 */
#define OVC0_OMASK17	(*( OVC0_OMASK0_type *) 0xf880fbe4u)	/* Overlay Mask Register 17 */
#define OVC0_OMASK18	(*( OVC0_OMASK0_type *) 0xf880fbf0u)	/* Overlay Mask Register 18 */
#define OVC0_OMASK19	(*( OVC0_OMASK0_type *) 0xf880fbfcu)	/* Overlay Mask Register 19 */
#define OVC0_OMASK2	(*( OVC0_OMASK0_type *) 0xf880fb30u)	/* Overlay Mask Register 2 */
#define OVC0_OMASK20	(*( OVC0_OMASK0_type *) 0xf880fc08u)	/* Overlay Mask Register 20 */
#define OVC0_OMASK21	(*( OVC0_OMASK0_type *) 0xf880fc14u)	/* Overlay Mask Register 21 */
#define OVC0_OMASK22	(*( OVC0_OMASK0_type *) 0xf880fc20u)	/* Overlay Mask Register 22 */
#define OVC0_OMASK23	(*( OVC0_OMASK0_type *) 0xf880fc2cu)	/* Overlay Mask Register 23 */
#define OVC0_OMASK24	(*( OVC0_OMASK0_type *) 0xf880fc38u)	/* Overlay Mask Register 24 */
#define OVC0_OMASK25	(*( OVC0_OMASK0_type *) 0xf880fc44u)	/* Overlay Mask Register 25 */
#define OVC0_OMASK26	(*( OVC0_OMASK0_type *) 0xf880fc50u)	/* Overlay Mask Register 26 */
#define OVC0_OMASK27	(*( OVC0_OMASK0_type *) 0xf880fc5cu)	/* Overlay Mask Register 27 */
#define OVC0_OMASK28	(*( OVC0_OMASK0_type *) 0xf880fc68u)	/* Overlay Mask Register 28 */
#define OVC0_OMASK29	(*( OVC0_OMASK0_type *) 0xf880fc74u)	/* Overlay Mask Register 29 */
#define OVC0_OMASK3	(*( OVC0_OMASK0_type *) 0xf880fb3cu)	/* Overlay Mask Register 3 */
#define OVC0_OMASK30	(*( OVC0_OMASK0_type *) 0xf880fc80u)	/* Overlay Mask Register 30 */
#define OVC0_OMASK31	(*( OVC0_OMASK0_type *) 0xf880fc8cu)	/* Overlay Mask Register 31 */
#define OVC0_OMASK4	(*( OVC0_OMASK0_type *) 0xf880fb48u)	/* Overlay Mask Register 4 */
#define OVC0_OMASK5	(*( OVC0_OMASK0_type *) 0xf880fb54u)	/* Overlay Mask Register 5 */
#define OVC0_OMASK6	(*( OVC0_OMASK0_type *) 0xf880fb60u)	/* Overlay Mask Register 6 */
#define OVC0_OMASK7	(*( OVC0_OMASK0_type *) 0xf880fb6cu)	/* Overlay Mask Register 7 */
#define OVC0_OMASK8	(*( OVC0_OMASK0_type *) 0xf880fb78u)	/* Overlay Mask Register 8 */
#define OVC0_OMASK9	(*( OVC0_OMASK0_type *) 0xf880fb84u)	/* Overlay Mask Register 9 */
#define OVC1_OMASK0	(*( OVC0_OMASK0_type *) 0xf882fb18u)	/* Overlay Mask Register 0 */
#define OVC1_OMASK1	(*( OVC0_OMASK0_type *) 0xf882fb24u)	/* Overlay Mask Register 1 */
#define OVC1_OMASK10	(*( OVC0_OMASK0_type *) 0xf882fb90u)	/* Overlay Mask Register 10 */
#define OVC1_OMASK11	(*( OVC0_OMASK0_type *) 0xf882fb9cu)	/* Overlay Mask Register 11 */
#define OVC1_OMASK12	(*( OVC0_OMASK0_type *) 0xf882fba8u)	/* Overlay Mask Register 12 */
#define OVC1_OMASK13	(*( OVC0_OMASK0_type *) 0xf882fbb4u)	/* Overlay Mask Register 13 */
#define OVC1_OMASK14	(*( OVC0_OMASK0_type *) 0xf882fbc0u)	/* Overlay Mask Register 14 */
#define OVC1_OMASK15	(*( OVC0_OMASK0_type *) 0xf882fbccu)	/* Overlay Mask Register 15 */
#define OVC1_OMASK16	(*( OVC0_OMASK0_type *) 0xf882fbd8u)	/* Overlay Mask Register 16 */
#define OVC1_OMASK17	(*( OVC0_OMASK0_type *) 0xf882fbe4u)	/* Overlay Mask Register 17 */
#define OVC1_OMASK18	(*( OVC0_OMASK0_type *) 0xf882fbf0u)	/* Overlay Mask Register 18 */
#define OVC1_OMASK19	(*( OVC0_OMASK0_type *) 0xf882fbfcu)	/* Overlay Mask Register 19 */
#define OVC1_OMASK2	(*( OVC0_OMASK0_type *) 0xf882fb30u)	/* Overlay Mask Register 2 */
#define OVC1_OMASK20	(*( OVC0_OMASK0_type *) 0xf882fc08u)	/* Overlay Mask Register 20 */
#define OVC1_OMASK21	(*( OVC0_OMASK0_type *) 0xf882fc14u)	/* Overlay Mask Register 21 */
#define OVC1_OMASK22	(*( OVC0_OMASK0_type *) 0xf882fc20u)	/* Overlay Mask Register 22 */
#define OVC1_OMASK23	(*( OVC0_OMASK0_type *) 0xf882fc2cu)	/* Overlay Mask Register 23 */
#define OVC1_OMASK24	(*( OVC0_OMASK0_type *) 0xf882fc38u)	/* Overlay Mask Register 24 */
#define OVC1_OMASK25	(*( OVC0_OMASK0_type *) 0xf882fc44u)	/* Overlay Mask Register 25 */
#define OVC1_OMASK26	(*( OVC0_OMASK0_type *) 0xf882fc50u)	/* Overlay Mask Register 26 */
#define OVC1_OMASK27	(*( OVC0_OMASK0_type *) 0xf882fc5cu)	/* Overlay Mask Register 27 */
#define OVC1_OMASK28	(*( OVC0_OMASK0_type *) 0xf882fc68u)	/* Overlay Mask Register 28 */
#define OVC1_OMASK29	(*( OVC0_OMASK0_type *) 0xf882fc74u)	/* Overlay Mask Register 29 */
#define OVC1_OMASK3	(*( OVC0_OMASK0_type *) 0xf882fb3cu)	/* Overlay Mask Register 3 */
#define OVC1_OMASK30	(*( OVC0_OMASK0_type *) 0xf882fc80u)	/* Overlay Mask Register 30 */
#define OVC1_OMASK31	(*( OVC0_OMASK0_type *) 0xf882fc8cu)	/* Overlay Mask Register 31 */
#define OVC1_OMASK4	(*( OVC0_OMASK0_type *) 0xf882fb48u)	/* Overlay Mask Register 4 */
#define OVC1_OMASK5	(*( OVC0_OMASK0_type *) 0xf882fb54u)	/* Overlay Mask Register 5 */
#define OVC1_OMASK6	(*( OVC0_OMASK0_type *) 0xf882fb60u)	/* Overlay Mask Register 6 */
#define OVC1_OMASK7	(*( OVC0_OMASK0_type *) 0xf882fb6cu)	/* Overlay Mask Register 7 */
#define OVC1_OMASK8	(*( OVC0_OMASK0_type *) 0xf882fb78u)	/* Overlay Mask Register 8 */
#define OVC1_OMASK9	(*( OVC0_OMASK0_type *) 0xf882fb84u)	/* Overlay Mask Register 9 */
#define OVC2_OMASK0	(*( OVC0_OMASK0_type *) 0xf884fb18u)	/* Overlay Mask Register 0 */
#define OVC2_OMASK1	(*( OVC0_OMASK0_type *) 0xf884fb24u)	/* Overlay Mask Register 1 */
#define OVC2_OMASK10	(*( OVC0_OMASK0_type *) 0xf884fb90u)	/* Overlay Mask Register 10 */
#define OVC2_OMASK11	(*( OVC0_OMASK0_type *) 0xf884fb9cu)	/* Overlay Mask Register 11 */
#define OVC2_OMASK12	(*( OVC0_OMASK0_type *) 0xf884fba8u)	/* Overlay Mask Register 12 */
#define OVC2_OMASK13	(*( OVC0_OMASK0_type *) 0xf884fbb4u)	/* Overlay Mask Register 13 */
#define OVC2_OMASK14	(*( OVC0_OMASK0_type *) 0xf884fbc0u)	/* Overlay Mask Register 14 */
#define OVC2_OMASK15	(*( OVC0_OMASK0_type *) 0xf884fbccu)	/* Overlay Mask Register 15 */
#define OVC2_OMASK16	(*( OVC0_OMASK0_type *) 0xf884fbd8u)	/* Overlay Mask Register 16 */
#define OVC2_OMASK17	(*( OVC0_OMASK0_type *) 0xf884fbe4u)	/* Overlay Mask Register 17 */
#define OVC2_OMASK18	(*( OVC0_OMASK0_type *) 0xf884fbf0u)	/* Overlay Mask Register 18 */
#define OVC2_OMASK19	(*( OVC0_OMASK0_type *) 0xf884fbfcu)	/* Overlay Mask Register 19 */
#define OVC2_OMASK2	(*( OVC0_OMASK0_type *) 0xf884fb30u)	/* Overlay Mask Register 2 */
#define OVC2_OMASK20	(*( OVC0_OMASK0_type *) 0xf884fc08u)	/* Overlay Mask Register 20 */
#define OVC2_OMASK21	(*( OVC0_OMASK0_type *) 0xf884fc14u)	/* Overlay Mask Register 21 */
#define OVC2_OMASK22	(*( OVC0_OMASK0_type *) 0xf884fc20u)	/* Overlay Mask Register 22 */
#define OVC2_OMASK23	(*( OVC0_OMASK0_type *) 0xf884fc2cu)	/* Overlay Mask Register 23 */
#define OVC2_OMASK24	(*( OVC0_OMASK0_type *) 0xf884fc38u)	/* Overlay Mask Register 24 */
#define OVC2_OMASK25	(*( OVC0_OMASK0_type *) 0xf884fc44u)	/* Overlay Mask Register 25 */
#define OVC2_OMASK26	(*( OVC0_OMASK0_type *) 0xf884fc50u)	/* Overlay Mask Register 26 */
#define OVC2_OMASK27	(*( OVC0_OMASK0_type *) 0xf884fc5cu)	/* Overlay Mask Register 27 */
#define OVC2_OMASK28	(*( OVC0_OMASK0_type *) 0xf884fc68u)	/* Overlay Mask Register 28 */
#define OVC2_OMASK29	(*( OVC0_OMASK0_type *) 0xf884fc74u)	/* Overlay Mask Register 29 */
#define OVC2_OMASK3	(*( OVC0_OMASK0_type *) 0xf884fb3cu)	/* Overlay Mask Register 3 */
#define OVC2_OMASK30	(*( OVC0_OMASK0_type *) 0xf884fc80u)	/* Overlay Mask Register 30 */
#define OVC2_OMASK31	(*( OVC0_OMASK0_type *) 0xf884fc8cu)	/* Overlay Mask Register 31 */
#define OVC2_OMASK4	(*( OVC0_OMASK0_type *) 0xf884fb48u)	/* Overlay Mask Register 4 */
#define OVC2_OMASK5	(*( OVC0_OMASK0_type *) 0xf884fb54u)	/* Overlay Mask Register 5 */
#define OVC2_OMASK6	(*( OVC0_OMASK0_type *) 0xf884fb60u)	/* Overlay Mask Register 6 */
#define OVC2_OMASK7	(*( OVC0_OMASK0_type *) 0xf884fb6cu)	/* Overlay Mask Register 7 */
#define OVC2_OMASK8	(*( OVC0_OMASK0_type *) 0xf884fb78u)	/* Overlay Mask Register 8 */
#define OVC2_OMASK9	(*( OVC0_OMASK0_type *) 0xf884fb84u)	/* Overlay Mask Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int SHOVEN0        : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN1        : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN2        : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN3        : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN4        : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN5        : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN6        : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN7        : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN8        : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN9        : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN10       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN11       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN12       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN13       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN14       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN15       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN16       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN17       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN18       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN19       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN20       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN21       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN22       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN23       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN24       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN25       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN26       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN27       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN28       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN29       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN30       : 1;	/* Shadow Overlay Enable x */
		unsigned int SHOVEN31       : 1;	/* Shadow Overlay Enable x */
	} B;
	int I;
	unsigned int U;

} OVC0_OSEL_type;
#define OVC0_OSEL	(*( OVC0_OSEL_type *) 0xf880fb00u)	/* Overlay Range Select Register */
#define OVC1_OSEL	(*( OVC0_OSEL_type *) 0xf882fb00u)	/* Overlay Range Select Register */
#define OVC2_OSEL	(*( OVC0_OSEL_type *) 0xf884fb00u)	/* Overlay Range Select Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		unsigned int TBASE          : 23;	/* Target Base */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} OVC0_OTAR0_type;
#define OVC0_OTAR0	(*( OVC0_OTAR0_type *) 0xf880fb14u)	/* Overlay Target Address Register 0 */
#define OVC0_OTAR1	(*( OVC0_OTAR0_type *) 0xf880fb20u)	/* Overlay Target Address Register 1 */
#define OVC0_OTAR10	(*( OVC0_OTAR0_type *) 0xf880fb8cu)	/* Overlay Target Address Register 10 */
#define OVC0_OTAR11	(*( OVC0_OTAR0_type *) 0xf880fb98u)	/* Overlay Target Address Register 11 */
#define OVC0_OTAR12	(*( OVC0_OTAR0_type *) 0xf880fba4u)	/* Overlay Target Address Register 12 */
#define OVC0_OTAR13	(*( OVC0_OTAR0_type *) 0xf880fbb0u)	/* Overlay Target Address Register 13 */
#define OVC0_OTAR14	(*( OVC0_OTAR0_type *) 0xf880fbbcu)	/* Overlay Target Address Register 14 */
#define OVC0_OTAR15	(*( OVC0_OTAR0_type *) 0xf880fbc8u)	/* Overlay Target Address Register 15 */
#define OVC0_OTAR16	(*( OVC0_OTAR0_type *) 0xf880fbd4u)	/* Overlay Target Address Register 16 */
#define OVC0_OTAR17	(*( OVC0_OTAR0_type *) 0xf880fbe0u)	/* Overlay Target Address Register 17 */
#define OVC0_OTAR18	(*( OVC0_OTAR0_type *) 0xf880fbecu)	/* Overlay Target Address Register 18 */
#define OVC0_OTAR19	(*( OVC0_OTAR0_type *) 0xf880fbf8u)	/* Overlay Target Address Register 19 */
#define OVC0_OTAR2	(*( OVC0_OTAR0_type *) 0xf880fb2cu)	/* Overlay Target Address Register 2 */
#define OVC0_OTAR20	(*( OVC0_OTAR0_type *) 0xf880fc04u)	/* Overlay Target Address Register 20 */
#define OVC0_OTAR21	(*( OVC0_OTAR0_type *) 0xf880fc10u)	/* Overlay Target Address Register 21 */
#define OVC0_OTAR22	(*( OVC0_OTAR0_type *) 0xf880fc1cu)	/* Overlay Target Address Register 22 */
#define OVC0_OTAR23	(*( OVC0_OTAR0_type *) 0xf880fc28u)	/* Overlay Target Address Register 23 */
#define OVC0_OTAR24	(*( OVC0_OTAR0_type *) 0xf880fc34u)	/* Overlay Target Address Register 24 */
#define OVC0_OTAR25	(*( OVC0_OTAR0_type *) 0xf880fc40u)	/* Overlay Target Address Register 25 */
#define OVC0_OTAR26	(*( OVC0_OTAR0_type *) 0xf880fc4cu)	/* Overlay Target Address Register 26 */
#define OVC0_OTAR27	(*( OVC0_OTAR0_type *) 0xf880fc58u)	/* Overlay Target Address Register 27 */
#define OVC0_OTAR28	(*( OVC0_OTAR0_type *) 0xf880fc64u)	/* Overlay Target Address Register 28 */
#define OVC0_OTAR29	(*( OVC0_OTAR0_type *) 0xf880fc70u)	/* Overlay Target Address Register 29 */
#define OVC0_OTAR3	(*( OVC0_OTAR0_type *) 0xf880fb38u)	/* Overlay Target Address Register 3 */
#define OVC0_OTAR30	(*( OVC0_OTAR0_type *) 0xf880fc7cu)	/* Overlay Target Address Register 30 */
#define OVC0_OTAR31	(*( OVC0_OTAR0_type *) 0xf880fc88u)	/* Overlay Target Address Register 31 */
#define OVC0_OTAR4	(*( OVC0_OTAR0_type *) 0xf880fb44u)	/* Overlay Target Address Register 4 */
#define OVC0_OTAR5	(*( OVC0_OTAR0_type *) 0xf880fb50u)	/* Overlay Target Address Register 5 */
#define OVC0_OTAR6	(*( OVC0_OTAR0_type *) 0xf880fb5cu)	/* Overlay Target Address Register 6 */
#define OVC0_OTAR7	(*( OVC0_OTAR0_type *) 0xf880fb68u)	/* Overlay Target Address Register 7 */
#define OVC0_OTAR8	(*( OVC0_OTAR0_type *) 0xf880fb74u)	/* Overlay Target Address Register 8 */
#define OVC0_OTAR9	(*( OVC0_OTAR0_type *) 0xf880fb80u)	/* Overlay Target Address Register 9 */
#define OVC1_OTAR0	(*( OVC0_OTAR0_type *) 0xf882fb14u)	/* Overlay Target Address Register 0 */
#define OVC1_OTAR1	(*( OVC0_OTAR0_type *) 0xf882fb20u)	/* Overlay Target Address Register 1 */
#define OVC1_OTAR10	(*( OVC0_OTAR0_type *) 0xf882fb8cu)	/* Overlay Target Address Register 10 */
#define OVC1_OTAR11	(*( OVC0_OTAR0_type *) 0xf882fb98u)	/* Overlay Target Address Register 11 */
#define OVC1_OTAR12	(*( OVC0_OTAR0_type *) 0xf882fba4u)	/* Overlay Target Address Register 12 */
#define OVC1_OTAR13	(*( OVC0_OTAR0_type *) 0xf882fbb0u)	/* Overlay Target Address Register 13 */
#define OVC1_OTAR14	(*( OVC0_OTAR0_type *) 0xf882fbbcu)	/* Overlay Target Address Register 14 */
#define OVC1_OTAR15	(*( OVC0_OTAR0_type *) 0xf882fbc8u)	/* Overlay Target Address Register 15 */
#define OVC1_OTAR16	(*( OVC0_OTAR0_type *) 0xf882fbd4u)	/* Overlay Target Address Register 16 */
#define OVC1_OTAR17	(*( OVC0_OTAR0_type *) 0xf882fbe0u)	/* Overlay Target Address Register 17 */
#define OVC1_OTAR18	(*( OVC0_OTAR0_type *) 0xf882fbecu)	/* Overlay Target Address Register 18 */
#define OVC1_OTAR19	(*( OVC0_OTAR0_type *) 0xf882fbf8u)	/* Overlay Target Address Register 19 */
#define OVC1_OTAR2	(*( OVC0_OTAR0_type *) 0xf882fb2cu)	/* Overlay Target Address Register 2 */
#define OVC1_OTAR20	(*( OVC0_OTAR0_type *) 0xf882fc04u)	/* Overlay Target Address Register 20 */
#define OVC1_OTAR21	(*( OVC0_OTAR0_type *) 0xf882fc10u)	/* Overlay Target Address Register 21 */
#define OVC1_OTAR22	(*( OVC0_OTAR0_type *) 0xf882fc1cu)	/* Overlay Target Address Register 22 */
#define OVC1_OTAR23	(*( OVC0_OTAR0_type *) 0xf882fc28u)	/* Overlay Target Address Register 23 */
#define OVC1_OTAR24	(*( OVC0_OTAR0_type *) 0xf882fc34u)	/* Overlay Target Address Register 24 */
#define OVC1_OTAR25	(*( OVC0_OTAR0_type *) 0xf882fc40u)	/* Overlay Target Address Register 25 */
#define OVC1_OTAR26	(*( OVC0_OTAR0_type *) 0xf882fc4cu)	/* Overlay Target Address Register 26 */
#define OVC1_OTAR27	(*( OVC0_OTAR0_type *) 0xf882fc58u)	/* Overlay Target Address Register 27 */
#define OVC1_OTAR28	(*( OVC0_OTAR0_type *) 0xf882fc64u)	/* Overlay Target Address Register 28 */
#define OVC1_OTAR29	(*( OVC0_OTAR0_type *) 0xf882fc70u)	/* Overlay Target Address Register 29 */
#define OVC1_OTAR3	(*( OVC0_OTAR0_type *) 0xf882fb38u)	/* Overlay Target Address Register 3 */
#define OVC1_OTAR30	(*( OVC0_OTAR0_type *) 0xf882fc7cu)	/* Overlay Target Address Register 30 */
#define OVC1_OTAR31	(*( OVC0_OTAR0_type *) 0xf882fc88u)	/* Overlay Target Address Register 31 */
#define OVC1_OTAR4	(*( OVC0_OTAR0_type *) 0xf882fb44u)	/* Overlay Target Address Register 4 */
#define OVC1_OTAR5	(*( OVC0_OTAR0_type *) 0xf882fb50u)	/* Overlay Target Address Register 5 */
#define OVC1_OTAR6	(*( OVC0_OTAR0_type *) 0xf882fb5cu)	/* Overlay Target Address Register 6 */
#define OVC1_OTAR7	(*( OVC0_OTAR0_type *) 0xf882fb68u)	/* Overlay Target Address Register 7 */
#define OVC1_OTAR8	(*( OVC0_OTAR0_type *) 0xf882fb74u)	/* Overlay Target Address Register 8 */
#define OVC1_OTAR9	(*( OVC0_OTAR0_type *) 0xf882fb80u)	/* Overlay Target Address Register 9 */
#define OVC2_OTAR0	(*( OVC0_OTAR0_type *) 0xf884fb14u)	/* Overlay Target Address Register 0 */
#define OVC2_OTAR1	(*( OVC0_OTAR0_type *) 0xf884fb20u)	/* Overlay Target Address Register 1 */
#define OVC2_OTAR10	(*( OVC0_OTAR0_type *) 0xf884fb8cu)	/* Overlay Target Address Register 10 */
#define OVC2_OTAR11	(*( OVC0_OTAR0_type *) 0xf884fb98u)	/* Overlay Target Address Register 11 */
#define OVC2_OTAR12	(*( OVC0_OTAR0_type *) 0xf884fba4u)	/* Overlay Target Address Register 12 */
#define OVC2_OTAR13	(*( OVC0_OTAR0_type *) 0xf884fbb0u)	/* Overlay Target Address Register 13 */
#define OVC2_OTAR14	(*( OVC0_OTAR0_type *) 0xf884fbbcu)	/* Overlay Target Address Register 14 */
#define OVC2_OTAR15	(*( OVC0_OTAR0_type *) 0xf884fbc8u)	/* Overlay Target Address Register 15 */
#define OVC2_OTAR16	(*( OVC0_OTAR0_type *) 0xf884fbd4u)	/* Overlay Target Address Register 16 */
#define OVC2_OTAR17	(*( OVC0_OTAR0_type *) 0xf884fbe0u)	/* Overlay Target Address Register 17 */
#define OVC2_OTAR18	(*( OVC0_OTAR0_type *) 0xf884fbecu)	/* Overlay Target Address Register 18 */
#define OVC2_OTAR19	(*( OVC0_OTAR0_type *) 0xf884fbf8u)	/* Overlay Target Address Register 19 */
#define OVC2_OTAR2	(*( OVC0_OTAR0_type *) 0xf884fb2cu)	/* Overlay Target Address Register 2 */
#define OVC2_OTAR20	(*( OVC0_OTAR0_type *) 0xf884fc04u)	/* Overlay Target Address Register 20 */
#define OVC2_OTAR21	(*( OVC0_OTAR0_type *) 0xf884fc10u)	/* Overlay Target Address Register 21 */
#define OVC2_OTAR22	(*( OVC0_OTAR0_type *) 0xf884fc1cu)	/* Overlay Target Address Register 22 */
#define OVC2_OTAR23	(*( OVC0_OTAR0_type *) 0xf884fc28u)	/* Overlay Target Address Register 23 */
#define OVC2_OTAR24	(*( OVC0_OTAR0_type *) 0xf884fc34u)	/* Overlay Target Address Register 24 */
#define OVC2_OTAR25	(*( OVC0_OTAR0_type *) 0xf884fc40u)	/* Overlay Target Address Register 25 */
#define OVC2_OTAR26	(*( OVC0_OTAR0_type *) 0xf884fc4cu)	/* Overlay Target Address Register 26 */
#define OVC2_OTAR27	(*( OVC0_OTAR0_type *) 0xf884fc58u)	/* Overlay Target Address Register 27 */
#define OVC2_OTAR28	(*( OVC0_OTAR0_type *) 0xf884fc64u)	/* Overlay Target Address Register 28 */
#define OVC2_OTAR29	(*( OVC0_OTAR0_type *) 0xf884fc70u)	/* Overlay Target Address Register 29 */
#define OVC2_OTAR3	(*( OVC0_OTAR0_type *) 0xf884fb38u)	/* Overlay Target Address Register 3 */
#define OVC2_OTAR30	(*( OVC0_OTAR0_type *) 0xf884fc7cu)	/* Overlay Target Address Register 30 */
#define OVC2_OTAR31	(*( OVC0_OTAR0_type *) 0xf884fc88u)	/* Overlay Target Address Register 31 */
#define OVC2_OTAR4	(*( OVC0_OTAR0_type *) 0xf884fb44u)	/* Overlay Target Address Register 4 */
#define OVC2_OTAR5	(*( OVC0_OTAR0_type *) 0xf884fb50u)	/* Overlay Target Address Register 5 */
#define OVC2_OTAR6	(*( OVC0_OTAR0_type *) 0xf884fb5cu)	/* Overlay Target Address Register 6 */
#define OVC2_OTAR7	(*( OVC0_OTAR0_type *) 0xf884fb68u)	/* Overlay Target Address Register 7 */
#define OVC2_OTAR8	(*( OVC0_OTAR0_type *) 0xf884fb74u)	/* Overlay Target Address Register 8 */
#define OVC2_OTAR9	(*( OVC0_OTAR0_type *) 0xf884fb80u)	/* Overlay Target Address Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		unsigned int OBASE          : 17;	/* Overlay Block Base Address */
		unsigned int                : 2;
		unsigned int OMEM           : 3;	/* Overlay Memory Select */
		unsigned int                : 4;
		unsigned int OVEN           : 1;	/* Overlay Enabled */
	} B;
	int I;
	unsigned int U;

} OVC0_RABR0_type;
#define OVC0_RABR0	(*( OVC0_RABR0_type *) 0xf880fb10u)	/* Redirected Address Base Register 0 */
#define OVC0_RABR1	(*( OVC0_RABR0_type *) 0xf880fb1cu)	/* Redirected Address Base Register 1 */
#define OVC0_RABR10	(*( OVC0_RABR0_type *) 0xf880fb88u)	/* Redirected Address Base Register 10 */
#define OVC0_RABR11	(*( OVC0_RABR0_type *) 0xf880fb94u)	/* Redirected Address Base Register 11 */
#define OVC0_RABR12	(*( OVC0_RABR0_type *) 0xf880fba0u)	/* Redirected Address Base Register 12 */
#define OVC0_RABR13	(*( OVC0_RABR0_type *) 0xf880fbacu)	/* Redirected Address Base Register 13 */
#define OVC0_RABR14	(*( OVC0_RABR0_type *) 0xf880fbb8u)	/* Redirected Address Base Register 14 */
#define OVC0_RABR15	(*( OVC0_RABR0_type *) 0xf880fbc4u)	/* Redirected Address Base Register 15 */
#define OVC0_RABR16	(*( OVC0_RABR0_type *) 0xf880fbd0u)	/* Redirected Address Base Register 16 */
#define OVC0_RABR17	(*( OVC0_RABR0_type *) 0xf880fbdcu)	/* Redirected Address Base Register 17 */
#define OVC0_RABR18	(*( OVC0_RABR0_type *) 0xf880fbe8u)	/* Redirected Address Base Register 18 */
#define OVC0_RABR19	(*( OVC0_RABR0_type *) 0xf880fbf4u)	/* Redirected Address Base Register 19 */
#define OVC0_RABR2	(*( OVC0_RABR0_type *) 0xf880fb28u)	/* Redirected Address Base Register 2 */
#define OVC0_RABR20	(*( OVC0_RABR0_type *) 0xf880fc00u)	/* Redirected Address Base Register 20 */
#define OVC0_RABR21	(*( OVC0_RABR0_type *) 0xf880fc0cu)	/* Redirected Address Base Register 21 */
#define OVC0_RABR22	(*( OVC0_RABR0_type *) 0xf880fc18u)	/* Redirected Address Base Register 22 */
#define OVC0_RABR23	(*( OVC0_RABR0_type *) 0xf880fc24u)	/* Redirected Address Base Register 23 */
#define OVC0_RABR24	(*( OVC0_RABR0_type *) 0xf880fc30u)	/* Redirected Address Base Register 24 */
#define OVC0_RABR25	(*( OVC0_RABR0_type *) 0xf880fc3cu)	/* Redirected Address Base Register 25 */
#define OVC0_RABR26	(*( OVC0_RABR0_type *) 0xf880fc48u)	/* Redirected Address Base Register 26 */
#define OVC0_RABR27	(*( OVC0_RABR0_type *) 0xf880fc54u)	/* Redirected Address Base Register 27 */
#define OVC0_RABR28	(*( OVC0_RABR0_type *) 0xf880fc60u)	/* Redirected Address Base Register 28 */
#define OVC0_RABR29	(*( OVC0_RABR0_type *) 0xf880fc6cu)	/* Redirected Address Base Register 29 */
#define OVC0_RABR3	(*( OVC0_RABR0_type *) 0xf880fb34u)	/* Redirected Address Base Register 3 */
#define OVC0_RABR30	(*( OVC0_RABR0_type *) 0xf880fc78u)	/* Redirected Address Base Register 30 */
#define OVC0_RABR31	(*( OVC0_RABR0_type *) 0xf880fc84u)	/* Redirected Address Base Register 31 */
#define OVC0_RABR4	(*( OVC0_RABR0_type *) 0xf880fb40u)	/* Redirected Address Base Register 4 */
#define OVC0_RABR5	(*( OVC0_RABR0_type *) 0xf880fb4cu)	/* Redirected Address Base Register 5 */
#define OVC0_RABR6	(*( OVC0_RABR0_type *) 0xf880fb58u)	/* Redirected Address Base Register 6 */
#define OVC0_RABR7	(*( OVC0_RABR0_type *) 0xf880fb64u)	/* Redirected Address Base Register 7 */
#define OVC0_RABR8	(*( OVC0_RABR0_type *) 0xf880fb70u)	/* Redirected Address Base Register 8 */
#define OVC0_RABR9	(*( OVC0_RABR0_type *) 0xf880fb7cu)	/* Redirected Address Base Register 9 */
#define OVC1_RABR0	(*( OVC0_RABR0_type *) 0xf882fb10u)	/* Redirected Address Base Register 0 */
#define OVC1_RABR1	(*( OVC0_RABR0_type *) 0xf882fb1cu)	/* Redirected Address Base Register 1 */
#define OVC1_RABR10	(*( OVC0_RABR0_type *) 0xf882fb88u)	/* Redirected Address Base Register 10 */
#define OVC1_RABR11	(*( OVC0_RABR0_type *) 0xf882fb94u)	/* Redirected Address Base Register 11 */
#define OVC1_RABR12	(*( OVC0_RABR0_type *) 0xf882fba0u)	/* Redirected Address Base Register 12 */
#define OVC1_RABR13	(*( OVC0_RABR0_type *) 0xf882fbacu)	/* Redirected Address Base Register 13 */
#define OVC1_RABR14	(*( OVC0_RABR0_type *) 0xf882fbb8u)	/* Redirected Address Base Register 14 */
#define OVC1_RABR15	(*( OVC0_RABR0_type *) 0xf882fbc4u)	/* Redirected Address Base Register 15 */
#define OVC1_RABR16	(*( OVC0_RABR0_type *) 0xf882fbd0u)	/* Redirected Address Base Register 16 */
#define OVC1_RABR17	(*( OVC0_RABR0_type *) 0xf882fbdcu)	/* Redirected Address Base Register 17 */
#define OVC1_RABR18	(*( OVC0_RABR0_type *) 0xf882fbe8u)	/* Redirected Address Base Register 18 */
#define OVC1_RABR19	(*( OVC0_RABR0_type *) 0xf882fbf4u)	/* Redirected Address Base Register 19 */
#define OVC1_RABR2	(*( OVC0_RABR0_type *) 0xf882fb28u)	/* Redirected Address Base Register 2 */
#define OVC1_RABR20	(*( OVC0_RABR0_type *) 0xf882fc00u)	/* Redirected Address Base Register 20 */
#define OVC1_RABR21	(*( OVC0_RABR0_type *) 0xf882fc0cu)	/* Redirected Address Base Register 21 */
#define OVC1_RABR22	(*( OVC0_RABR0_type *) 0xf882fc18u)	/* Redirected Address Base Register 22 */
#define OVC1_RABR23	(*( OVC0_RABR0_type *) 0xf882fc24u)	/* Redirected Address Base Register 23 */
#define OVC1_RABR24	(*( OVC0_RABR0_type *) 0xf882fc30u)	/* Redirected Address Base Register 24 */
#define OVC1_RABR25	(*( OVC0_RABR0_type *) 0xf882fc3cu)	/* Redirected Address Base Register 25 */
#define OVC1_RABR26	(*( OVC0_RABR0_type *) 0xf882fc48u)	/* Redirected Address Base Register 26 */
#define OVC1_RABR27	(*( OVC0_RABR0_type *) 0xf882fc54u)	/* Redirected Address Base Register 27 */
#define OVC1_RABR28	(*( OVC0_RABR0_type *) 0xf882fc60u)	/* Redirected Address Base Register 28 */
#define OVC1_RABR29	(*( OVC0_RABR0_type *) 0xf882fc6cu)	/* Redirected Address Base Register 29 */
#define OVC1_RABR3	(*( OVC0_RABR0_type *) 0xf882fb34u)	/* Redirected Address Base Register 3 */
#define OVC1_RABR30	(*( OVC0_RABR0_type *) 0xf882fc78u)	/* Redirected Address Base Register 30 */
#define OVC1_RABR31	(*( OVC0_RABR0_type *) 0xf882fc84u)	/* Redirected Address Base Register 31 */
#define OVC1_RABR4	(*( OVC0_RABR0_type *) 0xf882fb40u)	/* Redirected Address Base Register 4 */
#define OVC1_RABR5	(*( OVC0_RABR0_type *) 0xf882fb4cu)	/* Redirected Address Base Register 5 */
#define OVC1_RABR6	(*( OVC0_RABR0_type *) 0xf882fb58u)	/* Redirected Address Base Register 6 */
#define OVC1_RABR7	(*( OVC0_RABR0_type *) 0xf882fb64u)	/* Redirected Address Base Register 7 */
#define OVC1_RABR8	(*( OVC0_RABR0_type *) 0xf882fb70u)	/* Redirected Address Base Register 8 */
#define OVC1_RABR9	(*( OVC0_RABR0_type *) 0xf882fb7cu)	/* Redirected Address Base Register 9 */
#define OVC2_RABR0	(*( OVC0_RABR0_type *) 0xf884fb10u)	/* Redirected Address Base Register 0 */
#define OVC2_RABR1	(*( OVC0_RABR0_type *) 0xf884fb1cu)	/* Redirected Address Base Register 1 */
#define OVC2_RABR10	(*( OVC0_RABR0_type *) 0xf884fb88u)	/* Redirected Address Base Register 10 */
#define OVC2_RABR11	(*( OVC0_RABR0_type *) 0xf884fb94u)	/* Redirected Address Base Register 11 */
#define OVC2_RABR12	(*( OVC0_RABR0_type *) 0xf884fba0u)	/* Redirected Address Base Register 12 */
#define OVC2_RABR13	(*( OVC0_RABR0_type *) 0xf884fbacu)	/* Redirected Address Base Register 13 */
#define OVC2_RABR14	(*( OVC0_RABR0_type *) 0xf884fbb8u)	/* Redirected Address Base Register 14 */
#define OVC2_RABR15	(*( OVC0_RABR0_type *) 0xf884fbc4u)	/* Redirected Address Base Register 15 */
#define OVC2_RABR16	(*( OVC0_RABR0_type *) 0xf884fbd0u)	/* Redirected Address Base Register 16 */
#define OVC2_RABR17	(*( OVC0_RABR0_type *) 0xf884fbdcu)	/* Redirected Address Base Register 17 */
#define OVC2_RABR18	(*( OVC0_RABR0_type *) 0xf884fbe8u)	/* Redirected Address Base Register 18 */
#define OVC2_RABR19	(*( OVC0_RABR0_type *) 0xf884fbf4u)	/* Redirected Address Base Register 19 */
#define OVC2_RABR2	(*( OVC0_RABR0_type *) 0xf884fb28u)	/* Redirected Address Base Register 2 */
#define OVC2_RABR20	(*( OVC0_RABR0_type *) 0xf884fc00u)	/* Redirected Address Base Register 20 */
#define OVC2_RABR21	(*( OVC0_RABR0_type *) 0xf884fc0cu)	/* Redirected Address Base Register 21 */
#define OVC2_RABR22	(*( OVC0_RABR0_type *) 0xf884fc18u)	/* Redirected Address Base Register 22 */
#define OVC2_RABR23	(*( OVC0_RABR0_type *) 0xf884fc24u)	/* Redirected Address Base Register 23 */
#define OVC2_RABR24	(*( OVC0_RABR0_type *) 0xf884fc30u)	/* Redirected Address Base Register 24 */
#define OVC2_RABR25	(*( OVC0_RABR0_type *) 0xf884fc3cu)	/* Redirected Address Base Register 25 */
#define OVC2_RABR26	(*( OVC0_RABR0_type *) 0xf884fc48u)	/* Redirected Address Base Register 26 */
#define OVC2_RABR27	(*( OVC0_RABR0_type *) 0xf884fc54u)	/* Redirected Address Base Register 27 */
#define OVC2_RABR28	(*( OVC0_RABR0_type *) 0xf884fc60u)	/* Redirected Address Base Register 28 */
#define OVC2_RABR29	(*( OVC0_RABR0_type *) 0xf884fc6cu)	/* Redirected Address Base Register 29 */
#define OVC2_RABR3	(*( OVC0_RABR0_type *) 0xf884fb34u)	/* Redirected Address Base Register 3 */
#define OVC2_RABR30	(*( OVC0_RABR0_type *) 0xf884fc78u)	/* Redirected Address Base Register 30 */
#define OVC2_RABR31	(*( OVC0_RABR0_type *) 0xf884fc84u)	/* Redirected Address Base Register 31 */
#define OVC2_RABR4	(*( OVC0_RABR0_type *) 0xf884fb40u)	/* Redirected Address Base Register 4 */
#define OVC2_RABR5	(*( OVC0_RABR0_type *) 0xf884fb4cu)	/* Redirected Address Base Register 5 */
#define OVC2_RABR6	(*( OVC0_RABR0_type *) 0xf884fb58u)	/* Redirected Address Base Register 6 */
#define OVC2_RABR7	(*( OVC0_RABR0_type *) 0xf884fb64u)	/* Redirected Address Base Register 7 */
#define OVC2_RABR8	(*( OVC0_RABR0_type *) 0xf884fb70u)	/* Redirected Address Base Register 8 */
#define OVC2_RABR9	(*( OVC0_RABR0_type *) 0xf884fb7cu)	/* Redirected Address Base Register 9 */


/* Ports */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} P00_ACCEN0_type;
#define P00_ACCEN0	(*( P00_ACCEN0_type *) 0xf003a0fcu)	/* Port 00 Access Enable Register 0 */
#define P01_ACCEN0	(*( P00_ACCEN0_type *) 0xf003a1fcu)	/* Port 01 Access Enable Register 0 */
#define P02_ACCEN0	(*( P00_ACCEN0_type *) 0xf003a2fcu)	/* Port 02 Access Enable Register 0 */
#define P10_ACCEN0	(*( P00_ACCEN0_type *) 0xf003b0fcu)	/* Port 10 Access Enable Register 0 */
#define P11_ACCEN0	(*( P00_ACCEN0_type *) 0xf003b1fcu)	/* Port 11 Access Enable Register 0 */
#define P12_ACCEN0	(*( P00_ACCEN0_type *) 0xf003b2fcu)	/* Port 12 Access Enable Register 0 */
#define P13_ACCEN0	(*( P00_ACCEN0_type *) 0xf003b3fcu)	/* Port 13 Access Enable Register 0 */
#define P14_ACCEN0	(*( P00_ACCEN0_type *) 0xf003b4fcu)	/* Port 14 Access Enable Register 0 */
#define P15_ACCEN0	(*( P00_ACCEN0_type *) 0xf003b5fcu)	/* Port 15 Access Enable Register 0 */
#define P20_ACCEN0	(*( P00_ACCEN0_type *) 0xf003c0fcu)	/* Port 20 Access Enable Register 0 */
#define P21_ACCEN0	(*( P00_ACCEN0_type *) 0xf003c1fcu)	/* Port 21 Access Enable Register 0 */
#define P22_ACCEN0	(*( P00_ACCEN0_type *) 0xf003c2fcu)	/* Port 22 Access Enable Register 0 */
#define P23_ACCEN0	(*( P00_ACCEN0_type *) 0xf003c3fcu)	/* Port 23 Access Enable Register 0 */
#define P32_ACCEN0	(*( P00_ACCEN0_type *) 0xf003d2fcu)	/* Port 32 Access Enable Register 0 */
#define P33_ACCEN0	(*( P00_ACCEN0_type *) 0xf003d3fcu)	/* Port 33 Access Enable Register 0 */
#define P34_ACCEN0	(*( P00_ACCEN0_type *) 0xf003d4fcu)	/* Port 34 Access Enable Register 0 */
#define P40_ACCEN0	(*( P00_ACCEN0_type *) 0xf003e0fcu)	/* Port 40 Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P00_ACCEN1_type;
#define P00_ACCEN1	(*( P00_ACCEN1_type *) 0xf003a0f8u)	/* Port 00 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN1            : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN2            : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN3            : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN4            : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN5            : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN6            : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN7            : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN8            : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN9            : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN10           : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN11           : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN12           : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN13           : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN14           : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int EN15           : 1;	/* Emergency Stop Enable for Port n Pin x */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} P00_ESR_type;
#define P00_ESR	(*( P00_ESR_type *) 0xf003a050u)	/* Port 00 Emergency Stop Register */
#define P01_ESR	(*( P00_ESR_type *) 0xf003a150u)	/* Port 01 Emergency Stop Register */
#define P02_ESR	(*( P00_ESR_type *) 0xf003a250u)	/* Port 02 Emergency Stop Register */
#define P10_ESR	(*( P00_ESR_type *) 0xf003b050u)	/* Port 10 Emergency Stop Register */
#define P11_ESR	(*( P00_ESR_type *) 0xf003b150u)	/* Port 11 Emergency Stop Register */
#define P12_ESR	(*( P00_ESR_type *) 0xf003b250u)	/* Port 12 Emergency Stop Register */
#define P13_ESR	(*( P00_ESR_type *) 0xf003b350u)	/* Port 13 Emergency Stop Register */
#define P14_ESR	(*( P00_ESR_type *) 0xf003b450u)	/* Port 14 Emergency Stop Register */
#define P15_ESR	(*( P00_ESR_type *) 0xf003b550u)	/* Port 15 Emergency Stop Register */
#define P20_ESR	(*( P00_ESR_type *) 0xf003c050u)	/* Port 20 Emergency Stop Register */
#define P21_ESR	(*( P00_ESR_type *) 0xf003c150u)	/* Port 21 Emergency Stop Register */
#define P22_ESR	(*( P00_ESR_type *) 0xf003c250u)	/* Port 22 Emergency Stop Register */
#define P23_ESR	(*( P00_ESR_type *) 0xf003c350u)	/* Port 23 Emergency Stop Register */
#define P32_ESR	(*( P00_ESR_type *) 0xf003d250u)	/* Port 32 Emergency Stop Register */
#define P33_ESR	(*( P00_ESR_type *) 0xf003d350u)	/* Port 33 Emergency Stop Register */
#define P34_ESR	(*( P00_ESR_type *) 0xf003d450u)	/* Port 34 Emergency Stop Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} P00_ID_type;
#define P00_ID	(*( P00_ID_type *) 0xf003a008u)	/* Identification Register */
#define P01_ID	(*( P00_ID_type *) 0xf003a108u)	/* Identification Register */
#define P02_ID	(*( P00_ID_type *) 0xf003a208u)	/* Identification Register */
#define P10_ID	(*( P00_ID_type *) 0xf003b008u)	/* Identification Register */
#define P11_ID	(*( P00_ID_type *) 0xf003b108u)	/* Identification Register */
#define P12_ID	(*( P00_ID_type *) 0xf003b208u)	/* Identification Register */
#define P13_ID	(*( P00_ID_type *) 0xf003b308u)	/* Identification Register */
#define P14_ID	(*( P00_ID_type *) 0xf003b408u)	/* Identification Register */
#define P15_ID	(*( P00_ID_type *) 0xf003b508u)	/* Identification Register */
#define P20_ID	(*( P00_ID_type *) 0xf003c008u)	/* Identification Register */
#define P21_ID	(*( P00_ID_type *) 0xf003c108u)	/* Identification Register */
#define P22_ID	(*( P00_ID_type *) 0xf003c208u)	/* Identification Register */
#define P23_ID	(*( P00_ID_type *) 0xf003c308u)	/* Identification Register */
#define P32_ID	(*( P00_ID_type *) 0xf003d208u)	/* Identification Register */
#define P33_ID	(*( P00_ID_type *) 0xf003d308u)	/* Identification Register */
#define P34_ID	(*( P00_ID_type *) 0xf003d408u)	/* Identification Register */
#define P40_ID	(*( P00_ID_type *) 0xf003e008u)	/* Identification Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int P0             : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P1             : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P2             : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P3             : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P4             : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P5             : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P6             : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P7             : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P8             : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P9             : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P10            : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P11            : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P12            : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P13            : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P14            : 1;	/* Port n Input Bit x */
		/* const */ unsigned int P15            : 1;	/* Port n Input Bit x */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} P00_IN_type;
#define P00_IN	(*( P00_IN_type *) 0xf003a024u)	/* Port 00 Input Register */
#define P01_IN	(*( P00_IN_type *) 0xf003a124u)	/* Port 01 Input Register */
#define P02_IN	(*( P00_IN_type *) 0xf003a224u)	/* Port 02 Input Register */
#define P10_IN	(*( P00_IN_type *) 0xf003b024u)	/* Port 10 Input Register */
#define P11_IN	(*( P00_IN_type *) 0xf003b124u)	/* Port 11 Input Register */
#define P12_IN	(*( P00_IN_type *) 0xf003b224u)	/* Port 12 Input Register */
#define P13_IN	(*( P00_IN_type *) 0xf003b324u)	/* Port 13 Input Register */
#define P14_IN	(*( P00_IN_type *) 0xf003b424u)	/* Port 14 Input Register */
#define P15_IN	(*( P00_IN_type *) 0xf003b524u)	/* Port 15 Input Register */
#define P20_IN	(*( P00_IN_type *) 0xf003c024u)	/* Port 20 Input Register */
#define P21_IN	(*( P00_IN_type *) 0xf003c124u)	/* Port 21 Input Register */
#define P22_IN	(*( P00_IN_type *) 0xf003c224u)	/* Port 22 Input Register */
#define P23_IN	(*( P00_IN_type *) 0xf003c324u)	/* Port 23 Input Register */
#define P32_IN	(*( P00_IN_type *) 0xf003d224u)	/* Port 32 Input Register */
#define P33_IN	(*( P00_IN_type *) 0xf003d324u)	/* Port 33 Input Register */
#define P34_IN	(*( P00_IN_type *) 0xf003d424u)	/* Port 34 Input Register */
#define P40_IN	(*( P00_IN_type *) 0xf003e024u)	/* Port 40 Input Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC0            : 5;	/* Port Control for Port n Pin 0 to 3 */
		unsigned int                : 3;
		unsigned int PC1            : 5;	/* Port Control for Port n Pin 0 to 3 */
		unsigned int                : 3;
		unsigned int PC2            : 5;	/* Port Control for Port n Pin 0 to 3 */
		unsigned int                : 3;
		unsigned int PC3            : 5;	/* Port Control for Port n Pin 0 to 3 */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC0            : 5;	/* Port Control for Port n Pin 0 to 3 */
		unsigned int                : 3;
		unsigned int PC1            : 5;	/* Port Control for Port n Pin 0 to 3 */
		unsigned int                : 3;
		unsigned int PC2            : 5;	/* Port Control for Port n Pin 0 to 3 */
		unsigned int                : 3;
		unsigned int PC3            : 5;	/* Port Control for Port n Pin 0 to 3 */
	} B2;
	int I;
	unsigned int U;

} P00_IOCR0_type;
#define P00_IOCR0	(*( P00_IOCR0_type *) 0xf003a010u)	/* Port 00 Input/Output Control Register 0 */
#define P02_IOCR0	(*( P00_IOCR0_type *) 0xf003a210u)	/* Port 02 Input/Output Control Register 0 */
#define P10_IOCR0	(*( P00_IOCR0_type *) 0xf003b010u)	/* Port 10 Input/Output Control Register 0 */
#define P11_IOCR0	(*( P00_IOCR0_type *) 0xf003b110u)	/* Port 11 Input/Output Control Register 0 */
#define P13_IOCR0	(*( P00_IOCR0_type *) 0xf003b310u)	/* Port 13 Input/Output Control Register 0 */
#define P14_IOCR0	(*( P00_IOCR0_type *) 0xf003b410u)	/* Port 14 Input/Output Control Register 0 */
#define P15_IOCR0	(*( P00_IOCR0_type *) 0xf003b510u)	/* Port 15 Input/Output Control Register 0 */
#define P20_IOCR0	(*( P00_IOCR0_type *) 0xf003c010u)	/* Port 20 Input/Output Control Register 0 */
#define P21_IOCR0	(*( P00_IOCR0_type *) 0xf003c110u)	/* Port 21 Input/Output Control Register 0 */
#define P22_IOCR0	(*( P00_IOCR0_type *) 0xf003c210u)	/* Port 22 Input/Output Control Register 0 */
#define P23_IOCR0	(*( P00_IOCR0_type *) 0xf003c310u)	/* Port 23 Input/Output Control Register 0 */
#define P33_IOCR0	(*( P00_IOCR0_type *) 0xf003d310u)	/* Port 33 Input/Output Control Register 0 */
#define P34_IOCR0	(*( P00_IOCR0_type *) 0xf003d410u)	/* Port 34 Input/Output Control Register 0 */
#define P40_IOCR0	(*( P00_IOCR0_type *) 0xf003e010u)	/* Port 40 Input/Output Control Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC12           : 5;	/* Port Control for Port 00.12 */
		unsigned int                : 3;
		unsigned int PC13           : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC14           : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC15           : 5;	/* Reserved */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC12           : 5;	/* Port Control for Port 00.12 */
		unsigned int                : 3;
		unsigned int PC13           : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC14           : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC15           : 5;	/* Reserved */
	} B2;
	int I;
	unsigned int U;

} P00_IOCR12_type;
#define P00_IOCR12	(*( P00_IOCR12_type *) 0xf003a01cu)	/* Port 00 Input/Output Control Register 12 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC4            : 5;	/* Port Control for Port n Pin 4 to 7 */
		unsigned int                : 3;
		unsigned int PC5            : 5;	/* Port Control for Port n Pin 4 to 7 */
		unsigned int                : 3;
		unsigned int PC6            : 5;	/* Port Control for Port n Pin 4 to 7 */
		unsigned int                : 3;
		unsigned int PC7            : 5;	/* Port Control for Port n Pin 4 to 7 */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC4            : 5;	/* Port Control for Port n Pin 4 to 7 */
		unsigned int                : 3;
		unsigned int PC5            : 5;	/* Port Control for Port n Pin 4 to 7 */
		unsigned int                : 3;
		unsigned int PC6            : 5;	/* Port Control for Port n Pin 4 to 7 */
		unsigned int                : 3;
		unsigned int PC7            : 5;	/* Port Control for Port n Pin 4 to 7 */
	} B2;
	int I;
	unsigned int U;

} P00_IOCR4_type;
#define P00_IOCR4	(*( P00_IOCR4_type *) 0xf003a014u)	/* Port 00 Input/Output Control Register 4 */
#define P01_IOCR4	(*( P00_IOCR4_type *) 0xf003a114u)	/* Port 01 Input/Output Control Register 4 */
#define P02_IOCR4	(*( P00_IOCR4_type *) 0xf003a214u)	/* Port 02 Input/Output Control Register 4 */
#define P10_IOCR4	(*( P00_IOCR4_type *) 0xf003b014u)	/* Port 10 Input/Output Control Register 4 */
#define P11_IOCR4	(*( P00_IOCR4_type *) 0xf003b114u)	/* Port 11 Input/Output Control Register 4 */
#define P14_IOCR4	(*( P00_IOCR4_type *) 0xf003b414u)	/* Port 14 Input/Output Control Register 4 */
#define P15_IOCR4	(*( P00_IOCR4_type *) 0xf003b514u)	/* Port 15 Input/Output Control Register 4 */
#define P21_IOCR4	(*( P00_IOCR4_type *) 0xf003c114u)	/* Port 21 Input/Output Control Register 4 */
#define P22_IOCR4	(*( P00_IOCR4_type *) 0xf003c214u)	/* Port 22 Input/Output Control Register 4 */
#define P23_IOCR4	(*( P00_IOCR4_type *) 0xf003c314u)	/* Port 23 Input/Output Control Register 4 */
#define P32_IOCR4	(*( P00_IOCR4_type *) 0xf003d214u)	/* Port 32 Input/Output Control Register 4 */
#define P33_IOCR4	(*( P00_IOCR4_type *) 0xf003d314u)	/* Port 33 Input/Output Control Register 4 */
#define P40_IOCR4	(*( P00_IOCR4_type *) 0xf003e014u)	/* Port 40 Input/Output Control Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC8            : 5;	/* Port Control for Port n Pin 8 to 11 */
		unsigned int                : 3;
		unsigned int PC9            : 5;	/* Port Control for Port n Pin 8 to 11 */
		unsigned int                : 3;
		unsigned int PC10           : 5;	/* Port Control for Port n Pin 8 to 11 */
		unsigned int                : 3;
		unsigned int PC11           : 5;	/* Port Control for Port n Pin 8 to 11 */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC8            : 5;	/* Port Control for Port n Pin 8 to 11 */
		unsigned int                : 3;
		unsigned int PC9            : 5;	/* Port Control for Port n Pin 8 to 11 */
		unsigned int                : 3;
		unsigned int PC10           : 5;	/* Port Control for Port n Pin 8 to 11 */
		unsigned int                : 3;
		unsigned int PC11           : 5;	/* Port Control for Port n Pin 8 to 11 */
	} B2;
	int I;
	unsigned int U;

} P00_IOCR8_type;
#define P00_IOCR8	(*( P00_IOCR8_type *) 0xf003a018u)	/* Port 00 Input/Output Control Register 8 */
#define P02_IOCR8	(*( P00_IOCR8_type *) 0xf003a218u)	/* Port 02 Input/Output Control Register 8 */
#define P11_IOCR8	(*( P00_IOCR8_type *) 0xf003b118u)	/* Port 11 Input/Output Control Register 8 */
#define P20_IOCR8	(*( P00_IOCR8_type *) 0xf003c018u)	/* Port 20 Input/Output Control Register 8 */
#define P22_IOCR8	(*( P00_IOCR8_type *) 0xf003c218u)	/* Port 22 Input/Output Control Register 8 */
#define P33_IOCR8	(*( P00_IOCR8_type *) 0xf003d318u)	/* Port 33 Input/Output Control Register 8 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 16;
		unsigned int PCL0           : 1;	/* Port n Clear Bit x */
		unsigned int PCL1           : 1;	/* Port n Clear Bit x */
		unsigned int PCL2           : 1;	/* Port n Clear Bit x */
		unsigned int PCL3           : 1;	/* Port n Clear Bit x */
		unsigned int PCL4           : 1;	/* Port n Clear Bit x */
		unsigned int PCL5           : 1;	/* Port n Clear Bit x */
		unsigned int PCL6           : 1;	/* Port n Clear Bit x */
		unsigned int PCL7           : 1;	/* Port n Clear Bit x */
		unsigned int PCL8           : 1;	/* Port n Clear Bit x */
		unsigned int PCL9           : 1;	/* Port n Clear Bit x */
		unsigned int PCL10          : 1;	/* Port n Clear Bit x */
		unsigned int PCL11          : 1;	/* Port n Clear Bit x */
		unsigned int PCL12          : 1;	/* Port n Clear Bit x */
		unsigned int PCL13          : 1;	/* Port n Clear Bit x */
		unsigned int PCL14          : 1;	/* Port n Clear Bit x */
		unsigned int PCL15          : 1;	/* Port n Clear Bit x */
	} B;
	int I;
	unsigned int U;

} P00_OMCR_type;
#define P00_OMCR	(*( P00_OMCR_type *) 0xf003a094u)	/* Port 00 Output Modification Clear Register */
#define P01_OMCR	(*( P00_OMCR_type *) 0xf003a194u)	/* Port 01 Output Modification Clear Register */
#define P02_OMCR	(*( P00_OMCR_type *) 0xf003a294u)	/* Port 02 Output Modification Clear Register */
#define P10_OMCR	(*( P00_OMCR_type *) 0xf003b094u)	/* Port 10 Output Modification Clear Register */
#define P11_OMCR	(*( P00_OMCR_type *) 0xf003b194u)	/* Port 11 Output Modification Clear Register */
#define P12_OMCR	(*( P00_OMCR_type *) 0xf003b294u)	/* Port 12 Output Modification Clear Register */
#define P13_OMCR	(*( P00_OMCR_type *) 0xf003b394u)	/* Port 13 Output Modification Clear Register */
#define P14_OMCR	(*( P00_OMCR_type *) 0xf003b494u)	/* Port 14 Output Modification Clear Register */
#define P15_OMCR	(*( P00_OMCR_type *) 0xf003b594u)	/* Port 15 Output Modification Clear Register */
#define P20_OMCR	(*( P00_OMCR_type *) 0xf003c094u)	/* Port 20 Output Modification Clear Register */
#define P21_OMCR	(*( P00_OMCR_type *) 0xf003c194u)	/* Port 21 Output Modification Clear Register */
#define P22_OMCR	(*( P00_OMCR_type *) 0xf003c294u)	/* Port 22 Output Modification Clear Register */
#define P23_OMCR	(*( P00_OMCR_type *) 0xf003c394u)	/* Port 23 Output Modification Clear Register */
#define P32_OMCR	(*( P00_OMCR_type *) 0xf003d294u)	/* Port 32 Output Modification Clear Register */
#define P33_OMCR	(*( P00_OMCR_type *) 0xf003d394u)	/* Port 33 Output Modification Clear Register */
#define P34_OMCR	(*( P00_OMCR_type *) 0xf003d494u)	/* Port 34 Output Modification Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 16;
		unsigned int PCL0           : 1;	/* Port n Clear Bit x */
		unsigned int PCL1           : 1;	/* Port n Clear Bit x */
		unsigned int PCL2           : 1;	/* Port n Clear Bit x */
		unsigned int PCL3           : 1;	/* Port n Clear Bit x */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} P00_OMCR0_type;
#define P00_OMCR0	(*( P00_OMCR0_type *) 0xf003a080u)	/* Port 00 Output Modification Clear Register 0 */
#define P01_OMCR0	(*( P00_OMCR0_type *) 0xf003a180u)	/* Port 01 Output Modification Clear Register 0 */
#define P02_OMCR0	(*( P00_OMCR0_type *) 0xf003a280u)	/* Port 02 Output Modification Clear Register 0 */
#define P10_OMCR0	(*( P00_OMCR0_type *) 0xf003b080u)	/* Port 10 Output Modification Clear Register 0 */
#define P11_OMCR0	(*( P00_OMCR0_type *) 0xf003b180u)	/* Port 11 Output Modification Clear Register 0 */
#define P12_OMCR0	(*( P00_OMCR0_type *) 0xf003b280u)	/* Port 12 Output Modification Clear Register 0 */
#define P13_OMCR0	(*( P00_OMCR0_type *) 0xf003b380u)	/* Port 13 Output Modification Clear Register 0 */
#define P14_OMCR0	(*( P00_OMCR0_type *) 0xf003b480u)	/* Port 14 Output Modification Clear Register 0 */
#define P15_OMCR0	(*( P00_OMCR0_type *) 0xf003b580u)	/* Port 15 Output Modification Clear Register 0 */
#define P20_OMCR0	(*( P00_OMCR0_type *) 0xf003c080u)	/* Port 20 Output Modification Clear Register 0 */
#define P21_OMCR0	(*( P00_OMCR0_type *) 0xf003c180u)	/* Port 21 Output Modification Clear Register 0 */
#define P22_OMCR0	(*( P00_OMCR0_type *) 0xf003c280u)	/* Port 22 Output Modification Clear Register 0 */
#define P23_OMCR0	(*( P00_OMCR0_type *) 0xf003c380u)	/* Port 23 Output Modification Clear Register 0 */
#define P32_OMCR0	(*( P00_OMCR0_type *) 0xf003d280u)	/* Port 32 Output Modification Clear Register 0 */
#define P33_OMCR0	(*( P00_OMCR0_type *) 0xf003d380u)	/* Port 33 Output Modification Clear Register 0 */
#define P34_OMCR0	(*( P00_OMCR0_type *) 0xf003d480u)	/* Port 34 Output Modification Clear Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 28;
		unsigned int PCL12          : 1;	/* Port n Clear Bit x */
		unsigned int PCL13          : 1;	/* Port n Clear Bit x */
		unsigned int PCL14          : 1;	/* Port n Clear Bit x */
		unsigned int PCL15          : 1;	/* Port n Clear Bit x */
	} B;
	int I;
	unsigned int U;

} P00_OMCR12_type;
#define P00_OMCR12	(*( P00_OMCR12_type *) 0xf003a08cu)	/* Port 00 Output Modification Clear Register 12 */
#define P11_OMCR12	(*( P00_OMCR12_type *) 0xf003b18cu)	/* Port 11 Output Modification Clear Register 12 */
#define P20_OMCR12	(*( P00_OMCR12_type *) 0xf003c08cu)	/* Port 20 Output Modification Clear Register 12 */
#define P33_OMCR12	(*( P00_OMCR12_type *) 0xf003d38cu)	/* Port 33 Output Modification Clear Register 12 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 20;
		unsigned int PCL4           : 1;	/* Port n Clear Bit x */
		unsigned int PCL5           : 1;	/* Port n Clear Bit x */
		unsigned int PCL6           : 1;	/* Port n Clear Bit x */
		unsigned int PCL7           : 1;	/* Port n Clear Bit x */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} P00_OMCR4_type;
#define P00_OMCR4	(*( P00_OMCR4_type *) 0xf003a084u)	/* Port 00 Output Modification Clear Register 4 */
#define P01_OMCR4	(*( P00_OMCR4_type *) 0xf003a184u)	/* Port 01 Output Modification Clear Register 4 */
#define P02_OMCR4	(*( P00_OMCR4_type *) 0xf003a284u)	/* Port 02 Output Modification Clear Register 4 */
#define P10_OMCR4	(*( P00_OMCR4_type *) 0xf003b084u)	/* Port 10 Output Modification Clear Register 4 */
#define P11_OMCR4	(*( P00_OMCR4_type *) 0xf003b184u)	/* Port 11 Output Modification Clear Register 4 */
#define P14_OMCR4	(*( P00_OMCR4_type *) 0xf003b484u)	/* Port 14 Output Modification Clear Register 4 */
#define P15_OMCR4	(*( P00_OMCR4_type *) 0xf003b584u)	/* Port 15 Output Modification Clear Register 4 */
#define P20_OMCR4	(*( P00_OMCR4_type *) 0xf003c084u)	/* Port 20 Output Modification Clear Register 4 */
#define P21_OMCR4	(*( P00_OMCR4_type *) 0xf003c184u)	/* Port 21 Output Modification Clear Register 4 */
#define P22_OMCR4	(*( P00_OMCR4_type *) 0xf003c284u)	/* Port 22 Output Modification Clear Register 4 */
#define P23_OMCR4	(*( P00_OMCR4_type *) 0xf003c384u)	/* Port 23 Output Modification Clear Register 4 */
#define P32_OMCR4	(*( P00_OMCR4_type *) 0xf003d284u)	/* Port 32 Output Modification Clear Register 4 */
#define P33_OMCR4	(*( P00_OMCR4_type *) 0xf003d384u)	/* Port 33 Output Modification Clear Register 4 */
#define P34_OMCR4	(*( P00_OMCR4_type *) 0xf003d484u)	/* Port 34 Output Modification Clear Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int PCL8           : 1;	/* Port n Clear Bit x */
		unsigned int PCL9           : 1;	/* Port n Clear Bit x */
		unsigned int PCL10          : 1;	/* Port n Clear Bit x */
		unsigned int PCL11          : 1;	/* Port n Clear Bit x */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} P00_OMCR8_type;
#define P00_OMCR8	(*( P00_OMCR8_type *) 0xf003a088u)	/* Port 00 Output Modification Clear Register 8 */
#define P02_OMCR8	(*( P00_OMCR8_type *) 0xf003a288u)	/* Port 02 Output Modification Clear Register 8 */
#define P10_OMCR8	(*( P00_OMCR8_type *) 0xf003b088u)	/* Port 10 Output Modification Clear Register 8 */
#define P11_OMCR8	(*( P00_OMCR8_type *) 0xf003b188u)	/* Port 11 Output Modification Clear Register 8 */
#define P14_OMCR8	(*( P00_OMCR8_type *) 0xf003b488u)	/* Port 14 Output Modification Clear Register 8 */
#define P15_OMCR8	(*( P00_OMCR8_type *) 0xf003b588u)	/* Port 15 Output Modification Clear Register 8 */
#define P20_OMCR8	(*( P00_OMCR8_type *) 0xf003c088u)	/* Port 20 Output Modification Clear Register 8 */
#define P22_OMCR8	(*( P00_OMCR8_type *) 0xf003c288u)	/* Port 22 Output Modification Clear Register 8 */
#define P33_OMCR8	(*( P00_OMCR8_type *) 0xf003d388u)	/* Port 33 Output Modification Clear Register 8 */

typedef volatile union
{
	struct
	{ 
		unsigned int PS0            : 1;	/* Port n Set Bit x */
		unsigned int PS1            : 1;	/* Port n Set Bit x */
		unsigned int PS2            : 1;	/* Port n Set Bit x */
		unsigned int PS3            : 1;	/* Port n Set Bit x */
		unsigned int PS4            : 1;	/* Port n Set Bit x */
		unsigned int PS5            : 1;	/* Port n Set Bit x */
		unsigned int PS6            : 1;	/* Port n Set Bit x */
		unsigned int PS7            : 1;	/* Port n Set Bit x */
		unsigned int PS8            : 1;	/* Port n Set Bit x */
		unsigned int PS9            : 1;	/* Port n Set Bit x */
		unsigned int PS10           : 1;	/* Port n Set Bit x */
		unsigned int PS11           : 1;	/* Port n Set Bit x */
		unsigned int PS12           : 1;	/* Port n Set Bit x */
		unsigned int PS13           : 1;	/* Port n Set Bit x */
		unsigned int PS14           : 1;	/* Port n Set Bit x */
		unsigned int PS15           : 1;	/* Port n Set Bit x */
		unsigned int PCL0           : 1;	/* Port n Clear Bit x */
		unsigned int PCL1           : 1;	/* Port n Clear Bit x */
		unsigned int PCL2           : 1;	/* Port n Clear Bit x */
		unsigned int PCL3           : 1;	/* Port n Clear Bit x */
		unsigned int PCL4           : 1;	/* Port n Clear Bit x */
		unsigned int PCL5           : 1;	/* Port n Clear Bit x */
		unsigned int PCL6           : 1;	/* Port n Clear Bit x */
		unsigned int PCL7           : 1;	/* Port n Clear Bit x */
		unsigned int PCL8           : 1;	/* Port n Clear Bit x */
		unsigned int PCL9           : 1;	/* Port n Clear Bit x */
		unsigned int PCL10          : 1;	/* Port n Clear Bit x */
		unsigned int PCL11          : 1;	/* Port n Clear Bit x */
		unsigned int PCL12          : 1;	/* Port n Clear Bit x */
		unsigned int PCL13          : 1;	/* Port n Clear Bit x */
		unsigned int PCL14          : 1;	/* Port n Clear Bit x */
		unsigned int PCL15          : 1;	/* Port n Clear Bit x */
	} B;
	int I;
	unsigned int U;

} P00_OMR_type;
#define P00_OMR	(*( P00_OMR_type *) 0xf003a004u)	/* Port 00 Output Modification Register */
#define P01_OMR	(*( P00_OMR_type *) 0xf003a104u)	/* Port 01 Output Modification Register */
#define P02_OMR	(*( P00_OMR_type *) 0xf003a204u)	/* Port 02 Output Modification Register */
#define P10_OMR	(*( P00_OMR_type *) 0xf003b004u)	/* Port 10 Output Modification Register */
#define P11_OMR	(*( P00_OMR_type *) 0xf003b104u)	/* Port 11 Output Modification Register */
#define P12_OMR	(*( P00_OMR_type *) 0xf003b204u)	/* Port 12 Output Modification Register */
#define P13_OMR	(*( P00_OMR_type *) 0xf003b304u)	/* Port 13 Output Modification Register */
#define P14_OMR	(*( P00_OMR_type *) 0xf003b404u)	/* Port 14 Output Modification Register */
#define P15_OMR	(*( P00_OMR_type *) 0xf003b504u)	/* Port 15 Output Modification Register */
#define P20_OMR	(*( P00_OMR_type *) 0xf003c004u)	/* Port 20 Output Modification Register */
#define P21_OMR	(*( P00_OMR_type *) 0xf003c104u)	/* Port 21 Output Modification Register */
#define P22_OMR	(*( P00_OMR_type *) 0xf003c204u)	/* Port 22 Output Modification Register */
#define P23_OMR	(*( P00_OMR_type *) 0xf003c304u)	/* Port 23 Output Modification Register */
#define P32_OMR	(*( P00_OMR_type *) 0xf003d204u)	/* Port 32 Output Modification Register */
#define P33_OMR	(*( P00_OMR_type *) 0xf003d304u)	/* Port 33 Output Modification Register */
#define P34_OMR	(*( P00_OMR_type *) 0xf003d404u)	/* Port 34 Output Modification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PS0            : 1;	/* Port n Set Bit x */
		unsigned int PS1            : 1;	/* Port n Set Bit x */
		unsigned int PS2            : 1;	/* Port n Set Bit x */
		unsigned int PS3            : 1;	/* Port n Set Bit x */
		unsigned int PS4            : 1;	/* Port n Set Bit x */
		unsigned int PS5            : 1;	/* Port n Set Bit x */
		unsigned int PS6            : 1;	/* Port n Set Bit x */
		unsigned int PS7            : 1;	/* Port n Set Bit x */
		unsigned int PS8            : 1;	/* Port n Set Bit x */
		unsigned int PS9            : 1;	/* Port n Set Bit x */
		unsigned int PS10           : 1;	/* Port n Set Bit x */
		unsigned int PS11           : 1;	/* Port n Set Bit x */
		unsigned int PS12           : 1;	/* Port n Set Bit x */
		unsigned int PS13           : 1;	/* Port n Set Bit x */
		unsigned int PS14           : 1;	/* Port n Set Bit x */
		unsigned int PS15           : 1;	/* Port n Set Bit x */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} P00_OMSR_type;
#define P00_OMSR	(*( P00_OMSR_type *) 0xf003a090u)	/* Port 00 Output Modification Set Register */
#define P01_OMSR	(*( P00_OMSR_type *) 0xf003a190u)	/* Port 01 Output Modification Set Register */
#define P02_OMSR	(*( P00_OMSR_type *) 0xf003a290u)	/* Port 02 Output Modification Set Register */
#define P10_OMSR	(*( P00_OMSR_type *) 0xf003b090u)	/* Port 10 Output Modification Set Register */
#define P11_OMSR	(*( P00_OMSR_type *) 0xf003b190u)	/* Port 11 Output Modification Set Register */
#define P12_OMSR	(*( P00_OMSR_type *) 0xf003b290u)	/* Port 12 Output Modification Set Register */
#define P13_OMSR	(*( P00_OMSR_type *) 0xf003b390u)	/* Port 13 Output Modification Set Register */
#define P14_OMSR	(*( P00_OMSR_type *) 0xf003b490u)	/* Port 14 Output Modification Set Register */
#define P15_OMSR	(*( P00_OMSR_type *) 0xf003b590u)	/* Port 15 Output Modification Set Register */
#define P20_OMSR	(*( P00_OMSR_type *) 0xf003c090u)	/* Port 20 Output Modification Set Register */
#define P21_OMSR	(*( P00_OMSR_type *) 0xf003c190u)	/* Port 21 Output Modification Set Register */
#define P22_OMSR	(*( P00_OMSR_type *) 0xf003c290u)	/* Port 22 Output Modification Set Register */
#define P23_OMSR	(*( P00_OMSR_type *) 0xf003c390u)	/* Port 23 Output Modification Set Register */
#define P32_OMSR	(*( P00_OMSR_type *) 0xf003d290u)	/* Port 32 Output Modification Set Register */
#define P33_OMSR	(*( P00_OMSR_type *) 0xf003d390u)	/* Port 33 Output Modification Set Register */
#define P34_OMSR	(*( P00_OMSR_type *) 0xf003d490u)	/* Port 34 Output Modification Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PS0            : 1;	/* Port n Set Bit x */
		unsigned int PS1            : 1;	/* Port n Set Bit x */
		unsigned int PS2            : 1;	/* Port n Set Bit x */
		unsigned int PS3            : 1;	/* Port n Set Bit x */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} P00_OMSR0_type;
#define P00_OMSR0	(*( P00_OMSR0_type *) 0xf003a070u)	/* Port 00 Output Modification Set Register 0 */
#define P01_OMSR0	(*( P00_OMSR0_type *) 0xf003a170u)	/* Port 01 Output Modification Set Register 0 */
#define P02_OMSR0	(*( P00_OMSR0_type *) 0xf003a270u)	/* Port 02 Output Modification Set Register 0 */
#define P10_OMSR0	(*( P00_OMSR0_type *) 0xf003b070u)	/* Port 10 Output Modification Set Register 0 */
#define P11_OMSR0	(*( P00_OMSR0_type *) 0xf003b170u)	/* Port 11 Output Modification Set Register 0 */
#define P12_OMSR0	(*( P00_OMSR0_type *) 0xf003b270u)	/* Port 12 Output Modification Set Register 0 */
#define P13_OMSR0	(*( P00_OMSR0_type *) 0xf003b370u)	/* Port 13 Output Modification Set Register 0 */
#define P14_OMSR0	(*( P00_OMSR0_type *) 0xf003b470u)	/* Port 14 Output Modification Set Register 0 */
#define P15_OMSR0	(*( P00_OMSR0_type *) 0xf003b570u)	/* Port 15 Output Modification Set Register 0 */
#define P20_OMSR0	(*( P00_OMSR0_type *) 0xf003c070u)	/* Port 20 Output Modification Set Register 0 */
#define P21_OMSR0	(*( P00_OMSR0_type *) 0xf003c170u)	/* Port 21 Output Modification Set Register 0 */
#define P22_OMSR0	(*( P00_OMSR0_type *) 0xf003c270u)	/* Port 22 Output Modification Set Register 0 */
#define P23_OMSR0	(*( P00_OMSR0_type *) 0xf003c370u)	/* Port 23 Output Modification Set Register 0 */
#define P32_OMSR0	(*( P00_OMSR0_type *) 0xf003d270u)	/* Port 32 Output Modification Set Register 0 */
#define P33_OMSR0	(*( P00_OMSR0_type *) 0xf003d370u)	/* Port 33 Output Modification Set Register 0 */
#define P34_OMSR0	(*( P00_OMSR0_type *) 0xf003d470u)	/* Port 34 Output Modification Set Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 12;
		unsigned int PS12           : 1;	/* Port n Set Bit x */
		unsigned int PS13           : 1;	/* Port n Set Bit x */
		unsigned int PS14           : 1;	/* Port n Set Bit x */
		unsigned int PS15           : 1;	/* Port n Set Bit x */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} P00_OMSR12_type;
#define P00_OMSR12	(*( P00_OMSR12_type *) 0xf003a07cu)	/* Port 00 Output Modification Set Register 12 */
#define P11_OMSR12	(*( P00_OMSR12_type *) 0xf003b17cu)	/* Port 11 Output Modification Set Register 12 */
#define P20_OMSR12	(*( P00_OMSR12_type *) 0xf003c07cu)	/* Port 20 Output Modification Set Register 12 */
#define P33_OMSR12	(*( P00_OMSR12_type *) 0xf003d37cu)	/* Port 33 Output Modification Set Register 12 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int PS4            : 1;	/* Port n Set Bit x */
		unsigned int PS5            : 1;	/* Port n Set Bit x */
		unsigned int PS6            : 1;	/* Port n Set Bit x */
		unsigned int PS7            : 1;	/* Port n Set Bit x */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} P00_OMSR4_type;
#define P00_OMSR4	(*( P00_OMSR4_type *) 0xf003a074u)	/* Port 00 Output Modification Set Register 4 */
#define P01_OMSR4	(*( P00_OMSR4_type *) 0xf003a174u)	/* Port 01 Output Modification Set Register 4 */
#define P02_OMSR4	(*( P00_OMSR4_type *) 0xf003a274u)	/* Port 02 Output Modification Set Register 4 */
#define P10_OMSR4	(*( P00_OMSR4_type *) 0xf003b074u)	/* Port 10 Output Modification Set Register 4 */
#define P11_OMSR4	(*( P00_OMSR4_type *) 0xf003b174u)	/* Port 11 Output Modification Set Register 4 */
#define P14_OMSR4	(*( P00_OMSR4_type *) 0xf003b474u)	/* Port 14 Output Modification Set Register 4 */
#define P15_OMSR4	(*( P00_OMSR4_type *) 0xf003b574u)	/* Port 15 Output Modification Set Register 4 */
#define P20_OMSR4	(*( P00_OMSR4_type *) 0xf003c074u)	/* Port 20 Output Modification Set Register 4 */
#define P21_OMSR4	(*( P00_OMSR4_type *) 0xf003c174u)	/* Port 21 Output Modification Set Register 4 */
#define P22_OMSR4	(*( P00_OMSR4_type *) 0xf003c274u)	/* Port 22 Output Modification Set Register 4 */
#define P23_OMSR4	(*( P00_OMSR4_type *) 0xf003c374u)	/* Port 23 Output Modification Set Register 4 */
#define P32_OMSR4	(*( P00_OMSR4_type *) 0xf003d274u)	/* Port 32 Output Modification Set Register 4 */
#define P33_OMSR4	(*( P00_OMSR4_type *) 0xf003d374u)	/* Port 33 Output Modification Set Register 4 */
#define P34_OMSR4	(*( P00_OMSR4_type *) 0xf003d474u)	/* Port 34 Output Modification Set Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 8;
		unsigned int PS8            : 1;	/* Port n Set Bit x */
		unsigned int PS9            : 1;	/* Port n Set Bit x */
		unsigned int PS10           : 1;	/* Port n Set Bit x */
		unsigned int PS11           : 1;	/* Port n Set Bit x */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} P00_OMSR8_type;
#define P00_OMSR8	(*( P00_OMSR8_type *) 0xf003a078u)	/* Port 00 Output Modification Set Register 8 */
#define P02_OMSR8	(*( P00_OMSR8_type *) 0xf003a278u)	/* Port 02 Output Modification Set Register 8 */
#define P10_OMSR8	(*( P00_OMSR8_type *) 0xf003b078u)	/* Port 10 Output Modification Set Register 8 */
#define P11_OMSR8	(*( P00_OMSR8_type *) 0xf003b178u)	/* Port 11 Output Modification Set Register 8 */
#define P14_OMSR8	(*( P00_OMSR8_type *) 0xf003b478u)	/* Port 14 Output Modification Set Register 8 */
#define P15_OMSR8	(*( P00_OMSR8_type *) 0xf003b578u)	/* Port 15 Output Modification Set Register 8 */
#define P20_OMSR8	(*( P00_OMSR8_type *) 0xf003c078u)	/* Port 20 Output Modification Set Register 8 */
#define P22_OMSR8	(*( P00_OMSR8_type *) 0xf003c278u)	/* Port 22 Output Modification Set Register 8 */
#define P33_OMSR8	(*( P00_OMSR8_type *) 0xf003d378u)	/* Port 33 Output Modification Set Register 8 */

typedef volatile union
{
	struct
	{ 
		unsigned int P0             : 1;	/* Port n Output Bit x */
		unsigned int P1             : 1;	/* Port n Output Bit x */
		unsigned int P2             : 1;	/* Port n Output Bit x */
		unsigned int P3             : 1;	/* Port n Output Bit x */
		unsigned int P4             : 1;	/* Port n Output Bit x */
		unsigned int P5             : 1;	/* Port n Output Bit x */
		unsigned int P6             : 1;	/* Port n Output Bit x */
		unsigned int P7             : 1;	/* Port n Output Bit x */
		unsigned int P8             : 1;	/* Port n Output Bit x */
		unsigned int P9             : 1;	/* Port n Output Bit x */
		unsigned int P10            : 1;	/* Port n Output Bit x */
		unsigned int P11            : 1;	/* Port n Output Bit x */
		unsigned int P12            : 1;	/* Port n Output Bit x */
		unsigned int P13            : 1;	/* Port n Output Bit x */
		unsigned int P14            : 1;	/* Port n Output Bit x */
		unsigned int P15            : 1;	/* Port n Output Bit x */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} P00_OUT_type;
#define P00_OUT	(*( P00_OUT_type *) 0xf003a000u)	/* Port 00 Output Register */
#define P01_OUT	(*( P00_OUT_type *) 0xf003a100u)	/* Port 01 Output Register */
#define P02_OUT	(*( P00_OUT_type *) 0xf003a200u)	/* Port 02 Output Register */
#define P10_OUT	(*( P00_OUT_type *) 0xf003b000u)	/* Port 10 Output Register */
#define P11_OUT	(*( P00_OUT_type *) 0xf003b100u)	/* Port 11 Output Register */
#define P12_OUT	(*( P00_OUT_type *) 0xf003b200u)	/* Port 12 Output Register */
#define P13_OUT	(*( P00_OUT_type *) 0xf003b300u)	/* Port 13 Output Register */
#define P14_OUT	(*( P00_OUT_type *) 0xf003b400u)	/* Port 14 Output Register */
#define P15_OUT	(*( P00_OUT_type *) 0xf003b500u)	/* Port 15 Output Register */
#define P20_OUT	(*( P00_OUT_type *) 0xf003c000u)	/* Port 20 Output Register */
#define P21_OUT	(*( P00_OUT_type *) 0xf003c100u)	/* Port 21 Output Register */
#define P22_OUT	(*( P00_OUT_type *) 0xf003c200u)	/* Port 22 Output Register */
#define P23_OUT	(*( P00_OUT_type *) 0xf003c300u)	/* Port 23 Output Register */
#define P32_OUT	(*( P00_OUT_type *) 0xf003d200u)	/* Port 32 Output Register */
#define P33_OUT	(*( P00_OUT_type *) 0xf003d300u)	/* Port 33 Output Register */
#define P34_OUT	(*( P00_OUT_type *) 0xf003d400u)	/* Port 34 Output Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PD0            : 3;	/* Pad Driver Mode for Port n Pin 0 to 7 */
		unsigned int PL0            : 1;	/* Pad Level Selection for Port n Pin 0 to 7 */
		unsigned int PD1            : 3;	/* Pad Driver Mode for Port n Pin 0 to 7 */
		unsigned int PL1            : 1;	/* Pad Level Selection for Port n Pin 0 to 7 */
		unsigned int PD2            : 3;	/* Pad Driver Mode for Port n Pin 0 to 7 */
		unsigned int PL2            : 1;	/* Pad Level Selection for Port n Pin 0 to 7 */
		unsigned int PD3            : 3;	/* Pad Driver Mode for Port n Pin 0 to 7 */
		unsigned int PL3            : 1;	/* Pad Level Selection for Port n Pin 0 to 7 */
		unsigned int PD4            : 3;	/* Pad Driver Mode for Port n Pin 0 to 7 */
		unsigned int PL4            : 1;	/* Pad Level Selection for Port n Pin 0 to 7 */
		unsigned int PD5            : 3;	/* Pad Driver Mode for Port n Pin 0 to 7 */
		unsigned int PL5            : 1;	/* Pad Level Selection for Port n Pin 0 to 7 */
		unsigned int PD6            : 3;	/* Pad Driver Mode for Port n Pin 0 to 7 */
		unsigned int PL6            : 1;	/* Pad Level Selection for Port n Pin 0 to 7 */
		unsigned int PD7            : 3;	/* Pad Driver Mode for Port n Pin 0 to 7 */
		unsigned int PL7            : 1;	/* Pad Level Selection for Port n Pin 0 to 7 */
	} B;
	int I;
	unsigned int U;

} P00_PDR0_type;
#define P00_PDR0	(*( P00_PDR0_type *) 0xf003a040u)	/* Port 00 Pad Driver Mode 0 Register */
#define P02_PDR0	(*( P00_PDR0_type *) 0xf003a240u)	/* Port 02 Pad Driver Mode 0 Register */
#define P10_PDR0	(*( P00_PDR0_type *) 0xf003b040u)	/* Port 10 Pad Driver Mode 0 Register */
#define P11_PDR0	(*( P00_PDR0_type *) 0xf003b140u)	/* Port 11 Pad Driver Mode 0 Register */
#define P14_PDR0	(*( P00_PDR0_type *) 0xf003b440u)	/* Port 14 Pad Driver Mode 0 Register */
#define P15_PDR0	(*( P00_PDR0_type *) 0xf003b540u)	/* Port 15 Pad Driver Mode 0 Register */
#define P21_PDR0	(*( P00_PDR0_type *) 0xf003c140u)	/* Port 21 Pad Driver Mode 0 Register */
#define P22_PDR0	(*( P00_PDR0_type *) 0xf003c240u)	/* Port 22 Pad Driver Mode 0 Register */
#define P23_PDR0	(*( P00_PDR0_type *) 0xf003c340u)	/* Port 23 Pad Driver Mode 0 Register */
#define P32_PDR0	(*( P00_PDR0_type *) 0xf003d240u)	/* Port 32 Pad Driver Mode 0 Register */
#define P33_PDR0	(*( P00_PDR0_type *) 0xf003d340u)	/* Port 33 Pad Driver Mode 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PD8            : 3;	/* Pad Driver Mode for Port 00 Pin 8 to 12 */
		unsigned int PL8            : 1;	/* Pad Level Selection for Port 00 Pin 8 to 12 */
		unsigned int PD9            : 3;	/* Pad Driver Mode for Port 00 Pin 8 to 12 */
		unsigned int PL9            : 1;	/* Pad Level Selection for Port 00 Pin 8 to 12 */
		unsigned int PD10           : 3;	/* Pad Driver Mode for Port 00 Pin 8 to 12 */
		unsigned int PL10           : 1;	/* Pad Level Selection for Port 00 Pin 8 to 12 */
		unsigned int PD11           : 3;	/* Pad Driver Mode for Port 00 Pin 8 to 12 */
		unsigned int PL11           : 1;	/* Pad Level Selection for Port 00 Pin 8 to 12 */
		unsigned int PD12           : 3;	/* Pad Driver Mode for Port 00 Pin 8 to 12 */
		unsigned int PL12           : 1;	/* Pad Level Selection for Port 00 Pin 8 to 12 */
		unsigned int PD13           : 3;	/* Reserved */
		unsigned int PL13           : 1;	/* Reserved */
		unsigned int PD14           : 3;	/* Reserved */
		unsigned int PL14           : 1;	/* Reserved */
		unsigned int PD15           : 3;	/* Reserved */
		unsigned int PL15           : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P00_PDR1_type;
#define P00_PDR1	(*( P00_PDR1_type *) 0xf003a044u)	/* Port 00 Pad Driver Mode 1 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P01_ACCEN1_type;
#define P01_ACCEN1	(*( P01_ACCEN1_type *) 0xf003a1f8u)	/* Port 01 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC0            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC1            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC2            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC3            : 5;	/* Port Control for Port 01 Pin 3 */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC0            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC1            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC2            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC3            : 5;	/* Port Control for Port 01 Pin 3 */
	} B2;
	int I;
	unsigned int U;

} P01_IOCR0_type;
#define P01_IOCR0	(*( P01_IOCR0_type *) 0xf003a110u)	/* Port 01 Input/Output Control Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD0            : 3;	/* Reserved */
		unsigned int PL0            : 1;	/* Reserved */
		unsigned int PD1            : 3;	/* Reserved */
		unsigned int PL1            : 1;	/* Reserved */
		unsigned int PD2            : 3;	/* Reserved */
		unsigned int PL2            : 1;	/* Reserved */
		unsigned int PD3            : 3;	/* Pad Driver Mode for Port n Pin 3 to 7 */
		unsigned int PL3            : 1;	/* Pad Level Selection for Port n Pin 3 to 7 */
		unsigned int PD4            : 3;	/* Pad Driver Mode for Port n Pin 3 to 7 */
		unsigned int PL4            : 1;	/* Pad Level Selection for Port n Pin 3 to 7 */
		unsigned int PD5            : 3;	/* Pad Driver Mode for Port n Pin 3 to 7 */
		unsigned int PL5            : 1;	/* Pad Level Selection for Port n Pin 3 to 7 */
		unsigned int PD6            : 3;	/* Pad Driver Mode for Port n Pin 3 to 7 */
		unsigned int PL6            : 1;	/* Pad Level Selection for Port n Pin 3 to 7 */
		unsigned int PD7            : 3;	/* Pad Driver Mode for Port n Pin 3 to 7 */
		unsigned int PL7            : 1;	/* Pad Level Selection for Port n Pin 3 to 7 */
	} B;
	int I;
	unsigned int U;

} P01_PDR0_type;
#define P01_PDR0	(*( P01_PDR0_type *) 0xf003a140u)	/* Port 01 Pad Driver Mode 0 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P02_ACCEN1_type;
#define P02_ACCEN1	(*( P02_ACCEN1_type *) 0xf003a2f8u)	/* Port 02 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD8            : 3;	/* Pad Driver Mode for Port n Pin 8 to 11 */
		unsigned int PL8            : 1;	/* Pad Level Selection for Port n Pin 8 to 11 */
		unsigned int PD9            : 3;	/* Pad Driver Mode for Port n Pin 8 to 11 */
		unsigned int PL9            : 1;	/* Pad Level Selection for Port n Pin 8 to 11 */
		unsigned int PD10           : 3;	/* Pad Driver Mode for Port n Pin 8 to 11 */
		unsigned int PL10           : 1;	/* Pad Level Selection for Port n Pin 8 to 11 */
		unsigned int PD11           : 3;	/* Pad Driver Mode for Port n Pin 8 to 11 */
		unsigned int PL11           : 1;	/* Pad Level Selection for Port n Pin 8 to 11 */
		unsigned int PD12           : 3;	/* Reserved */
		unsigned int PL12           : 1;	/* Reserved */
		unsigned int PD13           : 3;	/* Reserved */
		unsigned int PL13           : 1;	/* Reserved */
		unsigned int PD14           : 3;	/* Reserved */
		unsigned int PL14           : 1;	/* Reserved */
		unsigned int PD15           : 3;	/* Reserved */
		unsigned int PL15           : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P02_PDR1_type;
#define P02_PDR1	(*( P02_PDR1_type *) 0xf003a244u)	/* Port 02 Pad Driver Mode 1 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P10_ACCEN1_type;
#define P10_ACCEN1	(*( P10_ACCEN1_type *) 0xf003b0f8u)	/* Port 10 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC8            : 5;	/* Port Control for Port 10 Pin 8 */
		unsigned int                : 3;
		unsigned int PC9            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC10           : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC11           : 5;	/* Reserved */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC8            : 5;	/* Port Control for Port 10 Pin 8 */
		unsigned int                : 3;
		unsigned int PC9            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC10           : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC11           : 5;	/* Reserved */
	} B2;
	int I;
	unsigned int U;

} P10_IOCR8_type;
#define P10_IOCR8	(*( P10_IOCR8_type *) 0xf003b018u)	/* Port 10 Input/Output Control Register 8 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD8            : 3;	/* Pad Driver Mode for Port 10 Pin 8 */
		unsigned int PL8            : 1;	/* Pad Level Selection for Port 10 Pin 8 */
		unsigned int PD9            : 3;	/* Reserved */
		unsigned int PL9            : 1;	/* Reserved */
		unsigned int PD10           : 3;	/* Reserved */
		unsigned int PL10           : 1;	/* Reserved */
		unsigned int PD11           : 3;	/* Reserved */
		unsigned int PL11           : 1;	/* Reserved */
		unsigned int PD12           : 3;	/* Reserved */
		unsigned int PL12           : 1;	/* Reserved */
		unsigned int PD13           : 3;	/* Reserved */
		unsigned int PL13           : 1;	/* Reserved */
		unsigned int PD14           : 3;	/* Reserved */
		unsigned int PL14           : 1;	/* Reserved */
		unsigned int PD15           : 3;	/* Reserved */
		unsigned int PL15           : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P10_PDR1_type;
#define P10_PDR1	(*( P10_PDR1_type *) 0xf003b044u)	/* Port 10 Pad Driver Mode 1 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P11_ACCEN1_type;
#define P11_ACCEN1	(*( P11_ACCEN1_type *) 0xf003b1f8u)	/* Port 11 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC12           : 5;	/* Port Control for Port n Pin 12 to 15 */
		unsigned int                : 3;
		unsigned int PC13           : 5;	/* Port Control for Port n Pin 12 to 15 */
		unsigned int                : 3;
		unsigned int PC14           : 5;	/* Port Control for Port n Pin 12 to 15 */
		unsigned int                : 3;
		unsigned int PC15           : 5;	/* Port Control for Port n Pin 12 to 15 */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC12           : 5;	/* Port Control for Port n Pin 12 to 15 */
		unsigned int                : 3;
		unsigned int PC13           : 5;	/* Port Control for Port n Pin 12 to 15 */
		unsigned int                : 3;
		unsigned int PC14           : 5;	/* Port Control for Port n Pin 12 to 15 */
		unsigned int                : 3;
		unsigned int PC15           : 5;	/* Port Control for Port n Pin 12 to 15 */
	} B2;
	int I;
	unsigned int U;

} P11_IOCR12_type;
#define P11_IOCR12	(*( P11_IOCR12_type *) 0xf003b11cu)	/* Port 11 Input/Output Control Register 12 */
#define P33_IOCR12	(*( P11_IOCR12_type *) 0xf003d31cu)	/* Port 33 Input/Output Control Register 12 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD8            : 3;	/* Pad Driver Mode for Port n Pin 8 to 15 */
		unsigned int PL8            : 1;	/* Pad Level Selection for Port n Pin 8 to 15 */
		unsigned int PD9            : 3;	/* Pad Driver Mode for Port n Pin 8 to 15 */
		unsigned int PL9            : 1;	/* Pad Level Selection for Port n Pin 8 to 15 */
		unsigned int PD10           : 3;	/* Pad Driver Mode for Port n Pin 8 to 15 */
		unsigned int PL10           : 1;	/* Pad Level Selection for Port n Pin 8 to 15 */
		unsigned int PD11           : 3;	/* Pad Driver Mode for Port n Pin 8 to 15 */
		unsigned int PL11           : 1;	/* Pad Level Selection for Port n Pin 8 to 15 */
		unsigned int PD12           : 3;	/* Pad Driver Mode for Port n Pin 8 to 15 */
		unsigned int PL12           : 1;	/* Pad Level Selection for Port n Pin 8 to 15 */
		unsigned int PD13           : 3;	/* Pad Driver Mode for Port n Pin 8 to 15 */
		unsigned int PL13           : 1;	/* Pad Level Selection for Port n Pin 8 to 15 */
		unsigned int PD14           : 3;	/* Pad Driver Mode for Port n Pin 8 to 15 */
		unsigned int PL14           : 1;	/* Pad Level Selection for Port n Pin 8 to 15 */
		unsigned int PD15           : 3;	/* Pad Driver Mode for Port n Pin 8 to 15 */
		unsigned int PL15           : 1;	/* Pad Level Selection for Port n Pin 8 to 15 */
	} B;
	int I;
	unsigned int U;

} P11_PDR1_type;
#define P11_PDR1	(*( P11_PDR1_type *) 0xf003b144u)	/* Port 11 Pad Driver Mode 1 Register */
#define P33_PDR1	(*( P11_PDR1_type *) 0xf003d344u)	/* Port 33 Pad Driver Mode 1 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P12_ACCEN1_type;
#define P12_ACCEN1	(*( P12_ACCEN1_type *) 0xf003b2f8u)	/* Port 12 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC0            : 5;	/* Port Control for Port 12 Pin 0 to 1 */
		unsigned int                : 3;
		unsigned int PC1            : 5;	/* Port Control for Port 12 Pin 0 to 1 */
		unsigned int                : 3;
		unsigned int PC2            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC3            : 5;	/* Reserved */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC0            : 5;	/* Port Control for Port 12 Pin 0 to 1 */
		unsigned int                : 3;
		unsigned int PC1            : 5;	/* Port Control for Port 12 Pin 0 to 1 */
		unsigned int                : 3;
		unsigned int PC2            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC3            : 5;	/* Reserved */
	} B2;
	int I;
	unsigned int U;

} P12_IOCR0_type;
#define P12_IOCR0	(*( P12_IOCR0_type *) 0xf003b210u)	/* Port 12 Input/Output Control Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD0            : 3;	/* Pad Driver Mode for Port 12 Pin 0 to 1 */
		unsigned int PL0            : 1;	/* Pad Level Selection for Port 12 Pin 0 to 1 */
		unsigned int PD1            : 3;	/* Pad Driver Mode for Port 12 Pin 0 to 1 */
		unsigned int PL1            : 1;	/* Pad Level Selection for Port 12 Pin 0 to 1 */
		unsigned int PD2            : 3;	/* Reserved */
		unsigned int PL2            : 1;	/* Reserved */
		unsigned int PD3            : 3;	/* Reserved */
		unsigned int PL3            : 1;	/* Reserved */
		unsigned int PD4            : 3;	/* Reserved */
		unsigned int PL4            : 1;	/* Reserved */
		unsigned int PD5            : 3;	/* Reserved */
		unsigned int PL5            : 1;	/* Reserved */
		unsigned int PD6            : 3;	/* Reserved */
		unsigned int PL6            : 1;	/* Reserved */
		unsigned int PD7            : 3;	/* Reserved */
		unsigned int PL7            : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P12_PDR0_type;
#define P12_PDR0	(*( P12_PDR0_type *) 0xf003b240u)	/* Port 12 Pad Driver Mode 0 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P13_ACCEN1_type;
#define P13_ACCEN1	(*( P13_ACCEN1_type *) 0xf003b3f8u)	/* Port 13 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD0            : 3;	/* Pad Driver Mode for Port 13 Pin [1:0] */
		unsigned int PL0            : 1;	/* Pad Level Selection for Port 13 Pin 0 to 3 */
		unsigned int PD1            : 3;	/* Pad Driver Mode for Port 13 Pin 1 and 3 */
		unsigned int PL1            : 1;	/* Pad Level Selection for Port 13 Pin 0 to 3 */
		unsigned int PD2            : 3;	/* Pad Driver Mode for Port 13 Pin [3:2] */
		unsigned int PL2            : 1;	/* Pad Level Selection for Port 13 Pin 0 to 3 */
		unsigned int PD3            : 3;	/* Pad Driver Mode for Port 13 Pin 1 and 3 */
		unsigned int PL3            : 1;	/* Pad Level Selection for Port 13 Pin 0 to 3 */
		unsigned int PD4            : 3;	/* Reserved */
		unsigned int PL4            : 1;	/* Reserved */
		unsigned int PD5            : 3;	/* Reserved */
		unsigned int PL5            : 1;	/* Reserved */
		unsigned int PD6            : 3;	/* Reserved */
		unsigned int PL6            : 1;	/* Reserved */
		unsigned int PD7            : 3;	/* Reserved */
		unsigned int PL7            : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P13_PDR0_type;
#define P13_PDR0	(*( P13_PDR0_type *) 0xf003b340u)	/* Port 13 Pad Driver Mode 0 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P14_ACCEN1_type;
#define P14_ACCEN1	(*( P14_ACCEN1_type *) 0xf003b4f8u)	/* Port 14 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC8            : 5;	/* Port Control for Port 14 Pin 8 to 10 */
		unsigned int                : 3;
		unsigned int PC9            : 5;	/* Port Control for Port 14 Pin 8 to 10 */
		unsigned int                : 3;
		unsigned int PC10           : 5;	/* Port Control for Port 14 Pin 8 to 10 */
		unsigned int                : 3;
		unsigned int PC11           : 5;	/* Reserved */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC8            : 5;	/* Port Control for Port 14 Pin 8 to 10 */
		unsigned int                : 3;
		unsigned int PC9            : 5;	/* Port Control for Port 14 Pin 8 to 10 */
		unsigned int                : 3;
		unsigned int PC10           : 5;	/* Port Control for Port 14 Pin 8 to 10 */
		unsigned int                : 3;
		unsigned int PC11           : 5;	/* Reserved */
	} B2;
	int I;
	unsigned int U;

} P14_IOCR8_type;
#define P14_IOCR8	(*( P14_IOCR8_type *) 0xf003b418u)	/* Port 14 Input/Output Control Register 8 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD8            : 3;	/* Pad Driver Mode for Port 14 Pin 8 to 10 */
		unsigned int PL8            : 1;	/* Pad Level Selection for Port 14 Pin 8 to 10 */
		unsigned int PD9            : 3;	/* Pad Driver Mode for Port 14 Pin 8 to 10 */
		unsigned int PL9            : 1;	/* Pad Level Selection for Port 14 Pin 8 to 10 */
		unsigned int PD10           : 3;	/* Pad Driver Mode for Port 14 Pin 8 to 10 */
		unsigned int PL10           : 1;	/* Pad Level Selection for Port 14 Pin 8 to 10 */
		unsigned int PD11           : 3;	/* Reserved */
		unsigned int PL11           : 1;	/* Reserved */
		unsigned int PD12           : 3;	/* Reserved */
		unsigned int PL12           : 1;	/* Reserved */
		unsigned int PD13           : 3;	/* Reserved */
		unsigned int PL13           : 1;	/* Reserved */
		unsigned int PD14           : 3;	/* Reserved */
		unsigned int PL14           : 1;	/* Reserved */
		unsigned int PD15           : 3;	/* Reserved */
		unsigned int PL15           : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P14_PDR1_type;
#define P14_PDR1	(*( P14_PDR1_type *) 0xf003b444u)	/* Port 14 Pad Driver Mode 1 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P15_ACCEN1_type;
#define P15_ACCEN1	(*( P15_ACCEN1_type *) 0xf003b5f8u)	/* Port 15 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC8            : 5;	/* Port Control for Port 15 Pin 8 */
		unsigned int                : 3;
		unsigned int PC9            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC10           : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC11           : 5;	/* Reserved */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC8            : 5;	/* Port Control for Port 15 Pin 8 */
		unsigned int                : 3;
		unsigned int PC9            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC10           : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC11           : 5;	/* Reserved */
	} B2;
	int I;
	unsigned int U;

} P15_IOCR8_type;
#define P15_IOCR8	(*( P15_IOCR8_type *) 0xf003b518u)	/* Port 15 Input/Output Control Register 8 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD8            : 3;	/* Pad Driver Mode for Port 15 Pin 8 */
		unsigned int PL8            : 1;	/* Pad Level Selection for Port 15 Pin 8 */
		unsigned int PD9            : 3;	/* Reserved */
		unsigned int PL9            : 1;	/* Reserved */
		unsigned int PD10           : 3;	/* Reserved */
		unsigned int PL10           : 1;	/* Reserved */
		unsigned int PD11           : 3;	/* Reserved */
		unsigned int PL11           : 1;	/* Reserved */
		unsigned int PD12           : 3;	/* Reserved */
		unsigned int PL12           : 1;	/* Reserved */
		unsigned int PD13           : 3;	/* Reserved */
		unsigned int PL13           : 1;	/* Reserved */
		unsigned int PD14           : 3;	/* Reserved */
		unsigned int PL14           : 1;	/* Reserved */
		unsigned int PD15           : 3;	/* Reserved */
		unsigned int PL15           : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P15_PDR1_type;
#define P15_PDR1	(*( P15_PDR1_type *) 0xf003b544u)	/* Port 15 Pad Driver Mode 1 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P20_ACCEN1_type;
#define P20_ACCEN1	(*( P20_ACCEN1_type *) 0xf003c0f8u)	/* Port 20 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC12           : 5;	/* Port Control for Port 20 Pin 12 to 14 */
		unsigned int                : 3;
		unsigned int PC13           : 5;	/* Port Control for Port 20 Pin 12 to 14 */
		unsigned int                : 3;
		unsigned int PC14           : 5;	/* Port Control for Port 20 Pin 12 to 14 */
		unsigned int                : 3;
		unsigned int PC15           : 5;	/* Reserved */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC12           : 5;	/* Port Control for Port 20 Pin 12 to 14 */
		unsigned int                : 3;
		unsigned int PC13           : 5;	/* Port Control for Port 20 Pin 12 to 14 */
		unsigned int                : 3;
		unsigned int PC14           : 5;	/* Port Control for Port 20 Pin 12 to 14 */
		unsigned int                : 3;
		unsigned int PC15           : 5;	/* Reserved */
	} B2;
	int I;
	unsigned int U;

} P20_IOCR12_type;
#define P20_IOCR12	(*( P20_IOCR12_type *) 0xf003c01cu)	/* Port 20 Input/Output Control Register 12 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC4            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC5            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC6            : 5;	/* Port Control for Port 20 Pin 6 to 7 */
		unsigned int                : 3;
		unsigned int PC7            : 5;	/* Port Control for Port 20 Pin 6 to 7 */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC4            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC5            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC6            : 5;	/* Port Control for Port 20 Pin 6 to 7 */
		unsigned int                : 3;
		unsigned int PC7            : 5;	/* Port Control for Port 20 Pin 6 to 7 */
	} B2;
	int I;
	unsigned int U;

} P20_IOCR4_type;
#define P20_IOCR4	(*( P20_IOCR4_type *) 0xf003c014u)	/* Port 20 Input/Output Control Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD0            : 3;	/* Pad Driver Mode for Port 20 Pin 0 to 7 */
		unsigned int PL0            : 1;	/* Pad Level Selection for Port 20 Pin 0 to 7 */
		unsigned int PD1            : 3;	/* Pad Driver Mode for Port 20 Pin 0 to 7 */
		unsigned int PL1            : 1;	/* Pad Level Selection for Port 20 Pin 0 to 7 */
		unsigned int PD2            : 3;	/* Pad Driver Mode for Port 20 Pin 0 to 7 */
		unsigned int PL2            : 1;	/* Pad Level Selection for Port 20 Pin 0 to 7 */
		unsigned int PD3            : 3;	/* Pad Driver Mode for Port 20 Pin 0 to 7 */
		unsigned int PL3            : 1;	/* Pad Level Selection for Port 20 Pin 0 to 7 */
		unsigned int PD4            : 3;	/* Reserved */
		unsigned int PL4            : 1;	/* Reserved */
		unsigned int PD5            : 3;	/* Reserved */
		unsigned int PL5            : 1;	/* Reserved */
		unsigned int PD6            : 3;	/* Pad Driver Mode for Port 20 Pin 0 to 7 */
		unsigned int PL6            : 1;	/* Pad Level Selection for Port 20 Pin 0 to 7 */
		unsigned int PD7            : 3;	/* Pad Driver Mode for Port 20 Pin 0 to 7 */
		unsigned int PL7            : 1;	/* Pad Level Selection for Port 20 Pin 0 to 7 */
	} B;
	int I;
	unsigned int U;

} P20_PDR0_type;
#define P20_PDR0	(*( P20_PDR0_type *) 0xf003c040u)	/* Port 20 Pad Driver Mode 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PD8            : 3;	/* Pad Driver Mode for Port 20 Pin 8 to 14 */
		unsigned int PL8            : 1;	/* Pad Level Selection for Port 20 Pin 8 to 14 */
		unsigned int PD9            : 3;	/* Pad Driver Mode for Port 20 Pin 8 to 14 */
		unsigned int PL9            : 1;	/* Pad Level Selection for Port 20 Pin 8 to 14 */
		unsigned int PD10           : 3;	/* Pad Driver Mode for Port 20 Pin 8 to 14 */
		unsigned int PL10           : 1;	/* Pad Level Selection for Port 20 Pin 8 to 14 */
		unsigned int PD11           : 3;	/* Pad Driver Mode for Port 20 Pin 8 to 14 */
		unsigned int PL11           : 1;	/* Pad Level Selection for Port 20 Pin 8 to 14 */
		unsigned int PD12           : 3;	/* Pad Driver Mode for Port 20 Pin 8 to 14 */
		unsigned int PL12           : 1;	/* Pad Level Selection for Port 20 Pin 8 to 14 */
		unsigned int PD13           : 3;	/* Pad Driver Mode for Port 20 Pin 8 to 14 */
		unsigned int PL13           : 1;	/* Pad Level Selection for Port 20 Pin 8 to 14 */
		unsigned int PD14           : 3;	/* Pad Driver Mode for Port 20 Pin 8 to 14 */
		unsigned int PL14           : 1;	/* Pad Level Selection for Port 20 Pin 8 to 14 */
		unsigned int PD15           : 3;	/* Reserved */
		unsigned int PL15           : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P20_PDR1_type;
#define P20_PDR1	(*( P20_PDR1_type *) 0xf003c044u)	/* Port 20 Pad Driver Mode 1 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P21_ACCEN1_type;
#define P21_ACCEN1	(*( P21_ACCEN1_type *) 0xf003c1f8u)	/* Port 21 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P22_ACCEN1_type;
#define P22_ACCEN1	(*( P22_ACCEN1_type *) 0xf003c2f8u)	/* Port 22 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD8            : 3;	/* Pad Driver Mode for Port 22 Pin 8 to 11 */
		unsigned int PL8            : 1;	/* Pad Level Selection for Port 22 Pin 8 to 11 */
		unsigned int PD9            : 3;	/* Pad Driver Mode for Port 22 Pin 8 to 11 */
		unsigned int PL9            : 1;	/* Pad Level Selection for Port 22 Pin 8 to 11 */
		unsigned int PD10           : 3;	/* Pad Driver Mode for Port 22 Pin 8 to 11 */
		unsigned int PL10           : 1;	/* Pad Level Selection for Port 22 Pin 8 to 11 */
		unsigned int PD11           : 3;	/* Pad Driver Mode for Port 22 Pin 8 to 11 */
		unsigned int PL11           : 1;	/* Pad Level Selection for Port 22 Pin 8 to 11 */
		unsigned int PD12           : 3;	/* Reserved */
		unsigned int PL12           : 1;	/* Reserved */
		unsigned int PD13           : 3;	/* Reserved */
		unsigned int PL13           : 1;	/* Reserved */
		unsigned int PD14           : 3;	/* Reserved */
		unsigned int PL14           : 1;	/* Reserved */
		unsigned int PD15           : 3;	/* Reserved */
		unsigned int PL15           : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P22_PDR1_type;
#define P22_PDR1	(*( P22_PDR1_type *) 0xf003c244u)	/* Port 22 Pad Driver Mode 1 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P23_ACCEN1_type;
#define P23_ACCEN1	(*( P23_ACCEN1_type *) 0xf003c3f8u)	/* Port 23 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P32_ACCEN1_type;
#define P32_ACCEN1	(*( P32_ACCEN1_type *) 0xf003d2f8u)	/* Port 32 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC0            : 5;	/* Port Control for Port n Pin 0, Pin 2 to 3 */
		unsigned int                : 3;
		unsigned int PC1            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC2            : 5;	/* Port Control for Port n Pin 0, Pin 2 to 3 */
		unsigned int                : 3;
		unsigned int PC3            : 5;	/* Port Control for Port n Pin 0, Pin 2 to 3 */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC0            : 5;	/* Port Control for Port n Pin 0, Pin 2 to 3 */
		unsigned int                : 3;
		unsigned int PC1            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC2            : 5;	/* Port Control for Port n Pin 0, Pin 2 to 3 */
		unsigned int                : 3;
		unsigned int PC3            : 5;	/* Port Control for Port n Pin 0, Pin 2 to 3 */
	} B2;
	int I;
	unsigned int U;

} P32_IOCR0_type;
#define P32_IOCR0	(*( P32_IOCR0_type *) 0xf003d210u)	/* Port 32 Input/Output Control Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P33_ACCEN1_type;
#define P33_ACCEN1	(*( P33_ACCEN1_type *) 0xf003d3f8u)	/* Port 33 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P34_ACCEN1_type;
#define P34_ACCEN1	(*( P34_ACCEN1_type *) 0xf003d4f8u)	/* Port 34 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC4            : 5;	/* Port Control for Port 34 Pin 4 to 5 */
		unsigned int                : 3;
		unsigned int PC5            : 5;	/* Port Control for Port 34 Pin 4 to 5 */
		unsigned int                : 3;
		unsigned int PC6            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC7            : 5;	/* Reserved */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC4            : 5;	/* Port Control for Port 34 Pin 4 to 5 */
		unsigned int                : 3;
		unsigned int PC5            : 5;	/* Port Control for Port 34 Pin 4 to 5 */
		unsigned int                : 3;
		unsigned int PC6            : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC7            : 5;	/* Reserved */
	} B2;
	int I;
	unsigned int U;

} P34_IOCR4_type;
#define P34_IOCR4	(*( P34_IOCR4_type *) 0xf003d414u)	/* Port 34 Input/Output Control Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int PD0            : 3;	/* Pad Driver Mode for Port 34 Pin 0 to 5 */
		unsigned int PL0            : 1;	/* Pad Level Selection for Port 34 Pin 0 to 5 */
		unsigned int PD1            : 3;	/* Pad Driver Mode for Port 34 Pin 0 to 5 */
		unsigned int PL1            : 1;	/* Pad Level Selection for Port 34 Pin 0 to 5 */
		unsigned int PD2            : 3;	/* Pad Driver Mode for Port 34 Pin 0 to 5 */
		unsigned int PL2            : 1;	/* Pad Level Selection for Port 34 Pin 0 to 5 */
		unsigned int PD3            : 3;	/* Pad Driver Mode for Port 34 Pin 0 to 5 */
		unsigned int PL3            : 1;	/* Pad Level Selection for Port 34 Pin 0 to 5 */
		unsigned int PD4            : 3;	/* Pad Driver Mode for Port 34 Pin 0 to 5 */
		unsigned int PL4            : 1;	/* Pad Level Selection for Port 34 Pin 0 to 5 */
		unsigned int PD5            : 3;	/* Pad Driver Mode for Port 34 Pin 0 to 5 */
		unsigned int PL5            : 1;	/* Pad Level Selection for Port 34 Pin 0 to 5 */
		unsigned int PD6            : 3;	/* Reserved */
		unsigned int PL6            : 1;	/* Reserved */
		unsigned int PD7            : 3;	/* Reserved */
		unsigned int PL7            : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P34_PDR0_type;
#define P34_PDR0	(*( P34_PDR0_type *) 0xf003d440u)	/* Port 34 Pad Driver Mode 0 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P40_ACCEN1_type;
#define P40_ACCEN1	(*( P40_ACCEN1_type *) 0xf003e0f8u)	/* Port 40 Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC8            : 5;	/* Port Control for Port 40 Pin 8 to 9 */
		unsigned int                : 3;
		unsigned int PC9            : 5;	/* Port Control for Port 40 Pin 8 to 9 */
		unsigned int                : 3;
		unsigned int PC10           : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC11           : 5;	/* Reserved */
	} B1;
	struct
	{ 
		unsigned int                : 3;
		unsigned int PC8            : 5;	/* Port Control for Port 40 Pin 8 to 9 */
		unsigned int                : 3;
		unsigned int PC9            : 5;	/* Port Control for Port 40 Pin 8 to 9 */
		unsigned int                : 3;
		unsigned int PC10           : 5;	/* Reserved */
		unsigned int                : 3;
		unsigned int PC11           : 5;	/* Reserved */
	} B2;
	int I;
	unsigned int U;

} P40_IOCR8_type;
#define P40_IOCR8	(*( P40_IOCR8_type *) 0xf003e018u)	/* Port 40 Input/Output Control Register 8 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 16;
		unsigned int PCL0           : 1;	/* Reserved */
		unsigned int PCL1           : 1;	/* Reserved */
		unsigned int PCL2           : 1;	/* Reserved */
		unsigned int PCL3           : 1;	/* Reserved */
		unsigned int PCL4           : 1;	/* Reserved */
		unsigned int PCL5           : 1;	/* Reserved */
		unsigned int PCL6           : 1;	/* Reserved */
		unsigned int PCL7           : 1;	/* Reserved */
		unsigned int PCL8           : 1;	/* Reserved */
		unsigned int PCL9           : 1;	/* Reserved */
		unsigned int PCL10          : 1;	/* Reserved */
		unsigned int PCL11          : 1;	/* Reserved */
		unsigned int PCL12          : 1;	/* Reserved */
		unsigned int PCL13          : 1;	/* Reserved */
		unsigned int PCL14          : 1;	/* Reserved */
		unsigned int PCL15          : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P40_OMCR_type;
#define P40_OMCR	(*( P40_OMCR_type *) 0xf003e094u)	/* Port 40 Output Modification Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 16;
		unsigned int PCL0           : 1;	/* Reserved */
		unsigned int PCL1           : 1;	/* Reserved */
		unsigned int PCL2           : 1;	/* Reserved */
		unsigned int PCL3           : 1;	/* Reserved */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} P40_OMCR0_type;
#define P40_OMCR0	(*( P40_OMCR0_type *) 0xf003e080u)	/* Port 40 Output Modification Clear Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 20;
		unsigned int PCL4           : 1;	/* Reserved */
		unsigned int PCL5           : 1;	/* Reserved */
		unsigned int PCL6           : 1;	/* Reserved */
		unsigned int PCL7           : 1;	/* Reserved */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} P40_OMCR4_type;
#define P40_OMCR4	(*( P40_OMCR4_type *) 0xf003e084u)	/* Port 40 Output Modification Clear Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int PCL8           : 1;	/* Reserved */
		unsigned int PCL9           : 1;	/* Reserved */
		unsigned int PCL10          : 1;	/* Reserved */
		unsigned int PCL11          : 1;	/* Reserved */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} P40_OMCR8_type;
#define P40_OMCR8	(*( P40_OMCR8_type *) 0xf003e088u)	/* Port 40 Output Modification Clear Register 8 */

typedef volatile union
{
	struct
	{ 
		unsigned int PS0            : 1;	/* Reserved */
		unsigned int PS1            : 1;	/* Reserved */
		unsigned int PS2            : 1;	/* Reserved */
		unsigned int PS3            : 1;	/* Reserved */
		unsigned int PS4            : 1;	/* Reserved */
		unsigned int PS5            : 1;	/* Reserved */
		unsigned int PS6            : 1;	/* Reserved */
		unsigned int PS7            : 1;	/* Reserved */
		unsigned int PS8            : 1;	/* Reserved */
		unsigned int PS9            : 1;	/* Reserved */
		unsigned int PS10           : 1;	/* Reserved */
		unsigned int PS11           : 1;	/* Reserved */
		unsigned int PS12           : 1;	/* Reserved */
		unsigned int PS13           : 1;	/* Reserved */
		unsigned int PS14           : 1;	/* Reserved */
		unsigned int PS15           : 1;	/* Reserved */
		unsigned int PCL0           : 1;	/* Reserved */
		unsigned int PCL1           : 1;	/* Reserved */
		unsigned int PCL2           : 1;	/* Reserved */
		unsigned int PCL3           : 1;	/* Reserved */
		unsigned int PCL4           : 1;	/* Reserved */
		unsigned int PCL5           : 1;	/* Reserved */
		unsigned int PCL6           : 1;	/* Reserved */
		unsigned int PCL7           : 1;	/* Reserved */
		unsigned int PCL8           : 1;	/* Reserved */
		unsigned int PCL9           : 1;	/* Reserved */
		unsigned int PCL10          : 1;	/* Reserved */
		unsigned int PCL11          : 1;	/* Reserved */
		unsigned int PCL12          : 1;	/* Reserved */
		unsigned int PCL13          : 1;	/* Reserved */
		unsigned int PCL14          : 1;	/* Reserved */
		unsigned int PCL15          : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P40_OMR_type;
#define P40_OMR	(*( P40_OMR_type *) 0xf003e004u)	/* Port 40 Output Modification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PS0            : 1;	/* Reserved */
		unsigned int PS1            : 1;	/* Reserved */
		unsigned int PS2            : 1;	/* Reserved */
		unsigned int PS3            : 1;	/* Reserved */
		unsigned int PS4            : 1;	/* Reserved */
		unsigned int PS5            : 1;	/* Reserved */
		unsigned int PS6            : 1;	/* Reserved */
		unsigned int PS7            : 1;	/* Reserved */
		unsigned int PS8            : 1;	/* Reserved */
		unsigned int PS9            : 1;	/* Reserved */
		unsigned int PS10           : 1;	/* Reserved */
		unsigned int PS11           : 1;	/* Reserved */
		unsigned int PS12           : 1;	/* Reserved */
		unsigned int PS13           : 1;	/* Reserved */
		unsigned int PS14           : 1;	/* Reserved */
		unsigned int PS15           : 1;	/* Reserved */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} P40_OMSR_type;
#define P40_OMSR	(*( P40_OMSR_type *) 0xf003e090u)	/* Port 40 Output Modification Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PS0            : 1;	/* Reserved */
		unsigned int PS1            : 1;	/* Reserved */
		unsigned int PS2            : 1;	/* Reserved */
		unsigned int PS3            : 1;	/* Reserved */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} P40_OMSR0_type;
#define P40_OMSR0	(*( P40_OMSR0_type *) 0xf003e070u)	/* Port 40 Output Modification Set Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int PS4            : 1;	/* Reserved */
		unsigned int PS5            : 1;	/* Reserved */
		unsigned int PS6            : 1;	/* Reserved */
		unsigned int PS7            : 1;	/* Reserved */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} P40_OMSR4_type;
#define P40_OMSR4	(*( P40_OMSR4_type *) 0xf003e074u)	/* Port 40 Output Modification Set Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 8;
		unsigned int PS8            : 1;	/* Reserved */
		unsigned int PS9            : 1;	/* Reserved */
		unsigned int PS10           : 1;	/* Reserved */
		unsigned int PS11           : 1;	/* Reserved */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} P40_OMSR8_type;
#define P40_OMSR8	(*( P40_OMSR8_type *) 0xf003e078u)	/* Port 40 Output Modification Set Register 8 */

typedef volatile union
{
	struct
	{ 
		unsigned int P0             : 1;	/* Reserved */
		unsigned int P1             : 1;	/* Reserved */
		unsigned int P2             : 1;	/* Reserved */
		unsigned int P3             : 1;	/* Reserved */
		unsigned int P4             : 1;	/* Reserved */
		unsigned int P5             : 1;	/* Reserved */
		unsigned int P6             : 1;	/* Reserved */
		unsigned int P7             : 1;	/* Reserved */
		unsigned int P8             : 1;	/* Reserved */
		unsigned int P9             : 1;	/* Reserved */
		unsigned int P10            : 1;	/* Reserved */
		unsigned int P11            : 1;	/* Reserved */
		unsigned int P12            : 1;	/* Reserved */
		unsigned int P13            : 1;	/* Reserved */
		unsigned int P14            : 1;	/* Reserved */
		unsigned int P15            : 1;	/* Reserved */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} P40_OUT_type;
#define P40_OUT	(*( P40_OUT_type *) 0xf003e000u)	/* Port 40 Output Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PDIS0          : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS1          : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS2          : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS3          : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS4          : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS5          : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS6          : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS7          : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS8          : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS9          : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS10         : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS11         : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS12         : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS13         : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS14         : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int PDIS15         : 1;	/* Pin Function Decision Control for Pin x */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} P40_PDISC_type;
#define P40_PDISC	(*( P40_PDISC_type *) 0xf003e060u)	/* Port 40 Pin Function Decision Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PD0            : 3;	/* Reserved */
		unsigned int PL0            : 1;	/* Reserved */
		unsigned int PD1            : 3;	/* Reserved */
		unsigned int PL1            : 1;	/* Reserved */
		unsigned int PD2            : 3;	/* Reserved */
		unsigned int PL2            : 1;	/* Reserved */
		unsigned int PD3            : 3;	/* Reserved */
		unsigned int PL3            : 1;	/* Reserved */
		unsigned int PD4            : 3;	/* Reserved */
		unsigned int PL4            : 1;	/* Reserved */
		unsigned int PD5            : 3;	/* Reserved */
		unsigned int PL5            : 1;	/* Reserved */
		unsigned int PD6            : 3;	/* Reserved */
		unsigned int PL6            : 1;	/* Reserved */
		unsigned int PD7            : 3;	/* Reserved */
		unsigned int PL7            : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P40_PDR0_type;
#define P40_PDR0	(*( P40_PDR0_type *) 0xf003e040u)	/* Port 40 Pad Driver Mode 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PD8            : 3;	/* Reserved */
		unsigned int PL8            : 1;	/* Reserved */
		unsigned int PD9            : 3;	/* Reserved */
		unsigned int PL9            : 1;	/* Reserved */
		unsigned int PD10           : 3;	/* Reserved */
		unsigned int PL10           : 1;	/* Reserved */
		unsigned int PD11           : 3;	/* Reserved */
		unsigned int PL11           : 1;	/* Reserved */
		unsigned int PD12           : 3;	/* Reserved */
		unsigned int PL12           : 1;	/* Reserved */
		unsigned int PD13           : 3;	/* Reserved */
		unsigned int PL13           : 1;	/* Reserved */
		unsigned int PD14           : 3;	/* Reserved */
		unsigned int PL14           : 1;	/* Reserved */
		unsigned int PD15           : 3;	/* Reserved */
		unsigned int PL15           : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} P40_PDR1_type;
#define P40_PDR1	(*( P40_PDR1_type *) 0xf003e044u)	/* Port 40 Pad Driver Mode 1 Register */


/* FCE */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} FCE_ACCEN0_type;
#define FCE_ACCEN0	(*( FCE_ACCEN0_type *) 0xf0003ffcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} FCE_ACCEN1_type;
#define FCE_ACCEN1	(*( FCE_ACCEN1_type *) 0xf0003ff8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CMI            : 1;	/* CRC Mismatch Interrupt */
		unsigned int CEI            : 1;	/* Configuration Error Interrupt */
		unsigned int LEI            : 1;	/* Length Error Interrupt */
		unsigned int BEI            : 1;	/* Bus Error Interrupt */
		unsigned int CCE            : 1;	/* CRC Check Comparison */
		unsigned int ALR            : 1;	/* Automatic Length Reload */
		unsigned int                : 2;
		unsigned int REFIN          : 1;	/* IR Byte Wise Reflection */
		unsigned int REFOUT         : 1;	/* CRC 32-Bit Wise Reflection */
		unsigned int XSEL           : 1;	/* Selects the value to be xored with the final CRC */
		unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} FCE_CFG0_type;
#define FCE_CFG0	(*( FCE_CFG0_type *) 0xf0003f28u)	/* CRC Configuration Register 0 */
#define FCE_CFG1	(*( FCE_CFG0_type *) 0xf0003f48u)	/* CRC Configuration Register 1 */
#define FCE_CFG2	(*( FCE_CFG0_type *) 0xf0003f68u)	/* CRC Configuration Register 2 */
#define FCE_CFG3	(*( FCE_CFG0_type *) 0xf0003f88u)	/* CRC Configuration Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int CHECK          : 32;	/* CHECK Register */
	} B;
	int I;
	unsigned int U;

} FCE_CHECK0_type;
#define FCE_CHECK0	(*( FCE_CHECK0_type *) 0xf0003f34u)	/* CRC Check Register 0 */
#define FCE_CHECK1	(*( FCE_CHECK0_type *) 0xf0003f54u)	/* CRC Check Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CHECK          : 16;	/* CHECK Register */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} FCE_CHECK2_type;
#define FCE_CHECK2	(*( FCE_CHECK2_type *) 0xf0003f74u)	/* CRC Check Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int CHECK          : 8;	/* CHECK Register */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} FCE_CHECK3_type;
#define FCE_CHECK3	(*( FCE_CHECK3_type *) 0xf0003f94u)	/* CRC Check Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} FCE_CLC_type;
#define FCE_CLC	(*( FCE_CLC_type *) 0xf0003f00u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CRC            : 32;	/* CRC Register */
	} B;
	int I;
	unsigned int U;

} FCE_CRC0_type;
#define FCE_CRC0	(*( FCE_CRC0_type *) 0xf0003f38u)	/* CRC Register 0 */
#define FCE_CRC1	(*( FCE_CRC0_type *) 0xf0003f58u)	/* CRC Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CRC            : 16;	/* CRC Register */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} FCE_CRC2_type;
#define FCE_CRC2	(*( FCE_CRC2_type *) 0xf0003f78u)	/* CRC Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int CRC            : 8;	/* CRC Register */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} FCE_CRC3_type;
#define FCE_CRC3	(*( FCE_CRC3_type *) 0xf0003f98u)	/* CRC Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int FCM            : 1;	/* Force CRC Mismatch */
		unsigned int FRM_CFG        : 1;	/* Force CFG Register Mismatch */
		unsigned int FRM_CHECK      : 1;	/* Force Check Register Mismatch */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} FCE_CTR0_type;
#define FCE_CTR0	(*( FCE_CTR0_type *) 0xf0003f3cu)	/* CRC Test Register 0 */
#define FCE_CTR1	(*( FCE_CTR0_type *) 0xf0003f5cu)	/* CRC Test Register 1 */
#define FCE_CTR2	(*( FCE_CTR0_type *) 0xf0003f7cu)	/* CRC Test Register 2 */
#define FCE_CTR3	(*( FCE_CTR0_type *) 0xf0003f9cu)	/* CRC Test Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} FCE_ID_type;
#define FCE_ID	(*( FCE_ID_type *) 0xf0003f08u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IR             : 32;	/* Input Register */
	} B;
	int I;
	unsigned int U;

} FCE_IR0_type;
#define FCE_IR0	(*( FCE_IR0_type *) 0xf0003f20u)	/* Input Register 0 */
#define FCE_IR1	(*( FCE_IR0_type *) 0xf0003f40u)	/* Input Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int IR             : 16;	/* Input Register */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} FCE_IR2_type;
#define FCE_IR2	(*( FCE_IR2_type *) 0xf0003f60u)	/* Input Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int IR             : 8;	/* Input Register */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} FCE_IR3_type;
#define FCE_IR3	(*( FCE_IR3_type *) 0xf0003f80u)	/* Input Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} FCE_KRST0_type;
#define FCE_KRST0	(*( FCE_KRST0_type *) 0xf0003ff4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} FCE_KRST1_type;
#define FCE_KRST1	(*( FCE_KRST1_type *) 0xf0003ff0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} FCE_KRSTCLR_type;
#define FCE_KRSTCLR	(*( FCE_KRSTCLR_type *) 0xf0003fecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LENGTH         : 16;	/* Message Length Register */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} FCE_LENGTH0_type;
#define FCE_LENGTH0	(*( FCE_LENGTH0_type *) 0xf0003f30u)	/* CRC Length Register 0 */
#define FCE_LENGTH1	(*( FCE_LENGTH0_type *) 0xf0003f50u)	/* CRC Length Register 1 */
#define FCE_LENGTH2	(*( FCE_LENGTH0_type *) 0xf0003f70u)	/* CRC Length Register 2 */
#define FCE_LENGTH3	(*( FCE_LENGTH0_type *) 0xf0003f90u)	/* CRC Length Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 32;	/* Result Register */
	} B;
	int I;
	unsigned int U;

} FCE_RES0_type;
#define FCE_RES0	(*( FCE_RES0_type *) 0xf0003f24u)	/* CRC Result Register 0 */
#define FCE_RES1	(*( FCE_RES0_type *) 0xf0003f44u)	/* CRC Result Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 16;	/* Result Register */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} FCE_RES2_type;
#define FCE_RES2	(*( FCE_RES2_type *) 0xf0003f64u)	/* CRC Result Register 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 8;	/* Result Register */
		/* const */ unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} FCE_RES3_type;
#define FCE_RES3	(*( FCE_RES3_type *) 0xf0003f84u)	/* CRC Result Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int CMF            : 1;	/* CRC Mismatch Flag */
		unsigned int CEF            : 1;	/* Configuration Error Flag */
		unsigned int LEF            : 1;	/* Length Error Flag */
		unsigned int BEF            : 1;	/* Bus Error Flag */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} FCE_STS0_type;
#define FCE_STS0	(*( FCE_STS0_type *) 0xf0003f2cu)	/* CRC Status Register 0 */
#define FCE_STS1	(*( FCE_STS0_type *) 0xf0003f4cu)	/* CRC Status Register 1 */
#define FCE_STS2	(*( FCE_STS0_type *) 0xf0003f6cu)	/* CRC Status Register 2 */
#define FCE_STS3	(*( FCE_STS0_type *) 0xf0003f8cu)	/* CRC Status Register 3 */


/* STM */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} STM0_ACCEN0_type;
#define STM0_ACCEN0	(*( STM0_ACCEN0_type *) 0xf00000fcu)	/* Access Enable Register 0 */
#define STM1_ACCEN0	(*( STM0_ACCEN0_type *) 0xf00001fcu)	/* Access Enable Register 0 */
#define STM2_ACCEN0	(*( STM0_ACCEN0_type *) 0xf00002fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} STM0_ACCEN1_type;
#define STM0_ACCEN1	(*( STM0_ACCEN1_type *) 0xf00000f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int STMCAP         : 32;	/* Captured System Timer Bits [63:32] */
	} B;
	int I;
	unsigned int U;

} STM0_CAP_type;
#define STM0_CAP	(*( STM0_CAP_type *) 0xf000002cu)	/* Timer Capture Register */
#define STM1_CAP	(*( STM0_CAP_type *) 0xf000012cu)	/* Timer Capture Register */
#define STM2_CAP	(*( STM0_CAP_type *) 0xf000022cu)	/* Timer Capture Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} STM0_CLC_type;
#define STM0_CLC	(*( STM0_CLC_type *) 0xf0000000u)	/* Clock Control Register */
#define STM1_CLC	(*( STM0_CLC_type *) 0xf0000100u)	/* Clock Control Register */
#define STM2_CLC	(*( STM0_CLC_type *) 0xf0000200u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MSIZE0         : 5;	/* Compare Register Size for CMP0 */
		unsigned int                : 3;
		unsigned int MSTART0        : 5;	/* Start Bit Location for CMP0 */
		unsigned int                : 3;
		unsigned int MSIZE1         : 5;	/* Compare Register Size for CMP1 */
		unsigned int                : 3;
		unsigned int MSTART1        : 5;	/* Start Bit Location for CMP1 */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} STM0_CMCON_type;
#define STM0_CMCON	(*( STM0_CMCON_type *) 0xf0000038u)	/* Compare Match Control Register */
#define STM1_CMCON	(*( STM0_CMCON_type *) 0xf0000138u)	/* Compare Match Control Register */
#define STM2_CMCON	(*( STM0_CMCON_type *) 0xf0000238u)	/* Compare Match Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CMPVAL         : 32;	/* Compare Value of Compare Register x */
	} B;
	int I;
	unsigned int U;

} STM0_CMP0_type;
#define STM0_CMP0	(*( STM0_CMP0_type *) 0xf0000030u)	/* Compare Register 0 */
#define STM0_CMP1	(*( STM0_CMP0_type *) 0xf0000034u)	/* Compare Register 1 */
#define STM1_CMP0	(*( STM0_CMP0_type *) 0xf0000130u)	/* Compare Register 0 */
#define STM1_CMP1	(*( STM0_CMP0_type *) 0xf0000134u)	/* Compare Register 1 */
#define STM2_CMP0	(*( STM0_CMP0_type *) 0xf0000230u)	/* Compare Register 0 */
#define STM2_CMP1	(*( STM0_CMP0_type *) 0xf0000234u)	/* Compare Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CMP0EN         : 1;	/* Compare Register CMP0 Interrupt Enable Control */
		/* const */ unsigned int CMP0IR         : 1;	/* Compare Register CMP0 Interrupt Request Flag */
		unsigned int CMP0OS         : 1;	/* Compare Register CMP0 Interrupt Output Selection */
		unsigned int                : 1;
		unsigned int CMP1EN         : 1;	/* Compare Register CMP1 Interrupt Enable Control */
		/* const */ unsigned int CMP1IR         : 1;	/* Compare Register CMP1 Interrupt Request Flag */
		unsigned int CMP1OS         : 1;	/* Compare Register CMP1 Interrupt Output Selection */
		unsigned int                : 25;
	} B;
	int I;
	unsigned int U;

} STM0_ICR_type;
#define STM0_ICR	(*( STM0_ICR_type *) 0xf000003cu)	/* Interrupt Control Register */
#define STM1_ICR	(*( STM0_ICR_type *) 0xf000013cu)	/* Interrupt Control Register */
#define STM2_ICR	(*( STM0_ICR_type *) 0xf000023cu)	/* Interrupt Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} STM0_ID_type;
#define STM0_ID	(*( STM0_ID_type *) 0xf0000008u)	/* Module Identification Register */
#define STM1_ID	(*( STM0_ID_type *) 0xf0000108u)	/* Module Identification Register */
#define STM2_ID	(*( STM0_ID_type *) 0xf0000208u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CMP0IRR        : 1;	/* Reset Compare Register CMP0 Interrupt Flag */
		unsigned int CMP0IRS        : 1;	/* Set Compare Register CMP0 Interrupt Flag */
		unsigned int CMP1IRR        : 1;	/* Reset Compare Register CMP1 Interrupt Flag */
		unsigned int CMP1IRS        : 1;	/* Set Compare Register CMP1 Interrupt Flag */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} STM0_ISCR_type;
#define STM0_ISCR	(*( STM0_ISCR_type *) 0xf0000040u)	/* Interrupt Set/Clear Register */
#define STM1_ISCR	(*( STM0_ISCR_type *) 0xf0000140u)	/* Interrupt Set/Clear Register */
#define STM2_ISCR	(*( STM0_ISCR_type *) 0xf0000240u)	/* Interrupt Set/Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} STM0_KRST0_type;
#define STM0_KRST0	(*( STM0_KRST0_type *) 0xf00000f4u)	/* Kernel Reset Register 0 */
#define STM1_KRST0	(*( STM0_KRST0_type *) 0xf00001f4u)	/* Kernel Reset Register 0 */
#define STM2_KRST0	(*( STM0_KRST0_type *) 0xf00002f4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} STM0_KRST1_type;
#define STM0_KRST1	(*( STM0_KRST1_type *) 0xf00000f0u)	/* Kernel Reset Register 1 */
#define STM1_KRST1	(*( STM0_KRST1_type *) 0xf00001f0u)	/* Kernel Reset Register 1 */
#define STM2_KRST1	(*( STM0_KRST1_type *) 0xf00002f0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} STM0_KRSTCLR_type;
#define STM0_KRSTCLR	(*( STM0_KRSTCLR_type *) 0xf00000ecu)	/* Kernel Reset Status Clear Register */
#define STM1_KRSTCLR	(*( STM0_KRSTCLR_type *) 0xf00001ecu)	/* Kernel Reset Status Clear Register */
#define STM2_KRSTCLR	(*( STM0_KRSTCLR_type *) 0xf00002ecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} STM0_OCS_type;
#define STM0_OCS	(*( STM0_OCS_type *) 0xf00000e8u)	/* OCDS Control and Status */
#define STM1_OCS	(*( STM0_OCS_type *) 0xf00001e8u)	/* OCDS Control and Status */
#define STM2_OCS	(*( STM0_OCS_type *) 0xf00002e8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int STM            : 32;	/* System Timer Bits [31:0] */
	} B;
	int I;
	unsigned int U;

} STM0_TIM0_type;
#define STM0_TIM0	(*( STM0_TIM0_type *) 0xf0000010u)	/* Timer Register 0 */
#define STM1_TIM0	(*( STM0_TIM0_type *) 0xf0000110u)	/* Timer Register 0 */
#define STM2_TIM0	(*( STM0_TIM0_type *) 0xf0000210u)	/* Timer Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int STM            : 32;	/* System Timer Bits [35:4] */
	} B;
	int I;
	unsigned int U;

} STM0_TIM1_type;
#define STM0_TIM1	(*( STM0_TIM1_type *) 0xf0000014u)	/* Timer Register 1 */
#define STM1_TIM1	(*( STM0_TIM1_type *) 0xf0000114u)	/* Timer Register 1 */
#define STM2_TIM1	(*( STM0_TIM1_type *) 0xf0000214u)	/* Timer Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int STM            : 32;	/* System Timer Bits [39:8] */
	} B;
	int I;
	unsigned int U;

} STM0_TIM2_type;
#define STM0_TIM2	(*( STM0_TIM2_type *) 0xf0000018u)	/* Timer Register 2 */
#define STM1_TIM2	(*( STM0_TIM2_type *) 0xf0000118u)	/* Timer Register 2 */
#define STM2_TIM2	(*( STM0_TIM2_type *) 0xf0000218u)	/* Timer Register 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int STM            : 32;	/* System Timer Bits [43:12] */
	} B;
	int I;
	unsigned int U;

} STM0_TIM3_type;
#define STM0_TIM3	(*( STM0_TIM3_type *) 0xf000001cu)	/* Timer Register 3 */
#define STM1_TIM3	(*( STM0_TIM3_type *) 0xf000011cu)	/* Timer Register 3 */
#define STM2_TIM3	(*( STM0_TIM3_type *) 0xf000021cu)	/* Timer Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int STM            : 32;	/* System Timer Bits [47:16] */
	} B;
	int I;
	unsigned int U;

} STM0_TIM4_type;
#define STM0_TIM4	(*( STM0_TIM4_type *) 0xf0000020u)	/* Timer Register 4 */
#define STM1_TIM4	(*( STM0_TIM4_type *) 0xf0000120u)	/* Timer Register 4 */
#define STM2_TIM4	(*( STM0_TIM4_type *) 0xf0000220u)	/* Timer Register 4 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int STM            : 32;	/* System Timer Bits [51:20] */
	} B;
	int I;
	unsigned int U;

} STM0_TIM5_type;
#define STM0_TIM5	(*( STM0_TIM5_type *) 0xf0000024u)	/* Timer Register 5 */
#define STM1_TIM5	(*( STM0_TIM5_type *) 0xf0000124u)	/* Timer Register 5 */
#define STM2_TIM5	(*( STM0_TIM5_type *) 0xf0000224u)	/* Timer Register 5 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int STM            : 32;	/* System Timer Bits [63:32] */
	} B;
	int I;
	unsigned int U;

} STM0_TIM6_type;
#define STM0_TIM6	(*( STM0_TIM6_type *) 0xf0000028u)	/* Timer Register 6 */
#define STM1_TIM6	(*( STM0_TIM6_type *) 0xf0000128u)	/* Timer Register 6 */
#define STM2_TIM6	(*( STM0_TIM6_type *) 0xf0000228u)	/* Timer Register 6 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} STM1_ACCEN1_type;
#define STM1_ACCEN1	(*( STM1_ACCEN1_type *) 0xf00001f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} STM2_ACCEN1_type;
#define STM2_ACCEN1	(*( STM2_ACCEN1_type *) 0xf00002f8u)	/* Access Enable Register 1 */

#define SYSTIME_LOW	STM0_TIM0.U
#define SYSTIME_HIGH	STM0_CAP.U
#define SYSTIME0_LOW	STM0_TIM0.U
#define SYSTIME0_HIGH	STM0_CAP.U
#define SYSTIME1_LOW	STM1_TIM0.U
#define SYSTIME1_HIGH	STM1_CAP.U
#define SYSTIME2_LOW	STM2_TIM0.U
#define SYSTIME2_HIGH	STM2_CAP.U

/* OCDS */
typedef volatile union
{
	struct
	{ 
		unsigned int DATA           : 32;	/* Read/Write Data */
	} B;
	int I;
	unsigned int U;

} CBS_COMDATA_type;
#define CBS_COMDATA	(*( CBS_COMDATA_type *) 0xf0000468u)	/* Communication Mode Data Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 32;	/* Source Address */
	} B;
	int I;
	unsigned int U;

} CBS_ICTSA_type;
#define CBS_ICTSA	(*( CBS_ICTSA_type *) 0xf0000488u)	/* Internally Controlled Trace Source Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 32;	/* Destination Address */
	} B;
	int I;
	unsigned int U;

} CBS_ICTTA_type;
#define CBS_ICTTA	(*( CBS_ICTTA_type *) 0xf000048cu)	/* Internally Controlled Trace Destination Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SET_CRS        : 1;	/* Set Read Sync Flag */
		unsigned int SET_CWS        : 1;	/* Set Write Sync Flag */
		unsigned int SET_CS         : 1;	/* Set Communication Synchronization Flag */
		unsigned int CLR_CS         : 1;	/* Clear Communication Synchronization Flag */
		unsigned int CHANNEL_P      : 1;	/* CHANNEL Write Protection */
		unsigned int CHANNEL        : 3;	/* Channel Indication */
		unsigned int                : 8;
		unsigned int SET_INT_MOD    : 1;	/* Enter Internal Mode */
		unsigned int                : 1;
		unsigned int SET_INT_TRC    : 1;	/* Enable Internally Controlled Triggered Transfer */
		unsigned int CLR_INT_TRC    : 1;	/* Disable Internally Controlled Triggered Transfer */
		unsigned int TRC_MOD_P      : 1;	/* TRC_MOD Write Protection */
		unsigned int TRC_MOD        : 2;	/* Data Size Definition for Triggered Transfer */
		unsigned int                : 1;
		/* const */ unsigned int INT_MOD        : 1;	/* Internal Mode Enabled Flag */
		/* const */ unsigned int INT_TRC        : 1;	/* Internally Controlled Triggered Transfer Enable */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} CBS_INTMOD_type;
#define CBS_INTMOD	(*( CBS_INTMOD_type *) 0xf0000484u)	/* Internal Mode Status and Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		/* const */ unsigned int CRSYNC         : 1;	/* Communication Mode Read Sync Flag */
		/* const */ unsigned int CWSYNC         : 1;	/* Communication Mode Write Sync Flag */
		unsigned int CW_ACK         : 1;	/* Communication Mode Write Acknowledge */
		/* const */ unsigned int COM_SYNC       : 1;	/* Communication Mode Synchronization Flag */
		/* const */ unsigned int HOSTED         : 1;	/* Tool Interface in Use */
		unsigned int                : 3;
		/* const */ unsigned int CHANNEL        : 3;	/* Channel Indication */
		unsigned int                : 17;
	} B;
	int I;
	unsigned int U;

} CBS_IOSR_type;
#define CBS_IOSR	(*( CBS_IOSR_type *) 0xf000046cu)	/* IOClient Status and Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} CBS_JDPID_type;
#define CBS_JDPID	(*( CBS_JDPID_type *) 0xf0000408u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int JTAG_ID        : 32;	/* JTAG Device ID */
	} B;
	int I;
	unsigned int U;

} CBS_JTAGID_type;
#define CBS_JTAGID	(*( CBS_JTAGID_type *) 0xf0000464u)	/* JTAG Device Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int OC0_P          : 1;	/* OCx Write Protection */
		unsigned int OC0            : 1;	/* Set/Clear OCDS Control Bits Bus Domain */
		unsigned int OC1_P          : 1;	/* OCx Write Protection */
		unsigned int OC1            : 1;	/* Set/Clear OCDS Control Bits Bus Domain */
		unsigned int OC2_P          : 1;	/* OCx Write Protection */
		unsigned int OC2            : 1;	/* Set/Clear OCDS Control Bits Bus Domain */
		unsigned int OC3_P          : 1;	/* OCx Write Protection */
		unsigned int OC3            : 1;	/* Set/Clear OCDS Control Bits Bus Domain */
		unsigned int OC4_P          : 1;	/* OCx Write Protection */
		unsigned int OC4            : 1;	/* Set/Clear OCDS Control Bits Bus Domain */
		unsigned int OC5_P          : 1;	/* OCx Write Protection */
		unsigned int OC5            : 1;	/* Set/Clear OCDS Control Bits Bus Domain */
		unsigned int WDTSUS_P       : 1;	/* WDTSUS Write Protection */
		unsigned int WDTSUS         : 1;	/* Set/Clear Watchdog Timer Suspension Control */
		unsigned int STABLE_P       : 1;	/* STABLE Write Protection */
		unsigned int STABLE         : 1;	/* Initialize Application Reset Indication */
		unsigned int OJC0_P         : 1;	/* OJCx Write Protection */
		unsigned int OJC0           : 1;	/* Set/Clear OCDS Control Bits IOClient Domain */
		unsigned int OJC1_P         : 1;	/* OJCx Write Protection */
		unsigned int OJC1           : 1;	/* Set/Clear OCDS Control Bits IOClient Domain */
		unsigned int OJC2_P         : 1;	/* OJCx Write Protection */
		unsigned int OJC2           : 1;	/* Set/Clear OCDS Control Bits IOClient Domain */
		unsigned int OJC3_P         : 1;	/* OJCx Write Protection */
		unsigned int OJC3           : 1;	/* Set/Clear OCDS Control Bits IOClient Domain */
		unsigned int OJC4_P         : 1;	/* OJCx Write Protection */
		unsigned int OJC4           : 1;	/* Set/Clear OCDS Control Bits IOClient Domain */
		unsigned int OJC5_P         : 1;	/* OJCx Write Protection */
		unsigned int OJC5           : 1;	/* Set/Clear OCDS Control Bits IOClient Domain */
		unsigned int OJC6_P         : 1;	/* OJCx Write Protection */
		unsigned int OJC6           : 1;	/* Set/Clear OCDS Control Bits IOClient Domain */
		unsigned int OJC7_P         : 1;	/* OJCx Write Protection */
		unsigned int OJC7           : 1;	/* Set/Clear OCDS Control Bits IOClient Domain */
	} B;
	int I;
	unsigned int U;

} CBS_OCNTRL_type;
#define CBS_OCNTRL	(*( CBS_OCNTRL_type *) 0xf000047cu)	/* OSCU Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PAT            : 8;	/* OCDS Enabling Pattern */
		unsigned int DS             : 1;	/* Disable OCDS */
		unsigned int                : 7;
		unsigned int IF_LCK_P       : 1;	/* IF_LCK Write Protection */
		unsigned int IF_LCK         : 1;	/* Set/Clear Interface Locked Indication */
		unsigned int AUT_OK_P       : 1;	/* AUT_OK Write Protection */
		unsigned int AUT_OK         : 1;	/* Set/Clear the Authorization OK Indication */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} CBS_OEC_type;
#define CBS_OEC	(*( CBS_OEC_type *) 0xf0000478u)	/* OCDS Enable Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DAPMODE        : 3;	/* DAP Interface Mode */
		unsigned int DAPRST         : 1;	/* DAP Protocol Clear */
		unsigned int                : 4;
		unsigned int F_JTAG         : 1;	/* Forced JTAG Mode (dap_bypass_o) */
		unsigned int N_JTAG         : 1;	/* No Switch to JTAG (jtag_disable_o) */
		unsigned int                : 2;
		unsigned int PADCTL         : 4;	/* Pad Control for Debug Interface Pins (padctl_o) */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CBS_OIFM_type;
#define CBS_OIFM	(*( CBS_OIFM_type *) 0xf000040cu)	/* OCDS Interface Mode Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int OEN            : 1;	/* OCDS Enabled Flag */
		/* const */ unsigned int OC0            : 1;	/* OCDS Control Bits System Bus Domain */
		/* const */ unsigned int OC1            : 1;	/* OCDS Control Bits System Bus Domain */
		/* const */ unsigned int OC2            : 1;	/* OCDS Control Bits System Bus Domain */
		/* const */ unsigned int ENIDIS         : 1;	/* OCDS ENDINIT Protection Override */
		/* const */ unsigned int EECTRC         : 1;	/* On Chip Trace Enable */
		/* const */ unsigned int EECDIS         : 1;	/* Emulation Logic Disable */
		/* const */ unsigned int WDTSUS         : 1;	/* Control of Watchdog Timer Suspension */
		/* const */ unsigned int HARR           : 1;	/* Halt after Reset Request */
		/* const */ unsigned int OJC1           : 1;	/* OCDS Control Bits IOClient Domain */
		/* const */ unsigned int OJC2           : 1;	/* OCDS Control Bits IOClient Domain */
		/* const */ unsigned int OJC3           : 1;	/* OCDS Control Bits IOClient Domain */
		/* const */ unsigned int RSTCL0         : 1;	/* OCDS System Reset (Class 0) Request */
		/* const */ unsigned int RSTCL1         : 1;	/* OCDS Debug Reset (Class 1) Request */
		/* const */ unsigned int OJC6           : 1;	/* OCDS Control Bits IOClient Domain */
		/* const */ unsigned int RSTCL3         : 1;	/* OCDS Application Reset (Class 3) Request */
		/* const */ unsigned int IF_LCK         : 1;	/* Interface Locked Indication */
		/* const */ unsigned int AUT_OK         : 1;	/* Authorization OK Indication */
		/* const */ unsigned int STABLE         : 1;	/* Application Reset Indication */
		/* const */ unsigned int                : 13;
	} B;
	int I;
	unsigned int U;

} CBS_OSTATE_type;
#define CBS_OSTATE	(*( CBS_OSTATE_type *) 0xf0000480u)	/* OSCU Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int C0             : 1;	/* Capture of BRKOUT Signal of CPUx */
		/* const */ unsigned int C1             : 1;	/* Capture of BRKOUT Signal of CPUx */
		/* const */ unsigned int C2             : 1;	/* Capture of BRKOUT Signal of CPUx */
		/* const */ unsigned int                : 28;
		/* const */ unsigned int HSM            : 1;	/* Capture of BRKOUT Signal of HSM */
	} B;
	int I;
	unsigned int U;

} CBS_TCCB_type;
#define CBS_TCCB	(*( CBS_TCCB_type *) 0xf00004b0u)	/* TG Capture for Cores - BRKOUT */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int C0             : 1;	/* Capture of HALT Signal of CPUx */
		/* const */ unsigned int C1             : 1;	/* Capture of HALT Signal of CPUx */
		/* const */ unsigned int C2             : 1;	/* Capture of HALT Signal of CPUx */
		/* const */ unsigned int                : 28;
		/* const */ unsigned int HSM            : 1;	/* Capture of HALT Signal of HSM */
	} B;
	int I;
	unsigned int U;

} CBS_TCCH_type;
#define CBS_TCCH	(*( CBS_TCCH_type *) 0xf00004b4u)	/* TG Capture for Cores - HALT */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int P0             : 1;	/* Capture of Trigger Input Pin x */
		/* const */ unsigned int P1             : 1;	/* Capture of Trigger Input Pin x */
		/* const */ unsigned int P2             : 1;	/* Capture of Trigger Input Pin x */
		/* const */ unsigned int P3             : 1;	/* Capture of Trigger Input Pin x */
		/* const */ unsigned int P4             : 1;	/* Capture of Trigger Input Pin x */
		/* const */ unsigned int P5             : 1;	/* Capture of Trigger Input Pin x */
		/* const */ unsigned int P6             : 1;	/* Capture of Trigger Input Pin x */
		/* const */ unsigned int P7             : 1;	/* Capture of Trigger Input Pin x */
		/* const */ unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} CBS_TCIP_type;
#define CBS_TCIP	(*( CBS_TCIP_type *) 0xf000041cu)	/* TG Capture for TG Input Pins */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int BRK            : 1;	/* Capture of MCDS break_out */
		/* const */ unsigned int SUS            : 1;	/* Capture of MCDS suspend_out */
		/* const */ unsigned int                : 6;
		/* const */ unsigned int T0             : 1;	/* Capture of MCDS trig_out x */
		/* const */ unsigned int T1             : 1;	/* Capture of MCDS trig_out x */
		/* const */ unsigned int T2             : 1;	/* Capture of MCDS trig_out x */
		/* const */ unsigned int T3             : 1;	/* Capture of MCDS trig_out x */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} CBS_TCM_type;
#define CBS_TCM	(*( CBS_TCM_type *) 0xf00004bcu)	/* TG Capture for MCDS */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int OTGB0          : 16;	/* Capture Bits for OTGB0 */
		/* const */ unsigned int OTGB1          : 16;	/* Capture Bits for OTGB1 */
	} B;
	int I;
	unsigned int U;

} CBS_TCTGB_type;
#define CBS_TCTGB	(*( CBS_TCTGB_type *) 0xf00004b8u)	/* TG Capture for OTGB0/1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 1;
		/* const */ unsigned int TL1            : 1;	/* Capture of Trigger Line x */
		/* const */ unsigned int TL2            : 1;	/* Capture of Trigger Line x */
		/* const */ unsigned int TL3            : 1;	/* Capture of Trigger Line x */
		/* const */ unsigned int TL4            : 1;	/* Capture of Trigger Line x */
		/* const */ unsigned int TL5            : 1;	/* Capture of Trigger Line x */
		/* const */ unsigned int TL6            : 1;	/* Capture of Trigger Line x */
		/* const */ unsigned int TL7            : 1;	/* Capture of Trigger Line x */
		/* const */ unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} CBS_TCTL_type;
#define CBS_TCTL	(*( CBS_TCTL_type *) 0xf0000474u)	/* TG Capture for TG Lines */

typedef volatile union
{
	struct
	{ 
		unsigned int PIN0           : 4;	/* Trigger Pin x to Trigger Line Routing */
		unsigned int PIN1           : 4;	/* Trigger Pin x to Trigger Line Routing */
		unsigned int PIN2           : 4;	/* Trigger Pin x to Trigger Line Routing */
		unsigned int PIN3           : 4;	/* Trigger Pin x to Trigger Line Routing */
		unsigned int PIN4           : 4;	/* Trigger Pin x to Trigger Line Routing */
		unsigned int PIN5           : 4;	/* Trigger Pin x to Trigger Line Routing */
		unsigned int PIN6           : 4;	/* Trigger Pin x to Trigger Line Routing */
		unsigned int PIN7           : 4;	/* Trigger Pin x to Trigger Line Routing */
	} B;
	int I;
	unsigned int U;

} CBS_TIPR_type;
#define CBS_TIPR	(*( CBS_TIPR_type *) 0xf0000410u)	/* TG Input Pins Routing */

typedef volatile union
{
	struct
	{ 
		unsigned int C0             : 1;	/* CPUx as Suspend Target */
		unsigned int C1             : 1;	/* CPUx as Suspend Target */
		unsigned int C2             : 1;	/* CPUx as Suspend Target */
		unsigned int                : 21;
		unsigned int M0123          : 4;	/* Master X as Suspend Target */
		unsigned int HSS            : 1;	/* HSSL as Suspend Target */
		unsigned int SDM            : 1;	/* SDMA as Suspend Target */
		unsigned int DM             : 1;	/* DMA as Suspend Target */
		unsigned int HSM            : 1;	/* HSM as Suspend Target */
	} B;
	int I;
	unsigned int U;

} CBS_TL1ST_type;
#define CBS_TL1ST	(*( CBS_TL1ST_type *) 0xf0000494u)	/* TG Line 1 Suspend Targets */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int TLSP1          : 4;	/* TG Line Signal Processing */
		unsigned int TLSP2          : 4;	/* TG Line Signal Processing */
		unsigned int TLSP3          : 4;	/* TG Line Signal Processing */
		unsigned int TLSP4          : 4;	/* TG Line Signal Processing */
		unsigned int TLSP5          : 4;	/* TG Line Signal Processing */
		unsigned int TLSP6          : 4;	/* TG Line Signal Processing */
		unsigned int TLSP7          : 4;	/* TG Line Signal Processing */
	} B;
	int I;
	unsigned int U;

} CBS_TLC_type;
#define CBS_TLC	(*( CBS_TLC_type *) 0xf0000490u)	/* TG Line Control */

typedef volatile union
{
	struct
	{ 
		unsigned int TGL            : 4;	/* Trigger Line to Counter Routing */
		unsigned int LE             : 3;	/* Level or Edge Counting */
		unsigned int                : 1;
		unsigned int CLR            : 2;	/* Clear and Enable Counter(s) */
		unsigned int                : 2;
		unsigned int STOP           : 2;	/* Stop Counter(s) */
		unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} CBS_TLCC0_type;
#define CBS_TLCC0	(*( CBS_TLCC0_type *) 0xf0000440u)	/* TG Line Counter Control */
#define CBS_TLCC1	(*( CBS_TLCC0_type *) 0xf0000444u)	/* TG Line Counter Control */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		unsigned int TL1            : 1;	/* Capture and Hold Enable for Trigger Line x */
		unsigned int TL2            : 1;	/* Capture and Hold Enable for Trigger Line x */
		unsigned int TL3            : 1;	/* Capture and Hold Enable for Trigger Line x */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CBS_TLCHE_type;
#define CBS_TLCHE	(*( CBS_TLCHE_type *) 0xf0000498u)	/* TG Line Capture and Hold Enable */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		unsigned int TL1            : 1;	/* Capture and Hold Clear for Trigger Line x */
		unsigned int TL2            : 1;	/* Capture and Hold Clear for Trigger Line x */
		unsigned int TL3            : 1;	/* Capture and Hold Clear for Trigger Line x */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} CBS_TLCHS_type;
#define CBS_TLCHS	(*( CBS_TLCHS_type *) 0xf000049cu)	/* TG Line Capture and Hold Clear */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CV             : 31;	/* Count Value */
		/* const */ unsigned int SO             : 1;	/* Sticky Overflow Bit */
	} B;
	int I;
	unsigned int U;

} CBS_TLCV0_type;
#define CBS_TLCV0	(*( CBS_TLCV0_type *) 0xf0000450u)	/* TG Line Counter Value */
#define CBS_TLCV1	(*( CBS_TLCV0_type *) 0xf0000454u)	/* TG Line Counter Value */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 1;
		/* const */ unsigned int TL1            : 1;	/* Current State of Trigger Line x */
		/* const */ unsigned int TL2            : 1;	/* Current State of Trigger Line x */
		/* const */ unsigned int TL3            : 1;	/* Current State of Trigger Line x */
		/* const */ unsigned int TL4            : 1;	/* Current State of Trigger Line x */
		/* const */ unsigned int TL5            : 1;	/* Current State of Trigger Line x */
		/* const */ unsigned int TL6            : 1;	/* Current State of Trigger Line x */
		/* const */ unsigned int TL7            : 1;	/* Current State of Trigger Line x */
		/* const */ unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} CBS_TLS_type;
#define CBS_TLS	(*( CBS_TLS_type *) 0xf0000470u)	/* TG Line State */

typedef volatile union
{
	struct
	{ 
		unsigned int TGL            : 4;	/* Timer to Trigger Line Routing */
		unsigned int VTZ            : 1;	/* TG Line Value when Timer Value is Zero */
		unsigned int                : 11;
		unsigned int TIM            : 16;	/* Timer Value */
	} B;
	int I;
	unsigned int U;

} CBS_TLT_type;
#define CBS_TLT	(*( CBS_TLT_type *) 0xf00004a8u)	/* TG Line Timer */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int TL1            : 2;	/* TG Line Enabling for Trigger to Host (TRIG) */
		unsigned int TL2            : 2;	/* TG Line Enabling for Trigger to Host (TRIG) */
		unsigned int TL3            : 2;	/* TG Line Enabling for Trigger to Host (TRIG) */
		unsigned int TL4            : 2;	/* TG Line Enabling for Trigger to Host (TRIG) */
		unsigned int TL5            : 2;	/* TG Line Enabling for Trigger to Host (TRIG) */
		unsigned int TL6            : 2;	/* TG Line Enabling for Trigger to Host (TRIG) */
		unsigned int TL7            : 2;	/* TG Line Enabling for Trigger to Host (TRIG) */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CBS_TLTTH_type;
#define CBS_TLTTH	(*( CBS_TLTTH_type *) 0xf00004acu)	/* TG Lines for Trigger to Host */

typedef volatile union
{
	struct
	{ 
		unsigned int PIN0           : 2;	/* Pulse Stretch Control for Trigger Pin x */
		unsigned int PIN1           : 2;	/* Pulse Stretch Control for Trigger Pin x */
		unsigned int PIN2           : 2;	/* Pulse Stretch Control for Trigger Pin x */
		unsigned int PIN3           : 2;	/* Pulse Stretch Control for Trigger Pin x */
		unsigned int PIN4           : 2;	/* Pulse Stretch Control for Trigger Pin x */
		unsigned int PIN5           : 2;	/* Pulse Stretch Control for Trigger Pin x */
		unsigned int PIN6           : 2;	/* Pulse Stretch Control for Trigger Pin x */
		unsigned int PIN7           : 2;	/* Pulse Stretch Control for Trigger Pin x */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CBS_TOPPS_type;
#define CBS_TOPPS	(*( CBS_TOPPS_type *) 0xf0000418u)	/* TG Output Pins Pulse Stretcher */

typedef volatile union
{
	struct
	{ 
		unsigned int PIN0           : 4;	/* Trigger Line to Trigger Pin x Routing */
		unsigned int PIN1           : 4;	/* Trigger Line to Trigger Pin x Routing */
		unsigned int PIN2           : 4;	/* Trigger Line to Trigger Pin x Routing */
		unsigned int PIN3           : 4;	/* Trigger Line to Trigger Pin x Routing */
		unsigned int PIN4           : 4;	/* Trigger Line to Trigger Pin x Routing */
		unsigned int PIN5           : 4;	/* Trigger Line to Trigger Pin x Routing */
		unsigned int PIN6           : 4;	/* Trigger Line to Trigger Pin x Routing */
		unsigned int PIN7           : 4;	/* Trigger Line to Trigger Pin x Routing */
	} B;
	int I;
	unsigned int U;

} CBS_TOPR_type;
#define CBS_TOPR	(*( CBS_TOPR_type *) 0xf0000414u)	/* TG Output Pins Routing */

typedef volatile union
{
	struct
	{ 
		unsigned int HALT           : 4;	/* HALT to Trigger Line Routing */
		unsigned int BRKOUT         : 4;	/* BRKOUT to Trigger Line Routing */
		unsigned int BT1            : 1;	/* BRKOUT to Trigger Line 1 Routing */
		unsigned int                : 11;
		unsigned int BRKIN          : 4;	/* Trigger Line to BRKIN Routing */
		unsigned int SUSIN          : 4;	/* Trigger Line to SUSIN Routing */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} CBS_TRC0_type;
#define CBS_TRC0	(*( CBS_TRC0_type *) 0xf0000420u)	/* TG Routing for CPU0 */
#define CBS_TRC1	(*( CBS_TRC0_type *) 0xf0000424u)	/* TG Routing for CPU1 */
#define CBS_TRC2	(*( CBS_TRC0_type *) 0xf0000428u)	/* TG Routing for CPU2 */

typedef volatile union
{
	struct
	{ 
		unsigned int TR0EV          : 4;	/* TRxEVT to Trigger Line Routing */
		unsigned int                : 4;
		unsigned int TR2EV          : 4;	/* TRxEVT to Trigger Line Routing */
		unsigned int                : 4;
		unsigned int TR4EV          : 4;	/* TRxEVT to Trigger Line Routing */
		unsigned int                : 4;
		unsigned int TR6EV          : 4;	/* TRxEVT to Trigger Line Routing */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} CBS_TREC0_type;
#define CBS_TREC0	(*( CBS_TREC0_type *) 0xf00004c0u)	/* TG Routing Events of CPU0 */
#define CBS_TREC1	(*( CBS_TREC0_type *) 0xf00004c4u)	/* TG Routing Events of CPU1 */
#define CBS_TREC2	(*( CBS_TREC0_type *) 0xf00004c8u)	/* TG Routing Events of CPU2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TRGx_0         : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_1         : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_2         : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_3         : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_4         : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_5         : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_6         : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_7         : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_8         : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_9         : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_10        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_11        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_12        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_13        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_14        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_15        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_16        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_17        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_18        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_19        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_20        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_21        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_22        : 1;	/* Service Request Bits */
		/* const */ unsigned int TRGx_23        : 1;	/* Service Request Bits */
		/* const */ unsigned int x              : 8;	/* TRIG register number */
	} B;
	int I;
	unsigned int U;

} CBS_TRIG0_type;
#define CBS_TRIG0	(*( CBS_TRIG0_type *) 0xf0000500u)	/* Trigger to Host Register 0 */
#define CBS_TRIG1	(*( CBS_TRIG0_type *) 0xf0000504u)	/* Trigger to Host Register 1 */
#define CBS_TRIG10	(*( CBS_TRIG0_type *) 0xf0000528u)	/* Trigger to Host Register 10 */
#define CBS_TRIG11	(*( CBS_TRIG0_type *) 0xf000052cu)	/* Trigger to Host Register 11 */
#define CBS_TRIG12	(*( CBS_TRIG0_type *) 0xf0000530u)	/* Trigger to Host Register 12 */
#define CBS_TRIG13	(*( CBS_TRIG0_type *) 0xf0000534u)	/* Trigger to Host Register 13 */
#define CBS_TRIG14	(*( CBS_TRIG0_type *) 0xf0000538u)	/* Trigger to Host Register 14 */
#define CBS_TRIG15	(*( CBS_TRIG0_type *) 0xf000053cu)	/* Trigger to Host Register 15 */
#define CBS_TRIG16	(*( CBS_TRIG0_type *) 0xf0000540u)	/* Trigger to Host Register 16 */
#define CBS_TRIG17	(*( CBS_TRIG0_type *) 0xf0000544u)	/* Trigger to Host Register 17 */
#define CBS_TRIG18	(*( CBS_TRIG0_type *) 0xf0000548u)	/* Trigger to Host Register 18 */
#define CBS_TRIG19	(*( CBS_TRIG0_type *) 0xf000054cu)	/* Trigger to Host Register 19 */
#define CBS_TRIG2	(*( CBS_TRIG0_type *) 0xf0000508u)	/* Trigger to Host Register 2 */
#define CBS_TRIG20	(*( CBS_TRIG0_type *) 0xf0000550u)	/* Trigger to Host Register 20 */
#define CBS_TRIG21	(*( CBS_TRIG0_type *) 0xf0000554u)	/* Trigger to Host Register 21 */
#define CBS_TRIG3	(*( CBS_TRIG0_type *) 0xf000050cu)	/* Trigger to Host Register 3 */
#define CBS_TRIG4	(*( CBS_TRIG0_type *) 0xf0000510u)	/* Trigger to Host Register 4 */
#define CBS_TRIG5	(*( CBS_TRIG0_type *) 0xf0000514u)	/* Trigger to Host Register 5 */
#define CBS_TRIG6	(*( CBS_TRIG0_type *) 0xf0000518u)	/* Trigger to Host Register 6 */
#define CBS_TRIG7	(*( CBS_TRIG0_type *) 0xf000051cu)	/* Trigger to Host Register 7 */
#define CBS_TRIG8	(*( CBS_TRIG0_type *) 0xf0000520u)	/* Trigger to Host Register 8 */
#define CBS_TRIG9	(*( CBS_TRIG0_type *) 0xf0000524u)	/* Trigger to Host Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TRGx_0         : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_1         : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_2         : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_3         : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_4         : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_5         : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_6         : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_7         : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_8         : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_9         : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_10        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_11        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_12        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_13        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_14        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_15        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_16        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_17        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_18        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_19        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_20        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_21        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_22        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int TRGx_23        : 1;	/* Request Bits of most important register TRIGx */
		/* const */ unsigned int x              : 8;	/* Index of most important register TRIGx */
	} B;
	int I;
	unsigned int U;

} CBS_TRIGC_type;
#define CBS_TRIGC	(*( CBS_TRIGC_type *) 0xf00004a4u)	/* Clear Trigger to Host Register */

typedef volatile union
{
	struct
	{ 
		unsigned int BITNUM         : 13;	/* Service Request Bit Number to Set */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} CBS_TRIGS_type;
#define CBS_TRIGS	(*( CBS_TRIGS_type *) 0xf00004a0u)	/* Set Trigger to Host Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 4;
		unsigned int BRKOUT         : 4;	/* MCDS break_out to Trigger Line Routing */
		unsigned int SUSOUT         : 4;	/* MCDS suspend_out to Trigger Line Routing */
		unsigned int                : 8;
		unsigned int BRKIN          : 4;	/* Trigger Line to MCDS break_in Routing */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CBS_TRMC_type;
#define CBS_TRMC	(*( CBS_TRMC_type *) 0xf000043cu)	/* TG Routing for MCDS Control */

typedef volatile union
{
	struct
	{ 
		unsigned int TG0            : 4;	/* MCDS trig_out x to Trigger Line Routing */
		unsigned int TG1            : 4;	/* MCDS trig_out x to Trigger Line Routing */
		unsigned int TG2            : 4;	/* MCDS trig_out x to Trigger Line Routing */
		unsigned int TG3            : 4;	/* MCDS trig_out x to Trigger Line Routing */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} CBS_TRMT_type;
#define CBS_TRMT	(*( CBS_TRMT_type *) 0xf00004dcu)	/* TG Routing for MCDS Triggers */

typedef volatile union
{
	struct
	{ 
		unsigned int TT             : 4;	/* Trigger Line to Cerberus? Triggered Transfer Routing */
		unsigned int                : 12;
		unsigned int SRC0           : 4;	/* Trigger Line to SRCx Interrupt Routing */
		unsigned int SRC1           : 4;	/* Trigger Line to SRCx Interrupt Routing */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} CBS_TRSS_type;
#define CBS_TRSS	(*( CBS_TRSS_type *) 0xf0000460u)	/* TG Routing for Special Signals */

typedef volatile union
{
	struct
	{ 
		unsigned int TG8            : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG9            : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG10           : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG11           : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG12           : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG13           : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG14           : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG15           : 4;	/* OTGB0 Bit x to Trigger Line Routing */
	} B;
	int I;
	unsigned int U;

} CBS_TRTGB0H_type;
#define CBS_TRTGB0H	(*( CBS_TRTGB0H_type *) 0xf00004e4u)	/* TG Routing for OTGB0 Bits [15:8] */

typedef volatile union
{
	struct
	{ 
		unsigned int TG0            : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG1            : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG2            : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG3            : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG4            : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG5            : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG6            : 4;	/* OTGB0 Bit x to Trigger Line Routing */
		unsigned int TG7            : 4;	/* OTGB0 Bit x to Trigger Line Routing */
	} B;
	int I;
	unsigned int U;

} CBS_TRTGB0L_type;
#define CBS_TRTGB0L	(*( CBS_TRTGB0L_type *) 0xf00004e0u)	/* TG Routing for OTGB0 Bits [7:0] */

typedef volatile union
{
	struct
	{ 
		unsigned int TG8            : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG9            : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG10           : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG11           : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG12           : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG13           : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG14           : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG15           : 4;	/* OTGB1 Bit x to Trigger Line Routing */
	} B;
	int I;
	unsigned int U;

} CBS_TRTGB1H_type;
#define CBS_TRTGB1H	(*( CBS_TRTGB1H_type *) 0xf00004ecu)	/* TG Routing for OTGB1 Bits [15:8] */

typedef volatile union
{
	struct
	{ 
		unsigned int TG0            : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG1            : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG2            : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG3            : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG4            : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG5            : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG6            : 4;	/* OTGB1 Bit x to Trigger Line Routing */
		unsigned int TG7            : 4;	/* OTGB1 Bit x to Trigger Line Routing */
	} B;
	int I;
	unsigned int U;

} CBS_TRTGB1L_type;
#define CBS_TRTGB1L	(*( CBS_TRTGB1L_type *) 0xf00004e8u)	/* TG Routing for OTGB1 Bits [7:0] */


/* ASCLIN */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_ACCEN0_type;
#define ASCLIN0_ACCEN0	(*( ASCLIN0_ACCEN0_type *) 0xf00006fcu)	/* Access Enable Register 0 */
#define ASCLIN1_ACCEN0	(*( ASCLIN0_ACCEN0_type *) 0xf00007fcu)	/* Access Enable Register 0 */
#define ASCLIN2_ACCEN0	(*( ASCLIN0_ACCEN0_type *) 0xf00008fcu)	/* Access Enable Register 0 */
#define ASCLIN3_ACCEN0	(*( ASCLIN0_ACCEN0_type *) 0xf00009fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_ACCEN1_type;
#define ASCLIN0_ACCEN1	(*( ASCLIN0_ACCEN1_type *) 0xf00006f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int PRESCALER      : 12;	/* Prescaling of the Fractional Divider */
		unsigned int                : 4;
		unsigned int OVERSAMPLING   : 4;	/* Oversampling Factor */
		unsigned int                : 4;
		unsigned int SAMPLEPOINT    : 4;	/* Sample Point Position */
		unsigned int                : 3;
		unsigned int SM             : 1;	/* Sample Mode */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_BITCON_type;
#define ASCLIN0_BITCON	(*( ASCLIN0_BITCON_type *) 0xf0000614u)	/* Bit Configuration Register */
#define ASCLIN1_BITCON	(*( ASCLIN0_BITCON_type *) 0xf0000714u)	/* Bit Configuration Register */
#define ASCLIN2_BITCON	(*( ASCLIN0_BITCON_type *) 0xf0000814u)	/* Bit Configuration Register */
#define ASCLIN3_BITCON	(*( ASCLIN0_BITCON_type *) 0xf0000914u)	/* Bit Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LOWERLIMIT     : 8;	/* Lower Limit */
		unsigned int UPPERLIMIT     : 8;	/* Upper Limit */
		/* const */ unsigned int MEASURED       : 12;	/* Measured Value of the Denominator */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_BRD_type;
#define ASCLIN0_BRD	(*( ASCLIN0_BRD_type *) 0xf0000624u)	/* Baud Rate Detection Register */
#define ASCLIN1_BRD	(*( ASCLIN0_BRD_type *) 0xf0000724u)	/* Baud Rate Detection Register */
#define ASCLIN2_BRD	(*( ASCLIN0_BRD_type *) 0xf0000824u)	/* Baud Rate Detection Register */
#define ASCLIN3_BRD	(*( ASCLIN0_BRD_type *) 0xf0000924u)	/* Baud Rate Detection Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DENOMINATOR    : 12;	/* Denominator */
		unsigned int                : 4;
		unsigned int NUMERATOR      : 12;	/* Numerator */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_BRG_type;
#define ASCLIN0_BRG	(*( ASCLIN0_BRG_type *) 0xf0000620u)	/* Baud Rate Generation Register */
#define ASCLIN1_BRG	(*( ASCLIN0_BRG_type *) 0xf0000720u)	/* Baud Rate Generation Register */
#define ASCLIN2_BRG	(*( ASCLIN0_BRG_type *) 0xf0000820u)	/* Baud Rate Generation Register */
#define ASCLIN3_BRG	(*( ASCLIN0_BRG_type *) 0xf0000920u)	/* Baud Rate Generation Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_CLC_type;
#define ASCLIN0_CLC	(*( ASCLIN0_CLC_type *) 0xf0000600u)	/* Clock Control Register */
#define ASCLIN1_CLC	(*( ASCLIN0_CLC_type *) 0xf0000700u)	/* Clock Control Register */
#define ASCLIN2_CLC	(*( ASCLIN0_CLC_type *) 0xf0000800u)	/* Clock Control Register */
#define ASCLIN3_CLC	(*( ASCLIN0_CLC_type *) 0xf0000900u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CLKSEL         : 4;	/* Baud Rate Logic Clock Select */
		unsigned int                : 27;
		/* const */ unsigned int CON            : 1;	/* Clock On Flag */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_CSR_type;
#define ASCLIN0_CSR	(*( ASCLIN0_CSR_type *) 0xf000064cu)	/* Clock Selection Register */
#define ASCLIN1_CSR	(*( ASCLIN0_CSR_type *) 0xf000074cu)	/* Clock Selection Register */
#define ASCLIN2_CSR	(*( ASCLIN0_CSR_type *) 0xf000084cu)	/* Clock Selection Register */
#define ASCLIN3_CSR	(*( ASCLIN0_CSR_type *) 0xf000094cu)	/* Clock Selection Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DATLEN         : 4;	/* Data Length */
		unsigned int                : 9;
		unsigned int HO             : 1;	/* Header Only */
		unsigned int RM             : 1;	/* Response Mode */
		unsigned int CSM            : 1;	/* Checksum Mode */
		unsigned int RESPONSE       : 8;	/* Response Timeout Threshold Value */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_DATCON_type;
#define ASCLIN0_DATCON	(*( ASCLIN0_DATCON_type *) 0xf000061cu)	/* Data Configuration Register */
#define ASCLIN1_DATCON	(*( ASCLIN0_DATCON_type *) 0xf000071cu)	/* Data Configuration Register */
#define ASCLIN2_DATCON	(*( ASCLIN0_DATCON_type *) 0xf000081cu)	/* Data Configuration Register */
#define ASCLIN3_DATCON	(*( ASCLIN0_DATCON_type *) 0xf000091cu)	/* Data Configuration Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TH             : 1;	/* Transmit Header End Flag */
		/* const */ unsigned int TR             : 1;	/* Transmit Response End Flag */
		/* const */ unsigned int RH             : 1;	/* Receive Header End Flag */
		/* const */ unsigned int RR             : 1;	/* Receive Response End Flag */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int FED            : 1;	/* Falling Edge from Level 1 to Level 0 Detected */
		/* const */ unsigned int RED            : 1;	/* Rising Edge from Level 0 to Level 1 Detected */
		/* const */ unsigned int                : 6;
		/* const */ unsigned int TWRQ           : 1;	/* Transmit Wake Request Flag */
		/* const */ unsigned int THRQ           : 1;	/* Transmit Header Request Flag */
		/* const */ unsigned int TRRQ           : 1;	/* Transmit Response Request Flag */
		/* const */ unsigned int PE             : 1;	/* Parity Error Flag */
		/* const */ unsigned int TC             : 1;	/* Transmission Completed Flag */
		/* const */ unsigned int FE             : 1;	/* Framing Error Flag */
		/* const */ unsigned int HT             : 1;	/* Header Timeout Flag */
		/* const */ unsigned int RT             : 1;	/* Response Timeout Flag */
		/* const */ unsigned int BD             : 1;	/* Break Detected Flag */
		/* const */ unsigned int LP             : 1;	/* LIN Parity Error Flag */
		/* const */ unsigned int LA             : 1;	/* LIN Autobaud Detection Error Flag */
		/* const */ unsigned int LC             : 1;	/* LIN Checksum Error Flag */
		/* const */ unsigned int CE             : 1;	/* Collision Detection Error Flag */
		/* const */ unsigned int RFO            : 1;	/* Receive FIFO Overflow Flag */
		/* const */ unsigned int RFU            : 1;	/* Receive FIFO Underflow Flag */
		/* const */ unsigned int RFL            : 1;	/* Receive FIFO Level Flag */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int TFO            : 1;	/* Transmit FIFO Overflow Flag */
		/* const */ unsigned int TFL            : 1;	/* Transmit FIFO Level Flag */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_FLAGS_type;
#define ASCLIN0_FLAGS	(*( ASCLIN0_FLAGS_type *) 0xf0000634u)	/* Flags Register */
#define ASCLIN1_FLAGS	(*( ASCLIN0_FLAGS_type *) 0xf0000734u)	/* Flags Register */
#define ASCLIN2_FLAGS	(*( ASCLIN0_FLAGS_type *) 0xf0000834u)	/* Flags Register */
#define ASCLIN3_FLAGS	(*( ASCLIN0_FLAGS_type *) 0xf0000934u)	/* Flags Register */

typedef volatile union
{
	struct
	{ 
		unsigned int THC            : 1;	/* Flag Clear Bit */
		unsigned int TRC            : 1;	/* Flag Clear Bit */
		unsigned int RHC            : 1;	/* Flag Clear Bit */
		unsigned int RRC            : 1;	/* Flag Clear Bit */
		unsigned int                : 1;
		unsigned int FEDC           : 1;	/* Flag Clear Bit */
		unsigned int REDC           : 1;	/* Flag Clear Bit */
		unsigned int                : 6;
		unsigned int TWRQC          : 1;	/* Flag Clear Bit */
		unsigned int THRQC          : 1;	/* Flag Clear Bit */
		unsigned int TRRQC          : 1;	/* Flag Clear Bit */
		unsigned int PEC            : 1;	/* Flag Clear Bit */
		unsigned int TCC            : 1;	/* Flag Clear Bit */
		unsigned int FEC            : 1;	/* Flag Clear Bit */
		unsigned int HTC            : 1;	/* Flag Clear Bit */
		unsigned int RTC            : 1;	/* Flag Clear Bit */
		unsigned int BDC            : 1;	/* Flag Clear Bit */
		unsigned int LPC            : 1;	/* Flag Clear Bit */
		unsigned int LAC            : 1;	/* Flag Clear Bit */
		unsigned int LCC            : 1;	/* Flag Clear Bit */
		unsigned int CEC            : 1;	/* Flag Clear Bit */
		unsigned int RFOC           : 1;	/* Flag Clear Bit */
		unsigned int RFUC           : 1;	/* Flag Clear Bit */
		unsigned int RFLC           : 1;	/* Flag Clear Bit */
		unsigned int                : 1;
		unsigned int TFOC           : 1;	/* Flag Clear Bit */
		unsigned int TFLC           : 1;	/* Flag Clear Bit */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_FLAGSCLEAR_type;
#define ASCLIN0_FLAGSCLEAR	(*( ASCLIN0_FLAGSCLEAR_type *) 0xf000063cu)	/* Flags Clear Register */
#define ASCLIN1_FLAGSCLEAR	(*( ASCLIN0_FLAGSCLEAR_type *) 0xf000073cu)	/* Flags Clear Register */
#define ASCLIN2_FLAGSCLEAR	(*( ASCLIN0_FLAGSCLEAR_type *) 0xf000083cu)	/* Flags Clear Register */
#define ASCLIN3_FLAGSCLEAR	(*( ASCLIN0_FLAGSCLEAR_type *) 0xf000093cu)	/* Flags Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int THE            : 1;	/* Flag Enable Bit */
		unsigned int TRE            : 1;	/* Flag Enable Bit */
		unsigned int RHE            : 1;	/* Flag Enable Bit */
		unsigned int RRE            : 1;	/* Flag Enable Bit */
		unsigned int                : 1;
		unsigned int FEDE           : 1;	/* Flag Enable Bit */
		unsigned int REDE           : 1;	/* Flag Enable Bit */
		unsigned int                : 9;
		unsigned int PEE            : 1;	/* Flag Enable Bit */
		unsigned int TCE            : 1;	/* Flag Enable Bit */
		unsigned int FEE            : 1;	/* Flag Enable Bit */
		unsigned int HTE            : 1;	/* Flag Enable Bit */
		unsigned int RTE            : 1;	/* Flag Enable Bit */
		unsigned int BDE            : 1;	/* Flag Enable Bit */
		unsigned int LPE            : 1;	/* Flag Enable Bit */
		unsigned int ABE            : 1;	/* Flag Enable Bit */
		unsigned int LCE            : 1;	/* Flag Enable Bit */
		unsigned int CEE            : 1;	/* Flag Enable Bit */
		unsigned int RFOE           : 1;	/* Flag Enable Bit */
		unsigned int RFUE           : 1;	/* Flag Enable Bit */
		unsigned int RFLE           : 1;	/* Flag Enable Bit */
		unsigned int                : 1;
		unsigned int TFOE           : 1;	/* Flag Enable Bit */
		unsigned int TFLE           : 1;	/* Flag Enable Bit */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_FLAGSENABLE_type;
#define ASCLIN0_FLAGSENABLE	(*( ASCLIN0_FLAGSENABLE_type *) 0xf0000640u)	/* Flags Enable Register */
#define ASCLIN1_FLAGSENABLE	(*( ASCLIN0_FLAGSENABLE_type *) 0xf0000740u)	/* Flags Enable Register */
#define ASCLIN2_FLAGSENABLE	(*( ASCLIN0_FLAGSENABLE_type *) 0xf0000840u)	/* Flags Enable Register */
#define ASCLIN3_FLAGSENABLE	(*( ASCLIN0_FLAGSENABLE_type *) 0xf0000940u)	/* Flags Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int THS            : 1;	/* Flag Set Bit */
		unsigned int TRS            : 1;	/* Flag Set Bit */
		unsigned int RHS            : 1;	/* Flag Set Bit */
		unsigned int RRS            : 1;	/* Flag Set Bit */
		unsigned int                : 1;
		unsigned int FEDS           : 1;	/* Flag Set Bit */
		unsigned int REDS           : 1;	/* Flag Set Bit */
		unsigned int                : 6;
		unsigned int TWRQS          : 1;	/* Flag Set Bit */
		unsigned int THRQS          : 1;	/* Flag Set Bit */
		unsigned int TRRQS          : 1;	/* Flag Set Bit */
		unsigned int PES            : 1;	/* Flag Set Bit */
		unsigned int TCS            : 1;	/* Flag Set Bit */
		unsigned int FES            : 1;	/* Flag Set Bit */
		unsigned int HTS            : 1;	/* Flag Set Bit */
		unsigned int RTS            : 1;	/* Flag Set Bit */
		unsigned int BDS            : 1;	/* Flag Set Bit */
		unsigned int LPS            : 1;	/* Flag Set Bit */
		unsigned int LAS            : 1;	/* Flag Set Bit */
		unsigned int LCS            : 1;	/* Flag Set Bit */
		unsigned int CES            : 1;	/* Flag Set Bit */
		unsigned int RFOS           : 1;	/* Flag Set Bit */
		unsigned int RFUS           : 1;	/* Flag Set Bit */
		unsigned int RFLS           : 1;	/* Flag Set Bit */
		unsigned int                : 1;
		unsigned int TFOS           : 1;	/* Flag Set Bit */
		unsigned int TFLS           : 1;	/* Flag Set Bit */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_FLAGSSET_type;
#define ASCLIN0_FLAGSSET	(*( ASCLIN0_FLAGSSET_type *) 0xf0000638u)	/* Flags Set Register */
#define ASCLIN1_FLAGSSET	(*( ASCLIN0_FLAGSSET_type *) 0xf0000738u)	/* Flags Set Register */
#define ASCLIN2_FLAGSSET	(*( ASCLIN0_FLAGSSET_type *) 0xf0000838u)	/* Flags Set Register */
#define ASCLIN3_FLAGSSET	(*( ASCLIN0_FLAGSSET_type *) 0xf0000938u)	/* Flags Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 6;
		unsigned int IDLE           : 3;	/* Duration of the IDLE delay */
		unsigned int STOP           : 3;	/* Number of Stop Bits */
		unsigned int LEAD           : 3;	/* Duration of the Leading Delay */
		unsigned int                : 1;
		unsigned int MODE           : 2;	/* Mode Selection */
		unsigned int                : 10;
		unsigned int MSB            : 1;	/* Shift Direction */
		unsigned int CEN            : 1;	/* Collision Detection Enable */
		unsigned int PEN            : 1;	/* Parity Enable */
		unsigned int ODD            : 1;	/* Parity Type */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_FRAMECON_type;
#define ASCLIN0_FRAMECON	(*( ASCLIN0_FRAMECON_type *) 0xf0000618u)	/* Frame Control Register */
#define ASCLIN1_FRAMECON	(*( ASCLIN0_FRAMECON_type *) 0xf0000718u)	/* Frame Control Register */
#define ASCLIN2_FRAMECON	(*( ASCLIN0_FRAMECON_type *) 0xf0000818u)	/* Frame Control Register */
#define ASCLIN3_FRAMECON	(*( ASCLIN0_FRAMECON_type *) 0xf0000918u)	/* Frame Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_ID_type;
#define ASCLIN0_ID	(*( ASCLIN0_ID_type *) 0xf0000608u)	/* Module Identification Register */
#define ASCLIN1_ID	(*( ASCLIN0_ID_type *) 0xf0000708u)	/* Module Identification Register */
#define ASCLIN2_ID	(*( ASCLIN0_ID_type *) 0xf0000808u)	/* Module Identification Register */
#define ASCLIN3_ID	(*( ASCLIN0_ID_type *) 0xf0000908u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ALTI           : 3;	/* Alternate Input Select */
		unsigned int                : 1;
		unsigned int DEPTH          : 6;	/* Digital Glitch Filter Depth */
		unsigned int                : 6;
		unsigned int CTS            : 2;	/* CTS Select */
		unsigned int                : 7;
		unsigned int RCPOL          : 1;	/* RTS CTS Polarity */
		unsigned int CPOL           : 1;	/* Clock Polarity in Synchronous Mode */
		unsigned int SPOL           : 1;	/* Slave Polarity in Synchronous Mode */
		unsigned int LB             : 1;	/* Loop Back Mode */
		unsigned int CTSEN          : 1;	/* Input Signal CTS Enable */
		/* const */ unsigned int RXM            : 1;	/* Receive Monitor */
		/* const */ unsigned int TXM            : 1;	/* Transmit Monitor */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_IOCR_type;
#define ASCLIN0_IOCR	(*( ASCLIN0_IOCR_type *) 0xf0000604u)	/* Input and Output Control Register */
#define ASCLIN1_IOCR	(*( ASCLIN0_IOCR_type *) 0xf0000704u)	/* Input and Output Control Register */
#define ASCLIN2_IOCR	(*( ASCLIN0_IOCR_type *) 0xf0000804u)	/* Input and Output Control Register */
#define ASCLIN3_IOCR	(*( ASCLIN0_IOCR_type *) 0xf0000904u)	/* Input and Output Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_KRST0_type;
#define ASCLIN0_KRST0	(*( ASCLIN0_KRST0_type *) 0xf00006f4u)	/* Kernel Reset Register 0 */
#define ASCLIN1_KRST0	(*( ASCLIN0_KRST0_type *) 0xf00007f4u)	/* Kernel Reset Register 0 */
#define ASCLIN2_KRST0	(*( ASCLIN0_KRST0_type *) 0xf00008f4u)	/* Kernel Reset Register 0 */
#define ASCLIN3_KRST0	(*( ASCLIN0_KRST0_type *) 0xf00009f4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_KRST1_type;
#define ASCLIN0_KRST1	(*( ASCLIN0_KRST1_type *) 0xf00006f0u)	/* Kernel Reset Register 1 */
#define ASCLIN1_KRST1	(*( ASCLIN0_KRST1_type *) 0xf00007f0u)	/* Kernel Reset Register 1 */
#define ASCLIN2_KRST1	(*( ASCLIN0_KRST1_type *) 0xf00008f0u)	/* Kernel Reset Register 1 */
#define ASCLIN3_KRST1	(*( ASCLIN0_KRST1_type *) 0xf00009f0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_KRSTCLR_type;
#define ASCLIN0_KRSTCLR	(*( ASCLIN0_KRSTCLR_type *) 0xf00006ecu)	/* Kernel Reset Status Clear Register */
#define ASCLIN1_KRSTCLR	(*( ASCLIN0_KRSTCLR_type *) 0xf00007ecu)	/* Kernel Reset Status Clear Register */
#define ASCLIN2_KRSTCLR	(*( ASCLIN0_KRSTCLR_type *) 0xf00008ecu)	/* Kernel Reset Status Clear Register */
#define ASCLIN3_KRSTCLR	(*( ASCLIN0_KRSTCLR_type *) 0xf00009ecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int BREAK          : 6;	/* Break Pulse Generation and Detection */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_LINBTIMER_type;
#define ASCLIN0_LINBTIMER	(*( ASCLIN0_LINBTIMER_type *) 0xf000062cu)	/* LIN Break Timer Register */
#define ASCLIN1_LINBTIMER	(*( ASCLIN0_LINBTIMER_type *) 0xf000072cu)	/* LIN Break Timer Register */
#define ASCLIN2_LINBTIMER	(*( ASCLIN0_LINBTIMER_type *) 0xf000082cu)	/* LIN Break Timer Register */
#define ASCLIN3_LINBTIMER	(*( ASCLIN0_LINBTIMER_type *) 0xf000092cu)	/* LIN Break Timer Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 23;
		unsigned int CSI            : 1;	/* Checksum Injection */
		unsigned int                : 1;
		unsigned int CSEN           : 1;	/* Hardware Checksum Enable */
		unsigned int MS             : 1;	/* Master Slave Mode */
		unsigned int ABD            : 1;	/* Autobaud Detection */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_LINCON_type;
#define ASCLIN0_LINCON	(*( ASCLIN0_LINCON_type *) 0xf0000628u)	/* LIN Control Register */
#define ASCLIN1_LINCON	(*( ASCLIN0_LINCON_type *) 0xf0000728u)	/* LIN Control Register */
#define ASCLIN2_LINCON	(*( ASCLIN0_LINCON_type *) 0xf0000828u)	/* LIN Control Register */
#define ASCLIN3_LINCON	(*( ASCLIN0_LINCON_type *) 0xf0000928u)	/* LIN Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int HEADER         : 8;	/* Header Timeout Threshold Value */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_LINHTIMER_type;
#define ASCLIN0_LINHTIMER	(*( ASCLIN0_LINHTIMER_type *) 0xf0000630u)	/* LIN Header Timer Register */
#define ASCLIN1_LINHTIMER	(*( ASCLIN0_LINHTIMER_type *) 0xf0000730u)	/* LIN Header Timer Register */
#define ASCLIN2_LINHTIMER	(*( ASCLIN0_LINHTIMER_type *) 0xf0000830u)	/* LIN Header Timer Register */
#define ASCLIN3_LINHTIMER	(*( ASCLIN0_LINHTIMER_type *) 0xf0000930u)	/* LIN Header Timer Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_OCS_type;
#define ASCLIN0_OCS	(*( ASCLIN0_OCS_type *) 0xf00006e8u)	/* OCDS Control and Status */
#define ASCLIN1_OCS	(*( ASCLIN0_OCS_type *) 0xf00007e8u)	/* OCDS Control and Status */
#define ASCLIN2_OCS	(*( ASCLIN0_OCS_type *) 0xf00008e8u)	/* OCDS Control and Status */
#define ASCLIN3_OCS	(*( ASCLIN0_OCS_type *) 0xf00009e8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DATA           : 32;	/* Data */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_RXDATA_type;
#define ASCLIN0_RXDATA	(*( ASCLIN0_RXDATA_type *) 0xf0000648u)	/* Receive Data Register */
#define ASCLIN1_RXDATA	(*( ASCLIN0_RXDATA_type *) 0xf0000748u)	/* Receive Data Register */
#define ASCLIN2_RXDATA	(*( ASCLIN0_RXDATA_type *) 0xf0000848u)	/* Receive Data Register */
#define ASCLIN3_RXDATA	(*( ASCLIN0_RXDATA_type *) 0xf0000948u)	/* Receive Data Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FLUSH          : 1;	/* Flush the receive FIFO */
		unsigned int ENI            : 1;	/* Receive FIFO Inlet Enable */
		unsigned int                : 4;
		unsigned int OUTW           : 2;	/* Receive FIFO Outlet Width */
		unsigned int INTLEVEL       : 4;	/* FIFO Interrupt Level */
		unsigned int                : 4;
		/* const */ unsigned int FILL           : 5;	/* FIFO Filling Level */
		unsigned int                : 10;
		unsigned int BUF            : 1;	/* Receive Buffer Mode */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_RXFIFOCON_type;
#define ASCLIN0_RXFIFOCON	(*( ASCLIN0_RXFIFOCON_type *) 0xf0000610u)	/* RX FIFO Configuration Register */
#define ASCLIN1_RXFIFOCON	(*( ASCLIN0_RXFIFOCON_type *) 0xf0000710u)	/* RX FIFO Configuration Register */
#define ASCLIN2_RXFIFOCON	(*( ASCLIN0_RXFIFOCON_type *) 0xf0000810u)	/* RX FIFO Configuration Register */
#define ASCLIN3_RXFIFOCON	(*( ASCLIN0_RXFIFOCON_type *) 0xf0000910u)	/* RX FIFO Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DATA           : 32;	/* Data */
	} B;
	int I;
	unsigned int U;

} ASCLIN0_TXDATA_type;
#define ASCLIN0_TXDATA	(*( ASCLIN0_TXDATA_type *) 0xf0000644u)	/* Transmit Data Register */
#define ASCLIN1_TXDATA	(*( ASCLIN0_TXDATA_type *) 0xf0000744u)	/* Transmit Data Register */
#define ASCLIN2_TXDATA	(*( ASCLIN0_TXDATA_type *) 0xf0000844u)	/* Transmit Data Register */
#define ASCLIN3_TXDATA	(*( ASCLIN0_TXDATA_type *) 0xf0000944u)	/* Transmit Data Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FLUSH          : 1;	/* Flush the transmit FIFO */
		unsigned int ENO            : 1;	/* Transmit FIFO Outlet Enable */
		unsigned int                : 4;
		unsigned int INW            : 2;	/* Transmit FIFO Inlet Width */
		unsigned int INTLEVEL       : 4;	/* FIFO Interrupt Level */
		unsigned int                : 4;
		/* const */ unsigned int FILL           : 5;	/* FIFO Filling Level */
		unsigned int                : 11;
	} B;
	int I;
	unsigned int U;

} ASCLIN0_TXFIFOCON_type;
#define ASCLIN0_TXFIFOCON	(*( ASCLIN0_TXFIFOCON_type *) 0xf000060cu)	/* TX FIFO Configuration Register */
#define ASCLIN1_TXFIFOCON	(*( ASCLIN0_TXFIFOCON_type *) 0xf000070cu)	/* TX FIFO Configuration Register */
#define ASCLIN2_TXFIFOCON	(*( ASCLIN0_TXFIFOCON_type *) 0xf000080cu)	/* TX FIFO Configuration Register */
#define ASCLIN3_TXFIFOCON	(*( ASCLIN0_TXFIFOCON_type *) 0xf000090cu)	/* TX FIFO Configuration Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} ASCLIN1_ACCEN1_type;
#define ASCLIN1_ACCEN1	(*( ASCLIN1_ACCEN1_type *) 0xf00007f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} ASCLIN2_ACCEN1_type;
#define ASCLIN2_ACCEN1	(*( ASCLIN2_ACCEN1_type *) 0xf00008f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} ASCLIN3_ACCEN1_type;
#define ASCLIN3_ACCEN1	(*( ASCLIN3_ACCEN1_type *) 0xf00009f8u)	/* Access Enable Register 1 */


/* QSPI */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} QSPI0_ACCEN0_type;
#define QSPI0_ACCEN0	(*( QSPI0_ACCEN0_type *) 0xf0001cfcu)	/* Access Enable Register 0 */
#define QSPI1_ACCEN0	(*( QSPI0_ACCEN0_type *) 0xf0001dfcu)	/* Access Enable Register 0 */
#define QSPI2_ACCEN0	(*( QSPI0_ACCEN0_type *) 0xf0001efcu)	/* Access Enable Register 0 */
#define QSPI3_ACCEN0	(*( QSPI0_ACCEN0_type *) 0xf0001ffcu)	/* Access Enable Register 0 */
#define QSPI4_ACCEN0	(*( QSPI0_ACCEN0_type *) 0xf00020fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} QSPI0_ACCEN1_type;
#define QSPI0_ACCEN1	(*( QSPI0_ACCEN1_type *) 0xf0001cf8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int LAST           : 1;	/* Last Word in a Frame */
		/* const */ unsigned int IPRE           : 3;	/* Prescaler for the Idle Delay */
		/* const */ unsigned int IDLE           : 3;	/* Idle Delay Length */
		/* const */ unsigned int LPRE           : 3;	/* Prescaler for the Leading Delay */
		/* const */ unsigned int LEAD           : 3;	/* Leading Delay Length */
		/* const */ unsigned int TPRE           : 3;	/* Prescaler for the Trailing Delay */
		/* const */ unsigned int TRAIL          : 3;	/* Trailing Delay Length */
		/* const */ unsigned int PARTYP         : 1;	/* Parity Type */
		/* const */ unsigned int UINT           : 1;	/* User Interrupt at the PT1 Event in the Subsequent Frames */
		/* const */ unsigned int MSB            : 1;	/* Shift MSB or LSB First */
		/* const */ unsigned int BYTE           : 1;	/* Byte */
		/* const */ unsigned int DL             : 5;	/* Data Length */
		/* const */ unsigned int CS             : 4;	/* Channel Select */
	} B;
	int I;
	unsigned int U;

} QSPI0_BACON_type;
#define QSPI0_BACON	(*( QSPI0_BACON_type *) 0xf0001c18u)	/* Basic Configuration Register */
#define QSPI1_BACON	(*( QSPI0_BACON_type *) 0xf0001d18u)	/* Basic Configuration Register */
#define QSPI2_BACON	(*( QSPI0_BACON_type *) 0xf0001e18u)	/* Basic Configuration Register */
#define QSPI3_BACON	(*( QSPI0_BACON_type *) 0xf0001f18u)	/* Basic Configuration Register */
#define QSPI4_BACON	(*( QSPI0_BACON_type *) 0xf0002018u)	/* Basic Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int E              : 32;	/* Entry Point to the TxFIFO */
	} B;
	int I;
	unsigned int U;

} QSPI0_BACONENTRY_type;
#define QSPI0_BACONENTRY	(*( QSPI0_BACONENTRY_type *) 0xf0001c60u)	/* BACON_ENTRY Register */
#define QSPI0_DATAENTRY0	(*( QSPI0_BACONENTRY_type *) 0xf0001c64u)	/* DATA_ENTRY Register 0 */
#define QSPI0_DATAENTRY1	(*( QSPI0_BACONENTRY_type *) 0xf0001c68u)	/* DATA_ENTRY Register 1 */
#define QSPI0_DATAENTRY2	(*( QSPI0_BACONENTRY_type *) 0xf0001c6cu)	/* DATA_ENTRY Register 2 */
#define QSPI0_DATAENTRY3	(*( QSPI0_BACONENTRY_type *) 0xf0001c70u)	/* DATA_ENTRY Register 3 */
#define QSPI0_DATAENTRY4	(*( QSPI0_BACONENTRY_type *) 0xf0001c74u)	/* DATA_ENTRY Register 4 */
#define QSPI0_DATAENTRY5	(*( QSPI0_BACONENTRY_type *) 0xf0001c78u)	/* DATA_ENTRY Register 5 */
#define QSPI0_DATAENTRY6	(*( QSPI0_BACONENTRY_type *) 0xf0001c7cu)	/* DATA_ENTRY Register 6 */
#define QSPI0_DATAENTRY7	(*( QSPI0_BACONENTRY_type *) 0xf0001c80u)	/* DATA_ENTRY Register 7 */
#define QSPI0_MIXENTRY	(*( QSPI0_BACONENTRY_type *) 0xf0001c5cu)	/* MIX_ENTRY Register */
#define QSPI1_BACONENTRY	(*( QSPI0_BACONENTRY_type *) 0xf0001d60u)	/* BACON_ENTRY Register */
#define QSPI1_DATAENTRY0	(*( QSPI0_BACONENTRY_type *) 0xf0001d64u)	/* DATA_ENTRY Register 0 */
#define QSPI1_DATAENTRY1	(*( QSPI0_BACONENTRY_type *) 0xf0001d68u)	/* DATA_ENTRY Register 1 */
#define QSPI1_DATAENTRY2	(*( QSPI0_BACONENTRY_type *) 0xf0001d6cu)	/* DATA_ENTRY Register 2 */
#define QSPI1_DATAENTRY3	(*( QSPI0_BACONENTRY_type *) 0xf0001d70u)	/* DATA_ENTRY Register 3 */
#define QSPI1_DATAENTRY4	(*( QSPI0_BACONENTRY_type *) 0xf0001d74u)	/* DATA_ENTRY Register 4 */
#define QSPI1_DATAENTRY5	(*( QSPI0_BACONENTRY_type *) 0xf0001d78u)	/* DATA_ENTRY Register 5 */
#define QSPI1_DATAENTRY6	(*( QSPI0_BACONENTRY_type *) 0xf0001d7cu)	/* DATA_ENTRY Register 6 */
#define QSPI1_DATAENTRY7	(*( QSPI0_BACONENTRY_type *) 0xf0001d80u)	/* DATA_ENTRY Register 7 */
#define QSPI1_MIXENTRY	(*( QSPI0_BACONENTRY_type *) 0xf0001d5cu)	/* MIX_ENTRY Register */
#define QSPI2_BACONENTRY	(*( QSPI0_BACONENTRY_type *) 0xf0001e60u)	/* BACON_ENTRY Register */
#define QSPI2_DATAENTRY0	(*( QSPI0_BACONENTRY_type *) 0xf0001e64u)	/* DATA_ENTRY Register 0 */
#define QSPI2_DATAENTRY1	(*( QSPI0_BACONENTRY_type *) 0xf0001e68u)	/* DATA_ENTRY Register 1 */
#define QSPI2_DATAENTRY2	(*( QSPI0_BACONENTRY_type *) 0xf0001e6cu)	/* DATA_ENTRY Register 2 */
#define QSPI2_DATAENTRY3	(*( QSPI0_BACONENTRY_type *) 0xf0001e70u)	/* DATA_ENTRY Register 3 */
#define QSPI2_DATAENTRY4	(*( QSPI0_BACONENTRY_type *) 0xf0001e74u)	/* DATA_ENTRY Register 4 */
#define QSPI2_DATAENTRY5	(*( QSPI0_BACONENTRY_type *) 0xf0001e78u)	/* DATA_ENTRY Register 5 */
#define QSPI2_DATAENTRY6	(*( QSPI0_BACONENTRY_type *) 0xf0001e7cu)	/* DATA_ENTRY Register 6 */
#define QSPI2_DATAENTRY7	(*( QSPI0_BACONENTRY_type *) 0xf0001e80u)	/* DATA_ENTRY Register 7 */
#define QSPI2_MIXENTRY	(*( QSPI0_BACONENTRY_type *) 0xf0001e5cu)	/* MIX_ENTRY Register */
#define QSPI3_BACONENTRY	(*( QSPI0_BACONENTRY_type *) 0xf0001f60u)	/* BACON_ENTRY Register */
#define QSPI3_DATAENTRY0	(*( QSPI0_BACONENTRY_type *) 0xf0001f64u)	/* DATA_ENTRY Register 0 */
#define QSPI3_DATAENTRY1	(*( QSPI0_BACONENTRY_type *) 0xf0001f68u)	/* DATA_ENTRY Register 1 */
#define QSPI3_DATAENTRY2	(*( QSPI0_BACONENTRY_type *) 0xf0001f6cu)	/* DATA_ENTRY Register 2 */
#define QSPI3_DATAENTRY3	(*( QSPI0_BACONENTRY_type *) 0xf0001f70u)	/* DATA_ENTRY Register 3 */
#define QSPI3_DATAENTRY4	(*( QSPI0_BACONENTRY_type *) 0xf0001f74u)	/* DATA_ENTRY Register 4 */
#define QSPI3_DATAENTRY5	(*( QSPI0_BACONENTRY_type *) 0xf0001f78u)	/* DATA_ENTRY Register 5 */
#define QSPI3_DATAENTRY6	(*( QSPI0_BACONENTRY_type *) 0xf0001f7cu)	/* DATA_ENTRY Register 6 */
#define QSPI3_DATAENTRY7	(*( QSPI0_BACONENTRY_type *) 0xf0001f80u)	/* DATA_ENTRY Register 7 */
#define QSPI3_MIXENTRY	(*( QSPI0_BACONENTRY_type *) 0xf0001f5cu)	/* MIX_ENTRY Register */
#define QSPI4_BACONENTRY	(*( QSPI0_BACONENTRY_type *) 0xf0002060u)	/* BACON_ENTRY Register */
#define QSPI4_DATAENTRY0	(*( QSPI0_BACONENTRY_type *) 0xf0002064u)	/* DATA_ENTRY Register 0 */
#define QSPI4_DATAENTRY1	(*( QSPI0_BACONENTRY_type *) 0xf0002068u)	/* DATA_ENTRY Register 1 */
#define QSPI4_DATAENTRY2	(*( QSPI0_BACONENTRY_type *) 0xf000206cu)	/* DATA_ENTRY Register 2 */
#define QSPI4_DATAENTRY3	(*( QSPI0_BACONENTRY_type *) 0xf0002070u)	/* DATA_ENTRY Register 3 */
#define QSPI4_DATAENTRY4	(*( QSPI0_BACONENTRY_type *) 0xf0002074u)	/* DATA_ENTRY Register 4 */
#define QSPI4_DATAENTRY5	(*( QSPI0_BACONENTRY_type *) 0xf0002078u)	/* DATA_ENTRY Register 5 */
#define QSPI4_DATAENTRY6	(*( QSPI0_BACONENTRY_type *) 0xf000207cu)	/* DATA_ENTRY Register 6 */
#define QSPI4_DATAENTRY7	(*( QSPI0_BACONENTRY_type *) 0xf0002080u)	/* DATA_ENTRY Register 7 */
#define QSPI4_MIXENTRY	(*( QSPI0_BACONENTRY_type *) 0xf000205cu)	/* MIX_ENTRY Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		unsigned int IPRE           : 3;	/* Prescaler for the Idle Delay */
		unsigned int IDLE           : 3;	/* Idle Delay Length */
		unsigned int LPRE           : 3;	/* Prescaler for the Leading Delay */
		unsigned int LEAD           : 3;	/* Leading Delay Length */
		unsigned int TPRE           : 3;	/* Prescaler for the Trailing Delay */
		unsigned int TRAIL          : 3;	/* Trailing Delay Length */
		unsigned int PARTYP         : 1;	/* Parity Type */
		unsigned int                : 1;
		unsigned int MSB            : 1;	/* Shift MSB or LSB First */
		unsigned int                : 1;
		unsigned int DL             : 5;	/* Data Length */
		unsigned int CS             : 4;	/* Channel Select */
	} B;
	int I;
	unsigned int U;

} QSPI0_BACONPWM_type;
#define QSPI0_BACONPWM	(*( QSPI0_BACONPWM_type *) 0xf0001c1cu)	/* Basic Configuration Register 1 */
#define QSPI1_BACONPWM	(*( QSPI0_BACONPWM_type *) 0xf0001d1cu)	/* Basic Configuration Register 1 */
#define QSPI2_BACONPWM	(*( QSPI0_BACONPWM_type *) 0xf0001e1cu)	/* Basic Configuration Register 1 */
#define QSPI3_BACONPWM	(*( QSPI0_BACONPWM_type *) 0xf0001f1cu)	/* Basic Configuration Register 1 */
#define QSPI4_BACONPWM	(*( QSPI0_BACONPWM_type *) 0xf000201cu)	/* Basic Configuration Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} QSPI0_CLC_type;
#define QSPI0_CLC	(*( QSPI0_CLC_type *) 0xf0001c00u)	/* Clock Control Register */
#define QSPI1_CLC	(*( QSPI0_CLC_type *) 0xf0001d00u)	/* Clock Control Register */
#define QSPI2_CLC	(*( QSPI0_CLC_type *) 0xf0001e00u)	/* Clock Control Register */
#define QSPI3_CLC	(*( QSPI0_CLC_type *) 0xf0001f00u)	/* Clock Control Register */
#define QSPI4_CLC	(*( QSPI0_CLC_type *) 0xf0002000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int Q              : 6;	/* Time Quantum */
		unsigned int A              : 2;	/* Bit Segment 1 */
		unsigned int B              : 2;	/* Bit Segment 2 */
		unsigned int C              : 2;	/* Bit Segment 3 */
		unsigned int CPH            : 1;	/* Clock Phase */
		unsigned int CPOL           : 1;	/* Clock Polarity */
		unsigned int PAREN          : 1;	/* Enable Parity Check */
		unsigned int                : 17;
	} B;
	int I;
	unsigned int U;

} QSPI0_ECON0_type;
#define QSPI0_ECON0	(*( QSPI0_ECON0_type *) 0xf0001c20u)	/* Configuration Extension 0 */
#define QSPI0_ECON1	(*( QSPI0_ECON0_type *) 0xf0001c24u)	/* Configuration Extension 1 */
#define QSPI0_ECON2	(*( QSPI0_ECON0_type *) 0xf0001c28u)	/* Configuration Extension 2 */
#define QSPI0_ECON3	(*( QSPI0_ECON0_type *) 0xf0001c2cu)	/* Configuration Extension 3 */
#define QSPI0_ECON4	(*( QSPI0_ECON0_type *) 0xf0001c30u)	/* Configuration Extension 4 */
#define QSPI0_ECON5	(*( QSPI0_ECON0_type *) 0xf0001c34u)	/* Configuration Extension 5 */
#define QSPI0_ECON6	(*( QSPI0_ECON0_type *) 0xf0001c38u)	/* Configuration Extension 6 */
#define QSPI0_ECON7	(*( QSPI0_ECON0_type *) 0xf0001c3cu)	/* Configuration Extension 7 */
#define QSPI1_ECON0	(*( QSPI0_ECON0_type *) 0xf0001d20u)	/* Configuration Extension 0 */
#define QSPI1_ECON1	(*( QSPI0_ECON0_type *) 0xf0001d24u)	/* Configuration Extension 1 */
#define QSPI1_ECON2	(*( QSPI0_ECON0_type *) 0xf0001d28u)	/* Configuration Extension 2 */
#define QSPI1_ECON3	(*( QSPI0_ECON0_type *) 0xf0001d2cu)	/* Configuration Extension 3 */
#define QSPI1_ECON4	(*( QSPI0_ECON0_type *) 0xf0001d30u)	/* Configuration Extension 4 */
#define QSPI1_ECON5	(*( QSPI0_ECON0_type *) 0xf0001d34u)	/* Configuration Extension 5 */
#define QSPI1_ECON6	(*( QSPI0_ECON0_type *) 0xf0001d38u)	/* Configuration Extension 6 */
#define QSPI1_ECON7	(*( QSPI0_ECON0_type *) 0xf0001d3cu)	/* Configuration Extension 7 */
#define QSPI2_ECON0	(*( QSPI0_ECON0_type *) 0xf0001e20u)	/* Configuration Extension 0 */
#define QSPI2_ECON1	(*( QSPI0_ECON0_type *) 0xf0001e24u)	/* Configuration Extension 1 */
#define QSPI2_ECON2	(*( QSPI0_ECON0_type *) 0xf0001e28u)	/* Configuration Extension 2 */
#define QSPI2_ECON3	(*( QSPI0_ECON0_type *) 0xf0001e2cu)	/* Configuration Extension 3 */
#define QSPI2_ECON4	(*( QSPI0_ECON0_type *) 0xf0001e30u)	/* Configuration Extension 4 */
#define QSPI2_ECON5	(*( QSPI0_ECON0_type *) 0xf0001e34u)	/* Configuration Extension 5 */
#define QSPI2_ECON6	(*( QSPI0_ECON0_type *) 0xf0001e38u)	/* Configuration Extension 6 */
#define QSPI2_ECON7	(*( QSPI0_ECON0_type *) 0xf0001e3cu)	/* Configuration Extension 7 */
#define QSPI3_ECON0	(*( QSPI0_ECON0_type *) 0xf0001f20u)	/* Configuration Extension 0 */
#define QSPI3_ECON1	(*( QSPI0_ECON0_type *) 0xf0001f24u)	/* Configuration Extension 1 */
#define QSPI3_ECON2	(*( QSPI0_ECON0_type *) 0xf0001f28u)	/* Configuration Extension 2 */
#define QSPI3_ECON3	(*( QSPI0_ECON0_type *) 0xf0001f2cu)	/* Configuration Extension 3 */
#define QSPI3_ECON4	(*( QSPI0_ECON0_type *) 0xf0001f30u)	/* Configuration Extension 4 */
#define QSPI3_ECON5	(*( QSPI0_ECON0_type *) 0xf0001f34u)	/* Configuration Extension 5 */
#define QSPI3_ECON6	(*( QSPI0_ECON0_type *) 0xf0001f38u)	/* Configuration Extension 6 */
#define QSPI3_ECON7	(*( QSPI0_ECON0_type *) 0xf0001f3cu)	/* Configuration Extension 7 */
#define QSPI4_ECON0	(*( QSPI0_ECON0_type *) 0xf0002020u)	/* Configuration Extension 0 */
#define QSPI4_ECON1	(*( QSPI0_ECON0_type *) 0xf0002024u)	/* Configuration Extension 1 */
#define QSPI4_ECON2	(*( QSPI0_ECON0_type *) 0xf0002028u)	/* Configuration Extension 2 */
#define QSPI4_ECON3	(*( QSPI0_ECON0_type *) 0xf000202cu)	/* Configuration Extension 3 */
#define QSPI4_ECON4	(*( QSPI0_ECON0_type *) 0xf0002030u)	/* Configuration Extension 4 */
#define QSPI4_ECON5	(*( QSPI0_ECON0_type *) 0xf0002034u)	/* Configuration Extension 5 */
#define QSPI4_ECON6	(*( QSPI0_ECON0_type *) 0xf0002038u)	/* Configuration Extension 6 */
#define QSPI4_ECON7	(*( QSPI0_ECON0_type *) 0xf000203cu)	/* Configuration Extension 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int ERRORCLEARS    : 9;	/* Write Only Bits for Clearing the Error Flags */
		unsigned int TXC            : 1;	/* Transmit Event Flag Clear */
		unsigned int RXC            : 1;	/* Receive Event Flag Clear */
		unsigned int PT1C           : 1;	/* PT1 Event Flag Clear */
		unsigned int PT2C           : 1;	/* PT2 Event Flag Clear */
		unsigned int HC1C           : 1;	/* HC1 Event Flag Clear */
		unsigned int HC2C           : 1;	/* HC2 Event Flag Clear */
		unsigned int USRC           : 1;	/* User Event Flag Clear */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} QSPI0_FLAGSCLEAR_type;
#define QSPI0_FLAGSCLEAR	(*( QSPI0_FLAGSCLEAR_type *) 0xf0001c54u)	/* Flags Clear Register */
#define QSPI1_FLAGSCLEAR	(*( QSPI0_FLAGSCLEAR_type *) 0xf0001d54u)	/* Flags Clear Register */
#define QSPI2_FLAGSCLEAR	(*( QSPI0_FLAGSCLEAR_type *) 0xf0001e54u)	/* Flags Clear Register */
#define QSPI3_FLAGSCLEAR	(*( QSPI0_FLAGSCLEAR_type *) 0xf0001f54u)	/* Flags Clear Register */
#define QSPI4_FLAGSCLEAR	(*( QSPI0_FLAGSCLEAR_type *) 0xf0002054u)	/* Flags Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TQ             : 8;	/* Global Time Quantum Length */
		unsigned int                : 1;
		unsigned int SI             : 1;	/* Status Injection */
		unsigned int EXPECT         : 4;	/* Time-Out Value for the Expect Phase */
		unsigned int LB             : 1;	/* Loop-Back Control */
		unsigned int DEL0           : 1;	/* Delayed Mode for SLSO0 */
		unsigned int STROBE         : 5;	/* Strobe Delay for SLSO0 in Delayed Mode */
		unsigned int SRF            : 1;	/* Stop on RxFIFO Full */
		unsigned int STIP           : 1;	/* Slave Transmit Idle State Polarity */
		unsigned int                : 1;
		unsigned int EN             : 1;	/* Enable Bit */
		unsigned int MS             : 2;	/* Master Slave Mode */
		unsigned int AREN           : 1;	/* Automatic Reset Enable */
		unsigned int RESETS         : 4;	/* Bits for resetting sub-modules per software */
	} B;
	int I;
	unsigned int U;

} QSPI0_GLOBALCON_type;
#define QSPI0_GLOBALCON	(*( QSPI0_GLOBALCON_type *) 0xf0001c10u)	/* Global Configuration Register */
#define QSPI1_GLOBALCON	(*( QSPI0_GLOBALCON_type *) 0xf0001d10u)	/* Global Configuration Register */
#define QSPI2_GLOBALCON	(*( QSPI0_GLOBALCON_type *) 0xf0001e10u)	/* Global Configuration Register */
#define QSPI3_GLOBALCON	(*( QSPI0_GLOBALCON_type *) 0xf0001f10u)	/* Global Configuration Register */
#define QSPI4_GLOBALCON	(*( QSPI0_GLOBALCON_type *) 0xf0002010u)	/* Global Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ERRORENS       : 9;	/* Error Enable Bits */
		unsigned int TXEN           : 1;	/* Tx Interrupt Event Enable */
		unsigned int RXEN           : 1;	/* RX Interrupt Event Enable */
		unsigned int PT1EN          : 1;	/* Interrupt on PT1 Event Enable */
		unsigned int PT2EN          : 1;	/* Interrupt on PT2 Event Enable */
		unsigned int HC1EN          : 1;	/* Interrupt on HC1 Event Enable */
		unsigned int HC2EN          : 1;	/* Interrupt on HC2 Event Enable */
		unsigned int USREN          : 1;	/* Interrupt on USR Event Enable */
		unsigned int TXFIFOINT      : 2;	/* Transmit FIFO Interrupt Threshold */
		unsigned int RXFIFOINT      : 2;	/* Receive FIFO Interrupt Threshold */
		unsigned int PT1            : 3;	/* Phase Transition Event 1 */
		unsigned int PT2            : 3;	/* Phase Transition Event 2 */
		unsigned int TXFM           : 2;	/* TXFIFO Mode */
		unsigned int RXFM           : 2;	/* RXFIFO Mode */
		unsigned int PWMVIOEN       : 1;	/* PWM Time Window Violation Interrupt */
		unsigned int TVIOEN         : 1;	/* Tx FIFO Time Window Violation Interrupt */
	} B;
	int I;
	unsigned int U;

} QSPI0_GLOBALCON1_type;
#define QSPI0_GLOBALCON1	(*( QSPI0_GLOBALCON1_type *) 0xf0001c14u)	/* Global Configuration Register 1 */
#define QSPI1_GLOBALCON1	(*( QSPI0_GLOBALCON1_type *) 0xf0001d14u)	/* Global Configuration Register 1 */
#define QSPI2_GLOBALCON1	(*( QSPI0_GLOBALCON1_type *) 0xf0001e14u)	/* Global Configuration Register 1 */
#define QSPI3_GLOBALCON1	(*( QSPI0_GLOBALCON1_type *) 0xf0001f14u)	/* Global Configuration Register 1 */
#define QSPI4_GLOBALCON1	(*( QSPI0_GLOBALCON1_type *) 0xf0002014u)	/* Global Configuration Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} QSPI0_ID_type;
#define QSPI0_ID	(*( QSPI0_ID_type *) 0xf0001c08u)	/* Module Identification Register */
#define QSPI1_ID	(*( QSPI0_ID_type *) 0xf0001d08u)	/* Module Identification Register */
#define QSPI2_ID	(*( QSPI0_ID_type *) 0xf0001e08u)	/* Module Identification Register */
#define QSPI3_ID	(*( QSPI0_ID_type *) 0xf0001f08u)	/* Module Identification Register */
#define QSPI4_ID	(*( QSPI0_ID_type *) 0xf0002008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int INJECT         : 32;	/* Inject */
	} B;
	int I;
	unsigned int U;

} QSPI0_INJECT_type;
#define QSPI0_INJECT	(*( QSPI0_INJECT_type *) 0xf0001c50u)	/* Inject Register */
#define QSPI1_INJECT	(*( QSPI0_INJECT_type *) 0xf0001d50u)	/* Inject Register */
#define QSPI2_INJECT	(*( QSPI0_INJECT_type *) 0xf0001e50u)	/* Inject Register */
#define QSPI3_INJECT	(*( QSPI0_INJECT_type *) 0xf0001f50u)	/* Inject Register */
#define QSPI4_INJECT	(*( QSPI0_INJECT_type *) 0xf0002050u)	/* Inject Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} QSPI0_KRST0_type;
#define QSPI0_KRST0	(*( QSPI0_KRST0_type *) 0xf0001cf4u)	/* Kernel Reset Register 0 */
#define QSPI1_KRST0	(*( QSPI0_KRST0_type *) 0xf0001df4u)	/* Kernel Reset Register 0 */
#define QSPI2_KRST0	(*( QSPI0_KRST0_type *) 0xf0001ef4u)	/* Kernel Reset Register 0 */
#define QSPI3_KRST0	(*( QSPI0_KRST0_type *) 0xf0001ff4u)	/* Kernel Reset Register 0 */
#define QSPI4_KRST0	(*( QSPI0_KRST0_type *) 0xf00020f4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} QSPI0_KRST1_type;
#define QSPI0_KRST1	(*( QSPI0_KRST1_type *) 0xf0001cf0u)	/* Kernel Reset Register 1 */
#define QSPI1_KRST1	(*( QSPI0_KRST1_type *) 0xf0001df0u)	/* Kernel Reset Register 1 */
#define QSPI2_KRST1	(*( QSPI0_KRST1_type *) 0xf0001ef0u)	/* Kernel Reset Register 1 */
#define QSPI3_KRST1	(*( QSPI0_KRST1_type *) 0xf0001ff0u)	/* Kernel Reset Register 1 */
#define QSPI4_KRST1	(*( QSPI0_KRST1_type *) 0xf00020f0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} QSPI0_KRSTCLR_type;
#define QSPI0_KRSTCLR	(*( QSPI0_KRSTCLR_type *) 0xf0001cecu)	/* Kernel Reset Status Clear Register */
#define QSPI1_KRSTCLR	(*( QSPI0_KRSTCLR_type *) 0xf0001decu)	/* Kernel Reset Status Clear Register */
#define QSPI2_KRSTCLR	(*( QSPI0_KRSTCLR_type *) 0xf0001eecu)	/* Kernel Reset Status Clear Register */
#define QSPI3_KRSTCLR	(*( QSPI0_KRSTCLR_type *) 0xf0001fecu)	/* Kernel Reset Status Clear Register */
#define QSPI4_KRSTCLR	(*( QSPI0_KRSTCLR_type *) 0xf00020ecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MASK           : 32;	/* Mask */
	} B;
	int I;
	unsigned int U;

} QSPI0_MASK_type;
#define QSPI0_MASK	(*( QSPI0_MASK_type *) 0xf0001c4cu)	/* Mask Register */
#define QSPI1_MASK	(*( QSPI0_MASK_type *) 0xf0001d4cu)	/* Mask Register */
#define QSPI2_MASK	(*( QSPI0_MASK_type *) 0xf0001e4cu)	/* Mask Register */
#define QSPI3_MASK	(*( QSPI0_MASK_type *) 0xf0001f4cu)	/* Mask Register */
#define QSPI4_MASK	(*( QSPI0_MASK_type *) 0xf000204cu)	/* Mask Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} QSPI0_OCS_type;
#define QSPI0_OCS	(*( QSPI0_OCS_type *) 0xf0001ce8u)	/* OCDS Control and Status */
#define QSPI1_OCS	(*( QSPI0_OCS_type *) 0xf0001de8u)	/* OCDS Control and Status */
#define QSPI2_OCS	(*( QSPI0_OCS_type *) 0xf0001ee8u)	/* OCDS Control and Status */
#define QSPI3_OCS	(*( QSPI0_OCS_type *) 0xf0001fe8u)	/* OCDS Control and Status */
#define QSPI4_OCS	(*( QSPI0_OCS_type *) 0xf00020e8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		unsigned int MRIS           : 3;	/* Master Mode Receive Input Select */
		unsigned int                : 1;
		unsigned int SRIS           : 3;	/* Slave Mode Receive Input Select */
		unsigned int                : 1;
		unsigned int SCIS           : 3;	/* Slave Mode Clock Input Select */
		unsigned int                : 1;
		unsigned int SLSIS          : 3;	/* Slave Mode Slave Select Input Selection */
		unsigned int                : 17;
	} B;
	int I;
	unsigned int U;

} QSPI0_PISEL_type;
#define QSPI0_PISEL	(*( QSPI0_PISEL_type *) 0xf0001c04u)	/* Port Input Select Register */
#define QSPI1_PISEL	(*( QSPI0_PISEL_type *) 0xf0001d04u)	/* Port Input Select Register */
#define QSPI2_PISEL	(*( QSPI0_PISEL_type *) 0xf0001e04u)	/* Port Input Select Register */
#define QSPI3_PISEL	(*( QSPI0_PISEL_type *) 0xf0001f04u)	/* Port Input Select Register */
#define QSPI4_PISEL	(*( QSPI0_PISEL_type *) 0xf0002004u)	/* Port Input Select Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int E              : 32;	/* Read Point from the RxFIFO */
	} B;
	int I;
	unsigned int U;

} QSPI0_RXEXIT_type;
#define QSPI0_RXEXIT	(*( QSPI0_RXEXIT_type *) 0xf0001c90u)	/* RX_EXIT Register */
#define QSPI1_RXEXIT	(*( QSPI0_RXEXIT_type *) 0xf0001d90u)	/* RX_EXIT Register */
#define QSPI2_RXEXIT	(*( QSPI0_RXEXIT_type *) 0xf0001e90u)	/* RX_EXIT Register */
#define QSPI3_RXEXIT	(*( QSPI0_RXEXIT_type *) 0xf0001f90u)	/* RX_EXIT Register */
#define QSPI4_RXEXIT	(*( QSPI0_RXEXIT_type *) 0xf0002090u)	/* RX_EXIT Register */

typedef volatile union
{
	struct
	{ 
		unsigned int AOL            : 16;	/* Active Output Level for the SLSO Outputs */
		unsigned int OEN            : 16;	/* Enable Bits for the SLSO Outputs */
	} B;
	int I;
	unsigned int U;

} QSPI0_SSOC_type;
#define QSPI0_SSOC	(*( QSPI0_SSOC_type *) 0xf0001c48u)	/* Slave Select Output Control Register */
#define QSPI1_SSOC	(*( QSPI0_SSOC_type *) 0xf0001d48u)	/* Slave Select Output Control Register */
#define QSPI2_SSOC	(*( QSPI0_SSOC_type *) 0xf0001e48u)	/* Slave Select Output Control Register */
#define QSPI3_SSOC	(*( QSPI0_SSOC_type *) 0xf0001f48u)	/* Slave Select Output Control Register */
#define QSPI4_SSOC	(*( QSPI0_SSOC_type *) 0xf0002048u)	/* Slave Select Output Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ERRORFLAGS     : 9;	/* Sticky Flags Signalling Errors */
		unsigned int TXF            : 1;	/* Transmit Interrupt Request Flag */
		unsigned int RXF            : 1;	/* Receive Interrupt Request Flag */
		unsigned int PT1F           : 1;	/* Phase Transition 1 Flag */
		unsigned int PT2F           : 1;	/* Phase Transition 2 Flag */
		unsigned int HC1F           : 1;	/* PWM Half Cycle 1 Flag */
		unsigned int HC2F           : 1;	/* PWM Half Cycle 2 Flag */
		unsigned int USRF           : 1;	/* User Interrupt Request Flag */
		/* const */ unsigned int TXFIFOLEVEL    : 3;	/* TXFIFO Filling Level */
		/* const */ unsigned int RXFIFOLEVEL    : 3;	/* RXFIFO Filling Level */
		/* const */ unsigned int SLAVESEL       : 4;	/* Currently Active Slave Select Flag */
		/* const */ unsigned int RPV            : 1;	/* Received Parity Value */
		/* const */ unsigned int TPV            : 1;	/* Transmitted Parity Value */
		/* const */ unsigned int PHASE          : 4;	/* Flags the ongoing phase */
	} B;
	int I;
	unsigned int U;

} QSPI0_STATUS_type;
#define QSPI0_STATUS	(*( QSPI0_STATUS_type *) 0xf0001c40u)	/* Status Register */
#define QSPI1_STATUS	(*( QSPI0_STATUS_type *) 0xf0001d40u)	/* Status Register */
#define QSPI2_STATUS	(*( QSPI0_STATUS_type *) 0xf0001e40u)	/* Status Register */
#define QSPI3_STATUS	(*( QSPI0_STATUS_type *) 0xf0001f40u)	/* Status Register */
#define QSPI4_STATUS	(*( QSPI0_STATUS_type *) 0xf0002040u)	/* Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int BITCOUNT       : 8;	/* Number of the bit shifted out */
		/* const */ unsigned int PWMVIO         : 1;	/* PWM Frame Violates its Time Window */
		unsigned int MPWMVIO        : 2;	/* Modify the PWMVIO Flag */
		/* const */ unsigned int TVIO           : 1;	/* Tx FIFO Frame Violates its Time Window */
		unsigned int MTVIO          : 2;	/* Modify the TVIO Flag */
		unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} QSPI0_STATUS1_type;
#define QSPI0_STATUS1	(*( QSPI0_STATUS1_type *) 0xf0001c44u)	/* Status Register 1 */
#define QSPI1_STATUS1	(*( QSPI0_STATUS1_type *) 0xf0001d44u)	/* Status Register 1 */
#define QSPI2_STATUS1	(*( QSPI0_STATUS1_type *) 0xf0001e44u)	/* Status Register 1 */
#define QSPI3_STATUS1	(*( QSPI0_STATUS1_type *) 0xf0001f44u)	/* Status Register 1 */
#define QSPI4_STATUS1	(*( QSPI0_STATUS1_type *) 0xf0002044u)	/* Status Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} QSPI1_ACCEN1_type;
#define QSPI1_ACCEN1	(*( QSPI1_ACCEN1_type *) 0xf0001df8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} QSPI2_ACCEN1_type;
#define QSPI2_ACCEN1	(*( QSPI2_ACCEN1_type *) 0xf0001ef8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} QSPI3_ACCEN1_type;
#define QSPI3_ACCEN1	(*( QSPI3_ACCEN1_type *) 0xf0001ff8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} QSPI4_ACCEN1_type;
#define QSPI4_ACCEN1	(*( QSPI4_ACCEN1_type *) 0xf00020f8u)	/* Access Enable Register 1 */


/* HSSL */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} HSSL_ACCEN0_type;
#define HSSL_ACCEN0	(*( HSSL_ACCEN0_type *) 0xf00800fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} HSSL_ACCEN1_type;
#define HSSL_ACCEN1	(*( HSSL_ACCEN1_type *) 0xf00800f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int PREDIV         : 14;	/* Global Predivider */
		unsigned int                : 2;
		unsigned int SMT            : 1;	/* Streaming Mode Transmitter */
		unsigned int SMR            : 1;	/* Streaming Mode Receiver */
		unsigned int SCM            : 1;	/* Streaming Channel Mode */
		unsigned int CCC            : 1;	/* Channel Code Control */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} HSSL_CFG_type;
#define HSSL_CFG	(*( HSSL_CFG_type *) 0xf0080010u)	/* Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} HSSL_CLC_type;
#define HSSL_CLC	(*( HSSL_CLC_type *) 0xf0080000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int XORMASK        : 16;	/* Value to be XORed with the Calculated CRC */
		unsigned int XEN            : 1;	/* Enable the Error Injection via XORMASK */
		unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} HSSL_CRC_type;
#define HSSL_CRC	(*( HSSL_CRC_type *) 0xf008000cu)	/* CRC Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IDQ            : 1;	/* Read ID Request */
		unsigned int TQ             : 1;	/* Trigger Request */
		/* const */ unsigned int LETT           : 3;	/* Last Error Transaction Tag */
		/* const */ unsigned int CETT           : 3;	/* Currently Expected Transaction Tag */
		/* const */ unsigned int TOCV           : 8;	/* Time Out Current Value */
		unsigned int DATLEN         : 2;	/* Data Length */
		unsigned int RWT            : 2;	/* Read Write Trigger Command Type */
		/* const */ unsigned int BSY            : 1;	/* Channel Busy */
		/* const */ unsigned int ITTAG          : 3;	/* Initiator Transaction Tag */
		unsigned int TOREL          : 8;	/* Time Out Reload Value */
	} B;
	int I;
	unsigned int U;

} HSSL_ICON0_type;
#define HSSL_ICON0	(*( HSSL_ICON0_type *) 0xf0080034u)	/* Initiator Control Data Register 0 */
#define HSSL_ICON1	(*( HSSL_ICON0_type *) 0xf0080044u)	/* Initiator Control Data Register 1 */
#define HSSL_ICON2	(*( HSSL_ICON0_type *) 0xf0080054u)	/* Initiator Control Data Register 2 */
#define HSSL_ICON3	(*( HSSL_ICON0_type *) 0xf0080064u)	/* Initiator Control Data Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} HSSL_ID_type;
#define HSSL_ID	(*( HSSL_ID_type *) 0xf0080008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DATA           : 32;	/* Data Delivered by a Read Response Frame */
	} B;
	int I;
	unsigned int U;

} HSSL_IRD0_type;
#define HSSL_IRD0	(*( HSSL_IRD0_type *) 0xf008003cu)	/* Initiator Read Data Register */
#define HSSL_IRD1	(*( HSSL_IRD0_type *) 0xf008004cu)	/* Initiator Read Data Register */
#define HSSL_IRD2	(*( HSSL_IRD0_type *) 0xf008005cu)	/* Initiator Read Data Register */
#define HSSL_IRD3	(*( HSSL_IRD0_type *) 0xf008006cu)	/* Initiator Read Data Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRESS        : 32;	/* Address Part of the Payload of a Write Frame */
	} B;
	int I;
	unsigned int U;

} HSSL_IRWA0_type;
#define HSSL_IRWA0	(*( HSSL_IRWA0_type *) 0xf0080038u)	/* Initiator Read Write Address Register */
#define HSSL_IRWA1	(*( HSSL_IRWA0_type *) 0xf0080048u)	/* Initiator Read Write Address Register */
#define HSSL_IRWA2	(*( HSSL_IRWA0_type *) 0xf0080058u)	/* Initiator Read Write Address Register */
#define HSSL_IRWA3	(*( HSSL_IRWA0_type *) 0xf0080068u)	/* Initiator Read Write Address Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 5;
		/* const */ unsigned int CURR           : 27;	/* Address of the Memory Location for the Current Transfer */
	} B;
	int I;
	unsigned int U;

} HSSL_ISCA_type;
#define HSSL_ISCA	(*( HSSL_ISCA_type *) 0xf00800a8u)	/* Initiator Stream Current Address Register */
#define HSSL_TSCA	(*( HSSL_ISCA_type *) 0xf00800b8u)	/* Target Stream Current Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RELCOUNT       : 16;	/* Reload Count Number */
		/* const */ unsigned int CURCOUNT       : 16;	/* Current Count Number */
	} B;
	int I;
	unsigned int U;

} HSSL_ISFC_type;
#define HSSL_ISFC	(*( HSSL_ISFC_type *) 0xf00800acu)	/* Initiator Stream Frame Count Register */
#define HSSL_TSFC	(*( HSSL_ISFC_type *) 0xf00800bcu)	/* Target Stream Frame Count Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		unsigned int START          : 27;	/* Start Address for the Memory Range */
	} B;
	int I;
	unsigned int U;

} HSSL_ISSA0_type;
#define HSSL_ISSA0	(*( HSSL_ISSA0_type *) 0xf00800a0u)	/* Initiator Stream Start Address Register */
#define HSSL_ISSA1	(*( HSSL_ISSA0_type *) 0xf00800a4u)	/* Initiator Stream Start Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DATA           : 32;	/* Data Part of the Payload of a Write Frame */
	} B;
	int I;
	unsigned int U;

} HSSL_IWD0_type;
#define HSSL_IWD0	(*( HSSL_IWD0_type *) 0xf0080030u)	/* Initiator Write Data Register 0 */
#define HSSL_IWD1	(*( HSSL_IWD0_type *) 0xf0080040u)	/* Initiator Write Data Register 1 */
#define HSSL_IWD2	(*( HSSL_IWD0_type *) 0xf0080050u)	/* Initiator Write Data Register 2 */
#define HSSL_IWD3	(*( HSSL_IWD0_type *) 0xf0080060u)	/* Initiator Write Data Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} HSSL_KRST0_type;
#define HSSL_KRST0	(*( HSSL_KRST0_type *) 0xf00800f4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} HSSL_KRST1_type;
#define HSSL_KRST1	(*( HSSL_KRST1_type *) 0xf00800f0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} HSSL_KRSTCLR_type;
#define HSSL_KRSTCLR	(*( HSSL_KRSTCLR_type *) 0xf00800ecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int NACK           : 4;	/* Not Acknowledge Error - Target Error */
		/* const */ unsigned int TTE            : 4;	/* Transaction Tag Error */
		/* const */ unsigned int TIMEOUT        : 4;	/* Timeout Error */
		/* const */ unsigned int UNEXPECTED     : 4;	/* Unexpected Type of Frame Error */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int TMB            : 1;	/* Target Memory Block */
		/* const */ unsigned int IMB            : 1;	/* Initiator Memory Block */
		/* const */ unsigned int ISB            : 1;	/* Initiator Stream Block Request */
		/* const */ unsigned int MAV            : 1;	/* Memory Access Violation */
		/* const */ unsigned int SRIE           : 1;	/* SRI Bus Access Error */
		/* const */ unsigned int PIE1           : 1;	/* PHY Inconsistency Error 1 (Channel Number Code Error) */
		/* const */ unsigned int PIE2           : 1;	/* PHY Inconsistency Error 2 (Data Length Error) */
		/* const */ unsigned int CRCE           : 1;	/* CRC Error */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int TSE            : 1;	/* Target Stream Enable */
		/* const */ unsigned int TEI            : 1;	/* Transmit Enable Input */
		/* const */ unsigned int TEO            : 1;	/* Transmit Enable Output */
		/* const */ unsigned int INI            : 1;	/* Initialize Mode */
	} B;
	int I;
	unsigned int U;

} HSSL_MFLAGS_type;
#define HSSL_MFLAGS	(*( HSSL_MFLAGS_type *) 0xf0080018u)	/* Miscellaneous Flags Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NACKC          : 4;	/* NACK Flags Clear */
		unsigned int TTEC           : 4;	/* Transaction Tag Error Flags Clear */
		unsigned int TIMEOUTC       : 4;	/* Timeout Error Flags Clear */
		unsigned int UNEXPECTEDC    : 4;	/* Unexpected Error Flags Clear */
		unsigned int                : 2;
		unsigned int TMBC           : 1;	/* Target Memory Block Flag Clear */
		unsigned int IMBC           : 1;	/* Initiator Memory Block Flag Clear */
		unsigned int ISBC           : 1;	/* Initiator Stream Block Request Clear */
		unsigned int MAVC           : 1;	/* MAV Flag Clear */
		unsigned int SRIEC          : 1;	/* SRI Bus Access Error Flag Clear */
		unsigned int PIE1C          : 1;	/* PIE1 Error Flag Clear */
		unsigned int PIE2C          : 1;	/* PIE2 Error Flag Clear */
		unsigned int CRCEC          : 1;	/* CRC Error Flag Clear */
		unsigned int                : 2;
		unsigned int TSEC           : 1;	/* Target Stream Enable Flag Clear */
		unsigned int                : 1;
		unsigned int TEOC           : 1;	/* Transmit Enable Flag Clear */
		unsigned int INIC           : 1;	/* Initialize Mode Flag Clear */
	} B;
	int I;
	unsigned int U;

} HSSL_MFLAGSCL_type;
#define HSSL_MFLAGSCL	(*( HSSL_MFLAGSCL_type *) 0xf0080020u)	/* Miscellaneous Flags Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NACKEN         : 4;	/* Not Acknowledge Error Enable Bits */
		unsigned int TTEEN          : 4;	/* Transaction Tag Error Enable Bits */
		unsigned int TIMEOUTEN      : 4;	/* Timeout Error Enable Bits */
		unsigned int UNEXPECTEDEN   : 4;	/* Unexpected Error Enable Bits */
		unsigned int                : 5;
		unsigned int MAVEN          : 1;	/* MAV Enable Bit */
		unsigned int SRIEEN         : 1;	/* SRI Bus Access Error Enable Bit */
		unsigned int PIE1EN         : 1;	/* PIE1 Error Enable Bit */
		unsigned int PIE2EN         : 1;	/* PIE2 Error Enable Bit */
		unsigned int CRCEEN         : 1;	/* CRC Error Enable Bit */
		unsigned int                : 3;
		unsigned int TEIEN          : 1;	/* TEI Enable Bit */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} HSSL_MFLAGSEN_type;
#define HSSL_MFLAGSEN	(*( HSSL_MFLAGSEN_type *) 0xf0080024u)	/* Flags Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NACKS          : 4;	/* NACK Flags Set */
		unsigned int TTES           : 4;	/* Transaction Tag Error Flags Set */
		unsigned int TIMEOUTS       : 4;	/* Timeout Error Flags Set */
		unsigned int UNEXPECTEDS    : 4;	/* Unexpected Error Flags Set */
		unsigned int                : 2;
		unsigned int TMBS           : 1;	/* Target Memory Block Flag Set */
		unsigned int IMBS           : 1;	/* Initiator Memory Block Flag Set */
		unsigned int ISBS           : 1;	/* Initiator Stream Block Request Set */
		unsigned int MAVS           : 1;	/* MAV Flag Set */
		unsigned int SRIES          : 1;	/* SRI Bus Access Error Flag Set */
		unsigned int PIE1S          : 1;	/* PIE1 Error Flag Set */
		unsigned int PIE2S          : 1;	/* PIE2 Error Flag Set */
		unsigned int CRCES          : 1;	/* CRC Error Flag Set */
		unsigned int                : 2;
		unsigned int TSES           : 1;	/* Target Stream Enable Flag Set */
		unsigned int                : 1;
		unsigned int TEOS           : 1;	/* Transmit Enable Flag Set */
		unsigned int INIS           : 1;	/* Initialize Mode Flag Set */
	} B;
	int I;
	unsigned int U;

} HSSL_MFLAGSSET_type;
#define HSSL_MFLAGSSET	(*( HSSL_MFLAGSSET_type *) 0xf008001cu)	/* Miscellaneous Flags Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 2;	/* Trigger Set for OTGB0/1 */
		unsigned int TGB            : 1;	/* OTGB0/1 Bus Select */
		unsigned int TG_P           : 1;	/* TGS, TGB Write Protection */
		unsigned int                : 20;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} HSSL_OCS_type;
#define HSSL_OCS	(*( HSSL_OCS_type *) 0xf00800e8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int I              : 4;	/* Request Flags for Initiated Commands */
		/* const */ unsigned int T              : 4;	/* Request Flags for Commands Arrived at Target */
		/* const */ unsigned int R              : 4;	/* Request Flags for Response Frames at the Target */
		/* const */ unsigned int                : 4;
		/* const */ unsigned int E0             : 2;	/* Expect Flags for Activated Timeout Timer 0 */
		/* const */ unsigned int E1             : 2;	/* Expect Flags for Activated Timeout Timer 1 */
		/* const */ unsigned int E2             : 2;	/* Expect Flags for Activated Timeout Timer 2 */
		/* const */ unsigned int E3             : 2;	/* Expect Flags for Activated Timeout Timer 3 */
		/* const */ unsigned int                : 4;
		/* const */ unsigned int IS             : 1;	/* I Flag for Stream Frames */
		/* const */ unsigned int RS             : 1;	/* R Flag for Stream Frames */
		/* const */ unsigned int TS             : 1;	/* T Flag for Stream Frames */
		/* const */ unsigned int ES             : 1;	/* E Flag for Stream Frames */
	} B;
	int I;
	unsigned int U;

} HSSL_QFLAGS_type;
#define HSSL_QFLAGS	(*( HSSL_QFLAGS_type *) 0xf0080014u)	/* Request Flags Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXFL           : 2;	/* Stream RxFIFO Filling Level */
		/* const */ unsigned int TXFL           : 2;	/* Stream TxFIFO Filling Level */
		/* const */ unsigned int EXFL           : 2;	/* Stream Expect FIFO Filling Level */
		/* const */ unsigned int                : 9;
		/* const */ unsigned int ISF            : 1;	/* Initiator Stream Frame Request */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} HSSL_SFSFLAGS_type;
#define HSSL_SFSFLAGS	(*( HSSL_SFSFLAGS_type *) 0xf0080028u)	/* Stream FIFOs Status Flags Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int A              : 32;	/* Address Part of the Payload of a Write Command Frame or a Read Command Frame or ID Frame */
	} B;
	int I;
	unsigned int U;

} HSSL_TCA0_type;
#define HSSL_TCA0	(*( HSSL_TCA0_type *) 0xf0080074u)	/* Target Current Address Register 0 */
#define HSSL_TCA1	(*( HSSL_TCA0_type *) 0xf008007cu)	/* Target Current Address Register 1 */
#define HSSL_TCA2	(*( HSSL_TCA0_type *) 0xf0080084u)	/* Target Current Address Register 2 */
#define HSSL_TCA3	(*( HSSL_TCA0_type *) 0xf008008cu)	/* Target Current Address Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int D              : 32;	/* Data Part of the Payload of a Write Command Frame or Read Data of a Read Command Frame */
	} B;
	int I;
	unsigned int U;

} HSSL_TCD0_type;
#define HSSL_TCD0	(*( HSSL_TCD0_type *) 0xf0080070u)	/* Target Current Data Register 0 */
#define HSSL_TCD1	(*( HSSL_TCD0_type *) 0xf0080078u)	/* Target Current Data Register 1 */
#define HSSL_TCD2	(*( HSSL_TCD0_type *) 0xf0080080u)	/* Target Current Data Register 2 */
#define HSSL_TCD3	(*( HSSL_TCD0_type *) 0xf0080088u)	/* Target Current Data Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int A              : 32;	/* Address Pointer */
	} B;
	int I;
	unsigned int U;

} HSSL_TIDADD_type;
#define HSSL_TIDADD	(*( HSSL_TIDADD_type *) 0xf0080094u)	/* Target ID Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 5;
		unsigned int ADDR           : 27;	/* Start Address for the Memory Range */
	} B;
	int I;
	unsigned int U;

} HSSL_TSSA0_type;
#define HSSL_TSSA0	(*( HSSL_TSSA0_type *) 0xf00800b0u)	/* Target Stream Start Address Register 0 */
#define HSSL_TSSA1	(*( HSSL_TSSA0_type *) 0xf00800b4u)	/* Target Stream Start Address Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int LASTCC0        : 5;	/* Last Command Code */
		/* const */ unsigned int LASTTT0        : 3;	/* Last Transaction Tag */
		/* const */ unsigned int LASTCC1        : 5;	/* Last Command Code */
		/* const */ unsigned int LASTTT1        : 3;	/* Last Transaction Tag */
		/* const */ unsigned int LASTCC2        : 5;	/* Last Command Code */
		/* const */ unsigned int LASTTT2        : 3;	/* Last Transaction Tag */
		/* const */ unsigned int LASTCC3        : 5;	/* Last Command Code */
		/* const */ unsigned int LASTTT3        : 3;	/* Last Transaction Tag */
	} B;
	int I;
	unsigned int U;

} HSSL_TSTAT_type;
#define HSSL_TSTAT	(*( HSSL_TSTAT_type *) 0xf0080090u)	/* Target Status Register */


/* HSCT */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} HSCT_ACCEN0_type;
#define HSCT_ACCEN0	(*( HSCT_ACCEN0_type *) 0xf009fffcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} HSCT_ACCEN1_type;
#define HSCT_ACCEN1	(*( HSCT_ACCEN1_type *) 0xf009fff8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} HSCT_CLC_type;
#define HSCT_CLC	(*( HSCT_CLC_type *) 0xf0090000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PHYPD          : 1;	/* Physical layer Power Down */
		unsigned int PLLPON         : 1;	/* PLL Power On (Master Mode only) */
		unsigned int PLLPE          : 6;	/* PLL phase enable - allows to enable/disable each of the 6 Phase outputs. */
		unsigned int PLLWMF         : 6;	/* PLL frequency control word multiplication factor */
		unsigned int PLLKPKI        : 1;	/* KP/KI Setting */
		unsigned int PHYRST         : 1;	/* Physical Layer Reset */
		unsigned int PLLKP          : 3;	/* KP of PLL - Configuration of PLL beta coefficients of proportional part of loop filter */
		unsigned int PLLKI          : 3;	/* KI of PLL - Configuration of PLL alpha coefficients of integral part of loop filter */
		unsigned int PLLIVR         : 4;	/* Adjustment for integrated voltage regulator */
		unsigned int                : 2;
		unsigned int OSCCLKEN       : 1;	/* Enable Oscillator Clock as PLL reference clock */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} HSCT_CONFIGPHY_type;
#define HSCT_CONFIGPHY	(*( HSCT_CONFIGPHY_type *) 0xf0090030u)	/* Configuration physical layer register */

typedef volatile union
{
	struct
	{ 
		unsigned int CTS_FRAME      : 1;	/* Transmit CTS Frame Generation */
		unsigned int CTS_TXD        : 1;	/* Disable TX CTS signaling */
		unsigned int CTS_RXD        : 1;	/* Disable RX CTS detection */
		unsigned int HSSL_CTS_FBD   : 1;	/* Disable HSSL interface CTS Frame Blocking */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} HSCT_CTSCTRL_type;
#define HSCT_CTSCTRL	(*( HSCT_CTSCTRL_type *) 0xf009001cu)	/* Clear To Send Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TX_DIS         : 1;	/* Disable HSCT Transmit path in Master interface */
		unsigned int RX_DIS         : 1;	/* Disable HSCT Receive path in Master interface */
		unsigned int RX_HEPD        : 1;	/* Disable RX Header Error Discard Payload data. */
		unsigned int TX_PWDPD       : 1;	/* Disable TX Power down pull down. */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} HSCT_DISABLE_type;
#define HSCT_DISABLE	(*( HSCT_DISABLE_type *) 0xf0090020u)	/* Transmission Disable Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} HSCT_ID_type;
#define HSCT_ID	(*( HSCT_ID_type *) 0xf0090008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IFCVS          : 8;	/* Master Mode - Interface Control Value to be send to Slave interface */
		unsigned int SIFCV          : 1;	/* Master Mode - Slave IF control frame trigger */
		unsigned int                : 7;
		unsigned int MRXSPEED       : 2;	/* Master Mode RX speed */
		unsigned int MTXSPEED       : 2;	/* Master Mode TX speed */
		unsigned int IFTESTMD       : 1;	/* Master Mode Interface Test Mode */
		unsigned int                : 11;
	} B;
	int I;
	unsigned int U;

} HSCT_IFCTRL_type;
#define HSCT_IFCTRL	(*( HSCT_IFCTRL_type *) 0xf0090014u)	/* CPU transfer control register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RX_STAT        : 3;	/* HSCT slave interface Status for RX link */
		/* const */ unsigned int TX_STAT        : 2;	/* HSCT slave interface Status for TX link */
		/* const */ unsigned int                : 27;
	} B;
	int I;
	unsigned int U;

} HSCT_IFSTAT_type;
#define HSCT_IFSTAT	(*( HSCT_IFSTAT_type *) 0xf0090028u)	/* Interface Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TERM           : 1;	/* Select Receiver Termination Mode of HSCT Interface */
		unsigned int SYS_CLK_EN     : 1;	/* Enable SysClk in Master interface */
		unsigned int SRCF           : 1;	/* Select SysClk / Reference Clock Frequency rate */
		unsigned int IFM            : 1;	/* Select Interface Mode */
		unsigned int                : 4;
		unsigned int LVDSR          : 1;	/* Special reduced LVDS electrical signaling mode */
		unsigned int LVDSRL         : 1;	/* LVDS IEEE electrical signaling mode */
		unsigned int LHLR           : 1;	/* Loopback path at Slave interface side at higher layer system RAM. */
		unsigned int                : 5;
		unsigned int TXHD           : 3;	/* Transmit High Speed Divider. */
		unsigned int RXHD           : 3;	/* Receive High Speed Divider. */
		unsigned int                : 10;
	} B;
	int I;
	unsigned int U;

} HSCT_INIT_type;
#define HSCT_INIT	(*( HSCT_INIT_type *) 0xf0090010u)	/* Initialization register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int                : 1;
		/* const */ unsigned int HER            : 1;	/* Header error detected */
		/* const */ unsigned int PYER           : 1;	/* Payload error detected */
		/* const */ unsigned int CER            : 1;	/* HSCT command error */
		/* const */ unsigned int IFCFS          : 1;	/* HSCT interface control frame send */
		/* const */ unsigned int SMER           : 1;	/* Speed Mode Switch Error (Master Mode only) */
		/* const */ unsigned int USMSF          : 1;	/* Unsolicited message frame send finished */
		/* const */ unsigned int PLER           : 1;	/* PLL lost lock error */
		/* const */ unsigned int USM            : 1;	/* Unsolicited Message Received */
		/* const */ unsigned int PAR            : 1;	/* PING Answer Received */
		/* const */ unsigned int TXTE           : 1;	/* TX transfer error occurred on a disabled TX channel. */
		/* const */ unsigned int SFO            : 1;	/* Synchronization FIFO overflow (in RX direction) */
		/* const */ unsigned int SFU            : 1;	/* Synchronization FIFO underflow (in TX direction) */
		/* const */ unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} HSCT_IRQ_type;
#define HSCT_IRQ	(*( HSCT_IRQ_type *) 0xf0090040u)	/* Interrupt register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		unsigned int HERCLR         : 1;	/* Header error detected interrupt clear */
		unsigned int PYERCLR        : 1;	/* Payload error detected interrupt clear */
		unsigned int CERCLR         : 1;	/* HSCT command error interrupt clear */
		unsigned int IFCFSCLR       : 1;	/* HSCT interface control command send interrupt clear */
		unsigned int SMERCLR        : 1;	/* Speed Mode Switch Error interrupt clear */
		unsigned int USMSFCLR       : 1;	/* Unsolicited message frame send finished interrupt clear */
		unsigned int PLERCLR        : 1;	/* PLL lost lock error interrupt clear */
		unsigned int USMCLR         : 1;	/* Unsolicited Message received clear */
		unsigned int PARCLR         : 1;	/* PING Answer received clear */
		unsigned int TXTECLR        : 1;	/* TX disable error interrupt clear */
		unsigned int SFOEN          : 1;	/* Synchronization FIFO overflow (in RX direction) interrupt clear */
		unsigned int SFUEN          : 1;	/* Synchronization FIFO underflow (in TX direction) interrupt clear */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} HSCT_IRQCLR_type;
#define HSCT_IRQCLR	(*( HSCT_IRQCLR_type *) 0xf0090048u)	/* Interrupt clear register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 1;
		unsigned int HEREN          : 1;	/* Header error detected interrupt enable */
		unsigned int PYEREN         : 1;	/* Payload error detected interrupt enable */
		unsigned int CEREN          : 1;	/* HSCT command error interrupt enable */
		unsigned int IFCFSEN        : 1;	/* HSCT interface control command send enable */
		unsigned int SMEREN         : 1;	/* Speed Mode Switch Error interrupt enable */
		unsigned int USMSFEN        : 1;	/* Unsolicited message frame send finished */
		unsigned int PLEREN         : 1;	/* PLL lost lock error interrupt enable */
		unsigned int USMEN          : 1;	/* Unsolicited Message received enable */
		unsigned int PAREN          : 1;	/* PING Answer Received enable */
		unsigned int TXTEEN         : 1;	/* TX disable error interrupt enable */
		unsigned int SFOEN          : 1;	/* Synchronization FIFO overflow (in RX direction) interrupt enable */
		unsigned int SFUEN          : 1;	/* Synchronization FIFO underflow (in TX direction) interrupt enable */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} HSCT_IRQEN_type;
#define HSCT_IRQEN	(*( HSCT_IRQEN_type *) 0xf0090044u)	/* Interrupt enable register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} HSCT_KRST0_type;
#define HSCT_KRST0	(*( HSCT_KRST0_type *) 0xf009fff4u)	/* Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} HSCT_KRST1_type;
#define HSCT_KRST1	(*( HSCT_KRST1_type *) 0xf009fff0u)	/* Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} HSCT_KRSTCLR_type;
#define HSCT_KRSTCLR	(*( HSCT_KRSTCLR_type *) 0xf009ffecu)	/* Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 2;	/* Trigger Set for OTGB0/1 */
		unsigned int TGB            : 1;	/* OTGB0/1 Bus Select */
		unsigned int TG_P           : 1;	/* TGS, TGB Write Protection */
		unsigned int                : 20;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} HSCT_OCS_type;
#define HSCT_OCS	(*( HSCT_OCS_type *) 0xf009ffe8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		unsigned int SLPEN          : 1;	/* Sleep mode enabled */
		unsigned int SLPCLKG        : 1;	/* Clock Gating in Sleep Mode */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} HSCT_SLEEPCTRL_type;
#define HSCT_SLEEPCTRL	(*( HSCT_SLEEPCTRL_type *) 0xf0090018u)	/* Sleep Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RX_PSIZE       : 3;	/* RX (receiving) Payload Size */
		/* const */ unsigned int RX_CHANNEL     : 4;	/* RX (receiving) Logical Channel Type */
		/* const */ unsigned int RX_SLEEP       : 1;	/* RX (receiving) Sleep Mode Status */
		/* const */ unsigned int TX_SLEEP       : 1;	/* TX (transmitting) Sleep Mode Status */
		/* const */ unsigned int                : 3;
		/* const */ unsigned int TX_PSIZE       : 3;	/* Transmission Payload Size */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int TX_CHANNEL_TYPE: 4;	/* Transmission Logical Channel Type */
		/* const */ unsigned int                : 4;
		/* const */ unsigned int LIFCCMDR       : 8;	/* Last Interface Control Command Received */
	} B;
	int I;
	unsigned int U;

} HSCT_STAT_type;
#define HSCT_STAT	(*( HSCT_STAT_type *) 0xf0090024u)	/* Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int PLOCK          : 1;	/* PLL locked */
		/* const */ unsigned int RXLSA          : 1;	/* Receiver in Low speed */
		/* const */ unsigned int TXLSA          : 1;	/* Transmitter in Low speed */
		/* const */ unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} HSCT_STATPHY_type;
#define HSCT_STATPHY	(*( HSCT_STATPHY_type *) 0xf0090034u)	/* STATPHY */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int USMR           : 32;	/* Unsolicited status message received */
	} B;
	int I;
	unsigned int U;

} HSCT_USMR_type;
#define HSCT_USMR	(*( HSCT_USMR_type *) 0xf0090050u)	/* Unsolicited Status Message Received */

typedef volatile union
{
	struct
	{ 
		unsigned int USMS           : 32;	/* Unsolicited status message send */
	} B;
	int I;
	unsigned int U;

} HSCT_USMS_type;
#define HSCT_USMS	(*( HSCT_USMS_type *) 0xf0090054u)	/* Unsolicited Status Message Send */


/* MSC */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} MSC0_ACCEN0_type;
#define MSC0_ACCEN0	(*( MSC0_ACCEN0_type *) 0xf00026fcu)	/* Access Enable Register 0 */
#define MSC1_ACCEN0	(*( MSC0_ACCEN0_type *) 0xf00027fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} MSC0_ACCEN1_type;
#define MSC0_ACCEN1	(*( MSC0_ACCEN1_type *) 0xf00026f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} MSC0_CLC_type;
#define MSC0_CLC	(*( MSC0_CLC_type *) 0xf0002600u)	/* Clock Control Register */
#define MSC1_CLC	(*( MSC0_CLC_type *) 0xf0002700u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DCL            : 16;	/* Downstream Command for SRL Shift Register */
		unsigned int DCH            : 16;	/* Downstream Command for SRH Shift Register */
	} B;
	int I;
	unsigned int U;

} MSC0_DC_type;
#define MSC0_DC	(*( MSC0_DC_type *) 0xf0002620u)	/* Downstream Command Register */
#define MSC1_DC	(*( MSC0_DC_type *) 0xf0002720u)	/* Downstream Command Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DDL            : 16;	/* Downstream Data for SRL Shift Register */
		unsigned int DDH            : 16;	/* Downstream Data for SRH Shift Register */
	} B;
	int I;
	unsigned int U;

} MSC0_DD_type;
#define MSC0_DD	(*( MSC0_DD_type *) 0xf000261cu)	/* Downstream Data Register */
#define MSC1_DD	(*( MSC0_DD_type *) 0xf000271cu)	/* Downstream Data Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TM             : 1;	/* Transmission Mode */
		/* const */ unsigned int CP             : 1;	/* Command Pending */
		/* const */ unsigned int DP             : 1;	/* Data Pending */
		unsigned int NDBL           : 5;	/* Number of SRL Bits Shifted at Data Frames */
		unsigned int NDBH           : 5;	/* Number of SRH Bits Shifted at Data Frames */
		unsigned int ENSELL         : 1;	/* Enable SRL Active Phase Selection Bit */
		unsigned int ENSELH         : 1;	/* Enable SRH Active Phase Selection Bit */
		/* const */ unsigned int DSDIS          : 1;	/* Downstream Disable */
		unsigned int NBC            : 6;	/* Number of Bits Shifted at Command Frames */
		unsigned int                : 2;
		unsigned int PPD            : 5;	/* Passive Phase Length at Data Frames */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} MSC0_DSC_type;
#define MSC0_DSC	(*( MSC0_DSC_type *) 0xf0002614u)	/* Downstream Control Register */
#define MSC1_DSC	(*( MSC0_DSC_type *) 0xf0002714u)	/* Downstream Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NDBHE          : 1;	/* Number of SRH Bits Shifted at Data Frames Extension */
		unsigned int NDBLE          : 1;	/* Number of SRH Bits Shifted at Data Frames Extension */
		unsigned int                : 12;
		unsigned int EXEN           : 1;	/* Extension Enable */
		/* const */ unsigned int CCF            : 1;	/* Command-Comand Flag */
		unsigned int INJENP0        : 1;	/* Injection Enable of the Pin 0 Signal */
		unsigned int INJPOSP0       : 6;	/* Injection Position of the Pin 0 Signal */
		unsigned int                : 1;
		unsigned int INJENP1        : 1;	/* Injection Enable of the Pin 1 Signal */
		unsigned int INJPOSP1       : 6;	/* Injection Position of the Pin 1 Signal */
		unsigned int CDCM           : 1;	/* Command-Data-Comand in Data Repetition Mode */
	} B;
	int I;
	unsigned int U;

} MSC0_DSCE_type;
#define MSC0_DSCE	(*( MSC0_DSCE_type *) 0xf0002658u)	/* Downstream Control Enhanced Register 1 */
#define MSC1_DSCE	(*( MSC0_DSCE_type *) 0xf0002758u)	/* Downstream Control Enhanced Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int SH0            : 2;	/* Select Source for SRH */
		unsigned int SH1            : 2;	/* Select Source for SRH */
		unsigned int SH2            : 2;	/* Select Source for SRH */
		unsigned int SH3            : 2;	/* Select Source for SRH */
		unsigned int SH4            : 2;	/* Select Source for SRH */
		unsigned int SH5            : 2;	/* Select Source for SRH */
		unsigned int SH6            : 2;	/* Select Source for SRH */
		unsigned int SH7            : 2;	/* Select Source for SRH */
		unsigned int SH8            : 2;	/* Select Source for SRH */
		unsigned int SH9            : 2;	/* Select Source for SRH */
		unsigned int SH10           : 2;	/* Select Source for SRH */
		unsigned int SH11           : 2;	/* Select Source for SRH */
		unsigned int SH12           : 2;	/* Select Source for SRH */
		unsigned int SH13           : 2;	/* Select Source for SRH */
		unsigned int SH14           : 2;	/* Select Source for SRH */
		unsigned int SH15           : 2;	/* Select Source for SRH */
	} B;
	int I;
	unsigned int U;

} MSC0_DSDSH_type;
#define MSC0_DSDSH	(*( MSC0_DSDSH_type *) 0xf0002628u)	/* Downstream Select Data Source High Register */
#define MSC1_DSDSH	(*( MSC0_DSDSH_type *) 0xf0002728u)	/* Downstream Select Data Source High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SL0            : 2;	/* Select Source for SRL */
		unsigned int SL1            : 2;	/* Select Source for SRL */
		unsigned int SL2            : 2;	/* Select Source for SRL */
		unsigned int SL3            : 2;	/* Select Source for SRL */
		unsigned int SL4            : 2;	/* Select Source for SRL */
		unsigned int SL5            : 2;	/* Select Source for SRL */
		unsigned int SL6            : 2;	/* Select Source for SRL */
		unsigned int SL7            : 2;	/* Select Source for SRL */
		unsigned int SL8            : 2;	/* Select Source for SRL */
		unsigned int SL9            : 2;	/* Select Source for SRL */
		unsigned int SL10           : 2;	/* Select Source for SRL */
		unsigned int SL11           : 2;	/* Select Source for SRL */
		unsigned int SL12           : 2;	/* Select Source for SRL */
		unsigned int SL13           : 2;	/* Select Source for SRL */
		unsigned int SL14           : 2;	/* Select Source for SRL */
		unsigned int SL15           : 2;	/* Select Source for SRL */
	} B;
	int I;
	unsigned int U;

} MSC0_DSDSL_type;
#define MSC0_DSDSL	(*( MSC0_DSDSL_type *) 0xf0002624u)	/* Downstream Select Data Source Low Register */
#define MSC1_DSDSL	(*( MSC0_DSDSL_type *) 0xf0002724u)	/* Downstream Select Data Source Low Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int PFC            : 4;	/* Passive Time Frame Counter */
		unsigned int                : 4;
		unsigned int NPTF           : 4;	/* Number Of Passive Time Frames */
		unsigned int                : 4;
		/* const */ unsigned int DC             : 8;	/* Downstream Counter */
		/* const */ unsigned int DFA            : 1;	/* Data Frame Active */
		/* const */ unsigned int CFA            : 1;	/* Command Frame Active */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} MSC0_DSS_type;
#define MSC0_DSS	(*( MSC0_DSS_type *) 0xf0002618u)	/* Downstream Status Register */
#define MSC1_DSS	(*( MSC0_DSS_type *) 0xf0002718u)	/* Downstream Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ENL0           : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL1           : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL2           : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL3           : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL4           : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL5           : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL6           : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL7           : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL8           : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL9           : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL10          : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL11          : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL12          : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL13          : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL14          : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENL15          : 1;	/* Emergency Stop Enable for Bit x in SRL */
		unsigned int ENH0           : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH1           : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH2           : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH3           : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH4           : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH5           : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH6           : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH7           : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH8           : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH9           : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH10          : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH11          : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH12          : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH13          : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH14          : 1;	/* Emergency Stop Enable for Bit x in SRH */
		unsigned int ENH15          : 1;	/* Emergency Stop Enable for Bit x in SRH */
	} B;
	int I;
	unsigned int U;

} MSC0_ESR_type;
#define MSC0_ESR	(*( MSC0_ESR_type *) 0xf000262cu)	/* Emergency Stop Register */
#define MSC1_ESR	(*( MSC0_ESR_type *) 0xf000272cu)	/* Emergency Stop Register */

typedef volatile union
{
	struct
	{ 
		unsigned int STEP           : 10;	/* Step Value */
		unsigned int                : 1;
		unsigned int SM             : 1;	/* Suspend Mode */
		unsigned int SC             : 2;	/* Suspend Control */
		unsigned int DM             : 2;	/* Divider Mode */
		/* const */ unsigned int RESULT         : 10;	/* Result Value */
		unsigned int                : 2;
		/* const */ unsigned int SUSACK         : 1;	/* Suspend Mode Acknowledge */
		/* const */ unsigned int SUSREQ         : 1;	/* Suspend Mode Request */
		unsigned int ENHW           : 1;	/* Enable Hardware Clock Control */
		unsigned int DISCLK         : 1;	/* Disable Clock */
	} B;
	int I;
	unsigned int U;

} MSC0_FDR_type;
#define MSC0_FDR	(*( MSC0_FDR_type *) 0xf000260cu)	/* Fractional Divider Register */
#define MSC1_FDR	(*( MSC0_FDR_type *) 0xf000270cu)	/* Fractional Divider Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EDIP           : 2;	/* Data Frame Interrupt Node Pointer */
		unsigned int EDIE           : 2;	/* Data Frame Interrupt Enable */
		unsigned int ECIP           : 2;	/* Command Frame Interrupt Node Pointer */
		unsigned int                : 1;
		unsigned int ECIE           : 1;	/* Command Frame Interrupt Enable */
		unsigned int TFIP           : 2;	/* Time Frame Interrupt Pointer */
		unsigned int                : 1;
		unsigned int TFIE           : 1;	/* Time Frame Interrupt Enable */
		unsigned int RDIP           : 2;	/* Receive Data Interrupt Pointer */
		unsigned int RDIE           : 2;	/* Receive Data Interrupt Enable */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} MSC0_ICR_type;
#define MSC0_ICR	(*( MSC0_ICR_type *) 0xf0002640u)	/* Interrupt Control Register */
#define MSC1_ICR	(*( MSC0_ICR_type *) 0xf0002740u)	/* Interrupt Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} MSC0_ID_type;
#define MSC0_ID	(*( MSC0_ID_type *) 0xf0002608u)	/* Module Identification Register */
#define MSC1_ID	(*( MSC0_ID_type *) 0xf0002708u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CDEDI          : 1;	/* Clear DEDI Flag */
		unsigned int CDECI          : 1;	/* Clear DECI Flag */
		unsigned int CDTFI          : 1;	/* Clear DTFI Flag */
		unsigned int CURDI          : 1;	/* Clear URDI Flag */
		unsigned int CDP            : 1;	/* Clear DP Flag */
		unsigned int CCP            : 1;	/* Clear CP Flag */
		unsigned int CDDIS          : 1;	/* Clear DSDIS Flag */
		unsigned int                : 9;
		unsigned int SDEDI          : 1;	/* Set DEDI Flag */
		unsigned int SDECI          : 1;	/* Set DECI Flag */
		unsigned int SDTFI          : 1;	/* Set DTFI Flag */
		unsigned int SURDI          : 1;	/* Set URDI Flag */
		unsigned int SDP            : 1;	/* Set DP Bit */
		unsigned int SCP            : 1;	/* Set CP Flag */
		unsigned int SDDIS          : 1;	/* Set DSDIS Flag */
		unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} MSC0_ISC_type;
#define MSC0_ISC	(*( MSC0_ISC_type *) 0xf0002648u)	/* Interrupt Set Clear Register */
#define MSC1_ISC	(*( MSC0_ISC_type *) 0xf0002748u)	/* Interrupt Set Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DEDI           : 1;	/* Data Frame Interrupt Flag */
		/* const */ unsigned int DECI           : 1;	/* Command Frame Interrupt Flag */
		/* const */ unsigned int DTFI           : 1;	/* Time Frame Interrupt Flag */
		/* const */ unsigned int URDI           : 1;	/* Receive Data Interrupt Flag */
		/* const */ unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} MSC0_ISR_type;
#define MSC0_ISR	(*( MSC0_ISR_type *) 0xf0002644u)	/* Interrupt Status Register */
#define MSC1_ISR	(*( MSC0_ISR_type *) 0xf0002744u)	/* Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} MSC0_KRST0_type;
#define MSC0_KRST0	(*( MSC0_KRST0_type *) 0xf00026f4u)	/* Kernel Reset Register 0 */
#define MSC1_KRST0	(*( MSC0_KRST0_type *) 0xf00027f4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} MSC0_KRST1_type;
#define MSC0_KRST1	(*( MSC0_KRST1_type *) 0xf00026f0u)	/* Kernel Reset Register 1 */
#define MSC1_KRST1	(*( MSC0_KRST1_type *) 0xf00027f0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} MSC0_KRSTCLR_type;
#define MSC0_KRSTCLR	(*( MSC0_KRSTCLR_type *) 0xf00026ecu)	/* Kernel Reset Status Clear Register */
#define MSC1_KRSTCLR	(*( MSC0_KRSTCLR_type *) 0xf00027ecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CLP            : 1;	/* FCLP Line Polarity */
		unsigned int SLP            : 1;	/* SOP Line Polarity */
		unsigned int CSLP           : 1;	/* Chip Selection Lines Polarity */
		unsigned int ILP            : 1;	/* SDI Line Polarity */
		unsigned int                : 4;
		unsigned int CLKCTRL        : 1;	/* Clock Control */
		unsigned int CSL            : 2;	/* Chip Enable Selection for ENL */
		unsigned int CSH            : 2;	/* Chip Enable Selection for ENH */
		unsigned int CSC            : 2;	/* Chip Enable Selection for ENC */
		unsigned int                : 1;
		unsigned int SDISEL         : 3;	/* Serial Data Input Selection */
		unsigned int                : 13;
	} B;
	int I;
	unsigned int U;

} MSC0_OCR_type;
#define MSC0_OCR	(*( MSC0_OCR_type *) 0xf000264cu)	/* Output Control Register */
#define MSC1_OCR	(*( MSC0_OCR_type *) 0xf000274cu)	/* Output Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} MSC0_OCS_type;
#define MSC0_OCS	(*( MSC0_OCS_type *) 0xf00026e8u)	/* OCDS Control and Status */
#define MSC1_OCS	(*( MSC0_OCS_type *) 0xf00027e8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DATA           : 8;	/* Received Data */
		unsigned int                : 8;
		/* const */ unsigned int V              : 1;	/* Valid Bit */
		/* const */ unsigned int P              : 1;	/* Parity Bit */
		unsigned int C              : 1;	/* Clear Bit */
		/* const */ unsigned int LABF           : 2;	/* Lower Address Bit Field */
		/* const */ unsigned int IPF            : 1;	/* Internal Parity Flag */
		/* const */ unsigned int PERR           : 1;	/* Parity Error */
		unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} MSC0_UD0_type;
#define MSC0_UD0	(*( MSC0_UD0_type *) 0xf0002630u)	/* Upstream Data Register 0 */
#define MSC0_UD1	(*( MSC0_UD0_type *) 0xf0002634u)	/* Upstream Data Register 1 */
#define MSC0_UD2	(*( MSC0_UD0_type *) 0xf0002638u)	/* Upstream Data Register 2 */
#define MSC0_UD3	(*( MSC0_UD0_type *) 0xf000263cu)	/* Upstream Data Register 3 */
#define MSC1_UD0	(*( MSC0_UD0_type *) 0xf0002730u)	/* Upstream Data Register 0 */
#define MSC1_UD1	(*( MSC0_UD0_type *) 0xf0002734u)	/* Upstream Data Register 1 */
#define MSC1_UD2	(*( MSC0_UD0_type *) 0xf0002738u)	/* Upstream Data Register 2 */
#define MSC1_UD3	(*( MSC0_UD0_type *) 0xf000273cu)	/* Upstream Data Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int USTOPRE        : 4;	/* Upstream Timeout Prescaler */
		unsigned int USTOVAL        : 4;	/* Upstream Timeout Value */
		unsigned int USTOEN         : 1;	/* Upstream Timeout Interrupt Enable */
		/* const */ unsigned int USTF           : 1;	/* Upstream Timeout Flag */
		unsigned int USTC           : 1;	/* Upstream Timout Clear */
		unsigned int USTS           : 1;	/* Upstream Timout Set */
		unsigned int                : 1;
		unsigned int UTASR          : 1;	/* Upstream Timout Alternate Service Request */
		unsigned int USTOIP         : 2;	/* Upstream Timout Interrupt Node Pointer */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} MSC0_USCE_type;
#define MSC0_USCE	(*( MSC0_USCE_type *) 0xf000265cu)	/* Upstream Control Enhanced Register 1 */
#define MSC1_USCE	(*( MSC0_USCE_type *) 0xf000275cu)	/* Upstream Control Enhanced Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int UFT            : 1;	/* Upstream Channel Frame Type */
		unsigned int URR            : 3;	/* Upstream Channel Receiving Rate */
		unsigned int PCTR           : 1;	/* Parity Control */
		unsigned int SRDC           : 1;	/* Service Request Delay Control */
		unsigned int                : 10;
		/* const */ unsigned int UC             : 5;	/* Upstream Counter */
		unsigned int                : 11;
	} B;
	int I;
	unsigned int U;

} MSC0_USR_type;
#define MSC0_USR	(*( MSC0_USR_type *) 0xf0002610u)	/* Upstream Status Register */
#define MSC1_USR	(*( MSC0_USR_type *) 0xf0002710u)	/* Upstream Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} MSC1_ACCEN1_type;
#define MSC1_ACCEN1	(*( MSC1_ACCEN1_type *) 0xf00027f8u)	/* Access Enable Register 1 */


/* SENT */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} SENT_ACCEN0_type;
#define SENT_ACCEN0	(*( SENT_ACCEN0_type *) 0xf00030fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} SENT_ACCEN1_type;
#define SENT_ACCEN1	(*( SENT_ACCEN1_type *) 0xf00030f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int DIV            : 12;	/* Divider Value */
		unsigned int                : 4;
		/* const */ unsigned int DIVM           : 12;	/* Measured Divider Value */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} SENT_CFDR0_type;
#define SENT_CFDR0	(*( SENT_CFDR0_type *) 0xf0003104u)	/* Channel Fractional Divider Register 0 */
#define SENT_CFDR1	(*( SENT_CFDR0_type *) 0xf0003144u)	/* Channel Fractional Divider Register 1 */
#define SENT_CFDR2	(*( SENT_CFDR0_type *) 0xf0003184u)	/* Channel Fractional Divider Register 2 */
#define SENT_CFDR3	(*( SENT_CFDR0_type *) 0xf00031c4u)	/* Channel Fractional Divider Register 3 */
#define SENT_CFDR4	(*( SENT_CFDR0_type *) 0xf0003204u)	/* Channel Fractional Divider Register 4 */
#define SENT_CFDR5	(*( SENT_CFDR0_type *) 0xf0003244u)	/* Channel Fractional Divider Register 5 */
#define SENT_CFDR6	(*( SENT_CFDR0_type *) 0xf0003284u)	/* Channel Fractional Divider Register 6 */
#define SENT_CFDR7	(*( SENT_CFDR0_type *) 0xf00032c4u)	/* Channel Fractional Divider Register 7 */
#define SENT_CFDR8	(*( SENT_CFDR0_type *) 0xf0003304u)	/* Channel Fractional Divider Register 8 */
#define SENT_CFDR9	(*( SENT_CFDR0_type *) 0xf0003344u)	/* Channel Fractional Divider Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 4;
		unsigned int RMC            : 8;	/* 8-bit Clock Divider Value in RUN Mode */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SENT_CLC_type;
#define SENT_CLC	(*( SENT_CLC_type *) 0xf0003000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PDIV           : 12;	/* Divider Factor of Pre Divider for Channel x */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} SENT_CPDR0_type;
#define SENT_CPDR0	(*( SENT_CPDR0_type *) 0xf0003100u)	/* Channel Pre Divider Register 0 */
#define SENT_CPDR1	(*( SENT_CPDR0_type *) 0xf0003140u)	/* Channel Pre Divider Register 1 */
#define SENT_CPDR2	(*( SENT_CPDR0_type *) 0xf0003180u)	/* Channel Pre Divider Register 2 */
#define SENT_CPDR3	(*( SENT_CPDR0_type *) 0xf00031c0u)	/* Channel Pre Divider Register 3 */
#define SENT_CPDR4	(*( SENT_CPDR0_type *) 0xf0003200u)	/* Channel Pre Divider Register 4 */
#define SENT_CPDR5	(*( SENT_CPDR0_type *) 0xf0003240u)	/* Channel Pre Divider Register 5 */
#define SENT_CPDR6	(*( SENT_CPDR0_type *) 0xf0003280u)	/* Channel Pre Divider Register 6 */
#define SENT_CPDR7	(*( SENT_CPDR0_type *) 0xf00032c0u)	/* Channel Pre Divider Register 7 */
#define SENT_CPDR8	(*( SENT_CPDR0_type *) 0xf0003300u)	/* Channel Pre Divider Register 8 */
#define SENT_CPDR9	(*( SENT_CPDR0_type *) 0xf0003340u)	/* Channel Pre Divider Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int STEP           : 10;	/* Step Value */
		unsigned int                : 4;
		unsigned int DM             : 2;	/* Divider Mode */
		/* const */ unsigned int RESULT         : 10;	/* Result Value */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} SENT_FDR_type;
#define SENT_FDR	(*( SENT_FDR_type *) 0xf000300cu)	/* SENT Fractional Divider Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} SENT_ID_type;
#define SENT_ID	(*( SENT_ID_type *) 0xf0003008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RSI            : 4;	/* Interrupt Node Pointer for Interrupt RSI */
		unsigned int RDI            : 4;	/* Interrupt Node Pointer for Interrupt RDI */
		unsigned int RBI            : 4;	/* Interrupt Node Pointer for Interrupt RBI */
		unsigned int TDI            : 4;	/* Interrupt Node Pointer for Interrupt TDI */
		unsigned int TBI            : 4;	/* Interrupt Node Pointer for Interrupt TBI */
		unsigned int ERRI           : 4;	/* Interrupt Node Pointer for Interrupt FRI, FDI, NNI, NVI, CRCI, WSI, SCRI */
		unsigned int SDI            : 4;	/* Interrupt Node Pointer for Interrupt SDI */
		unsigned int WDI            : 4;	/* Interrupt Node Pointer for Interrupt WDI */
	} B;
	int I;
	unsigned int U;

} SENT_INP0_type;
#define SENT_INP0	(*( SENT_INP0_type *) 0xf0003130u)	/* Interrupt Node Pointer Register 0 */
#define SENT_INP1	(*( SENT_INP0_type *) 0xf0003170u)	/* Interrupt Node Pointer Register 1 */
#define SENT_INP2	(*( SENT_INP0_type *) 0xf00031b0u)	/* Interrupt Node Pointer Register 2 */
#define SENT_INP3	(*( SENT_INP0_type *) 0xf00031f0u)	/* Interrupt Node Pointer Register 3 */
#define SENT_INP4	(*( SENT_INP0_type *) 0xf0003230u)	/* Interrupt Node Pointer Register 4 */
#define SENT_INP5	(*( SENT_INP0_type *) 0xf0003270u)	/* Interrupt Node Pointer Register 5 */
#define SENT_INP6	(*( SENT_INP0_type *) 0xf00032b0u)	/* Interrupt Node Pointer Register 6 */
#define SENT_INP7	(*( SENT_INP0_type *) 0xf00032f0u)	/* Interrupt Node Pointer Register 7 */
#define SENT_INP8	(*( SENT_INP0_type *) 0xf0003330u)	/* Interrupt Node Pointer Register 8 */
#define SENT_INP9	(*( SENT_INP0_type *) 0xf0003370u)	/* Interrupt Node Pointer Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int RSI            : 1;	/* Clear Interrupt Request Flag RSI */
		unsigned int RDI            : 1;	/* Clear Interrupt Request Flag RDI */
		unsigned int RBI            : 1;	/* Clear Interrupt Request Flag RBI */
		unsigned int TDI            : 1;	/* Clear Interrupt Request Flag TDI */
		unsigned int TBI            : 1;	/* Clear Interrupt Request Flag TBI */
		unsigned int FRI            : 1;	/* Clear Interrupt Request Flag FRI */
		unsigned int FDI            : 1;	/* Clear Interrupt Request Flag FDI */
		unsigned int NNI            : 1;	/* Clear Interrupt Request Flag NMI */
		unsigned int NVI            : 1;	/* Clear Interrupt Request Flag NVI */
		unsigned int CRCI           : 1;	/* Clear Interrupt Request Flag CRCI */
		unsigned int WSI            : 1;	/* Clear Interrupt Request Flag WSI */
		unsigned int SDI            : 1;	/* Clear Interrupt Request Flag SDI */
		unsigned int SCRI           : 1;	/* Clear Interrupt Request Flag SCRI */
		unsigned int WDI            : 1;	/* Clear Interrupt Request Flag WDI */
		unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} SENT_INTCLR0_type;
#define SENT_INTCLR0	(*( SENT_INTCLR0_type *) 0xf0003128u)	/* Interrupt Clear Register 0 */
#define SENT_INTCLR1	(*( SENT_INTCLR0_type *) 0xf0003168u)	/* Interrupt Clear Register 1 */
#define SENT_INTCLR2	(*( SENT_INTCLR0_type *) 0xf00031a8u)	/* Interrupt Clear Register 2 */
#define SENT_INTCLR3	(*( SENT_INTCLR0_type *) 0xf00031e8u)	/* Interrupt Clear Register 3 */
#define SENT_INTCLR4	(*( SENT_INTCLR0_type *) 0xf0003228u)	/* Interrupt Clear Register 4 */
#define SENT_INTCLR5	(*( SENT_INTCLR0_type *) 0xf0003268u)	/* Interrupt Clear Register 5 */
#define SENT_INTCLR6	(*( SENT_INTCLR0_type *) 0xf00032a8u)	/* Interrupt Clear Register 6 */
#define SENT_INTCLR7	(*( SENT_INTCLR0_type *) 0xf00032e8u)	/* Interrupt Clear Register 7 */
#define SENT_INTCLR8	(*( SENT_INTCLR0_type *) 0xf0003328u)	/* Interrupt Clear Register 8 */
#define SENT_INTCLR9	(*( SENT_INTCLR0_type *) 0xf0003368u)	/* Interrupt Clear Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int RSI            : 1;	/* Enable Interrupt Request RSI */
		unsigned int RDI            : 1;	/* Enable Interrupt Request RDI */
		unsigned int RBI            : 1;	/* Enable Interrupt Request RBI */
		unsigned int TDI            : 1;	/* Enable Interrupt Request TDI */
		unsigned int TBI            : 1;	/* Enable Interrupt Request TBI */
		unsigned int FRI            : 1;	/* Enable Interrupt Request FRI */
		unsigned int FDI            : 1;	/* Enable Interrupt Request FDI */
		unsigned int NNI            : 1;	/* Enable Interrupt Request NNI */
		unsigned int NVI            : 1;	/* Enable Interrupt Request NVI */
		unsigned int CRCI           : 1;	/* Enable Interrupt Request CRCI */
		unsigned int WSI            : 1;	/* Enable Interrupt Request WSI */
		unsigned int SDI            : 1;	/* Enable Interrupt Request SDI */
		unsigned int SCRI           : 1;	/* Enable Interrupt Request SCRI */
		unsigned int WDI            : 1;	/* Enable Interrupt Request WDI */
		unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} SENT_INTEN0_type;
#define SENT_INTEN0	(*( SENT_INTEN0_type *) 0xf000312cu)	/* Interrupt Enable Register 0 */
#define SENT_INTEN1	(*( SENT_INTEN0_type *) 0xf000316cu)	/* Interrupt Enable Register 1 */
#define SENT_INTEN2	(*( SENT_INTEN0_type *) 0xf00031acu)	/* Interrupt Enable Register 2 */
#define SENT_INTEN3	(*( SENT_INTEN0_type *) 0xf00031ecu)	/* Interrupt Enable Register 3 */
#define SENT_INTEN4	(*( SENT_INTEN0_type *) 0xf000322cu)	/* Interrupt Enable Register 4 */
#define SENT_INTEN5	(*( SENT_INTEN0_type *) 0xf000326cu)	/* Interrupt Enable Register 5 */
#define SENT_INTEN6	(*( SENT_INTEN0_type *) 0xf00032acu)	/* Interrupt Enable Register 6 */
#define SENT_INTEN7	(*( SENT_INTEN0_type *) 0xf00032ecu)	/* Interrupt Enable Register 7 */
#define SENT_INTEN8	(*( SENT_INTEN0_type *) 0xf000332cu)	/* Interrupt Enable Register 8 */
#define SENT_INTEN9	(*( SENT_INTEN0_type *) 0xf000336cu)	/* Interrupt Enable Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int IPC0           : 1;	/* Interrupt Pending on Channel y */
		/* const */ unsigned int IPC1           : 1;	/* Interrupt Pending on Channel y */
		/* const */ unsigned int IPC2           : 1;	/* Interrupt Pending on Channel y */
		/* const */ unsigned int IPC3           : 1;	/* Interrupt Pending on Channel y */
		/* const */ unsigned int IPC4           : 1;	/* Interrupt Pending on Channel y */
		/* const */ unsigned int IPC5           : 1;	/* Interrupt Pending on Channel y */
		/* const */ unsigned int IPC6           : 1;	/* Interrupt Pending on Channel y */
		/* const */ unsigned int IPC7           : 1;	/* Interrupt Pending on Channel y */
		/* const */ unsigned int IPC8           : 1;	/* Interrupt Pending on Channel y */
		/* const */ unsigned int IPC9           : 1;	/* Interrupt Pending on Channel y */
		/* const */ unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} SENT_INTOV_type;
#define SENT_INTOV	(*( SENT_INTOV_type *) 0xf0003014u)	/* Interrupt Overview Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RSI            : 1;	/* Set Interrupt Request Flag RSI */
		unsigned int RDI            : 1;	/* Set Interrupt Request Flag RDI */
		unsigned int RBI            : 1;	/* Set Interrupt Request Flag RBI */
		unsigned int TDI            : 1;	/* Set Interrupt Request Flag TDI */
		unsigned int TBI            : 1;	/* Set Interrupt Request Flag TBI */
		unsigned int FRI            : 1;	/* Set Interrupt Request Flag FRI */
		unsigned int FDI            : 1;	/* Set Interrupt Request Flag FDI */
		unsigned int NNI            : 1;	/* Set Interrupt Request Flag NNI */
		unsigned int NVI            : 1;	/* Set Interrupt Request Flag NVI */
		unsigned int CRCI           : 1;	/* Set Interrupt Request Flag CRCI */
		unsigned int WSI            : 1;	/* Set Interrupt Request Flag WSI */
		unsigned int SDI            : 1;	/* Set Interrupt Request Flag SDI */
		unsigned int SCRI           : 1;	/* Set Interrupt Request Flag SCRI */
		unsigned int WDI            : 1;	/* Set Interrupt Request Flag WDI */
		unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} SENT_INTSET0_type;
#define SENT_INTSET0	(*( SENT_INTSET0_type *) 0xf0003124u)	/* Interrupt Set Register 0 */
#define SENT_INTSET1	(*( SENT_INTSET0_type *) 0xf0003164u)	/* Interrupt Set Register 1 */
#define SENT_INTSET2	(*( SENT_INTSET0_type *) 0xf00031a4u)	/* Interrupt Set Register 2 */
#define SENT_INTSET3	(*( SENT_INTSET0_type *) 0xf00031e4u)	/* Interrupt Set Register 3 */
#define SENT_INTSET4	(*( SENT_INTSET0_type *) 0xf0003224u)	/* Interrupt Set Register 4 */
#define SENT_INTSET5	(*( SENT_INTSET0_type *) 0xf0003264u)	/* Interrupt Set Register 5 */
#define SENT_INTSET6	(*( SENT_INTSET0_type *) 0xf00032a4u)	/* Interrupt Set Register 6 */
#define SENT_INTSET7	(*( SENT_INTSET0_type *) 0xf00032e4u)	/* Interrupt Set Register 7 */
#define SENT_INTSET8	(*( SENT_INTSET0_type *) 0xf0003324u)	/* Interrupt Set Register 8 */
#define SENT_INTSET9	(*( SENT_INTSET0_type *) 0xf0003364u)	/* Interrupt Set Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RSI            : 1;	/* Receive Success Interrupt Request Flag */
		/* const */ unsigned int RDI            : 1;	/* Receive Data Interrupt Request Flag */
		/* const */ unsigned int RBI            : 1;	/* Receive Buffer Overflow Interrupt Request Flag */
		/* const */ unsigned int TDI            : 1;	/* Transfer Data Interrupt Request Flag */
		/* const */ unsigned int TBI            : 1;	/* Transmit Buffer Underflow Interrupt Request Flag */
		/* const */ unsigned int FRI            : 1;	/* Frequency Range Interrupt Request Flag */
		/* const */ unsigned int FDI            : 1;	/* Frequency Drift Interrupt Request Flag */
		/* const */ unsigned int NNI            : 1;	/* Number of Nibbles Wrong Request Flag */
		/* const */ unsigned int NVI            : 1;	/* Nibbles Value out of Range Request Flag */
		/* const */ unsigned int CRCI           : 1;	/* CRC Error Request Flag */
		/* const */ unsigned int WSI            : 1;	/* Wrong Status and Communication Nibble Error Request Flag */
		/* const */ unsigned int SDI            : 1;	/* Serial Data Receive Interrupt Request Flag */
		/* const */ unsigned int SCRI           : 1;	/* Serial Data CRC Error Request Flag */
		/* const */ unsigned int WDI            : 1;	/* Watch Dog Error Request Flag */
		/* const */ unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} SENT_INTSTAT0_type;
#define SENT_INTSTAT0	(*( SENT_INTSTAT0_type *) 0xf0003120u)	/* Interrupt Status Register 0 */
#define SENT_INTSTAT1	(*( SENT_INTSTAT0_type *) 0xf0003160u)	/* Interrupt Status Register 1 */
#define SENT_INTSTAT2	(*( SENT_INTSTAT0_type *) 0xf00031a0u)	/* Interrupt Status Register 2 */
#define SENT_INTSTAT3	(*( SENT_INTSTAT0_type *) 0xf00031e0u)	/* Interrupt Status Register 3 */
#define SENT_INTSTAT4	(*( SENT_INTSTAT0_type *) 0xf0003220u)	/* Interrupt Status Register 4 */
#define SENT_INTSTAT5	(*( SENT_INTSTAT0_type *) 0xf0003260u)	/* Interrupt Status Register 5 */
#define SENT_INTSTAT6	(*( SENT_INTSTAT0_type *) 0xf00032a0u)	/* Interrupt Status Register 6 */
#define SENT_INTSTAT7	(*( SENT_INTSTAT0_type *) 0xf00032e0u)	/* Interrupt Status Register 7 */
#define SENT_INTSTAT8	(*( SENT_INTSTAT0_type *) 0xf0003320u)	/* Interrupt Status Register 8 */
#define SENT_INTSTAT9	(*( SENT_INTSTAT0_type *) 0xf0003360u)	/* Interrupt Status Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int ALTI           : 2;	/* Alternate Input Select */
		unsigned int                : 2;
		unsigned int DEPTH          : 4;	/* Digital Glitch Filter Depth */
		unsigned int OIE            : 1;	/* Output Inverter Enable Channel x */
		unsigned int IIE            : 1;	/* Input Inverter Enable Channel x */
		unsigned int CEC            : 1;	/* Clear Edge Counter */
		unsigned int                : 1;
		/* const */ unsigned int REG            : 1;	/* Rising Edge Glitch Flag for Channel x */
		/* const */ unsigned int FEG            : 1;	/* Falling Edge Glitch Flag for Channel x */
		unsigned int CREG           : 1;	/* Clear Rising Edge Glitch Flag for Channel x */
		unsigned int CFEG           : 1;	/* Clear Falling Edge Glitch Flag for Channel x */
		unsigned int ETS            : 4;	/* External Trigger Select */
		/* const */ unsigned int EC             : 8;	/* Edge Counter */
		unsigned int CTR            : 1;	/* Clear Trigger Monitor Flag for Channel x */
		/* const */ unsigned int TRM            : 1;	/* Trigger Monitor Flag for Channel x */
		/* const */ unsigned int RXM            : 1;	/* Receive Monitor for Channel x */
		/* const */ unsigned int TXM            : 1;	/* Transmit Monitor for Channel x */
	} B;
	int I;
	unsigned int U;

} SENT_IOCR0_type;
#define SENT_IOCR0	(*( SENT_IOCR0_type *) 0xf0003114u)	/* Input and Output Control Register 0 */
#define SENT_IOCR1	(*( SENT_IOCR0_type *) 0xf0003154u)	/* Input and Output Control Register 1 */
#define SENT_IOCR2	(*( SENT_IOCR0_type *) 0xf0003194u)	/* Input and Output Control Register 2 */
#define SENT_IOCR3	(*( SENT_IOCR0_type *) 0xf00031d4u)	/* Input and Output Control Register 3 */
#define SENT_IOCR4	(*( SENT_IOCR0_type *) 0xf0003214u)	/* Input and Output Control Register 4 */
#define SENT_IOCR5	(*( SENT_IOCR0_type *) 0xf0003254u)	/* Input and Output Control Register 5 */
#define SENT_IOCR6	(*( SENT_IOCR0_type *) 0xf0003294u)	/* Input and Output Control Register 6 */
#define SENT_IOCR7	(*( SENT_IOCR0_type *) 0xf00032d4u)	/* Input and Output Control Register 7 */
#define SENT_IOCR8	(*( SENT_IOCR0_type *) 0xf0003314u)	/* Input and Output Control Register 8 */
#define SENT_IOCR9	(*( SENT_IOCR0_type *) 0xf0003354u)	/* Input and Output Control Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} SENT_KRST0_type;
#define SENT_KRST0	(*( SENT_KRST0_type *) 0xf00030f4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} SENT_KRST1_type;
#define SENT_KRST1	(*( SENT_KRST1_type *) 0xf00030f0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} SENT_KRSTCLR_type;
#define SENT_KRSTCLR	(*( SENT_KRSTCLR_type *) 0xf00030ecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} SENT_OCS_type;
#define SENT_OCS	(*( SENT_OCS_type *) 0xf00030e8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		unsigned int CEN            : 1;	/* Channel Enable */
		unsigned int IEP            : 1;	/* Ignore End Pulse */
		unsigned int ACE            : 1;	/* Alternative CRC Mode Enable */
		unsigned int SNI            : 1;	/* Status Nibble Included in CRC */
		unsigned int SDP            : 1;	/* Serial Data Processing Mode */
		unsigned int SCDIS          : 1;	/* CRC for Serial Data Disabled Mode */
		unsigned int CDIS           : 1;	/* CRC Disabled Mode */
		unsigned int CFC            : 1;	/* Consecutive Frame Check */
		unsigned int FRL            : 8;	/* Frame Length */
		unsigned int CRZ            : 1;	/* CRC with Zero Nibble for Serial Data */
		unsigned int ESF            : 1;	/* Extended Serial Frame Mode */
		unsigned int IDE            : 1;	/* Ignore Drift Error Mode */
		unsigned int SUSEN          : 1;	/* Suspend Enable */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} SENT_RCR0_type;
#define SENT_RCR0	(*( SENT_RCR0_type *) 0xf0003108u)	/* Receiver Control Register 0 */
#define SENT_RCR1	(*( SENT_RCR0_type *) 0xf0003148u)	/* Receiver Control Register 1 */
#define SENT_RCR2	(*( SENT_RCR0_type *) 0xf0003188u)	/* Receiver Control Register 2 */
#define SENT_RCR3	(*( SENT_RCR0_type *) 0xf00031c8u)	/* Receiver Control Register 3 */
#define SENT_RCR4	(*( SENT_RCR0_type *) 0xf0003208u)	/* Receiver Control Register 4 */
#define SENT_RCR5	(*( SENT_RCR0_type *) 0xf0003248u)	/* Receiver Control Register 5 */
#define SENT_RCR6	(*( SENT_RCR0_type *) 0xf0003288u)	/* Receiver Control Register 6 */
#define SENT_RCR7	(*( SENT_RCR0_type *) 0xf00032c8u)	/* Receiver Control Register 7 */
#define SENT_RCR8	(*( SENT_RCR0_type *) 0xf0003308u)	/* Receiver Control Register 8 */
#define SENT_RCR9	(*( SENT_RCR0_type *) 0xf0003348u)	/* Receiver Control Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RD0            : 4;	/* Receive Data Nibble y */
		/* const */ unsigned int RD1            : 4;	/* Receive Data Nibble y */
		/* const */ unsigned int RD2            : 4;	/* Receive Data Nibble y */
		/* const */ unsigned int RD3            : 4;	/* Receive Data Nibble y */
		/* const */ unsigned int RD4            : 4;	/* Receive Data Nibble y */
		/* const */ unsigned int RD5            : 4;	/* Receive Data Nibble y */
		/* const */ unsigned int RD6            : 4;	/* Receive Data Nibble y */
		/* const */ unsigned int RD7            : 4;	/* Receive Data Nibble y */
	} B;
	int I;
	unsigned int U;

} SENT_RDR0_type;
#define SENT_RDR0	(*( SENT_RDR0_type *) 0xf0003080u)	/* Receive Data Register 0 */
#define SENT_RDR1	(*( SENT_RDR0_type *) 0xf0003084u)	/* Receive Data Register 1 */
#define SENT_RDR2	(*( SENT_RDR0_type *) 0xf0003088u)	/* Receive Data Register 2 */
#define SENT_RDR3	(*( SENT_RDR0_type *) 0xf000308cu)	/* Receive Data Register 3 */
#define SENT_RDR4	(*( SENT_RDR0_type *) 0xf0003090u)	/* Receive Data Register 4 */
#define SENT_RDR5	(*( SENT_RDR0_type *) 0xf0003094u)	/* Receive Data Register 5 */
#define SENT_RDR6	(*( SENT_RDR0_type *) 0xf0003098u)	/* Receive Data Register 6 */
#define SENT_RDR7	(*( SENT_RDR0_type *) 0xf000309cu)	/* Receive Data Register 7 */
#define SENT_RDR8	(*( SENT_RDR0_type *) 0xf00030a0u)	/* Receive Data Register 8 */
#define SENT_RDR9	(*( SENT_RDR0_type *) 0xf00030a4u)	/* Receive Data Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CRC            : 4;	/* CRC */
		/* const */ unsigned int CST            : 2;	/* Channel Status */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int SCN            : 4;	/* Status and Communication Nibble */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} SENT_RSR0_type;
#define SENT_RSR0	(*( SENT_RSR0_type *) 0xf000310cu)	/* Receive Status Register 0 */
#define SENT_RSR1	(*( SENT_RSR0_type *) 0xf000314cu)	/* Receive Status Register 1 */
#define SENT_RSR2	(*( SENT_RSR0_type *) 0xf000318cu)	/* Receive Status Register 2 */
#define SENT_RSR3	(*( SENT_RSR0_type *) 0xf00031ccu)	/* Receive Status Register 3 */
#define SENT_RSR4	(*( SENT_RSR0_type *) 0xf000320cu)	/* Receive Status Register 4 */
#define SENT_RSR5	(*( SENT_RSR0_type *) 0xf000324cu)	/* Receive Status Register 5 */
#define SENT_RSR6	(*( SENT_RSR0_type *) 0xf000328cu)	/* Receive Status Register 6 */
#define SENT_RSR7	(*( SENT_RSR0_type *) 0xf00032ccu)	/* Receive Status Register 7 */
#define SENT_RSR8	(*( SENT_RSR0_type *) 0xf000330cu)	/* Receive Status Register 8 */
#define SENT_RSR9	(*( SENT_RSR0_type *) 0xf000334cu)	/* Receive Status Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int LTS            : 32;	/* Last Receive Time Stamp for Channel x */
	} B;
	int I;
	unsigned int U;

} SENT_RTS0_type;
#define SENT_RTS0	(*( SENT_RTS0_type *) 0xf0003a80u)	/* Receive Time Stamp Register 0 */
#define SENT_RTS1	(*( SENT_RTS0_type *) 0xf0003a84u)	/* Receive Time Stamp Register 1 */
#define SENT_RTS2	(*( SENT_RTS0_type *) 0xf0003a88u)	/* Receive Time Stamp Register 2 */
#define SENT_RTS3	(*( SENT_RTS0_type *) 0xf0003a8cu)	/* Receive Time Stamp Register 3 */
#define SENT_RTS4	(*( SENT_RTS0_type *) 0xf0003a90u)	/* Receive Time Stamp Register 4 */
#define SENT_RTS5	(*( SENT_RTS0_type *) 0xf0003a94u)	/* Receive Time Stamp Register 5 */
#define SENT_RTS6	(*( SENT_RTS0_type *) 0xf0003a98u)	/* Receive Time Stamp Register 6 */
#define SENT_RTS7	(*( SENT_RTS0_type *) 0xf0003a9cu)	/* Receive Time Stamp Register 7 */
#define SENT_RTS8	(*( SENT_RTS0_type *) 0xf0003aa0u)	/* Receive Time Stamp Register 8 */
#define SENT_RTS9	(*( SENT_RTS0_type *) 0xf0003aa4u)	/* Receive Time Stamp Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int PLEN           : 6;	/* Pulse Length */
		unsigned int TRIG           : 2;	/* Trigger Source and Mode Selection */
		unsigned int DEL            : 6;	/* Delay Length */
		unsigned int BASE           : 1;	/* Time Base */
		/* const */ unsigned int TRQ            : 1;	/* Transfer Request in Progress */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SENT_SCR0_type;
#define SENT_SCR0	(*( SENT_SCR0_type *) 0xf0003118u)	/* SPC Control Register 0 */
#define SENT_SCR1	(*( SENT_SCR0_type *) 0xf0003158u)	/* SPC Control Register 1 */
#define SENT_SCR2	(*( SENT_SCR0_type *) 0xf0003198u)	/* SPC Control Register 2 */
#define SENT_SCR3	(*( SENT_SCR0_type *) 0xf00031d8u)	/* SPC Control Register 3 */
#define SENT_SCR4	(*( SENT_SCR0_type *) 0xf0003218u)	/* SPC Control Register 4 */
#define SENT_SCR5	(*( SENT_SCR0_type *) 0xf0003258u)	/* SPC Control Register 5 */
#define SENT_SCR6	(*( SENT_SCR0_type *) 0xf0003298u)	/* SPC Control Register 6 */
#define SENT_SCR7	(*( SENT_SCR0_type *) 0xf00032d8u)	/* SPC Control Register 7 */
#define SENT_SCR8	(*( SENT_SCR0_type *) 0xf0003318u)	/* SPC Control Register 8 */
#define SENT_SCR9	(*( SENT_SCR0_type *) 0xf0003358u)	/* SPC Control Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SD             : 16;	/* Serial Data */
		/* const */ unsigned int MID            : 8;	/* Message ID */
		/* const */ unsigned int SCRC           : 6;	/* SCRC */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int CON            : 1;	/* Configuration bit */
	} B;
	int I;
	unsigned int U;

} SENT_SDS0_type;
#define SENT_SDS0	(*( SENT_SDS0_type *) 0xf0003110u)	/* Serial Data and Status Register 0 */
#define SENT_SDS1	(*( SENT_SDS0_type *) 0xf0003150u)	/* Serial Data and Status Register 1 */
#define SENT_SDS2	(*( SENT_SDS0_type *) 0xf0003190u)	/* Serial Data and Status Register 2 */
#define SENT_SDS3	(*( SENT_SDS0_type *) 0xf00031d0u)	/* Serial Data and Status Register 3 */
#define SENT_SDS4	(*( SENT_SDS0_type *) 0xf0003210u)	/* Serial Data and Status Register 4 */
#define SENT_SDS5	(*( SENT_SDS0_type *) 0xf0003250u)	/* Serial Data and Status Register 5 */
#define SENT_SDS6	(*( SENT_SDS0_type *) 0xf0003290u)	/* Serial Data and Status Register 6 */
#define SENT_SDS7	(*( SENT_SDS0_type *) 0xf00032d0u)	/* Serial Data and Status Register 7 */
#define SENT_SDS8	(*( SENT_SDS0_type *) 0xf0003310u)	/* Serial Data and Status Register 8 */
#define SENT_SDS9	(*( SENT_SDS0_type *) 0xf0003350u)	/* Serial Data and Status Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int TDIV           : 20;	/* Divider Factor of Pre Divider for TSR */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} SENT_TPD_type;
#define SENT_TPD	(*( SENT_TPD_type *) 0xf000301cu)	/* Time Stamp Predivider Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CTS            : 32;	/* Current Time Stamp for the Module */
	} B;
	int I;
	unsigned int U;

} SENT_TSR_type;
#define SENT_TSR	(*( SENT_TSR_type *) 0xf0003018u)	/* Time Stamp Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RDNP0          : 3;	/* Receive Data Target Nibble Pointer y */
		unsigned int                : 1;
		unsigned int RDNP1          : 3;	/* Receive Data Target Nibble Pointer y */
		unsigned int                : 1;
		unsigned int RDNP2          : 3;	/* Receive Data Target Nibble Pointer y */
		unsigned int                : 1;
		unsigned int RDNP3          : 3;	/* Receive Data Target Nibble Pointer y */
		unsigned int                : 1;
		unsigned int RDNP4          : 3;	/* Receive Data Target Nibble Pointer y */
		unsigned int                : 1;
		unsigned int RDNP5          : 3;	/* Receive Data Target Nibble Pointer y */
		unsigned int                : 1;
		unsigned int RDNP6          : 3;	/* Receive Data Target Nibble Pointer y */
		unsigned int                : 1;
		unsigned int RDNP7          : 3;	/* Receive Data Target Nibble Pointer y */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} SENT_VIEW0_type;
#define SENT_VIEW0	(*( SENT_VIEW0_type *) 0xf000311cu)	/* Receive Data View Register 0 */
#define SENT_VIEW1	(*( SENT_VIEW0_type *) 0xf000315cu)	/* Receive Data View Register 1 */
#define SENT_VIEW2	(*( SENT_VIEW0_type *) 0xf000319cu)	/* Receive Data View Register 2 */
#define SENT_VIEW3	(*( SENT_VIEW0_type *) 0xf00031dcu)	/* Receive Data View Register 3 */
#define SENT_VIEW4	(*( SENT_VIEW0_type *) 0xf000321cu)	/* Receive Data View Register 4 */
#define SENT_VIEW5	(*( SENT_VIEW0_type *) 0xf000325cu)	/* Receive Data View Register 5 */
#define SENT_VIEW6	(*( SENT_VIEW0_type *) 0xf000329cu)	/* Receive Data View Register 6 */
#define SENT_VIEW7	(*( SENT_VIEW0_type *) 0xf00032dcu)	/* Receive Data View Register 7 */
#define SENT_VIEW8	(*( SENT_VIEW0_type *) 0xf000331cu)	/* Receive Data View Register 8 */
#define SENT_VIEW9	(*( SENT_VIEW0_type *) 0xf000335cu)	/* Receive Data View Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int WDLx           : 16;	/* Watch Dog Timer Limit */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} SENT_WDT0_type;
#define SENT_WDT0	(*( SENT_WDT0_type *) 0xf0003134u)	/* Watch Dog Timer Register 0 */
#define SENT_WDT1	(*( SENT_WDT0_type *) 0xf0003174u)	/* Watch Dog Timer Register 1 */
#define SENT_WDT2	(*( SENT_WDT0_type *) 0xf00031b4u)	/* Watch Dog Timer Register 2 */
#define SENT_WDT3	(*( SENT_WDT0_type *) 0xf00031f4u)	/* Watch Dog Timer Register 3 */
#define SENT_WDT4	(*( SENT_WDT0_type *) 0xf0003234u)	/* Watch Dog Timer Register 4 */
#define SENT_WDT5	(*( SENT_WDT0_type *) 0xf0003274u)	/* Watch Dog Timer Register 5 */
#define SENT_WDT6	(*( SENT_WDT0_type *) 0xf00032b4u)	/* Watch Dog Timer Register 6 */
#define SENT_WDT7	(*( SENT_WDT0_type *) 0xf00032f4u)	/* Watch Dog Timer Register 7 */
#define SENT_WDT8	(*( SENT_WDT0_type *) 0xf0003334u)	/* Watch Dog Timer Register 8 */
#define SENT_WDT9	(*( SENT_WDT0_type *) 0xf0003374u)	/* Watch Dog Timer Register 9 */


/* ERAY */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} ERAY_ACCEN0_type;
#define ERAY_ACCEN0	(*( ERAY_ACCEN0_type *) 0xf001c8fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} ERAY_ACCEN1_type;
#define ERAY_ACCEN1	(*( ERAY_ACCEN1_type *) 0xf001c8f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int VFRA           : 1;	/* Valid Frame Received on Channel A (vSS!ValidFrameA) */
		unsigned int SEDA           : 1;	/* Syntax Error Detected on Channel A (vSS!SyntaxErrorA) */
		unsigned int CEDA           : 1;	/* Content Error Detected on Channel A (vSS!ContentErrorA) */
		unsigned int CIA            : 1;	/* Communication Indicator Channel A */
		unsigned int SBVA           : 1;	/* Slot Boundary Violation on Channel A (vSS!BViolationA) */
		unsigned int                : 3;
		unsigned int VFRB           : 1;	/* Valid Frame Received on Channel B (vSS!ValidFrameB) */
		unsigned int SEDB           : 1;	/* Syntax Error Detected on Channel B (vSS!SyntaxErrorB) */
		unsigned int CEDB           : 1;	/* Content Error Detected on Channel B (vSS!ContentErrorB) */
		unsigned int CIB            : 1;	/* Communication Indicator Channel B */
		unsigned int SBVB           : 1;	/* Slot Boundary Violation on Channel B (vSS!BViolationB) */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} ERAY_ACS_type;
#define ERAY_ACS	(*( ERAY_ACS_type *) 0xf001c128u)	/* Aggregated Channel Status */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CCFC           : 4;	/* Clock Correction Failed Counter (vClockCorrectionFailed) */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int ERRM           : 2;	/* Error Mode (vPOC!ErrorMode) */
		/* const */ unsigned int PTAC           : 5;	/* Passive to Active Count (vAllowPassiveToActive) */
		/* const */ unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} ERAY_CCEV_type;
#define ERAY_CCEV	(*( ERAY_CCEV_type *) 0xf001c104u)	/* Communication Controller Error Vector */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int POCS           : 6;	/* Protocol Operation Control Status */
		/* const */ unsigned int FSI            : 1;	/* Freeze Status Indicator (vPOC!Freeze) */
		/* const */ unsigned int HRQ            : 1;	/* Halt Request (vPOC!CHIHaltRequest) */
		/* const */ unsigned int SLM            : 2;	/* Slot Mode (vPOC!SlotMode) */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int CSNI           : 1;	/* Coldstart Noise Indicator (vPOC!ColdstartNoise) */
		/* const */ unsigned int CSAI           : 1;	/* Coldstart Abort Indicator */
		/* const */ unsigned int CSI            : 1;	/* Cold Start Inhibit (vColdStartInhibit) */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int WSV            : 3;	/* Wakeup Status (vPOC!WakeupStatus) */
		/* const */ unsigned int RCA            : 5;	/* Remaining Coldstart Attempts (vRemainingColdstartAttempts) */
		/* const */ unsigned int PSL            : 6;	/* POC Status Log */
		/* const */ unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_CCSV_type;
#define ERAY_CCSV	(*( ERAY_CCSV_type *) 0xf001c100u)	/* Communication Controller Status Vector */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 4;
		unsigned int RMC            : 8;	/* 8-bit Clock Divider Value in RUN Mode */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} ERAY_CLC_type;
#define ERAY_CLC	(*( ERAY_CLC_type *) 0xf001c000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DAY            : 8;	/* Design Time Stamp, Day */
		/* const */ unsigned int MON            : 8;	/* Design Time Stamp, Month */
		/* const */ unsigned int YEAR           : 4;	/* Design Time Stamp, Year */
		/* const */ unsigned int SUBSTEP        : 4;	/* Sub-Step of Core Release */
		/* const */ unsigned int STEP           : 4;	/* Step of Core Release */
		/* const */ unsigned int REL            : 4;	/* Core Release */
	} B;
	int I;
	unsigned int U;

} ERAY_CREL_type;
#define ERAY_CREL	(*( ERAY_CREL_type *) 0xf001c3f0u)	/* Core Release Register */

typedef volatile union
{
	struct
	{ 
		unsigned int INT0           : 1;	/* CIF Timeout Service Request Status */
		unsigned int OEN            : 1;	/* Enable auto delay scheme for Output Buffer Control Register (OBCR) */
		unsigned int IEN            : 1;	/* Enable auto delay scheme for Input Buffer Control Register (IBCR) */
		/* const */ unsigned int IBFS           : 1;	/* Input Buffer Status Register */
		unsigned int IBF1PAG        : 1;	/* Input Buffer 1 Page Select Register */
		unsigned int                : 2;
		unsigned int IBF2PAG        : 1;	/* Input Buffer 2 Page Select Register */
		unsigned int                : 2;
		unsigned int RISA           : 2;	/* Receive Input Select Channel A */
		unsigned int RISB           : 2;	/* Receive Input Select Channel B */
		unsigned int STPWTS         : 2;	/* Stop Watch Trigger Input Select */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} ERAY_CUST1_type;
#define ERAY_CUST1	(*( ERAY_CUST1_type *) 0xf001c004u)	/* Busy and Input Buffer Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TO             : 32;	/* CIF Timeout Reload Value */
	} B;
	int I;
	unsigned int U;

} ERAY_CUST3_type;
#define ERAY_CUST3	(*( ERAY_CUST3_type *) 0xf001c00cu)	/* Customer Interface Timeout Counter */

typedef volatile union
{
	struct
	{ 
		unsigned int PEMCE          : 1;	/* POC Error Mode Changed Service Request Enable */
		unsigned int CNAE           : 1;	/* Command Not Accepted Service Request Enable */
		unsigned int SFBME          : 1;	/* SYNC Frames Below Minimum Service Request Enable */
		unsigned int SFOE           : 1;	/* SYNC Frame Overflow Service Request Enable */
		unsigned int CCFE           : 1;	/* Clock Correction Failure Service Request Enable */
		unsigned int CCLE           : 1;	/* CHI Command Locked Service Request Enable */
		unsigned int EERRE          : 1;	/* ECC Error Service Request Enable */
		unsigned int RFOE           : 1;	/* Receive FIFO Overrun Service Request Enable */
		unsigned int EFAE           : 1;	/* Empty FIFO Access Service Request Enable */
		unsigned int IIBAE          : 1;	/* Illegal Input Buffer Access Service Request Enable */
		unsigned int IOBAE          : 1;	/* Illegal Output Buffer Access Service Request Enable */
		unsigned int MHFE           : 1;	/* Message Handler Constraints Flag Service Request Enable */
		unsigned int                : 4;
		unsigned int EDAE           : 1;	/* Error Detected on Channel A Service Request Enable */
		unsigned int LTVAE          : 1;	/* Latest Transmit Violation Channel A Service Request Enable */
		unsigned int TABAE          : 1;	/* Transmission Across Boundary Channel A Service Request Enable */
		unsigned int                : 5;
		unsigned int EDBE           : 1;	/* Error Detected on Channel B Service Request Enable */
		unsigned int LTVBE          : 1;	/* Latest Transmit Violation Channel B Service Request Enable */
		unsigned int TABBE          : 1;	/* Transmission Across Boundary Channel B Service Request Enable */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_EIER_type;
#define ERAY_EIER	(*( ERAY_EIER_type *) 0xf001c034u)	/* Error Service Request Enable Reset */

typedef volatile union
{
	struct
	{ 
		unsigned int PEMCE          : 1;	/* POC Error Mode Changed Service Request Enable */
		unsigned int CNAE           : 1;	/* Command Not Accepted Service Request Enable */
		unsigned int SFBME          : 1;	/* SYNC Frames Below Minimum Service Request Enable */
		unsigned int SFOE           : 1;	/* SYNC Frame Overflow Service Request Enable */
		unsigned int CCFE           : 1;	/* Clock Correction Failure Service Request Enable */
		unsigned int CCLE           : 1;	/* CHI Command Locked Service Request Enable */
		unsigned int EERRE          : 1;	/* ECC Error Service Request Enable */
		unsigned int RFOE           : 1;	/* Receive FIFO Overrun Service Request Enable */
		unsigned int EFAE           : 1;	/* Empty FIFO Access Service Request Enable */
		unsigned int IIBAE          : 1;	/* Illegal Input Buffer Access Service Request Enable */
		unsigned int IOBAE          : 1;	/* Illegal Output Buffer Access Service Request Enable */
		unsigned int MHFE           : 1;	/* Message Handler Constraints Flag Service Request Enable */
		unsigned int                : 4;
		unsigned int EDAE           : 1;	/* Error Detected on Channel A Service Request Enable */
		unsigned int LTVAE          : 1;	/* Latest Transmit Violation Channel A Service Request Enable */
		unsigned int TABAE          : 1;	/* Transmission Across Boundary Channel A Service Request Enable */
		unsigned int                : 5;
		unsigned int EDBE           : 1;	/* Error Detected on Channel B Service Request Enable */
		unsigned int LTVBE          : 1;	/* Latest Transmit Violation Channel B Service Request Enable */
		unsigned int TABBE          : 1;	/* Transmission Across Boundary Channel B Service Request Enable */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_EIES_type;
#define ERAY_EIES	(*( ERAY_EIES_type *) 0xf001c030u)	/* Error Service Request Enable Set */

typedef volatile union
{
	struct
	{ 
		unsigned int PEMCL          : 1;	/* POC Error Mode Changed Service Request Line */
		unsigned int CNAL           : 1;	/* Command Not Accepted Service Request Line */
		unsigned int SFBML          : 1;	/* SYNC Frames Below Minimum Service Request Line */
		unsigned int SFOL           : 1;	/* SYNC Frame Overflow Service Request Line */
		unsigned int CCFL           : 1;	/* Clock Correction Failure Service Request Line */
		unsigned int CCLL           : 1;	/* CHI Command Locked Service Request Line */
		unsigned int EERRL          : 1;	/* ECC Error Service Request Line */
		unsigned int RFOL           : 1;	/* Receive FIFO Overrun Service Request Line */
		unsigned int EFAL           : 1;	/* Empty FIFO Access Service Request Line */
		unsigned int IIBAL          : 1;	/* Illegal Input Buffer Access Service Request Line */
		unsigned int IOBAL          : 1;	/* Illegal Output Buffer Access Service Request Line */
		unsigned int MHFL           : 1;	/* Message Handler Constrains Flag Service Request Line */
		unsigned int                : 4;
		unsigned int EDAL           : 1;	/* Error Detected on Channel A Service Request Line */
		unsigned int LTVAL          : 1;	/* Latest Transmit Violation Channel A Service Request Line */
		unsigned int TABAL          : 1;	/* Transmission Across Boundary Channel A Service Request Line */
		unsigned int                : 5;
		unsigned int EDBL           : 1;	/* Error Detected on Channel B Service Request Line */
		unsigned int LTVBL          : 1;	/* Latest Transmit Violation Channel B Service Request Line */
		unsigned int TABBL          : 1;	/* Transmission Across Boundary Channel A Service Request Line */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_EILS_type;
#define ERAY_EILS	(*( ERAY_EILS_type *) 0xf001c028u)	/* Error Service Request Line Select */

typedef volatile union
{
	struct
	{ 
		unsigned int PEMC           : 1;	/* POC Error Mode Changed */
		unsigned int CNA            : 1;	/* Command Not Accepted */
		unsigned int SFBM           : 1;	/* SYNC Frames Below Minimum */
		unsigned int SFO            : 1;	/* SYNC Frame Overflow */
		unsigned int CCF            : 1;	/* Clock Correction Failure */
		unsigned int CCL            : 1;	/* CHI Command Locked */
		/* const */ unsigned int EERR           : 1;	/* ECC Error */
		/* const */ unsigned int RFO            : 1;	/* Receive FIFO Overrun */
		unsigned int EFA            : 1;	/* Empty FIFO Access */
		unsigned int IIBA           : 1;	/* Illegal Input Buffer Access */
		unsigned int IOBA           : 1;	/* Illegal Output Buffer Access */
		unsigned int MHF            : 1;	/* Message Handler Constraints Flag */
		unsigned int                : 4;
		unsigned int EDA            : 1;	/* Error Detected on Channel A */
		unsigned int LTVA           : 1;	/* Latest Transmit Violation Channel A */
		unsigned int TABA           : 1;	/* Transmission Across Boundary Channel A */
		unsigned int                : 5;
		unsigned int EDB            : 1;	/* Error Detected on Channel B */
		unsigned int LTVB           : 1;	/* Latest Transmit Violation Channel B */
		unsigned int TABB           : 1;	/* Transmission Across Boundary Channel B */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_EIR_type;
#define ERAY_EIR	(*( ERAY_EIR_type *) 0xf001c020u)	/* Error Service Request Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ETV            : 32;	/* Endianness Test Value */
	} B;
	int I;
	unsigned int U;

} ERAY_ENDN_type;
#define ERAY_ENDN	(*( ERAY_ENDN_type *) 0xf001c3f4u)	/* Endian Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int EID            : 10;	/* Even Sync ID (vsSyncIDListA,B even) */
		/* const */ unsigned int                : 4;
		/* const */ unsigned int RXEA           : 1;	/* Received/Configured Even Sync ID on Channel A */
		/* const */ unsigned int RXEB           : 1;	/* Received/Configured Even Sync ID on Channel B */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} ERAY_ESID01_type;
#define ERAY_ESID01	(*( ERAY_ESID01_type *) 0xf001c130u)	/* Even Sync ID Symbol Window 01 */
#define ERAY_ESID02	(*( ERAY_ESID01_type *) 0xf001c134u)	/* Even Sync ID Symbol Window 02 */
#define ERAY_ESID03	(*( ERAY_ESID01_type *) 0xf001c138u)	/* Even Sync ID Symbol Window 03 */
#define ERAY_ESID04	(*( ERAY_ESID01_type *) 0xf001c13cu)	/* Even Sync ID Symbol Window 04 */
#define ERAY_ESID05	(*( ERAY_ESID01_type *) 0xf001c140u)	/* Even Sync ID Symbol Window 05 */
#define ERAY_ESID06	(*( ERAY_ESID01_type *) 0xf001c144u)	/* Even Sync ID Symbol Window 06 */
#define ERAY_ESID07	(*( ERAY_ESID01_type *) 0xf001c148u)	/* Even Sync ID Symbol Window 07 */
#define ERAY_ESID08	(*( ERAY_ESID01_type *) 0xf001c14cu)	/* Even Sync ID Symbol Window 08 */
#define ERAY_ESID09	(*( ERAY_ESID01_type *) 0xf001c150u)	/* Even Sync ID Symbol Window 09 */
#define ERAY_ESID10	(*( ERAY_ESID01_type *) 0xf001c154u)	/* Even Sync ID Symbol Window 10 */
#define ERAY_ESID11	(*( ERAY_ESID01_type *) 0xf001c158u)	/* Even Sync ID Symbol Window 11 */
#define ERAY_ESID12	(*( ERAY_ESID01_type *) 0xf001c15cu)	/* Even Sync ID Symbol Window 12 */
#define ERAY_ESID13	(*( ERAY_ESID01_type *) 0xf001c160u)	/* Even Sync ID Symbol Window 13 */
#define ERAY_ESID14	(*( ERAY_ESID01_type *) 0xf001c164u)	/* Even Sync ID Symbol Window 14 */
#define ERAY_ESID15	(*( ERAY_ESID01_type *) 0xf001c168u)	/* Even Sync ID Symbol Window 15 */

typedef volatile union
{
	struct
	{ 
		unsigned int CL             : 8;	/* Critical Level */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} ERAY_FCL_type;
#define ERAY_FCL	(*( ERAY_FCL_type *) 0xf001c30cu)	/* FIFO Critical Level */

typedef volatile union
{
	struct
	{ 
		unsigned int CH             : 2;	/* Channel Filter */
		unsigned int FID            : 11;	/* Frame ID Filter */
		unsigned int                : 3;
		unsigned int CYF            : 7;	/* Cycle Counter Filter */
		unsigned int RSS            : 1;	/* Reject in Static Segment */
		unsigned int RNF            : 1;	/* Reject NULL Frames */
		unsigned int                : 7;
	} B;
	int I;
	unsigned int U;

} ERAY_FRF_type;
#define ERAY_FRF	(*( ERAY_FRF_type *) 0xf001c304u)	/* FIFO Rejection Filter */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 2;
		unsigned int MFID           : 11;	/* Mask Frame ID Filter */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} ERAY_FRFM_type;
#define ERAY_FRFM	(*( ERAY_FRFM_type *) 0xf001c308u)	/* FIFO Rejection Filter Mask */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RFNE           : 1;	/* Receive FIFO Not Empty */
		/* const */ unsigned int RFCL           : 1;	/* Receive FIFO Critical Level */
		/* const */ unsigned int RFO            : 1;	/* Receive FIFO Overrun */
		/* const */ unsigned int                : 5;
		/* const */ unsigned int RFFL           : 8;	/* Receive FIFO Fill Level */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} ERAY_FSR_type;
#define ERAY_FSR	(*( ERAY_FSR_type *) 0xf001c318u)	/* FIFO Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int UT             : 20;	/* Microtick per Cycle (pMicroPerCycle)This bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC01_type;
#define ERAY_GTUC01	(*( ERAY_GTUC01_type *) 0xf001c0a0u)	/* GTU Configuration Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int MPC            : 14;	/* Macrotick Per Cycle (gMacroPerCycle)This bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! */
		unsigned int                : 2;
		unsigned int SNM            : 4;	/* Sync Node Max (gSyncNodeMax) */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC02_type;
#define ERAY_GTUC02	(*( ERAY_GTUC02_type *) 0xf001c0a4u)	/* GTU Configuration Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int UIOA           : 8;	/* Microtick Initial Offset Channel AThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (pMicroInitialOffset[A]) */
		unsigned int UIOB           : 8;	/* Microtick Initial Offset Channel B (pMicroInitialOffset[B]) */
		unsigned int MIOA           : 7;	/* Macrotick Initial Offset Channel A (gMacroInitialOffset[A]) */
		unsigned int                : 1;
		unsigned int MIOB           : 7;	/* Macrotick Initial Offset Channel B (gMacroInitialOffset[B]) */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC03_type;
#define ERAY_GTUC03	(*( ERAY_GTUC03_type *) 0xf001c0a8u)	/* GTU Configuration Register 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int NIT            : 14;	/* Network Idle Time Start This bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (gMacroPerCycle - gdNIT - 1) */
		unsigned int                : 2;
		unsigned int OCS            : 14;	/* Offset Correction Start (gOffsetCorrectionStart - 1) */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC04_type;
#define ERAY_GTUC04	(*( ERAY_GTUC04_type *) 0xf001c0acu)	/* GTU Configuration Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int DCA            : 8;	/* Delay Compensation Channel AThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (pDelayCompensation[A]) */
		unsigned int DCB            : 8;	/* Delay Compensation Channel B (pDelayCompensation[B]) */
		unsigned int CDD            : 5;	/* Cluster Drift Damping (pClusterDriftDamping) */
		unsigned int                : 3;
		unsigned int DEC            : 8;	/* Decoding Correction (pDecodingCorrection) */
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC05_type;
#define ERAY_GTUC05	(*( ERAY_GTUC05_type *) 0xf001c0b0u)	/* GTU Configuration Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int ASR            : 11;	/* Accepted Startup RangeThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (pdAcceptedStartupRange) */
		unsigned int                : 5;
		unsigned int MOD            : 11;	/* Maximum Oscillator Drift (pdMaxDrift) */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC06_type;
#define ERAY_GTUC06	(*( ERAY_GTUC06_type *) 0xf001c0b4u)	/* GTU Configuration Register 6 */

typedef volatile union
{
	struct
	{ 
		unsigned int SSL            : 10;	/* Static Slot Length (gdStaticSlot)This bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! */
		unsigned int                : 6;
		unsigned int NSS            : 10;	/* Number of Static Slots (gNumberOfStaticSlots) */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC07_type;
#define ERAY_GTUC07	(*( ERAY_GTUC07_type *) 0xf001c0b8u)	/* GTU Configuration Register 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int MSL            : 6;	/* Minislot Length (gdMinislot)This bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! */
		unsigned int                : 10;
		unsigned int NMS            : 13;	/* Number of Minislots (gNumberOfMinislots) */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC08_type;
#define ERAY_GTUC08	(*( ERAY_GTUC08_type *) 0xf001c0bcu)	/* GTU Configuration Register 8 */

typedef volatile union
{
	struct
	{ 
		unsigned int APO            : 6;	/* Action Point Offset (gdActionPointOffset)This bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! */
		unsigned int                : 2;
		unsigned int MAPO           : 5;	/* Minislot Action Point Offset (gd Minislot Action Point Offset) */
		unsigned int                : 3;
		unsigned int DSI            : 2;	/* Dynamic Slot Idle Phase (gdDynamicSlotIdlePhase) */
		unsigned int                : 14;
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC09_type;
#define ERAY_GTUC09	(*( ERAY_GTUC09_type *) 0xf001c0c0u)	/* GTU Configuration Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int MOC            : 14;	/* Maximum Offset CorrectionThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (pOffsetCorrectionOut) */
		unsigned int                : 2;
		unsigned int MRC            : 11;	/* Maximum Rate Correction (pRateCorrectionOut) */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC10_type;
#define ERAY_GTUC10	(*( ERAY_GTUC10_type *) 0xf001c0c4u)	/* GTU Configuration Register 10 */

typedef volatile union
{
	struct
	{ 
		unsigned int EOCC           : 2;	/* External Offset Correction Control (pExternOffsetControl) */
		unsigned int                : 6;
		unsigned int ERCC           : 2;	/* External Rate Correction Control (pExternRateControl) */
		unsigned int                : 6;
		unsigned int EOC            : 3;	/* External Offset CorrectionThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (pExternOffsetCorrection) */
		unsigned int                : 5;
		unsigned int ERC            : 3;	/* External Rate Correction (pExternRateCorrection) */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_GTUC11_type;
#define ERAY_GTUC11	(*( ERAY_GTUC11_type *) 0xf001c0c8u)	/* GTU Configuration Register 11 */

typedef volatile union
{
	struct
	{ 
		unsigned int LHSH           : 1;	/* Load Header Section Host */
		unsigned int LDSH           : 1;	/* Load Data Section Host */
		unsigned int STXRH          : 1;	/* Set Transmission Request Host */
		unsigned int                : 13;
		/* const */ unsigned int LHSS           : 1;	/* Load Header Section Shadow */
		/* const */ unsigned int LDSS           : 1;	/* Load Data Section Shadow */
		/* const */ unsigned int STXRS          : 1;	/* Transmission Request Shadow */
		unsigned int                : 13;
	} B;
	int I;
	unsigned int U;

} ERAY_IBCM_type;
#define ERAY_IBCM	(*( ERAY_IBCM_type *) 0xf001c510u)	/* Input Buffer Command Mask */

typedef volatile union
{
	struct
	{ 
		unsigned int IBRH           : 7;	/* Input Buffer Request Host */
		unsigned int                : 8;
		/* const */ unsigned int IBSYH          : 1;	/* Input Buffer Busy Host */
		/* const */ unsigned int IBRS           : 7;	/* Input Buffer Request Shadow */
		unsigned int                : 8;
		/* const */ unsigned int IBSYS          : 1;	/* Input Buffer Busy Shadow */
	} B;
	int I;
	unsigned int U;

} ERAY_IBCR_type;
#define ERAY_IBCR	(*( ERAY_IBCR_type *) 0xf001c514u)	/* Input Buffer Command Request */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} ERAY_ID_type;
#define ERAY_ID	(*( ERAY_ID_type *) 0xf001c008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EINT0          : 1;	/* Enable Service Request Line 0 (INT0SRC) */
		unsigned int EINT1          : 1;	/* Enable Service Request Line 1 (INT1SRC) */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} ERAY_ILE_type;
#define ERAY_ILE	(*( ERAY_ILE_type *) 0xf001c040u)	/* Service Request Line Enable */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} ERAY_KRST0_type;
#define ERAY_KRST0	(*( ERAY_KRST0_type *) 0xf001c8f4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} ERAY_KRST1_type;
#define ERAY_KRST1	(*( ERAY_KRST1_type *) 0xf001c8f0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} ERAY_KRSTCLR_type;
#define ERAY_KRSTCLR	(*( ERAY_KRSTCLR_type *) 0xf001c8ecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CLK            : 8;	/* Configuration Lock Key */
		unsigned int TMK            : 8;	/* Test Mode Key */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} ERAY_LCK_type;
#define ERAY_LCK	(*( ERAY_LCK_type *) 0xf001c01cu)	/* Lock Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int LDTA           : 11;	/* Last Dynamic Transmission Channel A */
		/* const */ unsigned int                : 5;
		/* const */ unsigned int LDTB           : 11;	/* Last Dynamic Transmission Channel B */
		/* const */ unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_LDTS_type;
#define ERAY_LDTS	(*( ERAY_LDTS_type *) 0xf001c314u)	/* Last Dynamic Transmit Slot */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int VFRA           : 1;	/* Valid Frame Received on Channel A (vSS!ValidFrameA) */
		/* const */ unsigned int VFRB           : 1;	/* Valid Frame Received on Channel B (vSS!ValidFrameB) */
		/* const */ unsigned int SEOA           : 1;	/* Syntax Error Observed on Channel A (vSS!SyntaxErrorA) */
		/* const */ unsigned int SEOB           : 1;	/* Syntax Error Observed on Channel B (vSS!SyntaxErrorB) */
		/* const */ unsigned int CEOA           : 1;	/* Content Error Observed on Channel A (vSS!ContentErrorA) */
		/* const */ unsigned int CEOB           : 1;	/* Content Error Observed on Channel B (vSS!ContentErrorB) */
		/* const */ unsigned int SVOA           : 1;	/* Slot Boundary Violation Observed on Channel A (vSS!BViolationA) */
		/* const */ unsigned int SVOB           : 1;	/* Slot Boundary Violation Observed on Channel B (vSS!BViolationB) */
		/* const */ unsigned int TCIA           : 1;	/* Transmission Conflict Indication Channel A (vSS!TxConflictA) */
		/* const */ unsigned int TCIB           : 1;	/* Transmission Conflict Indication Channel B (vSS!TxConflictB) */
		/* const */ unsigned int ESA            : 1;	/* Empty Slot Channel A */
		/* const */ unsigned int ESB            : 1;	/* Empty Slot Channel B */
		/* const */ unsigned int MLST           : 1;	/* Message Lost */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int FTA            : 1;	/* Frame Transmitted on Channel A */
		/* const */ unsigned int FTB            : 1;	/* Frame Transmitted on Channel B */
		/* const */ unsigned int CCS            : 6;	/* Cycle Count Status */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int RCIS           : 1;	/* Received on Channel Indicator Status (vSS!Channel) */
		/* const */ unsigned int SFIS           : 1;	/* Startup Frame Indicator Status (vRF!Header!SuFIndicator) */
		/* const */ unsigned int SYNS           : 1;	/* SYNC Frame Indicator Status (vRF!Header!SyFIndicator) */
		/* const */ unsigned int NFIS           : 1;	/* NULL Frame Indicator Status (vRF!Header!NFIndicator) */
		/* const */ unsigned int PPIS           : 1;	/* Payload Preamble Indictor Status (vRF!Header!PPIndicator) */
		/* const */ unsigned int RESS           : 1;	/* Reserved Bit Status (vRF!Header!Reserved) */
		/* const */ unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_MBS_type;
#define ERAY_MBS	(*( ERAY_MBS_type *) 0xf001c70cu)	/* Message Buffer Status */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MBC0           : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC1           : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC2           : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC3           : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC4           : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC5           : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC6           : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC7           : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC8           : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC9           : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC10          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC11          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC12          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC13          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC14          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC15          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC16          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC17          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC18          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC19          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC20          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC21          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC22          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC23          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC24          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC25          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC26          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC27          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC28          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC29          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC30          : 1;	/* Message Buffer Status Changed n (n=0-31) */
		/* const */ unsigned int MBC31          : 1;	/* Message Buffer Status Changed n (n=0-31) */
	} B;
	int I;
	unsigned int U;

} ERAY_MBSC1_type;
#define ERAY_MBSC1	(*( ERAY_MBSC1_type *) 0xf001c340u)	/* Message Buffer Status Changed 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MBC32          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC33          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC34          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC35          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC36          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC37          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC38          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC39          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC40          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC41          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC42          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC43          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC44          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC45          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC46          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC47          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC48          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC49          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC50          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC51          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC52          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC53          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC54          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC55          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC56          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC57          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC58          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC59          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC60          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC61          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC62          : 1;	/* Message Buffer Status Changed n (n=32-63) */
		/* const */ unsigned int MBC63          : 1;	/* Message Buffer Status Changed n (n=32-63) */
	} B;
	int I;
	unsigned int U;

} ERAY_MBSC2_type;
#define ERAY_MBSC2	(*( ERAY_MBSC2_type *) 0xf001c344u)	/* Message Buffer Status Changed 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MBC64          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC65          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC66          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC67          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC68          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC69          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC70          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC71          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC72          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC73          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC74          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC75          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC76          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC77          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC78          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC79          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC80          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC81          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC82          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC83          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC84          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC85          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC86          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC87          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC88          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC89          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC90          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC91          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC92          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC93          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC94          : 1;	/* Message Buffer Status Changed n (n=64-95) */
		/* const */ unsigned int MBC95          : 1;	/* Message Buffer Status Changed n (n=64-95) */
	} B;
	int I;
	unsigned int U;

} ERAY_MBSC3_type;
#define ERAY_MBSC3	(*( ERAY_MBSC3_type *) 0xf001c348u)	/* Message Buffer Status Changed 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MBC96          : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC97          : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC98          : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC99          : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC100         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC101         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC102         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC103         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC104         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC105         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC106         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC107         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC108         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC109         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC110         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC111         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC112         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC113         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC114         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC115         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC116         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC117         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC118         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC119         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC120         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC121         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC122         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC123         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC124         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC125         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC126         : 1;	/* Message Buffer Status Changed n (n=96-127) */
		/* const */ unsigned int MBC127         : 1;	/* Message Buffer Status Changed n (n=96-127) */
	} B;
	int I;
	unsigned int U;

} ERAY_MBSC4_type;
#define ERAY_MBSC4	(*( ERAY_MBSC4_type *) 0xf001c34cu)	/* Message Buffer Status Changed 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int SFDL           : 7;	/* Static Frame Data Length (gPayloadLengthStatic)This bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! */
		unsigned int                : 9;
		unsigned int SLT            : 13;	/* Start of Latest Transmit (pLatestTx) */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} ERAY_MHDC_type;
#define ERAY_MHDC	(*( ERAY_MHDC_type *) 0xf001c098u)	/* MHD Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SNUA           : 1;	/* Status Not Updated Channel A */
		unsigned int SNUB           : 1;	/* Status Not Updated Channel B */
		unsigned int FNFA           : 1;	/* Find Sequence Not Finished Channel A */
		unsigned int FNFB           : 1;	/* Find Sequence Not Finished Channel B */
		unsigned int TBFA           : 1;	/* Transient Buffer Access Failure A */
		unsigned int TBFB           : 1;	/* Transient Buffer Access Failure B */
		unsigned int TNSA           : 1;	/* Transmission Not Started Channel A */
		unsigned int TNSB           : 1;	/* Transmission Not Started Channel B */
		unsigned int WAHP           : 1;	/* Write Attempt to Header Partition */
		unsigned int                : 23;
	} B;
	int I;
	unsigned int U;

} ERAY_MHDF_type;
#define ERAY_MHDF	(*( ERAY_MHDF_type *) 0xf001c31cu)	/* Message Handler Constraints Flags */

typedef volatile union
{
	struct
	{ 
		unsigned int EIBF           : 1;	/* ECC Error Input Buffer RAM 1,2 */
		unsigned int EOBF           : 1;	/* ECC Error Output Buffer RAM 1,2 */
		unsigned int EMR            : 1;	/* ECC Error Message RAM */
		unsigned int ETBF1          : 1;	/* ECC Error Transient Buffer RAM A */
		unsigned int ETBF2          : 1;	/* ECC Error Transient Buffer RAM B */
		unsigned int FMBD           : 1;	/* Faulty Message Buffer Detected */
		unsigned int MFMB           : 1;	/* Multiple Faulty Message Buffers detected */
		/* const */ unsigned int CRAM           : 1;	/* Clear all internal RAM?s */
		/* const */ unsigned int FMB            : 7;	/* Faulty Message Buffer */
		unsigned int                : 1;
		/* const */ unsigned int MBT            : 7;	/* Message Buffer Transmitted */
		unsigned int                : 1;
		/* const */ unsigned int MBU            : 7;	/* Message Buffer Updated */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} ERAY_MHDS_type;
#define ERAY_MHDS	(*( ERAY_MHDS_type *) 0xf001c310u)	/* Message Handler Status */

typedef volatile union
{
	struct
	{ 
		unsigned int FDB            : 8;	/* First Dynamic Buffer */
		unsigned int FFB            : 8;	/* First Buffer of FIFO */
		unsigned int LCB            : 8;	/* Last Configured Buffer */
		unsigned int SEC            : 2;	/* Secure Buffers */
		unsigned int SPLM           : 1;	/* SYNC Frame Payload Multiplex */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_MRC_type;
#define ERAY_MRC	(*( ERAY_MRC_type *) 0xf001c300u)	/* Message RAM Configuration */

typedef volatile union
{
	struct
	{ 
		unsigned int MSIP0          : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP1          : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP2          : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP3          : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP4          : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP5          : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP6          : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP7          : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP8          : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP9          : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP10         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP11         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP12         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP13         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP14         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP15         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP16         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP17         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP18         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP19         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP20         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP21         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP22         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP23         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP24         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP25         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP26         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP27         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP28         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP29         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP30         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
		unsigned int MSIP31         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=0-31) */
	} B;
	int I;
	unsigned int U;

} ERAY_MSIC1_type;
#define ERAY_MSIC1	(*( ERAY_MSIC1_type *) 0xf001c3b8u)	/* Message Buffer Status Changed Interrupt Control 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MSIP32         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP33         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP34         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP35         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP36         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP37         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP38         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP39         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP40         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP41         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP42         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP43         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP44         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP45         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP46         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP47         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP48         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP49         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP50         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP51         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP52         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP53         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP54         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP55         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP56         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP57         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP58         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP59         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP60         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP61         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP62         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
		/* const */ unsigned int MSIP63         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=32-63) */
	} B;
	int I;
	unsigned int U;

} ERAY_MSIC2_type;
#define ERAY_MSIC2	(*( ERAY_MSIC2_type *) 0xf001c3bcu)	/* Message Buffer Status Changed Interrupt Control 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int MSIP64         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP65         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP66         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP67         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP68         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP69         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP70         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP71         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP72         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP73         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP74         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP75         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP76         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP77         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP78         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP79         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP80         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP81         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP82         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP83         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP84         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP85         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP86         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP87         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP88         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP89         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP90         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP91         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP92         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP93         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP94         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
		unsigned int MSIP95         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=64-95) */
	} B;
	int I;
	unsigned int U;

} ERAY_MSIC3_type;
#define ERAY_MSIC3	(*( ERAY_MSIC3_type *) 0xf001c3c0u)	/* Message Buffer Status Changed Interrupt Control 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int MSIP96         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP97         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP98         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP99         : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP100        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP101        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP102        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP103        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP104        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP105        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP106        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP107        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP108        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP109        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP110        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP111        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP112        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP113        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP114        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP115        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP116        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP117        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP118        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP119        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP120        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP121        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP122        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP123        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP124        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP125        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP126        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
		unsigned int MSIP127        : 1;	/* Message Buffer Status Changed Interrupt Pointern (n=96-127) */
	} B;
	int I;
	unsigned int U;

} ERAY_MSIC4_type;
#define ERAY_MSIC4	(*( ERAY_MSIC4_type *) 0xf001c3c4u)	/* Message Buffer Status Changed Interrupt Control 4 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MTV            : 14;	/* Macrotick Value (vMacrotick) */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int CCV            : 6;	/* Cycle Counter Value (vCycleCounter) */
		/* const */ unsigned int                : 10;
	} B;
	int I;
	unsigned int U;

} ERAY_MTCCV_type;
#define ERAY_MTCCV	(*( ERAY_MTCCV_type *) 0xf001c114u)	/* Macrotick and Cycle Counter Value */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ND0            : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND1            : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND2            : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND3            : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND4            : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND5            : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND6            : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND7            : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND8            : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND9            : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND10           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND11           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND12           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND13           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND14           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND15           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND16           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND17           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND18           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND19           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND20           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND21           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND22           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND23           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND24           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND25           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND26           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND27           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND28           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND29           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND30           : 1;	/* New Data n (n=0-31) */
		/* const */ unsigned int ND31           : 1;	/* New Data n (n=0-31) */
	} B;
	int I;
	unsigned int U;

} ERAY_NDAT1_type;
#define ERAY_NDAT1	(*( ERAY_NDAT1_type *) 0xf001c330u)	/* New Data Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ND32           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND33           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND34           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND35           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND36           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND37           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND38           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND39           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND40           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND41           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND42           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND43           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND44           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND45           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND46           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND47           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND48           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND49           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND50           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND51           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND52           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND53           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND54           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND55           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND56           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND57           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND58           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND59           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND60           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND61           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND62           : 1;	/* New Data n (n=32-63) */
		/* const */ unsigned int ND63           : 1;	/* New Data n (n=32-63) */
	} B;
	int I;
	unsigned int U;

} ERAY_NDAT2_type;
#define ERAY_NDAT2	(*( ERAY_NDAT2_type *) 0xf001c334u)	/* New Data Register 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ND64           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND65           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND66           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND67           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND68           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND69           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND70           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND71           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND72           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND73           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND74           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND75           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND76           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND77           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND78           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND79           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND80           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND81           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND82           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND83           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND84           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND85           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND86           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND87           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND88           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND89           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND90           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND91           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND92           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND93           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND94           : 1;	/* New Data n (n=64-95) */
		/* const */ unsigned int ND95           : 1;	/* New Data n (n=64-95) */
	} B;
	int I;
	unsigned int U;

} ERAY_NDAT3_type;
#define ERAY_NDAT3	(*( ERAY_NDAT3_type *) 0xf001c338u)	/* New Data Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ND96           : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND97           : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND98           : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND99           : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND100          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND101          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND102          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND103          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND104          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND105          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND106          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND107          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND108          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND109          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND110          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND111          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND112          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND113          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND114          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND115          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND116          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND117          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND118          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND119          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND120          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND121          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND122          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND123          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND124          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND125          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND126          : 1;	/* New Data n (n=96-127) */
		/* const */ unsigned int ND127          : 1;	/* New Data n (n=96-127) */
	} B;
	int I;
	unsigned int U;

} ERAY_NDAT4_type;
#define ERAY_NDAT4	(*( ERAY_NDAT4_type *) 0xf001c33cu)	/* New Data Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int NDIP0          : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP1          : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP2          : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP3          : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP4          : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP5          : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP6          : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP7          : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP8          : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP9          : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP10         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP11         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP12         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP13         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP14         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP15         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP16         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP17         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP18         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP19         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP20         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP21         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP22         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP23         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP24         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP25         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP26         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP27         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP28         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP29         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP30         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
		unsigned int NDIP31         : 1;	/* New Data Interrupt Pointer n (n=0-31) */
	} B;
	int I;
	unsigned int U;

} ERAY_NDIC1_type;
#define ERAY_NDIC1	(*( ERAY_NDIC1_type *) 0xf001c3a8u)	/* New Data Interrupt Control 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int NDIP32         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP33         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP34         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP35         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP36         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP37         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP38         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP39         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP40         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP41         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP42         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP43         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP44         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP45         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP46         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP47         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP48         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP49         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP50         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP51         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP52         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP53         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP54         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP55         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP56         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP57         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP58         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP59         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP60         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP61         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP62         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
		unsigned int NDIP63         : 1;	/* New Data Interrupt Pointer n (n=32-63) */
	} B;
	int I;
	unsigned int U;

} ERAY_NDIC2_type;
#define ERAY_NDIC2	(*( ERAY_NDIC2_type *) 0xf001c3acu)	/* New Data Interrupt Control 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int NDIP64         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP65         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP66         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP67         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP68         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP69         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP70         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP71         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP72         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP73         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP74         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP75         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP76         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP77         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP78         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP79         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP80         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP81         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP82         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP83         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP84         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP85         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP86         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP87         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP88         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP89         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP90         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP91         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP92         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP93         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP94         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
		unsigned int NDIP95         : 1;	/* New Data Interrupt Pointer n (n=64-95) */
	} B;
	int I;
	unsigned int U;

} ERAY_NDIC3_type;
#define ERAY_NDIC3	(*( ERAY_NDIC3_type *) 0xf001c3b0u)	/* New Data Interrupt Control 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int NDIP96         : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP97         : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP98         : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP99         : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP100        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP101        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP102        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP103        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP104        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP105        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP106        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP107        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP108        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP109        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP110        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP111        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP112        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP113        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP114        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP115        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP116        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP117        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP118        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP119        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP120        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP121        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP122        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP123        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP124        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP125        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP126        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
		unsigned int NDIP127        : 1;	/* New Data Interrupt Pointer n (n=96-127) */
	} B;
	int I;
	unsigned int U;

} ERAY_NDIC4_type;
#define ERAY_NDIC4	(*( ERAY_NDIC4_type *) 0xf001c3b4u)	/* New Data Interrupt Control 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int NML            : 4;	/* Network Management Vector LengthThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (gNetworkManagementVectorLength) */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} ERAY_NEMC_type;
#define ERAY_NEMC	(*( ERAY_NEMC_type *) 0xf001c08cu)	/* NEM Configuration Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int NM             : 32;	/* Network Management Vector */
	} B;
	int I;
	unsigned int U;

} ERAY_NMV1_type;
#define ERAY_NMV1	(*( ERAY_NMV1_type *) 0xf001c1b0u)	/* Network Management Vector 1 */
#define ERAY_NMV2	(*( ERAY_NMV1_type *) 0xf001c1b4u)	/* Network Management Vector 2 */
#define ERAY_NMV3	(*( ERAY_NMV1_type *) 0xf001c1b8u)	/* Network Management Vector 3 */

typedef volatile union
{
	struct
	{ 
		unsigned int RHSS           : 1;	/* Read Header Section Shadow */
		unsigned int RDSS           : 1;	/* Read Data Section Shadow */
		unsigned int                : 14;
		/* const */ unsigned int RHSH           : 1;	/* Read Header Section Host */
		/* const */ unsigned int RDSH           : 1;	/* Read Data Section Host */
		unsigned int                : 14;
	} B;
	int I;
	unsigned int U;

} ERAY_OBCM_type;
#define ERAY_OBCM	(*( ERAY_OBCM_type *) 0xf001c710u)	/* Output Buffer Command Mask */

typedef volatile union
{
	struct
	{ 
		unsigned int OBRS           : 7;	/* Output Buffer Request Shadow */
		unsigned int                : 1;
		unsigned int VIEW           : 1;	/* View Shadow Buffer */
		unsigned int REQ            : 1;	/* Request Message RAM Transfer */
		unsigned int                : 5;
		/* const */ unsigned int OBSYS          : 1;	/* Output Buffer Busy Shadow */
		/* const */ unsigned int OBRH           : 7;	/* Output Buffer Request Host */
		unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} ERAY_OBCR_type;
#define ERAY_OBCR	(*( ERAY_OBCR_type *) 0xf001c714u)	/* Output Buffer Command Request */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 2;	/* Trigger Set for OTGB0/1 */
		unsigned int TGB            : 1;	/* OTGB0/1 Bus Select */
		unsigned int TG_P           : 1;	/* TGS, TGB Write Protection */
		unsigned int                : 20;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_OCS_type;
#define ERAY_OCS	(*( ERAY_OCS_type *) 0xf001c8e8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int OCV            : 19;	/* Offset Correction Value (vOffsetCorrection) */
		/* const */ unsigned int                : 13;
	} B;
	int I;
	unsigned int U;

} ERAY_OCV_type;
#define ERAY_OCV	(*( ERAY_OCV_type *) 0xf001c11cu)	/* Offset Correction Value */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int OID            : 10;	/* Odd Sync ID (vsSyncIDListA,B odd) */
		/* const */ unsigned int                : 4;
		/* const */ unsigned int RXOA           : 1;	/* Received Odd Sync ID on Channel A */
		/* const */ unsigned int RXOB           : 1;	/* Received Odd Sync ID on Channel B */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} ERAY_OSID01_type;
#define ERAY_OSID01	(*( ERAY_OSID01_type *) 0xf001c170u)	/* Odd Sync ID Symbol Window 01 */
#define ERAY_OSID02	(*( ERAY_OSID01_type *) 0xf001c174u)	/* Odd Sync ID Symbol Window 02 */
#define ERAY_OSID03	(*( ERAY_OSID01_type *) 0xf001c178u)	/* Odd Sync ID Symbol Window 03 */
#define ERAY_OSID04	(*( ERAY_OSID01_type *) 0xf001c17cu)	/* Odd Sync ID Symbol Window 04 */
#define ERAY_OSID05	(*( ERAY_OSID01_type *) 0xf001c180u)	/* Odd Sync ID Symbol Window 05 */
#define ERAY_OSID06	(*( ERAY_OSID01_type *) 0xf001c184u)	/* Odd Sync ID Symbol Window 06 */
#define ERAY_OSID07	(*( ERAY_OSID01_type *) 0xf001c188u)	/* Odd Sync ID Symbol Window 07 */
#define ERAY_OSID08	(*( ERAY_OSID01_type *) 0xf001c18cu)	/* Odd Sync ID Symbol Window 08 */
#define ERAY_OSID09	(*( ERAY_OSID01_type *) 0xf001c190u)	/* Odd Sync ID Symbol Window 09 */
#define ERAY_OSID10	(*( ERAY_OSID01_type *) 0xf001c194u)	/* Odd Sync ID Symbol Window 10 */
#define ERAY_OSID11	(*( ERAY_OSID01_type *) 0xf001c198u)	/* Odd Sync ID Symbol Window 11 */
#define ERAY_OSID12	(*( ERAY_OSID01_type *) 0xf001c19cu)	/* Odd Sync ID Symbol Window 12 */
#define ERAY_OSID13	(*( ERAY_OSID01_type *) 0xf001c1a0u)	/* Odd Sync ID Symbol Window 13 */
#define ERAY_OSID14	(*( ERAY_OSID01_type *) 0xf001c1a4u)	/* Odd Sync ID Symbol Window 14 */
#define ERAY_OSID15	(*( ERAY_OSID01_type *) 0xf001c1a8u)	/* Odd Sync ID Symbol Window 15 */

typedef volatile union
{
	struct
	{ 
		unsigned int OTGB0          : 2;	/* Trigger Set for OTGB0 */
		unsigned int                : 6;
		unsigned int OTGB1          : 2;	/* Trigger Set for OTGB1 */
		unsigned int                : 6;
		unsigned int OTGB2          : 1;	/* Trigger Set for OTGB2 */
		unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} ERAY_OTSS_type;
#define ERAY_OTSS	(*( ERAY_OTSS_type *) 0xf001c870u)	/* OCDS Trigger Set Select */

typedef volatile union
{
	struct
	{ 
		unsigned int TSST           : 4;	/* Transmission Start Sequence TransmitterThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (gdTSSTransmitter) */
		unsigned int CASM           : 7;	/* Collision Avoidance Symbol Maximum(gdCASRxLowMax) */
		unsigned int                : 1;
		unsigned int SPP            : 2;	/* Strobe Point Position */
		unsigned int BRP            : 2;	/* Baud Rate Prescaler(gdSampleClockPeriod, pSamplePerMicrotick) */
		unsigned int RXW            : 9;	/* Wakeup Symbol Receive Window Length (gdWakeupSymbolRxWindow) */
		unsigned int                : 1;
		unsigned int RWP            : 6;	/* Repetitions of Tx Wakeup Pattern (pWakeupPattern) */
	} B;
	int I;
	unsigned int U;

} ERAY_PRTC1_type;
#define ERAY_PRTC1	(*( ERAY_PRTC1_type *) 0xf001c090u)	/* PRT Configuration Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int RXI            : 6;	/* Wakeup Symbol Receive IdleThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (gdWakeupSymbolRxIdle) */
		unsigned int                : 2;
		unsigned int RXL            : 6;	/* Wakeup Symbol Receive Low(gdWakeupSymbolRxLow) */
		unsigned int                : 2;
		unsigned int TXI            : 8;	/* Wakeup Symbol Transmit Idle (gdWakeupSymbolTxIdle) */
		unsigned int TXL            : 6;	/* Wakeup Symbol Transmit Low (gdWakeupSymbolTxLow) */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_PRTC2_type;
#define ERAY_PRTC2	(*( ERAY_PRTC2_type *) 0xf001c094u)	/* PRT Configuration Register 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RCV            : 12;	/* Rate Correction Value (vRateCorrection) */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} ERAY_RCV_type;
#define ERAY_RCV	(*( ERAY_RCV_type *) 0xf001c118u)	/* Rate Correction Value */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MDRB0          : 8;	/* 32-Bit Word nn, Byte 0 */
		/* const */ unsigned int MDRB1          : 8;	/* 32-Bit Word nn, Byte 1 */
		/* const */ unsigned int MDRB2          : 8;	/* 32-Bit Word nn, Byte 2 */
		/* const */ unsigned int MDRB3          : 8;	/* 32-Bit Word nn, Byte 3 */
	} B;
	int I;
	unsigned int U;

} ERAY_RDDS01_type;
#define ERAY_RDDS01	(*( ERAY_RDDS01_type *) 0xf001c600u)	/* Read Data Section 01 */
#define ERAY_RDDS02	(*( ERAY_RDDS01_type *) 0xf001c604u)	/* Read Data Section 02 */
#define ERAY_RDDS03	(*( ERAY_RDDS01_type *) 0xf001c608u)	/* Read Data Section 03 */
#define ERAY_RDDS04	(*( ERAY_RDDS01_type *) 0xf001c60cu)	/* Read Data Section 04 */
#define ERAY_RDDS05	(*( ERAY_RDDS01_type *) 0xf001c610u)	/* Read Data Section 05 */
#define ERAY_RDDS06	(*( ERAY_RDDS01_type *) 0xf001c614u)	/* Read Data Section 06 */
#define ERAY_RDDS07	(*( ERAY_RDDS01_type *) 0xf001c618u)	/* Read Data Section 07 */
#define ERAY_RDDS08	(*( ERAY_RDDS01_type *) 0xf001c61cu)	/* Read Data Section 08 */
#define ERAY_RDDS09	(*( ERAY_RDDS01_type *) 0xf001c620u)	/* Read Data Section 09 */
#define ERAY_RDDS10	(*( ERAY_RDDS01_type *) 0xf001c624u)	/* Read Data Section 10 */
#define ERAY_RDDS11	(*( ERAY_RDDS01_type *) 0xf001c628u)	/* Read Data Section 11 */
#define ERAY_RDDS12	(*( ERAY_RDDS01_type *) 0xf001c62cu)	/* Read Data Section 12 */
#define ERAY_RDDS13	(*( ERAY_RDDS01_type *) 0xf001c630u)	/* Read Data Section 13 */
#define ERAY_RDDS14	(*( ERAY_RDDS01_type *) 0xf001c634u)	/* Read Data Section 14 */
#define ERAY_RDDS15	(*( ERAY_RDDS01_type *) 0xf001c638u)	/* Read Data Section 15 */
#define ERAY_RDDS16	(*( ERAY_RDDS01_type *) 0xf001c63cu)	/* Read Data Section 16 */
#define ERAY_RDDS17	(*( ERAY_RDDS01_type *) 0xf001c640u)	/* Read Data Section 17 */
#define ERAY_RDDS18	(*( ERAY_RDDS01_type *) 0xf001c644u)	/* Read Data Section 18 */
#define ERAY_RDDS19	(*( ERAY_RDDS01_type *) 0xf001c648u)	/* Read Data Section 19 */
#define ERAY_RDDS20	(*( ERAY_RDDS01_type *) 0xf001c64cu)	/* Read Data Section 20 */
#define ERAY_RDDS21	(*( ERAY_RDDS01_type *) 0xf001c650u)	/* Read Data Section 21 */
#define ERAY_RDDS22	(*( ERAY_RDDS01_type *) 0xf001c654u)	/* Read Data Section 22 */
#define ERAY_RDDS23	(*( ERAY_RDDS01_type *) 0xf001c658u)	/* Read Data Section 23 */
#define ERAY_RDDS24	(*( ERAY_RDDS01_type *) 0xf001c65cu)	/* Read Data Section 24 */
#define ERAY_RDDS25	(*( ERAY_RDDS01_type *) 0xf001c660u)	/* Read Data Section 25 */
#define ERAY_RDDS26	(*( ERAY_RDDS01_type *) 0xf001c664u)	/* Read Data Section 26 */
#define ERAY_RDDS27	(*( ERAY_RDDS01_type *) 0xf001c668u)	/* Read Data Section 27 */
#define ERAY_RDDS28	(*( ERAY_RDDS01_type *) 0xf001c66cu)	/* Read Data Section 28 */
#define ERAY_RDDS29	(*( ERAY_RDDS01_type *) 0xf001c670u)	/* Read Data Section 29 */
#define ERAY_RDDS30	(*( ERAY_RDDS01_type *) 0xf001c674u)	/* Read Data Section 30 */
#define ERAY_RDDS31	(*( ERAY_RDDS01_type *) 0xf001c678u)	/* Read Data Section 31 */
#define ERAY_RDDS32	(*( ERAY_RDDS01_type *) 0xf001c67cu)	/* Read Data Section 32 */
#define ERAY_RDDS33	(*( ERAY_RDDS01_type *) 0xf001c680u)	/* Read Data Section 33 */
#define ERAY_RDDS34	(*( ERAY_RDDS01_type *) 0xf001c684u)	/* Read Data Section 34 */
#define ERAY_RDDS35	(*( ERAY_RDDS01_type *) 0xf001c688u)	/* Read Data Section 35 */
#define ERAY_RDDS36	(*( ERAY_RDDS01_type *) 0xf001c68cu)	/* Read Data Section 36 */
#define ERAY_RDDS37	(*( ERAY_RDDS01_type *) 0xf001c690u)	/* Read Data Section 37 */
#define ERAY_RDDS38	(*( ERAY_RDDS01_type *) 0xf001c694u)	/* Read Data Section 38 */
#define ERAY_RDDS39	(*( ERAY_RDDS01_type *) 0xf001c698u)	/* Read Data Section 39 */
#define ERAY_RDDS40	(*( ERAY_RDDS01_type *) 0xf001c69cu)	/* Read Data Section 40 */
#define ERAY_RDDS41	(*( ERAY_RDDS01_type *) 0xf001c6a0u)	/* Read Data Section 41 */
#define ERAY_RDDS42	(*( ERAY_RDDS01_type *) 0xf001c6a4u)	/* Read Data Section 42 */
#define ERAY_RDDS43	(*( ERAY_RDDS01_type *) 0xf001c6a8u)	/* Read Data Section 43 */
#define ERAY_RDDS44	(*( ERAY_RDDS01_type *) 0xf001c6acu)	/* Read Data Section 44 */
#define ERAY_RDDS45	(*( ERAY_RDDS01_type *) 0xf001c6b0u)	/* Read Data Section 45 */
#define ERAY_RDDS46	(*( ERAY_RDDS01_type *) 0xf001c6b4u)	/* Read Data Section 46 */
#define ERAY_RDDS47	(*( ERAY_RDDS01_type *) 0xf001c6b8u)	/* Read Data Section 47 */
#define ERAY_RDDS48	(*( ERAY_RDDS01_type *) 0xf001c6bcu)	/* Read Data Section 48 */
#define ERAY_RDDS49	(*( ERAY_RDDS01_type *) 0xf001c6c0u)	/* Read Data Section 49 */
#define ERAY_RDDS50	(*( ERAY_RDDS01_type *) 0xf001c6c4u)	/* Read Data Section 50 */
#define ERAY_RDDS51	(*( ERAY_RDDS01_type *) 0xf001c6c8u)	/* Read Data Section 51 */
#define ERAY_RDDS52	(*( ERAY_RDDS01_type *) 0xf001c6ccu)	/* Read Data Section 52 */
#define ERAY_RDDS53	(*( ERAY_RDDS01_type *) 0xf001c6d0u)	/* Read Data Section 53 */
#define ERAY_RDDS54	(*( ERAY_RDDS01_type *) 0xf001c6d4u)	/* Read Data Section 54 */
#define ERAY_RDDS55	(*( ERAY_RDDS01_type *) 0xf001c6d8u)	/* Read Data Section 55 */
#define ERAY_RDDS56	(*( ERAY_RDDS01_type *) 0xf001c6dcu)	/* Read Data Section 56 */
#define ERAY_RDDS57	(*( ERAY_RDDS01_type *) 0xf001c6e0u)	/* Read Data Section 57 */
#define ERAY_RDDS58	(*( ERAY_RDDS01_type *) 0xf001c6e4u)	/* Read Data Section 58 */
#define ERAY_RDDS59	(*( ERAY_RDDS01_type *) 0xf001c6e8u)	/* Read Data Section 59 */
#define ERAY_RDDS60	(*( ERAY_RDDS01_type *) 0xf001c6ecu)	/* Read Data Section 60 */
#define ERAY_RDDS61	(*( ERAY_RDDS01_type *) 0xf001c6f0u)	/* Read Data Section 61 */
#define ERAY_RDDS62	(*( ERAY_RDDS01_type *) 0xf001c6f4u)	/* Read Data Section 62 */
#define ERAY_RDDS63	(*( ERAY_RDDS01_type *) 0xf001c6f8u)	/* Read Data Section 63 */
#define ERAY_RDDS64	(*( ERAY_RDDS01_type *) 0xf001c6fcu)	/* Read Data Section 64 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int FID            : 11;	/* Frame ID */
		/* const */ unsigned int                : 5;
		/* const */ unsigned int CYC            : 7;	/* Cycle Code */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int CHA            : 1;	/* Channel Filter Control A */
		/* const */ unsigned int CHB            : 1;	/* Channel Filter Control B */
		/* const */ unsigned int CFG            : 1;	/* Message Buffer Direction Configuration Bit */
		/* const */ unsigned int PPIT           : 1;	/* Payload Preamble Indicator Transmit */
		/* const */ unsigned int TXM            : 1;	/* Transmission Mode */
		/* const */ unsigned int MBI            : 1;	/* Message Buffer Service Request */
		/* const */ unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_RDHS1_type;
#define ERAY_RDHS1	(*( ERAY_RDHS1_type *) 0xf001c700u)	/* Read Header Section 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CRC            : 11;	/* Header CRC (vRF!Header!HeaderCRC) */
		/* const */ unsigned int                : 5;
		/* const */ unsigned int PLC            : 7;	/* Payload Length Configured */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int PLR            : 7;	/* Payload Length Received (vRF!Header!Length) */
		/* const */ unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} ERAY_RDHS2_type;
#define ERAY_RDHS2	(*( ERAY_RDHS2_type *) 0xf001c704u)	/* Read Header Section 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DP             : 11;	/* Data Pointer */
		/* const */ unsigned int                : 5;
		/* const */ unsigned int RCC            : 6;	/* Receive Cycle Count (vRF!Header!CycleCount) */
		/* const */ unsigned int                : 2;
		/* const */ unsigned int RCI            : 1;	/* Received on Channel Indicator (vSS!Channel) */
		/* const */ unsigned int SFI            : 1;	/* Startup Frame Indicator (vRF!Header!SuFIndicator) */
		/* const */ unsigned int SYN            : 1;	/* SYNC Frame Indicator (vRF!Header!SyFIndicator) */
		/* const */ unsigned int NFI            : 1;	/* NULL Frame Indicator (vRF!Header!NFIndicator) */
		/* const */ unsigned int PPI            : 1;	/* Payload Preamble Indicator (vRF!Header!PPIndicator) */
		/* const */ unsigned int RES            : 1;	/* Reserved Bit (vRF!Header!Reserved) */
		/* const */ unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_RDHS3_type;
#define ERAY_RDHS3	(*( ERAY_RDHS3_type *) 0xf001c708u)	/* Read Header Section 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SCCA           : 11;	/* Slot Counter Channel A (vSlotCounter[A]) */
		/* const */ unsigned int                : 5;
		/* const */ unsigned int SCCB           : 11;	/* Slot Counter Channel B (vSlotCounter[B]) */
		/* const */ unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_SCV_type;
#define ERAY_SCV	(*( ERAY_SCV_type *) 0xf001c110u)	/* Slot Counter Value */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int VSAE           : 4;	/* Valid SYNC Frames Channel A, even communication cycle */
		/* const */ unsigned int VSAO           : 4;	/* Valid SYNC Frames Channel A, odd communication cycle */
		/* const */ unsigned int VSBE           : 4;	/* Valid SYNC Frames Channel B, even communication cycle */
		/* const */ unsigned int VSBO           : 4;	/* Valid SYNC Frames Channel B, odd communication cycle */
		/* const */ unsigned int MOCS           : 1;	/* Missing Offset Correction Signal */
		/* const */ unsigned int OCLR           : 1;	/* Offset Correction Limit Reached */
		/* const */ unsigned int MRCS           : 1;	/* Missing Rate Correction Signal */
		/* const */ unsigned int RCLR           : 1;	/* Rate Correction Limit Reached */
		/* const */ unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} ERAY_SFS_type;
#define ERAY_SFS	(*( ERAY_SFS_type *) 0xf001c120u)	/* SYNC Frame Status */

typedef volatile union
{
	struct
	{ 
		unsigned int WSTE           : 1;	/* Wakeup Status Service Request Enable */
		unsigned int CASE           : 1;	/* Collision Avoidance Symbol Service Request Enable */
		unsigned int CYCSE          : 1;	/* Cycle Start Service Request Enable */
		unsigned int TXIE           : 1;	/* Transmit Service Request Enable */
		unsigned int RXIE           : 1;	/* Receive Service Request Enable */
		unsigned int RFNEE          : 1;	/* Receive FIFO Not Empty Service Request Enable */
		unsigned int RFCLE          : 1;	/* Receive FIFO Critical Level Service Request Enable */
		unsigned int NMVCE          : 1;	/* Network Management Vector Changed Service Request Enable */
		unsigned int TI0E           : 1;	/* Timer Service Request 0 Enable */
		unsigned int TI1E           : 1;	/* Timer Service Request 1 Enable */
		unsigned int TIBCE          : 1;	/* Transfer Input Buffer Completed Service Request Enable */
		unsigned int TOBCE          : 1;	/* Transfer Output Buffer Completed Service Request Enable */
		unsigned int SWEE           : 1;	/* Stop Watch Event Service Request Enable */
		unsigned int SUCSE          : 1;	/* Startup Completed Successfully Service Request Enable */
		unsigned int MBSIE          : 1;	/* Message Buffer Status Service Request Enable */
		unsigned int SDSE           : 1;	/* Start of Dynamic Segment Service Request Enable */
		unsigned int WUPAE          : 1;	/* Wakeup Pattern Channel A Service Request Enable */
		unsigned int MTSAE          : 1;	/* Media Access Test Symbol Channel A Service Request Enable */
		unsigned int                : 6;
		unsigned int WUPBE          : 1;	/* Wakeup Pattern Channel B Service Request Enable */
		unsigned int MTSBE          : 1;	/* Media Access Test Symbol Channel B Service Request Enable */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} ERAY_SIER_type;
#define ERAY_SIER	(*( ERAY_SIER_type *) 0xf001c03cu)	/* Status Service Request Enable Reset */

typedef volatile union
{
	struct
	{ 
		unsigned int WSTE           : 1;	/* Wakeup Status Service Request Enable */
		unsigned int CASE           : 1;	/* Collision Avoidance Symbol Service Request Enable */
		unsigned int CYCSE          : 1;	/* Cycle Start Service Request Enable */
		unsigned int TXIE           : 1;	/* Transmit Service Request Enable */
		unsigned int RXIE           : 1;	/* Receive Service Request Enable */
		unsigned int RFNEE          : 1;	/* Receive FIFO Not Empty Service Request Enable */
		unsigned int RFCLE          : 1;	/* Receive FIFO Critical Level Service Request Enable */
		unsigned int NMVCE          : 1;	/* Network Management Vector Changed Service Request Enable */
		unsigned int TI0E           : 1;	/* Timer Service Request 0 Enable */
		unsigned int TI1E           : 1;	/* Timer Service Request 1 Enable */
		unsigned int TIBCE          : 1;	/* Transfer Input Buffer Completed Service Request Enable */
		unsigned int TOBCE          : 1;	/* Transfer Output Buffer Completed Service Request Enable */
		unsigned int SWEE           : 1;	/* Stop Watch Event Service Request Enable */
		unsigned int SUCSE          : 1;	/* Startup Completed Successfully Service Request Enable */
		unsigned int MBSIE          : 1;	/* Message Buffer Status Service Request Enable */
		unsigned int SDSE           : 1;	/* Start of Dynamic Segment Service Request Enable */
		unsigned int WUPAE          : 1;	/* Wakeup Pattern Channel A Service Request Enable */
		unsigned int MTSAE          : 1;	/* Media Access Test Symbol Channel A Service Request Enable */
		unsigned int                : 6;
		unsigned int WUPBE          : 1;	/* Wakeup Pattern Channel B Service Request Enable */
		unsigned int MTSBE          : 1;	/* Media Access Test Symbol Channel B Service Request Enable */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} ERAY_SIES_type;
#define ERAY_SIES	(*( ERAY_SIES_type *) 0xf001c038u)	/* Status Service Request Enable Set */

typedef volatile union
{
	struct
	{ 
		unsigned int WSTL           : 1;	/* Wakeup Status Service Request Line */
		unsigned int CASL           : 1;	/* Collision Avoidance Symbol Service Request Line */
		unsigned int CYCSL          : 1;	/* Cycle Start Service Request Line */
		unsigned int TXIL           : 1;	/* Transmit Service Request Line */
		unsigned int RXIL           : 1;	/* Receive Service Request Line */
		unsigned int RFNEL          : 1;	/* Receive FIFO Not Empty Service Request Line */
		unsigned int RFCLL          : 1;	/* Receive FIFO Critical Level Service Request Line */
		unsigned int NMVCL          : 1;	/* Network Management Vector Changed Service Request Line */
		unsigned int TI0L           : 1;	/* Timer Service Request 0 Line */
		unsigned int TI1L           : 1;	/* Timer Service Request 1 Line */
		unsigned int TIBCL          : 1;	/* Transfer Input Buffer Completed Service Request Line */
		unsigned int TOBCL          : 1;	/* Transfer Output Buffer Completed Service Request Line */
		unsigned int SWEL           : 1;	/* Stop Watch Event Service Request Line */
		unsigned int SUCSL          : 1;	/* Startup Completed Successfully Service Request Line */
		unsigned int MBSIL          : 1;	/* Message Buffer Status Service Request Line */
		unsigned int SDSL           : 1;	/* Start of Dynamic Segment Service Request Line */
		unsigned int WUPAL          : 1;	/* Wakeup Pattern Channel A Service Request Line */
		unsigned int MTSAL          : 1;	/* Media Access Test Symbol Channel A Service Request Line */
		unsigned int                : 6;
		unsigned int WUPBL          : 1;	/* Wakeup Pattern Channel B Service Request Line */
		unsigned int MTSBL          : 1;	/* Media Access Test Symbol Channel B Service Request Line */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} ERAY_SILS_type;
#define ERAY_SILS	(*( ERAY_SILS_type *) 0xf001c02cu)	/* Status Service Request Line Select */

typedef volatile union
{
	struct
	{ 
		unsigned int WST            : 1;	/* Wakeup Status */
		unsigned int CAS            : 1;	/* Collision Avoidance Symbol */
		unsigned int CYCS           : 1;	/* Cycle Start Service Request */
		unsigned int TXI            : 1;	/* Transmit Service Request */
		unsigned int RXI            : 1;	/* Receive Service Request */
		/* const */ unsigned int RFNE           : 1;	/* Receive FIFO Not Empty */
		/* const */ unsigned int RFCL           : 1;	/* Receive FIFO Critical Level */
		unsigned int NMVC           : 1;	/* Network Management Vector Changed */
		unsigned int TI0            : 1;	/* Timer Service Request 0 */
		unsigned int TI1            : 1;	/* Timer Service Request 1 */
		unsigned int TIBC           : 1;	/* Transfer Input Buffer Completed */
		unsigned int TOBC           : 1;	/* Transfer Output Buffer Completed */
		unsigned int SWE            : 1;	/* Stop Watch Event */
		unsigned int SUCS           : 1;	/* Startup Completed Successfully */
		unsigned int MBSI           : 1;	/* Message Buffer Status Service Request */
		unsigned int SDS            : 1;	/* Start of Dynamic Segment */
		unsigned int WUPA           : 1;	/* Wakeup Pattern Channel A */
		unsigned int MTSA           : 1;	/* MTS Received on Channel A (vSS!ValidMTSA) */
		unsigned int                : 6;
		unsigned int WUPB           : 1;	/* Wakeup Pattern Channel B */
		unsigned int MTSB           : 1;	/* MTS Received on Channel B (vSS!ValidMTSB) */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} ERAY_SIR_type;
#define ERAY_SIR	(*( ERAY_SIR_type *) 0xf001c024u)	/* Status Service Request Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ESWT           : 1;	/* Enable Stop Watch Trigger */
		unsigned int SWMS           : 1;	/* Stop Watch Mode Select */
		unsigned int EDGE           : 1;	/* Stop Watch Trigger Edge Select */
		unsigned int SSWT           : 1;	/* Software Stop Watch Trigger */
		unsigned int EETP           : 1;	/* Enable External Trigger Pin */
		unsigned int EINT0          : 1;	/* Enable Service Request 0 Trigger */
		unsigned int EINT1          : 1;	/* Enable Service Request 1 Trigger */
		unsigned int                : 1;
		/* const */ unsigned int SCCV           : 6;	/* Stopped Cycle Counter Value */
		unsigned int                : 2;
		/* const */ unsigned int SMTV           : 14;	/* Stopped Macrotick Value */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_STPW1_type;
#define ERAY_STPW1	(*( ERAY_STPW1_type *) 0xf001c04cu)	/* Stop Watch Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SSCVA          : 11;	/* Stop Watch Captured Slot Counter Value Channel A */
		/* const */ unsigned int                : 5;
		/* const */ unsigned int SSCVB          : 11;	/* Stop Watch Captured Slot Counter Value Channel B */
		/* const */ unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} ERAY_STPW2_type;
#define ERAY_STPW2	(*( ERAY_STPW2_type *) 0xf001c050u)	/* Stop Watch Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int CMD            : 4;	/* CHI Command Vector */
		unsigned int                : 3;
		/* const */ unsigned int PBSY           : 1;	/* POC Busy */
		unsigned int TXST           : 1;	/* Transmit Startup Frame in Key SlotThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only!The protocol requires that both bits TXST and TXSY are set for coldstart nodes. (pKeySlotUsedForStartup) */
		unsigned int TXSY           : 1;	/* Transmit SYNC Frame in Key Slot(pKeySlotUsedForSync) */
		unsigned int                : 1;
		unsigned int CSA            : 5;	/* Cold Start Attempts(gColdStartAttempts) */
		unsigned int PTA            : 5;	/* Passive to Active (pAllowPassiveToActive) */
		unsigned int WUCS           : 1;	/* Wakeup Channel Select (pWakeupChannel) */
		unsigned int TSM            : 1;	/* Transmission Slot Mode (pSingleSlotEnabled) */
		unsigned int HCSE           : 1;	/* Halt due to Clock Sync Error (pAllowHaltDueToClock) */
		unsigned int MTSA           : 1;	/* Select Channel A for MTS TransmissionMTSA and MTSB may also be changed outside 'DEFAULT_CONFIG' or 'CONFIG' state when the write to SUCC1 register is directly preceded by the unlock sequence as described in Lock Register (LCK). This may be combined with CHI command 'SEND_MTS'. If both bits MTSA and MTSB are set to 1 an MTS symbol will be transmitted on both channels when requested by writing SUCC1.CMD = 1000B. */
		unsigned int MTSB           : 1;	/* Select Channel B for MTS Transmission */
		unsigned int CCHA           : 1;	/* Connected to Channel A (pChannels) */
		unsigned int CCHB           : 1;	/* Connected to Channel B (pChannels) */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} ERAY_SUCC1_type;
#define ERAY_SUCC1	(*( ERAY_SUCC1_type *) 0xf001c080u)	/* SUC Configuration Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int LT             : 21;	/* Listen TimeoutThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (pdListenTimeout) */
		unsigned int                : 3;
		unsigned int LTN            : 4;	/* Listen Time-out Noise (gListenNoise - 1) */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} ERAY_SUCC2_type;
#define ERAY_SUCC2	(*( ERAY_SUCC2_type *) 0xf001c084u)	/* SUC Configuration Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int WCP            : 4;	/* Maximum Without Clock Correction PassiveThis bit can be updated in 'DEFAULT_CONFIG' or 'CONFIG' state only! (gMaxWithoutClockCorrectionPassive) */
		unsigned int WCF            : 4;	/* Maximum Without Clock Correction Fatal (gMaxWithoutClockCorrecti on Fatal) */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} ERAY_SUCC3_type;
#define ERAY_SUCC3	(*( ERAY_SUCC3_type *) 0xf001c088u)	/* SUC Configuration Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SESA           : 1;	/* Syntax Error in Symbol Window Channel A (vSS!SyntaxErrorA) */
		/* const */ unsigned int SBSA           : 1;	/* Slot Boundary Violation in Symbol Window Channel A (vSS!BViolationA) */
		/* const */ unsigned int TCSA           : 1;	/* Transmission Conflict in Symbol Window Channel A (vSS!TxConflictA) */
		/* const */ unsigned int SESB           : 1;	/* Syntax Error in Symbol Window Channel B (vSS!SyntaxErrorB) */
		/* const */ unsigned int SBSB           : 1;	/* Slot Boundary Violation in Symbol Window Channel B (vSS!BViolationB) */
		/* const */ unsigned int TCSB           : 1;	/* Transmission Conflict in Symbol Window Channel B (vSS!TxConflictB) */
		/* const */ unsigned int MTSA           : 1;	/* MTS Received on Channel A (vSS!ValidMTSA)MTSA and MTSB may also be changed outside 'DEFAULT_CONFIG' or 'CONFIG' state when the write to SUCC1 register is directly preceded by the unlock sequence as described in 'Lock Register (LCK)'. This may be combined with CHI command SEND_MTS. If both bits MTSA and MTSB are set to 1 an MTS symbol will be transmitted on both channels when requested by writing SUCC1.CMD=1000B. */
		/* const */ unsigned int MTSB           : 1;	/* MTS Received on Channel B (vSS!ValidMTSB) */
		/* const */ unsigned int SENA           : 1;	/* Syntax Error during network idle time (NIT) Channel A (vSS!SyntaxErrorA) */
		/* const */ unsigned int SBNA           : 1;	/* Slot Boundary Violation during network idle time (NIT) Channel A (vSS!BViolationA) */
		/* const */ unsigned int SENB           : 1;	/* Syntax Error during network idle time (NIT) Channel B (vSS!SyntaxErrorB) */
		/* const */ unsigned int SBNB           : 1;	/* Slot Boundary Violation during network idle time (NIT) Channel B (vSS!BViolationB) */
		/* const */ unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} ERAY_SWNIT_type;
#define ERAY_SWNIT	(*( ERAY_SWNIT_type *) 0xf001c124u)	/* Symbol Window and Network Idle Time Status */

typedef volatile union
{
	struct
	{ 
		unsigned int T0RC           : 1;	/* Timer 0 Run Control */
		unsigned int T0MS           : 1;	/* Timer 0 Mode Select */
		unsigned int                : 6;
		unsigned int T0CC           : 7;	/* Timer 0 Cycle Code */
		unsigned int                : 1;
		unsigned int T0MO           : 14;	/* Timer 0 Macrotick Offset */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_T0C_type;
#define ERAY_T0C	(*( ERAY_T0C_type *) 0xf001c044u)	/* Timer 0 Configuration */

typedef volatile union
{
	struct
	{ 
		unsigned int T1RC           : 1;	/* Timer 1 Run Control */
		unsigned int T1MS           : 1;	/* Timer 1 Mode Select */
		unsigned int                : 14;
		unsigned int T1MC           : 14;	/* Timer 1 Macrotick Count */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_T1C_type;
#define ERAY_T1C	(*( ERAY_T1C_type *) 0xf001c048u)	/* Timer 1 Configuration */

typedef volatile union
{
	struct
	{ 
		unsigned int WRTEN          : 1;	/* Write Test Register Enable */
		unsigned int ELBE           : 1;	/* External Loop Back Enable */
		unsigned int                : 2;
		unsigned int TMC            : 2;	/* Test Multiplexer Control */
		unsigned int                : 2;
		/* const */ unsigned int AOA            : 1;	/* Activity on A */
		/* const */ unsigned int AOB            : 1;	/* Activity on B */
		unsigned int                : 6;
		/* const */ unsigned int RXA            : 1;	/* Read Channel A Receive Pin */
		/* const */ unsigned int RXB            : 1;	/* Read Channel B Receive Pin */
		unsigned int TXA            : 1;	/* Read or Write to Channel A Transmit Pin */
		unsigned int TXB            : 1;	/* Read or Write to Channel B Transmit Pin */
		unsigned int TXENA          : 1;	/* Read or Write to Channel A Transmit Enable Pin */
		unsigned int TXENB          : 1;	/* Read or Write to Channel B Transmit Enable Pin */
		unsigned int                : 2;
		/* const */ unsigned int CERA           : 4;	/* Coding Error Report Channel ACoding errors are also signalled when the Communication Controller is in 'MONITOR_MODE'. The error codes regarding CAS / MTS symbols concern only the monitored bit pattern, irrelevant whether those bit patterns are seen in the symbol window or elsewhere. */
		/* const */ unsigned int CERB           : 4;	/* Coding Error Report Channel B */
	} B;
	int I;
	unsigned int U;

} ERAY_TEST1_type;
#define ERAY_TEST1	(*( ERAY_TEST1_type *) 0xf001c010u)	/* Test Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int RS             : 3;	/* RAM Select */
		unsigned int                : 1;
		unsigned int SSEL           : 3;	/* Segment Select */
		unsigned int                : 7;
		unsigned int WRECC          : 1;	/* Write ECC Data Enable */
		unsigned int                : 17;
	} B;
	int I;
	unsigned int U;

} ERAY_TEST2_type;
#define ERAY_TEST2	(*( ERAY_TEST2_type *) 0xf001c014u)	/* Test Register 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXR0           : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR1           : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR2           : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR3           : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR4           : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR5           : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR6           : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR7           : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR8           : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR9           : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR10          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR11          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR12          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR13          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR14          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR15          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR16          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR17          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR18          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR19          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR20          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR21          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR22          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR23          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR24          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR25          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR26          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR27          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR28          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR29          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR30          : 1;	/* Transmission Request n (n= 0-31) */
		/* const */ unsigned int TXR31          : 1;	/* Transmission Request n (n= 0-31) */
	} B;
	int I;
	unsigned int U;

} ERAY_TXRQ1_type;
#define ERAY_TXRQ1	(*( ERAY_TXRQ1_type *) 0xf001c320u)	/* Transmission Request Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXR32          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR33          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR34          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR35          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR36          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR37          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR38          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR39          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR40          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR41          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR42          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR43          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR44          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR45          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR46          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR47          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR48          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR49          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR50          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR51          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR52          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR53          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR54          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR55          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR56          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR57          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR58          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR59          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR60          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR61          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR62          : 1;	/* Transmission Request n (n=32-63) */
		/* const */ unsigned int TXR63          : 1;	/* Transmission Request n (n=32-63) */
	} B;
	int I;
	unsigned int U;

} ERAY_TXRQ2_type;
#define ERAY_TXRQ2	(*( ERAY_TXRQ2_type *) 0xf001c324u)	/* Transmission Request Register 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXR64          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR65          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR66          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR67          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR68          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR69          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR70          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR71          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR72          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR73          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR74          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR75          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR76          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR77          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR78          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR79          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR80          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR81          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR82          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR83          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR84          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR85          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR86          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR87          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR88          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR89          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR90          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR91          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR92          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR93          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR94          : 1;	/* Transmission Request n (n=64-95) */
		/* const */ unsigned int TXR95          : 1;	/* Transmission Request n (n=64-95) */
	} B;
	int I;
	unsigned int U;

} ERAY_TXRQ3_type;
#define ERAY_TXRQ3	(*( ERAY_TXRQ3_type *) 0xf001c328u)	/* Transmission Request Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXR96          : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR97          : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR98          : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR99          : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR100         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR101         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR102         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR103         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR104         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR105         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR106         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR107         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR108         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR109         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR110         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR111         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR112         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR113         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR114         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR115         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR116         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR117         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR118         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR119         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR120         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR121         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR122         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR123         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR124         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR125         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR126         : 1;	/* Transmission Request n (n=96-127) */
		/* const */ unsigned int TXR127         : 1;	/* Transmission Request n (n=96-127) */
	} B;
	int I;
	unsigned int U;

} ERAY_TXRQ4_type;
#define ERAY_TXRQ4	(*( ERAY_TXRQ4_type *) 0xf001c32cu)	/* Transmission Request Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int MDWB0          : 8;	/* 32-Bit Word nn, Byte 0 */
		unsigned int MDWB1          : 8;	/* 32-Bit Word nn, Byte 1 */
		unsigned int MDWB2          : 8;	/* 32-Bit Word nn, Byte 2 */
		unsigned int MDWB3          : 8;	/* 32-Bit Word nn, Byte 3 */
	} B;
	int I;
	unsigned int U;

} ERAY_WRDS01_type;
#define ERAY_WRDS01	(*( ERAY_WRDS01_type *) 0xf001c400u)	/* Write Data Section 01 */
#define ERAY_WRDS02	(*( ERAY_WRDS01_type *) 0xf001c404u)	/* Write Data Section 02 */
#define ERAY_WRDS03	(*( ERAY_WRDS01_type *) 0xf001c408u)	/* Write Data Section 03 */
#define ERAY_WRDS04	(*( ERAY_WRDS01_type *) 0xf001c40cu)	/* Write Data Section 04 */
#define ERAY_WRDS05	(*( ERAY_WRDS01_type *) 0xf001c410u)	/* Write Data Section 05 */
#define ERAY_WRDS06	(*( ERAY_WRDS01_type *) 0xf001c414u)	/* Write Data Section 06 */
#define ERAY_WRDS07	(*( ERAY_WRDS01_type *) 0xf001c418u)	/* Write Data Section 07 */
#define ERAY_WRDS08	(*( ERAY_WRDS01_type *) 0xf001c41cu)	/* Write Data Section 08 */
#define ERAY_WRDS09	(*( ERAY_WRDS01_type *) 0xf001c420u)	/* Write Data Section 09 */
#define ERAY_WRDS10	(*( ERAY_WRDS01_type *) 0xf001c424u)	/* Write Data Section 10 */
#define ERAY_WRDS11	(*( ERAY_WRDS01_type *) 0xf001c428u)	/* Write Data Section 11 */
#define ERAY_WRDS12	(*( ERAY_WRDS01_type *) 0xf001c42cu)	/* Write Data Section 12 */
#define ERAY_WRDS13	(*( ERAY_WRDS01_type *) 0xf001c430u)	/* Write Data Section 13 */
#define ERAY_WRDS14	(*( ERAY_WRDS01_type *) 0xf001c434u)	/* Write Data Section 14 */
#define ERAY_WRDS15	(*( ERAY_WRDS01_type *) 0xf001c438u)	/* Write Data Section 15 */
#define ERAY_WRDS16	(*( ERAY_WRDS01_type *) 0xf001c43cu)	/* Write Data Section 16 */
#define ERAY_WRDS17	(*( ERAY_WRDS01_type *) 0xf001c440u)	/* Write Data Section 17 */
#define ERAY_WRDS18	(*( ERAY_WRDS01_type *) 0xf001c444u)	/* Write Data Section 18 */
#define ERAY_WRDS19	(*( ERAY_WRDS01_type *) 0xf001c448u)	/* Write Data Section 19 */
#define ERAY_WRDS20	(*( ERAY_WRDS01_type *) 0xf001c44cu)	/* Write Data Section 20 */
#define ERAY_WRDS21	(*( ERAY_WRDS01_type *) 0xf001c450u)	/* Write Data Section 21 */
#define ERAY_WRDS22	(*( ERAY_WRDS01_type *) 0xf001c454u)	/* Write Data Section 22 */
#define ERAY_WRDS23	(*( ERAY_WRDS01_type *) 0xf001c458u)	/* Write Data Section 23 */
#define ERAY_WRDS24	(*( ERAY_WRDS01_type *) 0xf001c45cu)	/* Write Data Section 24 */
#define ERAY_WRDS25	(*( ERAY_WRDS01_type *) 0xf001c460u)	/* Write Data Section 25 */
#define ERAY_WRDS26	(*( ERAY_WRDS01_type *) 0xf001c464u)	/* Write Data Section 26 */
#define ERAY_WRDS27	(*( ERAY_WRDS01_type *) 0xf001c468u)	/* Write Data Section 27 */
#define ERAY_WRDS28	(*( ERAY_WRDS01_type *) 0xf001c46cu)	/* Write Data Section 28 */
#define ERAY_WRDS29	(*( ERAY_WRDS01_type *) 0xf001c470u)	/* Write Data Section 29 */
#define ERAY_WRDS30	(*( ERAY_WRDS01_type *) 0xf001c474u)	/* Write Data Section 30 */
#define ERAY_WRDS31	(*( ERAY_WRDS01_type *) 0xf001c478u)	/* Write Data Section 31 */
#define ERAY_WRDS32	(*( ERAY_WRDS01_type *) 0xf001c47cu)	/* Write Data Section 32 */
#define ERAY_WRDS33	(*( ERAY_WRDS01_type *) 0xf001c480u)	/* Write Data Section 33 */
#define ERAY_WRDS34	(*( ERAY_WRDS01_type *) 0xf001c484u)	/* Write Data Section 34 */
#define ERAY_WRDS35	(*( ERAY_WRDS01_type *) 0xf001c488u)	/* Write Data Section 35 */
#define ERAY_WRDS36	(*( ERAY_WRDS01_type *) 0xf001c48cu)	/* Write Data Section 36 */
#define ERAY_WRDS37	(*( ERAY_WRDS01_type *) 0xf001c490u)	/* Write Data Section 37 */
#define ERAY_WRDS38	(*( ERAY_WRDS01_type *) 0xf001c494u)	/* Write Data Section 38 */
#define ERAY_WRDS39	(*( ERAY_WRDS01_type *) 0xf001c498u)	/* Write Data Section 39 */
#define ERAY_WRDS40	(*( ERAY_WRDS01_type *) 0xf001c49cu)	/* Write Data Section 40 */
#define ERAY_WRDS41	(*( ERAY_WRDS01_type *) 0xf001c4a0u)	/* Write Data Section 41 */
#define ERAY_WRDS42	(*( ERAY_WRDS01_type *) 0xf001c4a4u)	/* Write Data Section 42 */
#define ERAY_WRDS43	(*( ERAY_WRDS01_type *) 0xf001c4a8u)	/* Write Data Section 43 */
#define ERAY_WRDS44	(*( ERAY_WRDS01_type *) 0xf001c4acu)	/* Write Data Section 44 */
#define ERAY_WRDS45	(*( ERAY_WRDS01_type *) 0xf001c4b0u)	/* Write Data Section 45 */
#define ERAY_WRDS46	(*( ERAY_WRDS01_type *) 0xf001c4b4u)	/* Write Data Section 46 */
#define ERAY_WRDS47	(*( ERAY_WRDS01_type *) 0xf001c4b8u)	/* Write Data Section 47 */
#define ERAY_WRDS48	(*( ERAY_WRDS01_type *) 0xf001c4bcu)	/* Write Data Section 48 */
#define ERAY_WRDS49	(*( ERAY_WRDS01_type *) 0xf001c4c0u)	/* Write Data Section 49 */
#define ERAY_WRDS50	(*( ERAY_WRDS01_type *) 0xf001c4c4u)	/* Write Data Section 50 */
#define ERAY_WRDS51	(*( ERAY_WRDS01_type *) 0xf001c4c8u)	/* Write Data Section 51 */
#define ERAY_WRDS52	(*( ERAY_WRDS01_type *) 0xf001c4ccu)	/* Write Data Section 52 */
#define ERAY_WRDS53	(*( ERAY_WRDS01_type *) 0xf001c4d0u)	/* Write Data Section 53 */
#define ERAY_WRDS54	(*( ERAY_WRDS01_type *) 0xf001c4d4u)	/* Write Data Section 54 */
#define ERAY_WRDS55	(*( ERAY_WRDS01_type *) 0xf001c4d8u)	/* Write Data Section 55 */
#define ERAY_WRDS56	(*( ERAY_WRDS01_type *) 0xf001c4dcu)	/* Write Data Section 56 */
#define ERAY_WRDS57	(*( ERAY_WRDS01_type *) 0xf001c4e0u)	/* Write Data Section 57 */
#define ERAY_WRDS58	(*( ERAY_WRDS01_type *) 0xf001c4e4u)	/* Write Data Section 58 */
#define ERAY_WRDS59	(*( ERAY_WRDS01_type *) 0xf001c4e8u)	/* Write Data Section 59 */
#define ERAY_WRDS60	(*( ERAY_WRDS01_type *) 0xf001c4ecu)	/* Write Data Section 60 */
#define ERAY_WRDS61	(*( ERAY_WRDS01_type *) 0xf001c4f0u)	/* Write Data Section 61 */
#define ERAY_WRDS62	(*( ERAY_WRDS01_type *) 0xf001c4f4u)	/* Write Data Section 62 */
#define ERAY_WRDS63	(*( ERAY_WRDS01_type *) 0xf001c4f8u)	/* Write Data Section 63 */
#define ERAY_WRDS64	(*( ERAY_WRDS01_type *) 0xf001c4fcu)	/* Write Data Section 64 */

typedef volatile union
{
	struct
	{ 
		unsigned int FID            : 11;	/* Frame ID */
		unsigned int                : 5;
		unsigned int CYC            : 7;	/* Cycle Code */
		unsigned int                : 1;
		unsigned int CHA            : 1;	/* Channel Filter Control A */
		unsigned int CHB            : 1;	/* Channel Filter Control B */
		unsigned int CFG            : 1;	/* Message Buffer Direction Configuration Bit */
		unsigned int PPIT           : 1;	/* Payload Preamble Indicator Transmit */
		unsigned int TXM            : 1;	/* Transmission Mode */
		unsigned int MBI            : 1;	/* Message Buffer Service Request */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} ERAY_WRHS1_type;
#define ERAY_WRHS1	(*( ERAY_WRHS1_type *) 0xf001c500u)	/* Write Header Section 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CRC            : 11;	/* Header CRC (vRF!Header!HeaderCRC) */
		unsigned int                : 5;
		unsigned int PLC            : 7;	/* Payload Length Configured */
		unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} ERAY_WRHS2_type;
#define ERAY_WRHS2	(*( ERAY_WRHS2_type *) 0xf001c504u)	/* Write Header Section 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int DP             : 11;	/* Data Pointer */
		unsigned int                : 21;
	} B;
	int I;
	unsigned int U;

} ERAY_WRHS3_type;
#define ERAY_WRHS3	(*( ERAY_WRHS3_type *) 0xf001c508u)	/* Write Header Section 3 */


/* GTM */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} GTM_ACCEN0_type;
#define GTM_ACCEN0	(*( GTM_ACCEN0_type *) 0xf019fdfcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ACCEN1_type;
#define GTM_ACCEN1	(*( GTM_ACCEN1_type *) 0xf019fdf8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 4;	/* Output Selection for ADCx GTM connection */
		unsigned int SEL1           : 4;	/* Output Selection for ADCx GTM connection */
		unsigned int SEL2           : 4;	/* Output Selection for ADCx GTM connection */
		unsigned int SEL3           : 4;	/* Output Selection for ADCx GTM connection */
		unsigned int SEL4           : 4;	/* Output Selection for ADCx GTM connection */
		unsigned int SEL5           : 4;	/* Output Selection for ADCx GTM connection */
		unsigned int SEL6           : 4;	/* Output Selection for ADCx GTM connection */
		unsigned int SEL7           : 4;	/* Output Selection for ADCx GTM connection */
	} B;
	int I;
	unsigned int U;

} GTM_ADCTRIG0OUT0_type;
#define GTM_ADCTRIG0OUT0	(*( GTM_ADCTRIG0OUT0_type *) 0xf019fdb0u)	/* ADC Trigger 0 Output Select 0 Register */
#define GTM_ADCTRIG1OUT0	(*( GTM_ADCTRIG0OUT0_type *) 0xf019fdb8u)	/* ADC Trigger 1 Output Select 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 4;	/* Output Selection for ADCx GTM connection */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} GTM_ADCTRIG0OUT1_type;
#define GTM_ADCTRIG0OUT1	(*( GTM_ADCTRIG0OUT1_type *) 0xf019fdb4u)	/* ADC Trigger 0 Output Select 1 Register */
#define GTM_ADCTRIG1OUT1	(*( GTM_ADCTRIG0OUT1_type *) 0xf019fdbcu)	/* ADC Trigger 1 Output Select 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADD_IN_LD_1    : 24;	/* Input value for SUB_INC1 generation */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ADD_IN_LD1_type;
#define GTM_ADD_IN_LD1	(*( GTM_ADD_IN_LD1_type *) 0xf01280c8u)	/* DPLL Direct Load Input Value for SUB_INC1 */

typedef volatile union
{
	struct
	{ 
		unsigned int ADD_IN_LD_2    : 24;	/* Input value for SUB_INC2 generation */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ADD_IN_LD2_type;
#define GTM_ADD_IN_LD2	(*( GTM_ADD_IN_LD2_type *) 0xf01280ccu)	/* DPLL Direct Load Input Value for SUB_INC1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TO_ADDR        : 20;	/* AEI Timeout address */
		/* const */ unsigned int TO_W1R0        : 1;	/* AEI Timeout Read/Write flag */
		/* const */ unsigned int Reserved       : 11;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_AEI_ADDR_XPT_type;
#define GTM_AEI_ADDR_XPT	(*( GTM_AEI_ADDR_XPT_type *) 0xf010000cu)	/* GTM AEI Timeout Exception Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DATA           : 29;	/* Read/write data from/to FIFO */
		/* const */ unsigned int Reserved       : 3;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_AFD0_CH0_BUF_ACC_type;
#define GTM_AFD0_CH0_BUF_ACC	(*( GTM_AFD0_CH0_BUF_ACC_type *) 0xf0118080u)	/* AFD0 FIFO0 Channel0 Buffer Access Register */
#define GTM_AFD0_CH1_BUF_ACC	(*( GTM_AFD0_CH0_BUF_ACC_type *) 0xf0118090u)	/* AFD0 FIFO0 Channel1 Buffer Access Register */
#define GTM_AFD0_CH2_BUF_ACC	(*( GTM_AFD0_CH0_BUF_ACC_type *) 0xf01180a0u)	/* AFD0 FIFO0 Channel2 Buffer Access Register */
#define GTM_AFD0_CH3_BUF_ACC	(*( GTM_AFD0_CH0_BUF_ACC_type *) 0xf01180b0u)	/* AFD0 FIFO0 Channel3 Buffer Access Register */
#define GTM_AFD0_CH4_BUF_ACC	(*( GTM_AFD0_CH0_BUF_ACC_type *) 0xf01180c0u)	/* AFD0 FIFO0 Channel4 Buffer Access Register */
#define GTM_AFD0_CH5_BUF_ACC	(*( GTM_AFD0_CH0_BUF_ACC_type *) 0xf01180d0u)	/* AFD0 FIFO0 Channel5 Buffer Access Register */
#define GTM_AFD0_CH6_BUF_ACC	(*( GTM_AFD0_CH0_BUF_ACC_type *) 0xf01180e0u)	/* AFD0 FIFO0 Channel6 Buffer Access Register */
#define GTM_AFD0_CH7_BUF_ACC	(*( GTM_AFD0_CH0_BUF_ACC_type *) 0xf01180f0u)	/* AFD0 FIFO0 Channel7 Buffer Access Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 9;	/* ARU address */
		/* const */ unsigned int Reserved       : 3;	/* Reserved */
		unsigned int RREQ           : 1;	/* Initiate read request */
		unsigned int WREQ           : 1;	/* Initiate write request */
		/* const */ unsigned int Reserved_5     : 18;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ARU_ACCESS_type;
#define GTM_ARU_ACCESS	(*( GTM_ARU_ACCESS_type *) 0xf0100280u)	/* ARU Access Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DATA           : 29;	/* Upper ARU data word */
		/* const */ unsigned int Reserved       : 3;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ARU_DATA_H_type;
#define GTM_ARU_DATA_H	(*( GTM_ARU_DATA_H_type *) 0xf0100284u)	/* ARU Access Register Upper Data Word */

typedef volatile union
{
	struct
	{ 
		unsigned int DATA           : 29;	/* Lower ARU data word */
		/* const */ unsigned int Reserved       : 3;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ARU_DATA_L_type;
#define GTM_ARU_DATA_L	(*( GTM_ARU_DATA_L_type *) 0xf0100288u)	/* ARU Access Register Lower Data Word */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 9;	/* ARU debugging address */
		/* const */ unsigned int Reserved       : 23;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ARU_DBG_ACCESS0_type;
#define GTM_ARU_DBG_ACCESS0	(*( GTM_ARU_DBG_ACCESS0_type *) 0xf010028cu)	/* Debug Access Channel 0 */
#define GTM_ARU_DBG_ACCESS1	(*( GTM_ARU_DBG_ACCESS0_type *) 0xf0100298u)	/* Debug Access Channel 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DATA           : 29;	/* Upper debug data word */
		/* const */ unsigned int Reserved       : 3;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ARU_DBG_DATA0_H_type;
#define GTM_ARU_DBG_DATA0_H	(*( GTM_ARU_DBG_DATA0_H_type *) 0xf0100290u)	/* Debug Access 0 Transfer Register Upper Data Word */
#define GTM_ARU_DBG_DATA1_H	(*( GTM_ARU_DBG_DATA0_H_type *) 0xf010029cu)	/* Debug Access 1 Transfer Register Upper Data Word */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DATA           : 29;	/* Lower debug data word */
		/* const */ unsigned int Reserved       : 3;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ARU_DBG_DATA0_L_type;
#define GTM_ARU_DBG_DATA0_L	(*( GTM_ARU_DBG_DATA0_L_type *) 0xf0100294u)	/* Debug Access 0 Transfer Register Lower Data Word */
#define GTM_ARU_DBG_DATA1_L	(*( GTM_ARU_DBG_DATA0_L_type *) 0xf01002a0u)	/* Debug Access 1 Transfer Register Lower Data Word */

typedef volatile union
{
	struct
	{ 
		unsigned int NEW_DATA0_IRQ_EN: 1;	/* ARU_NEW_DATA0_IRQ interrupt enable */
		unsigned int NEW_DATA1_IRQ_EN: 1;	/* ARU_NEW_DATA1_IRQ interrupt enable */
		unsigned int ACC_ACK_IRQ_EN : 1;	/* ACC_ACK_IRQ interrupt enable */
		/* const */ unsigned int Reserved       : 29;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ARU_IRQ_EN_type;
#define GTM_ARU_IRQ_EN	(*( GTM_ARU_IRQ_EN_type *) 0xf01002a8u)	/* ARU Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_NEW_DATA0  : 1;	/* Trigger new data 0 interrupt */
		unsigned int TRG_NEW_DATA   : 1;	/* 1 Trigger new data 1 interrupt */
		unsigned int TRG_ACC_ACK    : 1;	/* Trigger ACC_ACK interrupt */
		/* const */ unsigned int Reserved       : 29;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ARU_IRQ_FORCINT_type;
#define GTM_ARU_IRQ_FORCINT	(*( GTM_ARU_IRQ_FORCINT_type *) 0xf01002acu)	/* ARU_NEW_DATA_IRQ Forcing Interrupt Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IRQ_MODE       : 2;	/* IRQ mode selection */
		/* const */ unsigned int Reserved       : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ARU_IRQ_MODE_type;
#define GTM_ARU_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01002b0u)	/* IRQ Mode Configuration Register */
#define GTM_ATOM0_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d0acu)	/* ATOM0 IRQ Mode Configuration Register */
#define GTM_ATOM0_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d12cu)	/* ATOM0 IRQ Mode Configuration Register */
#define GTM_ATOM0_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d1acu)	/* ATOM0 IRQ Mode Configuration Register */
#define GTM_ATOM0_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d22cu)	/* ATOM0 IRQ Mode Configuration Register */
#define GTM_ATOM0_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d2acu)	/* ATOM0 IRQ Mode Configuration Register */
#define GTM_ATOM0_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d32cu)	/* ATOM0 IRQ Mode Configuration Register */
#define GTM_ATOM0_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d3acu)	/* ATOM0 IRQ Mode Configuration Register */
#define GTM_ATOM0_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d42cu)	/* ATOM0 IRQ Mode Configuration Register */
#define GTM_ATOM1_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d8acu)	/* ATOM1 IRQ Mode Configuration Register */
#define GTM_ATOM1_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d92cu)	/* ATOM1 IRQ Mode Configuration Register */
#define GTM_ATOM1_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010d9acu)	/* ATOM1 IRQ Mode Configuration Register */
#define GTM_ATOM1_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010da2cu)	/* ATOM1 IRQ Mode Configuration Register */
#define GTM_ATOM1_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010daacu)	/* ATOM1 IRQ Mode Configuration Register */
#define GTM_ATOM1_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010db2cu)	/* ATOM1 IRQ Mode Configuration Register */
#define GTM_ATOM1_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010dbacu)	/* ATOM1 IRQ Mode Configuration Register */
#define GTM_ATOM1_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010dc2cu)	/* ATOM1 IRQ Mode Configuration Register */
#define GTM_ATOM2_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e0acu)	/* ATOM2 IRQ Mode Configuration Register */
#define GTM_ATOM2_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e12cu)	/* ATOM2 IRQ Mode Configuration Register */
#define GTM_ATOM2_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e1acu)	/* ATOM2 IRQ Mode Configuration Register */
#define GTM_ATOM2_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e22cu)	/* ATOM2 IRQ Mode Configuration Register */
#define GTM_ATOM2_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e2acu)	/* ATOM2 IRQ Mode Configuration Register */
#define GTM_ATOM2_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e32cu)	/* ATOM2 IRQ Mode Configuration Register */
#define GTM_ATOM2_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e3acu)	/* ATOM2 IRQ Mode Configuration Register */
#define GTM_ATOM2_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e42cu)	/* ATOM2 IRQ Mode Configuration Register */
#define GTM_ATOM3_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e8acu)	/* ATOM3 IRQ Mode Configuration Register */
#define GTM_ATOM3_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e92cu)	/* ATOM3 IRQ Mode Configuration Register */
#define GTM_ATOM3_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010e9acu)	/* ATOM3 IRQ Mode Configuration Register */
#define GTM_ATOM3_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010ea2cu)	/* ATOM3 IRQ Mode Configuration Register */
#define GTM_ATOM3_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010eaacu)	/* ATOM3 IRQ Mode Configuration Register */
#define GTM_ATOM3_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010eb2cu)	/* ATOM3 IRQ Mode Configuration Register */
#define GTM_ATOM3_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010ebacu)	/* ATOM3 IRQ Mode Configuration Register */
#define GTM_ATOM3_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010ec2cu)	/* ATOM3 IRQ Mode Configuration Register */
#define GTM_ATOM4_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010f0acu)	/* ATOM4 IRQ Mode Configuration Register */
#define GTM_ATOM4_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010f12cu)	/* ATOM4 IRQ Mode Configuration Register */
#define GTM_ATOM4_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010f1acu)	/* ATOM4 IRQ Mode Configuration Register */
#define GTM_ATOM4_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010f22cu)	/* ATOM4 IRQ Mode Configuration Register */
#define GTM_ATOM4_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010f2acu)	/* ATOM4 IRQ Mode Configuration Register */
#define GTM_ATOM4_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010f32cu)	/* ATOM4 IRQ Mode Configuration Register */
#define GTM_ATOM4_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010f3acu)	/* ATOM4 IRQ Mode Configuration Register */
#define GTM_ATOM4_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010f42cu)	/* ATOM4 IRQ Mode Configuration Register */
#define GTM_BRC_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010046cu)	/* BRC IRQ Mode Configuration Register */
#define GTM_CMP_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0100210u)	/* CMP IRQ Mode Configuration Register */
#define GTM_DPLL_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf012804cu)	/* DPLL Interrupt Mode Register */
#define GTM_MCS0_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0130038u)	/* MCS0 IRQ Mode Configuration Register */
#define GTM_MCS0_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01300b8u)	/* MCS0 IRQ Mode Configuration Register */
#define GTM_MCS0_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0130138u)	/* MCS0 IRQ Mode Configuration Register */
#define GTM_MCS0_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01301b8u)	/* MCS0 IRQ Mode Configuration Register */
#define GTM_MCS0_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0130238u)	/* MCS0 IRQ Mode Configuration Register */
#define GTM_MCS0_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01302b8u)	/* MCS0 IRQ Mode Configuration Register */
#define GTM_MCS0_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0130338u)	/* MCS0 IRQ Mode Configuration Register */
#define GTM_MCS0_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01303b8u)	/* MCS0 IRQ Mode Configuration Register */
#define GTM_MCS1_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0140038u)	/* MCS1 IRQ Mode Configuration Register */
#define GTM_MCS1_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01400b8u)	/* MCS1 IRQ Mode Configuration Register */
#define GTM_MCS1_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0140138u)	/* MCS1 IRQ Mode Configuration Register */
#define GTM_MCS1_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01401b8u)	/* MCS1 IRQ Mode Configuration Register */
#define GTM_MCS1_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0140238u)	/* MCS1 IRQ Mode Configuration Register */
#define GTM_MCS1_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01402b8u)	/* MCS1 IRQ Mode Configuration Register */
#define GTM_MCS1_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0140338u)	/* MCS1 IRQ Mode Configuration Register */
#define GTM_MCS1_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01403b8u)	/* MCS1 IRQ Mode Configuration Register */
#define GTM_MCS2_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0150038u)	/* MCS2 IRQ Mode Configuration Register */
#define GTM_MCS2_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01500b8u)	/* MCS2 IRQ Mode Configuration Register */
#define GTM_MCS2_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0150138u)	/* MCS2 IRQ Mode Configuration Register */
#define GTM_MCS2_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01501b8u)	/* MCS2 IRQ Mode Configuration Register */
#define GTM_MCS2_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0150238u)	/* MCS2 IRQ Mode Configuration Register */
#define GTM_MCS2_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01502b8u)	/* MCS2 IRQ Mode Configuration Register */
#define GTM_MCS2_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0150338u)	/* MCS2 IRQ Mode Configuration Register */
#define GTM_MCS2_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01503b8u)	/* MCS2 IRQ Mode Configuration Register */
#define GTM_MCS3_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0160038u)	/* MCS3 IRQ Mode Configuration Register */
#define GTM_MCS3_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01600b8u)	/* MCS3 IRQ Mode Configuration Register */
#define GTM_MCS3_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0160138u)	/* MCS3 IRQ Mode Configuration Register */
#define GTM_MCS3_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01601b8u)	/* MCS3 IRQ Mode Configuration Register */
#define GTM_MCS3_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0160238u)	/* MCS3 IRQ Mode Configuration Register */
#define GTM_MCS3_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01602b8u)	/* MCS3 IRQ Mode Configuration Register */
#define GTM_MCS3_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0160338u)	/* MCS3 IRQ Mode Configuration Register */
#define GTM_MCS3_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01603b8u)	/* MCS3 IRQ Mode Configuration Register */
#define GTM_SPE0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0100838u)	/* SPE0 IRQ Mode Configuration Register */
#define GTM_SPE1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01008b8u)	/* SPE1 IRQ Mode Configuration Register */
#define GTM_TIM0_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010102cu)	/* TIM0 IRQ Mode Configuration Register */
#define GTM_TIM0_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01010acu)	/* TIM0 IRQ Mode Configuration Register */
#define GTM_TIM0_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010112cu)	/* TIM0 IRQ Mode Configuration Register */
#define GTM_TIM0_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01011acu)	/* TIM0 IRQ Mode Configuration Register */
#define GTM_TIM0_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010122cu)	/* TIM0 IRQ Mode Configuration Register */
#define GTM_TIM0_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01012acu)	/* TIM0 IRQ Mode Configuration Register */
#define GTM_TIM0_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010132cu)	/* TIM0 IRQ Mode Configuration Register */
#define GTM_TIM0_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01013acu)	/* TIM0 IRQ Mode Configuration Register */
#define GTM_TIM1_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010182cu)	/* TIM1 IRQ Mode Configuration Register */
#define GTM_TIM1_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01018acu)	/* TIM1 IRQ Mode Configuration Register */
#define GTM_TIM1_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010192cu)	/* TIM1 IRQ Mode Configuration Register */
#define GTM_TIM1_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01019acu)	/* TIM1 IRQ Mode Configuration Register */
#define GTM_TIM1_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0101a2cu)	/* TIM1 IRQ Mode Configuration Register */
#define GTM_TIM1_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0101aacu)	/* TIM1 IRQ Mode Configuration Register */
#define GTM_TIM1_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0101b2cu)	/* TIM1 IRQ Mode Configuration Register */
#define GTM_TIM1_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0101bacu)	/* TIM1 IRQ Mode Configuration Register */
#define GTM_TIM2_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010202cu)	/* TIM2 IRQ Mode Configuration Register */
#define GTM_TIM2_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01020acu)	/* TIM2 IRQ Mode Configuration Register */
#define GTM_TIM2_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010212cu)	/* TIM2 IRQ Mode Configuration Register */
#define GTM_TIM2_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01021acu)	/* TIM2 IRQ Mode Configuration Register */
#define GTM_TIM2_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010222cu)	/* TIM2 IRQ Mode Configuration Register */
#define GTM_TIM2_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01022acu)	/* TIM2 IRQ Mode Configuration Register */
#define GTM_TIM2_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010232cu)	/* TIM2 IRQ Mode Configuration Register */
#define GTM_TIM2_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01023acu)	/* TIM2 IRQ Mode Configuration Register */
#define GTM_TIM3_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010282cu)	/* TIM3 IRQ Mode Configuration Register */
#define GTM_TIM3_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01028acu)	/* TIM3 IRQ Mode Configuration Register */
#define GTM_TIM3_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf010292cu)	/* TIM3 IRQ Mode Configuration Register */
#define GTM_TIM3_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01029acu)	/* TIM3 IRQ Mode Configuration Register */
#define GTM_TIM3_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0102a2cu)	/* TIM3 IRQ Mode Configuration Register */
#define GTM_TIM3_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0102aacu)	/* TIM3 IRQ Mode Configuration Register */
#define GTM_TIM3_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0102b2cu)	/* TIM3 IRQ Mode Configuration Register */
#define GTM_TIM3_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0102bacu)	/* TIM3 IRQ Mode Configuration Register */
#define GTM_TOM0_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01080a8u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH10_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108328u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH11_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108368u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH12_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01083a8u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH13_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01083e8u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH14_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108428u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH15_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108468u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01080e8u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108128u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108168u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01081a8u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01081e8u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108228u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108268u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH8_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01082a8u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM0_CH9_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01082e8u)	/* TOM0 IRQ Mode Configuration Register */
#define GTM_TOM1_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01088a8u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH10_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108b28u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH11_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108b68u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH12_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108ba8u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH13_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108be8u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH14_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108c28u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH15_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108c68u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01088e8u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108928u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108968u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01089a8u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01089e8u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108a28u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108a68u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH8_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108aa8u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM1_CH9_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0108ae8u)	/* TOM1 IRQ Mode Configuration Register */
#define GTM_TOM2_CH0_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01090a8u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH10_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0109328u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH11_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0109368u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH12_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01093a8u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH13_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01093e8u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH14_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0109428u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH15_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0109468u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH1_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01090e8u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH2_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0109128u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH3_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0109168u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH4_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01091a8u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH5_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01091e8u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH6_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0109228u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH7_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf0109268u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH8_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01092a8u)	/* TOM2 IRQ Mode Configuration Register */
#define GTM_TOM2_CH9_IRQ_MODE	(*( GTM_ARU_IRQ_MODE_type *) 0xf01092e8u)	/* TOM2 IRQ Mode Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NEW_DATA0      : 1;	/* Data was transferred for addr ARU_DBG_ACCESS0 */
		unsigned int NEW_DATA1      : 1;	/* Data was transferred for addr ARU_DBG_ACCESS1 */
		unsigned int ACC_ACK        : 1;	/* AEI to ARU access finished, on read access data are valid */
		/* const */ unsigned int Reserved       : 29;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ARU_IRQ_NOTIFY_type;
#define GTM_ARU_IRQ_NOTIFY	(*( GTM_ARU_IRQ_NOTIFY_type *) 0xf01002a4u)	/* ARU Interrupt Notification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ACT_TB         : 24;	/* Time base value */
		unsigned int TB_TRIG        : 1;	/* Set trigger request */
		unsigned int TBU_SEL        : 2;	/* Selection of time base used for comparison */
		/* const */ unsigned int Reserved       : 5;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_AGC_ACT_TB_type;
#define GTM_ATOM0_AGC_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010d00cu)	/* TOM0 TGC0 Action Time Base Register */
#define GTM_ATOM1_AGC_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010d80cu)	/* TOM1 TGC0 Action Time Base Register */
#define GTM_ATOM2_AGC_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010e00cu)	/* TOM2 TGC0 Action Time Base Register */
#define GTM_ATOM3_AGC_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010e80cu)	/* TOM3 TGC0 Action Time Base Register */
#define GTM_ATOM4_AGC_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010f00cu)	/* TOM4 TGC0 Action Time Base Register */
#define GTM_TOM0_TGC0_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010800cu)	/* TOM0 TGC0 Action Time Base Register */
#define GTM_TOM0_TGC1_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010804cu)	/* TOM0 TGC1 Action Time Base Register */
#define GTM_TOM1_TGC0_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010880cu)	/* TOM1 TGC0 Action Time Base Register */
#define GTM_TOM1_TGC1_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010884cu)	/* TOM1 TGC1 Action Time Base Register */
#define GTM_TOM2_TGC0_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010900cu)	/* TOM2 TGC0 Action Time Base Register */
#define GTM_TOM2_TGC1_ACT_TB	(*( GTM_ATOM0_AGC_ACT_TB_type *) 0xf010904cu)	/* TOM2 TGC1 Action Time Base Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ENDIS_CTRL0    : 2;	/* (A)TOM channel 0 enable/disable update value */
		unsigned int ENDIS_CTRL1    : 2;	/* (A)TOM channel 1 enable/disable update value */
		unsigned int ENDIS_CTRL2    : 2;	/* (A)TOM channel 2 enable/disable update value */
		unsigned int ENDIS_CTRL3    : 2;	/* (A)TOM channel 3 enable/disable update value */
		unsigned int ENDIS_CTRL4    : 2;	/* (A)TOM channel 4 enable/disable update value */
		unsigned int ENDIS_CTRL5    : 2;	/* (A)TOM channel 5 enable/disable update value */
		unsigned int ENDIS_CTRL6    : 2;	/* (A)TOM channel 6 enable/disable update value */
		unsigned int ENDIS_CTRL7    : 2;	/* (A)TOM channel 7 enable/disable update value */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_AGC_ENDIS_CTRL_type;
#define GTM_ATOM0_AGC_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf010d004u)	/* ATOM0 AGC Enable/Disable Control Register */
#define GTM_ATOM1_AGC_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf010d804u)	/* ATOM1 AGC Enable/Disable Control Register */
#define GTM_ATOM2_AGC_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf010e004u)	/* ATOM2 AGC Enable/Disable Control Register */
#define GTM_ATOM3_AGC_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf010e804u)	/* ATOM3 AGC Enable/Disable Control Register */
#define GTM_ATOM4_AGC_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf010f004u)	/* ATOM4 AGC Enable/Disable Control Register */
#define GTM_TOM0_TGC0_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf0108004u)	/* TOM0 TGC0 Enable/Disable Control Register */
#define GTM_TOM0_TGC1_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf0108044u)	/* TOM0 TGC1 Enable/Disable Control Register */
#define GTM_TOM1_TGC0_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf0108804u)	/* TOM1 TGC0 Enable/Disable Control Register */
#define GTM_TOM1_TGC1_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf0108844u)	/* TOM1 TGC1 Enable/Disable Control Register */
#define GTM_TOM2_TGC0_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf0109004u)	/* TOM2 TGC0 Enable/Disable Control Register */
#define GTM_TOM2_TGC1_ENDIS_CTRL	(*( GTM_ATOM0_AGC_ENDIS_CTRL_type *) 0xf0109044u)	/* TOM2 TGC1 Enable/Disable Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ENDIS_STAT0    : 2;	/* (A)TOM channel 0 enable/disable */
		unsigned int ENDIS_STAT1    : 2;	/* (A)TOM channel 1 enable/disable */
		unsigned int ENDIS_STAT2    : 2;	/* (A)TOM channel 2 enable/disable */
		unsigned int ENDIS_STAT3    : 2;	/* (A)TOM channel 3 enable/disable */
		unsigned int ENDIS_STAT4    : 2;	/* (A)TOM channel 4 enable/disable */
		unsigned int ENDIS_STAT5    : 2;	/* (A)TOM channel 5 enable/disable */
		unsigned int ENDIS_STAT6    : 2;	/* (A)TOM channel 6 enable/disable */
		unsigned int ENDIS_STAT7    : 2;	/* (A)TOM channel 7 enable/disable */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_AGC_ENDIS_STAT_type;
#define GTM_ATOM0_AGC_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf010d008u)	/* ATOM0 AGC Enable/Disable Status Register */
#define GTM_ATOM1_AGC_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf010d808u)	/* ATOM1 AGC Enable/Disable Status Register */
#define GTM_ATOM2_AGC_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf010e008u)	/* ATOM2 AGC Enable/Disable Status Register */
#define GTM_ATOM3_AGC_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf010e808u)	/* ATOM3 AGC Enable/Disable Status Register */
#define GTM_ATOM4_AGC_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf010f008u)	/* ATOM4 AGC Enable/Disable Status Register */
#define GTM_TOM0_TGC0_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf0108008u)	/* TOM0 TGC0 Enable/Disable Status Register */
#define GTM_TOM0_TGC1_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf0108048u)	/* TOM0 TGC1 Enable/Disable Status Register */
#define GTM_TOM1_TGC0_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf0108808u)	/* TOM1 TGC0 Enable/Disable Status Register */
#define GTM_TOM1_TGC1_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf0108848u)	/* TOM1 TGC1 Enable/Disable Status Register */
#define GTM_TOM2_TGC0_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf0109008u)	/* TOM2 TGC0 Enable/Disable Status Register */
#define GTM_TOM2_TGC1_ENDIS_STAT	(*( GTM_ATOM0_AGC_ENDIS_STAT_type *) 0xf0109048u)	/* TOM2 TGC1 Enable/Disable Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FUPD_CTRL0     : 2;	/* Force update of (A)TOM channel 0 operation registers */
		unsigned int FUPD_CTRL1     : 2;	/* Force update of (A)TOM channel 1 operation registers */
		unsigned int FUPD_CTRL2     : 2;	/* Force update of (A)TOM channel 2 operation registers */
		unsigned int FUPD_CTRL3     : 2;	/* Force update of (A)TOM channel 3 operation registers */
		unsigned int FUPD_CTRL4     : 2;	/* Force update of (A)TOM channel 4 operation registers */
		unsigned int FUPD_CTRL5     : 2;	/* Force update of (A)TOM channel 5 operation registers */
		unsigned int FUPD_CTRL6     : 2;	/* Force update of (A)TOM channel 6 operation registers */
		unsigned int FUPD_CTRL7     : 2;	/* Force update of (A)TOM channel 7 operation registers */
		unsigned int RSTCN0_CH0     : 2;	/* Reset CN0 of channel 0 on force update event */
		unsigned int RSTCN0_CH1     : 2;	/* Reset CN0 of channel 1 on force update event */
		unsigned int RSTCN0_CH2     : 2;	/* Reset CN0 of channel 2 on force update event */
		unsigned int RSTCN0_CH3     : 2;	/* Reset CN0 of channel 3 on force update event */
		unsigned int RSTCN0_CH4     : 2;	/* Reset CN0 of channel 4 on force update event */
		unsigned int RSTCN0_CH5     : 2;	/* Reset CN0 of channel 5 on force update event */
		unsigned int RSTCN0_CH6     : 2;	/* Reset CN0 of channel 6 on force update event */
		unsigned int RSTCN0_CH7     : 2;	/* Reset CN0 of channel 7 on force update event */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_AGC_FUPD_CTRL_type;
#define GTM_ATOM0_AGC_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf010d018u)	/* ATOM0 AGC Force Update Control Register */
#define GTM_ATOM1_AGC_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf010d818u)	/* ATOM1 AGC Force Update Control Register */
#define GTM_ATOM2_AGC_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf010e018u)	/* ATOM2 AGC Force Update Control Register */
#define GTM_ATOM3_AGC_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf010e818u)	/* ATOM3 AGC Force Update Control Register */
#define GTM_ATOM4_AGC_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf010f018u)	/* ATOM4 AGC Force Update Control Register */
#define GTM_TOM0_TGC0_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf0108018u)	/* TOM0 TGC0 Force Update Control Register */
#define GTM_TOM0_TGC1_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf0108058u)	/* TOM0 TGC1 Force Update Control Register */
#define GTM_TOM1_TGC0_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf0108818u)	/* TOM1 TGC0 Force Update Control Register */
#define GTM_TOM1_TGC1_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf0108858u)	/* TOM1 TGC1 Force Update Control Register */
#define GTM_TOM2_TGC0_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf0109018u)	/* TOM2 TGC0 Force Update Control Register */
#define GTM_TOM2_TGC1_FUPD_CTRL	(*( GTM_ATOM0_AGC_FUPD_CTRL_type *) 0xf0109058u)	/* TOM2 TGC1 Force Update Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int HOST_TRIG      : 1;	/* Trigger request signal (see AGC) to update the register ENDIS_STAT and OUTEN_STAT */
		/* const */ unsigned int Reserved       : 7;	/* Reserved */
		unsigned int RST_CH0        : 1;	/* Software reset of channel 0 */
		unsigned int RST_CH1        : 1;	/* Software reset of channel 1 */
		unsigned int RST_CH2        : 1;	/* Software reset of channel 2 */
		unsigned int RST_CH3        : 1;	/* Software reset of channel 3 */
		unsigned int RST_CH4        : 1;	/* Software reset of channel 4 */
		unsigned int RST_CH5        : 1;	/* Software reset of channel 5 */
		unsigned int RST_CH6        : 1;	/* Software reset of channel 6 */
		unsigned int RST_CH7        : 1;	/* Software reset of channel 7 */
		unsigned int UPEN_CTRL0     : 2;	/* ATOM channel 0 enable update of register CM0, CM1 and CLK_SRC_STAT from SR0, SR1 and CLK_SRC */
		unsigned int UPEN_CTRL1     : 2;	/* ATOM channel 1 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL2     : 2;	/* ATOM channel 2 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL3     : 2;	/* ATOM channel 3 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL4     : 2;	/* ATOM channel 4 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL5     : 2;	/* ATOM channel 5 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL6     : 2;	/* ATOM channel 6 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL7     : 2;	/* ATOM channel 7 enable update of register CM0, CM1 and CLK_SRC_STAT */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_AGC_GLB_CTRL_type;
#define GTM_ATOM0_AGC_GLB_CTRL	(*( GTM_ATOM0_AGC_GLB_CTRL_type *) 0xf010d000u)	/* ATOM0 AGC Global control register */
#define GTM_ATOM1_AGC_GLB_CTRL	(*( GTM_ATOM0_AGC_GLB_CTRL_type *) 0xf010d800u)	/* ATOM1 AGC Global control register */
#define GTM_ATOM2_AGC_GLB_CTRL	(*( GTM_ATOM0_AGC_GLB_CTRL_type *) 0xf010e000u)	/* ATOM2 AGC Global control register */
#define GTM_ATOM3_AGC_GLB_CTRL	(*( GTM_ATOM0_AGC_GLB_CTRL_type *) 0xf010e800u)	/* ATOM3 AGC Global control register */
#define GTM_ATOM4_AGC_GLB_CTRL	(*( GTM_ATOM0_AGC_GLB_CTRL_type *) 0xf010f000u)	/* ATOM4 AGC Global control register */

typedef volatile union
{
	struct
	{ 
		unsigned int INT_TRIG0      : 2;	/* Select input signal TRIG_0 as a trigger source */
		unsigned int INT_TRIG1      : 2;	/* Select input signal TRIG_1 as a trigger source */
		unsigned int INT_TRIG2      : 2;	/* Select input signal TRIG_2 as a trigger source */
		unsigned int INT_TRIG3      : 2;	/* Select input signal TRIG_3 as a trigger source */
		unsigned int INT_TRIG4      : 2;	/* Select input signal TRIG_4 as a trigger source */
		unsigned int INT_TRIG5      : 2;	/* Select input signal TRIG_5 as a trigger source */
		unsigned int INT_TRIG6      : 2;	/* Select input signal TRIG_6 as a trigger source */
		unsigned int INT_TRIG7      : 2;	/* Select input signal TRIG_7 as a trigger source */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_AGC_INT_TRIG_type;
#define GTM_ATOM0_AGC_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010d01cu)	/* ATOM0 AGC Internal Trigger Control Register */
#define GTM_ATOM1_AGC_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010d81cu)	/* ATOM1 AGC Internal Trigger Control Register */
#define GTM_ATOM2_AGC_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010e01cu)	/* ATOM2 AGC Internal Trigger Control Register */
#define GTM_ATOM3_AGC_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010e81cu)	/* ATOM3 AGC Internal Trigger Control Register */
#define GTM_ATOM4_AGC_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010f01cu)	/* ATOM4 AGC Internal Trigger Control Register */
#define GTM_TOM0_TGC0_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010801cu)	/* TOM0 TGC0 Internal Trigger Control Register */
#define GTM_TOM0_TGC1_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010805cu)	/* TOM0 TGC1 Internal Trigger Control Register */
#define GTM_TOM1_TGC0_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010881cu)	/* TOM1 TGC0 Internal Trigger Control Register */
#define GTM_TOM1_TGC1_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010885cu)	/* TOM1 TGC1 Internal Trigger Control Register */
#define GTM_TOM2_TGC0_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010901cu)	/* TOM2 TGC0 Internal Trigger Control Register */
#define GTM_TOM2_TGC1_INT_TRIG	(*( GTM_ATOM0_AGC_INT_TRIG_type *) 0xf010905cu)	/* TOM2 TGC1 Internal Trigger Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int OUTEN_CTRL0    : 2;	/* Output (A)TOM_OUT(0) enable/disable update value */
		unsigned int OUTEN_CTRL1    : 2;	/* Output (A)TOM_OUT(1)enable/disable update value */
		unsigned int OUTEN_CTRL2    : 2;	/* Output (A)TOM_OUT(2) enable/disable update value */
		unsigned int OUTEN_CTRL3    : 2;	/* Output (A)TOM_OUT(3) enable/disable update value */
		unsigned int OUTEN_CTRL4    : 2;	/* Output (A)TOM_OUT(4) enable/disable update value */
		unsigned int OUTEN_CTRL5    : 2;	/* Output (A)TOM_OUT(5) enable/disable update value */
		unsigned int OUTEN_CTRL6    : 2;	/* Output (A)TOM_OUT(6) enable/disable update value */
		unsigned int OUTEN_CTRL7    : 2;	/* Output (A)TOM_OUT(7) enable/disable update value */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_AGC_OUTEN_CTRL_type;
#define GTM_ATOM0_AGC_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf010d010u)	/* ATOM0 AGC Output Enable Control Register */
#define GTM_ATOM1_AGC_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf010d810u)	/* ATOM1 AGC Output Enable Control Register */
#define GTM_ATOM2_AGC_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf010e010u)	/* ATOM2 AGC Output Enable Control Register */
#define GTM_ATOM3_AGC_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf010e810u)	/* ATOM3 AGC Output Enable Control Register */
#define GTM_ATOM4_AGC_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf010f010u)	/* ATOM4 AGC Output Enable Control Register */
#define GTM_TOM0_TGC0_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf0108010u)	/* TOM0 TGC0 Output Enable Control Register */
#define GTM_TOM0_TGC1_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf0108050u)	/* TOM0 TGC1 Output Enable Control Register */
#define GTM_TOM1_TGC0_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf0108810u)	/* TOM1 TGC0 Output Enable Control Register */
#define GTM_TOM1_TGC1_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf0108850u)	/* TOM1 TGC1 Output Enable Control Register */
#define GTM_TOM2_TGC0_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf0109010u)	/* TOM2 TGC0 Output Enable Control Register */
#define GTM_TOM2_TGC1_OUTEN_CTRL	(*( GTM_ATOM0_AGC_OUTEN_CTRL_type *) 0xf0109050u)	/* TOM2 TGC1 Output Enable Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int OUTEN_STAT0    : 2;	/* Control/status of output (A)TOM_OUT(0) */
		unsigned int OUTEN_STAT1    : 2;	/* Control/status of output (A)TOM_OUT(1) */
		unsigned int OUTEN_STAT2    : 2;	/* Control/status of output (A)TOM_OUT(2) */
		unsigned int OUTEN_STAT3    : 2;	/* Control/status of output (A)TOM_OUT(3) */
		unsigned int OUTEN_STAT4    : 2;	/* Control/status of output (A)TOM_OUT(4) */
		unsigned int OUTEN_STAT5    : 2;	/* Control/status of output (A)TOM_OUT(5) */
		unsigned int OUTEN_STAT6    : 2;	/* Control/status of output (A)TOM_OUT(6) */
		unsigned int OUTEN_STAT7    : 2;	/* Control/status of output (A)TOM_OUT(7) */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_AGC_OUTEN_STAT_type;
#define GTM_ATOM0_AGC_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf010d014u)	/* ATOM0 AGC Output Enable Status Register */
#define GTM_ATOM1_AGC_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf010d814u)	/* ATOM1 AGC Output Enable Status Register */
#define GTM_ATOM2_AGC_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf010e014u)	/* ATOM2 AGC Output Enable Status Register */
#define GTM_ATOM3_AGC_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf010e814u)	/* ATOM3 AGC Output Enable Status Register */
#define GTM_ATOM4_AGC_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf010f014u)	/* ATOM4 AGC Output Enable Status Register */
#define GTM_TOM0_TGC0_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf0108014u)	/* TOM0 TGC0 Output Enable Status Register */
#define GTM_TOM0_TGC1_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf0108054u)	/* TOM0 TGC1 Output Enable Status Register */
#define GTM_TOM1_TGC0_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf0108814u)	/* TOM1 TGC0 Output Enable Status Register */
#define GTM_TOM1_TGC1_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf0108854u)	/* TOM1 TGC1 Output Enable Status Register */
#define GTM_TOM2_TGC0_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf0109014u)	/* TOM2 TGC0 Output Enable Status Register */
#define GTM_TOM2_TGC1_OUTEN_STAT	(*( GTM_ATOM0_AGC_OUTEN_STAT_type *) 0xf0109054u)	/* TOM2 TGC1 Output Enable Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CM0            : 24;	/* ATOM CCU0 compare register */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_CM0_type;
#define GTM_ATOM0_CH0_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d090u)	/* ATOM0 Channel 0 CCU0 Compare Register */
#define GTM_ATOM0_CH1_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d110u)	/* ATOM0 Channel 1 CCU0 Compare Register */
#define GTM_ATOM0_CH2_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d190u)	/* ATOM0 Channel 2 CCU0 Compare Register */
#define GTM_ATOM0_CH3_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d210u)	/* ATOM0 Channel 3 CCU0 Compare Register */
#define GTM_ATOM0_CH4_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d290u)	/* ATOM0 Channel 4 CCU0 Compare Register */
#define GTM_ATOM0_CH5_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d310u)	/* ATOM0 Channel 5 CCU0 Compare Register */
#define GTM_ATOM0_CH6_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d390u)	/* ATOM0 Channel 6 CCU0 Compare Register */
#define GTM_ATOM0_CH7_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d410u)	/* ATOM0 Channel 7 CCU0 Compare Register */
#define GTM_ATOM1_CH0_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d890u)	/* ATOM1 Channel 0 CCU0 Compare Register */
#define GTM_ATOM1_CH1_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d910u)	/* ATOM1 Channel 1 CCU0 Compare Register */
#define GTM_ATOM1_CH2_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010d990u)	/* ATOM1 Channel 2 CCU0 Compare Register */
#define GTM_ATOM1_CH3_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010da10u)	/* ATOM1 Channel 3 CCU0 Compare Register */
#define GTM_ATOM1_CH4_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010da90u)	/* ATOM1 Channel 4 CCU0 Compare Register */
#define GTM_ATOM1_CH5_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010db10u)	/* ATOM1 Channel 5 CCU0 Compare Register */
#define GTM_ATOM1_CH6_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010db90u)	/* ATOM1 Channel 6 CCU0 Compare Register */
#define GTM_ATOM1_CH7_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010dc10u)	/* ATOM1 Channel 7 CCU0 Compare Register */
#define GTM_ATOM2_CH0_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e090u)	/* ATOM2 Channel 0 CCU0 Compare Register */
#define GTM_ATOM2_CH1_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e110u)	/* ATOM2 Channel 1 CCU0 Compare Register */
#define GTM_ATOM2_CH2_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e190u)	/* ATOM2 Channel 2 CCU0 Compare Register */
#define GTM_ATOM2_CH3_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e210u)	/* ATOM2 Channel 3 CCU0 Compare Register */
#define GTM_ATOM2_CH4_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e290u)	/* ATOM2 Channel 4 CCU0 Compare Register */
#define GTM_ATOM2_CH5_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e310u)	/* ATOM2 Channel 5 CCU0 Compare Register */
#define GTM_ATOM2_CH6_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e390u)	/* ATOM2 Channel 6 CCU0 Compare Register */
#define GTM_ATOM2_CH7_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e410u)	/* ATOM2 Channel 7 CCU0 Compare Register */
#define GTM_ATOM3_CH0_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e890u)	/* ATOM3 Channel 0 CCU0 Compare Register */
#define GTM_ATOM3_CH1_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e910u)	/* ATOM3 Channel 1 CCU0 Compare Register */
#define GTM_ATOM3_CH2_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010e990u)	/* ATOM3 Channel 2 CCU0 Compare Register */
#define GTM_ATOM3_CH3_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010ea10u)	/* ATOM3 Channel 3 CCU0 Compare Register */
#define GTM_ATOM3_CH4_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010ea90u)	/* ATOM3 Channel 4 CCU0 Compare Register */
#define GTM_ATOM3_CH5_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010eb10u)	/* ATOM3 Channel 5 CCU0 Compare Register */
#define GTM_ATOM3_CH6_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010eb90u)	/* ATOM3 Channel 6 CCU0 Compare Register */
#define GTM_ATOM3_CH7_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010ec10u)	/* ATOM3 Channel 7 CCU0 Compare Register */
#define GTM_ATOM4_CH0_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010f090u)	/* ATOM4 Channel 0 CCU0 Compare Register */
#define GTM_ATOM4_CH1_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010f110u)	/* ATOM4 Channel 1 CCU0 Compare Register */
#define GTM_ATOM4_CH2_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010f190u)	/* ATOM4 Channel 2 CCU0 Compare Register */
#define GTM_ATOM4_CH3_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010f210u)	/* ATOM4 Channel 3 CCU0 Compare Register */
#define GTM_ATOM4_CH4_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010f290u)	/* ATOM4 Channel 4 CCU0 Compare Register */
#define GTM_ATOM4_CH5_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010f310u)	/* ATOM4 Channel 5 CCU0 Compare Register */
#define GTM_ATOM4_CH6_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010f390u)	/* ATOM4 Channel 6 CCU0 Compare Register */
#define GTM_ATOM4_CH7_CM0	(*( GTM_ATOM0_CH0_CM0_type *) 0xf010f410u)	/* ATOM4 Channel 7 CCU0 Compare Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CM1            : 24;	/* ATOM CCU1 compare register */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_CM1_type;
#define GTM_ATOM0_CH0_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d098u)	/* ATOM0 Channel 0 CCU1 Compare Register */
#define GTM_ATOM0_CH1_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d118u)	/* ATOM0 Channel 1 CCU1 Compare Register */
#define GTM_ATOM0_CH2_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d198u)	/* ATOM0 Channel 2 CCU1 Compare Register */
#define GTM_ATOM0_CH3_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d218u)	/* ATOM0 Channel 3 CCU1 Compare Register */
#define GTM_ATOM0_CH4_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d298u)	/* ATOM0 Channel 4 CCU1 Compare Register */
#define GTM_ATOM0_CH5_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d318u)	/* ATOM0 Channel 5 CCU1 Compare Register */
#define GTM_ATOM0_CH6_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d398u)	/* ATOM0 Channel 6 CCU1 Compare Register */
#define GTM_ATOM0_CH7_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d418u)	/* ATOM0 Channel 7 CCU1 Compare Register */
#define GTM_ATOM1_CH0_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d898u)	/* ATOM1 Channel 0 CCU1 Compare Register */
#define GTM_ATOM1_CH1_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d918u)	/* ATOM1 Channel 1 CCU1 Compare Register */
#define GTM_ATOM1_CH2_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010d998u)	/* ATOM1 Channel 2 CCU1 Compare Register */
#define GTM_ATOM1_CH3_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010da18u)	/* ATOM1 Channel 3 CCU1 Compare Register */
#define GTM_ATOM1_CH4_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010da98u)	/* ATOM1 Channel 4 CCU1 Compare Register */
#define GTM_ATOM1_CH5_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010db18u)	/* ATOM1 Channel 5 CCU1 Compare Register */
#define GTM_ATOM1_CH6_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010db98u)	/* ATOM1 Channel 6 CCU1 Compare Register */
#define GTM_ATOM1_CH7_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010dc18u)	/* ATOM1 Channel 7 CCU1 Compare Register */
#define GTM_ATOM2_CH0_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e098u)	/* ATOM2 Channel 0 CCU1 Compare Register */
#define GTM_ATOM2_CH1_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e118u)	/* ATOM2 Channel 1 CCU1 Compare Register */
#define GTM_ATOM2_CH2_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e198u)	/* ATOM2 Channel 2 CCU1 Compare Register */
#define GTM_ATOM2_CH3_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e218u)	/* ATOM2 Channel 3 CCU1 Compare Register */
#define GTM_ATOM2_CH4_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e298u)	/* ATOM2 Channel 4 CCU1 Compare Register */
#define GTM_ATOM2_CH5_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e318u)	/* ATOM2 Channel 5 CCU1 Compare Register */
#define GTM_ATOM2_CH6_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e398u)	/* ATOM2 Channel 6 CCU1 Compare Register */
#define GTM_ATOM2_CH7_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e418u)	/* ATOM2 Channel 7 CCU1 Compare Register */
#define GTM_ATOM3_CH0_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e898u)	/* ATOM3 Channel 0 CCU1 Compare Register */
#define GTM_ATOM3_CH1_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e918u)	/* ATOM3 Channel 1 CCU1 Compare Register */
#define GTM_ATOM3_CH2_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010e998u)	/* ATOM3 Channel 2 CCU1 Compare Register */
#define GTM_ATOM3_CH3_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010ea18u)	/* ATOM3 Channel 3 CCU1 Compare Register */
#define GTM_ATOM3_CH4_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010ea98u)	/* ATOM3 Channel 4 CCU1 Compare Register */
#define GTM_ATOM3_CH5_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010eb18u)	/* ATOM3 Channel 5 CCU1 Compare Register */
#define GTM_ATOM3_CH6_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010eb98u)	/* ATOM3 Channel 6 CCU1 Compare Register */
#define GTM_ATOM3_CH7_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010ec18u)	/* ATOM3 Channel 7 CCU1 Compare Register */
#define GTM_ATOM4_CH0_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010f098u)	/* ATOM4 Channel 0 CCU1 Compare Register */
#define GTM_ATOM4_CH1_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010f118u)	/* ATOM4 Channel 1 CCU1 Compare Register */
#define GTM_ATOM4_CH2_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010f198u)	/* ATOM4 Channel 2 CCU1 Compare Register */
#define GTM_ATOM4_CH3_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010f218u)	/* ATOM4 Channel 3 CCU1 Compare Register */
#define GTM_ATOM4_CH4_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010f298u)	/* ATOM4 Channel 4 CCU1 Compare Register */
#define GTM_ATOM4_CH5_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010f318u)	/* ATOM4 Channel 5 CCU1 Compare Register */
#define GTM_ATOM4_CH6_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010f398u)	/* ATOM4 Channel 6 CCU1 Compare Register */
#define GTM_ATOM4_CH7_CM1	(*( GTM_ATOM0_CH0_CM1_type *) 0xf010f418u)	/* ATOM4 Channel 7 CCU1 Compare Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CN0            : 24;	/* ATOM CCU0 counter register */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_CN0_type;
#define GTM_ATOM0_CH0_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d08cu)	/* ATOM0 Channel 0 CCU0 Counter Register */
#define GTM_ATOM0_CH1_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d10cu)	/* ATOM0 Channel 1 CCU0 Counter Register */
#define GTM_ATOM0_CH2_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d18cu)	/* ATOM0 Channel 2 CCU0 Counter Register */
#define GTM_ATOM0_CH3_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d20cu)	/* ATOM0 Channel 3 CCU0 Counter Register */
#define GTM_ATOM0_CH4_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d28cu)	/* ATOM0 Channel 4 CCU0 Counter Register */
#define GTM_ATOM0_CH5_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d30cu)	/* ATOM0 Channel 5 CCU0 Counter Register */
#define GTM_ATOM0_CH6_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d38cu)	/* ATOM0 Channel 6 CCU0 Counter Register */
#define GTM_ATOM0_CH7_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d40cu)	/* ATOM0 Channel 7 CCU0 Counter Register */
#define GTM_ATOM1_CH0_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d88cu)	/* ATOM1 Channel 0 CCU0 Counter Register */
#define GTM_ATOM1_CH1_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d90cu)	/* ATOM1 Channel 1 CCU0 Counter Register */
#define GTM_ATOM1_CH2_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010d98cu)	/* ATOM1 Channel 2 CCU0 Counter Register */
#define GTM_ATOM1_CH3_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010da0cu)	/* ATOM1 Channel 3 CCU0 Counter Register */
#define GTM_ATOM1_CH4_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010da8cu)	/* ATOM1 Channel 4 CCU0 Counter Register */
#define GTM_ATOM1_CH5_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010db0cu)	/* ATOM1 Channel 5 CCU0 Counter Register */
#define GTM_ATOM1_CH6_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010db8cu)	/* ATOM1 Channel 6 CCU0 Counter Register */
#define GTM_ATOM1_CH7_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010dc0cu)	/* ATOM1 Channel 7 CCU0 Counter Register */
#define GTM_ATOM2_CH0_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e08cu)	/* ATOM2 Channel 0 CCU0 Counter Register */
#define GTM_ATOM2_CH1_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e10cu)	/* ATOM2 Channel 1 CCU0 Counter Register */
#define GTM_ATOM2_CH2_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e18cu)	/* ATOM2 Channel 2 CCU0 Counter Register */
#define GTM_ATOM2_CH3_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e20cu)	/* ATOM2 Channel 3 CCU0 Counter Register */
#define GTM_ATOM2_CH4_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e28cu)	/* ATOM2 Channel 4 CCU0 Counter Register */
#define GTM_ATOM2_CH5_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e30cu)	/* ATOM2 Channel 5 CCU0 Counter Register */
#define GTM_ATOM2_CH6_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e38cu)	/* ATOM2 Channel 6 CCU0 Counter Register */
#define GTM_ATOM2_CH7_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e40cu)	/* ATOM2 Channel 7 CCU0 Counter Register */
#define GTM_ATOM3_CH0_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e88cu)	/* ATOM3 Channel 0 CCU0 Counter Register */
#define GTM_ATOM3_CH1_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e90cu)	/* ATOM3 Channel 1 CCU0 Counter Register */
#define GTM_ATOM3_CH2_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010e98cu)	/* ATOM3 Channel 2 CCU0 Counter Register */
#define GTM_ATOM3_CH3_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010ea0cu)	/* ATOM3 Channel 3 CCU0 Counter Register */
#define GTM_ATOM3_CH4_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010ea8cu)	/* ATOM3 Channel 4 CCU0 Counter Register */
#define GTM_ATOM3_CH5_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010eb0cu)	/* ATOM3 Channel 5 CCU0 Counter Register */
#define GTM_ATOM3_CH6_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010eb8cu)	/* ATOM3 Channel 6 CCU0 Counter Register */
#define GTM_ATOM3_CH7_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010ec0cu)	/* ATOM3 Channel 7 CCU0 Counter Register */
#define GTM_ATOM4_CH0_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010f08cu)	/* ATOM4 Channel 0 CCU0 Counter Register */
#define GTM_ATOM4_CH1_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010f10cu)	/* ATOM4 Channel 1 CCU0 Counter Register */
#define GTM_ATOM4_CH2_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010f18cu)	/* ATOM4 Channel 2 CCU0 Counter Register */
#define GTM_ATOM4_CH3_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010f20cu)	/* ATOM4 Channel 3 CCU0 Counter Register */
#define GTM_ATOM4_CH4_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010f28cu)	/* ATOM4 Channel 4 CCU0 Counter Register */
#define GTM_ATOM4_CH5_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010f30cu)	/* ATOM4 Channel 5 CCU0 Counter Register */
#define GTM_ATOM4_CH6_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010f38cu)	/* ATOM4 Channel 6 CCU0 Counter Register */
#define GTM_ATOM4_CH7_CN0	(*( GTM_ATOM0_CH0_CN0_type *) 0xf010f40cu)	/* ATOM4 Channel 7 CCU0 Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MODE           : 2;	/* ATOM channel mode select */
		unsigned int TB12_SEL       : 1;	/* Select time base value TBU_TS1 or TBU_TS2. */
		unsigned int ARU_EN         : 1;	/* ARU Input stream enable */
		unsigned int ACB            : 5;	/* ATOM Mode control bits */
		unsigned int CMP_CTRL       : 1;	/* CCUx compare strategy select */
		/* const */ unsigned int Reserved       : 1;	/* Reserved */
		unsigned int SL             : 1;	/* Initial signal level */
		unsigned int CLK_SRC        : 3;	/* actual CMU clock source (SOMS)/ shadow register for CMU clock source (SOMP) */
		/* const */ unsigned int Reserved_9     : 1;	/* Reserved */
		unsigned int WR_REQ         : 1;	/* CPU Write request bit for late compare register update */
		/* const */ unsigned int Reserved_11    : 3;	/* Reserved */
		unsigned int RST_CCU0       : 1;	/* Reset source of CCU0 */
		/* const */ unsigned int Reserved_13    : 3;	/* Reserved */
		unsigned int TRIGOUT        : 1;	/* Trigger output selection (output signal TRIG_CHx) of module ATOM_CHx. */
		unsigned int SLA            : 1;	/* Serve last ARU communication strategy */
		unsigned int OSM            : 1;	/* One-shot mode */
		unsigned int ABM            : 1;	/* ARU blocking mode */
		/* const */ unsigned int Reserved_18    : 4;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_CTRL_type;
#define GTM_ATOM0_CH0_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d080u)	/* ATOM0 Channel 0 Control Register */
#define GTM_ATOM0_CH1_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d100u)	/* ATOM0 Channel 1 Control Register */
#define GTM_ATOM0_CH2_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d180u)	/* ATOM0 Channel 2 Control Register */
#define GTM_ATOM0_CH3_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d200u)	/* ATOM0 Channel 3 Control Register */
#define GTM_ATOM0_CH4_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d280u)	/* ATOM0 Channel 4 Control Register */
#define GTM_ATOM0_CH5_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d300u)	/* ATOM0 Channel 5 Control Register */
#define GTM_ATOM0_CH6_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d380u)	/* ATOM0 Channel 6 Control Register */
#define GTM_ATOM0_CH7_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d400u)	/* ATOM0 Channel 7 Control Register */
#define GTM_ATOM1_CH0_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d880u)	/* ATOM1 Channel 0 Control Register */
#define GTM_ATOM1_CH1_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d900u)	/* ATOM1 Channel 1 Control Register */
#define GTM_ATOM1_CH2_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010d980u)	/* ATOM1 Channel 2 Control Register */
#define GTM_ATOM1_CH3_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010da00u)	/* ATOM1 Channel 3 Control Register */
#define GTM_ATOM1_CH4_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010da80u)	/* ATOM1 Channel 4 Control Register */
#define GTM_ATOM1_CH5_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010db00u)	/* ATOM1 Channel 5 Control Register */
#define GTM_ATOM1_CH6_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010db80u)	/* ATOM1 Channel 6 Control Register */
#define GTM_ATOM1_CH7_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010dc00u)	/* ATOM1 Channel 7 Control Register */
#define GTM_ATOM2_CH0_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e080u)	/* ATOM2 Channel 0 Control Register */
#define GTM_ATOM2_CH1_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e100u)	/* ATOM2 Channel 1 Control Register */
#define GTM_ATOM2_CH2_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e180u)	/* ATOM2 Channel 2 Control Register */
#define GTM_ATOM2_CH3_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e200u)	/* ATOM2 Channel 3 Control Register */
#define GTM_ATOM2_CH4_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e280u)	/* ATOM2 Channel 4 Control Register */
#define GTM_ATOM2_CH5_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e300u)	/* ATOM2 Channel 5 Control Register */
#define GTM_ATOM2_CH6_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e380u)	/* ATOM2 Channel 6 Control Register */
#define GTM_ATOM2_CH7_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e400u)	/* ATOM2 Channel 7 Control Register */
#define GTM_ATOM3_CH0_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e880u)	/* ATOM3 Channel 0 Control Register */
#define GTM_ATOM3_CH1_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e900u)	/* ATOM3 Channel 1 Control Register */
#define GTM_ATOM3_CH2_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010e980u)	/* ATOM3 Channel 2 Control Register */
#define GTM_ATOM3_CH3_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010ea00u)	/* ATOM3 Channel 3 Control Register */
#define GTM_ATOM3_CH4_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010ea80u)	/* ATOM3 Channel 4 Control Register */
#define GTM_ATOM3_CH5_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010eb00u)	/* ATOM3 Channel 5 Control Register */
#define GTM_ATOM3_CH6_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010eb80u)	/* ATOM3 Channel 6 Control Register */
#define GTM_ATOM3_CH7_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010ec00u)	/* ATOM3 Channel 7 Control Register */
#define GTM_ATOM4_CH0_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010f080u)	/* ATOM4 Channel 0 Control Register */
#define GTM_ATOM4_CH1_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010f100u)	/* ATOM4 Channel 1 Control Register */
#define GTM_ATOM4_CH2_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010f180u)	/* ATOM4 Channel 2 Control Register */
#define GTM_ATOM4_CH3_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010f200u)	/* ATOM4 Channel 3 Control Register */
#define GTM_ATOM4_CH4_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010f280u)	/* ATOM4 Channel 4 Control Register */
#define GTM_ATOM4_CH5_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010f300u)	/* ATOM4 Channel 5 Control Register */
#define GTM_ATOM4_CH6_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010f380u)	/* ATOM4 Channel 6 Control Register */
#define GTM_ATOM4_CH7_CTRL	(*( GTM_ATOM0_CH0_CTRL_type *) 0xf010f400u)	/* ATOM4 Channel 7 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CCU0TC_IRQ_EN  : 1;	/* ATOM_CCU0TC_IRQ interrupt enable */
		unsigned int CCU1TC_IRQ_EN  : 1;	/* ATOM_CCU1TC_IRQ interrupt enable */
		/* const */ unsigned int Reserved       : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_IRQ_EN_type;
#define GTM_ATOM0_CH0_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d0a4u)	/* ATOM0 Channel 0 Interrupt Enable Register */
#define GTM_ATOM0_CH1_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d124u)	/* ATOM0 Channel 1 Interrupt Enable Register */
#define GTM_ATOM0_CH2_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d1a4u)	/* ATOM0 Channel 2 Interrupt Enable Register */
#define GTM_ATOM0_CH3_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d224u)	/* ATOM0 Channel 3 Interrupt Enable Register */
#define GTM_ATOM0_CH4_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d2a4u)	/* ATOM0 Channel 4 Interrupt Enable Register */
#define GTM_ATOM0_CH5_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d324u)	/* ATOM0 Channel 5 Interrupt Enable Register */
#define GTM_ATOM0_CH6_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d3a4u)	/* ATOM0 Channel 6 Interrupt Enable Register */
#define GTM_ATOM0_CH7_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d424u)	/* ATOM0 Channel 7 Interrupt Enable Register */
#define GTM_ATOM1_CH0_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d8a4u)	/* ATOM1 Channel 0 Interrupt Enable Register */
#define GTM_ATOM1_CH1_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d924u)	/* ATOM1 Channel 1 Interrupt Enable Register */
#define GTM_ATOM1_CH2_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010d9a4u)	/* ATOM1 Channel 2 Interrupt Enable Register */
#define GTM_ATOM1_CH3_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010da24u)	/* ATOM1 Channel 3 Interrupt Enable Register */
#define GTM_ATOM1_CH4_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010daa4u)	/* ATOM1 Channel 4 Interrupt Enable Register */
#define GTM_ATOM1_CH5_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010db24u)	/* ATOM1 Channel 5 Interrupt Enable Register */
#define GTM_ATOM1_CH6_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010dba4u)	/* ATOM1 Channel 6 Interrupt Enable Register */
#define GTM_ATOM1_CH7_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010dc24u)	/* ATOM1 Channel 7 Interrupt Enable Register */
#define GTM_ATOM2_CH0_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e0a4u)	/* ATOM2 Channel 0 Interrupt Enable Register */
#define GTM_ATOM2_CH1_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e124u)	/* ATOM2 Channel 1 Interrupt Enable Register */
#define GTM_ATOM2_CH2_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e1a4u)	/* ATOM2 Channel 2 Interrupt Enable Register */
#define GTM_ATOM2_CH3_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e224u)	/* ATOM2 Channel 3 Interrupt Enable Register */
#define GTM_ATOM2_CH4_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e2a4u)	/* ATOM2 Channel 4 Interrupt Enable Register */
#define GTM_ATOM2_CH5_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e324u)	/* ATOM2 Channel 5 Interrupt Enable Register */
#define GTM_ATOM2_CH6_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e3a4u)	/* ATOM2 Channel 6 Interrupt Enable Register */
#define GTM_ATOM2_CH7_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e424u)	/* ATOM2 Channel 7 Interrupt Enable Register */
#define GTM_ATOM3_CH0_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e8a4u)	/* ATOM3 Channel 0 Interrupt Enable Register */
#define GTM_ATOM3_CH1_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e924u)	/* ATOM3 Channel 1 Interrupt Enable Register */
#define GTM_ATOM3_CH2_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010e9a4u)	/* ATOM3 Channel 2 Interrupt Enable Register */
#define GTM_ATOM3_CH3_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010ea24u)	/* ATOM3 Channel 3 Interrupt Enable Register */
#define GTM_ATOM3_CH4_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010eaa4u)	/* ATOM3 Channel 4 Interrupt Enable Register */
#define GTM_ATOM3_CH5_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010eb24u)	/* ATOM3 Channel 5 Interrupt Enable Register */
#define GTM_ATOM3_CH6_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010eba4u)	/* ATOM3 Channel 6 Interrupt Enable Register */
#define GTM_ATOM3_CH7_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010ec24u)	/* ATOM3 Channel 7 Interrupt Enable Register */
#define GTM_ATOM4_CH0_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010f0a4u)	/* ATOM4 Channel 0 Interrupt Enable Register */
#define GTM_ATOM4_CH1_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010f124u)	/* ATOM4 Channel 1 Interrupt Enable Register */
#define GTM_ATOM4_CH2_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010f1a4u)	/* ATOM4 Channel 2 Interrupt Enable Register */
#define GTM_ATOM4_CH3_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010f224u)	/* ATOM4 Channel 3 Interrupt Enable Register */
#define GTM_ATOM4_CH4_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010f2a4u)	/* ATOM4 Channel 4 Interrupt Enable Register */
#define GTM_ATOM4_CH5_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010f324u)	/* ATOM4 Channel 5 Interrupt Enable Register */
#define GTM_ATOM4_CH6_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010f3a4u)	/* ATOM4 Channel 6 Interrupt Enable Register */
#define GTM_ATOM4_CH7_IRQ_EN	(*( GTM_ATOM0_CH0_IRQ_EN_type *) 0xf010f424u)	/* ATOM4 Channel 7 Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_CCU0TC     : 1;	/* Trigger ATOM_CCU0TC_IRQ interrupt by software */
		unsigned int TRG_CCU1TC     : 1;	/* Trigger ATOM_CCU1TC_IRQ interrupt by software */
		/* const */ unsigned int Reserved       : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_IRQ_FORCINT_type;
#define GTM_ATOM0_CH0_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d0a8u)	/* ATOM0 Channel 0 Software Interrupt Generation Register */
#define GTM_ATOM0_CH1_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d128u)	/* ATOM0 Channel 1 Software Interrupt Generation Register */
#define GTM_ATOM0_CH2_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d1a8u)	/* ATOM0 Channel 2 Software Interrupt Generation Register */
#define GTM_ATOM0_CH3_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d228u)	/* ATOM0 Channel 3 Software Interrupt Generation Register */
#define GTM_ATOM0_CH4_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d2a8u)	/* ATOM0 Channel 4 Software Interrupt Generation Register */
#define GTM_ATOM0_CH5_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d328u)	/* ATOM0 Channel 5 Software Interrupt Generation Register */
#define GTM_ATOM0_CH6_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d3a8u)	/* ATOM0 Channel 6 Software Interrupt Generation Register */
#define GTM_ATOM0_CH7_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d428u)	/* ATOM0 Channel 7 Software Interrupt Generation Register */
#define GTM_ATOM1_CH0_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d8a8u)	/* ATOM1 Channel 0 Software Interrupt Generation Register */
#define GTM_ATOM1_CH1_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d928u)	/* ATOM1 Channel 1 Software Interrupt Generation Register */
#define GTM_ATOM1_CH2_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010d9a8u)	/* ATOM1 Channel 2 Software Interrupt Generation Register */
#define GTM_ATOM1_CH3_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010da28u)	/* ATOM1 Channel 3 Software Interrupt Generation Register */
#define GTM_ATOM1_CH4_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010daa8u)	/* ATOM1 Channel 4 Software Interrupt Generation Register */
#define GTM_ATOM1_CH5_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010db28u)	/* ATOM1 Channel 5 Software Interrupt Generation Register */
#define GTM_ATOM1_CH6_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010dba8u)	/* ATOM1 Channel 6 Software Interrupt Generation Register */
#define GTM_ATOM1_CH7_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010dc28u)	/* ATOM1 Channel 7 Software Interrupt Generation Register */
#define GTM_ATOM2_CH0_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e0a8u)	/* ATOM2 Channel 0 Software Interrupt Generation Register */
#define GTM_ATOM2_CH1_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e128u)	/* ATOM2 Channel 1 Software Interrupt Generation Register */
#define GTM_ATOM2_CH2_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e1a8u)	/* ATOM2 Channel 2 Software Interrupt Generation Register */
#define GTM_ATOM2_CH3_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e228u)	/* ATOM2 Channel 3 Software Interrupt Generation Register */
#define GTM_ATOM2_CH4_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e2a8u)	/* ATOM2 Channel 4 Software Interrupt Generation Register */
#define GTM_ATOM2_CH5_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e328u)	/* ATOM2 Channel 5 Software Interrupt Generation Register */
#define GTM_ATOM2_CH6_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e3a8u)	/* ATOM2 Channel 6 Software Interrupt Generation Register */
#define GTM_ATOM2_CH7_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e428u)	/* ATOM2 Channel 7 Software Interrupt Generation Register */
#define GTM_ATOM3_CH0_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e8a8u)	/* ATOM3 Channel 0 Software Interrupt Generation Register */
#define GTM_ATOM3_CH1_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e928u)	/* ATOM3 Channel 1 Software Interrupt Generation Register */
#define GTM_ATOM3_CH2_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010e9a8u)	/* ATOM3 Channel 2 Software Interrupt Generation Register */
#define GTM_ATOM3_CH3_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010ea28u)	/* ATOM3 Channel 3 Software Interrupt Generation Register */
#define GTM_ATOM3_CH4_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010eaa8u)	/* ATOM3 Channel 4 Software Interrupt Generation Register */
#define GTM_ATOM3_CH5_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010eb28u)	/* ATOM3 Channel 5 Software Interrupt Generation Register */
#define GTM_ATOM3_CH6_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010eba8u)	/* ATOM3 Channel 6 Software Interrupt Generation Register */
#define GTM_ATOM3_CH7_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010ec28u)	/* ATOM3 Channel 7 Software Interrupt Generation Register */
#define GTM_ATOM4_CH0_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010f0a8u)	/* ATOM4 Channel 0 Software Interrupt Generation Register */
#define GTM_ATOM4_CH1_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010f128u)	/* ATOM4 Channel 1 Software Interrupt Generation Register */
#define GTM_ATOM4_CH2_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010f1a8u)	/* ATOM4 Channel 2 Software Interrupt Generation Register */
#define GTM_ATOM4_CH3_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010f228u)	/* ATOM4 Channel 3 Software Interrupt Generation Register */
#define GTM_ATOM4_CH4_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010f2a8u)	/* ATOM4 Channel 4 Software Interrupt Generation Register */
#define GTM_ATOM4_CH5_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010f328u)	/* ATOM4 Channel 5 Software Interrupt Generation Register */
#define GTM_ATOM4_CH6_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010f3a8u)	/* ATOM4 Channel 6 Software Interrupt Generation Register */
#define GTM_ATOM4_CH7_IRQ_FORCINT	(*( GTM_ATOM0_CH0_IRQ_FORCINT_type *) 0xf010f428u)	/* ATOM4 Channel 7 Software Interrupt Generation Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CCU0TC         : 1;	/* CCU0 Trigger condition interrupt for channel x */
		unsigned int CCU1TC         : 1;	/* CCU1 Trigger condition interrupt for channel x */
		/* const */ unsigned int Reserved       : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_IRQ_NOTIFY_type;
#define GTM_ATOM0_CH0_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d0a0u)	/* ATOM0 Channel 0 Interrupt Notification Register */
#define GTM_ATOM0_CH1_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d120u)	/* ATOM0 Channel 1 Interrupt Notification Register */
#define GTM_ATOM0_CH2_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d1a0u)	/* ATOM0 Channel 2 Interrupt Notification Register */
#define GTM_ATOM0_CH3_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d220u)	/* ATOM0 Channel 3 Interrupt Notification Register */
#define GTM_ATOM0_CH4_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d2a0u)	/* ATOM0 Channel 4 Interrupt Notification Register */
#define GTM_ATOM0_CH5_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d320u)	/* ATOM0 Channel 5 Interrupt Notification Register */
#define GTM_ATOM0_CH6_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d3a0u)	/* ATOM0 Channel 6 Interrupt Notification Register */
#define GTM_ATOM0_CH7_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d420u)	/* ATOM0 Channel 7 Interrupt Notification Register */
#define GTM_ATOM1_CH0_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d8a0u)	/* ATOM1 Channel 0 Interrupt Notification Register */
#define GTM_ATOM1_CH1_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d920u)	/* ATOM1 Channel 1 Interrupt Notification Register */
#define GTM_ATOM1_CH2_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010d9a0u)	/* ATOM1 Channel 2 Interrupt Notification Register */
#define GTM_ATOM1_CH3_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010da20u)	/* ATOM1 Channel 3 Interrupt Notification Register */
#define GTM_ATOM1_CH4_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010daa0u)	/* ATOM1 Channel 4 Interrupt Notification Register */
#define GTM_ATOM1_CH5_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010db20u)	/* ATOM1 Channel 5 Interrupt Notification Register */
#define GTM_ATOM1_CH6_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010dba0u)	/* ATOM1 Channel 6 Interrupt Notification Register */
#define GTM_ATOM1_CH7_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010dc20u)	/* ATOM1 Channel 7 Interrupt Notification Register */
#define GTM_ATOM2_CH0_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e0a0u)	/* ATOM2 Channel 0 Interrupt Notification Register */
#define GTM_ATOM2_CH1_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e120u)	/* ATOM2 Channel 1 Interrupt Notification Register */
#define GTM_ATOM2_CH2_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e1a0u)	/* ATOM2 Channel 2 Interrupt Notification Register */
#define GTM_ATOM2_CH3_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e220u)	/* ATOM2 Channel 3 Interrupt Notification Register */
#define GTM_ATOM2_CH4_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e2a0u)	/* ATOM2 Channel 4 Interrupt Notification Register */
#define GTM_ATOM2_CH5_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e320u)	/* ATOM2 Channel 5 Interrupt Notification Register */
#define GTM_ATOM2_CH6_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e3a0u)	/* ATOM2 Channel 6 Interrupt Notification Register */
#define GTM_ATOM2_CH7_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e420u)	/* ATOM2 Channel 7 Interrupt Notification Register */
#define GTM_ATOM3_CH0_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e8a0u)	/* ATOM3 Channel 0 Interrupt Notification Register */
#define GTM_ATOM3_CH1_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e920u)	/* ATOM3 Channel 1 Interrupt Notification Register */
#define GTM_ATOM3_CH2_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010e9a0u)	/* ATOM3 Channel 2 Interrupt Notification Register */
#define GTM_ATOM3_CH3_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010ea20u)	/* ATOM3 Channel 3 Interrupt Notification Register */
#define GTM_ATOM3_CH4_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010eaa0u)	/* ATOM3 Channel 4 Interrupt Notification Register */
#define GTM_ATOM3_CH5_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010eb20u)	/* ATOM3 Channel 5 Interrupt Notification Register */
#define GTM_ATOM3_CH6_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010eba0u)	/* ATOM3 Channel 6 Interrupt Notification Register */
#define GTM_ATOM3_CH7_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010ec20u)	/* ATOM3 Channel 7 Interrupt Notification Register */
#define GTM_ATOM4_CH0_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010f0a0u)	/* ATOM4 Channel 0 Interrupt Notification Register */
#define GTM_ATOM4_CH1_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010f120u)	/* ATOM4 Channel 1 Interrupt Notification Register */
#define GTM_ATOM4_CH2_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010f1a0u)	/* ATOM4 Channel 2 Interrupt Notification Register */
#define GTM_ATOM4_CH3_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010f220u)	/* ATOM4 Channel 3 Interrupt Notification Register */
#define GTM_ATOM4_CH4_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010f2a0u)	/* ATOM4 Channel 4 Interrupt Notification Register */
#define GTM_ATOM4_CH5_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010f320u)	/* ATOM4 Channel 5 Interrupt Notification Register */
#define GTM_ATOM4_CH6_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010f3a0u)	/* ATOM4 Channel 6 Interrupt Notification Register */
#define GTM_ATOM4_CH7_IRQ_NOTIFY	(*( GTM_ATOM0_CH0_IRQ_NOTIFY_type *) 0xf010f420u)	/* ATOM4 Channel 7 Interrupt Notification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RDADDR0        : 9;	/* ARU Read address 0 */
		/* const */ unsigned int Reserved       : 7;	/* Read as zero, should be written as zero */
		unsigned int RDADDR1        : 9;	/* ARU Read address 1 */
		/* const */ unsigned int Reserved_4     : 7;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_RDADDR_type;
#define GTM_ATOM0_CH0_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d088u)	/* ATOM0 Channel 0 ARU Read Address Register */
#define GTM_ATOM0_CH1_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d108u)	/* ATOM0 Channel 1 ARU Read Address Register */
#define GTM_ATOM0_CH2_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d188u)	/* ATOM0 Channel 2 ARU Read Address Register */
#define GTM_ATOM0_CH3_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d208u)	/* ATOM0 Channel 3 ARU Read Address Register */
#define GTM_ATOM0_CH4_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d288u)	/* ATOM0 Channel 4 ARU Read Address Register */
#define GTM_ATOM0_CH5_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d308u)	/* ATOM0 Channel 5 ARU Read Address Register */
#define GTM_ATOM0_CH6_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d388u)	/* ATOM0 Channel 6 ARU Read Address Register */
#define GTM_ATOM0_CH7_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d408u)	/* ATOM0 Channel 7 ARU Read Address Register */
#define GTM_ATOM1_CH0_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d888u)	/* ATOM1 Channel 0 ARU Read Address Register */
#define GTM_ATOM1_CH1_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d908u)	/* ATOM1 Channel 1 ARU Read Address Register */
#define GTM_ATOM1_CH2_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010d988u)	/* ATOM1 Channel 2 ARU Read Address Register */
#define GTM_ATOM1_CH3_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010da08u)	/* ATOM1 Channel 3 ARU Read Address Register */
#define GTM_ATOM1_CH4_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010da88u)	/* ATOM1 Channel 4 ARU Read Address Register */
#define GTM_ATOM1_CH5_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010db08u)	/* ATOM1 Channel 5 ARU Read Address Register */
#define GTM_ATOM1_CH6_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010db88u)	/* ATOM1 Channel 6 ARU Read Address Register */
#define GTM_ATOM1_CH7_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010dc08u)	/* ATOM1 Channel 7 ARU Read Address Register */
#define GTM_ATOM2_CH0_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e088u)	/* ATOM2 Channel 0 ARU Read Address Register */
#define GTM_ATOM2_CH1_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e108u)	/* ATOM2 Channel 1 ARU Read Address Register */
#define GTM_ATOM2_CH2_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e188u)	/* ATOM2 Channel 2 ARU Read Address Register */
#define GTM_ATOM2_CH3_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e208u)	/* ATOM2 Channel 3 ARU Read Address Register */
#define GTM_ATOM2_CH4_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e288u)	/* ATOM2 Channel 4 ARU Read Address Register */
#define GTM_ATOM2_CH5_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e308u)	/* ATOM2 Channel 5 ARU Read Address Register */
#define GTM_ATOM2_CH6_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e388u)	/* ATOM2 Channel 6 ARU Read Address Register */
#define GTM_ATOM2_CH7_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e408u)	/* ATOM2 Channel 7 ARU Read Address Register */
#define GTM_ATOM3_CH0_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e888u)	/* ATOM3 Channel 0 ARU Read Address Register */
#define GTM_ATOM3_CH1_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e908u)	/* ATOM3 Channel 1 ARU Read Address Register */
#define GTM_ATOM3_CH2_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010e988u)	/* ATOM3 Channel 2 ARU Read Address Register */
#define GTM_ATOM3_CH3_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010ea08u)	/* ATOM3 Channel 3 ARU Read Address Register */
#define GTM_ATOM3_CH4_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010ea88u)	/* ATOM3 Channel 4 ARU Read Address Register */
#define GTM_ATOM3_CH5_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010eb08u)	/* ATOM3 Channel 5 ARU Read Address Register */
#define GTM_ATOM3_CH6_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010eb88u)	/* ATOM3 Channel 6 ARU Read Address Register */
#define GTM_ATOM3_CH7_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010ec08u)	/* ATOM3 Channel 7 ARU Read Address Register */
#define GTM_ATOM4_CH0_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010f088u)	/* ATOM4 Channel 0 ARU Read Address Register */
#define GTM_ATOM4_CH1_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010f108u)	/* ATOM4 Channel 1 ARU Read Address Register */
#define GTM_ATOM4_CH2_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010f188u)	/* ATOM4 Channel 2 ARU Read Address Register */
#define GTM_ATOM4_CH3_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010f208u)	/* ATOM4 Channel 3 ARU Read Address Register */
#define GTM_ATOM4_CH4_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010f288u)	/* ATOM4 Channel 4 ARU Read Address Register */
#define GTM_ATOM4_CH5_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010f308u)	/* ATOM4 Channel 5 ARU Read Address Register */
#define GTM_ATOM4_CH6_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010f388u)	/* ATOM4 Channel 6 ARU Read Address Register */
#define GTM_ATOM4_CH7_RDADDR	(*( GTM_ATOM0_CH0_RDADDR_type *) 0xf010f408u)	/* ATOM4 Channel 7 ARU Read Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SR0            : 24;	/* ATOM channel x shadow register SR0 */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_SR0_type;
#define GTM_ATOM0_CH0_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d094u)	/* ATOM0 Channel 0 CCU0 Compare Shadow Register */
#define GTM_ATOM0_CH1_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d114u)	/* ATOM0 Channel 1 CCU0 Compare Shadow Register */
#define GTM_ATOM0_CH2_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d194u)	/* ATOM0 Channel 2 CCU0 Compare Shadow Register */
#define GTM_ATOM0_CH3_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d214u)	/* ATOM0 Channel 3 CCU0 Compare Shadow Register */
#define GTM_ATOM0_CH4_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d294u)	/* ATOM0 Channel 4 CCU0 Compare Shadow Register */
#define GTM_ATOM0_CH5_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d314u)	/* ATOM0 Channel 5 CCU0 Compare Shadow Register */
#define GTM_ATOM0_CH6_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d394u)	/* ATOM0 Channel 6 CCU0 Compare Shadow Register */
#define GTM_ATOM0_CH7_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d414u)	/* ATOM0 Channel 7 CCU0 Compare Shadow Register */
#define GTM_ATOM1_CH0_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d894u)	/* ATOM1 Channel 0 CCU0 Compare Shadow Register */
#define GTM_ATOM1_CH1_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d914u)	/* ATOM1 Channel 1 CCU0 Compare Shadow Register */
#define GTM_ATOM1_CH2_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010d994u)	/* ATOM1 Channel 2 CCU0 Compare Shadow Register */
#define GTM_ATOM1_CH3_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010da14u)	/* ATOM1 Channel 3 CCU0 Compare Shadow Register */
#define GTM_ATOM1_CH4_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010da94u)	/* ATOM1 Channel 4 CCU0 Compare Shadow Register */
#define GTM_ATOM1_CH5_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010db14u)	/* ATOM1 Channel 5 CCU0 Compare Shadow Register */
#define GTM_ATOM1_CH6_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010db94u)	/* ATOM1 Channel 6 CCU0 Compare Shadow Register */
#define GTM_ATOM1_CH7_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010dc14u)	/* ATOM1 Channel 7 CCU0 Compare Shadow Register */
#define GTM_ATOM2_CH0_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e094u)	/* ATOM2 Channel 0 CCU0 Compare Shadow Register */
#define GTM_ATOM2_CH1_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e114u)	/* ATOM2 Channel 1 CCU0 Compare Shadow Register */
#define GTM_ATOM2_CH2_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e194u)	/* ATOM2 Channel 2 CCU0 Compare Shadow Register */
#define GTM_ATOM2_CH3_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e214u)	/* ATOM2 Channel 3 CCU0 Compare Shadow Register */
#define GTM_ATOM2_CH4_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e294u)	/* ATOM2 Channel 4 CCU0 Compare Shadow Register */
#define GTM_ATOM2_CH5_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e314u)	/* ATOM2 Channel 5 CCU0 Compare Shadow Register */
#define GTM_ATOM2_CH6_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e394u)	/* ATOM2 Channel 6 CCU0 Compare Shadow Register */
#define GTM_ATOM2_CH7_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e414u)	/* ATOM2 Channel 7 CCU0 Compare Shadow Register */
#define GTM_ATOM3_CH0_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e894u)	/* ATOM3 Channel 0 CCU0 Compare Shadow Register */
#define GTM_ATOM3_CH1_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e914u)	/* ATOM3 Channel 1 CCU0 Compare Shadow Register */
#define GTM_ATOM3_CH2_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010e994u)	/* ATOM3 Channel 2 CCU0 Compare Shadow Register */
#define GTM_ATOM3_CH3_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010ea14u)	/* ATOM3 Channel 3 CCU0 Compare Shadow Register */
#define GTM_ATOM3_CH4_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010ea94u)	/* ATOM3 Channel 4 CCU0 Compare Shadow Register */
#define GTM_ATOM3_CH5_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010eb14u)	/* ATOM3 Channel 5 CCU0 Compare Shadow Register */
#define GTM_ATOM3_CH6_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010eb94u)	/* ATOM3 Channel 6 CCU0 Compare Shadow Register */
#define GTM_ATOM3_CH7_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010ec14u)	/* ATOM3 Channel 7 CCU0 Compare Shadow Register */
#define GTM_ATOM4_CH0_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010f094u)	/* ATOM4 Channel 0 CCU0 Compare Shadow Register */
#define GTM_ATOM4_CH1_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010f114u)	/* ATOM4 Channel 1 CCU0 Compare Shadow Register */
#define GTM_ATOM4_CH2_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010f194u)	/* ATOM4 Channel 2 CCU0 Compare Shadow Register */
#define GTM_ATOM4_CH3_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010f214u)	/* ATOM4 Channel 3 CCU0 Compare Shadow Register */
#define GTM_ATOM4_CH4_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010f294u)	/* ATOM4 Channel 4 CCU0 Compare Shadow Register */
#define GTM_ATOM4_CH5_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010f314u)	/* ATOM4 Channel 5 CCU0 Compare Shadow Register */
#define GTM_ATOM4_CH6_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010f394u)	/* ATOM4 Channel 6 CCU0 Compare Shadow Register */
#define GTM_ATOM4_CH7_SR0	(*( GTM_ATOM0_CH0_SR0_type *) 0xf010f414u)	/* ATOM4 Channel 7 CCU0 Compare Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SR1            : 24;	/* ATOM channel x shadow register SR0 */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_SR1_type;
#define GTM_ATOM0_CH0_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d09cu)	/* ATOM0 Channel 0 CCU1 Compare Shadow Register */
#define GTM_ATOM0_CH1_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d11cu)	/* ATOM0 Channel 1 CCU1 Compare Shadow Register */
#define GTM_ATOM0_CH2_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d19cu)	/* ATOM0 Channel 2 CCU1 Compare Shadow Register */
#define GTM_ATOM0_CH3_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d21cu)	/* ATOM0 Channel 3 CCU1 Compare Shadow Register */
#define GTM_ATOM0_CH4_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d29cu)	/* ATOM0 Channel 4 CCU1 Compare Shadow Register */
#define GTM_ATOM0_CH5_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d31cu)	/* ATOM0 Channel 5 CCU1 Compare Shadow Register */
#define GTM_ATOM0_CH6_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d39cu)	/* ATOM0 Channel 6 CCU1 Compare Shadow Register */
#define GTM_ATOM0_CH7_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d41cu)	/* ATOM0 Channel 7 CCU1 Compare Shadow Register */
#define GTM_ATOM1_CH0_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d89cu)	/* ATOM1 Channel 0 CCU1 Compare Shadow Register */
#define GTM_ATOM1_CH1_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d91cu)	/* ATOM1 Channel 1 CCU1 Compare Shadow Register */
#define GTM_ATOM1_CH2_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010d99cu)	/* ATOM1 Channel 2 CCU1 Compare Shadow Register */
#define GTM_ATOM1_CH3_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010da1cu)	/* ATOM1 Channel 3 CCU1 Compare Shadow Register */
#define GTM_ATOM1_CH4_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010da9cu)	/* ATOM1 Channel 4 CCU1 Compare Shadow Register */
#define GTM_ATOM1_CH5_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010db1cu)	/* ATOM1 Channel 5 CCU1 Compare Shadow Register */
#define GTM_ATOM1_CH6_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010db9cu)	/* ATOM1 Channel 6 CCU1 Compare Shadow Register */
#define GTM_ATOM1_CH7_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010dc1cu)	/* ATOM1 Channel 7 CCU1 Compare Shadow Register */
#define GTM_ATOM2_CH0_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e09cu)	/* ATOM2 Channel 0 CCU1 Compare Shadow Register */
#define GTM_ATOM2_CH1_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e11cu)	/* ATOM2 Channel 1 CCU1 Compare Shadow Register */
#define GTM_ATOM2_CH2_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e19cu)	/* ATOM2 Channel 2 CCU1 Compare Shadow Register */
#define GTM_ATOM2_CH3_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e21cu)	/* ATOM2 Channel 3 CCU1 Compare Shadow Register */
#define GTM_ATOM2_CH4_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e29cu)	/* ATOM2 Channel 4 CCU1 Compare Shadow Register */
#define GTM_ATOM2_CH5_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e31cu)	/* ATOM2 Channel 5 CCU1 Compare Shadow Register */
#define GTM_ATOM2_CH6_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e39cu)	/* ATOM2 Channel 6 CCU1 Compare Shadow Register */
#define GTM_ATOM2_CH7_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e41cu)	/* ATOM2 Channel 7 CCU1 Compare Shadow Register */
#define GTM_ATOM3_CH0_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e89cu)	/* ATOM3 Channel 0 CCU1 Compare Shadow Register */
#define GTM_ATOM3_CH1_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e91cu)	/* ATOM3 Channel 1 CCU1 Compare Shadow Register */
#define GTM_ATOM3_CH2_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010e99cu)	/* ATOM3 Channel 2 CCU1 Compare Shadow Register */
#define GTM_ATOM3_CH3_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010ea1cu)	/* ATOM3 Channel 3 CCU1 Compare Shadow Register */
#define GTM_ATOM3_CH4_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010ea9cu)	/* ATOM3 Channel 4 CCU1 Compare Shadow Register */
#define GTM_ATOM3_CH5_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010eb1cu)	/* ATOM3 Channel 5 CCU1 Compare Shadow Register */
#define GTM_ATOM3_CH6_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010eb9cu)	/* ATOM3 Channel 6 CCU1 Compare Shadow Register */
#define GTM_ATOM3_CH7_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010ec1cu)	/* ATOM3 Channel 7 CCU1 Compare Shadow Register */
#define GTM_ATOM4_CH0_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010f09cu)	/* ATOM4 Channel 0 CCU1 Compare Shadow Register */
#define GTM_ATOM4_CH1_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010f11cu)	/* ATOM4 Channel 1 CCU1 Compare Shadow Register */
#define GTM_ATOM4_CH2_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010f19cu)	/* ATOM4 Channel 2 CCU1 Compare Shadow Register */
#define GTM_ATOM4_CH3_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010f21cu)	/* ATOM4 Channel 3 CCU1 Compare Shadow Register */
#define GTM_ATOM4_CH4_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010f29cu)	/* ATOM4 Channel 4 CCU1 Compare Shadow Register */
#define GTM_ATOM4_CH5_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010f31cu)	/* ATOM4 Channel 5 CCU1 Compare Shadow Register */
#define GTM_ATOM4_CH6_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010f39cu)	/* ATOM4 Channel 6 CCU1 Compare Shadow Register */
#define GTM_ATOM4_CH7_SR1	(*( GTM_ATOM0_CH0_SR1_type *) 0xf010f41cu)	/* ATOM4 Channel 7 CCU1 Compare Shadow Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int OL             : 1;	/* Actual output signal level of ATOM_CHx_OUT */
		/* const */ unsigned int Reserved       : 15;	/* Reserved */
		/* const */ unsigned int ACBI           : 5;	/* ATOM Mode control bits received through ARU */
		/* const */ unsigned int DV             : 1;	/* Valid ARU Data stored in compare registers */
		unsigned int WRF            : 1;	/* Write request of CPU failed for late update */
		/* const */ unsigned int Reserved_6     : 1;	/* Reserved */
		/* const */ unsigned int ACBO           : 5;	/* ATOM Internal status bits */
		/* const */ unsigned int Reserved_8     : 3;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ATOM0_CH0_STAT_type;
#define GTM_ATOM0_CH0_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d084u)	/* ATOM0 Channel 0 Status Register */
#define GTM_ATOM0_CH1_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d104u)	/* ATOM0 Channel 1 Status Register */
#define GTM_ATOM0_CH2_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d184u)	/* ATOM0 Channel 2 Status Register */
#define GTM_ATOM0_CH3_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d204u)	/* ATOM0 Channel 3 Status Register */
#define GTM_ATOM0_CH4_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d284u)	/* ATOM0 Channel 4 Status Register */
#define GTM_ATOM0_CH5_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d304u)	/* ATOM0 Channel 5 Status Register */
#define GTM_ATOM0_CH6_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d384u)	/* ATOM0 Channel 6 Status Register */
#define GTM_ATOM0_CH7_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d404u)	/* ATOM0 Channel 7 Status Register */
#define GTM_ATOM1_CH0_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d884u)	/* ATOM1 Channel 0 Status Register */
#define GTM_ATOM1_CH1_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d904u)	/* ATOM1 Channel 1 Status Register */
#define GTM_ATOM1_CH2_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010d984u)	/* ATOM1 Channel 2 Status Register */
#define GTM_ATOM1_CH3_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010da04u)	/* ATOM1 Channel 3 Status Register */
#define GTM_ATOM1_CH4_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010da84u)	/* ATOM1 Channel 4 Status Register */
#define GTM_ATOM1_CH5_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010db04u)	/* ATOM1 Channel 5 Status Register */
#define GTM_ATOM1_CH6_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010db84u)	/* ATOM1 Channel 6 Status Register */
#define GTM_ATOM1_CH7_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010dc04u)	/* ATOM1 Channel 7 Status Register */
#define GTM_ATOM2_CH0_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e084u)	/* ATOM2 Channel 0 Status Register */
#define GTM_ATOM2_CH1_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e104u)	/* ATOM2 Channel 1 Status Register */
#define GTM_ATOM2_CH2_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e184u)	/* ATOM2 Channel 2 Status Register */
#define GTM_ATOM2_CH3_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e204u)	/* ATOM2 Channel 3 Status Register */
#define GTM_ATOM2_CH4_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e284u)	/* ATOM2 Channel 4 Status Register */
#define GTM_ATOM2_CH5_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e304u)	/* ATOM2 Channel 5 Status Register */
#define GTM_ATOM2_CH6_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e384u)	/* ATOM2 Channel 6 Status Register */
#define GTM_ATOM2_CH7_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e404u)	/* ATOM2 Channel 7 Status Register */
#define GTM_ATOM3_CH0_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e884u)	/* ATOM3 Channel 0 Status Register */
#define GTM_ATOM3_CH1_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e904u)	/* ATOM3 Channel 1 Status Register */
#define GTM_ATOM3_CH2_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010e984u)	/* ATOM3 Channel 2 Status Register */
#define GTM_ATOM3_CH3_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010ea04u)	/* ATOM3 Channel 3 Status Register */
#define GTM_ATOM3_CH4_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010ea84u)	/* ATOM3 Channel 4 Status Register */
#define GTM_ATOM3_CH5_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010eb04u)	/* ATOM3 Channel 5 Status Register */
#define GTM_ATOM3_CH6_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010eb84u)	/* ATOM3 Channel 6 Status Register */
#define GTM_ATOM3_CH7_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010ec04u)	/* ATOM3 Channel 7 Status Register */
#define GTM_ATOM4_CH0_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010f084u)	/* ATOM4 Channel 0 Status Register */
#define GTM_ATOM4_CH1_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010f104u)	/* ATOM4 Channel 1 Status Register */
#define GTM_ATOM4_CH2_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010f184u)	/* ATOM4 Channel 2 Status Register */
#define GTM_ATOM4_CH3_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010f204u)	/* ATOM4 Channel 3 Status Register */
#define GTM_ATOM4_CH4_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010f284u)	/* ATOM4 Channel 4 Status Register */
#define GTM_ATOM4_CH5_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010f304u)	/* ATOM4 Channel 5 Status Register */
#define GTM_ATOM4_CH6_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010f384u)	/* ATOM4 Channel 6 Status Register */
#define GTM_ATOM4_CH7_STAT	(*( GTM_ATOM0_CH0_STAT_type *) 0xf010f404u)	/* ATOM4 Channel 7 Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DEST_ERR_EN    : 1;	/* BRC_DEST_ERR_IRQ interrupt enable */
		unsigned int DID_ENx        : 12;	/* BRC_DID_IRQ interrupt enable */
		/* const */ unsigned int Reserved       : 19;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_BRC_IRQ_EN_type;
#define GTM_BRC_IRQ_EN	(*( GTM_BRC_IRQ_EN_type *) 0xf0100464u)	/* BRC Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_DEST_ERR   : 1;	/* Trigger destination error interrupt */
		unsigned int TRG_DIDx       : 12;	/* Trigger data inconsistency error interrupt */
		/* const */ unsigned int Reserved       : 19;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_BRC_IRQ_FORCINT_type;
#define GTM_BRC_IRQ_FORCINT	(*( GTM_BRC_IRQ_FORCINT_type *) 0xf0100468u)	/* BRC_DEST_ERR Forcing Interrupt Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DEST_ERR       : 1;	/* Configuration error interrupt for BRC submodule */
		unsigned int DIDx           : 12;	/* Data inconsistency occurred in MTM mode */
		/* const */ unsigned int Reserved       : 19;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_BRC_IRQ_NOTIFY_type;
#define GTM_BRC_IRQ_NOTIFY	(*( GTM_BRC_IRQ_NOTIFY_type *) 0xf0100460u)	/* BRC Interrupt Notification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Software reset */
		/* const */ unsigned int Reserved       : 31;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_BRC_RST_type;
#define GTM_BRC_RST	(*( GTM_BRC_RST_type *) 0xf0100470u)	/* BRC Software Reset Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 9;	/* Source ARU address */
		/* const */ unsigned int Reserved       : 3;	/* Reserved */
		unsigned int BRC_MODE       : 1;	/* BRC Operation mode select */
		/* const */ unsigned int Reserved_4     : 19;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_BRC_SRC0_ADDR_type;
#define GTM_BRC_SRC0_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100400u)	/* Read Address For Input Channel 0 */
#define GTM_BRC_SRC10_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100450u)	/* Read Address For Input Channel 10 */
#define GTM_BRC_SRC11_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100458u)	/* Read Address For Input Channel 11 */
#define GTM_BRC_SRC1_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100408u)	/* Read Address For Input Channel 1 */
#define GTM_BRC_SRC2_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100410u)	/* Read Address For Input Channel 2 */
#define GTM_BRC_SRC3_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100418u)	/* Read Address For Input Channel 3 */
#define GTM_BRC_SRC4_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100420u)	/* Read Address For Input Channel 4 */
#define GTM_BRC_SRC5_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100428u)	/* Read Address For Input Channel 5 */
#define GTM_BRC_SRC6_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100430u)	/* Read Address For Input Channel 6 */
#define GTM_BRC_SRC7_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100438u)	/* Read Address For Input Channel 7 */
#define GTM_BRC_SRC8_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100440u)	/* Read Address For Input Channel 8 */
#define GTM_BRC_SRC9_ADDR	(*( GTM_BRC_SRC0_ADDR_type *) 0xf0100448u)	/* Read Address For Input Channel 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int EN_DEST0       : 1;	/* Enable BRC destination address 0 */
		unsigned int EN_DEST1       : 1;	/* Enable BRC destination address 1 */
		unsigned int EN_DEST2       : 1;	/* Enable BRC destination address 2 */
		unsigned int EN_DEST3       : 1;	/* Enable BRC destination address 3 */
		unsigned int EN_DEST4       : 1;	/* Enable BRC destination address 4 */
		unsigned int EN_DEST5       : 1;	/* Enable BRC destination address 5 */
		unsigned int EN_DEST6       : 1;	/* Enable BRC destination address 6 */
		unsigned int EN_DEST7       : 1;	/* Enable BRC destination address 7 */
		unsigned int EN_DEST8       : 1;	/* Enable BRC destination address 8 */
		unsigned int EN_DEST9       : 1;	/* Enable BRC destination address 9 */
		unsigned int EN_DEST10      : 1;	/* Enable BRC destination address 10 */
		unsigned int EN_DEST11      : 1;	/* Enable BRC destination address 11 */
		unsigned int EN_DEST12      : 1;	/* Enable BRC destination address 12 */
		unsigned int EN_DEST13      : 1;	/* Enable BRC destination address 13 */
		unsigned int EN_DEST14      : 1;	/* Enable BRC destination address 14 */
		unsigned int EN_DEST15      : 1;	/* Enable BRC destination address 15 */
		unsigned int EN_DEST16      : 1;	/* Enable BRC destination address 16 */
		unsigned int EN_DEST17      : 1;	/* Enable BRC destination address 17 */
		unsigned int EN_DEST18      : 1;	/* Enable BRC destination address 18 */
		unsigned int EN_DEST19      : 1;	/* Enable BRC destination address 19 */
		unsigned int EN_DEST20      : 1;	/* Enable BRC destination address 20 */
		unsigned int EN_DEST21      : 1;	/* Enable BRC destination address 21 */
		unsigned int EN_TRASHBIN    : 1;	/* Control trash bin functionality */
		/* const */ unsigned int Reserved       : 9;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_BRC_SRC0_DEST_type;
#define GTM_BRC_SRC0_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf0100404u)	/* Destination Channels For Input Channel 0 */
#define GTM_BRC_SRC10_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf0100454u)	/* Destination Channels For Input Channel 10 */
#define GTM_BRC_SRC11_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf010045cu)	/* Destination Channels For Input Channel 11 */
#define GTM_BRC_SRC1_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf010040cu)	/* Destination Channels For Input Channel 1 */
#define GTM_BRC_SRC2_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf0100414u)	/* Destination Channels For Input Channel 2 */
#define GTM_BRC_SRC3_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf010041cu)	/* Destination Channels For Input Channel 3 */
#define GTM_BRC_SRC4_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf0100424u)	/* Destination Channels For Input Channel 4 */
#define GTM_BRC_SRC5_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf010042cu)	/* Destination Channels For Input Channel 5 */
#define GTM_BRC_SRC6_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf0100434u)	/* Destination Channels For Input Channel 6 */
#define GTM_BRC_SRC7_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf010043cu)	/* Destination Channels For Input Channel 7 */
#define GTM_BRC_SRC8_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf0100444u)	/* Destination Channels For Input Channel 8 */
#define GTM_BRC_SRC9_DEST	(*( GTM_BRC_SRC0_DEST_type *) 0xf010044cu)	/* Destination Channels For Input Channel 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int BRG_MODE       : 1;	/* Defines the operation mode for the AEI bridge */
		unsigned int MSK_WR_RSP     : 1;	/* Mask write response */
		unsigned int                : 6;
		/* const */ unsigned int MODE_UP_PGR    : 1;	/* Mode update in progress */
		unsigned int BUFF_OVL       : 1;	/* Buffer overflow register */
		/* const */ unsigned int Reserved       : 6;	/* Reserved */
		unsigned int BRG_RST        : 1;	/* Bridge software reset */
		/* const */ unsigned int Reserved_7     : 7;	/* Reserved */
		/* const */ unsigned int BUFF_DPT       : 8;	/* Buffer depth of AEI bridge */
	} B;
	int I;
	unsigned int U;

} GTM_BRIDGE_MODE_type;
#define GTM_BRIDGE_MODE	(*( GTM_BRIDGE_MODE_type *) 0xf0100030u)	/* GTM to SPB BRIDGE MODE */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int NEW_TRAN_PTR   : 5;	/* New transaction pointer */
		/* const */ unsigned int FIRST_RSP_PTR  : 5;	/* First response pointer */
		/* const */ unsigned int TRAN_IN_PGR    : 5;	/* Transaction in progress pointer (aquire) */
		/* const */ unsigned int ABT_TRAN_PGR   : 5;	/* Aborted transaction in progress pointer */
		/* const */ unsigned int FBC            : 6;	/* Free buffer count */
		/* const */ unsigned int RSP_TRAN_RDY   : 6;	/* Response transactions ready */
	} B;
	int I;
	unsigned int U;

} GTM_BRIDGE_PTR1_type;
#define GTM_BRIDGE_PTR1	(*( GTM_BRIDGE_PTR1_type *) 0xf0100034u)	/* GTM to SPB BRIDGE PTR1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TRAN_IN_PGR2   : 5;	/* Transaction in progress pointer (aquire2) */
		/* const */ unsigned int Reserved       : 27;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_BRIDGE_PTR2_type;
#define GTM_BRIDGE_PTR2	(*( GTM_BRIDGE_PTR2_type *) 0xf0100038u)	/* GTM to SPB BRIDGE PTR2 */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 4;	/* Output Selection for (TT)CAN GTM connection */
		unsigned int SEL1           : 4;	/* Output Selection for (TT)CAN GTM connection */
		unsigned int SEL2           : 4;	/* Output Selection for CAN GTM connection */
		unsigned int SEL3           : 4;	/* Output Selection for CAN GTM connection */
		unsigned int SEL4           : 4;	/* Output Selection for CAN GTM connection */
		unsigned int SEL5           : 4;	/* Output Selection for CAN GTM connection */
		unsigned int SEL6           : 4;	/* Output Selection for CAN GTM connection */
		unsigned int SEL7           : 4;	/* Output Selection for CAN GTM connection */
	} B;
	int I;
	unsigned int U;

} GTM_CANOUTSEL_type;
#define GTM_CANOUTSEL	(*( GTM_CANOUTSEL_type *) 0xf019fda0u)	/* CAN Output Select Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} GTM_CLC_type;
#define GTM_CLC	(*( GTM_CLC_type *) 0xf019fd00u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ABWC0_EN       : 1;	/* Enable comparator 0 in ABWC */
		unsigned int ABWC1_EN       : 1;	/* Enable comparator 1 in ABWC */
		unsigned int ABWC2_EN       : 1;	/* Enable comparator 2 in ABWC */
		unsigned int ABWC3_EN       : 1;	/* Enable comparator 3 in ABWC */
		unsigned int ABWC4_EN       : 1;	/* Enable comparator 4 in ABWC */
		unsigned int ABWC5_EN       : 1;	/* Enable comparator 5 in ABWC */
		unsigned int ABWC6_EN       : 1;	/* Enable comparator 6 in ABWC */
		unsigned int ABWC7_EN       : 1;	/* Enable comparator 7 in ABWC */
		unsigned int ABWC8_EN       : 1;	/* Enable comparator 8 in ABWC */
		unsigned int ABWC9_EN       : 1;	/* Enable comparator 9 in ABW */
		unsigned int ABWC10_EN      : 1;	/* Enable comparator 10 in ABWC */
		unsigned int ABWC11_EN      : 1;	/* Enable comparator 11 in ABWC */
		unsigned int TBWC0_EN       : 1;	/* Enable comparator 0 in TBWC */
		unsigned int TBWC1_EN       : 1;	/* Enable comparator 1 in TBWC */
		unsigned int TBWC2_EN       : 1;	/* Enable comparator 2 in TBWC */
		unsigned int TBWC3_EN       : 1;	/* Enable comparator 3 in TBWC */
		unsigned int TBWC4_EN       : 1;	/* Enable comparator 4 in TBWC */
		unsigned int TBWC5_EN       : 1;	/* Enable comparator 5 in TBWC */
		unsigned int TBWC6_EN       : 1;	/* Enable comparator 6 in TBWC */
		unsigned int TBWC7_EN       : 1;	/* Enable comparator 7 in TBWC */
		unsigned int TBWC8_EN       : 1;	/* Enable comparator 8 in TBWC */
		unsigned int TBWC9_EN       : 1;	/* Enable comparator 9 in TBWC */
		unsigned int TBWC10_EN      : 1;	/* Enable comparator 10 in TBWC */
		unsigned int TBWC11_EN      : 1;	/* Enable comparator 11 in TBWC */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMP_EN_type;
#define GTM_CMP_EN	(*( GTM_CMP_EN_type *) 0xf0100200u)	/* CMP Comparator Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ABWC0_EN_IRQ   : 1;	/* Enable ABWC0 interrupt source for CMP_IRQ line */
		unsigned int ABWC1_EN_IRQ   : 1;	/* Enable ABWC1 interrupt source for CMP_IRQ line */
		unsigned int ABWC2_EN_IRQ   : 1;	/* Enable ABWC2 interrupt source for CMP_IRQ line */
		unsigned int ABWC3_EN_IRQ   : 1;	/* Enable ABWC3 interrupt source for CMP_IRQ line */
		unsigned int ABWC4_EN_IRQ   : 1;	/* Enable ABWC4 interrupt source for CMP_IRQ line */
		unsigned int ABWC5_EN_IRQ   : 1;	/* Enable ABWC5 interrupt source for CMP_IRQ line */
		unsigned int ABWC6_EN_IRQ   : 1;	/* Enable ABWC6 interrupt source for CMP_IRQ line */
		unsigned int ABWC7_EN_IRQ   : 1;	/* Enable ABWC7 interrupt source for CMP_IRQ line */
		unsigned int ABWC8_EN_IRQ   : 1;	/* Enable ABWC8 interrupt source for CMP_IRQ line */
		unsigned int ABWC9_EN_IRQ   : 1;	/* Enable ABWC9 interrupt source for CMP_IRQ line */
		unsigned int ABWC10_EN_IRQ  : 1;	/* Enable ABWC10 interrupt source for CMP_IRQ line */
		unsigned int ABWC11_EN_IRQ  : 1;	/* Enable ABWC11 interrupt source for CMP_IRQ line */
		unsigned int TBWC0_EN_IRQ   : 1;	/* Enable TBWC0 interrupt source for CMP_IRQ line */
		unsigned int TBWC1_EN_IRQ   : 1;	/* Enable TBWC1 interrupt source for CMP_IRQ line */
		unsigned int TBWC2_EN_IRQ   : 1;	/* Enable TBWC2 interrupt source for CMP_IRQ line */
		unsigned int TBWC3_EN_IRQ   : 1;	/* Enable TBWC3 interrupt source for CMP_IRQ line */
		unsigned int TBWC4_EN_IRQ   : 1;	/* Enable TBWC4 interrupt source for CMP_IRQ line */
		unsigned int TBWC5_EN_IRQ   : 1;	/* Enable TBWC5 interrupt source for CMP_IRQ line */
		unsigned int TBWC6_EN_IRQ   : 1;	/* Enable TBWC6 interrupt source for CMP_IRQ line */
		unsigned int TBWC7_EN_IRQ   : 1;	/* Enable TBWC7 interrupt source for CMP_IRQ line */
		unsigned int TBWC8_EN_IRQ   : 1;	/* Enable TBWC8 interrupt source for CMP_IRQ line */
		unsigned int TBWC9_EN_IRQ   : 1;	/* Enable TBWC9 interrupt source for CMP_IRQ line */
		unsigned int TBWC10_EN_IRQ  : 1;	/* Enable TBWC10 interrupt source for CMP_IRQ line */
		unsigned int TBWC11_EN_IRQ  : 1;	/* Enable TBWC11 interrupt source for CMP_IRQ line */
		unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMP_IRQ_EN_type;
#define GTM_CMP_IRQ_EN	(*( GTM_CMP_IRQ_EN_type *) 0xf0100208u)	/* CMP Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_ABWC0      : 1;	/* Trigger ABWC0 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC1      : 1;	/* Trigger ABWC1 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC2      : 1;	/* Trigger ABWC2 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC3      : 1;	/* Trigger ABWC3 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC4      : 1;	/* Trigger ABWC4 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC5      : 1;	/* Trigger ABWC5 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC6      : 1;	/* Trigger ABWC6 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC7      : 1;	/* Trigger ABWC7 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC8      : 1;	/* Trigger ABWC8 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC9      : 1;	/* Trigger ABWC9 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC10     : 1;	/* Trigger ABWC10 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_ABWC11     : 1;	/* Trigger ABWC11 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC0      : 1;	/* Trigger TBWC0 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC1      : 1;	/* Trigger TBWC1 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC2      : 1;	/* Trigger TBWC2 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC3      : 1;	/* Trigger TBWC3 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC4      : 1;	/* Trigger TBWC4 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC5      : 1;	/* Trigger TBWC5 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC6      : 1;	/* Trigger TBWC6 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC7      : 1;	/* Trigger TBWC7 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC8      : 1;	/* Trigger TBWC8 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC9      : 1;	/* Trigger TBWC9 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC10     : 1;	/* Trigger TBWC10 bit in CMP_IRQ_NOTIFY register by software */
		unsigned int TRG_TBWC11     : 1;	/* Trigger TBWC11 bit in CMP_IRQ_NOTIFY register by software */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMP_IRQ_FORCINT_type;
#define GTM_CMP_IRQ_FORCINT	(*( GTM_CMP_IRQ_FORCINT_type *) 0xf010020cu)	/* CMP Interrupt Force Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ABWC0          : 1;	/* ATOM sub modules outputs bitwise comparator 0 error indication */
		unsigned int ABWC1          : 1;	/* ATOM sub modules outputs bitwise comparator 1 error indication */
		unsigned int ABWC2          : 1;	/* ATOM sub modules outputs bitwise comparator 2 error indication */
		unsigned int ABWC3          : 1;	/* ATOM sub modules outputs bitwise comparator 3 error indication */
		unsigned int ABWC4          : 1;	/* ATOM sub modules outputs bitwise comparator 4 error indication */
		unsigned int ABWC5          : 1;	/* ATOM sub modules outputs bitwise comparator 5 error indication */
		unsigned int ABWC6          : 1;	/* ATOM sub modules outputs bitwise comparator 6 error indication */
		unsigned int ABWC7          : 1;	/* ATOM sub modules outputs bitwise comparator 7 error indication */
		unsigned int ABWC8          : 1;	/* ATOM sub modules outputs bitwise comparator 8 error indication */
		unsigned int ABWC9          : 1;	/* ATOM sub modules outputs bitwise comparator 9 error indication */
		unsigned int ABWC10         : 1;	/* ATOM sub modules outputs bitwise comparator 10 error indication */
		unsigned int ABWC11         : 1;	/* ATOM sub modules outputs bitwise comparator 11 error indication */
		unsigned int TBWC0          : 1;	/* TOM sub modules outputs bitwise comparator 0 error indication */
		unsigned int TBWC1          : 1;	/* TOM sub modules outputs bitwise comparator 1 error indication */
		unsigned int TBWC2          : 1;	/* TOM sub modules outputs bitwise comparator 2 error indication */
		unsigned int TBWC3          : 1;	/* TOM sub modules outputs bitwise comparator 3 error indication */
		unsigned int TBWC4          : 1;	/* TOM sub modules outputs bitwise comparator 4 error indication */
		unsigned int TBWC5          : 1;	/* TOM sub modules outputs bitwise comparator 5 error indication */
		unsigned int TBWC6          : 1;	/* TOM sub modules outputs bitwise comparator 6 error indication */
		unsigned int TBWC7          : 1;	/* TOM sub modules outputs bitwise comparator 7 error indication */
		unsigned int TBWC8          : 1;	/* TOM sub modules outputs bitwise comparator 8 error indication */
		unsigned int TBWC9          : 1;	/* TOM sub modules outputs bitwise comparator 9 error indication */
		unsigned int TBWC10         : 1;	/* TOM sub modules outputs bitwise comparator 10 error indication */
		unsigned int TBWC11         : 1;	/* TOM sub modules outputs bitwise comparator 11 error indication */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMP_IRQ_NOTIFY_type;
#define GTM_CMP_IRQ_NOTIFY	(*( GTM_CMP_IRQ_NOTIFY_type *) 0xf0100204u)	/* CMP Event Notification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CLK_CNT        : 24;	/* Clock count Defines count value for the clock divider of clock source CMU_CLK[x] (x:0...4) */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMU_CLK_0_CTRL_type;
#define GTM_CMU_CLK_0_CTRL	(*( GTM_CMU_CLK_0_CTRL_type *) 0xf010030cu)	/* CMU Control For Clock Source 0 Register */
#define GTM_CMU_CLK_1_CTRL	(*( GTM_CMU_CLK_0_CTRL_type *) 0xf0100310u)	/* CMU Control For Clock Source 1 Register */
#define GTM_CMU_CLK_2_CTRL	(*( GTM_CMU_CLK_0_CTRL_type *) 0xf0100314u)	/* CMU Control For Clock Source 2 Register */
#define GTM_CMU_CLK_3_CTRL	(*( GTM_CMU_CLK_0_CTRL_type *) 0xf0100318u)	/* CMU Control For Clock Source 3 Register */
#define GTM_CMU_CLK_4_CTRL	(*( GTM_CMU_CLK_0_CTRL_type *) 0xf010031cu)	/* CMU Control For Clock Source 4 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CLK_CNT        : 24;	/* Clock count Defines count value for the clock divider of clock source CMU_CLK[5] */
		/* const */ unsigned int Reserved       : 7;	/* Reserved */
		unsigned int FXCLK_SEL      : 1;	/* Clock source selection for CMU_FXCLKs */
	} B;
	int I;
	unsigned int U;

} GTM_CMU_CLK_5_CTRL_type;
#define GTM_CMU_CLK_5_CTRL	(*( GTM_CMU_CLK_5_CTRL_type *) 0xf0100320u)	/* CMU Control For Clock Source 5 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CLK_CNT        : 24;	/* Clock count. Define count value for the clock divider of clock source CMU_CLK6 */
		unsigned int CLK6_SEL       : 1;	/* Clock source selection for CMU_CLK6 */
		/* const */ unsigned int Reserved       : 7;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMU_CLK_6_CTRL_type;
#define GTM_CMU_CLK_6_CTRL	(*( GTM_CMU_CLK_6_CTRL_type *) 0xf0100324u)	/* CMU Control For Clock Source 6 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CLK_CNT        : 24;	/* Clock count. Define count value for the clock divider of clock source CMU_CLK7 */
		unsigned int CLK7_SEL       : 1;	/* Clock source selection for CMU_CLK7 */
		/* const */ unsigned int Reserved       : 7;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMU_CLK_7_CTRL_type;
#define GTM_CMU_CLK_7_CTRL	(*( GTM_CMU_CLK_7_CTRL_type *) 0xf0100328u)	/* CMU Control For Clock Source 7 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EN_CLK0        : 2;	/* Enable clock source 0 */
		unsigned int EN_CLK1        : 2;	/* Enable clock source 1 */
		unsigned int EN_CLK2        : 2;	/* Enable clock source 2 */
		unsigned int EN_CLK3        : 2;	/* Enable clock source 3 */
		unsigned int EN_CLK4        : 2;	/* Enable clock source 4 */
		unsigned int EN_CLK5        : 2;	/* Enable clock source 5 */
		unsigned int EN_CLK6        : 2;	/* Enable clock source 6 */
		unsigned int EN_CLK7        : 2;	/* Enable clock source 7 */
		unsigned int EN_ECLK0       : 2;	/* Enable ECLK 0 generation subunit */
		unsigned int EN_ECLK1       : 2;	/* Enable ECLK 1 generation subunit */
		unsigned int EN_ECLK2       : 2;	/* Enable ECLK 2 generation subunit */
		unsigned int EN_FXCLK       : 2;	/* Enable all CMU_FXCLK */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMU_CLK_EN_type;
#define GTM_CMU_CLK_EN	(*( GTM_CMU_CLK_EN_type *) 0xf0100300u)	/* CMU Clock Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ECLK_DEN       : 24;	/* Denominator for external clock divider */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMU_ECLK_0_DEN_type;
#define GTM_CMU_ECLK_0_DEN	(*( GTM_CMU_ECLK_0_DEN_type *) 0xf0100330u)	/* CMU External Clock 0 Control Denominator Register */
#define GTM_CMU_ECLK_1_DEN	(*( GTM_CMU_ECLK_0_DEN_type *) 0xf0100338u)	/* CMU External Clock 1 Control Denominator Register */
#define GTM_CMU_ECLK_2_DEN	(*( GTM_CMU_ECLK_0_DEN_type *) 0xf0100340u)	/* CMU External Clock 2 Control Denominator Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ECLK_NUM       : 24;	/* Numerator for external clock divider */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMU_ECLK_0_NUM_type;
#define GTM_CMU_ECLK_0_NUM	(*( GTM_CMU_ECLK_0_NUM_type *) 0xf010032cu)	/* CMU External Clock 0 Control Numerator Register */
#define GTM_CMU_ECLK_1_NUM	(*( GTM_CMU_ECLK_0_NUM_type *) 0xf0100334u)	/* CMU External Clock 1 Control Numerator Register */
#define GTM_CMU_ECLK_2_NUM	(*( GTM_CMU_ECLK_0_NUM_type *) 0xf010033cu)	/* CMU External Clock 2 Control Numerator Register */

typedef volatile union
{
	struct
	{ 
		unsigned int GCLK_DEN       : 24;	/* Denominator for global clock divider */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMU_GCLK_DEN_type;
#define GTM_CMU_GCLK_DEN	(*( GTM_CMU_GCLK_DEN_type *) 0xf0100308u)	/* CMU Global Clock Control Denominator Register */

typedef volatile union
{
	struct
	{ 
		unsigned int GCLK_NUM       : 24;	/* Numerator for global clock divider */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CMU_GCLK_NUM_type;
#define GTM_CMU_GCLK_NUM	(*( GTM_CMU_GCLK_NUM_type *) 0xf0100304u)	/* CMU Global Clock Control Numerator Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RF_PROT        : 1;	/* RST and FORCINT protection */
		unsigned int TO_MODE        : 1;	/* AEI Timeout mode */
		/* const */ unsigned int Reserved       : 2;	/* Reserved */
		unsigned int TO_VAL         : 5;	/* AEI Timeout value */
		/* const */ unsigned int Reserved_5     : 23;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_CTRL_type;
#define GTM_CTRL	(*( GTM_CTRL_type *) 0xf0100008u)	/* GTM Global Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ACBj_0         : 5;	/* Action Control Bits of ACTION_i */
		/* const */ unsigned int Reserved       : 3;	/* Reserved */
		unsigned int ACBj_1         : 5;	/* Action Control Bits of ACTION_(i + 1), reflects ACT_D[i+1](5248) */
		/* const */ unsigned int Reserved_4     : 3;	/* Reserved */
		unsigned int ACBj_2         : 5;	/* Action Control Bits of ACTION_(i + 2), reflects ACT_D[i+2](5248) */
		/* const */ unsigned int Reserved_6     : 3;	/* Reserved */
		unsigned int ACBj_3         : 5;	/* Action Control Bits of ACTION_(i + 3), reflects ACT_D[i+3](5248) */
		/* const */ unsigned int Reserved_8     : 3;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_ACB_0_type;
#define GTM_DPLL_ACB_0	(*( GTM_DPLL_ACB_0_type *) 0xf01281c0u)	/* Control Bits For Actions Register i */
#define GTM_DPLL_ACB_1	(*( GTM_DPLL_ACB_0_type *) 0xf01281c4u)	/* Control Bits For Actions Register i */
#define GTM_DPLL_ACB_2	(*( GTM_DPLL_ACB_0_type *) 0xf01281c8u)	/* Control Bits For Actions Register i */
#define GTM_DPLL_ACB_3	(*( GTM_DPLL_ACB_0_type *) 0xf01281ccu)	/* Control Bits For Actions Register i */
#define GTM_DPLL_ACB_4	(*( GTM_DPLL_ACB_0_type *) 0xf01281d0u)	/* Control Bits For Actions Register i */
#define GTM_DPLL_ACB_5	(*( GTM_DPLL_ACB_0_type *) 0xf01281d4u)	/* Control Bits For Actions Register i */

typedef volatile union
{
	struct
	{ 
		unsigned int ACT_Ni         : 24;	/* New output data values concerning to action i provided */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_ACT_STA_type;
#define GTM_DPLL_ACT_STA	(*( GTM_DPLL_ACT_STA_type *) 0xf0128018u)	/* DPLL ACTION Status Register With Shadow Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int AOSV_2a        : 8;	/* Address offset value of the RAM 2a region */
		/* const */ unsigned int AOSV_2b        : 8;	/* Address offset value of the RAM 2b region */
		/* const */ unsigned int AOSV_2c        : 8;	/* Address offset value of the RAM 2c region */
		/* const */ unsigned int AOSV_2d        : 8;	/* Address offset value of the RAM 2d region */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_AOSV_2_type;
#define GTM_DPLL_AOSV_2	(*( GTM_DPLL_AOSV_2_type *) 0xf0128020u)	/* DPLL Address Offset Register For APT In RAM Region 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 1;	/* Reserved */
		unsigned int WAPS           : 1;	/* Write bit for address pointer APS */
		unsigned int APS            : 6;	/* Address pointer STATE */
		/* const */ unsigned int Reserved_4     : 5;	/* Reserved */
		unsigned int WAPS_1c2       : 1;	/* Write bit for address pointer APS_1c2 */
		unsigned int APS_1c2        : 6;	/* Address pointer STATE for RAM region 1c2 */
		/* const */ unsigned int Reserved_7     : 12;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_APS_type;
#define GTM_DPLL_APS	(*( GTM_DPLL_APS_type *) 0xf0128028u)	/* DPLL Actual RAM Pointer to RAM Regions 1c1, 1c2 and 1c4 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 2;	/* Reserved */
		unsigned int APS_1c3        : 6;	/* Address pointer STATE for RAM region 1c3 */
		/* const */ unsigned int Reserved_3     : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_APS_1c3_type;
#define GTM_DPLL_APS_1c3	(*( GTM_DPLL_APS_1c3_type *) 0xf0128030u)	/* DPLL Actual RAM Pointer to RAM Region 1c3 */

typedef volatile union
{
	struct
	{ 
		unsigned int APS_1c2_ext    : 6;	/* Address pointer 1c2 extension */
		unsigned int APS_1c2_status : 1;	/* Address pointer 1c2 status */
		/* const */ unsigned int Reserved       : 7;	/* Reserved */
		unsigned int APS_1c2_old    : 6;	/* Address pointer STATE for RAM region 1c2 at synchronization time */
		/* const */ unsigned int Reserved_5     : 12;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_APS_SYNC_type;
#define GTM_DPLL_APS_SYNC	(*( GTM_DPLL_APS_SYNC_type *) 0xf01280bcu)	/* DPLL Old RAM Pointer and Offset Value for STATE */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 1;	/* Reserved */
		unsigned int WAPT           : 1;	/* Write bit for address pointer APT */
		unsigned int APT            : 10;	/* Address pointer TRIGGER */
		/* const */ unsigned int Reserved_4     : 1;	/* Reserved */
		unsigned int WAPT_2b        : 1;	/* Write bit for address pointer APT_2b */
		unsigned int APT_2b         : 10;	/* Address pointer TRIGGER for RAM region 2b */
		/* const */ unsigned int Reserved_7     : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_APT_type;
#define GTM_DPLL_APT	(*( GTM_DPLL_APT_type *) 0xf0128024u)	/* DPLL Actual RAM Pointer to RAM Regions 2a, b and d */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 2;	/* Reserved */
		unsigned int APT_2c         : 10;	/* Address pointer TRIGGER for RAM region 2c */
		/* const */ unsigned int Reserved_3     : 20;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_APT_2c_type;
#define GTM_DPLL_APT_2c	(*( GTM_DPLL_APT_2c_type *) 0xf012802cu)	/* DPLL Actual RAM Pointer to RAM Region 2c */

typedef volatile union
{
	struct
	{ 
		unsigned int APT_2b_ext     : 6;	/* Address pointer 2b extension */
		unsigned int APT_2b_status  : 1;	/* Address pointer 2b status */
		/* const */ unsigned int Reserved       : 7;	/* Reserved */
		unsigned int APT_2b_old     : 10;	/* Address pointer TRIGGER for RAM region 2b at synchronization time */
		/* const */ unsigned int Reserved_5     : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_APT_SYNC_type;
#define GTM_DPLL_APT_SYNC	(*( GTM_DPLL_APT_SYNC_type *) 0xf01280b8u)	/* DPLL Old RAM Pointer and Offset Value for TRIGGER */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DMO            : 1;	/* DPLL mode select */
		/* const */ unsigned int DEN            : 1;	/* DPLL enable */
		/* const */ unsigned int Reserved       : 1;	/* Reserved */
		/* const */ unsigned int COA            : 1;	/* Correction strategy in automatic end mode (DMO=0) */
		/* const */ unsigned int PIT            : 1;	/* Plausibility */
		/* const */ unsigned int SGE1           : 1;	/* SUB_INC1 generator enable */
		/* const */ unsigned int DLM1           : 1;	/* Direct Load Mode */
		/* const */ unsigned int PCM1           : 1;	/* Pulse Correction Mode */
		/* const */ unsigned int SGE2           : 1;	/* SUB_INC2 generator enable */
		/* const */ unsigned int DLM2           : 1;	/* Direct Load Mode */
		/* const */ unsigned int PCM2           : 1;	/* Pulse Correction Mode */
		/* const */ unsigned int SYN_NS         : 5;	/* Synchronization number of STATE */
		/* const */ unsigned int SYN_NT         : 5;	/* Synchronization number of TRIGGER */
		/* const */ unsigned int Reserved_14    : 2;	/* Reserved */
		/* const */ unsigned int SWR            : 1;	/* Software Reset */
		/* const */ unsigned int SYSF           : 1;	/* SYN_NS for FULL_SCALE */
		/* const */ unsigned int TS0_HRS        : 1;	/* Time stamp high resolution STATE */
		/* const */ unsigned int TS0_HRT        : 1;	/* Time stamp high resolution TRIGGER */
		/* const */ unsigned int SMC            : 1;	/* Synchronous Motor Control */
		/* const */ unsigned int SSL            : 2;	/* STATE slope select */
		/* const */ unsigned int TSL            : 2;	/* TRIGGER slope selected */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_CRTL_1_SHADOW_STATE_type;
#define GTM_DPLL_CRTL_1_SHADOW_STATE	(*( GTM_DPLL_CRTL_1_SHADOW_STATE_type *) 0xf01281ecu)	/* DPLL Control 1 Shadow STATE Register */
#define GTM_DPLL_CTRL_1_SHADOW_TRIGGER	(*( GTM_DPLL_CRTL_1_SHADOW_STATE_type *) 0xf01281e8u)	/* DPLL Control 1 Shadow TRIGGER Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MLT            : 10;	/* Multiplier for TRIGGER */
		unsigned int IFP            : 1;	/* Input filter position */
		unsigned int SNU            : 5;	/* STATE number */
		unsigned int TNU            : 9;	/* TRIGGER number */
		unsigned int AMS            : 1;	/* Adapt mode STATE */
		unsigned int AMT            : 1;	/* Adapt mode TRIGGER */
		unsigned int IDS            : 1;	/* Input delay STATE */
		unsigned int IDT            : 1;	/* Input delay TRIGGER */
		unsigned int SEN            : 1;	/* STATE enable */
		unsigned int TEN            : 1;	/* TRIGGER enable */
		unsigned int RMO            : 1;	/* Reference mode */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_CTRL_0_type;
#define GTM_DPLL_CTRL_0	(*( GTM_DPLL_CTRL_0_type *) 0xf0128000u)	/* DPLL Control Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MLT            : 10;	/* Multipler for TRIGGER */
		/* const */ unsigned int IFP            : 1;	/* Input filter position */
		/* const */ unsigned int SNU            : 5;	/* STATE number */
		/* const */ unsigned int TNU            : 9;	/* TRIGGER number */
		/* const */ unsigned int AMS            : 1;	/* Adapt mode STATE */
		/* const */ unsigned int AMT            : 1;	/* Adapt mode TRIGGER */
		/* const */ unsigned int IDS            : 1;	/* Input delay STATE */
		/* const */ unsigned int IDT            : 1;	/* Input delay TRIGGER */
		/* const */ unsigned int SEN            : 1;	/* STATE enable */
		/* const */ unsigned int TEN            : 1;	/* TRIGGER enable */
		/* const */ unsigned int RMO            : 1;	/* Reference mode; selection of the relevant the input signal for generation of SUB_INC1 */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_CTRL_0_SHADOW_STATE_type;
#define GTM_DPLL_CTRL_0_SHADOW_STATE	(*( GTM_DPLL_CTRL_0_SHADOW_STATE_type *) 0xf01281e4u)	/* DPLL Control 0 Shadow STATE Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MLT            : 10;	/* multipler for TRIGGER */
		/* const */ unsigned int IFP            : 1;	/* Input filter position */
		/* const */ unsigned int SNU            : 5;	/* STATE number */
		/* const */ unsigned int TNU            : 9;	/* TRIGGER number */
		/* const */ unsigned int AMS            : 1;	/* Adapt mode STATE */
		/* const */ unsigned int AMT            : 1;	/* Adapt mode TRIGGER */
		/* const */ unsigned int IDS            : 1;	/* Input delay STATE */
		/* const */ unsigned int IDT            : 1;	/* Input delay TRIGGER */
		/* const */ unsigned int SEN            : 1;	/* STATE enable */
		/* const */ unsigned int TEN            : 1;	/* TRIGGER enable */
		/* const */ unsigned int RMO            : 1;	/* Reference mode */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_CTRL_0_SHADOW_TRIGGER_type;
#define GTM_DPLL_CTRL_0_SHADOW_TRIGGER	(*( GTM_DPLL_CTRL_0_SHADOW_TRIGGER_type *) 0xf01281e0u)	/* DPLL Control0 Shadow Trigger Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DMO            : 1;	/* DPLL mode select */
		unsigned int DEN            : 1;	/* DPLL enable */
		/* const */ unsigned int Reserved       : 1;	/* Reserved */
		unsigned int COA            : 1;	/* Correction strategy in automatic end mode (DMO=0) */
		unsigned int PIT            : 1;	/* Plausibility value PVT to next valid TRIGGER is time related */
		unsigned int SGE1           : 1;	/* SUB_INC1 generator enable */
		unsigned int DLM1           : 1;	/* Direct Load Mode for SUB_INC1 generation */
		unsigned int PCM1           : 1;	/* Pulse Correction Mode for SUB_INC1 generation */
		unsigned int SGE2           : 1;	/* SUB_INC2 generator enable */
		unsigned int DLM2           : 1;	/* Direct Load Mode for SUB_INC2 generation */
		unsigned int PCM2           : 1;	/* Pulse Correction Mode for SUB_INC2 generation */
		unsigned int SYN_NS         : 5;	/* Synchronization number of STATE */
		unsigned int SYN_NT         : 5;	/* Synchronization number of TRIGGER */
		/* const */ unsigned int Reserved_14    : 2;	/* Reserved */
		unsigned int SWR            : 1;	/* Software Reset */
		unsigned int SYSF           : 1;	/* SYN_NS for FULL_SCALE */
		unsigned int TS0_HRS        : 1;	/* TS0_HRS */
		unsigned int TS0_HRT        : 1;	/* TS0_HRT */
		unsigned int SMC            : 1;	/* Synchronous Motor Control */
		unsigned int SSL            : 2;	/* STATE slope select */
		unsigned int TSL            : 2;	/* Definition of active slope for signal TRIGGER each active slope is an event defined by TNU */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_CTRL_1_type;
#define GTM_DPLL_CTRL_1	(*( GTM_DPLL_CTRL_1_type *) 0xf0128004u)	/* DPLL Control Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
		unsigned int AEN0           : 1;	/* ACTION_0 enable */
		unsigned int AEN1           : 1;	/* ACTION_1 enable */
		unsigned int AEN2           : 1;	/* ACTION_2 enable */
		unsigned int AEN3           : 1;	/* ACTION_3 enable */
		unsigned int AEN4           : 1;	/* ACTION_4 enable */
		unsigned int AEN5           : 1;	/* ACTION_5 enable */
		unsigned int AEN6           : 1;	/* ACTION_6 enable */
		unsigned int AEN7           : 1;	/* ACTION_7 enable */
		unsigned int WAD0           : 1;	/* Write control bit of Action_0 */
		unsigned int WAD1           : 1;	/* Write control bit of Action_1 */
		unsigned int WAD2           : 1;	/* Write control bit of Action_2 */
		unsigned int WAD3           : 1;	/* Write control bit of Action_3 */
		unsigned int WAD4           : 1;	/* Write control bit of Action_4 */
		unsigned int WAD5           : 1;	/* Write control bit of Action_5 */
		unsigned int WAD6           : 1;	/* Write control bit of Action_6 */
		unsigned int WAD7           : 1;	/* Write control bit of Action_7 */
		/* const */ unsigned int Reserved_18    : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_CTRL_2_type;
#define GTM_DPLL_CTRL_2	(*( GTM_DPLL_CTRL_2_type *) 0xf0128008u)	/* DPLL Control Register 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
		unsigned int AEN8           : 1;	/* ACTION_8 enable */
		unsigned int AEN9           : 1;	/* ACTION_9 enable */
		unsigned int AEN10          : 1;	/* ACTION_10enable */
		unsigned int AEN11          : 1;	/* ACTION_11 enable */
		unsigned int AEN12          : 1;	/* ACTION_12 enable */
		unsigned int AEN13          : 1;	/* ACTION_13 enable */
		unsigned int AEN14          : 1;	/* ACTION_14 enable */
		unsigned int AEN15          : 1;	/* ACTION_15 enable */
		unsigned int WAD8           : 1;	/* Write control bit of Action_8 */
		unsigned int WAD9           : 1;	/* Write control bit of Action_9 */
		unsigned int WAD10          : 1;	/* Write control bit of Action_10 */
		unsigned int WAD11          : 1;	/* Write control bit of Action_11 */
		unsigned int WAD12          : 1;	/* Write control bit of Action_12 */
		unsigned int WAD13          : 1;	/* Write control bit of Action_13 */
		unsigned int WAD14          : 1;	/* Write control bit of Action_14 */
		unsigned int WAD15          : 1;	/* Write control bit of Action_15 */
		/* const */ unsigned int Reserved_18    : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_CTRL_3_type;
#define GTM_DPLL_CTRL_3	(*( GTM_DPLL_CTRL_3_type *) 0xf012800cu)	/* DPLL Control Register 3 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
		unsigned int AEN16          : 1;	/* ACTION_16 enable */
		unsigned int AEN17          : 1;	/* ACTION_17 enable */
		unsigned int AEN18          : 1;	/* ACTION_18 enable */
		unsigned int AEN19          : 1;	/* ACTION_19 enable */
		unsigned int AEN20          : 1;	/* ACTION_20 enable */
		unsigned int AEN21          : 1;	/* ACTION_21 enable */
		unsigned int AEN22          : 1;	/* ACTION_22 enable */
		unsigned int AEN23          : 1;	/* ACTION_23 enable */
		unsigned int WAD16          : 1;	/* Write control bit of Action_16 */
		unsigned int WAD17          : 1;	/* Write control bit of Action_17 */
		unsigned int WAD18          : 1;	/* Write control bit of Action_18 */
		unsigned int WAD19          : 1;	/* Write control bit of Action_19 */
		unsigned int WAD20          : 1;	/* Write control bit of Action_20 */
		unsigned int WAD21          : 1;	/* Write control bit of Action_21 */
		unsigned int WAD22          : 1;	/* Write control bit of Action_22 */
		unsigned int WAD23          : 1;	/* Write control bit of Action_23 */
		/* const */ unsigned int Reserved_18    : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_CTRL_4_type;
#define GTM_DPLL_CTRL_4	(*( GTM_DPLL_CTRL_4_type *) 0xf0128010u)	/* DPLL Control Register 4 */

typedef volatile union
{
	struct
	{ 
		unsigned int ID_PMTR_x      : 9;	/* ID information to the input signal PMTR_x from the ARU */
		/* const */ unsigned int Reserved       : 23;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_ID_PMTR_0_type;
#define GTM_DPLL_ID_PMTR_0	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128050u)	/* DPLL ID Information For Input Signal PMTR 0 Register */
#define GTM_DPLL_ID_PMTR_1	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128054u)	/* DPLL ID Information For Input Signal PMTR 1 Register */
#define GTM_DPLL_ID_PMTR_10	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128078u)	/* DPLL ID Information For Input Signal PMTR 10 Register */
#define GTM_DPLL_ID_PMTR_11	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf012807cu)	/* DPLL ID Information For Input Signal PMTR 11 Register */
#define GTM_DPLL_ID_PMTR_12	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128080u)	/* DPLL ID Information For Input Signal PMTR 12 Register */
#define GTM_DPLL_ID_PMTR_13	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128084u)	/* DPLL ID Information For Input Signal PMTR 13 Register */
#define GTM_DPLL_ID_PMTR_14	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128088u)	/* DPLL ID Information For Input Signal PMTR 14 Register */
#define GTM_DPLL_ID_PMTR_15	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf012808cu)	/* DPLL ID Information For Input Signal PMTR 15 Register */
#define GTM_DPLL_ID_PMTR_16	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128090u)	/* DPLL ID Information For Input Signal PMTR 16 Register */
#define GTM_DPLL_ID_PMTR_17	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128094u)	/* DPLL ID Information For Input Signal PMTR 17 Register */
#define GTM_DPLL_ID_PMTR_18	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128098u)	/* DPLL ID Information For Input Signal PMTR 18 Register */
#define GTM_DPLL_ID_PMTR_19	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf012809cu)	/* DPLL ID Information For Input Signal PMTR 19 Register */
#define GTM_DPLL_ID_PMTR_2	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128058u)	/* DPLL ID Information For Input Signal PMTR 2 Register */
#define GTM_DPLL_ID_PMTR_20	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf01280a0u)	/* DPLL ID Information For Input Signal PMTR 20 Register */
#define GTM_DPLL_ID_PMTR_21	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf01280a4u)	/* DPLL ID Information For Input Signal PMTR 21 Register */
#define GTM_DPLL_ID_PMTR_22	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf01280a8u)	/* DPLL ID Information For Input Signal PMTR 22 Register */
#define GTM_DPLL_ID_PMTR_23	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf01280acu)	/* DPLL ID Information For Input Signal PMTR 23 Register */
#define GTM_DPLL_ID_PMTR_3	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf012805cu)	/* DPLL ID Information For Input Signal PMTR 3 Register */
#define GTM_DPLL_ID_PMTR_4	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128060u)	/* DPLL ID Information For Input Signal PMTR 4 Register */
#define GTM_DPLL_ID_PMTR_5	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128064u)	/* DPLL ID Information For Input Signal PMTR 5 Register */
#define GTM_DPLL_ID_PMTR_6	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128068u)	/* DPLL ID Information For Input Signal PMTR 6 Register */
#define GTM_DPLL_ID_PMTR_7	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf012806cu)	/* DPLL ID Information For Input Signal PMTR 7 Register */
#define GTM_DPLL_ID_PMTR_8	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128070u)	/* DPLL ID Information For Input Signal PMTR 8 Register */
#define GTM_DPLL_ID_PMTR_9	(*( GTM_DPLL_ID_PMTR_0_type *) 0xf0128074u)	/* DPLL ID Information For Input Signal PMTR 9 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int INC_CNT1       : 24;	/* Actual number of pulses to be still sent out at the current increment until the next valid input signal in automatic end mode */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_INC_CNT1_type;
#define GTM_DPLL_INC_CNT1	(*( GTM_DPLL_INC_CNT1_type *) 0xf01280b0u)	/* DPLL Counter for Pulses for TBU_TS1 to be sent in Automatic End Mode */

typedef volatile union
{
	struct
	{ 
		unsigned int INC_CNT2       : 24;	/* Actual number of pulses to be still sent out at the current increment until the next valid input signal in automatic end mode */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_INC_CNT2_type;
#define GTM_DPLL_INC_CNT2	(*( GTM_DPLL_INC_CNT2_type *) 0xf01280b4u)	/* DPLL Counter for Pulses for TBU_TS2 to be sent in Automatic End Mode when SMC=RMO=1 */

typedef volatile union
{
	struct
	{ 
		unsigned int PDI_IRQ_EN     : 1;	/* DPLL disable interrupt enable, when switch off of the DEN bit */
		unsigned int PEI_IRQ_EN     : 1;	/* DPLL enable interrupt enable, when switch on of the DEN bit */
		unsigned int TINI_IRQ_EN    : 1;	/* TRIGGER minimum hold time violation interrupt enable bit */
		unsigned int TAXI_IRQ_EN    : 1;	/* TRIGGER maximum hold time violation interrupt enable bit */
		unsigned int SISI_IRQ_EN    : 1;	/* STATE inactive slope interrupt enable bit */
		unsigned int TISI_IRQ_EN    : 1;	/* TRIGGER inactive slope interrupt enable bit */
		unsigned int MSI_IRQ_EN     : 1;	/* Missing STATE interrupt enable */
		unsigned int MTI_IRQ_EN     : 1;	/* Missing TRIGGER interrupt enable */
		unsigned int SASI_IRQ_EN    : 1;	/* STATE active slope interrupt enable */
		unsigned int TASI_IRQ_EN    : 1;	/* TRIGGER active slope interrupt enable */
		unsigned int PWI_IRQ_EN     : 1;	/* Plausibility window (PVT) violation interrupt of TRIGGER enable */
		unsigned int W2I_IRQ_EN     : 1;	/* RAM write access to RAM region 2 interrupt enable */
		unsigned int W1I_IRQ_EN     : 1;	/* Write access to RAM region 1b or 1c interrupt */
		unsigned int GL1I_IRQ_EN    : 1;	/* Get of lock interrupt enable, when lock arises */
		unsigned int LL1I_IRQ_EN    : 1;	/* Lost of lock interrupt enable */
		unsigned int EI_IRQ_EN      : 1;	/* Error interrupt enable (see status register) */
		unsigned int GL2I_IRQ_EN    : 1;	/* Get of lock interrupt enable for SUB_INC2 */
		unsigned int LL2I_IRQ_EN    : 1;	/* Lost of lock interrupt enable for SUB_INC2 */
		unsigned int TE0I_IRQ_EN    : 1;	/* TRIGGER event interrupt 0 enable */
		unsigned int TE1I_IRQ_EN    : 1;	/* TRIGGER event interrupt 1 enable */
		unsigned int TE2I_IRQ_EN    : 1;	/* TRIGGER event interrupt 2 enable */
		unsigned int TE3I_IRQ_EN    : 1;	/* TRIGGER event interrupt 3 enable */
		unsigned int TE4I_IRQ_EN    : 1;	/* TRIGGER event interrupt 4 enable */
		unsigned int CDTI_IRQ_EN    : 1;	/* Enable interrupt when calculation of TRIGGER duration done */
		unsigned int CDSI_IRQ_EN    : 1;	/* Enable interrupt when calculation of TRIGGER duration done */
		unsigned int TORI           : 1;	/* TRIGGER out of range interrupt */
		unsigned int SORI           : 1;	/* STATE out of range */
		unsigned int DCGI           : 1;	/* Direction change interrupt */
		/* const */ unsigned int Reserved       : 4;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_IRQ_EN_type;
#define GTM_DPLL_IRQ_EN	(*( GTM_DPLL_IRQ_EN_type *) 0xf0128044u)	/* DPLL Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_PDI        : 1;	/* Force Interrupt PDI */
		unsigned int TRG_PEI        : 1;	/* Force Interrupt PEI */
		unsigned int TRG_TINI       : 1;	/* Force Interrupt TINI */
		unsigned int TRG_TAXI       : 1;	/* Force Interrupt TAXI */
		unsigned int TRG_SISI       : 1;	/* Force Interrupt SISI */
		unsigned int TRG_TISI       : 1;	/* Force Interrupt TISI */
		unsigned int TRG_MSI        : 1;	/* Force Interrupt MSI */
		unsigned int TRG_MTI        : 1;	/* Force Interrupt MTI */
		unsigned int TRG_SASI       : 1;	/* Force Interrupt SASI */
		unsigned int TRG_TASI       : 1;	/* Force Interrupt TASI */
		unsigned int TRG_PWI        : 1;	/* Force Interrupt PWI */
		unsigned int TRG_W2I        : 1;	/* Force Interrupt W2IF */
		unsigned int TRG_W1I        : 1;	/* Force Interrupt W1I */
		unsigned int TRG_GL1I       : 1;	/* Force Interrupt GL1I */
		unsigned int TRG_LL1I       : 1;	/* Force Interrupt LL1I */
		unsigned int TRG_EI         : 1;	/* Force Interrupt EI */
		unsigned int TRG_GL2I       : 1;	/* Force Interrupt GL2I */
		unsigned int TRG_LL2I       : 1;	/* Force Interrupt LL2I */
		unsigned int TRG_TE0I       : 1;	/* Force Interrupt TE0I */
		unsigned int TRG_TE1I       : 1;	/* Force Interrupt TE1I */
		unsigned int TRG_TE2I       : 1;	/* Force Interrupt TE2I */
		unsigned int TRG_TE3I       : 1;	/* Force Interrupt TE3I */
		unsigned int TRG_TE4I       : 1;	/* Force Interrupt TE4I */
		unsigned int TRG_CDTI       : 1;	/* Force Interrupt CDTI */
		unsigned int TRG_CDSI       : 1;	/* Force Interrupt CDSI */
		unsigned int TRG_TORI       : 1;	/* Force Interrupt TORI */
		unsigned int TRG_SORI       : 1;	/* Force Interrupt SORI */
		/* const */ unsigned int Reserved       : 5;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_IRQ_FORCINT_type;
#define GTM_DPLL_IRQ_FORCINT	(*( GTM_DPLL_IRQ_FORCINT_type *) 0xf0128048u)	/* DPLL Interrupt Force Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PDI            : 1;	/* DPLL disable interrupt */
		unsigned int PEI            : 1;	/* DPLL enable interrupt */
		unsigned int TINI           : 1;	/* TRIGGER minimum hold time violation interrupt (?T) */
		unsigned int TAXI           : 1;	/* TRIGGER maximum hold time violation interrupt (?T'gt'THMA'gt'0) */
		unsigned int SISI           : 1;	/* STATE inactive slope interrupt */
		unsigned int TISI           : 1;	/* TRIGGER inactive slope interrupt */
		unsigned int MSI            : 1;	/* Missing STATE interrupt */
		unsigned int MTI            : 1;	/* Missing TRIGGER interrupt */
		unsigned int SASI           : 1;	/* STATE active slope interrupt */
		unsigned int TASI           : 1;	/* TRIGGER active slope interrupt */
		unsigned int PWI            : 1;	/* Plausibility window (PVT) violation interrupt of TRIGGER */
		unsigned int W2I            : 1;	/* RAM write access to RAM region 2 interrupt */
		unsigned int W1I            : 1;	/* Write access to RAM region 1b or 1c interrupt */
		unsigned int GL1I           : 1;	/* Get of lock interrupt, for SUB_INC1 */
		unsigned int LL1I           : 1;	/* Lost of lock interrupt for SUB_INC1 */
		unsigned int EI             : 1;	/* Error interrupt (see status register bit 31) */
		unsigned int GL2I           : 1;	/* Get of lock interrupt, for SUB_INC2 */
		unsigned int LL2I           : 1;	/* Lost of lock interrupt for SUB_INC2 */
		unsigned int TE0I           : 1;	/* TRIGGER event interrupt 0 */
		unsigned int TE1I           : 1;	/* TRIGGER event interrupt 1 */
		unsigned int TE2I           : 1;	/* TRIGGER event interrupt 2 */
		unsigned int TE3I           : 1;	/* TRIGGER event interrupt 3 */
		unsigned int TE4I           : 1;	/* TRIGGER event interrupt 4 */
		unsigned int CDTI           : 1;	/* Calculation of TRIGGER duration done, only while NTI_CNT is zero */
		unsigned int CDSI           : 1;	/* Calculation of STATE duration done */
		unsigned int TORI           : 1;	/* TRIGGER out of range interrupt */
		unsigned int SORI           : 1;	/* STATE out of range */
		unsigned int DCGI           : 1;	/* Direction change interrupt */
		/* const */ unsigned int Reserved       : 4;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_IRQ_NOTIFY_type;
#define GTM_DPLL_IRQ_NOTIFY	(*( GTM_DPLL_IRQ_NOTIFY_type *) 0xf0128040u)	/* DPLL Interrupt Notification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NTI_CNT        : 10;	/* Number of TRIGGERs to interrupt */
		/* const */ unsigned int Reserved       : 22;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_NTI_CNT_type;
#define GTM_DPLL_NTI_CNT	(*( GTM_DPLL_NTI_CNT_type *) 0xf012803cu)	/* DPLL Number of Active TRIGGER Events to Interrupt */

typedef volatile union
{
	struct
	{ 
		unsigned int NUSE           : 6;	/* Number of recent STATE events used for SUB_INCx calculations modulo 2*(SNUmax+1) */
		unsigned int FSS            : 1;	/* this value is to be set, when NUSE is set to FULL_SCALE */
		unsigned int SYN_S          : 6;	/* Number of real and virtual events to be considered for the current increment */
		unsigned int SYN_S_old      : 6;	/* Number of real and virtual events to be considered for the last increment */
		unsigned int VSN            : 6;	/* Virtual STATE number */
		/* const */ unsigned int Reserved       : 4;	/* Reserved */
		unsigned int WNUS           : 1;	/* Write control bit for NUSE; read as zero */
		unsigned int WSYN           : 1;	/* Write control bit for SYN_S and SYN_S_old; read as zero */
		unsigned int WVSN           : 1;	/* Write control bit for VSN; read as zero */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_NUSC_type;
#define GTM_DPLL_NUSC	(*( GTM_DPLL_NUSC_type *) 0xf0128038u)	/* DPLL Number of Recent STATE Events Used for Calculations */

typedef volatile union
{
	struct
	{ 
		unsigned int NUTE           : 10;	/* Number of recent TRIGGER events used for SUB_INC1 and action calculations modulo 2*(TNUmax+1) */
		unsigned int FST            : 1;	/* this value is to be set, when NUTE is set to FULL_SCALE */
		/* const */ unsigned int Reserved       : 2;	/* Reserved */
		unsigned int SYN_T          : 3;	/* Number of real and virtual events to be considered for the current increment */
		unsigned int SYN_T_old      : 3;	/* Number of real and virtual events to be considered for the last increment */
		unsigned int VTN            : 6;	/* Virtual TRIGGER number */
		/* const */ unsigned int Reserved_7     : 4;	/* Reserved */
		unsigned int WNUT           : 1;	/* Write control bit for NUTE */
		unsigned int WSYN           : 1;	/* Write control bit for SYN_T and SYN_T_old */
		unsigned int WVTN           : 1;	/* Write control bit for VTN */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_NUTC_type;
#define GTM_DPLL_NUTC	(*( GTM_DPLL_NUTC_type *) 0xf0128034u)	/* DPLL Number of Recent TRIGGER Events Used for Calculations */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SWON_S         : 1;	/* Switch of new STATE */
		/* const */ unsigned int SWON_T         : 1;	/* Switch of new TRIGGER */
		/* const */ unsigned int Reserved       : 6;	/* Reserved */
		unsigned int OSS            : 2;	/* Offset size of RAM region 2 */
		/* const */ unsigned int Reserved_5     : 22;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_OSW_type;
#define GTM_DPLL_OSW	(*( GTM_DPLL_OSW_type *) 0xf012801cu)	/* DPLL Offset And Switch Old/New Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PSAC           : 24;	/* Calculated position value for the start of ACTION_i in normal or emergency mode according to equations 1617 or 1620 respectively */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_PSAC_0_type;
#define GTM_DPLL_PSAC_0	(*( GTM_DPLL_PSAC_0_type *) 0xf0128160u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_1	(*( GTM_DPLL_PSAC_0_type *) 0xf0128164u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_10	(*( GTM_DPLL_PSAC_0_type *) 0xf0128188u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_11	(*( GTM_DPLL_PSAC_0_type *) 0xf012818cu)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_12	(*( GTM_DPLL_PSAC_0_type *) 0xf0128190u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_13	(*( GTM_DPLL_PSAC_0_type *) 0xf0128194u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_14	(*( GTM_DPLL_PSAC_0_type *) 0xf0128198u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_15	(*( GTM_DPLL_PSAC_0_type *) 0xf012819cu)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_16	(*( GTM_DPLL_PSAC_0_type *) 0xf01281a0u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_17	(*( GTM_DPLL_PSAC_0_type *) 0xf01281a4u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_18	(*( GTM_DPLL_PSAC_0_type *) 0xf01281a8u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_19	(*( GTM_DPLL_PSAC_0_type *) 0xf01281acu)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_2	(*( GTM_DPLL_PSAC_0_type *) 0xf0128168u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_20	(*( GTM_DPLL_PSAC_0_type *) 0xf01281b0u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_21	(*( GTM_DPLL_PSAC_0_type *) 0xf01281b4u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_22	(*( GTM_DPLL_PSAC_0_type *) 0xf01281b8u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_23	(*( GTM_DPLL_PSAC_0_type *) 0xf01281bcu)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_3	(*( GTM_DPLL_PSAC_0_type *) 0xf012816cu)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_4	(*( GTM_DPLL_PSAC_0_type *) 0xf0128170u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_5	(*( GTM_DPLL_PSAC_0_type *) 0xf0128174u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_6	(*( GTM_DPLL_PSAC_0_type *) 0xf0128178u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_7	(*( GTM_DPLL_PSAC_0_type *) 0xf012817cu)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_8	(*( GTM_DPLL_PSAC_0_type *) 0xf0128180u)	/* Calculated Position Value for ACTION_i Register */
#define GTM_DPLL_PSAC_9	(*( GTM_DPLL_PSAC_0_type *) 0xf0128184u)	/* Calculated Position Value for ACTION_i Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int INIT_1a        : 1;	/* RAM region 1a initialization in progress */
		/* const */ unsigned int INIT_1b        : 1;	/* RAM region 1b initialization in progress */
		/* const */ unsigned int INIT_2         : 1;	/* RAM region 2 initialization in progress */
		/* const */ unsigned int Reserved       : 1;	/* Reserved */
		unsigned int INIT_RAM       : 1;	/* RAM regions 1a, 1b and 2 are to be initialized */
		/* const */ unsigned int Reserved_6     : 27;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_RAM_INI_type;
#define GTM_DPLL_RAM_INI	(*( GTM_DPLL_RAM_INI_type *) 0xf01281fcu)	/* DPLL RAM Initatlisation Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CSON           : 1;	/* Calculated STATE duration overflow nominal */
		unsigned int CSO            : 1;	/* Calculated STATE duration overflow */
		unsigned int CTON           : 1;	/* Calculated TRIGGER duration overflow nominal */
		unsigned int CTO            : 1;	/* Calculated TRIGGER duration overflow */
		unsigned int CRO            : 1;	/* Calculated Reciprocal value overflow */
		/* const */ unsigned int RCS            : 1;	/* Resolution conflict STATE */
		/* const */ unsigned int RCT            : 1;	/* Resolution conflict TRIGGER */
		/* const */ unsigned int PSE            : 1;	/* Prediction space configuration error */
		unsigned int SOR            : 1;	/* STATE out of range The SOR Bit is set, when the time to the next active STATE slope exceeds the value of the last nominal STATE duration multiplied with the value of the SLR register (see ) and is reset, when at the current or last valid input event a direction change was detected. */
		unsigned int MS             : 1;	/* Missing STATE detected */
		unsigned int TOR            : 1;	/* TRIGGER out of range The TOR Bit is set, when the time to the next active TRIGGER slope exceeds the value of the last nominal TRIGGER duration multiplied with the value of the TLR register (see ) and is reset, when at the current or last vaild input event a direction change was detected. The DPLL_STATUS register is reset, when DPLL is disabled (switching DEN from 1 for 0). */
		unsigned int MT             : 1;	/* Missing TRIGGER detected */
		unsigned int RAM2_ERR       : 1;	/* DPLL internal access to not configured RAM2 memory */
		/* const */ unsigned int Reserved       : 2;	/* Reserved */
		/* const */ unsigned int LOW_RES        : 1;	/* Low resolution of TBU_TS0 is used for DPLL input */
		/* const */ unsigned int CSVS           : 1;	/* Current signal value STATE */
		/* const */ unsigned int CSVT           : 1;	/* Current signal value TRIGGER */
		/* const */ unsigned int CAIP2          : 1;	/* Calculation of actions 12 to 23 in progress (2nd part) */
		/* const */ unsigned int CAIP1          : 1;	/* Calculation of actions 0 to 11 in progress (1st part) */
		/* const */ unsigned int ISN            : 1;	/* Increment number of STATE is not plausible */
		/* const */ unsigned int ITN            : 1;	/* Increment number of TRIGGER is not plausible */
		/* const */ unsigned int BWD2           : 1;	/* Backwards drive of SUB_INC2 */
		/* const */ unsigned int BWD1           : 1;	/* Backwards drive of SUB_INC1 */
		/* const */ unsigned int Reserved_24    : 1;	/* Reserved */
		/* const */ unsigned int LOCK2          : 1;	/* DPLL Lock status concerning SUB_INC2 */
		/* const */ unsigned int SYS            : 1;	/* Synchronization condition of STATE fixed */
		/* const */ unsigned int SYT            : 1;	/* Synchronization condition of TRIGGER fixed */
		/* const */ unsigned int FSD            : 1;	/* First STATE detected */
		/* const */ unsigned int FTD            : 1;	/* First TRIGGER detected */
		/* const */ unsigned int LOCK1          : 1;	/* DPLL Lock status concerning SUB_INC1 */
		/* const */ unsigned int ERR            : 1;	/* Error during configuration or operation resulting in unexpected values */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_STATUS_type;
#define GTM_DPLL_STATUS	(*( GTM_DPLL_STATUS_type *) 0xf0128014u)	/* DPLL Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TSAC           : 24;	/* Calculated time stamp for ACTION_i */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_DPLL_TSA_0_type;
#define GTM_DPLL_TSA_0	(*( GTM_DPLL_TSA_0_type *) 0xf0128100u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_1	(*( GTM_DPLL_TSA_0_type *) 0xf0128104u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_10	(*( GTM_DPLL_TSA_0_type *) 0xf0128128u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_11	(*( GTM_DPLL_TSA_0_type *) 0xf012812cu)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_12	(*( GTM_DPLL_TSA_0_type *) 0xf0128130u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_13	(*( GTM_DPLL_TSA_0_type *) 0xf0128134u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_14	(*( GTM_DPLL_TSA_0_type *) 0xf0128138u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_15	(*( GTM_DPLL_TSA_0_type *) 0xf012813cu)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_16	(*( GTM_DPLL_TSA_0_type *) 0xf0128140u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_17	(*( GTM_DPLL_TSA_0_type *) 0xf0128144u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_18	(*( GTM_DPLL_TSA_0_type *) 0xf0128148u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_19	(*( GTM_DPLL_TSA_0_type *) 0xf012814cu)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_2	(*( GTM_DPLL_TSA_0_type *) 0xf0128108u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_20	(*( GTM_DPLL_TSA_0_type *) 0xf0128150u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_21	(*( GTM_DPLL_TSA_0_type *) 0xf0128154u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_22	(*( GTM_DPLL_TSA_0_type *) 0xf0128158u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_23	(*( GTM_DPLL_TSA_0_type *) 0xf012815cu)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_3	(*( GTM_DPLL_TSA_0_type *) 0xf012810cu)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_4	(*( GTM_DPLL_TSA_0_type *) 0xf0128110u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_5	(*( GTM_DPLL_TSA_0_type *) 0xf0128114u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_6	(*( GTM_DPLL_TSA_0_type *) 0xf0128118u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_7	(*( GTM_DPLL_TSA_0_type *) 0xf012811cu)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_8	(*( GTM_DPLL_TSA_0_type *) 0xf0128120u)	/* Calculated Time Stamp For ACTION_i Register */
#define GTM_DPLL_TSA_9	(*( GTM_DPLL_TSA_0_type *) 0xf0128124u)	/* Calculated Time Stamp For ACTION_i Register */

typedef volatile union
{
	struct
	{ 
		unsigned int INSEL0         : 4;	/* In Selection for DSADCx GTM connection */
		unsigned int INSEL1         : 4;	/* In Selection for DSADCx GTM connection */
		unsigned int INSEL2         : 4;	/* In Selection for DSADCx GTM connection */
		unsigned int INSEL3         : 4;	/* In Selection for DSADCx GTM connection */
		unsigned int INSEL4         : 4;	/* In Selection for DSADCx GTM connection */
		unsigned int INSEL5         : 4;	/* In Selection for DSADCx GTM connection */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} GTM_DSADCINSEL1_type;
#define GTM_DSADCINSEL1	(*( GTM_DSADCINSEL1_type *) 0xf019fd80u)	/* DSADC Input Select 1 Register */
#define GTM_DSADCINSEL2	(*( GTM_DSADCINSEL1_type *) 0xf019fd84u)	/* DSADC Input Select 2 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 1;
		unsigned int SEL1           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 1;
		unsigned int SEL2           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 1;
		unsigned int SEL3           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 1;
		unsigned int SEL4           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 1;
		unsigned int SEL5           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} GTM_DSADCOUTSEL00_type;
#define GTM_DSADCOUTSEL00	(*( GTM_DSADCOUTSEL00_type *) 0xf019fd88u)	/* DSADC Output Select 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 1;
		unsigned int SEL1           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 1;
		unsigned int SEL2           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 1;
		unsigned int SEL3           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 1;
		unsigned int SEL4           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 1;
		unsigned int SEL5           : 3;	/* Output Selection for DSADCx GTM connection */
		unsigned int                : 9;
	} B;
	int I;
	unsigned int U;

} GTM_DSADCOUTSEL10_type;
#define GTM_DSADCOUTSEL10	(*( GTM_DSADCOUTSEL10_type *) 0xf019fd90u)	/* DSADC Output Select 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 9;	/* ARU Read address */
		/* const */ unsigned int Reserved       : 23;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_F2A0_CH0_ARU_RD_FIFO_type;
#define GTM_F2A0_CH0_ARU_RD_FIFO	(*( GTM_F2A0_CH0_ARU_RD_FIFO_type *) 0xf0118000u)	/* F2A Read Channel Address Register */
#define GTM_F2A0_CH1_ARU_RD_FIFO	(*( GTM_F2A0_CH0_ARU_RD_FIFO_type *) 0xf0118004u)	/* F2A Read Channel Address Register */
#define GTM_F2A0_CH2_ARU_RD_FIFO	(*( GTM_F2A0_CH0_ARU_RD_FIFO_type *) 0xf0118008u)	/* F2A Read Channel Address Register */
#define GTM_F2A0_CH3_ARU_RD_FIFO	(*( GTM_F2A0_CH0_ARU_RD_FIFO_type *) 0xf011800cu)	/* F2A Read Channel Address Register */
#define GTM_F2A0_CH4_ARU_RD_FIFO	(*( GTM_F2A0_CH0_ARU_RD_FIFO_type *) 0xf0118010u)	/* F2A Read Channel Address Register */
#define GTM_F2A0_CH5_ARU_RD_FIFO	(*( GTM_F2A0_CH0_ARU_RD_FIFO_type *) 0xf0118014u)	/* F2A Read Channel Address Register */
#define GTM_F2A0_CH6_ARU_RD_FIFO	(*( GTM_F2A0_CH0_ARU_RD_FIFO_type *) 0xf0118018u)	/* F2A Read Channel Address Register */
#define GTM_F2A0_CH7_ARU_RD_FIFO	(*( GTM_F2A0_CH0_ARU_RD_FIFO_type *) 0xf011801cu)	/* F2A Read Channel Address Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
		unsigned int TMODE          : 2;	/* Transfer mode for 53 bit ARU data from/to FIFO */
		unsigned int DIR            : 1;	/* Data transfer direction */
		/* const */ unsigned int Reserved_4     : 13;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_F2A0_CH0_STR_CFG_type;
#define GTM_F2A0_CH0_STR_CFG	(*( GTM_F2A0_CH0_STR_CFG_type *) 0xf0118020u)	/* F2A Stream 0 Configuration Register */
#define GTM_F2A0_CH1_STR_CFG	(*( GTM_F2A0_CH0_STR_CFG_type *) 0xf0118024u)	/* F2A Stream 1 Configuration Register */
#define GTM_F2A0_CH2_STR_CFG	(*( GTM_F2A0_CH0_STR_CFG_type *) 0xf0118028u)	/* F2A Stream 2 Configuration Register */
#define GTM_F2A0_CH3_STR_CFG	(*( GTM_F2A0_CH0_STR_CFG_type *) 0xf011802cu)	/* F2A Stream 3 Configuration Register */
#define GTM_F2A0_CH4_STR_CFG	(*( GTM_F2A0_CH0_STR_CFG_type *) 0xf0118030u)	/* F2A Stream 4 Configuration Register */
#define GTM_F2A0_CH5_STR_CFG	(*( GTM_F2A0_CH0_STR_CFG_type *) 0xf0118034u)	/* F2A Stream 5 Configuration Register */
#define GTM_F2A0_CH6_STR_CFG	(*( GTM_F2A0_CH0_STR_CFG_type *) 0xf0118038u)	/* F2A Stream 6 Configuration Register */
#define GTM_F2A0_CH7_STR_CFG	(*( GTM_F2A0_CH0_STR_CFG_type *) 0xf011803cu)	/* F2A Stream 7 Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int STR0_EN        : 2;	/* Enable/disable stream 0 */
		unsigned int STR1_EN        : 2;	/* Enable/disable stream 1 */
		unsigned int STR2_EN        : 2;	/* Enable/disable stream 2 */
		unsigned int STR3_EN        : 2;	/* Enable/disable stream 3 */
		unsigned int STR4_EN        : 2;	/* Enable/disable stream 4 */
		unsigned int STR5_EN        : 2;	/* Enable/disable stream 5 */
		unsigned int STR6_EN        : 2;	/* Enable/disable stream 6 */
		unsigned int STR7_EN        : 2;	/* Enable/disable stream 7 */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_F2A0_ENABLE_type;
#define GTM_F2A0_ENABLE	(*( GTM_F2A0_ENABLE_type *) 0xf0118040u)	/* F2A0 Stream Activation Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RBM            : 1;	/* Ring buffer mode enable */
		unsigned int RAP            : 1;	/* RAM access priority */
		unsigned int FLUSH          : 1;	/* FIFO Flush control */
		unsigned int WULOCK         : 1;	/* RAM write unlock Enable/disable direct RAM write access to the memory mapped FIFO region */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_CTRL_type;
#define GTM_FIFO0_CH0_CTRL	(*( GTM_FIFO0_CH0_CTRL_type *) 0xf0118400u)	/* FIFO0 Channel 0 Control Register */
#define GTM_FIFO0_CH1_CTRL	(*( GTM_FIFO0_CH0_CTRL_type *) 0xf0118420u)	/* FIFO0 Channel 1 Control Register */
#define GTM_FIFO0_CH2_CTRL	(*( GTM_FIFO0_CH0_CTRL_type *) 0xf0118440u)	/* FIFO0 Channel 2 Control Register */
#define GTM_FIFO0_CH3_CTRL	(*( GTM_FIFO0_CH0_CTRL_type *) 0xf0118460u)	/* FIFO0 Channel 3 Control Register */
#define GTM_FIFO0_CH4_CTRL	(*( GTM_FIFO0_CH0_CTRL_type *) 0xf0118480u)	/* FIFO0 Channel 4 Control Register */
#define GTM_FIFO0_CH5_CTRL	(*( GTM_FIFO0_CH0_CTRL_type *) 0xf01184a0u)	/* FIFO0 Channel 5 Control Register */
#define GTM_FIFO0_CH6_CTRL	(*( GTM_FIFO0_CH0_CTRL_type *) 0xf01184c0u)	/* FIFO0 Channel 6 Control Register */
#define GTM_FIFO0_CH7_CTRL	(*( GTM_FIFO0_CH0_CTRL_type *) 0xf01184e0u)	/* FIFO0 Channel 7 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 10;	/* End address for FIFOi channel x, (x:0...7) */
		/* const */ unsigned int Reserved       : 22;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_END_ADDR_type;
#define GTM_FIFO0_CH0_END_ADDR	(*( GTM_FIFO0_CH0_END_ADDR_type *) 0xf0118404u)	/* FIFO0 Channel 0 End Address Register */
#define GTM_FIFO0_CH1_END_ADDR	(*( GTM_FIFO0_CH0_END_ADDR_type *) 0xf0118424u)	/* FIFO0 Channel 1 End Address Register */
#define GTM_FIFO0_CH2_END_ADDR	(*( GTM_FIFO0_CH0_END_ADDR_type *) 0xf0118444u)	/* FIFO0 Channel 2 End Address Register */
#define GTM_FIFO0_CH3_END_ADDR	(*( GTM_FIFO0_CH0_END_ADDR_type *) 0xf0118464u)	/* FIFO0 Channel 3 End Address Register */
#define GTM_FIFO0_CH4_END_ADDR	(*( GTM_FIFO0_CH0_END_ADDR_type *) 0xf0118484u)	/* FIFO0 Channel 4 End Address Register */
#define GTM_FIFO0_CH5_END_ADDR	(*( GTM_FIFO0_CH0_END_ADDR_type *) 0xf01184a4u)	/* FIFO0 Channel 5 End Address Register */
#define GTM_FIFO0_CH6_END_ADDR	(*( GTM_FIFO0_CH0_END_ADDR_type *) 0xf01184c4u)	/* FIFO0 Channel 6 End Address Register */
#define GTM_FIFO0_CH7_END_ADDR	(*( GTM_FIFO0_CH0_END_ADDR_type *) 0xf01184e4u)	/* FIFO0 Channel 7 End Address Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int LEVEL          : 11;	/* Fill level of the current FIFO */
		/* const */ unsigned int Reserved       : 21;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_FILL_LEVEL_type;
#define GTM_FIFO0_CH0_FILL_LEVEL	(*( GTM_FIFO0_CH0_FILL_LEVEL_type *) 0xf0118418u)	/* FIFO0 Channel 0 Fill Level Register */
#define GTM_FIFO0_CH1_FILL_LEVEL	(*( GTM_FIFO0_CH0_FILL_LEVEL_type *) 0xf0118438u)	/* FIFO0 Channel 1 Fill Level Register */
#define GTM_FIFO0_CH2_FILL_LEVEL	(*( GTM_FIFO0_CH0_FILL_LEVEL_type *) 0xf0118458u)	/* FIFO0 Channel 2 Fill Level Register */
#define GTM_FIFO0_CH3_FILL_LEVEL	(*( GTM_FIFO0_CH0_FILL_LEVEL_type *) 0xf0118478u)	/* FIFO0 Channel 3 Fill Level Register */
#define GTM_FIFO0_CH4_FILL_LEVEL	(*( GTM_FIFO0_CH0_FILL_LEVEL_type *) 0xf0118498u)	/* FIFO0 Channel 4 Fill Level Register */
#define GTM_FIFO0_CH5_FILL_LEVEL	(*( GTM_FIFO0_CH0_FILL_LEVEL_type *) 0xf01184b8u)	/* FIFO0 Channel 5 Fill Level Register */
#define GTM_FIFO0_CH6_FILL_LEVEL	(*( GTM_FIFO0_CH0_FILL_LEVEL_type *) 0xf01184d8u)	/* FIFO0 Channel 6 Fill Level Register */
#define GTM_FIFO0_CH7_FILL_LEVEL	(*( GTM_FIFO0_CH0_FILL_LEVEL_type *) 0xf01184f8u)	/* FIFO0 Channel 7 Fill Level Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FIFO_EMPTY_IRQ_EN: 1;	/* interrupt enable */
		unsigned int FIFO_FULL_IRQ_EN: 1;	/* interrupt enable */
		unsigned int FIFO_LWM_IRQ_EN: 1;	/* interrupt enable */
		unsigned int FIFO_UWM_IRQ_EN: 1;	/* interrupt enable */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_IRQ_EN_type;
#define GTM_FIFO0_CH0_IRQ_EN	(*( GTM_FIFO0_CH0_IRQ_EN_type *) 0xf0118604u)	/* FIFO0 Channel 0 Interrupt Enable Register */
#define GTM_FIFO0_CH1_IRQ_EN	(*( GTM_FIFO0_CH0_IRQ_EN_type *) 0xf0118624u)	/* FIFO0 Channel 1 Interrupt Enable Register */
#define GTM_FIFO0_CH2_IRQ_EN	(*( GTM_FIFO0_CH0_IRQ_EN_type *) 0xf0118644u)	/* FIFO0 Channel 2 Interrupt Enable Register */
#define GTM_FIFO0_CH3_IRQ_EN	(*( GTM_FIFO0_CH0_IRQ_EN_type *) 0xf0118664u)	/* FIFO0 Channel 3 Interrupt Enable Register */
#define GTM_FIFO0_CH4_IRQ_EN	(*( GTM_FIFO0_CH0_IRQ_EN_type *) 0xf0118684u)	/* FIFO0 Channel 4 Interrupt Enable Register */
#define GTM_FIFO0_CH5_IRQ_EN	(*( GTM_FIFO0_CH0_IRQ_EN_type *) 0xf01186a4u)	/* FIFO0 Channel 5 Interrupt Enable Register */
#define GTM_FIFO0_CH6_IRQ_EN	(*( GTM_FIFO0_CH0_IRQ_EN_type *) 0xf01186c4u)	/* FIFO0 Channel 6 Interrupt Enable Register */
#define GTM_FIFO0_CH7_IRQ_EN	(*( GTM_FIFO0_CH0_IRQ_EN_type *) 0xf01186e4u)	/* FIFO0 Channel 7 Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_FIFO_EMPTY : 1;	/* Force interrupt of FIFO empty status */
		unsigned int TRG_FIFO_FULL  : 1;	/* Force interrupt of FIFO full status */
		unsigned int TRG_FIFO_LWM   : 1;	/* Force interrupt of lower watermark */
		unsigned int TRG_FIFO_UWM   : 1;	/* Force interrupt of upper watermark */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_IRQ_FORCINT_type;
#define GTM_FIFO0_CH0_IRQ_FORCINT	(*( GTM_FIFO0_CH0_IRQ_FORCINT_type *) 0xf0118608u)	/* FIFO0 Channel0 Force Interrupt By Software Register */
#define GTM_FIFO0_CH1_IRQ_FORCINT	(*( GTM_FIFO0_CH0_IRQ_FORCINT_type *) 0xf0118628u)	/* FIFO0 Channel1 Force Interrupt By Software Register */
#define GTM_FIFO0_CH2_IRQ_FORCINT	(*( GTM_FIFO0_CH0_IRQ_FORCINT_type *) 0xf0118648u)	/* FIFO0 Channel2 Force Interrupt By Software Register */
#define GTM_FIFO0_CH3_IRQ_FORCINT	(*( GTM_FIFO0_CH0_IRQ_FORCINT_type *) 0xf0118668u)	/* FIFO0 Channel3 Force Interrupt By Software Register */
#define GTM_FIFO0_CH4_IRQ_FORCINT	(*( GTM_FIFO0_CH0_IRQ_FORCINT_type *) 0xf0118688u)	/* FIFO0 Channel4 Force Interrupt By Software Register */
#define GTM_FIFO0_CH5_IRQ_FORCINT	(*( GTM_FIFO0_CH0_IRQ_FORCINT_type *) 0xf01186a8u)	/* FIFO0 Channel5 Force Interrupt By Software Register */
#define GTM_FIFO0_CH6_IRQ_FORCINT	(*( GTM_FIFO0_CH0_IRQ_FORCINT_type *) 0xf01186c8u)	/* FIFO0 Channel6 Force Interrupt By Software Register */
#define GTM_FIFO0_CH7_IRQ_FORCINT	(*( GTM_FIFO0_CH0_IRQ_FORCINT_type *) 0xf01186e8u)	/* FIFO0 Channel7 Force Interrupt By Software Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IRQ_MODE       : 2;	/* IRQ mode selection */
		unsigned int DMA_HYSTERESIS : 1;	/* Enable DMA hysteresis mode */
		unsigned int DMA_HYST_DIR   : 1;	/* DMA direction in hysteresis mode */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_IRQ_MODE_type;
#define GTM_FIFO0_CH0_IRQ_MODE	(*( GTM_FIFO0_CH0_IRQ_MODE_type *) 0xf011860cu)	/* FIFO0 Channel0 IRQ Mode Control Register */
#define GTM_FIFO0_CH1_IRQ_MODE	(*( GTM_FIFO0_CH0_IRQ_MODE_type *) 0xf011862cu)	/* FIFO0 Channel1 IRQ Mode Control Register */
#define GTM_FIFO0_CH2_IRQ_MODE	(*( GTM_FIFO0_CH0_IRQ_MODE_type *) 0xf011864cu)	/* FIFO0 Channel2 IRQ Mode Control Register */
#define GTM_FIFO0_CH3_IRQ_MODE	(*( GTM_FIFO0_CH0_IRQ_MODE_type *) 0xf011866cu)	/* FIFO0 Channel3 IRQ Mode Control Register */
#define GTM_FIFO0_CH4_IRQ_MODE	(*( GTM_FIFO0_CH0_IRQ_MODE_type *) 0xf011868cu)	/* FIFO0 Channel4 IRQ Mode Control Register */
#define GTM_FIFO0_CH5_IRQ_MODE	(*( GTM_FIFO0_CH0_IRQ_MODE_type *) 0xf01186acu)	/* FIFO0 Channel5 IRQ Mode Control Register */
#define GTM_FIFO0_CH6_IRQ_MODE	(*( GTM_FIFO0_CH0_IRQ_MODE_type *) 0xf01186ccu)	/* FIFO0 Channel6 IRQ Mode Control Register */
#define GTM_FIFO0_CH7_IRQ_MODE	(*( GTM_FIFO0_CH0_IRQ_MODE_type *) 0xf01186ecu)	/* FIFO0 Channel7 IRQ Mode Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FIFO_EMPTY     : 1;	/* FIFO is empty */
		unsigned int FIFO_FULL      : 1;	/* FIFO is full */
		unsigned int FIFO_LWM       : 1;	/* FIFO Lower watermark was under-run */
		unsigned int FIFO_UWM       : 1;	/* FIFO Upper watermark was over-run */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_IRQ_NOTIFY_type;
#define GTM_FIFO0_CH0_IRQ_NOTIFY	(*( GTM_FIFO0_CH0_IRQ_NOTIFY_type *) 0xf0118600u)	/* FIFO0 Channel0 Interrupt Notification Register */
#define GTM_FIFO0_CH1_IRQ_NOTIFY	(*( GTM_FIFO0_CH0_IRQ_NOTIFY_type *) 0xf0118620u)	/* FIFO0 Channel1 Interrupt Notification Register */
#define GTM_FIFO0_CH2_IRQ_NOTIFY	(*( GTM_FIFO0_CH0_IRQ_NOTIFY_type *) 0xf0118640u)	/* FIFO0 Channel2 Interrupt Notification Register */
#define GTM_FIFO0_CH3_IRQ_NOTIFY	(*( GTM_FIFO0_CH0_IRQ_NOTIFY_type *) 0xf0118660u)	/* FIFO0 Channel3 Interrupt Notification Register */
#define GTM_FIFO0_CH4_IRQ_NOTIFY	(*( GTM_FIFO0_CH0_IRQ_NOTIFY_type *) 0xf0118680u)	/* FIFO0 Channel4 Interrupt Notification Register */
#define GTM_FIFO0_CH5_IRQ_NOTIFY	(*( GTM_FIFO0_CH0_IRQ_NOTIFY_type *) 0xf01186a0u)	/* FIFO0 Channel5 Interrupt Notification Register */
#define GTM_FIFO0_CH6_IRQ_NOTIFY	(*( GTM_FIFO0_CH0_IRQ_NOTIFY_type *) 0xf01186c0u)	/* FIFO0 Channel6 Interrupt Notification Register */
#define GTM_FIFO0_CH7_IRQ_NOTIFY	(*( GTM_FIFO0_CH0_IRQ_NOTIFY_type *) 0xf01186e0u)	/* FIFO0 Channel7 Interrupt Notification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 10;	/* Normal Operation mode Upper watermark Ring buffer operation mode Gate pointer from LWU to UWE */
		/* const */ unsigned int Reserved       : 22;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_LOWER_WM_type;
#define GTM_FIFO0_CH0_LOWER_WM	(*( GTM_FIFO0_CH0_LOWER_WM_type *) 0xf0118410u)	/* FIFO0 Channel 0 Lower Watermark Register */
#define GTM_FIFO0_CH1_LOWER_WM	(*( GTM_FIFO0_CH0_LOWER_WM_type *) 0xf0118430u)	/* FIFO0 Channel 1 Lower Watermark Register */
#define GTM_FIFO0_CH2_LOWER_WM	(*( GTM_FIFO0_CH0_LOWER_WM_type *) 0xf0118450u)	/* FIFO0 Channel 2 Lower Watermark Register */
#define GTM_FIFO0_CH3_LOWER_WM	(*( GTM_FIFO0_CH0_LOWER_WM_type *) 0xf0118470u)	/* FIFO0 Channel 3 Lower Watermark Register */
#define GTM_FIFO0_CH4_LOWER_WM	(*( GTM_FIFO0_CH0_LOWER_WM_type *) 0xf0118490u)	/* FIFO0 Channel 4 Lower Watermark Register */
#define GTM_FIFO0_CH5_LOWER_WM	(*( GTM_FIFO0_CH0_LOWER_WM_type *) 0xf01184b0u)	/* FIFO0 Channel 5 Lower Watermark Register */
#define GTM_FIFO0_CH6_LOWER_WM	(*( GTM_FIFO0_CH0_LOWER_WM_type *) 0xf01184d0u)	/* FIFO0 Channel 6 Lower Watermark Register */
#define GTM_FIFO0_CH7_LOWER_WM	(*( GTM_FIFO0_CH0_LOWER_WM_type *) 0xf01184f0u)	/* FIFO0 Channel 7 Lower Watermark Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ADDR           : 10;	/* Position of the read pointer */
		/* const */ unsigned int Reserved       : 22;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_RD_PTR_type;
#define GTM_FIFO0_CH0_RD_PTR	(*( GTM_FIFO0_CH0_RD_PTR_type *) 0xf0118504u)	/* FIFO0 Channel 0 Read Pointer Register */
#define GTM_FIFO0_CH1_RD_PTR	(*( GTM_FIFO0_CH0_RD_PTR_type *) 0xf0118524u)	/* FIFO0 Channel 1 Read Pointer Register */
#define GTM_FIFO0_CH2_RD_PTR	(*( GTM_FIFO0_CH0_RD_PTR_type *) 0xf0118544u)	/* FIFO0 Channel 2 Read Pointer Register */
#define GTM_FIFO0_CH3_RD_PTR	(*( GTM_FIFO0_CH0_RD_PTR_type *) 0xf0118564u)	/* FIFO0 Channel 3 Read Pointer Register */
#define GTM_FIFO0_CH4_RD_PTR	(*( GTM_FIFO0_CH0_RD_PTR_type *) 0xf0118584u)	/* FIFO0 Channel 4 Read Pointer Register */
#define GTM_FIFO0_CH5_RD_PTR	(*( GTM_FIFO0_CH0_RD_PTR_type *) 0xf01185a4u)	/* FIFO0 Channel 5 Read Pointer Register */
#define GTM_FIFO0_CH6_RD_PTR	(*( GTM_FIFO0_CH0_RD_PTR_type *) 0xf01185c4u)	/* FIFO0 Channel 6 Read Pointer Register */
#define GTM_FIFO0_CH7_RD_PTR	(*( GTM_FIFO0_CH0_RD_PTR_type *) 0xf01185e4u)	/* FIFO0 Channel 7 Read Pointer Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 10;	/* End address for FIFOi channel x, (x07) */
		/* const */ unsigned int Reserved       : 22;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_START_ADDR_type;
#define GTM_FIFO0_CH0_START_ADDR	(*( GTM_FIFO0_CH0_START_ADDR_type *) 0xf0118408u)	/* FIFO0 Channel 0 Start Address Register */
#define GTM_FIFO0_CH1_START_ADDR	(*( GTM_FIFO0_CH0_START_ADDR_type *) 0xf0118428u)	/* FIFO0 Channel 1 Start Address Register */
#define GTM_FIFO0_CH2_START_ADDR	(*( GTM_FIFO0_CH0_START_ADDR_type *) 0xf0118448u)	/* FIFO0 Channel 2 Start Address Register */
#define GTM_FIFO0_CH3_START_ADDR	(*( GTM_FIFO0_CH0_START_ADDR_type *) 0xf0118468u)	/* FIFO0 Channel 3 Start Address Register */
#define GTM_FIFO0_CH4_START_ADDR	(*( GTM_FIFO0_CH0_START_ADDR_type *) 0xf0118488u)	/* FIFO0 Channel 4 Start Address Register */
#define GTM_FIFO0_CH5_START_ADDR	(*( GTM_FIFO0_CH0_START_ADDR_type *) 0xf01184a8u)	/* FIFO0 Channel 5 Start Address Register */
#define GTM_FIFO0_CH6_START_ADDR	(*( GTM_FIFO0_CH0_START_ADDR_type *) 0xf01184c8u)	/* FIFO0 Channel 6 Start Address Register */
#define GTM_FIFO0_CH7_START_ADDR	(*( GTM_FIFO0_CH0_START_ADDR_type *) 0xf01184e8u)	/* FIFO0 Channel 7 Start Address Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int EMPTY          : 1;	/* FIFO x fill level status (x07) */
		/* const */ unsigned int FULL           : 1;	/* FIFO x fill level status (x07) */
		/* const */ unsigned int LOW_WM         : 1;	/* Lower watermark reached */
		/* const */ unsigned int UP_WM          : 1;	/* Upper watermark reached */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_STATUS_type;
#define GTM_FIFO0_CH0_STATUS	(*( GTM_FIFO0_CH0_STATUS_type *) 0xf0118414u)	/* FIFO0 Channel 0 Status Register */
#define GTM_FIFO0_CH1_STATUS	(*( GTM_FIFO0_CH0_STATUS_type *) 0xf0118434u)	/* FIFO0 Channel 1 Status Register */
#define GTM_FIFO0_CH2_STATUS	(*( GTM_FIFO0_CH0_STATUS_type *) 0xf0118454u)	/* FIFO0 Channel 2 Status Register */
#define GTM_FIFO0_CH3_STATUS	(*( GTM_FIFO0_CH0_STATUS_type *) 0xf0118474u)	/* FIFO0 Channel 3 Status Register */
#define GTM_FIFO0_CH4_STATUS	(*( GTM_FIFO0_CH0_STATUS_type *) 0xf0118494u)	/* FIFO0 Channel 4 Status Register */
#define GTM_FIFO0_CH5_STATUS	(*( GTM_FIFO0_CH0_STATUS_type *) 0xf01184b4u)	/* FIFO0 Channel 5 Status Register */
#define GTM_FIFO0_CH6_STATUS	(*( GTM_FIFO0_CH0_STATUS_type *) 0xf01184d4u)	/* FIFO0 Channel 6 Status Register */
#define GTM_FIFO0_CH7_STATUS	(*( GTM_FIFO0_CH0_STATUS_type *) 0xf01184f4u)	/* FIFO0 Channel 7 Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDR           : 10;	/* Normal Operation mode Upper watermark Ring buffer operation mode Gate pointer from SLW to LWU */
		/* const */ unsigned int Reserved       : 22;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_UPPER_WM_type;
#define GTM_FIFO0_CH0_UPPER_WM	(*( GTM_FIFO0_CH0_UPPER_WM_type *) 0xf011840cu)	/* FIFO0 Channel 0 Upper Watermark Register */
#define GTM_FIFO0_CH1_UPPER_WM	(*( GTM_FIFO0_CH0_UPPER_WM_type *) 0xf011842cu)	/* FIFO0 Channel 1 Upper Watermark Register */
#define GTM_FIFO0_CH2_UPPER_WM	(*( GTM_FIFO0_CH0_UPPER_WM_type *) 0xf011844cu)	/* FIFO0 Channel 2 Upper Watermark Register */
#define GTM_FIFO0_CH3_UPPER_WM	(*( GTM_FIFO0_CH0_UPPER_WM_type *) 0xf011846cu)	/* FIFO0 Channel 3 Upper Watermark Register */
#define GTM_FIFO0_CH4_UPPER_WM	(*( GTM_FIFO0_CH0_UPPER_WM_type *) 0xf011848cu)	/* FIFO0 Channel 4 Upper Watermark Register */
#define GTM_FIFO0_CH5_UPPER_WM	(*( GTM_FIFO0_CH0_UPPER_WM_type *) 0xf01184acu)	/* FIFO0 Channel 5 Upper Watermark Register */
#define GTM_FIFO0_CH6_UPPER_WM	(*( GTM_FIFO0_CH0_UPPER_WM_type *) 0xf01184ccu)	/* FIFO0 Channel 6 Upper Watermark Register */
#define GTM_FIFO0_CH7_UPPER_WM	(*( GTM_FIFO0_CH0_UPPER_WM_type *) 0xf01184ecu)	/* FIFO0 Channel 7 Upper Watermark Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ADDR           : 10;	/* Position of the write pointer */
		/* const */ unsigned int Reserved       : 22;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_FIFO0_CH0_WR_PTR_type;
#define GTM_FIFO0_CH0_WR_PTR	(*( GTM_FIFO0_CH0_WR_PTR_type *) 0xf0118500u)	/* FIFO0 Channel 0 Write Pointer Register */
#define GTM_FIFO0_CH1_WR_PTR	(*( GTM_FIFO0_CH0_WR_PTR_type *) 0xf0118520u)	/* FIFO0 Channel 1 Write Pointer Register */
#define GTM_FIFO0_CH2_WR_PTR	(*( GTM_FIFO0_CH0_WR_PTR_type *) 0xf0118540u)	/* FIFO0 Channel 2 Write Pointer Register */
#define GTM_FIFO0_CH3_WR_PTR	(*( GTM_FIFO0_CH0_WR_PTR_type *) 0xf0118560u)	/* FIFO0 Channel 3 Write Pointer Register */
#define GTM_FIFO0_CH4_WR_PTR	(*( GTM_FIFO0_CH0_WR_PTR_type *) 0xf0118580u)	/* FIFO0 Channel 4 Write Pointer Register */
#define GTM_FIFO0_CH5_WR_PTR	(*( GTM_FIFO0_CH0_WR_PTR_type *) 0xf01185a0u)	/* FIFO0 Channel 5 Write Pointer Register */
#define GTM_FIFO0_CH6_WR_PTR	(*( GTM_FIFO0_CH0_WR_PTR_type *) 0xf01185c0u)	/* FIFO0 Channel 6 Write Pointer Register */
#define GTM_FIFO0_CH7_WR_PTR	(*( GTM_FIFO0_CH0_WR_PTR_type *) 0xf01185e0u)	/* FIFO0 Channel 7 Write Pointer Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ARU_NEW_DATA0_IRQ: 1;	/* ARU_NEW_DATA0 interrupt */
		/* const */ unsigned int ARU_NEW_DATA1_IRQ: 1;	/* ARU_NEW_DATA1 interrupt */
		/* const */ unsigned int ARU_ACC_ACK_IRQ: 1;	/* ARU_ACC_ACK interrupt */
		/* const */ unsigned int BRC_IRQ        : 1;	/* BRC shared submodule interrupt */
		/* const */ unsigned int AEI_IRQ        : 1;	/* AEI_IRQ interrupt */
		/* const */ unsigned int CMP_IRQ        : 1;	/* CMP shared submodule interrupt */
		/* const */ unsigned int SPE0_IRQ       : 1;	/* SPE0 shared submodule interrupt */
		/* const */ unsigned int SPE1_IRQ       : 1;	/* SPE1 shared submodule interrupt */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
		/* const */ unsigned int PSM0_CH0_IRQ   : 1;	/* PSM0 shared submodule channel 0 interrupt */
		/* const */ unsigned int PSM0_CH1_IRQ   : 1;	/* PSM0 shared submodule channel 1 interrupt */
		/* const */ unsigned int PSM0_CH2_IRQ   : 1;	/* PSM0 shared submodule channel 2 interrupt */
		/* const */ unsigned int PSM0_CH3_IRQ   : 1;	/* PSM0 shared submodule channel 3 interrupt */
		/* const */ unsigned int PSM0_CH4_IRQ   : 1;	/* PSM0 shared submodule channel 4 interrupt */
		/* const */ unsigned int PSM0_CH5_IRQ   : 1;	/* PSM0 shared submodule channel 5 interrupt */
		/* const */ unsigned int PSM0_CH6_IRQ   : 1;	/* PSM0 shared submodule channel 6 interrupt */
		/* const */ unsigned int PSM0_CH7_IRQ   : 1;	/* PSM0 shared submodule channel 7 interrupt */
		/* const */ unsigned int Reserved_18    : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ICM_IRQG_0_type;
#define GTM_ICM_IRQG_0	(*( GTM_ICM_IRQG_0_type *) 0xf0100600u)	/* GTM Infrastructure Interrupt Group */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int DPLL_DCG_IRQ   : 1;	/* TRIGGER direction change detected. */
		/* const */ unsigned int DPLL_EDI_IRQ   : 1;	/* DPLL enable/disable interrupt */
		/* const */ unsigned int DPLL_TIN_IRQ   : 1;	/* TRIGGER minimum hold time (THMI) violation detected interrupt */
		/* const */ unsigned int DPLL_TAX_IRQ   : 1;	/* TRIGGER maximum hold time (THMA) violation detected interrupt */
		/* const */ unsigned int DPLL_SIS_IRQ   : 1;	/* STATE inactive slope detected interrupt. See bit 0. */
		/* const */ unsigned int DPLL_TIS_IRQ   : 1;	/* TRIGGER inactive slope detected interrupt. See bit 0. */
		/* const */ unsigned int DPLL_MSI_IRQ   : 1;	/* Missing STATE interrupt */
		/* const */ unsigned int DPLL_MTI_IRQ   : 1;	/* Missing TRIGGER interrupt */
		/* const */ unsigned int DPLL_SAS_IRQ   : 1;	/* STATE active slope detected */
		/* const */ unsigned int DPLL_TAS_IRQ   : 1;	/* TRIGGER active slope detected while NTI_CNT is zero */
		/* const */ unsigned int DPLL_PWI_IRQ   : 1;	/* Plausibility window (PVT) violation interrupt of TRIGGER */
		/* const */ unsigned int DPLL_W2I_IRQ   : 1;	/* Write access to RAM region 2 interrupt */
		/* const */ unsigned int DPLL_W1I_IRQ   : 1;	/* Write access to RAM region 1b or 1c interrupt */
		/* const */ unsigned int DPLL_GLI_IRQ   : 1;	/* Get of lock interrupt for SUB_INC1 */
		/* const */ unsigned int DPLL_LLI_IRQ   : 1;	/* Lost of lock interrupt for SUB_INC1 */
		/* const */ unsigned int DPLL_EI_IRQ    : 1;	/* Error interrupt See bit 0 */
		/* const */ unsigned int DPLL_GL2I_IRQ  : 1;	/* Get of lock interrupt for SUB_INC2 */
		/* const */ unsigned int DPLL_LL2I_IRQ  : 1;	/* Lost of lock interrupt for SUB_INC2 */
		/* const */ unsigned int DPLL_TE0_IRQ   : 1;	/* TRIGGER event interrupt 0 */
		/* const */ unsigned int DPLL_TE1_IRQ   : 1;	/* TRIGGER event interrupt 1 */
		/* const */ unsigned int DPLL_TE2_IRQ   : 1;	/* TRIGGER event interrupt 2 */
		/* const */ unsigned int DPLL_TE3_IRQ   : 1;	/* TRIGGER event interrupt 3 */
		/* const */ unsigned int DPLL_TE4_IRQ   : 1;	/* TRIGGER event interrupt 4 */
		/* const */ unsigned int DPLL_CDIT_IRQ  : 1;	/* DPLL calculated duration interrupt for trigger */
		/* const */ unsigned int DPLL_CDIS_IRQ  : 1;	/* DPLL calculated duration interrupt for state */
		/* const */ unsigned int DPLL_TORI_IRQ  : 1;	/* DPLL calculated duration interrupt for state */
		/* const */ unsigned int DPLL_SORI_IRQ  : 1;	/* DPLL calculated duration interrupt for state */
		/* const */ unsigned int Reserved       : 5;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ICM_IRQG_1_type;
#define GTM_ICM_IRQG_1	(*( GTM_ICM_IRQG_1_type *) 0xf0100604u)	/* GTM DPLL Interrupt Group */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ATOM4_CH0_IRQ  : 1;	/* ATOM4 channel 0 shared interrupt */
		/* const */ unsigned int ATOM4_CH1_IRQ  : 1;	/* ATOM4 channel 1 shared interrupt */
		/* const */ unsigned int ATOM4_CH2_IRQ  : 1;	/* ATOM4 channel 2 shared interrupt */
		/* const */ unsigned int ATOM4_CH3_IRQ  : 1;	/* ATOM4 channel 3 shared interrupt */
		/* const */ unsigned int ATOM4_CH4_IRQ  : 1;	/* ATOM4 channel 4 shared interrupt */
		/* const */ unsigned int ATOM4_CH5_IRQ  : 1;	/* ATOM4 channel 5 shared interrupt */
		/* const */ unsigned int ATOM4_CH6_IRQ  : 1;	/* ATOM4 channel 6 shared interrupt */
		/* const */ unsigned int ATOM4_CH7_IRQ  : 1;	/* ATOM4 channel 7 shared interrupt */
		/* const */ unsigned int Reserved       : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ICM_IRQG_10_type;
#define GTM_ICM_IRQG_10	(*( GTM_ICM_IRQG_10_type *) 0xf0100628u)	/* ATOM Interrupt Group 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TIM0_CH0_IRQ   : 1;	/* TIM0 shared interrupt channel 0. */
		/* const */ unsigned int TIM0_CH1_IRQ   : 1;	/* TIM0 shared interrupt channel 1 */
		/* const */ unsigned int TIM0_CH2_IRQ   : 1;	/* TIM0 shared interrupt channel 2 */
		/* const */ unsigned int TIM0_CH3_IRQ   : 1;	/* TIM0 shared interrupt channel 3 */
		/* const */ unsigned int TIM0_CH4_IRQ   : 1;	/* TIM0 shared interrupt channel 4 */
		/* const */ unsigned int TIM0_CH5_IRQ   : 1;	/* TIM0 shared interrupt channel 5 */
		/* const */ unsigned int TIM0_CH6_IRQ   : 1;	/* TIM0 shared interrupt channel 6 */
		/* const */ unsigned int TIM0_CH7_IRQ   : 1;	/* TIM0 shared interrupt channel 7 */
		/* const */ unsigned int TIM1_CH0_IRQ   : 1;	/* TIM1 shared interrupt channel 0 */
		/* const */ unsigned int TIM1_CH1_IRQ   : 1;	/* TIM1 shared interrupt channel 1 */
		/* const */ unsigned int TIM1_CH2_IRQ   : 1;	/* TIM1 shared interrupt channel 2 */
		/* const */ unsigned int TIM1_CH3_IRQ   : 1;	/* TIM1 shared interrupt channel 3 */
		/* const */ unsigned int TIM1_CH4_IRQ   : 1;	/* TIM1 shared interrupt channel 4 */
		/* const */ unsigned int TIM1_CH5_IRQ   : 1;	/* TIM1 shared interrupt channel 5 */
		/* const */ unsigned int TIM1_CH6_IRQ   : 1;	/* TIM1 shared interrupt channel 6 */
		/* const */ unsigned int TIM1_CH7_IRQ   : 1;	/* TIM1 shared interrupt channel 7 */
		/* const */ unsigned int TIM2_CH0_IRQ   : 1;	/* TIM2 shared interrupt channel 0 */
		/* const */ unsigned int TIM2_CH1_IRQ   : 1;	/* TIM2 shared interrupt channel 1 */
		/* const */ unsigned int TIM2_CH2_IRQ   : 1;	/* TIM2 shared interrupt channel 2 */
		/* const */ unsigned int TIM2_CH3_IRQ   : 1;	/* TIM2 shared interrupt channel 3 */
		/* const */ unsigned int TIM2_CH4_IRQ   : 1;	/* TIM2 shared interrupt channel 4 */
		/* const */ unsigned int TIM2_CH5_IRQ   : 1;	/* TIM2 shared interrupt channel 5 */
		/* const */ unsigned int TIM2_CH6_IRQ   : 1;	/* TIM2 shared interrupt channel 6 */
		/* const */ unsigned int TIM2_CH7_IRQ   : 1;	/* TIM2 shared interrupt channel 7 */
		/* const */ unsigned int TIM3_CH0_IRQ   : 1;	/* TIM3 shared interrupt channel 0 */
		/* const */ unsigned int TIM3_CH1_IRQ   : 1;	/* TIM3 shared interrupt channel 1 */
		/* const */ unsigned int TIM3_CH2_IRQ   : 1;	/* TIM3 shared interrupt channel 2 */
		/* const */ unsigned int TIM3_CH3_IRQ   : 1;	/* TIM3 shared interrupt channel 3 */
		/* const */ unsigned int TIM3_CH4_IRQ   : 1;	/* TIM3 shared interrupt channel 4 */
		/* const */ unsigned int TIM3_CH5_IRQ   : 1;	/* TIM3 shared interrupt channel 5 */
		/* const */ unsigned int TIM3_CH6_IRQ   : 1;	/* TIM3 shared interrupt channel 6 */
		/* const */ unsigned int TIM3_CH7_IRQ   : 1;	/* TIM3 shared interrupt channel 7 */
	} B;
	int I;
	unsigned int U;

} GTM_ICM_IRQG_2_type;
#define GTM_ICM_IRQG_2	(*( GTM_ICM_IRQG_2_type *) 0xf0100608u)	/* TIM Interrupt Group 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MCS0_CH0_IRQ   : 1;	/* MCS0 channel 0 interrupt */
		/* const */ unsigned int MCS0_CH1_IRQ   : 1;	/* MCS0 channel 1 interrupt */
		/* const */ unsigned int MCS0_CH2_IRQ   : 1;	/* MCS0 channel 2 interrupt */
		/* const */ unsigned int MCS0_CH3_IRQ   : 1;	/* MCS0 channel 3 interrupt */
		/* const */ unsigned int MCS0_CH4_IRQ   : 1;	/* MCS0 channel 4 interrupt */
		/* const */ unsigned int MCS0_CH5_IRQ   : 1;	/* MCS0 channel 5 interrupt */
		/* const */ unsigned int MCS0_CH6_IRQ   : 1;	/* MCS0 channel 6 interrupt */
		/* const */ unsigned int MCS0_CH7_IRQ   : 1;	/* MCS0 channel 7 interrupt */
		/* const */ unsigned int MCS1_CH0_IRQ   : 1;	/* MCS1 channel 0 interrupt */
		/* const */ unsigned int MCS1_CH1_IRQ   : 1;	/* MCS1 channel 1 interrupt */
		/* const */ unsigned int MCS1_CH2_IRQ   : 1;	/* MCS1 channel 2 interrupt */
		/* const */ unsigned int MCS1_CH3_IRQ   : 1;	/* MCS1 channel 3 interrupt */
		/* const */ unsigned int MCS1_CH4_IRQ   : 1;	/* MCS1 channel 4 interrupt */
		/* const */ unsigned int MCS1_CH5_IRQ   : 1;	/* MCS1 channel 5 interrupt */
		/* const */ unsigned int MCS1_CH6_IRQ   : 1;	/* MCS1 channel 6 interrupt */
		/* const */ unsigned int MCS1_CH7_IRQ   : 1;	/* MCS1 channel 7 interrupt */
		/* const */ unsigned int MCS2_CH0_IRQ   : 1;	/* MCS1 channel 0 interrupt */
		/* const */ unsigned int MCS2_CH1_IRQ   : 1;	/* MCS2 channel 1 interrupt */
		/* const */ unsigned int MCS2_CH2_IRQ   : 1;	/* MCS2 channel 2 interrupt */
		/* const */ unsigned int MCS2_CH3_IRQ   : 1;	/* MCS2 channel 3 interrupt */
		/* const */ unsigned int MCS2_CH4_IRQ   : 1;	/* MCS2 channel 4 interrupt */
		/* const */ unsigned int MCS2_CH5_IRQ   : 1;	/* MCS2 channel 5 interrupt */
		/* const */ unsigned int MCS2_CH6_IRQ   : 1;	/* MCS2 channel 6 interrupt */
		/* const */ unsigned int MCS2_CH7_IRQ   : 1;	/* MCS2 channel 7 interrupt */
		/* const */ unsigned int MCS3_CH0_IRQ   : 1;	/* MCS3 channel 0 interrupt */
		/* const */ unsigned int MCS3_CH1_IRQ   : 1;	/* MCS3 channel 1 interrupt */
		/* const */ unsigned int MCS3_CH2_IRQ   : 1;	/* MCS3 channel 2 interrupt */
		/* const */ unsigned int MCS3_CH3_IRQ   : 1;	/* MCS3 channel 3 interrupt */
		/* const */ unsigned int MCS3_CH4_IRQ   : 1;	/* MCS3 channel 4 interrupt */
		/* const */ unsigned int MCS3_CH5_IRQ   : 1;	/* MCS3 channel 5 interrupt */
		/* const */ unsigned int MCS3_CH6_IRQ   : 1;	/* MCS3 channel 6 interrupt */
		/* const */ unsigned int MCS3_CH7_IRQ   : 1;	/* MCS3 channel 7 interrupt */
	} B;
	int I;
	unsigned int U;

} GTM_ICM_IRQG_4_type;
#define GTM_ICM_IRQG_4	(*( GTM_ICM_IRQG_4_type *) 0xf0100610u)	/* MCS Interrupt Group 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TOM0_CH0_IRQ   : 1;	/* TOM0 channel 0 shared interrupt */
		/* const */ unsigned int TOM0_CH1_IRQ   : 1;	/* TOM0 channel 1 shared interrupt */
		/* const */ unsigned int TOM0_CH2_IRQ   : 1;	/* TOM0 channel 2 shared interrupt */
		/* const */ unsigned int TOM0_CH3_IRQ   : 1;	/* TOM0 channel 3 shared interrupt */
		/* const */ unsigned int TOM0_CH4_IRQ   : 1;	/* TOM0 channel 4 shared interrupt */
		/* const */ unsigned int TOM0_CH5_IRQ   : 1;	/* TOM0 channel 5 shared interrupt */
		/* const */ unsigned int TOM0_CH6_IRQ   : 1;	/* TOM0 channel 6 shared interrupt */
		/* const */ unsigned int TOM0_CH7_IRQ   : 1;	/* TOM0 channel 7 shared interrupt */
		/* const */ unsigned int TOM0_CH8_IRQ   : 1;	/* TOM0 channel 8 shared interrupt */
		/* const */ unsigned int TOM0_CH9_IRQ   : 1;	/* TOM0 channel 9 shared interrupt */
		/* const */ unsigned int TOM0_CH10_IRQ  : 1;	/* TOM0 channel 10 shared interrupt */
		/* const */ unsigned int TOM0_CH11_IRQ  : 1;	/* TOM0 channel 11 shared interrupt */
		/* const */ unsigned int TOM0_CH12_IRQ  : 1;	/* TOM0 channel 12 shared interrupt */
		/* const */ unsigned int TOM0_CH13_IRQ  : 1;	/* TOM0 channel 13 shared interrupt */
		/* const */ unsigned int TOM0_CH14_IRQ  : 1;	/* TOM0 channel 14 shared interrupt */
		/* const */ unsigned int TOM0_CH15_IRQ  : 1;	/* TOM0 channel 15 shared interrupt */
		/* const */ unsigned int TOM1_CH0_IRQ   : 1;	/* TOM1 channel 0 shared interrupt */
		/* const */ unsigned int TOM1_CH1_IRQ   : 1;	/* TOM1 channel 1 shared interrupt */
		/* const */ unsigned int TOM1_CH2_IRQ   : 1;	/* TOM1 channel 2 shared interrupt */
		/* const */ unsigned int TOM1_CH3_IRQ   : 1;	/* TOM1 channel 3 shared interrupt */
		/* const */ unsigned int TOM1_CH4_IRQ   : 1;	/* TOM1 channel 4 shared interrupt */
		/* const */ unsigned int TOM1_CH5_IRQ   : 1;	/* TOM1 channel 5 shared interrupt */
		/* const */ unsigned int TOM1_CH6_IRQ   : 1;	/* TOM1 channel 6 shared interrupt */
		/* const */ unsigned int TOM1_CH7_IRQ   : 1;	/* TOM1 channel 7 shared interrupt */
		/* const */ unsigned int TOM1_CH8_IRQ   : 1;	/* TOM1 channel 8 shared interrupt */
		/* const */ unsigned int TOM1_CH9_IRQ   : 1;	/* TOM1 channel 9 shared interrupt */
		/* const */ unsigned int TOM1_CH10_IRQ  : 1;	/* TOM1 channel 10 shared interrupt */
		/* const */ unsigned int TOM1_CH11_IRQ  : 1;	/* TOM1 channel 11 shared interrupt */
		/* const */ unsigned int TOM1_CH12_IRQ  : 1;	/* TOM1 channel 12 shared interrupt */
		/* const */ unsigned int TOM1_CH13_IRQ  : 1;	/* TOM1 channel 13 shared interrupt */
		/* const */ unsigned int TOM1_CH14_IRQ  : 1;	/* TOM1 channel 14 shared interrupt */
		/* const */ unsigned int TOM1_CH15_IRQ  : 1;	/* TOM1 channel 15 shared interrupt */
	} B;
	int I;
	unsigned int U;

} GTM_ICM_IRQG_6_type;
#define GTM_ICM_IRQG_6	(*( GTM_ICM_IRQG_6_type *) 0xf0100618u)	/* TOM Interrupt Group 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TOM2_CH0_IRQ   : 1;	/* TOM2 channel 0 shared interrupt */
		/* const */ unsigned int TOM2_CH1_IRQ   : 1;	/* TOM2 channel 1 shared interrupt */
		/* const */ unsigned int TOM2_CH2_IRQ   : 1;	/* TOM2 channel 2 shared interrupt */
		/* const */ unsigned int TOM2_CH3_IRQ   : 1;	/* TOM2 channel 3 shared interrupt */
		/* const */ unsigned int TOM2_CH4_IRQ   : 1;	/* TOM2 channel 4 shared interrupt */
		/* const */ unsigned int TOM2_CH5_IRQ   : 1;	/* TOM2 channel 5 shared interrupt */
		/* const */ unsigned int TOM2_CH6_IRQ   : 1;	/* TOM2 channel 6 shared interrupt */
		/* const */ unsigned int TOM2_CH7_IRQ   : 1;	/* TOM2 channel 7 shared interrupt */
		/* const */ unsigned int TOM2_CH8_IRQ   : 1;	/* TOM2 channel 8 shared interrupt */
		/* const */ unsigned int TOM2_CH9_IRQ   : 1;	/* TOM2 channel 9 shared interrupt */
		/* const */ unsigned int TOM2_CH10_IRQ  : 1;	/* TOM2 channel 10 shared interrupt */
		/* const */ unsigned int TOM2_CH11_IRQ  : 1;	/* TOM2 channel 11 shared interrupt */
		/* const */ unsigned int TOM2_CH12_IRQ  : 1;	/* TOM2 channel 12 shared interrupt */
		/* const */ unsigned int TOM2_CH13_IRQ  : 1;	/* TOM2 channel 13 shared interrupt */
		/* const */ unsigned int TOM2_CH14_IRQ  : 1;	/* TOM2 channel 14 shared interrupt */
		/* const */ unsigned int TOM2_CH15_IRQ  : 1;	/* TOM2 channel 15 shared interrupt */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_ICM_IRQG_7_type;
#define GTM_ICM_IRQG_7	(*( GTM_ICM_IRQG_7_type *) 0xf010061cu)	/* ITOM Interrupt Group 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ATOM0_CH0_IRQ  : 1;	/* ATOM0 channel 0 shared interrupt */
		/* const */ unsigned int ATOM0_CH1_IRQ  : 1;	/* ATOM0 channel 1 shared interrupt */
		/* const */ unsigned int ATOM0_CH2_IRQ  : 1;	/* ATOM0 channel 2 shared interrupt */
		/* const */ unsigned int ATOM0_CH3_IRQ  : 1;	/* ATOM0 channel 3 shared interrupt */
		/* const */ unsigned int ATOM0_CH4_IRQ  : 1;	/* ATOM0 channel 4 shared interrupt */
		/* const */ unsigned int ATOM0_CH5_IRQ  : 1;	/* ATOM0 channel 5 shared interrupt */
		/* const */ unsigned int ATOM0_CH6_IRQ  : 1;	/* ATOM0 channel 6 shared interrupt */
		/* const */ unsigned int ATOM0_CH7_IRQ  : 1;	/* ATOM0 channel 7 shared interrupt */
		/* const */ unsigned int ATOM1_CH0_IRQ  : 1;	/* ATOM1 channel 0 shared interrupt */
		/* const */ unsigned int ATOM1_CH1_IRQ  : 1;	/* ATOM1 channel 1 shared interrupt */
		/* const */ unsigned int ATOM1_CH2_IRQ  : 1;	/* ATOM1 channel 2 shared interrupt */
		/* const */ unsigned int ATOM1_CH3_IRQ  : 1;	/* ATOM1 channel 3 shared interrupt */
		/* const */ unsigned int ATOM1_CH4_IRQ  : 1;	/* ATOM1 channel 4 shared interrupt */
		/* const */ unsigned int ATOM1_CH5_IRQ  : 1;	/* ATOM1 channel 5 shared interrupt */
		/* const */ unsigned int ATOM1_CH6_IRQ  : 1;	/* ATOM1 channel 6 shared interrupt */
		/* const */ unsigned int ATOM1_CH7_IRQ  : 1;	/* ATOM1 channel 7 shared interrupt */
		/* const */ unsigned int ATOM2_CH0_IRQ  : 1;	/* ATOM2 channel 0 shared interrupt */
		/* const */ unsigned int ATOM2_CH1_IRQ  : 1;	/* ATOM2 channel 1 shared interrupt */
		/* const */ unsigned int ATOM2_CH2_IRQ  : 1;	/* ATOM2 channel 2 shared interrupt */
		/* const */ unsigned int ATOM2_CH3_IRQ  : 1;	/* ATOM2 channel 3 shared interrupt */
		/* const */ unsigned int ATOM2_CH4_IRQ  : 1;	/* ATOM2 channel 4 shared interrupt */
		/* const */ unsigned int ATOM2_CH5_IRQ  : 1;	/* ATOM2 channel 5 shared interrupt */
		/* const */ unsigned int ATOM2_CH6_IRQ  : 1;	/* ATOM2 channel 6 shared interrupt */
		/* const */ unsigned int ATOM2_CH7_IRQ  : 1;	/* ATOM2 channel 7 shared interrupt */
		/* const */ unsigned int ATOM3_CH0_IRQ  : 1;	/* ATOM3 channel 0 shared interrupt */
		/* const */ unsigned int ATOM3_CH1_IRQ  : 1;	/* ATOM3 channel 1 shared interrupt */
		/* const */ unsigned int ATOM3_CH2_IRQ  : 1;	/* ATOM3 channel 2 shared interrupt */
		/* const */ unsigned int ATOM3_CH3_IRQ  : 1;	/* ATOM3 channel 3 shared interrupt */
		/* const */ unsigned int ATOM3_CH4_IRQ  : 1;	/* ATOM3 channel 4 shared interrupt */
		/* const */ unsigned int ATOM3_CH5_IRQ  : 1;	/* ATOM3 channel 5 shared interrupt */
		/* const */ unsigned int ATOM3_CH6_IRQ  : 1;	/* ATOM3 channel 6 shared interrupt */
		/* const */ unsigned int ATOM3_CH7_IRQ  : 1;	/* ATOM3 channel 7 shared interrupt */
	} B;
	int I;
	unsigned int U;

} GTM_ICM_IRQG_9_type;
#define GTM_ICM_IRQG_9	(*( GTM_ICM_IRQG_9_type *) 0xf0100624u)	/* ATOM Interrupt Group 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int AEI_TO_XPT_IRQ_EN: 1;	/* AEI_TO_XPT_IRQ interrupt enable. */
		unsigned int AEI_USP_ADDR_IRQ_EN: 1;	/* AEI_USP_ADDR_IRQ interrupt enable. */
		unsigned int AEI_IM_ADDR_IRQ_EN: 1;	/* AEI_IM_ADDR_IRQ interrupt enable. */
		unsigned int AEI_USP_BE_IRQ_EN: 1;	/* AEI_USP_BE_IRQ interrupt enable. */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_IRQ_EN_type;
#define GTM_IRQ_EN	(*( GTM_IRQ_EN_type *) 0xf0100014u)	/* GTM Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_AEI_TO_XPT : 1;	/* Trigger AEI_TO_XPT_IRQ interrupt by software. */
		unsigned int TRG_AEI_USP_ADDR: 1;	/* Trigger AEI_USP_ADDR_IRQ interrupt by software. */
		unsigned int TRG_AEI_IM_ADDR: 1;	/* Trigger AEI_IM_ADDR_IRQ interrupt by software. */
		unsigned int TRG_AEI_USP_BE : 1;	/* Trigger AEI_USP_BE_IRQ interrupt by software. */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_IRQ_FORCINT_type;
#define GTM_IRQ_FORCINT	(*( GTM_IRQ_FORCINT_type *) 0xf0100018u)	/* GTM Software Interrupt Generation Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IRQ_MODE       : 2;	/* Interrupt strategy mode selection for the AEI timeout and address monitoring interrupts */
		/* const */ unsigned int Reserved       : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_IRQ_MODE_type;
#define GTM_IRQ_MODE	(*( GTM_IRQ_MODE_type *) 0xf010001cu)	/* GTM Top Level Interrupts Mode Selection */

typedef volatile union
{
	struct
	{ 
		unsigned int AEI_TO_XPT     : 1;	/* AEI Timeout exception occurred */
		unsigned int AEI_USP_ADDR   : 1;	/* AEI Unsupported address interrupt */
		unsigned int AEI_IM_ADDR    : 1;	/* AEI Illegal Module address interrupt */
		unsigned int AEI_USP_BE     : 1;	/* AEI Unsupported byte enable interrupt */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_IRQ_NOTIFY_type;
#define GTM_IRQ_NOTIFY	(*( GTM_IRQ_NOTIFY_type *) 0xf0100010u)	/* GTM Interrupt Notification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} GTM_KRST0_type;
#define GTM_KRST0	(*( GTM_KRST0_type *) 0xf019fdf4u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} GTM_KRST1_type;
#define GTM_KRST1	(*( GTM_KRST1_type *) 0xf019fdf0u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} GTM_KRSTCLR_type;
#define GTM_KRSTCLR	(*( GTM_KRSTCLR_type *) 0xf019fdecu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TSEL           : 1;	/* TRIGGER signal output select. */
		unsigned int SSL            : 3;	/* STATE signal output select. */
		/* const */ unsigned int Reserved       : 12;	/* Reserved */
		unsigned int TSPP0_EN       : 1;	/* Enable of TSPP0 subunit */
		unsigned int TSPP0_DLD      : 1;	/* DIR level definition bit */
		/* const */ unsigned int Reserved_6     : 2;	/* Reserved */
		unsigned int TSPP0_I0V      : 1;	/* Disable of TSPP0 TIM0_CHx(48) input line. */
		unsigned int TSPP0_I1V      : 1;	/* Disable of TSPP0 TIM0_CHy(48) input line. */
		unsigned int TSPP0_I2V      : 1;	/* Disable of TSPP0 TIM0_CHz(48) input line. */
		/* const */ unsigned int Reserved_10    : 1;	/* Reserved */
		unsigned int TSPP1_EN       : 1;	/* Enable of TSPP1 subunit */
		unsigned int TSPP1_DLD      : 1;	/* DIR level definition bit */
		/* const */ unsigned int Reserved_13    : 2;	/* Reserved */
		unsigned int TSPP1_I0V      : 1;	/* Disable of TSPP1 TIM0_CHx(48) input line */
		unsigned int TSPP1_I1V      : 1;	/* Disable of TSPP1 TIM0_CHy(48) input line */
		unsigned int TSPP1_I2V      : 1;	/* Disable of TSPP1 TIM0_CHz(48) input line. */
		/* const */ unsigned int Reserved_17    : 1;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MAP_CTRL_type;
#define GTM_MAP_CTRL	(*( GTM_MAP_CTRL_type *) 0xf0100040u)	/* MAP Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MEM0           : 2;	/* Configure Memory pages for MCS-instance MCS0 */
		unsigned int MEM1           : 2;	/* Configure Memory pages for MCS-instance MCS1 */
		unsigned int MEM2           : 2;	/* Configure Memory pages for MCS-instance MCS2 */
		unsigned int MEM3           : 2;	/* Configure Memory pages for MCS-instance MCS3 */
		/* const */ unsigned int Reserved       : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCFG_CTRL_type;
#define GTM_MCFG_CTRL	(*( GTM_MCFG_CTRL_type *) 0xf0100080u)	/* Memory Layout Configuration Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int ACB0           : 1;	/* ARU Control bit 0 */
		/* const */ unsigned int ACB1           : 1;	/* ARU Control bit 1 */
		/* const */ unsigned int ACB2           : 1;	/* ARU Control bit 2 */
		/* const */ unsigned int ACB3           : 1;	/* ARU Control bit 3 */
		/* const */ unsigned int ACB4           : 1;	/* ARU Control bit 4 */
		/* const */ unsigned int Reserved       : 27;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_CH0_ACB_type;
#define GTM_MCS0_CH0_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0130028u)	/* MCS0 Channel ACB Register */
#define GTM_MCS0_CH1_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01300a8u)	/* MCS0 Channel ACB Register */
#define GTM_MCS0_CH2_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0130128u)	/* MCS0 Channel ACB Register */
#define GTM_MCS0_CH3_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01301a8u)	/* MCS0 Channel ACB Register */
#define GTM_MCS0_CH4_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0130228u)	/* MCS0 Channel ACB Register */
#define GTM_MCS0_CH5_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01302a8u)	/* MCS0 Channel ACB Register */
#define GTM_MCS0_CH6_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0130328u)	/* MCS0 Channel ACB Register */
#define GTM_MCS0_CH7_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01303a8u)	/* MCS0 Channel ACB Register */
#define GTM_MCS1_CH0_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0140028u)	/* MCS1 Channel ACB Register */
#define GTM_MCS1_CH1_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01400a8u)	/* MCS1 Channel ACB Register */
#define GTM_MCS1_CH2_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0140128u)	/* MCS1 Channel ACB Register */
#define GTM_MCS1_CH3_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01401a8u)	/* MCS1 Channel ACB Register */
#define GTM_MCS1_CH4_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0140228u)	/* MCS1 Channel ACB Register */
#define GTM_MCS1_CH5_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01402a8u)	/* MCS1 Channel ACB Register */
#define GTM_MCS1_CH6_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0140328u)	/* MCS1 Channel ACB Register */
#define GTM_MCS1_CH7_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01403a8u)	/* MCS1 Channel ACB Register */
#define GTM_MCS2_CH0_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0150028u)	/* MCS2 Channel ACB Register */
#define GTM_MCS2_CH1_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01500a8u)	/* MCS2 Channel ACB Register */
#define GTM_MCS2_CH2_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0150128u)	/* MCS2 Channel ACB Register */
#define GTM_MCS2_CH3_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01501a8u)	/* MCS2 Channel ACB Register */
#define GTM_MCS2_CH4_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0150228u)	/* MCS2 Channel ACB Register */
#define GTM_MCS2_CH5_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01502a8u)	/* MCS2 Channel ACB Register */
#define GTM_MCS2_CH6_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0150328u)	/* MCS2 Channel ACB Register */
#define GTM_MCS2_CH7_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01503a8u)	/* MCS2 Channel ACB Register */
#define GTM_MCS3_CH0_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0160028u)	/* MCS3 Channel ACB Register */
#define GTM_MCS3_CH1_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01600a8u)	/* MCS3 Channel ACB Register */
#define GTM_MCS3_CH2_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0160128u)	/* MCS3 Channel ACB Register */
#define GTM_MCS3_CH3_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01601a8u)	/* MCS3 Channel ACB Register */
#define GTM_MCS3_CH4_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0160228u)	/* MCS3 Channel ACB Register */
#define GTM_MCS3_CH5_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01602a8u)	/* MCS3 Channel ACB Register */
#define GTM_MCS3_CH6_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf0160328u)	/* MCS3 Channel ACB Register */
#define GTM_MCS3_CH7_ACB	(*( GTM_MCS0_CH0_ACB_type *) 0xf01603a8u)	/* MCS3 Channel ACB Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EN             : 1;	/* Enable MCS-channel */
		/* const */ unsigned int IRQ            : 1;	/* Interrupt state */
		/* const */ unsigned int ERR            : 1;	/* Error state */
		/* const */ unsigned int Reserved       : 1;	/* Reserved */
		/* const */ unsigned int CY             : 1;	/* Carry bit state */
		/* const */ unsigned int Z              : 1;	/* Zero bit state */
		/* const */ unsigned int V              : 1;	/* Overflow bit state */
		/* const */ unsigned int N              : 1;	/* Negative bit state */
		/* const */ unsigned int CAT            : 1;	/* Cancel ARU transfer state */
		/* const */ unsigned int CWT            : 1;	/* Cancel WURM instruction state */
		/* const */ unsigned int Reserved_11    : 6;	/* Reserved */
		/* const */ unsigned int SP_CNT         : 3;	/* Stack pointer counter value */
		/* const */ unsigned int Reserved_13    : 13;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_CH0_CTRL_type;
#define GTM_MCS0_CH0_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0130000u)	/* MCS0 Channel Control Register */
#define GTM_MCS0_CH1_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0130080u)	/* MCS0 Channel Control Register */
#define GTM_MCS0_CH2_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0130100u)	/* MCS0 Channel Control Register */
#define GTM_MCS0_CH3_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0130180u)	/* MCS0 Channel Control Register */
#define GTM_MCS0_CH4_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0130200u)	/* MCS0 Channel Control Register */
#define GTM_MCS0_CH5_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0130280u)	/* MCS0 Channel Control Register */
#define GTM_MCS0_CH6_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0130300u)	/* MCS0 Channel Control Register */
#define GTM_MCS0_CH7_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0130380u)	/* MCS0 Channel Control Register */
#define GTM_MCS1_CH0_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0140000u)	/* MCS1 Channel Control Register */
#define GTM_MCS1_CH1_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0140080u)	/* MCS1 Channel Control Register */
#define GTM_MCS1_CH2_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0140100u)	/* MCS1 Channel Control Register */
#define GTM_MCS1_CH3_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0140180u)	/* MCS1 Channel Control Register */
#define GTM_MCS1_CH4_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0140200u)	/* MCS1 Channel Control Register */
#define GTM_MCS1_CH5_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0140280u)	/* MCS1 Channel Control Register */
#define GTM_MCS1_CH6_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0140300u)	/* MCS1 Channel Control Register */
#define GTM_MCS1_CH7_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0140380u)	/* MCS1 Channel Control Register */
#define GTM_MCS2_CH0_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0150000u)	/* MCS2 Channel Control Register */
#define GTM_MCS2_CH1_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0150080u)	/* MCS2 Channel Control Register */
#define GTM_MCS2_CH2_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0150100u)	/* MCS2 Channel Control Register */
#define GTM_MCS2_CH3_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0150180u)	/* MCS2 Channel Control Register */
#define GTM_MCS2_CH4_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0150200u)	/* MCS2 Channel Control Register */
#define GTM_MCS2_CH5_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0150280u)	/* MCS2 Channel Control Register */
#define GTM_MCS2_CH6_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0150300u)	/* MCS2 Channel Control Register */
#define GTM_MCS2_CH7_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0150380u)	/* MCS2 Channel Control Register */
#define GTM_MCS3_CH0_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0160000u)	/* MCS3 Channel Control Register */
#define GTM_MCS3_CH1_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0160080u)	/* MCS3 Channel Control Register */
#define GTM_MCS3_CH2_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0160100u)	/* MCS3 Channel Control Register */
#define GTM_MCS3_CH3_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0160180u)	/* MCS3 Channel Control Register */
#define GTM_MCS3_CH4_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0160200u)	/* MCS3 Channel Control Register */
#define GTM_MCS3_CH5_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0160280u)	/* MCS3 Channel Control Register */
#define GTM_MCS3_CH6_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0160300u)	/* MCS3 Channel Control Register */
#define GTM_MCS3_CH7_CTRL	(*( GTM_MCS0_CH0_CTRL_type *) 0xf0160380u)	/* MCS3 Channel Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MCS_IRQ_EN     : 1;	/* MCS channel x MCS_IRQ interrupt enable */
		unsigned int STK_ERR_IRQ_EN : 1;	/* MCS channel x STK_ERR_IRQ interrupt enable */
		unsigned int MEM_ERR_IRQ_EN : 1;	/* MCS channel x MEM_ERR_IRQ interrupt enable */
		/* const */ unsigned int Reserved       : 29;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_CH0_IRQ_EN_type;
#define GTM_MCS0_CH0_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0130030u)	/* MCS0 Channel 0 Interrupt Enable Register */
#define GTM_MCS0_CH1_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01300b0u)	/* MCS0 Channel 1 Interrupt Enable Register */
#define GTM_MCS0_CH2_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0130130u)	/* MCS0 Channel 2 Interrupt Enable Register */
#define GTM_MCS0_CH3_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01301b0u)	/* MCS0 Channel 3 Interrupt Enable Register */
#define GTM_MCS0_CH4_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0130230u)	/* MCS0 Channel 4 Interrupt Enable Register */
#define GTM_MCS0_CH5_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01302b0u)	/* MCS0 Channel 5 Interrupt Enable Register */
#define GTM_MCS0_CH6_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0130330u)	/* MCS0 Channel 6 Interrupt Enable Register */
#define GTM_MCS0_CH7_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01303b0u)	/* MCS0 Channel 7 Interrupt Enable Register */
#define GTM_MCS1_CH0_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0140030u)	/* MCS1 Channel 0 Interrupt Enable Register */
#define GTM_MCS1_CH1_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01400b0u)	/* MCS1 Channel 1 Interrupt Enable Register */
#define GTM_MCS1_CH2_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0140130u)	/* MCS1 Channel 2 Interrupt Enable Register */
#define GTM_MCS1_CH3_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01401b0u)	/* MCS1 Channel 3 Interrupt Enable Register */
#define GTM_MCS1_CH4_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0140230u)	/* MCS1 Channel 4 Interrupt Enable Register */
#define GTM_MCS1_CH5_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01402b0u)	/* MCS1 Channel 5 Interrupt Enable Register */
#define GTM_MCS1_CH6_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0140330u)	/* MCS1 Channel 6 Interrupt Enable Register */
#define GTM_MCS1_CH7_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01403b0u)	/* MCS1 Channel 7 Interrupt Enable Register */
#define GTM_MCS2_CH0_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0150030u)	/* MCS2 Channel 0 Interrupt Enable Register */
#define GTM_MCS2_CH1_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01500b0u)	/* MCS2 Channel 1 Interrupt Enable Register */
#define GTM_MCS2_CH2_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0150130u)	/* MCS2 Channel 2 Interrupt Enable Register */
#define GTM_MCS2_CH3_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01501b0u)	/* MCS2 Channel 3 Interrupt Enable Register */
#define GTM_MCS2_CH4_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0150230u)	/* MCS2 Channel 4 Interrupt Enable Register */
#define GTM_MCS2_CH5_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01502b0u)	/* MCS2 Channel 5 Interrupt Enable Register */
#define GTM_MCS2_CH6_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0150330u)	/* MCS2 Channel 6 Interrupt Enable Register */
#define GTM_MCS2_CH7_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01503b0u)	/* MCS2 Channel 7 Interrupt Enable Register */
#define GTM_MCS3_CH0_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0160030u)	/* MCS3 Channel 0 Interrupt Enable Register */
#define GTM_MCS3_CH1_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01600b0u)	/* MCS3 Channel 1 Interrupt Enable Register */
#define GTM_MCS3_CH2_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0160130u)	/* MCS3 Channel 2 Interrupt Enable Register */
#define GTM_MCS3_CH3_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01601b0u)	/* MCS3 Channel 3 Interrupt Enable Register */
#define GTM_MCS3_CH4_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0160230u)	/* MCS3 Channel 4 Interrupt Enable Register */
#define GTM_MCS3_CH5_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01602b0u)	/* MCS3 Channel 5 Interrupt Enable Register */
#define GTM_MCS3_CH6_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf0160330u)	/* MCS3 Channel 6 Interrupt Enable Register */
#define GTM_MCS3_CH7_IRQ_EN	(*( GTM_MCS0_CH0_IRQ_EN_type *) 0xf01603b0u)	/* MCS3 Channel 7 Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_MCS_IRQ    : 1;	/* Trigger IRQ bit in MCS_CH_[x]_IRQ_NOTIFY register by software */
		unsigned int TRG_STK_ERR_IRQ: 1;	/* Trigger IRQ bit in MCS_CH_[x]_IRQ_NOTIFY register by software */
		unsigned int TRG_MEM_ERR_IRQ: 1;	/* Trigger IRQ bit in MCS_CH_[x]_IRQ_NOTIFY register by software */
		/* const */ unsigned int Reserved       : 29;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_CH0_IRQ_FORCINT_type;
#define GTM_MCS0_CH0_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0130034u)	/* MCS0 Channel 0 Software Interrupt Generation Register */
#define GTM_MCS0_CH1_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01300b4u)	/* MCS0 Channel 1 Software Interrupt Generation Register */
#define GTM_MCS0_CH2_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0130134u)	/* MCS0 Channel 2 Software Interrupt Generation Register */
#define GTM_MCS0_CH3_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01301b4u)	/* MCS0 Channel 3 Software Interrupt Generation Register */
#define GTM_MCS0_CH4_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0130234u)	/* MCS0 Channel 4 Software Interrupt Generation Register */
#define GTM_MCS0_CH5_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01302b4u)	/* MCS0 Channel 5 Software Interrupt Generation Register */
#define GTM_MCS0_CH6_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0130334u)	/* MCS0 Channel 6 Software Interrupt Generation Register */
#define GTM_MCS0_CH7_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01303b4u)	/* MCS0 Channel 7 Software Interrupt Generation Register */
#define GTM_MCS1_CH0_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0140034u)	/* MCS1 Channel 0 Software Interrupt Generation Register */
#define GTM_MCS1_CH1_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01400b4u)	/* MCS1 Channel 1 Software Interrupt Generation Register */
#define GTM_MCS1_CH2_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0140134u)	/* MCS1 Channel 2 Software Interrupt Generation Register */
#define GTM_MCS1_CH3_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01401b4u)	/* MCS1 Channel 3 Software Interrupt Generation Register */
#define GTM_MCS1_CH4_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0140234u)	/* MCS1 Channel 4 Software Interrupt Generation Register */
#define GTM_MCS1_CH5_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01402b4u)	/* MCS1 Channel 5 Software Interrupt Generation Register */
#define GTM_MCS1_CH6_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0140334u)	/* MCS1 Channel 6 Software Interrupt Generation Register */
#define GTM_MCS1_CH7_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01403b4u)	/* MCS1 Channel 7 Software Interrupt Generation Register */
#define GTM_MCS2_CH0_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0150034u)	/* MCS2 Channel 0 Software Interrupt Generation Register */
#define GTM_MCS2_CH1_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01500b4u)	/* MCS2 Channel 1 Software Interrupt Generation Register */
#define GTM_MCS2_CH2_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0150134u)	/* MCS2 Channel 2 Software Interrupt Generation Register */
#define GTM_MCS2_CH3_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01501b4u)	/* MCS2 Channel 3 Software Interrupt Generation Register */
#define GTM_MCS2_CH4_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0150234u)	/* MCS2 Channel 4 Software Interrupt Generation Register */
#define GTM_MCS2_CH5_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01502b4u)	/* MCS2 Channel 5 Software Interrupt Generation Register */
#define GTM_MCS2_CH6_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0150334u)	/* MCS2 Channel 6 Software Interrupt Generation Register */
#define GTM_MCS2_CH7_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01503b4u)	/* MCS2 Channel 7 Software Interrupt Generation Register */
#define GTM_MCS3_CH0_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0160034u)	/* MCS3 Channel 0 Software Interrupt Generation Register */
#define GTM_MCS3_CH1_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01600b4u)	/* MCS3 Channel 1 Software Interrupt Generation Register */
#define GTM_MCS3_CH2_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0160134u)	/* MCS3 Channel 2 Software Interrupt Generation Register */
#define GTM_MCS3_CH3_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01601b4u)	/* MCS3 Channel 3 Software Interrupt Generation Register */
#define GTM_MCS3_CH4_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0160234u)	/* MCS3 Channel 4 Software Interrupt Generation Register */
#define GTM_MCS3_CH5_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01602b4u)	/* MCS3 Channel 5 Software Interrupt Generation Register */
#define GTM_MCS3_CH6_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf0160334u)	/* MCS3 Channel 6 Software Interrupt Generation Register */
#define GTM_MCS3_CH7_IRQ_FORCINT	(*( GTM_MCS0_CH0_IRQ_FORCINT_type *) 0xf01603b4u)	/* MCS3 Channel 7 Software Interrupt Generation Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MCS_IRQ        : 1;	/* Interrupt request by MCS-channel x */
		unsigned int STK_ERR_IRQ    : 1;	/* Stack counter overflow/underflow of channel x */
		unsigned int MEM_ERR_IRQ    : 1;	/* Memory access out of range in channel x */
		/* const */ unsigned int Reserved       : 29;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_CH0_IRQ_NOTIFY_type;
#define GTM_MCS0_CH0_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf013002cu)	/* MCS0 Channel 0 interrupt notification register */
#define GTM_MCS0_CH1_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01300acu)	/* MCS0 Channel 1 interrupt notification register */
#define GTM_MCS0_CH2_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf013012cu)	/* MCS0 Channel 2 interrupt notification register */
#define GTM_MCS0_CH3_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01301acu)	/* MCS0 Channel 3 interrupt notification register */
#define GTM_MCS0_CH4_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf013022cu)	/* MCS0 Channel 4 interrupt notification register */
#define GTM_MCS0_CH5_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01302acu)	/* MCS0 Channel 5 interrupt notification register */
#define GTM_MCS0_CH6_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf013032cu)	/* MCS0 Channel 6 interrupt notification register */
#define GTM_MCS0_CH7_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01303acu)	/* MCS0 Channel 7 interrupt notification register */
#define GTM_MCS1_CH0_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf014002cu)	/* MCS1 Channel 0 interrupt notification register */
#define GTM_MCS1_CH1_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01400acu)	/* MCS1 Channel 1 interrupt notification register */
#define GTM_MCS1_CH2_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf014012cu)	/* MCS1 Channel 2 interrupt notification register */
#define GTM_MCS1_CH3_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01401acu)	/* MCS1 Channel 3 interrupt notification register */
#define GTM_MCS1_CH4_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf014022cu)	/* MCS1 Channel 4 interrupt notification register */
#define GTM_MCS1_CH5_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01402acu)	/* MCS1 Channel 5 interrupt notification register */
#define GTM_MCS1_CH6_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf014032cu)	/* MCS1 Channel 6 interrupt notification register */
#define GTM_MCS1_CH7_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01403acu)	/* MCS1 Channel 7 interrupt notification register */
#define GTM_MCS2_CH0_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf015002cu)	/* MCS2 Channel 0 interrupt notification register */
#define GTM_MCS2_CH1_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01500acu)	/* MCS2 Channel 1 interrupt notification register */
#define GTM_MCS2_CH2_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf015012cu)	/* MCS2 Channel 2 interrupt notification register */
#define GTM_MCS2_CH3_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01501acu)	/* MCS2 Channel 3 interrupt notification register */
#define GTM_MCS2_CH4_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf015022cu)	/* MCS2 Channel 4 interrupt notification register */
#define GTM_MCS2_CH5_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01502acu)	/* MCS2 Channel 5 interrupt notification register */
#define GTM_MCS2_CH6_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf015032cu)	/* MCS2 Channel 6 interrupt notification register */
#define GTM_MCS2_CH7_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01503acu)	/* MCS2 Channel 7 interrupt notification register */
#define GTM_MCS3_CH0_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf016002cu)	/* MCS3 Channel 0 interrupt notification register */
#define GTM_MCS3_CH1_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01600acu)	/* MCS3 Channel 1 interrupt notification register */
#define GTM_MCS3_CH2_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf016012cu)	/* MCS3 Channel 2 interrupt notification register */
#define GTM_MCS3_CH3_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01601acu)	/* MCS3 Channel 3 interrupt notification register */
#define GTM_MCS3_CH4_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf016022cu)	/* MCS3 Channel 4 interrupt notification register */
#define GTM_MCS3_CH5_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01602acu)	/* MCS3 Channel 5 interrupt notification register */
#define GTM_MCS3_CH6_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf016032cu)	/* MCS3 Channel 6 interrupt notification register */
#define GTM_MCS3_CH7_IRQ_NOTIFY	(*( GTM_MCS0_CH0_IRQ_NOTIFY_type *) 0xf01603acu)	/* MCS3 Channel 7 interrupt notification register */

typedef volatile union
{
	struct
	{ 
		unsigned int bPC            : 14;	/* Current Program Counter */
		/* const */ unsigned int Reserved       : 18;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_CH0_PC_type;
#define GTM_MCS0_CH0_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0130004u)	/* MCS0 Channel 0 Program Counter Register */
#define GTM_MCS0_CH1_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0130084u)	/* MCS0 Channel 1 Program Counter Register */
#define GTM_MCS0_CH2_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0130104u)	/* MCS0 Channel 2 Program Counter Register */
#define GTM_MCS0_CH3_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0130184u)	/* MCS0 Channel 3 Program Counter Register */
#define GTM_MCS0_CH4_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0130204u)	/* MCS0 Channel 4 Program Counter Register */
#define GTM_MCS0_CH5_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0130284u)	/* MCS0 Channel 5 Program Counter Register */
#define GTM_MCS0_CH6_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0130304u)	/* MCS0 Channel 6 Program Counter Register */
#define GTM_MCS0_CH7_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0130384u)	/* MCS0 Channel 7 Program Counter Register */
#define GTM_MCS1_CH0_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0140004u)	/* MCS1 Channel 0 Program Counter Register */
#define GTM_MCS1_CH1_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0140084u)	/* MCS1 Channel 1 Program Counter Register */
#define GTM_MCS1_CH2_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0140104u)	/* MCS1 Channel 2 Program Counter Register */
#define GTM_MCS1_CH3_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0140184u)	/* MCS1 Channel 3 Program Counter Register */
#define GTM_MCS1_CH4_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0140204u)	/* MCS1 Channel 4 Program Counter Register */
#define GTM_MCS1_CH5_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0140284u)	/* MCS1 Channel 5 Program Counter Register */
#define GTM_MCS1_CH6_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0140304u)	/* MCS1 Channel 6 Program Counter Register */
#define GTM_MCS1_CH7_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0140384u)	/* MCS1 Channel 7 Program Counter Register */
#define GTM_MCS2_CH0_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0150004u)	/* MCS2 Channel 0 Program Counter Register */
#define GTM_MCS2_CH1_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0150084u)	/* MCS2 Channel 1 Program Counter Register */
#define GTM_MCS2_CH2_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0150104u)	/* MCS2 Channel 2 Program Counter Register */
#define GTM_MCS2_CH3_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0150184u)	/* MCS2 Channel 3 Program Counter Register */
#define GTM_MCS2_CH4_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0150204u)	/* MCS2 Channel 4 Program Counter Register */
#define GTM_MCS2_CH5_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0150284u)	/* MCS2 Channel 5 Program Counter Register */
#define GTM_MCS2_CH6_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0150304u)	/* MCS2 Channel 6 Program Counter Register */
#define GTM_MCS2_CH7_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0150384u)	/* MCS2 Channel 7 Program Counter Register */
#define GTM_MCS3_CH0_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0160004u)	/* MCS3 Channel 0 Program Counter Register */
#define GTM_MCS3_CH1_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0160084u)	/* MCS3 Channel 1 Program Counter Register */
#define GTM_MCS3_CH2_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0160104u)	/* MCS3 Channel 2 Program Counter Register */
#define GTM_MCS3_CH3_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0160184u)	/* MCS3 Channel 3 Program Counter Register */
#define GTM_MCS3_CH4_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0160204u)	/* MCS3 Channel 4 Program Counter Register */
#define GTM_MCS3_CH5_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0160284u)	/* MCS3 Channel 5 Program Counter Register */
#define GTM_MCS3_CH6_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0160304u)	/* MCS3 Channel 6 Program Counter Register */
#define GTM_MCS3_CH7_PC	(*( GTM_MCS0_CH0_PC_type *) 0xf0160384u)	/* MCS3 Channel 7 Program Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DATA           : 24;	/* Data of MCS general purpose register ry */
		/* const */ unsigned int Reserved       : 8;	/* Read as zero, should be written as zero */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_CH0_R0_type;
#define GTM_MCS0_CH0_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0130008u)	/* MCS0 Channel 0 Program Counter Register 0 */
#define GTM_MCS0_CH0_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf013000cu)	/* MCS0 Channel 0 Program Counter Register 1 */
#define GTM_MCS0_CH0_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0130010u)	/* MCS0 Channel 0 Program Counter Register 2 */
#define GTM_MCS0_CH0_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0130014u)	/* MCS0 Channel 0 Program Counter Register 3 */
#define GTM_MCS0_CH0_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0130018u)	/* MCS0 Channel 0 Program Counter Register 4 */
#define GTM_MCS0_CH0_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf013001cu)	/* MCS0 Channel 0 Program Counter Register 5 */
#define GTM_MCS0_CH0_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0130020u)	/* MCS0 Channel 0 Program Counter Register 6 */
#define GTM_MCS0_CH0_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0130024u)	/* MCS0 Channel 0 Program Counter Register 7 */
#define GTM_MCS0_CH1_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0130088u)	/* MCS0 Channel 1 Program Counter Register 0 */
#define GTM_MCS0_CH1_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf013008cu)	/* MCS0 Channel 1 Program Counter Register 1 */
#define GTM_MCS0_CH1_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0130090u)	/* MCS0 Channel 1 Program Counter Register 2 */
#define GTM_MCS0_CH1_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0130094u)	/* MCS0 Channel 1 Program Counter Register 3 */
#define GTM_MCS0_CH1_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0130098u)	/* MCS0 Channel 1 Program Counter Register 4 */
#define GTM_MCS0_CH1_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf013009cu)	/* MCS0 Channel 1 Program Counter Register 5 */
#define GTM_MCS0_CH1_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01300a0u)	/* MCS0 Channel 1 Program Counter Register 6 */
#define GTM_MCS0_CH1_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01300a4u)	/* MCS0 Channel 1 Program Counter Register 7 */
#define GTM_MCS0_CH2_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0130108u)	/* MCS0 Channel 2 Program Counter Register 0 */
#define GTM_MCS0_CH2_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf013010cu)	/* MCS0 Channel 2 Program Counter Register 1 */
#define GTM_MCS0_CH2_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0130110u)	/* MCS0 Channel 2 Program Counter Register 2 */
#define GTM_MCS0_CH2_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0130114u)	/* MCS0 Channel 2 Program Counter Register 3 */
#define GTM_MCS0_CH2_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0130118u)	/* MCS0 Channel 2 Program Counter Register 4 */
#define GTM_MCS0_CH2_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf013011cu)	/* MCS0 Channel 2 Program Counter Register 5 */
#define GTM_MCS0_CH2_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0130120u)	/* MCS0 Channel 2 Program Counter Register 6 */
#define GTM_MCS0_CH2_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0130124u)	/* MCS0 Channel 2 Program Counter Register 7 */
#define GTM_MCS0_CH3_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0130188u)	/* MCS0 Channel 3 Program Counter Register 0 */
#define GTM_MCS0_CH3_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf013018cu)	/* MCS0 Channel 3 Program Counter Register 1 */
#define GTM_MCS0_CH3_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0130190u)	/* MCS0 Channel 3 Program Counter Register 2 */
#define GTM_MCS0_CH3_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0130194u)	/* MCS0 Channel 3 Program Counter Register 3 */
#define GTM_MCS0_CH3_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0130198u)	/* MCS0 Channel 3 Program Counter Register 4 */
#define GTM_MCS0_CH3_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf013019cu)	/* MCS0 Channel 3 Program Counter Register 5 */
#define GTM_MCS0_CH3_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01301a0u)	/* MCS0 Channel 3 Program Counter Register 6 */
#define GTM_MCS0_CH3_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01301a4u)	/* MCS0 Channel 3 Program Counter Register 7 */
#define GTM_MCS0_CH4_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0130208u)	/* MCS0 Channel 4 Program Counter Register 0 */
#define GTM_MCS0_CH4_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf013020cu)	/* MCS0 Channel 4 Program Counter Register 1 */
#define GTM_MCS0_CH4_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0130210u)	/* MCS0 Channel 4 Program Counter Register 2 */
#define GTM_MCS0_CH4_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0130214u)	/* MCS0 Channel 4 Program Counter Register 3 */
#define GTM_MCS0_CH4_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0130218u)	/* MCS0 Channel 4 Program Counter Register 4 */
#define GTM_MCS0_CH4_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf013021cu)	/* MCS0 Channel 4 Program Counter Register 5 */
#define GTM_MCS0_CH4_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0130220u)	/* MCS0 Channel 4 Program Counter Register 6 */
#define GTM_MCS0_CH4_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0130224u)	/* MCS0 Channel 4 Program Counter Register 7 */
#define GTM_MCS0_CH5_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0130288u)	/* MCS0 Channel 5 Program Counter Register 0 */
#define GTM_MCS0_CH5_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf013028cu)	/* MCS0 Channel 5 Program Counter Register 1 */
#define GTM_MCS0_CH5_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0130290u)	/* MCS0 Channel 5 Program Counter Register 2 */
#define GTM_MCS0_CH5_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0130294u)	/* MCS0 Channel 5 Program Counter Register 3 */
#define GTM_MCS0_CH5_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0130298u)	/* MCS0 Channel 5 Program Counter Register 4 */
#define GTM_MCS0_CH5_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf013029cu)	/* MCS0 Channel 5 Program Counter Register 5 */
#define GTM_MCS0_CH5_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01302a0u)	/* MCS0 Channel 5 Program Counter Register 6 */
#define GTM_MCS0_CH5_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01302a4u)	/* MCS0 Channel 5 Program Counter Register 7 */
#define GTM_MCS0_CH6_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0130308u)	/* MCS0 Channel 6 Program Counter Register 0 */
#define GTM_MCS0_CH6_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf013030cu)	/* MCS0 Channel 6 Program Counter Register 1 */
#define GTM_MCS0_CH6_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0130310u)	/* MCS0 Channel 6 Program Counter Register 2 */
#define GTM_MCS0_CH6_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0130314u)	/* MCS0 Channel 6 Program Counter Register 3 */
#define GTM_MCS0_CH6_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0130318u)	/* MCS0 Channel 6 Program Counter Register 4 */
#define GTM_MCS0_CH6_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf013031cu)	/* MCS0 Channel 6 Program Counter Register 5 */
#define GTM_MCS0_CH6_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0130320u)	/* MCS0 Channel 6 Program Counter Register 6 */
#define GTM_MCS0_CH6_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0130324u)	/* MCS0 Channel 6 Program Counter Register 7 */
#define GTM_MCS0_CH7_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0130388u)	/* MCS0 Channel 7 Program Counter Register 0 */
#define GTM_MCS0_CH7_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf013038cu)	/* MCS0 Channel 7 Program Counter Register 1 */
#define GTM_MCS0_CH7_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0130390u)	/* MCS0 Channel 7 Program Counter Register 2 */
#define GTM_MCS0_CH7_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0130394u)	/* MCS0 Channel 7 Program Counter Register 3 */
#define GTM_MCS0_CH7_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0130398u)	/* MCS0 Channel 7 Program Counter Register 4 */
#define GTM_MCS0_CH7_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf013039cu)	/* MCS0 Channel 7 Program Counter Register 5 */
#define GTM_MCS0_CH7_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01303a0u)	/* MCS0 Channel 7 Program Counter Register 6 */
#define GTM_MCS0_CH7_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01303a4u)	/* MCS0 Channel 7 Program Counter Register 7 */
#define GTM_MCS1_CH0_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0140008u)	/* MCS1 Channel 0 Program Counter Register 0 */
#define GTM_MCS1_CH0_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf014000cu)	/* MCS1 Channel 0 Program Counter Register 1 */
#define GTM_MCS1_CH0_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0140010u)	/* MCS1 Channel 0 Program Counter Register 2 */
#define GTM_MCS1_CH0_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0140014u)	/* MCS1 Channel 0 Program Counter Register 3 */
#define GTM_MCS1_CH0_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0140018u)	/* MCS1 Channel 0 Program Counter Register 4 */
#define GTM_MCS1_CH0_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf014001cu)	/* MCS1 Channel 0 Program Counter Register 5 */
#define GTM_MCS1_CH0_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0140020u)	/* MCS1 Channel 0 Program Counter Register 6 */
#define GTM_MCS1_CH0_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0140024u)	/* MCS1 Channel 0 Program Counter Register 7 */
#define GTM_MCS1_CH1_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0140088u)	/* MCS1 Channel 1 Program Counter Register 0 */
#define GTM_MCS1_CH1_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf014008cu)	/* MCS1 Channel 1 Program Counter Register 1 */
#define GTM_MCS1_CH1_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0140090u)	/* MCS1 Channel 1 Program Counter Register 2 */
#define GTM_MCS1_CH1_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0140094u)	/* MCS1 Channel 1 Program Counter Register 3 */
#define GTM_MCS1_CH1_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0140098u)	/* MCS1 Channel 1 Program Counter Register 4 */
#define GTM_MCS1_CH1_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf014009cu)	/* MCS1 Channel 1 Program Counter Register 5 */
#define GTM_MCS1_CH1_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01400a0u)	/* MCS1 Channel 1 Program Counter Register 6 */
#define GTM_MCS1_CH1_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01400a4u)	/* MCS1 Channel 1 Program Counter Register 7 */
#define GTM_MCS1_CH2_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0140108u)	/* MCS1 Channel 2 Program Counter Register 0 */
#define GTM_MCS1_CH2_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf014010cu)	/* MCS1 Channel 2 Program Counter Register 1 */
#define GTM_MCS1_CH2_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0140110u)	/* MCS1 Channel 2 Program Counter Register 2 */
#define GTM_MCS1_CH2_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0140114u)	/* MCS1 Channel 2 Program Counter Register 3 */
#define GTM_MCS1_CH2_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0140118u)	/* MCS1 Channel 2 Program Counter Register 4 */
#define GTM_MCS1_CH2_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf014011cu)	/* MCS1 Channel 2 Program Counter Register 5 */
#define GTM_MCS1_CH2_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0140120u)	/* MCS1 Channel 2 Program Counter Register 6 */
#define GTM_MCS1_CH2_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0140124u)	/* MCS1 Channel 2 Program Counter Register 7 */
#define GTM_MCS1_CH3_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0140188u)	/* MCS1 Channel 3 Program Counter Register 0 */
#define GTM_MCS1_CH3_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf014018cu)	/* MCS1 Channel 3 Program Counter Register 1 */
#define GTM_MCS1_CH3_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0140190u)	/* MCS1 Channel 3 Program Counter Register 2 */
#define GTM_MCS1_CH3_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0140194u)	/* MCS1 Channel 3 Program Counter Register 3 */
#define GTM_MCS1_CH3_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0140198u)	/* MCS1 Channel 3 Program Counter Register 4 */
#define GTM_MCS1_CH3_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf014019cu)	/* MCS1 Channel 3 Program Counter Register 5 */
#define GTM_MCS1_CH3_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01401a0u)	/* MCS1 Channel 3 Program Counter Register 6 */
#define GTM_MCS1_CH3_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01401a4u)	/* MCS1 Channel 3 Program Counter Register 7 */
#define GTM_MCS1_CH4_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0140208u)	/* MCS1 Channel 4 Program Counter Register 0 */
#define GTM_MCS1_CH4_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf014020cu)	/* MCS1 Channel 4 Program Counter Register 1 */
#define GTM_MCS1_CH4_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0140210u)	/* MCS1 Channel 4 Program Counter Register 2 */
#define GTM_MCS1_CH4_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0140214u)	/* MCS1 Channel 4 Program Counter Register 3 */
#define GTM_MCS1_CH4_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0140218u)	/* MCS1 Channel 4 Program Counter Register 4 */
#define GTM_MCS1_CH4_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf014021cu)	/* MCS1 Channel 4 Program Counter Register 5 */
#define GTM_MCS1_CH4_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0140220u)	/* MCS1 Channel 4 Program Counter Register 6 */
#define GTM_MCS1_CH4_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0140224u)	/* MCS1 Channel 4 Program Counter Register 7 */
#define GTM_MCS1_CH5_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0140288u)	/* MCS1 Channel 5 Program Counter Register 0 */
#define GTM_MCS1_CH5_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf014028cu)	/* MCS1 Channel 5 Program Counter Register 1 */
#define GTM_MCS1_CH5_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0140290u)	/* MCS1 Channel 5 Program Counter Register 2 */
#define GTM_MCS1_CH5_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0140294u)	/* MCS1 Channel 5 Program Counter Register 3 */
#define GTM_MCS1_CH5_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0140298u)	/* MCS1 Channel 5 Program Counter Register 4 */
#define GTM_MCS1_CH5_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf014029cu)	/* MCS1 Channel 5 Program Counter Register 5 */
#define GTM_MCS1_CH5_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01402a0u)	/* MCS1 Channel 5 Program Counter Register 6 */
#define GTM_MCS1_CH5_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01402a4u)	/* MCS1 Channel 5 Program Counter Register 7 */
#define GTM_MCS1_CH6_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0140308u)	/* MCS1 Channel 6 Program Counter Register 0 */
#define GTM_MCS1_CH6_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf014030cu)	/* MCS1 Channel 6 Program Counter Register 1 */
#define GTM_MCS1_CH6_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0140310u)	/* MCS1 Channel 6 Program Counter Register 2 */
#define GTM_MCS1_CH6_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0140314u)	/* MCS1 Channel 6 Program Counter Register 3 */
#define GTM_MCS1_CH6_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0140318u)	/* MCS1 Channel 6 Program Counter Register 4 */
#define GTM_MCS1_CH6_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf014031cu)	/* MCS1 Channel 6 Program Counter Register 5 */
#define GTM_MCS1_CH6_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0140320u)	/* MCS1 Channel 6 Program Counter Register 6 */
#define GTM_MCS1_CH6_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0140324u)	/* MCS1 Channel 6 Program Counter Register 7 */
#define GTM_MCS1_CH7_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0140388u)	/* MCS1 Channel 7 Program Counter Register 0 */
#define GTM_MCS1_CH7_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf014038cu)	/* MCS1 Channel 7 Program Counter Register 1 */
#define GTM_MCS1_CH7_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0140390u)	/* MCS1 Channel 7 Program Counter Register 2 */
#define GTM_MCS1_CH7_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0140394u)	/* MCS1 Channel 7 Program Counter Register 3 */
#define GTM_MCS1_CH7_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0140398u)	/* MCS1 Channel 7 Program Counter Register 4 */
#define GTM_MCS1_CH7_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf014039cu)	/* MCS1 Channel 7 Program Counter Register 5 */
#define GTM_MCS1_CH7_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01403a0u)	/* MCS1 Channel 7 Program Counter Register 6 */
#define GTM_MCS1_CH7_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01403a4u)	/* MCS1 Channel 7 Program Counter Register 7 */
#define GTM_MCS2_CH0_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0150008u)	/* MCS2 Channel 0 Program Counter Register 0 */
#define GTM_MCS2_CH0_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf015000cu)	/* MCS2 Channel 0 Program Counter Register 1 */
#define GTM_MCS2_CH0_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0150010u)	/* MCS2 Channel 0 Program Counter Register 2 */
#define GTM_MCS2_CH0_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0150014u)	/* MCS2 Channel 0 Program Counter Register 3 */
#define GTM_MCS2_CH0_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0150018u)	/* MCS2 Channel 0 Program Counter Register 4 */
#define GTM_MCS2_CH0_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf015001cu)	/* MCS2 Channel 0 Program Counter Register 5 */
#define GTM_MCS2_CH0_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0150020u)	/* MCS2 Channel 0 Program Counter Register 6 */
#define GTM_MCS2_CH0_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0150024u)	/* MCS2 Channel 0 Program Counter Register 7 */
#define GTM_MCS2_CH1_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0150088u)	/* MCS2 Channel 1 Program Counter Register 0 */
#define GTM_MCS2_CH1_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf015008cu)	/* MCS2 Channel 1 Program Counter Register 1 */
#define GTM_MCS2_CH1_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0150090u)	/* MCS2 Channel 1 Program Counter Register 2 */
#define GTM_MCS2_CH1_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0150094u)	/* MCS2 Channel 1 Program Counter Register 3 */
#define GTM_MCS2_CH1_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0150098u)	/* MCS2 Channel 1 Program Counter Register 4 */
#define GTM_MCS2_CH1_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf015009cu)	/* MCS2 Channel 1 Program Counter Register 5 */
#define GTM_MCS2_CH1_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01500a0u)	/* MCS2 Channel 1 Program Counter Register 6 */
#define GTM_MCS2_CH1_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01500a4u)	/* MCS2 Channel 1 Program Counter Register 7 */
#define GTM_MCS2_CH2_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0150108u)	/* MCS2 Channel 2 Program Counter Register 0 */
#define GTM_MCS2_CH2_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf015010cu)	/* MCS2 Channel 2 Program Counter Register 1 */
#define GTM_MCS2_CH2_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0150110u)	/* MCS2 Channel 2 Program Counter Register 2 */
#define GTM_MCS2_CH2_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0150114u)	/* MCS2 Channel 2 Program Counter Register 3 */
#define GTM_MCS2_CH2_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0150118u)	/* MCS2 Channel 2 Program Counter Register 4 */
#define GTM_MCS2_CH2_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf015011cu)	/* MCS2 Channel 2 Program Counter Register 5 */
#define GTM_MCS2_CH2_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0150120u)	/* MCS2 Channel 2 Program Counter Register 6 */
#define GTM_MCS2_CH2_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0150124u)	/* MCS2 Channel 2 Program Counter Register 7 */
#define GTM_MCS2_CH3_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0150188u)	/* MCS2 Channel 3 Program Counter Register 0 */
#define GTM_MCS2_CH3_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf015018cu)	/* MCS2 Channel 3 Program Counter Register 1 */
#define GTM_MCS2_CH3_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0150190u)	/* MCS2 Channel 3 Program Counter Register 2 */
#define GTM_MCS2_CH3_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0150194u)	/* MCS2 Channel 3 Program Counter Register 3 */
#define GTM_MCS2_CH3_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0150198u)	/* MCS2 Channel 3 Program Counter Register 4 */
#define GTM_MCS2_CH3_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf015019cu)	/* MCS2 Channel 3 Program Counter Register 5 */
#define GTM_MCS2_CH3_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01501a0u)	/* MCS2 Channel 3 Program Counter Register 6 */
#define GTM_MCS2_CH3_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01501a4u)	/* MCS2 Channel 3 Program Counter Register 7 */
#define GTM_MCS2_CH4_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0150208u)	/* MCS2 Channel 4 Program Counter Register 0 */
#define GTM_MCS2_CH4_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf015020cu)	/* MCS2 Channel 4 Program Counter Register 1 */
#define GTM_MCS2_CH4_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0150210u)	/* MCS2 Channel 4 Program Counter Register 2 */
#define GTM_MCS2_CH4_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0150214u)	/* MCS2 Channel 4 Program Counter Register 3 */
#define GTM_MCS2_CH4_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0150218u)	/* MCS2 Channel 4 Program Counter Register 4 */
#define GTM_MCS2_CH4_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf015021cu)	/* MCS2 Channel 4 Program Counter Register 5 */
#define GTM_MCS2_CH4_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0150220u)	/* MCS2 Channel 4 Program Counter Register 6 */
#define GTM_MCS2_CH4_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0150224u)	/* MCS2 Channel 4 Program Counter Register 7 */
#define GTM_MCS2_CH5_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0150288u)	/* MCS2 Channel 5 Program Counter Register 0 */
#define GTM_MCS2_CH5_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf015028cu)	/* MCS2 Channel 5 Program Counter Register 1 */
#define GTM_MCS2_CH5_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0150290u)	/* MCS2 Channel 5 Program Counter Register 2 */
#define GTM_MCS2_CH5_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0150294u)	/* MCS2 Channel 5 Program Counter Register 3 */
#define GTM_MCS2_CH5_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0150298u)	/* MCS2 Channel 5 Program Counter Register 4 */
#define GTM_MCS2_CH5_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf015029cu)	/* MCS2 Channel 5 Program Counter Register 5 */
#define GTM_MCS2_CH5_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01502a0u)	/* MCS2 Channel 5 Program Counter Register 6 */
#define GTM_MCS2_CH5_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01502a4u)	/* MCS2 Channel 5 Program Counter Register 7 */
#define GTM_MCS2_CH6_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0150308u)	/* MCS2 Channel 6 Program Counter Register 0 */
#define GTM_MCS2_CH6_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf015030cu)	/* MCS2 Channel 6 Program Counter Register 1 */
#define GTM_MCS2_CH6_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0150310u)	/* MCS2 Channel 6 Program Counter Register 2 */
#define GTM_MCS2_CH6_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0150314u)	/* MCS2 Channel 6 Program Counter Register 3 */
#define GTM_MCS2_CH6_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0150318u)	/* MCS2 Channel 6 Program Counter Register 4 */
#define GTM_MCS2_CH6_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf015031cu)	/* MCS2 Channel 6 Program Counter Register 5 */
#define GTM_MCS2_CH6_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0150320u)	/* MCS2 Channel 6 Program Counter Register 6 */
#define GTM_MCS2_CH6_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0150324u)	/* MCS2 Channel 6 Program Counter Register 7 */
#define GTM_MCS2_CH7_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0150388u)	/* MCS2 Channel 7 Program Counter Register 0 */
#define GTM_MCS2_CH7_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf015038cu)	/* MCS2 Channel 7 Program Counter Register 1 */
#define GTM_MCS2_CH7_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0150390u)	/* MCS2 Channel 7 Program Counter Register 2 */
#define GTM_MCS2_CH7_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0150394u)	/* MCS2 Channel 7 Program Counter Register 3 */
#define GTM_MCS2_CH7_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0150398u)	/* MCS2 Channel 7 Program Counter Register 4 */
#define GTM_MCS2_CH7_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf015039cu)	/* MCS2 Channel 7 Program Counter Register 5 */
#define GTM_MCS2_CH7_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01503a0u)	/* MCS2 Channel 7 Program Counter Register 6 */
#define GTM_MCS2_CH7_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01503a4u)	/* MCS2 Channel 7 Program Counter Register 7 */
#define GTM_MCS3_CH0_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0160008u)	/* MCS3 Channel 0 Program Counter Register 0 */
#define GTM_MCS3_CH0_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf016000cu)	/* MCS3 Channel 0 Program Counter Register 1 */
#define GTM_MCS3_CH0_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0160010u)	/* MCS3 Channel 0 Program Counter Register 2 */
#define GTM_MCS3_CH0_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0160014u)	/* MCS3 Channel 0 Program Counter Register 3 */
#define GTM_MCS3_CH0_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0160018u)	/* MCS3 Channel 0 Program Counter Register 4 */
#define GTM_MCS3_CH0_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf016001cu)	/* MCS3 Channel 0 Program Counter Register 5 */
#define GTM_MCS3_CH0_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0160020u)	/* MCS3 Channel 0 Program Counter Register 6 */
#define GTM_MCS3_CH0_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0160024u)	/* MCS3 Channel 0 Program Counter Register 7 */
#define GTM_MCS3_CH1_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0160088u)	/* MCS3 Channel 1 Program Counter Register 0 */
#define GTM_MCS3_CH1_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf016008cu)	/* MCS3 Channel 1 Program Counter Register 1 */
#define GTM_MCS3_CH1_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0160090u)	/* MCS3 Channel 1 Program Counter Register 2 */
#define GTM_MCS3_CH1_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0160094u)	/* MCS3 Channel 1 Program Counter Register 3 */
#define GTM_MCS3_CH1_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0160098u)	/* MCS3 Channel 1 Program Counter Register 4 */
#define GTM_MCS3_CH1_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf016009cu)	/* MCS3 Channel 1 Program Counter Register 5 */
#define GTM_MCS3_CH1_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01600a0u)	/* MCS3 Channel 1 Program Counter Register 6 */
#define GTM_MCS3_CH1_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01600a4u)	/* MCS3 Channel 1 Program Counter Register 7 */
#define GTM_MCS3_CH2_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0160108u)	/* MCS3 Channel 2 Program Counter Register 0 */
#define GTM_MCS3_CH2_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf016010cu)	/* MCS3 Channel 2 Program Counter Register 1 */
#define GTM_MCS3_CH2_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0160110u)	/* MCS3 Channel 2 Program Counter Register 2 */
#define GTM_MCS3_CH2_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0160114u)	/* MCS3 Channel 2 Program Counter Register 3 */
#define GTM_MCS3_CH2_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0160118u)	/* MCS3 Channel 2 Program Counter Register 4 */
#define GTM_MCS3_CH2_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf016011cu)	/* MCS3 Channel 2 Program Counter Register 5 */
#define GTM_MCS3_CH2_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0160120u)	/* MCS3 Channel 2 Program Counter Register 6 */
#define GTM_MCS3_CH2_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0160124u)	/* MCS3 Channel 2 Program Counter Register 7 */
#define GTM_MCS3_CH3_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0160188u)	/* MCS3 Channel 3 Program Counter Register 0 */
#define GTM_MCS3_CH3_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf016018cu)	/* MCS3 Channel 3 Program Counter Register 1 */
#define GTM_MCS3_CH3_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0160190u)	/* MCS3 Channel 3 Program Counter Register 2 */
#define GTM_MCS3_CH3_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0160194u)	/* MCS3 Channel 3 Program Counter Register 3 */
#define GTM_MCS3_CH3_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0160198u)	/* MCS3 Channel 3 Program Counter Register 4 */
#define GTM_MCS3_CH3_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf016019cu)	/* MCS3 Channel 3 Program Counter Register 5 */
#define GTM_MCS3_CH3_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01601a0u)	/* MCS3 Channel 3 Program Counter Register 6 */
#define GTM_MCS3_CH3_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01601a4u)	/* MCS3 Channel 3 Program Counter Register 7 */
#define GTM_MCS3_CH4_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0160208u)	/* MCS3 Channel 4 Program Counter Register 0 */
#define GTM_MCS3_CH4_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf016020cu)	/* MCS3 Channel 4 Program Counter Register 1 */
#define GTM_MCS3_CH4_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0160210u)	/* MCS3 Channel 4 Program Counter Register 2 */
#define GTM_MCS3_CH4_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0160214u)	/* MCS3 Channel 4 Program Counter Register 3 */
#define GTM_MCS3_CH4_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0160218u)	/* MCS3 Channel 4 Program Counter Register 4 */
#define GTM_MCS3_CH4_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf016021cu)	/* MCS3 Channel 4 Program Counter Register 5 */
#define GTM_MCS3_CH4_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0160220u)	/* MCS3 Channel 4 Program Counter Register 6 */
#define GTM_MCS3_CH4_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0160224u)	/* MCS3 Channel 4 Program Counter Register 7 */
#define GTM_MCS3_CH5_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0160288u)	/* MCS3 Channel 5 Program Counter Register 0 */
#define GTM_MCS3_CH5_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf016028cu)	/* MCS3 Channel 5 Program Counter Register 1 */
#define GTM_MCS3_CH5_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0160290u)	/* MCS3 Channel 5 Program Counter Register 2 */
#define GTM_MCS3_CH5_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0160294u)	/* MCS3 Channel 5 Program Counter Register 3 */
#define GTM_MCS3_CH5_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0160298u)	/* MCS3 Channel 5 Program Counter Register 4 */
#define GTM_MCS3_CH5_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf016029cu)	/* MCS3 Channel 5 Program Counter Register 5 */
#define GTM_MCS3_CH5_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01602a0u)	/* MCS3 Channel 5 Program Counter Register 6 */
#define GTM_MCS3_CH5_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01602a4u)	/* MCS3 Channel 5 Program Counter Register 7 */
#define GTM_MCS3_CH6_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0160308u)	/* MCS3 Channel 6 Program Counter Register 0 */
#define GTM_MCS3_CH6_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf016030cu)	/* MCS3 Channel 6 Program Counter Register 1 */
#define GTM_MCS3_CH6_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0160310u)	/* MCS3 Channel 6 Program Counter Register 2 */
#define GTM_MCS3_CH6_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0160314u)	/* MCS3 Channel 6 Program Counter Register 3 */
#define GTM_MCS3_CH6_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0160318u)	/* MCS3 Channel 6 Program Counter Register 4 */
#define GTM_MCS3_CH6_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf016031cu)	/* MCS3 Channel 6 Program Counter Register 5 */
#define GTM_MCS3_CH6_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf0160320u)	/* MCS3 Channel 6 Program Counter Register 6 */
#define GTM_MCS3_CH6_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf0160324u)	/* MCS3 Channel 6 Program Counter Register 7 */
#define GTM_MCS3_CH7_R0	(*( GTM_MCS0_CH0_R0_type *) 0xf0160388u)	/* MCS3 Channel 7 Program Counter Register 0 */
#define GTM_MCS3_CH7_R1	(*( GTM_MCS0_CH0_R0_type *) 0xf016038cu)	/* MCS3 Channel 7 Program Counter Register 1 */
#define GTM_MCS3_CH7_R2	(*( GTM_MCS0_CH0_R0_type *) 0xf0160390u)	/* MCS3 Channel 7 Program Counter Register 2 */
#define GTM_MCS3_CH7_R3	(*( GTM_MCS0_CH0_R0_type *) 0xf0160394u)	/* MCS3 Channel 7 Program Counter Register 3 */
#define GTM_MCS3_CH7_R4	(*( GTM_MCS0_CH0_R0_type *) 0xf0160398u)	/* MCS3 Channel 7 Program Counter Register 4 */
#define GTM_MCS3_CH7_R5	(*( GTM_MCS0_CH0_R0_type *) 0xf016039cu)	/* MCS3 Channel 7 Program Counter Register 5 */
#define GTM_MCS3_CH7_R6	(*( GTM_MCS0_CH0_R0_type *) 0xf01603a0u)	/* MCS3 Channel 7 Program Counter Register 6 */
#define GTM_MCS3_CH7_R7	(*( GTM_MCS0_CH0_R0_type *) 0xf01603a4u)	/* MCS3 Channel 7 Program Counter Register 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG0           : 1;	/* Trigger bit 0 */
		unsigned int TRG1           : 1;	/* Trigger bit 1 */
		unsigned int TRG2           : 1;	/* Trigger bit 2 */
		unsigned int TRG3           : 1;	/* Trigger bit 3 */
		unsigned int TRG4           : 1;	/* Trigger bit 4 */
		unsigned int TRG5           : 1;	/* Trigger bit 5 */
		unsigned int TRG6           : 1;	/* Trigger bit 6 */
		unsigned int TRG7           : 1;	/* Trigger bit 7 */
		unsigned int TRG8           : 1;	/* Trigger bit 8 */
		unsigned int TRG9           : 1;	/* Trigger bit 9 */
		unsigned int TRG10          : 1;	/* Trigger bit 10 */
		unsigned int TRG11          : 1;	/* Trigger bit 11 */
		unsigned int TRG12          : 1;	/* Trigger bit 12 */
		unsigned int TRG13          : 1;	/* Trigger bit 13 */
		unsigned int TRG14          : 1;	/* Trigger bit 14 */
		unsigned int TRG15          : 1;	/* Trigger bit 15 */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_CTRG_type;
#define GTM_MCS0_CTRG	(*( GTM_MCS0_CTRG_type *) 0xf0130404u)	/* MCS0 Clear Trigger Control Register */
#define GTM_MCS1_CTRG	(*( GTM_MCS0_CTRG_type *) 0xf0140404u)	/* MCS1 Clear Trigger Control Register */
#define GTM_MCS2_CTRG	(*( GTM_MCS0_CTRG_type *) 0xf0150404u)	/* MCS2 Clear Trigger Control Register */
#define GTM_MCS3_CTRG	(*( GTM_MCS0_CTRG_type *) 0xf0160404u)	/* MCS3 Clear Trigger Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SCHED          : 1;	/* MCS submodule scheduling scheme */
		unsigned int HLT_SP_OFL     : 1;	/* Halt on stack pointer overflow */
		/* const */ unsigned int Reserved       : 14;	/* Reserved */
		/* const */ unsigned int RAM_RST        : 1;	/* RAM reset bit */
		/* const */ unsigned int Reserved_5     : 15;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_CTRL_type;
#define GTM_MCS0_CTRL	(*( GTM_MCS0_CTRL_type *) 0xf0130400u)	/* MCS0 Control Register */
#define GTM_MCS1_CTRL	(*( GTM_MCS0_CTRL_type *) 0xf0140400u)	/* MCS1 Control Register */
#define GTM_MCS2_CTRL	(*( GTM_MCS0_CTRL_type *) 0xf0150400u)	/* MCS2 Control Register */
#define GTM_MCS3_CTRL	(*( GTM_MCS0_CTRL_type *) 0xf0160400u)	/* MCS3 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ERR0           : 1;	/* Error State of MCS-channel 0 */
		unsigned int ERR1           : 1;	/* Error State of MCS-channel 1 */
		unsigned int ERR2           : 1;	/* Error State of MCS-channel 2 */
		unsigned int ERR3           : 1;	/* Error State of MCS-channel3 */
		unsigned int ERR4           : 1;	/* Error State of MCS-channel 4 */
		unsigned int ERR5           : 1;	/* Error State of MCS-channel 5 */
		unsigned int ERR6           : 1;	/* Error State of MCS-channel 6 */
		unsigned int ERR7           : 1;	/* Error State of MCS-channel 7 */
		/* const */ unsigned int Reserved       : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_ERR_type;
#define GTM_MCS0_ERR	(*( GTM_MCS0_ERR_type *) 0xf0130410u)	/* MCS0 Error Register */
#define GTM_MCS1_ERR	(*( GTM_MCS0_ERR_type *) 0xf0140410u)	/* MCS1 Error Register */
#define GTM_MCS2_ERR	(*( GTM_MCS0_ERR_type *) 0xf0150410u)	/* MCS2 Error Register */
#define GTM_MCS3_ERR	(*( GTM_MCS0_ERR_type *) 0xf0160410u)	/* MCS3 Error Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST0           : 1;	/* Software reset of channel 0 */
		unsigned int RST1           : 1;	/* Software reset of channel 1 */
		unsigned int RST2           : 1;	/* Software reset of channel 2 */
		unsigned int RST3           : 1;	/* Software reset of channel 3 */
		unsigned int RST4           : 1;	/* Software reset of channel 4 */
		unsigned int RST5           : 1;	/* Software reset of channel 5 */
		unsigned int RST6           : 1;	/* Software reset of channel 6 */
		unsigned int RST7           : 1;	/* Software reset of channel 7 */
		unsigned int CAT0           : 1;	/* Cancel ARU transfer for channel 0 */
		unsigned int CAT1           : 1;	/* Cancel ARU transfer for channel 1 */
		unsigned int CAT2           : 1;	/* Cancel ARU transfer for channel 2 */
		unsigned int CAT3           : 1;	/* Cancel ARU transfer for channel 3 */
		unsigned int CAT4           : 1;	/* Cancel ARU transfer for channel 4 */
		unsigned int CAT5           : 1;	/* Cancel ARU transfer for channel 5 */
		unsigned int CAT6           : 1;	/* Cancel ARU transfer for channel 6 */
		unsigned int CAT7           : 1;	/* Cancel ARU transfer for channel 7 */
		unsigned int CWT0           : 1;	/* Cancel WURM instruction for channel 0 */
		unsigned int CWT1           : 1;	/* Cancel WURM instruction for channel 1 */
		unsigned int CWT2           : 1;	/* Cancel WURM instruction for channel 2 */
		unsigned int CWT3           : 1;	/* Cancel WURM instruction for channel 3 */
		unsigned int CWT4           : 1;	/* Cancel WURM instruction for channel 4 */
		unsigned int CWT5           : 1;	/* Cancel WURM instruction for channel 5 */
		unsigned int CWT6           : 1;	/* Cancel WURM instruction for channel 6 */
		unsigned int CWT7           : 1;	/* Cancel WURM instruction for channel 7 */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_RST_type;
#define GTM_MCS0_RST	(*( GTM_MCS0_RST_type *) 0xf013040cu)	/* MCS0 Channel Reset Register */
#define GTM_MCS1_RST	(*( GTM_MCS0_RST_type *) 0xf014040cu)	/* MCS1 Channel Reset Register */
#define GTM_MCS2_RST	(*( GTM_MCS0_RST_type *) 0xf015040cu)	/* MCS2 Channel Reset Register */
#define GTM_MCS3_RST	(*( GTM_MCS0_RST_type *) 0xf016040cu)	/* MCS3 Channel Reset Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG0           : 1;	/* Trigger bit 0 */
		unsigned int TRG1           : 1;	/* Trigger bit 1 */
		unsigned int TRG2           : 1;	/* Trigger bit 2 */
		unsigned int TRG3           : 1;	/* Trigger bit 3 */
		unsigned int TRG4           : 1;	/* Trigger bit 4 */
		unsigned int TRG5           : 1;	/* Trigger bit 5 */
		unsigned int TRG6           : 1;	/* Trigger bit 6 */
		unsigned int TRG7           : 1;	/* Trigger bit 7 */
		unsigned int TRG8           : 1;	/* trigger bit 8 */
		unsigned int TRG9           : 1;	/* Trigger bit 9 */
		unsigned int TRG10          : 1;	/* Trigger bit 10 */
		unsigned int TRG11          : 1;	/* Trigger bit 11 */
		unsigned int TRG12          : 1;	/* Trigger bit 12 */
		unsigned int TRG13          : 1;	/* Trigger bit 13 */
		unsigned int TRG14          : 1;	/* Trigger bit 14 */
		unsigned int TRG15          : 1;	/* Trigger bit 15 */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MCS0_STRG_type;
#define GTM_MCS0_STRG	(*( GTM_MCS0_STRG_type *) 0xf0130408u)	/* MCS0 Set Trigger Control Register */
#define GTM_MCS1_STRG	(*( GTM_MCS0_STRG_type *) 0xf0140408u)	/* MCS1 Set Trigger Control Register */
#define GTM_MCS2_STRG	(*( GTM_MCS0_STRG_type *) 0xf0150408u)	/* MCS2 Set Trigger Control Register */
#define GTM_MCS3_STRG	(*( GTM_MCS0_STRG_type *) 0xf0160408u)	/* MCS3 Set Trigger Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MCA_0_0        : 1;	/* Activity of check performed in module MCS[0] at channel 0 */
		unsigned int MCA_0_1        : 1;	/* Activity of check performed in module MCS[0] at channel 1 */
		unsigned int MCA_0_2        : 1;	/* Activity of check performed in module MCS[0] at channel 2 */
		unsigned int MCA_0_3        : 1;	/* Activity of check performed in module MCS[0] at channel 3 */
		unsigned int MCA_0_4        : 1;	/* Activity of check performed in module MCS[0] at channel 4 */
		unsigned int MCA_0_5        : 1;	/* Activity of check performed in module MCS[0] at channel 5 */
		unsigned int MCA_0_6        : 1;	/* Activity of check performed in module MCS[0] at channel 6 */
		unsigned int MCA_0_7        : 1;	/* Activity of check performed in module MCS[0] at channel 7 */
		unsigned int MCA_1_0        : 1;	/* Activity of check performed in module MCS[1] at channel 0 */
		unsigned int MCA_1_1        : 1;	/* Activity of check performed in module MCS[1] at channel 1 */
		unsigned int MCA_1_2        : 1;	/* Activity of check performed in module MCS[1] at channel 2 */
		unsigned int MCA_1_3        : 1;	/* Activity of check performed in module MCS[1] at channel 3 */
		unsigned int MCA_1_4        : 1;	/* Activity of check performed in module MCS[1] at channel 4 */
		unsigned int MCA_1_5        : 1;	/* Activity of check performed in module MCS[1] at channel 5 */
		unsigned int MCA_1_6        : 1;	/* Activity of check performed in module MCS[1] at channel 6 */
		unsigned int MCA_1_7        : 1;	/* Activity of check performed in module MCS[1] at channel 7 */
		unsigned int MCA_2_0        : 1;	/* Activity of check performed in module MCS[2] at channel 0 */
		unsigned int MCA_2_1        : 1;	/* Activity of check performed in module MCS[2] at channel 1 */
		unsigned int MCA_2_2        : 1;	/* Activity of check performed in module MCS[2] at channel 2 */
		unsigned int MCA_2_3        : 1;	/* Activity of check performed in module MCS[2] at channel 3 */
		unsigned int MCA_2_4        : 1;	/* Activity of check performed in module MCS[2] at channel 4 */
		unsigned int MCA_2_5        : 1;	/* Activity of check performed in module MCS[2] at channel 5 */
		unsigned int MCA_2_6        : 1;	/* Activity of check performed in module MCS[2] at channel 6 */
		unsigned int MCA_2_7        : 1;	/* Activity of check performed in module MCS[2] at channel 7 */
		unsigned int MCA_3_0        : 1;	/* Activity of check performed in module MCS[3] at channel 0 */
		unsigned int MCA_3_1        : 1;	/* Activity of check performed in module MCS[3] at channel 1 */
		unsigned int MCA_3_2        : 1;	/* Activity of check performed in module MCS[3] at channel 2 */
		unsigned int MCA_3_3        : 1;	/* Activity of check performed in module MCS[3] at channel 3 */
		unsigned int MCA_3_4        : 1;	/* Activity of check performed in module MCS[3] at channel 4 */
		unsigned int MCA_3_5        : 1;	/* Activity of check performed in module MCS[3] at channel 5 */
		unsigned int MCA_3_6        : 1;	/* Activity of check performed in module MCS[3] at channel 6 */
		unsigned int MCA_3_7        : 1;	/* Activity of check performed in module MCS[3] at channel 7 */
	} B;
	int I;
	unsigned int U;

} GTM_MON_ACTIVITY_0_type;
#define GTM_MON_ACTIVITY_0	(*( GTM_MON_ACTIVITY_0_type *) 0xf0100184u)	/* Monitor Activity Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int ACT_CMU0       : 1;	/* CMU_CLK0 activity */
		unsigned int ACT_CMU1       : 1;	/* CMU_CLK1 activity */
		unsigned int ACT_CMU2       : 1;	/* CMU_CLK2 activity */
		unsigned int ACT_CMU3       : 1;	/* CMU_CLK3 activity */
		unsigned int ACT_CMU4       : 1;	/* CMU_CLK4 activity */
		unsigned int ACT_CMU5       : 1;	/* CMU_CLK5 activity */
		unsigned int ACT_CMU6       : 1;	/* CMU_CLK6 activity */
		unsigned int ACT_CMU7       : 1;	/* CMU_CLK7 activity */
		unsigned int ACT_CMUFX0     : 1;	/* CMU_CLKFX0 activity */
		unsigned int ACT_CMUFX1     : 1;	/* CMU_CLKFX1 activity */
		unsigned int ACT_CMUFX2     : 1;	/* CMU_CLKFX2 activity */
		unsigned int ACT_CMUFX3     : 1;	/* CMU_CLKFX3 activity */
		unsigned int ACT_CMUFX4     : 1;	/* CMU_CLKFX4 activity */
		/* const */ unsigned int Reserved       : 3;	/* Reserved */
		/* const */ unsigned int CMP_ERR        : 1;	/* Error detected at CMP */
		/* const */ unsigned int Reserved_16    : 3;	/* Reserved */
		/* const */ unsigned int MCS0_ERR       : 1;	/* Error detected at MCS[0] */
		/* const */ unsigned int MCS1_ERR       : 1;	/* Error detected at MCS[1] */
		/* const */ unsigned int MCS2_ERR       : 1;	/* Error detected at MCS[2] */
		/* const */ unsigned int MCS3_ERR       : 1;	/* Error detected at MCS[3] */
		/* const */ unsigned int Reserved_21    : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_MON_STATUS_type;
#define GTM_MON_STATUS	(*( GTM_MON_STATUS_type *) 0xf0100180u)	/* Monitor Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL1           : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL2           : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL3           : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL4           : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL5           : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL6           : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL7           : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL8           : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL9           : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL10          : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL11          : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL12          : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL13          : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL14          : 2;	/* GTM MSC0 High x Output Selection */
		unsigned int SEL15          : 2;	/* GTM MSC0 High x Output Selection */
	} B;
	int I;
	unsigned int U;

} GTM_MSC0INHCON_type;
#define GTM_MSC0INHCON	(*( GTM_MSC0INHCON_type *) 0xf019ff64u)	/* MSC0 Input High Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL1           : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL2           : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL3           : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL4           : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL5           : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL6           : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL7           : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL8           : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL9           : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL10          : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL11          : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL12          : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL13          : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL14          : 2;	/* GTM MSC0 Low x Output Selection */
		unsigned int SEL15          : 2;	/* GTM MSC0 Low x Output Selection */
	} B;
	int I;
	unsigned int U;

} GTM_MSC0INLCON_type;
#define GTM_MSC0INLCON	(*( GTM_MSC0INLCON_type *) 0xf019ff60u)	/* MSC0 Input Low Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL1           : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL2           : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL3           : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL4           : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL5           : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL6           : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL7           : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL8           : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL9           : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL10          : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL11          : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL12          : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL13          : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL14          : 2;	/* GTM MSC1 High x Output Selection */
		unsigned int SEL15          : 2;	/* GTM MSC1 High x Output Selection */
	} B;
	int I;
	unsigned int U;

} GTM_MSC1INHCON_type;
#define GTM_MSC1INHCON	(*( GTM_MSC1INHCON_type *) 0xf019ff6cu)	/* MSC1 Input High Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL1           : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL2           : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL3           : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL4           : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL5           : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL6           : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL7           : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL8           : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL9           : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL10          : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL11          : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL12          : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL13          : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL14          : 2;	/* GTM MSC1 Low x Output Selection */
		unsigned int SEL15          : 2;	/* GTM MSC1 Low x Output Selection */
	} B;
	int I;
	unsigned int U;

} GTM_MSC1INLCON_type;
#define GTM_MSC1INLCON	(*( GTM_MSC1INLCON_type *) 0xf019ff68u)	/* MSC1 Input Low Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 5;	/* Set 1[0] Input Selection */
		unsigned int                : 3;
		unsigned int SEL1           : 5;	/* Set 1[1] Input Selection */
		unsigned int                : 3;
		unsigned int SEL2           : 5;	/* Set 1[2] Input Selection */
		unsigned int                : 3;
		unsigned int SEL3           : 5;	/* Set 1[3] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET1CON0_type;
#define GTM_MSCSET1CON0	(*( GTM_MSCSET1CON0_type *) 0xf019ff00u)	/* MSC Set 1 Control 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL4           : 5;	/* Set 1[4] Input Selection */
		unsigned int                : 3;
		unsigned int SEL5           : 5;	/* Set 1[5] Input Selection */
		unsigned int                : 3;
		unsigned int SEL6           : 5;	/* Set 1[6] Input Selection */
		unsigned int                : 3;
		unsigned int SEL7           : 5;	/* Set 1[7] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET1CON1_type;
#define GTM_MSCSET1CON1	(*( GTM_MSCSET1CON1_type *) 0xf019ff04u)	/* MSC Set 1 Control 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL8           : 5;	/* Set 1[8] Input Selection */
		unsigned int                : 3;
		unsigned int SEL9           : 5;	/* Set 1[9] Input Selection */
		unsigned int                : 3;
		unsigned int SEL10          : 5;	/* Set 1[10] Input Selection */
		unsigned int                : 3;
		unsigned int SEL11          : 5;	/* Set 1[11] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET1CON2_type;
#define GTM_MSCSET1CON2	(*( GTM_MSCSET1CON2_type *) 0xf019ff08u)	/* MSC Set 1 Control 2 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL12          : 5;	/* Set 1[12] Input Selection */
		unsigned int                : 3;
		unsigned int SEL13          : 5;	/* Set 1[13] Input Selection */
		unsigned int                : 3;
		unsigned int SEL14          : 5;	/* Set 1[14] Input Selection */
		unsigned int                : 3;
		unsigned int SEL15          : 5;	/* Set 1[15] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET1CON3_type;
#define GTM_MSCSET1CON3	(*( GTM_MSCSET1CON3_type *) 0xf019ff0cu)	/* MSC Set 1 Control 3 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 5;	/* Set 2[0] Input Selection */
		unsigned int                : 3;
		unsigned int SEL1           : 5;	/* Set 2[1] Input Selection */
		unsigned int                : 3;
		unsigned int SEL2           : 5;	/* Set 2[2] Input Selection */
		unsigned int                : 3;
		unsigned int SEL3           : 5;	/* Set 2[3] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET2CON0_type;
#define GTM_MSCSET2CON0	(*( GTM_MSCSET2CON0_type *) 0xf019ff10u)	/* MSC Set 2 Control 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL4           : 5;	/* Set 2[4] Input Selection */
		unsigned int                : 3;
		unsigned int SEL5           : 5;	/* Set 2[5] Input Selection */
		unsigned int                : 3;
		unsigned int SEL6           : 5;	/* Set 2[6] Input Selection */
		unsigned int                : 3;
		unsigned int SEL7           : 5;	/* Set 2[7] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET2CON1_type;
#define GTM_MSCSET2CON1	(*( GTM_MSCSET2CON1_type *) 0xf019ff14u)	/* MSC Set 2 Control 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL8           : 5;	/* Set 2[8] Input Selection */
		unsigned int                : 3;
		unsigned int SEL9           : 5;	/* Set 2[9] Input Selection */
		unsigned int                : 3;
		unsigned int SEL10          : 5;	/* Set 2[10] Input Selection */
		unsigned int                : 3;
		unsigned int SEL11          : 5;	/* Set 2[11] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET2CON2_type;
#define GTM_MSCSET2CON2	(*( GTM_MSCSET2CON2_type *) 0xf019ff18u)	/* MSC Set 2 Control 2 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL12          : 5;	/* Set 2[12] Input Selection */
		unsigned int                : 3;
		unsigned int SEL13          : 5;	/* Set 2[13] Input Selection */
		unsigned int                : 3;
		unsigned int SEL14          : 5;	/* Set 2[14] Input Selection */
		unsigned int                : 3;
		unsigned int SEL15          : 5;	/* Set 2[15] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET2CON3_type;
#define GTM_MSCSET2CON3	(*( GTM_MSCSET2CON3_type *) 0xf019ff1cu)	/* MSC Set 2 Control 3 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 5;	/* Set 3[0] Input Selection */
		unsigned int                : 3;
		unsigned int SEL1           : 5;	/* Set 3[1] Input Selection */
		unsigned int                : 3;
		unsigned int SEL2           : 5;	/* Set 3[2] Input Selection */
		unsigned int                : 3;
		unsigned int SEL3           : 5;	/* Set 3[3] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET3CON0_type;
#define GTM_MSCSET3CON0	(*( GTM_MSCSET3CON0_type *) 0xf019ff20u)	/* MSC Set 3 Control 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL4           : 5;	/* Set 3[4] Input Selection */
		unsigned int                : 3;
		unsigned int SEL5           : 5;	/* Set 3[5] Input Selection */
		unsigned int                : 3;
		unsigned int SEL6           : 5;	/* Set 3[6] Input Selection */
		unsigned int                : 3;
		unsigned int SEL7           : 5;	/* Set 3[7] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET3CON1_type;
#define GTM_MSCSET3CON1	(*( GTM_MSCSET3CON1_type *) 0xf019ff24u)	/* MSC Set 3 Control 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL8           : 5;	/* Set 3[8] Input Selection */
		unsigned int                : 3;
		unsigned int SEL9           : 5;	/* Set 3[9] Input Selection */
		unsigned int                : 3;
		unsigned int SEL10          : 5;	/* Set 3[10] Input Selection */
		unsigned int                : 3;
		unsigned int SEL11          : 5;	/* Set 3[11] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET3CON2_type;
#define GTM_MSCSET3CON2	(*( GTM_MSCSET3CON2_type *) 0xf019ff28u)	/* MSC Set 3 Control 2 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL12          : 5;	/* Set 3[12] Input Selection */
		unsigned int                : 3;
		unsigned int SEL13          : 5;	/* Set 3[13] Input Selection */
		unsigned int                : 3;
		unsigned int SEL14          : 5;	/* Set 3[14] Input Selection */
		unsigned int                : 3;
		unsigned int SEL15          : 5;	/* Set 3[15] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET3CON3_type;
#define GTM_MSCSET3CON3	(*( GTM_MSCSET3CON3_type *) 0xf019ff2cu)	/* MSC Set 3 Control 3 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 5;	/* Set 4[0] Input Selection */
		unsigned int                : 3;
		unsigned int SEL1           : 5;	/* Set 4[1] Input Selection */
		unsigned int                : 3;
		unsigned int SEL2           : 5;	/* Set 4[2] Input Selection */
		unsigned int                : 3;
		unsigned int SEL3           : 5;	/* Set 4[3] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET4CON0_type;
#define GTM_MSCSET4CON0	(*( GTM_MSCSET4CON0_type *) 0xf019ff30u)	/* MSC Set 4 Control 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL4           : 5;	/* Set 4[4] Input Selection */
		unsigned int                : 3;
		unsigned int SEL5           : 5;	/* Set 4[5] Input Selection */
		unsigned int                : 3;
		unsigned int SEL6           : 5;	/* Set 4[6] Input Selection */
		unsigned int                : 3;
		unsigned int SEL7           : 5;	/* Set 4[7] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET4CON1_type;
#define GTM_MSCSET4CON1	(*( GTM_MSCSET4CON1_type *) 0xf019ff34u)	/* MSC Set 4 Control 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL8           : 5;	/* Set 4[8] Input Selection */
		unsigned int                : 3;
		unsigned int SEL9           : 5;	/* Set 4[9] Input Selection */
		unsigned int                : 3;
		unsigned int SEL10          : 5;	/* Set 4[10] Input Selection */
		unsigned int                : 3;
		unsigned int SEL11          : 5;	/* Set 4[11] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET4CON2_type;
#define GTM_MSCSET4CON2	(*( GTM_MSCSET4CON2_type *) 0xf019ff38u)	/* MSC Set 4 Control 2 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL12          : 5;	/* Set 4[12] Input Selection */
		unsigned int                : 3;
		unsigned int SEL13          : 5;	/* Set 4[13] Input Selection */
		unsigned int                : 3;
		unsigned int SEL14          : 5;	/* Set 4[14] Input Selection */
		unsigned int                : 3;
		unsigned int SEL15          : 5;	/* Set 4[15] Input Selection */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_MSCSET4CON3_type;
#define GTM_MSCSET4CON3	(*( GTM_MSCSET4CON3_type *) 0xf019ff3cu)	/* MSC Set 4 Control 3 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} GTM_OCS_type;
#define GTM_OCS	(*( GTM_OCS_type *) 0xf019fde8u)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		unsigned int DDREN          : 1;	/* Detructive Debug Read Enable */
		unsigned int DREN           : 1;	/* Detructive Read Enable */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} GTM_ODA_type;
#define GTM_ODA	(*( GTM_ODA_type *) 0xf019fddcu)	/* OCDS Debug Access Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CV             : 27;	/* Compare Value */
		unsigned int                : 1;
		unsigned int CM             : 2;	/* Compare Mode */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} GTM_OTBU0T_type;
#define GTM_OTBU0T	(*( GTM_OTBU0T_type *) 0xf019fdc4u)	/* OCDS TBU0 Trigger Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CV             : 24;	/* Compare Value */
		unsigned int                : 4;
		unsigned int EN             : 1;	/* Enable */
		unsigned int                : 3;
	} B;
	int I;
	unsigned int U;

} GTM_OTBU1T_type;
#define GTM_OTBU1T	(*( GTM_OTBU1T_type *) 0xf019fdc8u)	/* OCDS TBU1 Trigger Register */
#define GTM_OTBU2T	(*( GTM_OTBU1T_type *) 0xf019fdccu)	/* OCDS TBU2 Trigger Register */

typedef volatile union
{
	struct
	{ 
		unsigned int B0LMT          : 3;	/* OTGB0 TS16_IOS Low Byte Module Type */
		unsigned int                : 1;
		unsigned int B0LMI          : 4;	/* OTGB0 TS16_IOS Low Byte Module Instance */
		unsigned int B0HMT          : 3;	/* OTGB0 TS16_IOS High Byte Module Type */
		unsigned int                : 1;
		unsigned int B0HMI          : 4;	/* OTGB0 TS16_IOS High Byte Module Instance */
		unsigned int B1LMT          : 3;	/* OTGB1 TS16_IOS Low Byte Module Type */
		unsigned int                : 1;
		unsigned int B1LMI          : 4;	/* OTGB1 TS16_IOS Low Byte Module Instance */
		unsigned int B1HMT          : 3;	/* OTGB1 TS16_IOS High Byte Module Type */
		unsigned int                : 1;
		unsigned int B1HMI          : 4;	/* OTGB1 TS16_IOS High Byte Module Instance */
	} B;
	int I;
	unsigned int U;

} GTM_OTSC0_type;
#define GTM_OTSC0	(*( GTM_OTSC0_type *) 0xf019fdd4u)	/* OCDS Trigger Set Control 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MCS            : 4;	/* MCS Channel Select */
		unsigned int MI             : 4;	/* MCS Instance */
		unsigned int MCE            : 1;	/* MCS CPU (AEI) Accesses Trace Enable */
		unsigned int MOE            : 1;	/* MCS Opcode Trace Enable */
		unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} GTM_OTSC1_type;
#define GTM_OTSC1	(*( GTM_OTSC1_type *) 0xf019fdd8u)	/* OCDS Trigger Set Control 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int OTGB0          : 4;	/* Trigger Set for OTGB0 */
		unsigned int                : 4;
		unsigned int OTGB1          : 4;	/* Trigger Set for OTGB1 */
		unsigned int                : 4;
		unsigned int OTGB2          : 4;	/* Trigger Set for OTGB2 */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} GTM_OTSS_type;
#define GTM_OTSS	(*( GTM_OTSS_type *) 0xf019fdd0u)	/* OCDS Trigger Set Select Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 4;	/* Output Selection for PSI5x GTM connection */
		unsigned int SEL1           : 4;	/* Output Selection for PSI5x GTM connection */
		unsigned int SEL2           : 4;	/* Output Selection for PSI5x GTM connection */
		unsigned int SEL3           : 4;	/* Output Selection for PSI5x GTM connection */
		unsigned int SEL4           : 4;	/* Output Selection for PSI5x GTM connection */
		unsigned int SEL5           : 4;	/* Output Selection for PSI5x GTM connection */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} GTM_PSI5OUTSEL0_type;
#define GTM_PSI5OUTSEL0	(*( GTM_PSI5OUTSEL0_type *) 0xf019fda4u)	/* PSI5 Output Select 0 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 4;	/* Output Selection for PSI5-S GTM connection */
		unsigned int SEL1           : 4;	/* Output Selection for PSI5-S GTM connection */
		unsigned int SEL2           : 4;	/* Output Selection for PSI5-S GTM connection */
		unsigned int SEL3           : 4;	/* Output Selection for PSI5-S GTM connection */
		unsigned int SEL4           : 4;	/* Output Selection for PSI5-S GTM connection */
		unsigned int SEL5           : 4;	/* Output Selection for PSI5-S GTM connection */
		unsigned int SEL6           : 4;	/* Output Selection for PSI5-S GTM connection */
		unsigned int SEL7           : 4;	/* Output Selection for PSI5-S GTM connection */
	} B;
	int I;
	unsigned int U;

} GTM_PSI5SOUTSEL_type;
#define GTM_PSI5SOUTSEL	(*( GTM_PSI5SOUTSEL_type *) 0xf019fda8u)	/* PSI5-S Output Select Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int YEAR           : 8;	/* GTM Year of development */
		/* const */ unsigned int NO             : 4;	/* Define delivery number */
		/* const */ unsigned int MINOR          : 4;	/* Define minor version number of implementation */
		/* const */ unsigned int MAJOR          : 4;	/* Define major version number of implementation */
		/* const */ unsigned int DEV_CODE0      : 4;	/* Device encoding digit 0 */
		/* const */ unsigned int DEV_CODE1      : 4;	/* Device encoding digit 1 */
		/* const */ unsigned int DEV_CODE2      : 4;	/* Device encoding digit 2 */
	} B;
	int I;
	unsigned int U;

} GTM_REV_type;
#define GTM_REV	(*( GTM_REV_type *) 0xf0100000u)	/* GTM Version Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* GTM Reset */
		/* const */ unsigned int Reserved       : 31;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_RST_type;
#define GTM_RST	(*( GTM_RST_type *) 0xf0100004u)	/* GTM Global Reset Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SPE_EN         : 1;	/* SPE Submodule enable */
		unsigned int SIE0           : 1;	/* SPE Input enable for TIM_CHx(48) */
		unsigned int SIE1           : 1;	/* SPE Input enable for TIM_CHy(48) */
		unsigned int SIE2           : 1;	/* SPE Input enable for TIM_CHz(48) */
		unsigned int TRIG_SEL       : 2;	/* Select trigger input signal */
		unsigned int TIM_SEL        : 1;	/* select TIM input signal */
		unsigned int FSOM           : 1;	/* Fast Shut-Off Mode */
		unsigned int SPE_PAT_PTR    : 3;	/* Pattern selector for TOM output signals */
		/* const */ unsigned int Reserved       : 1;	/* Reserved */
		unsigned int AIP            : 3;	/* Actual input pattern that was detected by a regular input pattern change */
		unsigned int ADIR           : 1;	/* Actual rotation direction */
		unsigned int PIP            : 3;	/* Previous input pattern that was detected by a regular input pattern change */
		unsigned int PDIR           : 1;	/* Previous rotation direction */
		/* const */ unsigned int NIP            : 3;	/* New input pattern that was detected */
		/* const */ unsigned int Reserved_15    : 1;	/* Reserved */
		unsigned int FSOL           : 8;	/* Fast Shut-Off Level for TOM[i] channel 0 to 7 */
	} B;
	int I;
	unsigned int U;

} GTM_SPE0_CTRL_STAT_type;
#define GTM_SPE0_CTRL_STAT	(*( GTM_SPE0_CTRL_STAT_type *) 0xf0100800u)	/* SPE0 Control Status Register */
#define GTM_SPE1_CTRL_STAT	(*( GTM_SPE0_CTRL_STAT_type *) 0xf0100880u)	/* SPE1 Control Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SPE_NIPD_IRQ_EN: 1;	/* SPE_NIPD_IRQ interrupt enable */
		unsigned int SPE_DCHG_IRQ_EN: 1;	/* SPE_DCHG_IRQ interrupt enable */
		unsigned int SPE_PERR_IRQ_EN: 1;	/* SPE_PERR_IRQ interrupt enable */
		unsigned int SPE_BIS_IRQ_EN : 1;	/* SPE_BIS_IRQ interrupt enable */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_SPE0_IRQ_EN_type;
#define GTM_SPE0_IRQ_EN	(*( GTM_SPE0_IRQ_EN_type *) 0xf0100830u)	/* SPE0 Interrupt Enable Register */
#define GTM_SPE1_IRQ_EN	(*( GTM_SPE0_IRQ_EN_type *) 0xf01008b0u)	/* SPE1 Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_SPE_NIPD   : 1;	/* Force interrupt of SPE_NIPD */
		unsigned int TRG_SPE_DCHG   : 1;	/* Force interrupt of SPE_DCHG */
		unsigned int TRG_SPE_PERR   : 1;	/* Force interrupt of SPE_PERR */
		unsigned int TRG_SPE_BIS    : 1;	/* Force interrupt of SPE_BIS */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_SPE0_IRQ_FORCINT_type;
#define GTM_SPE0_IRQ_FORCINT	(*( GTM_SPE0_IRQ_FORCINT_type *) 0xf0100834u)	/* SPE0 Interrupt Generation by Software */
#define GTM_SPE1_IRQ_FORCINT	(*( GTM_SPE0_IRQ_FORCINT_type *) 0xf01008b4u)	/* SPE1 Interrupt Generation by Software */

typedef volatile union
{
	struct
	{ 
		unsigned int SPE_NIPD       : 1;	/* New input pattern interrupt occurred */
		unsigned int SPE_DCHG       : 1;	/* SPE_DIR bit changed on behalf of new input pattern */
		unsigned int SPE_PERR       : 1;	/* Wrong or invalid pattern detected at input */
		unsigned int SPE_BIS        : 1;	/* Bouncing input signal detected */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_SPE0_IRQ_NOTIFY_type;
#define GTM_SPE0_IRQ_NOTIFY	(*( GTM_SPE0_IRQ_NOTIFY_type *) 0xf010082cu)	/* SPE0 Interrupt Notification Register */
#define GTM_SPE1_IRQ_NOTIFY	(*( GTM_SPE0_IRQ_NOTIFY_type *) 0xf01008acu)	/* SPE1 Interrupt Notification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SPE_OUT_CTRL   : 16;	/* SPE output control value for TOM_CH0 to TOM_CH7 */
		/* const */ unsigned int Reserved       : 16;	/* Read as zero, should be written as zero */
	} B;
	int I;
	unsigned int U;

} GTM_SPE0_OUT_CTRL_type;
#define GTM_SPE0_OUT_CTRL	(*( GTM_SPE0_OUT_CTRL_type *) 0xf0100828u)	/* SPE0 Output Control Register */
#define GTM_SPE1_OUT_CTRL	(*( GTM_SPE0_OUT_CTRL_type *) 0xf01008a8u)	/* SPE1 Output Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SPE_OUT_PAT    : 16;	/* SPE output control value for TOM_CH0 to TOM_CH7 */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_SPE0_OUT_PAT0_type;
#define GTM_SPE0_OUT_PAT0	(*( GTM_SPE0_OUT_PAT0_type *) 0xf0100808u)	/* SPE0 Output Definition Register r0 */
#define GTM_SPE0_OUT_PAT1	(*( GTM_SPE0_OUT_PAT0_type *) 0xf010080cu)	/* SPE0 Output Definition Register r1 */
#define GTM_SPE0_OUT_PAT2	(*( GTM_SPE0_OUT_PAT0_type *) 0xf0100810u)	/* SPE0 Output Definition Register r2 */
#define GTM_SPE0_OUT_PAT3	(*( GTM_SPE0_OUT_PAT0_type *) 0xf0100814u)	/* SPE0 Output Definition Register r3 */
#define GTM_SPE0_OUT_PAT4	(*( GTM_SPE0_OUT_PAT0_type *) 0xf0100818u)	/* SPE0 Output Definition Register r4 */
#define GTM_SPE0_OUT_PAT5	(*( GTM_SPE0_OUT_PAT0_type *) 0xf010081cu)	/* SPE0 Output Definition Register r5 */
#define GTM_SPE0_OUT_PAT6	(*( GTM_SPE0_OUT_PAT0_type *) 0xf0100820u)	/* SPE0 Output Definition Register r6 */
#define GTM_SPE0_OUT_PAT7	(*( GTM_SPE0_OUT_PAT0_type *) 0xf0100824u)	/* SPE0 Output Definition Register r7 */
#define GTM_SPE1_OUT_PAT0	(*( GTM_SPE0_OUT_PAT0_type *) 0xf0100888u)	/* SPE1 Output Definition Register r0 */
#define GTM_SPE1_OUT_PAT1	(*( GTM_SPE0_OUT_PAT0_type *) 0xf010088cu)	/* SPE1 Output Definition Register r1 */
#define GTM_SPE1_OUT_PAT2	(*( GTM_SPE0_OUT_PAT0_type *) 0xf0100890u)	/* SPE1 Output Definition Register r2 */
#define GTM_SPE1_OUT_PAT3	(*( GTM_SPE0_OUT_PAT0_type *) 0xf0100894u)	/* SPE1 Output Definition Register r3 */
#define GTM_SPE1_OUT_PAT4	(*( GTM_SPE0_OUT_PAT0_type *) 0xf0100898u)	/* SPE1 Output Definition Register r4 */
#define GTM_SPE1_OUT_PAT5	(*( GTM_SPE0_OUT_PAT0_type *) 0xf010089cu)	/* SPE1 Output Definition Register r5 */
#define GTM_SPE1_OUT_PAT6	(*( GTM_SPE0_OUT_PAT0_type *) 0xf01008a0u)	/* SPE1 Output Definition Register r6 */
#define GTM_SPE1_OUT_PAT7	(*( GTM_SPE0_OUT_PAT0_type *) 0xf01008a4u)	/* SPE1 Output Definition Register r7 */

typedef volatile union
{
	struct
	{ 
		unsigned int IP0_VAL        : 1;	/* Input pattern 0 is a valid pattern */
		unsigned int IP0_PAT        : 3;	/* Input pattern 0 */
		unsigned int IP1_VAL        : 1;	/* Input pattern 1 is a valid pattern */
		unsigned int IP1_PAT        : 3;	/* Input pattern 1 */
		unsigned int IP2_VAL        : 1;	/* Input pattern 2 is a valid pattern */
		unsigned int IP2_PAT        : 3;	/* Input pattern 2 */
		unsigned int IP3_VAL        : 1;	/* Input pattern 3 is a valid pattern */
		unsigned int IP3_PAT        : 3;	/* Input pattern 3 */
		unsigned int IP4_VAL        : 1;	/* Input pattern 4 is a valid pattern */
		unsigned int IP4_PAT        : 3;	/* Input pattern 4 */
		unsigned int IP5_VAL        : 1;	/* Input pattern 5 is a valid pattern */
		unsigned int IP5_PAT        : 3;	/* Input pattern 5 */
		unsigned int IP6_VAL        : 1;	/* Input pattern 6 is a valid pattern */
		unsigned int IP6_PAT        : 3;	/* Input pattern 6 */
		unsigned int IP7_VAL        : 1;	/* Input pattern 7 is a valid pattern */
		unsigned int IP7_PAT        : 3;	/* Input pattern 7 */
	} B;
	int I;
	unsigned int U;

} GTM_SPE0_PAT_type;
#define GTM_SPE0_PAT	(*( GTM_SPE0_PAT_type *) 0xf0100804u)	/* SPE0 Input Pattern Definition Register */
#define GTM_SPE1_PAT	(*( GTM_SPE0_PAT_type *) 0xf0100884u)	/* SPE1 Input Pattern Definition Register */

typedef volatile union
{
	struct
	{ 
		unsigned int BASE           : 27;	/* Time base value for channel 0 */
		/* const */ unsigned int Reserved       : 5;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TBU_CH0_BASE_type;
#define GTM_TBU_CH0_BASE	(*( GTM_TBU_CH0_BASE_type *) 0xf0100108u)	/* TBU Channel 0 Base Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LOW_RES        : 1;	/* TBU_CH0_BASE register resolution */
		unsigned int CH_CLK_SRC     : 3;	/* Clock source for channel x (x:0...2) time base counter */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TBU_CH0_CTRL_type;
#define GTM_TBU_CH0_CTRL	(*( GTM_TBU_CH0_CTRL_type *) 0xf0100104u)	/* TBU Channel 0 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int BASE           : 24;	/* Time base value for channel x (x 1, 2) */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TBU_CH1_BASE_type;
#define GTM_TBU_CH1_BASE	(*( GTM_TBU_CH1_BASE_type *) 0xf0100110u)	/* TBU Channel 1 Base Register */
#define GTM_TBU_CH2_BASE	(*( GTM_TBU_CH1_BASE_type *) 0xf0100118u)	/* TBU Channel 2 Base Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CH_MODE        : 1;	/* Channel mode */
		unsigned int CH_CLK_SRC     : 3;	/* Clock source for channel x (x02) time base counter */
		/* const */ unsigned int Reserved       : 28;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TBU_CH1_CTRL_type;
#define GTM_TBU_CH1_CTRL	(*( GTM_TBU_CH1_CTRL_type *) 0xf010010cu)	/* TBU Channel 1 Control Register */
#define GTM_TBU_CH2_CTRL	(*( GTM_TBU_CH1_CTRL_type *) 0xf0100114u)	/* TBU Channel 2 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ENDIS_CH0      : 2;	/* TBU channel 0 enable/disable control */
		unsigned int ENDIS_CH1      : 2;	/* TBU channel 1 enable/disable control */
		unsigned int ENDIS_CH2      : 2;	/* TBU channel 2 enable/disable control */
		/* const */ unsigned int Reserved       : 26;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TBU_CHEN_type;
#define GTM_TBU_CHEN	(*( GTM_TBU_CHEN_type *) 0xf0100100u)	/* TBU Global Channel Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TBU_TS0_S      : 24;	/* value of TBU_TS0 at the last STATE event */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TBU_TS0_S_type;
#define GTM_TBU_TS0_S	(*( GTM_TBU_TS0_S_type *) 0xf01280c4u)	/* DPLL TBU_TS0 Value at last STATE Event */

typedef volatile union
{
	struct
	{ 
		unsigned int TBU_TS0_T      : 24;	/* value of TBU_TS0 at the last TRIGGER event */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TBU_TS0_T_type;
#define GTM_TBU_TS0_T	(*( GTM_TBU_TS0_T_type *) 0xf01280c0u)	/* DPLL TBU_TS0 Value at last TRIGGER Event */

typedef volatile union
{
	struct
	{ 
		unsigned int CH0SEL         : 4;	/* TIM Channel x Input Selection */
		unsigned int CH1SEL         : 4;	/* TIM Channel x Input Selection */
		unsigned int CH2SEL         : 4;	/* TIM Channel x Input Selection */
		unsigned int CH3SEL         : 4;	/* TIM Channel x Input Selection */
		unsigned int CH4SEL         : 4;	/* TIM Channel x Input Selection */
		unsigned int CH5SEL         : 4;	/* TIM Channel x Input Selection */
		unsigned int CH6SEL         : 4;	/* TIM Channel x Input Selection */
		unsigned int CH7SEL         : 4;	/* TIM Channel x Input Selection */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0INSEL_type;
#define GTM_TIM0INSEL	(*( GTM_TIM0INSEL_type *) 0xf019fd10u)	/* TIM0 Input Select Register */
#define GTM_TIM1INSEL	(*( GTM_TIM0INSEL_type *) 0xf019fd14u)	/* TIM1 Input Select Register */
#define GTM_TIM2INSEL	(*( GTM_TIM0INSEL_type *) 0xf019fd18u)	/* TIM2 Input Select Register */
#define GTM_TIM3INSEL	(*( GTM_TIM0INSEL_type *) 0xf019fd1cu)	/* TIM3 Input Select Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CNT            : 24;	/* Actual SMU counter value */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_CNT_type;
#define GTM_TIM0_CH0_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101018u)	/* TIM0 Channel 0 SMU Counter Register */
#define GTM_TIM0_CH1_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101098u)	/* TIM0 Channel 1 SMU Counter Register */
#define GTM_TIM0_CH2_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101118u)	/* TIM0 Channel 2 SMU Counter Register */
#define GTM_TIM0_CH3_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101198u)	/* TIM0 Channel 3 SMU Counter Register */
#define GTM_TIM0_CH4_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101218u)	/* TIM0 Channel 4 SMU Counter Register */
#define GTM_TIM0_CH5_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101298u)	/* TIM0 Channel 5 SMU Counter Register */
#define GTM_TIM0_CH6_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101318u)	/* TIM0 Channel 6 SMU Counter Register */
#define GTM_TIM0_CH7_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101398u)	/* TIM0 Channel 7 SMU Counter Register */
#define GTM_TIM1_CH0_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101818u)	/* TIM1 Channel 0 SMU Counter Register */
#define GTM_TIM1_CH1_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101898u)	/* TIM1 Channel 1 SMU Counter Register */
#define GTM_TIM1_CH2_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101918u)	/* TIM1 Channel 2 SMU Counter Register */
#define GTM_TIM1_CH3_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101998u)	/* TIM1 Channel 3 SMU Counter Register */
#define GTM_TIM1_CH4_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101a18u)	/* TIM1 Channel 4 SMU Counter Register */
#define GTM_TIM1_CH5_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101a98u)	/* TIM1 Channel 5 SMU Counter Register */
#define GTM_TIM1_CH6_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101b18u)	/* TIM1 Channel 6 SMU Counter Register */
#define GTM_TIM1_CH7_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0101b98u)	/* TIM1 Channel 7 SMU Counter Register */
#define GTM_TIM2_CH0_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102018u)	/* TIM2 Channel 0 SMU Counter Register */
#define GTM_TIM2_CH1_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102098u)	/* TIM2 Channel 1 SMU Counter Register */
#define GTM_TIM2_CH2_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102118u)	/* TIM2 Channel 2 SMU Counter Register */
#define GTM_TIM2_CH3_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102198u)	/* TIM2 Channel 3 SMU Counter Register */
#define GTM_TIM2_CH4_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102218u)	/* TIM2 Channel 4 SMU Counter Register */
#define GTM_TIM2_CH5_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102298u)	/* TIM2 Channel 5 SMU Counter Register */
#define GTM_TIM2_CH6_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102318u)	/* TIM2 Channel 6 SMU Counter Register */
#define GTM_TIM2_CH7_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102398u)	/* TIM2 Channel 7 SMU Counter Register */
#define GTM_TIM3_CH0_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102818u)	/* TIM3 Channel 0 SMU Counter Register */
#define GTM_TIM3_CH1_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102898u)	/* TIM3 Channel 1 SMU Counter Register */
#define GTM_TIM3_CH2_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102918u)	/* TIM3 Channel 2 SMU Counter Register */
#define GTM_TIM3_CH3_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102998u)	/* TIM3 Channel 3 SMU Counter Register */
#define GTM_TIM3_CH4_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102a18u)	/* TIM3 Channel 4 SMU Counter Register */
#define GTM_TIM3_CH5_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102a98u)	/* TIM3 Channel 5 SMU Counter Register */
#define GTM_TIM3_CH6_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102b18u)	/* TIM3 Channel 6 SMU Counter Register */
#define GTM_TIM3_CH7_CNT	(*( GTM_TIM0_CH0_CNT_type *) 0xf0102b98u)	/* TIM3 Channel 7 SMU Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CNTS           : 24;	/* Counter shadow register */
		/* const */ unsigned int ECNT           : 8;	/* Edge counter */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_CNTS_type;
#define GTM_TIM0_CH0_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010101cu)	/* TIM0 Channel 0 SMU Shadow Counter Register */
#define GTM_TIM0_CH1_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010109cu)	/* TIM0 Channel 1 SMU Shadow Counter Register */
#define GTM_TIM0_CH2_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010111cu)	/* TIM0 Channel 2 SMU Shadow Counter Register */
#define GTM_TIM0_CH3_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010119cu)	/* TIM0 Channel 3 SMU Shadow Counter Register */
#define GTM_TIM0_CH4_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010121cu)	/* TIM0 Channel 4 SMU Shadow Counter Register */
#define GTM_TIM0_CH5_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010129cu)	/* TIM0 Channel 5 SMU Shadow Counter Register */
#define GTM_TIM0_CH6_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010131cu)	/* TIM0 Channel 6 SMU Shadow Counter Register */
#define GTM_TIM0_CH7_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010139cu)	/* TIM0 Channel 7 SMU Shadow Counter Register */
#define GTM_TIM1_CH0_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010181cu)	/* TIM1 Channel 0 SMU Shadow Counter Register */
#define GTM_TIM1_CH1_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010189cu)	/* TIM1 Channel 1 SMU Shadow Counter Register */
#define GTM_TIM1_CH2_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010191cu)	/* TIM1 Channel 2 SMU Shadow Counter Register */
#define GTM_TIM1_CH3_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010199cu)	/* TIM1 Channel 3 SMU Shadow Counter Register */
#define GTM_TIM1_CH4_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf0101a1cu)	/* TIM1 Channel 4 SMU Shadow Counter Register */
#define GTM_TIM1_CH5_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf0101a9cu)	/* TIM1 Channel 5 SMU Shadow Counter Register */
#define GTM_TIM1_CH6_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf0101b1cu)	/* TIM1 Channel 6 SMU Shadow Counter Register */
#define GTM_TIM1_CH7_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf0101b9cu)	/* TIM1 Channel 7 SMU Shadow Counter Register */
#define GTM_TIM2_CH0_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010201cu)	/* TIM2 Channel 0 SMU Shadow Counter Register */
#define GTM_TIM2_CH1_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010209cu)	/* TIM2 Channel 1 SMU Shadow Counter Register */
#define GTM_TIM2_CH2_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010211cu)	/* TIM2 Channel 2 SMU Shadow Counter Register */
#define GTM_TIM2_CH3_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010219cu)	/* TIM2 Channel 3 SMU Shadow Counter Register */
#define GTM_TIM2_CH4_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010221cu)	/* TIM2 Channel 4 SMU Shadow Counter Register */
#define GTM_TIM2_CH5_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010229cu)	/* TIM2 Channel 5 SMU Shadow Counter Register */
#define GTM_TIM2_CH6_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010231cu)	/* TIM2 Channel 6 SMU Shadow Counter Register */
#define GTM_TIM2_CH7_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010239cu)	/* TIM2 Channel 7 SMU Shadow Counter Register */
#define GTM_TIM3_CH0_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010281cu)	/* TIM3 Channel 0 SMU Shadow Counter Register */
#define GTM_TIM3_CH1_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010289cu)	/* TIM3 Channel 1 SMU Shadow Counter Register */
#define GTM_TIM3_CH2_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010291cu)	/* TIM3 Channel 2 SMU Shadow Counter Register */
#define GTM_TIM3_CH3_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf010299cu)	/* TIM3 Channel 3 SMU Shadow Counter Register */
#define GTM_TIM3_CH4_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf0102a1cu)	/* TIM3 Channel 4 SMU Shadow Counter Register */
#define GTM_TIM3_CH5_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf0102a9cu)	/* TIM3 Channel 5 SMU Shadow Counter Register */
#define GTM_TIM3_CH6_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf0102b1cu)	/* TIM3 Channel 6 SMU Shadow Counter Register */
#define GTM_TIM3_CH7_CNTS	(*( GTM_TIM0_CH0_CNTS_type *) 0xf0102b9cu)	/* TIM3 Channel 7 SMU Shadow Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TIM_EN         : 1;	/* TIM channel x (x:0..7) enable */
		unsigned int TIM_MODE       : 3;	/* TIM channel x (x:0..7) mode */
		unsigned int OSM            : 1;	/* One-shot mode */
		unsigned int ARU_EN         : 1;	/* GPR0 and GPR1 register values routed to ARU */
		unsigned int CICTRL         : 1;	/* Channel Input Control */
		unsigned int TBU0x_SEL      : 1;	/* TBU_TS0 bits input select for TIM_CH[x]_GPRz (x: 0, 1) */
		unsigned int GPR0_SEL       : 2;	/* Selection for GPR0 register */
		unsigned int GPR1_SEL       : 2;	/* Selection for GPR1 register */
		unsigned int CNTS_SEL       : 1;	/* Selection for CNTS register */
		unsigned int DSL            : 1;	/* Signal level control */
		unsigned int ISL            : 1;	/* Ignore signal level */
		/* const */ unsigned int Reserved       : 1;	/* Reserved */
		unsigned int FLT_EN         : 1;	/* Filter enable for channel x (x:0..7) */
		unsigned int FLT_CNT_FRQ    : 2;	/* Filter counter frequency select */
		/* const */ unsigned int Reserved_15    : 1;	/* Reserved */
		unsigned int FLT_MODE_RE    : 1;	/* Filter mode for rising edge */
		unsigned int FLT_CTR_RE     : 1;	/* Filter counter mode for rising edge */
		unsigned int FLT_MODE_FE    : 1;	/* Filter mode for falling edge */
		unsigned int FLT_CTR_FE     : 1;	/* Filter counter mode for falling edge */
		unsigned int CLK_SEL        : 3;	/* CMU clock source select for channel */
		/* const */ unsigned int Reserved_21    : 5;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_CTRL_type;
#define GTM_TIM0_CH0_CTRL	(*( GTM_TIM0_CH0_CTRL_type *) 0xf0101000u)	/* TIM Channel 0 Control Register */
#define GTM_TIM0_CH1_CTRL	(*( GTM_TIM0_CH0_CTRL_type *) 0xf0101080u)	/* TIM Channel 1 Control Register */
#define GTM_TIM0_CH2_CTRL	(*( GTM_TIM0_CH0_CTRL_type *) 0xf0101100u)	/* TIM Channel 2 Control Register */
#define GTM_TIM0_CH3_CTRL	(*( GTM_TIM0_CH0_CTRL_type *) 0xf0101180u)	/* TIM Channel 3 Control Register */
#define GTM_TIM0_CH4_CTRL	(*( GTM_TIM0_CH0_CTRL_type *) 0xf0101200u)	/* TIM Channel 4 Control Register */
#define GTM_TIM0_CH5_CTRL	(*( GTM_TIM0_CH0_CTRL_type *) 0xf0101280u)	/* TIM Channel 5 Control Register */
#define GTM_TIM0_CH6_CTRL	(*( GTM_TIM0_CH0_CTRL_type *) 0xf0101300u)	/* TIM Channel 6 Control Register */
#define GTM_TIM0_CH7_CTRL	(*( GTM_TIM0_CH0_CTRL_type *) 0xf0101380u)	/* TIM Channel 7 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FLT_FE         : 24;	/* Filter parameter for falling edge */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_FLT_FE_type;
#define GTM_TIM0_CH0_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101008u)	/* TIM0 Channel 0 Filter Parameter 1 Register */
#define GTM_TIM0_CH1_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101088u)	/* TIM0 Channel 1 Filter Parameter 1 Register */
#define GTM_TIM0_CH2_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101108u)	/* TIM0 Channel 2 Filter Parameter 1 Register */
#define GTM_TIM0_CH3_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101188u)	/* TIM0 Channel 3 Filter Parameter 1 Register */
#define GTM_TIM0_CH4_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101208u)	/* TIM0 Channel 4 Filter Parameter 1 Register */
#define GTM_TIM0_CH5_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101288u)	/* TIM0 Channel 5 Filter Parameter 1 Register */
#define GTM_TIM0_CH6_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101308u)	/* TIM0 Channel 6 Filter Parameter 1 Register */
#define GTM_TIM0_CH7_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101388u)	/* TIM0 Channel 7 Filter Parameter 1 Register */
#define GTM_TIM1_CH0_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101808u)	/* TIM1 Channel 0 Filter Parameter 1 Register */
#define GTM_TIM1_CH1_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101888u)	/* TIM1 Channel 1 Filter Parameter 1 Register */
#define GTM_TIM1_CH2_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101908u)	/* TIM1 Channel 2 Filter Parameter 1 Register */
#define GTM_TIM1_CH3_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101988u)	/* TIM1 Channel 3 Filter Parameter 1 Register */
#define GTM_TIM1_CH4_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101a08u)	/* TIM1 Channel 4 Filter Parameter 1 Register */
#define GTM_TIM1_CH5_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101a88u)	/* TIM1 Channel 5 Filter Parameter 1 Register */
#define GTM_TIM1_CH6_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101b08u)	/* TIM1 Channel 6 Filter Parameter 1 Register */
#define GTM_TIM1_CH7_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0101b88u)	/* TIM1 Channel 7 Filter Parameter 1 Register */
#define GTM_TIM2_CH0_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102008u)	/* TIM2 Channel 0 Filter Parameter 1 Register */
#define GTM_TIM2_CH1_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102088u)	/* TIM2 Channel 1 Filter Parameter 1 Register */
#define GTM_TIM2_CH2_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102108u)	/* TIM2 Channel 2 Filter Parameter 1 Register */
#define GTM_TIM2_CH3_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102188u)	/* TIM2 Channel 3 Filter Parameter 1 Register */
#define GTM_TIM2_CH4_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102208u)	/* TIM2 Channel 4 Filter Parameter 1 Register */
#define GTM_TIM2_CH5_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102288u)	/* TIM2 Channel 5 Filter Parameter 1 Register */
#define GTM_TIM2_CH6_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102308u)	/* TIM2 Channel 6 Filter Parameter 1 Register */
#define GTM_TIM2_CH7_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102388u)	/* TIM2 Channel 7 Filter Parameter 1 Register */
#define GTM_TIM3_CH0_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102808u)	/* TIM3 Channel 0 Filter Parameter 1 Register */
#define GTM_TIM3_CH1_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102888u)	/* TIM3 Channel 1 Filter Parameter 1 Register */
#define GTM_TIM3_CH2_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102908u)	/* TIM3 Channel 2 Filter Parameter 1 Register */
#define GTM_TIM3_CH3_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102988u)	/* TIM3 Channel 3 Filter Parameter 1 Register */
#define GTM_TIM3_CH4_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102a08u)	/* TIM3 Channel 4 Filter Parameter 1 Register */
#define GTM_TIM3_CH5_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102a88u)	/* TIM3 Channel 5 Filter Parameter 1 Register */
#define GTM_TIM3_CH6_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102b08u)	/* TIM3 Channel 6 Filter Parameter 1 Register */
#define GTM_TIM3_CH7_FLT_FE	(*( GTM_TIM0_CH0_FLT_FE_type *) 0xf0102b88u)	/* TIM3 Channel 7 Filter Parameter 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FLT_RE         : 24;	/* Filter parameter for rising edge */
		/* const */ unsigned int Reserved       : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_FLT_RE_type;
#define GTM_TIM0_CH0_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101004u)	/* GTM_TIM0 Channel 0 Filter Parameter 0 Register */
#define GTM_TIM0_CH1_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101084u)	/* GTM_TIM0 Channel 1 Filter Parameter 0 Register */
#define GTM_TIM0_CH2_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101104u)	/* GTM_TIM0 Channel 2 Filter Parameter 0 Register */
#define GTM_TIM0_CH3_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101184u)	/* GTM_TIM0 Channel 3 Filter Parameter 0 Register */
#define GTM_TIM0_CH4_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101204u)	/* GTM_TIM0 Channel 4 Filter Parameter 0 Register */
#define GTM_TIM0_CH5_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101284u)	/* GTM_TIM0 Channel 5 Filter Parameter 0 Register */
#define GTM_TIM0_CH6_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101304u)	/* GTM_TIM0 Channel 6 Filter Parameter 0 Register */
#define GTM_TIM0_CH7_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101384u)	/* GTM_TIM0 Channel 7 Filter Parameter 0 Register */
#define GTM_TIM1_CH0_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101804u)	/* GTM_TIM1 Channel 0 Filter Parameter 0 Register */
#define GTM_TIM1_CH1_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101884u)	/* GTM_TIM1 Channel 1 Filter Parameter 0 Register */
#define GTM_TIM1_CH2_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101904u)	/* GTM_TIM1 Channel 2 Filter Parameter 0 Register */
#define GTM_TIM1_CH3_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101984u)	/* GTM_TIM1 Channel 3 Filter Parameter 0 Register */
#define GTM_TIM1_CH4_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101a04u)	/* GTM_TIM1 Channel 4 Filter Parameter 0 Register */
#define GTM_TIM1_CH5_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101a84u)	/* GTM_TIM1 Channel 5 Filter Parameter 0 Register */
#define GTM_TIM1_CH6_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101b04u)	/* GTM_TIM1 Channel 6 Filter Parameter 0 Register */
#define GTM_TIM1_CH7_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0101b84u)	/* GTM_TIM1 Channel 7 Filter Parameter 0 Register */
#define GTM_TIM2_CH0_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102004u)	/* GTM_TIM2 Channel 0 Filter Parameter 0 Register */
#define GTM_TIM2_CH1_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102084u)	/* GTM_TIM2 Channel 1 Filter Parameter 0 Register */
#define GTM_TIM2_CH2_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102104u)	/* GTM_TIM2 Channel 2 Filter Parameter 0 Register */
#define GTM_TIM2_CH3_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102184u)	/* GTM_TIM2 Channel 3 Filter Parameter 0 Register */
#define GTM_TIM2_CH4_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102204u)	/* GTM_TIM2 Channel 4 Filter Parameter 0 Register */
#define GTM_TIM2_CH5_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102284u)	/* GTM_TIM2 Channel 5 Filter Parameter 0 Register */
#define GTM_TIM2_CH6_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102304u)	/* GTM_TIM2 Channel 6 Filter Parameter 0 Register */
#define GTM_TIM2_CH7_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102384u)	/* GTM_TIM2 Channel 7 Filter Parameter 0 Register */
#define GTM_TIM3_CH0_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102804u)	/* GTM_TIM3 Channel 0 Filter Parameter 0 Register */
#define GTM_TIM3_CH1_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102884u)	/* GTM_TIM3 Channel 1 Filter Parameter 0 Register */
#define GTM_TIM3_CH2_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102904u)	/* GTM_TIM3 Channel 2 Filter Parameter 0 Register */
#define GTM_TIM3_CH3_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102984u)	/* GTM_TIM3 Channel 3 Filter Parameter 0 Register */
#define GTM_TIM3_CH4_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102a04u)	/* GTM_TIM3 Channel 4 Filter Parameter 0 Register */
#define GTM_TIM3_CH5_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102a84u)	/* GTM_TIM3 Channel 5 Filter Parameter 0 Register */
#define GTM_TIM3_CH6_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102b04u)	/* GTM_TIM3 Channel 6 Filter Parameter 0 Register */
#define GTM_TIM3_CH7_FLT_RE	(*( GTM_TIM0_CH0_FLT_RE_type *) 0xf0102b84u)	/* GTM_TIM3 Channel 7 Filter Parameter 0 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int GPR0           : 24;	/* Input signal characteristic parameter 0 */
		/* const */ unsigned int ECNT           : 8;	/* Edge counter */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_GPR0_type;
#define GTM_TIM0_CH0_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101010u)	/* TIM0 Channel 0 General Purpose 0 Register */
#define GTM_TIM0_CH1_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101090u)	/* TIM0 Channel 1 General Purpose 0 Register */
#define GTM_TIM0_CH2_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101110u)	/* TIM0 Channel 2 General Purpose 0 Register */
#define GTM_TIM0_CH3_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101190u)	/* TIM0 Channel 3 General Purpose 0 Register */
#define GTM_TIM0_CH4_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101210u)	/* TIM0 Channel 4 General Purpose 0 Register */
#define GTM_TIM0_CH5_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101290u)	/* TIM0 Channel 5 General Purpose 0 Register */
#define GTM_TIM0_CH6_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101310u)	/* TIM0 Channel 6 General Purpose 0 Register */
#define GTM_TIM0_CH7_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101390u)	/* TIM0 Channel 7 General Purpose 0 Register */
#define GTM_TIM1_CH0_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101810u)	/* TIM1 Channel 0 General Purpose 0 Register */
#define GTM_TIM1_CH1_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101890u)	/* TIM1 Channel 1 General Purpose 0 Register */
#define GTM_TIM1_CH2_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101910u)	/* TIM1 Channel 2 General Purpose 0 Register */
#define GTM_TIM1_CH3_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101990u)	/* TIM1 Channel 3 General Purpose 0 Register */
#define GTM_TIM1_CH4_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101a10u)	/* TIM1 Channel 4 General Purpose 0 Register */
#define GTM_TIM1_CH5_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101a90u)	/* TIM1 Channel 5 General Purpose 0 Register */
#define GTM_TIM1_CH6_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101b10u)	/* TIM1 Channel 6 General Purpose 0 Register */
#define GTM_TIM1_CH7_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0101b90u)	/* TIM1 Channel 7 General Purpose 0 Register */
#define GTM_TIM2_CH0_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102010u)	/* TIM2 Channel 0 General Purpose 0 Register */
#define GTM_TIM2_CH1_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102090u)	/* TIM2 Channel 1 General Purpose 0 Register */
#define GTM_TIM2_CH2_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102110u)	/* TIM2 Channel 2 General Purpose 0 Register */
#define GTM_TIM2_CH3_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102190u)	/* TIM2 Channel 3 General Purpose 0 Register */
#define GTM_TIM2_CH4_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102210u)	/* TIM2 Channel 4 General Purpose 0 Register */
#define GTM_TIM2_CH5_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102290u)	/* TIM2 Channel 5 General Purpose 0 Register */
#define GTM_TIM2_CH6_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102310u)	/* TIM2 Channel 6 General Purpose 0 Register */
#define GTM_TIM2_CH7_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102390u)	/* TIM2 Channel 7 General Purpose 0 Register */
#define GTM_TIM3_CH0_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102810u)	/* TIM3 Channel 0 General Purpose 0 Register */
#define GTM_TIM3_CH1_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102890u)	/* TIM3 Channel 1 General Purpose 0 Register */
#define GTM_TIM3_CH2_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102910u)	/* TIM3 Channel 2 General Purpose 0 Register */
#define GTM_TIM3_CH3_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102990u)	/* TIM3 Channel 3 General Purpose 0 Register */
#define GTM_TIM3_CH4_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102a10u)	/* TIM3 Channel 4 General Purpose 0 Register */
#define GTM_TIM3_CH5_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102a90u)	/* TIM3 Channel 5 General Purpose 0 Register */
#define GTM_TIM3_CH6_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102b10u)	/* TIM3 Channel 6 General Purpose 0 Register */
#define GTM_TIM3_CH7_GPR0	(*( GTM_TIM0_CH0_GPR0_type *) 0xf0102b90u)	/* TIM3 Channel 7 General Purpose 0 Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int GPR1           : 24;	/* Input signal characteristic parameter 1 */
		/* const */ unsigned int ECNT           : 8;	/* Edge counter */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_GPR1_type;
#define GTM_TIM0_CH0_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101014u)	/* TIM0 Channel 0 General Purpose 1 Register */
#define GTM_TIM0_CH1_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101094u)	/* TIM0 Channel 1 General Purpose 1 Register */
#define GTM_TIM0_CH2_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101114u)	/* TIM0 Channel 2 General Purpose 1 Register */
#define GTM_TIM0_CH3_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101194u)	/* TIM0 Channel 3 General Purpose 1 Register */
#define GTM_TIM0_CH4_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101214u)	/* TIM0 Channel 4 General Purpose 1 Register */
#define GTM_TIM0_CH5_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101294u)	/* TIM0 Channel 5 General Purpose 1 Register */
#define GTM_TIM0_CH6_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101314u)	/* TIM0 Channel 6 General Purpose 1 Register */
#define GTM_TIM0_CH7_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101394u)	/* TIM0 Channel 7 General Purpose 1 Register */
#define GTM_TIM1_CH0_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101814u)	/* TIM1 Channel 0 General Purpose 1 Register */
#define GTM_TIM1_CH1_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101894u)	/* TIM1 Channel 1 General Purpose 1 Register */
#define GTM_TIM1_CH2_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101914u)	/* TIM1 Channel 2 General Purpose 1 Register */
#define GTM_TIM1_CH3_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101994u)	/* TIM1 Channel 3 General Purpose 1 Register */
#define GTM_TIM1_CH4_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101a14u)	/* TIM1 Channel 4 General Purpose 1 Register */
#define GTM_TIM1_CH5_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101a94u)	/* TIM1 Channel 5 General Purpose 1 Register */
#define GTM_TIM1_CH6_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101b14u)	/* TIM1 Channel 6 General Purpose 1 Register */
#define GTM_TIM1_CH7_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0101b94u)	/* TIM1 Channel 7 General Purpose 1 Register */
#define GTM_TIM2_CH0_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102014u)	/* TIM2 Channel 0 General Purpose 1 Register */
#define GTM_TIM2_CH1_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102094u)	/* TIM2 Channel 1 General Purpose 1 Register */
#define GTM_TIM2_CH2_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102114u)	/* TIM2 Channel 2 General Purpose 1 Register */
#define GTM_TIM2_CH3_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102194u)	/* TIM2 Channel 3 General Purpose 1 Register */
#define GTM_TIM2_CH4_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102214u)	/* TIM2 Channel 4 General Purpose 1 Register */
#define GTM_TIM2_CH5_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102294u)	/* TIM2 Channel 5 General Purpose 1 Register */
#define GTM_TIM2_CH6_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102314u)	/* TIM2 Channel 6 General Purpose 1 Register */
#define GTM_TIM2_CH7_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102394u)	/* TIM2 Channel 7 General Purpose 1 Register */
#define GTM_TIM3_CH0_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102814u)	/* TIM3 Channel 0 General Purpose 1 Register */
#define GTM_TIM3_CH1_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102894u)	/* TIM3 Channel 1 General Purpose 1 Register */
#define GTM_TIM3_CH2_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102914u)	/* TIM3 Channel 2 General Purpose 1 Register */
#define GTM_TIM3_CH3_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102994u)	/* TIM3 Channel 3 General Purpose 1 Register */
#define GTM_TIM3_CH4_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102a14u)	/* TIM3 Channel 4 General Purpose 1 Register */
#define GTM_TIM3_CH5_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102a94u)	/* TIM3 Channel 5 General Purpose 1 Register */
#define GTM_TIM3_CH6_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102b14u)	/* TIM3 Channel 6 General Purpose 1 Register */
#define GTM_TIM3_CH7_GPR1	(*( GTM_TIM0_CH0_GPR1_type *) 0xf0102b94u)	/* TIM3 Channel 7 General Purpose 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NEWVAL_IRQ_EN  : 1;	/* TIM_NEWVALx_IRQ interrupt enable */
		unsigned int ECNTOFL_IRQ_EN : 1;	/* TIM_ECNTOFLx_IRQ interrupt enable */
		unsigned int CNTOFL_IRQ_EN  : 1;	/* TIM_CNTOFLx_IRQ interrupt enable */
		unsigned int GPRzOFL_IRQ_EN : 1;	/* TIM_GPRzOFLx_IRQ interrupt enable */
		unsigned int TODET_IRQ_EN   : 1;	/* TIM_TODETx_IRQ interrupt enable */
		unsigned int GLITCHDET_IRQ_EN: 1;	/* TIM_GLITCHDETx_IRQ interrupt enable */
		/* const */ unsigned int Reserved       : 26;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_IRQ_EN_type;
#define GTM_TIM0_CH0_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0101024u)	/* TIM0 Channel 0 Interrupt Enable Register */
#define GTM_TIM0_CH1_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01010a4u)	/* TIM0 Channel 1 Interrupt Enable Register */
#define GTM_TIM0_CH2_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0101124u)	/* TIM0 Channel 2 Interrupt Enable Register */
#define GTM_TIM0_CH3_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01011a4u)	/* TIM0 Channel 3 Interrupt Enable Register */
#define GTM_TIM0_CH4_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0101224u)	/* TIM0 Channel 4 Interrupt Enable Register */
#define GTM_TIM0_CH5_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01012a4u)	/* TIM0 Channel 5 Interrupt Enable Register */
#define GTM_TIM0_CH6_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0101324u)	/* TIM0 Channel 6 Interrupt Enable Register */
#define GTM_TIM0_CH7_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01013a4u)	/* TIM0 Channel 7 Interrupt Enable Register */
#define GTM_TIM1_CH0_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0101824u)	/* TIM1 Channel 0 Interrupt Enable Register */
#define GTM_TIM1_CH1_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01018a4u)	/* TIM1 Channel 1 Interrupt Enable Register */
#define GTM_TIM1_CH2_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0101924u)	/* TIM1 Channel 2 Interrupt Enable Register */
#define GTM_TIM1_CH3_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01019a4u)	/* TIM1 Channel 3 Interrupt Enable Register */
#define GTM_TIM1_CH4_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0101a24u)	/* TIM1 Channel 4 Interrupt Enable Register */
#define GTM_TIM1_CH5_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0101aa4u)	/* TIM1 Channel 5 Interrupt Enable Register */
#define GTM_TIM1_CH6_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0101b24u)	/* TIM1 Channel 6 Interrupt Enable Register */
#define GTM_TIM1_CH7_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0101ba4u)	/* TIM1 Channel 7 Interrupt Enable Register */
#define GTM_TIM2_CH0_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0102024u)	/* TIM2 Channel 0 Interrupt Enable Register */
#define GTM_TIM2_CH1_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01020a4u)	/* TIM2 Channel 1 Interrupt Enable Register */
#define GTM_TIM2_CH2_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0102124u)	/* TIM2 Channel 2 Interrupt Enable Register */
#define GTM_TIM2_CH3_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01021a4u)	/* TIM2 Channel 3 Interrupt Enable Register */
#define GTM_TIM2_CH4_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0102224u)	/* TIM2 Channel 4 Interrupt Enable Register */
#define GTM_TIM2_CH5_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01022a4u)	/* TIM2 Channel 5 Interrupt Enable Register */
#define GTM_TIM2_CH6_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0102324u)	/* TIM2 Channel 6 Interrupt Enable Register */
#define GTM_TIM2_CH7_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01023a4u)	/* TIM2 Channel 7 Interrupt Enable Register */
#define GTM_TIM3_CH0_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0102824u)	/* TIM3 Channel 0 Interrupt Enable Register */
#define GTM_TIM3_CH1_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01028a4u)	/* TIM3 Channel 1 Interrupt Enable Register */
#define GTM_TIM3_CH2_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0102924u)	/* TIM3 Channel 2 Interrupt Enable Register */
#define GTM_TIM3_CH3_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf01029a4u)	/* TIM3 Channel 3 Interrupt Enable Register */
#define GTM_TIM3_CH4_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0102a24u)	/* TIM3 Channel 4 Interrupt Enable Register */
#define GTM_TIM3_CH5_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0102aa4u)	/* TIM3 Channel 5 Interrupt Enable Register */
#define GTM_TIM3_CH6_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0102b24u)	/* TIM3 Channel 6 Interrupt Enable Register */
#define GTM_TIM3_CH7_IRQ_EN	(*( GTM_TIM0_CH0_IRQ_EN_type *) 0xf0102ba4u)	/* TIM3 Channel 7 Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_NEWVAL     : 1;	/* Trigger NEWVAL bit in TIM_CHx_IRQ_NOTIFY register by software */
		unsigned int TRG_ECNTOFL    : 1;	/* Trigger ECNTOFL bit in TIM_CHx_IRQ_NOTIFY register by software */
		unsigned int TRG_CNTOFL     : 1;	/* Trigger CNTOFL bit in TIM_CHx_IRQ_NOTIFY register by software */
		unsigned int TRG_GPRzOFL    : 1;	/* Trigger GPRzOFL bit in TIM_CHx_IRQ_NOTIFY register by software */
		unsigned int TRG_TODET      : 1;	/* Trigger TODET bit in TIM_CHx_IRQ_NOTIFY register by software */
		unsigned int TRG_GLITCHDET  : 1;	/* Trigger GLITCHDET bit in TIM_CHx_IRQ_NOTIFY register by software */
		/* const */ unsigned int Reserved       : 26;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_IRQ_FORCINT_type;
#define GTM_TIM0_CH0_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0101028u)	/* TIM0 Channel 0 Software Interrupt Force Register */
#define GTM_TIM0_CH1_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01010a8u)	/* TIM0 Channel 1 Software Interrupt Force Register */
#define GTM_TIM0_CH2_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0101128u)	/* TIM0 Channel 2 Software Interrupt Force Register */
#define GTM_TIM0_CH3_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01011a8u)	/* TIM0 Channel 3 Software Interrupt Force Register */
#define GTM_TIM0_CH4_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0101228u)	/* TIM0 Channel 4 Software Interrupt Force Register */
#define GTM_TIM0_CH5_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01012a8u)	/* TIM0 Channel 5 Software Interrupt Force Register */
#define GTM_TIM0_CH6_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0101328u)	/* TIM0 Channel 6 Software Interrupt Force Register */
#define GTM_TIM0_CH7_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01013a8u)	/* TIM0 Channel 7 Software Interrupt Force Register */
#define GTM_TIM1_CH0_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0101828u)	/* TIM1 Channel 0 Software Interrupt Force Register */
#define GTM_TIM1_CH1_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01018a8u)	/* TIM1 Channel 1 Software Interrupt Force Register */
#define GTM_TIM1_CH2_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0101928u)	/* TIM1 Channel 2 Software Interrupt Force Register */
#define GTM_TIM1_CH3_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01019a8u)	/* TIM1 Channel 3 Software Interrupt Force Register */
#define GTM_TIM1_CH4_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0101a28u)	/* TIM1 Channel 4 Software Interrupt Force Register */
#define GTM_TIM1_CH5_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0101aa8u)	/* TIM1 Channel 5 Software Interrupt Force Register */
#define GTM_TIM1_CH6_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0101b28u)	/* TIM1 Channel 6 Software Interrupt Force Register */
#define GTM_TIM1_CH7_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0101ba8u)	/* TIM1 Channel 7 Software Interrupt Force Register */
#define GTM_TIM2_CH0_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0102028u)	/* TIM2 Channel 0 Software Interrupt Force Register */
#define GTM_TIM2_CH1_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01020a8u)	/* TIM2 Channel 1 Software Interrupt Force Register */
#define GTM_TIM2_CH2_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0102128u)	/* TIM2 Channel 2 Software Interrupt Force Register */
#define GTM_TIM2_CH3_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01021a8u)	/* TIM2 Channel 3 Software Interrupt Force Register */
#define GTM_TIM2_CH4_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0102228u)	/* TIM2 Channel 4 Software Interrupt Force Register */
#define GTM_TIM2_CH5_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01022a8u)	/* TIM2 Channel 5 Software Interrupt Force Register */
#define GTM_TIM2_CH6_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0102328u)	/* TIM2 Channel 6 Software Interrupt Force Register */
#define GTM_TIM2_CH7_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01023a8u)	/* TIM2 Channel 7 Software Interrupt Force Register */
#define GTM_TIM3_CH0_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0102828u)	/* TIM3 Channel 0 Software Interrupt Force Register */
#define GTM_TIM3_CH1_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01028a8u)	/* TIM3 Channel 1 Software Interrupt Force Register */
#define GTM_TIM3_CH2_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0102928u)	/* TIM3 Channel 2 Software Interrupt Force Register */
#define GTM_TIM3_CH3_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf01029a8u)	/* TIM3 Channel 3 Software Interrupt Force Register */
#define GTM_TIM3_CH4_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0102a28u)	/* TIM3 Channel 4 Software Interrupt Force Register */
#define GTM_TIM3_CH5_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0102aa8u)	/* TIM3 Channel 5 Software Interrupt Force Register */
#define GTM_TIM3_CH6_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0102b28u)	/* TIM3 Channel 6 Software Interrupt Force Register */
#define GTM_TIM3_CH7_IRQ_FORCINT	(*( GTM_TIM0_CH0_IRQ_FORCINT_type *) 0xf0102ba8u)	/* TIM3 Channel 7 Software Interrupt Force Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NEWVAL         : 1;	/* New measurement value detected by in channel x (x:0..7) */
		unsigned int ECNTOFL        : 1;	/* counter overflow of channel x, (x:0..7) */
		unsigned int CNTOFL         : 1;	/* SMU CNT counter overflow of channel x, (x:0...7) */
		unsigned int GPRzOFL        : 1;	/* data overflow, old data not read out before new data has arrived at input pin, (x:0..7) */
		unsigned int TODET          : 1;	/* Timeout reached for input signal of channel x, (x:0..7) */
		unsigned int GLITCHDET      : 1;	/* Glitch detected on channel x, (x:0..7) */
		/* const */ unsigned int Reserved       : 26;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_IRQ_NOTIFY_type;
#define GTM_TIM0_CH0_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0101020u)	/* TIM0 Channel 0 Interrupt Notification Register */
#define GTM_TIM0_CH1_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01010a0u)	/* TIM0 Channel 1 Interrupt Notification Register */
#define GTM_TIM0_CH2_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0101120u)	/* TIM0 Channel 2 Interrupt Notification Register */
#define GTM_TIM0_CH3_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01011a0u)	/* TIM0 Channel 3 Interrupt Notification Register */
#define GTM_TIM0_CH4_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0101220u)	/* TIM0 Channel 4 Interrupt Notification Register */
#define GTM_TIM0_CH5_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01012a0u)	/* TIM0 Channel 5 Interrupt Notification Register */
#define GTM_TIM0_CH6_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0101320u)	/* TIM0 Channel 6 Interrupt Notification Register */
#define GTM_TIM0_CH7_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01013a0u)	/* TIM0 Channel 7 Interrupt Notification Register */
#define GTM_TIM1_CH0_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0101820u)	/* TIM1 Channel 0 Interrupt Notification Register */
#define GTM_TIM1_CH1_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01018a0u)	/* TIM1 Channel 1 Interrupt Notification Register */
#define GTM_TIM1_CH2_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0101920u)	/* TIM1 Channel 2 Interrupt Notification Register */
#define GTM_TIM1_CH3_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01019a0u)	/* TIM1 Channel 3 Interrupt Notification Register */
#define GTM_TIM1_CH4_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0101a20u)	/* TIM1 Channel 4 Interrupt Notification Register */
#define GTM_TIM1_CH5_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0101aa0u)	/* TIM1 Channel 5 Interrupt Notification Register */
#define GTM_TIM1_CH6_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0101b20u)	/* TIM1 Channel 6 Interrupt Notification Register */
#define GTM_TIM1_CH7_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0101ba0u)	/* TIM1 Channel 7 Interrupt Notification Register */
#define GTM_TIM2_CH0_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0102020u)	/* TIM2 Channel 0 Interrupt Notification Register */
#define GTM_TIM2_CH1_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01020a0u)	/* TIM2 Channel 1 Interrupt Notification Register */
#define GTM_TIM2_CH2_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0102120u)	/* TIM2 Channel 2 Interrupt Notification Register */
#define GTM_TIM2_CH3_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01021a0u)	/* TIM2 Channel 3 Interrupt Notification Register */
#define GTM_TIM2_CH4_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0102220u)	/* TIM2 Channel 4 Interrupt Notification Register */
#define GTM_TIM2_CH5_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01022a0u)	/* TIM2 Channel 5 Interrupt Notification Register */
#define GTM_TIM2_CH6_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0102320u)	/* TIM2 Channel 6 Interrupt Notification Register */
#define GTM_TIM2_CH7_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01023a0u)	/* TIM2 Channel 7 Interrupt Notification Register */
#define GTM_TIM3_CH0_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0102820u)	/* TIM3 Channel 0 Interrupt Notification Register */
#define GTM_TIM3_CH1_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01028a0u)	/* TIM3 Channel 1 Interrupt Notification Register */
#define GTM_TIM3_CH2_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0102920u)	/* TIM3 Channel 2 Interrupt Notification Register */
#define GTM_TIM3_CH3_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf01029a0u)	/* TIM3 Channel 3 Interrupt Notification Register */
#define GTM_TIM3_CH4_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0102a20u)	/* TIM3 Channel 4 Interrupt Notification Register */
#define GTM_TIM3_CH5_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0102aa0u)	/* TIM3 Channel 5 Interrupt Notification Register */
#define GTM_TIM3_CH6_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0102b20u)	/* TIM3 Channel 6 Interrupt Notification Register */
#define GTM_TIM3_CH7_IRQ_NOTIFY	(*( GTM_TIM0_CH0_IRQ_NOTIFY_type *) 0xf0102ba0u)	/* TIM3 Channel 7 Interrupt Notification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TO_EN          : 1;	/* Timeout detection unit enable */
		unsigned int TCS            : 3;	/* Timeout Clock selection */
		/* const */ unsigned int Reserved       : 4;	/* Reserved */
		unsigned int TOV            : 8;	/* Time out duration for channel x (x:0..7) */
		/* const */ unsigned int TO_CNT         : 8;	/* Current Timeout value for channel x (x:0..7) */
		/* const */ unsigned int Reserved_6     : 8;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_CH0_TDU_type;
#define GTM_TIM0_CH0_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010100cu)	/* TIM0 Channel 0 TDU Control Register */
#define GTM_TIM0_CH1_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010108cu)	/* TIM0 Channel 1 TDU Control Register */
#define GTM_TIM0_CH2_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010110cu)	/* TIM0 Channel 2 TDU Control Register */
#define GTM_TIM0_CH3_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010118cu)	/* TIM0 Channel 3 TDU Control Register */
#define GTM_TIM0_CH4_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010120cu)	/* TIM0 Channel 4 TDU Control Register */
#define GTM_TIM0_CH5_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010128cu)	/* TIM0 Channel 5 TDU Control Register */
#define GTM_TIM0_CH6_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010130cu)	/* TIM0 Channel 6 TDU Control Register */
#define GTM_TIM0_CH7_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010138cu)	/* TIM0 Channel 7 TDU Control Register */
#define GTM_TIM1_CH0_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010180cu)	/* TIM1 Channel 0 TDU Control Register */
#define GTM_TIM1_CH1_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010188cu)	/* TIM1 Channel 1 TDU Control Register */
#define GTM_TIM1_CH2_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010190cu)	/* TIM1 Channel 2 TDU Control Register */
#define GTM_TIM1_CH3_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010198cu)	/* TIM1 Channel 3 TDU Control Register */
#define GTM_TIM1_CH4_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf0101a0cu)	/* TIM1 Channel 4 TDU Control Register */
#define GTM_TIM1_CH5_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf0101a8cu)	/* TIM1 Channel 5 TDU Control Register */
#define GTM_TIM1_CH6_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf0101b0cu)	/* TIM1 Channel 6 TDU Control Register */
#define GTM_TIM1_CH7_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf0101b8cu)	/* TIM1 Channel 7 TDU Control Register */
#define GTM_TIM2_CH0_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010200cu)	/* TIM2 Channel 0 TDU Control Register */
#define GTM_TIM2_CH1_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010208cu)	/* TIM2 Channel 1 TDU Control Register */
#define GTM_TIM2_CH2_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010210cu)	/* TIM2 Channel 2 TDU Control Register */
#define GTM_TIM2_CH3_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010218cu)	/* TIM2 Channel 3 TDU Control Register */
#define GTM_TIM2_CH4_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010220cu)	/* TIM2 Channel 4 TDU Control Register */
#define GTM_TIM2_CH5_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010228cu)	/* TIM2 Channel 5 TDU Control Register */
#define GTM_TIM2_CH6_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010230cu)	/* TIM2 Channel 6 TDU Control Register */
#define GTM_TIM2_CH7_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010238cu)	/* TIM2 Channel 7 TDU Control Register */
#define GTM_TIM3_CH0_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010280cu)	/* TIM3 Channel 0 TDU Control Register */
#define GTM_TIM3_CH1_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010288cu)	/* TIM3 Channel 1 TDU Control Register */
#define GTM_TIM3_CH2_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010290cu)	/* TIM3 Channel 2 TDU Control Register */
#define GTM_TIM3_CH3_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf010298cu)	/* TIM3 Channel 3 TDU Control Register */
#define GTM_TIM3_CH4_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf0102a0cu)	/* TIM3 Channel 4 TDU Control Register */
#define GTM_TIM3_CH5_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf0102a8cu)	/* TIM3 Channel 5 TDU Control Register */
#define GTM_TIM3_CH6_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf0102b0cu)	/* TIM3 Channel 6 TDU Control Register */
#define GTM_TIM3_CH7_TDU	(*( GTM_TIM0_CH0_TDU_type *) 0xf0102b8cu)	/* TIM3 Channel 7 TDU Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST_CH0        : 1;	/* Software reset of channel 0 */
		unsigned int RST_CH1        : 1;	/* Software reset of channel 1 */
		unsigned int RST_CH2        : 1;	/* Software reset of channel 2 */
		unsigned int RST_CH3        : 1;	/* Software reset of channel 3 */
		unsigned int RST_CH4        : 1;	/* Software reset of channel 4 */
		unsigned int RST_CH5        : 1;	/* Software reset of channel 5 */
		unsigned int RST_CH6        : 1;	/* Software reset of channel 6 */
		unsigned int RST_CH7        : 1;	/* Software reset of channel 7 */
		/* const */ unsigned int Reserved       : 24;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TIM0_RST_type;
#define GTM_TIM0_RST	(*( GTM_TIM0_RST_type *) 0xf0101400u)	/* TIM0 Global Software Reset Register */
#define GTM_TIM1_RST	(*( GTM_TIM0_RST_type *) 0xf0101c00u)	/* TIM1 Global Software Reset Register */
#define GTM_TIM2_RST	(*( GTM_TIM0_RST_type *) 0xf0102400u)	/* TIM2 Global Software Reset Register */
#define GTM_TIM3_RST	(*( GTM_TIM0_RST_type *) 0xf0102c00u)	/* TIM3 Global Software Reset Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TIM_EN         : 1;	/* TIM channel x (x:0..7) enable */
		unsigned int TIM_MODE       : 3;	/* TIM channel x (x:0..7) mode */
		unsigned int OSM            : 1;	/* One-shot mode */
		unsigned int ARU_EN         : 1;	/* GPR0 and GPR1 register values routed to ARU */
		unsigned int CICTRL         : 1;	/* Channel Input Control */
		/* const */ unsigned int Reserved       : 1;	/* Reserved */
		unsigned int GPR0_SEL       : 2;	/* Selection for GPR0 register */
		unsigned int GPR1_SEL       : 2;	/* Selection for GPR1 register */
		unsigned int CNTS_SEL       : 1;	/* Selection for CNTS register */
		unsigned int DSL            : 1;	/* Signal level control */
		unsigned int ISL            : 1;	/* Ignore signal level */
		/* const */ unsigned int Reserved_12    : 1;	/* Reserved */
		unsigned int FLT_EN         : 1;	/* Filter enable for channel x (x:0..7) */
		unsigned int FLT_CNT_FRQ    : 2;	/* Filter counter frequency select */
		/* const */ unsigned int Reserved_15    : 1;	/* Reserved */
		unsigned int FLT_MODE_RE    : 1;	/* Filter mode for rising edge */
		unsigned int FLT_CTR_RE     : 1;	/* Filter counter mode for rising edge */
		unsigned int FLT_MODE_FE    : 1;	/* Filter mode for falling edge */
		unsigned int FLT_CTR_FE     : 1;	/* Filter counter mode for falling edge */
		unsigned int CLK_SEL        : 3;	/* CMU clock source select for channel */
		/* const */ unsigned int Reserved_21    : 5;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TIM1_CH0_CTRL_type;
#define GTM_TIM1_CH0_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0101800u)	/* TIM1 Channel 0 Control Register */
#define GTM_TIM1_CH1_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0101880u)	/* TIM1 Channel 1 Control Register */
#define GTM_TIM1_CH2_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0101900u)	/* TIM1 Channel 2 Control Register */
#define GTM_TIM1_CH3_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0101980u)	/* TIM1 Channel 3 Control Register */
#define GTM_TIM1_CH4_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0101a00u)	/* TIM1 Channel 4 Control Register */
#define GTM_TIM1_CH5_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0101a80u)	/* TIM1 Channel 5 Control Register */
#define GTM_TIM1_CH6_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0101b00u)	/* TIM1 Channel 6 Control Register */
#define GTM_TIM1_CH7_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0101b80u)	/* TIM1 Channel 7 Control Register */
#define GTM_TIM2_CH0_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102000u)	/* TIM2 Channel 0 Control Register */
#define GTM_TIM2_CH1_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102080u)	/* TIM2 Channel 1 Control Register */
#define GTM_TIM2_CH2_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102100u)	/* TIM2 Channel 2 Control Register */
#define GTM_TIM2_CH3_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102180u)	/* TIM2 Channel 3 Control Register */
#define GTM_TIM2_CH4_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102200u)	/* TIM2 Channel 4 Control Register */
#define GTM_TIM2_CH5_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102280u)	/* TIM2 Channel 5 Control Register */
#define GTM_TIM2_CH6_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102300u)	/* TIM2 Channel 6 Control Register */
#define GTM_TIM2_CH7_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102380u)	/* TIM2 Channel 7 Control Register */
#define GTM_TIM3_CH0_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102800u)	/* TIM3 Channel 0 Control Register */
#define GTM_TIM3_CH1_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102880u)	/* TIM3 Channel 1 Control Register */
#define GTM_TIM3_CH2_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102900u)	/* TIM3 Channel 2 Control Register */
#define GTM_TIM3_CH3_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102980u)	/* TIM3 Channel 3 Control Register */
#define GTM_TIM3_CH4_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102a00u)	/* TIM3 Channel 4 Control Register */
#define GTM_TIM3_CH5_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102a80u)	/* TIM3 Channel 5 Control Register */
#define GTM_TIM3_CH6_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102b00u)	/* TIM3 Channel 6 Control Register */
#define GTM_TIM3_CH7_CTRL	(*( GTM_TIM1_CH0_CTRL_type *) 0xf0102b80u)	/* TIM3 Channel 7 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CM0            : 16;	/* TOM CCU0 compare register */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH0_CM0_type;
#define GTM_TOM0_CH0_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108088u)	/* TOM0 Channel 0 CCU0 Compare Register */
#define GTM_TOM0_CH10_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108308u)	/* TOM0 Channel 10 CCU0 Compare Register */
#define GTM_TOM0_CH11_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108348u)	/* TOM0 Channel 11 CCU0 Compare Register */
#define GTM_TOM0_CH12_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108388u)	/* TOM0 Channel 12 CCU0 Compare Register */
#define GTM_TOM0_CH13_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf01083c8u)	/* TOM0 Channel 13 CCU0 Compare Register */
#define GTM_TOM0_CH14_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108408u)	/* TOM0 Channel 14 CCU0 Compare Register */
#define GTM_TOM0_CH15_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108448u)	/* TOM0 Channel 15 CCU0 Compare Register */
#define GTM_TOM0_CH1_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf01080c8u)	/* TOM0 Channel 1 CCU0 Compare Register */
#define GTM_TOM0_CH2_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108108u)	/* TOM0 Channel 2 CCU0 Compare Register */
#define GTM_TOM0_CH3_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108148u)	/* TOM0 Channel 3 CCU0 Compare Register */
#define GTM_TOM0_CH4_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108188u)	/* TOM0 Channel 4 CCU0 Compare Register */
#define GTM_TOM0_CH5_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf01081c8u)	/* TOM0 Channel 5 CCU0 Compare Register */
#define GTM_TOM0_CH6_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108208u)	/* TOM0 Channel 6 CCU0 Compare Register */
#define GTM_TOM0_CH7_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108248u)	/* TOM0 Channel 7 CCU0 Compare Register */
#define GTM_TOM0_CH8_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108288u)	/* TOM0 Channel 8 CCU0 Compare Register */
#define GTM_TOM0_CH9_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf01082c8u)	/* TOM0 Channel 9 CCU0 Compare Register */
#define GTM_TOM1_CH0_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108888u)	/* TOM1 Channel 0 CCU0 Compare Register */
#define GTM_TOM1_CH10_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108b08u)	/* TOM1 Channel 10 CCU0 Compare Register */
#define GTM_TOM1_CH11_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108b48u)	/* TOM1 Channel 11 CCU0 Compare Register */
#define GTM_TOM1_CH12_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108b88u)	/* TOM1 Channel 12 CCU0 Compare Register */
#define GTM_TOM1_CH13_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108bc8u)	/* TOM1 Channel 13 CCU0 Compare Register */
#define GTM_TOM1_CH14_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108c08u)	/* TOM1 Channel 14 CCU0 Compare Register */
#define GTM_TOM1_CH15_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108c48u)	/* TOM1 Channel 15 CCU0 Compare Register */
#define GTM_TOM1_CH1_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf01088c8u)	/* TOM1 Channel 1 CCU0 Compare Register */
#define GTM_TOM1_CH2_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108908u)	/* TOM1 Channel 2 CCU0 Compare Register */
#define GTM_TOM1_CH3_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108948u)	/* TOM1 Channel 3 CCU0 Compare Register */
#define GTM_TOM1_CH4_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108988u)	/* TOM1 Channel 4 CCU0 Compare Register */
#define GTM_TOM1_CH5_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf01089c8u)	/* TOM1 Channel 5 CCU0 Compare Register */
#define GTM_TOM1_CH6_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108a08u)	/* TOM1 Channel 6 CCU0 Compare Register */
#define GTM_TOM1_CH7_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108a48u)	/* TOM1 Channel 7 CCU0 Compare Register */
#define GTM_TOM1_CH8_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108a88u)	/* TOM1 Channel 8 CCU0 Compare Register */
#define GTM_TOM1_CH9_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0108ac8u)	/* TOM1 Channel 9 CCU0 Compare Register */
#define GTM_TOM2_CH0_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109088u)	/* TOM2 Channel 0 CCU0 Compare Register */
#define GTM_TOM2_CH10_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109308u)	/* TOM2 Channel 10 CCU0 Compare Register */
#define GTM_TOM2_CH11_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109348u)	/* TOM2 Channel 11 CCU0 Compare Register */
#define GTM_TOM2_CH12_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109388u)	/* TOM2 Channel 12 CCU0 Compare Register */
#define GTM_TOM2_CH13_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf01093c8u)	/* TOM2 Channel 13 CCU0 Compare Register */
#define GTM_TOM2_CH14_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109408u)	/* TOM2 Channel 14 CCU0 Compare Register */
#define GTM_TOM2_CH15_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109448u)	/* TOM2 Channel 15 CCU0 Compare Register */
#define GTM_TOM2_CH1_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf01090c8u)	/* TOM2 Channel 1 CCU0 Compare Register */
#define GTM_TOM2_CH2_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109108u)	/* TOM2 Channel 2 CCU0 Compare Register */
#define GTM_TOM2_CH3_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109148u)	/* TOM2 Channel 3 CCU0 Compare Register */
#define GTM_TOM2_CH4_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109188u)	/* TOM2 Channel 4 CCU0 Compare Register */
#define GTM_TOM2_CH5_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf01091c8u)	/* TOM2 Channel 5 CCU0 Compare Register */
#define GTM_TOM2_CH6_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109208u)	/* TOM2 Channel 6 CCU0 Compare Register */
#define GTM_TOM2_CH7_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109248u)	/* TOM2 Channel 7 CCU0 Compare Register */
#define GTM_TOM2_CH8_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf0109288u)	/* TOM2 Channel 8 CCU0 Compare Register */
#define GTM_TOM2_CH9_CM0	(*( GTM_TOM0_CH0_CM0_type *) 0xf01092c8u)	/* TOM2 Channel 9 CCU0 Compare Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CM1            : 16;	/* TOM CCU1 compare register */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH0_CM1_type;
#define GTM_TOM0_CH0_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108090u)	/* TOM0 Channel 0 CCU1 Compare Register */
#define GTM_TOM0_CH10_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108310u)	/* TOM0 Channel 10 CCU1 Compare Register */
#define GTM_TOM0_CH11_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108350u)	/* TOM0 Channel 11 CCU1 Compare Register */
#define GTM_TOM0_CH12_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108390u)	/* TOM0 Channel 12 CCU1 Compare Register */
#define GTM_TOM0_CH13_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf01083d0u)	/* TOM0 Channel 13 CCU1 Compare Register */
#define GTM_TOM0_CH14_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108410u)	/* TOM0 Channel 14 CCU1 Compare Register */
#define GTM_TOM0_CH15_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108450u)	/* TOM0 Channel 15 CCU1 Compare Register */
#define GTM_TOM0_CH1_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf01080d0u)	/* TOM0 Channel 1 CCU1 Compare Register */
#define GTM_TOM0_CH2_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108110u)	/* TOM0 Channel 2 CCU1 Compare Register */
#define GTM_TOM0_CH3_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108150u)	/* TOM0 Channel 3 CCU1 Compare Register */
#define GTM_TOM0_CH4_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108190u)	/* TOM0 Channel 4 CCU1 Compare Register */
#define GTM_TOM0_CH5_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf01081d0u)	/* TOM0 Channel 5 CCU1 Compare Register */
#define GTM_TOM0_CH6_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108210u)	/* TOM0 Channel 6 CCU1 Compare Register */
#define GTM_TOM0_CH7_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108250u)	/* TOM0 Channel 7 CCU1 Compare Register */
#define GTM_TOM0_CH8_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108290u)	/* TOM0 Channel 8 CCU1 Compare Register */
#define GTM_TOM0_CH9_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf01082d0u)	/* TOM0 Channel 9 CCU1 Compare Register */
#define GTM_TOM1_CH0_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108890u)	/* TOM1 Channel 0 CCU1 Compare Register */
#define GTM_TOM1_CH10_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108b10u)	/* TOM1 Channel 10 CCU1 Compare Register */
#define GTM_TOM1_CH11_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108b50u)	/* TOM1 Channel 11 CCU1 Compare Register */
#define GTM_TOM1_CH12_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108b90u)	/* TOM1 Channel 12 CCU1 Compare Register */
#define GTM_TOM1_CH13_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108bd0u)	/* TOM1 Channel 13 CCU1 Compare Register */
#define GTM_TOM1_CH14_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108c10u)	/* TOM1 Channel 14 CCU1 Compare Register */
#define GTM_TOM1_CH15_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108c50u)	/* TOM1 Channel 15 CCU1 Compare Register */
#define GTM_TOM1_CH1_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf01088d0u)	/* TOM1 Channel 1 CCU1 Compare Register */
#define GTM_TOM1_CH2_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108910u)	/* TOM1 Channel 2 CCU1 Compare Register */
#define GTM_TOM1_CH3_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108950u)	/* TOM1 Channel 3 CCU1 Compare Register */
#define GTM_TOM1_CH4_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108990u)	/* TOM1 Channel 4 CCU1 Compare Register */
#define GTM_TOM1_CH5_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf01089d0u)	/* TOM1 Channel 5 CCU1 Compare Register */
#define GTM_TOM1_CH6_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108a10u)	/* TOM1 Channel 6 CCU1 Compare Register */
#define GTM_TOM1_CH7_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108a50u)	/* TOM1 Channel 7 CCU1 Compare Register */
#define GTM_TOM1_CH8_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108a90u)	/* TOM1 Channel 8 CCU1 Compare Register */
#define GTM_TOM1_CH9_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0108ad0u)	/* TOM1 Channel 9 CCU1 Compare Register */
#define GTM_TOM2_CH0_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109090u)	/* TOM2 Channel 0 CCU1 Compare Register */
#define GTM_TOM2_CH10_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109310u)	/* TOM2 Channel 10 CCU1 Compare Register */
#define GTM_TOM2_CH11_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109350u)	/* TOM2 Channel 11 CCU1 Compare Register */
#define GTM_TOM2_CH12_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109390u)	/* TOM2 Channel 12 CCU1 Compare Register */
#define GTM_TOM2_CH13_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf01093d0u)	/* TOM2 Channel 13 CCU1 Compare Register */
#define GTM_TOM2_CH14_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109410u)	/* TOM2 Channel 14 CCU1 Compare Register */
#define GTM_TOM2_CH15_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109450u)	/* TOM2 Channel 15 CCU1 Compare Register */
#define GTM_TOM2_CH1_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf01090d0u)	/* TOM2 Channel 1 CCU1 Compare Register */
#define GTM_TOM2_CH2_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109110u)	/* TOM2 Channel 2 CCU1 Compare Register */
#define GTM_TOM2_CH3_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109150u)	/* TOM2 Channel 3 CCU1 Compare Register */
#define GTM_TOM2_CH4_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109190u)	/* TOM2 Channel 4 CCU1 Compare Register */
#define GTM_TOM2_CH5_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf01091d0u)	/* TOM2 Channel 5 CCU1 Compare Register */
#define GTM_TOM2_CH6_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109210u)	/* TOM2 Channel 6 CCU1 Compare Register */
#define GTM_TOM2_CH7_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109250u)	/* TOM2 Channel 7 CCU1 Compare Register */
#define GTM_TOM2_CH8_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf0109290u)	/* TOM2 Channel 8 CCU1 Compare Register */
#define GTM_TOM2_CH9_CM1	(*( GTM_TOM0_CH0_CM1_type *) 0xf01092d0u)	/* TOM2 Channel 9 CCU1 Compare Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CN0            : 16;	/* TOM CCU0 counter register */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH0_CN0_type;
#define GTM_TOM0_CH0_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108084u)	/* TOM0 Channel 0 CCU0 Counter Register */
#define GTM_TOM0_CH10_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108304u)	/* TOM0 Channel 10 CCU0 Counter Register */
#define GTM_TOM0_CH11_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108344u)	/* TOM0 Channel 11 CCU0 Counter Register */
#define GTM_TOM0_CH12_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108384u)	/* TOM0 Channel 12 CCU0 Counter Register */
#define GTM_TOM0_CH13_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf01083c4u)	/* TOM0 Channel 13 CCU0 Counter Register */
#define GTM_TOM0_CH14_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108404u)	/* TOM0 Channel 14 CCU0 Counter Register */
#define GTM_TOM0_CH15_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108444u)	/* TOM0 Channel 15 CCU0 Counter Register */
#define GTM_TOM0_CH1_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf01080c4u)	/* TOM0 Channel 1 CCU0 Counter Register */
#define GTM_TOM0_CH2_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108104u)	/* TOM0 Channel 2 CCU0 Counter Register */
#define GTM_TOM0_CH3_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108144u)	/* TOM0 Channel 3 CCU0 Counter Register */
#define GTM_TOM0_CH4_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108184u)	/* TOM0 Channel 4 CCU0 Counter Register */
#define GTM_TOM0_CH5_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf01081c4u)	/* TOM0 Channel 5 CCU0 Counter Register */
#define GTM_TOM0_CH6_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108204u)	/* TOM0 Channel 6 CCU0 Counter Register */
#define GTM_TOM0_CH7_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108244u)	/* TOM0 Channel 7 CCU0 Counter Register */
#define GTM_TOM0_CH8_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108284u)	/* TOM0 Channel 8 CCU0 Counter Register */
#define GTM_TOM0_CH9_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf01082c4u)	/* TOM0 Channel 9 CCU0 Counter Register */
#define GTM_TOM1_CH0_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108884u)	/* TOM1 Channel 0 CCU0 Counter Register */
#define GTM_TOM1_CH10_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108b04u)	/* TOM1 Channel 10 CCU0 Counter Register */
#define GTM_TOM1_CH11_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108b44u)	/* TOM1 Channel 11 CCU0 Counter Register */
#define GTM_TOM1_CH12_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108b84u)	/* TOM1 Channel 12 CCU0 Counter Register */
#define GTM_TOM1_CH13_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108bc4u)	/* TOM1 Channel 13 CCU0 Counter Register */
#define GTM_TOM1_CH14_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108c04u)	/* TOM1 Channel 14 CCU0 Counter Register */
#define GTM_TOM1_CH15_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108c44u)	/* TOM1 Channel 15 CCU0 Counter Register */
#define GTM_TOM1_CH1_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf01088c4u)	/* TOM1 Channel 1 CCU0 Counter Register */
#define GTM_TOM1_CH2_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108904u)	/* TOM1 Channel 2 CCU0 Counter Register */
#define GTM_TOM1_CH3_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108944u)	/* TOM1 Channel 3 CCU0 Counter Register */
#define GTM_TOM1_CH4_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108984u)	/* TOM1 Channel 4 CCU0 Counter Register */
#define GTM_TOM1_CH5_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf01089c4u)	/* TOM1 Channel 5 CCU0 Counter Register */
#define GTM_TOM1_CH6_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108a04u)	/* TOM1 Channel 6 CCU0 Counter Register */
#define GTM_TOM1_CH7_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108a44u)	/* TOM1 Channel 7 CCU0 Counter Register */
#define GTM_TOM1_CH8_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108a84u)	/* TOM1 Channel 8 CCU0 Counter Register */
#define GTM_TOM1_CH9_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0108ac4u)	/* TOM1 Channel 9 CCU0 Counter Register */
#define GTM_TOM2_CH0_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109084u)	/* TOM2 Channel 0 CCU0 Counter Register */
#define GTM_TOM2_CH10_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109304u)	/* TOM2 Channel 10 CCU0 Counter Register */
#define GTM_TOM2_CH11_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109344u)	/* TOM2 Channel 11 CCU0 Counter Register */
#define GTM_TOM2_CH12_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109384u)	/* TOM2 Channel 12 CCU0 Counter Register */
#define GTM_TOM2_CH13_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf01093c4u)	/* TOM2 Channel 13 CCU0 Counter Register */
#define GTM_TOM2_CH14_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109404u)	/* TOM2 Channel 14 CCU0 Counter Register */
#define GTM_TOM2_CH15_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109444u)	/* TOM2 Channel 15 CCU0 Counter Register */
#define GTM_TOM2_CH1_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf01090c4u)	/* TOM2 Channel 1 CCU0 Counter Register */
#define GTM_TOM2_CH2_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109104u)	/* TOM2 Channel 2 CCU0 Counter Register */
#define GTM_TOM2_CH3_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109144u)	/* TOM2 Channel 3 CCU0 Counter Register */
#define GTM_TOM2_CH4_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109184u)	/* TOM2 Channel 4 CCU0 Counter Register */
#define GTM_TOM2_CH5_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf01091c4u)	/* TOM2 Channel 5 CCU0 Counter Register */
#define GTM_TOM2_CH6_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109204u)	/* TOM2 Channel 6 CCU0 Counter Register */
#define GTM_TOM2_CH7_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109244u)	/* TOM2 Channel 7 CCU0 Counter Register */
#define GTM_TOM2_CH8_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf0109284u)	/* TOM2 Channel 8 CCU0 Counter Register */
#define GTM_TOM2_CH9_CN0	(*( GTM_TOM0_CH0_CN0_type *) 0xf01092c4u)	/* TOM2 Channel 9 CCU0 Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 11;	/* Reserved */
		unsigned int SL             : 1;	/* Signal level for duty cycle */
		unsigned int CLK_SRC_SR     : 3;	/* Clock source select for channel */
		/* const */ unsigned int Reserved_4     : 5;	/* Reserved */
		unsigned int RST_CCU0       : 1;	/* Reset source of CCU0 */
		/* const */ unsigned int Reserved_6     : 3;	/* Reserved */
		unsigned int TRIGOUT        : 1;	/* Trigger output selection (output signal TRIG_[x]) of module TOM_CH[x] */
		/* const */ unsigned int Reserved_8     : 1;	/* Reserved */
		unsigned int OSM            : 1;	/* One-shot mode */
		/* const */ unsigned int Reserved_10    : 1;	/* Reserved */
		unsigned int SPEM           : 1;	/* SPE mode enable for channel */
		unsigned int GCM            : 1;	/* Gated Counter Mode enable */
		/* const */ unsigned int Reserved_13    : 2;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH0_CTRL_type;
#define GTM_TOM0_CH0_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108080u)	/* TOM0 Channel 0 Control Register? */
#define GTM_TOM0_CH10_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108300u)	/* TOM0 Channel 10 Control Register? */
#define GTM_TOM0_CH11_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108340u)	/* TOM0 Channel 11 Control Register? */
#define GTM_TOM0_CH12_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108380u)	/* TOM0 Channel 12 Control Register? */
#define GTM_TOM0_CH13_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf01083c0u)	/* TOM0 Channel 13 Control Register? */
#define GTM_TOM0_CH14_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108400u)	/* TOM0 Channel 14 Control Register? */
#define GTM_TOM0_CH1_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf01080c0u)	/* TOM0 Channel 1 Control Register? */
#define GTM_TOM0_CH2_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108100u)	/* TOM0 Channel 2 Control Register? */
#define GTM_TOM0_CH3_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108140u)	/* TOM0 Channel 3 Control Register? */
#define GTM_TOM0_CH4_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108180u)	/* TOM0 Channel 4 Control Register? */
#define GTM_TOM0_CH5_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf01081c0u)	/* TOM0 Channel 5 Control Register? */
#define GTM_TOM0_CH6_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108200u)	/* TOM0 Channel 6 Control Register? */
#define GTM_TOM0_CH7_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108240u)	/* TOM0 Channel 7 Control Register? */
#define GTM_TOM0_CH8_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108280u)	/* TOM0 Channel 8 Control Register? */
#define GTM_TOM0_CH9_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf01082c0u)	/* TOM0 Channel 9 Control Register? */
#define GTM_TOM1_CH0_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108880u)	/* TOM1 Channel 0 Control Register? */
#define GTM_TOM1_CH10_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108b00u)	/* TOM1 Channel 10 Control Register? */
#define GTM_TOM1_CH11_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108b40u)	/* TOM1 Channel 11 Control Register? */
#define GTM_TOM1_CH12_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108b80u)	/* TOM1 Channel 12 Control Register? */
#define GTM_TOM1_CH13_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108bc0u)	/* TOM1 Channel 13 Control Register? */
#define GTM_TOM1_CH14_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108c00u)	/* TOM1 Channel 14 Control Register? */
#define GTM_TOM1_CH1_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf01088c0u)	/* TOM1 Channel 1 Control Register? */
#define GTM_TOM1_CH2_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108900u)	/* TOM1 Channel 2 Control Register? */
#define GTM_TOM1_CH3_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108940u)	/* TOM1 Channel 3 Control Register? */
#define GTM_TOM1_CH4_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108980u)	/* TOM1 Channel 4 Control Register? */
#define GTM_TOM1_CH5_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf01089c0u)	/* TOM1 Channel 5 Control Register? */
#define GTM_TOM1_CH6_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108a00u)	/* TOM1 Channel 6 Control Register? */
#define GTM_TOM1_CH7_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108a40u)	/* TOM1 Channel 7 Control Register? */
#define GTM_TOM1_CH8_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108a80u)	/* TOM1 Channel 8 Control Register? */
#define GTM_TOM1_CH9_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0108ac0u)	/* TOM1 Channel 9 Control Register? */
#define GTM_TOM2_CH0_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109080u)	/* TOM2 Channel 0 Control Register? */
#define GTM_TOM2_CH10_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109300u)	/* TOM2 Channel 10 Control Register? */
#define GTM_TOM2_CH11_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109340u)	/* TOM2 Channel 11 Control Register? */
#define GTM_TOM2_CH12_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109380u)	/* TOM2 Channel 12 Control Register? */
#define GTM_TOM2_CH13_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf01093c0u)	/* TOM2 Channel 13 Control Register? */
#define GTM_TOM2_CH14_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109400u)	/* TOM2 Channel 14 Control Register? */
#define GTM_TOM2_CH1_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf01090c0u)	/* TOM2 Channel 1 Control Register? */
#define GTM_TOM2_CH2_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109100u)	/* TOM2 Channel 2 Control Register? */
#define GTM_TOM2_CH3_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109140u)	/* TOM2 Channel 3 Control Register? */
#define GTM_TOM2_CH4_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109180u)	/* TOM2 Channel 4 Control Register? */
#define GTM_TOM2_CH5_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf01091c0u)	/* TOM2 Channel 5 Control Register? */
#define GTM_TOM2_CH6_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109200u)	/* TOM2 Channel 6 Control Register? */
#define GTM_TOM2_CH7_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109240u)	/* TOM2 Channel 7 Control Register? */
#define GTM_TOM2_CH8_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf0109280u)	/* TOM2 Channel 8 Control Register? */
#define GTM_TOM2_CH9_CTRL	(*( GTM_TOM0_CH0_CTRL_type *) 0xf01092c0u)	/* TOM2 Channel 9 Control Register? */

typedef volatile union
{
	struct
	{ 
		unsigned int CCU0TC_IRQ_EN  : 1;	/* TOM_CCU0TC_IRQ interrupt enable */
		unsigned int CCU1TC_IRQ_EN  : 1;	/* TOM_CCU1TC_IRQ interrupt enable */
		/* const */ unsigned int Reserved       : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH0_IRQ_EN_type;
#define GTM_TOM0_CH0_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01080a0u)	/* TOM0 Channel 0 Interrupt Enable Register */
#define GTM_TOM0_CH10_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108320u)	/* TOM0 Channel 10 Interrupt Enable Register */
#define GTM_TOM0_CH11_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108360u)	/* TOM0 Channel 11 Interrupt Enable Register */
#define GTM_TOM0_CH12_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01083a0u)	/* TOM0 Channel 12 Interrupt Enable Register */
#define GTM_TOM0_CH13_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01083e0u)	/* TOM0 Channel 13 Interrupt Enable Register */
#define GTM_TOM0_CH14_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108420u)	/* TOM0 Channel 14 Interrupt Enable Register */
#define GTM_TOM0_CH15_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108460u)	/* TOM0 Channel 15 Interrupt Enable Register */
#define GTM_TOM0_CH1_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01080e0u)	/* TOM0 Channel 1 Interrupt Enable Register */
#define GTM_TOM0_CH2_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108120u)	/* TOM0 Channel 2 Interrupt Enable Register */
#define GTM_TOM0_CH3_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108160u)	/* TOM0 Channel 3 Interrupt Enable Register */
#define GTM_TOM0_CH4_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01081a0u)	/* TOM0 Channel 4 Interrupt Enable Register */
#define GTM_TOM0_CH5_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01081e0u)	/* TOM0 Channel 5 Interrupt Enable Register */
#define GTM_TOM0_CH6_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108220u)	/* TOM0 Channel 6 Interrupt Enable Register */
#define GTM_TOM0_CH7_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108260u)	/* TOM0 Channel 7 Interrupt Enable Register */
#define GTM_TOM0_CH8_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01082a0u)	/* TOM0 Channel 8 Interrupt Enable Register */
#define GTM_TOM0_CH9_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01082e0u)	/* TOM0 Channel 9 Interrupt Enable Register */
#define GTM_TOM1_CH0_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01088a0u)	/* TOM1 Channel 0 Interrupt Enable Register */
#define GTM_TOM1_CH10_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108b20u)	/* TOM1 Channel 10 Interrupt Enable Register */
#define GTM_TOM1_CH11_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108b60u)	/* TOM1 Channel 11 Interrupt Enable Register */
#define GTM_TOM1_CH12_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108ba0u)	/* TOM1 Channel 12 Interrupt Enable Register */
#define GTM_TOM1_CH13_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108be0u)	/* TOM1 Channel 13 Interrupt Enable Register */
#define GTM_TOM1_CH14_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108c20u)	/* TOM1 Channel 14 Interrupt Enable Register */
#define GTM_TOM1_CH15_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108c60u)	/* TOM1 Channel 15 Interrupt Enable Register */
#define GTM_TOM1_CH1_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01088e0u)	/* TOM1 Channel 1 Interrupt Enable Register */
#define GTM_TOM1_CH2_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108920u)	/* TOM1 Channel 2 Interrupt Enable Register */
#define GTM_TOM1_CH3_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108960u)	/* TOM1 Channel 3 Interrupt Enable Register */
#define GTM_TOM1_CH4_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01089a0u)	/* TOM1 Channel 4 Interrupt Enable Register */
#define GTM_TOM1_CH5_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01089e0u)	/* TOM1 Channel 5 Interrupt Enable Register */
#define GTM_TOM1_CH6_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108a20u)	/* TOM1 Channel 6 Interrupt Enable Register */
#define GTM_TOM1_CH7_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108a60u)	/* TOM1 Channel 7 Interrupt Enable Register */
#define GTM_TOM1_CH8_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108aa0u)	/* TOM1 Channel 8 Interrupt Enable Register */
#define GTM_TOM1_CH9_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0108ae0u)	/* TOM1 Channel 9 Interrupt Enable Register */
#define GTM_TOM2_CH0_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01090a0u)	/* TOM2 Channel 0 Interrupt Enable Register */
#define GTM_TOM2_CH10_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0109320u)	/* TOM2 Channel 10 Interrupt Enable Register */
#define GTM_TOM2_CH11_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0109360u)	/* TOM2 Channel 11 Interrupt Enable Register */
#define GTM_TOM2_CH12_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01093a0u)	/* TOM2 Channel 12 Interrupt Enable Register */
#define GTM_TOM2_CH13_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01093e0u)	/* TOM2 Channel 13 Interrupt Enable Register */
#define GTM_TOM2_CH14_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0109420u)	/* TOM2 Channel 14 Interrupt Enable Register */
#define GTM_TOM2_CH15_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0109460u)	/* TOM2 Channel 15 Interrupt Enable Register */
#define GTM_TOM2_CH1_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01090e0u)	/* TOM2 Channel 1 Interrupt Enable Register */
#define GTM_TOM2_CH2_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0109120u)	/* TOM2 Channel 2 Interrupt Enable Register */
#define GTM_TOM2_CH3_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0109160u)	/* TOM2 Channel 3 Interrupt Enable Register */
#define GTM_TOM2_CH4_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01091a0u)	/* TOM2 Channel 4 Interrupt Enable Register */
#define GTM_TOM2_CH5_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01091e0u)	/* TOM2 Channel 5 Interrupt Enable Register */
#define GTM_TOM2_CH6_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0109220u)	/* TOM2 Channel 6 Interrupt Enable Register */
#define GTM_TOM2_CH7_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf0109260u)	/* TOM2 Channel 7 Interrupt Enable Register */
#define GTM_TOM2_CH8_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01092a0u)	/* TOM2 Channel 8 Interrupt Enable Register */
#define GTM_TOM2_CH9_IRQ_EN	(*( GTM_TOM0_CH0_IRQ_EN_type *) 0xf01092e0u)	/* TOM2 Channel 9 Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TRG_CCU0TC0    : 1;	/* Trigger TOM_CCU0TC0_IRQ interrupt by software */
		unsigned int TRG_CCU1TC0    : 1;	/* Trigger TOM_CCU1TC0_IRQ interrupt by software */
		/* const */ unsigned int Reserved       : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH0_IRQ_FORCINT_type;
#define GTM_TOM0_CH0_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01080a4u)	/* TOM0 Channel 0 Software Interrupt Generation Register */
#define GTM_TOM0_CH10_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108324u)	/* TOM0 Channel 10 Software Interrupt Generation Register */
#define GTM_TOM0_CH11_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108364u)	/* TOM0 Channel 11 Software Interrupt Generation Register */
#define GTM_TOM0_CH12_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01083a4u)	/* TOM0 Channel 12 Software Interrupt Generation Register */
#define GTM_TOM0_CH13_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01083e4u)	/* TOM0 Channel 13 Software Interrupt Generation Register */
#define GTM_TOM0_CH14_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108424u)	/* TOM0 Channel 14 Software Interrupt Generation Register */
#define GTM_TOM0_CH15_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108464u)	/* TOM0 Channel 15 Software Interrupt Generation Register */
#define GTM_TOM0_CH1_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01080e4u)	/* TOM0 Channel 1 Software Interrupt Generation Register */
#define GTM_TOM0_CH2_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108124u)	/* TOM0 Channel 2 Software Interrupt Generation Register */
#define GTM_TOM0_CH3_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108164u)	/* TOM0 Channel 3 Software Interrupt Generation Register */
#define GTM_TOM0_CH4_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01081a4u)	/* TOM0 Channel 4 Software Interrupt Generation Register */
#define GTM_TOM0_CH5_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01081e4u)	/* TOM0 Channel 5 Software Interrupt Generation Register */
#define GTM_TOM0_CH6_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108224u)	/* TOM0 Channel 6 Software Interrupt Generation Register */
#define GTM_TOM0_CH7_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108264u)	/* TOM0 Channel 7 Software Interrupt Generation Register */
#define GTM_TOM0_CH8_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01082a4u)	/* TOM0 Channel 8 Software Interrupt Generation Register */
#define GTM_TOM0_CH9_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01082e4u)	/* TOM0 Channel 9 Software Interrupt Generation Register */
#define GTM_TOM1_CH0_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01088a4u)	/* TOM1 Channel 0 Software Interrupt Generation Register */
#define GTM_TOM1_CH10_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108b24u)	/* TOM1 Channel 10 Software Interrupt Generation Register */
#define GTM_TOM1_CH11_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108b64u)	/* TOM1 Channel 11 Software Interrupt Generation Register */
#define GTM_TOM1_CH12_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108ba4u)	/* TOM1 Channel 12 Software Interrupt Generation Register */
#define GTM_TOM1_CH13_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108be4u)	/* TOM1 Channel 13 Software Interrupt Generation Register */
#define GTM_TOM1_CH14_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108c24u)	/* TOM1 Channel 14 Software Interrupt Generation Register */
#define GTM_TOM1_CH15_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108c64u)	/* TOM1 Channel 15 Software Interrupt Generation Register */
#define GTM_TOM1_CH1_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01088e4u)	/* TOM1 Channel 1 Software Interrupt Generation Register */
#define GTM_TOM1_CH2_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108924u)	/* TOM1 Channel 2 Software Interrupt Generation Register */
#define GTM_TOM1_CH3_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108964u)	/* TOM1 Channel 3 Software Interrupt Generation Register */
#define GTM_TOM1_CH4_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01089a4u)	/* TOM1 Channel 4 Software Interrupt Generation Register */
#define GTM_TOM1_CH5_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01089e4u)	/* TOM1 Channel 5 Software Interrupt Generation Register */
#define GTM_TOM1_CH6_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108a24u)	/* TOM1 Channel 6 Software Interrupt Generation Register */
#define GTM_TOM1_CH7_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108a64u)	/* TOM1 Channel 7 Software Interrupt Generation Register */
#define GTM_TOM1_CH8_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108aa4u)	/* TOM1 Channel 8 Software Interrupt Generation Register */
#define GTM_TOM1_CH9_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0108ae4u)	/* TOM1 Channel 9 Software Interrupt Generation Register */
#define GTM_TOM2_CH0_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01090a4u)	/* TOM2 Channel 0 Software Interrupt Generation Register */
#define GTM_TOM2_CH10_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0109324u)	/* TOM2 Channel 10 Software Interrupt Generation Register */
#define GTM_TOM2_CH11_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0109364u)	/* TOM2 Channel 11 Software Interrupt Generation Register */
#define GTM_TOM2_CH12_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01093a4u)	/* TOM2 Channel 12 Software Interrupt Generation Register */
#define GTM_TOM2_CH13_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01093e4u)	/* TOM2 Channel 13 Software Interrupt Generation Register */
#define GTM_TOM2_CH14_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0109424u)	/* TOM2 Channel 14 Software Interrupt Generation Register */
#define GTM_TOM2_CH15_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0109464u)	/* TOM2 Channel 15 Software Interrupt Generation Register */
#define GTM_TOM2_CH1_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01090e4u)	/* TOM2 Channel 1 Software Interrupt Generation Register */
#define GTM_TOM2_CH2_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0109124u)	/* TOM2 Channel 2 Software Interrupt Generation Register */
#define GTM_TOM2_CH3_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0109164u)	/* TOM2 Channel 3 Software Interrupt Generation Register */
#define GTM_TOM2_CH4_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01091a4u)	/* TOM2 Channel 4 Software Interrupt Generation Register */
#define GTM_TOM2_CH5_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01091e4u)	/* TOM2 Channel 5 Software Interrupt Generation Register */
#define GTM_TOM2_CH6_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0109224u)	/* TOM2 Channel 6 Software Interrupt Generation Register */
#define GTM_TOM2_CH7_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf0109264u)	/* TOM2 Channel 7 Software Interrupt Generation Register */
#define GTM_TOM2_CH8_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01092a4u)	/* TOM2 Channel 8 Software Interrupt Generation Register */
#define GTM_TOM2_CH9_IRQ_FORCINT	(*( GTM_TOM0_CH0_IRQ_FORCINT_type *) 0xf01092e4u)	/* TOM2 Channel 9 Software Interrupt Generation Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CCU0TC         : 1;	/* CCU0 Trigger condition interrupt for channel x */
		unsigned int CCU1TC         : 1;	/* CCU1 Trigger condition interrupt for channel x */
		/* const */ unsigned int Reserved       : 30;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH0_IRQ_NOTIFY_type;
#define GTM_TOM0_CH0_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010809cu)	/* TOM0 Channel 0 Interrupt Notification Register */
#define GTM_TOM0_CH10_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010831cu)	/* TOM0 Channel 10 Interrupt Notification Register */
#define GTM_TOM0_CH11_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010835cu)	/* TOM0 Channel 11 Interrupt Notification Register */
#define GTM_TOM0_CH12_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010839cu)	/* TOM0 Channel 12 Interrupt Notification Register */
#define GTM_TOM0_CH13_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf01083dcu)	/* TOM0 Channel 13 Interrupt Notification Register */
#define GTM_TOM0_CH14_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010841cu)	/* TOM0 Channel 14 Interrupt Notification Register */
#define GTM_TOM0_CH15_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010845cu)	/* TOM0 Channel 15 Interrupt Notification Register */
#define GTM_TOM0_CH1_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf01080dcu)	/* TOM0 Channel 1 Interrupt Notification Register */
#define GTM_TOM0_CH2_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010811cu)	/* TOM0 Channel 2 Interrupt Notification Register */
#define GTM_TOM0_CH3_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010815cu)	/* TOM0 Channel 3 Interrupt Notification Register */
#define GTM_TOM0_CH4_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010819cu)	/* TOM0 Channel 4 Interrupt Notification Register */
#define GTM_TOM0_CH5_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf01081dcu)	/* TOM0 Channel 5 Interrupt Notification Register */
#define GTM_TOM0_CH6_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010821cu)	/* TOM0 Channel 6 Interrupt Notification Register */
#define GTM_TOM0_CH7_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010825cu)	/* TOM0 Channel 7 Interrupt Notification Register */
#define GTM_TOM0_CH8_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010829cu)	/* TOM0 Channel 8 Interrupt Notification Register */
#define GTM_TOM0_CH9_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf01082dcu)	/* TOM0 Channel 9 Interrupt Notification Register */
#define GTM_TOM1_CH0_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010889cu)	/* TOM1 Channel 0 Interrupt Notification Register */
#define GTM_TOM1_CH10_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf0108b1cu)	/* TOM1 Channel 10 Interrupt Notification Register */
#define GTM_TOM1_CH11_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf0108b5cu)	/* TOM1 Channel 11 Interrupt Notification Register */
#define GTM_TOM1_CH12_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf0108b9cu)	/* TOM1 Channel 12 Interrupt Notification Register */
#define GTM_TOM1_CH13_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf0108bdcu)	/* TOM1 Channel 13 Interrupt Notification Register */
#define GTM_TOM1_CH14_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf0108c1cu)	/* TOM1 Channel 14 Interrupt Notification Register */
#define GTM_TOM1_CH15_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf0108c5cu)	/* TOM1 Channel 15 Interrupt Notification Register */
#define GTM_TOM1_CH1_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf01088dcu)	/* TOM1 Channel 1 Interrupt Notification Register */
#define GTM_TOM1_CH2_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010891cu)	/* TOM1 Channel 2 Interrupt Notification Register */
#define GTM_TOM1_CH3_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010895cu)	/* TOM1 Channel 3 Interrupt Notification Register */
#define GTM_TOM1_CH4_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010899cu)	/* TOM1 Channel 4 Interrupt Notification Register */
#define GTM_TOM1_CH5_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf01089dcu)	/* TOM1 Channel 5 Interrupt Notification Register */
#define GTM_TOM1_CH6_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf0108a1cu)	/* TOM1 Channel 6 Interrupt Notification Register */
#define GTM_TOM1_CH7_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf0108a5cu)	/* TOM1 Channel 7 Interrupt Notification Register */
#define GTM_TOM1_CH8_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf0108a9cu)	/* TOM1 Channel 8 Interrupt Notification Register */
#define GTM_TOM1_CH9_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf0108adcu)	/* TOM1 Channel 9 Interrupt Notification Register */
#define GTM_TOM2_CH0_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010909cu)	/* TOM2 Channel 0 Interrupt Notification Register */
#define GTM_TOM2_CH10_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010931cu)	/* TOM2 Channel 10 Interrupt Notification Register */
#define GTM_TOM2_CH11_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010935cu)	/* TOM2 Channel 11 Interrupt Notification Register */
#define GTM_TOM2_CH12_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010939cu)	/* TOM2 Channel 12 Interrupt Notification Register */
#define GTM_TOM2_CH13_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf01093dcu)	/* TOM2 Channel 13 Interrupt Notification Register */
#define GTM_TOM2_CH14_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010941cu)	/* TOM2 Channel 14 Interrupt Notification Register */
#define GTM_TOM2_CH15_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010945cu)	/* TOM2 Channel 15 Interrupt Notification Register */
#define GTM_TOM2_CH1_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf01090dcu)	/* TOM2 Channel 1 Interrupt Notification Register */
#define GTM_TOM2_CH2_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010911cu)	/* TOM2 Channel 2 Interrupt Notification Register */
#define GTM_TOM2_CH3_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010915cu)	/* TOM2 Channel 3 Interrupt Notification Register */
#define GTM_TOM2_CH4_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010919cu)	/* TOM2 Channel 4 Interrupt Notification Register */
#define GTM_TOM2_CH5_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf01091dcu)	/* TOM2 Channel 5 Interrupt Notification Register */
#define GTM_TOM2_CH6_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010921cu)	/* TOM2 Channel 6 Interrupt Notification Register */
#define GTM_TOM2_CH7_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010925cu)	/* TOM2 Channel 7 Interrupt Notification Register */
#define GTM_TOM2_CH8_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf010929cu)	/* TOM2 Channel 8 Interrupt Notification Register */
#define GTM_TOM2_CH9_IRQ_NOTIFY	(*( GTM_TOM0_CH0_IRQ_NOTIFY_type *) 0xf01092dcu)	/* TOM2 Channel 9 Interrupt Notification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SR0            : 16;	/* TOM channel x shadow register SR0 for update of compare register CM0 */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH0_SR0_type;
#define GTM_TOM0_CH0_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010808cu)	/* TOM0 Channel 0 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH10_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010830cu)	/* TOM0 Channel 10 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH11_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010834cu)	/* TOM0 Channel 11 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH12_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010838cu)	/* TOM0 Channel 12 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH13_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf01083ccu)	/* TOM0 Channel 13 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH14_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010840cu)	/* TOM0 Channel 14 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH15_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010844cu)	/* TOM0 Channel 15 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH1_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf01080ccu)	/* TOM0 Channel 1 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH2_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010810cu)	/* TOM0 Channel 2 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH3_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010814cu)	/* TOM0 Channel 3 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH4_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010818cu)	/* TOM0 Channel 4 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH5_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf01081ccu)	/* TOM0 Channel 5 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH6_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010820cu)	/* TOM0 Channel 6 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH7_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010824cu)	/* TOM0 Channel 7 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH8_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010828cu)	/* TOM0 Channel 8 CCU0 Compare Shadow Register */
#define GTM_TOM0_CH9_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf01082ccu)	/* TOM0 Channel 9 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH0_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010888cu)	/* TOM1 Channel 0 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH10_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf0108b0cu)	/* TOM1 Channel 10 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH11_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf0108b4cu)	/* TOM1 Channel 11 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH12_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf0108b8cu)	/* TOM1 Channel 12 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH13_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf0108bccu)	/* TOM1 Channel 13 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH14_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf0108c0cu)	/* TOM1 Channel 14 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH15_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf0108c4cu)	/* TOM1 Channel 15 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH1_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf01088ccu)	/* TOM1 Channel 1 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH2_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010890cu)	/* TOM1 Channel 2 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH3_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010894cu)	/* TOM1 Channel 3 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH4_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010898cu)	/* TOM1 Channel 4 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH5_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf01089ccu)	/* TOM1 Channel 5 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH6_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf0108a0cu)	/* TOM1 Channel 6 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH7_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf0108a4cu)	/* TOM1 Channel 7 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH8_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf0108a8cu)	/* TOM1 Channel 8 CCU0 Compare Shadow Register */
#define GTM_TOM1_CH9_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf0108accu)	/* TOM1 Channel 9 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH0_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010908cu)	/* TOM2 Channel 0 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH10_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010930cu)	/* TOM2 Channel 10 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH11_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010934cu)	/* TOM2 Channel 11 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH12_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010938cu)	/* TOM2 Channel 12 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH13_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf01093ccu)	/* TOM2 Channel 13 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH14_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010940cu)	/* TOM2 Channel 14 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH15_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010944cu)	/* TOM2 Channel 15 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH1_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf01090ccu)	/* TOM2 Channel 1 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH2_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010910cu)	/* TOM2 Channel 2 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH3_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010914cu)	/* TOM2 Channel 3 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH4_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010918cu)	/* TOM2 Channel 4 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH5_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf01091ccu)	/* TOM2 Channel 5 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH6_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010920cu)	/* TOM2 Channel 6 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH7_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010924cu)	/* TOM2 Channel 7 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH8_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf010928cu)	/* TOM2 Channel 8 CCU0 Compare Shadow Register */
#define GTM_TOM2_CH9_SR0	(*( GTM_TOM0_CH0_SR0_type *) 0xf01092ccu)	/* TOM2 Channel 9 CCU0 Compare Shadow Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SR1            : 16;	/* TOM channel x shadow register SR1 for update of compare register CM1 */
		/* const */ unsigned int Reserved       : 16;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH0_SR1_type;
#define GTM_TOM0_CH0_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108094u)	/* TOM0 Channel 0 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH10_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108314u)	/* TOM0 Channel 10 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH11_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108354u)	/* TOM0 Channel 11 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH12_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108394u)	/* TOM0 Channel 12 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH13_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf01083d4u)	/* TOM0 Channel 13 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH14_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108414u)	/* TOM0 Channel 14 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH15_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108454u)	/* TOM0 Channel 15 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH1_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf01080d4u)	/* TOM0 Channel 1 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH2_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108114u)	/* TOM0 Channel 2 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH3_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108154u)	/* TOM0 Channel 3 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH4_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108194u)	/* TOM0 Channel 4 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH5_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf01081d4u)	/* TOM0 Channel 5 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH6_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108214u)	/* TOM0 Channel 6 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH7_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108254u)	/* TOM0 Channel 7 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH8_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108294u)	/* TOM0 Channel 8 CCU1 Compare Shadow Register */
#define GTM_TOM0_CH9_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf01082d4u)	/* TOM0 Channel 9 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH0_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108894u)	/* TOM1 Channel 0 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH10_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108b14u)	/* TOM1 Channel 10 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH11_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108b54u)	/* TOM1 Channel 11 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH12_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108b94u)	/* TOM1 Channel 12 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH13_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108bd4u)	/* TOM1 Channel 13 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH14_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108c14u)	/* TOM1 Channel 14 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH15_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108c54u)	/* TOM1 Channel 15 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH1_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf01088d4u)	/* TOM1 Channel 1 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH2_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108914u)	/* TOM1 Channel 2 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH3_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108954u)	/* TOM1 Channel 3 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH4_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108994u)	/* TOM1 Channel 4 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH5_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf01089d4u)	/* TOM1 Channel 5 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH6_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108a14u)	/* TOM1 Channel 6 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH7_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108a54u)	/* TOM1 Channel 7 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH8_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108a94u)	/* TOM1 Channel 8 CCU1 Compare Shadow Register */
#define GTM_TOM1_CH9_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0108ad4u)	/* TOM1 Channel 9 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH0_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109094u)	/* TOM2 Channel 0 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH10_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109314u)	/* TOM2 Channel 10 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH11_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109354u)	/* TOM2 Channel 11 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH12_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109394u)	/* TOM2 Channel 12 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH13_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf01093d4u)	/* TOM2 Channel 13 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH14_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109414u)	/* TOM2 Channel 14 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH15_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109454u)	/* TOM2 Channel 15 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH1_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf01090d4u)	/* TOM2 Channel 1 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH2_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109114u)	/* TOM2 Channel 2 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH3_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109154u)	/* TOM2 Channel 3 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH4_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109194u)	/* TOM2 Channel 4 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH5_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf01091d4u)	/* TOM2 Channel 5 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH6_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109214u)	/* TOM2 Channel 6 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH7_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109254u)	/* TOM2 Channel 7 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH8_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf0109294u)	/* TOM2 Channel 8 CCU1 Compare Shadow Register */
#define GTM_TOM2_CH9_SR1	(*( GTM_TOM0_CH0_SR1_type *) 0xf01092d4u)	/* TOM2 Channel 9 CCU1 Compare Shadow Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int OL             : 1;	/* Output level of output TOM_OUT(x) */
		/* const */ unsigned int Reserved       : 31;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH0_STAT_type;
#define GTM_TOM0_CH0_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108098u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH10_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108318u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH11_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108358u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH12_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108398u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH13_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf01083d8u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH14_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108418u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH15_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108458u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH1_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf01080d8u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH2_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108118u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH3_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108158u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH4_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108198u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH5_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf01081d8u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH6_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108218u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH7_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108258u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH8_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108298u)	/* TOM0 Channel Status Register */
#define GTM_TOM0_CH9_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf01082d8u)	/* TOM0 Channel Status Register */
#define GTM_TOM1_CH0_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108898u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH10_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108b18u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH11_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108b58u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH12_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108b98u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH13_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108bd8u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH14_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108c18u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH15_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108c58u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH1_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf01088d8u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH2_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108918u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH3_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108958u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH4_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108998u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH5_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf01089d8u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH6_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108a18u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH7_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108a58u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH8_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108a98u)	/* TOM1 Channel Status Register */
#define GTM_TOM1_CH9_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0108ad8u)	/* TOM1 Channel Status Register */
#define GTM_TOM2_CH0_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109098u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH10_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109318u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH11_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109358u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH12_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109398u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH13_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf01093d8u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH14_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109418u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH15_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109458u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH1_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf01090d8u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH2_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109118u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH3_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109158u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH4_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109198u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH5_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf01091d8u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH6_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109218u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH7_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109258u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH8_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf0109298u)	/* TOM2 Channel Status Register */
#define GTM_TOM2_CH9_STAT	(*( GTM_TOM0_CH0_STAT_type *) 0xf01092d8u)	/* TOM2 Channel Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 11;	/* Reserved */
		unsigned int SL             : 1;	/* Signal level for duty cycle */
		unsigned int CLK_SRC_SR     : 3;	/* Clock source select for channel */
		/* const */ unsigned int Reserved_4     : 5;	/* Reserved */
		unsigned int RST_CCU0       : 1;	/* Reset source of CCU0 */
		/* const */ unsigned int Reserved_6     : 3;	/* Reserved */
		unsigned int TRIGOUT        : 1;	/* Trigger output selection (output signal TRIG_15) of module TOM_CH15 */
		/* const */ unsigned int Reserved_8     : 1;	/* Reserved */
		unsigned int OSM            : 1;	/* One-shot mode */
		unsigned int BITREV         : 1;	/* Bit-reversing of output of counter register CN0 */
		/* const */ unsigned int Reserved_11    : 4;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_CH15_CTRL_type;
#define GTM_TOM0_CH15_CTRL	(*( GTM_TOM0_CH15_CTRL_type *) 0xf0108440u)	/* TOM0 Channel 15 Control Register */
#define GTM_TOM1_CH15_CTRL	(*( GTM_TOM0_CH15_CTRL_type *) 0xf0108c40u)	/* TOM1 Channel 15 Control Register */
#define GTM_TOM2_CH15_CTRL	(*( GTM_TOM0_CH15_CTRL_type *) 0xf0109440u)	/* TOM2 Channel 15 Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int HOST_TRIG      : 1;	/* Trigger request signal (see TGC0, TGC1) to update the register ENDIS_STAT and OUTEN_STAT */
		/* const */ unsigned int Reserved       : 7;	/* Reserved */
		unsigned int RST_CH0        : 1;	/* Software reset of channel 0 */
		unsigned int RST_CH1        : 1;	/* Software reset of channel 1 */
		unsigned int RST_CH2        : 1;	/* Software reset of channel 2 */
		unsigned int RST_CH3        : 1;	/* Software reset of channel 3 */
		unsigned int RST_CH4        : 1;	/* Software reset of channel 4 */
		unsigned int RST_CH5        : 1;	/* Software reset of channel 5 */
		unsigned int RST_CH6        : 1;	/* Software reset of channel 6 */
		unsigned int RST_CH7        : 1;	/* Software reset of channel 7 */
		unsigned int UPEN_CTRL0     : 2;	/* TOM channel 0 enable update of register CM0, CM1 and CLK_SRC_STAT from SR0, SR1 and CLK_SRC */
		unsigned int UPEN_CTRL1     : 2;	/* TOM channel 1 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL2     : 2;	/* TOM channel 2 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL3     : 2;	/* TOM channel 3 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL4     : 2;	/* TOM channel 4 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL5     : 2;	/* TOM channel 5 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL6     : 2;	/* TOM channel 6 enable update of register CM0, CM1 and CLK_SRC_STAT */
		unsigned int UPEN_CTRL7     : 2;	/* TOM channel 7 enable update of register CM0, CM1 and CLK_SRC_STAT */
	} B;
	int I;
	unsigned int U;

} GTM_TOM0_TGC0_GLB_CTRL_type;
#define GTM_TOM0_TGC0_GLB_CTRL	(*( GTM_TOM0_TGC0_GLB_CTRL_type *) 0xf0108000u)	/* TOM0 TGC0 Global Control Register */
#define GTM_TOM0_TGC1_GLB_CTRL	(*( GTM_TOM0_TGC0_GLB_CTRL_type *) 0xf0108040u)	/* TOM0 TGC1 Global Control Register */
#define GTM_TOM1_TGC0_GLB_CTRL	(*( GTM_TOM0_TGC0_GLB_CTRL_type *) 0xf0108800u)	/* TOM1 TGC0 Global Control Register */
#define GTM_TOM1_TGC1_GLB_CTRL	(*( GTM_TOM0_TGC0_GLB_CTRL_type *) 0xf0108840u)	/* TOM1 TGC1 Global Control Register */
#define GTM_TOM2_TGC0_GLB_CTRL	(*( GTM_TOM0_TGC0_GLB_CTRL_type *) 0xf0109000u)	/* TOM2 TGC0 Global Control Register */
#define GTM_TOM2_TGC1_GLB_CTRL	(*( GTM_TOM0_TGC0_GLB_CTRL_type *) 0xf0109040u)	/* TOM2 TGC1 Global Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEL0           : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL1           : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL2           : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL3           : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL4           : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL5           : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL6           : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL7           : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL8           : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL9           : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL10          : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL11          : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL12          : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL13          : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL14          : 2;	/* TOUT(n*16+x) Output Selection */
		unsigned int SEL15          : 2;	/* TOUT(n*16+x) Output Selection */
	} B;
	int I;
	unsigned int U;

} GTM_TOUTSEL0_type;
#define GTM_TOUTSEL0	(*( GTM_TOUTSEL0_type *) 0xf019fd30u)	/* Timer Output Select Register */
#define GTM_TOUTSEL1	(*( GTM_TOUTSEL0_type *) 0xf019fd34u)	/* Timer Output Select Register */
#define GTM_TOUTSEL10	(*( GTM_TOUTSEL0_type *) 0xf019fd58u)	/* Timer Output Select Register */
#define GTM_TOUTSEL11	(*( GTM_TOUTSEL0_type *) 0xf019fd5cu)	/* Timer Output Select Register */
#define GTM_TOUTSEL12	(*( GTM_TOUTSEL0_type *) 0xf019fd60u)	/* Timer Output Select Register */
#define GTM_TOUTSEL13	(*( GTM_TOUTSEL0_type *) 0xf019fd64u)	/* Timer Output Select Register */
#define GTM_TOUTSEL14	(*( GTM_TOUTSEL0_type *) 0xf019fd68u)	/* Timer Output Select Register */
#define GTM_TOUTSEL2	(*( GTM_TOUTSEL0_type *) 0xf019fd38u)	/* Timer Output Select Register */
#define GTM_TOUTSEL3	(*( GTM_TOUTSEL0_type *) 0xf019fd3cu)	/* Timer Output Select Register */
#define GTM_TOUTSEL4	(*( GTM_TOUTSEL0_type *) 0xf019fd40u)	/* Timer Output Select Register */
#define GTM_TOUTSEL5	(*( GTM_TOUTSEL0_type *) 0xf019fd44u)	/* Timer Output Select Register */
#define GTM_TOUTSEL6	(*( GTM_TOUTSEL0_type *) 0xf019fd48u)	/* Timer Output Select Register */
#define GTM_TOUTSEL7	(*( GTM_TOUTSEL0_type *) 0xf019fd4cu)	/* Timer Output Select Register */
#define GTM_TOUTSEL8	(*( GTM_TOUTSEL0_type *) 0xf019fd50u)	/* Timer Output Select Register */
#define GTM_TOUTSEL9	(*( GTM_TOUTSEL0_type *) 0xf019fd54u)	/* Timer Output Select Register */


/* VADC */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID x */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID x */
	} B;
	int I;
	unsigned int U;

} VADC_ACCEN0_type;
#define VADC_ACCEN0	(*( VADC_ACCEN0_type *) 0xf002003cu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int APC0           : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC1           : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC2           : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC3           : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC4           : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC5           : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC6           : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC7           : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC8           : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC9           : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC10          : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC11          : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC12          : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC13          : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APC14          : 1;	/* Access Protection Channel Control, Group 0 - 14 */
		unsigned int APEM           : 1;	/* Access Protection External Multiplexer */
		unsigned int API0           : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API1           : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API2           : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API3           : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API4           : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API5           : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API6           : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API7           : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API8           : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API9           : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API10          : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API11          : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API12          : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API13          : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int API14          : 1;	/* Access Protection Initialization, Group 0 - 14 */
		unsigned int APGC           : 1;	/* Access Protection Global Configuration */
	} B;
	int I;
	unsigned int U;

} VADC_ACCPROT0_type;
#define VADC_ACCPROT0	(*( VADC_ACCPROT0_type *) 0xf0020088u)	/* Access Protection Register */

typedef volatile union
{
	struct
	{ 
		unsigned int APS0           : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS1           : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS2           : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS3           : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS4           : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS5           : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS6           : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS7           : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS8           : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS9           : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS10          : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS11          : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS12          : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS13          : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APS14          : 1;	/* Access Protection Service Request, Group 0 - 14 */
		unsigned int APTF           : 1;	/* Access Protection Test Function */
		unsigned int APR0           : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR1           : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR2           : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR3           : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR4           : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR5           : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR6           : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR7           : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR8           : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR9           : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR10          : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR11          : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR12          : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR13          : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int APR14          : 1;	/* Access Protection Result Registers, Group 0 - 14 */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} VADC_ACCPROT1_type;
#define VADC_ACCPROT1	(*( VADC_ACCPROT1_type *) 0xf002008cu)	/* Access Protection Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SRCRESREG      : 4;	/* Source-specific Result Register */
		unsigned int                : 4;
		unsigned int XTSEL          : 4;	/* External Trigger Input Selection */
		/* const */ unsigned int XTLVL          : 1;	/* External Trigger Level */
		unsigned int XTMODE         : 2;	/* Trigger Operating Mode */
		unsigned int XTWC           : 1;	/* Write Control for Trigger Configuration */
		unsigned int GTSEL          : 4;	/* Gate Input Selection */
		/* const */ unsigned int GTLVL          : 1;	/* Gate Input Level */
		unsigned int                : 2;
		unsigned int GTWC           : 1;	/* Write Control for Gate Configuration */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} VADC_BRSCTRL_type;
#define VADC_BRSCTRL	(*( VADC_BRSCTRL_type *) 0xf0020200u)	/* Background Request Source Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ENGT           : 2;	/* Enable Gate */
		unsigned int ENTR           : 1;	/* Enable External Trigger */
		unsigned int ENSI           : 1;	/* Enable Source Interrupt */
		unsigned int SCAN           : 1;	/* Autoscan Enable */
		unsigned int LDM            : 1;	/* Autoscan Source Load Event Mode */
		unsigned int                : 1;
		/* const */ unsigned int REQGT          : 1;	/* Request Gate Level */
		unsigned int CLRPND         : 1;	/* Clear Pending Bits */
		unsigned int LDEV           : 1;	/* Generate Load Event */
		unsigned int                : 6;
		unsigned int RPTDIS         : 1;	/* Repeat Disable */
		unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} VADC_BRSMR_type;
#define VADC_BRSMR	(*( VADC_BRSMR_type *) 0xf0020204u)	/* Background Request Source Mode Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CHPNDGy        : 32;	/* Channels Pending Group x */
	} B;
	int I;
	unsigned int U;

} VADC_BRSPND0_type;
#define VADC_BRSPND0	(*( VADC_BRSPND0_type *) 0xf00201c0u)	/* Background Request Source Pending Register, Group 0 */
#define VADC_BRSPND1	(*( VADC_BRSPND0_type *) 0xf00201c4u)	/* Background Request Source Pending Register, Group 1 */
#define VADC_BRSPND2	(*( VADC_BRSPND0_type *) 0xf00201c8u)	/* Background Request Source Pending Register, Group 2 */
#define VADC_BRSPND3	(*( VADC_BRSPND0_type *) 0xf00201ccu)	/* Background Request Source Pending Register, Group 3 */
#define VADC_BRSPND4	(*( VADC_BRSPND0_type *) 0xf00201d0u)	/* Background Request Source Pending Register, Group 4 */
#define VADC_BRSPND5	(*( VADC_BRSPND0_type *) 0xf00201d4u)	/* Background Request Source Pending Register, Group 5 */
#define VADC_BRSPND6	(*( VADC_BRSPND0_type *) 0xf00201d8u)	/* Background Request Source Pending Register, Group 6 */
#define VADC_BRSPND7	(*( VADC_BRSPND0_type *) 0xf00201dcu)	/* Background Request Source Pending Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int CHSELGy        : 32;	/* Channel Selection Group x */
	} B;
	int I;
	unsigned int U;

} VADC_BRSSEL0_type;
#define VADC_BRSSEL0	(*( VADC_BRSSEL0_type *) 0xf0020180u)	/* Background Request Source Channel Select Register, Group 0 */
#define VADC_BRSSEL1	(*( VADC_BRSSEL0_type *) 0xf0020184u)	/* Background Request Source Channel Select Register, Group 1 */
#define VADC_BRSSEL2	(*( VADC_BRSSEL0_type *) 0xf0020188u)	/* Background Request Source Channel Select Register, Group 2 */
#define VADC_BRSSEL3	(*( VADC_BRSSEL0_type *) 0xf002018cu)	/* Background Request Source Channel Select Register, Group 3 */
#define VADC_BRSSEL4	(*( VADC_BRSSEL0_type *) 0xf0020190u)	/* Background Request Source Channel Select Register, Group 4 */
#define VADC_BRSSEL5	(*( VADC_BRSSEL0_type *) 0xf0020194u)	/* Background Request Source Channel Select Register, Group 5 */
#define VADC_BRSSEL6	(*( VADC_BRSSEL0_type *) 0xf0020198u)	/* Background Request Source Channel Select Register, Group 6 */
#define VADC_BRSSEL7	(*( VADC_BRSSEL0_type *) 0xf002019cu)	/* Background Request Source Channel Select Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} VADC_CLC_type;
#define VADC_CLC	(*( VADC_CLC_type *) 0xf0020000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int EMUXGRP0       : 4;	/* External Multiplexer Group for Interface x */
		unsigned int EMUXGRP1       : 4;	/* External Multiplexer Group for Interface x */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} VADC_EMUXSEL_type;
#define VADC_EMUXSEL	(*( VADC_EMUXSEL_type *) 0xf00203f0u)	/* External Multiplexer Select Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ALIAS0         : 5;	/* Alias Value for CH0 Conversion Requests */
		unsigned int                : 3;
		unsigned int ALIAS1         : 5;	/* Alias Value for CH1 Conversion Requests */
		unsigned int                : 19;
	} B;
	int I;
	unsigned int U;

} VADC_G0ALIAS_type;
#define VADC_G0ALIAS	(*( VADC_G0ALIAS_type *) 0xf00204b0u)	/* Alias Register, Group 0 */
#define VADC_G1ALIAS	(*( VADC_G0ALIAS_type *) 0xf00208b0u)	/* Alias Register, Group 1 */
#define VADC_G2ALIAS	(*( VADC_G0ALIAS_type *) 0xf0020cb0u)	/* Alias Register, Group 2 */
#define VADC_G3ALIAS	(*( VADC_G0ALIAS_type *) 0xf00210b0u)	/* Alias Register, Group 3 */
#define VADC_G4ALIAS	(*( VADC_G0ALIAS_type *) 0xf00214b0u)	/* Alias Register, Group 4 */
#define VADC_G5ALIAS	(*( VADC_G0ALIAS_type *) 0xf00218b0u)	/* Alias Register, Group 5 */
#define VADC_G6ALIAS	(*( VADC_G0ALIAS_type *) 0xf0021cb0u)	/* Alias Register, Group 6 */
#define VADC_G7ALIAS	(*( VADC_G0ALIAS_type *) 0xf00220b0u)	/* Alias Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int ANONC          : 2;	/* Analog Converter Control */
		unsigned int                : 2;
		unsigned int ARBRND         : 2;	/* Arbitration Round Length */
		unsigned int                : 1;
		unsigned int ARBM           : 1;	/* Arbitration Mode */
		unsigned int                : 8;
		/* const */ unsigned int ANONS          : 2;	/* Analog Converter Control Status */
		unsigned int                : 10;
		/* const */ unsigned int CAL            : 1;	/* Start-Up Calibration Active Indication */
		unsigned int                : 1;
		/* const */ unsigned int BUSY           : 1;	/* Converter Busy Flag */
		/* const */ unsigned int SAMPLE         : 1;	/* Sample Phase Flag */
	} B;
	int I;
	unsigned int U;

} VADC_G0ARBCFG_type;
#define VADC_G0ARBCFG	(*( VADC_G0ARBCFG_type *) 0xf0020480u)	/* Arbitration Configuration Register, Group 0 */
#define VADC_G1ARBCFG	(*( VADC_G0ARBCFG_type *) 0xf0020880u)	/* Arbitration Configuration Register, Group 1 */
#define VADC_G2ARBCFG	(*( VADC_G0ARBCFG_type *) 0xf0020c80u)	/* Arbitration Configuration Register, Group 2 */
#define VADC_G3ARBCFG	(*( VADC_G0ARBCFG_type *) 0xf0021080u)	/* Arbitration Configuration Register, Group 3 */
#define VADC_G4ARBCFG	(*( VADC_G0ARBCFG_type *) 0xf0021480u)	/* Arbitration Configuration Register, Group 4 */
#define VADC_G5ARBCFG	(*( VADC_G0ARBCFG_type *) 0xf0021880u)	/* Arbitration Configuration Register, Group 5 */
#define VADC_G6ARBCFG	(*( VADC_G0ARBCFG_type *) 0xf0021c80u)	/* Arbitration Configuration Register, Group 6 */
#define VADC_G7ARBCFG	(*( VADC_G0ARBCFG_type *) 0xf0022080u)	/* Arbitration Configuration Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int PRIO0          : 2;	/* Priority of Request Source x */
		unsigned int                : 1;
		unsigned int CSM0           : 1;	/* Conversion Start Mode of Request Source x */
		unsigned int PRIO1          : 2;	/* Priority of Request Source x */
		unsigned int                : 1;
		unsigned int CSM1           : 1;	/* Conversion Start Mode of Request Source x */
		unsigned int PRIO2          : 2;	/* Priority of Request Source x */
		unsigned int                : 1;
		unsigned int CSM2           : 1;	/* Conversion Start Mode of Request Source x */
		unsigned int                : 12;
		unsigned int ASEN0          : 1;	/* Arbitration Slot y Enable */
		unsigned int ASEN1          : 1;	/* Arbitration Slot y Enable */
		unsigned int ASEN2          : 1;	/* Arbitration Slot y Enable */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} VADC_G0ARBPR_type;
#define VADC_G0ARBPR	(*( VADC_G0ARBPR_type *) 0xf0020484u)	/* Arbitration Priority Register, Group 0 */
#define VADC_G1ARBPR	(*( VADC_G0ARBPR_type *) 0xf0020884u)	/* Arbitration Priority Register, Group 1 */
#define VADC_G2ARBPR	(*( VADC_G0ARBPR_type *) 0xf0020c84u)	/* Arbitration Priority Register, Group 2 */
#define VADC_G3ARBPR	(*( VADC_G0ARBPR_type *) 0xf0021084u)	/* Arbitration Priority Register, Group 3 */
#define VADC_G4ARBPR	(*( VADC_G0ARBPR_type *) 0xf0021484u)	/* Arbitration Priority Register, Group 4 */
#define VADC_G5ARBPR	(*( VADC_G0ARBPR_type *) 0xf0021884u)	/* Arbitration Priority Register, Group 5 */
#define VADC_G6ARBPR	(*( VADC_G0ARBPR_type *) 0xf0021c84u)	/* Arbitration Priority Register, Group 6 */
#define VADC_G7ARBPR	(*( VADC_G0ARBPR_type *) 0xf0022084u)	/* Arbitration Priority Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int SRCRESREG      : 4;	/* Source-specific Result Register */
		unsigned int                : 4;
		unsigned int XTSEL          : 4;	/* External Trigger Input Selection */
		/* const */ unsigned int XTLVL          : 1;	/* External Trigger Level */
		unsigned int XTMODE         : 2;	/* Trigger Operating Mode */
		unsigned int XTWC           : 1;	/* Write Control for Trigger Configuration */
		unsigned int GTSEL          : 4;	/* Gate Input Selection */
		/* const */ unsigned int GTLVL          : 1;	/* Gate Input Level */
		unsigned int                : 2;
		unsigned int GTWC           : 1;	/* Write Control for Gate Configuration */
		unsigned int                : 4;
		unsigned int TMEN           : 1;	/* Timer Mode Enable */
		unsigned int                : 2;
		unsigned int TMWC           : 1;	/* Write Control for Timer Mode */
	} B;
	int I;
	unsigned int U;

} VADC_G0ASCTRL_type;
#define VADC_G0ASCTRL	(*( VADC_G0ASCTRL_type *) 0xf0020520u)	/* Autoscan Source Control Register, Group 0 */
#define VADC_G0QCTRL0	(*( VADC_G0ASCTRL_type *) 0xf0020500u)	/* Queue 0 Source Control Register, Group 0 */
#define VADC_G1ASCTRL	(*( VADC_G0ASCTRL_type *) 0xf0020920u)	/* Autoscan Source Control Register, Group 1 */
#define VADC_G1QCTRL0	(*( VADC_G0ASCTRL_type *) 0xf0020900u)	/* Queue 0 Source Control Register, Group 1 */
#define VADC_G2ASCTRL	(*( VADC_G0ASCTRL_type *) 0xf0020d20u)	/* Autoscan Source Control Register, Group 2 */
#define VADC_G2QCTRL0	(*( VADC_G0ASCTRL_type *) 0xf0020d00u)	/* Queue 0 Source Control Register, Group 2 */
#define VADC_G3ASCTRL	(*( VADC_G0ASCTRL_type *) 0xf0021120u)	/* Autoscan Source Control Register, Group 3 */
#define VADC_G3QCTRL0	(*( VADC_G0ASCTRL_type *) 0xf0021100u)	/* Queue 0 Source Control Register, Group 3 */
#define VADC_G4ASCTRL	(*( VADC_G0ASCTRL_type *) 0xf0021520u)	/* Autoscan Source Control Register, Group 4 */
#define VADC_G4QCTRL0	(*( VADC_G0ASCTRL_type *) 0xf0021500u)	/* Queue 0 Source Control Register, Group 4 */
#define VADC_G5ASCTRL	(*( VADC_G0ASCTRL_type *) 0xf0021920u)	/* Autoscan Source Control Register, Group 5 */
#define VADC_G5QCTRL0	(*( VADC_G0ASCTRL_type *) 0xf0021900u)	/* Queue 0 Source Control Register, Group 5 */
#define VADC_G6ASCTRL	(*( VADC_G0ASCTRL_type *) 0xf0021d20u)	/* Autoscan Source Control Register, Group 6 */
#define VADC_G6QCTRL0	(*( VADC_G0ASCTRL_type *) 0xf0021d00u)	/* Queue 0 Source Control Register, Group 6 */
#define VADC_G7ASCTRL	(*( VADC_G0ASCTRL_type *) 0xf0022120u)	/* Autoscan Source Control Register, Group 7 */
#define VADC_G7QCTRL0	(*( VADC_G0ASCTRL_type *) 0xf0022100u)	/* Queue 0 Source Control Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int ENGT           : 2;	/* Enable Gate */
		unsigned int ENTR           : 1;	/* Enable External Trigger */
		unsigned int ENSI           : 1;	/* Enable Source Interrupt */
		unsigned int SCAN           : 1;	/* Autoscan Enable */
		unsigned int LDM            : 1;	/* Autoscan Source Load Event Mode */
		unsigned int                : 1;
		/* const */ unsigned int REQGT          : 1;	/* Request Gate Level */
		unsigned int CLRPND         : 1;	/* Clear Pending Bits */
		unsigned int LDEV           : 1;	/* Generate Load Event */
		unsigned int                : 6;
		unsigned int RPTDIS         : 1;	/* Repeat Disable */
		unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} VADC_G0ASMR_type;
#define VADC_G0ASMR	(*( VADC_G0ASMR_type *) 0xf0020524u)	/* Autoscan Source Mode Register, Group 0 */
#define VADC_G1ASMR	(*( VADC_G0ASMR_type *) 0xf0020924u)	/* Autoscan Source Mode Register, Group 1 */
#define VADC_G2ASMR	(*( VADC_G0ASMR_type *) 0xf0020d24u)	/* Autoscan Source Mode Register, Group 2 */
#define VADC_G3ASMR	(*( VADC_G0ASMR_type *) 0xf0021124u)	/* Autoscan Source Mode Register, Group 3 */
#define VADC_G4ASMR	(*( VADC_G0ASMR_type *) 0xf0021524u)	/* Autoscan Source Mode Register, Group 4 */
#define VADC_G5ASMR	(*( VADC_G0ASMR_type *) 0xf0021924u)	/* Autoscan Source Mode Register, Group 5 */
#define VADC_G6ASMR	(*( VADC_G0ASMR_type *) 0xf0021d24u)	/* Autoscan Source Mode Register, Group 6 */
#define VADC_G7ASMR	(*( VADC_G0ASMR_type *) 0xf0022124u)	/* Autoscan Source Mode Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int CHPND          : 32;	/* Channels Pending */
	} B;
	int I;
	unsigned int U;

} VADC_G0ASPND_type;
#define VADC_G0ASPND	(*( VADC_G0ASPND_type *) 0xf002052cu)	/* Autoscan Source Pending Register, Group 0 */
#define VADC_G1ASPND	(*( VADC_G0ASPND_type *) 0xf002092cu)	/* Autoscan Source Pending Register, Group 1 */
#define VADC_G2ASPND	(*( VADC_G0ASPND_type *) 0xf0020d2cu)	/* Autoscan Source Pending Register, Group 2 */
#define VADC_G3ASPND	(*( VADC_G0ASPND_type *) 0xf002112cu)	/* Autoscan Source Pending Register, Group 3 */
#define VADC_G4ASPND	(*( VADC_G0ASPND_type *) 0xf002152cu)	/* Autoscan Source Pending Register, Group 4 */
#define VADC_G5ASPND	(*( VADC_G0ASPND_type *) 0xf002192cu)	/* Autoscan Source Pending Register, Group 5 */
#define VADC_G6ASPND	(*( VADC_G0ASPND_type *) 0xf0021d2cu)	/* Autoscan Source Pending Register, Group 6 */
#define VADC_G7ASPND	(*( VADC_G0ASPND_type *) 0xf002212cu)	/* Autoscan Source Pending Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int CHSEL          : 32;	/* Channel Selection */
	} B;
	int I;
	unsigned int U;

} VADC_G0ASSEL_type;
#define VADC_G0ASSEL	(*( VADC_G0ASSEL_type *) 0xf0020528u)	/* Autoscan Source Channel Select Register, Group 0 */
#define VADC_G1ASSEL	(*( VADC_G0ASSEL_type *) 0xf0020928u)	/* Autoscan Source Channel Select Register, Group 1 */
#define VADC_G2ASSEL	(*( VADC_G0ASSEL_type *) 0xf0020d28u)	/* Autoscan Source Channel Select Register, Group 2 */
#define VADC_G3ASSEL	(*( VADC_G0ASSEL_type *) 0xf0021128u)	/* Autoscan Source Channel Select Register, Group 3 */
#define VADC_G4ASSEL	(*( VADC_G0ASSEL_type *) 0xf0021528u)	/* Autoscan Source Channel Select Register, Group 4 */
#define VADC_G5ASSEL	(*( VADC_G0ASSEL_type *) 0xf0021928u)	/* Autoscan Source Channel Select Register, Group 5 */
#define VADC_G6ASSEL	(*( VADC_G0ASSEL_type *) 0xf0021d28u)	/* Autoscan Source Channel Select Register, Group 6 */
#define VADC_G7ASSEL	(*( VADC_G0ASSEL_type *) 0xf0022128u)	/* Autoscan Source Channel Select Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int BFL0           : 1;	/* Boundary Flag y */
		/* const */ unsigned int BFL1           : 1;	/* Boundary Flag y */
		/* const */ unsigned int BFL2           : 1;	/* Boundary Flag y */
		/* const */ unsigned int BFL3           : 1;	/* Boundary Flag y */
		unsigned int                : 4;
		unsigned int BFA0           : 1;	/* Boundary Flag y Activation Select */
		unsigned int BFA1           : 1;	/* Boundary Flag y Activation Select */
		unsigned int BFA2           : 1;	/* Boundary Flag y Activation Select */
		unsigned int BFA3           : 1;	/* Boundary Flag y Activation Select */
		unsigned int                : 4;
		unsigned int BFI0           : 1;	/* Boundary Flag y Inversion Control */
		unsigned int BFI1           : 1;	/* Boundary Flag y Inversion Control */
		unsigned int BFI2           : 1;	/* Boundary Flag y Inversion Control */
		unsigned int BFI3           : 1;	/* Boundary Flag y Inversion Control */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} VADC_G0BFL_type;
#define VADC_G0BFL	(*( VADC_G0BFL_type *) 0xf00204c8u)	/* Boundary Flag Register, Group 0 */
#define VADC_G1BFL	(*( VADC_G0BFL_type *) 0xf00208c8u)	/* Boundary Flag Register, Group 1 */
#define VADC_G2BFL	(*( VADC_G0BFL_type *) 0xf0020cc8u)	/* Boundary Flag Register, Group 2 */
#define VADC_G3BFL	(*( VADC_G0BFL_type *) 0xf00210c8u)	/* Boundary Flag Register, Group 3 */
#define VADC_G4BFL	(*( VADC_G0BFL_type *) 0xf00214c8u)	/* Boundary Flag Register, Group 4 */
#define VADC_G5BFL	(*( VADC_G0BFL_type *) 0xf00218c8u)	/* Boundary Flag Register, Group 5 */
#define VADC_G6BFL	(*( VADC_G0BFL_type *) 0xf0021cc8u)	/* Boundary Flag Register, Group 6 */
#define VADC_G7BFL	(*( VADC_G0BFL_type *) 0xf00220c8u)	/* Boundary Flag Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int BFM0           : 4;	/* Boundary Flag y Mode Control */
		unsigned int BFM1           : 4;	/* Boundary Flag y Mode Control */
		unsigned int BFM2           : 4;	/* Boundary Flag y Mode Control */
		unsigned int BFM3           : 4;	/* Boundary Flag y Mode Control */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} VADC_G0BFLC_type;
#define VADC_G0BFLC	(*( VADC_G0BFLC_type *) 0xf00204d0u)	/* Boundary Flag Control Register, Group 0 */
#define VADC_G1BFLC	(*( VADC_G0BFLC_type *) 0xf00208d0u)	/* Boundary Flag Control Register, Group 1 */
#define VADC_G2BFLC	(*( VADC_G0BFLC_type *) 0xf0020cd0u)	/* Boundary Flag Control Register, Group 2 */
#define VADC_G3BFLC	(*( VADC_G0BFLC_type *) 0xf00210d0u)	/* Boundary Flag Control Register, Group 3 */
#define VADC_G4BFLC	(*( VADC_G0BFLC_type *) 0xf00214d0u)	/* Boundary Flag Control Register, Group 4 */
#define VADC_G5BFLC	(*( VADC_G0BFLC_type *) 0xf00218d0u)	/* Boundary Flag Control Register, Group 5 */
#define VADC_G6BFLC	(*( VADC_G0BFLC_type *) 0xf0021cd0u)	/* Boundary Flag Control Register, Group 6 */
#define VADC_G7BFLC	(*( VADC_G0BFLC_type *) 0xf00220d0u)	/* Boundary Flag Control Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int BFC0           : 1;	/* Boundary Flag y Clear */
		unsigned int BFC1           : 1;	/* Boundary Flag y Clear */
		unsigned int BFC2           : 1;	/* Boundary Flag y Clear */
		unsigned int BFC3           : 1;	/* Boundary Flag y Clear */
		unsigned int                : 12;
		unsigned int BFS0           : 1;	/* Boundary Flag y Set */
		unsigned int BFS1           : 1;	/* Boundary Flag y Set */
		unsigned int BFS2           : 1;	/* Boundary Flag y Set */
		unsigned int BFS3           : 1;	/* Boundary Flag y Set */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} VADC_G0BFLS_type;
#define VADC_G0BFLS	(*( VADC_G0BFLS_type *) 0xf00204ccu)	/* Boundary Flag Software Register, Group 0 */
#define VADC_G1BFLS	(*( VADC_G0BFLS_type *) 0xf00208ccu)	/* Boundary Flag Software Register, Group 1 */
#define VADC_G2BFLS	(*( VADC_G0BFLS_type *) 0xf0020cccu)	/* Boundary Flag Software Register, Group 2 */
#define VADC_G3BFLS	(*( VADC_G0BFLS_type *) 0xf00210ccu)	/* Boundary Flag Software Register, Group 3 */
#define VADC_G4BFLS	(*( VADC_G0BFLS_type *) 0xf00214ccu)	/* Boundary Flag Software Register, Group 4 */
#define VADC_G5BFLS	(*( VADC_G0BFLS_type *) 0xf00218ccu)	/* Boundary Flag Software Register, Group 5 */
#define VADC_G6BFLS	(*( VADC_G0BFLS_type *) 0xf0021cccu)	/* Boundary Flag Software Register, Group 6 */
#define VADC_G7BFLS	(*( VADC_G0BFLS_type *) 0xf00220ccu)	/* Boundary Flag Software Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int BOUNDARY0      : 12;	/* Boundary Value 0 for Limit Checking */
		unsigned int                : 4;
		unsigned int BOUNDARY1      : 12;	/* Boundary Value 1 for Limit Checking */
		unsigned int                : 4;
	} B;
	int I;
	unsigned int U;

} VADC_G0BOUND_type;
#define VADC_G0BOUND	(*( VADC_G0BOUND_type *) 0xf00204b8u)	/* Boundary Select Register, Group 0 */
#define VADC_G1BOUND	(*( VADC_G0BOUND_type *) 0xf00208b8u)	/* Boundary Select Register, Group 1 */
#define VADC_G2BOUND	(*( VADC_G0BOUND_type *) 0xf0020cb8u)	/* Boundary Select Register, Group 2 */
#define VADC_G3BOUND	(*( VADC_G0BOUND_type *) 0xf00210b8u)	/* Boundary Select Register, Group 3 */
#define VADC_G4BOUND	(*( VADC_G0BOUND_type *) 0xf00214b8u)	/* Boundary Select Register, Group 4 */
#define VADC_G5BOUND	(*( VADC_G0BOUND_type *) 0xf00218b8u)	/* Boundary Select Register, Group 5 */
#define VADC_G6BOUND	(*( VADC_G0BOUND_type *) 0xf0021cb8u)	/* Boundary Select Register, Group 6 */
#define VADC_G7BOUND	(*( VADC_G0BOUND_type *) 0xf00220b8u)	/* Boundary Select Register, Group 7 */
#define VADC_GLOBBOUND	(*( VADC_G0BOUND_type *) 0xf00200b8u)	/* Global Boundary Select Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CEV0           : 1;	/* Clear Channel Event for Channel y */
		unsigned int CEV1           : 1;	/* Clear Channel Event for Channel y */
		unsigned int CEV2           : 1;	/* Clear Channel Event for Channel y */
		unsigned int CEV3           : 1;	/* Clear Channel Event for Channel y */
		unsigned int CEV4           : 1;	/* Clear Channel Event for Channel y */
		unsigned int CEV5           : 1;	/* Clear Channel Event for Channel y */
		unsigned int CEV6           : 1;	/* Clear Channel Event for Channel y */
		unsigned int CEV7           : 1;	/* Clear Channel Event for Channel y */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} VADC_G0CEFCLR_type;
#define VADC_G0CEFCLR	(*( VADC_G0CEFCLR_type *) 0xf0020590u)	/* Channel Event Flag Clear Register, Group 0 */
#define VADC_G1CEFCLR	(*( VADC_G0CEFCLR_type *) 0xf0020990u)	/* Channel Event Flag Clear Register, Group 1 */
#define VADC_G2CEFCLR	(*( VADC_G0CEFCLR_type *) 0xf0020d90u)	/* Channel Event Flag Clear Register, Group 2 */
#define VADC_G3CEFCLR	(*( VADC_G0CEFCLR_type *) 0xf0021190u)	/* Channel Event Flag Clear Register, Group 3 */
#define VADC_G4CEFCLR	(*( VADC_G0CEFCLR_type *) 0xf0021590u)	/* Channel Event Flag Clear Register, Group 4 */
#define VADC_G5CEFCLR	(*( VADC_G0CEFCLR_type *) 0xf0021990u)	/* Channel Event Flag Clear Register, Group 5 */
#define VADC_G6CEFCLR	(*( VADC_G0CEFCLR_type *) 0xf0021d90u)	/* Channel Event Flag Clear Register, Group 6 */
#define VADC_G7CEFCLR	(*( VADC_G0CEFCLR_type *) 0xf0022190u)	/* Channel Event Flag Clear Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int CEV0           : 1;	/* Channel Event for Channel y */
		unsigned int CEV1           : 1;	/* Channel Event for Channel y */
		unsigned int CEV2           : 1;	/* Channel Event for Channel y */
		unsigned int CEV3           : 1;	/* Channel Event for Channel y */
		unsigned int CEV4           : 1;	/* Channel Event for Channel y */
		unsigned int CEV5           : 1;	/* Channel Event for Channel y */
		unsigned int CEV6           : 1;	/* Channel Event for Channel y */
		unsigned int CEV7           : 1;	/* Channel Event for Channel y */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} VADC_G0CEFLAG_type;
#define VADC_G0CEFLAG	(*( VADC_G0CEFLAG_type *) 0xf0020580u)	/* Channel Event Flag Register, Group 0 */
#define VADC_G1CEFLAG	(*( VADC_G0CEFLAG_type *) 0xf0020980u)	/* Channel Event Flag Register, Group 1 */
#define VADC_G2CEFLAG	(*( VADC_G0CEFLAG_type *) 0xf0020d80u)	/* Channel Event Flag Register, Group 2 */
#define VADC_G3CEFLAG	(*( VADC_G0CEFLAG_type *) 0xf0021180u)	/* Channel Event Flag Register, Group 3 */
#define VADC_G4CEFLAG	(*( VADC_G0CEFLAG_type *) 0xf0021580u)	/* Channel Event Flag Register, Group 4 */
#define VADC_G5CEFLAG	(*( VADC_G0CEFLAG_type *) 0xf0021980u)	/* Channel Event Flag Register, Group 5 */
#define VADC_G6CEFLAG	(*( VADC_G0CEFLAG_type *) 0xf0021d80u)	/* Channel Event Flag Register, Group 6 */
#define VADC_G7CEFLAG	(*( VADC_G0CEFLAG_type *) 0xf0022180u)	/* Channel Event Flag Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int CEV0NP         : 4;	/* Service Request Node Pointer Channel Event i */
		unsigned int CEV1NP         : 4;	/* Service Request Node Pointer Channel Event i */
		unsigned int CEV2NP         : 4;	/* Service Request Node Pointer Channel Event i */
		unsigned int CEV3NP         : 4;	/* Service Request Node Pointer Channel Event i */
		unsigned int CEV4NP         : 4;	/* Service Request Node Pointer Channel Event i */
		unsigned int CEV5NP         : 4;	/* Service Request Node Pointer Channel Event i */
		unsigned int CEV6NP         : 4;	/* Service Request Node Pointer Channel Event i */
		unsigned int CEV7NP         : 4;	/* Service Request Node Pointer Channel Event i */
	} B;
	int I;
	unsigned int U;

} VADC_G0CEVNP0_type;
#define VADC_G0CEVNP0	(*( VADC_G0CEVNP0_type *) 0xf00205a0u)	/* Channel Event Node Pointer Register 0, Group 0 */
#define VADC_G1CEVNP0	(*( VADC_G0CEVNP0_type *) 0xf00209a0u)	/* Channel Event Node Pointer Register 0, Group 1 */
#define VADC_G2CEVNP0	(*( VADC_G0CEVNP0_type *) 0xf0020da0u)	/* Channel Event Node Pointer Register 0, Group 2 */
#define VADC_G3CEVNP0	(*( VADC_G0CEVNP0_type *) 0xf00211a0u)	/* Channel Event Node Pointer Register 0, Group 3 */
#define VADC_G4CEVNP0	(*( VADC_G0CEVNP0_type *) 0xf00215a0u)	/* Channel Event Node Pointer Register 0, Group 4 */
#define VADC_G5CEVNP0	(*( VADC_G0CEVNP0_type *) 0xf00219a0u)	/* Channel Event Node Pointer Register 0, Group 5 */
#define VADC_G6CEVNP0	(*( VADC_G0CEVNP0_type *) 0xf0021da0u)	/* Channel Event Node Pointer Register 0, Group 6 */
#define VADC_G7CEVNP0	(*( VADC_G0CEVNP0_type *) 0xf00221a0u)	/* Channel Event Node Pointer Register 0, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int ASSCH0         : 1;	/* Assignment for Channel y */
		unsigned int ASSCH1         : 1;	/* Assignment for Channel y */
		unsigned int ASSCH2         : 1;	/* Assignment for Channel y */
		unsigned int ASSCH3         : 1;	/* Assignment for Channel y */
		unsigned int ASSCH4         : 1;	/* Assignment for Channel y */
		unsigned int ASSCH5         : 1;	/* Assignment for Channel y */
		unsigned int ASSCH6         : 1;	/* Assignment for Channel y */
		unsigned int ASSCH7         : 1;	/* Assignment for Channel y */
		unsigned int ASSCH8         : 1;	/* Assignment for Channel y */
		unsigned int ASSCH9         : 1;	/* Assignment for Channel y */
		unsigned int ASSCH10        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH11        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH12        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH13        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH14        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH15        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH16        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH17        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH18        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH19        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH20        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH21        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH22        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH23        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH24        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH25        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH26        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH27        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH28        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH29        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH30        : 1;	/* Assignment for Channel y */
		unsigned int ASSCH31        : 1;	/* Assignment for Channel y */
	} B;
	int I;
	unsigned int U;

} VADC_G0CHASS_type;
#define VADC_G0CHASS	(*( VADC_G0CHASS_type *) 0xf0020488u)	/* Channel Assignment Register, Group 0 */
#define VADC_G1CHASS	(*( VADC_G0CHASS_type *) 0xf0020888u)	/* Channel Assignment Register, Group 1 */
#define VADC_G2CHASS	(*( VADC_G0CHASS_type *) 0xf0020c88u)	/* Channel Assignment Register, Group 2 */
#define VADC_G3CHASS	(*( VADC_G0CHASS_type *) 0xf0021088u)	/* Channel Assignment Register, Group 3 */
#define VADC_G4CHASS	(*( VADC_G0CHASS_type *) 0xf0021488u)	/* Channel Assignment Register, Group 4 */
#define VADC_G5CHASS	(*( VADC_G0CHASS_type *) 0xf0021888u)	/* Channel Assignment Register, Group 5 */
#define VADC_G6CHASS	(*( VADC_G0CHASS_type *) 0xf0021c88u)	/* Channel Assignment Register, Group 6 */
#define VADC_G7CHASS	(*( VADC_G0CHASS_type *) 0xf0022088u)	/* Channel Assignment Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int ICLSEL         : 2;	/* Input Class Select */
		unsigned int                : 2;
		unsigned int BNDSELL        : 2;	/* Lower Boundary SelectWhile BNDSELX ? 0000, bitfields BNDSELU and BNDSELL are concatenated and select the corresponding result register as lower boundary. */
		unsigned int BNDSELU        : 2;	/* Upper Boundary Select */
		unsigned int CHEVMODE       : 2;	/* Channel Event Mode */
		unsigned int SYNC           : 1;	/* Synchronization Request */
		unsigned int REFSEL         : 1;	/* Reference Input Selection */
		unsigned int BNDSELX        : 4;	/* BoundaryExtension */
		unsigned int RESREG         : 4;	/* Result Register */
		unsigned int RESTBS         : 1;	/* Result Target for Background Source */
		unsigned int RESPOS         : 1;	/* Result Position */
		unsigned int                : 6;
		unsigned int BWDCH          : 2;	/* Broken Wire Detection Channel */
		unsigned int BWDEN          : 1;	/* Broken Wire Detection Enable */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} VADC_G0CHCTR0_type;
#define VADC_G0CHCTR0	(*( VADC_G0CHCTR0_type *) 0xf0020600u)	/* Group 0, Channel 0 Ctrl. Reg. */
#define VADC_G0CHCTR1	(*( VADC_G0CHCTR0_type *) 0xf0020604u)	/* Group 0, Channel 1 Ctrl. Reg. */
#define VADC_G0CHCTR2	(*( VADC_G0CHCTR0_type *) 0xf0020608u)	/* Group 0, Channel 2 Ctrl. Reg. */
#define VADC_G0CHCTR3	(*( VADC_G0CHCTR0_type *) 0xf002060cu)	/* Group 0, Channel 3 Ctrl. Reg. */
#define VADC_G0CHCTR4	(*( VADC_G0CHCTR0_type *) 0xf0020610u)	/* Group 0, Channel 4 Ctrl. Reg. */
#define VADC_G0CHCTR5	(*( VADC_G0CHCTR0_type *) 0xf0020614u)	/* Group 0, Channel 5 Ctrl. Reg. */
#define VADC_G0CHCTR6	(*( VADC_G0CHCTR0_type *) 0xf0020618u)	/* Group 0, Channel 6 Ctrl. Reg. */
#define VADC_G0CHCTR7	(*( VADC_G0CHCTR0_type *) 0xf002061cu)	/* Group 0, Channel 7 Ctrl. Reg. */
#define VADC_G1CHCTR0	(*( VADC_G0CHCTR0_type *) 0xf0020a00u)	/* Group 1, Channel 0 Ctrl. Reg. */
#define VADC_G1CHCTR1	(*( VADC_G0CHCTR0_type *) 0xf0020a04u)	/* Group 1, Channel 1 Ctrl. Reg. */
#define VADC_G1CHCTR2	(*( VADC_G0CHCTR0_type *) 0xf0020a08u)	/* Group 1, Channel 2 Ctrl. Reg. */
#define VADC_G1CHCTR3	(*( VADC_G0CHCTR0_type *) 0xf0020a0cu)	/* Group 1, Channel 3 Ctrl. Reg. */
#define VADC_G1CHCTR4	(*( VADC_G0CHCTR0_type *) 0xf0020a10u)	/* Group 1, Channel 4 Ctrl. Reg. */
#define VADC_G1CHCTR5	(*( VADC_G0CHCTR0_type *) 0xf0020a14u)	/* Group 1, Channel 5 Ctrl. Reg. */
#define VADC_G1CHCTR6	(*( VADC_G0CHCTR0_type *) 0xf0020a18u)	/* Group 1, Channel 6 Ctrl. Reg. */
#define VADC_G1CHCTR7	(*( VADC_G0CHCTR0_type *) 0xf0020a1cu)	/* Group 1, Channel 7 Ctrl. Reg. */
#define VADC_G2CHCTR0	(*( VADC_G0CHCTR0_type *) 0xf0020e00u)	/* Group 2, Channel 0 Ctrl. Reg. */
#define VADC_G2CHCTR1	(*( VADC_G0CHCTR0_type *) 0xf0020e04u)	/* Group 2, Channel 1 Ctrl. Reg. */
#define VADC_G2CHCTR2	(*( VADC_G0CHCTR0_type *) 0xf0020e08u)	/* Group 2, Channel 2 Ctrl. Reg. */
#define VADC_G2CHCTR3	(*( VADC_G0CHCTR0_type *) 0xf0020e0cu)	/* Group 2, Channel 3 Ctrl. Reg. */
#define VADC_G2CHCTR4	(*( VADC_G0CHCTR0_type *) 0xf0020e10u)	/* Group 2, Channel 4 Ctrl. Reg. */
#define VADC_G2CHCTR5	(*( VADC_G0CHCTR0_type *) 0xf0020e14u)	/* Group 2, Channel 5 Ctrl. Reg. */
#define VADC_G2CHCTR6	(*( VADC_G0CHCTR0_type *) 0xf0020e18u)	/* Group 2, Channel 6 Ctrl. Reg. */
#define VADC_G2CHCTR7	(*( VADC_G0CHCTR0_type *) 0xf0020e1cu)	/* Group 2, Channel 7 Ctrl. Reg. */
#define VADC_G3CHCTR0	(*( VADC_G0CHCTR0_type *) 0xf0021200u)	/* Group 3, Channel 0 Ctrl. Reg. */
#define VADC_G3CHCTR1	(*( VADC_G0CHCTR0_type *) 0xf0021204u)	/* Group 3, Channel 1 Ctrl. Reg. */
#define VADC_G3CHCTR2	(*( VADC_G0CHCTR0_type *) 0xf0021208u)	/* Group 3, Channel 2 Ctrl. Reg. */
#define VADC_G3CHCTR3	(*( VADC_G0CHCTR0_type *) 0xf002120cu)	/* Group 3, Channel 3 Ctrl. Reg. */
#define VADC_G3CHCTR4	(*( VADC_G0CHCTR0_type *) 0xf0021210u)	/* Group 3, Channel 4 Ctrl. Reg. */
#define VADC_G3CHCTR5	(*( VADC_G0CHCTR0_type *) 0xf0021214u)	/* Group 3, Channel 5 Ctrl. Reg. */
#define VADC_G3CHCTR6	(*( VADC_G0CHCTR0_type *) 0xf0021218u)	/* Group 3, Channel 6 Ctrl. Reg. */
#define VADC_G3CHCTR7	(*( VADC_G0CHCTR0_type *) 0xf002121cu)	/* Group 3, Channel 7 Ctrl. Reg. */
#define VADC_G4CHCTR0	(*( VADC_G0CHCTR0_type *) 0xf0021600u)	/* Group 4, Channel 0 Ctrl. Reg. */
#define VADC_G4CHCTR1	(*( VADC_G0CHCTR0_type *) 0xf0021604u)	/* Group 4, Channel 1 Ctrl. Reg. */
#define VADC_G4CHCTR2	(*( VADC_G0CHCTR0_type *) 0xf0021608u)	/* Group 4, Channel 2 Ctrl. Reg. */
#define VADC_G4CHCTR3	(*( VADC_G0CHCTR0_type *) 0xf002160cu)	/* Group 4, Channel 3 Ctrl. Reg. */
#define VADC_G4CHCTR4	(*( VADC_G0CHCTR0_type *) 0xf0021610u)	/* Group 4, Channel 4 Ctrl. Reg. */
#define VADC_G4CHCTR5	(*( VADC_G0CHCTR0_type *) 0xf0021614u)	/* Group 4, Channel 5 Ctrl. Reg. */
#define VADC_G4CHCTR6	(*( VADC_G0CHCTR0_type *) 0xf0021618u)	/* Group 4, Channel 6 Ctrl. Reg. */
#define VADC_G4CHCTR7	(*( VADC_G0CHCTR0_type *) 0xf002161cu)	/* Group 4, Channel 7 Ctrl. Reg. */
#define VADC_G5CHCTR0	(*( VADC_G0CHCTR0_type *) 0xf0021a00u)	/* Group 5, Channel 0 Ctrl. Reg. */
#define VADC_G5CHCTR1	(*( VADC_G0CHCTR0_type *) 0xf0021a04u)	/* Group 5, Channel 1 Ctrl. Reg. */
#define VADC_G5CHCTR2	(*( VADC_G0CHCTR0_type *) 0xf0021a08u)	/* Group 5, Channel 2 Ctrl. Reg. */
#define VADC_G5CHCTR3	(*( VADC_G0CHCTR0_type *) 0xf0021a0cu)	/* Group 5, Channel 3 Ctrl. Reg. */
#define VADC_G5CHCTR4	(*( VADC_G0CHCTR0_type *) 0xf0021a10u)	/* Group 5, Channel 4 Ctrl. Reg. */
#define VADC_G5CHCTR5	(*( VADC_G0CHCTR0_type *) 0xf0021a14u)	/* Group 5, Channel 5 Ctrl. Reg. */
#define VADC_G5CHCTR6	(*( VADC_G0CHCTR0_type *) 0xf0021a18u)	/* Group 5, Channel 6 Ctrl. Reg. */
#define VADC_G5CHCTR7	(*( VADC_G0CHCTR0_type *) 0xf0021a1cu)	/* Group 5, Channel 7 Ctrl. Reg. */
#define VADC_G6CHCTR0	(*( VADC_G0CHCTR0_type *) 0xf0021e00u)	/* Group 6, Channel 0 Ctrl. Reg. */
#define VADC_G6CHCTR1	(*( VADC_G0CHCTR0_type *) 0xf0021e04u)	/* Group 6, Channel 1 Ctrl. Reg. */
#define VADC_G6CHCTR2	(*( VADC_G0CHCTR0_type *) 0xf0021e08u)	/* Group 6, Channel 2 Ctrl. Reg. */
#define VADC_G6CHCTR3	(*( VADC_G0CHCTR0_type *) 0xf0021e0cu)	/* Group 6, Channel 3 Ctrl. Reg. */
#define VADC_G6CHCTR4	(*( VADC_G0CHCTR0_type *) 0xf0021e10u)	/* Group 6, Channel 4 Ctrl. Reg. */
#define VADC_G6CHCTR5	(*( VADC_G0CHCTR0_type *) 0xf0021e14u)	/* Group 6, Channel 5 Ctrl. Reg. */
#define VADC_G6CHCTR6	(*( VADC_G0CHCTR0_type *) 0xf0021e18u)	/* Group 6, Channel 6 Ctrl. Reg. */
#define VADC_G6CHCTR7	(*( VADC_G0CHCTR0_type *) 0xf0021e1cu)	/* Group 6, Channel 7 Ctrl. Reg. */
#define VADC_G7CHCTR0	(*( VADC_G0CHCTR0_type *) 0xf0022200u)	/* Group 7, Channel 0 Ctrl. Reg. */
#define VADC_G7CHCTR1	(*( VADC_G0CHCTR0_type *) 0xf0022204u)	/* Group 7, Channel 1 Ctrl. Reg. */
#define VADC_G7CHCTR2	(*( VADC_G0CHCTR0_type *) 0xf0022208u)	/* Group 7, Channel 2 Ctrl. Reg. */
#define VADC_G7CHCTR3	(*( VADC_G0CHCTR0_type *) 0xf002220cu)	/* Group 7, Channel 3 Ctrl. Reg. */
#define VADC_G7CHCTR4	(*( VADC_G0CHCTR0_type *) 0xf0022210u)	/* Group 7, Channel 4 Ctrl. Reg. */
#define VADC_G7CHCTR5	(*( VADC_G0CHCTR0_type *) 0xf0022214u)	/* Group 7, Channel 5 Ctrl. Reg. */
#define VADC_G7CHCTR6	(*( VADC_G0CHCTR0_type *) 0xf0022218u)	/* Group 7, Channel 6 Ctrl. Reg. */
#define VADC_G7CHCTR7	(*( VADC_G0CHCTR0_type *) 0xf002221cu)	/* Group 7, Channel 7 Ctrl. Reg. */

typedef volatile union
{
	struct
	{ 
		unsigned int EMUXSET        : 3;	/* External Multiplexer Start SelectionFor single-step mode and sequence mode: Select the start value before selecting the respective mode. */
		unsigned int                : 5;
		/* const */ unsigned int EMUXACT        : 3;	/* External Multiplexer Actual Selection */
		unsigned int                : 5;
		unsigned int EMUXCH         : 10;	/* External Multiplexer Channel Select */
		unsigned int EMUXMODE       : 2;	/* External Multiplexer Mode */
		unsigned int EMXCOD         : 1;	/* External Multiplexer Coding Scheme */
		unsigned int EMXST          : 1;	/* External Multiplexer Sample Time Control */
		/* const */ unsigned int EMXCSS         : 1;	/* External Multiplexer Channel Selection Style */
		unsigned int EMXWC          : 1;	/* Write Control for EMUX Configuration */
	} B;
	int I;
	unsigned int U;

} VADC_G0EMUXCTR_type;
#define VADC_G0EMUXCTR	(*( VADC_G0EMUXCTR_type *) 0xf00205f0u)	/* External Multiplexer Control Register, Group x */
#define VADC_G1EMUXCTR	(*( VADC_G0EMUXCTR_type *) 0xf00209f0u)	/* External Multiplexer Control Register, Group x */
#define VADC_G2EMUXCTR	(*( VADC_G0EMUXCTR_type *) 0xf0020df0u)	/* External Multiplexer Control Register, Group x */
#define VADC_G3EMUXCTR	(*( VADC_G0EMUXCTR_type *) 0xf00211f0u)	/* External Multiplexer Control Register, Group x */
#define VADC_G4EMUXCTR	(*( VADC_G0EMUXCTR_type *) 0xf00215f0u)	/* External Multiplexer Control Register, Group x */
#define VADC_G5EMUXCTR	(*( VADC_G0EMUXCTR_type *) 0xf00219f0u)	/* External Multiplexer Control Register, Group x */
#define VADC_G6EMUXCTR	(*( VADC_G0EMUXCTR_type *) 0xf0021df0u)	/* External Multiplexer Control Register, Group x */
#define VADC_G7EMUXCTR	(*( VADC_G0EMUXCTR_type *) 0xf00221f0u)	/* External Multiplexer Control Register, Group x */

typedef volatile union
{
	struct
	{ 
		unsigned int STCS           : 5;	/* Sample Time Control for Standard Conversions */
		unsigned int                : 3;
		unsigned int CMS            : 3;	/* Conversion Mode for Standard Conversions */
		unsigned int                : 5;
		unsigned int STCE           : 5;	/* Sample Time Control for EMUX Conversions */
		unsigned int                : 3;
		unsigned int CME            : 3;	/* Conversion Mode for EMUX Conversions */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} VADC_G0ICLASS0_type;
#define VADC_G0ICLASS0	(*( VADC_G0ICLASS0_type *) 0xf00204a0u)	/* Input Class Register 0, Group 0 */
#define VADC_G0ICLASS1	(*( VADC_G0ICLASS0_type *) 0xf00204a4u)	/* Input Class Register 1, Group 0 */
#define VADC_G1ICLASS0	(*( VADC_G0ICLASS0_type *) 0xf00208a0u)	/* Input Class Register 0, Group 1 */
#define VADC_G1ICLASS1	(*( VADC_G0ICLASS0_type *) 0xf00208a4u)	/* Input Class Register 1, Group 1 */
#define VADC_G2ICLASS0	(*( VADC_G0ICLASS0_type *) 0xf0020ca0u)	/* Input Class Register 0, Group 2 */
#define VADC_G2ICLASS1	(*( VADC_G0ICLASS0_type *) 0xf0020ca4u)	/* Input Class Register 1, Group 2 */
#define VADC_G3ICLASS0	(*( VADC_G0ICLASS0_type *) 0xf00210a0u)	/* Input Class Register 0, Group 3 */
#define VADC_G3ICLASS1	(*( VADC_G0ICLASS0_type *) 0xf00210a4u)	/* Input Class Register 1, Group 3 */
#define VADC_G4ICLASS0	(*( VADC_G0ICLASS0_type *) 0xf00214a0u)	/* Input Class Register 0, Group 4 */
#define VADC_G4ICLASS1	(*( VADC_G0ICLASS0_type *) 0xf00214a4u)	/* Input Class Register 1, Group 4 */
#define VADC_G5ICLASS0	(*( VADC_G0ICLASS0_type *) 0xf00218a0u)	/* Input Class Register 0, Group 5 */
#define VADC_G5ICLASS1	(*( VADC_G0ICLASS0_type *) 0xf00218a4u)	/* Input Class Register 1, Group 5 */
#define VADC_G6ICLASS0	(*( VADC_G0ICLASS0_type *) 0xf0021ca0u)	/* Input Class Register 0, Group 6 */
#define VADC_G6ICLASS1	(*( VADC_G0ICLASS0_type *) 0xf0021ca4u)	/* Input Class Register 1, Group 6 */
#define VADC_G7ICLASS0	(*( VADC_G0ICLASS0_type *) 0xf00220a0u)	/* Input Class Register 0, Group 7 */
#define VADC_G7ICLASS1	(*( VADC_G0ICLASS0_type *) 0xf00220a4u)	/* Input Class Register 1, Group 7 */
#define VADC_GLOBICLASS0	(*( VADC_G0ICLASS0_type *) 0xf00200a0u)	/* Input Class Register 0, Global */
#define VADC_GLOBICLASS1	(*( VADC_G0ICLASS0_type *) 0xf00200a4u)	/* Input Class Register 1, Global */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int REQCHNR        : 5;	/* Request Channel Number */
		/* const */ unsigned int RF             : 1;	/* Refill */
		/* const */ unsigned int ENSI           : 1;	/* Enable Source Interrupt */
		/* const */ unsigned int EXTR           : 1;	/* External Trigger */
		/* const */ unsigned int V              : 1;	/* Request Channel Number Valid */
		/* const */ unsigned int                : 23;
	} B;
	int I;
	unsigned int U;

} VADC_G0Q0R0_type;
#define VADC_G0Q0R0	(*( VADC_G0Q0R0_type *) 0xf002050cu)	/* Queue 0 Register 0, Group 0 */
#define VADC_G1Q0R0	(*( VADC_G0Q0R0_type *) 0xf002090cu)	/* Queue 0 Register 0, Group 1 */
#define VADC_G2Q0R0	(*( VADC_G0Q0R0_type *) 0xf0020d0cu)	/* Queue 0 Register 0, Group 2 */
#define VADC_G3Q0R0	(*( VADC_G0Q0R0_type *) 0xf002110cu)	/* Queue 0 Register 0, Group 3 */
#define VADC_G4Q0R0	(*( VADC_G0Q0R0_type *) 0xf002150cu)	/* Queue 0 Register 0, Group 4 */
#define VADC_G5Q0R0	(*( VADC_G0Q0R0_type *) 0xf002190cu)	/* Queue 0 Register 0, Group 5 */
#define VADC_G6Q0R0	(*( VADC_G0Q0R0_type *) 0xf0021d0cu)	/* Queue 0 Register 0, Group 6 */
#define VADC_G7Q0R0	(*( VADC_G0Q0R0_type *) 0xf002210cu)	/* Queue 0 Register 0, Group 7 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int REQCHNR        : 5;	/* Request Channel Number */
		/* const */ unsigned int RF             : 1;	/* Refill */
		/* const */ unsigned int ENSI           : 1;	/* Enable Source Interrupt */
		/* const */ unsigned int EXTR           : 1;	/* External Trigger */
		/* const */ unsigned int V              : 1;	/* Request Channel Number Valid */
		/* const */ unsigned int r              : 23;	/* Reserved, write 0, read as 0 */
	} B;
	int I;
	unsigned int U;

} VADC_G0QBUR0_type;
#define VADC_G0QBUR0	(*( VADC_G0QBUR0_type *) 0xf0020510u)	/* Queue 0 Backup Register, Group 0 */
#define VADC_G1QBUR0	(*( VADC_G0QBUR0_type *) 0xf0020910u)	/* Queue 0 Backup Register, Group 1 */
#define VADC_G2QBUR0	(*( VADC_G0QBUR0_type *) 0xf0020d10u)	/* Queue 0 Backup Register, Group 2 */
#define VADC_G3QBUR0	(*( VADC_G0QBUR0_type *) 0xf0021110u)	/* Queue 0 Backup Register, Group 3 */
#define VADC_G4QBUR0	(*( VADC_G0QBUR0_type *) 0xf0021510u)	/* Queue 0 Backup Register, Group 4 */
#define VADC_G5QBUR0	(*( VADC_G0QBUR0_type *) 0xf0021910u)	/* Queue 0 Backup Register, Group 5 */
#define VADC_G6QBUR0	(*( VADC_G0QBUR0_type *) 0xf0021d10u)	/* Queue 0 Backup Register, Group 6 */
#define VADC_G7QBUR0	(*( VADC_G0QBUR0_type *) 0xf0022110u)	/* Queue 0 Backup Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int REQCHNR        : 5;	/* Request Channel Number */
		unsigned int RF             : 1;	/* Refill */
		unsigned int ENSI           : 1;	/* Enable Source Interrupt */
		unsigned int EXTR           : 1;	/* External Trigger */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} VADC_G0QINR0_type;
#define VADC_G0QINR0	(*( VADC_G0QINR0_type *) 0xf0020510u)	/* Queue 0 Input Register, Group 0 */
#define VADC_G1QINR0	(*( VADC_G0QINR0_type *) 0xf0020910u)	/* Queue 0 Input Register, Group 1 */
#define VADC_G2QINR0	(*( VADC_G0QINR0_type *) 0xf0020d10u)	/* Queue 0 Input Register, Group 2 */
#define VADC_G3QINR0	(*( VADC_G0QINR0_type *) 0xf0021110u)	/* Queue 0 Input Register, Group 3 */
#define VADC_G4QINR0	(*( VADC_G0QINR0_type *) 0xf0021510u)	/* Queue 0 Input Register, Group 4 */
#define VADC_G5QINR0	(*( VADC_G0QINR0_type *) 0xf0021910u)	/* Queue 0 Input Register, Group 5 */
#define VADC_G6QINR0	(*( VADC_G0QINR0_type *) 0xf0021d10u)	/* Queue 0 Input Register, Group 6 */
#define VADC_G7QINR0	(*( VADC_G0QINR0_type *) 0xf0022110u)	/* Queue 0 Input Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int ENGT           : 2;	/* Enable Gate */
		unsigned int ENTR           : 1;	/* Enable External Trigger */
		unsigned int                : 5;
		unsigned int CLRV           : 1;	/* Clear Valid Bit */
		unsigned int TREV           : 1;	/* Trigger Event */
		unsigned int FLUSH          : 1;	/* Flush Queue */
		unsigned int CEV            : 1;	/* Clear Event Flag */
		unsigned int                : 4;
		unsigned int RPTDIS         : 1;	/* Repeat Disable */
		unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} VADC_G0QMR0_type;
#define VADC_G0QMR0	(*( VADC_G0QMR0_type *) 0xf0020504u)	/* Queue 0 Mode Register, Group 0 */
#define VADC_G1QMR0	(*( VADC_G0QMR0_type *) 0xf0020904u)	/* Queue 0 Mode Register, Group 1 */
#define VADC_G2QMR0	(*( VADC_G0QMR0_type *) 0xf0020d04u)	/* Queue 0 Mode Register, Group 2 */
#define VADC_G3QMR0	(*( VADC_G0QMR0_type *) 0xf0021104u)	/* Queue 0 Mode Register, Group 3 */
#define VADC_G4QMR0	(*( VADC_G0QMR0_type *) 0xf0021504u)	/* Queue 0 Mode Register, Group 4 */
#define VADC_G5QMR0	(*( VADC_G0QMR0_type *) 0xf0021904u)	/* Queue 0 Mode Register, Group 5 */
#define VADC_G6QMR0	(*( VADC_G0QMR0_type *) 0xf0021d04u)	/* Queue 0 Mode Register, Group 6 */
#define VADC_G7QMR0	(*( VADC_G0QMR0_type *) 0xf0022104u)	/* Queue 0 Mode Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int FILL           : 4;	/* Filling Level for Queue 2 */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int EMPTY          : 1;	/* Queue Empty */
		/* const */ unsigned int                : 1;
		/* const */ unsigned int REQGT          : 1;	/* Request Gate Level */
		/* const */ unsigned int EV             : 1;	/* Event Detected */
		/* const */ unsigned int                : 23;
	} B;
	int I;
	unsigned int U;

} VADC_G0QSR0_type;
#define VADC_G0QSR0	(*( VADC_G0QSR0_type *) 0xf0020508u)	/* Queue 0 Status Register, Group 0 */
#define VADC_G1QSR0	(*( VADC_G0QSR0_type *) 0xf0020908u)	/* Queue 0 Status Register, Group 1 */
#define VADC_G2QSR0	(*( VADC_G0QSR0_type *) 0xf0020d08u)	/* Queue 0 Status Register, Group 2 */
#define VADC_G3QSR0	(*( VADC_G0QSR0_type *) 0xf0021108u)	/* Queue 0 Status Register, Group 3 */
#define VADC_G4QSR0	(*( VADC_G0QSR0_type *) 0xf0021508u)	/* Queue 0 Status Register, Group 4 */
#define VADC_G5QSR0	(*( VADC_G0QSR0_type *) 0xf0021908u)	/* Queue 0 Status Register, Group 5 */
#define VADC_G6QSR0	(*( VADC_G0QSR0_type *) 0xf0021d08u)	/* Queue 0 Status Register, Group 6 */
#define VADC_G7QSR0	(*( VADC_G0QSR0_type *) 0xf0022108u)	/* Queue 0 Status Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 16;
		unsigned int DRCTR          : 4;	/* Data Reduction Control */
		unsigned int DMM            : 2;	/* Data Modification Mode */
		unsigned int                : 2;
		unsigned int WFR            : 1;	/* Wait-for-Read Mode Enable */
		unsigned int FEN            : 2;	/* FIFO Mode Enable */
		unsigned int                : 4;
		unsigned int SRGEN          : 1;	/* Service Request Generation Enable */
	} B;
	int I;
	unsigned int U;

} VADC_G0RCR0_type;
#define VADC_G0RCR0	(*( VADC_G0RCR0_type *) 0xf0020680u)	/* Group 0 Result Control Reg. 0 */
#define VADC_G0RCR1	(*( VADC_G0RCR0_type *) 0xf0020684u)	/* Group 0 Result Control Reg. 1 */
#define VADC_G0RCR10	(*( VADC_G0RCR0_type *) 0xf00206a8u)	/* Group 0 Result Control Reg. 10 */
#define VADC_G0RCR11	(*( VADC_G0RCR0_type *) 0xf00206acu)	/* Group 0 Result Control Reg. 11 */
#define VADC_G0RCR12	(*( VADC_G0RCR0_type *) 0xf00206b0u)	/* Group 0 Result Control Reg. 12 */
#define VADC_G0RCR13	(*( VADC_G0RCR0_type *) 0xf00206b4u)	/* Group 0 Result Control Reg. 13 */
#define VADC_G0RCR14	(*( VADC_G0RCR0_type *) 0xf00206b8u)	/* Group 0 Result Control Reg. 14 */
#define VADC_G0RCR15	(*( VADC_G0RCR0_type *) 0xf00206bcu)	/* Group 0 Result Control Reg. 15 */
#define VADC_G0RCR2	(*( VADC_G0RCR0_type *) 0xf0020688u)	/* Group 0 Result Control Reg. 2 */
#define VADC_G0RCR3	(*( VADC_G0RCR0_type *) 0xf002068cu)	/* Group 0 Result Control Reg. 3 */
#define VADC_G0RCR4	(*( VADC_G0RCR0_type *) 0xf0020690u)	/* Group 0 Result Control Reg. 4 */
#define VADC_G0RCR5	(*( VADC_G0RCR0_type *) 0xf0020694u)	/* Group 0 Result Control Reg. 5 */
#define VADC_G0RCR6	(*( VADC_G0RCR0_type *) 0xf0020698u)	/* Group 0 Result Control Reg. 6 */
#define VADC_G0RCR7	(*( VADC_G0RCR0_type *) 0xf002069cu)	/* Group 0 Result Control Reg. 7 */
#define VADC_G0RCR8	(*( VADC_G0RCR0_type *) 0xf00206a0u)	/* Group 0 Result Control Reg. 8 */
#define VADC_G0RCR9	(*( VADC_G0RCR0_type *) 0xf00206a4u)	/* Group 0 Result Control Reg. 9 */
#define VADC_G1RCR0	(*( VADC_G0RCR0_type *) 0xf0020a80u)	/* Group 1 Result Control Reg. 0 */
#define VADC_G1RCR1	(*( VADC_G0RCR0_type *) 0xf0020a84u)	/* Group 1 Result Control Reg. 1 */
#define VADC_G1RCR10	(*( VADC_G0RCR0_type *) 0xf0020aa8u)	/* Group 1 Result Control Reg. 10 */
#define VADC_G1RCR11	(*( VADC_G0RCR0_type *) 0xf0020aacu)	/* Group 1 Result Control Reg. 11 */
#define VADC_G1RCR12	(*( VADC_G0RCR0_type *) 0xf0020ab0u)	/* Group 1 Result Control Reg. 12 */
#define VADC_G1RCR13	(*( VADC_G0RCR0_type *) 0xf0020ab4u)	/* Group 1 Result Control Reg. 13 */
#define VADC_G1RCR14	(*( VADC_G0RCR0_type *) 0xf0020ab8u)	/* Group 1 Result Control Reg. 14 */
#define VADC_G1RCR15	(*( VADC_G0RCR0_type *) 0xf0020abcu)	/* Group 1 Result Control Reg. 15 */
#define VADC_G1RCR2	(*( VADC_G0RCR0_type *) 0xf0020a88u)	/* Group 1 Result Control Reg. 2 */
#define VADC_G1RCR3	(*( VADC_G0RCR0_type *) 0xf0020a8cu)	/* Group 1 Result Control Reg. 3 */
#define VADC_G1RCR4	(*( VADC_G0RCR0_type *) 0xf0020a90u)	/* Group 1 Result Control Reg. 4 */
#define VADC_G1RCR5	(*( VADC_G0RCR0_type *) 0xf0020a94u)	/* Group 1 Result Control Reg. 5 */
#define VADC_G1RCR6	(*( VADC_G0RCR0_type *) 0xf0020a98u)	/* Group 1 Result Control Reg. 6 */
#define VADC_G1RCR7	(*( VADC_G0RCR0_type *) 0xf0020a9cu)	/* Group 1 Result Control Reg. 7 */
#define VADC_G1RCR8	(*( VADC_G0RCR0_type *) 0xf0020aa0u)	/* Group 1 Result Control Reg. 8 */
#define VADC_G1RCR9	(*( VADC_G0RCR0_type *) 0xf0020aa4u)	/* Group 1 Result Control Reg. 9 */
#define VADC_G2RCR0	(*( VADC_G0RCR0_type *) 0xf0020e80u)	/* Group 2 Result Control Reg. 0 */
#define VADC_G2RCR1	(*( VADC_G0RCR0_type *) 0xf0020e84u)	/* Group 2 Result Control Reg. 1 */
#define VADC_G2RCR10	(*( VADC_G0RCR0_type *) 0xf0020ea8u)	/* Group 2 Result Control Reg. 10 */
#define VADC_G2RCR11	(*( VADC_G0RCR0_type *) 0xf0020eacu)	/* Group 2 Result Control Reg. 11 */
#define VADC_G2RCR12	(*( VADC_G0RCR0_type *) 0xf0020eb0u)	/* Group 2 Result Control Reg. 12 */
#define VADC_G2RCR13	(*( VADC_G0RCR0_type *) 0xf0020eb4u)	/* Group 2 Result Control Reg. 13 */
#define VADC_G2RCR14	(*( VADC_G0RCR0_type *) 0xf0020eb8u)	/* Group 2 Result Control Reg. 14 */
#define VADC_G2RCR15	(*( VADC_G0RCR0_type *) 0xf0020ebcu)	/* Group 2 Result Control Reg. 15 */
#define VADC_G2RCR2	(*( VADC_G0RCR0_type *) 0xf0020e88u)	/* Group 2 Result Control Reg. 2 */
#define VADC_G2RCR3	(*( VADC_G0RCR0_type *) 0xf0020e8cu)	/* Group 2 Result Control Reg. 3 */
#define VADC_G2RCR4	(*( VADC_G0RCR0_type *) 0xf0020e90u)	/* Group 2 Result Control Reg. 4 */
#define VADC_G2RCR5	(*( VADC_G0RCR0_type *) 0xf0020e94u)	/* Group 2 Result Control Reg. 5 */
#define VADC_G2RCR6	(*( VADC_G0RCR0_type *) 0xf0020e98u)	/* Group 2 Result Control Reg. 6 */
#define VADC_G2RCR7	(*( VADC_G0RCR0_type *) 0xf0020e9cu)	/* Group 2 Result Control Reg. 7 */
#define VADC_G2RCR8	(*( VADC_G0RCR0_type *) 0xf0020ea0u)	/* Group 2 Result Control Reg. 8 */
#define VADC_G2RCR9	(*( VADC_G0RCR0_type *) 0xf0020ea4u)	/* Group 2 Result Control Reg. 9 */
#define VADC_G3RCR0	(*( VADC_G0RCR0_type *) 0xf0021280u)	/* Group 3 Result Control Reg. 0 */
#define VADC_G3RCR1	(*( VADC_G0RCR0_type *) 0xf0021284u)	/* Group 3 Result Control Reg. 1 */
#define VADC_G3RCR10	(*( VADC_G0RCR0_type *) 0xf00212a8u)	/* Group 3 Result Control Reg. 10 */
#define VADC_G3RCR11	(*( VADC_G0RCR0_type *) 0xf00212acu)	/* Group 3 Result Control Reg. 11 */
#define VADC_G3RCR12	(*( VADC_G0RCR0_type *) 0xf00212b0u)	/* Group 3 Result Control Reg. 12 */
#define VADC_G3RCR13	(*( VADC_G0RCR0_type *) 0xf00212b4u)	/* Group 3 Result Control Reg. 13 */
#define VADC_G3RCR14	(*( VADC_G0RCR0_type *) 0xf00212b8u)	/* Group 3 Result Control Reg. 14 */
#define VADC_G3RCR15	(*( VADC_G0RCR0_type *) 0xf00212bcu)	/* Group 3 Result Control Reg. 15 */
#define VADC_G3RCR2	(*( VADC_G0RCR0_type *) 0xf0021288u)	/* Group 3 Result Control Reg. 2 */
#define VADC_G3RCR3	(*( VADC_G0RCR0_type *) 0xf002128cu)	/* Group 3 Result Control Reg. 3 */
#define VADC_G3RCR4	(*( VADC_G0RCR0_type *) 0xf0021290u)	/* Group 3 Result Control Reg. 4 */
#define VADC_G3RCR5	(*( VADC_G0RCR0_type *) 0xf0021294u)	/* Group 3 Result Control Reg. 5 */
#define VADC_G3RCR6	(*( VADC_G0RCR0_type *) 0xf0021298u)	/* Group 3 Result Control Reg. 6 */
#define VADC_G3RCR7	(*( VADC_G0RCR0_type *) 0xf002129cu)	/* Group 3 Result Control Reg. 7 */
#define VADC_G3RCR8	(*( VADC_G0RCR0_type *) 0xf00212a0u)	/* Group 3 Result Control Reg. 8 */
#define VADC_G3RCR9	(*( VADC_G0RCR0_type *) 0xf00212a4u)	/* Group 3 Result Control Reg. 9 */
#define VADC_G4RCR0	(*( VADC_G0RCR0_type *) 0xf0021680u)	/* Group 4 Result Control Reg. 0 */
#define VADC_G4RCR1	(*( VADC_G0RCR0_type *) 0xf0021684u)	/* Group 4 Result Control Reg. 1 */
#define VADC_G4RCR10	(*( VADC_G0RCR0_type *) 0xf00216a8u)	/* Group 4 Result Control Reg. 10 */
#define VADC_G4RCR11	(*( VADC_G0RCR0_type *) 0xf00216acu)	/* Group 4 Result Control Reg. 11 */
#define VADC_G4RCR12	(*( VADC_G0RCR0_type *) 0xf00216b0u)	/* Group 4 Result Control Reg. 12 */
#define VADC_G4RCR13	(*( VADC_G0RCR0_type *) 0xf00216b4u)	/* Group 4 Result Control Reg. 13 */
#define VADC_G4RCR14	(*( VADC_G0RCR0_type *) 0xf00216b8u)	/* Group 4 Result Control Reg. 14 */
#define VADC_G4RCR15	(*( VADC_G0RCR0_type *) 0xf00216bcu)	/* Group 4 Result Control Reg. 15 */
#define VADC_G4RCR2	(*( VADC_G0RCR0_type *) 0xf0021688u)	/* Group 4 Result Control Reg. 2 */
#define VADC_G4RCR3	(*( VADC_G0RCR0_type *) 0xf002168cu)	/* Group 4 Result Control Reg. 3 */
#define VADC_G4RCR4	(*( VADC_G0RCR0_type *) 0xf0021690u)	/* Group 4 Result Control Reg. 4 */
#define VADC_G4RCR5	(*( VADC_G0RCR0_type *) 0xf0021694u)	/* Group 4 Result Control Reg. 5 */
#define VADC_G4RCR6	(*( VADC_G0RCR0_type *) 0xf0021698u)	/* Group 4 Result Control Reg. 6 */
#define VADC_G4RCR7	(*( VADC_G0RCR0_type *) 0xf002169cu)	/* Group 4 Result Control Reg. 7 */
#define VADC_G4RCR8	(*( VADC_G0RCR0_type *) 0xf00216a0u)	/* Group 4 Result Control Reg. 8 */
#define VADC_G4RCR9	(*( VADC_G0RCR0_type *) 0xf00216a4u)	/* Group 4 Result Control Reg. 9 */
#define VADC_G5RCR0	(*( VADC_G0RCR0_type *) 0xf0021a80u)	/* Group 5 Result Control Reg. 0 */
#define VADC_G5RCR1	(*( VADC_G0RCR0_type *) 0xf0021a84u)	/* Group 5 Result Control Reg. 1 */
#define VADC_G5RCR10	(*( VADC_G0RCR0_type *) 0xf0021aa8u)	/* Group 5 Result Control Reg. 10 */
#define VADC_G5RCR11	(*( VADC_G0RCR0_type *) 0xf0021aacu)	/* Group 5 Result Control Reg. 11 */
#define VADC_G5RCR12	(*( VADC_G0RCR0_type *) 0xf0021ab0u)	/* Group 5 Result Control Reg. 12 */
#define VADC_G5RCR13	(*( VADC_G0RCR0_type *) 0xf0021ab4u)	/* Group 5 Result Control Reg. 13 */
#define VADC_G5RCR14	(*( VADC_G0RCR0_type *) 0xf0021ab8u)	/* Group 5 Result Control Reg. 14 */
#define VADC_G5RCR15	(*( VADC_G0RCR0_type *) 0xf0021abcu)	/* Group 5 Result Control Reg. 15 */
#define VADC_G5RCR2	(*( VADC_G0RCR0_type *) 0xf0021a88u)	/* Group 5 Result Control Reg. 2 */
#define VADC_G5RCR3	(*( VADC_G0RCR0_type *) 0xf0021a8cu)	/* Group 5 Result Control Reg. 3 */
#define VADC_G5RCR4	(*( VADC_G0RCR0_type *) 0xf0021a90u)	/* Group 5 Result Control Reg. 4 */
#define VADC_G5RCR5	(*( VADC_G0RCR0_type *) 0xf0021a94u)	/* Group 5 Result Control Reg. 5 */
#define VADC_G5RCR6	(*( VADC_G0RCR0_type *) 0xf0021a98u)	/* Group 5 Result Control Reg. 6 */
#define VADC_G5RCR7	(*( VADC_G0RCR0_type *) 0xf0021a9cu)	/* Group 5 Result Control Reg. 7 */
#define VADC_G5RCR8	(*( VADC_G0RCR0_type *) 0xf0021aa0u)	/* Group 5 Result Control Reg. 8 */
#define VADC_G5RCR9	(*( VADC_G0RCR0_type *) 0xf0021aa4u)	/* Group 5 Result Control Reg. 9 */
#define VADC_G6RCR0	(*( VADC_G0RCR0_type *) 0xf0021e80u)	/* Group 6 Result Control Reg. 0 */
#define VADC_G6RCR1	(*( VADC_G0RCR0_type *) 0xf0021e84u)	/* Group 6 Result Control Reg. 1 */
#define VADC_G6RCR10	(*( VADC_G0RCR0_type *) 0xf0021ea8u)	/* Group 6 Result Control Reg. 10 */
#define VADC_G6RCR11	(*( VADC_G0RCR0_type *) 0xf0021eacu)	/* Group 6 Result Control Reg. 11 */
#define VADC_G6RCR12	(*( VADC_G0RCR0_type *) 0xf0021eb0u)	/* Group 6 Result Control Reg. 12 */
#define VADC_G6RCR13	(*( VADC_G0RCR0_type *) 0xf0021eb4u)	/* Group 6 Result Control Reg. 13 */
#define VADC_G6RCR14	(*( VADC_G0RCR0_type *) 0xf0021eb8u)	/* Group 6 Result Control Reg. 14 */
#define VADC_G6RCR15	(*( VADC_G0RCR0_type *) 0xf0021ebcu)	/* Group 6 Result Control Reg. 15 */
#define VADC_G6RCR2	(*( VADC_G0RCR0_type *) 0xf0021e88u)	/* Group 6 Result Control Reg. 2 */
#define VADC_G6RCR3	(*( VADC_G0RCR0_type *) 0xf0021e8cu)	/* Group 6 Result Control Reg. 3 */
#define VADC_G6RCR4	(*( VADC_G0RCR0_type *) 0xf0021e90u)	/* Group 6 Result Control Reg. 4 */
#define VADC_G6RCR5	(*( VADC_G0RCR0_type *) 0xf0021e94u)	/* Group 6 Result Control Reg. 5 */
#define VADC_G6RCR6	(*( VADC_G0RCR0_type *) 0xf0021e98u)	/* Group 6 Result Control Reg. 6 */
#define VADC_G6RCR7	(*( VADC_G0RCR0_type *) 0xf0021e9cu)	/* Group 6 Result Control Reg. 7 */
#define VADC_G6RCR8	(*( VADC_G0RCR0_type *) 0xf0021ea0u)	/* Group 6 Result Control Reg. 8 */
#define VADC_G6RCR9	(*( VADC_G0RCR0_type *) 0xf0021ea4u)	/* Group 6 Result Control Reg. 9 */
#define VADC_G7RCR0	(*( VADC_G0RCR0_type *) 0xf0022280u)	/* Group 7 Result Control Reg. 0 */
#define VADC_G7RCR1	(*( VADC_G0RCR0_type *) 0xf0022284u)	/* Group 7 Result Control Reg. 1 */
#define VADC_G7RCR10	(*( VADC_G0RCR0_type *) 0xf00222a8u)	/* Group 7 Result Control Reg. 10 */
#define VADC_G7RCR11	(*( VADC_G0RCR0_type *) 0xf00222acu)	/* Group 7 Result Control Reg. 11 */
#define VADC_G7RCR12	(*( VADC_G0RCR0_type *) 0xf00222b0u)	/* Group 7 Result Control Reg. 12 */
#define VADC_G7RCR13	(*( VADC_G0RCR0_type *) 0xf00222b4u)	/* Group 7 Result Control Reg. 13 */
#define VADC_G7RCR14	(*( VADC_G0RCR0_type *) 0xf00222b8u)	/* Group 7 Result Control Reg. 14 */
#define VADC_G7RCR15	(*( VADC_G0RCR0_type *) 0xf00222bcu)	/* Group 7 Result Control Reg. 15 */
#define VADC_G7RCR2	(*( VADC_G0RCR0_type *) 0xf0022288u)	/* Group 7 Result Control Reg. 2 */
#define VADC_G7RCR3	(*( VADC_G0RCR0_type *) 0xf002228cu)	/* Group 7 Result Control Reg. 3 */
#define VADC_G7RCR4	(*( VADC_G0RCR0_type *) 0xf0022290u)	/* Group 7 Result Control Reg. 4 */
#define VADC_G7RCR5	(*( VADC_G0RCR0_type *) 0xf0022294u)	/* Group 7 Result Control Reg. 5 */
#define VADC_G7RCR6	(*( VADC_G0RCR0_type *) 0xf0022298u)	/* Group 7 Result Control Reg. 6 */
#define VADC_G7RCR7	(*( VADC_G0RCR0_type *) 0xf002229cu)	/* Group 7 Result Control Reg. 7 */
#define VADC_G7RCR8	(*( VADC_G0RCR0_type *) 0xf00222a0u)	/* Group 7 Result Control Reg. 8 */
#define VADC_G7RCR9	(*( VADC_G0RCR0_type *) 0xf00222a4u)	/* Group 7 Result Control Reg. 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int REV0           : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV1           : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV2           : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV3           : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV4           : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV5           : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV6           : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV7           : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV8           : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV9           : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV10          : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV11          : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV12          : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV13          : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV14          : 1;	/* Clear Result Event for Result Register y */
		unsigned int REV15          : 1;	/* Clear Result Event for Result Register y */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} VADC_G0REFCLR_type;
#define VADC_G0REFCLR	(*( VADC_G0REFCLR_type *) 0xf0020594u)	/* Result Event Flag Clear Register, Group 0 */
#define VADC_G1REFCLR	(*( VADC_G0REFCLR_type *) 0xf0020994u)	/* Result Event Flag Clear Register, Group 1 */
#define VADC_G2REFCLR	(*( VADC_G0REFCLR_type *) 0xf0020d94u)	/* Result Event Flag Clear Register, Group 2 */
#define VADC_G3REFCLR	(*( VADC_G0REFCLR_type *) 0xf0021194u)	/* Result Event Flag Clear Register, Group 3 */
#define VADC_G4REFCLR	(*( VADC_G0REFCLR_type *) 0xf0021594u)	/* Result Event Flag Clear Register, Group 4 */
#define VADC_G5REFCLR	(*( VADC_G0REFCLR_type *) 0xf0021994u)	/* Result Event Flag Clear Register, Group 5 */
#define VADC_G6REFCLR	(*( VADC_G0REFCLR_type *) 0xf0021d94u)	/* Result Event Flag Clear Register, Group 6 */
#define VADC_G7REFCLR	(*( VADC_G0REFCLR_type *) 0xf0022194u)	/* Result Event Flag Clear Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int REV0           : 1;	/* Result Event for Result Register y */
		unsigned int REV1           : 1;	/* Result Event for Result Register y */
		unsigned int REV2           : 1;	/* Result Event for Result Register y */
		unsigned int REV3           : 1;	/* Result Event for Result Register y */
		unsigned int REV4           : 1;	/* Result Event for Result Register y */
		unsigned int REV5           : 1;	/* Result Event for Result Register y */
		unsigned int REV6           : 1;	/* Result Event for Result Register y */
		unsigned int REV7           : 1;	/* Result Event for Result Register y */
		unsigned int REV8           : 1;	/* Result Event for Result Register y */
		unsigned int REV9           : 1;	/* Result Event for Result Register y */
		unsigned int REV10          : 1;	/* Result Event for Result Register y */
		unsigned int REV11          : 1;	/* Result Event for Result Register y */
		unsigned int REV12          : 1;	/* Result Event for Result Register y */
		unsigned int REV13          : 1;	/* Result Event for Result Register y */
		unsigned int REV14          : 1;	/* Result Event for Result Register y */
		unsigned int REV15          : 1;	/* Result Event for Result Register y */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} VADC_G0REFLAG_type;
#define VADC_G0REFLAG	(*( VADC_G0REFLAG_type *) 0xf0020584u)	/* Result Event Flag Register, Group 0 */
#define VADC_G1REFLAG	(*( VADC_G0REFLAG_type *) 0xf0020984u)	/* Result Event Flag Register, Group 1 */
#define VADC_G2REFLAG	(*( VADC_G0REFLAG_type *) 0xf0020d84u)	/* Result Event Flag Register, Group 2 */
#define VADC_G3REFLAG	(*( VADC_G0REFLAG_type *) 0xf0021184u)	/* Result Event Flag Register, Group 3 */
#define VADC_G4REFLAG	(*( VADC_G0REFLAG_type *) 0xf0021584u)	/* Result Event Flag Register, Group 4 */
#define VADC_G5REFLAG	(*( VADC_G0REFLAG_type *) 0xf0021984u)	/* Result Event Flag Register, Group 5 */
#define VADC_G6REFLAG	(*( VADC_G0REFLAG_type *) 0xf0021d84u)	/* Result Event Flag Register, Group 6 */
#define VADC_G7REFLAG	(*( VADC_G0REFLAG_type *) 0xf0022184u)	/* Result Event Flag Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int RESULT         : 16;	/* Result of Most Recent Conversion */
		/* const */ unsigned int DRC            : 4;	/* Data Reduction Counter */
		/* const */ unsigned int CHNR           : 5;	/* Channel Number */
		/* const */ unsigned int EMUX           : 3;	/* External Multiplexer Setting */
		/* const */ unsigned int CRS            : 2;	/* Converted Request Source */
		/* const */ unsigned int FCR            : 1;	/* Fast Compare Result */
		/* const */ unsigned int VF             : 1;	/* Valid Flag */
	} B;
	int I;
	unsigned int U;

} VADC_G0RES0_type;
#define VADC_G0RES0	(*( VADC_G0RES0_type *) 0xf0020700u)	/* Group 0 Result Register 0 */
#define VADC_G0RES1	(*( VADC_G0RES0_type *) 0xf0020704u)	/* Group 0 Result Register 1 */
#define VADC_G0RES10	(*( VADC_G0RES0_type *) 0xf0020728u)	/* Group 0 Result Register 10 */
#define VADC_G0RES11	(*( VADC_G0RES0_type *) 0xf002072cu)	/* Group 0 Result Register 11 */
#define VADC_G0RES12	(*( VADC_G0RES0_type *) 0xf0020730u)	/* Group 0 Result Register 12 */
#define VADC_G0RES13	(*( VADC_G0RES0_type *) 0xf0020734u)	/* Group 0 Result Register 13 */
#define VADC_G0RES14	(*( VADC_G0RES0_type *) 0xf0020738u)	/* Group 0 Result Register 14 */
#define VADC_G0RES15	(*( VADC_G0RES0_type *) 0xf002073cu)	/* Group 0 Result Register 15 */
#define VADC_G0RES2	(*( VADC_G0RES0_type *) 0xf0020708u)	/* Group 0 Result Register 2 */
#define VADC_G0RES3	(*( VADC_G0RES0_type *) 0xf002070cu)	/* Group 0 Result Register 3 */
#define VADC_G0RES4	(*( VADC_G0RES0_type *) 0xf0020710u)	/* Group 0 Result Register 4 */
#define VADC_G0RES5	(*( VADC_G0RES0_type *) 0xf0020714u)	/* Group 0 Result Register 5 */
#define VADC_G0RES6	(*( VADC_G0RES0_type *) 0xf0020718u)	/* Group 0 Result Register 6 */
#define VADC_G0RES7	(*( VADC_G0RES0_type *) 0xf002071cu)	/* Group 0 Result Register 7 */
#define VADC_G0RES8	(*( VADC_G0RES0_type *) 0xf0020720u)	/* Group 0 Result Register 8 */
#define VADC_G0RES9	(*( VADC_G0RES0_type *) 0xf0020724u)	/* Group 0 Result Register 9 */
#define VADC_G1RES0	(*( VADC_G0RES0_type *) 0xf0020b00u)	/* Group 1 Result Register 0 */
#define VADC_G1RES1	(*( VADC_G0RES0_type *) 0xf0020b04u)	/* Group 1 Result Register 1 */
#define VADC_G1RES10	(*( VADC_G0RES0_type *) 0xf0020b28u)	/* Group 1 Result Register 10 */
#define VADC_G1RES11	(*( VADC_G0RES0_type *) 0xf0020b2cu)	/* Group 1 Result Register 11 */
#define VADC_G1RES12	(*( VADC_G0RES0_type *) 0xf0020b30u)	/* Group 1 Result Register 12 */
#define VADC_G1RES13	(*( VADC_G0RES0_type *) 0xf0020b34u)	/* Group 1 Result Register 13 */
#define VADC_G1RES14	(*( VADC_G0RES0_type *) 0xf0020b38u)	/* Group 1 Result Register 14 */
#define VADC_G1RES15	(*( VADC_G0RES0_type *) 0xf0020b3cu)	/* Group 1 Result Register 15 */
#define VADC_G1RES2	(*( VADC_G0RES0_type *) 0xf0020b08u)	/* Group 1 Result Register 2 */
#define VADC_G1RES3	(*( VADC_G0RES0_type *) 0xf0020b0cu)	/* Group 1 Result Register 3 */
#define VADC_G1RES4	(*( VADC_G0RES0_type *) 0xf0020b10u)	/* Group 1 Result Register 4 */
#define VADC_G1RES5	(*( VADC_G0RES0_type *) 0xf0020b14u)	/* Group 1 Result Register 5 */
#define VADC_G1RES6	(*( VADC_G0RES0_type *) 0xf0020b18u)	/* Group 1 Result Register 6 */
#define VADC_G1RES7	(*( VADC_G0RES0_type *) 0xf0020b1cu)	/* Group 1 Result Register 7 */
#define VADC_G1RES8	(*( VADC_G0RES0_type *) 0xf0020b20u)	/* Group 1 Result Register 8 */
#define VADC_G1RES9	(*( VADC_G0RES0_type *) 0xf0020b24u)	/* Group 1 Result Register 9 */
#define VADC_G2RES0	(*( VADC_G0RES0_type *) 0xf0020f00u)	/* Group 2 Result Register 0 */
#define VADC_G2RES1	(*( VADC_G0RES0_type *) 0xf0020f04u)	/* Group 2 Result Register 1 */
#define VADC_G2RES10	(*( VADC_G0RES0_type *) 0xf0020f28u)	/* Group 2 Result Register 10 */
#define VADC_G2RES11	(*( VADC_G0RES0_type *) 0xf0020f2cu)	/* Group 2 Result Register 11 */
#define VADC_G2RES12	(*( VADC_G0RES0_type *) 0xf0020f30u)	/* Group 2 Result Register 12 */
#define VADC_G2RES13	(*( VADC_G0RES0_type *) 0xf0020f34u)	/* Group 2 Result Register 13 */
#define VADC_G2RES14	(*( VADC_G0RES0_type *) 0xf0020f38u)	/* Group 2 Result Register 14 */
#define VADC_G2RES15	(*( VADC_G0RES0_type *) 0xf0020f3cu)	/* Group 2 Result Register 15 */
#define VADC_G2RES2	(*( VADC_G0RES0_type *) 0xf0020f08u)	/* Group 2 Result Register 2 */
#define VADC_G2RES3	(*( VADC_G0RES0_type *) 0xf0020f0cu)	/* Group 2 Result Register 3 */
#define VADC_G2RES4	(*( VADC_G0RES0_type *) 0xf0020f10u)	/* Group 2 Result Register 4 */
#define VADC_G2RES5	(*( VADC_G0RES0_type *) 0xf0020f14u)	/* Group 2 Result Register 5 */
#define VADC_G2RES6	(*( VADC_G0RES0_type *) 0xf0020f18u)	/* Group 2 Result Register 6 */
#define VADC_G2RES7	(*( VADC_G0RES0_type *) 0xf0020f1cu)	/* Group 2 Result Register 7 */
#define VADC_G2RES8	(*( VADC_G0RES0_type *) 0xf0020f20u)	/* Group 2 Result Register 8 */
#define VADC_G2RES9	(*( VADC_G0RES0_type *) 0xf0020f24u)	/* Group 2 Result Register 9 */
#define VADC_G3RES0	(*( VADC_G0RES0_type *) 0xf0021300u)	/* Group 3 Result Register 0 */
#define VADC_G3RES1	(*( VADC_G0RES0_type *) 0xf0021304u)	/* Group 3 Result Register 1 */
#define VADC_G3RES10	(*( VADC_G0RES0_type *) 0xf0021328u)	/* Group 3 Result Register 10 */
#define VADC_G3RES11	(*( VADC_G0RES0_type *) 0xf002132cu)	/* Group 3 Result Register 11 */
#define VADC_G3RES12	(*( VADC_G0RES0_type *) 0xf0021330u)	/* Group 3 Result Register 12 */
#define VADC_G3RES13	(*( VADC_G0RES0_type *) 0xf0021334u)	/* Group 3 Result Register 13 */
#define VADC_G3RES14	(*( VADC_G0RES0_type *) 0xf0021338u)	/* Group 3 Result Register 14 */
#define VADC_G3RES15	(*( VADC_G0RES0_type *) 0xf002133cu)	/* Group 3 Result Register 15 */
#define VADC_G3RES2	(*( VADC_G0RES0_type *) 0xf0021308u)	/* Group 3 Result Register 2 */
#define VADC_G3RES3	(*( VADC_G0RES0_type *) 0xf002130cu)	/* Group 3 Result Register 3 */
#define VADC_G3RES4	(*( VADC_G0RES0_type *) 0xf0021310u)	/* Group 3 Result Register 4 */
#define VADC_G3RES5	(*( VADC_G0RES0_type *) 0xf0021314u)	/* Group 3 Result Register 5 */
#define VADC_G3RES6	(*( VADC_G0RES0_type *) 0xf0021318u)	/* Group 3 Result Register 6 */
#define VADC_G3RES7	(*( VADC_G0RES0_type *) 0xf002131cu)	/* Group 3 Result Register 7 */
#define VADC_G3RES8	(*( VADC_G0RES0_type *) 0xf0021320u)	/* Group 3 Result Register 8 */
#define VADC_G3RES9	(*( VADC_G0RES0_type *) 0xf0021324u)	/* Group 3 Result Register 9 */
#define VADC_G4RES0	(*( VADC_G0RES0_type *) 0xf0021700u)	/* Group 4 Result Register 0 */
#define VADC_G4RES1	(*( VADC_G0RES0_type *) 0xf0021704u)	/* Group 4 Result Register 1 */
#define VADC_G4RES10	(*( VADC_G0RES0_type *) 0xf0021728u)	/* Group 4 Result Register 10 */
#define VADC_G4RES11	(*( VADC_G0RES0_type *) 0xf002172cu)	/* Group 4 Result Register 11 */
#define VADC_G4RES12	(*( VADC_G0RES0_type *) 0xf0021730u)	/* Group 4 Result Register 12 */
#define VADC_G4RES13	(*( VADC_G0RES0_type *) 0xf0021734u)	/* Group 4 Result Register 13 */
#define VADC_G4RES14	(*( VADC_G0RES0_type *) 0xf0021738u)	/* Group 4 Result Register 14 */
#define VADC_G4RES15	(*( VADC_G0RES0_type *) 0xf002173cu)	/* Group 4 Result Register 15 */
#define VADC_G4RES2	(*( VADC_G0RES0_type *) 0xf0021708u)	/* Group 4 Result Register 2 */
#define VADC_G4RES3	(*( VADC_G0RES0_type *) 0xf002170cu)	/* Group 4 Result Register 3 */
#define VADC_G4RES4	(*( VADC_G0RES0_type *) 0xf0021710u)	/* Group 4 Result Register 4 */
#define VADC_G4RES5	(*( VADC_G0RES0_type *) 0xf0021714u)	/* Group 4 Result Register 5 */
#define VADC_G4RES6	(*( VADC_G0RES0_type *) 0xf0021718u)	/* Group 4 Result Register 6 */
#define VADC_G4RES7	(*( VADC_G0RES0_type *) 0xf002171cu)	/* Group 4 Result Register 7 */
#define VADC_G4RES8	(*( VADC_G0RES0_type *) 0xf0021720u)	/* Group 4 Result Register 8 */
#define VADC_G4RES9	(*( VADC_G0RES0_type *) 0xf0021724u)	/* Group 4 Result Register 9 */
#define VADC_G5RES0	(*( VADC_G0RES0_type *) 0xf0021b00u)	/* Group 5 Result Register 0 */
#define VADC_G5RES1	(*( VADC_G0RES0_type *) 0xf0021b04u)	/* Group 5 Result Register 1 */
#define VADC_G5RES10	(*( VADC_G0RES0_type *) 0xf0021b28u)	/* Group 5 Result Register 10 */
#define VADC_G5RES11	(*( VADC_G0RES0_type *) 0xf0021b2cu)	/* Group 5 Result Register 11 */
#define VADC_G5RES12	(*( VADC_G0RES0_type *) 0xf0021b30u)	/* Group 5 Result Register 12 */
#define VADC_G5RES13	(*( VADC_G0RES0_type *) 0xf0021b34u)	/* Group 5 Result Register 13 */
#define VADC_G5RES14	(*( VADC_G0RES0_type *) 0xf0021b38u)	/* Group 5 Result Register 14 */
#define VADC_G5RES15	(*( VADC_G0RES0_type *) 0xf0021b3cu)	/* Group 5 Result Register 15 */
#define VADC_G5RES2	(*( VADC_G0RES0_type *) 0xf0021b08u)	/* Group 5 Result Register 2 */
#define VADC_G5RES3	(*( VADC_G0RES0_type *) 0xf0021b0cu)	/* Group 5 Result Register 3 */
#define VADC_G5RES4	(*( VADC_G0RES0_type *) 0xf0021b10u)	/* Group 5 Result Register 4 */
#define VADC_G5RES5	(*( VADC_G0RES0_type *) 0xf0021b14u)	/* Group 5 Result Register 5 */
#define VADC_G5RES6	(*( VADC_G0RES0_type *) 0xf0021b18u)	/* Group 5 Result Register 6 */
#define VADC_G5RES7	(*( VADC_G0RES0_type *) 0xf0021b1cu)	/* Group 5 Result Register 7 */
#define VADC_G5RES8	(*( VADC_G0RES0_type *) 0xf0021b20u)	/* Group 5 Result Register 8 */
#define VADC_G5RES9	(*( VADC_G0RES0_type *) 0xf0021b24u)	/* Group 5 Result Register 9 */
#define VADC_G6RES0	(*( VADC_G0RES0_type *) 0xf0021f00u)	/* Group 6 Result Register 0 */
#define VADC_G6RES1	(*( VADC_G0RES0_type *) 0xf0021f04u)	/* Group 6 Result Register 1 */
#define VADC_G6RES10	(*( VADC_G0RES0_type *) 0xf0021f28u)	/* Group 6 Result Register 10 */
#define VADC_G6RES11	(*( VADC_G0RES0_type *) 0xf0021f2cu)	/* Group 6 Result Register 11 */
#define VADC_G6RES12	(*( VADC_G0RES0_type *) 0xf0021f30u)	/* Group 6 Result Register 12 */
#define VADC_G6RES13	(*( VADC_G0RES0_type *) 0xf0021f34u)	/* Group 6 Result Register 13 */
#define VADC_G6RES14	(*( VADC_G0RES0_type *) 0xf0021f38u)	/* Group 6 Result Register 14 */
#define VADC_G6RES15	(*( VADC_G0RES0_type *) 0xf0021f3cu)	/* Group 6 Result Register 15 */
#define VADC_G6RES2	(*( VADC_G0RES0_type *) 0xf0021f08u)	/* Group 6 Result Register 2 */
#define VADC_G6RES3	(*( VADC_G0RES0_type *) 0xf0021f0cu)	/* Group 6 Result Register 3 */
#define VADC_G6RES4	(*( VADC_G0RES0_type *) 0xf0021f10u)	/* Group 6 Result Register 4 */
#define VADC_G6RES5	(*( VADC_G0RES0_type *) 0xf0021f14u)	/* Group 6 Result Register 5 */
#define VADC_G6RES6	(*( VADC_G0RES0_type *) 0xf0021f18u)	/* Group 6 Result Register 6 */
#define VADC_G6RES7	(*( VADC_G0RES0_type *) 0xf0021f1cu)	/* Group 6 Result Register 7 */
#define VADC_G6RES8	(*( VADC_G0RES0_type *) 0xf0021f20u)	/* Group 6 Result Register 8 */
#define VADC_G6RES9	(*( VADC_G0RES0_type *) 0xf0021f24u)	/* Group 6 Result Register 9 */
#define VADC_G7RES0	(*( VADC_G0RES0_type *) 0xf0022300u)	/* Group 7 Result Register 0 */
#define VADC_G7RES1	(*( VADC_G0RES0_type *) 0xf0022304u)	/* Group 7 Result Register 1 */
#define VADC_G7RES10	(*( VADC_G0RES0_type *) 0xf0022328u)	/* Group 7 Result Register 10 */
#define VADC_G7RES11	(*( VADC_G0RES0_type *) 0xf002232cu)	/* Group 7 Result Register 11 */
#define VADC_G7RES12	(*( VADC_G0RES0_type *) 0xf0022330u)	/* Group 7 Result Register 12 */
#define VADC_G7RES13	(*( VADC_G0RES0_type *) 0xf0022334u)	/* Group 7 Result Register 13 */
#define VADC_G7RES14	(*( VADC_G0RES0_type *) 0xf0022338u)	/* Group 7 Result Register 14 */
#define VADC_G7RES15	(*( VADC_G0RES0_type *) 0xf002233cu)	/* Group 7 Result Register 15 */
#define VADC_G7RES2	(*( VADC_G0RES0_type *) 0xf0022308u)	/* Group 7 Result Register 2 */
#define VADC_G7RES3	(*( VADC_G0RES0_type *) 0xf002230cu)	/* Group 7 Result Register 3 */
#define VADC_G7RES4	(*( VADC_G0RES0_type *) 0xf0022310u)	/* Group 7 Result Register 4 */
#define VADC_G7RES5	(*( VADC_G0RES0_type *) 0xf0022314u)	/* Group 7 Result Register 5 */
#define VADC_G7RES6	(*( VADC_G0RES0_type *) 0xf0022318u)	/* Group 7 Result Register 6 */
#define VADC_G7RES7	(*( VADC_G0RES0_type *) 0xf002231cu)	/* Group 7 Result Register 7 */
#define VADC_G7RES8	(*( VADC_G0RES0_type *) 0xf0022320u)	/* Group 7 Result Register 8 */
#define VADC_G7RES9	(*( VADC_G0RES0_type *) 0xf0022324u)	/* Group 7 Result Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RESULT         : 16;	/* Result of Most Recent Conversion */
		/* const */ unsigned int DRC            : 4;	/* Data Reduction Counter */
		/* const */ unsigned int CHNR           : 5;	/* Channel Number */
		/* const */ unsigned int EMUX           : 3;	/* External Multiplexer Setting */
		/* const */ unsigned int CRS            : 2;	/* Converted Request Source */
		/* const */ unsigned int FCR            : 1;	/* Fast Compare Result */
		/* const */ unsigned int VF             : 1;	/* Valid Flag */
	} B;
	int I;
	unsigned int U;

} VADC_G0RESD0_type;
#define VADC_G0RESD0	(*( VADC_G0RESD0_type *) 0xf0020780u)	/* Group 0 Result Reg. 0, Debug */
#define VADC_G0RESD1	(*( VADC_G0RESD0_type *) 0xf0020784u)	/* Group 0 Result Reg. 1, Debug */
#define VADC_G0RESD10	(*( VADC_G0RESD0_type *) 0xf00207a8u)	/* Group 0 Result Reg. 10, Debug */
#define VADC_G0RESD11	(*( VADC_G0RESD0_type *) 0xf00207acu)	/* Group 0 Result Reg. 11, Debug */
#define VADC_G0RESD12	(*( VADC_G0RESD0_type *) 0xf00207b0u)	/* Group 0 Result Reg. 12, Debug */
#define VADC_G0RESD13	(*( VADC_G0RESD0_type *) 0xf00207b4u)	/* Group 0 Result Reg. 13, Debug */
#define VADC_G0RESD14	(*( VADC_G0RESD0_type *) 0xf00207b8u)	/* Group 0 Result Reg. 14, Debug */
#define VADC_G0RESD15	(*( VADC_G0RESD0_type *) 0xf00207bcu)	/* Group 0 Result Reg. 15, Debug */
#define VADC_G0RESD2	(*( VADC_G0RESD0_type *) 0xf0020788u)	/* Group 0 Result Reg. 2, Debug */
#define VADC_G0RESD3	(*( VADC_G0RESD0_type *) 0xf002078cu)	/* Group 0 Result Reg. 3, Debug */
#define VADC_G0RESD4	(*( VADC_G0RESD0_type *) 0xf0020790u)	/* Group 0 Result Reg. 4, Debug */
#define VADC_G0RESD5	(*( VADC_G0RESD0_type *) 0xf0020794u)	/* Group 0 Result Reg. 5, Debug */
#define VADC_G0RESD6	(*( VADC_G0RESD0_type *) 0xf0020798u)	/* Group 0 Result Reg. 6, Debug */
#define VADC_G0RESD7	(*( VADC_G0RESD0_type *) 0xf002079cu)	/* Group 0 Result Reg. 7, Debug */
#define VADC_G0RESD8	(*( VADC_G0RESD0_type *) 0xf00207a0u)	/* Group 0 Result Reg. 8, Debug */
#define VADC_G0RESD9	(*( VADC_G0RESD0_type *) 0xf00207a4u)	/* Group 0 Result Reg. 9, Debug */
#define VADC_G1RESD0	(*( VADC_G0RESD0_type *) 0xf0020b80u)	/* Group 1 Result Reg. 0, Debug */
#define VADC_G1RESD1	(*( VADC_G0RESD0_type *) 0xf0020b84u)	/* Group 1 Result Reg. 1, Debug */
#define VADC_G1RESD10	(*( VADC_G0RESD0_type *) 0xf0020ba8u)	/* Group 1 Result Reg. 10, Debug */
#define VADC_G1RESD11	(*( VADC_G0RESD0_type *) 0xf0020bacu)	/* Group 1 Result Reg. 11, Debug */
#define VADC_G1RESD12	(*( VADC_G0RESD0_type *) 0xf0020bb0u)	/* Group 1 Result Reg. 12, Debug */
#define VADC_G1RESD13	(*( VADC_G0RESD0_type *) 0xf0020bb4u)	/* Group 1 Result Reg. 13, Debug */
#define VADC_G1RESD14	(*( VADC_G0RESD0_type *) 0xf0020bb8u)	/* Group 1 Result Reg. 14, Debug */
#define VADC_G1RESD15	(*( VADC_G0RESD0_type *) 0xf0020bbcu)	/* Group 1 Result Reg. 15, Debug */
#define VADC_G1RESD2	(*( VADC_G0RESD0_type *) 0xf0020b88u)	/* Group 1 Result Reg. 2, Debug */
#define VADC_G1RESD3	(*( VADC_G0RESD0_type *) 0xf0020b8cu)	/* Group 1 Result Reg. 3, Debug */
#define VADC_G1RESD4	(*( VADC_G0RESD0_type *) 0xf0020b90u)	/* Group 1 Result Reg. 4, Debug */
#define VADC_G1RESD5	(*( VADC_G0RESD0_type *) 0xf0020b94u)	/* Group 1 Result Reg. 5, Debug */
#define VADC_G1RESD6	(*( VADC_G0RESD0_type *) 0xf0020b98u)	/* Group 1 Result Reg. 6, Debug */
#define VADC_G1RESD7	(*( VADC_G0RESD0_type *) 0xf0020b9cu)	/* Group 1 Result Reg. 7, Debug */
#define VADC_G1RESD8	(*( VADC_G0RESD0_type *) 0xf0020ba0u)	/* Group 1 Result Reg. 8, Debug */
#define VADC_G1RESD9	(*( VADC_G0RESD0_type *) 0xf0020ba4u)	/* Group 1 Result Reg. 9, Debug */
#define VADC_G2RESD0	(*( VADC_G0RESD0_type *) 0xf0020f80u)	/* Group 2 Result Reg. 0, Debug */
#define VADC_G2RESD1	(*( VADC_G0RESD0_type *) 0xf0020f84u)	/* Group 2 Result Reg. 1, Debug */
#define VADC_G2RESD10	(*( VADC_G0RESD0_type *) 0xf0020fa8u)	/* Group 2 Result Reg. 10, Debug */
#define VADC_G2RESD11	(*( VADC_G0RESD0_type *) 0xf0020facu)	/* Group 2 Result Reg. 11, Debug */
#define VADC_G2RESD12	(*( VADC_G0RESD0_type *) 0xf0020fb0u)	/* Group 2 Result Reg. 12, Debug */
#define VADC_G2RESD13	(*( VADC_G0RESD0_type *) 0xf0020fb4u)	/* Group 2 Result Reg. 13, Debug */
#define VADC_G2RESD14	(*( VADC_G0RESD0_type *) 0xf0020fb8u)	/* Group 2 Result Reg. 14, Debug */
#define VADC_G2RESD15	(*( VADC_G0RESD0_type *) 0xf0020fbcu)	/* Group 2 Result Reg. 15, Debug */
#define VADC_G2RESD2	(*( VADC_G0RESD0_type *) 0xf0020f88u)	/* Group 2 Result Reg. 2, Debug */
#define VADC_G2RESD3	(*( VADC_G0RESD0_type *) 0xf0020f8cu)	/* Group 2 Result Reg. 3, Debug */
#define VADC_G2RESD4	(*( VADC_G0RESD0_type *) 0xf0020f90u)	/* Group 2 Result Reg. 4, Debug */
#define VADC_G2RESD5	(*( VADC_G0RESD0_type *) 0xf0020f94u)	/* Group 2 Result Reg. 5, Debug */
#define VADC_G2RESD6	(*( VADC_G0RESD0_type *) 0xf0020f98u)	/* Group 2 Result Reg. 6, Debug */
#define VADC_G2RESD7	(*( VADC_G0RESD0_type *) 0xf0020f9cu)	/* Group 2 Result Reg. 7, Debug */
#define VADC_G2RESD8	(*( VADC_G0RESD0_type *) 0xf0020fa0u)	/* Group 2 Result Reg. 8, Debug */
#define VADC_G2RESD9	(*( VADC_G0RESD0_type *) 0xf0020fa4u)	/* Group 2 Result Reg. 9, Debug */
#define VADC_G3RESD0	(*( VADC_G0RESD0_type *) 0xf0021380u)	/* Group 3 Result Reg. 0, Debug */
#define VADC_G3RESD1	(*( VADC_G0RESD0_type *) 0xf0021384u)	/* Group 3 Result Reg. 1, Debug */
#define VADC_G3RESD10	(*( VADC_G0RESD0_type *) 0xf00213a8u)	/* Group 3 Result Reg. 10, Debug */
#define VADC_G3RESD11	(*( VADC_G0RESD0_type *) 0xf00213acu)	/* Group 3 Result Reg. 11, Debug */
#define VADC_G3RESD12	(*( VADC_G0RESD0_type *) 0xf00213b0u)	/* Group 3 Result Reg. 12, Debug */
#define VADC_G3RESD13	(*( VADC_G0RESD0_type *) 0xf00213b4u)	/* Group 3 Result Reg. 13, Debug */
#define VADC_G3RESD14	(*( VADC_G0RESD0_type *) 0xf00213b8u)	/* Group 3 Result Reg. 14, Debug */
#define VADC_G3RESD15	(*( VADC_G0RESD0_type *) 0xf00213bcu)	/* Group 3 Result Reg. 15, Debug */
#define VADC_G3RESD2	(*( VADC_G0RESD0_type *) 0xf0021388u)	/* Group 3 Result Reg. 2, Debug */
#define VADC_G3RESD3	(*( VADC_G0RESD0_type *) 0xf002138cu)	/* Group 3 Result Reg. 3, Debug */
#define VADC_G3RESD4	(*( VADC_G0RESD0_type *) 0xf0021390u)	/* Group 3 Result Reg. 4, Debug */
#define VADC_G3RESD5	(*( VADC_G0RESD0_type *) 0xf0021394u)	/* Group 3 Result Reg. 5, Debug */
#define VADC_G3RESD6	(*( VADC_G0RESD0_type *) 0xf0021398u)	/* Group 3 Result Reg. 6, Debug */
#define VADC_G3RESD7	(*( VADC_G0RESD0_type *) 0xf002139cu)	/* Group 3 Result Reg. 7, Debug */
#define VADC_G3RESD8	(*( VADC_G0RESD0_type *) 0xf00213a0u)	/* Group 3 Result Reg. 8, Debug */
#define VADC_G3RESD9	(*( VADC_G0RESD0_type *) 0xf00213a4u)	/* Group 3 Result Reg. 9, Debug */
#define VADC_G4RESD0	(*( VADC_G0RESD0_type *) 0xf0021780u)	/* Group 4 Result Reg. 0, Debug */
#define VADC_G4RESD1	(*( VADC_G0RESD0_type *) 0xf0021784u)	/* Group 4 Result Reg. 1, Debug */
#define VADC_G4RESD10	(*( VADC_G0RESD0_type *) 0xf00217a8u)	/* Group 4 Result Reg. 10, Debug */
#define VADC_G4RESD11	(*( VADC_G0RESD0_type *) 0xf00217acu)	/* Group 4 Result Reg. 11, Debug */
#define VADC_G4RESD12	(*( VADC_G0RESD0_type *) 0xf00217b0u)	/* Group 4 Result Reg. 12, Debug */
#define VADC_G4RESD13	(*( VADC_G0RESD0_type *) 0xf00217b4u)	/* Group 4 Result Reg. 13, Debug */
#define VADC_G4RESD14	(*( VADC_G0RESD0_type *) 0xf00217b8u)	/* Group 4 Result Reg. 14, Debug */
#define VADC_G4RESD15	(*( VADC_G0RESD0_type *) 0xf00217bcu)	/* Group 4 Result Reg. 15, Debug */
#define VADC_G4RESD2	(*( VADC_G0RESD0_type *) 0xf0021788u)	/* Group 4 Result Reg. 2, Debug */
#define VADC_G4RESD3	(*( VADC_G0RESD0_type *) 0xf002178cu)	/* Group 4 Result Reg. 3, Debug */
#define VADC_G4RESD4	(*( VADC_G0RESD0_type *) 0xf0021790u)	/* Group 4 Result Reg. 4, Debug */
#define VADC_G4RESD5	(*( VADC_G0RESD0_type *) 0xf0021794u)	/* Group 4 Result Reg. 5, Debug */
#define VADC_G4RESD6	(*( VADC_G0RESD0_type *) 0xf0021798u)	/* Group 4 Result Reg. 6, Debug */
#define VADC_G4RESD7	(*( VADC_G0RESD0_type *) 0xf002179cu)	/* Group 4 Result Reg. 7, Debug */
#define VADC_G4RESD8	(*( VADC_G0RESD0_type *) 0xf00217a0u)	/* Group 4 Result Reg. 8, Debug */
#define VADC_G4RESD9	(*( VADC_G0RESD0_type *) 0xf00217a4u)	/* Group 4 Result Reg. 9, Debug */
#define VADC_G5RESD0	(*( VADC_G0RESD0_type *) 0xf0021b80u)	/* Group 5 Result Reg. 0, Debug */
#define VADC_G5RESD1	(*( VADC_G0RESD0_type *) 0xf0021b84u)	/* Group 5 Result Reg. 1, Debug */
#define VADC_G5RESD10	(*( VADC_G0RESD0_type *) 0xf0021ba8u)	/* Group 5 Result Reg. 10, Debug */
#define VADC_G5RESD11	(*( VADC_G0RESD0_type *) 0xf0021bacu)	/* Group 5 Result Reg. 11, Debug */
#define VADC_G5RESD12	(*( VADC_G0RESD0_type *) 0xf0021bb0u)	/* Group 5 Result Reg. 12, Debug */
#define VADC_G5RESD13	(*( VADC_G0RESD0_type *) 0xf0021bb4u)	/* Group 5 Result Reg. 13, Debug */
#define VADC_G5RESD14	(*( VADC_G0RESD0_type *) 0xf0021bb8u)	/* Group 5 Result Reg. 14, Debug */
#define VADC_G5RESD15	(*( VADC_G0RESD0_type *) 0xf0021bbcu)	/* Group 5 Result Reg. 15, Debug */
#define VADC_G5RESD2	(*( VADC_G0RESD0_type *) 0xf0021b88u)	/* Group 5 Result Reg. 2, Debug */
#define VADC_G5RESD3	(*( VADC_G0RESD0_type *) 0xf0021b8cu)	/* Group 5 Result Reg. 3, Debug */
#define VADC_G5RESD4	(*( VADC_G0RESD0_type *) 0xf0021b90u)	/* Group 5 Result Reg. 4, Debug */
#define VADC_G5RESD5	(*( VADC_G0RESD0_type *) 0xf0021b94u)	/* Group 5 Result Reg. 5, Debug */
#define VADC_G5RESD6	(*( VADC_G0RESD0_type *) 0xf0021b98u)	/* Group 5 Result Reg. 6, Debug */
#define VADC_G5RESD7	(*( VADC_G0RESD0_type *) 0xf0021b9cu)	/* Group 5 Result Reg. 7, Debug */
#define VADC_G5RESD8	(*( VADC_G0RESD0_type *) 0xf0021ba0u)	/* Group 5 Result Reg. 8, Debug */
#define VADC_G5RESD9	(*( VADC_G0RESD0_type *) 0xf0021ba4u)	/* Group 5 Result Reg. 9, Debug */
#define VADC_G6RESD0	(*( VADC_G0RESD0_type *) 0xf0021f80u)	/* Group 6 Result Reg. 0, Debug */
#define VADC_G6RESD1	(*( VADC_G0RESD0_type *) 0xf0021f84u)	/* Group 6 Result Reg. 1, Debug */
#define VADC_G6RESD10	(*( VADC_G0RESD0_type *) 0xf0021fa8u)	/* Group 6 Result Reg. 10, Debug */
#define VADC_G6RESD11	(*( VADC_G0RESD0_type *) 0xf0021facu)	/* Group 6 Result Reg. 11, Debug */
#define VADC_G6RESD12	(*( VADC_G0RESD0_type *) 0xf0021fb0u)	/* Group 6 Result Reg. 12, Debug */
#define VADC_G6RESD13	(*( VADC_G0RESD0_type *) 0xf0021fb4u)	/* Group 6 Result Reg. 13, Debug */
#define VADC_G6RESD14	(*( VADC_G0RESD0_type *) 0xf0021fb8u)	/* Group 6 Result Reg. 14, Debug */
#define VADC_G6RESD15	(*( VADC_G0RESD0_type *) 0xf0021fbcu)	/* Group 6 Result Reg. 15, Debug */
#define VADC_G6RESD2	(*( VADC_G0RESD0_type *) 0xf0021f88u)	/* Group 6 Result Reg. 2, Debug */
#define VADC_G6RESD3	(*( VADC_G0RESD0_type *) 0xf0021f8cu)	/* Group 6 Result Reg. 3, Debug */
#define VADC_G6RESD4	(*( VADC_G0RESD0_type *) 0xf0021f90u)	/* Group 6 Result Reg. 4, Debug */
#define VADC_G6RESD5	(*( VADC_G0RESD0_type *) 0xf0021f94u)	/* Group 6 Result Reg. 5, Debug */
#define VADC_G6RESD6	(*( VADC_G0RESD0_type *) 0xf0021f98u)	/* Group 6 Result Reg. 6, Debug */
#define VADC_G6RESD7	(*( VADC_G0RESD0_type *) 0xf0021f9cu)	/* Group 6 Result Reg. 7, Debug */
#define VADC_G6RESD8	(*( VADC_G0RESD0_type *) 0xf0021fa0u)	/* Group 6 Result Reg. 8, Debug */
#define VADC_G6RESD9	(*( VADC_G0RESD0_type *) 0xf0021fa4u)	/* Group 6 Result Reg. 9, Debug */
#define VADC_G7RESD0	(*( VADC_G0RESD0_type *) 0xf0022380u)	/* Group 7 Result Reg. 0, Debug */
#define VADC_G7RESD1	(*( VADC_G0RESD0_type *) 0xf0022384u)	/* Group 7 Result Reg. 1, Debug */
#define VADC_G7RESD10	(*( VADC_G0RESD0_type *) 0xf00223a8u)	/* Group 7 Result Reg. 10, Debug */
#define VADC_G7RESD11	(*( VADC_G0RESD0_type *) 0xf00223acu)	/* Group 7 Result Reg. 11, Debug */
#define VADC_G7RESD12	(*( VADC_G0RESD0_type *) 0xf00223b0u)	/* Group 7 Result Reg. 12, Debug */
#define VADC_G7RESD13	(*( VADC_G0RESD0_type *) 0xf00223b4u)	/* Group 7 Result Reg. 13, Debug */
#define VADC_G7RESD14	(*( VADC_G0RESD0_type *) 0xf00223b8u)	/* Group 7 Result Reg. 14, Debug */
#define VADC_G7RESD15	(*( VADC_G0RESD0_type *) 0xf00223bcu)	/* Group 7 Result Reg. 15, Debug */
#define VADC_G7RESD2	(*( VADC_G0RESD0_type *) 0xf0022388u)	/* Group 7 Result Reg. 2, Debug */
#define VADC_G7RESD3	(*( VADC_G0RESD0_type *) 0xf002238cu)	/* Group 7 Result Reg. 3, Debug */
#define VADC_G7RESD4	(*( VADC_G0RESD0_type *) 0xf0022390u)	/* Group 7 Result Reg. 4, Debug */
#define VADC_G7RESD5	(*( VADC_G0RESD0_type *) 0xf0022394u)	/* Group 7 Result Reg. 5, Debug */
#define VADC_G7RESD6	(*( VADC_G0RESD0_type *) 0xf0022398u)	/* Group 7 Result Reg. 6, Debug */
#define VADC_G7RESD7	(*( VADC_G0RESD0_type *) 0xf002239cu)	/* Group 7 Result Reg. 7, Debug */
#define VADC_G7RESD8	(*( VADC_G0RESD0_type *) 0xf00223a0u)	/* Group 7 Result Reg. 8, Debug */
#define VADC_G7RESD9	(*( VADC_G0RESD0_type *) 0xf00223a4u)	/* Group 7 Result Reg. 9, Debug */

typedef volatile union
{
	struct
	{ 
		unsigned int REV0NP         : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV1NP         : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV2NP         : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV3NP         : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV4NP         : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV5NP         : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV6NP         : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV7NP         : 4;	/* Service Request Node Pointer Result Event i */
	} B;
	int I;
	unsigned int U;

} VADC_G0REVNP0_type;
#define VADC_G0REVNP0	(*( VADC_G0REVNP0_type *) 0xf00205b0u)	/* Result Event Node Pointer Register 0, Group 0 */
#define VADC_G1REVNP0	(*( VADC_G0REVNP0_type *) 0xf00209b0u)	/* Result Event Node Pointer Register 0, Group 1 */
#define VADC_G2REVNP0	(*( VADC_G0REVNP0_type *) 0xf0020db0u)	/* Result Event Node Pointer Register 0, Group 2 */
#define VADC_G3REVNP0	(*( VADC_G0REVNP0_type *) 0xf00211b0u)	/* Result Event Node Pointer Register 0, Group 3 */
#define VADC_G4REVNP0	(*( VADC_G0REVNP0_type *) 0xf00215b0u)	/* Result Event Node Pointer Register 0, Group 4 */
#define VADC_G5REVNP0	(*( VADC_G0REVNP0_type *) 0xf00219b0u)	/* Result Event Node Pointer Register 0, Group 5 */
#define VADC_G6REVNP0	(*( VADC_G0REVNP0_type *) 0xf0021db0u)	/* Result Event Node Pointer Register 0, Group 6 */
#define VADC_G7REVNP0	(*( VADC_G0REVNP0_type *) 0xf00221b0u)	/* Result Event Node Pointer Register 0, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int REV8NP         : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV9NP         : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV10NP        : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV11NP        : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV12NP        : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV13NP        : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV14NP        : 4;	/* Service Request Node Pointer Result Event i */
		unsigned int REV15NP        : 4;	/* Service Request Node Pointer Result Event i */
	} B;
	int I;
	unsigned int U;

} VADC_G0REVNP1_type;
#define VADC_G0REVNP1	(*( VADC_G0REVNP1_type *) 0xf00205b4u)	/* Result Event Node Pointer Register 1, Group 0 */
#define VADC_G1REVNP1	(*( VADC_G0REVNP1_type *) 0xf00209b4u)	/* Result Event Node Pointer Register 1, Group 1 */
#define VADC_G2REVNP1	(*( VADC_G0REVNP1_type *) 0xf0020db4u)	/* Result Event Node Pointer Register 1, Group 2 */
#define VADC_G3REVNP1	(*( VADC_G0REVNP1_type *) 0xf00211b4u)	/* Result Event Node Pointer Register 1, Group 3 */
#define VADC_G4REVNP1	(*( VADC_G0REVNP1_type *) 0xf00215b4u)	/* Result Event Node Pointer Register 1, Group 4 */
#define VADC_G5REVNP1	(*( VADC_G0REVNP1_type *) 0xf00219b4u)	/* Result Event Node Pointer Register 1, Group 5 */
#define VADC_G6REVNP1	(*( VADC_G0REVNP1_type *) 0xf0021db4u)	/* Result Event Node Pointer Register 1, Group 6 */
#define VADC_G7REVNP1	(*( VADC_G0REVNP1_type *) 0xf00221b4u)	/* Result Event Node Pointer Register 1, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int SEV0           : 1;	/* Clear Source Event 0/1 */
		unsigned int SEV1           : 1;	/* Clear Source Event 0/1 */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} VADC_G0SEFCLR_type;
#define VADC_G0SEFCLR	(*( VADC_G0SEFCLR_type *) 0xf0020598u)	/* Source Event Flag Clear Register, Group 0 */
#define VADC_G1SEFCLR	(*( VADC_G0SEFCLR_type *) 0xf0020998u)	/* Source Event Flag Clear Register, Group 1 */
#define VADC_G2SEFCLR	(*( VADC_G0SEFCLR_type *) 0xf0020d98u)	/* Source Event Flag Clear Register, Group 2 */
#define VADC_G3SEFCLR	(*( VADC_G0SEFCLR_type *) 0xf0021198u)	/* Source Event Flag Clear Register, Group 3 */
#define VADC_G4SEFCLR	(*( VADC_G0SEFCLR_type *) 0xf0021598u)	/* Source Event Flag Clear Register, Group 4 */
#define VADC_G5SEFCLR	(*( VADC_G0SEFCLR_type *) 0xf0021998u)	/* Source Event Flag Clear Register, Group 5 */
#define VADC_G6SEFCLR	(*( VADC_G0SEFCLR_type *) 0xf0021d98u)	/* Source Event Flag Clear Register, Group 6 */
#define VADC_G7SEFCLR	(*( VADC_G0SEFCLR_type *) 0xf0022198u)	/* Source Event Flag Clear Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int SEV0           : 1;	/* Source Event 0/1 */
		unsigned int SEV1           : 1;	/* Source Event 0/1 */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} VADC_G0SEFLAG_type;
#define VADC_G0SEFLAG	(*( VADC_G0SEFLAG_type *) 0xf0020588u)	/* Source Event Flag Register, Group 0 */
#define VADC_G1SEFLAG	(*( VADC_G0SEFLAG_type *) 0xf0020988u)	/* Source Event Flag Register, Group 1 */
#define VADC_G2SEFLAG	(*( VADC_G0SEFLAG_type *) 0xf0020d88u)	/* Source Event Flag Register, Group 2 */
#define VADC_G3SEFLAG	(*( VADC_G0SEFLAG_type *) 0xf0021188u)	/* Source Event Flag Register, Group 3 */
#define VADC_G4SEFLAG	(*( VADC_G0SEFLAG_type *) 0xf0021588u)	/* Source Event Flag Register, Group 4 */
#define VADC_G5SEFLAG	(*( VADC_G0SEFLAG_type *) 0xf0021988u)	/* Source Event Flag Register, Group 5 */
#define VADC_G6SEFLAG	(*( VADC_G0SEFLAG_type *) 0xf0021d88u)	/* Source Event Flag Register, Group 6 */
#define VADC_G7SEFLAG	(*( VADC_G0SEFLAG_type *) 0xf0022188u)	/* Source Event Flag Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int SEV0NP         : 4;	/* Service Request Node Pointer Source Event i */
		unsigned int SEV1NP         : 4;	/* Service Request Node Pointer Source Event i */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} VADC_G0SEVNP_type;
#define VADC_G0SEVNP	(*( VADC_G0SEVNP_type *) 0xf00205c0u)	/* Source Event Node Pointer Register, Group 0 */
#define VADC_G1SEVNP	(*( VADC_G0SEVNP_type *) 0xf00209c0u)	/* Source Event Node Pointer Register, Group 1 */
#define VADC_G2SEVNP	(*( VADC_G0SEVNP_type *) 0xf0020dc0u)	/* Source Event Node Pointer Register, Group 2 */
#define VADC_G3SEVNP	(*( VADC_G0SEVNP_type *) 0xf00211c0u)	/* Source Event Node Pointer Register, Group 3 */
#define VADC_G4SEVNP	(*( VADC_G0SEVNP_type *) 0xf00215c0u)	/* Source Event Node Pointer Register, Group 4 */
#define VADC_G5SEVNP	(*( VADC_G0SEVNP_type *) 0xf00219c0u)	/* Source Event Node Pointer Register, Group 5 */
#define VADC_G6SEVNP	(*( VADC_G0SEVNP_type *) 0xf0021dc0u)	/* Source Event Node Pointer Register, Group 6 */
#define VADC_G7SEVNP	(*( VADC_G0SEVNP_type *) 0xf00221c0u)	/* Source Event Node Pointer Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int AGSR0          : 1;	/* Activate Group Service Request Node y */
		unsigned int AGSR1          : 1;	/* Activate Group Service Request Node y */
		unsigned int AGSR2          : 1;	/* Activate Group Service Request Node y */
		unsigned int AGSR3          : 1;	/* Activate Group Service Request Node y */
		unsigned int                : 4;
		unsigned int ASSR0          : 1;	/* Activate Shared Service Request Node y */
		unsigned int ASSR1          : 1;	/* Activate Shared Service Request Node y */
		unsigned int ASSR2          : 1;	/* Activate Shared Service Request Node y */
		unsigned int ASSR3          : 1;	/* Activate Shared Service Request Node y */
		unsigned int                : 20;
	} B;
	int I;
	unsigned int U;

} VADC_G0SRACT_type;
#define VADC_G0SRACT	(*( VADC_G0SRACT_type *) 0xf00205c8u)	/* Service Request Software Activation Trigger, Group 0 */
#define VADC_G1SRACT	(*( VADC_G0SRACT_type *) 0xf00209c8u)	/* Service Request Software Activation Trigger, Group 1 */
#define VADC_G2SRACT	(*( VADC_G0SRACT_type *) 0xf0020dc8u)	/* Service Request Software Activation Trigger, Group 2 */
#define VADC_G3SRACT	(*( VADC_G0SRACT_type *) 0xf00211c8u)	/* Service Request Software Activation Trigger, Group 3 */
#define VADC_G4SRACT	(*( VADC_G0SRACT_type *) 0xf00215c8u)	/* Service Request Software Activation Trigger, Group 4 */
#define VADC_G5SRACT	(*( VADC_G0SRACT_type *) 0xf00219c8u)	/* Service Request Software Activation Trigger, Group 5 */
#define VADC_G6SRACT	(*( VADC_G0SRACT_type *) 0xf0021dc8u)	/* Service Request Software Activation Trigger, Group 6 */
#define VADC_G7SRACT	(*( VADC_G0SRACT_type *) 0xf00221c8u)	/* Service Request Software Activation Trigger, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int STSEL          : 2;	/* Start Selection */
		unsigned int                : 2;
		unsigned int EVALR1         : 1;	/* Evaluate Ready Input Rx */
		unsigned int EVALR2         : 1;	/* Evaluate Ready Input Rx */
		unsigned int EVALR3         : 1;	/* Evaluate Ready Input Rx */
		unsigned int                : 25;
	} B;
	int I;
	unsigned int U;

} VADC_G0SYNCTR_type;
#define VADC_G0SYNCTR	(*( VADC_G0SYNCTR_type *) 0xf00204c0u)	/* Synchronization Control Register, Group 0 */
#define VADC_G1SYNCTR	(*( VADC_G0SYNCTR_type *) 0xf00208c0u)	/* Synchronization Control Register, Group 1 */
#define VADC_G2SYNCTR	(*( VADC_G0SYNCTR_type *) 0xf0020cc0u)	/* Synchronization Control Register, Group 2 */
#define VADC_G3SYNCTR	(*( VADC_G0SYNCTR_type *) 0xf00210c0u)	/* Synchronization Control Register, Group 3 */
#define VADC_G4SYNCTR	(*( VADC_G0SYNCTR_type *) 0xf00214c0u)	/* Synchronization Control Register, Group 4 */
#define VADC_G5SYNCTR	(*( VADC_G0SYNCTR_type *) 0xf00218c0u)	/* Synchronization Control Register, Group 5 */
#define VADC_G6SYNCTR	(*( VADC_G0SYNCTR_type *) 0xf0021cc0u)	/* Synchronization Control Register, Group 6 */
#define VADC_G7SYNCTR	(*( VADC_G0SYNCTR_type *) 0xf00220c0u)	/* Synchronization Control Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int VF0            : 1;	/* Valid Flag of Result Register x */
		unsigned int VF1            : 1;	/* Valid Flag of Result Register x */
		unsigned int VF2            : 1;	/* Valid Flag of Result Register x */
		unsigned int VF3            : 1;	/* Valid Flag of Result Register x */
		unsigned int VF4            : 1;	/* Valid Flag of Result Register x */
		unsigned int VF5            : 1;	/* Valid Flag of Result Register x */
		unsigned int VF6            : 1;	/* Valid Flag of Result Register x */
		unsigned int VF7            : 1;	/* Valid Flag of Result Register x */
		unsigned int VF8            : 1;	/* Valid Flag of Result Register x */
		unsigned int VF9            : 1;	/* Valid Flag of Result Register x */
		unsigned int VF10           : 1;	/* Valid Flag of Result Register x */
		unsigned int VF11           : 1;	/* Valid Flag of Result Register x */
		unsigned int VF12           : 1;	/* Valid Flag of Result Register x */
		unsigned int VF13           : 1;	/* Valid Flag of Result Register x */
		unsigned int VF14           : 1;	/* Valid Flag of Result Register x */
		unsigned int VF15           : 1;	/* Valid Flag of Result Register x */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} VADC_G0VFR_type;
#define VADC_G0VFR	(*( VADC_G0VFR_type *) 0xf00205f8u)	/* Valid Flag Register, Group 0 */
#define VADC_G1VFR	(*( VADC_G0VFR_type *) 0xf00209f8u)	/* Valid Flag Register, Group 1 */
#define VADC_G2VFR	(*( VADC_G0VFR_type *) 0xf0020df8u)	/* Valid Flag Register, Group 2 */
#define VADC_G3VFR	(*( VADC_G0VFR_type *) 0xf00211f8u)	/* Valid Flag Register, Group 3 */
#define VADC_G4VFR	(*( VADC_G0VFR_type *) 0xf00215f8u)	/* Valid Flag Register, Group 4 */
#define VADC_G5VFR	(*( VADC_G0VFR_type *) 0xf00219f8u)	/* Valid Flag Register, Group 5 */
#define VADC_G6VFR	(*( VADC_G0VFR_type *) 0xf0021df8u)	/* Valid Flag Register, Group 6 */
#define VADC_G7VFR	(*( VADC_G0VFR_type *) 0xf00221f8u)	/* Valid Flag Register, Group 7 */

typedef volatile union
{
	struct
	{ 
		unsigned int DIVA           : 5;	/* Divider Factor for the Analog Internal Clock */
		unsigned int                : 2;
		unsigned int DCMSB          : 1;	/* Double Clock for the MSB Conversion */
		unsigned int DIVD           : 2;	/* Divider Factor for the Arbiter Clock */
		unsigned int                : 5;
		unsigned int DIVWC          : 1;	/* Write Control for Divider Parameters */
		unsigned int DPCAL0         : 1;	/* Disable Post-Calibration */
		unsigned int DPCAL1         : 1;	/* Disable Post-Calibration */
		unsigned int DPCAL2         : 1;	/* Disable Post-Calibration */
		unsigned int DPCAL3         : 1;	/* Disable Post-Calibration */
		unsigned int                : 11;
		unsigned int SUCAL          : 1;	/* Start-Up Calibration */
	} B;
	int I;
	unsigned int U;

} VADC_GLOBCFG_type;
#define VADC_GLOBCFG	(*( VADC_GLOBCFG_type *) 0xf0020080u)	/* Global Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEVGLB         : 1;	/* Source Event (Background) */
		unsigned int                : 7;
		unsigned int REVGLB         : 1;	/* Global Result Event */
		unsigned int                : 7;
		unsigned int SEVGLBCLR      : 1;	/* Clear Source Event (Background) */
		unsigned int                : 7;
		unsigned int REVGLBCLR      : 1;	/* Clear Global Result Event */
		unsigned int                : 7;
	} B;
	int I;
	unsigned int U;

} VADC_GLOBEFLAG_type;
#define VADC_GLOBEFLAG	(*( VADC_GLOBEFLAG_type *) 0xf00200e0u)	/* Global Event Flag Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SEV0NP         : 4;	/* Service Request Node Pointer Backgr. Source */
		unsigned int                : 12;
		unsigned int REV0NP         : 4;	/* Service Request Node Pointer Backgr. Result */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} VADC_GLOBEVNP_type;
#define VADC_GLOBEVNP	(*( VADC_GLOBEVNP_type *) 0xf0020140u)	/* Global Event Node Pointer Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 16;
		unsigned int DRCTR          : 4;	/* Data Reduction Control */
		unsigned int                : 4;
		unsigned int WFR            : 1;	/* Wait-for-Read Mode Enable */
		unsigned int                : 6;
		unsigned int SRGEN          : 1;	/* Service Request Generation Enable */
	} B;
	int I;
	unsigned int U;

} VADC_GLOBRCR_type;
#define VADC_GLOBRCR	(*( VADC_GLOBRCR_type *) 0xf0020280u)	/* Global Result Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RESULT         : 16;	/* Result of most recent conversion */
		/* const */ unsigned int GNR            : 4;	/* Group Number */
		/* const */ unsigned int CHNR           : 5;	/* Channel Number */
		/* const */ unsigned int EMUX           : 3;	/* External Multiplexer Setting */
		/* const */ unsigned int CRS            : 2;	/* Converted Request Source */
		/* const */ unsigned int FCR            : 1;	/* Fast Compare Result */
		unsigned int VF             : 1;	/* Valid Flag */
	} B;
	int I;
	unsigned int U;

} VADC_GLOBRES_type;
#define VADC_GLOBRES	(*( VADC_GLOBRES_type *) 0xf0020300u)	/* Global Result Register */
#define VADC_GLOBRESD	(*( VADC_GLOBRES_type *) 0xf0020380u)	/* Global Result Register, Debug */

typedef volatile union
{
	struct
	{ 
		unsigned int CDCH           : 4;	/* Converter Diagnostics Channel */
		unsigned int CDGR           : 4;	/* Converter Diagnostics Group */
		unsigned int CDEN           : 1;	/* Converter Diagnostics Enable */
		unsigned int CDSEL          : 2;	/* Converter Diagnostics Pull-Devices Select */
		unsigned int                : 4;
		unsigned int CDWC           : 1;	/* Write Control for Conversion Diagnostics */
		unsigned int PDD            : 1;	/* Pull-Down Diagnostics Enable */
		unsigned int MDPD           : 1;	/* Multiplexer Diagnostics Pull-Devices Enable */
		unsigned int MDPU           : 1;	/* Multiplexer Diagnostics Pull-Devices Enable */
		unsigned int                : 4;
		unsigned int MDWC           : 1;	/* Write Control for Multiplexer Diagnostics */
		unsigned int TRSW           : 1;	/* Trigger Event via Software */
		unsigned int TREV           : 1;	/* Trigger Event Flag */
		unsigned int                : 3;
		unsigned int SRGMODE        : 2;	/* Service Request Generation Mode */
		unsigned int SRGWC          : 1;	/* Write Control for Service Request Gen. Mode */
	} B;
	int I;
	unsigned int U;

} VADC_GLOBTF_type;
#define VADC_GLOBTF	(*( VADC_GLOBTF_type *) 0xf0020160u)	/* Global Test Functions Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} VADC_ID_type;
#define VADC_ID	(*( VADC_ID_type *) 0xf0020008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} VADC_KRST0_type;
#define VADC_KRST0	(*( VADC_KRST0_type *) 0xf0020034u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} VADC_KRST1_type;
#define VADC_KRST1	(*( VADC_KRST1_type *) 0xf0020030u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} VADC_KRSTCLR_type;
#define VADC_KRSTCLR	(*( VADC_KRSTCLR_type *) 0xf002002cu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TGS            : 2;	/* Trigger Set for OTGB0/1 */
		unsigned int TGB            : 1;	/* OTGB0/1 Bus Select */
		unsigned int TG_P           : 1;	/* TGS, TGB Write Protection */
		unsigned int                : 20;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} VADC_OCS_type;
#define VADC_OCS	(*( VADC_OCS_type *) 0xf0020028u)	/* OCDS Control and Status Register */


/* DSADC */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} DSADC_ACCEN0_type;
#define DSADC_ACCEN0	(*( DSADC_ACCEN0_type *) 0xf002403cu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RG00           : 1;	/* Register Group x, Channels 0 - 3 */
		unsigned int RG01           : 1;	/* Register Group x, Channels 0 - 3 */
		unsigned int RG02           : 1;	/* Register Group x, Channels 0 - 3 */
		unsigned int RG03           : 1;	/* Register Group x, Channels 0 - 3 */
		unsigned int RG04           : 1;	/* Register Group x, Channels 0 - 3 */
		unsigned int                : 9;
		unsigned int RG10           : 1;	/* Register Group 0/1, General Control */
		unsigned int RG11           : 1;	/* Register Group 0/1, General Control */
		unsigned int RG40           : 1;	/* Register Group x, Channels 4 - 5 */
		unsigned int RG41           : 1;	/* Register Group x, Channels 4 - 5 */
		unsigned int RG42           : 1;	/* Register Group x, Channels 4 - 5 */
		unsigned int RG43           : 1;	/* Register Group x, Channels 4 - 5 */
		unsigned int RG44           : 1;	/* Register Group x, Channels 4 - 5 */
		unsigned int                : 11;
	} B;
	int I;
	unsigned int U;

} DSADC_ACCPROT_type;
#define DSADC_ACCPROT	(*( DSADC_ACCPROT_type *) 0xf0024090u)	/* Access Protection Register */

typedef volatile union
{
	struct
	{ 
		unsigned int BOUNDARYL      : 16;	/* Lower Boundary Value for Limit Checking */
		unsigned int BOUNDARYU      : 16;	/* Upper Boundary Value for Limit Checking */
	} B;
	int I;
	unsigned int U;

} DSADC_BOUNDSEL0_type;
#define DSADC_BOUNDSEL0	(*( DSADC_BOUNDSEL0_type *) 0xf0024128u)	/* Boundary Select Register 0 */
#define DSADC_BOUNDSEL1	(*( DSADC_BOUNDSEL0_type *) 0xf0024228u)	/* Boundary Select Register 1 */
#define DSADC_BOUNDSEL2	(*( DSADC_BOUNDSEL0_type *) 0xf0024328u)	/* Boundary Select Register 2 */
#define DSADC_BOUNDSEL3	(*( DSADC_BOUNDSEL0_type *) 0xf0024428u)	/* Boundary Select Register 3 */
#define DSADC_BOUNDSEL4	(*( DSADC_BOUNDSEL0_type *) 0xf0024528u)	/* Boundary Select Register 4 */
#define DSADC_BOUNDSEL5	(*( DSADC_BOUNDSEL0_type *) 0xf0024628u)	/* Boundary Select Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int CGMOD          : 2;	/* Carrier Generator Operating Mode */
		unsigned int BREV           : 1;	/* Bit-Reverse PWM Generation */
		unsigned int SIGPOL         : 1;	/* Signal Polarity */
		unsigned int DIVCG          : 4;	/* Divider Factor for the PWM Pattern Signal Generator */
		unsigned int                : 7;
		/* const */ unsigned int RUN            : 1;	/* Run Indicator */
		/* const */ unsigned int BITCOUNT       : 5;	/* Bit Counter */
		unsigned int                : 3;
		/* const */ unsigned int STEPCOUNT      : 4;	/* Step Counter */
		/* const */ unsigned int STEPS          : 1;	/* Step Counter Sign */
		/* const */ unsigned int STEPD          : 1;	/* Step Counter Direction */
		/* const */ unsigned int SGNCG          : 1;	/* Sign Signal from Carrier Generator */
		unsigned int                : 1;
	} B;
	int I;
	unsigned int U;

} DSADC_CGCFG_type;
#define DSADC_CGCFG	(*( DSADC_CGCFG_type *) 0xf00240a0u)	/* Carrier Generator Configuration Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SDCOUNT        : 8;	/* Sign Delay Counter */
		/* const */ unsigned int SDCAP          : 8;	/* Sign Delay Capture Value */
		unsigned int SDPOS          : 8;	/* Sign Delay Value for Positive Halfwave */
		unsigned int SDNEG          : 8;	/* Sign Delay Value for Negative Halfwave */
	} B;
	int I;
	unsigned int U;

} DSADC_CGSYNC0_type;
#define DSADC_CGSYNC0	(*( DSADC_CGSYNC0_type *) 0xf00241a0u)	/* Carrier Generator Synchronization Register 0 */
#define DSADC_CGSYNC1	(*( DSADC_CGSYNC0_type *) 0xf00242a0u)	/* Carrier Generator Synchronization Register 1 */
#define DSADC_CGSYNC2	(*( DSADC_CGSYNC0_type *) 0xf00243a0u)	/* Carrier Generator Synchronization Register 2 */
#define DSADC_CGSYNC3	(*( DSADC_CGSYNC0_type *) 0xf00244a0u)	/* Carrier Generator Synchronization Register 3 */
#define DSADC_CGSYNC4	(*( DSADC_CGSYNC0_type *) 0xf00245a0u)	/* Carrier Generator Synchronization Register 4 */
#define DSADC_CGSYNC5	(*( DSADC_CGSYNC0_type *) 0xf00246a0u)	/* Carrier Generator Synchronization Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} DSADC_CLC_type;
#define DSADC_CLC	(*( DSADC_CLC_type *) 0xf0024000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DSRC           : 4;	/* Input Data Source Select */
		unsigned int                : 3;
		unsigned int DSWC           : 1;	/* Write Control for Data Selection */
		unsigned int ITRMODE        : 2;	/* Integrator Trigger ModeThe integration trigger mode controls bit INTEN in register and hence the operation of the integrator: Bit INTEN is set when ITRMODE=11 or when the selected trigger signal transition occurs. Bit INTEN is cleared when ITRMODE=00 or when the inverse trigger signal transition occurs. */
		unsigned int TSTRMODE       : 2;	/* Timestamp Trigger ModeThe timestamp trigger mode controls capturing the timestamp information to register . */
		unsigned int TRSEL          : 3;	/* Trigger Select */
		unsigned int TRWC           : 1;	/* Write Control for Trigger Parameters */
		unsigned int CSRC           : 4;	/* Sample Clock Source Select */
		unsigned int STROBE         : 4;	/* Data Strobe Generation Mode */
		unsigned int                : 7;
		unsigned int SCWC           : 1;	/* Write Control for Strobe/Clock Selection */
	} B;
	int I;
	unsigned int U;

} DSADC_DICFG0_type;
#define DSADC_DICFG0	(*( DSADC_DICFG0_type *) 0xf0024108u)	/* Demodulator Input Configuration Register 0 */
#define DSADC_DICFG1	(*( DSADC_DICFG0_type *) 0xf0024208u)	/* Demodulator Input Configuration Register 1 */
#define DSADC_DICFG2	(*( DSADC_DICFG0_type *) 0xf0024308u)	/* Demodulator Input Configuration Register 2 */
#define DSADC_DICFG3	(*( DSADC_DICFG0_type *) 0xf0024408u)	/* Demodulator Input Configuration Register 3 */
#define DSADC_DICFG4	(*( DSADC_DICFG0_type *) 0xf0024508u)	/* Demodulator Input Configuration Register 4 */
#define DSADC_DICFG5	(*( DSADC_DICFG0_type *) 0xf0024608u)	/* Demodulator Input Configuration Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int RESEV0         : 1;	/* Result Event */
		unsigned int RESEV1         : 1;	/* Result Event */
		unsigned int RESEV2         : 1;	/* Result Event */
		unsigned int RESEV3         : 1;	/* Result Event */
		unsigned int RESEV4         : 1;	/* Result Event */
		unsigned int RESEV5         : 1;	/* Result Event */
		unsigned int                : 10;
		unsigned int ALEV0          : 1;	/* Alarm Event */
		unsigned int ALEV1          : 1;	/* Alarm Event */
		unsigned int ALEV2          : 1;	/* Alarm Event */
		unsigned int ALEV3          : 1;	/* Alarm Event */
		unsigned int ALEV4          : 1;	/* Alarm Event */
		unsigned int ALEV5          : 1;	/* Alarm Event */
		unsigned int                : 10;
	} B;
	int I;
	unsigned int U;

} DSADC_EVFLAG_type;
#define DSADC_EVFLAG	(*( DSADC_EVFLAG_type *) 0xf00240e0u)	/* Event Flag Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RESEC0         : 1;	/* Result Event Clear */
		unsigned int RESEC1         : 1;	/* Result Event Clear */
		unsigned int RESEC2         : 1;	/* Result Event Clear */
		unsigned int RESEC3         : 1;	/* Result Event Clear */
		unsigned int RESEC4         : 1;	/* Result Event Clear */
		unsigned int RESEC5         : 1;	/* Result Event Clear */
		unsigned int                : 10;
		unsigned int ALEC0          : 1;	/* Alarm Event Clear */
		unsigned int ALEC1          : 1;	/* Alarm Event Clear */
		unsigned int ALEC2          : 1;	/* Alarm Event Clear */
		unsigned int ALEC3          : 1;	/* Alarm Event Clear */
		unsigned int ALEC4          : 1;	/* Alarm Event Clear */
		unsigned int ALEC5          : 1;	/* Alarm Event Clear */
		unsigned int                : 10;
	} B;
	int I;
	unsigned int U;

} DSADC_EVFLAGCLR_type;
#define DSADC_EVFLAGCLR	(*( DSADC_EVFLAGCLR_type *) 0xf00240e4u)	/* Event Flag Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CFADF          : 8;	/* Comb Filter (Auxiliary) Decimation Factor */
		unsigned int CFAC           : 2;	/* Comb Filter (Auxiliary) Configuration */
		unsigned int SRGA           : 2;	/* Service Request Generation Auxiliary Filter */
		unsigned int ESEL           : 2;	/* Event Select */
		unsigned int EGT            : 1;	/* Event Gating */
		unsigned int                : 1;
		unsigned int AFSC           : 2;	/* Auxiliary Filter Shift Control */
		unsigned int                : 6;
		/* const */ unsigned int CFADCNT        : 8;	/* Comb Filter (Auxiliary) Decimation Counter */
	} B;
	int I;
	unsigned int U;

} DSADC_FCFGA0_type;
#define DSADC_FCFGA0	(*( DSADC_FCFGA0_type *) 0xf0024118u)	/* Filter Configuration Register 0, Auxiliary Filter */
#define DSADC_FCFGA1	(*( DSADC_FCFGA0_type *) 0xf0024218u)	/* Filter Configuration Register 1, Auxiliary Filter */
#define DSADC_FCFGA2	(*( DSADC_FCFGA0_type *) 0xf0024318u)	/* Filter Configuration Register 2, Auxiliary Filter */
#define DSADC_FCFGA3	(*( DSADC_FCFGA0_type *) 0xf0024418u)	/* Filter Configuration Register 3, Auxiliary Filter */
#define DSADC_FCFGA4	(*( DSADC_FCFGA0_type *) 0xf0024518u)	/* Filter Configuration Register 4, Auxiliary Filter */
#define DSADC_FCFGA5	(*( DSADC_FCFGA0_type *) 0xf0024618u)	/* Filter Configuration Register 5, Auxiliary Filter */

typedef volatile union
{
	struct
	{ 
		unsigned int CFMDF          : 8;	/* Comb Filter (Main Chain) Decimation Factor */
		unsigned int CFMC           : 2;	/* Comb Filter (Main Chain) Configuration */
		unsigned int CFEN           : 1;	/* Comb Filter Enable */
		unsigned int                : 1;
		unsigned int MFSC           : 2;	/* Main Filter Shift Control */
		unsigned int SRGM           : 2;	/* Service Request Generation Main Chain */
		unsigned int CFMSV          : 8;	/* Comb Filter (Main Chain) Start Value */
		/* const */ unsigned int CFMDCNT        : 8;	/* Comb Filter (Main Chain) Decimation Counter */
	} B;
	int I;
	unsigned int U;

} DSADC_FCFGC0_type;
#define DSADC_FCFGC0	(*( DSADC_FCFGC0_type *) 0xf0024114u)	/* Filter Configuration Register 0, Main Comb Filter */
#define DSADC_FCFGC1	(*( DSADC_FCFGC0_type *) 0xf0024214u)	/* Filter Configuration Register 1, Main Comb Filter */
#define DSADC_FCFGC2	(*( DSADC_FCFGC0_type *) 0xf0024314u)	/* Filter Configuration Register 2, Main Comb Filter */
#define DSADC_FCFGC3	(*( DSADC_FCFGC0_type *) 0xf0024414u)	/* Filter Configuration Register 3, Main Comb Filter */
#define DSADC_FCFGC4	(*( DSADC_FCFGC0_type *) 0xf0024514u)	/* Filter Configuration Register 4, Main Comb Filter */
#define DSADC_FCFGC5	(*( DSADC_FCFGC0_type *) 0xf0024614u)	/* Filter Configuration Register 5, Main Comb Filter */

typedef volatile union
{
	struct
	{ 
		unsigned int FIR0EN         : 1;	/* FIR Filter 0 Enable */
		unsigned int FIR1EN         : 1;	/* FIR Filter 1 Enable */
		unsigned int OCEN           : 1;	/* Offset Compensation Filter Enable */
		unsigned int DSH            : 2;	/* Data Shift Control */
		unsigned int                : 27;
	} B;
	int I;
	unsigned int U;

} DSADC_FCFGM0_type;
#define DSADC_FCFGM0	(*( DSADC_FCFGM0_type *) 0xf0024110u)	/* Filter Configuration Register 0, Main Filter Chain */
#define DSADC_FCFGM1	(*( DSADC_FCFGM0_type *) 0xf0024210u)	/* Filter Configuration Register 1, Main Filter Chain */
#define DSADC_FCFGM2	(*( DSADC_FCFGM0_type *) 0xf0024310u)	/* Filter Configuration Register 2, Main Filter Chain */
#define DSADC_FCFGM3	(*( DSADC_FCFGM0_type *) 0xf0024410u)	/* Filter Configuration Register 3, Main Filter Chain */
#define DSADC_FCFGM4	(*( DSADC_FCFGM0_type *) 0xf0024510u)	/* Filter Configuration Register 4, Main Filter Chain */
#define DSADC_FCFGM5	(*( DSADC_FCFGM0_type *) 0xf0024610u)	/* Filter Configuration Register 5, Main Filter Chain */

typedef volatile union
{
	struct
	{ 
		unsigned int MCSEL          : 3;	/* Modulator Clock Select */
		unsigned int                : 8;
		unsigned int IRM0           : 1;	/* Internal Resistance Measurement Control */
		unsigned int IRM2           : 1;	/* Internal Resistance Measurement Control */
		unsigned int IRM4           : 1;	/* Internal Resistance Measurement Control */
		unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} DSADC_GLOBCFG_type;
#define DSADC_GLOBCFG	(*( DSADC_GLOBCFG_type *) 0xf0024080u)	/* Global Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CHRUN          : 6;	/* Channel x Run Control */
		unsigned int                : 10;
		unsigned int MRUN           : 6;	/* Modulator x Run Control */
		unsigned int                : 10;
	} B;
	int I;
	unsigned int U;

} DSADC_GLOBRC_type;
#define DSADC_GLOBRC	(*( DSADC_GLOBRC_type *) 0xf0024088u)	/* Global Run Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} DSADC_ID_type;
#define DSADC_ID	(*( DSADC_ID_type *) 0xf0024008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int NVALCNT        : 6;	/* Number of Values Counted */
		unsigned int                : 1;
		/* const */ unsigned int INTEN          : 1;	/* Integration EnableFor the control of bit INTEN, see also bitfield ITRMODE in register . */
		/* const */ unsigned int REPCNT         : 4;	/* Integration Cycle Counter */
		unsigned int REPVAL         : 4;	/* Number of Integration Cycles */
		unsigned int NVALDIS        : 6;	/* Number of Values Discarded */
		unsigned int                : 1;
		unsigned int IWS            : 1;	/* Integration Window SIze */
		unsigned int NVALINT        : 6;	/* Number of Values Integrated */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} DSADC_IWCTR0_type;
#define DSADC_IWCTR0	(*( DSADC_IWCTR0_type *) 0xf0024120u)	/* Integration Window Control Register 0 */
#define DSADC_IWCTR1	(*( DSADC_IWCTR0_type *) 0xf0024220u)	/* Integration Window Control Register 1 */
#define DSADC_IWCTR2	(*( DSADC_IWCTR0_type *) 0xf0024320u)	/* Integration Window Control Register 2 */
#define DSADC_IWCTR3	(*( DSADC_IWCTR0_type *) 0xf0024420u)	/* Integration Window Control Register 3 */
#define DSADC_IWCTR4	(*( DSADC_IWCTR0_type *) 0xf0024520u)	/* Integration Window Control Register 4 */
#define DSADC_IWCTR5	(*( DSADC_IWCTR0_type *) 0xf0024620u)	/* Integration Window Control Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} DSADC_KRST0_type;
#define DSADC_KRST0	(*( DSADC_KRST0_type *) 0xf0024034u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} DSADC_KRST1_type;
#define DSADC_KRST1	(*( DSADC_KRST1_type *) 0xf0024030u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} DSADC_KRSTCLR_type;
#define DSADC_KRSTCLR	(*( DSADC_KRSTCLR_type *) 0xf002402cu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int INCFGP         : 2;	/* Configuration of Positive Input Line */
		unsigned int INCFGN         : 2;	/* Configuration of Negative Input Line */
		unsigned int GAINSEL        : 4;	/* Gain Select of Analog Input Path */
		unsigned int INSEL          : 2;	/* Input Pin Selection */
		/* const */ unsigned int INMUX          : 2;	/* Input Multiplexer Setting */
		unsigned int INMODE         : 2;	/* Input Multiplexer Control Mode */
		unsigned int INMAC          : 1;	/* Input Multiplexer Action Control */
		unsigned int INCWC          : 1;	/* Write Control for Input Parameters */
		unsigned int DIVM           : 4;	/* Divider Factor for Modulator Clock */
		unsigned int                : 3;
		unsigned int DWC            : 1;	/* Write Control for Divider Factor */
		unsigned int CMVS           : 2;	/* Common Mode Voltage Selection */
		unsigned int MCFG           : 2;	/* Modulator Configuration */
		unsigned int GCEN           : 1;	/* Gain Calibration Enable */
		unsigned int APC            : 1;	/* Automatic Power Control */
		unsigned int                : 1;
		unsigned int MWC            : 1;	/* Write Control for Mode Selection */
	} B;
	int I;
	unsigned int U;

} DSADC_MODCFG0_type;
#define DSADC_MODCFG0	(*( DSADC_MODCFG0_type *) 0xf0024100u)	/* Modulator Configuration Register 0 */
#define DSADC_MODCFG1	(*( DSADC_MODCFG0_type *) 0xf0024200u)	/* Modulator Configuration Register 1 */
#define DSADC_MODCFG2	(*( DSADC_MODCFG0_type *) 0xf0024300u)	/* Modulator Configuration Register 2 */
#define DSADC_MODCFG3	(*( DSADC_MODCFG0_type *) 0xf0024400u)	/* Modulator Configuration Register 3 */
#define DSADC_MODCFG4	(*( DSADC_MODCFG0_type *) 0xf0024500u)	/* Modulator Configuration Register 4 */
#define DSADC_MODCFG5	(*( DSADC_MODCFG0_type *) 0xf0024600u)	/* Modulator Configuration Register 5 */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} DSADC_OCS_type;
#define DSADC_OCS	(*( DSADC_OCS_type *) 0xf0024028u)	/* OCDS Control and Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int OFFSET         : 16;	/* Offset Value */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} DSADC_OFFM0_type;
#define DSADC_OFFM0	(*( DSADC_OFFM0_type *) 0xf0024138u)	/* Offset Register 0 Main Filter */
#define DSADC_OFFM1	(*( DSADC_OFFM0_type *) 0xf0024238u)	/* Offset Register 1 Main Filter */
#define DSADC_OFFM2	(*( DSADC_OFFM0_type *) 0xf0024338u)	/* Offset Register 2 Main Filter */
#define DSADC_OFFM3	(*( DSADC_OFFM0_type *) 0xf0024438u)	/* Offset Register 3 Main Filter */
#define DSADC_OFFM4	(*( DSADC_OFFM0_type *) 0xf0024538u)	/* Offset Register 4 Main Filter */
#define DSADC_OFFM5	(*( DSADC_OFFM0_type *) 0xf0024638u)	/* Offset Register 5 Main Filter */

typedef volatile union
{
	struct
	{ 
		unsigned int RFEN           : 1;	/* Rectification Enable */
		unsigned int                : 3;
		unsigned int SSRC           : 2;	/* Sign Source */
		unsigned int                : 9;
		/* const */ unsigned int SDCVAL         : 1;	/* Valid Flag */
		unsigned int                : 14;
		/* const */ unsigned int SGNCS          : 1;	/* Selected Carrier Sign Signal */
		/* const */ unsigned int SGND           : 1;	/* Sign Signal Delayed */
	} B;
	int I;
	unsigned int U;

} DSADC_RECTCFG0_type;
#define DSADC_RECTCFG0	(*( DSADC_RECTCFG0_type *) 0xf00241a8u)	/* Rectification Configuration Register 0 */
#define DSADC_RECTCFG1	(*( DSADC_RECTCFG0_type *) 0xf00242a8u)	/* Rectification Configuration Register 1 */
#define DSADC_RECTCFG2	(*( DSADC_RECTCFG0_type *) 0xf00243a8u)	/* Rectification Configuration Register 2 */
#define DSADC_RECTCFG3	(*( DSADC_RECTCFG0_type *) 0xf00244a8u)	/* Rectification Configuration Register 3 */
#define DSADC_RECTCFG4	(*( DSADC_RECTCFG0_type *) 0xf00245a8u)	/* Rectification Configuration Register 4 */
#define DSADC_RECTCFG5	(*( DSADC_RECTCFG0_type *) 0xf00246a8u)	/* Rectification Configuration Register 5 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RESULT         : 16;	/* Result of most recent conversion */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} DSADC_RESA0_type;
#define DSADC_RESA0	(*( DSADC_RESA0_type *) 0xf0024140u)	/* Result Register 0 Auxiliary Filter */
#define DSADC_RESA1	(*( DSADC_RESA0_type *) 0xf0024240u)	/* Result Register 1 Auxiliary Filter */
#define DSADC_RESA2	(*( DSADC_RESA0_type *) 0xf0024340u)	/* Result Register 2 Auxiliary Filter */
#define DSADC_RESA3	(*( DSADC_RESA0_type *) 0xf0024440u)	/* Result Register 3 Auxiliary Filter */
#define DSADC_RESA4	(*( DSADC_RESA0_type *) 0xf0024540u)	/* Result Register 4 Auxiliary Filter */
#define DSADC_RESA5	(*( DSADC_RESA0_type *) 0xf0024640u)	/* Result Register 5 Auxiliary Filter */
#define DSADC_RESM0	(*( DSADC_RESA0_type *) 0xf0024130u)	/* Result Register 0 Main Filter */
#define DSADC_RESM1	(*( DSADC_RESA0_type *) 0xf0024230u)	/* Result Register 1 Main Filter */
#define DSADC_RESM2	(*( DSADC_RESA0_type *) 0xf0024330u)	/* Result Register 2 Main Filter */
#define DSADC_RESM3	(*( DSADC_RESA0_type *) 0xf0024430u)	/* Result Register 3 Main Filter */
#define DSADC_RESM4	(*( DSADC_RESA0_type *) 0xf0024530u)	/* Result Register 4 Main Filter */
#define DSADC_RESM5	(*( DSADC_RESA0_type *) 0xf0024630u)	/* Result Register 5 Main Filter */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RESULT         : 16;	/* Result of most recent conversion */
		/* const */ unsigned int CFMDCNT        : 8;	/* Comb Filter (Main Chain) Decimation Counter */
		/* const */ unsigned int NVALCNT        : 6;	/* Number of Values Counted */
		/* const */ unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} DSADC_TSTMP0_type;
#define DSADC_TSTMP0	(*( DSADC_TSTMP0_type *) 0xf0024150u)	/* Time-Stamp Register 0 */
#define DSADC_TSTMP1	(*( DSADC_TSTMP0_type *) 0xf0024250u)	/* Time-Stamp Register 1 */
#define DSADC_TSTMP2	(*( DSADC_TSTMP0_type *) 0xf0024350u)	/* Time-Stamp Register 2 */
#define DSADC_TSTMP3	(*( DSADC_TSTMP0_type *) 0xf0024450u)	/* Time-Stamp Register 3 */
#define DSADC_TSTMP4	(*( DSADC_TSTMP0_type *) 0xf0024550u)	/* Time-Stamp Register 4 */
#define DSADC_TSTMP5	(*( DSADC_TSTMP0_type *) 0xf0024650u)	/* Time-Stamp Register 5 */


/* BMU */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} BMU_ACCEN0_type;
#define BMU_ACCEN0	(*( BMU_ACCEN0_type *) 0xf00308fcu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} BMU_ACCEN1_type;
#define BMU_ACCEN1	(*( BMU_ACCEN1_type *) 0xf00308f8u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 4;
		/* const */ unsigned int RMC            : 8;	/* 8-bit Clock Divider Value in RUN Mode */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} BMU_CLC_type;
#define BMU_CLC	(*( BMU_CLC_type *) 0xf0030800u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MODE           : 1;	/* Access Mode */
		/* const */ unsigned int TMF            : 1;	/* Transaction Master Filtering */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} BMU_CTL_type;
#define BMU_CTL	(*( BMU_CTL_type *) 0xf0030820u)	/* Transaction Filtering Control */

typedef volatile union
{
	struct
	{ 
		unsigned int FHT_INT        : 1;	/* Interrupt Enable for Fifo High Threshold */
		unsigned int OVF_INT        : 1;	/* Interrupt Enable for Overflow Detection */
		unsigned int UDF_INT        : 1;	/* Interrupt Enable for Underflow Detection */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} BMU_FMCTL_type;
#define BMU_FMCTL	(*( BMU_FMCTL_type *) 0xf0030840u)	/* Fifo Monitor control register */

typedef volatile union
{
	struct
	{ 
		unsigned int FHT_STS        : 1;	/* Status Flag for Fifo High Threshold interrupt */
		unsigned int OVF_STS        : 1;	/* Status Flag for Overrun interrupt */
		unsigned int UDF_STS        : 1;	/* Status Flag for Underflow interrupt */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} BMU_FMSTS_type;
#define BMU_FMSTS	(*( BMU_FMSTS_type *) 0xf0030844u)	/* Fifo Monitor Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FHT            : 8;	/* Fifo High Threshold */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} BMU_FMTH_type;
#define BMU_FMTH	(*( BMU_FMTH_type *) 0xf0030848u)	/* Fifo Monitor: Fullness Threshold Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int UCELLS         : 9;	/* Number of valid (used) entries in the BTF */
		/* const */ unsigned int                : 7;
		/* const */ unsigned int FCELLS         : 9;	/* Number of free entries in the BTF */
		/* const */ unsigned int                : 7;
	} B;
	int I;
	unsigned int U;

} BMU_FULLNESS_type;
#define BMU_FULLNESS	(*( BMU_FULLNESS_type *) 0xf0030828u)	/* Fullness Information for Bus Transaction Fifo */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} BMU_ID_type;
#define BMU_ID	(*( BMU_ID_type *) 0xf0030808u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FPI_SEL0       : 1;	/* Select Bit for FPI Region 0 */
		unsigned int FPI_SEL1       : 1;	/* Select Bit for FPI Region 1 */
		unsigned int FPI_SEL2       : 1;	/* Select Bit for FPI Region 2 */
		unsigned int FPI_SEL3       : 1;	/* Select Bit for FPI Region 3 */
		unsigned int FPI_SEL4       : 1;	/* Select Bit for FPI Region 4 */
		unsigned int FPI_SEL5       : 1;	/* Select Bit for FPI Region 5 */
		unsigned int FPI_SEL6       : 1;	/* Select Bit for FPI Region 6 */
		unsigned int FPI_SEL7       : 1;	/* Select Bit for FPI Region 7 */
		unsigned int FPI_SEL8       : 1;	/* Select Bit for FPI Region 8 */
		unsigned int FPI_SEL9       : 1;	/* Select Bit for FPI Region 9 */
		unsigned int FPI_SEL10      : 1;	/* Select Bit for FPI Region 10 */
		unsigned int FPI_SEL11      : 1;	/* Select Bit for FPI Region 11 */
		unsigned int FPI_SEL12      : 1;	/* Select Bit for FPI Region 12 */
		unsigned int FPI_SEL13      : 1;	/* Select Bit for FPI Region 13 */
		unsigned int FPI_SEL14      : 1;	/* Select Bit for FPI Region 14 */
		unsigned int FPI_SEL15      : 1;	/* Select Bit for FPI Region 15 */
		unsigned int FPI_SEL16      : 1;	/* Select Bit for FPI Region 16 */
		unsigned int FPI_SEL17      : 1;	/* Select Bit for FPI Region 17 */
		unsigned int FPI_SEL18      : 1;	/* Select Bit for FPI Region 18 */
		unsigned int FPI_SEL19      : 1;	/* Select Bit for FPI Region 19 */
		unsigned int FPI_SEL20      : 1;	/* Select Bit for FPI Region 20 */
		unsigned int FPI_SEL21      : 1;	/* Select Bit for FPI Region 21 */
		unsigned int FPI_SEL22      : 1;	/* Select Bit for FPI Region 22 */
		unsigned int FPI_SEL23      : 1;	/* Select Bit for FPI Region 23 */
		unsigned int FPI_SEL24      : 1;	/* Select Bit for FPI Region 24 */
		unsigned int FPI_SEL25      : 1;	/* Select Bit for FPI Region 25 */
		unsigned int FPI_SEL26      : 1;	/* Select Bit for FPI Region 26 */
		unsigned int FPI_SEL27      : 1;	/* Select Bit for FPI Region 27 */
		unsigned int FPI_SEL28      : 1;	/* Select Bit for FPI Region 28 */
		unsigned int FPI_SEL29      : 1;	/* Select Bit for FPI Region 29 */
		unsigned int FPI_SEL30      : 1;	/* Select Bit for FPI Region 30 */
		unsigned int FPI_SEL31      : 1;	/* Select Bit for FPI Region 31 */
	} B;
	int I;
	unsigned int U;

} BMU_PSET0_type;
#define BMU_PSET0	(*( BMU_PSET0_type *) 0xf0030830u)	/* Peripheral Set 0 Configuration */

typedef volatile union
{
	struct
	{ 
		unsigned int FPI_SEL32      : 1;	/* Select Bit for FPI Region 32 */
		unsigned int FPI_SEL33      : 1;	/* Select Bit for FPI Region 33 */
		unsigned int FPI_SEL34      : 1;	/* Select Bit for FPI Region 34 */
		unsigned int FPI_SEL35      : 1;	/* Select Bit for FPI Region 35 */
		unsigned int FPI_SEL36      : 1;	/* Select Bit for FPI Region 36 */
		unsigned int FPI_SEL37      : 1;	/* Select Bit for FPI Region 37 */
		unsigned int FPI_SEL38      : 1;	/* Select Bit for FPI Region 38 */
		unsigned int FPI_SEL39      : 1;	/* Select Bit for FPI Region 39 */
		unsigned int FPI_SEL40      : 1;	/* Select Bit for FPI Region 40 */
		unsigned int FPI_SEL41      : 1;	/* Select Bit for FPI Region 41 */
		unsigned int FPI_SEL42      : 1;	/* Select Bit for FPI Region 42 */
		unsigned int FPI_SEL43      : 1;	/* Select Bit for FPI Region 43 */
		unsigned int FPI_SEL44      : 1;	/* Select Bit for FPI Region 44 */
		unsigned int FPI_SEL45      : 1;	/* Select Bit for FPI Region 45 */
		unsigned int FPI_SEL46      : 1;	/* Select Bit for FPI Region 46 */
		unsigned int FPI_SEL47      : 1;	/* Select Bit for FPI Region 47 */
		unsigned int FPI_SEL48      : 1;	/* Select Bit for FPI Region 48 */
		unsigned int FPI_SEL49      : 1;	/* Select Bit for FPI Region 49 */
		unsigned int FPI_SEL50      : 1;	/* Select Bit for FPI Region 50 */
		unsigned int FPI_SEL51      : 1;	/* Select Bit for FPI Region 51 */
		unsigned int FPI_SEL52      : 1;	/* Select Bit for FPI Region 52 */
		unsigned int FPI_SEL53      : 1;	/* Select Bit for FPI Region 53 */
		unsigned int FPI_SEL54      : 1;	/* Select Bit for FPI Region 54 */
		unsigned int FPI_SEL55      : 1;	/* Select Bit for FPI Region 55 */
		unsigned int FPI_SEL56      : 1;	/* Select Bit for FPI Region 56 */
		unsigned int FPI_SEL57      : 1;	/* Select Bit for FPI Region 57 */
		unsigned int FPI_SEL58      : 1;	/* Select Bit for FPI Region 58 */
		unsigned int FPI_SEL59      : 1;	/* Select Bit for FPI Region 59 */
		unsigned int FPI_SEL60      : 1;	/* Select Bit for FPI Region 60 */
		unsigned int FPI_SEL61      : 1;	/* Select Bit for FPI Region 61 */
		unsigned int FPI_SEL62      : 1;	/* Select Bit for FPI Region 62 */
		unsigned int FPI_SEL63      : 1;	/* Select Bit for FPI Region 63 */
	} B;
	int I;
	unsigned int U;

} BMU_PSET1_type;
#define BMU_PSET1	(*( BMU_PSET1_type *) 0xf0030834u)	/* Peripheral Set 1 Configuration */

typedef volatile union
{
	struct
	{ 
		unsigned int FPI_SEL64      : 1;	/* Select Bit for FPI Region 64 */
		unsigned int FPI_SEL65      : 1;	/* Select Bit for FPI Region 65 */
		unsigned int FPI_SEL66      : 1;	/* Select Bit for FPI Region 66 */
		unsigned int FPI_SEL67      : 1;	/* Select Bit for FPI Region 67 */
		unsigned int FPI_SEL68      : 1;	/* Select Bit for FPI Region 68 */
		unsigned int FPI_SEL69      : 1;	/* Select Bit for FPI Region 69 */
		unsigned int FPI_SEL70      : 1;	/* Select Bit for FPI Region 70 */
		unsigned int FPI_SEL71      : 1;	/* Select Bit for FPI Region 71 */
		unsigned int FPI_SEL72      : 1;	/* Select Bit for FPI Region 72 */
		unsigned int FPI_SEL73      : 1;	/* Select Bit for FPI Region 73 */
		unsigned int FPI_SEL74      : 1;	/* Select Bit for FPI Region 74 */
		unsigned int FPI_SEL75      : 1;	/* Select Bit for FPI Region 75 */
		unsigned int FPI_SEL76      : 1;	/* Select Bit for FPI Region 76 */
		unsigned int FPI_SEL77      : 1;	/* Select Bit for FPI Region 77 */
		unsigned int FPI_SEL78      : 1;	/* Select Bit for FPI Region 78 */
		unsigned int FPI_SEL79      : 1;	/* Select Bit for FPI Region 79 */
		unsigned int FPI_SEL80      : 1;	/* Select Bit for FPI Region 80 */
		unsigned int FPI_SEL81      : 1;	/* Select Bit for FPI Region 81 */
		unsigned int FPI_SEL82      : 1;	/* Select Bit for FPI Region 82 */
		unsigned int FPI_SEL83      : 1;	/* Select Bit for FPI Region 83 */
		unsigned int FPI_SEL84      : 1;	/* Select Bit for FPI Region 84 */
		unsigned int FPI_SEL85      : 1;	/* Select Bit for FPI Region 85 */
		unsigned int FPI_SEL86      : 1;	/* Select Bit for FPI Region 86 */
		unsigned int FPI_SEL87      : 1;	/* Select Bit for FPI Region 87 */
		unsigned int FPI_SEL88      : 1;	/* Select Bit for FPI Region 88 */
		unsigned int FPI_SEL89      : 1;	/* Select Bit for FPI Region 89 */
		unsigned int FPI_SEL90      : 1;	/* Select Bit for FPI Region 90 */
		unsigned int FPI_SEL91      : 1;	/* Select Bit for FPI Region 91 */
		unsigned int FPI_SEL92      : 1;	/* Select Bit for FPI Region 92 */
		unsigned int FPI_SEL93      : 1;	/* Select Bit for FPI Region 93 */
		unsigned int FPI_SEL94      : 1;	/* Select Bit for FPI Region 94 */
		unsigned int FPI_SEL95      : 1;	/* Select Bit for FPI Region 95 */
	} B;
	int I;
	unsigned int U;

} BMU_PSET2_type;
#define BMU_PSET2	(*( BMU_PSET2_type *) 0xf0030838u)	/* Peripheral Set 2 Configuration */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RPTR           : 8;	/* Read Pointer Position */
		/* const */ unsigned int                : 8;
		/* const */ unsigned int WPTR           : 8;	/* Write Pointer Position */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} BMU_PTR_type;
#define BMU_PTR	(*( BMU_PTR_type *) 0xf0030824u)	/* Pointer Information for Bus Transaction Fifo */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TID0           : 4;	/* Transaction Identifier 0 */
		/* const */ unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} BMU_TID_type;
#define BMU_TID	(*( BMU_TID_type *) 0xf003083cu)	/* FPI Transaction ID Set 0 Configuration */


/* I2C */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} I2C0_ACCEN0_type;
#define I2C0_ACCEN0	(*( I2C0_ACCEN0_type *) 0xf00d000cu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RES            : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} I2C0_ACCEN1_type;
#define I2C0_ACCEN1	(*( I2C0_ACCEN1_type *) 0xf00d0010u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int ADR            : 10;	/* I2C-bus Device Address */
		unsigned int                : 6;
		unsigned int TBAM           : 1;	/* Ten Bit Address Mode */
		unsigned int GCE            : 1;	/* General Call Enable */
		unsigned int MCE            : 1;	/* Master Code Enable */
		unsigned int MnS            : 1;	/* Master / not Slave */
		unsigned int SONA           : 1;	/* Stop on Not-acknowledge */
		unsigned int SOPE           : 1;	/* Stop on Packet End */
		unsigned int                : 10;
	} B;
	int I;
	unsigned int U;

} I2C0_ADDRCFG_type;
#define I2C0_ADDRCFG	(*( I2C0_ADDRCFG_type *) 0xf00c0020u)	/* Address Configuration Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int BS             : 2;	/* Bus Status */
		/* const */ unsigned int RnW            : 1;	/* Read/not Write */
		/* const */ unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} I2C0_BUSSTAT_type;
#define I2C0_BUSSTAT	(*( I2C0_BUSSTAT_type *) 0xf00c0024u)	/* Bus Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} I2C0_CLC_type;
#define I2C0_CLC	(*( I2C0_CLC_type *) 0xf00d0000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int SPEN           : 1;	/* Module Suspend Enable Bit for OCDS */
		unsigned int EDIS           : 1;	/* External Request Disable */
		unsigned int SBWE           : 1;	/* Module Suspend Bit Write Enable for OCDS */
		unsigned int FSOE           : 1;	/* Fast Switch Off Enable */
		unsigned int                : 2;
		unsigned int RMC            : 8;	/* Clock Divider for Standard Run Mode */
		unsigned int ORMC           : 8;	/* Clock Divider for Optional Run Mode (AHB peripherals) */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} I2C0_CLC1_type;
#define I2C0_CLC1	(*( I2C0_CLC1_type *) 0xf00c0000u)	/* Clock Control 1 Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SETRSC         : 1;	/* Set Restart Condition */
		unsigned int SETEND         : 1;	/* Set End of Transmission */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} I2C0_ENDDCTRL_type;
#define I2C0_ENDDCTRL	(*( I2C0_ENDDCTRL_type *) 0xf00c0014u)	/* End Data Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RXF_UFL        : 1;	/* RX FIFO Underflow */
		unsigned int RXF_OFL        : 1;	/* RX FIFO Overflow */
		unsigned int TXF_UFL        : 1;	/* TX FIFO Underflow */
		unsigned int TXF_OFL        : 1;	/* TX FIFO Overflow */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} I2C0_ERRIRQSC_type;
#define I2C0_ERRIRQSC	(*( I2C0_ERRIRQSC_type *) 0xf00c0068u)	/* Error Interrupt Request Source Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RXF_UFL        : 1;	/* RX FIFO Underflow */
		unsigned int RXF_OFL        : 1;	/* RX FIFO Overflow */
		unsigned int TXF_UFL        : 1;	/* TX FIFO Underflow */
		unsigned int TXF_OFL        : 1;	/* TX FIFO Overflow */
		unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} I2C0_ERRIRQSM_type;
#define I2C0_ERRIRQSM	(*( I2C0_ERRIRQSM_type *) 0xf00c0060u)	/* Error Interrupt Request Source Mask Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXF_UFL        : 1;	/* RX FIFO Underflow */
		/* const */ unsigned int RXF_OFL        : 1;	/* RX FIFO Overflow */
		/* const */ unsigned int TXF_UFL        : 1;	/* TX FIFO Underflow */
		/* const */ unsigned int TXF_OFL        : 1;	/* TX FIFO Overflow */
		/* const */ unsigned int                : 28;
	} B;
	int I;
	unsigned int U;

} I2C0_ERRIRQSS_type;
#define I2C0_ERRIRQSS	(*( I2C0_ERRIRQSS_type *) 0xf00c0064u)	/* Error Interrupt Request Source Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DEC            : 11;	/* Decrement Value of Fractional Divider */
		unsigned int                : 5;
		unsigned int INC            : 8;	/* Increment Value of Fractional Divider */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} I2C0_FDIVCFG_type;
#define I2C0_FDIVCFG	(*( I2C0_FDIVCFG_type *) 0xf00c0018u)	/* Fractional Divider Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DEC            : 11;	/* Decrement Value of Fractional Divider */
		unsigned int                : 5;
		unsigned int INC            : 8;	/* Increment Value of Fractional Divider */
		unsigned int                : 7;
		unsigned int DIS_SCL_SYN    : 1;	/* Disable SCL Synchronization */
	} B;
	int I;
	unsigned int U;

} I2C0_FDIVHIGHCFG_type;
#define I2C0_FDIVHIGHCFG	(*( I2C0_FDIVHIGHCFG_type *) 0xf00c001cu)	/* Fractional Divider High-speed Mode Configuration Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int FFS            : 6;	/* Filled FIFO Stages */
		/* const */ unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} I2C0_FFSSTAT_type;
#define I2C0_FFSSTAT	(*( I2C0_FFSSTAT_type *) 0xf00c0038u)	/* Filled FIFO Stages Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RXBS           : 2;	/* RX Burst Size */
		unsigned int                : 2;
		unsigned int TXBS           : 2;	/* TX Burst Size */
		unsigned int                : 2;
		unsigned int RXFA           : 2;	/* RX FIFO Alignment */
		unsigned int                : 2;
		unsigned int TXFA           : 2;	/* TX FIFO Alignment */
		unsigned int                : 2;
		unsigned int RXFC           : 1;	/* RX FIFO Flow Control */
		unsigned int TXFC           : 1;	/* TX FIFO Flow Control */
		unsigned int                : 14;
	} B;
	int I;
	unsigned int U;

} I2C0_FIFOCFG_type;
#define I2C0_FIFOCFG	(*( I2C0_FIFOCFG_type *) 0xf00c0028u)	/* FIFO Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PISEL          : 3;	/* Port Input Select */
		unsigned int                : 29;
	} B;
	int I;
	unsigned int U;

} I2C0_GPCTL_type;
#define I2C0_GPCTL	(*( I2C0_GPCTL_type *) 0xf00d0008u)	/* General Purpose Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LSREQ_INT      : 1;	/* Last Single Request Interrupt */
		unsigned int SREQ_INT       : 1;	/* Single Request Interrupt */
		unsigned int LBREQ_INT      : 1;	/* Last Burst Request Interrupt */
		unsigned int BREQ_INT       : 1;	/* Burst Request Interrupt */
		unsigned int I2C_ERR_INT    : 1;	/* I2C Error Interrupt */
		unsigned int I2C_P_INT      : 1;	/* I2C Protocol Interrupt */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} I2C0_ICR_type;
#define I2C0_ICR	(*( I2C0_ICR_type *) 0xf00c008cu)	/* Interrupt Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODNUMBER      : 8;	/* Module Number Value */
		/* const */ unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} I2C0_ID_type;
#define I2C0_ID	(*( I2C0_ID_type *) 0xf00c0008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LSREQ_INT      : 1;	/* Last Single Request Interrupt */
		unsigned int SREQ_INT       : 1;	/* Single Request Interrupt */
		unsigned int LBREQ_INT      : 1;	/* Last Burst Request Interrupt */
		unsigned int BREQ_INT       : 1;	/* Burst Request Interrupt */
		unsigned int I2C_ERR_INT    : 1;	/* I2C Error Interrupt */
		unsigned int I2C_P_INT      : 1;	/* I2C Protocol Interrupt */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} I2C0_IMSC_type;
#define I2C0_IMSC	(*( I2C0_IMSC_type *) 0xf00c0084u)	/* Interrupt Mask Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int LSREQ_INT      : 1;	/* Last Single Request Interrupt */
		unsigned int SREQ_INT       : 1;	/* Single Request Interrupt */
		unsigned int LBREQ_INT      : 1;	/* Last Burst Request Interrupt */
		unsigned int BREQ_INT       : 1;	/* Burst Request Interrupt */
		unsigned int I2C_ERR_INT    : 1;	/* I2C Error Interrupt */
		unsigned int I2C_P_INT      : 1;	/* I2C Protocol Interrupt */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} I2C0_ISR_type;
#define I2C0_ISR	(*( I2C0_ISR_type *) 0xf00c0090u)	/* Interrupt Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} I2C0_KRST0_type;
#define I2C0_KRST0	(*( I2C0_KRST0_type *) 0xf00d0014u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} I2C0_KRST1_type;
#define I2C0_KRST1	(*( I2C0_KRST1_type *) 0xf00d0018u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} I2C0_KRSTCLR_type;
#define I2C0_KRSTCLR	(*( I2C0_KRSTCLR_type *) 0xf00d001cu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int LSREQ_INT      : 1;	/* Last Single Request Interrupt */
		/* const */ unsigned int SREQ_INT       : 1;	/* Single Request Interrupt */
		/* const */ unsigned int LBREQ_INT      : 1;	/* Last Burst Request Interrupt */
		/* const */ unsigned int BREQ_INT       : 1;	/* Burst Request Interrupt */
		/* const */ unsigned int I2C_ERR_INT    : 1;	/* I2C Error Interrupt */
		/* const */ unsigned int I2C_P_INT      : 1;	/* I2C Protocol Interrupt */
		/* const */ unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} I2C0_MIS_type;
#define I2C0_MIS	(*( I2C0_MIS_type *) 0xf00c0088u)	/* Masked Interrupt Status Register */
#define I2C0_RIS	(*( I2C0_MIS_type *) 0xf00c0080u)	/* Raw Interrupt Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} I2C0_MODID_type;
#define I2C0_MODID	(*( I2C0_MODID_type *) 0xf00d0004u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MRPS           : 14;	/* Maximum Received Packet Size */
		unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} I2C0_MRPSCTRL_type;
#define I2C0_MRPSCTRL	(*( I2C0_MRPSCTRL_type *) 0xf00c002cu)	/* Maximum Received Packet Size Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int AM             : 1;	/* Address Match */
		unsigned int GC             : 1;	/* General Call */
		unsigned int MC             : 1;	/* Master Code */
		unsigned int AL             : 1;	/* Arbitration Lost */
		unsigned int NACK           : 1;	/* Not-acknowledge Received */
		unsigned int TX_END         : 1;	/* Transmission End */
		unsigned int RX             : 1;	/* Receive Mode */
		unsigned int                : 25;
	} B;
	int I;
	unsigned int U;

} I2C0_PIRQSC_type;
#define I2C0_PIRQSC	(*( I2C0_PIRQSC_type *) 0xf00c0078u)	/* Protocol Interrupt Request Source Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int AM             : 1;	/* Address Match */
		unsigned int GC             : 1;	/* General Call */
		unsigned int MC             : 1;	/* Master Code */
		unsigned int AL             : 1;	/* Arbitration Lost */
		unsigned int NACK           : 1;	/* Not-acknowledge Received */
		unsigned int TX_END         : 1;	/* Transmission End */
		unsigned int RX             : 1;	/* Receive Mode */
		unsigned int                : 25;
	} B;
	int I;
	unsigned int U;

} I2C0_PIRQSM_type;
#define I2C0_PIRQSM	(*( I2C0_PIRQSM_type *) 0xf00c0070u)	/* Protocol Interrupt Request Source Mask Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int AM             : 1;	/* Address Match */
		/* const */ unsigned int GC             : 1;	/* General Call */
		/* const */ unsigned int MC             : 1;	/* Master Code */
		/* const */ unsigned int AL             : 1;	/* Arbitration Lost */
		/* const */ unsigned int NACK           : 1;	/* Not-acknowledge Received */
		/* const */ unsigned int TX_END         : 1;	/* Transmission End */
		/* const */ unsigned int RX             : 1;	/* Receive Mode */
		/* const */ unsigned int                : 25;
	} B;
	int I;
	unsigned int U;

} I2C0_PIRQSS_type;
#define I2C0_PIRQSS	(*( I2C0_PIRQSS_type *) 0xf00c0074u)	/* Protocol Interrupt Request Source Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RPS            : 14;	/* Received Packet Size */
		/* const */ unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} I2C0_RPSSTAT_type;
#define I2C0_RPSSTAT	(*( I2C0_RPSSTAT_type *) 0xf00c0030u)	/* Received Packet Size Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RUN            : 1;	/* Enable I2C-bus Interface */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} I2C0_RUNCTRL_type;
#define I2C0_RUNCTRL	(*( I2C0_RUNCTRL_type *) 0xf00c0010u)	/* RUN Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXD            : 32;	/* Reception Data */
	} B;
	int I;
	unsigned int U;

} I2C0_RXD_type;
#define I2C0_RXD	(*( I2C0_RXD_type *) 0xf00cc000u)	/* Reception Data Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SDA_DEL_HD_DAT : 6;	/* SDA Delay Stages for Data Hold Time */
		unsigned int HS_SDA_DEL_HD_DAT: 3;	/* SDA Delay Stages for Data Hold Time in High-speed Mode */
		unsigned int SCL_DEL_HD_STA : 3;	/* SCL Delay Stages for Hold Time Start (Restart) Bit */
		unsigned int                : 2;
		unsigned int EN_SCL_LOW_LEN : 1;	/* Enable Direct Configuration of SCL Low Period Length in Fast Mode */
		unsigned int FS_SCL_LOW     : 1;	/* Set Fast Mode SCL Low Period Timing */
		unsigned int HS_SDA_DEL     : 3;	/* SDA Delay Stages for Start/Stop bit in High-speed Mode */
		unsigned int                : 5;
		unsigned int SCL_LOW_LEN    : 8;	/* SCL Low Length in Fast Mode */
	} B;
	int I;
	unsigned int U;

} I2C0_TIMCFG_type;
#define I2C0_TIMCFG	(*( I2C0_TIMCFG_type *) 0xf00c0040u)	/* Timing Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TPS            : 14;	/* Transmit Packet Size */
		unsigned int                : 18;
	} B;
	int I;
	unsigned int U;

} I2C0_TPSCTRL_type;
#define I2C0_TPSCTRL	(*( I2C0_TPSCTRL_type *) 0xf00c0034u)	/* Transmit Packet Size Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TXD            : 32;	/* Transmission Data */
	} B;
	int I;
	unsigned int U;

} I2C0_TXD_type;
#define I2C0_TXD	(*( I2C0_TXD_type *) 0xf00c8000u)	/* Transmission Data Register */


/* IOM */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} IOM_ACCEN0_type;
#define IOM_ACCEN0	(*( IOM_ACCEN0_type *) 0xf003502cu)	/* IOM Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} IOM_ACCEN1_type;
#define IOM_ACCEN1	(*( IOM_ACCEN1_type *) 0xf0035028u)	/* IOM Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 1;
		unsigned int EDIS           : 1;	/* Sleep Mode Enable Control */
		unsigned int                : 4;
		unsigned int RMC            : 8;	/* 8-bit Clock Divider Value in RUN Mode */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} IOM_CLC_type;
#define IOM_CLC	(*( IOM_CLC_type *) 0xf0035000u)	/* IOM Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SELC0          : 4;	/* Event Channel Select */
		unsigned int THRC0          : 4;	/* Channel Event Counter Threshold */
		unsigned int SELC1          : 4;	/* Event Channel Select */
		unsigned int THCR1          : 4;	/* Channel Event Counter Threshold */
		unsigned int SELC2          : 4;	/* Event Channel Select */
		unsigned int THCR2          : 4;	/* Channel Event Counter Threshold */
		unsigned int SELC3          : 4;	/* Event Channel Select */
		unsigned int THCR3          : 4;	/* Channel Event Counter Threshold */
	} B;
	int I;
	unsigned int U;

} IOM_ECMCCFG_type;
#define IOM_ECMCCFG	(*( IOM_ECMCCFG_type *) 0xf0035030u)	/* IOM Event Combiner Module Counter Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ETA0_15        : 16;	/* LAM 0-15 Event Trigger Activity (last) */
		unsigned int ETB0_15        : 16;	/* LAM 0-15 Event Trigger Activity (previous ETA0-15) */
	} B;
	int I;
	unsigned int U;

} IOM_ECMETH0_type;
#define IOM_ECMETH0	(*( IOM_ECMETH0_type *) 0xf0035038u)	/* IOM Event Combiner Module Event Trigger History Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int ETC0_15        : 16;	/* LAM 0-15 Event Trigger Activity (previous ETB0-15) */
		unsigned int ETD0_15        : 16;	/* LAM 0-15 Event Trigger Activity (previous ETC0-15) */
	} B;
	int I;
	unsigned int U;

} IOM_ECMETH1_type;
#define IOM_ECMETH1	(*( IOM_ECMETH1_type *) 0xf003503cu)	/* IOM Event Combiner Module Event Trigger History Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CES0           : 1;	/* Event Combiner Selection */
		unsigned int CES1           : 1;	/* Event Combiner Selection */
		unsigned int CES2           : 1;	/* Event Combiner Selection */
		unsigned int CES3           : 1;	/* Event Combiner Selection */
		unsigned int CES4           : 1;	/* Event Combiner Selection */
		unsigned int CES5           : 1;	/* Event Combiner Selection */
		unsigned int CES6           : 1;	/* Event Combiner Selection */
		unsigned int CES7           : 1;	/* Event Combiner Selection */
		unsigned int CES8           : 1;	/* Event Combiner Selection */
		unsigned int CES9           : 1;	/* Event Combiner Selection */
		unsigned int CES10          : 1;	/* Event Combiner Selection */
		unsigned int CES11          : 1;	/* Event Combiner Selection */
		unsigned int CES12          : 1;	/* Event Combiner Selection */
		unsigned int CES13          : 1;	/* Event Combiner Selection */
		unsigned int CES14          : 1;	/* Event Combiner Selection */
		unsigned int CES15          : 1;	/* Event Combiner Selection */
		unsigned int CTS0           : 1;	/* Accumulated (Counted) Event Combiner Selection */
		unsigned int CTS1           : 1;	/* Accumulated (Counted) Event Combiner Selection */
		unsigned int CTS2           : 1;	/* Accumulated (Counted) Event Combiner Selection */
		unsigned int CTS3           : 1;	/* Accumulated (Counted) Event Combiner Selection */
		unsigned int                : 12;
	} B;
	int I;
	unsigned int U;

} IOM_ECMSELR_type;
#define IOM_ECMSELR	(*( IOM_ECMSELR_type *) 0xf0035034u)	/* IOM Event Combiner Module Global Event Selection Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CMP            : 16;	/* Threshold Value of Filter 'and' Prescaler Cell k */
		unsigned int MOD            : 3;	/* Operation Mode Selection for Filter 'and' Prescaler Cell k */
		unsigned int ISM            : 2;	/* Monitor Input Signal Selection for Filter 'and' Prescaler Cell k */
		unsigned int                : 1;
		unsigned int RTG            : 1;	/* Reset Timer behaviour for Filter 'and' Prescaler Cell k on Glitch */
		unsigned int                : 1;
		unsigned int ISR            : 3;	/* Reference Input Signal Selection for Filter 'and' Prescaler Cell k */
		unsigned int                : 5;
	} B;
	int I;
	unsigned int U;

} IOM_FPCCTR0_type;
#define IOM_FPCCTR0	(*( IOM_FPCCTR0_type *) 0xf0035080u)	/* IOM Filter and Prescaler Cell Control Register 0 */
#define IOM_FPCCTR1	(*( IOM_FPCCTR0_type *) 0xf0035084u)	/* IOM Filter and Prescaler Cell Control Register 1 */
#define IOM_FPCCTR10	(*( IOM_FPCCTR0_type *) 0xf00350a8u)	/* IOM Filter and Prescaler Cell Control Register 10 */
#define IOM_FPCCTR11	(*( IOM_FPCCTR0_type *) 0xf00350acu)	/* IOM Filter and Prescaler Cell Control Register 11 */
#define IOM_FPCCTR12	(*( IOM_FPCCTR0_type *) 0xf00350b0u)	/* IOM Filter and Prescaler Cell Control Register 12 */
#define IOM_FPCCTR13	(*( IOM_FPCCTR0_type *) 0xf00350b4u)	/* IOM Filter and Prescaler Cell Control Register 13 */
#define IOM_FPCCTR14	(*( IOM_FPCCTR0_type *) 0xf00350b8u)	/* IOM Filter and Prescaler Cell Control Register 14 */
#define IOM_FPCCTR15	(*( IOM_FPCCTR0_type *) 0xf00350bcu)	/* IOM Filter and Prescaler Cell Control Register 15 */
#define IOM_FPCCTR2	(*( IOM_FPCCTR0_type *) 0xf0035088u)	/* IOM Filter and Prescaler Cell Control Register 2 */
#define IOM_FPCCTR3	(*( IOM_FPCCTR0_type *) 0xf003508cu)	/* IOM Filter and Prescaler Cell Control Register 3 */
#define IOM_FPCCTR4	(*( IOM_FPCCTR0_type *) 0xf0035090u)	/* IOM Filter and Prescaler Cell Control Register 4 */
#define IOM_FPCCTR5	(*( IOM_FPCCTR0_type *) 0xf0035094u)	/* IOM Filter and Prescaler Cell Control Register 5 */
#define IOM_FPCCTR6	(*( IOM_FPCCTR0_type *) 0xf0035098u)	/* IOM Filter and Prescaler Cell Control Register 6 */
#define IOM_FPCCTR7	(*( IOM_FPCCTR0_type *) 0xf003509cu)	/* IOM Filter and Prescaler Cell Control Register 7 */
#define IOM_FPCCTR8	(*( IOM_FPCCTR0_type *) 0xf00350a0u)	/* IOM Filter and Prescaler Cell Control Register 8 */
#define IOM_FPCCTR9	(*( IOM_FPCCTR0_type *) 0xf00350a4u)	/* IOM Filter and Prescaler Cell Control Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int FEG0           : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG1           : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG2           : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG3           : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG4           : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG5           : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG6           : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG7           : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG8           : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG9           : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG10          : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG11          : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG12          : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG13          : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG14          : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int FEG15          : 1;	/* Falling Edge Glitch Flag for FPCk */
		unsigned int REG0           : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG1           : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG2           : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG3           : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG4           : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG5           : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG6           : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG7           : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG8           : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG9           : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG10          : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG11          : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG12          : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG13          : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG14          : 1;	/* Rising Edge Glitch Flag for FPCk */
		unsigned int REG15          : 1;	/* Rising Edge Glitch Flag for FPCk */
	} B;
	int I;
	unsigned int U;

} IOM_FPCESR_type;
#define IOM_FPCESR	(*( IOM_FPCESR_type *) 0xf0035078u)	/* IOM Filter and Prescaler Cells Rising 'and' Falling Edge Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TIM            : 16;	/* Timer Value of Filter and Prescaler Cell k */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} IOM_FPCTIM0_type;
#define IOM_FPCTIM0	(*( IOM_FPCTIM0_type *) 0xf00350c0u)	/* IOM Filter and Prescaler Cell 0 Timer Register k */
#define IOM_FPCTIM1	(*( IOM_FPCTIM0_type *) 0xf00350c4u)	/* IOM Filter and Prescaler Cell 1 Timer Register k */
#define IOM_FPCTIM10	(*( IOM_FPCTIM0_type *) 0xf00350e8u)	/* IOM Filter and Prescaler Cell 10 Timer Register k */
#define IOM_FPCTIM11	(*( IOM_FPCTIM0_type *) 0xf00350ecu)	/* IOM Filter and Prescaler Cell 11 Timer Register k */
#define IOM_FPCTIM12	(*( IOM_FPCTIM0_type *) 0xf00350f0u)	/* IOM Filter and Prescaler Cell 12 Timer Register k */
#define IOM_FPCTIM13	(*( IOM_FPCTIM0_type *) 0xf00350f4u)	/* IOM Filter and Prescaler Cell 13 Timer Register k */
#define IOM_FPCTIM14	(*( IOM_FPCTIM0_type *) 0xf00350f8u)	/* IOM Filter and Prescaler Cell 14 Timer Register k */
#define IOM_FPCTIM15	(*( IOM_FPCTIM0_type *) 0xf00350fcu)	/* IOM Filter and Prescaler Cell 15 Timer Register k */
#define IOM_FPCTIM2	(*( IOM_FPCTIM0_type *) 0xf00350c8u)	/* IOM Filter and Prescaler Cell 2 Timer Register k */
#define IOM_FPCTIM3	(*( IOM_FPCTIM0_type *) 0xf00350ccu)	/* IOM Filter and Prescaler Cell 3 Timer Register k */
#define IOM_FPCTIM4	(*( IOM_FPCTIM0_type *) 0xf00350d0u)	/* IOM Filter and Prescaler Cell 4 Timer Register k */
#define IOM_FPCTIM5	(*( IOM_FPCTIM0_type *) 0xf00350d4u)	/* IOM Filter and Prescaler Cell 5 Timer Register k */
#define IOM_FPCTIM6	(*( IOM_FPCTIM0_type *) 0xf00350d8u)	/* IOM Filter and Prescaler Cell 6 Timer Register k */
#define IOM_FPCTIM7	(*( IOM_FPCTIM0_type *) 0xf00350dcu)	/* IOM Filter and Prescaler Cell 7 Timer Register k */
#define IOM_FPCTIM8	(*( IOM_FPCTIM0_type *) 0xf00350e0u)	/* IOM Filter and Prescaler Cell 8 Timer Register k */
#define IOM_FPCTIM9	(*( IOM_FPCTIM0_type *) 0xf00350e4u)	/* IOM Filter and Prescaler Cell 9 Timer Register k */

typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* GTM input 0 selection for EXOR combiner */
		unsigned int EN1            : 1;	/* GTM input 1 selection for EXOR combiner */
		unsigned int EN2            : 1;	/* GTM input 2 selection for EXOR combiner */
		unsigned int EN3            : 1;	/* GTM input 3 selection for EXOR combiner */
		unsigned int EN4            : 1;	/* GTM input 4 selection for EXOR combiner */
		unsigned int EN5            : 1;	/* GTM input 5 selection for EXOR combiner */
		unsigned int EN6            : 1;	/* GTM input 6 selection for EXOR combiner */
		unsigned int EN7            : 1;	/* GTM input 7 selection for EXOR combiner */
		unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} IOM_GTMEXR_type;
#define IOM_GTMEXR	(*( IOM_GTMEXR_type *) 0xf0035040u)	/* IOM GTM Input EXOR Combiner Selection Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} IOM_ID_type;
#define IOM_ID	(*( IOM_ID_type *) 0xf0035008u)	/* IOM Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} IOM_KRST0_type;
#define IOM_KRST0	(*( IOM_KRST0_type *) 0xf0035024u)	/* IOM Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} IOM_KRST1_type;
#define IOM_KRST1	(*( IOM_KRST1_type *) 0xf0035020u)	/* IOM Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} IOM_KRSTCLR_type;
#define IOM_KRSTCLR	(*( IOM_KRSTCLR_type *) 0xf003501cu)	/* IOM Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int IVR            : 1;	/* Invert Reference LAM block m */
		unsigned int IVM            : 1;	/* Invert Monitor LAM block m */
		unsigned int MOS            : 1;	/* Monitor Source Select LAM block m */
		unsigned int RMS            : 1;	/* Runmode Select LAM block m */
		unsigned int EWS            : 1;	/* Event Window Select LAM block m */
		unsigned int                : 3;
		unsigned int EDS            : 4;	/* Event Window Active Edge Selection LAM block m */
		unsigned int IVW            : 1;	/* Invert Event Window LAM block m */
		unsigned int                : 3;
		unsigned int MCS            : 4;	/* Monitor Input Signal Selection LAM block m */
		unsigned int RCS            : 4;	/* Reference Input Signal Selection LAM block m */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} IOM_LAMCFG0_type;
#define IOM_LAMCFG0	(*( IOM_LAMCFG0_type *) 0xf0035180u)	/* IOM Logic Analyzer Module Configuration Register 0 */
#define IOM_LAMCFG1	(*( IOM_LAMCFG0_type *) 0xf0035184u)	/* IOM Logic Analyzer Module Configuration Register 1 */
#define IOM_LAMCFG10	(*( IOM_LAMCFG0_type *) 0xf00351a8u)	/* IOM Logic Analyzer Module Configuration Register 10 */
#define IOM_LAMCFG11	(*( IOM_LAMCFG0_type *) 0xf00351acu)	/* IOM Logic Analyzer Module Configuration Register 11 */
#define IOM_LAMCFG12	(*( IOM_LAMCFG0_type *) 0xf00351b0u)	/* IOM Logic Analyzer Module Configuration Register 12 */
#define IOM_LAMCFG13	(*( IOM_LAMCFG0_type *) 0xf00351b4u)	/* IOM Logic Analyzer Module Configuration Register 13 */
#define IOM_LAMCFG14	(*( IOM_LAMCFG0_type *) 0xf00351b8u)	/* IOM Logic Analyzer Module Configuration Register 14 */
#define IOM_LAMCFG15	(*( IOM_LAMCFG0_type *) 0xf00351bcu)	/* IOM Logic Analyzer Module Configuration Register 15 */
#define IOM_LAMCFG2	(*( IOM_LAMCFG0_type *) 0xf0035188u)	/* IOM Logic Analyzer Module Configuration Register 2 */
#define IOM_LAMCFG3	(*( IOM_LAMCFG0_type *) 0xf003518cu)	/* IOM Logic Analyzer Module Configuration Register 3 */
#define IOM_LAMCFG4	(*( IOM_LAMCFG0_type *) 0xf0035190u)	/* IOM Logic Analyzer Module Configuration Register 4 */
#define IOM_LAMCFG5	(*( IOM_LAMCFG0_type *) 0xf0035194u)	/* IOM Logic Analyzer Module Configuration Register 5 */
#define IOM_LAMCFG6	(*( IOM_LAMCFG0_type *) 0xf0035198u)	/* IOM Logic Analyzer Module Configuration Register 6 */
#define IOM_LAMCFG7	(*( IOM_LAMCFG0_type *) 0xf003519cu)	/* IOM Logic Analyzer Module Configuration Register 7 */
#define IOM_LAMCFG8	(*( IOM_LAMCFG0_type *) 0xf00351a0u)	/* IOM Logic Analyzer Module Configuration Register 8 */
#define IOM_LAMCFG9	(*( IOM_LAMCFG0_type *) 0xf00351a4u)	/* IOM Logic Analyzer Module Configuration Register 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CNT            : 24;	/* Event Window Count Value LAM block m */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} IOM_LAMEWC0_type;
#define IOM_LAMEWC0	(*( IOM_LAMEWC0_type *) 0xf0035100u)	/* IOM Logic Analyzer Module Event Window Count Status Register 0 */
#define IOM_LAMEWC1	(*( IOM_LAMEWC0_type *) 0xf0035104u)	/* IOM Logic Analyzer Module Event Window Count Status Register 1 */
#define IOM_LAMEWC10	(*( IOM_LAMEWC0_type *) 0xf0035128u)	/* IOM Logic Analyzer Module Event Window Count Status Register 10 */
#define IOM_LAMEWC11	(*( IOM_LAMEWC0_type *) 0xf003512cu)	/* IOM Logic Analyzer Module Event Window Count Status Register 11 */
#define IOM_LAMEWC12	(*( IOM_LAMEWC0_type *) 0xf0035130u)	/* IOM Logic Analyzer Module Event Window Count Status Register 12 */
#define IOM_LAMEWC13	(*( IOM_LAMEWC0_type *) 0xf0035134u)	/* IOM Logic Analyzer Module Event Window Count Status Register 13 */
#define IOM_LAMEWC14	(*( IOM_LAMEWC0_type *) 0xf0035138u)	/* IOM Logic Analyzer Module Event Window Count Status Register 14 */
#define IOM_LAMEWC15	(*( IOM_LAMEWC0_type *) 0xf003513cu)	/* IOM Logic Analyzer Module Event Window Count Status Register 15 */
#define IOM_LAMEWC2	(*( IOM_LAMEWC0_type *) 0xf0035108u)	/* IOM Logic Analyzer Module Event Window Count Status Register 2 */
#define IOM_LAMEWC3	(*( IOM_LAMEWC0_type *) 0xf003510cu)	/* IOM Logic Analyzer Module Event Window Count Status Register 3 */
#define IOM_LAMEWC4	(*( IOM_LAMEWC0_type *) 0xf0035110u)	/* IOM Logic Analyzer Module Event Window Count Status Register 4 */
#define IOM_LAMEWC5	(*( IOM_LAMEWC0_type *) 0xf0035114u)	/* IOM Logic Analyzer Module Event Window Count Status Register 5 */
#define IOM_LAMEWC6	(*( IOM_LAMEWC0_type *) 0xf0035118u)	/* IOM Logic Analyzer Module Event Window Count Status Register 6 */
#define IOM_LAMEWC7	(*( IOM_LAMEWC0_type *) 0xf003511cu)	/* IOM Logic Analyzer Module Event Window Count Status Register 7 */
#define IOM_LAMEWC8	(*( IOM_LAMEWC0_type *) 0xf0035120u)	/* IOM Logic Analyzer Module Event Window Count Status Register 8 */
#define IOM_LAMEWC9	(*( IOM_LAMEWC0_type *) 0xf0035124u)	/* IOM Logic Analyzer Module Event Window Count Status Register 9 */

typedef volatile union
{
	struct
	{ 
		unsigned int THR            : 24;	/* Event Window Count Threshold */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} IOM_LAMEWS0_type;
#define IOM_LAMEWS0	(*( IOM_LAMEWS0_type *) 0xf00351c0u)	/* IOM Logic Analyzer Module Event Window Configuration Register 0 */
#define IOM_LAMEWS1	(*( IOM_LAMEWS0_type *) 0xf00351c4u)	/* IOM Logic Analyzer Module Event Window Configuration Register 1 */
#define IOM_LAMEWS10	(*( IOM_LAMEWS0_type *) 0xf00351e8u)	/* IOM Logic Analyzer Module Event Window Configuration Register 10 */
#define IOM_LAMEWS11	(*( IOM_LAMEWS0_type *) 0xf00351ecu)	/* IOM Logic Analyzer Module Event Window Configuration Register 11 */
#define IOM_LAMEWS12	(*( IOM_LAMEWS0_type *) 0xf00351f0u)	/* IOM Logic Analyzer Module Event Window Configuration Register 12 */
#define IOM_LAMEWS13	(*( IOM_LAMEWS0_type *) 0xf00351f4u)	/* IOM Logic Analyzer Module Event Window Configuration Register 13 */
#define IOM_LAMEWS14	(*( IOM_LAMEWS0_type *) 0xf00351f8u)	/* IOM Logic Analyzer Module Event Window Configuration Register 14 */
#define IOM_LAMEWS15	(*( IOM_LAMEWS0_type *) 0xf00351fcu)	/* IOM Logic Analyzer Module Event Window Configuration Register 15 */
#define IOM_LAMEWS2	(*( IOM_LAMEWS0_type *) 0xf00351c8u)	/* IOM Logic Analyzer Module Event Window Configuration Register 2 */
#define IOM_LAMEWS3	(*( IOM_LAMEWS0_type *) 0xf00351ccu)	/* IOM Logic Analyzer Module Event Window Configuration Register 3 */
#define IOM_LAMEWS4	(*( IOM_LAMEWS0_type *) 0xf00351d0u)	/* IOM Logic Analyzer Module Event Window Configuration Register 4 */
#define IOM_LAMEWS5	(*( IOM_LAMEWS0_type *) 0xf00351d4u)	/* IOM Logic Analyzer Module Event Window Configuration Register 5 */
#define IOM_LAMEWS6	(*( IOM_LAMEWS0_type *) 0xf00351d8u)	/* IOM Logic Analyzer Module Event Window Configuration Register 6 */
#define IOM_LAMEWS7	(*( IOM_LAMEWS0_type *) 0xf00351dcu)	/* IOM Logic Analyzer Module Event Window Configuration Register 7 */
#define IOM_LAMEWS8	(*( IOM_LAMEWS0_type *) 0xf00351e0u)	/* IOM Logic Analyzer Module Event Window Configuration Register 8 */
#define IOM_LAMEWS9	(*( IOM_LAMEWS0_type *) 0xf00351e4u)	/* IOM Logic Analyzer Module Event Window Configuration Register 9 */


/* PSI5 */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} PSI5_ACCEN0_type;
#define PSI5_ACCEN0	(*( PSI5_ACCEN0_type *) 0xf00053d0u)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} PSI5_ACCEN1_type;
#define PSI5_ACCEN1	(*( PSI5_ACCEN1_type *) 0xf00053d4u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} PSI5_CLC_type;
#define PSI5_CLC	(*( PSI5_CLC_type *) 0xf0005000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CRCI0          : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI1          : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI2          : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI3          : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI4          : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI5          : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI6          : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI7          : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI8          : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI9          : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI10         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI11         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI12         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI13         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI14         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI15         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI16         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI17         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI18         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI19         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI20         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI21         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI22         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI23         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI24         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI25         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI26         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI27         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI28         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI29         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI30         : 1;	/* Clear CRCI Flag of Buffer y */
		unsigned int CRCI31         : 1;	/* Clear CRCI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_CRCICLR0_type;
#define PSI5_CRCICLR0	(*( PSI5_CRCICLR0_type *) 0xf000559cu)	/* CRCIOV0 Clear Register */
#define PSI5_CRCICLR1	(*( PSI5_CRCICLR0_type *) 0xf00055a0u)	/* CRCIOV1 Clear Register */
#define PSI5_CRCICLR2	(*( PSI5_CRCICLR0_type *) 0xf00055a4u)	/* CRCIOV2 Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CRCI0          : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI1          : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI2          : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI3          : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI4          : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI5          : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI6          : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI7          : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI8          : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI9          : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI10         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI11         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI12         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI13         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI14         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI15         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI16         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI17         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI18         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI19         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI20         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI21         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI22         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI23         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI24         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI25         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI26         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI27         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI28         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI29         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI30         : 1;	/* CRCI Flag of Buffer y */
		/* const */ unsigned int CRCI31         : 1;	/* CRCI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_CRCIOV0_type;
#define PSI5_CRCIOV0	(*( PSI5_CRCIOV0_type *) 0xf000545cu)	/* CRCI Overview Register */
#define PSI5_CRCIOV1	(*( PSI5_CRCIOV0_type *) 0xf0005460u)	/* CRCI Overview Register */
#define PSI5_CRCIOV2	(*( PSI5_CRCIOV0_type *) 0xf0005464u)	/* CRCI Overview Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CRCI0          : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI1          : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI2          : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI3          : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI4          : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI5          : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI6          : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI7          : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI8          : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI9          : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI10         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI11         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI12         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI13         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI14         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI15         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI16         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI17         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI18         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI19         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI20         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI21         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI22         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI23         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI24         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI25         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI26         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI27         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI28         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI29         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI30         : 1;	/* Set CRCI Flag of Buffer y */
		unsigned int CRCI31         : 1;	/* Set CRCI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_CRCISET0_type;
#define PSI5_CRCISET0	(*( PSI5_CRCISET0_type *) 0xf00054fcu)	/* CRCIOV0 Set Register */
#define PSI5_CRCISET1	(*( PSI5_CRCISET0_type *) 0xf0005500u)	/* CRCIOV1 Set Register */
#define PSI5_CRCISET2	(*( PSI5_CRCISET0_type *) 0xf0005504u)	/* CRCIOV2 Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CTV            : 16;	/* Channel Trigger Value CTV */
		unsigned int CTC            : 16;	/* Channel Trigger Counter */
	} B;
	int I;
	unsigned int U;

} PSI5_CTV0_type;
#define PSI5_CTV0	(*( PSI5_CTV0_type *) 0xf000508cu)	/* Channel Trigger Value Register 0 */
#define PSI5_CTV1	(*( PSI5_CTV0_type *) 0xf000511cu)	/* Channel Trigger Value Register 1 */
#define PSI5_CTV2	(*( PSI5_CTV0_type *) 0xf00051acu)	/* Channel Trigger Value Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int STEP           : 10;	/* Step Value */
		unsigned int                : 4;
		unsigned int DM             : 2;	/* Divider Mode */
		/* const */ unsigned int RESULT         : 10;	/* Result Value */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} PSI5_FDR_type;
#define PSI5_FDR	(*( PSI5_FDR_type *) 0xf000500cu)	/* SMU Fractional Divider Register */

typedef volatile union
{
	struct
	{ 
		unsigned int STEP           : 10;	/* Step Value */
		unsigned int                : 4;
		unsigned int DM             : 2;	/* Divider Mode */
		/* const */ unsigned int RESULT         : 10;	/* Result Value */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} PSI5_FDRH_type;
#define PSI5_FDRH	(*( PSI5_FDRH_type *) 0xf0005014u)	/* Fractional Divider Register for Higher Bit Rate */
#define PSI5_FDRL	(*( PSI5_FDRH_type *) 0xf0005010u)	/* Fractional Divider Register for Lower Bit Rate */

typedef volatile union
{
	struct
	{ 
		unsigned int STEP           : 10;	/* Step Value */
		unsigned int                : 4;
		unsigned int DM             : 2;	/* Divider Mode */
		/* const */ unsigned int RESULT         : 10;	/* Result Value */
		unsigned int ECS            : 3;	/* External Time Stamp Clear Source Select */
		unsigned int ECEA           : 1;	/* External Time Stamp Clear Enable A */
		unsigned int ECEB           : 1;	/* External Time Stamp Clear Enable B */
		unsigned int ECEC           : 1;	/* External Time Stamp Clear Enable C */
	} B;
	int I;
	unsigned int U;

} PSI5_FDRT_type;
#define PSI5_FDRT	(*( PSI5_FDRT_type *) 0xf0005018u)	/* Fractional Divider Register for Time Stamp */

typedef volatile union
{
	struct
	{ 
		unsigned int CRCI           : 1;	/* CRCI */
		unsigned int NBI            : 1;	/* NBI */
		unsigned int MEI            : 1;	/* MEI */
		unsigned int NFI            : 1;	/* NFI */
		unsigned int TEI            : 1;	/* TEI */
		unsigned int                : 3;
		unsigned int ETC0           : 1;	/* Enable Channel Trigger Counter CTVx.CTC */
		unsigned int ETC1           : 1;	/* Enable Channel Trigger Counter CTVx.CTC */
		unsigned int ETC2           : 1;	/* Enable Channel Trigger Counter CTVx.CTC */
		unsigned int ETC3           : 1;	/* Enable Channel Trigger Counter CTVx.CTC */
		unsigned int ETC4           : 1;	/* Enable Channel Trigger Counter CTVx.CTC */
		unsigned int                : 3;
		unsigned int CEN0           : 1;	/* Enable Channel */
		unsigned int CEN1           : 1;	/* Enable Channel */
		unsigned int CEN2           : 1;	/* Enable Channel */
		unsigned int CEN3           : 1;	/* Enable Channel */
		unsigned int CEN4           : 1;	/* Enable Channel */
		unsigned int                : 11;
	} B;
	int I;
	unsigned int U;

} PSI5_GCR_type;
#define PSI5_GCR	(*( PSI5_GCR_type *) 0xf000502cu)	/* Global Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} PSI5_ID_type;
#define PSI5_ID	(*( PSI5_ID_type *) 0xf0005008u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RSI            : 4;	/* Interrupt Node Pointer for Interrupt RSI */
		unsigned int RDI            : 4;	/* Interrupt Node Pointer for Interrupt RDI */
		unsigned int RBI            : 4;	/* Interrupt Node Pointer for Interrupt RBI */
		unsigned int TDI            : 4;	/* Interrupt Node Pointer for Interrupt TDI */
		unsigned int TBI            : 4;	/* Interrupt Node Pointer for Interrupt TBI */
		unsigned int ERRI           : 4;	/* Interrupt Node Pointer for Interrupt ERRI */
		unsigned int SDI            : 4;	/* Interrupt Node Pointer for Interrupt SDI */
		unsigned int FWI            : 4;	/* Interrupt Node Pointer for FWI */
	} B;
	int I;
	unsigned int U;

} PSI5_INP0_type;
#define PSI5_INP0	(*( PSI5_INP0_type *) 0xf00052fcu)	/* Interrupt Node Pointer Register 0 */
#define PSI5_INP1	(*( PSI5_INP0_type *) 0xf0005300u)	/* Interrupt Node Pointer Register 1 */
#define PSI5_INP2	(*( PSI5_INP0_type *) 0xf0005304u)	/* Interrupt Node Pointer Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int RSI            : 1;	/* Clear Interrupt Request Flag RSI */
		unsigned int RDI            : 1;	/* Clear Interrupt Request Flag RDI */
		unsigned int RBI            : 1;	/* Clear Interrupt Request Flag RBI */
		unsigned int TEI            : 1;	/* Clear Interrupt Request Flag TEI */
		unsigned int NBI            : 1;	/* Clear Interrupt Request Flag NBI */
		unsigned int MEI            : 1;	/* Clear Interrupt Request Flag MEI */
		unsigned int CRCI           : 1;	/* Clear Interrupt Request Flag CRCI */
		unsigned int FWI            : 1;	/* Clear Interrupt Request Flag FWI */
		unsigned int RUI            : 1;	/* Clear Interrupt Request Flag RUI */
		unsigned int RMI            : 1;	/* Clear Interrupt Request Flag RMI */
		unsigned int TPI            : 1;	/* Clear Interrupt Request Flag TPI */
		unsigned int TPOI           : 1;	/* Clear Interrupt Request Flag TPOI */
		unsigned int TSI            : 1;	/* Clear Interrupt Request Flag TSI */
		unsigned int TSOI           : 1;	/* Clear Interrupt Request Flag TSOI */
		unsigned int TOI            : 1;	/* Clear Interrupt Request Flag TOI */
		unsigned int TOOI           : 1;	/* Clear Interrupt Request Flag TOOI */
		unsigned int NFI            : 1;	/* Clear Interrupt Request Flag NFI */
		unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} PSI5_INTCLRA0_type;
#define PSI5_INTCLRA0	(*( PSI5_INTCLRA0_type *) 0xf0005360u)	/* Interrupt Clear Register A 0 */
#define PSI5_INTCLRA1	(*( PSI5_INTCLRA0_type *) 0xf0005364u)	/* Interrupt Clear Register A 1 */
#define PSI5_INTCLRA2	(*( PSI5_INTCLRA0_type *) 0xf0005368u)	/* Interrupt Clear Register A 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int WSI0           : 1;	/* Clear Interrupt Request Flag WSIy */
		unsigned int WSI1           : 1;	/* Clear Interrupt Request Flag WSIy */
		unsigned int WSI2           : 1;	/* Clear Interrupt Request Flag WSIy */
		unsigned int WSI3           : 1;	/* Clear Interrupt Request Flag WSIy */
		unsigned int WSI4           : 1;	/* Clear Interrupt Request Flag WSIy */
		unsigned int WSI5           : 1;	/* Clear Interrupt Request Flag WSIy */
		unsigned int SDI0           : 1;	/* Clear Interrupt Request Flag SDIy */
		unsigned int SDI1           : 1;	/* Clear Interrupt Request Flag SDIy */
		unsigned int SDI2           : 1;	/* Clear Interrupt Request Flag SDIy */
		unsigned int SDI3           : 1;	/* Clear Interrupt Request Flag SDIy */
		unsigned int SDI4           : 1;	/* Clear Interrupt Request Flag SDIy */
		unsigned int SDI5           : 1;	/* Clear Interrupt Request Flag SDIy */
		unsigned int SOI0           : 1;	/* Clear Interrupt Request Flag SOIy */
		unsigned int SOI1           : 1;	/* Clear Interrupt Request Flag SOIy */
		unsigned int SOI2           : 1;	/* Clear Interrupt Request Flag SOIy */
		unsigned int SOI3           : 1;	/* Clear Interrupt Request Flag SOIy */
		unsigned int SOI4           : 1;	/* Clear Interrupt Request Flag SOIy */
		unsigned int SOI5           : 1;	/* Clear Interrupt Request Flag SOIy */
		unsigned int SCRI0          : 1;	/* Clear Interrupt Request Flag SCRIy */
		unsigned int SCRI1          : 1;	/* Clear Interrupt Request Flag SCRIy */
		unsigned int SCRI2          : 1;	/* Clear Interrupt Request Flag SCRIy */
		unsigned int SCRI3          : 1;	/* Clear Interrupt Request Flag SCRIy */
		unsigned int SCRI4          : 1;	/* Clear Interrupt Request Flag SCRIy */
		unsigned int SCRI5          : 1;	/* Clear Interrupt Request Flag SCRIy */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} PSI5_INTCLRB0_type;
#define PSI5_INTCLRB0	(*( PSI5_INTCLRB0_type *) 0xf0005374u)	/* Interrupt Clear Register A 0 */
#define PSI5_INTCLRB1	(*( PSI5_INTCLRB0_type *) 0xf0005378u)	/* Interrupt Clear Register A 1 */
#define PSI5_INTCLRB2	(*( PSI5_INTCLRB0_type *) 0xf000537cu)	/* Interrupt Clear Register A 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int RSI            : 1;	/* Enable Interrupt Request RSI */
		unsigned int RDI            : 1;	/* Enable Interrupt Request RDI */
		unsigned int RBI            : 1;	/* Enable Interrupt Request RBI */
		unsigned int TEI            : 1;	/* Enable Interrupt Request TEI */
		unsigned int NBI            : 1;	/* Enable Interrupt Request NBI */
		unsigned int MEI            : 1;	/* Enable Interrupt Request MEII */
		unsigned int CRCI           : 1;	/* Enable Interrupt Request CRCI */
		unsigned int FWI            : 1;	/* Enable Interrupt Request FWI */
		unsigned int RUI            : 1;	/* Enable Interrupt Request RUI */
		unsigned int RMI            : 1;	/* Enable Interrupt Request RMII */
		unsigned int TPI            : 1;	/* Enable Interrupt Request TPI */
		unsigned int TPOI           : 1;	/* Enable Interrupt Request TPOI */
		unsigned int TSI            : 1;	/* Enable Interrupt Request TSI */
		unsigned int TSOI           : 1;	/* Enable Interrupt Request TSOI */
		unsigned int TOI            : 1;	/* Enable Interrupt Request TOI */
		unsigned int TOOI           : 1;	/* Enable Interrupt Request TOOI */
		unsigned int NFI            : 1;	/* Enable Interrupt Request NFI */
		unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} PSI5_INTENA0_type;
#define PSI5_INTENA0	(*( PSI5_INTENA0_type *) 0xf0005388u)	/* Interrupt Enable Register A 0 */
#define PSI5_INTENA1	(*( PSI5_INTENA0_type *) 0xf000538cu)	/* Interrupt Enable Register A 1 */
#define PSI5_INTENA2	(*( PSI5_INTENA0_type *) 0xf0005390u)	/* Interrupt Enable Register A 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int WSI0           : 1;	/* Enable Interrupt Request WSIy */
		unsigned int WSI1           : 1;	/* Enable Interrupt Request WSIy */
		unsigned int WSI2           : 1;	/* Enable Interrupt Request WSIy */
		unsigned int WSI3           : 1;	/* Enable Interrupt Request WSIy */
		unsigned int WSI4           : 1;	/* Enable Interrupt Request WSIy */
		unsigned int WSI5           : 1;	/* Enable Interrupt Request WSIy */
		unsigned int SDI0           : 1;	/* Enable Interrupt Request SDIy */
		unsigned int SDI1           : 1;	/* Enable Interrupt Request SDIy */
		unsigned int SDI2           : 1;	/* Enable Interrupt Request SDIy */
		unsigned int SDI3           : 1;	/* Enable Interrupt Request SDIy */
		unsigned int SDI4           : 1;	/* Enable Interrupt Request SDIy */
		unsigned int SDI5           : 1;	/* Enable Interrupt Request SDIy */
		unsigned int SOI0           : 1;	/* Enable Interrupt Request SOIy */
		unsigned int SOI1           : 1;	/* Enable Interrupt Request SOIy */
		unsigned int SOI2           : 1;	/* Enable Interrupt Request SOIy */
		unsigned int SOI3           : 1;	/* Enable Interrupt Request SOIy */
		unsigned int SOI4           : 1;	/* Enable Interrupt Request SOIy */
		unsigned int SOI5           : 1;	/* Enable Interrupt Request SOIy */
		unsigned int SCRI0          : 1;	/* Enable Interrupt Request SCRIy */
		unsigned int SCRI1          : 1;	/* Enable Interrupt Request SCRIy */
		unsigned int SCRI2          : 1;	/* Enable Interrupt Request SCRIy */
		unsigned int SCRI3          : 1;	/* Enable Interrupt Request SCRIy */
		unsigned int SCRI4          : 1;	/* Enable Interrupt Request SCRIy */
		unsigned int SCRI5          : 1;	/* Enable Interrupt Request SCRIy */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} PSI5_INTENB0_type;
#define PSI5_INTENB0	(*( PSI5_INTENB0_type *) 0xf000539cu)	/* Interrupt Enable Register B 0 */
#define PSI5_INTENB1	(*( PSI5_INTENB0_type *) 0xf00053a0u)	/* Interrupt Enable Register B 1 */
#define PSI5_INTENB2	(*( PSI5_INTENB0_type *) 0xf00053a4u)	/* Interrupt Enable Register B 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RSI            : 1;	/* Interrupt Pending on any Node Pointer RSI */
		/* const */ unsigned int RDI            : 1;	/* Interrupt Pending on any Node Pointer RDI */
		/* const */ unsigned int RBI            : 1;	/* Interrupt Pending on any Node Pointer RBI */
		/* const */ unsigned int TDI            : 1;	/* Interrupt Pending on any Node Pointer TDI */
		/* const */ unsigned int TBI            : 1;	/* Interrupt Pending on any Node Pointer TBI */
		/* const */ unsigned int ERRI           : 1;	/* Interrupt Pending on any Node Pointer ERRI */
		/* const */ unsigned int SDI            : 1;	/* Interrupt Pending on any Node Pointer SDI */
		/* const */ unsigned int FWI            : 1;	/* Interrupt Pending on any Node Pointer FWI */
		/* const */ unsigned int                : 24;
	} B;
	int I;
	unsigned int U;

} PSI5_INTOV_type;
#define PSI5_INTOV	(*( PSI5_INTOV_type *) 0xf00052f8u)	/* Interrupt Overview Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RSI            : 1;	/* Set Interrupt Request Flag RSI */
		unsigned int RDI            : 1;	/* Set Interrupt Request Flag RDI */
		unsigned int RBI            : 1;	/* Set Interrupt Request Flag RBI */
		unsigned int TEI            : 1;	/* Set Interrupt Request Flag TEI */
		unsigned int NBI            : 1;	/* Set Interrupt Request Flag NBI */
		unsigned int MEI            : 1;	/* Set Interrupt Request Flag MEI */
		unsigned int CRCI           : 1;	/* Set Interrupt Request Flag CRCI */
		unsigned int FWI            : 1;	/* Set Interrupt Request Flag FWI */
		unsigned int RUI            : 1;	/* Set Interrupt Request Flag RUI */
		unsigned int RMI            : 1;	/* Set Interrupt Request Flag RMI */
		unsigned int TPI            : 1;	/* Set Interrupt Request Flag TPI */
		unsigned int TPOI           : 1;	/* Set Interrupt Request Flag TPOI */
		unsigned int TSI            : 1;	/* Set Interrupt Request Flag TSI */
		unsigned int TSOI           : 1;	/* Set Interrupt Request Flag TSOI */
		unsigned int TOI            : 1;	/* Set Interrupt Request Flag TOI */
		unsigned int TOOI           : 1;	/* Set Interrupt Request Flag TOOI */
		unsigned int NFI            : 1;	/* Set Interrupt Request Flag NFI */
		unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} PSI5_INTSETA0_type;
#define PSI5_INTSETA0	(*( PSI5_INTSETA0_type *) 0xf0005338u)	/* Interrupt Set Register A 0 */
#define PSI5_INTSETA1	(*( PSI5_INTSETA0_type *) 0xf000533cu)	/* Interrupt Set Register A 1 */
#define PSI5_INTSETA2	(*( PSI5_INTSETA0_type *) 0xf0005340u)	/* Interrupt Set Register A 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int WSI0           : 1;	/* Set Interrupt Request Flag WSIy */
		unsigned int WSI1           : 1;	/* Set Interrupt Request Flag WSIy */
		unsigned int WSI2           : 1;	/* Set Interrupt Request Flag WSIy */
		unsigned int WSI3           : 1;	/* Set Interrupt Request Flag WSIy */
		unsigned int WSI4           : 1;	/* Set Interrupt Request Flag WSIy */
		unsigned int WSI5           : 1;	/* Set Interrupt Request Flag WSIy */
		unsigned int SDI0           : 1;	/* Set Interrupt Request Flag SDIy */
		unsigned int SDI1           : 1;	/* Set Interrupt Request Flag SDIy */
		unsigned int SDI2           : 1;	/* Set Interrupt Request Flag SDIy */
		unsigned int SDI3           : 1;	/* Set Interrupt Request Flag SDIy */
		unsigned int SDI4           : 1;	/* Set Interrupt Request Flag SDIy */
		unsigned int SDI5           : 1;	/* Set Interrupt Request Flag SDIy */
		unsigned int SOI0           : 1;	/* Set Interrupt Request Flag SOIy */
		unsigned int SOI1           : 1;	/* Set Interrupt Request Flag SOIy */
		unsigned int SOI2           : 1;	/* Set Interrupt Request Flag SOIy */
		unsigned int SOI3           : 1;	/* Set Interrupt Request Flag SOIy */
		unsigned int SOI4           : 1;	/* Set Interrupt Request Flag SOIy */
		unsigned int SOI5           : 1;	/* Set Interrupt Request Flag SOIy */
		unsigned int SCRI0          : 1;	/* Set Interrupt Request Flag SCRIy */
		unsigned int SCRI1          : 1;	/* Set Interrupt Request Flag SCRIy */
		unsigned int SCRI2          : 1;	/* Set Interrupt Request Flag SCRIy */
		unsigned int SCRI3          : 1;	/* Set Interrupt Request Flag SCRIy */
		unsigned int SCRI4          : 1;	/* Set Interrupt Request Flag SCRIy */
		unsigned int SCRI5          : 1;	/* Set Interrupt Request Flag SCRIy */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} PSI5_INTSETB0_type;
#define PSI5_INTSETB0	(*( PSI5_INTSETB0_type *) 0xf000534cu)	/* Interrupt Set Register B 0 */
#define PSI5_INTSETB1	(*( PSI5_INTSETB0_type *) 0xf0005350u)	/* Interrupt Set Register B 1 */
#define PSI5_INTSETB2	(*( PSI5_INTSETB0_type *) 0xf0005354u)	/* Interrupt Set Register B 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RSI            : 1;	/* Receive Success Interrupt Request Flag */
		/* const */ unsigned int RDI            : 1;	/* Receive Data Interrupt Request Flag */
		/* const */ unsigned int RBI            : 1;	/* Receive Buffer Overflow Interrupt Request Flag */
		/* const */ unsigned int TEI            : 1;	/* Time Slot Error Interrupt Request Flag */
		/* const */ unsigned int NBI            : 1;	/* Number of Bits too low Request Flag */
		/* const */ unsigned int MEI            : 1;	/* Error in Message Bits Flag */
		/* const */ unsigned int CRCI           : 1;	/* CRC Error Request Flag */
		/* const */ unsigned int FWI            : 1;	/* FIFO Warning Level Request Flag */
		/* const */ unsigned int RUI            : 1;	/* Receive Memory Underrun Interrupt Request Flag */
		/* const */ unsigned int RMI            : 1;	/* Receive Memory Overflow Flag */
		/* const */ unsigned int TPI            : 1;	/* Transfer Preparation Interrupt Request Flag */
		/* const */ unsigned int TPOI           : 1;	/* Transmit Preparation Overflow Interrupt Request Flag */
		/* const */ unsigned int TSI            : 1;	/* Transfer Shift Interrupt Request Flag */
		/* const */ unsigned int TSOI           : 1;	/* Transmit Shift Overflow Interrupt Request Flag */
		/* const */ unsigned int TOI            : 1;	/* Transfer Output Interrupt Request Flag */
		/* const */ unsigned int TOOI           : 1;	/* Transmit Shift Overflow Interrupt Request Flag */
		/* const */ unsigned int NFI            : 1;	/* No Frame Received Interrupt Flag */
		/* const */ unsigned int                : 15;
	} B;
	int I;
	unsigned int U;

} PSI5_INTSTATA0_type;
#define PSI5_INTSTATA0	(*( PSI5_INTSTATA0_type *) 0xf0005310u)	/* Interrupt Status Register A 0 */
#define PSI5_INTSTATA1	(*( PSI5_INTSTATA0_type *) 0xf0005314u)	/* Interrupt Status Register A 1 */
#define PSI5_INTSTATA2	(*( PSI5_INTSTATA0_type *) 0xf0005318u)	/* Interrupt Status Register A 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int WSI0           : 1;	/* Wrong Serial Protocol Error Request Flag */
		/* const */ unsigned int WSI1           : 1;	/* Wrong Serial Protocol Error Request Flag */
		/* const */ unsigned int WSI2           : 1;	/* Wrong Serial Protocol Error Request Flag */
		/* const */ unsigned int WSI3           : 1;	/* Wrong Serial Protocol Error Request Flag */
		/* const */ unsigned int WSI4           : 1;	/* Wrong Serial Protocol Error Request Flag */
		/* const */ unsigned int WSI5           : 1;	/* Wrong Serial Protocol Error Request Flag */
		/* const */ unsigned int SDI0           : 1;	/* Serial Data Receive Interrupt Request Flag */
		/* const */ unsigned int SDI1           : 1;	/* Serial Data Receive Interrupt Request Flag */
		/* const */ unsigned int SDI2           : 1;	/* Serial Data Receive Interrupt Request Flag */
		/* const */ unsigned int SDI3           : 1;	/* Serial Data Receive Interrupt Request Flag */
		/* const */ unsigned int SDI4           : 1;	/* Serial Data Receive Interrupt Request Flag */
		/* const */ unsigned int SDI5           : 1;	/* Serial Data Receive Interrupt Request Flag */
		/* const */ unsigned int SOI0           : 1;	/* Serial Data Buffer Overrun Interrupt Request Flag */
		/* const */ unsigned int SOI1           : 1;	/* Serial Data Buffer Overrun Interrupt Request Flag */
		/* const */ unsigned int SOI2           : 1;	/* Serial Data Buffer Overrun Interrupt Request Flag */
		/* const */ unsigned int SOI3           : 1;	/* Serial Data Buffer Overrun Interrupt Request Flag */
		/* const */ unsigned int SOI4           : 1;	/* Serial Data Buffer Overrun Interrupt Request Flag */
		/* const */ unsigned int SOI5           : 1;	/* Serial Data Buffer Overrun Interrupt Request Flag */
		/* const */ unsigned int SCRI0          : 1;	/* Serial Data CRC Error Request Flag */
		/* const */ unsigned int SCRI1          : 1;	/* Serial Data CRC Error Request Flag */
		/* const */ unsigned int SCRI2          : 1;	/* Serial Data CRC Error Request Flag */
		/* const */ unsigned int SCRI3          : 1;	/* Serial Data CRC Error Request Flag */
		/* const */ unsigned int SCRI4          : 1;	/* Serial Data CRC Error Request Flag */
		/* const */ unsigned int SCRI5          : 1;	/* Serial Data CRC Error Request Flag */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} PSI5_INTSTATB0_type;
#define PSI5_INTSTATB0	(*( PSI5_INTSTATB0_type *) 0xf0005324u)	/* Interrupt Status Register B 0 */
#define PSI5_INTSTATB1	(*( PSI5_INTSTATB0_type *) 0xf0005328u)	/* Interrupt Status Register B 1 */
#define PSI5_INTSTATB2	(*( PSI5_INTSTATB0_type *) 0xf000532cu)	/* Interrupt Status Register B 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int ALTI           : 2;	/* Alternate Input Select */
		unsigned int                : 2;
		unsigned int DEPTH          : 4;	/* Digital Glitch Filter Depth */
		unsigned int OIE            : 1;	/* Output Inverter Enable Channel x */
		unsigned int IIE            : 1;	/* Input Inverter Enable Channel x */
		unsigned int                : 2;
		/* const */ unsigned int REG            : 1;	/* Rising Edge Glitch Flag for Channel x */
		/* const */ unsigned int FEG            : 1;	/* Falling Edge Glitch Flag for Channel x */
		unsigned int CREG           : 1;	/* Clear Rising Edge Glitch Flag for Channel x */
		unsigned int CFEG           : 1;	/* Clear Falling Edge Glitch Flag for Channel x */
		unsigned int                : 14;
		/* const */ unsigned int RXM            : 1;	/* Receive Monitor for Channel x */
		/* const */ unsigned int TXM            : 1;	/* Transmit Monitor for Channel x */
	} B;
	int I;
	unsigned int U;

} PSI5_IOCR0_type;
#define PSI5_IOCR0	(*( PSI5_IOCR0_type *) 0xf0005030u)	/* Input and Output Control Register 0 */
#define PSI5_IOCR1	(*( PSI5_IOCR0_type *) 0xf00050c0u)	/* Input and Output Control Register 1 */
#define PSI5_IOCR2	(*( PSI5_IOCR0_type *) 0xf0005150u)	/* Input and Output Control Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} PSI5_KRST0_type;
#define PSI5_KRST0	(*( PSI5_KRST0_type *) 0xf00053d8u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} PSI5_KRST1_type;
#define PSI5_KRST1	(*( PSI5_KRST1_type *) 0xf00053dcu)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} PSI5_KRSTCLR_type;
#define PSI5_KRSTCLR	(*( PSI5_KRSTCLR_type *) 0xf00053e0u)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MEI0           : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI1           : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI2           : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI3           : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI4           : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI5           : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI6           : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI7           : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI8           : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI9           : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI10          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI11          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI12          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI13          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI14          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI15          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI16          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI17          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI18          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI19          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI20          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI21          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI22          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI23          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI24          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI25          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI26          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI27          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI28          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI29          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI30          : 1;	/* Clear MEI Flag of Buffer y */
		unsigned int MEI31          : 1;	/* Clear MEI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_MEICLR0_type;
#define PSI5_MEICLR0	(*( PSI5_MEICLR0_type *) 0xf00055d8u)	/* MEIOV0 Clear Register */
#define PSI5_MEICLR1	(*( PSI5_MEICLR0_type *) 0xf00055dcu)	/* MEIOV1 Clear Register */
#define PSI5_MEICLR2	(*( PSI5_MEICLR0_type *) 0xf00055e0u)	/* MEIOV2 Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MEI0           : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI1           : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI2           : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI3           : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI4           : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI5           : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI6           : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI7           : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI8           : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI9           : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI10          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI11          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI12          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI13          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI14          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI15          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI16          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI17          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI18          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI19          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI20          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI21          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI22          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI23          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI24          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI25          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI26          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI27          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI28          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI29          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI30          : 1;	/* MEI Flag of Buffer y */
		/* const */ unsigned int MEI31          : 1;	/* MEI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_MEIOV0_type;
#define PSI5_MEIOV0	(*( PSI5_MEIOV0_type *) 0xf0005498u)	/* MEI Overview Register */
#define PSI5_MEIOV1	(*( PSI5_MEIOV0_type *) 0xf000549cu)	/* MEI Overview Register */
#define PSI5_MEIOV2	(*( PSI5_MEIOV0_type *) 0xf00054a0u)	/* MEI Overview Register */

typedef volatile union
{
	struct
	{ 
		unsigned int MEI0           : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI1           : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI2           : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI3           : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI4           : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI5           : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI6           : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI7           : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI8           : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI9           : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI10          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI11          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI12          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI13          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI14          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI15          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI16          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI17          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI18          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI19          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI20          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI21          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI22          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI23          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI24          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI25          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI26          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI27          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI28          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI29          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI30          : 1;	/* Set MEI Flag of Buffer y */
		unsigned int MEI31          : 1;	/* Set MEI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_MEISET0_type;
#define PSI5_MEISET0	(*( PSI5_MEISET0_type *) 0xf0005538u)	/* MEIOV0 Set Register */
#define PSI5_MEISET1	(*( PSI5_MEISET0_type *) 0xf000553cu)	/* MEIOV1 Set Register */
#define PSI5_MEISET2	(*( PSI5_MEISET0_type *) 0xf0005540u)	/* MEIOV2 Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NBI0           : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI1           : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI2           : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI3           : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI4           : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI5           : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI6           : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI7           : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI8           : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI9           : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI10          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI11          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI12          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI13          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI14          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI15          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI16          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI17          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI18          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI19          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI20          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI21          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI22          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI23          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI24          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI25          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI26          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI27          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI28          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI29          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI30          : 1;	/* Clear NBI Flag of Buffer y */
		unsigned int NBI31          : 1;	/* Clear NBI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_NBICLR0_type;
#define PSI5_NBICLR0	(*( PSI5_NBICLR0_type *) 0xf0005574u)	/* NBIOV0 Clear Register */
#define PSI5_NBICLR1	(*( PSI5_NBICLR0_type *) 0xf0005578u)	/* NBIOV1 Clear Register */
#define PSI5_NBICLR2	(*( PSI5_NBICLR0_type *) 0xf000557cu)	/* NBIOV2 Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int NBI0           : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI1           : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI2           : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI3           : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI4           : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI5           : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI6           : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI7           : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI8           : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI9           : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI10          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI11          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI12          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI13          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI14          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI15          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI16          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI17          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI18          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI19          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI20          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI21          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI22          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI23          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI24          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI25          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI26          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI27          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI28          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI29          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI30          : 1;	/* NBI Flag of Buffer y */
		/* const */ unsigned int NBI31          : 1;	/* NBI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_NBIOV0_type;
#define PSI5_NBIOV0	(*( PSI5_NBIOV0_type *) 0xf0005434u)	/* NBI Overview Register */
#define PSI5_NBIOV1	(*( PSI5_NBIOV0_type *) 0xf0005438u)	/* NBI Overview Register */
#define PSI5_NBIOV2	(*( PSI5_NBIOV0_type *) 0xf000543cu)	/* NBI Overview Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NBI0           : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI1           : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI2           : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI3           : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI4           : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI5           : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI6           : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI7           : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI8           : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI9           : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI10          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI11          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI12          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI13          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI14          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI15          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI16          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI17          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI18          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI19          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI20          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI21          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI22          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI23          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI24          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI25          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI26          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI27          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI28          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI29          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI30          : 1;	/* Set NBI Flag of Buffer y */
		unsigned int NBI31          : 1;	/* Set NBI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_NBISET0_type;
#define PSI5_NBISET0	(*( PSI5_NBISET0_type *) 0xf00054d4u)	/* NBIOV0 Set Register */
#define PSI5_NBISET1	(*( PSI5_NBISET0_type *) 0xf00054d8u)	/* NBIOV1 Set Register */
#define PSI5_NBISET2	(*( PSI5_NBISET0_type *) 0xf00054dcu)	/* NBIOV2 Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NFI0           : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI1           : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI2           : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI3           : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI4           : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI5           : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI6           : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI7           : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI8           : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI9           : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI10          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI11          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI12          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI13          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI14          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI15          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI16          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI17          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI18          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI19          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI20          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI21          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI22          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI23          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI24          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI25          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI26          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI27          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI28          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI29          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI30          : 1;	/* Clear NFI Flag of Buffer y */
		unsigned int NFI31          : 1;	/* Clear NFI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_NFICLR0_type;
#define PSI5_NFICLR0	(*( PSI5_NFICLR0_type *) 0xf00055c4u)	/* NFIOV0 Clear Register */
#define PSI5_NFICLR1	(*( PSI5_NFICLR0_type *) 0xf00055c8u)	/* NFIOV1 Clear Register */
#define PSI5_NFICLR2	(*( PSI5_NFICLR0_type *) 0xf00055ccu)	/* NFIOV2 Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int NFI0           : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI1           : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI2           : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI3           : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI4           : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI5           : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI6           : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI7           : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI8           : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI9           : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI10          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI11          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI12          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI13          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI14          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI15          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI16          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI17          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI18          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI19          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI20          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI21          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI22          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI23          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI24          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI25          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI26          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI27          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI28          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI29          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI30          : 1;	/* NFI Flag of Buffer y */
		/* const */ unsigned int NFI31          : 1;	/* NFI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_NFIOV0_type;
#define PSI5_NFIOV0	(*( PSI5_NFIOV0_type *) 0xf0005484u)	/* NFI Overview Register */
#define PSI5_NFIOV1	(*( PSI5_NFIOV0_type *) 0xf0005488u)	/* NFI Overview Register */
#define PSI5_NFIOV2	(*( PSI5_NFIOV0_type *) 0xf000548cu)	/* NFI Overview Register */

typedef volatile union
{
	struct
	{ 
		unsigned int NFI0           : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI1           : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI2           : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI3           : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI4           : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI5           : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI6           : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI7           : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI8           : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI9           : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI10          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI11          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI12          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI13          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI14          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI15          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI16          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI17          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI18          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI19          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI20          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI21          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI22          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI23          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI24          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI25          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI26          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI27          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI28          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI29          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI30          : 1;	/* Set NFI Flag of Buffer y */
		unsigned int NFI31          : 1;	/* Set NFI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_NFISET0_type;
#define PSI5_NFISET0	(*( PSI5_NFISET0_type *) 0xf0005524u)	/* NFIOV0 Set Register */
#define PSI5_NFISET1	(*( PSI5_NFISET0_type *) 0xf0005528u)	/* NFIOV1 Set Register */
#define PSI5_NFISET2	(*( PSI5_NFISET0_type *) 0xf000552cu)	/* NFIOV2 Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int                : 24;
		unsigned int SUS            : 4;	/* OCDS Suspend Control */
		unsigned int SUS_P          : 1;	/* SUS Write Protection */
		/* const */ unsigned int SUSSTA         : 1;	/* Suspend State */
		unsigned int                : 2;
	} B;
	int I;
	unsigned int U;

} PSI5_OCS_type;
#define PSI5_OCS	(*( PSI5_OCS_type *) 0xf00053ccu)	/* OCDS Control and Status */

typedef volatile union
{
	struct
	{ 
		unsigned int PLEN           : 6;	/* Pulse Length */
		unsigned int                : 2;
		unsigned int DEL            : 6;	/* Delay Length */
		unsigned int                : 1;
		unsigned int TBS            : 1;	/* Time Base Select */
		unsigned int ETB            : 3;	/* External Time Base Select */
		unsigned int PTE            : 1;	/* Periodic Trigger Enable */
		unsigned int ETS            : 3;	/* External Trigger Select */
		unsigned int ETE            : 1;	/* External Trigger Enable */
		unsigned int BYP            : 1;	/* Bypass Enable */
		unsigned int BOT            : 7;	/* Blank Out Time */
	} B;
	int I;
	unsigned int U;

} PSI5_PGC0_type;
#define PSI5_PGC0	(*( PSI5_PGC0_type *) 0xf0005088u)	/* Pulse Generation Control Register 0 */
#define PSI5_PGC1	(*( PSI5_PGC0_type *) 0xf0005118u)	/* Pulse Generation Control Register 1 */
#define PSI5_PGC2	(*( PSI5_PGC0_type *) 0xf00051a8u)	/* Pulse Generation Control Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int PDL0           : 5;	/* Payload Data Length */
		unsigned int PDL1           : 5;	/* Payload Data Length */
		unsigned int PDL2           : 5;	/* Payload Data Length */
		unsigned int PDL3           : 5;	/* Payload Data Length */
		unsigned int PDL4           : 5;	/* Payload Data Length */
		unsigned int PDL5           : 5;	/* Payload Data Length */
		unsigned int ASYN           : 1;	/* Asynchronous Mode */
		unsigned int AVBS           : 1;	/* Verbose Mode for Asynchronous Mode */
	} B;
	int I;
	unsigned int U;

} PSI5_RCRA0_type;
#define PSI5_RCRA0	(*( PSI5_RCRA0_type *) 0xf0005034u)	/* Receiver Control Register A 0 */
#define PSI5_RCRA1	(*( PSI5_RCRA0_type *) 0xf00050c4u)	/* Receiver Control Register A 1 */
#define PSI5_RCRA2	(*( PSI5_RCRA0_type *) 0xf0005154u)	/* Receiver Control Register A 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int MSG0           : 1;	/* Messaging Bits */
		unsigned int CRC0           : 1;	/* CRC or Parity Selection */
		unsigned int FEC0           : 1;	/* Frame Expectation Control */
		unsigned int VBS0           : 1;	/* Verbose Mode */
		unsigned int MSG1           : 1;	/* Messaging Bits */
		unsigned int CRC1           : 1;	/* CRC or Parity Selection */
		unsigned int FEC1           : 1;	/* Frame Expectation Control */
		unsigned int VBS1           : 1;	/* Verbose Mode */
		unsigned int MSG2           : 1;	/* Messaging Bits */
		unsigned int CRC2           : 1;	/* CRC or Parity Selection */
		unsigned int FEC2           : 1;	/* Frame Expectation Control */
		unsigned int VBS2           : 1;	/* Verbose Mode */
		unsigned int MSG3           : 1;	/* Messaging Bits */
		unsigned int CRC3           : 1;	/* CRC or Parity Selection */
		unsigned int FEC3           : 1;	/* Frame Expectation Control */
		unsigned int VBS3           : 1;	/* Verbose Mode */
		unsigned int MSG4           : 1;	/* Messaging Bits */
		unsigned int CRC4           : 1;	/* CRC or Parity Selection */
		unsigned int FEC4           : 1;	/* Frame Expectation Control */
		unsigned int VBS4           : 1;	/* Verbose Mode */
		unsigned int MSG5           : 1;	/* Messaging Bits */
		unsigned int CRC5           : 1;	/* CRC or Parity Selection */
		unsigned int FEC5           : 1;	/* Frame Expectation Control */
		unsigned int VBS5           : 1;	/* Verbose Mode */
		unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} PSI5_RCRB0_type;
#define PSI5_RCRB0	(*( PSI5_RCRB0_type *) 0xf0005038u)	/* Receiver Control Register B 0 */
#define PSI5_RCRB1	(*( PSI5_RCRB0_type *) 0xf00050c8u)	/* Receiver Control Register B 1 */
#define PSI5_RCRB2	(*( PSI5_RCRB0_type *) 0xf0005158u)	/* Receiver Control Register B 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int BRS            : 1;	/* Baud Rate Select */
		unsigned int TSP            : 2;	/* Time Stamp Select for Pulses */
		unsigned int TSF            : 2;	/* Time Stamp Select for Start of Frame (SOF) */
		unsigned int TSR            : 1;	/* Time Stamp Select for Receive Data Registers */
		unsigned int                : 26;
	} B;
	int I;
	unsigned int U;

} PSI5_RCRC0_type;
#define PSI5_RCRC0	(*( PSI5_RCRC0_type *) 0xf000503cu)	/* Receiver Control Register C 0 */
#define PSI5_RCRC1	(*( PSI5_RCRC0_type *) 0xf00050ccu)	/* Receiver Control Register C 1 */
#define PSI5_RCRC2	(*( PSI5_RCRC0_type *) 0xf000515cu)	/* Receiver Control Register C 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RD             : 32;	/* RD */
	} B;
	int I;
	unsigned int U;

} PSI5_RDF0_type;
#define PSI5_RDF0	(*( PSI5_RDF0_type *) 0xf00053f8u)	/* Receive Data FIFO 0 */
#define PSI5_RDF1	(*( PSI5_RDF0_type *) 0xf00053fcu)	/* Receive Data FIFO 1 */
#define PSI5_RDF2	(*( PSI5_RDF0_type *) 0xf0005400u)	/* Receive Data FIFO 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int RDI0           : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI1           : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI2           : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI3           : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI4           : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI5           : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI6           : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI7           : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI8           : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI9           : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI10          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI11          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI12          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI13          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI14          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI15          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI16          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI17          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI18          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI19          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI20          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI21          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI22          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI23          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI24          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI25          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI26          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI27          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI28          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI29          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI30          : 1;	/* Clear RDI Flag of Buffer y */
		unsigned int RDI31          : 1;	/* Clear RDI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_RDICLR0_type;
#define PSI5_RDICLR0	(*( PSI5_RDICLR0_type *) 0xf00055b0u)	/* RDIOV0 Clear Register */
#define PSI5_RDICLR1	(*( PSI5_RDICLR0_type *) 0xf00055b4u)	/* RDIOV1 Clear Register */
#define PSI5_RDICLR2	(*( PSI5_RDICLR0_type *) 0xf00055b8u)	/* RDIOV2 Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RDI0           : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI1           : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI2           : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI3           : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI4           : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI5           : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI6           : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI7           : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI8           : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI9           : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI10          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI11          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI12          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI13          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI14          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI15          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI16          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI17          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI18          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI19          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI20          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI21          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI22          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI23          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI24          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI25          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI26          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI27          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI28          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI29          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI30          : 1;	/* RDI Flag of Buffer y */
		/* const */ unsigned int RDI31          : 1;	/* RDI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_RDIOV0_type;
#define PSI5_RDIOV0	(*( PSI5_RDIOV0_type *) 0xf0005470u)	/* RDI Overview Register */
#define PSI5_RDIOV1	(*( PSI5_RDIOV0_type *) 0xf0005474u)	/* RDI Overview Register */
#define PSI5_RDIOV2	(*( PSI5_RDIOV0_type *) 0xf0005478u)	/* RDI Overview Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RDI0           : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI1           : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI2           : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI3           : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI4           : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI5           : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI6           : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI7           : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI8           : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI9           : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI10          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI11          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI12          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI13          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI14          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI15          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI16          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI17          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI18          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI19          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI20          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI21          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI22          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI23          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI24          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI25          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI26          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI27          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI28          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI29          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI30          : 1;	/* Set RDI Flag of Buffer y */
		unsigned int RDI31          : 1;	/* Set RDI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_RDISET0_type;
#define PSI5_RDISET0	(*( PSI5_RDISET0_type *) 0xf0005510u)	/* RDIOV0 Set Register */
#define PSI5_RDISET1	(*( PSI5_RDISET0_type *) 0xf0005514u)	/* RDIOV1 Set Register */
#define PSI5_RDISET2	(*( PSI5_RDISET0_type *) 0xf0005518u)	/* RDIOV2 Set Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TS             : 24;	/* Time Stamp */
		/* const */ unsigned int SC             : 3;	/* Slot Counter */
		/* const */ unsigned int TEI            : 1;	/* Time Slot Error Flag */
		/* const */ unsigned int NBI            : 1;	/* Number of bits Error Flag */
		/* const */ unsigned int MEI            : 1;	/* Error in Messaging Bits Flag */
		/* const */ unsigned int NFI            : 1;	/* No Frame Received Flag */
		/* const */ unsigned int RMI            : 1;	/* Receive Memory Overflow Flag */
	} B;
	int I;
	unsigned int U;

} PSI5_RDMH00_type;
#define PSI5_RDMH00	(*( PSI5_RDMH00_type *) 0xf0005604u)	/* Receive Data Memory High 0 0 */
#define PSI5_RDMH01	(*( PSI5_RDMH00_type *) 0xf000560cu)	/* Receive Data Memory High 0 1 */
#define PSI5_RDMH010	(*( PSI5_RDMH00_type *) 0xf0005654u)	/* Receive Data Memory High 0 10 */
#define PSI5_RDMH011	(*( PSI5_RDMH00_type *) 0xf000565cu)	/* Receive Data Memory High 0 11 */
#define PSI5_RDMH012	(*( PSI5_RDMH00_type *) 0xf0005664u)	/* Receive Data Memory High 0 12 */
#define PSI5_RDMH013	(*( PSI5_RDMH00_type *) 0xf000566cu)	/* Receive Data Memory High 0 13 */
#define PSI5_RDMH014	(*( PSI5_RDMH00_type *) 0xf0005674u)	/* Receive Data Memory High 0 14 */
#define PSI5_RDMH015	(*( PSI5_RDMH00_type *) 0xf000567cu)	/* Receive Data Memory High 0 15 */
#define PSI5_RDMH016	(*( PSI5_RDMH00_type *) 0xf0005684u)	/* Receive Data Memory High 0 16 */
#define PSI5_RDMH017	(*( PSI5_RDMH00_type *) 0xf000568cu)	/* Receive Data Memory High 0 17 */
#define PSI5_RDMH018	(*( PSI5_RDMH00_type *) 0xf0005694u)	/* Receive Data Memory High 0 18 */
#define PSI5_RDMH019	(*( PSI5_RDMH00_type *) 0xf000569cu)	/* Receive Data Memory High 0 19 */
#define PSI5_RDMH02	(*( PSI5_RDMH00_type *) 0xf0005614u)	/* Receive Data Memory High 0 2 */
#define PSI5_RDMH020	(*( PSI5_RDMH00_type *) 0xf00056a4u)	/* Receive Data Memory High 0 20 */
#define PSI5_RDMH021	(*( PSI5_RDMH00_type *) 0xf00056acu)	/* Receive Data Memory High 0 21 */
#define PSI5_RDMH022	(*( PSI5_RDMH00_type *) 0xf00056b4u)	/* Receive Data Memory High 0 22 */
#define PSI5_RDMH023	(*( PSI5_RDMH00_type *) 0xf00056bcu)	/* Receive Data Memory High 0 23 */
#define PSI5_RDMH024	(*( PSI5_RDMH00_type *) 0xf00056c4u)	/* Receive Data Memory High 0 24 */
#define PSI5_RDMH025	(*( PSI5_RDMH00_type *) 0xf00056ccu)	/* Receive Data Memory High 0 25 */
#define PSI5_RDMH026	(*( PSI5_RDMH00_type *) 0xf00056d4u)	/* Receive Data Memory High 0 26 */
#define PSI5_RDMH027	(*( PSI5_RDMH00_type *) 0xf00056dcu)	/* Receive Data Memory High 0 27 */
#define PSI5_RDMH028	(*( PSI5_RDMH00_type *) 0xf00056e4u)	/* Receive Data Memory High 0 28 */
#define PSI5_RDMH029	(*( PSI5_RDMH00_type *) 0xf00056ecu)	/* Receive Data Memory High 0 29 */
#define PSI5_RDMH03	(*( PSI5_RDMH00_type *) 0xf000561cu)	/* Receive Data Memory High 0 3 */
#define PSI5_RDMH030	(*( PSI5_RDMH00_type *) 0xf00056f4u)	/* Receive Data Memory High 0 30 */
#define PSI5_RDMH031	(*( PSI5_RDMH00_type *) 0xf00056fcu)	/* Receive Data Memory High 0 31 */
#define PSI5_RDMH04	(*( PSI5_RDMH00_type *) 0xf0005624u)	/* Receive Data Memory High 0 4 */
#define PSI5_RDMH05	(*( PSI5_RDMH00_type *) 0xf000562cu)	/* Receive Data Memory High 0 5 */
#define PSI5_RDMH06	(*( PSI5_RDMH00_type *) 0xf0005634u)	/* Receive Data Memory High 0 6 */
#define PSI5_RDMH07	(*( PSI5_RDMH00_type *) 0xf000563cu)	/* Receive Data Memory High 0 7 */
#define PSI5_RDMH08	(*( PSI5_RDMH00_type *) 0xf0005644u)	/* Receive Data Memory High 0 8 */
#define PSI5_RDMH09	(*( PSI5_RDMH00_type *) 0xf000564cu)	/* Receive Data Memory High 0 9 */
#define PSI5_RDMH10	(*( PSI5_RDMH00_type *) 0xf0005704u)	/* Receive Data Memory High 1 0 */
#define PSI5_RDMH11	(*( PSI5_RDMH00_type *) 0xf000570cu)	/* Receive Data Memory High 1 1 */
#define PSI5_RDMH110	(*( PSI5_RDMH00_type *) 0xf0005754u)	/* Receive Data Memory High 1 10 */
#define PSI5_RDMH111	(*( PSI5_RDMH00_type *) 0xf000575cu)	/* Receive Data Memory High 1 11 */
#define PSI5_RDMH112	(*( PSI5_RDMH00_type *) 0xf0005764u)	/* Receive Data Memory High 1 12 */
#define PSI5_RDMH113	(*( PSI5_RDMH00_type *) 0xf000576cu)	/* Receive Data Memory High 1 13 */
#define PSI5_RDMH114	(*( PSI5_RDMH00_type *) 0xf0005774u)	/* Receive Data Memory High 1 14 */
#define PSI5_RDMH115	(*( PSI5_RDMH00_type *) 0xf000577cu)	/* Receive Data Memory High 1 15 */
#define PSI5_RDMH116	(*( PSI5_RDMH00_type *) 0xf0005784u)	/* Receive Data Memory High 1 16 */
#define PSI5_RDMH117	(*( PSI5_RDMH00_type *) 0xf000578cu)	/* Receive Data Memory High 1 17 */
#define PSI5_RDMH118	(*( PSI5_RDMH00_type *) 0xf0005794u)	/* Receive Data Memory High 1 18 */
#define PSI5_RDMH119	(*( PSI5_RDMH00_type *) 0xf000579cu)	/* Receive Data Memory High 1 19 */
#define PSI5_RDMH12	(*( PSI5_RDMH00_type *) 0xf0005714u)	/* Receive Data Memory High 1 2 */
#define PSI5_RDMH120	(*( PSI5_RDMH00_type *) 0xf00057a4u)	/* Receive Data Memory High 1 20 */
#define PSI5_RDMH121	(*( PSI5_RDMH00_type *) 0xf00057acu)	/* Receive Data Memory High 1 21 */
#define PSI5_RDMH122	(*( PSI5_RDMH00_type *) 0xf00057b4u)	/* Receive Data Memory High 1 22 */
#define PSI5_RDMH123	(*( PSI5_RDMH00_type *) 0xf00057bcu)	/* Receive Data Memory High 1 23 */
#define PSI5_RDMH124	(*( PSI5_RDMH00_type *) 0xf00057c4u)	/* Receive Data Memory High 1 24 */
#define PSI5_RDMH125	(*( PSI5_RDMH00_type *) 0xf00057ccu)	/* Receive Data Memory High 1 25 */
#define PSI5_RDMH126	(*( PSI5_RDMH00_type *) 0xf00057d4u)	/* Receive Data Memory High 1 26 */
#define PSI5_RDMH127	(*( PSI5_RDMH00_type *) 0xf00057dcu)	/* Receive Data Memory High 1 27 */
#define PSI5_RDMH128	(*( PSI5_RDMH00_type *) 0xf00057e4u)	/* Receive Data Memory High 1 28 */
#define PSI5_RDMH129	(*( PSI5_RDMH00_type *) 0xf00057ecu)	/* Receive Data Memory High 1 29 */
#define PSI5_RDMH13	(*( PSI5_RDMH00_type *) 0xf000571cu)	/* Receive Data Memory High 1 3 */
#define PSI5_RDMH130	(*( PSI5_RDMH00_type *) 0xf00057f4u)	/* Receive Data Memory High 1 30 */
#define PSI5_RDMH131	(*( PSI5_RDMH00_type *) 0xf00057fcu)	/* Receive Data Memory High 1 31 */
#define PSI5_RDMH14	(*( PSI5_RDMH00_type *) 0xf0005724u)	/* Receive Data Memory High 1 4 */
#define PSI5_RDMH15	(*( PSI5_RDMH00_type *) 0xf000572cu)	/* Receive Data Memory High 1 5 */
#define PSI5_RDMH16	(*( PSI5_RDMH00_type *) 0xf0005734u)	/* Receive Data Memory High 1 6 */
#define PSI5_RDMH17	(*( PSI5_RDMH00_type *) 0xf000573cu)	/* Receive Data Memory High 1 7 */
#define PSI5_RDMH18	(*( PSI5_RDMH00_type *) 0xf0005744u)	/* Receive Data Memory High 1 8 */
#define PSI5_RDMH19	(*( PSI5_RDMH00_type *) 0xf000574cu)	/* Receive Data Memory High 1 9 */
#define PSI5_RDMH20	(*( PSI5_RDMH00_type *) 0xf0005804u)	/* Receive Data Memory High 2 0 */
#define PSI5_RDMH21	(*( PSI5_RDMH00_type *) 0xf000580cu)	/* Receive Data Memory High 2 1 */
#define PSI5_RDMH210	(*( PSI5_RDMH00_type *) 0xf0005854u)	/* Receive Data Memory High 2 10 */
#define PSI5_RDMH211	(*( PSI5_RDMH00_type *) 0xf000585cu)	/* Receive Data Memory High 2 11 */
#define PSI5_RDMH212	(*( PSI5_RDMH00_type *) 0xf0005864u)	/* Receive Data Memory High 2 12 */
#define PSI5_RDMH213	(*( PSI5_RDMH00_type *) 0xf000586cu)	/* Receive Data Memory High 2 13 */
#define PSI5_RDMH214	(*( PSI5_RDMH00_type *) 0xf0005874u)	/* Receive Data Memory High 2 14 */
#define PSI5_RDMH215	(*( PSI5_RDMH00_type *) 0xf000587cu)	/* Receive Data Memory High 2 15 */
#define PSI5_RDMH216	(*( PSI5_RDMH00_type *) 0xf0005884u)	/* Receive Data Memory High 2 16 */
#define PSI5_RDMH217	(*( PSI5_RDMH00_type *) 0xf000588cu)	/* Receive Data Memory High 2 17 */
#define PSI5_RDMH218	(*( PSI5_RDMH00_type *) 0xf0005894u)	/* Receive Data Memory High 2 18 */
#define PSI5_RDMH219	(*( PSI5_RDMH00_type *) 0xf000589cu)	/* Receive Data Memory High 2 19 */
#define PSI5_RDMH22	(*( PSI5_RDMH00_type *) 0xf0005814u)	/* Receive Data Memory High 2 2 */
#define PSI5_RDMH220	(*( PSI5_RDMH00_type *) 0xf00058a4u)	/* Receive Data Memory High 2 20 */
#define PSI5_RDMH221	(*( PSI5_RDMH00_type *) 0xf00058acu)	/* Receive Data Memory High 2 21 */
#define PSI5_RDMH222	(*( PSI5_RDMH00_type *) 0xf00058b4u)	/* Receive Data Memory High 2 22 */
#define PSI5_RDMH223	(*( PSI5_RDMH00_type *) 0xf00058bcu)	/* Receive Data Memory High 2 23 */
#define PSI5_RDMH224	(*( PSI5_RDMH00_type *) 0xf00058c4u)	/* Receive Data Memory High 2 24 */
#define PSI5_RDMH225	(*( PSI5_RDMH00_type *) 0xf00058ccu)	/* Receive Data Memory High 2 25 */
#define PSI5_RDMH226	(*( PSI5_RDMH00_type *) 0xf00058d4u)	/* Receive Data Memory High 2 26 */
#define PSI5_RDMH227	(*( PSI5_RDMH00_type *) 0xf00058dcu)	/* Receive Data Memory High 2 27 */
#define PSI5_RDMH228	(*( PSI5_RDMH00_type *) 0xf00058e4u)	/* Receive Data Memory High 2 28 */
#define PSI5_RDMH229	(*( PSI5_RDMH00_type *) 0xf00058ecu)	/* Receive Data Memory High 2 29 */
#define PSI5_RDMH23	(*( PSI5_RDMH00_type *) 0xf000581cu)	/* Receive Data Memory High 2 3 */
#define PSI5_RDMH230	(*( PSI5_RDMH00_type *) 0xf00058f4u)	/* Receive Data Memory High 2 30 */
#define PSI5_RDMH231	(*( PSI5_RDMH00_type *) 0xf00058fcu)	/* Receive Data Memory High 2 31 */
#define PSI5_RDMH24	(*( PSI5_RDMH00_type *) 0xf0005824u)	/* Receive Data Memory High 2 4 */
#define PSI5_RDMH25	(*( PSI5_RDMH00_type *) 0xf000582cu)	/* Receive Data Memory High 2 5 */
#define PSI5_RDMH26	(*( PSI5_RDMH00_type *) 0xf0005834u)	/* Receive Data Memory High 2 6 */
#define PSI5_RDMH27	(*( PSI5_RDMH00_type *) 0xf000583cu)	/* Receive Data Memory High 2 7 */
#define PSI5_RDMH28	(*( PSI5_RDMH00_type *) 0xf0005844u)	/* Receive Data Memory High 2 8 */
#define PSI5_RDMH29	(*( PSI5_RDMH00_type *) 0xf000584cu)	/* Receive Data Memory High 2 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CRCI           : 1;	/* CRC Error Flag */
		/* const */ unsigned int CRC            : 3;	/* CRC */
		/* const */ unsigned int RD             : 28;	/* RD */
	} B;
	int I;
	unsigned int U;

} PSI5_RDML00_type;
#define PSI5_RDML00	(*( PSI5_RDML00_type *) 0xf0005600u)	/* Receive Data Memory Low 0 0 */
#define PSI5_RDML01	(*( PSI5_RDML00_type *) 0xf0005608u)	/* Receive Data Memory Low 0 1 */
#define PSI5_RDML010	(*( PSI5_RDML00_type *) 0xf0005650u)	/* Receive Data Memory Low 0 10 */
#define PSI5_RDML011	(*( PSI5_RDML00_type *) 0xf0005658u)	/* Receive Data Memory Low 0 11 */
#define PSI5_RDML012	(*( PSI5_RDML00_type *) 0xf0005660u)	/* Receive Data Memory Low 0 12 */
#define PSI5_RDML013	(*( PSI5_RDML00_type *) 0xf0005668u)	/* Receive Data Memory Low 0 13 */
#define PSI5_RDML014	(*( PSI5_RDML00_type *) 0xf0005670u)	/* Receive Data Memory Low 0 14 */
#define PSI5_RDML015	(*( PSI5_RDML00_type *) 0xf0005678u)	/* Receive Data Memory Low 0 15 */
#define PSI5_RDML016	(*( PSI5_RDML00_type *) 0xf0005680u)	/* Receive Data Memory Low 0 16 */
#define PSI5_RDML017	(*( PSI5_RDML00_type *) 0xf0005688u)	/* Receive Data Memory Low 0 17 */
#define PSI5_RDML018	(*( PSI5_RDML00_type *) 0xf0005690u)	/* Receive Data Memory Low 0 18 */
#define PSI5_RDML019	(*( PSI5_RDML00_type *) 0xf0005698u)	/* Receive Data Memory Low 0 19 */
#define PSI5_RDML02	(*( PSI5_RDML00_type *) 0xf0005610u)	/* Receive Data Memory Low 0 2 */
#define PSI5_RDML020	(*( PSI5_RDML00_type *) 0xf00056a0u)	/* Receive Data Memory Low 0 20 */
#define PSI5_RDML021	(*( PSI5_RDML00_type *) 0xf00056a8u)	/* Receive Data Memory Low 0 21 */
#define PSI5_RDML022	(*( PSI5_RDML00_type *) 0xf00056b0u)	/* Receive Data Memory Low 0 22 */
#define PSI5_RDML023	(*( PSI5_RDML00_type *) 0xf00056b8u)	/* Receive Data Memory Low 0 23 */
#define PSI5_RDML024	(*( PSI5_RDML00_type *) 0xf00056c0u)	/* Receive Data Memory Low 0 24 */
#define PSI5_RDML025	(*( PSI5_RDML00_type *) 0xf00056c8u)	/* Receive Data Memory Low 0 25 */
#define PSI5_RDML026	(*( PSI5_RDML00_type *) 0xf00056d0u)	/* Receive Data Memory Low 0 26 */
#define PSI5_RDML027	(*( PSI5_RDML00_type *) 0xf00056d8u)	/* Receive Data Memory Low 0 27 */
#define PSI5_RDML028	(*( PSI5_RDML00_type *) 0xf00056e0u)	/* Receive Data Memory Low 0 28 */
#define PSI5_RDML029	(*( PSI5_RDML00_type *) 0xf00056e8u)	/* Receive Data Memory Low 0 29 */
#define PSI5_RDML03	(*( PSI5_RDML00_type *) 0xf0005618u)	/* Receive Data Memory Low 0 3 */
#define PSI5_RDML030	(*( PSI5_RDML00_type *) 0xf00056f0u)	/* Receive Data Memory Low 0 30 */
#define PSI5_RDML031	(*( PSI5_RDML00_type *) 0xf00056f8u)	/* Receive Data Memory Low 0 31 */
#define PSI5_RDML04	(*( PSI5_RDML00_type *) 0xf0005620u)	/* Receive Data Memory Low 0 4 */
#define PSI5_RDML05	(*( PSI5_RDML00_type *) 0xf0005628u)	/* Receive Data Memory Low 0 5 */
#define PSI5_RDML06	(*( PSI5_RDML00_type *) 0xf0005630u)	/* Receive Data Memory Low 0 6 */
#define PSI5_RDML07	(*( PSI5_RDML00_type *) 0xf0005638u)	/* Receive Data Memory Low 0 7 */
#define PSI5_RDML08	(*( PSI5_RDML00_type *) 0xf0005640u)	/* Receive Data Memory Low 0 8 */
#define PSI5_RDML09	(*( PSI5_RDML00_type *) 0xf0005648u)	/* Receive Data Memory Low 0 9 */
#define PSI5_RDML10	(*( PSI5_RDML00_type *) 0xf0005700u)	/* Receive Data Memory Low 1 0 */
#define PSI5_RDML11	(*( PSI5_RDML00_type *) 0xf0005708u)	/* Receive Data Memory Low 1 1 */
#define PSI5_RDML110	(*( PSI5_RDML00_type *) 0xf0005750u)	/* Receive Data Memory Low 1 10 */
#define PSI5_RDML111	(*( PSI5_RDML00_type *) 0xf0005758u)	/* Receive Data Memory Low 1 11 */
#define PSI5_RDML112	(*( PSI5_RDML00_type *) 0xf0005760u)	/* Receive Data Memory Low 1 12 */
#define PSI5_RDML113	(*( PSI5_RDML00_type *) 0xf0005768u)	/* Receive Data Memory Low 1 13 */
#define PSI5_RDML114	(*( PSI5_RDML00_type *) 0xf0005770u)	/* Receive Data Memory Low 1 14 */
#define PSI5_RDML115	(*( PSI5_RDML00_type *) 0xf0005778u)	/* Receive Data Memory Low 1 15 */
#define PSI5_RDML116	(*( PSI5_RDML00_type *) 0xf0005780u)	/* Receive Data Memory Low 1 16 */
#define PSI5_RDML117	(*( PSI5_RDML00_type *) 0xf0005788u)	/* Receive Data Memory Low 1 17 */
#define PSI5_RDML118	(*( PSI5_RDML00_type *) 0xf0005790u)	/* Receive Data Memory Low 1 18 */
#define PSI5_RDML119	(*( PSI5_RDML00_type *) 0xf0005798u)	/* Receive Data Memory Low 1 19 */
#define PSI5_RDML12	(*( PSI5_RDML00_type *) 0xf0005710u)	/* Receive Data Memory Low 1 2 */
#define PSI5_RDML120	(*( PSI5_RDML00_type *) 0xf00057a0u)	/* Receive Data Memory Low 1 20 */
#define PSI5_RDML121	(*( PSI5_RDML00_type *) 0xf00057a8u)	/* Receive Data Memory Low 1 21 */
#define PSI5_RDML122	(*( PSI5_RDML00_type *) 0xf00057b0u)	/* Receive Data Memory Low 1 22 */
#define PSI5_RDML123	(*( PSI5_RDML00_type *) 0xf00057b8u)	/* Receive Data Memory Low 1 23 */
#define PSI5_RDML124	(*( PSI5_RDML00_type *) 0xf00057c0u)	/* Receive Data Memory Low 1 24 */
#define PSI5_RDML125	(*( PSI5_RDML00_type *) 0xf00057c8u)	/* Receive Data Memory Low 1 25 */
#define PSI5_RDML126	(*( PSI5_RDML00_type *) 0xf00057d0u)	/* Receive Data Memory Low 1 26 */
#define PSI5_RDML127	(*( PSI5_RDML00_type *) 0xf00057d8u)	/* Receive Data Memory Low 1 27 */
#define PSI5_RDML128	(*( PSI5_RDML00_type *) 0xf00057e0u)	/* Receive Data Memory Low 1 28 */
#define PSI5_RDML129	(*( PSI5_RDML00_type *) 0xf00057e8u)	/* Receive Data Memory Low 1 29 */
#define PSI5_RDML13	(*( PSI5_RDML00_type *) 0xf0005718u)	/* Receive Data Memory Low 1 3 */
#define PSI5_RDML130	(*( PSI5_RDML00_type *) 0xf00057f0u)	/* Receive Data Memory Low 1 30 */
#define PSI5_RDML131	(*( PSI5_RDML00_type *) 0xf00057f8u)	/* Receive Data Memory Low 1 31 */
#define PSI5_RDML14	(*( PSI5_RDML00_type *) 0xf0005720u)	/* Receive Data Memory Low 1 4 */
#define PSI5_RDML15	(*( PSI5_RDML00_type *) 0xf0005728u)	/* Receive Data Memory Low 1 5 */
#define PSI5_RDML16	(*( PSI5_RDML00_type *) 0xf0005730u)	/* Receive Data Memory Low 1 6 */
#define PSI5_RDML17	(*( PSI5_RDML00_type *) 0xf0005738u)	/* Receive Data Memory Low 1 7 */
#define PSI5_RDML18	(*( PSI5_RDML00_type *) 0xf0005740u)	/* Receive Data Memory Low 1 8 */
#define PSI5_RDML19	(*( PSI5_RDML00_type *) 0xf0005748u)	/* Receive Data Memory Low 1 9 */
#define PSI5_RDML20	(*( PSI5_RDML00_type *) 0xf0005800u)	/* Receive Data Memory Low 2 0 */
#define PSI5_RDML21	(*( PSI5_RDML00_type *) 0xf0005808u)	/* Receive Data Memory Low 2 1 */
#define PSI5_RDML210	(*( PSI5_RDML00_type *) 0xf0005850u)	/* Receive Data Memory Low 2 10 */
#define PSI5_RDML211	(*( PSI5_RDML00_type *) 0xf0005858u)	/* Receive Data Memory Low 2 11 */
#define PSI5_RDML212	(*( PSI5_RDML00_type *) 0xf0005860u)	/* Receive Data Memory Low 2 12 */
#define PSI5_RDML213	(*( PSI5_RDML00_type *) 0xf0005868u)	/* Receive Data Memory Low 2 13 */
#define PSI5_RDML214	(*( PSI5_RDML00_type *) 0xf0005870u)	/* Receive Data Memory Low 2 14 */
#define PSI5_RDML215	(*( PSI5_RDML00_type *) 0xf0005878u)	/* Receive Data Memory Low 2 15 */
#define PSI5_RDML216	(*( PSI5_RDML00_type *) 0xf0005880u)	/* Receive Data Memory Low 2 16 */
#define PSI5_RDML217	(*( PSI5_RDML00_type *) 0xf0005888u)	/* Receive Data Memory Low 2 17 */
#define PSI5_RDML218	(*( PSI5_RDML00_type *) 0xf0005890u)	/* Receive Data Memory Low 2 18 */
#define PSI5_RDML219	(*( PSI5_RDML00_type *) 0xf0005898u)	/* Receive Data Memory Low 2 19 */
#define PSI5_RDML22	(*( PSI5_RDML00_type *) 0xf0005810u)	/* Receive Data Memory Low 2 2 */
#define PSI5_RDML220	(*( PSI5_RDML00_type *) 0xf00058a0u)	/* Receive Data Memory Low 2 20 */
#define PSI5_RDML221	(*( PSI5_RDML00_type *) 0xf00058a8u)	/* Receive Data Memory Low 2 21 */
#define PSI5_RDML222	(*( PSI5_RDML00_type *) 0xf00058b0u)	/* Receive Data Memory Low 2 22 */
#define PSI5_RDML223	(*( PSI5_RDML00_type *) 0xf00058b8u)	/* Receive Data Memory Low 2 23 */
#define PSI5_RDML224	(*( PSI5_RDML00_type *) 0xf00058c0u)	/* Receive Data Memory Low 2 24 */
#define PSI5_RDML225	(*( PSI5_RDML00_type *) 0xf00058c8u)	/* Receive Data Memory Low 2 25 */
#define PSI5_RDML226	(*( PSI5_RDML00_type *) 0xf00058d0u)	/* Receive Data Memory Low 2 26 */
#define PSI5_RDML227	(*( PSI5_RDML00_type *) 0xf00058d8u)	/* Receive Data Memory Low 2 27 */
#define PSI5_RDML228	(*( PSI5_RDML00_type *) 0xf00058e0u)	/* Receive Data Memory Low 2 28 */
#define PSI5_RDML229	(*( PSI5_RDML00_type *) 0xf00058e8u)	/* Receive Data Memory Low 2 29 */
#define PSI5_RDML23	(*( PSI5_RDML00_type *) 0xf0005818u)	/* Receive Data Memory Low 2 3 */
#define PSI5_RDML230	(*( PSI5_RDML00_type *) 0xf00058f0u)	/* Receive Data Memory Low 2 30 */
#define PSI5_RDML231	(*( PSI5_RDML00_type *) 0xf00058f8u)	/* Receive Data Memory Low 2 31 */
#define PSI5_RDML24	(*( PSI5_RDML00_type *) 0xf0005820u)	/* Receive Data Memory Low 2 4 */
#define PSI5_RDML25	(*( PSI5_RDML00_type *) 0xf0005828u)	/* Receive Data Memory Low 2 5 */
#define PSI5_RDML26	(*( PSI5_RDML00_type *) 0xf0005830u)	/* Receive Data Memory Low 2 6 */
#define PSI5_RDML27	(*( PSI5_RDML00_type *) 0xf0005838u)	/* Receive Data Memory Low 2 7 */
#define PSI5_RDML28	(*( PSI5_RDML00_type *) 0xf0005840u)	/* Receive Data Memory Low 2 8 */
#define PSI5_RDML29	(*( PSI5_RDML00_type *) 0xf0005848u)	/* Receive Data Memory Low 2 9 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TS             : 24;	/* Time Stamp */
		/* const */ unsigned int SC             : 3;	/* Slot Counter */
		/* const */ unsigned int TEI            : 1;	/* Time Slot Error Flag */
		/* const */ unsigned int NBI            : 1;	/* Number of bits Error Flag */
		/* const */ unsigned int MEI            : 1;	/* Error in Message Bits Flag */
		/* const */ unsigned int NFI            : 1;	/* No Frame Received Flag */
		/* const */ unsigned int RBI            : 1;	/* Receive Buffer Overflow Flag */
	} B;
	int I;
	unsigned int U;

} PSI5_RDRH0_type;
#define PSI5_RDRH0	(*( PSI5_RDRH0_type *) 0xf0005084u)	/* Receive Data Register High 0 */
#define PSI5_RDRH1	(*( PSI5_RDRH0_type *) 0xf0005114u)	/* Receive Data Register High 1 */
#define PSI5_RDRH2	(*( PSI5_RDRH0_type *) 0xf00051a4u)	/* Receive Data Register High 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CRCI           : 1;	/* CRC Error Flag */
		/* const */ unsigned int CRC            : 3;	/* CRC */
		/* const */ unsigned int RD             : 28;	/* RD */
	} B;
	int I;
	unsigned int U;

} PSI5_RDRL0_type;
#define PSI5_RDRL0	(*( PSI5_RDRL0_type *) 0xf0005080u)	/* Receive Data Register Low 0 */
#define PSI5_RDRL1	(*( PSI5_RDRL0_type *) 0xf0005110u)	/* Receive Data Register Low 1 */
#define PSI5_RDRL2	(*( PSI5_RDRL0_type *) 0xf00051a0u)	/* Receive Data Register Low 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int REP            : 6;	/* FIFO Read Pointer */
		unsigned int                : 2;
		/* const */ unsigned int WRP            : 6;	/* FIFO/Ring Buffer Write Pointer */
		unsigned int                : 2;
		unsigned int FWL            : 5;	/* FIFO Warning Level */
		unsigned int                : 8;
		/* const */ unsigned int WRAP           : 1;	/* Write Pointer WRAP Indicator */
		/* const */ unsigned int FRQ            : 1;	/* Flush Request */
		unsigned int FLU            : 1;	/* Flush */
	} B;
	int I;
	unsigned int U;

} PSI5_RFC0_type;
#define PSI5_RFC0	(*( PSI5_RFC0_type *) 0xf00053e4u)	/* Receive FIFO Control Register 0 */
#define PSI5_RFC1	(*( PSI5_RFC0_type *) 0xf00053e8u)	/* Receive FIFO Control Register 1 */
#define PSI5_RFC2	(*( PSI5_RFC0_type *) 0xf00053ecu)	/* Receive FIFO Control Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int RMI0           : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI1           : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI2           : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI3           : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI4           : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI5           : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI6           : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI7           : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI8           : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI9           : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI10          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI11          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI12          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI13          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI14          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI15          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI16          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI17          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI18          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI19          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI20          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI21          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI22          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI23          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI24          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI25          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI26          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI27          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI28          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI29          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI30          : 1;	/* Clear RMI Flag of Buffer y */
		unsigned int RMI31          : 1;	/* Clear RMI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_RMICLR0_type;
#define PSI5_RMICLR0	(*( PSI5_RMICLR0_type *) 0xf0005560u)	/* RMIOV0 Clear Register */
#define PSI5_RMICLR1	(*( PSI5_RMICLR0_type *) 0xf0005564u)	/* RMIOV1 Clear Register */
#define PSI5_RMICLR2	(*( PSI5_RMICLR0_type *) 0xf0005568u)	/* RMIOV2 Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RMI0           : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI1           : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI2           : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI3           : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI4           : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI5           : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI6           : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI7           : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI8           : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI9           : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI10          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI11          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI12          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI13          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI14          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI15          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI16          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI17          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI18          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI19          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI20          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI21          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI22          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI23          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI24          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI25          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI26          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI27          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI28          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI29          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI30          : 1;	/* RMI Flag of Buffer y */
		/* const */ unsigned int RMI31          : 1;	/* RMI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_RMIOV0_type;
#define PSI5_RMIOV0	(*( PSI5_RMIOV0_type *) 0xf0005420u)	/* RMI Overview Register */
#define PSI5_RMIOV1	(*( PSI5_RMIOV0_type *) 0xf0005424u)	/* RMI Overview Register */
#define PSI5_RMIOV2	(*( PSI5_RMIOV0_type *) 0xf0005428u)	/* RMI Overview Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RMI0           : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI1           : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI2           : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI3           : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI4           : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI5           : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI6           : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI7           : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI8           : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI9           : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI10          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI11          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI12          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI13          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI14          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI15          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI16          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI17          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI18          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI19          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI20          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI21          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI22          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI23          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI24          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI25          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI26          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI27          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI28          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI29          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI30          : 1;	/* Set RMI Flag of Buffer y */
		unsigned int RMI31          : 1;	/* Set RMI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_RMISET0_type;
#define PSI5_RMISET0	(*( PSI5_RMISET0_type *) 0xf00054c0u)	/* RMIOV0 Set Register */
#define PSI5_RMISET1	(*( PSI5_RMISET0_type *) 0xf00054c4u)	/* RMIOV1 Set Register */
#define PSI5_RMISET2	(*( PSI5_RMISET0_type *) 0xf00054c8u)	/* RMIOV2 Set Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RSI0           : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI1           : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI2           : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI3           : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI4           : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI5           : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI6           : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI7           : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI8           : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI9           : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI10          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI11          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI12          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI13          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI14          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI15          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI16          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI17          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI18          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI19          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI20          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI21          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI22          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI23          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI24          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI25          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI26          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI27          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI28          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI29          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI30          : 1;	/* Clear RSI Flag of Buffer y */
		unsigned int RSI31          : 1;	/* Clear RSI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_RSICLR0_type;
#define PSI5_RSICLR0	(*( PSI5_RSICLR0_type *) 0xf000554cu)	/* RSIOV0 Clear Register */
#define PSI5_RSICLR1	(*( PSI5_RSICLR0_type *) 0xf0005550u)	/* RSIOV1 Clear Register */
#define PSI5_RSICLR2	(*( PSI5_RSICLR0_type *) 0xf0005554u)	/* RSIOV2 Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RSI0           : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI1           : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI2           : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI3           : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI4           : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI5           : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI6           : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI7           : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI8           : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI9           : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI10          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI11          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI12          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI13          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI14          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI15          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI16          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI17          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI18          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI19          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI20          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI21          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI22          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI23          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI24          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI25          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI26          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI27          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI28          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI29          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI30          : 1;	/* RSI Flag of Buffer y */
		/* const */ unsigned int RSI31          : 1;	/* RSI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_RSIOV0_type;
#define PSI5_RSIOV0	(*( PSI5_RSIOV0_type *) 0xf000540cu)	/* RSI Overview Register */
#define PSI5_RSIOV1	(*( PSI5_RSIOV0_type *) 0xf0005410u)	/* RSI Overview Register */
#define PSI5_RSIOV2	(*( PSI5_RSIOV0_type *) 0xf0005414u)	/* RSI Overview Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RSI0           : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI1           : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI2           : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI3           : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI4           : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI5           : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI6           : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI7           : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI8           : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI9           : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI10          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI11          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI12          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI13          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI14          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI15          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI16          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI17          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI18          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI19          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI20          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI21          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI22          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI23          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI24          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI25          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI26          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI27          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI28          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI29          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI30          : 1;	/* Set RSI Flag of Buffer y */
		unsigned int RSI31          : 1;	/* Set RSI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_RSISET0_type;
#define PSI5_RSISET0	(*( PSI5_RSISET0_type *) 0xf00054acu)	/* RSIOV0 Set Register */
#define PSI5_RSISET1	(*( PSI5_RSISET0_type *) 0xf00054b0u)	/* RSIOV1 Set Register */
#define PSI5_RSISET2	(*( PSI5_RSISET0_type *) 0xf00054b4u)	/* RSIOV2 Set Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CRC            : 3;	/* CRC */
		/* const */ unsigned int                : 5;
		/* const */ unsigned int MSG            : 2;	/* Messaging Bits */
		/* const */ unsigned int                : 22;
	} B;
	int I;
	unsigned int U;

} PSI5_RSR0_type;
#define PSI5_RSR0	(*( PSI5_RSR0_type *) 0xf000505cu)	/* Receive Status Register 0 */
#define PSI5_RSR1	(*( PSI5_RSR0_type *) 0xf00050ecu)	/* Receive Status Register 1 */
#define PSI5_RSR2	(*( PSI5_RSR0_type *) 0xf000517cu)	/* Receive Status Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int PLL            : 6;	/* Pay Load Length of Registers SDRL/H */
		unsigned int EPS            : 1;	/* Enhanced Protocol Selection */
		unsigned int BSC            : 1;	/* Bit Stuffing Control */
		unsigned int SSL            : 6;	/* Pay Load Length of Registers SSRL/H */
		unsigned int FLUS           : 1;	/* Flush SSRH/Lx */
		unsigned int FLUO           : 1;	/* Flush SORH/Lx */
		unsigned int SOL            : 6;	/* Pay Load Length of Registers SORL/H */
		unsigned int CRC            : 1;	/* CRC Generation Control */
		unsigned int STA            : 1;	/* Start Sequence Generation Control */
		unsigned int INH            : 1;	/* Inhibit Transfer */
		unsigned int GO             : 1;	/* Release prepared Send data */
		/* const */ unsigned int TPF            : 1;	/* Transmit Preparation Flag */
		/* const */ unsigned int TSF            : 1;	/* Transmit Shift Flag */
		/* const */ unsigned int TOF            : 1;	/* Transmit Output Flag */
		unsigned int                : 2;
		/* const */ unsigned int TRQ            : 1;	/* Transfer Request in Progress */
	} B;
	int I;
	unsigned int U;

} PSI5_SCR0_type;
#define PSI5_SCR0	(*( PSI5_SCR0_type *) 0xf0005090u)	/* Send Control Register 0 */
#define PSI5_SCR1	(*( PSI5_SCR0_type *) 0xf0005120u)	/* Send Control Register 1 */
#define PSI5_SCR2	(*( PSI5_SCR0_type *) 0xf00051b0u)	/* Send Control Register 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int SD32           : 1;	/* SDy */
		unsigned int SD33           : 1;	/* SDy */
		unsigned int SD34           : 1;	/* SDy */
		unsigned int SD35           : 1;	/* SDy */
		unsigned int SD36           : 1;	/* SDy */
		unsigned int SD37           : 1;	/* SDy */
		unsigned int SD38           : 1;	/* SDy */
		unsigned int SD39           : 1;	/* SDy */
		unsigned int SD40           : 1;	/* SDy */
		unsigned int SD41           : 1;	/* SDy */
		unsigned int SD42           : 1;	/* SDy */
		unsigned int SD43           : 1;	/* SDy */
		unsigned int SD44           : 1;	/* SDy */
		unsigned int SD45           : 1;	/* SDy */
		unsigned int SD46           : 1;	/* SDy */
		unsigned int SD47           : 1;	/* SDy */
		unsigned int SD48           : 1;	/* SDy */
		unsigned int SD49           : 1;	/* SDy */
		unsigned int SD50           : 1;	/* SDy */
		unsigned int SD51           : 1;	/* SDy */
		unsigned int SD52           : 1;	/* SDy */
		unsigned int SD53           : 1;	/* SDy */
		unsigned int SD54           : 1;	/* SDy */
		unsigned int SD55           : 1;	/* SDy */
		unsigned int SD56           : 1;	/* SDy */
		unsigned int SD57           : 1;	/* SDy */
		unsigned int SD58           : 1;	/* SDy */
		unsigned int SD59           : 1;	/* SDy */
		unsigned int SD60           : 1;	/* SDy */
		unsigned int SD61           : 1;	/* SDy */
		unsigned int SD62           : 1;	/* SDy */
		unsigned int SD63           : 1;	/* SDy */
	} B;
	int I;
	unsigned int U;

} PSI5_SDRH0_type;
#define PSI5_SDRH0	(*( PSI5_SDRH0_type *) 0xf0005098u)	/* Send Data Register High 0 */
#define PSI5_SDRH1	(*( PSI5_SDRH0_type *) 0xf0005128u)	/* Send Data Register High 1 */
#define PSI5_SDRH2	(*( PSI5_SDRH0_type *) 0xf00051b8u)	/* Send Data Register High 2 */
#define PSI5_SORH0	(*( PSI5_SDRH0_type *) 0xf00050a8u)	/* Send Output Register High 0 */
#define PSI5_SORH1	(*( PSI5_SDRH0_type *) 0xf0005138u)	/* Send Output Register High 1 */
#define PSI5_SORH2	(*( PSI5_SDRH0_type *) 0xf00051c8u)	/* Send Output Register High 2 */
#define PSI5_SSRH0	(*( PSI5_SDRH0_type *) 0xf00050a0u)	/* Send Shift Register High 0 */
#define PSI5_SSRH1	(*( PSI5_SDRH0_type *) 0xf0005130u)	/* Send Shift Register High 1 */
#define PSI5_SSRH2	(*( PSI5_SDRH0_type *) 0xf00051c0u)	/* Send Shift Register High 2 */

typedef volatile union
{
	struct
	{ 
		unsigned int SD0            : 1;	/* SDy */
		unsigned int SD1            : 1;	/* SDy */
		unsigned int SD2            : 1;	/* SDy */
		unsigned int SD3            : 1;	/* SDy */
		unsigned int SD4            : 1;	/* SDy */
		unsigned int SD5            : 1;	/* SDy */
		unsigned int SD6            : 1;	/* SDy */
		unsigned int SD7            : 1;	/* SDy */
		unsigned int SD8            : 1;	/* SDy */
		unsigned int SD9            : 1;	/* SDy */
		unsigned int SD10           : 1;	/* SDy */
		unsigned int SD11           : 1;	/* SDy */
		unsigned int SD12           : 1;	/* SDy */
		unsigned int SD13           : 1;	/* SDy */
		unsigned int SD14           : 1;	/* SDy */
		unsigned int SD15           : 1;	/* SDy */
		unsigned int SD16           : 1;	/* SDy */
		unsigned int SD17           : 1;	/* SDy */
		unsigned int SD18           : 1;	/* SDy */
		unsigned int SD19           : 1;	/* SDy */
		unsigned int SD20           : 1;	/* SDy */
		unsigned int SD21           : 1;	/* SDy */
		unsigned int SD22           : 1;	/* SDy */
		unsigned int SD23           : 1;	/* SDy */
		unsigned int SD24           : 1;	/* SDy */
		unsigned int SD25           : 1;	/* SDy */
		unsigned int SD26           : 1;	/* SDy */
		unsigned int SD27           : 1;	/* SDy */
		unsigned int SD28           : 1;	/* SDy */
		unsigned int SD29           : 1;	/* SDy */
		unsigned int SD30           : 1;	/* SDy */
		unsigned int SD31           : 1;	/* SDy */
	} B;
	int I;
	unsigned int U;

} PSI5_SDRL0_type;
#define PSI5_SDRL0	(*( PSI5_SDRL0_type *) 0xf0005094u)	/* Send Data Register Low 0 */
#define PSI5_SDRL1	(*( PSI5_SDRL0_type *) 0xf0005124u)	/* Send Data Register Low 1 */
#define PSI5_SDRL2	(*( PSI5_SDRL0_type *) 0xf00051b4u)	/* Send Data Register Low 2 */
#define PSI5_SORL0	(*( PSI5_SDRL0_type *) 0xf00050a4u)	/* Send Output Register Low 0 */
#define PSI5_SORL1	(*( PSI5_SDRL0_type *) 0xf0005134u)	/* Send Output Register Low 1 */
#define PSI5_SORL2	(*( PSI5_SDRL0_type *) 0xf00051c4u)	/* Send Output Register Low 2 */
#define PSI5_SSRL0	(*( PSI5_SDRL0_type *) 0xf000509cu)	/* Send Shift Register Low 0 */
#define PSI5_SSRL1	(*( PSI5_SDRL0_type *) 0xf000512cu)	/* Send Shift Register Low 1 */
#define PSI5_SSRL2	(*( PSI5_SDRL0_type *) 0xf00051bcu)	/* Send Shift Register Low 2 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SD             : 16;	/* Serial Data */
		/* const */ unsigned int MID            : 8;	/* Message ID */
		/* const */ unsigned int SCRC           : 6;	/* SCRC */
		/* const */ unsigned int SCRI           : 1;	/* CRC of Serial Message failed Interrupt Flag. */
		/* const */ unsigned int CON            : 1;	/* Configuration bit */
	} B;
	int I;
	unsigned int U;

} PSI5_SDS00_type;
#define PSI5_SDS00	(*( PSI5_SDS00_type *) 0xf0005060u)	/* Serial Data and Status Register 00 */
#define PSI5_SDS01	(*( PSI5_SDS00_type *) 0xf0005064u)	/* Serial Data and Status Register 01 */
#define PSI5_SDS02	(*( PSI5_SDS00_type *) 0xf0005068u)	/* Serial Data and Status Register 02 */
#define PSI5_SDS03	(*( PSI5_SDS00_type *) 0xf000506cu)	/* Serial Data and Status Register 03 */
#define PSI5_SDS04	(*( PSI5_SDS00_type *) 0xf0005070u)	/* Serial Data and Status Register 04 */
#define PSI5_SDS05	(*( PSI5_SDS00_type *) 0xf0005074u)	/* Serial Data and Status Register 05 */
#define PSI5_SDS10	(*( PSI5_SDS00_type *) 0xf00050f0u)	/* Serial Data and Status Register 10 */
#define PSI5_SDS11	(*( PSI5_SDS00_type *) 0xf00050f4u)	/* Serial Data and Status Register 11 */
#define PSI5_SDS12	(*( PSI5_SDS00_type *) 0xf00050f8u)	/* Serial Data and Status Register 12 */
#define PSI5_SDS13	(*( PSI5_SDS00_type *) 0xf00050fcu)	/* Serial Data and Status Register 13 */
#define PSI5_SDS14	(*( PSI5_SDS00_type *) 0xf0005100u)	/* Serial Data and Status Register 14 */
#define PSI5_SDS15	(*( PSI5_SDS00_type *) 0xf0005104u)	/* Serial Data and Status Register 15 */
#define PSI5_SDS20	(*( PSI5_SDS00_type *) 0xf0005180u)	/* Serial Data and Status Register 20 */
#define PSI5_SDS21	(*( PSI5_SDS00_type *) 0xf0005184u)	/* Serial Data and Status Register 21 */
#define PSI5_SDS22	(*( PSI5_SDS00_type *) 0xf0005188u)	/* Serial Data and Status Register 22 */
#define PSI5_SDS23	(*( PSI5_SDS00_type *) 0xf000518cu)	/* Serial Data and Status Register 23 */
#define PSI5_SDS24	(*( PSI5_SDS00_type *) 0xf0005190u)	/* Serial Data and Status Register 24 */
#define PSI5_SDS25	(*( PSI5_SDS00_type *) 0xf0005194u)	/* Serial Data and Status Register 25 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TS             : 24;	/* Time Stamp */
		/* const */ unsigned int                : 8;
	} B;
	int I;
	unsigned int U;

} PSI5_SFTSC0_type;
#define PSI5_SFTSC0	(*( PSI5_SFTSC0_type *) 0xf000507cu)	/* SOF TS Capture Register SFTSC0 */
#define PSI5_SFTSC1	(*( PSI5_SFTSC0_type *) 0xf000510cu)	/* SOF TS Capture Register SFTSC1 */
#define PSI5_SFTSC2	(*( PSI5_SFTSC0_type *) 0xf000519cu)	/* SOF TS Capture Register SFTSC2 */
#define PSI5_SPTSC0	(*( PSI5_SFTSC0_type *) 0xf0005078u)	/* SOP TS Capture Register SPTSC0 */
#define PSI5_SPTSC1	(*( PSI5_SFTSC0_type *) 0xf0005108u)	/* SOP TS Capture Register SPTSC1 */
#define PSI5_SPTSC2	(*( PSI5_SFTSC0_type *) 0xf0005198u)	/* SOP TS Capture Register SPTSC2 */

typedef volatile union
{
	struct
	{ 
		unsigned int TEI0           : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI1           : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI2           : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI3           : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI4           : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI5           : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI6           : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI7           : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI8           : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI9           : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI10          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI11          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI12          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI13          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI14          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI15          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI16          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI17          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI18          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI19          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI20          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI21          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI22          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI23          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI24          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI25          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI26          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI27          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI28          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI29          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI30          : 1;	/* Clear TEI Flag of Buffer y */
		unsigned int TEI31          : 1;	/* Clear TEI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_TEICLR0_type;
#define PSI5_TEICLR0	(*( PSI5_TEICLR0_type *) 0xf0005588u)	/* TEIOV0 Clear Register */
#define PSI5_TEICLR1	(*( PSI5_TEICLR0_type *) 0xf000558cu)	/* TEIOV1 Clear Register */
#define PSI5_TEICLR2	(*( PSI5_TEICLR0_type *) 0xf0005590u)	/* TEIOV2 Clear Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TEI0           : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI1           : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI2           : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI3           : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI4           : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI5           : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI6           : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI7           : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI8           : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI9           : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI10          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI11          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI12          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI13          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI14          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI15          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI16          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI17          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI18          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI19          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI20          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI21          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI22          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI23          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI24          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI25          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI26          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI27          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI28          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI29          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI30          : 1;	/* TEI Flag of Buffer y */
		/* const */ unsigned int TEI31          : 1;	/* TEI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_TEIOV0_type;
#define PSI5_TEIOV0	(*( PSI5_TEIOV0_type *) 0xf0005448u)	/* TEI Overview Register */
#define PSI5_TEIOV1	(*( PSI5_TEIOV0_type *) 0xf000544cu)	/* TEI Overview Register */
#define PSI5_TEIOV2	(*( PSI5_TEIOV0_type *) 0xf0005450u)	/* TEI Overview Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TEI0           : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI1           : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI2           : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI3           : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI4           : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI5           : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI6           : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI7           : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI8           : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI9           : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI10          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI11          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI12          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI13          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI14          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI15          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI16          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI17          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI18          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI19          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI20          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI21          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI22          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI23          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI24          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI25          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI26          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI27          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI28          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI29          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI30          : 1;	/* Set TEI Flag of Buffer y */
		unsigned int TEI31          : 1;	/* Set TEI Flag of Buffer y */
	} B;
	int I;
	unsigned int U;

} PSI5_TEISET0_type;
#define PSI5_TEISET0	(*( PSI5_TEISET0_type *) 0xf00054e8u)	/* TEIOV0 Set Register */
#define PSI5_TEISET1	(*( PSI5_TEISET0_type *) 0xf00054ecu)	/* TEIOV1 Set Register */
#define PSI5_TEISET2	(*( PSI5_TEISET0_type *) 0xf00054f0u)	/* TEIOV2 Set Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CTS            : 24;	/* Current Time Stamp for the Module */
		unsigned int ETB            : 3;	/* External Time Base Select */
		unsigned int TBS            : 1;	/* Time Base Select */
		unsigned int                : 2;
		unsigned int ACLR           : 1;	/* Clear All Current Time Stamp Counters */
		unsigned int CLR            : 1;	/* Clear Current Time Stamp for the Module */
	} B;
	int I;
	unsigned int U;

} PSI5_TSRA_type;
#define PSI5_TSRA	(*( PSI5_TSRA_type *) 0xf000501cu)	/* Time Stamp Register A */
#define PSI5_TSRB	(*( PSI5_TSRA_type *) 0xf0005020u)	/* Time Stamp Register B */
#define PSI5_TSRC	(*( PSI5_TSRA_type *) 0xf0005024u)	/* Time Stamp Register C */

typedef volatile union
{
	struct
	{ 
		unsigned int WDLxw          : 16;	/* Watch Dog Timer Limit */
		unsigned int                : 16;
	} B;
	int I;
	unsigned int U;

} PSI5_WDT00_type;
#define PSI5_WDT00	(*( PSI5_WDT00_type *) 0xf0005040u)	/* Watch Dog Timer Register 00 */
#define PSI5_WDT01	(*( PSI5_WDT00_type *) 0xf0005044u)	/* Watch Dog Timer Register 01 */
#define PSI5_WDT02	(*( PSI5_WDT00_type *) 0xf0005048u)	/* Watch Dog Timer Register 02 */
#define PSI5_WDT03	(*( PSI5_WDT00_type *) 0xf000504cu)	/* Watch Dog Timer Register 03 */
#define PSI5_WDT04	(*( PSI5_WDT00_type *) 0xf0005050u)	/* Watch Dog Timer Register 04 */
#define PSI5_WDT05	(*( PSI5_WDT00_type *) 0xf0005054u)	/* Watch Dog Timer Register 05 */
#define PSI5_WDT06	(*( PSI5_WDT00_type *) 0xf0005058u)	/* Watch Dog Timer Register 06 */
#define PSI5_WDT10	(*( PSI5_WDT00_type *) 0xf00050d0u)	/* Watch Dog Timer Register 10 */
#define PSI5_WDT11	(*( PSI5_WDT00_type *) 0xf00050d4u)	/* Watch Dog Timer Register 11 */
#define PSI5_WDT12	(*( PSI5_WDT00_type *) 0xf00050d8u)	/* Watch Dog Timer Register 12 */
#define PSI5_WDT13	(*( PSI5_WDT00_type *) 0xf00050dcu)	/* Watch Dog Timer Register 13 */
#define PSI5_WDT14	(*( PSI5_WDT00_type *) 0xf00050e0u)	/* Watch Dog Timer Register 14 */
#define PSI5_WDT15	(*( PSI5_WDT00_type *) 0xf00050e4u)	/* Watch Dog Timer Register 15 */
#define PSI5_WDT16	(*( PSI5_WDT00_type *) 0xf00050e8u)	/* Watch Dog Timer Register 16 */
#define PSI5_WDT20	(*( PSI5_WDT00_type *) 0xf0005160u)	/* Watch Dog Timer Register 20 */
#define PSI5_WDT21	(*( PSI5_WDT00_type *) 0xf0005164u)	/* Watch Dog Timer Register 21 */
#define PSI5_WDT22	(*( PSI5_WDT00_type *) 0xf0005168u)	/* Watch Dog Timer Register 22 */
#define PSI5_WDT23	(*( PSI5_WDT00_type *) 0xf000516cu)	/* Watch Dog Timer Register 23 */
#define PSI5_WDT24	(*( PSI5_WDT00_type *) 0xf0005170u)	/* Watch Dog Timer Register 24 */
#define PSI5_WDT25	(*( PSI5_WDT00_type *) 0xf0005174u)	/* Watch Dog Timer Register 25 */
#define PSI5_WDT26	(*( PSI5_WDT00_type *) 0xf0005178u)	/* Watch Dog Timer Register 26 */


/* ETH */
typedef volatile union
{
	struct
	{ 
		unsigned int EN0            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN1            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN2            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN3            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN4            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN5            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN6            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN7            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN8            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN9            : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN10           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN11           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN12           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN13           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN14           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN15           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN16           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN17           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN18           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN19           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN20           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN21           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN22           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN23           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN24           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN25           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN26           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN27           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN28           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN29           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN30           : 1;	/* Access Enable for Master TAG ID n */
		unsigned int EN31           : 1;	/* Access Enable for Master TAG ID n */
	} B;
	int I;
	unsigned int U;

} ETH_ACCEN0_type;
#define ETH_ACCEN0	(*( ETH_ACCEN0_type *) 0xf001d00cu)	/* Access Enable Register 0 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int Reserved       : 32;	/* Reserved */
	} B;
	int I;
	unsigned int U;

} ETH_ACCEN1_type;
#define ETH_ACCEN1	(*( ETH_ACCEN1_type *) 0xf001d010u)	/* Access Enable Register 1 */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int AXWHSTS        : 1;	/* AXI Master Write Channel or AHB Master Status */
		/* const */ unsigned int AXIRDSTS       : 1;	/* AXI Master Read Channel Status */
		/* const */ unsigned int RESERVED_31_2  : 30;	/* RESERVED_31_2 */
	} B;
	int I;
	unsigned int U;

} ETH_AHB_OR_AXI_STATUS_type;
#define ETH_AHB_OR_AXI_STATUS	(*( ETH_AHB_OR_AXI_STATUS_type *) 0xf001f02cu)	/* Register 11 - AHB or AXI Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SWR            : 1;	/* Software Reset */
		unsigned int DA             : 1;	/* DMA Arbitration Scheme */
		unsigned int DSL            : 5;	/* Descriptor Skip Length */
		unsigned int ATDS           : 1;	/* Alternate Descriptor Size */
		unsigned int PBL            : 6;	/* Programmable Burst Length */
		unsigned int PR             : 2;	/* Priority Ratio */
		unsigned int FB             : 1;	/* Fixed Burst */
		unsigned int RPBL           : 6;	/* Rx DMA PBL */
		unsigned int USP            : 1;	/* Use Seperate PBL */
		unsigned int HEIGHTxPBL     : 1;	/* 8xPBL Mode */
		unsigned int AAL            : 1;	/* Address Aligned Beats */
		unsigned int MB             : 1;	/* Mixed Burst */
		unsigned int TXPR           : 1;	/* Transmit Priority */
		/* const */ unsigned int PRWG           : 2;	/* Channel Priority Weights */
		/* const */ unsigned int RESERVED_31_30 : 2;	/* RESERVED_31_30 */
	} B;
	int I;
	unsigned int U;

} ETH_BUS_MODE_type;
#define ETH_BUS_MODE	(*( ETH_BUS_MODE_type *) 0xf001f000u)	/* Register 0 - Bus Mode Register */

typedef volatile union
{
	struct
	{ 
		unsigned int DISR           : 1;	/* Module Disable Request Bit */
		/* const */ unsigned int DISS           : 1;	/* Module Disable Status Bit */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} ETH_CLC_type;
#define ETH_CLC	(*( ETH_CLC_type *) 0xf001d000u)	/* Clock Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CURRBUFAPTR    : 32;	/* Host Receive Buffer Address Pointer */
	} B;
	int I;
	unsigned int U;

} ETH_CURRENT_HOST_RECEIVE_BUFFER_ADDRESS_type;
#define ETH_CURRENT_HOST_RECEIVE_BUFFER_ADDRESS	(*( ETH_CURRENT_HOST_RECEIVE_BUFFER_ADDRESS_type *) 0xf001f054u)	/* Register 21 - Current Host Receive Buffer Address Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CURRDESAPTR    : 32;	/* Host Receive Descriptor Address Pointer */
	} B;
	int I;
	unsigned int U;

} ETH_CURRENT_HOST_RECEIVE_DESCRIPTOR_type;
#define ETH_CURRENT_HOST_RECEIVE_DESCRIPTOR	(*( ETH_CURRENT_HOST_RECEIVE_DESCRIPTOR_type *) 0xf001f04cu)	/* Register 19 - Current Host Receive Descriptor Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CURTBUFAPTR    : 32;	/* Host Transmit Buffer Address Pointer */
	} B;
	int I;
	unsigned int U;

} ETH_CURRENT_HOST_TRANSMIT_BUFFER_ADDRESS_type;
#define ETH_CURRENT_HOST_TRANSMIT_BUFFER_ADDRESS	(*( ETH_CURRENT_HOST_TRANSMIT_BUFFER_ADDRESS_type *) 0xf001f050u)	/* Register 20 - Current Host Transmit Buffer Address Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int CURTDESAPTR    : 32;	/* Host Transmit Descriptor Address Pointer */
	} B;
	int I;
	unsigned int U;

} ETH_CURRENT_HOST_TRANSMIT_DESCRIPTOR_type;
#define ETH_CURRENT_HOST_TRANSMIT_DESCRIPTOR	(*( ETH_CURRENT_HOST_TRANSMIT_DESCRIPTOR_type *) 0xf001f048u)	/* Register 18 - Current Host Transmit Descriptor Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RPESTS         : 1;	/* MAC GMII or MII Receive Protocol Engine Status */
		/* const */ unsigned int RFCFCSTS       : 2;	/* MAC Receive Frame Controller FIFO Status */
		/* const */ unsigned int RESERVED_3     : 1;	/* RESERVED_3 */
		/* const */ unsigned int RWCSTS         : 1;	/* MTL Rx FIFO Write Controller Active Status */
		/* const */ unsigned int RRCSTS         : 2;	/* MTL Rx FIFO Read Controller State */
		/* const */ unsigned int RESERVED_7     : 1;	/* RESERVED_7 */
		/* const */ unsigned int RXFSTS         : 2;	/* MTL Rx FIFO Fill-level Status */
		/* const */ unsigned int RESERVED_15_10 : 6;	/* RESERVED_15_10 */
		/* const */ unsigned int TPESTS         : 1;	/* MAC GMII or MII Transmit Protocol Engine Status */
		/* const */ unsigned int TFCSTS         : 2;	/* MAC Transmit Frame Controller Status */
		/* const */ unsigned int TXPAUSED       : 1;	/* MAC transmitter in PAUSE */
		/* const */ unsigned int TRCSTS         : 2;	/* MTL Tx FIFO Read Controller Status */
		/* const */ unsigned int TWCSTS         : 1;	/* MTL Tx FIFO Write Controller Active Status */
		/* const */ unsigned int RESERVED_23    : 1;	/* RESERVED_23 */
		/* const */ unsigned int TXFSTS         : 1;	/* MTL Tx FIFO Not Empty Status */
		/* const */ unsigned int TXSTSFSTS      : 1;	/* MTL TxStatus FIFO Full Status */
		/* const */ unsigned int RESERVED_31_26 : 6;	/* RESERVED_31_26 */
	} B;
	int I;
	unsigned int U;

} ETH_DEBUG_type;
#define ETH_DEBUG	(*( ETH_DEBUG_type *) 0xf001e024u)	/* Register 9 - Debug Register */

typedef volatile union
{
	struct
	{ 
		unsigned int FCA_BPA        : 1;	/* Flow Control Busy or Backpressure Activate */
		unsigned int TFE            : 1;	/* Transmit Flow Control Enable */
		unsigned int RFE            : 1;	/* Receive Flow Control Enable */
		unsigned int UP             : 1;	/* Unicast Pause Frame Detect */
		unsigned int PLT            : 2;	/* Pause Low Threshold */
		/* const */ unsigned int RESERVED_6     : 1;	/* RESERVED_6 */
		unsigned int DZPQ           : 1;	/* Disable Zero-Quanta Pause */
		/* const */ unsigned int RESERVED_15_8  : 8;	/* RESERVED_15_8 */
		unsigned int PT             : 16;	/* Pause Time */
	} B;
	int I;
	unsigned int U;

} ETH_FLOW_CONTROL_type;
#define ETH_FLOW_CONTROL	(*( ETH_FLOW_CONTROL_type *) 0xf001e018u)	/* Register 6 - Flow Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int GB             : 1;	/* GMII Busy */
		unsigned int GW             : 1;	/* GMII Write */
		unsigned int CR             : 4;	/* CSR Clock Range */
		unsigned int GR             : 5;	/* GMII Register */
		unsigned int PA             : 5;	/* Physical Layer Address */
		/* const */ unsigned int RESERVED_31_16 : 16;	/* RESERVED_31_16 */
	} B;
	int I;
	unsigned int U;

} ETH_GMII_ADDRESS_type;
#define ETH_GMII_ADDRESS	(*( ETH_GMII_ADDRESS_type *) 0xf001e010u)	/* Register 4 - GMII Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int GD             : 16;	/* GMII Data */
		/* const */ unsigned int RESERVED_31_16 : 16;	/* RESERVED_31_16 */
	} B;
	int I;
	unsigned int U;

} ETH_GMII_DATA_type;
#define ETH_GMII_DATA	(*( ETH_GMII_DATA_type *) 0xf001e014u)	/* Register 5 - GMII Data Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ALTI0          : 2;	/* Alternate Input Select */
		unsigned int ALTI1          : 2;	/* Alternate Input Select */
		unsigned int ALTI2          : 2;	/* Alternate Input Select */
		unsigned int ALTI3          : 2;	/* Alternate Input Select */
		unsigned int ALTI4          : 2;	/* Alternate Input Select */
		unsigned int ALTI5          : 2;	/* Alternate Input Select */
		unsigned int ALTI6          : 2;	/* Alternate Input Select */
		unsigned int ALTI7          : 2;	/* Alternate Input Select */
		unsigned int ALTI8          : 2;	/* Alternate Input Select */
		unsigned int ALTI9          : 2;	/* Alternate Input Select */
		unsigned int ALTI10         : 2;	/* Alternate Input Select */
		unsigned int                : 2;
		unsigned int EPR            : 1;	/* External Phy Interface RMMI Mode Bit */
		unsigned int DIV            : 1;	/* Module Clock Divider Request Bit */
		unsigned int                : 6;
	} B;
	int I;
	unsigned int U;

} ETH_GPCTL_type;
#define ETH_GPCTL	(*( ETH_GPCTL_type *) 0xf001d008u)	/* Input and Output Control Register */

typedef volatile union
{
	struct
	{ 
		unsigned int HTH            : 32;	/* Hash Table High */
	} B;
	int I;
	unsigned int U;

} ETH_HASH_TABLE_HIGH_type;
#define ETH_HASH_TABLE_HIGH	(*( ETH_HASH_TABLE_HIGH_type *) 0xf001e008u)	/* Register 2 - Hash Table High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int HTL            : 32;	/* Hash Table Low */
	} B;
	int I;
	unsigned int U;

} ETH_HASH_TABLE_LOW_type;
#define ETH_HASH_TABLE_LOW	(*( ETH_HASH_TABLE_LOW_type *) 0xf001e00cu)	/* Register 3 - Hash Table Low Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MIISEL         : 1;	/* MIISEL */
		/* const */ unsigned int GMIISEL        : 1;	/* GMIISEL */
		/* const */ unsigned int HDSEL          : 1;	/* HDSEL */
		/* const */ unsigned int EXTHASHEN      : 1;	/* EXTHASHEN */
		/* const */ unsigned int HASHSEL        : 1;	/* HASHSEL */
		/* const */ unsigned int ADDMACADRSEL   : 1;	/* ADDMACADRSEL */
		/* const */ unsigned int PCSSEL         : 1;	/* PCSSEL */
		/* const */ unsigned int L3L4FLTREN     : 1;	/* L3L4FLTREN */
		/* const */ unsigned int SMASEL         : 1;	/* SMASEL */
		/* const */ unsigned int RWKSEL         : 1;	/* RWKSEL */
		/* const */ unsigned int MGKSEL         : 1;	/* MGKSEL */
		/* const */ unsigned int MMCSEL         : 1;	/* MMCSEL */
		/* const */ unsigned int TSVER1SEL      : 1;	/* TSVER1SEL */
		/* const */ unsigned int TSVER2SEL      : 1;	/* TSVER2SEL */
		/* const */ unsigned int EEESEL         : 1;	/* EEESEL */
		/* const */ unsigned int AVSEL          : 1;	/* AVSEL */
		/* const */ unsigned int TXCOESEL       : 1;	/* TXCOESEL */
		/* const */ unsigned int RXTYP1COE      : 1;	/* RXTYP1COE */
		/* const */ unsigned int RXTYP2COE      : 1;	/* RXTYP2COE */
		unsigned int RXFIFOSIZE     : 1;	/* RXFIFOSIZE */
		/* const */ unsigned int RXCHCNT        : 2;	/* RXCHCNT */
		/* const */ unsigned int TXCHCNT        : 2;	/* TXCHCNT */
		/* const */ unsigned int ENHDESSEL      : 1;	/* ENHDESSEL */
		/* const */ unsigned int INTTSEN        : 1;	/* INTTSEN */
		/* const */ unsigned int FLEXIPPSEN     : 1;	/* FLEXIPPSEN */
		/* const */ unsigned int SAVLANINS      : 1;	/* SAVLANINS */
		/* const */ unsigned int ACTPHYIF       : 3;	/* Active or Selected PHY interface */
		/* const */ unsigned int RESERVED_31    : 1;	/* RESERVED_31 */
	} B;
	int I;
	unsigned int U;

} ETH_HW_FEATURE_type;
#define ETH_HW_FEATURE	(*( ETH_HW_FEATURE_type *) 0xf001f058u)	/* Register 22 - HW Feature Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MODREV         : 8;	/* Module Revision Number */
		/* const */ unsigned int MODTYPE        : 8;	/* Module Type */
		/* const */ unsigned int MODNUMBER      : 16;	/* Module Number Value */
	} B;
	int I;
	unsigned int U;

} ETH_ID_type;
#define ETH_ID	(*( ETH_ID_type *) 0xf001d004u)	/* Module Identification Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TIE            : 1;	/* Transmit Interrupt Enable */
		unsigned int TSE            : 1;	/* Transmit Stopped Enable */
		unsigned int TUE            : 1;	/* Transmit Buffer Unvailable Enable */
		unsigned int TJE            : 1;	/* Transmit Jabber Timeout Enable */
		unsigned int OVE            : 1;	/* Overflow Interrupt Enable */
		unsigned int UNE            : 1;	/* Underflow Interrupt Enable */
		unsigned int RIE            : 1;	/* Receive Interrupt Enable */
		unsigned int RUE            : 1;	/* Receive Buffer Unavailable Enable */
		unsigned int RSE            : 1;	/* Receive Stopped Enable */
		unsigned int RWE            : 1;	/* Receive Watchdog Timeout Enable */
		unsigned int ETE            : 1;	/* Early Transmit Interrupt Enable */
		/* const */ unsigned int RESERVED_12_11 : 2;	/* RESERVED_12_11 */
		unsigned int FBE            : 1;	/* Fatal Bus Error Enable */
		unsigned int ERE            : 1;	/* Early Receive Interrupt Enable */
		unsigned int AIE            : 1;	/* Abnormal Interrupt Summary Enable */
		unsigned int NIE            : 1;	/* Normal Interrupt Summary Enable */
		/* const */ unsigned int RESERVED_31_17 : 15;	/* RESERVED_31_17 */
	} B;
	int I;
	unsigned int U;

} ETH_INTERRUPT_ENABLE_type;
#define ETH_INTERRUPT_ENABLE	(*( ETH_INTERRUPT_ENABLE_type *) 0xf001f01cu)	/* Register 7 - Interrupt Enable Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RGSMIIIM       : 1;	/* RGMII or SMII Interrupt Mask */
		/* const */ unsigned int PCSLCHGIM      : 1;	/* PCS Link Status Interrupt Mask */
		/* const */ unsigned int PCSANCIM       : 1;	/* PCS AN Completion Interrupt Mask */
		unsigned int PMTIM          : 1;	/* PMT Interrupt Mask */
		/* const */ unsigned int RESERVED_8_4   : 5;	/* RESERVED_8_4 */
		unsigned int TSIM           : 1;	/* Timestamp Interrupt Mask */
		/* const */ unsigned int LPIIM          : 1;	/* LPI Interrupt Mask */
		/* const */ unsigned int RESERVED_31_11 : 21;	/* RESERVED_31_11 */
	} B;
	int I;
	unsigned int U;

} ETH_INTERRUPT_MASK_type;
#define ETH_INTERRUPT_MASK	(*( ETH_INTERRUPT_MASK_type *) 0xf001e03cu)	/* Register 15 - Interrupt Mask Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RGSMIIIS       : 1;	/* RGMII or SMII Interrupt Status */
		/* const */ unsigned int PCSLCHGIS      : 1;	/* PCS Link Status Changed */
		/* const */ unsigned int PCSANCIS       : 1;	/* PCS Auto-Negotiation Complete */
		/* const */ unsigned int PMTIS          : 1;	/* PMT Interrupt Status */
		/* const */ unsigned int MMCIS          : 1;	/* MMC Interrupt Status */
		/* const */ unsigned int MMCRXIS        : 1;	/* MMC Receive Interrupt Status */
		/* const */ unsigned int MMCTXIS        : 1;	/* MMC Transmit Interrupt Status */
		/* const */ unsigned int MMCRXIPIS      : 1;	/* MMC Receive Checksum Offload Interrupt Status */
		/* const */ unsigned int RESERVED_8     : 1;	/* RESERVED_8 */
		/* const */ unsigned int TSIS           : 1;	/* Timestamp Interrupt Status */
		/* const */ unsigned int LPIIS          : 1;	/* LPI Interrupt Status */
		/* const */ unsigned int RESERVED_31_11 : 21;	/* RESERVED_31_11 */
	} B;
	int I;
	unsigned int U;

} ETH_INTERRUPT_STATUS_type;
#define ETH_INTERRUPT_STATUS	(*( ETH_INTERRUPT_STATUS_type *) 0xf001e038u)	/* Register 14 - Interrupt Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		/* const */ unsigned int RSTSTAT        : 1;	/* Kernel Reset Status */
		unsigned int                : 30;
	} B;
	int I;
	unsigned int U;

} ETH_KRST0_type;
#define ETH_KRST0	(*( ETH_KRST0_type *) 0xf001d014u)	/* Kernel Reset Register 0 */

typedef volatile union
{
	struct
	{ 
		unsigned int RST            : 1;	/* Kernel Reset */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} ETH_KRST1_type;
#define ETH_KRST1	(*( ETH_KRST1_type *) 0xf001d018u)	/* Kernel Reset Register 1 */

typedef volatile union
{
	struct
	{ 
		unsigned int CLR            : 1;	/* Kernel Reset Status Clear */
		unsigned int                : 31;
	} B;
	int I;
	unsigned int U;

} ETH_KRSTCLR_type;
#define ETH_KRSTCLR	(*( ETH_KRSTCLR_type *) 0xf001d01cu)	/* Kernel Reset Status Clear Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address0 [47:32] */
		/* const */ unsigned int RESERVED_30_16 : 15;	/* RESERVED_30_16 */
		/* const */ unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS0_HIGH_type;
#define ETH_MAC_ADDRESS0_HIGH	(*( ETH_MAC_ADDRESS0_HIGH_type *) 0xf001e040u)	/* Register 16 - MAC Address0 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address0 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS0_LOW_type;
#define ETH_MAC_ADDRESS0_LOW	(*( ETH_MAC_ADDRESS0_LOW_type *) 0xf001e044u)	/* Register 17 - MAC Address0 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address10 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS10_HIGH_type;
#define ETH_MAC_ADDRESS10_HIGH	(*( ETH_MAC_ADDRESS10_HIGH_type *) 0xf001e090u)	/* Register 36 - MAC Address10 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address10 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS10_LOW_type;
#define ETH_MAC_ADDRESS10_LOW	(*( ETH_MAC_ADDRESS10_LOW_type *) 0xf001e094u)	/* Register 37 - MAC Address10 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address11 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS11_HIGH_type;
#define ETH_MAC_ADDRESS11_HIGH	(*( ETH_MAC_ADDRESS11_HIGH_type *) 0xf001e098u)	/* Register 38 - MAC Address11 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address11 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS11_LOW_type;
#define ETH_MAC_ADDRESS11_LOW	(*( ETH_MAC_ADDRESS11_LOW_type *) 0xf001e09cu)	/* Register 39 - MAC Address1 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address12 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS12_HIGH_type;
#define ETH_MAC_ADDRESS12_HIGH	(*( ETH_MAC_ADDRESS12_HIGH_type *) 0xf001e0a0u)	/* Register 40 - MAC Address12 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address12 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS12_LOW_type;
#define ETH_MAC_ADDRESS12_LOW	(*( ETH_MAC_ADDRESS12_LOW_type *) 0xf001e0a4u)	/* Register 41 - MAC Address12 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address13 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS13_HIGH_type;
#define ETH_MAC_ADDRESS13_HIGH	(*( ETH_MAC_ADDRESS13_HIGH_type *) 0xf001e0a8u)	/* Register 42 - MAC Address13 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address13 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS13_LOW_type;
#define ETH_MAC_ADDRESS13_LOW	(*( ETH_MAC_ADDRESS13_LOW_type *) 0xf001e0acu)	/* Register 43 - MAC Address13 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address14 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS14_HIGH_type;
#define ETH_MAC_ADDRESS14_HIGH	(*( ETH_MAC_ADDRESS14_HIGH_type *) 0xf001e0b0u)	/* Register 44 - MAC Address14 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address14 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS14_LOW_type;
#define ETH_MAC_ADDRESS14_LOW	(*( ETH_MAC_ADDRESS14_LOW_type *) 0xf001e0b4u)	/* Register 45 - MAC Address14 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* ADDRHI */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS15_HIGH_type;
#define ETH_MAC_ADDRESS15_HIGH	(*( ETH_MAC_ADDRESS15_HIGH_type *) 0xf001e0b8u)	/* Register 46 - MAC Address15 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address15 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS15_LOW_type;
#define ETH_MAC_ADDRESS15_LOW	(*( ETH_MAC_ADDRESS15_LOW_type *) 0xf001e0bcu)	/* Register 47 - MAC Address15 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address16 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS16_HIGH_type;
#define ETH_MAC_ADDRESS16_HIGH	(*( ETH_MAC_ADDRESS16_HIGH_type *) 0xf001e800u)	/* Register 512 - MAC Address16 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address16 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS16_LOW_type;
#define ETH_MAC_ADDRESS16_LOW	(*( ETH_MAC_ADDRESS16_LOW_type *) 0xf001e804u)	/* Register 513 - MAC Address16 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address18 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS17_HIGH_type;
#define ETH_MAC_ADDRESS17_HIGH	(*( ETH_MAC_ADDRESS17_HIGH_type *) 0xf001e808u)	/* Register 514 - MAC Address17 High Register */
#define ETH_MAC_ADDRESS18_HIGH	(*( ETH_MAC_ADDRESS17_HIGH_type *) 0xf001e810u)	/* Register 516 - MAC Address18 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address17 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS17_LOW_type;
#define ETH_MAC_ADDRESS17_LOW	(*( ETH_MAC_ADDRESS17_LOW_type *) 0xf001e80cu)	/* Register 515 - MAC Address17 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address18 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS18_LOW_type;
#define ETH_MAC_ADDRESS18_LOW	(*( ETH_MAC_ADDRESS18_LOW_type *) 0xf001e814u)	/* Register 517 - MAC Address18 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address19 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS19_HIGH_type;
#define ETH_MAC_ADDRESS19_HIGH	(*( ETH_MAC_ADDRESS19_HIGH_type *) 0xf001e818u)	/* Register 518 - MAC Address19 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address19 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS19_LOW_type;
#define ETH_MAC_ADDRESS19_LOW	(*( ETH_MAC_ADDRESS19_LOW_type *) 0xf001e81cu)	/* Register 519 - MAC Address19 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address1 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS1_HIGH_type;
#define ETH_MAC_ADDRESS1_HIGH	(*( ETH_MAC_ADDRESS1_HIGH_type *) 0xf001e048u)	/* Register 18 - MAC Address1 High Register */
#define ETH_MAC_ADDRESS24_HIGH	(*( ETH_MAC_ADDRESS1_HIGH_type *) 0xf001e840u)	/* Register 528 - MAC Address24 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address1 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS1_LOW_type;
#define ETH_MAC_ADDRESS1_LOW	(*( ETH_MAC_ADDRESS1_LOW_type *) 0xf001e04cu)	/* Register 19 - MAC Address1 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address20 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS20_HIGH_type;
#define ETH_MAC_ADDRESS20_HIGH	(*( ETH_MAC_ADDRESS20_HIGH_type *) 0xf001e820u)	/* Register 520 - MAC Address20 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address20 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS20_LOW_type;
#define ETH_MAC_ADDRESS20_LOW	(*( ETH_MAC_ADDRESS20_LOW_type *) 0xf001e824u)	/* Register 521 - MAC Address20 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address21 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS21_HIGH_type;
#define ETH_MAC_ADDRESS21_HIGH	(*( ETH_MAC_ADDRESS21_HIGH_type *) 0xf001e828u)	/* Register 522 - MAC Address21 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address21 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS21_LOW_type;
#define ETH_MAC_ADDRESS21_LOW	(*( ETH_MAC_ADDRESS21_LOW_type *) 0xf001e82cu)	/* Register 523 - MAC Address21 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address22 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS22_HIGH_type;
#define ETH_MAC_ADDRESS22_HIGH	(*( ETH_MAC_ADDRESS22_HIGH_type *) 0xf001e830u)	/* Register 524 - MAC Address22 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address22 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS22_LOW_type;
#define ETH_MAC_ADDRESS22_LOW	(*( ETH_MAC_ADDRESS22_LOW_type *) 0xf001e834u)	/* Register 525 - MAC Address22 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address23 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS23_HIGH_type;
#define ETH_MAC_ADDRESS23_HIGH	(*( ETH_MAC_ADDRESS23_HIGH_type *) 0xf001e838u)	/* Register 526 - MAC Address23 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address23 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS23_LOW_type;
#define ETH_MAC_ADDRESS23_LOW	(*( ETH_MAC_ADDRESS23_LOW_type *) 0xf001e83cu)	/* Register 527 - MAC Address23 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address24 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS24_LOW_type;
#define ETH_MAC_ADDRESS24_LOW	(*( ETH_MAC_ADDRESS24_LOW_type *) 0xf001e844u)	/* Register 529 - MAC Address24 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address25 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS25_HIGH_type;
#define ETH_MAC_ADDRESS25_HIGH	(*( ETH_MAC_ADDRESS25_HIGH_type *) 0xf001e848u)	/* Register 530 - MAC Address25 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address25 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS25_LOW_type;
#define ETH_MAC_ADDRESS25_LOW	(*( ETH_MAC_ADDRESS25_LOW_type *) 0xf001e84cu)	/* Register 531 - MAC Address25 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address26 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS26_HIGH_type;
#define ETH_MAC_ADDRESS26_HIGH	(*( ETH_MAC_ADDRESS26_HIGH_type *) 0xf001e850u)	/* Register 532 - MAC Address26 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address26 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS26_LOW_type;
#define ETH_MAC_ADDRESS26_LOW	(*( ETH_MAC_ADDRESS26_LOW_type *) 0xf001e854u)	/* Register 533 - MAC Address26 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address27 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS27_HIGH_type;
#define ETH_MAC_ADDRESS27_HIGH	(*( ETH_MAC_ADDRESS27_HIGH_type *) 0xf001e858u)	/* Register 534 - MAC Address27 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address27 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS27_LOW_type;
#define ETH_MAC_ADDRESS27_LOW	(*( ETH_MAC_ADDRESS27_LOW_type *) 0xf001e85cu)	/* Register 535 - MAC Address27 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address28 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS28_HIGH_type;
#define ETH_MAC_ADDRESS28_HIGH	(*( ETH_MAC_ADDRESS28_HIGH_type *) 0xf001e860u)	/* Register 536 - MAC Address28 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address28 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS28_LOW_type;
#define ETH_MAC_ADDRESS28_LOW	(*( ETH_MAC_ADDRESS28_LOW_type *) 0xf001e864u)	/* Register 537 - MAC Address28 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address29 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS29_HIGH_type;
#define ETH_MAC_ADDRESS29_HIGH	(*( ETH_MAC_ADDRESS29_HIGH_type *) 0xf001e868u)	/* Register 538 - MAC Address29 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address29 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS29_LOW_type;
#define ETH_MAC_ADDRESS29_LOW	(*( ETH_MAC_ADDRESS29_LOW_type *) 0xf001e86cu)	/* Register 539 - MAC Address29 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address2 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS2_HIGH_type;
#define ETH_MAC_ADDRESS2_HIGH	(*( ETH_MAC_ADDRESS2_HIGH_type *) 0xf001e050u)	/* Register 20 - MAC Address2 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address2 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS2_LOW_type;
#define ETH_MAC_ADDRESS2_LOW	(*( ETH_MAC_ADDRESS2_LOW_type *) 0xf001e054u)	/* Register 21 - MAC Address2 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address30 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS30_HIGH_type;
#define ETH_MAC_ADDRESS30_HIGH	(*( ETH_MAC_ADDRESS30_HIGH_type *) 0xf001e870u)	/* Register 540 - MAC Address30 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address30 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS30_LOW_type;
#define ETH_MAC_ADDRESS30_LOW	(*( ETH_MAC_ADDRESS30_LOW_type *) 0xf001e874u)	/* Register 541 - MAC Address30 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address31 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS31_HIGH_type;
#define ETH_MAC_ADDRESS31_HIGH	(*( ETH_MAC_ADDRESS31_HIGH_type *) 0xf001e878u)	/* Register 542 - MAC Address31 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address31 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS31_LOW_type;
#define ETH_MAC_ADDRESS31_LOW	(*( ETH_MAC_ADDRESS31_LOW_type *) 0xf001e87cu)	/* Register 543 - MAC Address31 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address3 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS3_HIGH_type;
#define ETH_MAC_ADDRESS3_HIGH	(*( ETH_MAC_ADDRESS3_HIGH_type *) 0xf001e058u)	/* Register 22 - MAC Address3 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address3 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS3_LOW_type;
#define ETH_MAC_ADDRESS3_LOW	(*( ETH_MAC_ADDRESS3_LOW_type *) 0xf001e05cu)	/* Register 23 - MAC Address3 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address4 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS4_HIGH_type;
#define ETH_MAC_ADDRESS4_HIGH	(*( ETH_MAC_ADDRESS4_HIGH_type *) 0xf001e060u)	/* Register 24 - MAC Address4 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address4 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS4_LOW_type;
#define ETH_MAC_ADDRESS4_LOW	(*( ETH_MAC_ADDRESS4_LOW_type *) 0xf001e064u)	/* Register 25 - MAC Address4 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address5 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS5_HIGH_type;
#define ETH_MAC_ADDRESS5_HIGH	(*( ETH_MAC_ADDRESS5_HIGH_type *) 0xf001e068u)	/* Register 26 - MAC Address5 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address5 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS5_LOW_type;
#define ETH_MAC_ADDRESS5_LOW	(*( ETH_MAC_ADDRESS5_LOW_type *) 0xf001e06cu)	/* Register 27 - MAC Address5 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address6 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS6_HIGH_type;
#define ETH_MAC_ADDRESS6_HIGH	(*( ETH_MAC_ADDRESS6_HIGH_type *) 0xf001e070u)	/* Register 28 - MAC Address6 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address6 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS6_LOW_type;
#define ETH_MAC_ADDRESS6_LOW	(*( ETH_MAC_ADDRESS6_LOW_type *) 0xf001e074u)	/* Register 29 - MAC Address6 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address7 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS7_HIGH_type;
#define ETH_MAC_ADDRESS7_HIGH	(*( ETH_MAC_ADDRESS7_HIGH_type *) 0xf001e078u)	/* Register 30 - MAC Address7 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address7 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS7_LOW_type;
#define ETH_MAC_ADDRESS7_LOW	(*( ETH_MAC_ADDRESS7_LOW_type *) 0xf001e07cu)	/* Register 31 - MAC Address7 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address8 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS8_HIGH_type;
#define ETH_MAC_ADDRESS8_HIGH	(*( ETH_MAC_ADDRESS8_HIGH_type *) 0xf001e080u)	/* Register 32 - MAC Address8 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address8 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS8_LOW_type;
#define ETH_MAC_ADDRESS8_LOW	(*( ETH_MAC_ADDRESS8_LOW_type *) 0xf001e084u)	/* Register 33 - MAC Address8 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRHI         : 16;	/* MAC Address9 [47:32] */
		/* const */ unsigned int RESERVED_23_16 : 8;	/* RESERVED_23_16 */
		unsigned int MBC            : 6;	/* Mask Byte Control */
		unsigned int SA             : 1;	/* Source Address */
		unsigned int AE             : 1;	/* Address Enable */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS9_HIGH_type;
#define ETH_MAC_ADDRESS9_HIGH	(*( ETH_MAC_ADDRESS9_HIGH_type *) 0xf001e088u)	/* Register 34 - MAC Address9 High Register */

typedef volatile union
{
	struct
	{ 
		unsigned int ADDRLO         : 32;	/* MAC Address9 [31:0] */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_ADDRESS9_LOW_type;
#define ETH_MAC_ADDRESS9_LOW	(*( ETH_MAC_ADDRESS9_LOW_type *) 0xf001e08cu)	/* Register 35 - MAC Address9 Low Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PRELEN         : 2;	/* Preamble Length for Transmit Frames */
		unsigned int RE             : 1;	/* Receiver Enable */
		unsigned int TE             : 1;	/* Transmitter Enable */
		unsigned int DC             : 1;	/* Deferral Check */
		unsigned int BL             : 2;	/* Back-Off Limit */
		unsigned int ACS            : 1;	/* Automatic Pad or CRC Stripping */
		/* const */ unsigned int LUD            : 1;	/* Link Up or Down */
		unsigned int DR             : 1;	/* Disable Retry */
		unsigned int IPC            : 1;	/* Checksum Offload */
		unsigned int DM             : 1;	/* Duplex Mode */
		unsigned int LM             : 1;	/* Loopback Mode */
		unsigned int DO             : 1;	/* Disable Receive Own */
		unsigned int FES            : 1;	/* Speed */
		/* const */ unsigned int PS             : 1;	/* Port Select */
		unsigned int DCRS           : 1;	/* Disable Carrier Sense During Transmission */
		unsigned int IFG            : 3;	/* Inter-Frame Gap */
		unsigned int JE             : 1;	/* Jumbo Frame Enable */
		/* const */ unsigned int BE             : 1;	/* Frame Burst Enable */
		unsigned int JD             : 1;	/* Jabber Disable */
		unsigned int WD             : 1;	/* Watchdog Disable */
		/* const */ unsigned int TC             : 1;	/* Transmit Configuration in RGMII, SGMII, or SMII */
		unsigned int CST            : 1;	/* CRC Stripping of Type Frames */
		/* const */ unsigned int SFTERR         : 1;	/* SMII Force Transmit Error */
		unsigned int TWOKPE         : 1;	/* IEEE 802.3as support for 2K packets Enable */
		/* const */ unsigned int SARC           : 3;	/* Source Address Insertion or Replacement Control */
		/* const */ unsigned int RESERVED_31    : 1;	/* RESERVED_31 */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_CONFIGURATION_type;
#define ETH_MAC_CONFIGURATION	(*( ETH_MAC_CONFIGURATION_type *) 0xf001e000u)	/* Register 0 - MAC Configuration Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PR             : 1;	/* Promiscuous Mode */
		unsigned int HUC            : 1;	/* Hash Unicast */
		unsigned int HMC            : 1;	/* Hash Multicast */
		unsigned int DAIF           : 1;	/* DA Inverse Filtering */
		unsigned int PM             : 1;	/* Pass All Multicast */
		unsigned int DBF            : 1;	/* Disable Broadcast Frames */
		unsigned int PCF            : 2;	/* Pass Control Frames */
		unsigned int SAIF           : 1;	/* SA Inverse Filtering */
		unsigned int SAF            : 1;	/* Source Address Filter Enable */
		unsigned int HPF            : 1;	/* Hash or Perfect Filter */
		/* const */ unsigned int RESERVED_15_11 : 5;	/* RESERVED_15_11 */
		unsigned int VTFE           : 1;	/* VLAN Tag Filter Enable */
		/* const */ unsigned int RESERVED_19_17 : 3;	/* RESERVED_19_17 */
		/* const */ unsigned int IPFE           : 1;	/* Layer 3 and Layer 4 Filter Enable */
		/* const */ unsigned int DNTU           : 1;	/* Drop non-TCP/UDP over IP Frames */
		/* const */ unsigned int RESERVED_30_22 : 9;	/* RESERVED_30_22 */
		unsigned int RA             : 1;	/* Receive All */
	} B;
	int I;
	unsigned int U;

} ETH_MAC_FRAME_FILTER_type;
#define ETH_MAC_FRAME_FILTER	(*( ETH_MAC_FRAME_FILTER_type *) 0xf001e004u)	/* Register 1 - MAC Frame Filter */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int MISFRMCNT      : 16;	/* MISFRMCNT */
		/* const */ unsigned int MISCNTOVF      : 1;	/* MISCNTOVF */
		/* const */ unsigned int OVFFRMCNT      : 11;	/* OVFFRMCNT */
		/* const */ unsigned int OVFCNTOVF      : 1;	/* OVFCNTOVF */
		/* const */ unsigned int RESERVED_31_29 : 3;	/* RESERVED_31_29 */
	} B;
	int I;
	unsigned int U;

} ETH_MISSED_FRAME_AND_BUFFER_OVERFLOW_COUNTER_type;
#define ETH_MISSED_FRAME_AND_BUFFER_OVERFLOW_COUNTER	(*( ETH_MISSED_FRAME_AND_BUFFER_OVERFLOW_COUNTER_type *) 0xf001f020u)	/* Register 8 - Missed Frame and Buffer Overflow Counter Register */

typedef volatile union
{
	struct
	{ 
		unsigned int CNTRST         : 1;	/* Counters Reset */
		unsigned int CNTSTOPRO      : 1;	/* Counters Stop Rollover */
		unsigned int RSTONRD        : 1;	/* Reset on Read */
		unsigned int CNTFREEZ       : 1;	/* MMC Counter Freeze */
		unsigned int CNTPRST        : 1;	/* Counters Preset */
		unsigned int CNTPRSTLVL     : 1;	/* Full-Half Preset */
		/* const */ unsigned int RESERVED_7_6   : 2;	/* RESERVED_7_6 */
		unsigned int UCDBC          : 1;	/* Update MMC Counters for Dropped Broadcast Frames */
		/* const */ unsigned int RESERVED_31_9  : 23;	/* RESERVED_31_9 */
	} B;
	int I;
	unsigned int U;

} ETH_MMC_CONTROL_type;
#define ETH_MMC_CONTROL	(*( ETH_MMC_CONTROL_type *) 0xf001e100u)	/* Register 64 - MMC Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4GFIS     : 1;	/* MMC Receive IPV4 Good Frame Counter Interrupt Status */
		/* const */ unsigned int RXIPV4HERFIS   : 1;	/* MMC Receive IPV4 Header Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXIPV4NOPAYFIS : 1;	/* MMC Receive IPV4 No Payload Frame Counter Interrupt Status */
		/* const */ unsigned int RXIPV4FRAGFIS  : 1;	/* MMC Receive IPV4 Fragmented Frame Counter Interrupt Status */
		/* const */ unsigned int RXIPV4UDSBLFIS : 1;	/* MMC Receive IPV4 UDP Checksum Disabled Frame Counter Interrupt Status */
		/* const */ unsigned int RXIPV6GFIS     : 1;	/* MMC Receive IPV6 Good Frame Counter Interrupt Status */
		/* const */ unsigned int RXIPV6HERFIS   : 1;	/* MMC Receive IPV6 Header Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXIPV6NOPAYFIS : 1;	/* MMC Receive IPV6 No Payload Frame Counter Interrupt Status */
		/* const */ unsigned int RXUDPGFIS      : 1;	/* MMC Receive UDP Good Frame Counter Interrupt Status */
		/* const */ unsigned int RXUDPERFIS     : 1;	/* MMC Receive UDP Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXTCPGFIS      : 1;	/* MMC Receive TCP Good Frame Counter Interrupt Status */
		/* const */ unsigned int RXTCPERFIS     : 1;	/* MMC Receive TCP Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXICMPGFIS     : 1;	/* MMC Receive ICMP Good Frame Counter Interrupt Status */
		/* const */ unsigned int RXICMPERFIS    : 1;	/* MMC Receive ICMP Error Frame Counter Interrupt Status */
		/* const */ unsigned int RESERVED_15_14 : 2;	/* RESERVED_15_14 */
		/* const */ unsigned int RXIPV4GOIS     : 1;	/* MMC Receive IPV4 Good Octet Counter Interrupt Status */
		/* const */ unsigned int RXIPV4HEROIS   : 1;	/* MMC Receive IPV4 Header Error Octet Counter Interrupt Status */
		/* const */ unsigned int RXIPV4NOPAYOIS : 1;	/* MMC Receive IPV4 No Payload Octet Counter Interrupt Status */
		/* const */ unsigned int RXIPV4FRAGOIS  : 1;	/* MMC Receive IPV4 Fragmented Octet Counter Interrupt Status */
		/* const */ unsigned int RXIPV4UDSBLOIS : 1;	/* MMC Receive IPV4 UDP Checksum Disabled Octet Counter Interrupt Status */
		/* const */ unsigned int RXIPV6GOIS     : 1;	/* MMC Receive IPV6 Good Octet Counter Interrupt Status */
		/* const */ unsigned int RXIPV6HEROIS   : 1;	/* MMC Receive IPV6 Header Error Octet Counter Interrupt Status */
		/* const */ unsigned int RXIPV6NOPAYOIS : 1;	/* MMC Receive IPV6 No Payload Octet Counter Interrupt Status */
		/* const */ unsigned int RXUDPGOIS      : 1;	/* MMC Receive UDP Good Octet Counter Interrupt Status */
		/* const */ unsigned int RXUDPEROIS     : 1;	/* MMC Receive UDP Error Octet Counter Interrupt Status */
		/* const */ unsigned int RXTCPGOIS      : 1;	/* MMC Receive TCP Good Octet Counter Interrupt Status */
		/* const */ unsigned int RXTCPEROIS     : 1;	/* MMC Receive TCP Error Octet Counter Interrupt Status */
		/* const */ unsigned int RXICMPGOIS     : 1;	/* MMC Receive ICMP Good Octet Counter Interrupt Status */
		/* const */ unsigned int RXICMPEROIS    : 1;	/* MMC Receive ICMP Error Octet Counter Interrupt Status */
		/* const */ unsigned int RESERVED_31_30 : 2;	/* RESERVED_31_30 */
	} B;
	int I;
	unsigned int U;

} ETH_MMC_IPC_RECEIVE_INTERRUPT_type;
#define ETH_MMC_IPC_RECEIVE_INTERRUPT	(*( ETH_MMC_IPC_RECEIVE_INTERRUPT_type *) 0xf001e208u)	/* Register 130 - MMC Receive Checksum Offload Interrupt Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RXIPV4GFIM     : 1;	/* MMC Receive IPV4 Good Frame Counter Interrupt Mask */
		unsigned int RXIPV4HERFIM   : 1;	/* MMC Receive IPV4 Header Error Frame Counter Interrupt Mask */
		unsigned int RXIPV4NOPAYFIM : 1;	/* MMC Receive IPV4 No Payload Frame Counter Interrupt Mask */
		unsigned int RXIPV4FRAGFIM  : 1;	/* MMC Receive IPV4 Fragmented Frame Counter Interrupt Mask */
		unsigned int RXIPV4UDSBLFIM : 1;	/* MMC Receive IPV4 UDP Checksum Disabled Frame Counter Interrupt Mask */
		unsigned int RXIPV6GFIM     : 1;	/* MMC Receive IPV6 Good Frame Counter Interrupt Mask */
		unsigned int RXIPV6HERFIM   : 1;	/* MMC Receive IPV6 Header Error Frame Counter Interrupt Mask */
		unsigned int RXIPV6NOPAYFIM : 1;	/* MMC Receive IPV6 No Payload Frame Counter Interrupt Mask */
		unsigned int RXUDPGFIM      : 1;	/* MMC Receive UDP Good Frame Counter Interrupt Mask */
		unsigned int RXUDPERFIM     : 1;	/* MMC Receive UDP Error Frame Counter Interrupt Mask */
		unsigned int RXTCPGFIM      : 1;	/* MMC Receive TCP Good Frame Counter Interrupt Mask */
		unsigned int RXTCPERFIM     : 1;	/* MMC Receive TCP Error Frame Counter Interrupt Mask */
		unsigned int RXICMPGFIM     : 1;	/* MMC Receive ICMP Good Frame Counter Interrupt Mask */
		unsigned int RXICMPERFIM    : 1;	/* MMC Receive ICMP Error Frame Counter Interrupt Mask */
		/* const */ unsigned int RESERVED_15_14 : 2;	/* RESERVED_15_14 */
		unsigned int RXIPV4GOIM     : 1;	/* MMC Receive IPV4 Good Octet Counter Interrupt Mask */
		unsigned int RXIPV4HEROIM   : 1;	/* MMC Receive IPV4 Header Error Octet Counter Interrupt Mask */
		unsigned int RXIPV4NOPAYOIM : 1;	/* MMC Receive IPV4 No Payload Octet Counter Interrupt Mask */
		unsigned int RXIPV4FRAGOIM  : 1;	/* MMC Receive IPV4 Fragmented Octet Counter Interrupt Mask */
		unsigned int RXIPV4UDSBLOIM : 1;	/* MMC Receive IPV4 UDP Checksum Disabled Octet Counter Interrupt Mask */
		unsigned int RXIPV6GOIM     : 1;	/* MMC Receive IPV6 Good Octet Counter Interrupt Mask */
		unsigned int RXIPV6HEROIM   : 1;	/* MMC Receive IPV6 Header Error Octet Counter Interrupt Mask */
		unsigned int RXIPV6NOPAYOIM : 1;	/* MMC Receive IPV6 No Payload Octet Counter Interrupt Mask */
		unsigned int RXUDPGOIM      : 1;	/* MMC Receive UDP Good Octet Counter Interrupt Mask */
		unsigned int RXUDPEROIM     : 1;	/* MMC Receive UDP Error Octet Counter Interrupt Mask */
		unsigned int RXTCPGOIM      : 1;	/* MMC Receive TCP Good Octet Counter Interrupt Mask */
		unsigned int RXTCPEROIM     : 1;	/* MMC Receive TCP Error Octet Counter Interrupt Mask */
		unsigned int RXICMPGOIM     : 1;	/* MMC Receive ICMP Good Octet Counter Interrupt Mask */
		unsigned int RXICMPEROIM    : 1;	/* MMC Receive ICMP Error Octet Counter Interrupt Mask */
		/* const */ unsigned int RESERVED_31_30 : 2;	/* RESERVED_31_30 */
	} B;
	int I;
	unsigned int U;

} ETH_MMC_IPC_RECEIVE_INTERRUPT_MASK_type;
#define ETH_MMC_IPC_RECEIVE_INTERRUPT_MASK	(*( ETH_MMC_IPC_RECEIVE_INTERRUPT_MASK_type *) 0xf001e200u)	/* Register 128 - MMC Receive Checksum Offload Interrupt Mask Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXGBFRMIS      : 1;	/* MMC Receive Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int RXGBOCTIS      : 1;	/* MMC Receive Good Bad Octet Counter Interrupt Status */
		/* const */ unsigned int RXGOCTIS       : 1;	/* MMC Receive Good Octet Counter Interrupt Status. */
		/* const */ unsigned int RXBCGFIS       : 1;	/* MMC Receive Broadcast Good Frame Counter Interrupt Status. */
		/* const */ unsigned int RXMCGFIS       : 1;	/* MMC Receive Multicast Good Frame Counter Interrupt Status */
		/* const */ unsigned int RXCRCERFIS     : 1;	/* MMC Receive CRC Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXALGNERFIS    : 1;	/* MMC Receive Alignment Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXRUNTFIS      : 1;	/* MMC Receive Runt Frame Counter Interrupt Status */
		/* const */ unsigned int RXJABERFIS     : 1;	/* MMC Receive Jabber Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXUSIZEGFIS    : 1;	/* MMC Receive Undersize Good Frame Counter Interrupt Status */
		/* const */ unsigned int RXOSIZEGFIS    : 1;	/* MMC Receive Oversize Good Frame Counter Interrupt Status */
		/* const */ unsigned int RX64OCTGBFIS   : 1;	/* MMC Receive 64 Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int RX65T127OCTGBFIS: 1;	/* MMC Receive 65 to 127 Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int RX128T255OCTGBFIS: 1;	/* MMC Receive 128 to 255 Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int RX256T511OCTGBFIS: 1;	/* MMC Receive 256 to 511 Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int RX512T1023OCTGBFIS: 1;	/* MMC Receive 512 to 1023 Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int RX1024TMAXOCTGBFIS: 1;	/* MMC Receive 1024 to Maximum Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int RXUCGFIS       : 1;	/* MMC Receive Unicast Good Frame Counter Interrupt Status */
		/* const */ unsigned int RXLENERFIS     : 1;	/* MMC Receive Length Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXORANGEFIS    : 1;	/* MMC Receive Out Of Range Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXPAUSFIS      : 1;	/* MMC Receive Pause Frame Counter Interrupt Status */
		/* const */ unsigned int RXFOVFIS       : 1;	/* MMC Receive FIFO Overflow Frame Counter Interrupt Status */
		/* const */ unsigned int RXVLANGBFIS    : 1;	/* MMC Receive VLAN Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int RXWDOGFIS      : 1;	/* MMC Receive Watchdog Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXRCVERRFIS    : 1;	/* MMC Receive Error Frame Counter Interrupt Status */
		/* const */ unsigned int RXCTRLFIS      : 1;	/* MMC Receive Control Frame Counter Interrupt Status */
		/* const */ unsigned int RESERVED_31_26 : 6;	/* RESERVED_31_26 */
	} B;
	int I;
	unsigned int U;

} ETH_MMC_RECEIVE_INTERRUPT_type;
#define ETH_MMC_RECEIVE_INTERRUPT	(*( ETH_MMC_RECEIVE_INTERRUPT_type *) 0xf001e104u)	/* Register 65 - MMC Receive Interrupt Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RXGBFRMIM      : 1;	/* MMC Receive Good Bad Frame Counter Interrupt Mask */
		unsigned int RXGBOCTIM      : 1;	/* MMC Receive Good Bad Octet Counter Interrupt Mask */
		unsigned int RXGOCTIM       : 1;	/* MMC Receive Good Octet Counter Interrupt Mask */
		unsigned int RXBCGFIM       : 1;	/* MMC Receive Broadcast Good Frame Counter Interrupt Mask */
		unsigned int RXMCGFIM       : 1;	/* MMC Receive Multicast Good Frame Counter Interrupt Mask */
		unsigned int RXCRCERFIM     : 1;	/* MMC Receive CRC Error Frame Counter Interrupt Mask */
		unsigned int RXALGNERFIM    : 1;	/* MMC Receive Alignment Error Frame Counter Interrupt Mask */
		unsigned int RXRUNTFIM      : 1;	/* MMC Receive Runt Frame Counter Interrupt Mask */
		unsigned int RXJABERFIM     : 1;	/* MMC Receive Jabber Error Frame Counter Interrupt Mask */
		unsigned int RXUSIZEGFIM    : 1;	/* MMC Receive Undersize Good Frame Counter Interrupt Mask */
		unsigned int RXOSIZEGFIM    : 1;	/* MMC Receive Oversize Good Frame Counter Interrupt Mask */
		unsigned int RX64OCTGBFIM   : 1;	/* MMC Receive 64 Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int RX65T127OCTGBFIM: 1;	/* MMC Receive 65 to 127 Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int RX128T255OCTGBFIM: 1;	/* MMC Receive 128 to 255 Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int RX256T511OCTGBFIM: 1;	/* MMC Receive 256 to 511 Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int RX512T1023OCTGBFIM: 1;	/* MMC Receive 512 to 1023 Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int RX1024TMAXOCTGBFIM: 1;	/* MMC Receive 1024 to Maximum Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int RXUCGFIM       : 1;	/* MMC Receive Unicast Good Frame Counter Interrupt Mask */
		unsigned int RXLENERFIM     : 1;	/* MMC Receive Length Error Frame Counter Interrupt Mask */
		unsigned int RXORANGEFIM    : 1;	/* MMC Receive Out Of Range Error Frame Counter Interrupt Mask */
		unsigned int RXPAUSFIM      : 1;	/* MMC Receive Pause Frame Counter Interrupt Mask */
		unsigned int RXFOVFIM       : 1;	/* MMC Receive FIFO Overflow Frame Counter Interrupt Mask */
		unsigned int RXVLANGBFIM    : 1;	/* MMC Receive VLAN Good Bad Frame Counter Interrupt Mask */
		unsigned int RXWDOGFIM      : 1;	/* MMC Receive Watchdog Error Frame Counter Interrupt Mask */
		unsigned int RXRCVERRFIM    : 1;	/* MMC Receive Error Frame Counter Interrupt Mask */
		unsigned int RXCTRLFIM      : 1;	/* MMC Receive Control Frame Counter Interrupt Mask */
		/* const */ unsigned int RESERVED_31_26 : 6;	/* RESERVED_31_26 */
	} B;
	int I;
	unsigned int U;

} ETH_MMC_RECEIVE_INTERRUPT_MASK_type;
#define ETH_MMC_RECEIVE_INTERRUPT_MASK	(*( ETH_MMC_RECEIVE_INTERRUPT_MASK_type *) 0xf001e10cu)	/* - */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXGBOCTIS      : 1;	/* MMC Transmit Good Bad Octet Counter Interrupt Status */
		/* const */ unsigned int TXGBFRMIS      : 1;	/* MMC Transmit Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int TXBCGFIS       : 1;	/* MMC Transmit Broadcast Good Frame Counter Interrupt Status */
		/* const */ unsigned int TXMCGFIS       : 1;	/* MMC Transmit Multicast Good Frame Counter Interrupt Status */
		/* const */ unsigned int TX64OCTGBFIS   : 1;	/* MMC Transmit 64 Octet Good Bad Frame Counter Interrupt Status. */
		/* const */ unsigned int TX65T127OCTGBFIS: 1;	/* MMC Transmit 65 to 127 Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int TX128T255OCTGBFIS: 1;	/* MMC Transmit 128 to 255 Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int TX256T511OCTGBFIS: 1;	/* MMC Transmit 256 to 511 Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int TX512T1023OCTGBFIS: 1;	/* MMC Transmit 512 to 1023 Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int TX1024TMAXOCTGBFIS: 1;	/* MMC Transmit 1024 to Maximum Octet Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int TXUCGBFIS      : 1;	/* MMC Transmit Unicast Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int TXMCGBFIS      : 1;	/* MMC Transmit Multicast Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int TXBCGBFIS      : 1;	/* MMC Transmit Broadcast Good Bad Frame Counter Interrupt Status */
		/* const */ unsigned int TXUFLOWERFIS   : 1;	/* MMC Transmit Underflow Error Frame Counter Interrupt Status */
		/* const */ unsigned int TXSCOLGFIS     : 1;	/* MMC Transmit Single Collision Good Frame Counter Interrupt Status */
		/* const */ unsigned int TXMCOLGFIS     : 1;	/* MMC Transmit Multiple Collision Good Frame Counter Interrupt Status */
		/* const */ unsigned int TXDEFFIS       : 1;	/* MMC Transmit Deferred Frame Counter Interrupt Status */
		/* const */ unsigned int TXLATCOLFIS    : 1;	/* MMC Transmit Late Collision Frame Counter Interrupt Status */
		/* const */ unsigned int TXEXCOLFIS     : 1;	/* MMC Transmit Excessive Collision Frame Counter Interrupt Status */
		/* const */ unsigned int TXCARERFIS     : 1;	/* MMC Transmit Carrier Error Frame Counter Interrupt Status */
		/* const */ unsigned int TXGOCTIS       : 1;	/* MMC Transmit Good Octet Counter Interrupt Status */
		/* const */ unsigned int TXGFRMIS       : 1;	/* MMC Transmit Good Frame Counter Interrupt Status */
		/* const */ unsigned int TXEXDEFFIS     : 1;	/* MMC Transmit Excessive Deferral Frame Counter Interrupt Status */
		/* const */ unsigned int TXPAUSFIS      : 1;	/* MMC Transmit Pause Frame Counter Interrupt Status */
		/* const */ unsigned int TXVLANGFIS     : 1;	/* MMC Transmit VLAN Good Frame Counter Interrupt Status */
		/* const */ unsigned int TXOSIZEGFIS    : 1;	/* MMC Transmit Oversize Good Frame Counter Interrupt Status */
		/* const */ unsigned int RESERVED_31_26 : 6;	/* RESERVED_31_26 */
	} B;
	int I;
	unsigned int U;

} ETH_MMC_TRANSMIT_INTERRUPT_type;
#define ETH_MMC_TRANSMIT_INTERRUPT	(*( ETH_MMC_TRANSMIT_INTERRUPT_type *) 0xf001e108u)	/* Register 66 - MMC Transmit Interrupt Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TXGBOCTIM      : 1;	/* MMC Transmit Good Bad Octet Counter Interrupt Mask */
		unsigned int TXGBFRMIM      : 1;	/* MMC Transmit Good Bad Frame Counter Interrupt Mask */
		unsigned int TXBCGFIM       : 1;	/* MMC Transmit Broadcast Good Frame Counter Interrupt Mask */
		unsigned int TXMCGFIM       : 1;	/* MMC Transmit Multicast Good Frame Counter Interrupt Mask */
		unsigned int TX64OCTGBFIM   : 1;	/* MMC Transmit 64 Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int TX65T127OCTGBFIM: 1;	/* MMC Transmit 65 to 127 Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int TX128T255OCTGBFIM: 1;	/* MMC Transmit 128 to 255 Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int TX256T511OCTGBFIM: 1;	/* MMC Transmit 256 to 511 Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int TX512T1023OCTGBFIM: 1;	/* MMC Transmit 512 to 1023 Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int TX1024TMAXOCTGBFIM: 1;	/* MMC Transmit 1024 to Maximum Octet Good Bad Frame Counter Interrupt Mask */
		unsigned int TXUCGBFIM      : 1;	/* MMC Transmit Unicast Good Bad Frame Counter Interrupt Mask */
		unsigned int TXMCGBFIM      : 1;	/* MMC Transmit Multicast Good Bad Frame Counter Interrupt Mask */
		unsigned int TXBCGBFIM      : 1;	/* MMC Transmit Broadcast Good Bad Frame Counter Interrupt Mask */
		unsigned int TXUFLOWERFIM   : 1;	/* MMC Transmit Underflow Error Frame Counter Interrupt Mask */
		unsigned int TXSCOLGFIM     : 1;	/* MMC Transmit Single Collision Good Frame Counter Interrupt Mask */
		unsigned int TXMCOLGFIM     : 1;	/* MMC Transmit Multiple Collision Good Frame Counter Interrupt Mask */
		unsigned int TXDEFFIM       : 1;	/* MMC Transmit Deferred Frame Counter Interrupt Mask */
		unsigned int TXLATCOLFIM    : 1;	/* MMC Transmit Late Collision Frame Counter Interrupt Mask */
		unsigned int TXEXCOLFIM     : 1;	/* MMC Transmit Excessive Collision Frame Counter Interrupt Mask */
		unsigned int TXCARERFIM     : 1;	/* MMC Transmit Carrier Error Frame Counter Interrupt Mask */
		unsigned int TXGOCTIM       : 1;	/* MMC Transmit Good Octet Counter Interrupt Mask */
		unsigned int TXGFRMIM       : 1;	/* MMC Transmit Good Frame Counter Interrupt Mask */
		unsigned int TXEXDEFFIM     : 1;	/* MMC Transmit Excessive Deferral Frame Counter Interrupt Mask */
		unsigned int TXPAUSFIM      : 1;	/* MMC Transmit Pause Frame Counter Interrupt Mask */
		unsigned int TXVLANGFIM     : 1;	/* MMC Transmit VLAN Good Frame Counter Interrupt Mask */
		unsigned int TXOSIZEGFIM    : 1;	/* MMC Transmit Oversize Good Frame Counter Interrupt Mask */
		/* const */ unsigned int RESERVED_31_26 : 6;	/* RESERVED_31_26 */
	} B;
	int I;
	unsigned int U;

} ETH_MMC_TRANSMIT_INTERRUPT_MASK_type;
#define ETH_MMC_TRANSMIT_INTERRUPT_MASK	(*( ETH_MMC_TRANSMIT_INTERRUPT_MASK_type *) 0xf001e110u)	/* Register 68 - MMC Transmit Interrupt Mask Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RESERVED_0     : 1;	/* RESERVED_0 */
		unsigned int SR             : 1;	/* Start or Stop Receive */
		unsigned int OSF            : 1;	/* Operate on Second Frame */
		unsigned int RTC            : 2;	/* Receive Threshold Control */
		/* const */ unsigned int RESERVED_5     : 1;	/* RESERVED_5 */
		unsigned int FUF            : 1;	/* Forward Undersized Good Frames */
		unsigned int FEF            : 1;	/* Forward Error Frames */
		unsigned int EFC            : 1;	/* Enable HW Flow Control */
		unsigned int RFA            : 2;	/* Threshold for Activating Flow Control (in half-duplex and full-duplex) */
		unsigned int RFD            : 2;	/* Threshold for Deactivating Flow Control (in half-duplex and full-duplex) */
		unsigned int ST             : 1;	/* Start or Stop Transmission Command */
		unsigned int TTC            : 3;	/* Transmit Threshold Control */
		/* const */ unsigned int RESERVED_19_17 : 3;	/* RESERVED_19_17 */
		unsigned int FTF            : 1;	/* Flush Transmit FIFO */
		unsigned int TSF            : 1;	/* Transmit Store and Forward */
		/* const */ unsigned int RFD2           : 1;	/* MSB of Threshold for Deactivating Flow Control */
		/* const */ unsigned int RFA2           : 1;	/* MSB of Threshold for Activating Flow Control */
		unsigned int DFF            : 1;	/* Disable Flushing of Received Frames */
		unsigned int RSF            : 1;	/* Receive Store and Forward */
		unsigned int DT             : 1;	/* Disable Dropping of TCP/IP Checksum Error Frames */
		/* const */ unsigned int RESERVED_31_27 : 5;	/* RESERVED_31_27 */
	} B;
	int I;
	unsigned int U;

} ETH_OPERATION_MODE_type;
#define ETH_OPERATION_MODE	(*( ETH_OPERATION_MODE_type *) 0xf001f018u)	/* Register 6 - Operation Mode Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PWRDWN         : 1;	/* Power Down */
		unsigned int MGKPKTEN       : 1;	/* Magic Packet Enable */
		unsigned int RWKPKTEN       : 1;	/* Wake-Up Frame Enable */
		/* const */ unsigned int RESERVED_4_3   : 2;	/* RESERVED_4_3 */
		/* const */ unsigned int MGKPRCVD       : 1;	/* Magic Packet Received */
		/* const */ unsigned int RWKPRCVD       : 1;	/* Wake-Up Frame Received */
		/* const */ unsigned int RESERVED_8_7   : 2;	/* RESERVED_8_7 */
		unsigned int GLBLUCAST      : 1;	/* Global Unicast */
		/* const */ unsigned int RESERVED_30_10 : 21;	/* RESERVED_30_10 */
		unsigned int RWKFILTRST     : 1;	/* Wake-Up Frame Filter Register Pointer Reset */
	} B;
	int I;
	unsigned int U;

} ETH_PMT_CONTROL_STATUS_type;
#define ETH_PMT_CONTROL_STATUS	(*( ETH_PMT_CONTROL_STATUS_type *) 0xf001e02cu)	/* Register 11 - PMT Control and Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int PPSCTRL_PPSCMD : 4;	/* PPSCTRL0 or PPSCMD0 */
		/* const */ unsigned int PPSEN0         : 1;	/* Flexible PPS Output Mode Enable */
		/* const */ unsigned int TRGTMODSEL0    : 2;	/* Target Time Register Mode for PPS0 Output */
		/* const */ unsigned int RESERVED_7     : 1;	/* RESERVED_7 */
		/* const */ unsigned int PPSCMD1        : 3;	/* Flexible PPS1 Output Control */
		/* const */ unsigned int RESERVED_12_11 : 2;	/* RESERVED_12_11 */
		/* const */ unsigned int TRGTMODSEL1    : 2;	/* Target Time Register Mode for PPS1 Output */
		/* const */ unsigned int RESERVED_15    : 1;	/* RESERVED_15 */
		/* const */ unsigned int PPSCMD2        : 3;	/* Flexible PPS2 Output Control */
		/* const */ unsigned int RESERVED_20_19 : 2;	/* RESERVED_20_19 */
		/* const */ unsigned int TRGTMODSEL2    : 2;	/* Target Time Register Mode for PPS2 Output */
		/* const */ unsigned int RESERVED_23    : 1;	/* RESERVED_23 */
		/* const */ unsigned int PPSCMD3        : 3;	/* Flexible PPS3 Output Control */
		/* const */ unsigned int RESERVED_28_27 : 2;	/* RESERVED_28_27 */
		/* const */ unsigned int TRGTMODSEL3    : 2;	/* Target Time Register Mode for PPS3 Output */
		/* const */ unsigned int RESERVED_31    : 1;	/* RESERVED_31 */
	} B;
	int I;
	unsigned int U;

} ETH_PPS_CONTROL_type;
#define ETH_PPS_CONTROL	(*( ETH_PPS_CONTROL_type *) 0xf001e72cu)	/* Register 459 - PPS Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RESERVED_1_0   : 2;	/* RESERVED_1_0 */
		unsigned int RDESLA_32bit   : 30;	/* Start of Receive List */
	} B;
	int I;
	unsigned int U;

} ETH_RECEIVE_DESCRIPTOR_LIST_ADDRESS_type;
#define ETH_RECEIVE_DESCRIPTOR_LIST_ADDRESS	(*( ETH_RECEIVE_DESCRIPTOR_LIST_ADDRESS_type *) 0xf001f00cu)	/* Register 3 - Receive Descriptor List Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RIWT           : 8;	/* RI Watchdog Timer Count */
		/* const */ unsigned int RESERVED_31_8  : 24;	/* RESERVED_31_8 */
	} B;
	int I;
	unsigned int U;

} ETH_RECEIVE_INTERRUPT_WATCHDOG_TIMER_type;
#define ETH_RECEIVE_INTERRUPT_WATCHDOG_TIMER	(*( ETH_RECEIVE_INTERRUPT_WATCHDOG_TIMER_type *) 0xf001f024u)	/* Register 9 - Receive Interrupt Watchdog Timer Register */

typedef volatile union
{
	struct
	{ 
		unsigned int RPD            : 32;	/* Receive Poll Demand */
	} B;
	int I;
	unsigned int U;

} ETH_RECEIVE_POLL_DEMAND_type;
#define ETH_RECEIVE_POLL_DEMAND	(*( ETH_RECEIVE_POLL_DEMAND_type *) 0xf001f008u)	/* Register 2 - Receive Poll Demand Register */

typedef volatile union
{
	struct
	{ 
		unsigned int WKUPFRMFTR     : 32;	/* WKUPFRMFTR */
	} B;
	int I;
	unsigned int U;

} ETH_REMOTE_WAKE_UP_FRAME_FILTER_type;
#define ETH_REMOTE_WAKE_UP_FRAME_FILTER	(*( ETH_REMOTE_WAKE_UP_FRAME_FILTER_type *) 0xf001e028u)	/* Register 10 - Remote Wake-Up Frame Filter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXICMPERRFRM   : 32;	/* RXICMPERRFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXICMP_ERROR_FRAMES_type;
#define ETH_RXICMP_ERROR_FRAMES	(*( ETH_RXICMP_ERROR_FRAMES_type *) 0xf001e244u)	/* Register 145 - Receive ICMP Error Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXICMPERROCT   : 32;	/* RXICMPERROCT */
	} B;
	int I;
	unsigned int U;

} ETH_RXICMP_ERROR_OCTETS_type;
#define ETH_RXICMP_ERROR_OCTETS	(*( ETH_RXICMP_ERROR_OCTETS_type *) 0xf001e284u)	/* Register 161 - Receive ICMP Error Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXICMPGDFRM    : 32;	/* RXICMPGDFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXICMP_GOOD_FRAMES_type;
#define ETH_RXICMP_GOOD_FRAMES	(*( ETH_RXICMP_GOOD_FRAMES_type *) 0xf001e240u)	/* Register 144 - Receive ICMP Good Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXICMPGDOCT    : 32;	/* RXICMPGDOCT */
	} B;
	int I;
	unsigned int U;

} ETH_RXICMP_GOOD_OCTETS_type;
#define ETH_RXICMP_GOOD_OCTETS	(*( ETH_RXICMP_GOOD_OCTETS_type *) 0xf001e280u)	/* Register 160 - Receive ICMP Good Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4FRAGFRM  : 32;	/* RXIPV4FRAGFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV4_FRAGMENTED_FRAMES_type;
#define ETH_RXIPV4_FRAGMENTED_FRAMES	(*( ETH_RXIPV4_FRAGMENTED_FRAMES_type *) 0xf001e21cu)	/* Register 135 - Receive IPV4 Fragmented Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4FRAGOCT  : 32;	/* This field indicates the number of bytes received in fragmented IPv4 datagrams. The value in the IPv4 headers Length field is used to update this counter. */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV4_FRAGMENTED_OCTETS_type;
#define ETH_RXIPV4_FRAGMENTED_OCTETS	(*( ETH_RXIPV4_FRAGMENTED_OCTETS_type *) 0xf001e25cu)	/* Register 151 - Receive IPV4 Fragmented Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4GDFRM    : 32;	/* RXIPV4GDFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV4_GOOD_FRAMES_type;
#define ETH_RXIPV4_GOOD_FRAMES	(*( ETH_RXIPV4_GOOD_FRAMES_type *) 0xf001e210u)	/* Register 132 - Receive IPV4 Good Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4GDOCT    : 32;	/* This field indicates the number of bytes received in good IPv4 datagrams encapsulating TCP, UDP, or ICMP data. The Ethernet header, FCS, pad, or IP pad */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV4_GOOD_OCTETS_type;
#define ETH_RXIPV4_GOOD_OCTETS	(*( ETH_RXIPV4_GOOD_OCTETS_type *) 0xf001e250u)	/* Register 148 - Receive IPV4 Good Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4HDRERRFRM: 32;	/* RXIPV4HDRERRFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV4_HEADER_ERROR_FRAMES_type;
#define ETH_RXIPV4_HEADER_ERROR_FRAMES	(*( ETH_RXIPV4_HEADER_ERROR_FRAMES_type *) 0xf001e214u)	/* Register 133 - Receive IPV4 Header Error Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4HDRERROCT: 32;	/* This field indicates the number of bytes received in the IPv4 datagrams with header errors (checksum, length, or version mismatch). The value in the Length field of IPv4 header is used to update this counter. */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV4_HEADER_ERROR_OCTETS_type;
#define ETH_RXIPV4_HEADER_ERROR_OCTETS	(*( ETH_RXIPV4_HEADER_ERROR_OCTETS_type *) 0xf001e254u)	/* Register 149 - Receive IPV4 Header Error Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4NOPAYFRM : 32;	/* RXIPV4NOPAYFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV4_NO_PAYLOAD_FRAMES_type;
#define ETH_RXIPV4_NO_PAYLOAD_FRAMES	(*( ETH_RXIPV4_NO_PAYLOAD_FRAMES_type *) 0xf001e218u)	/* Register 134 - Receive IPV4 No Payload Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4NOPAYOCT : 32;	/* This field indicates the number of bytes received in IPv4 datagrams that did not have a TCP, UDP, or ICMP payload. The value in the IPv4 headers Length field is used to update this counter. */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV4_NO_PAYLOAD_OCTETS_type;
#define ETH_RXIPV4_NO_PAYLOAD_OCTETS	(*( ETH_RXIPV4_NO_PAYLOAD_OCTETS_type *) 0xf001e258u)	/* Register 150 - Receive IPV4 No Payload Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4UDSBLFRM : 32;	/* RXIPV4UDSBLFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV4_UDP_CHECKSUM_DISABLED_FRAMES_type;
#define ETH_RXIPV4_UDP_CHECKSUM_DISABLED_FRAMES	(*( ETH_RXIPV4_UDP_CHECKSUM_DISABLED_FRAMES_type *) 0xf001e220u)	/* Register 136 - Receive IPV4 UDP Checksum Disabled Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV4UDSBLOCT : 32;	/* RXIPV4UDSBLOCT */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV4_UDP_CHECKSUM_DISABLE_OCTETS_type;
#define ETH_RXIPV4_UDP_CHECKSUM_DISABLE_OCTETS	(*( ETH_RXIPV4_UDP_CHECKSUM_DISABLE_OCTETS_type *) 0xf001e260u)	/* Register 152 - Receive IPV4 Fragmented Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV6GDFRM    : 32;	/* RXIPV6GDFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV6_GOOD_FRAMES_type;
#define ETH_RXIPV6_GOOD_FRAMES	(*( ETH_RXIPV6_GOOD_FRAMES_type *) 0xf001e224u)	/* Register 137 - Receive IPV6 Good Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV6GDOCT    : 32;	/* Thsi field indicates the number of bytes received in good IPv6 datagrams encapsulating TCP, UDP or ICMPv6 data. */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV6_GOOD_OCTETS_type;
#define ETH_RXIPV6_GOOD_OCTETS	(*( ETH_RXIPV6_GOOD_OCTETS_type *) 0xf001e264u)	/* Register 153 - Receive IPV6 Good Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV6HDRERRFRM: 32;	/* RXIPV6HDRERRFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV6_HEADER_ERROR_FRAMES_type;
#define ETH_RXIPV6_HEADER_ERROR_FRAMES	(*( ETH_RXIPV6_HEADER_ERROR_FRAMES_type *) 0xf001e228u)	/* Register 138 - Receive IPV6 Header Error Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV6HDRERROCT: 32;	/* This field indicates the number of bytes received in IPv6 datagrams with header errors (length or version mismatch). The value in the IPv6 headers Length field is used to update this counter. */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV6_HEADER_ERROR_OCTETS_type;
#define ETH_RXIPV6_HEADER_ERROR_OCTETS	(*( ETH_RXIPV6_HEADER_ERROR_OCTETS_type *) 0xf001e268u)	/* Register 154 - Receive IPV6 Header Error Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV6NOPAYFRM : 32;	/* RXIPV6NOPAYFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV6_NO_PAYLOAD_FRAMES_type;
#define ETH_RXIPV6_NO_PAYLOAD_FRAMES	(*( ETH_RXIPV6_NO_PAYLOAD_FRAMES_type *) 0xf001e22cu)	/* Register 139 - Receive IPV6 No Payload Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXIPV6NOPAYOCT : 32;	/* This field indicates the number of bytes received in IPv6 datagrams that did not have a TCP, UDP, or ICMP payload. The value in the IPv6 headers Length field is used to update this counter. */
	} B;
	int I;
	unsigned int U;

} ETH_RXIPV6_NO_PAYLOAD_OCTETS_type;
#define ETH_RXIPV6_NO_PAYLOAD_OCTETS	(*( ETH_RXIPV6_NO_PAYLOAD_OCTETS_type *) 0xf001e26cu)	/* Register 155 - Receive IPV6 No Payload Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXTCPERRFRM    : 32;	/* RXTCPERRFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXTCP_ERROR_FRAMES_type;
#define ETH_RXTCP_ERROR_FRAMES	(*( ETH_RXTCP_ERROR_FRAMES_type *) 0xf001e23cu)	/* Register 143 - Receive TCP Error Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXTCPERROCT    : 32;	/* RXTCPERROCT */
	} B;
	int I;
	unsigned int U;

} ETH_RXTCP_ERROR_OCTETS_type;
#define ETH_RXTCP_ERROR_OCTETS	(*( ETH_RXTCP_ERROR_OCTETS_type *) 0xf001e27cu)	/* Register 159 - Receive TCP Error Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXTCPGDFRM     : 32;	/* RXTCPGDFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXTCP_GOOD_FRAMES_type;
#define ETH_RXTCP_GOOD_FRAMES	(*( ETH_RXTCP_GOOD_FRAMES_type *) 0xf001e238u)	/* Register 142 - Receive TCP Good Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXTCPGDOCT     : 32;	/* RXTCPGDOCT */
	} B;
	int I;
	unsigned int U;

} ETH_RXTCP_GOOD_OCTETS_type;
#define ETH_RXTCP_GOOD_OCTETS	(*( ETH_RXTCP_GOOD_OCTETS_type *) 0xf001e278u)	/* Register 158 - Receive TCP Good Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXUDPERRFRM    : 32;	/* RXUDPERRFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXUDP_ERROR_FRAMES_type;
#define ETH_RXUDP_ERROR_FRAMES	(*( ETH_RXUDP_ERROR_FRAMES_type *) 0xf001e234u)	/* Register 141 - Receive UDP Error Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXUDPERROCT    : 32;	/* RXUDPERROCT */
	} B;
	int I;
	unsigned int U;

} ETH_RXUDP_ERROR_OCTETS_type;
#define ETH_RXUDP_ERROR_OCTETS	(*( ETH_RXUDP_ERROR_OCTETS_type *) 0xf001e274u)	/* Register 157 - Receive UDP Error Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXUDPGDFRM     : 32;	/* RXUDPGDFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RXUDP_GOOD_FRAMES_type;
#define ETH_RXUDP_GOOD_FRAMES	(*( ETH_RXUDP_GOOD_FRAMES_type *) 0xf001e230u)	/* Register 140 - Receive UDP Good Frame Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXUDPGDOCT     : 32;	/* RXUDPGDOCT */
	} B;
	int I;
	unsigned int U;

} ETH_RXUDP_GOOD_OCTETS_type;
#define ETH_RXUDP_GOOD_OCTETS	(*( ETH_RXUDP_GOOD_OCTETS_type *) 0xf001e270u)	/* Register 156 - Receive UDP Good Octet Counter Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RX1024_MAXOCTGB: 32;	/* RX1024_MAXOCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_RX_1024TOMAXOCTETS_FRAMES_GOOD_BAD_type;
#define ETH_RX_1024TOMAXOCTETS_FRAMES_GOOD_BAD	(*( ETH_RX_1024TOMAXOCTETS_FRAMES_GOOD_BAD_type *) 0xf001e1c0u)	/* Register 112 - Receive Frame Count for Good and Bad 1,024 to Maxsize Bytes Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RX128_255OCTGB : 32;	/* RX128_255OCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_RX_128TO255OCTETS_FRAMES_GOOD_BAD_type;
#define ETH_RX_128TO255OCTETS_FRAMES_GOOD_BAD	(*( ETH_RX_128TO255OCTETS_FRAMES_GOOD_BAD_type *) 0xf001e1b4u)	/* Register 109 - Receive Frame Count for Good and Bad 128 to 255 Bytes Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RX256_511OCTGB : 32;	/* RX256_511OCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_RX_256TO511OCTETS_FRAMES_GOOD_BAD_type;
#define ETH_RX_256TO511OCTETS_FRAMES_GOOD_BAD	(*( ETH_RX_256TO511OCTETS_FRAMES_GOOD_BAD_type *) 0xf001e1b8u)	/* Register 110 - Receive Frame Count for Good and Bad 256 to 511 Bytes Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RX512_1023OCTGB: 32;	/* RX512_1023OCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_RX_512TO1023OCTETS_FRAMES_GOOD_BAD_type;
#define ETH_RX_512TO1023OCTETS_FRAMES_GOOD_BAD	(*( ETH_RX_512TO1023OCTETS_FRAMES_GOOD_BAD_type *) 0xf001e1bcu)	/* Register 111 - Receive Frame Count for Good and Bad 512 to 1,023 Bytes Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RX64OCTGB      : 32;	/* RX64OCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_RX_64OCTETS_FRAMES_GOOD_BAD_type;
#define ETH_RX_64OCTETS_FRAMES_GOOD_BAD	(*( ETH_RX_64OCTETS_FRAMES_GOOD_BAD_type *) 0xf001e1acu)	/* Register 107 - Receive Frame Count for Good and Bad 64 Byte Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RX65_127OCTGB  : 32;	/* RX65_127OCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_RX_65TO127OCTETS_FRAMES_GOOD_BAD_type;
#define ETH_RX_65TO127OCTETS_FRAMES_GOOD_BAD	(*( ETH_RX_65TO127OCTETS_FRAMES_GOOD_BAD_type *) 0xf001e1b0u)	/* Register 108 - Receive Frame Count for Good and Bad 65 to 127 Bytes Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXALGNERR      : 32;	/* RXALGNERR */
	} B;
	int I;
	unsigned int U;

} ETH_RX_ALIGNMENT_ERROR_FRAMES_type;
#define ETH_RX_ALIGNMENT_ERROR_FRAMES	(*( ETH_RX_ALIGNMENT_ERROR_FRAMES_type *) 0xf001e198u)	/* Register 102 - Receive Frame Count for Alignment Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXBCASTG       : 32;	/* RXBCASTG */
	} B;
	int I;
	unsigned int U;

} ETH_RX_BROADCAST_FRAMES_GOOD_type;
#define ETH_RX_BROADCAST_FRAMES_GOOD	(*( ETH_RX_BROADCAST_FRAMES_GOOD_type *) 0xf001e18cu)	/* Register 99 - Receive Frame Count for Good Broadcast Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXCTRLG        : 32;	/* RXCTRLG */
	} B;
	int I;
	unsigned int U;

} ETH_RX_CONTROL_FRAMES_GOOD_type;
#define ETH_RX_CONTROL_FRAMES_GOOD	(*( ETH_RX_CONTROL_FRAMES_GOOD_type *) 0xf001e1e4u)	/* Register 121 - Receive Frame Count for Good Control Frames Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXCRCERR       : 32;	/* RXCRCERR */
	} B;
	int I;
	unsigned int U;

} ETH_RX_CRC_ERROR_FRAMES_type;
#define ETH_RX_CRC_ERROR_FRAMES	(*( ETH_RX_CRC_ERROR_FRAMES_type *) 0xf001e194u)	/* Register 101 - Receive Frame Count for CRC Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXFIFOOVFL     : 32;	/* RXFIFOOVFL */
	} B;
	int I;
	unsigned int U;

} ETH_RX_FIFO_OVERFLOW_FRAMES_type;
#define ETH_RX_FIFO_OVERFLOW_FRAMES	(*( ETH_RX_FIFO_OVERFLOW_FRAMES_type *) 0xf001e1d4u)	/* Register 117 - Receive Frame Count for FIFO Overflow Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXFRMGB        : 32;	/* RXFRMGB */
	} B;
	int I;
	unsigned int U;

} ETH_RX_FRAMES_COUNT_GOOD_BAD_type;
#define ETH_RX_FRAMES_COUNT_GOOD_BAD	(*( ETH_RX_FRAMES_COUNT_GOOD_BAD_type *) 0xf001e180u)	/* Register 96 - Receive Frame Count for Good and Bad Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXJABERR       : 32;	/* RXJABERR */
	} B;
	int I;
	unsigned int U;

} ETH_RX_JABBER_ERROR_FRAMES_type;
#define ETH_RX_JABBER_ERROR_FRAMES	(*( ETH_RX_JABBER_ERROR_FRAMES_type *) 0xf001e1a0u)	/* Register 104 - Receive Frame Count for Jabber Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXLENERR       : 32;	/* RXLENERR */
	} B;
	int I;
	unsigned int U;

} ETH_RX_LENGTH_ERROR_FRAMES_type;
#define ETH_RX_LENGTH_ERROR_FRAMES	(*( ETH_RX_LENGTH_ERROR_FRAMES_type *) 0xf001e1c8u)	/* Register 114 - Receive Frame Count for Length Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXMCASTG       : 32;	/* RXMCASTG */
	} B;
	int I;
	unsigned int U;

} ETH_RX_MULTICAST_FRAMES_GOOD_type;
#define ETH_RX_MULTICAST_FRAMES_GOOD	(*( ETH_RX_MULTICAST_FRAMES_GOOD_type *) 0xf001e190u)	/* Register 100 - Receive Frame Count for Good Multicast Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXOCTG         : 32;	/* RXOCTG */
	} B;
	int I;
	unsigned int U;

} ETH_RX_OCTET_COUNT_GOOD_type;
#define ETH_RX_OCTET_COUNT_GOOD	(*( ETH_RX_OCTET_COUNT_GOOD_type *) 0xf001e188u)	/* Register 98 - Receive Octet Count for Good Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXOCTGB        : 32;	/* RXOCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_RX_OCTET_COUNT_GOOD_BAD_type;
#define ETH_RX_OCTET_COUNT_GOOD_BAD	(*( ETH_RX_OCTET_COUNT_GOOD_BAD_type *) 0xf001e184u)	/* Register 97 - Receive Octet Count for Good and Bad Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXOUTOFRNG     : 32;	/* RXOUTOFRNG */
	} B;
	int I;
	unsigned int U;

} ETH_RX_OUT_OF_RANGE_TYPE_FRAMES_type;
#define ETH_RX_OUT_OF_RANGE_TYPE_FRAMES	(*( ETH_RX_OUT_OF_RANGE_TYPE_FRAMES_type *) 0xf001e1ccu)	/* Register 115 - Receive Frame Count for Out of Range Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXOVERSZG      : 32;	/* RXOVERSZG */
	} B;
	int I;
	unsigned int U;

} ETH_RX_OVERSIZE_FRAMES_GOOD_type;
#define ETH_RX_OVERSIZE_FRAMES_GOOD	(*( ETH_RX_OVERSIZE_FRAMES_GOOD_type *) 0xf001e1a8u)	/* Register 106 - Receive Frame Count for Oversize Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXPAUSEFRM     : 32;	/* RXPAUSEFRM */
	} B;
	int I;
	unsigned int U;

} ETH_RX_PAUSE_FRAMES_type;
#define ETH_RX_PAUSE_FRAMES	(*( ETH_RX_PAUSE_FRAMES_type *) 0xf001e1d0u)	/* Register 116 - Receive Frame Count for PAUSE Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXRCVERR       : 32;	/* RXRCVERR */
	} B;
	int I;
	unsigned int U;

} ETH_RX_RECEIVE_ERROR_FRAMES_type;
#define ETH_RX_RECEIVE_ERROR_FRAMES	(*( ETH_RX_RECEIVE_ERROR_FRAMES_type *) 0xf001e1e0u)	/* Register 120 - Receive Frame Count for Receive Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXRUNTERR      : 32;	/* RXRUNTERR */
	} B;
	int I;
	unsigned int U;

} ETH_RX_RUNT_ERROR_FRAMES_type;
#define ETH_RX_RUNT_ERROR_FRAMES	(*( ETH_RX_RUNT_ERROR_FRAMES_type *) 0xf001e19cu)	/* Register 103 - Receive Frame Count for Runt Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXUNDERSZG     : 32;	/* RXUNDERSZG */
	} B;
	int I;
	unsigned int U;

} ETH_RX_UNDERSIZE_FRAMES_GOOD_type;
#define ETH_RX_UNDERSIZE_FRAMES_GOOD	(*( ETH_RX_UNDERSIZE_FRAMES_GOOD_type *) 0xf001e1a4u)	/* Register 105 - Receive Frame Count for Undersize Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXUCASTG       : 32;	/* RXUCASTG */
	} B;
	int I;
	unsigned int U;

} ETH_RX_UNICAST_FRAMES_GOOD_type;
#define ETH_RX_UNICAST_FRAMES_GOOD	(*( ETH_RX_UNICAST_FRAMES_GOOD_type *) 0xf001e1c4u)	/* Register 113 - Receive Frame Count for Good Unicast Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXVLANFRGB     : 32;	/* RXVLANFRGB */
	} B;
	int I;
	unsigned int U;

} ETH_RX_VLAN_FRAMES_GOOD_BAD_type;
#define ETH_RX_VLAN_FRAMES_GOOD_BAD	(*( ETH_RX_VLAN_FRAMES_GOOD_BAD_type *) 0xf001e1d8u)	/* Register 118 - Receive Frame Count for Good and Bad VLAN Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RXWDGERR       : 32;	/* RXWDGERR */
	} B;
	int I;
	unsigned int U;

} ETH_RX_WATCHDOG_ERROR_FRAMES_type;
#define ETH_RX_WATCHDOG_ERROR_FRAMES	(*( ETH_RX_WATCHDOG_ERROR_FRAMES_type *) 0xf001e1dcu)	/* Register 119 - Receive Frame Count for Watchdog Error Frames */

typedef volatile union
{
	struct
	{ 
		unsigned int TI             : 1;	/* Transmit Interrupt */
		unsigned int TPS            : 1;	/* Transmit Process Stopped */
		unsigned int TU             : 1;	/* Transmit Buffer Unavailable */
		unsigned int TJT            : 1;	/* Transmit Jabber Timeout */
		unsigned int OVF            : 1;	/* Receive Overflow */
		unsigned int UNF            : 1;	/* Transmit Underflow */
		unsigned int RI             : 1;	/* Receive Interrupt */
		unsigned int RU             : 1;	/* Receive Buffer Unavailable */
		unsigned int RPS            : 1;	/* Receive Process Stopped */
		unsigned int RWT            : 1;	/* Receive Watchdog Timeout */
		unsigned int ETI            : 1;	/* Early Transmit Interrupt */
		/* const */ unsigned int RESERVED_12_11 : 2;	/* RESERVED_12_11 */
		unsigned int FBI            : 1;	/* Fatal Bus Error Interrupt */
		unsigned int ERI            : 1;	/* Early Receive Interrupt */
		unsigned int AIS            : 1;	/* Abnormal Interrupt Summary */
		unsigned int NIS            : 1;	/* Normal Interrupt Summary */
		/* const */ unsigned int RS             : 3;	/* Received Process State */
		/* const */ unsigned int TS             : 3;	/* Transmit Process State */
		/* const */ unsigned int EB             : 3;	/* Error Bits */
		/* const */ unsigned int GLI            : 1;	/* GMAC Line interface Interrupt */
		/* const */ unsigned int GMI            : 1;	/* GMAC MMC Interrupt */
		/* const */ unsigned int GPI            : 1;	/* GMAC PMT Interrupt */
		/* const */ unsigned int TTI            : 1;	/* Timestamp Trigger Interrupt */
		/* const */ unsigned int GLPII          : 1;	/* GMAC LPI Interrupt (for Channel 0) */
		/* const */ unsigned int RESERVED_31    : 1;	/* RESERVED_31 */
	} B;
	int I;
	unsigned int U;

} ETH_STATUS_type;
#define ETH_STATUS	(*( ETH_STATUS_type *) 0xf001f014u)	/* Register 5 - Status Register */

typedef volatile union
{
	struct
	{ 
		unsigned int SSINC          : 8;	/* Sub-second Increment Value */
		/* const */ unsigned int RESERVED_31_8  : 24;	/* RESERVED_31_8 */
	} B;
	int I;
	unsigned int U;

} ETH_SUB_SECOND_INCREMENT_type;
#define ETH_SUB_SECOND_INCREMENT	(*( ETH_SUB_SECOND_INCREMENT_type *) 0xf001e704u)	/* Register 449 - Sub-Second Increment Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TSHWR          : 16;	/* Timestamp Higher Word Register */
		/* const */ unsigned int RESERVED_31_16 : 16;	/* RESERVED_31_16 */
	} B;
	int I;
	unsigned int U;

} ETH_SYSTEM_TIME_HIGHER_WORD_SECONDS_type;
#define ETH_SYSTEM_TIME_HIGHER_WORD_SECONDS	(*( ETH_SYSTEM_TIME_HIGHER_WORD_SECONDS_type *) 0xf001e724u)	/* Register 457 - System Time - Higher Word Seconds Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TSSS           : 31;	/* Timestamp Sub Seconds */
		/* const */ unsigned int RESERVED_31    : 1;	/* RESERVED_31 */
	} B;
	int I;
	unsigned int U;

} ETH_SYSTEM_TIME_NANOSECONDS_type;
#define ETH_SYSTEM_TIME_NANOSECONDS	(*( ETH_SYSTEM_TIME_NANOSECONDS_type *) 0xf001e70cu)	/* Register 451 - System Time - Nanoseconds Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TSSS           : 31;	/* Timestamp Sub Second */
		unsigned int ADDSUB         : 1;	/* Add or subtract time */
	} B;
	int I;
	unsigned int U;

} ETH_SYSTEM_TIME_NANOSECONDS_UPDATE_type;
#define ETH_SYSTEM_TIME_NANOSECONDS_UPDATE	(*( ETH_SYSTEM_TIME_NANOSECONDS_UPDATE_type *) 0xf001e714u)	/* Register 453 - System Time - Nanoseconds Update Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TSS            : 32;	/* Timestamp Second */
	} B;
	int I;
	unsigned int U;

} ETH_SYSTEM_TIME_SECONDS_type;
#define ETH_SYSTEM_TIME_SECONDS	(*( ETH_SYSTEM_TIME_SECONDS_type *) 0xf001e708u)	/* Register 450 - System Time - Seconds Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TSS            : 32;	/* Timestamp Second */
	} B;
	int I;
	unsigned int U;

} ETH_SYSTEM_TIME_SECONDS_UPDATE_type;
#define ETH_SYSTEM_TIME_SECONDS_UPDATE	(*( ETH_SYSTEM_TIME_SECONDS_UPDATE_type *) 0xf001e710u)	/* Register 452 - System Time - Seconds Update Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TTSLO          : 31;	/* Target Timestamp Low Register */
		/* const */ unsigned int TRGTBUSY       : 1;	/* Target Time Register Busy */
	} B;
	int I;
	unsigned int U;

} ETH_TARGET_TIME_NANOSECONDS_type;
#define ETH_TARGET_TIME_NANOSECONDS	(*( ETH_TARGET_TIME_NANOSECONDS_type *) 0xf001e720u)	/* Register 456 - Target Time Nanoseconds Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TSTR           : 32;	/* Target Time Seconds Register */
	} B;
	int I;
	unsigned int U;

} ETH_TARGET_TIME_SECONDS_type;
#define ETH_TARGET_TIME_SECONDS	(*( ETH_TARGET_TIME_SECONDS_type *) 0xf001e71cu)	/* Register 455 - Target Time Seconds Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TSAR           : 32;	/* Timestamp Addend Register */
	} B;
	int I;
	unsigned int U;

} ETH_TIMESTAMP_ADDEND_type;
#define ETH_TIMESTAMP_ADDEND	(*( ETH_TIMESTAMP_ADDEND_type *) 0xf001e718u)	/* Register 454 - Timestamp Addend Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TSENA          : 1;	/* Timestamp Enable */
		unsigned int TSCFUPDT       : 1;	/* Timestamp Fine or Coarse Update */
		unsigned int TSINIT         : 1;	/* Timestamp Initialize */
		unsigned int TSUPDT         : 1;	/* Timestamp Update */
		unsigned int TSTRIG         : 1;	/* Timestamp Interrupt Trigger Enable */
		unsigned int TSADDREG       : 1;	/* Addend Reg Update */
		/* const */ unsigned int RESERVED_7_6   : 2;	/* RESERVED_7_6 */
		unsigned int TSENALL        : 1;	/* Enable Timestamp for All Frames */
		unsigned int TSCTRLSSR      : 1;	/* Timestamp Digital or Binary Rollover Control */
		unsigned int TSVER2ENA      : 1;	/* Enable PTP packet Processing for Version 2 Format */
		unsigned int TSIPENA        : 1;	/* Enable Processing of PTP over Ethernet Frames */
		unsigned int TSIPV6ENA      : 1;	/* Enable Processing of PTP Frames Sent Over IPv6-UDP */
		unsigned int TSIPV4ENA      : 1;	/* Enable Processing of PTP Frames Sent over IPv4-UDP */
		unsigned int TSEVNTENA      : 1;	/* Enable Timestamp Snapshot for Event Messages */
		unsigned int TSMSTRENA      : 1;	/* Enable Snapshot for Messages Relevant to Master */
		unsigned int SNAPTYPSEL     : 2;	/* Select PTP packets for Taking Snapshots */
		unsigned int TSENMACADDR    : 1;	/* Enable MAC address for PTP Frame Filtering */
		/* const */ unsigned int RESERVED_23_19 : 5;	/* RESERVED_23_19 */
		/* const */ unsigned int ATSFC          : 1;	/* Auxiliary Snapshot FIFO Clear */
		/* const */ unsigned int ATSEN0         : 1;	/* Auxiliary Snapshot 0 Enable */
		/* const */ unsigned int ATSEN1         : 1;	/* Auxiliary Snapshot 1 Enable */
		/* const */ unsigned int ATSEN2         : 1;	/* Auxiliary Snapshot 2 Enable */
		/* const */ unsigned int ATSEN3         : 1;	/* Auxiliary Snapshot 3 Enable */
		/* const */ unsigned int RESERVED_31_29 : 3;	/* RESERVED_31_29 */
	} B;
	int I;
	unsigned int U;

} ETH_TIMESTAMP_CONTROL_type;
#define ETH_TIMESTAMP_CONTROL	(*( ETH_TIMESTAMP_CONTROL_type *) 0xf001e700u)	/* Register 448 - Timestamp Control Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TSSOVF         : 1;	/* Timestamp Seconds Overflow */
		/* const */ unsigned int TSTARGT        : 1;	/* Timestamp Target Time Reached */
		/* const */ unsigned int AUXTSTRIG      : 1;	/* Auxiliary Timestamp Trigger Snapshot */
		/* const */ unsigned int TSTRGTERR      : 1;	/* Timestamp Target Time Error */
		/* const */ unsigned int TSTARGT1       : 1;	/* Timestamp Target Time Reached for Target Time PPS1 */
		/* const */ unsigned int TSTRGTERR1     : 1;	/* Timestamp Target Time Error */
		/* const */ unsigned int TSTARGT2       : 1;	/* Timestamp Target Time Reached for Target Time PPS2 */
		/* const */ unsigned int TSTRGTERR2     : 1;	/* Timestamp Target Time Error */
		/* const */ unsigned int TSTARGT3       : 1;	/* Timestamp Target Time Reached for Target Time PPS3 */
		/* const */ unsigned int TSTRGTERR3     : 1;	/* Timestamp Target Time Error */
		/* const */ unsigned int RESERVED_15_10 : 6;	/* RESERVED_15_10 */
		/* const */ unsigned int ATSSTN         : 4;	/* Auxiliary Timestamp Snapshot Trigger Identifier */
		/* const */ unsigned int RESERVED_23_20 : 4;	/* RESERVED_23_20 */
		/* const */ unsigned int ATSSTM         : 1;	/* Auxiliary Timestamp Snapshot Trigger Missed */
		/* const */ unsigned int ATSNS          : 5;	/* Number of Auxiliary Timestamp Snapshots */
		/* const */ unsigned int RESERVED_31_30 : 2;	/* RESERVED_31_30 */
	} B;
	int I;
	unsigned int U;

} ETH_TIMESTAMP_STATUS_type;
#define ETH_TIMESTAMP_STATUS	(*( ETH_TIMESTAMP_STATUS_type *) 0xf001e728u)	/* Register 458 - Timestamp Status Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int RESERVED_1_0   : 2;	/* RESERVED_1_0 */
		unsigned int TDESLA_32bit   : 30;	/* Start of Transmit List */
	} B;
	int I;
	unsigned int U;

} ETH_TRANSMIT_DESCRIPTOR_LIST_ADDRESS_type;
#define ETH_TRANSMIT_DESCRIPTOR_LIST_ADDRESS	(*( ETH_TRANSMIT_DESCRIPTOR_LIST_ADDRESS_type *) 0xf001f010u)	/* Register 4 - Transmit Descriptor List Address Register */

typedef volatile union
{
	struct
	{ 
		unsigned int TPD            : 32;	/* Transmit Poll Demand */
	} B;
	int I;
	unsigned int U;

} ETH_TRANSMIT_POLL_DEMAND_type;
#define ETH_TRANSMIT_POLL_DEMAND	(*( ETH_TRANSMIT_POLL_DEMAND_type *) 0xf001f004u)	/* Register 1 - Transmit Poll Demand Register */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TX1024_MAXOCTGB: 32;	/* TX1024_MAXOCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_1024TOMAXOCTETS_FRAMES_GOOD_BAD_type;
#define ETH_TX_1024TOMAXOCTETS_FRAMES_GOOD_BAD	(*( ETH_TX_1024TOMAXOCTETS_FRAMES_GOOD_BAD_type *) 0xf001e138u)	/* Register 78 - Transmit Octet Count for Good and Bad 1024 to Maxsize Bytes Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TX128_255OCTGB : 32;	/* TX128_255OCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_128TO255OCTETS_FRAMES_GOOD_BAD_type;
#define ETH_TX_128TO255OCTETS_FRAMES_GOOD_BAD	(*( ETH_TX_128TO255OCTETS_FRAMES_GOOD_BAD_type *) 0xf001e12cu)	/* Register 75 - Transmit Octet Count for Good and Bad 128 to 255 Bytes Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TX256_511OCTGB : 32;	/* TX256_511OCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_256TO511OCTETS_FRAMES_GOOD_BAD_type;
#define ETH_TX_256TO511OCTETS_FRAMES_GOOD_BAD	(*( ETH_TX_256TO511OCTETS_FRAMES_GOOD_BAD_type *) 0xf001e130u)	/* Register 76 - Transmit Octet Count for Good and Bad 256 to 511 Bytes Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TX512_1023OCTGB: 32;	/* TX512_1023OCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_512TO1023OCTETS_FRAMES_GOOD_BAD_type;
#define ETH_TX_512TO1023OCTETS_FRAMES_GOOD_BAD	(*( ETH_TX_512TO1023OCTETS_FRAMES_GOOD_BAD_type *) 0xf001e134u)	/* Register 77 - Transmit Octet Count for Good and Bad 512 to 1023 Bytes Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TX64OCTGB      : 32;	/* TX64OCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_64OCTETS_FRAMES_GOOD_BAD_type;
#define ETH_TX_64OCTETS_FRAMES_GOOD_BAD	(*( ETH_TX_64OCTETS_FRAMES_GOOD_BAD_type *) 0xf001e124u)	/* Register 73 - Transmit Octet Count for Good and Bad 64 Byte Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TX65_127OCTGB  : 32;	/* TX65_127OCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_65TO127OCTETS_FRAMES_GOOD_BAD_type;
#define ETH_TX_65TO127OCTETS_FRAMES_GOOD_BAD	(*( ETH_TX_65TO127OCTETS_FRAMES_GOOD_BAD_type *) 0xf001e128u)	/* Register 74 - Transmit Octet Count for Good and Bad 65 to 127 Bytes Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXBCASTG       : 32;	/* TXBCASTG */
	} B;
	int I;
	unsigned int U;

} ETH_TX_BROADCAST_FRAMES_GOOD_type;
#define ETH_TX_BROADCAST_FRAMES_GOOD	(*( ETH_TX_BROADCAST_FRAMES_GOOD_type *) 0xf001e11cu)	/* Register 71 - Transmit Frame Count for Good Broadcast Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXBCASTGB      : 32;	/* TXBCASTGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_BROADCAST_FRAMES_GOOD_BAD_type;
#define ETH_TX_BROADCAST_FRAMES_GOOD_BAD	(*( ETH_TX_BROADCAST_FRAMES_GOOD_BAD_type *) 0xf001e144u)	/* Register 81 - Transmit Frame Count for Good and Bad Broadcast Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXCARR         : 32;	/* TXCARR */
	} B;
	int I;
	unsigned int U;

} ETH_TX_CARRIER_ERROR_FRAMES_type;
#define ETH_TX_CARRIER_ERROR_FRAMES	(*( ETH_TX_CARRIER_ERROR_FRAMES_type *) 0xf001e160u)	/* Register 88 - Transmit Frame Count for Carrier Sense Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXDEFRD        : 32;	/* TXDEFRD */
	} B;
	int I;
	unsigned int U;

} ETH_TX_DEFERRED_FRAMES_type;
#define ETH_TX_DEFERRED_FRAMES	(*( ETH_TX_DEFERRED_FRAMES_type *) 0xf001e154u)	/* Register 85 - Transmit Frame Count for Deferred Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXEXSCOL       : 32;	/* TXEXSCOL */
	} B;
	int I;
	unsigned int U;

} ETH_TX_EXCESSIVE_COLLISION_FRAMES_type;
#define ETH_TX_EXCESSIVE_COLLISION_FRAMES	(*( ETH_TX_EXCESSIVE_COLLISION_FRAMES_type *) 0xf001e15cu)	/* Register 87 - Transmit Frame Count for Excessive Collision Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXEXSDEF       : 32;	/* TXEXSDEF */
	} B;
	int I;
	unsigned int U;

} ETH_TX_EXCESSIVE_DEFERRAL_ERROR_type;
#define ETH_TX_EXCESSIVE_DEFERRAL_ERROR	(*( ETH_TX_EXCESSIVE_DEFERRAL_ERROR_type *) 0xf001e16cu)	/* Register 91 - Transmit Frame Count for Excessive Deferral Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXFRMG         : 32;	/* TXFRMG */
	} B;
	int I;
	unsigned int U;

} ETH_TX_FRAME_COUNT_GOOD_type;
#define ETH_TX_FRAME_COUNT_GOOD	(*( ETH_TX_FRAME_COUNT_GOOD_type *) 0xf001e168u)	/* Register 90 - Transmit Frame Count for Good Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXFRMGB        : 32;	/* TXFRMGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_FRAME_COUNT_GOOD_BAD_type;
#define ETH_TX_FRAME_COUNT_GOOD_BAD	(*( ETH_TX_FRAME_COUNT_GOOD_BAD_type *) 0xf001e118u)	/* Register 70 - Transmit Frame Count for Good and Bad Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXLATECOL      : 32;	/* TXLATECOL */
	} B;
	int I;
	unsigned int U;

} ETH_TX_LATE_COLLISION_FRAMES_type;
#define ETH_TX_LATE_COLLISION_FRAMES	(*( ETH_TX_LATE_COLLISION_FRAMES_type *) 0xf001e158u)	/* Register 86 - Transmit Frame Count for Late Collision Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXMCASTG       : 32;	/* TXMCASTG */
	} B;
	int I;
	unsigned int U;

} ETH_TX_MULTICAST_FRAMES_GOOD_type;
#define ETH_TX_MULTICAST_FRAMES_GOOD	(*( ETH_TX_MULTICAST_FRAMES_GOOD_type *) 0xf001e120u)	/* Register 72 - Transmit Frame Count for Good Multicast Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXMCASTGB      : 32;	/* TXMCASTGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_MULTICAST_FRAMES_GOOD_BAD_type;
#define ETH_TX_MULTICAST_FRAMES_GOOD_BAD	(*( ETH_TX_MULTICAST_FRAMES_GOOD_BAD_type *) 0xf001e140u)	/* Register 80 - Transmit Frame Count for Good and Bad Multicast Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXMULTCOLG     : 32;	/* TXMULTCOLG */
	} B;
	int I;
	unsigned int U;

} ETH_TX_MULTIPLE_COLLISION_GOOD_FRAMES_type;
#define ETH_TX_MULTIPLE_COLLISION_GOOD_FRAMES	(*( ETH_TX_MULTIPLE_COLLISION_GOOD_FRAMES_type *) 0xf001e150u)	/* Register 84 - Transmit Frame Count for Frames Transmitted after Multiple Collision */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXOCTG         : 32;	/* TXOCTG */
	} B;
	int I;
	unsigned int U;

} ETH_TX_OCTET_COUNT_GOOD_type;
#define ETH_TX_OCTET_COUNT_GOOD	(*( ETH_TX_OCTET_COUNT_GOOD_type *) 0xf001e164u)	/* Register 89 - Transmit Octet Count for Good Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXOCTGB        : 32;	/* TXOCTGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_OCTET_COUNT_GOOD_BAD_type;
#define ETH_TX_OCTET_COUNT_GOOD_BAD	(*( ETH_TX_OCTET_COUNT_GOOD_BAD_type *) 0xf001e114u)	/* Register 69 - Transmit Octet Count for Good and Bad Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXOSIZG        : 32;	/* TXOSIZG */
	} B;
	int I;
	unsigned int U;

} ETH_TX_OSIZE_FRAMES_GOOD_type;
#define ETH_TX_OSIZE_FRAMES_GOOD	(*( ETH_TX_OSIZE_FRAMES_GOOD_type *) 0xf001e178u)	/* Register 94 - Transmit Frame Count for Good Oversize Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXPAUSE        : 32;	/* TXPAUSE */
	} B;
	int I;
	unsigned int U;

} ETH_TX_PAUSE_FRAMES_type;
#define ETH_TX_PAUSE_FRAMES	(*( ETH_TX_PAUSE_FRAMES_type *) 0xf001e170u)	/* Register 92 - Transmit Frame Count for Good PAUSE Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXSNGLCOLG     : 32;	/* TXSNGLCOLG */
	} B;
	int I;
	unsigned int U;

} ETH_TX_SINGLE_COLLISION_GOOD_FRAMES_type;
#define ETH_TX_SINGLE_COLLISION_GOOD_FRAMES	(*( ETH_TX_SINGLE_COLLISION_GOOD_FRAMES_type *) 0xf001e14cu)	/* Register 83 - Transmit Frame Count for Frames Transmitted after Single Collision */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXUNDRFLW      : 32;	/* TXUNDRFLW */
	} B;
	int I;
	unsigned int U;

} ETH_TX_UNDERFLOW_ERROR_FRAMES_type;
#define ETH_TX_UNDERFLOW_ERROR_FRAMES	(*( ETH_TX_UNDERFLOW_ERROR_FRAMES_type *) 0xf001e148u)	/* Register 82 - Transmit Frame Count for Underflow Error Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXUCASTGB      : 32;	/* TXUCASTGB */
	} B;
	int I;
	unsigned int U;

} ETH_TX_UNICAST_FRAMES_GOOD_BAD_type;
#define ETH_TX_UNICAST_FRAMES_GOOD_BAD	(*( ETH_TX_UNICAST_FRAMES_GOOD_BAD_type *) 0xf001e13cu)	/* Register 79 - Transmit Frame Count for Good and Bad Unicast Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int TXVLANG        : 32;	/* TXVLANG */
	} B;
	int I;
	unsigned int U;

} ETH_TX_VLAN_FRAMES_GOOD_type;
#define ETH_TX_VLAN_FRAMES_GOOD	(*( ETH_TX_VLAN_FRAMES_GOOD_type *) 0xf001e174u)	/* Register 93 - Transmit Frame Count for Good VLAN Frames */

typedef volatile union
{
	struct
	{ 
		/* const */ unsigned int SNPSVER        : 8;	/* SNPSVER */
		/* const */ unsigned int USERVER        : 8;	/* USERVER */
		/* const */ unsigned int RESERVED_31_16 : 16;	/* RESERVED_31_16 */
	} B;
	int I;
	unsigned int U;

} ETH_VERSION_type;
#define ETH_VERSION	(*( ETH_VERSION_type *) 0xf001e020u)	/* Register 8 - Version Register */

typedef volatile union
{
	struct
	{ 
		unsigned int VL             : 16;	/* VLAN Tag Identifier for Receive Frames */
		unsigned int ETV            : 1;	/* Enable 12-Bit VLAN Tag Comparison */
		unsigned int VTIM           : 1;	/* VLAN Tag Inverse Match Enable */
		unsigned int ESVL           : 1;	/* Enable S-VLAN */
		/* const */ unsigned int VTHM           : 1;	/* VLAN Tag Hash Table Match Enable */
		/* const */ unsigned int RESERVED_31_20 : 12;	/* RESERVED_31_20 */
	} B;
	int I;
	unsigned int U;

} ETH_VLAN_TAG_type;
#define ETH_VLAN_TAG	(*( ETH_VLAN_TAG_type *) 0xf001e01cu)	/* Register 7 - VLAN Tag Register */

#endif /*_REGTC27X_H*/
